(function() {
    'use strict';

    class BlinBlinEffect extends Laya.Script {
        constructor() {
            super();
            this.scaleMax = 1;
            this.scaleMin = 1;
        }
        onAwake() {}
        onDisable() {
            for (let i = 0; i < this.owner.numChildren; i++) {
                let img = this.owner.getChildAt(i);
                Laya.Tween.clearAll(img);
            }
        }
        onEnable() {
            for (let i = 0; i < this.owner.numChildren; i++) {
                let img = this.owner.getChildAt(i);
                img.scale(this.scaleMax, this.scaleMax);
                img.alpha = 0;
                Laya.timer.once(i * 50, this, function() {
                    this.action(img);
                });
            }
        }
        action(img) {
            img.alpha = Math.random() * 0.5 + 0.5;
            let owner = this.owner;
            img.pos(Math.random() * owner.width, owner.height);
            img.scale(this.scaleMax, this.scaleMax);
            let scale = this.scaleMin;
            Laya.Tween.clearAll(img);
            Laya.Tween.to(img, {
                alpha: 0,
                y: 0,
                scaleX: scale,
                scaleY: scale
            }, Math.random() * 2000 + 2000, null, Laya.Handler.create(this, function() {
                this.action(img);
            }));
        }
    }

    class PointEffect extends Laya.Script {
        constructor() {
            super();
        }
        onAwake() {}
        onDisable() {
            for (let i = 0; i < this.owner.numChildren; i++) {
                let img = this.owner.getChildAt(i);
                Laya.Tween.clearAll(img);
            }
        }
        onEnable() {
            for (let i = 0; i < this.owner.numChildren; i++) {
                let img = this.owner.getChildAt(i);
                this.pointCtrl(img, Math.random() * 500);
            }
        }
        pointCtrl(img, time) {
            let owner = this.owner;
            let x = Math.random() * (Math.random() * owner.width - img.width) + img.width / 2;
            let y = Math.random() * (Math.random() * owner.height - img.height) + img.height / 2;
            img.x = x;
            img.y = y;
            img.alpha = 0;
            Laya.timer.clearAll(img);
            Laya.Tween.clearAll(img);
            var that = this;
            let func = function() {
                if (img) {
                    Laya.Tween.to(img, {
                        alpha: 1
                    }, 400, null, Laya.Handler.create(img, () => {
                        Laya.Tween.to(img, {
                            alpha: 0
                        }, 400, null, Laya.Handler.create(img, () => {
                            that.pointCtrl(img, Math.random() * 1000);
                        }));
                    }));
                } else {
                    Laya.Tween.clearAll(img);
                }
            };
            Laya.timer.once(time, img, func);
        }
    }

    let STORAGE_ID = {
        RES_VERTION: 'RES_VERTION_',
        IS_UPDATE: 'IS_UPDATE',
        ROLE_INFO: 'ROLE_INFO',
        AD_LIMIT: 'AD_LIMIT',
        CONFIG: 'CONFIG',
        MUSIC: 'MUSIC',
        EFFECT: 'EFFECT',
        VIBRATE: 'VIBRATE',
        PLATFORM_USER_ID: 'PLATFORM_USER_ID',
        JUMPLIST: 'JUMPLIST',
        DOT_REWARD_COUNT: 'DOT_REWARD_COUNT',
        DOT_REWARD_DAY_COUNT: 'DOT_REWARD_DAY_COUNT',
        OPEN_ID: 'OPEN_ID',
        EQUIP_RED: 'EQUIP_RED',
        PRIVATE_STATE: 'PRIVATE_STATE',
        PLATFORM_USER_INFO: 'PLATFORM_USER_INFO',
        TURN_TABLE_ITEM: 'TURN_TABLE_ITEM',
    };
    if (('h5api' in Laya.Browser.window)) {
        for (let index in STORAGE_ID) {
            let element = STORAGE_ID[index];
            STORAGE_ID[index] = 'yhxyqz' + element;
        }
    }

    var REWARD_CTRL_TYPE;
    (function(REWARD_CTRL_TYPE) {
        REWARD_CTRL_TYPE[REWARD_CTRL_TYPE["DEFAULT"] = 0] = "DEFAULT";
        REWARD_CTRL_TYPE[REWARD_CTRL_TYPE["END_DOUBLE_REWARD"] = 1] = "END_DOUBLE_REWARD";
        REWARD_CTRL_TYPE[REWARD_CTRL_TYPE["TRY_SKIN"] = 2] = "TRY_SKIN";
        REWARD_CTRL_TYPE[REWARD_CTRL_TYPE["SUPER_REWARD"] = 3] = "SUPER_REWARD";
        REWARD_CTRL_TYPE[REWARD_CTRL_TYPE["GOLD_REWARD"] = 4] = "GOLD_REWARD";
        REWARD_CTRL_TYPE[REWARD_CTRL_TYPE["DIAMOND_REWARD"] = 5] = "DIAMOND_REWARD";
        REWARD_CTRL_TYPE[REWARD_CTRL_TYPE["SIGN"] = 6] = "SIGN";
        REWARD_CTRL_TYPE[REWARD_CTRL_TYPE["NEW_GIFT"] = 7] = "NEW_GIFT";
        REWARD_CTRL_TYPE[REWARD_CTRL_TYPE["SUPER_EQUIP"] = 8] = "SUPER_EQUIP";
        REWARD_CTRL_TYPE[REWARD_CTRL_TYPE["TASK"] = 9] = "TASK";
        REWARD_CTRL_TYPE[REWARD_CTRL_TYPE["REVIVE"] = 10] = "REVIVE";
        REWARD_CTRL_TYPE[REWARD_CTRL_TYPE["EQUIP_TRY"] = 10] = "EQUIP_TRY";
        REWARD_CTRL_TYPE[REWARD_CTRL_TYPE["DROP_AIR"] = 11] = "DROP_AIR";
        REWARD_CTRL_TYPE[REWARD_CTRL_TYPE["BOX_REWARD"] = 12] = "BOX_REWARD";
        REWARD_CTRL_TYPE[REWARD_CTRL_TYPE["REWARD_EXTRA"] = 13] = "REWARD_EXTRA";
        REWARD_CTRL_TYPE[REWARD_CTRL_TYPE["BUFF"] = 14] = "BUFF";
        REWARD_CTRL_TYPE[REWARD_CTRL_TYPE["MTOUCH"] = 15] = "MTOUCH";
        REWARD_CTRL_TYPE[REWARD_CTRL_TYPE["FIRECRACKER"] = 16] = "FIRECRACKER";
        REWARD_CTRL_TYPE[REWARD_CTRL_TYPE["GAMEAIR"] = 17] = "GAMEAIR";
        REWARD_CTRL_TYPE[REWARD_CTRL_TYPE["TURNTABLE"] = 18] = "TURNTABLE";
        REWARD_CTRL_TYPE[REWARD_CTRL_TYPE["SHOP_TRY"] = 19] = "SHOP_TRY";
        REWARD_CTRL_TYPE[REWARD_CTRL_TYPE["ROLE_TRY"] = 20] = "ROLE_TRY";
        REWARD_CTRL_TYPE[REWARD_CTRL_TYPE["NEW_YEAR_PLAYER"] = 21] = "NEW_YEAR_PLAYER";
        REWARD_CTRL_TYPE[REWARD_CTRL_TYPE["GET_DEBRIS"] = 22] = "GET_DEBRIS";
        REWARD_CTRL_TYPE[REWARD_CTRL_TYPE["ACT_GOLD_GUN"] = 23] = "ACT_GOLD_GUN";
        REWARD_CTRL_TYPE[REWARD_CTRL_TYPE["AUTO"] = 24] = "AUTO";
    })(REWARD_CTRL_TYPE || (REWARD_CTRL_TYPE = {}));
    var NATIVE_TYPE;
    (function(NATIVE_TYPE) {
        NATIVE_TYPE[NATIVE_TYPE["BANNER"] = 1] = "BANNER";
        NATIVE_TYPE[NATIVE_TYPE["ICON"] = 2] = "ICON";
    })(NATIVE_TYPE || (NATIVE_TYPE = {}));
    let AdData = [{
            id: REWARD_CTRL_TYPE.DEFAULT,
            ad_id: '',
            info: '通用',
            list: [0],
            count: 0
        },
        {
            id: REWARD_CTRL_TYPE.END_DOUBLE_REWARD,
            ad_id: '',
            info: '结束三倍领取',
            list: [0],
            count: 0
        },
        {
            id: REWARD_CTRL_TYPE.TRY_SKIN,
            ad_id: '',
            info: '皮肤试用',
            list: [0],
            count: 0
        },
        {
            id: REWARD_CTRL_TYPE.SUPER_REWARD,
            ad_id: '',
            info: '超级奖励',
            list: [0],
            count: 0
        },
        {
            id: REWARD_CTRL_TYPE.GOLD_REWARD,
            ad_id: '',
            info: '金币获取',
            list: [0],
            count: 0
        },
        {
            id: REWARD_CTRL_TYPE.DIAMOND_REWARD,
            ad_id: '',
            info: '钻石获取',
            list: [0],
            count: 0
        },
        {
            id: REWARD_CTRL_TYPE.SIGN,
            ad_id: '',
            info: '签到',
            list: [0],
            count: 0
        },
        {
            id: REWARD_CTRL_TYPE.NEW_GIFT,
            ad_id: '',
            info: '新手礼包',
            list: [0],
            count: 0
        },
        {
            id: REWARD_CTRL_TYPE.SUPER_EQUIP,
            ad_id: '',
            info: '超级武器',
            list: [0],
            count: 0
        },
        {
            id: REWARD_CTRL_TYPE.TASK,
            ad_id: '',
            info: '七日任务',
            list: [0],
            count: 0
        },
        {
            id: REWARD_CTRL_TYPE.REVIVE,
            ad_id: '',
            info: '复活',
            list: [0],
            count: 0
        },
        {
            id: REWARD_CTRL_TYPE.EQUIP_TRY,
            ad_id: '',
            info: '武器试用',
            list: [0],
            count: 0
        },
        {
            id: REWARD_CTRL_TYPE.DROP_AIR,
            ad_id: '',
            info: '空投',
            list: [0],
            count: 0
        },
        {
            id: REWARD_CTRL_TYPE.BOX_REWARD,
            ad_id: '',
            info: '宝箱奖励',
            list: [0],
            count: 0
        },
        {
            id: REWARD_CTRL_TYPE.REWARD_EXTRA,
            ad_id: '',
            info: '额外领取奖励',
            list: [0],
            count: 0
        },
        {
            id: REWARD_CTRL_TYPE.BUFF,
            ad_id: '',
            info: 'buff增益',
            list: [0],
            count: 0
        },
        {
            id: REWARD_CTRL_TYPE.MTOUCH,
            ad_id: '',
            info: '误触',
            list: [0],
            count: 0
        },
        {
            id: REWARD_CTRL_TYPE.FIRECRACKER,
            ad_id: '',
            info: '爆竹',
            list: [0],
            count: 0
        },
        {
            id: REWARD_CTRL_TYPE.GAMEAIR,
            ad_id: '',
            info: '空投神枪',
            list: [0],
            count: 0
        },
        {
            id: REWARD_CTRL_TYPE.TURNTABLE,
            ad_id: '',
            info: '转盘',
            list: [0],
            count: 0
        },
        {
            id: REWARD_CTRL_TYPE.SHOP_TRY,
            ad_id: '',
            info: '商店试用',
            list: [0],
            count: 0
        },
        {
            id: REWARD_CTRL_TYPE.ROLE_TRY,
            ad_id: '',
            info: '角色试用',
            list: [0],
            count: 0
        },
        {
            id: REWARD_CTRL_TYPE.NEW_YEAR_PLAYER,
            ad_id: '',
            info: '新春人物',
            list: [0],
            count: 0
        },
        {
            id: REWARD_CTRL_TYPE.GET_DEBRIS,
            ad_id: '',
            info: '获取碎片',
            list: [0],
            count: 0
        },
        {
            id: REWARD_CTRL_TYPE.ACT_GOLD_GUN,
            ad_id: '',
            info: '金色传说',
            list: [0],
            count: 0
        },
    ];
    var REWARD_WAY;
    (function(REWARD_WAY) {
        REWARD_WAY[REWARD_WAY["AD"] = 0] = "AD";
        REWARD_WAY[REWARD_WAY["SHARE"] = 1] = "SHARE";
    })(REWARD_WAY || (REWARD_WAY = {}));
    let AD_BANNER = [];
    let AD_INTERSTITIAL = [];
    let SHARE_TYPE = {
        NORMAL: 0,
    };
    let AD_APP_BOX = [];
    let AD_NAVITE = [];
    let AD_GIRD = [];
    let AD_FULL_SCREEN = [];
    let AD_OPPO_GAME_PORTAL = [];
    let AD_NAVITE_EXTEND = [];
    let AD_CUSTOM = [];
    let AD_CUSTOM_1 = [];
    let AD_CUSTOM_V = [];
    let AD_CUSTOM_H = [];
    let AD_CUSTOM_MATRIX = [];

    class NotifyManager {
        static register(eventId, func, self) {
            if (!NotifyManager.list[eventId])
                NotifyManager.list[eventId] = {};
            let id = eventId + ':' + new Date().getTime() + Math.floor(Math.random() * 1000).toString();
            NotifyManager.list[eventId][id] = func.bind(self);
            return id;
        }
        static once(eventId, func, self) {
            if (!NotifyManager.onceList[eventId])
                NotifyManager.onceList[eventId] = {};
            let id = eventId + ':' + new Date().getTime();
            NotifyManager.onceList[eventId][id] = func.bind(self);
            return id;
        }
        static unregisterByEventId(eventId) {
            for (let k in NotifyManager.list[eventId]) {
                NotifyManager.list[eventId][k] = null;
            }
            NotifyManager.list[eventId] = null;
            console.log('注销事件');
            console.log(NotifyManager.list);
            delete NotifyManager.list[eventId];
        }
        static unregisterByFuncId(funcId) {
            for (let k1 in NotifyManager.list) {
                for (let k2 in NotifyManager.list[k1]) {
                    if (k2 == funcId) {
                        NotifyManager.list[k1][k2] = null;
                        delete NotifyManager.list[k1][k2];
                    }
                }
            }
        }
        static notify(eventId, params = null) {
            if (NotifyManager.list[eventId]) {
                for (let k in NotifyManager.list[eventId]) {
                    NotifyManager.list[eventId][k](params);
                }
            }
            if (NotifyManager.onceList[eventId]) {
                for (let k in NotifyManager.onceList[eventId]) {
                    NotifyManager.onceList[eventId][k](params);
                }
                NotifyManager.onceList[eventId] = null;
                delete NotifyManager.onceList[eventId];
            }
        }
    }
    NotifyManager.list = {};
    NotifyManager.onceList = {};

    let NOTIFY_ID = {
        REFRESH_GAME_VIEW: 'REFRESH_GAME_VIEW',
        REFRESH_GOLD_VIEW: 'REFRESH_GOLD_VIEW',
        REFRESH_DIAMOND_VIEW: 'REFRESH_DIAMOND_VIEW',
        REFRESH_SKIN: 'REFRESH_SKIN',
        FIRST_VIEW_BANNER: 'FIRST_VIEW_BANNER',
        PLAY_UPPER_LIMB_ANI: 'PLAY_UPPER_LIMB_ANI',
        PLAY_THE_LEGS_ANI: 'PLAY_THE_LEGS_ANI',
        PLAY_EFFECT: 'PLAY_EFFECT',
        ON_SHOW: 'ON_SHOW',
        PLAY_SOUND: 'PLAY_SOUND',
        KILL: 'KILL',
        REFRESH_PLAYER_HP_UI: 'REFRESH_PLAYER_HP_UI',
        PLAYER_WAR_SITUATION: 'PLAYER_WAR_SITUATION',
        KILL_BROADCAST: 'KILL_BROADCAST',
        REFRESH_MAIN_ARM: 'REFRESH_MAIN_ARM',
        BINDING_HEAD: 'BINDING_HEAD',
        MATCH_KILL: 'MATCH_KILL',
        PLAYER_KILL_DETAILS: 'PLAYER_KILL_DETAILS',
        REFRESH_CANBUY_ARM: 'REFRESH_CANBUY_ARM',
        ADDARM_BY_SHOP: 'ADDARM_BY_SHOP',
        REFRESH_NATIVE_AD: 'REFRESH_NATIVE_AD',
        ISHIDE_NATIVE_AD: 'HIDE_NATIVE_AD',
        REFRESH_PLAYER_ARMOR_UI: 'REFRESH_PLAYER_ARMOR_UI',
        REFRESH_OV_AD: 'REFRESH_OV_AD',
        ANDROID_IMG_AD_LOAD: 'ANDROID_IMG_AD_LOAD',
        ANDROID_REWARD_AD_LOAD: 'ANDROID_REWARD_AD_LOAD',
        REFRESH_AI_GOOD: 'REFRESH_AI_GOOD'
    };

    let NETWORK_CONTENT = {
        WX_HEADER_CODE: 'X-WX-Code',
        WX_SESSION_MAGIC_ID: 'F2C224D4-2BCE-4C64-AF9F-A6D872000D1A',
        WX_HEADER_SKEY: 'X-WX-Skey',
        MULTI_SKEY: 'Multi-Skey',
    };
    let NETWORK_CODE = {
        ERR_TIMEOUT: '网络超时',
        ERR_LOGIN_SESSION_NOT_RECEIVED: '1001',
        ERR_SKEY_INVALID: 'ERR_SKEY_INVALID',
    };
    let ROUTE_MAP = {
        LOGIN: 'login',
        USER: 'user',
        CONFIG: 'config',
        PLATFORM_USER_ID: 'platformUserId',
        SUBSCRIBE: 'subscribe',
        CHANNEL: 'channel',
        COS_CREDENTIALS: 'cosCredentials',
    };

    var PLATFORM_TYPE;
    (function(PLATFORM_TYPE) {
        PLATFORM_TYPE[PLATFORM_TYPE["WEB"] = 1] = "WEB";
        PLATFORM_TYPE[PLATFORM_TYPE["WX"] = 2] = "WX";
        PLATFORM_TYPE[PLATFORM_TYPE["VIVO"] = 3] = "VIVO";
        PLATFORM_TYPE[PLATFORM_TYPE["OPPO"] = 4] = "OPPO";
        PLATFORM_TYPE[PLATFORM_TYPE["QQ"] = 5] = "QQ";
        PLATFORM_TYPE[PLATFORM_TYPE["TT"] = 6] = "TT";
        PLATFORM_TYPE[PLATFORM_TYPE["NATIVE_IOS"] = 7] = "NATIVE_IOS";
        PLATFORM_TYPE[PLATFORM_TYPE["NATIVE_ANDRIOD"] = 8] = "NATIVE_ANDRIOD";
        PLATFORM_TYPE[PLATFORM_TYPE["WEB_4399"] = 9] = "WEB_4399";
    })(PLATFORM_TYPE || (PLATFORM_TYPE = {}));

    var noop = function noop() {};
    class NetworkManager {
        static request(route, method, data, success = null, fail = null, isShowLoading = false) {
            if (ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.WEB_4399) {
                fail();
                return;
            }
            success = success || noop;
            fail = fail || noop;
            if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD) {
                let id = `${route}:${method}:${Laya.Utils.getGID()}`;
                this.handle[id + ':success'] = success;
                this.handle[id + ':fail'] = fail;
                let PlatformClass = window['PlatformClass'];
                if (PlatformClass)
                    PlatformClass.createClass('demo.JSBridge').call('request', route, method, JSON.stringify(data), id);
                return;
            }
            let url = NetworkManager.httpHost + route;
            var request = new Laya.HttpRequest();
            if (ConfigManager.platform == PLATFORM_TYPE.VIVO || ConfigManager.platform == PLATFORM_TYPE.OPPO || ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS) {
                if (method == 'GET') {
                    let query = '?';
                    for (let k in data) {
                        query += encodeURIComponent(k) + '=' + encodeURIComponent(data[k]) + '&';
                    }
                    query = query.substring(0, query.length - 1);
                    url += query;
                    data = '';
                } else if (method == 'POST') {
                    data = JSON.stringify(data);
                }
            }
            request.send(url, data, method, 'json', [
                NETWORK_CONTENT.WX_HEADER_SKEY, Laya.LocalStorage.getItem(NETWORK_CONTENT.WX_SESSION_MAGIC_ID),
                NETWORK_CONTENT.MULTI_SKEY, NetworkManager.multiSkey,
                "Content-Type", "application/json",
            ]);
            request.on(Laya.Event.COMPLETE, null, function(data) {
                if (data && data.code === 0) {
                    success(data.data);
                } else {
                    if (data.error == NETWORK_CODE.ERR_SKEY_INVALID) {
                        NetworkManager.doLogin(function(res) {
                            if (route != ROUTE_MAP.USER) {
                                NetworkManager.request(route, method, data, success, fail);
                            } else {
                                console.log('it is user route exec success');
                                success(res);
                            }
                        }, fail);
                    } else {
                        fail('登陆失败 code:' + NETWORK_CODE.ERR_LOGIN_SESSION_NOT_RECEIVED);
                    }
                }
                request.offAll();
            });
            request.on(Laya.Event.ERROR, null, function() {
                console.log('请求失败');
                fail();
                request.offAll();
            });
        }
        static requestWithUrl(url, method, header, data, success = null, fail = null, isShowLoading = false) {
            if (ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.WEB_4399) {
                fail();
                return;
            }
            if (isShowLoading) {}
            success = success || noop;
            fail = fail || noop;
            var request = new Laya.HttpRequest();
            if (ConfigManager.platform == PLATFORM_TYPE.VIVO || ConfigManager.platform == PLATFORM_TYPE.OPPO) {
                if (method == 'GET') {
                    let query = '?';
                    for (let k in data) {
                        query += encodeURIComponent(k) + '=' + encodeURIComponent(data[k]) + '&';
                    }
                    query = query.substring(0, query.length - 1);
                    url += query;
                    data = '';
                } else if (method == 'POST') {
                    data = JSON.stringify(data);
                }
            }
            let headerData = ["Content-Type", "application/json;charset=utf-8"];
            for (let k in header) {
                headerData.push(header[k]);
            }
            request.send(url, data, method, 'json', headerData);
            request.once(Laya.Event.COMPLETE, null, function(data) {
                if (data && (data.code === 0 || data.code === 200 || typeof(data.code) === "undefined")) {
                    if (typeof(data.code) === "undefined") {
                        success(data);
                    } else {
                        success(data.data);
                    }
                } else {
                    fail(JSON.stringify(data));
                }
                if (isShowLoading) {}
            });
            request.once(Laya.Event.ERROR, null, function(err) {
                console.log('请求失败', err);
                fail(err);
                if (isShowLoading) {}
            });
        }
        static doLogin(succssCallBack, failCallBack) {
            wx.login({
                success: function(res) {
                    var request = new Laya.HttpRequest();
                    request.send(NetworkManager.httpHost + ROUTE_MAP.LOGIN, {}, 'post', 'json', [
                        NETWORK_CONTENT.WX_HEADER_CODE,
                        res.code
                    ]);
                    request.once(Laya.Event.COMPLETE, null, function(data) {
                        if (data && data.code === 0 && data.data.result == 1) {
                            var res = data.data;
                            Laya.LocalStorage.setItem(NETWORK_CONTENT.WX_SESSION_MAGIC_ID, res.data.skey);
                            succssCallBack(res);
                        } else {
                            failCallBack('登陆失败 code:' + NETWORK_CODE.ERR_LOGIN_SESSION_NOT_RECEIVED);
                        }
                    });
                    request.once(Laya.Event.ERROR, null, function(error) {
                        console.log(error);
                        failCallBack('微信登录失败，请检查网络状态');
                    });
                },
                fail: function(error) {
                    failCallBack(error);
                }
            });
        }
        static reLogin(succssCallBack, failCallBack) {
            NetworkManager.login(succssCallBack, failCallBack);
        }
        static login(succssCallBack, failCallBack) {
            if (ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.WEB_4399) {
                failCallBack();
                return;
            }
            NetworkManager.loginTimer = setTimeout(function() {
                NetworkManager.isFirstLogin = false;
                NetworkManager.reLogin(succssCallBack, failCallBack);
                if (failCallBack && NetworkManager.isDoFail) {
                    NetworkManager.isDoFail = false;
                    failCallBack('登陆超时');
                }
            }, NetworkManager.loginTimeOut);

            function success(data) {
                clearTimeout(NetworkManager.loginTimer);
                if (NetworkManager.isDoSuccess && succssCallBack) {
                    NetworkManager.isDoSuccess = false;
                    succssCallBack(data);
                }
                NetworkManager.isFirstLogin = false;
            }

            function fail(error) {
                console.log('登陆失败');
                if (NetworkManager.isFirstLogin) {
                    clearTimeout(NetworkManager.loginTimer);
                    NetworkManager.reLogin(succssCallBack, failCallBack);
                }
                NetworkManager.isFirstLogin = false;
                if (failCallBack && NetworkManager.isDoFail) {
                    NetworkManager.isDoFail = false;
                    failCallBack(error);
                }
            }
            let session = Laya.LocalStorage.getItem(NETWORK_CONTENT.WX_SESSION_MAGIC_ID);
            if (session) {
                wx.checkSession({
                    success: function() {
                        console.log('登陆态未过期');
                        NetworkManager.request(ROUTE_MAP.USER, 'post', {}, success, fail);
                    },
                    fail: function() {
                        Laya.LocalStorage.removeItem(NETWORK_CONTENT.WX_SESSION_MAGIC_ID);
                        NetworkManager.doLogin(success, fail);
                        console.log('登陆态已过期');
                    }
                });
            } else {
                NetworkManager.doLogin(success, fail);
            }
        }
        static nativeSuccessCallBack(id, data) {
            console.log('nativeSuccessCallBack', id, data);
            if (data && (data.code === 0 || data.code === 200 || typeof(data.code) === "undefined")) {
                if (this.handle[id + ':success']) {
                    if (typeof(data.code) === "undefined") {
                        this.handle[id + ':success'](data);
                        delete this.handle[id + ':success'];
                    } else {
                        this.handle[id + ':success'](data.data);
                        delete this.handle[id + ':success'];
                    }
                }
            } else {
                if (this.handle[id + ':fail']) {
                    this.handle[id + ':fail'](JSON.stringify(data));
                    delete this.handle[id + ':fail'];
                }
            }
        }
        static nativeFaiCallBack(id) {
            console.log('nativeFaiCallBack', id);
            if (this.handle[id + ':fail']) {
                this.handle[id + ':fail']("");
                delete this.handle[id + ':fail'];
            }
        }
    }
    NetworkManager.httpHost = '  wxg-twoface.ruidroid.xyz/multi/';
    NetworkManager.loginTimeOut = 5000;
    NetworkManager.multiSkey = 'yidingkeji888888';
    NetworkManager.handle = {};
    NetworkManager.isFirstLogin = true;
    NetworkManager.isDoSuccess = true;
    NetworkManager.isDoFail = true;
    window["NetworkManager"] = NetworkManager;

    class ARM {
        static getDataByKey(key) {
            if (ARM.cache[key])
                return ARM.cache[key];
            if (key == 1) {
                let template = new ARM();
                template.id = 1;
                template.name = '猎人手枪';
                template.objName = '4001';
                template.type = 4;
                template.interval = 500;
                template.attackSound = 'QBZ92Fire.mp3';
                template.magazineBullet = 20;
                template.bullets = 40;
                template.bulletChangeTimer = 2000;
                template.hit = 20;
                template.bodyMultiple = 1.5;
                template.headHit = 30;
                template.limbMultiple = 0.5;
                template.limbHit = 10;
                template.maxBodyHit = 80;
                template.maxHeadHit = 120;
                template.maxLimbHit = 60;
                template.isCanOpMirror = 0;
                template.cutScale = 0;
                template.attackDis = -1;
                template.icon = 'sub1/equip/arm/1.png';
                template.recoilForce = [0.5, 0];
                template.reloadsound = 'reload2.mp3';
                template.firestarter = 'm4_Effect';
                template.ballistic = 'fire';
                template.bullethole = 'impactSparks';
                template.price = 100;
                template.produce = 10;
                template.priceByDiamond = 10;
                template.grade = 4;
                template.lv = 1;
                template.pierceThrough = 30;
                template.range = 20;
                template.sight = -1;
                template.movingSpeed = 0.18;
                template.biochemicalCharging = 0;
                template.accurate = 30;
                ARM.cache[key] = template;
                return template;
            } else if (key == 2) {
                let template = new ARM();
                template.id = 2;
                template.name = '代号-37';
                template.objName = '5004';
                template.type = 5;
                template.interval = 180;
                template.attackSound = '9A91Fire.mp3';
                template.magazineBullet = 30;
                template.bullets = 60;
                template.bulletChangeTimer = 2000;
                template.hit = 15;
                template.bodyMultiple = 1.5;
                template.headHit = 22.5;
                template.limbMultiple = 0.5;
                template.limbHit = 7.5;
                template.maxBodyHit = 30;
                template.maxHeadHit = 50;
                template.maxLimbHit = 20;
                template.isCanOpMirror = 0;
                template.cutScale = 0;
                template.attackDis = -1;
                template.icon = 'sub1/equip/arm/2.png';
                template.recoilForce = [0.1, 0];
                template.reloadsound = 'reload1.mp3';
                template.firestarter = 'm4_Effect';
                template.ballistic = 'fire';
                template.bullethole = 'impactSparks';
                template.price = 1000;
                template.produce = 100;
                template.priceByDiamond = 100;
                template.grade = 4;
                template.lv = 1;
                template.pierceThrough = 50;
                template.range = 30;
                template.sight = -1;
                template.movingSpeed = 0.15;
                template.biochemicalCharging = 0;
                template.accurate = 31;
                ARM.cache[key] = template;
                return template;
            } else if (key == 3) {
                let template = new ARM();
                template.id = 3;
                template.name = '星环';
                template.objName = '5008';
                template.type = 5;
                template.interval = 180;
                template.attackSound = 'PP2000Fire.mp3';
                template.magazineBullet = 30;
                template.bullets = 60;
                template.bulletChangeTimer = 2000;
                template.hit = 16;
                template.bodyMultiple = 1.5;
                template.headHit = 24;
                template.limbMultiple = 0.5;
                template.limbHit = 8;
                template.maxBodyHit = 30;
                template.maxHeadHit = 50;
                template.maxLimbHit = 20;
                template.isCanOpMirror = 0;
                template.cutScale = 0;
                template.attackDis = -1;
                template.icon = 'sub1/equip/arm/3.png';
                template.recoilForce = [0.1, 0];
                template.reloadsound = 'reload1.mp3';
                template.firestarter = 'm4_Effect';
                template.ballistic = 'fire';
                template.bullethole = 'impactSparks';
                template.price = 5000;
                template.produce = 150;
                template.priceByDiamond = 150;
                template.grade = 4;
                template.lv = 1;
                template.pierceThrough = 55;
                template.range = 30;
                template.sight = -1;
                template.movingSpeed = 0.15;
                template.biochemicalCharging = 0;
                template.accurate = 32;
                ARM.cache[key] = template;
                return template;
            } else if (key == 4) {
                let template = new ARM();
                template.id = 4;
                template.name = 'Q97-红龙';
                template.objName = '1006';
                template.type = 1;
                template.interval = 200;
                template.attackSound = 'FamasFire.mp3';
                template.magazineBullet = 25;
                template.bullets = 50;
                template.bulletChangeTimer = 2000;
                template.hit = 20;
                template.bodyMultiple = 1.6;
                template.headHit = 32;
                template.limbMultiple = 0.65;
                template.limbHit = 13;
                template.maxBodyHit = 50;
                template.maxHeadHit = 80;
                template.maxLimbHit = 40;
                template.isCanOpMirror = 0;
                template.cutScale = 0;
                template.attackDis = -1;
                template.icon = 'sub1/equip/arm/4.png';
                template.recoilForce = [0.1, 0];
                template.reloadsound = 'reload1.mp3';
                template.firestarter = 'm4_Effect';
                template.ballistic = 'fire';
                template.bullethole = 'impactSparks';
                template.price = 10000;
                template.produce = 200;
                template.priceByDiamond = 200;
                template.grade = 4;
                template.lv = 1;
                template.pierceThrough = 47;
                template.range = 50;
                template.sight = -1;
                template.movingSpeed = 0.14;
                template.biochemicalCharging = 0;
                template.accurate = 33;
                ARM.cache[key] = template;
                return template;
            } else if (key == 5) {
                let template = new ARM();
                template.id = 5;
                template.name = 'M50-挑战者';
                template.objName = '3001';
                template.type = 3;
                template.interval = 2000;
                template.attackSound = 'M700Fire.mp3';
                template.magazineBullet = 10;
                template.bullets = 20;
                template.bulletChangeTimer = 2000;
                template.hit = 100;
                template.bodyMultiple = 1.98;
                template.headHit = 198;
                template.limbMultiple = 0.8;
                template.limbHit = 80;
                template.maxBodyHit = 280;
                template.maxHeadHit = 700;
                template.maxLimbHit = 250;
                template.isCanOpMirror = 0;
                template.cutScale = 0;
                template.attackDis = -1;
                template.icon = 'sub1/equip/arm/5.png';
                template.recoilForce = [3, 0];
                template.reloadsound = 'reload1.mp3';
                template.firestarter = 'm4_Effect';
                template.ballistic = 'fire';
                template.bullethole = 'impactSparks';
                template.price = 25000;
                template.produce = 250;
                template.priceByDiamond = 250;
                template.grade = 4;
                template.lv = 1;
                template.pierceThrough = 80;
                template.range = 70;
                template.sight = -1;
                template.movingSpeed = 0.11;
                template.biochemicalCharging = 0;
                template.accurate = 34;
                ARM.cache[key] = template;
                return template;
            } else if (key == 6) {
                let template = new ARM();
                template.id = 6;
                template.name = '星耀';
                template.objName = '5007';
                template.type = 5;
                template.interval = 180;
                template.attackSound = 'UMP45Fire.mp3';
                template.magazineBullet = 30;
                template.bullets = 60;
                template.bulletChangeTimer = 2000;
                template.hit = 17;
                template.bodyMultiple = 1.5;
                template.headHit = 25.5;
                template.limbMultiple = 0.5;
                template.limbHit = 8.5;
                template.maxBodyHit = 30;
                template.maxHeadHit = 50;
                template.maxLimbHit = 20;
                template.isCanOpMirror = 0;
                template.cutScale = 0;
                template.attackDis = -1;
                template.icon = 'sub1/equip/arm/6.png';
                template.recoilForce = [0.1, 0];
                template.reloadsound = 'reload1.mp3';
                template.firestarter = 'm4_Effect';
                template.ballistic = 'fire';
                template.bullethole = 'impactSparks';
                template.price = 30000;
                template.produce = 300;
                template.priceByDiamond = 300;
                template.grade = 4;
                template.lv = 1;
                template.pierceThrough = 60;
                template.range = 30;
                template.sight = -1;
                template.movingSpeed = 0.15;
                template.biochemicalCharging = 0;
                template.accurate = 35;
                ARM.cache[key] = template;
                return template;
            } else if (key == 7) {
                let template = new ARM();
                template.id = 7;
                template.name = '星爵';
                template.objName = '5006';
                template.type = 5;
                template.interval = 180;
                template.attackSound = 'MP5Fire.mp3';
                template.magazineBullet = 30;
                template.bullets = 60;
                template.bulletChangeTimer = 2000;
                template.hit = 18;
                template.bodyMultiple = 1.5;
                template.headHit = 27;
                template.limbMultiple = 0.5;
                template.limbHit = 9;
                template.maxBodyHit = 30;
                template.maxHeadHit = 50;
                template.maxLimbHit = 20;
                template.isCanOpMirror = 0;
                template.cutScale = 0;
                template.attackDis = -1;
                template.icon = 'sub1/equip/arm/7.png';
                template.recoilForce = [0.1, 0];
                template.reloadsound = 'reload1.mp3';
                template.firestarter = 'm4_Effect';
                template.ballistic = 'fire';
                template.bullethole = 'impactSparks';
                template.price = 35000;
                template.produce = 350;
                template.priceByDiamond = 350;
                template.grade = 4;
                template.lv = 1;
                template.pierceThrough = 65;
                template.range = 30;
                template.sight = -1;
                template.movingSpeed = 0.15;
                template.biochemicalCharging = 0;
                template.accurate = 36;
                ARM.cache[key] = template;
                return template;
            } else if (key == 8) {
                let template = new ARM();
                template.id = 8;
                template.name = 'M7-开拓者';
                template.objName = '1002';
                template.type = 1;
                template.interval = 200;
                template.attackSound = 'G36Fire.mp3';
                template.magazineBullet = 30;
                template.bullets = 60;
                template.bulletChangeTimer = 2000;
                template.hit = 21;
                template.bodyMultiple = 1.6;
                template.headHit = 33.6;
                template.limbMultiple = 0.65;
                template.limbHit = 13.65;
                template.maxBodyHit = 50;
                template.maxHeadHit = 80;
                template.maxLimbHit = 40;
                template.isCanOpMirror = 0;
                template.cutScale = 0;
                template.attackDis = -1;
                template.icon = 'sub1/equip/arm/8.png';
                template.recoilForce = [0.1, 0];
                template.reloadsound = 'reload1.mp3';
                template.firestarter = 'm4_Effect';
                template.ballistic = 'fire';
                template.bullethole = 'impactSparks';
                template.price = 40000;
                template.produce = 400;
                template.priceByDiamond = 400;
                template.grade = 4;
                template.lv = 1;
                template.pierceThrough = 49;
                template.range = 50;
                template.sight = -1;
                template.movingSpeed = 0.14;
                template.biochemicalCharging = 0;
                template.accurate = 37;
                ARM.cache[key] = template;
                return template;
            } else if (key == 9) {
                let template = new ARM();
                template.id = 9;
                template.name = '打击者';
                template.objName = '3002';
                template.type = 3;
                template.interval = 2000;
                template.attackSound = 'QBU88Fire.mp3';
                template.magazineBullet = 10;
                template.bullets = 20;
                template.bulletChangeTimer = 2000;
                template.hit = 120;
                template.bodyMultiple = 1.98;
                template.headHit = 237.6;
                template.limbMultiple = 0.8;
                template.limbHit = 96;
                template.maxBodyHit = 280;
                template.maxHeadHit = 700;
                template.maxLimbHit = 250;
                template.isCanOpMirror = 0;
                template.cutScale = 0;
                template.attackDis = -1;
                template.icon = 'sub1/equip/arm/9.png';
                template.recoilForce = [3, 0];
                template.reloadsound = 'reload1.mp3';
                template.firestarter = 'm4_Effect';
                template.ballistic = 'fire';
                template.bullethole = 'impactSparks';
                template.price = 45000;
                template.produce = 450;
                template.priceByDiamond = 450;
                template.grade = 4;
                template.lv = 1;
                template.pierceThrough = 85;
                template.range = 70;
                template.sight = -1;
                template.movingSpeed = 0.11;
                template.biochemicalCharging = 0;
                template.accurate = 38;
                ARM.cache[key] = template;
                return template;
            } else if (key == 10) {
                let template = new ARM();
                template.id = 10;
                template.name = '幻影';
                template.objName = '5005';
                template.type = 5;
                template.interval = 180;
                template.attackSound = 'VectorFire.mp3';
                template.magazineBullet = 30;
                template.bullets = 60;
                template.bulletChangeTimer = 2000;
                template.hit = 19;
                template.bodyMultiple = 1.55;
                template.headHit = 29.45;
                template.limbMultiple = 0.54;
                template.limbHit = 10.26;
                template.maxBodyHit = 30;
                template.maxHeadHit = 50;
                template.maxLimbHit = 20;
                template.isCanOpMirror = 0;
                template.cutScale = 0;
                template.attackDis = 1;
                template.icon = 'sub1/equip/arm/10.png';
                template.recoilForce = [0.1, 0];
                template.reloadsound = 'reload1.mp3';
                template.firestarter = 'm4_Effect';
                template.ballistic = 'fire';
                template.bullethole = 'impactSparks';
                template.price = 50000;
                template.produce = 500;
                template.priceByDiamond = 500;
                template.grade = 4;
                template.lv = 1;
                template.pierceThrough = 70;
                template.range = 30;
                template.sight = -1;
                template.movingSpeed = 0.15;
                template.biochemicalCharging = 0;
                template.accurate = 39;
                ARM.cache[key] = template;
                return template;
            } else if (key == 11) {
                let template = new ARM();
                template.id = 11;
                template.name = 'Q97-猩红猎手';
                template.objName = '5002';
                template.type = 5;
                template.interval = 180;
                template.attackSound = 'P90Fire.mp3';
                template.magazineBullet = 40;
                template.bullets = 80;
                template.bulletChangeTimer = 2000;
                template.hit = 20;
                template.bodyMultiple = 1.55;
                template.headHit = 31;
                template.limbMultiple = 0.54;
                template.limbHit = 10.8;
                template.maxBodyHit = 30;
                template.maxHeadHit = 50;
                template.maxLimbHit = 20;
                template.isCanOpMirror = 0;
                template.cutScale = 0;
                template.attackDis = -1;
                template.icon = 'sub1/equip/arm/11.png';
                template.recoilForce = [0.1, 0];
                template.reloadsound = 'reload1.mp3';
                template.firestarter = 'm4_Effect';
                template.ballistic = 'fire';
                template.bullethole = 'impactSparks';
                template.price = 55000;
                template.produce = 550;
                template.priceByDiamond = 550;
                template.grade = 4;
                template.lv = 1;
                template.pierceThrough = 75;
                template.range = 30;
                template.sight = -1;
                template.movingSpeed = 0.15;
                template.biochemicalCharging = 0;
                template.accurate = 40;
                ARM.cache[key] = template;
                return template;
            } else if (key == 12) {
                let template = new ARM();
                template.id = 12;
                template.name = 'M8-金色幻想';
                template.objName = '4002';
                template.type = 4;
                template.interval = 500;
                template.attackSound = 'shamozhiyingFire.mp3';
                template.magazineBullet = 15;
                template.bullets = 30;
                template.bulletChangeTimer = 2000;
                template.hit = 40;
                template.bodyMultiple = 1.7;
                template.headHit = 68;
                template.limbMultiple = 0.7;
                template.limbHit = 28;
                template.maxBodyHit = 80;
                template.maxHeadHit = 120;
                template.maxLimbHit = 60;
                template.isCanOpMirror = 0;
                template.cutScale = 0;
                template.attackDis = -1;
                template.icon = 'sub1/equip/arm/12.png';
                template.recoilForce = [0.5, 0];
                template.reloadsound = 'reload2.mp3';
                template.firestarter = 'm4_Effect';
                template.ballistic = 'fire';
                template.bullethole = 'impactSparks';
                template.price = 60000;
                template.produce = 600;
                template.priceByDiamond = 600;
                template.grade = 4;
                template.lv = 1;
                template.pierceThrough = 40;
                template.range = 20;
                template.sight = -1;
                template.movingSpeed = 0.18;
                template.biochemicalCharging = 0;
                template.accurate = 41;
                ARM.cache[key] = template;
                return template;
            } else if (key == 13) {
                let template = new ARM();
                template.id = 13;
                template.name = 'SKG-突击者';
                template.objName = '1004';
                template.type = 1;
                template.interval = 200;
                template.attackSound = 'M4A1Fire.mp3';
                template.magazineBullet = 30;
                template.bullets = 60;
                template.bulletChangeTimer = 2000;
                template.hit = 22;
                template.bodyMultiple = 1.6;
                template.headHit = 35.2;
                template.limbMultiple = 0.65;
                template.limbHit = 14.3;
                template.maxBodyHit = 50;
                template.maxHeadHit = 80;
                template.maxLimbHit = 40;
                template.isCanOpMirror = 0;
                template.cutScale = 0;
                template.attackDis = -1;
                template.icon = 'sub1/equip/arm/13.png';
                template.recoilForce = [0.1, 0];
                template.reloadsound = 'reload1.mp3';
                template.firestarter = 'm4_Effect';
                template.ballistic = 'fire';
                template.bullethole = 'impactSparks';
                template.price = 65000;
                template.produce = 650;
                template.priceByDiamond = 650;
                template.grade = 4;
                template.lv = 1;
                template.pierceThrough = 51;
                template.range = 50;
                template.sight = -1;
                template.movingSpeed = 0.14;
                template.biochemicalCharging = 0;
                template.accurate = 42;
                ARM.cache[key] = template;
                return template;
            } else if (key == 14) {
                let template = new ARM();
                template.id = 14;
                template.name = '粒子风暴';
                template.objName = '1005';
                template.type = 1;
                template.interval = 200;
                template.attackSound = 'AK47Fire.mp3';
                template.magazineBullet = 30;
                template.bullets = 60;
                template.bulletChangeTimer = 2000;
                template.hit = 23;
                template.bodyMultiple = 1.6;
                template.headHit = 36.8;
                template.limbMultiple = 0.65;
                template.limbHit = 14.95;
                template.maxBodyHit = 50;
                template.maxHeadHit = 80;
                template.maxLimbHit = 40;
                template.isCanOpMirror = 0;
                template.cutScale = 0;
                template.attackDis = -1;
                template.icon = 'sub1/equip/arm/14.png';
                template.recoilForce = [0.1, 0];
                template.reloadsound = 'reload1.mp3';
                template.firestarter = 'm4_Effect';
                template.ballistic = 'fire';
                template.bullethole = 'impactSparks';
                template.price = 70000;
                template.produce = 700;
                template.priceByDiamond = 700;
                template.grade = 4;
                template.lv = 1;
                template.pierceThrough = 53;
                template.range = 50;
                template.sight = -1;
                template.movingSpeed = 0.14;
                template.biochemicalCharging = 0;
                template.accurate = 43;
                ARM.cache[key] = template;
                return template;
            } else if (key == 15) {
                let template = new ARM();
                template.id = 15;
                template.name = 'AWM-闪击者';
                template.objName = '3003';
                template.type = 3;
                template.interval = 2000;
                template.attackSound = 'SVDFire.mp3';
                template.magazineBullet = 10;
                template.bullets = 20;
                template.bulletChangeTimer = 2000;
                template.hit = 140;
                template.bodyMultiple = 1.98;
                template.headHit = 277.2;
                template.limbMultiple = 0.8;
                template.limbHit = 112;
                template.maxBodyHit = 280;
                template.maxHeadHit = 700;
                template.maxLimbHit = 250;
                template.isCanOpMirror = 0;
                template.cutScale = 0;
                template.attackDis = -1;
                template.icon = 'sub1/equip/arm/15.png';
                template.recoilForce = [3, 0];
                template.reloadsound = 'reload1.mp3';
                template.firestarter = 'm4_Effect';
                template.ballistic = 'fire';
                template.bullethole = 'impactSparks';
                template.price = 75000;
                template.produce = 750;
                template.priceByDiamond = 750;
                template.grade = 4;
                template.lv = 1;
                template.pierceThrough = 90;
                template.range = 70;
                template.sight = -1;
                template.movingSpeed = 0.11;
                template.biochemicalCharging = 0;
                template.accurate = 44;
                ARM.cache[key] = template;
                return template;
            } else if (key == 16) {
                let template = new ARM();
                template.id = 16;
                template.name = 'M700';
                template.objName = '7001';
                template.type = 7;
                template.interval = 1800;
                template.attackSound = 'qichuiFire.mp3';
                template.magazineBullet = 7;
                template.bullets = 14;
                template.bulletChangeTimer = 2000;
                template.hit = 35;
                template.bodyMultiple = 1.5;
                template.headHit = 52.5;
                template.limbMultiple = 0.8;
                template.limbHit = 28;
                template.maxBodyHit = 50;
                template.maxHeadHit = 90;
                template.maxLimbHit = 50;
                template.isCanOpMirror = 0;
                template.cutScale = 0;
                template.attackDis = -1;
                template.icon = 'sub1/equip/arm/16.png';
                template.recoilForce = [1.5, 0];
                template.reloadsound = 'reload1.mp3';
                template.firestarter = 'm4_Effect';
                template.ballistic = 'fire';
                template.bullethole = 'impactSparks';
                template.price = 80000;
                template.produce = 800;
                template.priceByDiamond = 800;
                template.grade = 4;
                template.lv = 1;
                template.pierceThrough = 86;
                template.range = 10;
                template.sight = -1;
                template.movingSpeed = 0.13;
                template.biochemicalCharging = 0;
                template.accurate = 45;
                ARM.cache[key] = template;
                return template;
            } else if (key == 17) {
                let template = new ARM();
                template.id = 17;
                template.name = '星际霸者';
                template.objName = '6001';
                template.type = 6;
                template.interval = 250;
                template.attackSound = 'M60Fire.mp3';
                template.magazineBullet = 100;
                template.bullets = 200;
                template.bulletChangeTimer = 2000;
                template.hit = 20;
                template.bodyMultiple = 1.75;
                template.headHit = 35;
                template.limbMultiple = 0.73;
                template.limbHit = 14.6;
                template.maxBodyHit = 30;
                template.maxHeadHit = 60;
                template.maxLimbHit = 30;
                template.isCanOpMirror = 0;
                template.cutScale = 0;
                template.attackDis = -1;
                template.icon = 'sub1/equip/arm/17.png';
                template.recoilForce = [0.5, 0];
                template.reloadsound = 'reload1.mp3';
                template.firestarter = 'm4_Effect';
                template.ballistic = 'fire';
                template.bullethole = 'impactSparks';
                template.price = 85000;
                template.produce = 850;
                template.priceByDiamond = 850;
                template.grade = 4;
                template.lv = 1;
                template.pierceThrough = 70;
                template.range = 40;
                template.sight = -1;
                template.movingSpeed = 0.1;
                template.biochemicalCharging = 0;
                template.accurate = 46;
                ARM.cache[key] = template;
                return template;
            } else if (key == 18) {
                let template = new ARM();
                template.id = 18;
                template.name = '伪装者';
                template.objName = '1009';
                template.type = 1;
                template.interval = 200;
                template.attackSound = 'AUGFire.mp3';
                template.magazineBullet = 30;
                template.bullets = 60;
                template.bulletChangeTimer = 2000;
                template.hit = 24;
                template.bodyMultiple = 1.6;
                template.headHit = 38.4;
                template.limbMultiple = 0.65;
                template.limbHit = 15.6;
                template.maxBodyHit = 50;
                template.maxHeadHit = 80;
                template.maxLimbHit = 40;
                template.isCanOpMirror = 0;
                template.cutScale = 0;
                template.attackDis = -1;
                template.icon = 'sub1/equip/arm/18.png';
                template.recoilForce = [0.1, 0];
                template.reloadsound = 'reload1.mp3';
                template.firestarter = 'm4_Effect';
                template.ballistic = 'fire';
                template.bullethole = 'impactSparks';
                template.price = 90000;
                template.produce = 900;
                template.priceByDiamond = 900;
                template.grade = 4;
                template.lv = 1;
                template.pierceThrough = 55;
                template.range = 50;
                template.sight = -1;
                template.movingSpeed = 0.14;
                template.biochemicalCharging = 0;
                template.accurate = 47;
                ARM.cache[key] = template;
                return template;
            } else if (key == 19) {
                let template = new ARM();
                template.id = 19;
                template.name = '正义仲裁者';
                template.objName = '1011';
                template.type = 1;
                template.interval = 200;
                template.attackSound = 'QBZ03Fire.mp3';
                template.magazineBullet = 30;
                template.bullets = 60;
                template.bulletChangeTimer = 2000;
                template.hit = 25;
                template.bodyMultiple = 1.6;
                template.headHit = 40;
                template.limbMultiple = 0.65;
                template.limbHit = 16.25;
                template.maxBodyHit = 50;
                template.maxHeadHit = 80;
                template.maxLimbHit = 40;
                template.isCanOpMirror = 0;
                template.cutScale = 0;
                template.attackDis = -1;
                template.icon = 'sub1/equip/arm/19.png';
                template.recoilForce = [0.1, 0];
                template.reloadsound = 'reload1.mp3';
                template.firestarter = 'm4_Effect';
                template.ballistic = 'fire';
                template.bullethole = 'impactSparks';
                template.price = 95000;
                template.produce = 950;
                template.priceByDiamond = 950;
                template.grade = 4;
                template.lv = 1;
                template.pierceThrough = 57;
                template.range = 50;
                template.sight = -1;
                template.movingSpeed = 0.14;
                template.biochemicalCharging = 0;
                template.accurate = 48;
                ARM.cache[key] = template;
                return template;
            } else if (key == 20) {
                let template = new ARM();
                template.id = 20;
                template.name = '绿魔';
                template.objName = '3004';
                template.type = 3;
                template.interval = 2000;
                template.attackSound = 'AWPFire.mp3';
                template.magazineBullet = 10;
                template.bullets = 20;
                template.bulletChangeTimer = 2000;
                template.hit = 160;
                template.bodyMultiple = 1.98;
                template.headHit = 316.8;
                template.limbMultiple = 0.8;
                template.limbHit = 128;
                template.maxBodyHit = 280;
                template.maxHeadHit = 700;
                template.maxLimbHit = 250;
                template.isCanOpMirror = 0;
                template.cutScale = 0;
                template.attackDis = -1;
                template.icon = 'sub1/equip/arm/20.png';
                template.recoilForce = [3, 0];
                template.reloadsound = 'reload1.mp3';
                template.firestarter = 'm4_Effect';
                template.ballistic = 'fire';
                template.bullethole = 'impactSparks';
                template.price = 100000;
                template.produce = 1000;
                template.priceByDiamond = 1050;
                template.grade = 4;
                template.lv = 1;
                template.pierceThrough = 95;
                template.range = 70;
                template.sight = -1;
                template.movingSpeed = 0.11;
                template.biochemicalCharging = 0;
                template.accurate = 49;
                ARM.cache[key] = template;
                return template;
            } else if (key == 21) {
                let template = new ARM();
                template.id = 21;
                template.name = '空之律者';
                template.objName = '5001';
                template.type = 5;
                template.interval = 180;
                template.attackSound = 'tangmuxunFire.mp3';
                template.magazineBullet = 40;
                template.bullets = 80;
                template.bulletChangeTimer = 2000;
                template.hit = 21;
                template.bodyMultiple = 1.55;
                template.headHit = 32.55;
                template.limbMultiple = 0.54;
                template.limbHit = 11.34;
                template.maxBodyHit = 30;
                template.maxHeadHit = 50;
                template.maxLimbHit = 20;
                template.isCanOpMirror = 0;
                template.cutScale = 0;
                template.attackDis = -1;
                template.icon = 'sub1/equip/arm/21.png';
                template.recoilForce = [0.1, 0];
                template.reloadsound = 'reload1.mp3';
                template.firestarter = 'm4_Effect';
                template.ballistic = 'fire';
                template.bullethole = 'impactSparks';
                template.price = 150000;
                template.produce = 1500;
                template.priceByDiamond = 1100;
                template.grade = 4;
                template.lv = 1;
                template.pierceThrough = 80;
                template.range = 30;
                template.sight = -1;
                template.movingSpeed = 0.15;
                template.biochemicalCharging = 0;
                template.accurate = 50;
                ARM.cache[key] = template;
                return template;
            } else if (key == 22) {
                let template = new ARM();
                template.id = 22;
                template.name = '神圣骑士';
                template.objName = '5003';
                template.type = 5;
                template.interval = 180;
                template.attackSound = 'MP5-XFire.mp3';
                template.magazineBullet = 40;
                template.bullets = 80;
                template.bulletChangeTimer = 2000;
                template.hit = 22;
                template.bodyMultiple = 1.63;
                template.headHit = 35.86;
                template.limbMultiple = 0.57;
                template.limbHit = 12.54;
                template.maxBodyHit = 30;
                template.maxHeadHit = 50;
                template.maxLimbHit = 20;
                template.isCanOpMirror = 0;
                template.cutScale = 0;
                template.attackDis = -1;
                template.icon = 'sub1/equip/arm/22.png';
                template.recoilForce = [0.1, 0];
                template.reloadsound = 'reload1.mp3';
                template.firestarter = 'm4_Effect';
                template.ballistic = 'fire';
                template.bullethole = 'impactSparks';
                template.price = 200000;
                template.produce = 2000;
                template.priceByDiamond = 1150;
                template.grade = 4;
                template.lv = 1;
                template.pierceThrough = 85;
                template.range = 30;
                template.sight = -1;
                template.movingSpeed = 0.15;
                template.biochemicalCharging = 0;
                template.accurate = 51;
                ARM.cache[key] = template;
                return template;
            } else if (key == 23) {
                let template = new ARM();
                template.id = 23;
                template.name = '咆哮';
                template.objName = '6002';
                template.type = 6;
                template.interval = 250;
                template.attackSound = 'RPKFire.mp3';
                template.magazineBullet = 100;
                template.bullets = 200;
                template.bulletChangeTimer = 2000;
                template.hit = 22;
                template.bodyMultiple = 1.75;
                template.headHit = 38.5;
                template.limbMultiple = 0.73;
                template.limbHit = 16.06;
                template.maxBodyHit = 30;
                template.maxHeadHit = 60;
                template.maxLimbHit = 30;
                template.isCanOpMirror = 0;
                template.cutScale = 0;
                template.attackDis = -1;
                template.icon = 'sub1/equip/arm/23.png';
                template.recoilForce = [0.5, 0];
                template.reloadsound = 'reload1.mp3';
                template.firestarter = 'm4_Effect';
                template.ballistic = 'fire';
                template.bullethole = 'impactSparks';
                template.price = 250000;
                template.produce = 2500;
                template.priceByDiamond = 1200;
                template.grade = 3;
                template.lv = 1;
                template.pierceThrough = 75;
                template.range = 40;
                template.sight = -1;
                template.movingSpeed = 0.1;
                template.biochemicalCharging = 0;
                template.accurate = 52;
                ARM.cache[key] = template;
                return template;
            } else if (key == 24) {
                let template = new ARM();
                template.id = 24;
                template.name = '恶灵骑士';
                template.objName = '1007';
                template.type = 1;
                template.interval = 200;
                template.attackSound = 'QBZ95Fire.mp3';
                template.magazineBullet = 30;
                template.bullets = 60;
                template.bulletChangeTimer = 2000;
                template.hit = 26;
                template.bodyMultiple = 1.68;
                template.headHit = 43.68;
                template.limbMultiple = 0.7;
                template.limbHit = 18.2;
                template.maxBodyHit = 50;
                template.maxHeadHit = 80;
                template.maxLimbHit = 40;
                template.isCanOpMirror = 0;
                template.cutScale = 0;
                template.attackDis = -1;
                template.icon = 'sub1/equip/arm/24.png';
                template.recoilForce = [0.1, 0];
                template.reloadsound = 'reload1.mp3';
                template.firestarter = 'm4_Effect';
                template.ballistic = 'fire';
                template.bullethole = 'impactSparks';
                template.price = 300000;
                template.produce = 3000;
                template.priceByDiamond = 1250;
                template.grade = 3;
                template.lv = 1;
                template.pierceThrough = 59;
                template.range = 50;
                template.sight = -1;
                template.movingSpeed = 0.14;
                template.biochemicalCharging = 0;
                template.accurate = 53;
                ARM.cache[key] = template;
                return template;
            } else if (key == 25) {
                let template = new ARM();
                template.id = 25;
                template.name = '幽冥双子星';
                template.objName = '4003';
                template.type = 4;
                template.interval = 500;
                template.attackSound = 'shuangzixingFire.mp3';
                template.magazineBullet = 15;
                template.bullets = 30;
                template.bulletChangeTimer = 2000;
                template.hit = 60;
                template.bodyMultiple = 1.88;
                template.headHit = 112.8;
                template.limbMultiple = 0.8;
                template.limbHit = 48;
                template.maxBodyHit = 80;
                template.maxHeadHit = 120;
                template.maxLimbHit = 60;
                template.isCanOpMirror = 0;
                template.cutScale = 0;
                template.attackDis = -1;
                template.icon = 'sub1/equip/arm/25.png';
                template.recoilForce = [0.5, 0];
                template.reloadsound = 'reload2.mp3';
                template.firestarter = 'm4_Effect';
                template.ballistic = 'fire';
                template.bullethole = 'impactSparks';
                template.price = 350000;
                template.produce = 3500;
                template.priceByDiamond = 1300;
                template.grade = 3;
                template.lv = 1;
                template.pierceThrough = 50;
                template.range = 20;
                template.sight = -1;
                template.movingSpeed = 0.18;
                template.biochemicalCharging = 0;
                template.accurate = 54;
                ARM.cache[key] = template;
                return template;
            } else if (key == 26) {
                let template = new ARM();
                template.id = 26;
                template.name = '玫瑰精灵';
                template.objName = '3005';
                template.type = 3;
                template.interval = 2000;
                template.attackSound = 'MSRFire.mp3';
                template.magazineBullet = 10;
                template.bullets = 20;
                template.bulletChangeTimer = 2000;
                template.hit = 180;
                template.bodyMultiple = 2;
                template.headHit = 360;
                template.limbMultiple = 0.83;
                template.limbHit = 149.4;
                template.maxBodyHit = 280;
                template.maxHeadHit = 700;
                template.maxLimbHit = 250;
                template.isCanOpMirror = 0;
                template.cutScale = 0;
                template.attackDis = -1;
                template.icon = 'sub1/equip/arm/26.png';
                template.recoilForce = [3, 0];
                template.reloadsound = 'reload1.mp3';
                template.firestarter = 'm4_Effect';
                template.ballistic = 'fire';
                template.bullethole = 'impactSparks';
                template.price = 400000;
                template.produce = 4000;
                template.priceByDiamond = 1350;
                template.grade = 3;
                template.lv = 1;
                template.pierceThrough = 100;
                template.range = 70;
                template.sight = -1;
                template.movingSpeed = 0.11;
                template.biochemicalCharging = 0;
                template.accurate = 55;
                ARM.cache[key] = template;
                return template;
            } else if (key == 27) {
                let template = new ARM();
                template.id = 27;
                template.name = '黄金M4A1';
                template.objName = '1015';
                template.type = 1;
                template.interval = 200;
                template.attackSound = 'SCARFire.mp3';
                template.magazineBullet = 30;
                template.bullets = 60;
                template.bulletChangeTimer = 2000;
                template.hit = 27;
                template.bodyMultiple = 1.68;
                template.headHit = 45.36;
                template.limbMultiple = 0.7;
                template.limbHit = 18.9;
                template.maxBodyHit = 50;
                template.maxHeadHit = 80;
                template.maxLimbHit = 40;
                template.isCanOpMirror = 0;
                template.cutScale = 0;
                template.attackDis = -1;
                template.icon = 'sub1/equip/arm/27.png';
                template.recoilForce = [0.1, 0];
                template.reloadsound = 'reload1.mp3';
                template.firestarter = 'm4_Effect';
                template.ballistic = 'fire';
                template.bullethole = 'impactSparks';
                template.price = 450000;
                template.produce = 4500;
                template.priceByDiamond = 1400;
                template.grade = 3;
                template.lv = 1;
                template.pierceThrough = 61;
                template.range = 50;
                template.sight = -1;
                template.movingSpeed = 0.14;
                template.biochemicalCharging = 0;
                template.accurate = 56;
                ARM.cache[key] = template;
                return template;
            } else if (key == 28) {
                let template = new ARM();
                template.id = 28;
                template.name = '天启者';
                template.objName = '6006';
                template.type = 6;
                template.interval = 250;
                template.attackSound = 'RPKFire.mp3';
                template.magazineBullet = 30;
                template.bullets = 60;
                template.bulletChangeTimer = 2000;
                template.hit = 28;
                template.bodyMultiple = 1.68;
                template.headHit = 47.04;
                template.limbMultiple = 0.7;
                template.limbHit = 19.6;
                template.maxBodyHit = 50;
                template.maxHeadHit = 80;
                template.maxLimbHit = 40;
                template.isCanOpMirror = 0;
                template.cutScale = 0;
                template.attackDis = -1;
                template.icon = 'sub1/equip/arm/28.png';
                template.recoilForce = [0.1, 0];
                template.reloadsound = 'reload1.mp3';
                template.firestarter = 'm4_Effect';
                template.ballistic = 'fire';
                template.bullethole = 'impactSparks';
                template.price = 500000;
                template.produce = 5000;
                template.priceByDiamond = 1450;
                template.grade = 3;
                template.lv = 1;
                template.pierceThrough = 63;
                template.range = 50;
                template.sight = -1;
                template.movingSpeed = 0.14;
                template.biochemicalCharging = 0;
                template.accurate = 57;
                ARM.cache[key] = template;
                return template;
            } else if (key == 29) {
                let template = new ARM();
                template.id = 29;
                template.name = '聚灵';
                template.objName = '7002';
                template.type = 7;
                template.interval = 1800;
                template.attackSound = 'KSGFire.mp3';
                template.magazineBullet = 10;
                template.bullets = 20;
                template.bulletChangeTimer = 2000;
                template.hit = 40;
                template.bodyMultiple = 1.6;
                template.headHit = 64;
                template.limbMultiple = 0.85;
                template.limbHit = 34;
                template.maxBodyHit = 50;
                template.maxHeadHit = 90;
                template.maxLimbHit = 50;
                template.isCanOpMirror = 0;
                template.cutScale = 0;
                template.attackDis = -1;
                template.icon = 'sub1/equip/arm/29.png';
                template.recoilForce = [1.5, 0];
                template.reloadsound = 'reload1.mp3';
                template.firestarter = 'm4_Effect';
                template.ballistic = 'fire';
                template.bullethole = 'impactSparks';
                template.price = 550000;
                template.produce = 5500;
                template.priceByDiamond = 1500;
                template.grade = 3;
                template.lv = 1;
                template.pierceThrough = 92;
                template.range = 10;
                template.sight = -1;
                template.movingSpeed = 0.13;
                template.biochemicalCharging = 0;
                template.accurate = 58;
                ARM.cache[key] = template;
                return template;
            } else if (key == 30) {
                let template = new ARM();
                template.id = 30;
                template.name = '逆转次元';
                template.objName = '1001';
                template.type = 1;
                template.interval = 200;
                template.attackSound = 'AN94Fire.mp3';
                template.magazineBullet = 30;
                template.bullets = 60;
                template.bulletChangeTimer = 2000;
                template.hit = 29;
                template.bodyMultiple = 1.68;
                template.headHit = 48.72;
                template.limbMultiple = 0.7;
                template.limbHit = 20.3;
                template.maxBodyHit = 50;
                template.maxHeadHit = 80;
                template.maxLimbHit = 40;
                template.isCanOpMirror = 0;
                template.cutScale = 0;
                template.attackDis = -1;
                template.icon = 'sub1/equip/arm/30.png';
                template.recoilForce = [0.1, 0];
                template.reloadsound = 'reload1.mp3';
                template.firestarter = 'm4_Effect';
                template.ballistic = 'fire';
                template.bullethole = 'impactSparks';
                template.price = 600000;
                template.produce = 6000;
                template.priceByDiamond = 1550;
                template.grade = 3;
                template.lv = 1;
                template.pierceThrough = 65;
                template.range = 50;
                template.sight = -1;
                template.movingSpeed = 0.14;
                template.biochemicalCharging = 0;
                template.accurate = 59;
                ARM.cache[key] = template;
                return template;
            } else if (key == 31) {
                let template = new ARM();
                template.id = 31;
                template.name = '超级照明灯';
                template.objName = '6003';
                template.type = 6;
                template.interval = 250;
                template.attackSound = 'MG3Fire.mp3';
                template.magazineBullet = 100;
                template.bullets = 200;
                template.bulletChangeTimer = 2000;
                template.hit = 24;
                template.bodyMultiple = 1.78;
                template.headHit = 42.72;
                template.limbMultiple = 0.78;
                template.limbHit = 18.72;
                template.maxBodyHit = 30;
                template.maxHeadHit = 60;
                template.maxLimbHit = 30;
                template.isCanOpMirror = 0;
                template.cutScale = 0;
                template.attackDis = -1;
                template.icon = 'sub1/equip/arm/31.png';
                template.recoilForce = [0.5, 0];
                template.reloadsound = 'reload1.mp3';
                template.firestarter = 'm4_Effect';
                template.ballistic = 'fire';
                template.bullethole = 'impactSparks';
                template.price = 650000;
                template.produce = 6500;
                template.priceByDiamond = 1600;
                template.grade = 3;
                template.lv = 1;
                template.pierceThrough = 80;
                template.range = 40;
                template.sight = -1;
                template.movingSpeed = 0.1;
                template.biochemicalCharging = 0;
                template.accurate = 60;
                ARM.cache[key] = template;
                return template;
            } else if (key == 32) {
                let template = new ARM();
                template.id = 32;
                template.name = 'MK50-魅影';
                template.objName = '3006';
                template.type = 3;
                template.interval = 2000;
                template.attackSound = 'leitingFire.mp3';
                template.magazineBullet = 10;
                template.bullets = 20;
                template.bulletChangeTimer = 2000;
                template.hit = 200;
                template.bodyMultiple = 2;
                template.headHit = 400;
                template.limbMultiple = 0.83;
                template.limbHit = 166;
                template.maxBodyHit = 280;
                template.maxHeadHit = 700;
                template.maxLimbHit = 250;
                template.isCanOpMirror = 0;
                template.cutScale = 0;
                template.attackDis = -1;
                template.icon = 'sub1/equip/arm/32.png';
                template.recoilForce = [3, 0];
                template.reloadsound = 'reload1.mp3';
                template.firestarter = 'm4_Effect';
                template.ballistic = 'fire';
                template.bullethole = 'impactSparks';
                template.price = 700000;
                template.produce = 7000;
                template.priceByDiamond = 1650;
                template.grade = 3;
                template.lv = 1;
                template.pierceThrough = 105;
                template.range = 70;
                template.sight = -1;
                template.movingSpeed = 0.11;
                template.biochemicalCharging = 0;
                template.accurate = 61;
                ARM.cache[key] = template;
                return template;
            } else if (key == 33) {
                let template = new ARM();
                template.id = 33;
                template.name = '等离子电磁炮';
                template.objName = '1010';
                template.type = 1;
                template.interval = 200;
                template.attackSound = 'dengliziFire.mp3';
                template.magazineBullet = 30;
                template.bullets = 60;
                template.bulletChangeTimer = 2000;
                template.hit = 30;
                template.bodyMultiple = 1.68;
                template.headHit = 50.4;
                template.limbMultiple = 0.7;
                template.limbHit = 21;
                template.maxBodyHit = 50;
                template.maxHeadHit = 80;
                template.maxLimbHit = 40;
                template.isCanOpMirror = 0;
                template.cutScale = 0;
                template.attackDis = -1;
                template.icon = 'sub1/equip/arm/33.png';
                template.recoilForce = [0.1, 0];
                template.reloadsound = 'reload1.mp3';
                template.firestarter = 'm4_Effect';
                template.ballistic = 'fire';
                template.bullethole = 'impactSparks';
                template.price = 750000;
                template.produce = 7500;
                template.priceByDiamond = 1700;
                template.grade = 3;
                template.lv = 1;
                template.pierceThrough = 67;
                template.range = 50;
                template.sight = -1;
                template.movingSpeed = 0.14;
                template.biochemicalCharging = 0;
                template.accurate = 62;
                ARM.cache[key] = template;
                return template;
            } else if (key == 34) {
                let template = new ARM();
                template.id = 34;
                template.name = '红莲审判';
                template.objName = '1012';
                template.type = 1;
                template.interval = 200;
                template.attackSound = 'guizuqishiFire.mp3';
                template.magazineBullet = 30;
                template.bullets = 60;
                template.bulletChangeTimer = 2000;
                template.hit = 31;
                template.bodyMultiple = 1.68;
                template.headHit = 52.08;
                template.limbMultiple = 0.7;
                template.limbHit = 21.7;
                template.maxBodyHit = 50;
                template.maxHeadHit = 80;
                template.maxLimbHit = 40;
                template.isCanOpMirror = 0;
                template.cutScale = 0;
                template.attackDis = -1;
                template.icon = 'sub1/equip/arm/34.png';
                template.recoilForce = [0.1, 0];
                template.reloadsound = 'reload1.mp3';
                template.firestarter = 'm4_Effect';
                template.ballistic = 'fire';
                template.bullethole = 'impactSparks';
                template.price = 800000;
                template.produce = 8000;
                template.priceByDiamond = 1750;
                template.grade = 3;
                template.lv = 1;
                template.pierceThrough = 69;
                template.range = 50;
                template.sight = -1;
                template.movingSpeed = 0.14;
                template.biochemicalCharging = 0;
                template.accurate = 63;
                ARM.cache[key] = template;
                return template;
            } else if (key == 35) {
                let template = new ARM();
                template.id = 35;
                template.name = '圣诞大喇叭';
                template.objName = '1014';
                template.type = 1;
                template.interval = 200;
                template.attackSound = 'labaFire.mp3';
                template.magazineBullet = 35;
                template.bullets = 70;
                template.bulletChangeTimer = 2000;
                template.hit = 32;
                template.bodyMultiple = 1.68;
                template.headHit = 53.76;
                template.limbMultiple = 0.7;
                template.limbHit = 22.4;
                template.maxBodyHit = 50;
                template.maxHeadHit = 80;
                template.maxLimbHit = 40;
                template.isCanOpMirror = 0;
                template.cutScale = 0;
                template.attackDis = -1;
                template.icon = 'sub1/equip/arm/35.png';
                template.recoilForce = [0.1, 0];
                template.reloadsound = 'reload1.mp3';
                template.firestarter = 'm4_Effect';
                template.ballistic = 'fire';
                template.bullethole = 'impactSparks';
                template.price = 850000;
                template.produce = 8500;
                template.priceByDiamond = 1800;
                template.grade = 3;
                template.lv = 1;
                template.pierceThrough = 71;
                template.range = 50;
                template.sight = -1;
                template.movingSpeed = 0.14;
                template.biochemicalCharging = 0;
                template.accurate = 64;
                ARM.cache[key] = template;
                return template;
            } else if (key == 36) {
                let template = new ARM();
                template.id = 36;
                template.name = '病毒T-800';
                template.objName = '1003';
                template.type = 1;
                template.interval = 200;
                template.attackSound = 'dulongzhuanFire.mp3';
                template.magazineBullet = 35;
                template.bullets = 70;
                template.bulletChangeTimer = 2000;
                template.hit = 33;
                template.bodyMultiple = 1.68;
                template.headHit = 55.44;
                template.limbMultiple = 0.7;
                template.limbHit = 23.1;
                template.maxBodyHit = 50;
                template.maxHeadHit = 80;
                template.maxLimbHit = 40;
                template.isCanOpMirror = 0;
                template.cutScale = 0;
                template.attackDis = -1;
                template.icon = 'sub1/equip/arm/36.png';
                template.recoilForce = [0.1, 0];
                template.reloadsound = 'reload1.mp3';
                template.firestarter = 'm4_Effect';
                template.ballistic = 'fire';
                template.bullethole = 'impactSparks';
                template.price = 900000;
                template.produce = 9000;
                template.priceByDiamond = 1850;
                template.grade = 2;
                template.lv = 1;
                template.pierceThrough = 73;
                template.range = 50;
                template.sight = -1;
                template.movingSpeed = 0.14;
                template.biochemicalCharging = 0;
                template.accurate = 65;
                ARM.cache[key] = template;
                return template;
            } else if (key == 37) {
                let template = new ARM();
                template.id = 37;
                template.name = '圣枪-翎羽';
                template.objName = '3008';
                template.type = 3;
                template.interval = 2000;
                template.attackSound = 'M82A1Fire.mp3';
                template.magazineBullet = 15;
                template.bullets = 30;
                template.bulletChangeTimer = 2000;
                template.hit = 220;
                template.bodyMultiple = 2;
                template.headHit = 440;
                template.limbMultiple = 0.83;
                template.limbHit = 182.6;
                template.maxBodyHit = 280;
                template.maxHeadHit = 700;
                template.maxLimbHit = 250;
                template.isCanOpMirror = 0;
                template.cutScale = 0;
                template.attackDis = -1;
                template.icon = 'sub1/equip/arm/37.png';
                template.recoilForce = [3, 0];
                template.reloadsound = 'reload1.mp3';
                template.firestarter = 'm4_Effect';
                template.ballistic = 'fire';
                template.bullethole = 'impactSparks';
                template.price = 950000;
                template.produce = 9500;
                template.priceByDiamond = 1900;
                template.grade = 2;
                template.lv = 1;
                template.pierceThrough = 110;
                template.range = 70;
                template.sight = -1;
                template.movingSpeed = 0.11;
                template.biochemicalCharging = 0;
                template.accurate = 66;
                ARM.cache[key] = template;
                return template;
            } else if (key == 38) {
                let template = new ARM();
                template.id = 38;
                template.name = '阿波菲斯之怒';
                template.objName = '6004';
                template.type = 6;
                template.interval = 250;
                template.attackSound = 'M249Fire.mp3';
                template.magazineBullet = 150;
                template.bullets = 300;
                template.bulletChangeTimer = 2000;
                template.hit = 26;
                template.bodyMultiple = 1.8;
                template.headHit = 46.8;
                template.limbMultiple = 0.83;
                template.limbHit = 21.58;
                template.maxBodyHit = 30;
                template.maxHeadHit = 60;
                template.maxLimbHit = 30;
                template.isCanOpMirror = 0;
                template.cutScale = 0;
                template.attackDis = -1;
                template.icon = 'sub1/equip/arm/38.png';
                template.recoilForce = [0.5, 0];
                template.reloadsound = 'reload1.mp3';
                template.firestarter = 'm4_Effect';
                template.ballistic = 'fire';
                template.bullethole = 'impactSparks';
                template.price = 1000000;
                template.produce = 10000;
                template.priceByDiamond = 1950;
                template.grade = 2;
                template.lv = 1;
                template.pierceThrough = 85;
                template.range = 40;
                template.sight = -1;
                template.movingSpeed = 0.1;
                template.biochemicalCharging = 0;
                template.accurate = 67;
                ARM.cache[key] = template;
                return template;
            } else if (key == 39) {
                let template = new ARM();
                template.id = 39;
                template.name = '明月之祝福';
                template.objName = '1013';
                template.type = 1;
                template.interval = 200;
                template.attackSound = 'M4A1xiaoyinFire.mp3';
                template.magazineBullet = 35;
                template.bullets = 70;
                template.bulletChangeTimer = 2000;
                template.hit = 34;
                template.bodyMultiple = 1.85;
                template.headHit = 62.9;
                template.limbMultiple = 0.8;
                template.limbHit = 27.2;
                template.maxBodyHit = 50;
                template.maxHeadHit = 80;
                template.maxLimbHit = 40;
                template.isCanOpMirror = 0;
                template.cutScale = 0;
                template.attackDis = -1;
                template.icon = 'sub1/equip/arm/39.png';
                template.recoilForce = [0.1, 0];
                template.reloadsound = 'reload1.mp3';
                template.firestarter = 'm4_Effect';
                template.ballistic = 'fire';
                template.bullethole = 'impactSparks';
                template.price = 1500000;
                template.produce = 15000;
                template.priceByDiamond = 2000;
                template.grade = 2;
                template.lv = 1;
                template.pierceThrough = 75;
                template.range = 50;
                template.sight = -1;
                template.movingSpeed = 0.14;
                template.biochemicalCharging = 0;
                template.accurate = 68;
                ARM.cache[key] = template;
                return template;
            } else if (key == 40) {
                let template = new ARM();
                template.id = 40;
                template.name = '时空电流';
                template.objName = '1016';
                template.type = 1;
                template.interval = 200;
                template.attackSound = 'jidianFire.mp3';
                template.magazineBullet = 35;
                template.bullets = 70;
                template.bulletChangeTimer = 2000;
                template.hit = 35;
                template.bodyMultiple = 1.85;
                template.headHit = 64.75;
                template.limbMultiple = 0.8;
                template.limbHit = 28;
                template.maxBodyHit = 50;
                template.maxHeadHit = 80;
                template.maxLimbHit = 40;
                template.isCanOpMirror = 0;
                template.cutScale = 0;
                template.attackDis = -1;
                template.icon = 'sub1/equip/arm/40.png';
                template.recoilForce = [0.1, 0];
                template.reloadsound = 'reload1.mp3';
                template.firestarter = 'm4_Effect';
                template.ballistic = 'fire';
                template.bullethole = 'impactSparks';
                template.price = 2000000;
                template.produce = 20000;
                template.priceByDiamond = 2050;
                template.grade = 2;
                template.lv = 1;
                template.pierceThrough = 77;
                template.range = 50;
                template.sight = -1;
                template.movingSpeed = 0.14;
                template.biochemicalCharging = 0;
                template.accurate = 69;
                ARM.cache[key] = template;
                return template;
            } else if (key == 41) {
                let template = new ARM();
                template.id = 41;
                template.name = '钻石星尘';
                template.objName = '5009';
                template.type = 5;
                template.interval = 180;
                template.attackSound = 'shikongFire.mp3';
                template.magazineBullet = 50;
                template.bullets = 100;
                template.bulletChangeTimer = 2000;
                template.hit = 23;
                template.bodyMultiple = 1.68;
                template.headHit = 38.64;
                template.limbMultiple = 0.63;
                template.limbHit = 14.49;
                template.maxBodyHit = 30;
                template.maxHeadHit = 50;
                template.maxLimbHit = 20;
                template.isCanOpMirror = 0;
                template.cutScale = 0;
                template.attackDis = -1;
                template.icon = 'sub1/equip/arm/41.png';
                template.recoilForce = [0.1, 0];
                template.reloadsound = 'reload1.mp3';
                template.firestarter = 'm4_Effect';
                template.ballistic = 'fire';
                template.bullethole = 'impactSparks';
                template.price = 2500000;
                template.produce = 25000;
                template.priceByDiamond = 2100;
                template.grade = 2;
                template.lv = 1;
                template.pierceThrough = 90;
                template.range = 30;
                template.sight = -1;
                template.movingSpeed = 0.15;
                template.biochemicalCharging = 0;
                template.accurate = 70;
                ARM.cache[key] = template;
                return template;
            } else if (key == 42) {
                let template = new ARM();
                template.id = 42;
                template.name = '毁灭风暴';
                template.objName = '7003';
                template.type = 7;
                template.interval = 1800;
                template.attackSound = 'baijuFire.mp3';
                template.magazineBullet = 14;
                template.bullets = 28;
                template.bulletChangeTimer = 2000;
                template.hit = 45;
                template.bodyMultiple = 1.75;
                template.headHit = 78.75;
                template.limbMultiple = 0.9;
                template.limbHit = 40.5;
                template.maxBodyHit = 50;
                template.maxHeadHit = 90;
                template.maxLimbHit = 50;
                template.isCanOpMirror = 0;
                template.cutScale = 0;
                template.attackDis = -1;
                template.icon = 'sub1/equip/arm/42.png';
                template.recoilForce = [1.5, 0];
                template.reloadsound = 'reload1.mp3';
                template.firestarter = 'm4_Effect';
                template.ballistic = 'fire';
                template.bullethole = 'impactSparks';
                template.price = 3000000;
                template.produce = 30000;
                template.priceByDiamond = 2150;
                template.grade = 2;
                template.lv = 1;
                template.pierceThrough = 75;
                template.range = 10;
                template.sight = -1;
                template.movingSpeed = 0.13;
                template.biochemicalCharging = 0;
                template.accurate = 71;
                ARM.cache[key] = template;
                return template;
            } else if (key == 43) {
                let template = new ARM();
                template.id = 43;
                template.name = '黎明之眼';
                template.objName = '3014';
                template.type = 3;
                template.interval = 2000;
                template.attackSound = 'baleiteFire.mp3';
                template.magazineBullet = 15;
                template.bullets = 30;
                template.bulletChangeTimer = 2000;
                template.hit = 240;
                template.bodyMultiple = 2.5;
                template.headHit = 600;
                template.limbMultiple = 0.88;
                template.limbHit = 211.2;
                template.maxBodyHit = 280;
                template.maxHeadHit = 700;
                template.maxLimbHit = 250;
                template.isCanOpMirror = 0;
                template.cutScale = 0;
                template.attackDis = -1;
                template.icon = 'sub1/equip/arm/43.png';
                template.recoilForce = [3, 0];
                template.reloadsound = 'reload1.mp3';
                template.firestarter = 'm4_Effect';
                template.ballistic = 'fire';
                template.bullethole = 'impactSparks';
                template.price = 3500000;
                template.produce = 35000;
                template.priceByDiamond = 2200;
                template.grade = 2;
                template.lv = 1;
                template.pierceThrough = 115;
                template.range = 70;
                template.sight = -1;
                template.movingSpeed = 0.11;
                template.biochemicalCharging = 0;
                template.accurate = 72;
                ARM.cache[key] = template;
                return template;
            } else if (key == 44) {
                let template = new ARM();
                template.id = 44;
                template.name = '魔影之龙';
                template.objName = '1017';
                template.type = 1;
                template.interval = 200;
                template.attackSound = 'helongFire.mp3';
                template.magazineBullet = 35;
                template.bullets = 70;
                template.bulletChangeTimer = 2000;
                template.hit = 36;
                template.bodyMultiple = 1.85;
                template.headHit = 66.6;
                template.limbMultiple = 0.8;
                template.limbHit = 28.8;
                template.maxBodyHit = 50;
                template.maxHeadHit = 80;
                template.maxLimbHit = 40;
                template.isCanOpMirror = 0;
                template.cutScale = 0;
                template.attackDis = -1;
                template.icon = 'sub1/equip/arm/44.png';
                template.recoilForce = [0.1, 0];
                template.reloadsound = 'reload1.mp3';
                template.firestarter = 'm4_Effect';
                template.ballistic = 'fire';
                template.bullethole = 'impactSparks';
                template.price = 4000000;
                template.produce = 40000;
                template.priceByDiamond = 2250;
                template.grade = 2;
                template.lv = 1;
                template.pierceThrough = 79;
                template.range = 50;
                template.sight = -1;
                template.movingSpeed = 0.14;
                template.biochemicalCharging = 0;
                template.accurate = 73;
                ARM.cache[key] = template;
                return template;
            } else if (key == 45) {
                let template = new ARM();
                template.id = 45;
                template.name = '魔女的暗水枪';
                template.objName = '5012';
                template.type = 5;
                template.interval = 180;
                template.attackSound = 'MP5-XFire.mp3';
                template.magazineBullet = 40;
                template.bullets = 80;
                template.bulletChangeTimer = 2000;
                template.hit = 22;
                template.bodyMultiple = 1.63;
                template.headHit = 35.86;
                template.limbMultiple = 0.57;
                template.limbHit = 12.54;
                template.maxBodyHit = 30;
                template.maxHeadHit = 50;
                template.maxLimbHit = 20;
                template.isCanOpMirror = 0;
                template.cutScale = 0;
                template.attackDis = -1;
                template.icon = 'sub1/equip/arm/45.png';
                template.recoilForce = [0.1, 0];
                template.reloadsound = 'reload1.mp3';
                template.firestarter = 'm4_Effect';
                template.ballistic = 'fire';
                template.bullethole = 'impactSparks';
                template.price = 200000;
                template.produce = 2000;
                template.priceByDiamond = 1150;
                template.grade = 4;
                template.lv = 1;
                template.pierceThrough = 85;
                template.range = 30;
                template.sight = -1;
                template.movingSpeed = 0.15;
                template.biochemicalCharging = 0;
                template.accurate = 51;
                ARM.cache[key] = template;
                return template;
            } else if (key == 46) {
                let template = new ARM();
                template.id = 46;
                template.name = '裂空之啸';
                template.objName = '3010';
                template.type = 3;
                template.interval = 2000;
                template.attackSound = 'MSRFire.mp3';
                template.magazineBullet = 10;
                template.bullets = 20;
                template.bulletChangeTimer = 2000;
                template.hit = 200;
                template.bodyMultiple = 2;
                template.headHit = 400;
                template.limbMultiple = 0.83;
                template.limbHit = 166;
                template.maxBodyHit = 280;
                template.maxHeadHit = 700;
                template.maxLimbHit = 250;
                template.isCanOpMirror = 0;
                template.cutScale = 0;
                template.attackDis = -1;
                template.icon = 'sub1/equip/arm/46.png';
                template.recoilForce = [3, 0];
                template.reloadsound = 'reload1.mp3';
                template.firestarter = 'm4_Effect';
                template.ballistic = 'fire';
                template.bullethole = 'impactSparks';
                template.price = 700000;
                template.produce = 7000;
                template.priceByDiamond = 1650;
                template.grade = 3;
                template.lv = 1;
                template.pierceThrough = 105;
                template.range = 70;
                template.sight = -1;
                template.movingSpeed = 0.11;
                template.biochemicalCharging = 0;
                template.accurate = 61;
                ARM.cache[key] = template;
                return template;
            } else if (key == 47) {
                let template = new ARM();
                template.id = 47;
                template.name = '王者之怒';
                template.objName = '3007';
                template.type = 3;
                template.interval = 2000;
                template.attackSound = 'baleiteFire.mp3';
                template.magazineBullet = 15;
                template.bullets = 30;
                template.bulletChangeTimer = 2000;
                template.hit = 240;
                template.bodyMultiple = 2.5;
                template.headHit = 600;
                template.limbMultiple = 0.88;
                template.limbHit = 211.2;
                template.maxBodyHit = 280;
                template.maxHeadHit = 700;
                template.maxLimbHit = 250;
                template.isCanOpMirror = 0;
                template.cutScale = 0;
                template.attackDis = -1;
                template.icon = 'sub1/equip/arm/47.png';
                template.recoilForce = [3, 0];
                template.reloadsound = 'reload1.mp3';
                template.firestarter = 'm4_Effect';
                template.ballistic = 'fire';
                template.bullethole = 'impactSparks';
                template.price = 3500000;
                template.produce = 35000;
                template.priceByDiamond = 2200;
                template.grade = 2;
                template.lv = 1;
                template.pierceThrough = 115;
                template.range = 70;
                template.sight = -1;
                template.movingSpeed = 0.11;
                template.biochemicalCharging = 0;
                template.accurate = 72;
                ARM.cache[key] = template;
                return template;
            } else if (key == 48) {
                let template = new ARM();
                template.id = 48;
                template.name = '时空主宰者';
                template.objName = '1008';
                template.type = 1;
                template.interval = 200;
                template.attackSound = 'aiguozheFire.mp3';
                template.magazineBullet = 100;
                template.bullets = 200;
                template.bulletChangeTimer = 2000;
                template.hit = 22;
                template.bodyMultiple = 1.75;
                template.headHit = 38.5;
                template.limbMultiple = 0.73;
                template.limbHit = 16.06;
                template.maxBodyHit = 30;
                template.maxHeadHit = 60;
                template.maxLimbHit = 30;
                template.isCanOpMirror = 0;
                template.cutScale = 0;
                template.attackDis = -1;
                template.icon = 'sub1/equip/arm/48.png';
                template.recoilForce = [0.5, 0];
                template.reloadsound = 'reload1.mp3';
                template.firestarter = 'm4_Effect';
                template.ballistic = 'fire';
                template.bullethole = 'impactSparks';
                template.price = 250000;
                template.produce = 2500;
                template.priceByDiamond = 1200;
                template.grade = 3;
                template.lv = 1;
                template.pierceThrough = 75;
                template.range = 40;
                template.sight = -1;
                template.movingSpeed = 0.1;
                template.biochemicalCharging = 0;
                template.accurate = 52;
                ARM.cache[key] = template;
                return template;
            } else if (key == 49) {
                let template = new ARM();
                template.id = 49;
                template.name = '星际绝影';
                template.objName = '1027';
                template.type = 1;
                template.interval = 200;
                template.attackSound = 'dulongzhuanFire.mp3';
                template.magazineBullet = 35;
                template.bullets = 70;
                template.bulletChangeTimer = 2000;
                template.hit = 33;
                template.bodyMultiple = 1.68;
                template.headHit = 55.44;
                template.limbMultiple = 0.7;
                template.limbHit = 23.1;
                template.maxBodyHit = 50;
                template.maxHeadHit = 80;
                template.maxLimbHit = 40;
                template.isCanOpMirror = 0;
                template.cutScale = 0;
                template.attackDis = -1;
                template.icon = 'sub1/equip/arm/49.png';
                template.recoilForce = [0.1, 0];
                template.reloadsound = 'reload1.mp3';
                template.firestarter = 'm4_Effect';
                template.ballistic = 'fire';
                template.bullethole = 'impactSparks';
                template.price = 900000;
                template.produce = 9000;
                template.priceByDiamond = 1850;
                template.grade = 2;
                template.lv = 1;
                template.pierceThrough = 73;
                template.range = 50;
                template.sight = -1;
                template.movingSpeed = 0.14;
                template.biochemicalCharging = 0;
                template.accurate = 65;
                ARM.cache[key] = template;
                return template;
            } else if (key == 50) {
                let template = new ARM();
                template.id = 50;
                template.name = '纳罗时空';
                template.objName = '6005';
                template.type = 6;
                template.interval = 250;
                template.attackSound = 'MG3Fire.mp3';
                template.magazineBullet = 100;
                template.bullets = 200;
                template.bulletChangeTimer = 2000;
                template.hit = 24;
                template.bodyMultiple = 1.78;
                template.headHit = 42.72;
                template.limbMultiple = 0.78;
                template.limbHit = 18.72;
                template.maxBodyHit = 30;
                template.maxHeadHit = 60;
                template.maxLimbHit = 30;
                template.isCanOpMirror = 0;
                template.cutScale = 0;
                template.attackDis = -1;
                template.icon = 'sub1/equip/arm/50.png';
                template.recoilForce = [0.5, 0];
                template.reloadsound = 'reload1.mp3';
                template.firestarter = 'm4_Effect';
                template.ballistic = 'fire';
                template.bullethole = 'impactSparks';
                template.price = 650000;
                template.produce = 6500;
                template.priceByDiamond = 1600;
                template.grade = 3;
                template.lv = 1;
                template.pierceThrough = 80;
                template.range = 40;
                template.sight = -1;
                template.movingSpeed = 0.1;
                template.biochemicalCharging = 0;
                template.accurate = 60;
                ARM.cache[key] = template;
                return template;
            }
        }
        static getDataByIndex(index) {
            if (ARM.cache[this.keys[index]])
                return ARM.cache[this.keys[index]];
            return this.getDataByKey(this.keys[index]);
        }
        static getAllData() {
            for (let index = 0; index < this.keys.length; index++) {
                this.getDataByKey(this.keys[index]);
            }
            return ARM.cache;
        }
        clear() {
            ARM.cache = {};
        }
    }
    ARM.cache = {};
    ARM.keys = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50];

    const ANALYISE_ID = {
        AD: '观看视频：',
        SHARE: '分享：',
        START_GAME: '开始对局',
        END_GAME: '成功局数',
        NAV_SUCCESS: '跳转成功',
        NEW_NAV_SUCCESS: '新用户跳转成功',
        FULL_SCREEN: '全屏导出页',
        FULL_SCREEN_JUMP: '全屏导出页点击',
        FULL_SCREEN_JUMP_SUCCESS: '全屏导出页成功跳转',
        FIRST_VIEW: '首页曝光',
        SKIN_VIEW: '选购皮肤',
        END_VIEW: '结算页曝光',
        CHANNEL_FLOAT_VIEW: '插屏导出页曝光'
    };

    var ORDER_LAYER_Z;
    (function(ORDER_LAYER_Z) {
        ORDER_LAYER_Z[ORDER_LAYER_Z["NORNAL"] = 0] = "NORNAL";
        ORDER_LAYER_Z[ORDER_LAYER_Z["SYNTESIS"] = 200] = "SYNTESIS";
        ORDER_LAYER_Z[ORDER_LAYER_Z["LOADING"] = 300] = "LOADING";
        ORDER_LAYER_Z[ORDER_LAYER_Z["NOTIFY"] = 400] = "NOTIFY";
        ORDER_LAYER_Z[ORDER_LAYER_Z["MAX"] = 500] = "MAX";
    })(ORDER_LAYER_Z || (ORDER_LAYER_Z = {}));

    var View = Laya.View;
    var Scene = Laya.Scene;
    var REG = Laya.ClassUtils.regClass;
    var ui;
    (function(ui) {
        var scene;
        (function(scene) {
            class GameSceneUI extends Scene {
                constructor() {
                    super();
                }
                createChildren() {
                    super.createChildren();
                    this.createView(GameSceneUI.uiView);
                }
            }
            GameSceneUI.uiView = {
                "type": "Scene",
                "props": {
                    "width": 750,
                    "height": 1334
                },
                "compId": 2,
                "loadList": [],
                "loadList3D": []
            };
            scene.GameSceneUI = GameSceneUI;
            REG("ui.scene.GameSceneUI", GameSceneUI);
        })(scene = ui.scene || (ui.scene = {}));
    })(ui || (ui = {}));
    (function(ui) {
        var view;
        (function(view) {
            var ani;
            (function(ani) {
                class AccountUpgradeViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/ani/AccountUpgradeView");
                    }
                }
                ani.AccountUpgradeViewUI = AccountUpgradeViewUI;
                REG("ui.view.ani.AccountUpgradeViewUI", AccountUpgradeViewUI);
                class DanAniViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/ani/DanAniView");
                    }
                }
                ani.DanAniViewUI = DanAniViewUI;
                REG("ui.view.ani.DanAniViewUI", DanAniViewUI);
                class EndAniViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/ani/EndAniView");
                    }
                }
                ani.EndAniViewUI = EndAniViewUI;
                REG("ui.view.ani.EndAniViewUI", EndAniViewUI);
                class LoadFightAniViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/ani/LoadFightAniView");
                    }
                }
                ani.LoadFightAniViewUI = LoadFightAniViewUI;
                REG("ui.view.ani.LoadFightAniViewUI", LoadFightAniViewUI);
            })(ani = view.ani || (view.ani = {}));
        })(view = ui.view || (ui.view = {}));
    })(ui || (ui = {}));
    (function(ui) {
        var view;
        (function(view) {
            var award;
            (function(award) {
                class ActivityEquipViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/award/ActivityEquipView");
                    }
                }
                award.ActivityEquipViewUI = ActivityEquipViewUI;
                REG("ui.view.award.ActivityEquipViewUI", ActivityEquipViewUI);
                class ActivityGoldGunViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/award/ActivityGoldGunView");
                    }
                }
                award.ActivityGoldGunViewUI = ActivityGoldGunViewUI;
                REG("ui.view.award.ActivityGoldGunViewUI", ActivityGoldGunViewUI);
                class ActivityPlayerViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/award/ActivityPlayerView");
                    }
                }
                award.ActivityPlayerViewUI = ActivityPlayerViewUI;
                REG("ui.view.award.ActivityPlayerViewUI", ActivityPlayerViewUI);
                class NewGiftViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/award/NewGiftView");
                    }
                }
                award.NewGiftViewUI = NewGiftViewUI;
                REG("ui.view.award.NewGiftViewUI", NewGiftViewUI);
                class NewPlayerTryArmViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/award/NewPlayerTryArmView");
                    }
                }
                award.NewPlayerTryArmViewUI = NewPlayerTryArmViewUI;
                REG("ui.view.award.NewPlayerTryArmViewUI", NewPlayerTryArmViewUI);
                class NewYearGiftCellViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/award/NewYearGiftCellView");
                    }
                }
                award.NewYearGiftCellViewUI = NewYearGiftCellViewUI;
                REG("ui.view.award.NewYearGiftCellViewUI", NewYearGiftCellViewUI);
                class NewYearGiftViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/award/NewYearGiftView");
                    }
                }
                award.NewYearGiftViewUI = NewYearGiftViewUI;
                REG("ui.view.award.NewYearGiftViewUI", NewYearGiftViewUI);
                class SuperEquipViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/award/SuperEquipView");
                    }
                }
                award.SuperEquipViewUI = SuperEquipViewUI;
                REG("ui.view.award.SuperEquipViewUI", SuperEquipViewUI);
            })(award = view.award || (view.award = {}));
        })(view = ui.view || (ui.view = {}));
    })(ui || (ui = {}));
    (function(ui) {
        var view;
        (function(view) {
            var cdkey;
            (function(cdkey) {
                class CDKeyViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/cdkey/CDKeyView");
                    }
                }
                cdkey.CDKeyViewUI = CDKeyViewUI;
                REG("ui.view.cdkey.CDKeyViewUI", CDKeyViewUI);
            })(cdkey = view.cdkey || (view.cdkey = {}));
        })(view = ui.view || (ui.view = {}));
    })(ui || (ui = {}));
    (function(ui) {
        var view;
        (function(view) {
            var channel;
            (function(channel) {
                class ChannelSingleCellUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/channel/ChannelSingleCell");
                    }
                }
                channel.ChannelSingleCellUI = ChannelSingleCellUI;
                REG("ui.view.channel.ChannelSingleCellUI", ChannelSingleCellUI);
            })(channel = view.channel || (view.channel = {}));
        })(view = ui.view || (ui.view = {}));
    })(ui || (ui = {}));
    (function(ui) {
        var view;
        (function(view) {
            var characterCtrl;
            (function(characterCtrl) {
                class RockerMoveViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.createView(RockerMoveViewUI.uiView);
                    }
                }
                RockerMoveViewUI.uiView = {
                    "type": "View",
                    "props": {
                        "width": 185,
                        "height": 185
                    },
                    "compId": 2,
                    "child": [{
                        "type": "Image",
                        "props": {
                            "y": 0,
                            "x": 92.5,
                            "width": 185,
                            "var": "imgBottom",
                            "skin": "sub1/ui/move/img_2.png",
                            "height": 185,
                            "anchorY": 0,
                            "anchorX": 0.5
                        },
                        "compId": 5
                    }, {
                        "type": "Box",
                        "props": {
                            "y": 93,
                            "x": 93,
                            "width": 118,
                            "var": "imgKnob",
                            "height": 129,
                            "anchorY": 0.5,
                            "anchorX": 0.5,
                            "alpha": 1
                        },
                        "compId": 4,
                        "child": [{
                            "type": "Image",
                            "props": {
                                "skin": "sub1/ui/move/img_1.png",
                                "centerY": 0,
                                "centerX": 0
                            },
                            "compId": 7
                        }]
                    }],
                    "animations": [{
                        "nodes": [{
                            "target": 4,
                            "keyframes": {
                                "y": [{
                                    "value": 8.5,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "key": "y",
                                    "index": 0
                                }, {
                                    "value": 20,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "key": "y",
                                    "index": 5
                                }, {
                                    "value": 40,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "key": "y",
                                    "index": 10
                                }, {
                                    "value": 77.5,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "key": "y",
                                    "index": 15
                                }, {
                                    "value": 127.33333333333333,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "key": "y",
                                    "index": 20
                                }, {
                                    "value": 156,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "key": "y",
                                    "index": 25
                                }, {
                                    "value": 171,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "key": "y",
                                    "index": 30
                                }, {
                                    "value": 177,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "key": "y",
                                    "index": 35
                                }, {
                                    "value": 164,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "key": "y",
                                    "index": 40
                                }, {
                                    "value": 150,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "key": "y",
                                    "index": 45
                                }, {
                                    "value": 128,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "key": "y",
                                    "index": 50
                                }, {
                                    "value": 92.5,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "key": "y",
                                    "index": 55
                                }, {
                                    "value": 55.333333333333336,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "key": "y",
                                    "index": 60
                                }, {
                                    "value": 22,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "key": "y",
                                    "index": 65
                                }, {
                                    "value": 8.5,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "label": null,
                                    "key": "y",
                                    "index": 70
                                }, {
                                    "value": 92.5,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "key": "y",
                                    "index": 75
                                }],
                                "x": [{
                                    "value": 92.5,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "key": "x",
                                    "index": 0
                                }, {
                                    "value": 134,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "key": "x",
                                    "index": 5
                                }, {
                                    "value": 157,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "key": "x",
                                    "index": 10
                                }, {
                                    "value": 174,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "key": "x",
                                    "index": 15
                                }, {
                                    "value": 168.44444444444446,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "key": "x",
                                    "index": 20
                                }, {
                                    "value": 147,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "key": "x",
                                    "index": 25
                                }, {
                                    "value": 119,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "key": "x",
                                    "index": 30
                                }, {
                                    "value": 92,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "key": "x",
                                    "index": 35
                                }, {
                                    "value": 49.5,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "key": "x",
                                    "index": 40
                                }, {
                                    "value": 31,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "key": "x",
                                    "index": 45
                                }, {
                                    "value": 17,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "key": "x",
                                    "index": 50
                                }, {
                                    "value": 8.5,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "key": "x",
                                    "index": 55
                                }, {
                                    "value": 17.458333333333332,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "key": "x",
                                    "index": 60
                                }, {
                                    "value": 49.5,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "key": "x",
                                    "index": 65
                                }, {
                                    "value": 92.5,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "label": null,
                                    "key": "x",
                                    "index": 70
                                }]
                            }
                        }],
                        "name": "ani1",
                        "id": 1,
                        "frameRate": 60,
                        "action": 0
                    }],
                    "loadList": ["sub1/ui/move/img_2.png", "sub1/ui/move/img_1.png"],
                    "loadList3D": []
                };
                characterCtrl.RockerMoveViewUI = RockerMoveViewUI;
                REG("ui.view.characterCtrl.RockerMoveViewUI", RockerMoveViewUI);
            })(characterCtrl = view.characterCtrl || (view.characterCtrl = {}));
        })(view = ui.view || (ui.view = {}));
    })(ui || (ui = {}));
    (function(ui) {
        var view;
        (function(view) {
            var common;
            (function(common) {
                class CommonMenuTopBarUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/common/CommonMenuTopBar");
                    }
                }
                common.CommonMenuTopBarUI = CommonMenuTopBarUI;
                REG("ui.view.common.CommonMenuTopBarUI", CommonMenuTopBarUI);
                class DiamondNumUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/common/DiamondNum");
                    }
                }
                common.DiamondNumUI = DiamondNumUI;
                REG("ui.view.common.DiamondNumUI", DiamondNumUI);
                class DiamondsTopUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.createView(DiamondsTopUI.uiView);
                    }
                }
                DiamondsTopUI.uiView = {
                    "type": "View",
                    "props": {
                        "width": 141,
                        "height": 42
                    },
                    "compId": 2,
                    "child": [{
                        "type": "Box",
                        "props": {
                            "y": 21,
                            "x": 75.5,
                            "width": 151,
                            "var": "btnDiamonds",
                            "height": 42,
                            "anchorY": 0.5,
                            "anchorX": 0.5
                        },
                        "compId": 3,
                        "child": [{
                            "type": "Image",
                            "props": {
                                "y": 21,
                                "x": 21,
                                "var": "imgDiamond",
                                "skin": "sub1/ui/common/img_4.png",
                                "anchorY": 0.5,
                                "anchorX": 0.5
                            },
                            "compId": 5
                        }, {
                            "type": "Label",
                            "props": {
                                "y": 9,
                                "x": 43,
                                "width": 69,
                                "var": "txtDiamonds",
                                "valign": "middle",
                                "text": "label",
                                "height": 24,
                                "fontSize": 22,
                                "font": "SimHei",
                                "color": "#FFFFFF",
                                "align": "left"
                            },
                            "compId": 6
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 20,
                                "x": 28,
                                "var": "imgAdd",
                                "skin": "sub1/ui/first/img_13.png"
                            },
                            "compId": 7
                        }, {
                            "type": "Script",
                            "props": {
                                "runtime": "effect/ButtonEffect.ts"
                            },
                            "compId": 8
                        }]
                    }],
                    "loadList": ["sub1/ui/common/img_4.png", "sub1/ui/first/img_13.png"],
                    "loadList3D": []
                };
                common.DiamondsTopUI = DiamondsTopUI;
                REG("ui.view.common.DiamondsTopUI", DiamondsTopUI);
                class GoldNumUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.createView(GoldNumUI.uiView);
                    }
                }
                GoldNumUI.uiView = {
                    "type": "View",
                    "props": {
                        "y": 21,
                        "x": 77,
                        "width": 188,
                        "pivotY": 21,
                        "pivotX": 77,
                        "height": 44
                    },
                    "compId": 2,
                    "child": [{
                        "type": "Image",
                        "props": {
                            "skin": "sub1/ui/first/img_58.png"
                        },
                        "compId": 10
                    }, {
                        "type": "Image",
                        "props": {
                            "y": 23,
                            "x": 16,
                            "var": "imgGold",
                            "skin": "sub1/ui/common/img_3.png",
                            "anchorY": 0.5,
                            "anchorX": 0.5
                        },
                        "compId": 4
                    }, {
                        "type": "Label",
                        "props": {
                            "y": 9,
                            "x": 46.5,
                            "width": 69,
                            "var": "txtCount",
                            "valign": "middle",
                            "text": "label",
                            "height": 24,
                            "fontSize": 28,
                            "font": "SimHei",
                            "color": "#FFFFFF",
                            "align": "left"
                        },
                        "compId": 5
                    }, {
                        "type": "Script",
                        "props": {
                            "y": 0,
                            "x": -6,
                            "runtime": "effect/ButtonEffect.ts"
                        },
                        "compId": 8
                    }, {
                        "type": "Image",
                        "props": {
                            "y": -1,
                            "x": 143.5,
                            "var": "imgAdd",
                            "skin": "sub1/ui/common/img_add.png"
                        },
                        "compId": 9
                    }],
                    "loadList": ["sub1/ui/first/img_58.png", "sub1/ui/common/img_3.png", "sub1/ui/common/img_add.png"],
                    "loadList3D": []
                };
                common.GoldNumUI = GoldNumUI;
                REG("ui.view.common.GoldNumUI", GoldNumUI);
                class GoldTopUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/common/GoldTop");
                    }
                }
                common.GoldTopUI = GoldTopUI;
                REG("ui.view.common.GoldTopUI", GoldTopUI);
                class LogClickViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/common/LogClickView");
                    }
                }
                common.LogClickViewUI = LogClickViewUI;
                REG("ui.view.common.LogClickViewUI", LogClickViewUI);
                class LogViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.createView(LogViewUI.uiView);
                    }
                }
                LogViewUI.uiView = {
                    "type": "View",
                    "props": {
                        "width": 322,
                        "mouseThrough": false,
                        "mouseEnabled": false,
                        "hitTestPrior": false,
                        "height": 51,
                        "centerX": 0
                    },
                    "compId": 2,
                    "child": [{
                        "type": "Image",
                        "props": {
                            "width": 322,
                            "var": "imgBg",
                            "skin": "sub1/ui/scale9/img_27.png",
                            "sizeGrid": "6,8,10,7",
                            "height": 51,
                            "centerY": 0,
                            "centerX": 0,
                            "anchorY": 0.5,
                            "anchorX": 0.5,
                            "alpha": 0.7
                        },
                        "compId": 5
                    }, {
                        "type": "Label",
                        "props": {
                            "y": 26,
                            "x": 672,
                            "var": "labelLog",
                            "fontSize": 24,
                            "color": "#ffffff",
                            "centerY": 0,
                            "centerX": 0,
                            "anchorY": 0.5,
                            "anchorX": 0.5,
                            "alpha": 1
                        },
                        "compId": 6
                    }],
                    "loadList": ["sub1/ui/scale9/img_27.png"],
                    "loadList3D": []
                };
                common.LogViewUI = LogViewUI;
                REG("ui.view.common.LogViewUI", LogViewUI);
                class LoseFocusViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/common/LoseFocusView");
                    }
                }
                common.LoseFocusViewUI = LoseFocusViewUI;
                REG("ui.view.common.LoseFocusViewUI", LoseFocusViewUI);
                class MoreGameViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/common/MoreGameView");
                    }
                }
                common.MoreGameViewUI = MoreGameViewUI;
                REG("ui.view.common.MoreGameViewUI", MoreGameViewUI);
                class NotificationViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.createView(NotificationViewUI.uiView);
                    }
                }
                NotificationViewUI.uiView = {
                    "type": "View",
                    "props": {
                        "width": 1334,
                        "height": 750
                    },
                    "compId": 2,
                    "child": [{
                        "type": "Box",
                        "props": {
                            "width": 300,
                            "var": "boxContent",
                            "height": 0,
                            "centerY": -50,
                            "centerX": 0,
                            "anchorY": 1
                        },
                        "compId": 26
                    }],
                    "loadList": [],
                    "loadList3D": []
                };
                common.NotificationViewUI = NotificationViewUI;
                REG("ui.view.common.NotificationViewUI", NotificationViewUI);
                class NotifyViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.createView(NotifyViewUI.uiView);
                    }
                }
                NotifyViewUI.uiView = {
                    "type": "View",
                    "props": {
                        "width": 1334,
                        "name": "NotifyView",
                        "height": 750
                    },
                    "compId": 2,
                    "child": [{
                        "type": "Box",
                        "props": {
                            "x": 0,
                            "top": 0,
                            "right": 0,
                            "left": 0,
                            "bottom": 0,
                            "alpha": 0
                        },
                        "compId": 6,
                        "child": [{
                            "type": "Image",
                            "props": {
                                "y": 0,
                                "x": 0,
                                "top": 0,
                                "skin": "sub1/ui/scale9/img_13.png",
                                "right": 0,
                                "left": 0,
                                "bottom": 0,
                                "alpha": 0.5,
                                "sizeGrid": "2,4,3,2"
                            },
                            "compId": 5
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 318,
                                "x": 412,
                                "width": 511,
                                "skin": "sub1/ui/scale9/img_tip_1.png",
                                "height": 75,
                                "centerY": -20,
                                "centerX": 0,
                                "sizeGrid": "7,7,10,6"
                            },
                            "compId": 3,
                            "child": [{
                                "type": "Label",
                                "props": {
                                    "y": 10.5,
                                    "x": 0,
                                    "width": 510,
                                    "var": "txtContent",
                                    "valign": "middle",
                                    "text": "已发送好友申请！",
                                    "height": 56,
                                    "fontSize": 30,
                                    "font": "Helvetica",
                                    "color": "#FFFFFF",
                                    "bold": false,
                                    "align": "center"
                                },
                                "compId": 4
                            }]
                        }]
                    }],
                    "animations": [{
                        "nodes": [{
                            "target": 6,
                            "keyframes": {
                                "x": [{
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 6,
                                    "key": "x",
                                    "index": 0
                                }],
                                "alpha": [{
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 6,
                                    "key": "alpha",
                                    "index": 0
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 6,
                                    "key": "alpha",
                                    "index": 30
                                }]
                            }
                        }],
                        "name": "aniOpen",
                        "id": 1,
                        "frameRate": 60,
                        "action": 0
                    }, {
                        "nodes": [{
                            "target": 6,
                            "keyframes": {
                                "x": [{
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 6,
                                    "key": "x",
                                    "index": 0
                                }, {
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 6,
                                    "key": "x",
                                    "index": 22
                                }],
                                "alpha": [{
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 6,
                                    "key": "alpha",
                                    "index": 0
                                }, {
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 6,
                                    "key": "alpha",
                                    "index": 22
                                }]
                            }
                        }],
                        "name": "aniClose",
                        "id": 2,
                        "frameRate": 60,
                        "action": 0
                    }],
                    "loadList": ["sub1/ui/scale9/img_13.png", "sub1/ui/scale9/img_tip_1.png"],
                    "loadList3D": []
                };
                common.NotifyViewUI = NotifyViewUI;
                REG("ui.view.common.NotifyViewUI", NotifyViewUI);
                class PrivateDetailViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.createView(PrivateDetailViewUI.uiView);
                    }
                }
                PrivateDetailViewUI.uiView = {
                    "type": "View",
                    "props": {
                        "width": 1334,
                        "height": 750
                    },
                    "compId": 2,
                    "child": [{
                        "type": "Box",
                        "props": {
                            "y": 0,
                            "x": 0,
                            "visible": true,
                            "var": "boxDetail",
                            "right": 0,
                            "left": 0,
                            "height": 750
                        },
                        "compId": 3,
                        "child": [{
                            "type": "Rect",
                            "props": {
                                "y": 0,
                                "x": 0,
                                "width": 1962,
                                "lineWidth": 1,
                                "height": 1132,
                                "fillColor": "#ffffff"
                            },
                            "compId": 4
                        }, {
                            "type": "Panel",
                            "props": {
                                "y": 0,
                                "width": 1334,
                                "var": "panel",
                                "height": 750,
                                "elasticEnabled": true,
                                "centerX": 0
                            },
                            "compId": 5,
                            "child": [{
                                "type": "Label",
                                "props": {
                                    "y": 66,
                                    "x": 0,
                                    "wordWrap": true,
                                    "width": 1334,
                                    "var": "txtContent",
                                    "text": "更新日期:2021/12/13 \\n生效日期:2021/12/13\\n隐私政策\\n 引言\\n 欢迎使用广州市一盯科技有限公司(以下简称\"我们\")提供的产品和服务。您在使用我们的产品时，我们可能会收集和使用您的相关信息。我们承诺将极力保护使用我们产品和服务之用户（以下称“用户”或“您”）的隐私。  \\n我们将不时地更新检查本隐私政策，因此有关的措施会随之变化，我们恳请您定期查看本页面，确保对我们《隐私政策》始终保持了解。如您对本《隐私政策》及其相关事宜有任何问题，请与客服联系。  \\n本《隐私政策》主要向您说明以下信息：  \\n我们收集哪些信息； \\n我们收集信息的用途； \\n您享有的权利。 \\n本《隐私政策》适用于我司旗下所有产品和服务。当您使用我们任何产品和服务时，即表示您认同我们在本政策中所述内容。  \\n一、我们收集的信息 1.非身份信息 当您使用我司产品和服务时，我们可能会搜集用户的来源途径、访问顺序等信息。例如记录每个用户的来源途径、浏览器信息等。  \\n2.注册信息 当您使用我司注册服务时，我们可能收集您的个人注册信息，如：个人身份证明（包括身份证、护照、驾驶证等）、籍贯、性别、个人手机号码、网络身份标识（包括账号、IP地址、电子邮箱地址以及与前述有关的密码、密码保护信息、口令、口令保护信息等）。  \\n3.使用产品设备信息 当您使用我司产品时，我们可能会收集您的设备信息（包括设备型号、设备MAC地址、操作系统类型、设备设置等）、软件列表唯一设备识别码（如IMEI/android ID/IDFA/OPENUDID/GUID、SIM卡IMSI信息等在内的描述个人常用设备基本情况的信息）。  \\n4.产品相关信息 当你使用我司产品时，我们可能会收集和汇总您的游戏虚拟币、游戏余额、游戏类型、游戏记录等信息。  \\n二、我们如何收集和使用信息 1.您提供的信息 a.您在注册我司产品服务的账号或使用我司产品服务时向我们提供的信息；  \\nb.您通过我司产品向其他方提供的共享信息，以及您使用我司产品时所储存的信息；  \\nc.其他方分享的您的信息；  \\nd.我们获取到您使用我司产品或服务时的信息。如：日志信息、设备信息、网络信息等。  \\n2.Cookies、日志 我们可能通过cookies获取和使用您的信息，并将该信息储存为日志信息。  \\n通过使用cookies我们向用户提供更好的网络体验。我们使用cookies是为了让用户可以受益。例如使用我司产品服务时登录过程更快捷，cookies能帮助我们确定您连接的页面和内容，能使我们能更好、更快地为您服务，并且使您在我司享受到的服务更丰富。  \\n您可以控制cookies是否被您的设备接受。请查阅您的设备附带的文件以获得更多这方面的信息。  \\n3.我们使用cookies用于以下用途 a.记住您的身份。Cookies有助于我们辨认您作为我们的注册用户的身份，或保存您向我们提供有关您的喜好或其他信息；  \\nb.分析您使用我们服务的情况。我们可以用cookies来了解您使用我司产品时喜爱哪些活动或者哪些服务。  \\n我们为上述目的使用cookies收集到的非个人身份信息可能提供给其它伙伴，用于分析您和其它用户如何使用我司服务。  \\n我们的产品或服务上可能放置cookies，这些cookies可能会收集与您相关的非个人身份信息，以用于分析用户如何使用我们的产品和服务，您可以通过用户选择机制或用户管理来控制cookies。如果您停止使用cookies，我们可能无法向您提供最佳的服务，某些服务也可能无法正常使用。  \\n三、我们出于以下目的，收集和使用您的信息： 1.帮助您快速完成注册 为便于我们为您提供服务，您需要提供基本的注册信息，例如个人身份证明、手机号码等，并创建您的用户名和密码。  \\n2.向您提供奖品、服务 a.在部分服务项目中，为便于向您提供奖品或服务，您需要提供个人身份信息、姓名、收货地址、邮政编码、收货人、联系电话等信息，如果您拒绝提供此类信息，我们将无法完成奖品提供或服务； \\n b.当您与我们联系时，我们可能会保存您的通信/通话记录和您留下的联系方式等，以便我们与您联系或帮助您解决问题；  \\nc.为向您提供奖品或服务，我们可能会收集您所选择的物流信息、奖品信息等信息，并可能会共享给上述服务提供者。  \\n3.向您发出通知 我们可能在必要时（例如暂停、维护等），向您发出服务有关通知，以便您更好的知晓我们的服务状态。  \\n4.改进我们的服务 我们可能将通过一项我司产品所收集的信息，用于我们的其它产品。我们可能请您参与有关我司产品的调查，帮助我们改善我们现有的产品和服务或设计新的产品和服务。  \\n5.为您提供安全保障 为确保您身份的真实性、向您提供更好的安全保障，您可以向我们提供身份证明等个人敏感信息以完成实名认证。  \\n除身份验证外，我们可能将您的信息用于客户服务、安全防范、诈骗监测、存档和备份等用途，确保我们向您提供的服务的安全性；我们可能使用或整合我们所收集的您的信息，以及我们的合作伙伴取得您授权或依据法律共享的信息，来综合判断您的账户、进行身份验证、检测及防范安全事件，并依法采取必要的记录、审计、分析、处置等措施。  \\n四、分享及披露 1.分享 未经您明确同意，我们不会与我司外任何第三方分享您的信息  \\na.向您提供服务，我们可能向合作伙伴或第三方分享您的信息，例如物流服务等； \\n b.实现本《隐私政策》第二条“我们如何收集和使用信息”部分所述目的； \\n c.维护和改善我们的服务。我们可能向合作伙伴及其他第三方分享您的信息，以帮助我们为您提供更有针对性、更完善的服务，例如：代表我们发出电子邮件或推送通知的通讯服务提供商等； \\n d.履行我们在本《隐私政策》或我们与您达成的其他协议中的义务和行使我们的权利； \\n e.向委托我们进行推广的合作伙伴等第三方共享，但我们仅会向这些委托方提供推广的覆盖面和有效性的信息，而不会提供可以识别您身份的信息，例如姓名电话号码或电子邮箱；或者我们将这些信息进行汇总，以便它不会识别您个人； \\n f.在法律法规允许的范围内，为了遵守法律、维护我们及我们的关联方或合作伙伴、您或其他我司用户或社会公众利益、财产或安全免遭损害，比如为防止欺诈等违法活动和减少信用风险，我们可能与其他公司或组织交换信息； \\n g.应您合法需求，协助处理您与他人的纠纷或争议； \\n h.应您的监护人合法要求而提供您的信息； \\n i.根据与您签署的单项服务协议（包括在线签署的电子协议以及相应的平台规则）或其他的法律文件约定所提供；  \\n j.基于学术研究而提供；  \\n k.基于符合法律法规的社会公共利益而提供。  \\n我们仅会出于合法、正当、必要、特定、明确的目的共享您的信息。对我们与之共享信息的公司、组织和个人，我们会与其签署严格的保密协定，要求他们按照我们的说明、本《隐私政策》以及其他任何相关的保密和安全措施来处理信息。  \\n2.披露 我们仅会在以下情况披露您的信息：  \\na.符合业界标准的安全防护措施的前提； \\n b.在您明确同意下，根据您的需求披露您所指定的信息；  \\nc.根据法律、法规的要求、强制性的行政执法或司法要求所必须提供您信息的情况下，我们可能会依据所要求的信息类型和披露方式披露您的信息。在符合法律法规的前提下，当我们收到上述披露信息的请求时，我们会要求接收方必须出具与之相应的法律文件，如传票或调查函。  \\n五、我们对您的信息的保护和处理 \\n1.数据安全技术措施 a.我们会采用符合业界标准的安全防护措施，包括建立合理的制度规范、安全技术来防止您的信息遭到未经授权的访问使用、修改，避免数据的损坏或丢失； \\n b.网络服务采取了多种加密技术，例如SSL、TLS等加密技术来保护您的信息；  \\nc.并通过隔离技术进行隔离； \\n d.在信息使用时，例如信息展示、信息关联计算，我们会采用多种数据脱敏技术增强信息在使用中的安全性。采用严格的数据访问权限控制和多重身份认证技术保护信息，避免数据被违规使用。 \\n 2.保护信息采取的其他安全措施 \\na.通过建立数据分类分级制度、数据安全管理规范、数据安全开发规范来管理规范信息的存储和使用；\\n  b.通过信息接触者保密协议、监控和审计机制来对数据进行全面安全控制； \\n c.加强安全意识。我们还会举办安全和隐私保护培训课程，加强员工对于信息保护重要性的认识。 \\n 3.仅允许必要人员知晓这些信息，并保证知晓人员不记录、保存。 为此设置了严格的访问权限控制和监控机制。我们同时要求可能接触到您的信息的所有人员履行相应的保密义务。如未能履行这些义务，会被追究法律责任。 \\n 4.我们会采取一切合理可行的措施，确保不收集无关的信息。\\n 5.我们将尽力确保或担保您发送给我们的任何信息的安全性。 如果我们的物理、技术、或管理防护设施遭到破坏，导致信息被非授权访问、公开披露、篡改或毁坏，导致您的合法权益受损，我们将承担相应的法律责任。 \\n 6.安全事件如何处理 a.通过我司与其他方进行沟通或服务时，您不可避免要向其他方披露自己的信息，如手机号码、电子邮箱地址等，请您妥善保护自己的信息，仅在必要的情况下向他人提供；\\n  b.为应对信息泄露、损毁和丢失等可能出现的风险，我们制定了多项制度，明确安全事件、安全漏洞的分类分级标准及相应的处理流程。我们也为安全事件建立了专门的应急响应团队，按照安全事件处置规范要求，针对不同安全事件启动安全预案，进行止损、分析、定位、制定补救措施，联合相关部门进行打击；  \\n c.若不幸发生安全事件时，我们将按照法律法规的要求，及时向您告知：事件的基本情况、我们已采取或将要采取的处置方案及可能会发生的情况、您可自主防范和降低风险的建议、对您补救的方案等。同时我们要按照监管部门的要求，主动上报信息安全事件和处置情况； \\n d.由于技术的限制以及风险防范的局限，即便我们已经尽量加强安全措施，也无法始终保证信息百分之百的安全。所以您需要了解，有可能在我们可控范围外的情况而发生的情况和问题 \\n 六、您如何管理自己的信息 1.访问、更新和删除 我们鼓励您更新和修改您的信息以使其更准确有效。您能通过我司访问您的信息，并根据对应信息的管理方式自行完成或合理要求我们进行修改、补充和删除。我们将采取适当的技术手段，尽可能保证您可以访问、更新和更正自己的信息或使用我司服务时提供的其他信息。 \\n 在访问、更新、更正和删除前述信息时，我们可能会要求您进行身份验证，以保障信息安全。 \\n 如您想查询、修改或删除您的部分信息，请登录我司帐号中心或按照单项服务的具体指引进行操作。\\n  2.公开和分享 您在使用我们的服务过程中，会分享您使用服务的相关信息（如性别、昵称等），此类信息可通过您自行访问后修改，我们慎重的提醒您不要将个人信息填写至公开信息区（如昵称）。由此造成您的信息泄露，我们不承担责任。 \\n 3.注销 在符合我司服务协议及国家相关法律法规的情况下，您的账号或相关信息可能被注销或删除。在您的账号或相关信息被注销或删除后，这些信息将按照我司服务协议处理。 \\n 4.改变您授权同意的范围 您可以选择您的信息是否被披露，且您可以通过删除信息、关闭设备功能等方式改变您授权我们继续收集信息的范围或撤回您的授权。 \\n 5.敏感信息 某些信息因其特殊性可能被认为是敏感信息，例如您的种族、宗教、个人健康和医疗信息等，以及身份证明文件、个人生物识别信息、财产信息、行踪轨迹、未成年人的信息等。因此，您需要在使用我们为您提供的产品或服务前谨慎考虑。您同意这些个人敏感信息将按照《隐私政策》的相关条款来进行处理。\\n  您在我司服务中所提供的内容和信息您需要慎重考虑。 \\n 七、第三方服务 我们选择有信誉的第三方作为我们的合作伙伴，为用户提供信息和服务。然而每个合作伙伴都有与我司不同的隐私政策，您进入至第三方服务时，我司的隐私政策条款将不再生效。我们建议您查看第三方的隐私政策，确保您的信息安全。 \\n 八、未成年人限制 任何未成年人参加网上活动应事先取得家长或其法定监护人的同意。我们将根据国家相关法律法规的规定保护未成年人的相关信息并执行相关限制。 \\n 九、更新和修订 本《隐私政策》自发布生效，我们将根据国家法律法规对本《隐私政策》不定期进行更新和修订。本《隐私政策》变更后，若您不接受修订后的条款，应立即停止使用我司的产品和服务。若您在本《隐私条款》变更七日后继续使用本服务的，视为接受修订后的所有条款。\\n  十、联系我们 如您有关于网络信息安全的投诉和举报，或您对本《隐私政策》及其相关事宜有任何问题、意见或建议的，您可通过我司客服中心与我们联系。邮箱地址:959999019@qq.com",
                                    "padding": "10",
                                    "leading": 10,
                                    "height": 7650,
                                    "fontSize": 34,
                                    "color": "#000000",
                                    "centerX": 0
                                },
                                "compId": 7
                            }, {
                                "type": "Label",
                                "props": {
                                    "y": 17,
                                    "width": 100,
                                    "var": "txtClose2",
                                    "valign": "middle",
                                    "text": "X",
                                    "right": 146,
                                    "height": 55,
                                    "fontSize": 50,
                                    "color": "#000000",
                                    "align": "center"
                                },
                                "compId": 6
                            }, {
                                "type": "Label",
                                "props": {
                                    "y": 7600,
                                    "width": 100,
                                    "var": "txtClose1",
                                    "valign": "middle",
                                    "text": "关闭",
                                    "height": 55,
                                    "fontSize": 34,
                                    "color": "#000000",
                                    "centerX": 0,
                                    "align": "center"
                                },
                                "compId": 8
                            }]
                        }]
                    }],
                    "loadList": [],
                    "loadList3D": []
                };
                common.PrivateDetailViewUI = PrivateDetailViewUI;
                REG("ui.view.common.PrivateDetailViewUI", PrivateDetailViewUI);
                class PrivateDialogViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.createView(PrivateDialogViewUI.uiView);
                    }
                }
                PrivateDialogViewUI.uiView = {
                    "type": "View",
                    "props": {
                        "width": 1625,
                        "height": 750
                    },
                    "compId": 2,
                    "child": [{
                        "type": "Image",
                        "props": {
                            "top": 0,
                            "skin": "private/img_02black2.png",
                            "sizeGrid": "5,10,10,8",
                            "right": 0,
                            "left": 1,
                            "bottom": 0,
                            "alpha": 0.8
                        },
                        "compId": 3
                    }, {
                        "type": "Box",
                        "props": {
                            "width": 720,
                            "height": 562,
                            "centerY": -24,
                            "centerX": 0,
                            "anchorY": 0.5,
                            "anchorX": 0.5
                        },
                        "compId": 4,
                        "child": [{
                            "type": "Image",
                            "props": {
                                "y": 75,
                                "width": 717,
                                "skin": "private/img_32.png",
                                "sizeGrid": "66,16,16,19",
                                "right": 3,
                                "left": 0,
                                "height": 456
                            },
                            "compId": 10
                        }, {
                            "type": "Label",
                            "props": {
                                "y": 87,
                                "text": "温馨提示",
                                "fontSize": 40,
                                "color": "#ffffff",
                                "centerX": 0
                            },
                            "compId": 11
                        }, {
                            "type": "Box",
                            "props": {
                                "y": 463,
                                "x": 190.125,
                                "width": 251,
                                "var": "btnCancel",
                                "text": "不同意",
                                "height": 90,
                                "fontSize": 40,
                                "color": "#454444",
                                "anchorY": 0.5,
                                "anchorX": 0.5
                            },
                            "compId": 12,
                            "child": [{
                                "type": "Script",
                                "props": {
                                    "runtime": "effect/ButtonEffect.ts"
                                },
                                "compId": 25
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 45,
                                    "x": 125,
                                    "width": 248,
                                    "skin": "private/img_normal_2.png",
                                    "pivotY": 42,
                                    "pivotX": 124,
                                    "height": 84
                                },
                                "compId": 30
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 28,
                                    "x": 72,
                                    "skin": "private/img_4.png"
                                },
                                "compId": 31
                            }]
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 463,
                                "x": 525,
                                "width": 248,
                                "var": "btnOK",
                                "skin": "private/img_normal_1.png",
                                "sizeGrid": "0,56,0,52",
                                "pivotY": 42,
                                "pivotX": 124,
                                "height": 84
                            },
                            "compId": 14,
                            "child": [{
                                "type": "Script",
                                "props": {
                                    "runtime": "effect/ButtonEffect.ts"
                                },
                                "compId": 26
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 28,
                                    "x": 36,
                                    "skin": "private/img_6.png"
                                },
                                "compId": 28
                            }]
                        }, {
                            "type": "Label",
                            "props": {
                                "y": 175,
                                "x": 43,
                                "wordWrap": true,
                                "width": 605,
                                "text": "欢迎使用本协议,在使用本协议前,请您充分阅读并理解",
                                "leading": 20,
                                "height": 84,
                                "fontSize": 34,
                                "color": "#ffffff"
                            },
                            "compId": 17,
                            "child": [{
                                "type": "Label",
                                "props": {
                                    "y": 76,
                                    "x": 318,
                                    "wordWrap": true,
                                    "width": 204,
                                    "var": "txtDetail",
                                    "text": "《隐私政策》",
                                    "leading": 10,
                                    "height": 43,
                                    "fontSize": 34,
                                    "color": "#0bc003",
                                    "anchorY": 0.5,
                                    "anchorX": 0.5
                                },
                                "compId": 18,
                                "child": [{
                                    "type": "Script",
                                    "props": {
                                        "runtime": "effect/ButtonEffect.ts"
                                    },
                                    "compId": 27
                                }]
                            }, {
                                "type": "Label",
                                "props": {
                                    "y": 106,
                                    "x": 0,
                                    "wordWrap": true,
                                    "width": 605,
                                    "text": "各项条款,如您已详细阅读并同意隐私政策,请点击\"同意并继续\"开始我们的服务",
                                    "leading": 20,
                                    "height": 248,
                                    "fontSize": 34,
                                    "color": "#ffffff"
                                },
                                "compId": 20
                            }]
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 403,
                                "skin": "private/img_5.png",
                                "right": 20,
                                "left": 20
                            },
                            "compId": 24
                        }]
                    }],
                    "animations": [{
                        "nodes": [{
                            "target": 3,
                            "keyframes": {
                                "alpha": [{
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 3,
                                    "key": "alpha",
                                    "index": 0
                                }, {
                                    "value": 0.8,
                                    "tweenMethod": "backOut",
                                    "tween": true,
                                    "target": 3,
                                    "key": "alpha",
                                    "index": 30
                                }]
                            }
                        }, {
                            "target": 4,
                            "keyframes": {
                                "scaleY": [{
                                    "value": 0,
                                    "tweenMethod": "backOut",
                                    "tween": true,
                                    "target": 4,
                                    "key": "scaleY",
                                    "index": 0
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "key": "scaleY",
                                    "index": 30
                                }],
                                "scaleX": [{
                                    "value": 0,
                                    "tweenMethod": "backOut",
                                    "tween": true,
                                    "target": 4,
                                    "key": "scaleX",
                                    "index": 0
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "key": "scaleX",
                                    "index": 30
                                }]
                            }
                        }],
                        "name": "aniOpen",
                        "id": 1,
                        "frameRate": 60,
                        "action": 1
                    }],
                    "loadList": ["private/img_02black2.png", "private/img_32.png", "private/img_normal_2.png", "private/img_4.png", "private/img_normal_1.png", "private/img_6.png", "private/img_5.png"],
                    "loadList3D": []
                };
                common.PrivateDialogViewUI = PrivateDialogViewUI;
                REG("ui.view.common.PrivateDialogViewUI", PrivateDialogViewUI);
            })(common = view.common || (view.common = {}));
        })(view = ui.view || (ui.view = {}));
    })(ui || (ui = {}));
    (function(ui) {
        var view;
        (function(view) {
            class DemoShowViewUI extends View {
                constructor() {
                    super();
                }
                createChildren() {
                    super.createChildren();
                    this.loadScene("view/DemoShowView");
                }
            }
            view.DemoShowViewUI = DemoShowViewUI;
            REG("ui.view.DemoShowViewUI", DemoShowViewUI);
        })(view = ui.view || (ui.view = {}));
    })(ui || (ui = {}));
    (function(ui) {
        var view;
        (function(view) {
            var diamonds;
            (function(diamonds) {
                class AddDiamondsViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/diamonds/AddDiamondsView");
                    }
                }
                diamonds.AddDiamondsViewUI = AddDiamondsViewUI;
                REG("ui.view.diamonds.AddDiamondsViewUI", AddDiamondsViewUI);
            })(diamonds = view.diamonds || (view.diamonds = {}));
        })(view = ui.view || (ui.view = {}));
    })(ui || (ui = {}));
    (function(ui) {
        var view;
        (function(view) {
            var end;
            (function(end) {
                class EndItemUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.createView(EndItemUI.uiView);
                    }
                }
                EndItemUI.uiView = {
                    "type": "View",
                    "props": {
                        "width": 571,
                        "height": 95
                    },
                    "compId": 2,
                    "child": [{
                        "type": "Box",
                        "props": {
                            "y": 0,
                            "x": 0,
                            "width": 571,
                            "height": 98
                        },
                        "compId": 24,
                        "child": [{
                            "type": "Image",
                            "props": {
                                "y": 0,
                                "x": 7,
                                "width": 562,
                                "skin": "sub1/ui/scale9/img_end_5.png",
                                "sizeGrid": "13,21,24,15",
                                "height": 99
                            },
                            "compId": 31
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 0,
                                "x": 85,
                                "var": "imgPlayerBg",
                                "skin": "sub1/ui/end/img_51.png"
                            },
                            "compId": 25
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 13,
                                "x": 17,
                                "width": 71,
                                "skin": "sub1/ui/scale9/img_end_6.png",
                                "sizeGrid": "7,6,7,9",
                                "height": 71
                            },
                            "compId": 30,
                            "child": [{
                                "type": "Image",
                                "props": {
                                    "y": 2,
                                    "x": 2,
                                    "width": 67,
                                    "var": "imgHead",
                                    "skin": "sub1/role/001.png",
                                    "height": 67
                                },
                                "compId": 5
                            }]
                        }, {
                            "type": "Label",
                            "props": {
                                "y": 9,
                                "x": 92,
                                "width": 135,
                                "var": "txtName",
                                "valign": "middle",
                                "text": "txtName",
                                "height": 28,
                                "fontSize": 22,
                                "color": "#000000",
                                "align": "left"
                            },
                            "compId": 6
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 36,
                                "x": 219,
                                "var": "imgFist",
                                "skin": "sub1/ui/end/img_3.png"
                            },
                            "compId": 7
                        }, {
                            "type": "Label",
                            "props": {
                                "y": 34,
                                "x": 251,
                                "width": 135,
                                "var": "txtBeat",
                                "valign": "middle",
                                "text": "0",
                                "height": 28,
                                "fontSize": 28,
                                "color": "#000000",
                                "align": "center"
                            },
                            "compId": 8
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 43,
                                "x": 94,
                                "width": 87,
                                "var": "imgDouble",
                                "height": 33
                            },
                            "compId": 11
                        }, {
                            "type": "Label",
                            "props": {
                                "y": 34,
                                "x": 301,
                                "width": 135,
                                "var": "txtBeBeat",
                                "valign": "middle",
                                "text": "0",
                                "height": 28,
                                "fontSize": 28,
                                "color": "#000000",
                                "align": "center"
                            },
                            "compId": 26
                        }, {
                            "type": "Label",
                            "props": {
                                "y": 34,
                                "x": 354,
                                "width": 135,
                                "var": "txtScore",
                                "valign": "middle",
                                "text": "0",
                                "height": 28,
                                "fontSize": 28,
                                "color": "#0f0000",
                                "align": "center"
                            },
                            "compId": 27
                        }, {
                            "type": "Box",
                            "props": {
                                "y": 29.5,
                                "x": 471.5,
                                "width": 35,
                                "var": "btnGood",
                                "height": 37
                            },
                            "compId": 15,
                            "child": [{
                                "type": "Image",
                                "props": {
                                    "skin": "sub1/ui/end/img_26.png"
                                },
                                "compId": 16
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 8.5,
                                    "x": 7.5,
                                    "var": "imgGood",
                                    "skin": "sub1/ui/end/img_25.png"
                                },
                                "compId": 17
                            }, {
                                "type": "Label",
                                "props": {
                                    "y": 23,
                                    "x": 32,
                                    "width": 61,
                                    "visible": false,
                                    "var": "txtGoodNum",
                                    "text": "0",
                                    "height": 15,
                                    "fontSize": 16,
                                    "color": "#000000"
                                },
                                "compId": 18
                            }]
                        }, {
                            "type": "Box",
                            "props": {
                                "y": 47,
                                "x": 539,
                                "width": 36,
                                "var": "btnSend",
                                "height": 36,
                                "anchorY": 0.5,
                                "anchorX": 0.5
                            },
                            "compId": 20,
                            "child": [{
                                "type": "Image",
                                "props": {
                                    "y": -0.5,
                                    "x": -2.5,
                                    "skin": "sub1/ui/end/img_26.png"
                                },
                                "compId": 19
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 16,
                                    "x": 18,
                                    "skin": "sub1/ui/common/img_common_5.png",
                                    "anchorY": 0.5,
                                    "anchorX": 0.5
                                },
                                "compId": 13
                            }, {
                                "type": "Script",
                                "props": {
                                    "runtime": "effect/ButtonEffect.ts"
                                },
                                "compId": 21
                            }]
                        }, {
                            "type": "Label",
                            "props": {
                                "y": 34,
                                "x": 276.5,
                                "width": 135,
                                "valign": "middle",
                                "text": "/",
                                "height": 28,
                                "fontSize": 28,
                                "color": "#000000",
                                "align": "center"
                            },
                            "compId": 28
                        }, {
                            "type": "Label",
                            "props": {
                                "y": 34,
                                "x": 326.5,
                                "width": 135,
                                "valign": "middle",
                                "text": "/",
                                "height": 28,
                                "fontSize": 28,
                                "color": "#000000",
                                "align": "center"
                            },
                            "compId": 29
                        }]
                    }],
                    "animations": [{
                        "nodes": [{
                            "target": 17,
                            "keyframes": {
                                "y": [{
                                    "value": 8.5,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 17,
                                    "key": "y",
                                    "index": 0
                                }, {
                                    "value": 8,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 17,
                                    "key": "y",
                                    "index": 5
                                }, {
                                    "value": 8.5,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 17,
                                    "label": null,
                                    "key": "y",
                                    "index": 10
                                }],
                                "x": [{
                                    "value": 7.5,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 17,
                                    "key": "x",
                                    "index": 0
                                }, {
                                    "value": 5.5,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 17,
                                    "key": "x",
                                    "index": 5
                                }, {
                                    "value": 7.5,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 17,
                                    "label": null,
                                    "key": "x",
                                    "index": 10
                                }],
                                "rotation": [{
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 17,
                                    "key": "rotation",
                                    "index": 0
                                }, {
                                    "value": -11,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 17,
                                    "key": "rotation",
                                    "index": 5
                                }, {
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 17,
                                    "label": null,
                                    "key": "rotation",
                                    "index": 10
                                }]
                            }
                        }],
                        "name": "ani1",
                        "id": 1,
                        "frameRate": 24,
                        "action": 0
                    }],
                    "loadList": ["sub1/ui/scale9/img_end_5.png", "sub1/ui/end/img_51.png", "sub1/ui/scale9/img_end_6.png", "sub1/role/001.png", "sub1/ui/end/img_3.png", "sub1/ui/end/img_26.png", "sub1/ui/end/img_25.png", "sub1/ui/common/img_common_5.png"],
                    "loadList3D": []
                };
                end.EndItemUI = EndItemUI;
                REG("ui.view.end.EndItemUI", EndItemUI);
                class EndMySelfViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/end/EndMySelfView");
                    }
                }
                end.EndMySelfViewUI = EndMySelfViewUI;
                REG("ui.view.end.EndMySelfViewUI", EndMySelfViewUI);
                class EndRecreationViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/end/EndRecreationView");
                    }
                }
                end.EndRecreationViewUI = EndRecreationViewUI;
                REG("ui.view.end.EndRecreationViewUI", EndRecreationViewUI);
                class EndViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.createView(EndViewUI.uiView);
                    }
                }
                EndViewUI.uiView = {
                    "type": "View",
                    "props": {
                        "width": 1625,
                        "height": 750
                    },
                    "compId": 2,
                    "child": [{
                        "type": "Image",
                        "props": {
                            "top": 0,
                            "skin": "sub1/ui/end/img_end_bg.jpg",
                            "right": 0,
                            "left": 0,
                            "bottom": 0
                        },
                        "compId": 86
                    }, {
                        "type": "Image",
                        "props": {
                            "width": 1176,
                            "top": 0,
                            "skin": "sub1/ui/end/img_50.png",
                            "height": 69,
                            "centerX": 0
                        },
                        "compId": 11,
                        "child": [{
                            "type": "Label",
                            "props": {
                                "y": 11,
                                "x": 494,
                                "var": "labelLog",
                                "text": "团队胜利",
                                "fontSize": 47,
                                "color": "#ffffff"
                            },
                            "compId": 93
                        }, {
                            "type": "Label",
                            "props": {
                                "y": -1,
                                "x": 651,
                                "width": 282,
                                "var": "txtEnemyScore",
                                "valign": "middle",
                                "text": "0",
                                "strokeColor": "#000000",
                                "height": 99,
                                "fontSize": 47,
                                "font": "SimHei",
                                "color": "#ffffff",
                                "align": "center"
                            },
                            "compId": 42
                        }, {
                            "type": "Label",
                            "props": {
                                "y": -2,
                                "x": 264,
                                "width": 282,
                                "var": "txtWeScore",
                                "valign": "middle",
                                "text": "0",
                                "strokeColor": "#000000",
                                "height": 99,
                                "fontSize": 47,
                                "font": "SimHei",
                                "color": "#ffffff",
                                "align": "center"
                            },
                            "compId": 41
                        }]
                    }, {
                        "type": "Box",
                        "props": {
                            "width": 1177,
                            "var": "boxMain",
                            "height": 482,
                            "centerY": -67,
                            "centerX": 0
                        },
                        "compId": 9,
                        "child": [{
                            "type": "Image",
                            "props": {
                                "y": 1,
                                "x": 1,
                                "width": 1176,
                                "skin": "sub1/ui/scale9/img_50.png",
                                "sizeGrid": "26,31,34,31",
                                "height": 467
                            },
                            "compId": 22
                        }, {
                            "type": "Box",
                            "props": {
                                "y": 33,
                                "x": 16,
                                "width": 572,
                                "var": "boxWe",
                                "height": 429
                            },
                            "compId": 45
                        }, {
                            "type": "Box",
                            "props": {
                                "y": 33,
                                "x": 591,
                                "width": 573,
                                "var": "boxEnemy",
                                "height": 429
                            },
                            "compId": 47
                        }, {
                            "type": "Label",
                            "props": {
                                "y": 3,
                                "x": 37,
                                "width": 77,
                                "valign": "middle",
                                "text": "玩家",
                                "height": 33,
                                "fontSize": 22,
                                "font": "SimHei",
                                "color": "#FFFFFF",
                                "align": "center"
                            },
                            "compId": 13
                        }, {
                            "type": "Label",
                            "props": {
                                "y": 3,
                                "x": 315,
                                "width": 77,
                                "valign": "middle",
                                "text": "淘汰/死亡/评分",
                                "height": 33,
                                "fontSize": 22,
                                "font": "SimHei",
                                "color": "#FFFFFF",
                                "align": "center"
                            },
                            "compId": 14
                        }, {
                            "type": "Label",
                            "props": {
                                "y": 1,
                                "x": 622,
                                "width": 77,
                                "valign": "middle",
                                "text": "玩家",
                                "height": 33,
                                "fontSize": 22,
                                "font": "SimHei",
                                "color": "#FFFFFF",
                                "align": "center"
                            },
                            "compId": 18
                        }, {
                            "type": "Label",
                            "props": {
                                "y": 0,
                                "x": 903,
                                "width": 77,
                                "valign": "middle",
                                "text": "淘汰/死亡/评分",
                                "height": 33,
                                "fontSize": 22,
                                "font": "SimHei",
                                "color": "#FFFFFF",
                                "align": "center"
                            },
                            "compId": 19
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 515.5,
                                "x": -41,
                                "width": 356,
                                "visible": false,
                                "skin": "sub1/ui/scale9/img_51.png",
                                "height": 91,
                                "sizeGrid": "8,7,9,6"
                            },
                            "compId": 24,
                            "child": [{
                                "type": "Image",
                                "props": {
                                    "y": 11.5,
                                    "x": 76,
                                    "var": "imgGold",
                                    "skin": "sub1/ui/common/img_3.png"
                                },
                                "compId": 25
                            }, {
                                "type": "Label",
                                "props": {
                                    "y": 49.5,
                                    "x": 13.5,
                                    "width": 165,
                                    "var": "txtRewardGold",
                                    "valign": "middle",
                                    "text": "label",
                                    "height": 40,
                                    "fontSize": 22,
                                    "color": "#ffffff",
                                    "align": "center"
                                },
                                "compId": 26
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 11.5,
                                    "x": 235,
                                    "skin": "sub1/ui/end/img_1.png"
                                },
                                "compId": 27
                            }, {
                                "type": "Label",
                                "props": {
                                    "y": 48.5,
                                    "x": 183.5,
                                    "width": 165,
                                    "var": "txtRewardExp",
                                    "valign": "middle",
                                    "text": "label",
                                    "height": 40,
                                    "fontSize": 22,
                                    "color": "#ffffff",
                                    "align": "center"
                                },
                                "compId": 28
                            }]
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 547,
                                "x": 1046,
                                "width": 230,
                                "visible": false,
                                "var": "btnBack",
                                "skin": "sub1/ui/scale9/img_normal_1.png",
                                "pivotY": 49,
                                "pivotX": 115,
                                "height": 97,
                                "sizeGrid": "24,92,27,91"
                            },
                            "compId": 72,
                            "child": [{
                                "type": "Script",
                                "props": {
                                    "runtime": "effect/ButtonEffect.ts"
                                },
                                "compId": 73
                            }, {
                                "type": "Label",
                                "props": {
                                    "y": 28.5,
                                    "x": 47.5,
                                    "text": "返回大厅",
                                    "fontSize": 32,
                                    "color": "#000000",
                                    "bold": true
                                },
                                "compId": 94
                            }]
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 547,
                                "x": 134,
                                "visible": false,
                                "var": "btnShare",
                                "skin": "sub1/ui/scale9/img_normal_2.png",
                                "height": 97,
                                "anchorY": 0.5,
                                "anchorX": 0.5,
                                "sizeGrid": "21,80,30,79"
                            },
                            "compId": 75,
                            "child": [{
                                "type": "Script",
                                "props": {
                                    "runtime": "effect/ButtonEffect.ts"
                                },
                                "compId": 76
                            }, {
                                "type": "Label",
                                "props": {
                                    "y": 28,
                                    "x": 47,
                                    "text": "分享战绩",
                                    "fontSize": 32,
                                    "color": "#000000",
                                    "bold": true
                                },
                                "compId": 95
                            }]
                        }]
                    }],
                    "loadList": ["sub1/ui/end/img_end_bg.jpg", "sub1/ui/end/img_50.png", "sub1/ui/scale9/img_50.png", "sub1/ui/scale9/img_51.png", "sub1/ui/common/img_3.png", "sub1/ui/end/img_1.png", "sub1/ui/scale9/img_normal_1.png", "sub1/ui/scale9/img_normal_2.png"],
                    "loadList3D": []
                };
                end.EndViewUI = EndViewUI;
                REG("ui.view.end.EndViewUI", EndViewUI);
            })(end = view.end || (view.end = {}));
        })(view = ui.view || (ui.view = {}));
    })(ui || (ui = {}));
    (function(ui) {
        var view;
        (function(view) {
            var equip;
            (function(equip) {
                class AirdropItemUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/equip/AirdropItem");
                    }
                }
                equip.AirdropItemUI = AirdropItemUI;
                REG("ui.view.equip.AirdropItemUI", AirdropItemUI);
                class EquipLibarayViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/equip/EquipLibarayView");
                    }
                }
                equip.EquipLibarayViewUI = EquipLibarayViewUI;
                REG("ui.view.equip.EquipLibarayViewUI", EquipLibarayViewUI);
                class EquipLibraryItemUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/equip/EquipLibraryItem");
                    }
                }
                equip.EquipLibraryItemUI = EquipLibraryItemUI;
                REG("ui.view.equip.EquipLibraryItemUI", EquipLibraryItemUI);
                class EquipViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/equip/EquipView");
                    }
                }
                equip.EquipViewUI = EquipViewUI;
                REG("ui.view.equip.EquipViewUI", EquipViewUI);
                class NewEquipUnLockViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/equip/NewEquipUnLockView");
                    }
                }
                equip.NewEquipUnLockViewUI = NewEquipUnLockViewUI;
                REG("ui.view.equip.NewEquipUnLockViewUI", NewEquipUnLockViewUI);
                class ProduceGoldUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/equip/ProduceGold");
                    }
                }
                equip.ProduceGoldUI = ProduceGoldUI;
                REG("ui.view.equip.ProduceGoldUI", ProduceGoldUI);
                class PropertybarItemUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.createView(PropertybarItemUI.uiView);
                    }
                }
                PropertybarItemUI.uiView = {
                    "type": "View",
                    "props": {
                        "width": 226,
                        "height": 21
                    },
                    "compId": 2,
                    "child": [{
                        "type": "Box",
                        "props": {
                            "width": 226,
                            "height": 21
                        },
                        "compId": 10,
                        "child": [{
                            "type": "Label",
                            "props": {
                                "x": 4,
                                "width": 123,
                                "var": "txtAttribute",
                                "valign": "middle",
                                "text": "火力",
                                "height": 20,
                                "fontSize": 16,
                                "font": "SimHei",
                                "color": "#000000",
                                "centerY": 0,
                                "align": "left"
                            },
                            "compId": 11
                        }, {
                            "type": "Label",
                            "props": {
                                "x": 14,
                                "width": 113,
                                "var": "txtPro",
                                "valign": "middle",
                                "text": "100",
                                "height": 18,
                                "fontSize": 16,
                                "font": "SimHei",
                                "color": "#000000",
                                "centerY": 0,
                                "align": "right"
                            },
                            "compId": 12
                        }, {
                            "type": "Image",
                            "props": {
                                "x": 136,
                                "width": 99,
                                "skin": "sub1/ui/scale9/img_eq_lib_2.png",
                                "sizeGrid": "1,4,1,4",
                                "height": 9,
                                "centerY": 0
                            },
                            "compId": 13
                        }, {
                            "type": "Image",
                            "props": {
                                "x": 136,
                                "width": 99,
                                "var": "imgPro",
                                "skin": "sub1/ui/scale9/img_eq_lib_1.png",
                                "sizeGrid": "3,5,2,3",
                                "height": 9,
                                "centerY": 0
                            },
                            "compId": 14
                        }]
                    }],
                    "loadList": ["sub1/ui/scale9/img_eq_lib_2.png", "sub1/ui/scale9/img_eq_lib_1.png"],
                    "loadList3D": []
                };
                equip.PropertybarItemUI = PropertybarItemUI;
                REG("ui.view.equip.PropertybarItemUI", PropertybarItemUI);
                class SynthesisCellUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/equip/SynthesisCell");
                    }
                }
                equip.SynthesisCellUI = SynthesisCellUI;
                REG("ui.view.equip.SynthesisCellUI", SynthesisCellUI);
                class SynthesisViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/equip/SynthesisView");
                    }
                }
                equip.SynthesisViewUI = SynthesisViewUI;
                REG("ui.view.equip.SynthesisViewUI", SynthesisViewUI);
                class WarehouseBottomItemUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.createView(WarehouseBottomItemUI.uiView);
                    }
                }
                WarehouseBottomItemUI.uiView = {
                    "type": "View",
                    "props": {
                        "width": 289,
                        "height": 150
                    },
                    "compId": 2,
                    "child": [{
                        "type": "Image",
                        "props": {
                            "var": "imgSelect",
                            "top": 0,
                            "skin": "sub1/ui/scale9/img_45.png",
                            "right": 0,
                            "left": 0,
                            "bottom": 0,
                            "sizeGrid": "34,31,28,30"
                        },
                        "compId": 4
                    }, {
                        "type": "Image",
                        "props": {
                            "y": 15,
                            "x": 16,
                            "width": 256,
                            "var": "imgFrame",
                            "skin": "sub1/ui/scale9/img_pingjikuang_1.png",
                            "height": 119,
                            "sizeGrid": "10,14,16,15"
                        },
                        "compId": 5
                    }, {
                        "type": "Image",
                        "props": {
                            "y": 22,
                            "x": 235,
                            "var": "imgGrade",
                            "skin": "sub1/ui/warehouse/img_pingji_1.png"
                        },
                        "compId": 6
                    }, {
                        "type": "Label",
                        "props": {
                            "y": 104,
                            "x": 24,
                            "width": 184,
                            "var": "txtName",
                            "valign": "middle",
                            "text": "label",
                            "height": 27,
                            "fontSize": 22,
                            "color": "#000000",
                            "align": "left"
                        },
                        "compId": 7
                    }, {
                        "type": "Image",
                        "props": {
                            "y": 19,
                            "x": 16,
                            "var": "imgIcon",
                            "skin": "sub1/equip/arm/1.png"
                        },
                        "compId": 8
                    }, {
                        "type": "Label",
                        "props": {
                            "y": 102,
                            "x": 81,
                            "width": 184,
                            "var": "txtLv",
                            "valign": "middle",
                            "text": "label",
                            "height": 27,
                            "fontSize": 22,
                            "color": "#000000",
                            "align": "right"
                        },
                        "compId": 10
                    }, {
                        "type": "Image",
                        "props": {
                            "y": 56,
                            "x": 16,
                            "width": 256,
                            "var": "imgEquip",
                            "skin": "sub1/ui/scale9/img_43.png",
                            "height": 37,
                            "sizeGrid": "4,4,5,3"
                        },
                        "compId": 11,
                        "child": [{
                            "type": "Label",
                            "props": {
                                "y": 5,
                                "x": 67.5,
                                "width": 121,
                                "valign": "middle",
                                "text": "已装备",
                                "height": 27,
                                "fontSize": 24,
                                "font": "SimHei",
                                "color": "#ffffff",
                                "align": "center"
                            },
                            "compId": 12
                        }]
                    }, {
                        "type": "Image",
                        "props": {
                            "y": 2,
                            "x": 259,
                            "visible": false,
                            "var": "imgDot",
                            "skin": "sub1/ui/common/img_1.png"
                        },
                        "compId": 13
                    }],
                    "loadList": ["sub1/ui/scale9/img_45.png", "sub1/ui/scale9/img_pingjikuang_1.png", "sub1/ui/warehouse/img_pingji_1.png", "sub1/equip/arm/1.png", "sub1/ui/scale9/img_43.png", "sub1/ui/common/img_1.png"],
                    "loadList3D": []
                };
                equip.WarehouseBottomItemUI = WarehouseBottomItemUI;
                REG("ui.view.equip.WarehouseBottomItemUI", WarehouseBottomItemUI);
                class WarehouseRightItemUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.createView(WarehouseRightItemUI.uiView);
                    }
                }
                WarehouseRightItemUI.uiView = {
                    "type": "View",
                    "props": {
                        "width": 124,
                        "height": 63
                    },
                    "compId": 2,
                    "child": [{
                        "type": "Image",
                        "props": {
                            "y": 0,
                            "x": 0,
                            "var": "imgFrame",
                            "top": 0,
                            "skin": "sub1/ui/scale9/img_46.png",
                            "right": 0,
                            "left": 0,
                            "bottom": 0,
                            "sizeGrid": "13,10,10,11"
                        },
                        "compId": 3
                    }, {
                        "type": "Image",
                        "props": {
                            "y": 9,
                            "x": 11,
                            "var": "imgIcon",
                            "skin": "sub1/equip/arm/1.png",
                            "scaleY": 0.4,
                            "scaleX": 0.4
                        },
                        "compId": 4
                    }, {
                        "type": "Image",
                        "props": {
                            "y": 13,
                            "x": 48,
                            "var": "imgLock",
                            "skin": "sub1/ui/equip/img_6.png",
                            "scaleY": 0.4,
                            "scaleX": 0.4
                        },
                        "compId": 5
                    }],
                    "loadList": ["sub1/ui/scale9/img_46.png", "sub1/equip/arm/1.png", "sub1/ui/equip/img_6.png"],
                    "loadList3D": []
                };
                equip.WarehouseRightItemUI = WarehouseRightItemUI;
                REG("ui.view.equip.WarehouseRightItemUI", WarehouseRightItemUI);
                class WarehouseViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.createView(WarehouseViewUI.uiView);
                    }
                }
                WarehouseViewUI.uiView = {
                    "type": "View",
                    "props": {
                        "width": 1174,
                        "height": 750
                    },
                    "compId": 2,
                    "child": [{
                        "type": "Box",
                        "props": {
                            "x": 0,
                            "width": 1174,
                            "top": 0,
                            "bottom": 0
                        },
                        "compId": 3,
                        "child": [{
                            "type": "Box",
                            "props": {
                                "y": 108,
                                "x": 551,
                                "width": 606,
                                "var": "boxTop",
                                "height": 213
                            },
                            "compId": 4,
                            "child": [{
                                "type": "Image",
                                "props": {
                                    "y": 0,
                                    "x": 0,
                                    "width": 607,
                                    "skin": "sub1/ui/scale9/img_13.png",
                                    "height": 211,
                                    "alpha": 0.3,
                                    "sizeGrid": "2,4,3,2"
                                },
                                "compId": 45
                            }, {
                                "type": "Label",
                                "props": {
                                    "y": -12,
                                    "x": 245,
                                    "width": 114,
                                    "text": "已携带装备",
                                    "height": 28,
                                    "fontSize": 24,
                                    "font": "SimHei",
                                    "color": "#FFFFFF",
                                    "bold": true
                                },
                                "compId": 11
                            }, {
                                "type": "Box",
                                "props": {
                                    "y": 35,
                                    "x": 34,
                                    "width": 539,
                                    "var": "boxEquip",
                                    "height": 144
                                },
                                "compId": 96
                            }]
                        }, {
                            "type": "Box",
                            "props": {
                                "y": 345,
                                "x": 11,
                                "width": 1156,
                                "var": "boxBottom",
                                "height": 311
                            },
                            "compId": 8,
                            "child": [{
                                "type": "List",
                                "props": {
                                    "y": 0,
                                    "x": 0,
                                    "width": 1149,
                                    "var": "listBottom",
                                    "repeatX": 4,
                                    "height": 312
                                },
                                "compId": 10
                            }]
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 334,
                                "x": 2,
                                "width": 1158,
                                "skin": "sub1/ui/scale9/img_48.png",
                                "height": 7
                            },
                            "compId": 46
                        }, {
                            "type": "Box",
                            "props": {
                                "y": 0,
                                "x": 0,
                                "width": 527,
                                "height": 327
                            },
                            "compId": 47,
                            "child": [{
                                "type": "Image",
                                "props": {
                                    "y": 80,
                                    "x": 224,
                                    "width": 291,
                                    "skin": "sub1/ui/scale9/img_48.png",
                                    "height": 3
                                },
                                "compId": 52
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 45,
                                    "x": 220,
                                    "width": 121,
                                    "var": "imgNameBg",
                                    "skin": "sub1/ui/scale9/img_pingjikuang_bg_4.png",
                                    "height": 29
                                },
                                "compId": 48
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 45,
                                    "x": 349,
                                    "var": "imgIcon",
                                    "skin": "sub1/equip/arm/1.png",
                                    "scaleY": 0.3,
                                    "scaleX": 0.3
                                },
                                "compId": 49
                            }, {
                                "type": "Label",
                                "props": {
                                    "y": 41.5,
                                    "x": 392,
                                    "width": 112,
                                    "var": "txtType",
                                    "valign": "middle",
                                    "text": "label",
                                    "height": 42,
                                    "fontSize": 16,
                                    "font": "SimHei",
                                    "color": "#FFFFFF",
                                    "bold": true,
                                    "align": "center"
                                },
                                "compId": 50
                            }, {
                                "type": "Label",
                                "props": {
                                    "y": 37.5,
                                    "x": 210,
                                    "width": 139,
                                    "var": "txtName",
                                    "valign": "middle",
                                    "text": "label",
                                    "height": 42,
                                    "fontSize": 22,
                                    "font": "SimHei",
                                    "color": "#FFFFFF",
                                    "bold": true,
                                    "align": "center"
                                },
                                "compId": 51
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 50,
                                    "x": 488,
                                    "var": "imgGrade",
                                    "skin": "sub1/ui/warehouse/img_pingji_1.png"
                                },
                                "compId": 107
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": -45,
                                    "x": -103,
                                    "width": 442,
                                    "var": "img3DCenter",
                                    "height": 442
                                },
                                "compId": 108
                            }, {
                                "type": "Box",
                                "props": {
                                    "y": 83,
                                    "x": 217,
                                    "width": 311,
                                    "var": "boxPropertybar",
                                    "height": 231
                                },
                                "compId": 109
                            }]
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 697,
                                "x": 439,
                                "width": 198,
                                "var": "btnStrengthen",
                                "skin": "sub1/ui/scale9/img_normal_3.png",
                                "height": 80,
                                "centerX": -148,
                                "bottom": 13,
                                "anchorY": 0.5,
                                "anchorX": 0.5,
                                "sizeGrid": "25,29,30,26"
                            },
                            "compId": 97,
                            "child": [{
                                "type": "Script",
                                "props": {
                                    "runtime": "effect/ButtonEffect.ts"
                                },
                                "compId": 99
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 22.5,
                                    "x": 68,
                                    "skin": "sub1/ui/warehouse/img_1.png"
                                },
                                "compId": 104
                            }]
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 697,
                                "x": 728,
                                "width": 198,
                                "var": "btnEquip",
                                "skin": "sub1/ui/scale9/img_normal_1.png",
                                "name": "btnEquip",
                                "height": 80,
                                "centerX": 141,
                                "bottom": 13,
                                "anchorY": 0.5,
                                "anchorX": 0.5,
                                "sizeGrid": "24,92,27,91"
                            },
                            "compId": 98,
                            "child": [{
                                "type": "Script",
                                "props": {
                                    "runtime": "effect/ButtonEffect.ts"
                                },
                                "compId": 103
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 21.5,
                                    "x": 68,
                                    "skin": "sub1/ui/warehouse/img_3.png"
                                },
                                "compId": 105
                            }]
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 697,
                                "x": 728,
                                "width": 198,
                                "var": "btnRemove",
                                "skin": "sub1/ui/scale9/img_normal_4.png",
                                "height": 80,
                                "centerX": 141,
                                "bottom": 13,
                                "anchorY": 0.5,
                                "anchorX": 0.5,
                                "sizeGrid": "21,28,29,28"
                            },
                            "compId": 100,
                            "child": [{
                                "type": "Script",
                                "props": {
                                    "runtime": "effect/ButtonEffect.ts"
                                },
                                "compId": 101
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 20,
                                    "x": 66.5,
                                    "skin": "sub1/ui/warehouse/img_2.png"
                                },
                                "compId": 106
                            }]
                        }]
                    }],
                    "loadList": ["sub1/ui/scale9/img_13.png", "sub1/ui/scale9/img_48.png", "sub1/ui/scale9/img_pingjikuang_bg_4.png", "sub1/equip/arm/1.png", "sub1/ui/warehouse/img_pingji_1.png", "sub1/ui/scale9/img_normal_3.png", "sub1/ui/warehouse/img_1.png", "sub1/ui/scale9/img_normal_1.png", "sub1/ui/warehouse/img_3.png", "sub1/ui/scale9/img_normal_4.png", "sub1/ui/warehouse/img_2.png"],
                    "loadList3D": []
                };
                equip.WarehouseViewUI = WarehouseViewUI;
                REG("ui.view.equip.WarehouseViewUI", WarehouseViewUI);
            })(equip = view.equip || (view.equip = {}));
        })(view = ui.view || (ui.view = {}));
    })(ui || (ui = {}));
    (function(ui) {
        var view;
        (function(view) {
            var equipTry;
            (function(equipTry) {
                class EquipTryViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/equipTry/EquipTryView");
                    }
                }
                equipTry.EquipTryViewUI = EquipTryViewUI;
                REG("ui.view.equipTry.EquipTryViewUI", EquipTryViewUI);
                class RoleTryViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/equipTry/RoleTryView");
                    }
                }
                equipTry.RoleTryViewUI = RoleTryViewUI;
                REG("ui.view.equipTry.RoleTryViewUI", RoleTryViewUI);
                class ShopTryViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/equipTry/ShopTryView");
                    }
                }
                equipTry.ShopTryViewUI = ShopTryViewUI;
                REG("ui.view.equipTry.ShopTryViewUI", ShopTryViewUI);
            })(equipTry = view.equipTry || (view.equipTry = {}));
        })(view = ui.view || (ui.view = {}));
    })(ui || (ui = {}));
    (function(ui) {
        var view;
        (function(view) {
            var exit;
            (function(exit) {
                class ExitViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.createView(ExitViewUI.uiView);
                    }
                }
                ExitViewUI.uiView = {
                    "type": "View",
                    "props": {
                        "width": 1334,
                        "height": 750
                    },
                    "compId": 2,
                    "child": [{
                        "type": "Image",
                        "props": {
                            "y": 0,
                            "x": 0,
                            "top": 0,
                            "skin": "sub1/ui/scale9/img_28.png",
                            "right": 0,
                            "left": 0,
                            "bottom": 0,
                            "alpha": 0.75,
                            "sizeGrid": "2,3,2,2"
                        },
                        "compId": 3
                    }, {
                        "type": "Box",
                        "props": {
                            "width": 738,
                            "height": 444,
                            "centerY": -36,
                            "centerX": 0
                        },
                        "compId": 8,
                        "child": [{
                            "type": "Label",
                            "props": {
                                "text": "您确定要退出游戏吗？",
                                "fontSize": 54,
                                "font": "SimHei",
                                "color": "#FFFFFF",
                                "centerY": -77,
                                "centerX": 0,
                                "bold": true
                            },
                            "compId": 4
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 319,
                                "x": 559,
                                "var": "btnBack",
                                "skin": "sub1/ui/scale9/img_normal_2.png",
                                "anchorY": 0.5,
                                "anchorX": 0.5,
                                "sizeGrid": "21,80,30,79"
                            },
                            "compId": 6,
                            "child": [{
                                "type": "Script",
                                "props": {
                                    "runtime": "effect/ButtonEffect.ts"
                                },
                                "compId": 9
                            }, {
                                "type": "Label",
                                "props": {
                                    "y": 15,
                                    "x": 56,
                                    "width": 100,
                                    "valign": "middle",
                                    "text": "否",
                                    "height": 57,
                                    "fontSize": 32,
                                    "color": "#371301",
                                    "bold": true,
                                    "align": "center"
                                },
                                "compId": 15
                            }]
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 319,
                                "x": 169,
                                "var": "btnOK",
                                "skin": "sub1/ui/scale9/img_normal_2.png",
                                "anchorY": 0.5,
                                "anchorX": 0.5,
                                "sizeGrid": "21,80,30,79"
                            },
                            "compId": 7,
                            "child": [{
                                "type": "Script",
                                "props": {
                                    "runtime": "effect/ButtonEffect.ts"
                                },
                                "compId": 10
                            }, {
                                "type": "Label",
                                "props": {
                                    "y": 16,
                                    "x": 54,
                                    "width": 100,
                                    "valign": "middle",
                                    "text": "是",
                                    "height": 57,
                                    "fontSize": 32,
                                    "color": "#371301",
                                    "bold": true,
                                    "align": "center"
                                },
                                "compId": 16
                            }]
                        }]
                    }],
                    "loadList": ["sub1/ui/scale9/img_28.png", "sub1/ui/scale9/img_normal_2.png"],
                    "loadList3D": []
                };
                exit.ExitViewUI = ExitViewUI;
                REG("ui.view.exit.ExitViewUI", ExitViewUI);
            })(exit = view.exit || (view.exit = {}));
        })(view = ui.view || (ui.view = {}));
    })(ui || (ui = {}));
    (function(ui) {
        var view;
        (function(view) {
            var fisrt;
            (function(fisrt) {
                class FirstViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/fisrt/FirstView");
                    }
                }
                fisrt.FirstViewUI = FirstViewUI;
                REG("ui.view.fisrt.FirstViewUI", FirstViewUI);
            })(fisrt = view.fisrt || (view.fisrt = {}));
        })(view = ui.view || (ui.view = {}));
    })(ui || (ui = {}));
    (function(ui) {
        var view;
        (function(view) {
            var game;
            (function(game) {
                class AIItemUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.createView(AIItemUI.uiView);
                    }
                }
                AIItemUI.uiView = {
                    "type": "View",
                    "props": {
                        "width": 41,
                        "height": 41
                    },
                    "compId": 2,
                    "child": [{
                        "type": "Image",
                        "props": {
                            "var": "imgFrame",
                            "skin": "sub1/ui/scale9/img_4.png"
                        },
                        "compId": 3
                    }, {
                        "type": "Image",
                        "props": {
                            "y": 2,
                            "x": 1.5,
                            "var": "imgState",
                            "skin": "sub1/ui/game/img_1.png"
                        },
                        "compId": 4
                    }],
                    "loadList": ["sub1/ui/scale9/img_4.png", "sub1/ui/game/img_1.png"],
                    "loadList3D": []
                };
                game.AIItemUI = AIItemUI;
                REG("ui.view.game.AIItemUI", AIItemUI);
                class BroadcastViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.createView(BroadcastViewUI.uiView);
                    }
                }
                BroadcastViewUI.uiView = {
                    "type": "View",
                    "props": {
                        "width": 250,
                        "height": 130
                    },
                    "compId": 2,
                    "loadList": [],
                    "loadList3D": []
                };
                game.BroadcastViewUI = BroadcastViewUI;
                REG("ui.view.game.BroadcastViewUI", BroadcastViewUI);
                class BuoyUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.createView(BuoyUI.uiView);
                    }
                }
                BuoyUI.uiView = {
                    "type": "View",
                    "props": {
                        "width": 55,
                        "height": 72
                    },
                    "compId": 2,
                    "child": [{
                        "type": "Image",
                        "props": {
                            "y": 72,
                            "x": 27,
                            "var": "buoy",
                            "skin": "sub1/ui/game/img_1.png",
                            "anchorY": 1,
                            "anchorX": 0.5
                        },
                        "compId": 6
                    }],
                    "loadList": ["sub1/ui/game/img_1.png"],
                    "loadList3D": []
                };
                game.BuoyUI = BuoyUI;
                REG("ui.view.game.BuoyUI", BuoyUI);
                class DoubleKillItemUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.createView(DoubleKillItemUI.uiView);
                    }
                }
                DoubleKillItemUI.uiView = {
                    "type": "View",
                    "props": {
                        "width": 372,
                        "height": 236
                    },
                    "compId": 2,
                    "child": [{
                        "type": "Box",
                        "props": {
                            "y": 118,
                            "x": 186,
                            "scaleY": 0,
                            "scaleX": 0,
                            "anchorY": 0.5,
                            "anchorX": 0.5
                        },
                        "compId": 4,
                        "child": [{
                            "type": "Image",
                            "props": {
                                "var": "imgDouble",
                                "skin": "sub1/ui/game/bomb_kill.png",
                                "centerY": 0,
                                "centerX": 0
                            },
                            "compId": 3
                        }]
                    }],
                    "animations": [{
                        "nodes": [{
                            "target": 4,
                            "keyframes": {
                                "x": [{
                                    "value": 186,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "key": "x",
                                    "index": 0
                                }, {
                                    "value": 186,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "label": null,
                                    "key": "x",
                                    "index": 13
                                }, {
                                    "value": 186,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "label": null,
                                    "key": "x",
                                    "index": 39
                                }, {
                                    "value": 186,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "label": null,
                                    "key": "x",
                                    "index": 46
                                }],
                                "scaleY": [{
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "key": "scaleY",
                                    "index": 0
                                }, {
                                    "value": 1.3,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "key": "scaleY",
                                    "index": 10
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "label": null,
                                    "key": "scaleY",
                                    "index": 13
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "label": null,
                                    "key": "scaleY",
                                    "index": 39
                                }, {
                                    "value": 1.3,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "key": "scaleY",
                                    "index": 43
                                }, {
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "label": null,
                                    "key": "scaleY",
                                    "index": 46
                                }],
                                "scaleX": [{
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "key": "scaleX",
                                    "index": 0
                                }, {
                                    "value": 1.3,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "key": "scaleX",
                                    "index": 10
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "label": null,
                                    "key": "scaleX",
                                    "index": 13
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "label": null,
                                    "key": "scaleX",
                                    "index": 39
                                }, {
                                    "value": 1.3,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "key": "scaleX",
                                    "index": 43
                                }, {
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "label": null,
                                    "key": "scaleX",
                                    "index": 46
                                }]
                            }
                        }],
                        "name": "ani1",
                        "id": 1,
                        "frameRate": 60,
                        "action": 0
                    }, {
                        "nodes": [{
                            "target": 4,
                            "keyframes": {
                                "x": [{
                                    "value": 186,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "key": "x",
                                    "index": 0
                                }, {
                                    "value": 186,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "key": "x",
                                    "index": 10
                                }],
                                "scaleY": [{
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "key": "scaleY",
                                    "index": 0
                                }, {
                                    "value": 1.3,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "key": "scaleY",
                                    "index": 10
                                }, {
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "key": "scaleY",
                                    "index": 13
                                }],
                                "scaleX": [{
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "key": "scaleX",
                                    "index": 0
                                }, {
                                    "value": 1.3,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "key": "scaleX",
                                    "index": 10
                                }, {
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "key": "scaleX",
                                    "index": 13
                                }]
                            }
                        }],
                        "name": "ani2",
                        "id": 2,
                        "frameRate": 60,
                        "action": 0
                    }],
                    "loadList": ["sub1/ui/game/bomb_kill.png"],
                    "loadList3D": []
                };
                game.DoubleKillItemUI = DoubleKillItemUI;
                REG("ui.view.game.DoubleKillItemUI", DoubleKillItemUI);
                class FloatingbloodItemUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.createView(FloatingbloodItemUI.uiView);
                    }
                }
                FloatingbloodItemUI.uiView = {
                    "type": "View",
                    "props": {
                        "width": 83,
                        "height": 100
                    },
                    "compId": 2,
                    "child": [{
                        "type": "Box",
                        "props": {
                            "y": 0,
                            "x": 0,
                            "width": 83,
                            "height": 100
                        },
                        "compId": 4,
                        "child": [{
                            "type": "Label",
                            "props": {
                                "y": 61,
                                "x": -14.5,
                                "width": 112,
                                "var": "txtHit",
                                "valign": "middle",
                                "text": "0",
                                "height": 30,
                                "fontSize": 30,
                                "font": "fnt5",
                                "color": "#FFFFFF",
                                "align": "center"
                            },
                            "compId": 3
                        }]
                    }],
                    "animations": [{
                        "nodes": [{
                            "target": 3,
                            "keyframes": {
                                "y": [{
                                    "value": 61,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 3,
                                    "key": "y",
                                    "index": 0
                                }, {
                                    "value": 9,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 3,
                                    "key": "y",
                                    "index": 58
                                }],
                                "alpha": [{
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 3,
                                    "key": "alpha",
                                    "index": 0
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 3,
                                    "key": "alpha",
                                    "index": 36
                                }, {
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 3,
                                    "key": "alpha",
                                    "index": 58
                                }]
                            }
                        }],
                        "name": "ani1",
                        "id": 1,
                        "frameRate": 60,
                        "action": 0
                    }],
                    "loadList": [],
                    "loadList3D": []
                };
                game.FloatingbloodItemUI = FloatingbloodItemUI;
                REG("ui.view.game.FloatingbloodItemUI", FloatingbloodItemUI);
                class GameArmItemUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.createView(GameArmItemUI.uiView);
                    }
                }
                GameArmItemUI.uiView = {
                    "type": "View",
                    "props": {
                        "width": 176,
                        "height": 72
                    },
                    "compId": 2,
                    "child": [{
                        "type": "Box",
                        "props": {
                            "y": 0,
                            "x": 0,
                            "width": 174,
                            "var": "box1",
                            "height": 72
                        },
                        "compId": 10,
                        "child": [{
                            "type": "Image",
                            "props": {
                                "top": 0,
                                "skin": "sub1/ui/scale9/img_1.png",
                                "right": 0,
                                "name": "imgFrame",
                                "left": 0,
                                "bottom": 0,
                                "sizeGrid": "7,10,8,11"
                            },
                            "compId": 11
                        }, {
                            "type": "Image",
                            "props": {
                                "top": 0,
                                "skin": "sub1/ui/scale9/img_game_4.png",
                                "sizeGrid": "16,18,23,15",
                                "right": 0,
                                "name": "imgSelect",
                                "left": 0,
                                "bottom": 0
                            },
                            "compId": 12
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 5,
                                "x": 24,
                                "width": 202,
                                "scaleY": 0.65,
                                "scaleX": 0.65,
                                "name": "imgIcon",
                                "height": 98
                            },
                            "compId": 13
                        }, {
                            "type": "Label",
                            "props": {
                                "y": 45.5,
                                "x": 42,
                                "width": 92,
                                "valign": "middle",
                                "text": "label",
                                "name": "txtData",
                                "height": 23,
                                "fontSize": 22,
                                "font": "SimHei",
                                "color": "#FFFFFF",
                                "bold": false,
                                "align": "right"
                            },
                            "compId": 14
                        }, {
                            "type": "Label",
                            "props": {
                                "y": 47.5,
                                "x": 77,
                                "width": 92,
                                "valign": "middle",
                                "text": "label",
                                "name": "txtAll",
                                "height": 23,
                                "fontSize": 16,
                                "font": "SimHei",
                                "color": "#FFFFFF",
                                "bold": false,
                                "alpha": 0.8,
                                "align": "right"
                            },
                            "compId": 15
                        }, {
                            "type": "Image",
                            "props": {
                                "y": -4,
                                "x": -5,
                                "width": 183,
                                "visible": false,
                                "skin": "sub1/ui/scale9/img_3.png",
                                "name": "imgTrue",
                                "height": 81,
                                "sizeGrid": "16,16,14,16"
                            },
                            "compId": 16
                        }]
                    }, {
                        "type": "Box",
                        "props": {
                            "y": 0,
                            "x": 0,
                            "width": 134,
                            "var": "box2",
                            "height": 72
                        },
                        "compId": 24,
                        "child": [{
                            "type": "Image",
                            "props": {
                                "top": 0,
                                "skin": "sub1/ui/scale9/img_1.png",
                                "right": 0,
                                "name": "imgFrame",
                                "left": 0,
                                "bottom": 0,
                                "sizeGrid": "7,10,8,11"
                            },
                            "compId": 25
                        }, {
                            "type": "Image",
                            "props": {
                                "top": 0,
                                "skin": "sub1/ui/scale9/img_game_4.png",
                                "sizeGrid": "16,18,23,15",
                                "right": 0,
                                "name": "imgSelect",
                                "left": 0,
                                "bottom": 0
                            },
                            "compId": 26
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 10,
                                "x": 18,
                                "width": 202,
                                "scaleY": 0.5,
                                "scaleX": 0.5,
                                "name": "imgIcon",
                                "height": 98
                            },
                            "compId": 27
                        }, {
                            "type": "Label",
                            "props": {
                                "y": 43.5,
                                "x": 33,
                                "width": 92,
                                "valign": "middle",
                                "text": "0",
                                "name": "txtData",
                                "height": 23,
                                "fontSize": 22,
                                "font": "SimHei",
                                "color": "#FFFFFF",
                                "bold": false,
                                "align": "right"
                            },
                            "compId": 28
                        }, {
                            "type": "Label",
                            "props": {
                                "y": 43.5,
                                "x": 32,
                                "width": 92,
                                "valign": "middle",
                                "text": "0",
                                "name": "txtAll",
                                "height": 23,
                                "fontSize": 16,
                                "font": "SimHei",
                                "color": "#FFFFFF",
                                "bold": false,
                                "alpha": 0.8,
                                "align": "right"
                            },
                            "compId": 29
                        }, {
                            "type": "Image",
                            "props": {
                                "y": -4,
                                "x": -4,
                                "width": 143,
                                "visible": false,
                                "skin": "sub1/ui/scale9/img_3.png",
                                "name": "imgTrue",
                                "height": 81,
                                "sizeGrid": "16,16,14,16"
                            },
                            "compId": 30
                        }]
                    }],
                    "loadList": ["sub1/ui/scale9/img_1.png", "sub1/ui/scale9/img_game_4.png", "sub1/ui/scale9/img_3.png"],
                    "loadList3D": []
                };
                game.GameArmItemUI = GameArmItemUI;
                REG("ui.view.game.GameArmItemUI", GameArmItemUI);
                class GameViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.createView(GameViewUI.uiView);
                    }
                }
                GameViewUI.uiView = {
                    "type": "View",
                    "props": {
                        "width": 1625,
                        "height": 750
                    },
                    "compId": 2,
                    "child": [{
                        "type": "Image",
                        "props": {
                            "y": 375,
                            "x": 667,
                            "visible": false,
                            "var": "imgMirror",
                            "skin": "sub1/ui/game/img_33.png",
                            "scaleY": 1,
                            "scaleX": 1,
                            "centerY": 0,
                            "centerX": 0,
                            "anchorY": 0.5,
                            "anchorX": 0.5,
                            "sizeGrid": "87,159,88,157"
                        },
                        "compId": 160,
                        "child": [{
                            "type": "Box",
                            "props": {
                                "width": 696,
                                "height": 620,
                                "centerY": 0,
                                "centerX": 0,
                                "anchorY": 0.5,
                                "anchorX": 0.5
                            },
                            "compId": 226,
                            "child": [{
                                "type": "Image",
                                "props": {
                                    "y": 308,
                                    "x": 345,
                                    "skin": "sub1/ui/game/img_55.png",
                                    "centerY": 0,
                                    "centerX": 0
                                },
                                "compId": 224
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 308,
                                    "x": -258,
                                    "width": 603,
                                    "skin": "sub1/ui/game/img_56.png",
                                    "height": 4
                                },
                                "compId": 225
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": -290,
                                    "x": 350,
                                    "width": 597,
                                    "skin": "sub1/ui/game/img_56.png",
                                    "rotation": 90,
                                    "height": 4
                                },
                                "compId": 227
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 312,
                                    "x": 954,
                                    "width": 602,
                                    "skin": "sub1/ui/game/img_56.png",
                                    "rotation": 180,
                                    "height": 4
                                },
                                "compId": 229
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 913,
                                    "x": 346,
                                    "width": 599,
                                    "skin": "sub1/ui/game/img_56.png",
                                    "rotation": 270,
                                    "height": 4
                                },
                                "compId": 230
                            }]
                        }]
                    }, {
                        "type": "Box",
                        "props": {
                            "y": 0,
                            "x": 0,
                            "var": "floatingLayer",
                            "top": 0,
                            "right": 0,
                            "left": 0,
                            "bottom": 0
                        },
                        "compId": 5
                    }, {
                        "type": "Box",
                        "props": {
                            "y": 351,
                            "x": 788,
                            "width": 50,
                            "var": "boxQuasi",
                            "height": 50,
                            "centerY": 0,
                            "centerX": 0
                        },
                        "compId": 324,
                        "child": [{
                            "type": "QuasiCenter",
                            "props": {
                                "y": -6,
                                "x": -7,
                                "var": "quasiCenter",
                                "runtime": "view/game/QuasiCenterCtrl.ts",
                                "centerY": 0,
                                "centerX": 0
                            },
                            "compId": 325
                        }, {
                            "type": "QuasiCenter1",
                            "props": {
                                "var": "quasiCenter1",
                                "runtime": "view/game/QuasiCenter1Ctrl.ts",
                                "centerY": 0,
                                "centerX": 0
                            },
                            "compId": 326
                        }]
                    }, {
                        "type": "Box",
                        "props": {
                            "y": 0,
                            "x": 0,
                            "width": 304,
                            "height": 260
                        },
                        "compId": 56,
                        "child": [{
                            "type": "Box",
                            "props": {
                                "y": 79,
                                "x": 64,
                                "width": 304,
                                "var": "boxLeftNonBiochemical",
                                "height": 171
                            },
                            "compId": 289,
                            "child": [{
                                "type": "Image",
                                "props": {
                                    "y": 0,
                                    "x": 0,
                                    "skin": "sub1/ui/game/img_19.png"
                                },
                                "compId": 290
                            }, {
                                "type": "Label",
                                "props": {
                                    "y": 0,
                                    "x": 24,
                                    "width": 249,
                                    "var": "txtMySelfWarSituation",
                                    "valign": "middle",
                                    "text": "击败:0    被击败:0",
                                    "height": 36,
                                    "fontSize": 23,
                                    "font": "SimHei",
                                    "color": "#ffffff",
                                    "bold": true,
                                    "align": "center"
                                },
                                "compId": 291
                            }, {
                                "type": "Box",
                                "props": {
                                    "y": 41,
                                    "x": 46,
                                    "width": 239,
                                    "var": "boxWarSituation",
                                    "height": 125
                                },
                                "compId": 292
                            }]
                        }, {
                            "type": "Box",
                            "props": {
                                "y": -6.5,
                                "x": 64,
                                "width": 304,
                                "var": "boxLeftBiochemical",
                                "height": 171
                            },
                            "compId": 293,
                            "child": [{
                                "type": "Image",
                                "props": {
                                    "x": 43,
                                    "var": "imgZombie",
                                    "skin": "sub1/ui/game/img_shenghua_7.png",
                                    "centerY": 25
                                },
                                "compId": 294
                            }, {
                                "type": "Label",
                                "props": {
                                    "y": 84,
                                    "x": 98,
                                    "width": 257,
                                    "var": "txtPlayerZombieKillNum",
                                    "valign": "middle",
                                    "text": "击杀数： 0",
                                    "height": 52,
                                    "fontSize": 24,
                                    "font": "SimHei",
                                    "color": "#FFFFFF",
                                    "bold": true,
                                    "align": "left"
                                },
                                "compId": 295
                            }]
                        }]
                    }, {
                        "type": "Box",
                        "props": {
                            "y": 0,
                            "x": 273,
                            "width": 788,
                            "visible": true,
                            "var": "boxTop",
                            "height": 81,
                            "centerX": 0
                        },
                        "compId": 29,
                        "child": [{
                            "type": "Box",
                            "props": {
                                "y": -2,
                                "x": 282,
                                "width": 223,
                                "var": "boxTopNonBiochemical",
                                "height": 58
                            },
                            "compId": 87,
                            "child": [{
                                "type": "Image",
                                "props": {
                                    "y": -16,
                                    "x": -78.5,
                                    "skin": "sub1/ui/game/img_3.png"
                                },
                                "compId": 236
                            }, {
                                "type": "Label",
                                "props": {
                                    "y": 4.5,
                                    "x": 77,
                                    "width": 72,
                                    "var": "txtCurTask",
                                    "valign": "middle",
                                    "text": "30",
                                    "height": 30,
                                    "fontSize": 32,
                                    "font": "SimHei",
                                    "color": "#000000",
                                    "bold": true,
                                    "align": "center"
                                },
                                "compId": 32
                            }, {
                                "type": "Label",
                                "props": {
                                    "y": 19.5,
                                    "x": 8,
                                    "width": 51,
                                    "var": "txtCurFriPro",
                                    "valign": "middle",
                                    "text": "0",
                                    "strokeColor": "#000000",
                                    "stroke": 2,
                                    "height": 46,
                                    "fontSize": 34,
                                    "font": "SimHei",
                                    "color": "#FFFFFF",
                                    "bold": true,
                                    "align": "center"
                                },
                                "compId": 38
                            }, {
                                "type": "Label",
                                "props": {
                                    "y": 19.5,
                                    "x": 168,
                                    "width": 51,
                                    "var": "txtCurEnePro",
                                    "valign": "middle",
                                    "text": "0",
                                    "strokeColor": "#000000",
                                    "stroke": 2,
                                    "height": 46,
                                    "fontSize": 34,
                                    "font": "SimHei",
                                    "color": "#FFFFFF",
                                    "bold": true,
                                    "align": "center"
                                },
                                "compId": 39
                            }, {
                                "type": "Label",
                                "props": {
                                    "y": 34.5,
                                    "x": 78,
                                    "width": 70,
                                    "visible": true,
                                    "var": "txtCurTime",
                                    "valign": "middle",
                                    "text": "00:00",
                                    "height": 17,
                                    "fontSize": 18,
                                    "font": "SimHei",
                                    "color": "#08070C",
                                    "bold": true,
                                    "align": "center"
                                },
                                "compId": 33
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 160,
                                    "x": -12.5,
                                    "width": 254,
                                    "var": "imgWarmUp",
                                    "skin": "sub1/ui/game/img_41.png",
                                    "height": 39
                                },
                                "compId": 213,
                                "child": [{
                                    "type": "Label",
                                    "props": {
                                        "y": -5,
                                        "x": -18,
                                        "width": 293,
                                        "var": "txtWarmUp",
                                        "valign": "middle",
                                        "text": "热身时间：15s",
                                        "height": 45,
                                        "fontSize": 28,
                                        "font": "SimHei",
                                        "color": "#FFFFFF",
                                        "bold": false,
                                        "align": "center"
                                    },
                                    "compId": 214
                                }]
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 0,
                                    "x": 234,
                                    "skin": "sub1/ui/game/img_43.png"
                                },
                                "compId": 314
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 0.5,
                                    "x": -62.5,
                                    "skin": "sub1/ui/game/img_44.png"
                                },
                                "compId": 315
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 77,
                                    "x": -18,
                                    "width": 192,
                                    "visible": false,
                                    "var": "imgEnemy",
                                    "skin": "sub1/ui/scale9/img_game_2.png",
                                    "sizeGrid": "0,7,0,59",
                                    "scaleY": 1.2,
                                    "scaleX": 1.2,
                                    "height": 31
                                },
                                "compId": 319,
                                "child": [{
                                    "type": "Label",
                                    "props": {
                                        "y": -1,
                                        "x": 55,
                                        "var": "labelName",
                                        "text": "吃",
                                        "fontSize": 18
                                    },
                                    "compId": 320
                                }, {
                                    "type": "Label",
                                    "props": {
                                        "y": 13,
                                        "x": 197,
                                        "var": "labelCount",
                                        "text": "吃",
                                        "fontSize": 18
                                    },
                                    "compId": 321
                                }, {
                                    "type": "Label",
                                    "props": {
                                        "y": 1,
                                        "x": 6,
                                        "text": "敌方",
                                        "fontSize": 18,
                                        "color": "#ffffff"
                                    },
                                    "compId": 322
                                }, {
                                    "type": "Image",
                                    "props": {
                                        "y": 19,
                                        "x": 2,
                                        "width": 188,
                                        "var": "imgEnemyHp",
                                        "skin": "sub1/ui/scale9/img_game_1.png",
                                        "sizeGrid": "0,4,0,4",
                                        "height": 10
                                    },
                                    "compId": 323
                                }]
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 119,
                                    "x": 35.5,
                                    "visible": false,
                                    "var": "imgBomb",
                                    "skin": "sub1/ui/game/img_47.png"
                                },
                                "compId": 329,
                                "child": [{
                                    "type": "Label",
                                    "props": {
                                        "var": "bombTime",
                                        "text": "5s",
                                        "fontSize": 28,
                                        "color": "#ffffff",
                                        "centerY": 1,
                                        "centerX": 0
                                    },
                                    "compId": 330
                                }]
                            }]
                        }, {
                            "type": "Box",
                            "props": {
                                "y": -1,
                                "x": 41,
                                "width": 757,
                                "var": "boxTopBiochemical",
                                "height": 142
                            },
                            "compId": 167,
                            "child": [{
                                "type": "Image",
                                "props": {
                                    "y": -87,
                                    "x": 139,
                                    "width": 447,
                                    "var": "imgTopZomBieBg",
                                    "skin": "sub1/ui/scale9/img_shenghua_2.png",
                                    "sizeGrid": "0,86,0,92",
                                    "height": 60
                                },
                                "compId": 168,
                                "child": [{
                                    "type": "Label",
                                    "props": {
                                        "y": 2,
                                        "x": 57,
                                        "width": 204,
                                        "var": "txtZombieRound",
                                        "valign": "middle",
                                        "text": "第1批",
                                        "height": 59,
                                        "fontSize": 28,
                                        "font": "SimHei",
                                        "color": "#FFFFFF",
                                        "align": "left"
                                    },
                                    "compId": 169
                                }, {
                                    "type": "Image",
                                    "props": {
                                        "x": 173.5,
                                        "var": "imgHead",
                                        "skin": "sub1/ui/game/img_shenghua_5.png",
                                        "centerY": -1
                                    },
                                    "compId": 170
                                }, {
                                    "type": "Label",
                                    "props": {
                                        "y": 1,
                                        "x": 219.5,
                                        "width": 204,
                                        "var": "txtZombieNum",
                                        "valign": "middle",
                                        "text": "剩余僵尸：100",
                                        "height": 59,
                                        "fontSize": 28,
                                        "font": "SimHei",
                                        "color": "#FFFFFF",
                                        "align": "left"
                                    },
                                    "compId": 171
                                }]
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 121,
                                    "x": 160,
                                    "var": "imgZombieTimeBg",
                                    "skin": "sub1/ui/game/img_shenghua_8.png"
                                },
                                "compId": 179,
                                "child": [{
                                    "type": "Label",
                                    "props": {
                                        "y": 5,
                                        "x": 91,
                                        "width": 251,
                                        "valign": "middle",
                                        "text": "剩余时间：",
                                        "height": 33,
                                        "fontSize": 28,
                                        "font": "SimHei",
                                        "color": "#FFFFFF",
                                        "bold": true,
                                        "align": "left"
                                    },
                                    "compId": 180
                                }, {
                                    "type": "Label",
                                    "props": {
                                        "y": 6,
                                        "x": 221,
                                        "width": 251,
                                        "var": "txtZombieDownTime",
                                        "valign": "middle",
                                        "text": "100s",
                                        "height": 33,
                                        "fontSize": 28,
                                        "font": "SimHei",
                                        "color": "#FFFFFF",
                                        "bold": true,
                                        "align": "left"
                                    },
                                    "compId": 181
                                }]
                            }]
                        }]
                    }, {
                        "type": "Box",
                        "props": {
                            "y": 0,
                            "x": 0,
                            "var": "boxJoystick",
                            "top": 0,
                            "right": 0,
                            "left": 0,
                            "height": 750,
                            "bottom": 0
                        },
                        "compId": 101,
                        "child": [{
                            "type": "Box",
                            "props": {
                                "var": "boxTouch",
                                "top": 0,
                                "right": 0,
                                "left": 0,
                                "bottom": 0
                            },
                            "compId": 232
                        }, {
                            "type": "Image",
                            "props": {
                                "var": "btnJump",
                                "skin": "sub1/ui/game/img_8.png",
                                "right": 106,
                                "bottom": 133,
                                "anchorY": 0.5,
                                "anchorX": 0.5
                            },
                            "compId": 6
                        }, {
                            "type": "Image",
                            "props": {
                                "var": "btnRightAttack",
                                "skin": "sub1/ui/game/img_4.png",
                                "right": 258,
                                "bottom": 200,
                                "anchorY": 0.5,
                                "anchorX": 0.5
                            },
                            "compId": 15
                        }, {
                            "type": "Box",
                            "props": {
                                "width": 107,
                                "visible": true,
                                "var": "btnLeftAttack",
                                "left": 184,
                                "height": 107,
                                "bottom": 391,
                                "anchorY": 0.5,
                                "anchorX": 0.5
                            },
                            "compId": 40,
                            "child": [{
                                "type": "Image",
                                "props": {
                                    "y": 0,
                                    "x": 110,
                                    "width": 114,
                                    "skin": "sub1/ui/game/img_4.png",
                                    "skewY": 180,
                                    "height": 114
                                },
                                "compId": 327
                            }]
                        }, {
                            "type": "Image",
                            "props": {
                                "width": 90,
                                "visible": false,
                                "var": "btnSquat",
                                "skin": "sub1/ui/game/img_7.png",
                                "right": -3150,
                                "height": 90,
                                "bottom": -395,
                                "anchorY": 0.5,
                                "anchorX": 0.5
                            },
                            "compId": 48
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 39,
                                "x": 117.5,
                                "visible": true,
                                "var": "btnBack",
                                "skin": "sub1/ui/game/img_16.png",
                                "anchorY": 0.5,
                                "anchorX": 0.5
                            },
                            "compId": 52,
                            "child": [{
                                "type": "Script",
                                "props": {
                                    "runtime": "effect/ButtonEffect.ts"
                                },
                                "compId": 53
                            }]
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 16,
                                "x": 167.5,
                                "var": "btnAutoAttack",
                                "skin": "sub1/ui/game/img_18.png"
                            },
                            "compId": 54
                        }, {
                            "type": "Image",
                            "props": {
                                "visible": true,
                                "var": "btnGiveUp",
                                "skin": "sub1/ui/game/img_diu_1.png",
                                "right": 73,
                                "bottom": 400,
                                "anchorY": 0.5,
                                "anchorX": 0.5
                            },
                            "compId": 165
                        }, {
                            "type": "Label",
                            "props": {
                                "y": 186,
                                "width": 394,
                                "var": "txtZomBieAppearDown",
                                "valign": "middle",
                                "text": "5",
                                "stroke": 3,
                                "height": 203,
                                "fontSize": 86,
                                "font": "SimHei",
                                "color": "#FFFFFF",
                                "centerX": 0,
                                "bold": true,
                                "anchorY": 0.5,
                                "anchorX": 0.5,
                                "align": "center"
                            },
                            "compId": 182
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 316,
                                "x": 362,
                                "visible": false,
                                "var": "btnCloseMirror",
                                "skin": "sub1/ui/game/img_closeMirror_1.png",
                                "anchorY": 0.5,
                                "anchorX": 0.5
                            },
                            "compId": 200
                        }, {
                            "type": "Label",
                            "props": {
                                "y": 186,
                                "width": 394,
                                "visible": false,
                                "var": "txtTeamDown",
                                "valign": "middle",
                                "text": "5",
                                "strokeColor": "#000000",
                                "stroke": 2,
                                "height": 203,
                                "fontSize": 86,
                                "font": "SimHei",
                                "color": "#FFFFFF",
                                "centerX": 0,
                                "bold": true,
                                "anchorY": 0.5,
                                "anchorX": 0.5,
                                "align": "center"
                            },
                            "compId": 216
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 186,
                                "visible": true,
                                "skin": "sub1/ui/game/img_39.png",
                                "scaleY": 0,
                                "scaleX": 0,
                                "centerX": 0,
                                "anchorY": 0.5,
                                "anchorX": 0.5
                            },
                            "compId": 215
                        }, {
                            "type": "Image",
                            "props": {
                                "width": 92,
                                "var": "btnAmmunitionChange",
                                "right": 83,
                                "height": 89,
                                "bottom": 301,
                                "anchorY": 0.5,
                                "anchorX": 0.5
                            },
                            "compId": 42,
                            "child": [{
                                "type": "Image",
                                "props": {
                                    "y": 2,
                                    "x": 3.5,
                                    "skin": "sub1/ui/game/img_12.png"
                                },
                                "compId": 234
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 44,
                                    "x": 46,
                                    "var": "imgAmmunitionRot",
                                    "skin": "sub1/ui/game/img_10.png",
                                    "anchorY": 0.5,
                                    "anchorX": 0.5
                                },
                                "compId": 83
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 2,
                                    "x": 7.5,
                                    "visible": false,
                                    "var": "btnAmmunitionChanging",
                                    "skin": "sub1/ui/game/img_28.png"
                                },
                                "compId": 44,
                                "child": [{
                                    "type": "Label",
                                    "props": {
                                        "y": 30.5,
                                        "x": 16,
                                        "width": 53,
                                        "var": "txtAmmunitionChangTime",
                                        "valign": "middle",
                                        "text": "1.4s",
                                        "height": 24,
                                        "fontSize": 24,
                                        "font": "SimHei",
                                        "color": "#FFFFFF",
                                        "bold": true,
                                        "align": "center"
                                    },
                                    "compId": 46
                                }]
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 2,
                                    "x": 7.5,
                                    "var": "imgAmmunitionChang",
                                    "skin": "sub1/ui/game/img_29.png"
                                },
                                "compId": 82
                            }]
                        }, {
                            "type": "Image",
                            "props": {
                                "width": 94,
                                "var": "btnConvenient",
                                "skin": "sub1/ui/game/img_11.png",
                                "right": 203,
                                "height": 94,
                                "bottom": 388,
                                "anchorY": 0.5,
                                "anchorX": 0.5
                            },
                            "compId": 217,
                            "child": [{
                                "type": "Image",
                                "props": {
                                    "y": 47,
                                    "x": 0,
                                    "width": 262,
                                    "var": "imgArm",
                                    "skin": "sub1/equip/arm/1.png",
                                    "scaleY": 0.35,
                                    "scaleX": 0.35,
                                    "rotation": -24,
                                    "height": 122
                                },
                                "compId": 218
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 0,
                                    "x": 0,
                                    "width": 93,
                                    "skin": "sub1/ui/game/img_10.png",
                                    "height": 93
                                },
                                "compId": 235
                            }]
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 460,
                                "x": 458,
                                "width": 95,
                                "visible": false,
                                "var": "btnCloseBomb",
                                "skin": "sub1/ui/game/img_46.png",
                                "pivotY": 47,
                                "pivotX": 48,
                                "height": 94
                            },
                            "compId": 331,
                            "child": [{
                                "type": "Image",
                                "props": {
                                    "visible": false,
                                    "var": "imgMask",
                                    "skin": "sub1/ui/game/img_45.png"
                                },
                                "compId": 332
                            }, {
                                "type": "Script",
                                "props": {
                                    "runtime": "effect/ButtonEffect.ts"
                                },
                                "compId": 333
                            }]
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 56,
                                "x": 1234,
                                "visible": false,
                                "var": "btnRecord",
                                "skin": "sub1/ui/game/img_record_3.png",
                                "centerX": 421,
                                "anchorY": 0.5,
                                "anchorX": 0.5
                            },
                            "compId": 334,
                            "child": [{
                                "type": "Image",
                                "props": {
                                    "y": 3,
                                    "x": 0,
                                    "skin": "sub1/ui/game/img_record_4.png",
                                    "blendMode": "lighter",
                                    "alpha": 0.5
                                },
                                "compId": 335
                            }, {
                                "type": "Image",
                                "props": {
                                    "skin": "sub1/ui/game/img_record_3.png",
                                    "renderType": "mask"
                                },
                                "compId": 342
                            }, {
                                "type": "Script",
                                "props": {
                                    "runtime": "effect/ButtonEffect.ts"
                                },
                                "compId": 350
                            }]
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 56,
                                "visible": false,
                                "var": "btnRecording",
                                "skin": "sub1/ui/game/img_record_2.png",
                                "centerX": 423,
                                "anchorY": 0.5,
                                "anchorX": 0.5
                            },
                            "compId": 343,
                            "child": [{
                                "type": "Image",
                                "props": {
                                    "skin": "sub1/ui/game/img_record_2.png"
                                },
                                "compId": 345,
                                "child": [{
                                    "type": "Image",
                                    "props": {
                                        "y": 3,
                                        "x": 0,
                                        "skin": "sub1/ui/game/img_record_4.png",
                                        "blendMode": "lighter",
                                        "alpha": 0.5
                                    },
                                    "compId": 344
                                }, {
                                    "type": "Image",
                                    "props": {
                                        "skin": "sub1/ui/game/img_record_2.png",
                                        "renderType": "mask"
                                    },
                                    "compId": 354
                                }]
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 82,
                                    "x": -10.5,
                                    "skin": "sub1/ui/game/img_record_5.png"
                                },
                                "compId": 349
                            }, {
                                "type": "Script",
                                "props": {
                                    "y": 0,
                                    "x": 0,
                                    "runtime": "effect/ButtonEffect.ts"
                                },
                                "compId": 351
                            }]
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 56,
                                "x": 1234,
                                "visible": false,
                                "var": "btnShare",
                                "skin": "sub1/ui/game/img_record_1.png",
                                "centerX": 421,
                                "anchorY": 0.5,
                                "anchorX": 0.5
                            },
                            "compId": 346,
                            "child": [{
                                "type": "Image",
                                "props": {
                                    "y": 3,
                                    "x": 0,
                                    "skin": "sub1/ui/game/img_record_4.png",
                                    "blendMode": "lighter",
                                    "alpha": 0.5
                                },
                                "compId": 347
                            }, {
                                "type": "Image",
                                "props": {
                                    "skin": "sub1/ui/game/img_record_1.png",
                                    "renderType": "mask"
                                },
                                "compId": 348
                            }, {
                                "type": "Script",
                                "props": {
                                    "y": 0,
                                    "x": 0,
                                    "runtime": "effect/ButtonEffect.ts"
                                },
                                "compId": 352
                            }]
                        }]
                    }, {
                        "type": "Box",
                        "props": {
                            "var": "boxCenter",
                            "right": 0,
                            "left": 0,
                            "height": 147,
                            "bottom": 1
                        },
                        "compId": 49,
                        "child": [{
                            "type": "Panel",
                            "props": {
                                "y": 97,
                                "width": 926,
                                "var": "listArm",
                                "spaceX": 10,
                                "height": 101,
                                "centerX": 0,
                                "anchorY": 0.5,
                                "anchorX": 0.5
                            },
                            "compId": 55,
                            "child": [{
                                "type": "HBox",
                                "props": {
                                    "y": 9.5,
                                    "var": "boxArmCell",
                                    "space": 10,
                                    "centerX": 0
                                },
                                "compId": 250
                            }]
                        }, {
                            "type": "Box",
                            "props": {
                                "y": 9,
                                "width": 594,
                                "height": 51,
                                "centerX": -31
                            },
                            "compId": 305,
                            "child": [{
                                "type": "Image",
                                "props": {
                                    "y": 11,
                                    "x": 45,
                                    "width": 248,
                                    "skin": "sub1/ui/scale9/img_8.png",
                                    "height": 26,
                                    "sizeGrid": "6,9,10,7"
                                },
                                "compId": 306,
                                "child": [{
                                    "type": "Image",
                                    "props": {
                                        "y": 2,
                                        "x": 2,
                                        "width": 244,
                                        "var": "imgHP",
                                        "skin": "sub1/ui/scale9/img_7.png",
                                        "height": 22,
                                        "sizeGrid": "11,6,8,6"
                                    },
                                    "compId": 307
                                }, {
                                    "type": "Image",
                                    "props": {
                                        "y": -7.5,
                                        "x": 6,
                                        "skin": "sub1/ui/game/img_21.png"
                                    },
                                    "compId": 308
                                }, {
                                    "type": "Label",
                                    "props": {
                                        "y": 3,
                                        "x": 114,
                                        "var": "txtHP",
                                        "text": "100/100",
                                        "stroke": 2,
                                        "fontSize": 20,
                                        "font": "SimHei",
                                        "color": "#FFFFFF",
                                        "bold": true
                                    },
                                    "compId": 309
                                }]
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 11,
                                    "x": 308,
                                    "width": 248,
                                    "skin": "sub1/ui/scale9/img_8.png",
                                    "height": 26,
                                    "sizeGrid": "6,9,10,7"
                                },
                                "compId": 310,
                                "child": [{
                                    "type": "Image",
                                    "props": {
                                        "y": 2,
                                        "x": 2,
                                        "width": 244,
                                        "var": "imgArmor",
                                        "skin": "sub1/ui/scale9/img_10.png",
                                        "height": 22,
                                        "sizeGrid": "10,5,8,3"
                                    },
                                    "compId": 311
                                }, {
                                    "type": "Image",
                                    "props": {
                                        "y": -7.5,
                                        "x": 6,
                                        "skin": "sub1/ui/game/img_20.png"
                                    },
                                    "compId": 312
                                }, {
                                    "type": "Label",
                                    "props": {
                                        "y": 3,
                                        "x": 114,
                                        "var": "txtArmor",
                                        "text": "100/100",
                                        "stroke": 2,
                                        "fontSize": 20,
                                        "font": "SimHei",
                                        "color": "#FFFFFF",
                                        "bold": true
                                    },
                                    "compId": 313
                                }]
                            }]
                        }]
                    }, {
                        "type": "Image",
                        "props": {
                            "var": "imgBeZombieHit",
                            "top": 0,
                            "skin": "sub1/ui/scale9/img_shanghua_1.png",
                            "right": 0,
                            "left": 0,
                            "bottom": 0,
                            "alpha": 0
                        },
                        "compId": 183
                    }, {
                        "type": "Box",
                        "props": {
                            "width": 100,
                            "height": 100,
                            "centerY": -114,
                            "centerX": 0,
                            "anchorY": 0.5,
                            "anchorX": 0.5
                        },
                        "compId": 185,
                        "child": [{
                            "type": "Box",
                            "props": {
                                "y": 50,
                                "x": 50,
                                "width": 100,
                                "var": "btnRescue",
                                "height": 100,
                                "anchorY": 0.5,
                                "anchorX": 0.5
                            },
                            "compId": 186,
                            "child": [{
                                "type": "Image",
                                "props": {
                                    "y": 20.5,
                                    "x": 20.5,
                                    "skin": "sub1/ui/game/img_jiuyuan_6.png"
                                },
                                "compId": 187
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 15.5,
                                    "x": 15.5,
                                    "skin": "sub1/ui/game/img_jiuyuan_5.png"
                                },
                                "compId": 188
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 32,
                                    "x": 32,
                                    "skin": "sub1/ui/game/img_jiuyuan_7.png"
                                },
                                "compId": 189
                            }, {
                                "type": "Script",
                                "props": {
                                    "runtime": "effect/ButtonEffect.ts"
                                },
                                "compId": 190
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 95,
                                    "x": 23.5,
                                    "skin": "sub1/ui/game/img_jiuyuan_2.png"
                                },
                                "compId": 196
                            }]
                        }, {
                            "type": "Box",
                            "props": {
                                "y": 50,
                                "x": 50,
                                "width": 100,
                                "var": "rescuing",
                                "height": 100,
                                "anchorY": 0.5,
                                "anchorX": 0.5
                            },
                            "compId": 191,
                            "child": [{
                                "type": "Script",
                                "props": {
                                    "runtime": "effect/ButtonEffect.ts"
                                },
                                "compId": 195
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 95,
                                    "x": 15.5,
                                    "skin": "sub1/ui/game/img_jiuyuan_4.png"
                                },
                                "compId": 197
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 134,
                                    "x": 5.5,
                                    "var": "btnResueCancel",
                                    "skin": "sub1/ui/game/img_jiuyuan_3.png"
                                },
                                "compId": 198
                            }]
                        }]
                    }, {
                        "type": "Label",
                        "props": {
                            "x": 42,
                            "width": 280,
                            "visible": true,
                            "var": "txtCurDiff",
                            "valign": "middle",
                            "underlineColor": "#ffffff",
                            "text": "label",
                            "height": 89,
                            "fontSize": 50,
                            "font": "SimHei",
                            "color": "#dd5621",
                            "bottom": 92,
                            "bold": true,
                            "alpha": 0,
                            "align": "left"
                        },
                        "compId": 206
                    }],
                    "animations": [{
                        "nodes": [{
                            "target": 83,
                            "keyframes": {
                                "x": [{
                                    "value": 46,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 83,
                                    "key": "x",
                                    "index": 0
                                }],
                                "rotation": [{
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 83,
                                    "key": "rotation",
                                    "index": 0
                                }, {
                                    "value": 360,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 83,
                                    "key": "rotation",
                                    "index": 32
                                }]
                            }
                        }],
                        "name": "ani1",
                        "id": 1,
                        "frameRate": 60,
                        "action": 0
                    }, {
                        "nodes": [{
                            "target": 168,
                            "keyframes": {
                                "y": [{
                                    "value": -78,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 168,
                                    "key": "y",
                                    "index": 0
                                }, {
                                    "value": 4,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 168,
                                    "key": "y",
                                    "index": 5
                                }, {
                                    "value": -5,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 168,
                                    "key": "y",
                                    "index": 8
                                }]
                            }
                        }],
                        "name": "down",
                        "id": 2,
                        "frameRate": 60,
                        "action": 0
                    }, {
                        "nodes": [{
                            "target": 168,
                            "keyframes": {
                                "y": [{
                                    "value": -5,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 168,
                                    "key": "y",
                                    "index": 0
                                }, {
                                    "value": 4,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 168,
                                    "key": "y",
                                    "index": 3
                                }, {
                                    "value": -78,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 168,
                                    "key": "y",
                                    "index": 7
                                }]
                            }
                        }],
                        "name": "up",
                        "id": 3,
                        "frameRate": 60,
                        "action": 0
                    }, {
                        "nodes": [{
                            "target": 179,
                            "keyframes": {
                                "x": [{
                                    "value": 130.5,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 179,
                                    "key": "x",
                                    "index": 0
                                }, {
                                    "value": 130.5,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 179,
                                    "key": "x",
                                    "index": 17
                                }, {
                                    "value": 130.5,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "label": null,
                                    "index": 36
                                }],
                                "alpha": [{
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 179,
                                    "key": "alpha",
                                    "index": 0
                                }, {
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 179,
                                    "key": "alpha",
                                    "index": 17
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "label": null,
                                    "index": 36
                                }]
                            }
                        }],
                        "name": "ani4",
                        "id": 4,
                        "frameRate": 24,
                        "action": 0
                    }, {
                        "nodes": [{
                            "target": 183,
                            "keyframes": {
                                "x": [{
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 183,
                                    "key": "x",
                                    "index": 0
                                }, {
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 183,
                                    "label": null,
                                    "key": "x",
                                    "index": 20
                                }],
                                "alpha": [{
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 183,
                                    "key": "alpha",
                                    "index": 0
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 183,
                                    "key": "alpha",
                                    "index": 10
                                }, {
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 183,
                                    "label": null,
                                    "key": "alpha",
                                    "index": 20
                                }]
                            }
                        }],
                        "name": "ani5",
                        "id": 5,
                        "frameRate": 60,
                        "action": 0
                    }, {
                        "nodes": [{
                            "target": 215,
                            "keyframes": {
                                "visible": [{
                                    "value": true,
                                    "tweenMethod": "linearNone",
                                    "tween": false,
                                    "target": 215,
                                    "key": "visible",
                                    "index": 0
                                }, {
                                    "value": true,
                                    "tweenMethod": "linearNone",
                                    "tween": false,
                                    "target": 215,
                                    "label": null,
                                    "key": "visible",
                                    "index": 58
                                }],
                                "scaleY": [{
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 215,
                                    "key": "scaleY",
                                    "index": 0
                                }, {
                                    "value": 1.1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 215,
                                    "key": "scaleY",
                                    "index": 11
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 215,
                                    "key": "scaleY",
                                    "index": 15
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 215,
                                    "label": null,
                                    "key": "scaleY",
                                    "index": 40
                                }, {
                                    "value": 1.1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 215,
                                    "label": null,
                                    "key": "scaleY",
                                    "index": 45
                                }, {
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 215,
                                    "label": null,
                                    "key": "scaleY",
                                    "index": 58
                                }],
                                "scaleX": [{
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 215,
                                    "key": "scaleX",
                                    "index": 0
                                }, {
                                    "value": 1.1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 215,
                                    "key": "scaleX",
                                    "index": 11
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 215,
                                    "key": "scaleX",
                                    "index": 15
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 215,
                                    "label": null,
                                    "key": "scaleX",
                                    "index": 40
                                }, {
                                    "value": 1.1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 215,
                                    "label": null,
                                    "key": "scaleX",
                                    "index": 45
                                }, {
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 215,
                                    "label": null,
                                    "key": "scaleX",
                                    "index": 58
                                }]
                            }
                        }],
                        "name": "ani6",
                        "id": 6,
                        "frameRate": 60,
                        "action": 0
                    }, {
                        "nodes": [{
                            "target": 219,
                            "keyframes": {
                                "y": [{
                                    "value": 7,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 219,
                                    "key": "y",
                                    "index": 0
                                }, {
                                    "value": -23,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 219,
                                    "key": "y",
                                    "index": 8
                                }],
                                "alpha": [{
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 219,
                                    "key": "alpha",
                                    "index": 0
                                }, {
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 219,
                                    "key": "alpha",
                                    "index": 8
                                }]
                            }
                        }, {
                            "target": 220,
                            "keyframes": {
                                "y": [{
                                    "value": 3,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 220,
                                    "key": "y",
                                    "index": 0
                                }, {
                                    "value": -16,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 220,
                                    "key": "y",
                                    "index": 11
                                }],
                                "alpha": [{
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 220,
                                    "key": "alpha",
                                    "index": 0
                                }, {
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 220,
                                    "key": "alpha",
                                    "index": 11
                                }]
                            }
                        }, {
                            "target": 221,
                            "keyframes": {
                                "y": [{
                                    "value": 6,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 221,
                                    "key": "y",
                                    "index": 0
                                }, {
                                    "value": -12,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 221,
                                    "key": "y",
                                    "index": 7
                                }],
                                "alpha": [{
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 221,
                                    "key": "alpha",
                                    "index": 0
                                }, {
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 221,
                                    "key": "alpha",
                                    "index": 7
                                }]
                            }
                        }, {
                            "target": 222,
                            "keyframes": {
                                "y": [{
                                    "value": 7,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 222,
                                    "key": "y",
                                    "index": 0
                                }, {
                                    "value": -30,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 222,
                                    "key": "y",
                                    "index": 10
                                }],
                                "alpha": [{
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 222,
                                    "key": "alpha",
                                    "index": 0
                                }, {
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 222,
                                    "key": "alpha",
                                    "index": 10
                                }]
                            }
                        }, {
                            "target": 223,
                            "keyframes": {
                                "y": [{
                                    "value": 20,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 223,
                                    "key": "y",
                                    "index": 0
                                }, {
                                    "value": -16,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 223,
                                    "key": "y",
                                    "index": 12
                                }],
                                "alpha": [{
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 223,
                                    "key": "alpha",
                                    "index": 0
                                }, {
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 223,
                                    "key": "alpha",
                                    "index": 12
                                }]
                            }
                        }],
                        "name": "ani7",
                        "id": 7,
                        "frameRate": 24,
                        "action": 0
                    }, {
                        "nodes": [{
                            "target": 225,
                            "keyframes": {
                                "x": [{
                                    "value": -258,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 225,
                                    "key": "x",
                                    "index": 0
                                }],
                                "scaleX": [{
                                    "value": 0.8,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 225,
                                    "key": "scaleX",
                                    "index": 0
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 225,
                                    "key": "scaleX",
                                    "index": 17
                                }]
                            }
                        }, {
                            "target": 227,
                            "keyframes": {
                                "x": [{
                                    "value": 351,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 227,
                                    "key": "x",
                                    "index": 0
                                }, {
                                    "value": 351,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 227,
                                    "key": "x",
                                    "index": 17
                                }],
                                "scaleX": [{
                                    "value": 0.8,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 227,
                                    "key": "scaleX",
                                    "index": 0
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 227,
                                    "key": "scaleX",
                                    "index": 17
                                }]
                            }
                        }, {
                            "target": 229,
                            "keyframes": {
                                "x": [{
                                    "value": 954,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 229,
                                    "key": "x",
                                    "index": 0
                                }, {
                                    "value": 954,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 229,
                                    "key": "x",
                                    "index": 17
                                }],
                                "scaleX": [{
                                    "value": 0.8,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 229,
                                    "key": "scaleX",
                                    "index": 0
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 229,
                                    "key": "scaleX",
                                    "index": 17
                                }]
                            }
                        }, {
                            "target": 230,
                            "keyframes": {
                                "x": [{
                                    "value": 346,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 230,
                                    "key": "x",
                                    "index": 0
                                }, {
                                    "value": 346,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 230,
                                    "key": "x",
                                    "index": 17
                                }],
                                "scaleX": [{
                                    "value": 0.8,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 230,
                                    "key": "scaleX",
                                    "index": 0
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 230,
                                    "key": "scaleX",
                                    "index": 17
                                }]
                            }
                        }],
                        "name": "ani8",
                        "id": 8,
                        "frameRate": 60,
                        "action": 0
                    }, {
                        "nodes": [{
                            "target": 335,
                            "keyframes": {
                                "x": [{
                                    "value": -44,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 335,
                                    "key": "x",
                                    "index": 0
                                }, {
                                    "value": 68,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 335,
                                    "key": "x",
                                    "index": 30
                                }],
                                "alpha": [{
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 335,
                                    "key": "alpha",
                                    "index": 0
                                }, {
                                    "value": 0.49,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 335,
                                    "key": "alpha",
                                    "index": 55
                                }]
                            }
                        }, {
                            "target": 344,
                            "keyframes": {
                                "x": [{
                                    "value": -42,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 344,
                                    "key": "x",
                                    "index": 0
                                }, {
                                    "value": 72,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 344,
                                    "key": "x",
                                    "index": 30
                                }],
                                "alpha": [{
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 344,
                                    "key": "alpha",
                                    "index": 0
                                }, {
                                    "value": 0.49,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 344,
                                    "key": "alpha",
                                    "index": 55
                                }]
                            }
                        }, {
                            "target": 347,
                            "keyframes": {
                                "x": [{
                                    "value": -44,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 347,
                                    "key": "x",
                                    "index": 0
                                }, {
                                    "value": 74,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 347,
                                    "key": "x",
                                    "index": 30
                                }],
                                "alpha": [{
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 347,
                                    "key": "alpha",
                                    "index": 0
                                }, {
                                    "value": 0.49,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 347,
                                    "key": "alpha",
                                    "index": 55
                                }]
                            }
                        }, {
                            "target": 349,
                            "keyframes": {
                                "visible": [{
                                    "value": true,
                                    "tweenMethod": "linearNone",
                                    "tween": false,
                                    "target": 349,
                                    "key": "visible",
                                    "index": 0
                                }, {
                                    "value": false,
                                    "tweenMethod": "linearNone",
                                    "tween": false,
                                    "target": 349,
                                    "key": "visible",
                                    "index": 10
                                }, {
                                    "value": true,
                                    "tweenMethod": "linearNone",
                                    "tween": false,
                                    "target": 349,
                                    "key": "visible",
                                    "index": 20
                                }, {
                                    "value": false,
                                    "tweenMethod": "linearNone",
                                    "tween": false,
                                    "target": 349,
                                    "key": "visible",
                                    "index": 30
                                }, {
                                    "value": true,
                                    "tweenMethod": "linearNone",
                                    "tween": false,
                                    "target": 349,
                                    "key": "visible",
                                    "index": 40
                                }, {
                                    "value": false,
                                    "tweenMethod": "linearNone",
                                    "tween": false,
                                    "target": 349,
                                    "key": "visible",
                                    "index": 50
                                }]
                            }
                        }],
                        "name": "aniRecord",
                        "id": 9,
                        "frameRate": 30,
                        "action": 2
                    }],
                    "loadList": ["sub1/ui/game/img_33.png", "sub1/ui/game/img_55.png", "sub1/ui/game/img_56.png", "view/game/QuasiCenter1.scene", "sub1/ui/game/img_19.png", "sub1/ui/game/img_shenghua_7.png", "sub1/ui/game/img_3.png", "sub1/ui/game/img_41.png", "sub1/ui/game/img_43.png", "sub1/ui/game/img_44.png", "sub1/ui/scale9/img_game_2.png", "sub1/ui/scale9/img_game_1.png", "sub1/ui/game/img_47.png", "sub1/ui/scale9/img_shenghua_2.png", "sub1/ui/game/img_shenghua_5.png", "sub1/ui/game/img_shenghua_8.png", "sub1/ui/game/img_8.png", "sub1/ui/game/img_4.png", "sub1/ui/game/img_7.png", "sub1/ui/game/img_16.png", "sub1/ui/game/img_18.png", "sub1/ui/game/img_diu_1.png", "sub1/ui/game/img_closeMirror_1.png", "sub1/ui/game/img_39.png", "sub1/ui/game/img_12.png", "sub1/ui/game/img_10.png", "sub1/ui/game/img_28.png", "sub1/ui/game/img_29.png", "sub1/ui/game/img_11.png", "sub1/equip/arm/1.png", "sub1/ui/game/img_46.png", "sub1/ui/game/img_45.png", "sub1/ui/game/img_record_3.png", "sub1/ui/game/img_record_4.png", "sub1/ui/game/img_record_2.png", "sub1/ui/game/img_record_5.png", "sub1/ui/game/img_record_1.png", "sub1/ui/scale9/img_8.png", "sub1/ui/scale9/img_7.png", "sub1/ui/game/img_21.png", "sub1/ui/scale9/img_10.png", "sub1/ui/game/img_20.png", "sub1/ui/scale9/img_shanghua_1.png", "sub1/ui/game/img_jiuyuan_6.png", "sub1/ui/game/img_jiuyuan_5.png", "sub1/ui/game/img_jiuyuan_7.png", "sub1/ui/game/img_jiuyuan_2.png", "sub1/ui/game/img_jiuyuan_4.png", "sub1/ui/game/img_jiuyuan_3.png"],
                    "loadList3D": []
                };
                game.GameViewUI = GameViewUI;
                REG("ui.view.game.GameViewUI", GameViewUI);
                class HeadshotUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.createView(HeadshotUI.uiView);
                    }
                }
                HeadshotUI.uiView = {
                    "type": "View",
                    "props": {
                        "width": 372,
                        "height": 236
                    },
                    "compId": 2,
                    "child": [{
                        "type": "Box",
                        "props": {
                            "y": 118,
                            "x": 186,
                            "width": 372,
                            "scaleY": 0,
                            "scaleX": 0,
                            "height": 236,
                            "anchorY": 0.5,
                            "anchorX": 0.5
                        },
                        "compId": 4,
                        "child": [{
                            "type": "Image",
                            "props": {
                                "var": "imgIcon",
                                "skin": "sub1/ui/game/Kill_Headshot.png",
                                "scaleY": 1,
                                "scaleX": 1,
                                "centerY": 0,
                                "centerX": 0,
                                "anchorY": 0.5,
                                "anchorX": 0.5
                            },
                            "compId": 3
                        }]
                    }],
                    "animations": [{
                        "nodes": [{
                            "target": 4,
                            "keyframes": {
                                "x": [{
                                    "value": 186,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "key": "x",
                                    "index": 0
                                }, {
                                    "value": 186,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "key": "x",
                                    "index": 6
                                }, {
                                    "value": 186,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "label": null,
                                    "key": "x",
                                    "index": 54
                                }],
                                "scaleY": [{
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "key": "scaleY",
                                    "index": 0
                                }, {
                                    "value": 1.3,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "key": "scaleY",
                                    "index": 6
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "key": "scaleY",
                                    "index": 9
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "label": null,
                                    "key": "scaleY",
                                    "index": 47
                                }, {
                                    "value": 1.3,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "label": null,
                                    "key": "scaleY",
                                    "index": 54
                                }, {
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "key": "scaleY",
                                    "index": 57
                                }],
                                "scaleX": [{
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "key": "scaleX",
                                    "index": 0
                                }, {
                                    "value": 1.3,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "key": "scaleX",
                                    "index": 6
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "key": "scaleX",
                                    "index": 9
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "label": null,
                                    "key": "scaleX",
                                    "index": 47
                                }, {
                                    "value": 1.3,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "label": null,
                                    "key": "scaleX",
                                    "index": 54
                                }, {
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 4,
                                    "key": "scaleX",
                                    "index": 57
                                }]
                            }
                        }],
                        "name": "baotou",
                        "id": 1,
                        "frameRate": 60,
                        "action": 0
                    }],
                    "loadList": ["sub1/ui/game/Kill_Headshot.png"],
                    "loadList3D": []
                };
                game.HeadshotUI = HeadshotUI;
                REG("ui.view.game.HeadshotUI", HeadshotUI);
                class InvincibleProUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.createView(InvincibleProUI.uiView);
                    }
                }
                InvincibleProUI.uiView = {
                    "type": "View",
                    "props": {
                        "width": 204,
                        "height": 70
                    },
                    "compId": 2,
                    "child": [{
                        "type": "Image",
                        "props": {
                            "y": 9,
                            "x": -57,
                            "width": 324,
                            "skin": "sub1/ui/scale9/img_8.png",
                            "height": 17,
                            "sizeGrid": "6,9,10,7"
                        },
                        "compId": 3,
                        "child": [{
                            "type": "Image",
                            "props": {
                                "y": 2,
                                "x": 2,
                                "width": 320,
                                "var": "imgPro",
                                "skin": "sub1/ui/scale9/img_12.png",
                                "height": 13,
                                "sizeGrid": "9,7,8,6"
                            },
                            "compId": 4
                        }]
                    }, {
                        "type": "Label",
                        "props": {
                            "y": 36,
                            "x": 8,
                            "width": 188,
                            "valign": "middle",
                            "text": "无敌时间",
                            "height": 31,
                            "fontSize": 26,
                            "font": "SimHei",
                            "color": "#FFFFFF",
                            "bold": true,
                            "align": "center"
                        },
                        "compId": 6
                    }],
                    "loadList": ["sub1/ui/scale9/img_8.png", "sub1/ui/scale9/img_12.png"],
                    "loadList3D": []
                };
                game.InvincibleProUI = InvincibleProUI;
                REG("ui.view.game.InvincibleProUI", InvincibleProUI);
                class MatchSituationUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.createView(MatchSituationUI.uiView);
                    }
                }
                MatchSituationUI.uiView = {
                    "type": "View",
                    "props": {
                        "width": 373,
                        "height": 30
                    },
                    "compId": 2,
                    "child": [{
                        "type": "Image",
                        "props": {
                            "y": -1,
                            "x": 0,
                            "skin": "sub1/ui/game/img_27.png",
                            "height": 30,
                            "alpha": 0
                        },
                        "compId": 3,
                        "child": [{
                            "type": "Image",
                            "props": {
                                "y": 4,
                                "x": 78,
                                "skin": "sub1/ui/game/img_32.png"
                            },
                            "compId": 4
                        }, {
                            "type": "Label",
                            "props": {
                                "y": 5,
                                "x": 111,
                                "width": 155,
                                "var": "txtContent",
                                "text": "敌方剩余分数：",
                                "height": 25,
                                "fontSize": 22,
                                "font": "SimHei",
                                "color": "#FFFFFF",
                                "bold": true
                            },
                            "compId": 5
                        }, {
                            "type": "Label",
                            "props": {
                                "y": 6,
                                "x": 261,
                                "width": 75,
                                "var": "txtData",
                                "text": "30",
                                "height": 25,
                                "fontSize": 22,
                                "font": "SimHei",
                                "color": "#FF7623",
                                "bold": true
                            },
                            "compId": 6
                        }]
                    }],
                    "animations": [{
                        "nodes": [{
                            "target": 3,
                            "keyframes": {
                                "x": [{
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 3,
                                    "key": "x",
                                    "index": 0
                                }],
                                "alpha": [{
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 3,
                                    "key": "alpha",
                                    "index": 0
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 3,
                                    "key": "alpha",
                                    "index": 8
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 3,
                                    "label": null,
                                    "key": "alpha",
                                    "index": 120
                                }, {
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 3,
                                    "key": "alpha",
                                    "index": 128
                                }]
                            }
                        }],
                        "name": "ani1",
                        "id": 1,
                        "frameRate": 60,
                        "action": 0
                    }],
                    "loadList": ["sub1/ui/game/img_27.png", "sub1/ui/game/img_32.png"],
                    "loadList3D": []
                };
                game.MatchSituationUI = MatchSituationUI;
                REG("ui.view.game.MatchSituationUI", MatchSituationUI);
                class PlayerItemUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.createView(PlayerItemUI.uiView);
                    }
                }
                PlayerItemUI.uiView = {
                    "type": "View",
                    "props": {
                        "width": 41,
                        "height": 41
                    },
                    "compId": 2,
                    "child": [{
                        "type": "Image",
                        "props": {
                            "skin": "sub1/ui/scale9/img_6.png"
                        },
                        "compId": 3
                    }, {
                        "type": "Image",
                        "props": {
                            "y": 2,
                            "x": 0,
                            "var": "imgState",
                            "skin": "sub1/ui/game/img_1.png"
                        },
                        "compId": 4
                    }],
                    "loadList": ["sub1/ui/scale9/img_6.png", "sub1/ui/game/img_1.png"],
                    "loadList3D": []
                };
                game.PlayerItemUI = PlayerItemUI;
                REG("ui.view.game.PlayerItemUI", PlayerItemUI);
                class PlayerKillBroadcastUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.createView(PlayerKillBroadcastUI.uiView);
                    }
                }
                PlayerKillBroadcastUI.uiView = {
                    "type": "View",
                    "props": {
                        "width": 373,
                        "height": 30
                    },
                    "compId": 2,
                    "child": [{
                        "type": "Image",
                        "props": {
                            "skin": "sub1/ui/game/img_27.png"
                        },
                        "compId": 3
                    }, {
                        "type": "Label",
                        "props": {
                            "y": 0,
                            "x": 0,
                            "width": 372,
                            "var": "txttKill",
                            "valign": "middle",
                            "text": "你使用akm-12击杀了吃瓜的喃",
                            "height": 30,
                            "fontSize": 20,
                            "font": "SimHei",
                            "color": "#FFFFFF",
                            "bold": true,
                            "align": "center"
                        },
                        "compId": 4
                    }],
                    "loadList": ["sub1/ui/game/img_27.png"],
                    "loadList3D": []
                };
                game.PlayerKillBroadcastUI = PlayerKillBroadcastUI;
                REG("ui.view.game.PlayerKillBroadcastUI", PlayerKillBroadcastUI);
                class QuasiCenterUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.createView(QuasiCenterUI.uiView);
                    }
                }
                QuasiCenterUI.uiView = {
                    "type": "View",
                    "props": {
                        "width": 64,
                        "runtime": "view/game/QuasiCenterCtrl.ts",
                        "height": 63
                    },
                    "compId": 2,
                    "child": [{
                        "type": "Box",
                        "props": {
                            "y": 0,
                            "x": 0,
                            "width": 64,
                            "height": 63
                        },
                        "compId": 3,
                        "child": [{
                            "type": "Image",
                            "props": {
                                "y": 25,
                                "x": 34,
                                "var": "imgZhunXinUp",
                                "skin": "sub1/ui/game/img_13.png",
                                "rotation": -180
                            },
                            "compId": 4
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 29,
                                "x": 26,
                                "var": "imgZhunXinLeft",
                                "skin": "sub1/ui/game/img_13.png",
                                "rotation": 90
                            },
                            "compId": 7
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 34,
                                "x": 37,
                                "var": "imgZhunXinRight",
                                "skin": "sub1/ui/game/img_13.png",
                                "rotation": -90
                            },
                            "compId": 9
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 37,
                                "x": 29,
                                "var": "imgZhunXinDown",
                                "skin": "sub1/ui/game/img_13.png"
                            },
                            "compId": 10
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 29,
                                "x": 29,
                                "var": "imgPoint",
                                "skin": "sub1/ui/game/img_14.png"
                            },
                            "compId": 5
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 31,
                                "x": 32,
                                "width": 53,
                                "visible": true,
                                "var": "imgAttack",
                                "skin": "sub1/ui/game/img_15.png",
                                "height": 53,
                                "anchorY": 0.5,
                                "anchorX": 0.5,
                                "alpha": 0
                            },
                            "compId": 11
                        }, {
                            "type": "Box",
                            "props": {
                                "y": 31,
                                "x": 33,
                                "width": 51,
                                "var": "boxArrow",
                                "pivotY": 28,
                                "pivotX": 26,
                                "height": 55,
                                "alpha": 0
                            },
                            "compId": 16,
                            "child": [{
                                "type": "Image",
                                "props": {
                                    "y": 22.999999999999996,
                                    "x": 57,
                                    "var": "imgRight",
                                    "skin": "sub1/ui/game/img_arraw.png"
                                },
                                "compId": 12
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 33,
                                    "x": -7,
                                    "var": "imgLeft",
                                    "skin": "sub1/ui/game/img_arraw.png",
                                    "rotation": 180
                                },
                                "compId": 13
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": -3,
                                    "x": 20.000000589487758,
                                    "width": 7,
                                    "var": "imgTop",
                                    "skin": "sub1/ui/game/img_arraw.png",
                                    "rotation": -90,
                                    "height": 11
                                },
                                "compId": 14
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 60,
                                    "x": 30.000000589487758,
                                    "width": 7,
                                    "var": "imgBottom",
                                    "skin": "sub1/ui/game/img_arraw.png",
                                    "rotation": 90,
                                    "height": 11
                                },
                                "compId": 15
                            }]
                        }]
                    }],
                    "loadList": ["sub1/ui/game/img_13.png", "sub1/ui/game/img_14.png", "sub1/ui/game/img_15.png", "sub1/ui/game/img_arraw.png"],
                    "loadList3D": []
                };
                game.QuasiCenterUI = QuasiCenterUI;
                REG("ui.view.game.QuasiCenterUI", QuasiCenterUI);
                class QuasiCenter1UI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/game/QuasiCenter1");
                    }
                }
                game.QuasiCenter1UI = QuasiCenter1UI;
                REG("ui.view.game.QuasiCenter1UI", QuasiCenter1UI);
                class RescuingItemUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.createView(RescuingItemUI.uiView);
                    }
                }
                RescuingItemUI.uiView = {
                    "type": "View",
                    "props": {
                        "width": 69,
                        "height": 69
                    },
                    "compId": 2,
                    "child": [{
                        "type": "Box",
                        "props": {
                            "y": 73,
                            "x": 72,
                            "width": 56,
                            "var": "box",
                            "pivotY": 65,
                            "pivotX": 65,
                            "height": 56
                        },
                        "compId": 3,
                        "child": [{
                            "type": "Image",
                            "props": {
                                "y": 0,
                                "x": 0,
                                "skin": "sub1/ui/game/img_jiuyuan_6.png"
                            },
                            "compId": 10
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 81,
                                "x": 61,
                                "var": "imgMask",
                                "skin": "sub1/ui/game/img_jiuyuan_5.png",
                                "sizeGrid": "8,7,6,5",
                                "pivotY": 89,
                                "pivotX": 67,
                                "alpha": 0.7
                            },
                            "compId": 5
                        }, {
                            "type": "Label",
                            "props": {
                                "width": 75,
                                "var": "txtTime",
                                "valign": "middle",
                                "text": "1",
                                "height": 32,
                                "fontSize": 24,
                                "font": "SimHei",
                                "color": "#ffffff",
                                "centerY": -2,
                                "centerX": -1,
                                "align": "center"
                            },
                            "compId": 7
                        }, {
                            "type": "Sprite",
                            "props": {
                                "y": -8,
                                "x": -9,
                                "width": 70,
                                "var": "sprPie",
                                "height": 69
                            },
                            "compId": 12
                        }]
                    }],
                    "loadList": ["sub1/ui/game/img_jiuyuan_6.png", "sub1/ui/game/img_jiuyuan_5.png"],
                    "loadList3D": []
                };
                game.RescuingItemUI = RescuingItemUI;
                REG("ui.view.game.RescuingItemUI", RescuingItemUI);
                class RevengeItemUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.createView(RevengeItemUI.uiView);
                    }
                }
                RevengeItemUI.uiView = {
                    "type": "View",
                    "props": {
                        "width": 372,
                        "height": 236
                    },
                    "compId": 2,
                    "child": [{
                        "type": "Box",
                        "props": {
                            "y": 118,
                            "x": 186,
                            "width": 317,
                            "scaleY": 0,
                            "scaleX": 0,
                            "height": 180,
                            "anchorY": 0.5,
                            "anchorX": 0.5
                        },
                        "compId": 3,
                        "child": [{
                            "type": "Image",
                            "props": {
                                "y": 36,
                                "x": 108,
                                "var": "imgIcon",
                                "skin": "sub1/ui/game/Kill_Revenge.png"
                            },
                            "compId": 5
                        }]
                    }],
                    "animations": [{
                        "nodes": [{
                            "target": 3,
                            "keyframes": {
                                "scaleY": [{
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 3,
                                    "key": "scaleY",
                                    "index": 0
                                }, {
                                    "value": 1.5,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 3,
                                    "key": "scaleY",
                                    "index": 3
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 3,
                                    "key": "scaleY",
                                    "index": 5
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 3,
                                    "label": null,
                                    "key": "scaleY",
                                    "index": 7
                                }],
                                "scaleX": [{
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 3,
                                    "key": "scaleX",
                                    "index": 0
                                }, {
                                    "value": 1.5,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 3,
                                    "key": "scaleX",
                                    "index": 3
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 3,
                                    "key": "scaleX",
                                    "index": 5
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 3,
                                    "label": null,
                                    "key": "scaleX",
                                    "index": 7
                                }],
                                "alpha": [{
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 3,
                                    "key": "alpha",
                                    "index": 0
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 3,
                                    "key": "alpha",
                                    "index": 28
                                }, {
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 3,
                                    "key": "alpha",
                                    "index": 34
                                }]
                            }
                        }],
                        "name": "ani1",
                        "id": 1,
                        "frameRate": 60,
                        "action": 0
                    }],
                    "loadList": ["sub1/ui/game/Kill_Revenge.png"],
                    "loadList3D": []
                };
                game.RevengeItemUI = RevengeItemUI;
                REG("ui.view.game.RevengeItemUI", RevengeItemUI);
                class SingleBroadcastUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.createView(SingleBroadcastUI.uiView);
                    }
                }
                SingleBroadcastUI.uiView = {
                    "type": "View",
                    "props": {
                        "width": 300,
                        "height": 34
                    },
                    "compId": 2,
                    "child": [{
                        "type": "HBox",
                        "props": {
                            "y": 1,
                            "x": 0,
                            "width": 362,
                            "height": 31
                        },
                        "compId": 21,
                        "child": [{
                            "type": "Label",
                            "props": {
                                "y": 6,
                                "x": 7,
                                "var": "txtKiller",
                                "text": "吃瓜的喃",
                                "stroke": 1,
                                "height": 23,
                                "fontSize": 22,
                                "font": "SimHei",
                                "color": "#FFFFFF",
                                "bold": false
                            },
                            "compId": 3
                        }, {
                            "type": "Image",
                            "props": {
                                "zOrder": 1,
                                "y": 6,
                                "x": 100,
                                "width": 44,
                                "var": "imgIcon",
                                "skin": "sub1/equip/arm/10.png",
                                "height": 25
                            },
                            "compId": 4
                        }, {
                            "type": "Label",
                            "props": {
                                "zOrder": 2,
                                "y": 7,
                                "x": 144,
                                "var": "txtBeKiller",
                                "text": "吃瓜的喃",
                                "stroke": 1,
                                "height": 23,
                                "fontSize": 22,
                                "font": "SimHei",
                                "color": "#FFFFFF",
                                "bold": false
                            },
                            "compId": 5
                        }, {
                            "type": "Box",
                            "props": {
                                "zOrder": 3,
                                "y": 16,
                                "x": 221,
                                "width": 158,
                                "var": "boxHead",
                                "scaleY": 0.3,
                                "scaleX": 0.3,
                                "height": 128,
                                "anchorY": 0.5,
                                "anchorX": 0
                            },
                            "compId": 12,
                            "child": [{
                                "type": "Image",
                                "props": {
                                    "var": "imgHeadShot",
                                    "skin": "sub1/ui/game/Kill_Headshot.png",
                                    "centerY": 17,
                                    "centerX": 0
                                },
                                "compId": 20
                            }]
                        }]
                    }],
                    "loadList": ["sub1/equip/arm/10.png", "sub1/ui/game/Kill_Headshot.png"],
                    "loadList3D": []
                };
                game.SingleBroadcastUI = SingleBroadcastUI;
                REG("ui.view.game.SingleBroadcastUI", SingleBroadcastUI);
                class WaitingforrescueViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.createView(WaitingforrescueViewUI.uiView);
                    }
                }
                WaitingforrescueViewUI.uiView = {
                    "type": "View",
                    "props": {
                        "width": 1,
                        "height": 1
                    },
                    "compId": 2,
                    "child": [{
                        "type": "Image",
                        "props": {
                            "skin": "sub1/ui/game/img_jiuyuan_1.png"
                        },
                        "compId": 3
                    }, {
                        "type": "Image",
                        "props": {
                            "y": 83,
                            "x": 133,
                            "skin": "sub1/ui/game/img_jiuyuan_8.png",
                            "anchorY": 0.5,
                            "anchorX": 0.5
                        },
                        "compId": 4
                    }],
                    "loadList": ["sub1/ui/game/img_jiuyuan_1.png", "sub1/ui/game/img_jiuyuan_8.png"],
                    "loadList3D": []
                };
                game.WaitingforrescueViewUI = WaitingforrescueViewUI;
                REG("ui.view.game.WaitingforrescueViewUI", WaitingforrescueViewUI);
                class ZombieComingViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.createView(ZombieComingViewUI.uiView);
                    }
                }
                ZombieComingViewUI.uiView = {
                    "type": "View",
                    "props": {
                        "width": 690,
                        "height": 100
                    },
                    "compId": 2,
                    "child": [{
                        "type": "Image",
                        "props": {
                            "y": 13,
                            "x": -225,
                            "var": "imgZomBieComingBg",
                            "skin": "sub1/ui/game/img_shenghua_10.png",
                            "scaleY": 1.2,
                            "scaleX": 1.2
                        },
                        "compId": 3
                    }, {
                        "type": "Image",
                        "props": {
                            "y": 13,
                            "x": 136,
                            "var": "imgZombieComing",
                            "skin": "sub1/ui/game/img_shenghua_2.png"
                        },
                        "compId": 4
                    }],
                    "animations": [{
                        "nodes": [{
                            "target": 3,
                            "keyframes": {
                                "alpha": [{
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 3,
                                    "key": "alpha",
                                    "index": 0
                                }, {
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 3,
                                    "key": "alpha",
                                    "index": 45
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 3,
                                    "label": null,
                                    "key": "alpha",
                                    "index": 89
                                }]
                            }
                        }],
                        "name": "ani1",
                        "id": 1,
                        "frameRate": 60,
                        "action": 0
                    }],
                    "loadList": ["sub1/ui/game/img_shenghua_10.png", "sub1/ui/game/img_shenghua_2.png"],
                    "loadList3D": []
                };
                game.ZombieComingViewUI = ZombieComingViewUI;
                REG("ui.view.game.ZombieComingViewUI", ZombieComingViewUI);
            })(game = view.game || (view.game = {}));
        })(view = ui.view || (ui.view = {}));
    })(ui || (ui = {}));
    (function(ui) {
        var view;
        (function(view) {
            var gameAir;
            (function(gameAir) {
                class GameAirCrazyViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/gameAir/GameAirCrazyView");
                    }
                }
                gameAir.GameAirCrazyViewUI = GameAirCrazyViewUI;
                REG("ui.view.gameAir.GameAirCrazyViewUI", GameAirCrazyViewUI);
                class GameAirViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/gameAir/GameAirView");
                    }
                }
                gameAir.GameAirViewUI = GameAirViewUI;
                REG("ui.view.gameAir.GameAirViewUI", GameAirViewUI);
            })(gameAir = view.gameAir || (view.gameAir = {}));
        })(view = ui.view || (ui.view = {}));
    })(ui || (ui = {}));
    (function(ui) {
        var view;
        (function(view) {
            var gameBox;
            (function(gameBox) {
                class EndGameBoxViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/gameBox/EndGameBoxView");
                    }
                }
                gameBox.EndGameBoxViewUI = EndGameBoxViewUI;
                REG("ui.view.gameBox.EndGameBoxViewUI", EndGameBoxViewUI);
                class GameBoxViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/gameBox/GameBoxView");
                    }
                }
                gameBox.GameBoxViewUI = GameBoxViewUI;
                REG("ui.view.gameBox.GameBoxViewUI", GameBoxViewUI);
                class OPPOGameBoxViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.createView(OPPOGameBoxViewUI.uiView);
                    }
                }
                OPPOGameBoxViewUI.uiView = {
                    "type": "View",
                    "props": {
                        "width": 1334,
                        "height": 750
                    },
                    "compId": 2,
                    "child": [{
                        "type": "Image",
                        "props": {
                            "top": 0,
                            "skin": "loading/img_11.jpg",
                            "right": 0,
                            "left": 0,
                            "bottom": 0
                        },
                        "compId": 3
                    }, {
                        "type": "Box",
                        "props": {
                            "width": 1145,
                            "var": "boxAll",
                            "height": 721,
                            "centerY": 0,
                            "centerX": 0
                        },
                        "compId": 4,
                        "child": [{
                            "type": "Image",
                            "props": {
                                "y": 301,
                                "x": 573,
                                "width": 204,
                                "skin": "sub1/ui/common/img_common_1.png",
                                "scaleY": 2.5,
                                "scaleX": 2.5,
                                "height": 198,
                                "anchorY": 0.5,
                                "anchorX": 0.5
                            },
                            "compId": 5
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 321,
                                "x": 584,
                                "width": 160,
                                "skin": "sub1/ui/common/img_common_2.png",
                                "scaleY": 2.8,
                                "scaleX": 2.8,
                                "height": 155,
                                "anchorY": 0.5,
                                "anchorX": 0.5
                            },
                            "compId": 6
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 302,
                                "x": 574,
                                "var": "imgBox",
                                "skin": "sub1/ui/gameBox/img_1.png",
                                "scaleY": 1,
                                "scaleX": 1,
                                "anchorY": 0.5,
                                "anchorX": 0.5
                            },
                            "compId": 7
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 552,
                                "x": 584,
                                "width": 227,
                                "var": "btnOpenSenior",
                                "skin": "sub1/ui/scale9/img_normal_1.png",
                                "height": 86,
                                "anchorY": 0.5,
                                "anchorX": 0.5,
                                "sizeGrid": "24,92,27,91"
                            },
                            "compId": 13,
                            "child": [{
                                "type": "Script",
                                "props": {
                                    "runtime": "effect/ButtonEffect.ts"
                                },
                                "compId": 14
                            }, {
                                "type": "Box",
                                "props": {
                                    "y": 14,
                                    "x": 15,
                                    "width": 200,
                                    "var": "boxAd",
                                    "height": 56
                                },
                                "compId": 17,
                                "child": [{
                                    "type": "Image",
                                    "props": {
                                        "y": 11,
                                        "x": 58,
                                        "skin": "sub1/ui/gameBox/img_5.png"
                                    },
                                    "compId": 15
                                }, {
                                    "type": "Image",
                                    "props": {
                                        "y": 15,
                                        "x": 10,
                                        "skin": "sub1/ui/common/img_10.png"
                                    },
                                    "compId": 16
                                }]
                            }]
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 176,
                                "x": 428,
                                "skin": "sub1/ui/gameBox/img_3.png",
                                "anchorY": 0.5,
                                "anchorX": 0.5
                            },
                            "compId": 24
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 189,
                                "x": 676,
                                "width": 30,
                                "skin": "sub1/ui/gameBox/img_3.png",
                                "height": 32,
                                "anchorY": 0.5,
                                "anchorX": 0.5
                            },
                            "compId": 26
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 340,
                                "x": 383,
                                "width": 45,
                                "skin": "sub1/ui/gameBox/img_3.png",
                                "height": 49,
                                "anchorY": 0.5,
                                "anchorX": 0.5
                            },
                            "compId": 27
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 436,
                                "x": 737,
                                "width": 36,
                                "skin": "sub1/ui/gameBox/img_3.png",
                                "height": 35,
                                "anchorY": 0.5,
                                "anchorX": 0.5
                            },
                            "compId": 28
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 302,
                                "x": 159,
                                "skin": "sub1/ui/gameBox/img_2.png",
                                "scaleY": 1,
                                "scaleX": 1,
                                "anchorY": 0.5,
                                "anchorX": 0.5
                            },
                            "compId": 29
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 552,
                                "x": 156,
                                "width": 227,
                                "var": "btnOpenPrimary",
                                "skin": "sub1/ui/scale9/img_normal_2.png",
                                "height": 86,
                                "anchorY": 0.5,
                                "anchorX": 0.5,
                                "sizeGrid": "21,80,30,79"
                            },
                            "compId": 30,
                            "child": [{
                                "type": "Script",
                                "props": {
                                    "runtime": "effect/ButtonEffect.ts"
                                },
                                "compId": 31
                            }, {
                                "type": "Box",
                                "props": {
                                    "y": 14,
                                    "x": 15,
                                    "width": 200,
                                    "height": 56
                                },
                                "compId": 32,
                                "child": [{
                                    "type": "Image",
                                    "props": {
                                        "y": 10,
                                        "x": 34,
                                        "skin": "sub1/ui/gameBox/img_4.png"
                                    },
                                    "compId": 33
                                }]
                            }]
                        }]
                    }],
                    "animations": [{
                        "nodes": [{
                            "target": 5,
                            "keyframes": {
                                "x": [{
                                    "value": 572.5,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 5,
                                    "key": "x",
                                    "index": 0
                                }],
                                "rotation": [{
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 5,
                                    "key": "rotation",
                                    "index": 0
                                }, {
                                    "value": 360,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 5,
                                    "key": "rotation",
                                    "index": 275
                                }]
                            }
                        }, {
                            "target": 6,
                            "keyframes": {
                                "x": [{
                                    "value": 584,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 6,
                                    "key": "x",
                                    "index": 0
                                }, {
                                    "value": 584,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 6,
                                    "key": "x",
                                    "index": 275
                                }],
                                "rotation": [{
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 6,
                                    "key": "rotation",
                                    "index": 0
                                }, {
                                    "value": -360,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 6,
                                    "key": "rotation",
                                    "index": 275
                                }]
                            }
                        }],
                        "name": "ani1",
                        "id": 1,
                        "frameRate": 60,
                        "action": 0
                    }, {
                        "nodes": [{
                            "target": 24,
                            "keyframes": {
                                "x": [{
                                    "value": 428,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 24,
                                    "key": "x",
                                    "index": 0
                                }, {
                                    "value": 428,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 24,
                                    "label": null,
                                    "key": "x",
                                    "index": 20
                                }, {
                                    "value": 428,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 24,
                                    "label": null,
                                    "key": "x",
                                    "index": 40
                                }],
                                "scaleY": [{
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 24,
                                    "key": "scaleY",
                                    "index": 0
                                }, {
                                    "value": 0.1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 24,
                                    "key": "scaleY",
                                    "index": 10
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 24,
                                    "label": null,
                                    "key": "scaleY",
                                    "index": 20
                                }, {
                                    "value": 0.1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 24,
                                    "label": null,
                                    "key": "scaleY",
                                    "index": 30
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 24,
                                    "label": null,
                                    "key": "scaleY",
                                    "index": 40
                                }],
                                "scaleX": [{
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 24,
                                    "key": "scaleX",
                                    "index": 0
                                }, {
                                    "value": 0.1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 24,
                                    "key": "scaleX",
                                    "index": 10
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 24,
                                    "label": null,
                                    "key": "scaleX",
                                    "index": 20
                                }, {
                                    "value": 0.1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 24,
                                    "label": null,
                                    "key": "scaleX",
                                    "index": 30
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 24,
                                    "label": null,
                                    "key": "scaleX",
                                    "index": 40
                                }]
                            }
                        }, {
                            "target": 26,
                            "keyframes": {
                                "x": [{
                                    "value": 676,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 26,
                                    "key": "x",
                                    "index": 0
                                }, {
                                    "value": 676,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 26,
                                    "key": "x",
                                    "index": 12
                                }, {
                                    "value": 676,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 26,
                                    "label": null,
                                    "key": "x",
                                    "index": 24
                                }, {
                                    "value": 676,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 26,
                                    "label": null,
                                    "key": "x",
                                    "index": 34
                                }, {
                                    "value": 676,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 26,
                                    "label": null,
                                    "key": "x",
                                    "index": 47
                                }],
                                "scaleY": [{
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 26,
                                    "key": "scaleY",
                                    "index": 0
                                }, {
                                    "value": 2,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 26,
                                    "key": "scaleY",
                                    "index": 12
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 26,
                                    "label": null,
                                    "key": "scaleY",
                                    "index": 24
                                }, {
                                    "value": 2,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 26,
                                    "label": null,
                                    "key": "scaleY",
                                    "index": 34
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 26,
                                    "label": null,
                                    "key": "scaleY",
                                    "index": 47
                                }],
                                "scaleX": [{
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 26,
                                    "key": "scaleX",
                                    "index": 0
                                }, {
                                    "value": 2,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 26,
                                    "key": "scaleX",
                                    "index": 12
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 26,
                                    "label": null,
                                    "key": "scaleX",
                                    "index": 24
                                }, {
                                    "value": 2,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 26,
                                    "label": null,
                                    "key": "scaleX",
                                    "index": 34
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 26,
                                    "label": null,
                                    "key": "scaleX",
                                    "index": 47
                                }]
                            }
                        }, {
                            "target": 27,
                            "keyframes": {
                                "x": [{
                                    "value": 383,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 27,
                                    "key": "x",
                                    "index": 0
                                }, {
                                    "value": 383,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 27,
                                    "key": "x",
                                    "index": 7
                                }, {
                                    "value": 383,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 27,
                                    "label": null,
                                    "key": "x",
                                    "index": 21
                                }, {
                                    "value": 383,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 27,
                                    "label": null,
                                    "key": "x",
                                    "index": 32
                                }, {
                                    "value": 383,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 27,
                                    "label": null,
                                    "key": "x",
                                    "index": 44
                                }],
                                "scaleY": [{
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 27,
                                    "key": "scaleY",
                                    "index": 0
                                }, {
                                    "value": 0.1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 27,
                                    "key": "scaleY",
                                    "index": 7
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 27,
                                    "label": null,
                                    "key": "scaleY",
                                    "index": 21
                                }, {
                                    "value": 0.1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 27,
                                    "label": null,
                                    "key": "scaleY",
                                    "index": 32
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 27,
                                    "label": null,
                                    "key": "scaleY",
                                    "index": 44
                                }],
                                "scaleX": [{
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 27,
                                    "key": "scaleX",
                                    "index": 0
                                }, {
                                    "value": 0.1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 27,
                                    "key": "scaleX",
                                    "index": 7
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 27,
                                    "label": null,
                                    "key": "scaleX",
                                    "index": 21
                                }, {
                                    "value": 0.1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 27,
                                    "label": null,
                                    "key": "scaleX",
                                    "index": 32
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 27,
                                    "label": null,
                                    "key": "scaleX",
                                    "index": 44
                                }]
                            }
                        }, {
                            "target": 28,
                            "keyframes": {
                                "x": [{
                                    "value": 737,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 28,
                                    "key": "x",
                                    "index": 0
                                }, {
                                    "value": 737,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 28,
                                    "key": "x",
                                    "index": 13
                                }, {
                                    "value": 737,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 28,
                                    "label": null,
                                    "key": "x",
                                    "index": 27
                                }, {
                                    "value": 737,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 28,
                                    "label": null,
                                    "key": "x",
                                    "index": 37
                                }, {
                                    "value": 737,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 28,
                                    "label": null,
                                    "key": "x",
                                    "index": 49
                                }],
                                "scaleY": [{
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 28,
                                    "key": "scaleY",
                                    "index": 0
                                }, {
                                    "value": 0.3,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 28,
                                    "key": "scaleY",
                                    "index": 13
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 28,
                                    "label": null,
                                    "key": "scaleY",
                                    "index": 27
                                }, {
                                    "value": 0.3,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 28,
                                    "label": null,
                                    "key": "scaleY",
                                    "index": 37
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 28,
                                    "label": null,
                                    "key": "scaleY",
                                    "index": 49
                                }],
                                "scaleX": [{
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 28,
                                    "key": "scaleX",
                                    "index": 0
                                }, {
                                    "value": 0.3,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 28,
                                    "key": "scaleX",
                                    "index": 13
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 28,
                                    "label": null,
                                    "key": "scaleX",
                                    "index": 27
                                }, {
                                    "value": 0.3,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 28,
                                    "label": null,
                                    "key": "scaleX",
                                    "index": 37
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 28,
                                    "label": null,
                                    "key": "scaleX",
                                    "index": 49
                                }]
                            }
                        }],
                        "name": "ani2",
                        "id": 2,
                        "frameRate": 24,
                        "action": 0
                    }],
                    "loadList": ["loading/img_11.jpg", "sub1/ui/common/img_common_1.png", "sub1/ui/common/img_common_2.png", "sub1/ui/gameBox/img_1.png", "sub1/ui/scale9/img_normal_1.png", "sub1/ui/gameBox/img_5.png", "sub1/ui/common/img_10.png", "sub1/ui/gameBox/img_3.png", "sub1/ui/gameBox/img_2.png", "sub1/ui/scale9/img_normal_2.png", "sub1/ui/gameBox/img_4.png"],
                    "loadList3D": []
                };
                gameBox.OPPOGameBoxViewUI = OPPOGameBoxViewUI;
                REG("ui.view.gameBox.OPPOGameBoxViewUI", OPPOGameBoxViewUI);
            })(gameBox = view.gameBox || (view.gameBox = {}));
        })(view = ui.view || (ui.view = {}));
    })(ui || (ui = {}));
    (function(ui) {
        var view;
        (function(view) {
            var getReward;
            (function(getReward) {
                class BoxItemCellViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/getReward/BoxItemCellView");
                    }
                }
                getReward.BoxItemCellViewUI = BoxItemCellViewUI;
                REG("ui.view.getReward.BoxItemCellViewUI", BoxItemCellViewUI);
                class GetBoxRewardNextExtraViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/getReward/GetBoxRewardNextExtraView");
                    }
                }
                getReward.GetBoxRewardNextExtraViewUI = GetBoxRewardNextExtraViewUI;
                REG("ui.view.getReward.GetBoxRewardNextExtraViewUI", GetBoxRewardNextExtraViewUI);
                class GetBoxRewardNextViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/getReward/GetBoxRewardNextView");
                    }
                }
                getReward.GetBoxRewardNextViewUI = GetBoxRewardNextViewUI;
                REG("ui.view.getReward.GetBoxRewardNextViewUI", GetBoxRewardNextViewUI);
                class GetBoxRewardViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/getReward/GetBoxRewardView");
                    }
                }
                getReward.GetBoxRewardViewUI = GetBoxRewardViewUI;
                REG("ui.view.getReward.GetBoxRewardViewUI", GetBoxRewardViewUI);
                class GetDiamondsRewardViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.createView(GetDiamondsRewardViewUI.uiView);
                    }
                }
                GetDiamondsRewardViewUI.uiView = {
                    "type": "View",
                    "props": {
                        "width": 1625,
                        "height": 750
                    },
                    "compId": 2,
                    "child": [{
                        "type": "Image",
                        "props": {
                            "y": 0,
                            "x": 0,
                            "top": 0,
                            "skin": "sub1/ui/scale9/img_getReward_bg.png",
                            "right": 0,
                            "left": 0,
                            "bottom": 0,
                            "sizeGrid": "10,9,12,10"
                        },
                        "compId": 14
                    }, {
                        "type": "Box",
                        "props": {
                            "width": 1334,
                            "var": "boxAll",
                            "height": 750,
                            "centerY": 0,
                            "centerX": 0
                        },
                        "compId": 3,
                        "child": [{
                            "type": "Box",
                            "props": {
                                "y": 80,
                                "x": 585,
                                "width": 51,
                                "rotation": 90,
                                "height": 214
                            },
                            "compId": 112,
                            "child": [{
                                "type": "Image",
                                "props": {
                                    "y": 205,
                                    "x": 17.5,
                                    "width": 36,
                                    "skin": "sub1/ui/getReward/img_x_12.png",
                                    "scaleY": 1.5,
                                    "scaleX": 1.5,
                                    "rotation": 0,
                                    "pivotY": 15,
                                    "pivotX": 14,
                                    "height": 36,
                                    "blendMode": "lighter"
                                },
                                "compId": 113
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 215,
                                    "x": 18,
                                    "width": 36,
                                    "skin": "sub1/ui/getReward/img_x_12.png",
                                    "rotation": 0,
                                    "pivotY": 15,
                                    "pivotX": 14,
                                    "height": 36,
                                    "blendMode": "lighter"
                                },
                                "compId": 114
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 207,
                                    "x": 43,
                                    "width": 36,
                                    "skin": "sub1/ui/getReward/img_x_12.png",
                                    "rotation": 0,
                                    "pivotY": 15,
                                    "pivotX": 14,
                                    "height": 36,
                                    "blendMode": "lighter"
                                },
                                "compId": 115
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 217,
                                    "x": 44,
                                    "width": 36,
                                    "skin": "sub1/ui/getReward/img_x_12.png",
                                    "rotation": 0,
                                    "pivotY": 15,
                                    "pivotX": 14,
                                    "height": 36,
                                    "blendMode": "lighter"
                                },
                                "compId": 116
                            }, {
                                "type": "Script",
                                "props": {
                                    "scaleMin": 0.2,
                                    "scaleMax": 1.5,
                                    "runtime": "effect/UpMoveEffect.ts"
                                },
                                "compId": 117
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 207,
                                    "x": 43,
                                    "width": 36,
                                    "skin": "sub1/ui/getReward/img_x_12.png",
                                    "rotation": 0,
                                    "pivotY": 15,
                                    "pivotX": 14,
                                    "height": 36,
                                    "blendMode": "lighter"
                                },
                                "compId": 118
                            }]
                        }, {
                            "type": "Box",
                            "props": {
                                "y": 131,
                                "x": -81,
                                "width": 47,
                                "rotation": -90,
                                "height": 214
                            },
                            "compId": 119,
                            "child": [{
                                "type": "Image",
                                "props": {
                                    "y": 205,
                                    "x": 17.5,
                                    "width": 36,
                                    "skin": "sub1/ui/getReward/img_x_12.png",
                                    "scaleY": 1.5,
                                    "scaleX": 1.5,
                                    "rotation": 0,
                                    "pivotY": 15,
                                    "pivotX": 14,
                                    "height": 36,
                                    "blendMode": "lighter"
                                },
                                "compId": 120
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 215,
                                    "x": 18,
                                    "width": 36,
                                    "skin": "sub1/ui/getReward/img_x_12.png",
                                    "rotation": 0,
                                    "pivotY": 15,
                                    "pivotX": 14,
                                    "height": 36,
                                    "blendMode": "lighter"
                                },
                                "compId": 121
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 207,
                                    "x": 43,
                                    "width": 36,
                                    "skin": "sub1/ui/getReward/img_x_12.png",
                                    "rotation": 0,
                                    "pivotY": 15,
                                    "pivotX": 14,
                                    "height": 36,
                                    "blendMode": "lighter"
                                },
                                "compId": 122
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 217,
                                    "x": 44,
                                    "width": 36,
                                    "skin": "sub1/ui/getReward/img_x_12.png",
                                    "rotation": 0,
                                    "pivotY": 15,
                                    "pivotX": 14,
                                    "height": 36,
                                    "blendMode": "lighter"
                                },
                                "compId": 123
                            }, {
                                "type": "Script",
                                "props": {
                                    "scaleMin": 0.2,
                                    "scaleMax": 1.5,
                                    "runtime": "effect/UpMoveEffect.ts"
                                },
                                "compId": 124
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 207,
                                    "x": 43,
                                    "width": 36,
                                    "skin": "sub1/ui/getReward/img_x_12.png",
                                    "rotation": 0,
                                    "pivotY": 15,
                                    "pivotX": 14,
                                    "height": 36,
                                    "blendMode": "lighter"
                                },
                                "compId": 125
                            }]
                        }, {
                            "type": "Box",
                            "props": {
                                "y": 102,
                                "x": -145,
                                "width": 1625,
                                "var": "boxBg",
                                "height": 404,
                                "centerX": 0
                            },
                            "compId": 82,
                            "child": [{
                                "type": "Image",
                                "props": {
                                    "y": -16,
                                    "x": 1629,
                                    "width": 818,
                                    "skin": "sub1/ui/getReward/img_x_3.png",
                                    "skewY": 180,
                                    "height": 487
                                },
                                "compId": 85
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": -16,
                                    "x": -4,
                                    "width": 815,
                                    "skin": "sub1/ui/getReward/img_x_3.png",
                                    "height": 487
                                },
                                "compId": 86
                            }]
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 495,
                                "x": 74,
                                "skin": "sub1/ui/end/img_30.png",
                                "skewY": 180
                            },
                            "compId": 110
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 113,
                                "x": 1251,
                                "skin": "sub1/ui/end/img_30.png",
                                "right": -132
                            },
                            "compId": 111
                        }, {
                            "type": "Box",
                            "props": {
                                "y": 152,
                                "x": -145,
                                "width": 1612,
                                "height": 343
                            },
                            "compId": 126,
                            "child": [{
                                "type": "Image",
                                "props": {
                                    "y": 31,
                                    "x": 145,
                                    "width": 121,
                                    "skin": "sub1/ui/getReward/img_x_13.png",
                                    "height": 134,
                                    "anchorY": 0.5,
                                    "anchorX": 0.5,
                                    "alpha": 0
                                },
                                "compId": 128
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 185,
                                    "x": 145,
                                    "skin": "sub1/ui/getReward/img_x_13.png",
                                    "anchorY": 0.5,
                                    "anchorX": 0.5,
                                    "alpha": 0
                                },
                                "compId": 129
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 50,
                                    "x": 1173,
                                    "skin": "sub1/ui/getReward/img_x_13.png",
                                    "anchorY": 0.5,
                                    "anchorX": 0.5,
                                    "alpha": 0
                                },
                                "compId": 130
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 40,
                                    "x": 317,
                                    "skin": "sub1/ui/getReward/img_x_13.png",
                                    "anchorY": 0.5,
                                    "anchorX": 0.5,
                                    "alpha": 0
                                },
                                "compId": 131
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 60,
                                    "x": 597,
                                    "skin": "sub1/ui/getReward/img_x_13.png",
                                    "anchorY": 0.5,
                                    "anchorX": 0.5,
                                    "alpha": 0
                                },
                                "compId": 132
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 82,
                                    "x": 945,
                                    "skin": "sub1/ui/getReward/img_x_13.png",
                                    "anchorY": 0.5,
                                    "anchorX": 0.5,
                                    "alpha": 0
                                },
                                "compId": 133
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 40,
                                    "x": 1373,
                                    "skin": "sub1/ui/getReward/img_x_13.png",
                                    "anchorY": 0.5,
                                    "anchorX": 0.5,
                                    "alpha": 0
                                },
                                "compId": 134
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 185,
                                    "x": 1173,
                                    "skin": "sub1/ui/getReward/img_x_13.png",
                                    "anchorY": 0.5,
                                    "anchorX": 0.5,
                                    "alpha": 0
                                },
                                "compId": 135
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 204,
                                    "x": 410,
                                    "skin": "sub1/ui/getReward/img_x_13.png",
                                    "anchorY": 0.5,
                                    "anchorX": 0.5,
                                    "alpha": 0
                                },
                                "compId": 136
                            }, {
                                "type": "Script",
                                "props": {
                                    "runtime": "effect/PointEffect.ts"
                                },
                                "compId": 138
                            }]
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 117,
                                "x": 276,
                                "skin": "sub1/ui/getReward/img_x_8.png",
                                "anchorY": 0.5,
                                "anchorX": 0.5,
                                "alpha": 1
                            },
                            "compId": 5,
                            "child": [{
                                "type": "Image",
                                "props": {
                                    "y": 94,
                                    "x": -29,
                                    "skin": "sub1/ui/getReward/img_x_11.png"
                                },
                                "compId": 109
                            }]
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 270,
                                "x": 667,
                                "var": "imgGold",
                                "skin": "sub1/ui/common/img_20.png",
                                "scaleY": 0.9,
                                "scaleX": 0.9,
                                "anchorY": 0.5,
                                "anchorX": 0.5,
                                "alpha": 0
                            },
                            "compId": 6
                        }, {
                            "type": "Label",
                            "props": {
                                "y": 442,
                                "x": 661,
                                "width": 290,
                                "var": "btnBack",
                                "valign": "middle",
                                "text": "点击任意位置继续",
                                "height": 56,
                                "fontSize": 26,
                                "font": "SimHei",
                                "color": "#ffffff",
                                "bold": true,
                                "anchorY": 0.5,
                                "anchorX": 0.5,
                                "align": "center"
                            },
                            "compId": 22,
                            "child": [{
                                "type": "Script",
                                "props": {
                                    "runtime": "effect/ButtonEffect.ts"
                                },
                                "compId": 23
                            }]
                        }, {
                            "type": "Box",
                            "props": {
                                "y": 297,
                                "x": 656,
                                "width": 206,
                                "scaleY": 0.6,
                                "scaleX": 0.6,
                                "pivotY": 103,
                                "pivotX": 103,
                                "height": 206
                            },
                            "compId": 103,
                            "child": [{
                                "type": "Image",
                                "props": {
                                    "y": 1,
                                    "x": 0,
                                    "width": 120,
                                    "var": "imgBg",
                                    "skin": "sub1/ui/scale9/img_Item_bg_3.png",
                                    "sizeGrid": "13,17,17,17",
                                    "scaleY": 1.71,
                                    "scaleX": 1.71,
                                    "height": 120
                                },
                                "compId": 104
                            }, {
                                "type": "Image",
                                "props": {
                                    "var": "imgIcon",
                                    "skin": "sub1/item/2001.png",
                                    "scaleY": 1.9,
                                    "scaleX": 1.9,
                                    "centerY": 0,
                                    "centerX": 0
                                },
                                "compId": 105
                            }, {
                                "type": "HBox",
                                "props": {
                                    "right": 9,
                                    "bottom": 8
                                },
                                "compId": 106,
                                "child": [{
                                    "type": "Label",
                                    "props": {
                                        "x": 122,
                                        "var": "txtReward",
                                        "text": "1",
                                        "stroke": 2,
                                        "fontSize": 46,
                                        "color": "#ffffff"
                                    },
                                    "compId": 107
                                }]
                            }, {
                                "type": "Label",
                                "props": {
                                    "y": 225,
                                    "x": 0,
                                    "var": "labelName",
                                    "text": "钻石",
                                    "fontSize": 32,
                                    "color": "#000000",
                                    "centerX": 0,
                                    "bold": true,
                                    "alpha": 1
                                },
                                "compId": 108
                            }]
                        }]
                    }],
                    "animations": [{
                        "nodes": [{
                            "target": 5,
                            "keyframes": {
                                "alpha": [{
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 5,
                                    "key": "alpha",
                                    "index": 0
                                }, {
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 5,
                                    "key": "alpha",
                                    "index": 21
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 5,
                                    "key": "alpha",
                                    "index": 33
                                }]
                            }
                        }, {
                            "target": 119,
                            "keyframes": {
                                "alpha": [{
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 119,
                                    "label": null,
                                    "key": "alpha",
                                    "index": 0
                                }, {
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 119,
                                    "key": "alpha",
                                    "index": 33
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 119,
                                    "label": null,
                                    "key": "alpha",
                                    "index": 50
                                }]
                            }
                        }, {
                            "target": 112,
                            "keyframes": {
                                "alpha": [{
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 112,
                                    "label": null,
                                    "key": "alpha",
                                    "index": 0
                                }, {
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 112,
                                    "key": "alpha",
                                    "index": 33
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 112,
                                    "key": "alpha",
                                    "index": 50
                                }]
                            }
                        }],
                        "name": "ani1",
                        "id": 1,
                        "frameRate": 60,
                        "action": 0
                    }, {
                        "nodes": [],
                        "name": "ani2",
                        "id": 2,
                        "frameRate": 30,
                        "action": 0
                    }, {
                        "nodes": [],
                        "name": "ani3",
                        "id": 3,
                        "frameRate": 24,
                        "action": 0
                    }, {
                        "nodes": [],
                        "name": "ani4",
                        "id": 4,
                        "frameRate": 60,
                        "action": 2
                    }],
                    "loadList": ["sub1/ui/scale9/img_getReward_bg.png", "sub1/ui/getReward/img_x_12.png", "sub1/ui/getReward/img_x_3.png", "sub1/ui/end/img_30.png", "sub1/ui/getReward/img_x_13.png", "sub1/ui/getReward/img_x_8.png", "sub1/ui/getReward/img_x_11.png", "sub1/ui/common/img_20.png", "sub1/ui/scale9/img_Item_bg_3.png", "sub1/item/2001.png"],
                    "loadList3D": []
                };
                getReward.GetDiamondsRewardViewUI = GetDiamondsRewardViewUI;
                REG("ui.view.getReward.GetDiamondsRewardViewUI", GetDiamondsRewardViewUI);
                class GetEquipOrRoleRewardViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/getReward/GetEquipOrRoleRewardView");
                    }
                }
                getReward.GetEquipOrRoleRewardViewUI = GetEquipOrRoleRewardViewUI;
                REG("ui.view.getReward.GetEquipOrRoleRewardViewUI", GetEquipOrRoleRewardViewUI);
                class GetGoldRewardViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.createView(GetGoldRewardViewUI.uiView);
                    }
                }
                GetGoldRewardViewUI.uiView = {
                    "type": "View",
                    "props": {
                        "width": 1334,
                        "height": 750
                    },
                    "compId": 2,
                    "child": [{
                        "type": "Image",
                        "props": {
                            "y": 0,
                            "x": 0,
                            "top": 0,
                            "skin": "sub1/ui/scale9/img_getReward_bg.png",
                            "right": 0,
                            "left": 0,
                            "bottom": 0,
                            "alpha": 1,
                            "sizeGrid": "10,9,12,10"
                        },
                        "compId": 14
                    }, {
                        "type": "Box",
                        "props": {
                            "width": 1334,
                            "var": "boxAll",
                            "height": 750,
                            "centerY": 0,
                            "centerX": 0
                        },
                        "compId": 3,
                        "child": [{
                            "type": "Box",
                            "props": {
                                "y": 80,
                                "x": 585,
                                "width": 51,
                                "rotation": 90,
                                "height": 214
                            },
                            "compId": 128,
                            "child": [{
                                "type": "Image",
                                "props": {
                                    "y": 205,
                                    "x": 17.5,
                                    "width": 36,
                                    "skin": "sub1/ui/getReward/img_x_12.png",
                                    "scaleY": 1.5,
                                    "scaleX": 1.5,
                                    "rotation": 0,
                                    "pivotY": 15,
                                    "pivotX": 14,
                                    "height": 36,
                                    "blendMode": "lighter"
                                },
                                "compId": 133
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 215,
                                    "x": 18,
                                    "width": 36,
                                    "skin": "sub1/ui/getReward/img_x_12.png",
                                    "rotation": 0,
                                    "pivotY": 15,
                                    "pivotX": 14,
                                    "height": 36,
                                    "blendMode": "lighter"
                                },
                                "compId": 134
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 207,
                                    "x": 43,
                                    "width": 36,
                                    "skin": "sub1/ui/getReward/img_x_12.png",
                                    "rotation": 0,
                                    "pivotY": 15,
                                    "pivotX": 14,
                                    "height": 36,
                                    "blendMode": "lighter"
                                },
                                "compId": 135
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 217,
                                    "x": 44,
                                    "width": 36,
                                    "skin": "sub1/ui/getReward/img_x_12.png",
                                    "rotation": 0,
                                    "pivotY": 15,
                                    "pivotX": 14,
                                    "height": 36,
                                    "blendMode": "lighter"
                                },
                                "compId": 136
                            }, {
                                "type": "Script",
                                "props": {
                                    "scaleMin": 0.2,
                                    "scaleMax": 1.5,
                                    "runtime": "effect/UpMoveEffect.ts"
                                },
                                "compId": 137
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 207,
                                    "x": 43,
                                    "width": 36,
                                    "skin": "sub1/ui/getReward/img_x_12.png",
                                    "rotation": 0,
                                    "pivotY": 15,
                                    "pivotX": 14,
                                    "height": 36,
                                    "blendMode": "lighter"
                                },
                                "compId": 138
                            }]
                        }, {
                            "type": "Box",
                            "props": {
                                "y": 131,
                                "x": -81,
                                "width": 47,
                                "rotation": -90,
                                "height": 214
                            },
                            "compId": 129,
                            "child": [{
                                "type": "Image",
                                "props": {
                                    "y": 205,
                                    "x": 17.5,
                                    "width": 36,
                                    "skin": "sub1/ui/getReward/img_x_12.png",
                                    "scaleY": 1.5,
                                    "scaleX": 1.5,
                                    "rotation": 0,
                                    "pivotY": 15,
                                    "pivotX": 14,
                                    "height": 36,
                                    "blendMode": "lighter"
                                },
                                "compId": 139
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 215,
                                    "x": 18,
                                    "width": 36,
                                    "skin": "sub1/ui/getReward/img_x_12.png",
                                    "rotation": 0,
                                    "pivotY": 15,
                                    "pivotX": 14,
                                    "height": 36,
                                    "blendMode": "lighter"
                                },
                                "compId": 140
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 207,
                                    "x": 43,
                                    "width": 36,
                                    "skin": "sub1/ui/getReward/img_x_12.png",
                                    "rotation": 0,
                                    "pivotY": 15,
                                    "pivotX": 14,
                                    "height": 36,
                                    "blendMode": "lighter"
                                },
                                "compId": 141
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 217,
                                    "x": 44,
                                    "width": 36,
                                    "skin": "sub1/ui/getReward/img_x_12.png",
                                    "rotation": 0,
                                    "pivotY": 15,
                                    "pivotX": 14,
                                    "height": 36,
                                    "blendMode": "lighter"
                                },
                                "compId": 142
                            }, {
                                "type": "Script",
                                "props": {
                                    "scaleMin": 0.2,
                                    "scaleMax": 1.5,
                                    "runtime": "effect/UpMoveEffect.ts"
                                },
                                "compId": 143
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 207,
                                    "x": 43,
                                    "width": 36,
                                    "skin": "sub1/ui/getReward/img_x_12.png",
                                    "rotation": 0,
                                    "pivotY": 15,
                                    "pivotX": 14,
                                    "height": 36,
                                    "blendMode": "lighter"
                                },
                                "compId": 144
                            }]
                        }, {
                            "type": "Box",
                            "props": {
                                "y": 102,
                                "x": -145,
                                "width": 1625,
                                "var": "boxBg",
                                "height": 404,
                                "centerX": 0
                            },
                            "compId": 130,
                            "child": [{
                                "type": "Image",
                                "props": {
                                    "y": -16,
                                    "x": 1629,
                                    "width": 818,
                                    "skin": "sub1/ui/getReward/img_x_3.png",
                                    "skewY": 180,
                                    "height": 487
                                },
                                "compId": 145
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": -16,
                                    "x": -4,
                                    "width": 815,
                                    "skin": "sub1/ui/getReward/img_x_3.png",
                                    "height": 487
                                },
                                "compId": 146
                            }]
                        }, {
                            "type": "Box",
                            "props": {
                                "y": 152,
                                "x": -145,
                                "width": 1612,
                                "height": 343
                            },
                            "compId": 131,
                            "child": [{
                                "type": "Image",
                                "props": {
                                    "y": 31,
                                    "x": 145,
                                    "width": 121,
                                    "skin": "sub1/ui/getReward/img_x_13.png",
                                    "height": 134,
                                    "anchorY": 0.5,
                                    "anchorX": 0.5,
                                    "alpha": 0
                                },
                                "compId": 147
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 185,
                                    "x": 145,
                                    "skin": "sub1/ui/getReward/img_x_13.png",
                                    "anchorY": 0.5,
                                    "anchorX": 0.5,
                                    "alpha": 0
                                },
                                "compId": 148
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 50,
                                    "x": 1173,
                                    "skin": "sub1/ui/getReward/img_x_13.png",
                                    "anchorY": 0.5,
                                    "anchorX": 0.5,
                                    "alpha": 0
                                },
                                "compId": 149
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 40,
                                    "x": 317,
                                    "skin": "sub1/ui/getReward/img_x_13.png",
                                    "anchorY": 0.5,
                                    "anchorX": 0.5,
                                    "alpha": 0
                                },
                                "compId": 150
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 60,
                                    "x": 597,
                                    "skin": "sub1/ui/getReward/img_x_13.png",
                                    "anchorY": 0.5,
                                    "anchorX": 0.5,
                                    "alpha": 0
                                },
                                "compId": 151
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 82,
                                    "x": 945,
                                    "skin": "sub1/ui/getReward/img_x_13.png",
                                    "anchorY": 0.5,
                                    "anchorX": 0.5,
                                    "alpha": 0
                                },
                                "compId": 152
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 40,
                                    "x": 1373,
                                    "skin": "sub1/ui/getReward/img_x_13.png",
                                    "anchorY": 0.5,
                                    "anchorX": 0.5,
                                    "alpha": 0
                                },
                                "compId": 153
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 185,
                                    "x": 1173,
                                    "skin": "sub1/ui/getReward/img_x_13.png",
                                    "anchorY": 0.5,
                                    "anchorX": 0.5,
                                    "alpha": 0
                                },
                                "compId": 154
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 204,
                                    "x": 410,
                                    "skin": "sub1/ui/getReward/img_x_13.png",
                                    "anchorY": 0.5,
                                    "anchorX": 0.5,
                                    "alpha": 0
                                },
                                "compId": 155
                            }, {
                                "type": "Script",
                                "props": {
                                    "runtime": "effect/PointEffect.ts"
                                },
                                "compId": 156
                            }]
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 117,
                                "x": 276,
                                "skin": "sub1/ui/getReward/img_x_8.png",
                                "anchorY": 0.5,
                                "anchorX": 0.5,
                                "alpha": 1
                            },
                            "compId": 132,
                            "child": [{
                                "type": "Image",
                                "props": {
                                    "y": 94,
                                    "x": -29,
                                    "skin": "sub1/ui/getReward/img_x_11.png"
                                },
                                "compId": 157
                            }]
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 279.5,
                                "x": 656.5,
                                "var": "imgGold",
                                "skin": "sub1/ui/common/img_17.png",
                                "scaleY": 0.9,
                                "scaleX": 0.9,
                                "anchorY": 0.5,
                                "anchorX": 0.5,
                                "alpha": 0
                            },
                            "compId": 6
                        }, {
                            "type": "Label",
                            "props": {
                                "y": 426,
                                "x": 656.5,
                                "width": 290,
                                "var": "btnBack",
                                "valign": "middle",
                                "text": "点击任意位置继续",
                                "height": 56,
                                "fontSize": 26,
                                "font": "SimHei",
                                "color": "#ffffff",
                                "bold": true,
                                "anchorY": 0.5,
                                "anchorX": 0.5,
                                "align": "center"
                            },
                            "compId": 22,
                            "child": [{
                                "type": "Script",
                                "props": {
                                    "runtime": "effect/ButtonEffect.ts"
                                },
                                "compId": 23
                            }]
                        }, {
                            "type": "Box",
                            "props": {
                                "y": 295,
                                "x": 656.5,
                                "width": 206,
                                "scaleY": 0.6,
                                "scaleX": 0.6,
                                "pivotY": 103,
                                "pivotX": 103,
                                "height": 206
                            },
                            "compId": 119,
                            "child": [{
                                "type": "Image",
                                "props": {
                                    "y": 0,
                                    "x": 0,
                                    "width": 206,
                                    "var": "imgBg",
                                    "skin": "sub1/ui/scale9/img_Item_bg_1.png",
                                    "sizeGrid": "17,15,17,14",
                                    "height": 206
                                },
                                "compId": 120
                            }, {
                                "type": "Image",
                                "props": {
                                    "var": "imgIcon",
                                    "skin": "sub1/item/1001.png",
                                    "scaleY": 1.9,
                                    "scaleX": 1.9,
                                    "centerY": 0,
                                    "centerX": 0
                                },
                                "compId": 121
                            }, {
                                "type": "HBox",
                                "props": {
                                    "right": 9,
                                    "bottom": 8
                                },
                                "compId": 122,
                                "child": [{
                                    "type": "Label",
                                    "props": {
                                        "x": 122,
                                        "var": "txtReward",
                                        "text": "1",
                                        "stroke": 2,
                                        "fontSize": 46,
                                        "color": "#ffffff"
                                    },
                                    "compId": 124
                                }]
                            }, {
                                "type": "Label",
                                "props": {
                                    "y": 225,
                                    "x": 0,
                                    "var": "labelName",
                                    "text": "金币",
                                    "fontSize": 32,
                                    "color": "#000000",
                                    "centerX": 0,
                                    "bold": true,
                                    "alpha": 1
                                },
                                "compId": 127
                            }]
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 495,
                                "x": 74,
                                "skin": "sub1/ui/end/img_30.png",
                                "skewY": 180
                            },
                            "compId": 158
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 113,
                                "x": 1251,
                                "skin": "sub1/ui/end/img_30.png",
                                "right": -132
                            },
                            "compId": 159
                        }]
                    }],
                    "animations": [{
                        "nodes": [],
                        "name": "ani1",
                        "id": 1,
                        "frameRate": 60,
                        "action": 0
                    }, {
                        "nodes": [],
                        "name": "ani2",
                        "id": 2,
                        "frameRate": 30,
                        "action": 0
                    }, {
                        "nodes": [],
                        "name": "ani3",
                        "id": 3,
                        "frameRate": 24,
                        "action": 0
                    }, {
                        "nodes": [{
                            "target": 81,
                            "keyframes": {
                                "alpha": [{
                                    "value": 0.5,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 81,
                                    "key": "alpha",
                                    "index": 0
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 81,
                                    "key": "alpha",
                                    "index": 90
                                }, {
                                    "value": 0.5,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 81,
                                    "key": "alpha",
                                    "index": 180
                                }]
                            }
                        }, {
                            "target": 82,
                            "keyframes": {
                                "alpha": [{
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 82,
                                    "key": "alpha",
                                    "index": 0
                                }, {
                                    "value": 0.5,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 82,
                                    "key": "alpha",
                                    "index": 90
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 82,
                                    "key": "alpha",
                                    "index": 180
                                }]
                            }
                        }, {
                            "target": 95,
                            "keyframes": {
                                "alpha": [{
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 95,
                                    "key": "alpha",
                                    "index": 0
                                }, {
                                    "value": 0.5,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 95,
                                    "key": "alpha",
                                    "index": 90
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 95,
                                    "key": "alpha",
                                    "index": 180
                                }]
                            }
                        }],
                        "name": "ani4",
                        "id": 4,
                        "frameRate": 60,
                        "action": 2
                    }],
                    "loadList": ["sub1/ui/scale9/img_getReward_bg.png", "sub1/ui/getReward/img_x_12.png", "sub1/ui/getReward/img_x_3.png", "sub1/ui/getReward/img_x_13.png", "sub1/ui/getReward/img_x_8.png", "sub1/ui/getReward/img_x_11.png", "sub1/ui/common/img_17.png", "sub1/ui/scale9/img_Item_bg_1.png", "sub1/item/1001.png", "sub1/ui/end/img_30.png"],
                    "loadList3D": []
                };
                getReward.GetGoldRewardViewUI = GetGoldRewardViewUI;
                REG("ui.view.getReward.GetGoldRewardViewUI", GetGoldRewardViewUI);
                class GetModeRewardViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/getReward/GetModeRewardView");
                    }
                }
                getReward.GetModeRewardViewUI = GetModeRewardViewUI;
                REG("ui.view.getReward.GetModeRewardViewUI", GetModeRewardViewUI);
                class GetModeRewardView2UI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/getReward/GetModeRewardView2");
                    }
                }
                getReward.GetModeRewardView2UI = GetModeRewardView2UI;
                REG("ui.view.getReward.GetModeRewardView2UI", GetModeRewardView2UI);
                class GetThreeRewardViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/getReward/GetThreeRewardView");
                    }
                }
                getReward.GetThreeRewardViewUI = GetThreeRewardViewUI;
                REG("ui.view.getReward.GetThreeRewardViewUI", GetThreeRewardViewUI);
                class ItemCellViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/getReward/ItemCellView");
                    }
                }
                getReward.ItemCellViewUI = ItemCellViewUI;
                REG("ui.view.getReward.ItemCellViewUI", ItemCellViewUI);
            })(getReward = view.getReward || (view.getReward = {}));
        })(view = ui.view || (ui.view = {}));
    })(ui || (ui = {}));
    (function(ui) {
        var view;
        (function(view) {
            var gold;
            (function(gold) {
                class AddGoldViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.createView(AddGoldViewUI.uiView);
                    }
                }
                AddGoldViewUI.uiView = {
                    "type": "View",
                    "props": {
                        "width": 1625,
                        "height": 750
                    },
                    "compId": 2,
                    "child": [{
                        "type": "Box",
                        "props": {
                            "width": 717,
                            "var": "boxAll",
                            "height": 490,
                            "centerY": -62,
                            "centerX": 0
                        },
                        "compId": 22,
                        "child": [{
                            "type": "Image",
                            "props": {
                                "y": 3,
                                "x": 37,
                                "width": 645,
                                "skin": "sub1/ui/scale9/img_new_1.png",
                                "sizeGrid": "44,18,33,22",
                                "height": 461
                            },
                            "compId": 25
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 71,
                                "width": 587,
                                "skin": "sub1/ui/scale9/img_new_2.png",
                                "sizeGrid": "10,17,16,12",
                                "height": 271,
                                "centerX": 0
                            },
                            "compId": 35
                        }, {
                            "type": "Label",
                            "props": {
                                "y": 72,
                                "width": 470,
                                "valign": "middle",
                                "text": "观看简短的视频免费获得金币！",
                                "height": 48,
                                "fontSize": 26,
                                "font": "SimHei",
                                "color": "#000000",
                                "centerX": 18,
                                "align": "center"
                            },
                            "compId": 6
                        }, {
                            "type": "Box",
                            "props": {
                                "y": 108,
                                "x": 219,
                                "width": 257,
                                "height": 217
                            },
                            "compId": 7,
                            "child": [{
                                "type": "Image",
                                "props": {
                                    "y": 105,
                                    "x": 139,
                                    "var": "imgStartGold",
                                    "skin": "sub1/ui/common/img_17.png",
                                    "anchorY": 0.5,
                                    "anchorX": 0.5
                                },
                                "compId": 8
                            }, {
                                "type": "Label",
                                "props": {
                                    "y": 171,
                                    "x": 44,
                                    "width": 180,
                                    "var": "txtGold",
                                    "valign": "middle",
                                    "text": "钻石x30",
                                    "height": 60,
                                    "fontSize": 34,
                                    "font": "SimHei",
                                    "color": "#FF5B01",
                                    "bold": true,
                                    "align": "center"
                                },
                                "compId": 9
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 81,
                                    "x": 44,
                                    "width": 45,
                                    "skin": "sub1/ui/common/img_13.png",
                                    "height": 42,
                                    "anchorY": 0.5,
                                    "anchorX": 0.5
                                },
                                "compId": 10
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 41,
                                    "x": 217,
                                    "width": 22,
                                    "skin": "sub1/ui/common/img_13.png",
                                    "height": 40,
                                    "anchorY": 0.5,
                                    "anchorX": 0.5
                                },
                                "compId": 11
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 159,
                                    "x": 212,
                                    "width": 34,
                                    "skin": "sub1/ui/common/img_13.png",
                                    "height": 47,
                                    "anchorY": 0.5,
                                    "anchorX": 0.5
                                },
                                "compId": 12
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 141,
                                    "x": 85,
                                    "width": 30,
                                    "skin": "sub1/ui/common/img_13.png",
                                    "height": 37,
                                    "anchorY": 0.5,
                                    "anchorX": 0.5
                                },
                                "compId": 13
                            }]
                        }, {
                            "type": "Box",
                            "props": {
                                "y": 42,
                                "x": 632,
                                "width": 77,
                                "var": "btnClose",
                                "height": 62,
                                "anchorY": 0.5,
                                "anchorX": 0.5
                            },
                            "compId": 19,
                            "child": [{
                                "type": "Image",
                                "props": {
                                    "y": 14,
                                    "x": 21,
                                    "skin": "sub1/ui/common/img_7.png",
                                    "centerY": 0,
                                    "centerX": 0
                                },
                                "compId": 18
                            }, {
                                "type": "Script",
                                "props": {
                                    "runtime": "effect/ButtonEffect.ts"
                                },
                                "compId": 20
                            }]
                        }, {
                            "type": "Label",
                            "props": {
                                "y": 16,
                                "width": 470,
                                "var": "labelTag",
                                "valign": "middle",
                                "text": "免费金币",
                                "height": 48,
                                "fontSize": 34,
                                "font": "SimHei",
                                "color": "#000000",
                                "centerX": 0,
                                "bold": true,
                                "align": "center"
                            },
                            "compId": 26
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 403,
                                "x": 359,
                                "width": 230,
                                "var": "btnGold",
                                "skin": "sub1/ui/scale9/img_normal_1.png",
                                "sizeGrid": "24,92,27,91",
                                "height": 91,
                                "anchorY": 0.5,
                                "anchorX": 0.5
                            },
                            "compId": 27,
                            "child": [{
                                "type": "Image",
                                "props": {
                                    "y": 30.5,
                                    "x": 56,
                                    "skin": "sub1/ui/common/img_10.png"
                                },
                                "compId": 28
                            }, {
                                "type": "Script",
                                "props": {
                                    "runtime": "effect/ButtonEffect.ts"
                                },
                                "compId": 30
                            }, {
                                "type": "Label",
                                "props": {
                                    "y": 27,
                                    "x": 106,
                                    "text": "领取",
                                    "fontSize": 32,
                                    "color": "#371301",
                                    "bold": true
                                },
                                "compId": 34
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 4,
                                    "x": -54,
                                    "width": 61,
                                    "skin": "sub1/ui/first/img_59.png",
                                    "height": 74,
                                    "blendMode": "lighter",
                                    "alpha": 0.5
                                },
                                "compId": 36
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 0,
                                    "x": 0,
                                    "width": 230,
                                    "skin": "sub1/ui/scale9/img_normal_1.png",
                                    "renderType": "mask",
                                    "height": 91,
                                    "sizeGrid": "24,92,27,91"
                                },
                                "compId": 37
                            }]
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 403,
                                "width": 230,
                                "visible": false,
                                "var": "btnNo",
                                "skin": "sub1/ui/scale9/img_normal_3.png",
                                "height": 91,
                                "centerX": 130,
                                "anchorY": 0.5,
                                "anchorX": 0.5,
                                "sizeGrid": "25,29,30,26"
                            },
                            "compId": 31,
                            "child": [{
                                "type": "Script",
                                "props": {
                                    "runtime": "effect/ButtonEffect.ts"
                                },
                                "compId": 32
                            }, {
                                "type": "Label",
                                "props": {
                                    "y": 26,
                                    "text": "不了,谢谢",
                                    "fontSize": 32,
                                    "color": "#ffffff",
                                    "centerX": 0,
                                    "bold": true
                                },
                                "compId": 33
                            }]
                        }]
                    }],
                    "animations": [{
                        "nodes": [{
                            "target": 10,
                            "keyframes": {
                                "x": [{
                                    "value": 61,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 10,
                                    "key": "x",
                                    "index": 0
                                }, {
                                    "value": 61,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 10,
                                    "label": null,
                                    "key": "x",
                                    "index": 20
                                }, {
                                    "value": 61,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 10,
                                    "label": null,
                                    "key": "x",
                                    "index": 40
                                }],
                                "scaleY": [{
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 10,
                                    "key": "scaleY",
                                    "index": 0
                                }, {
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 10,
                                    "key": "scaleY",
                                    "index": 10
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 10,
                                    "label": null,
                                    "key": "scaleY",
                                    "index": 20
                                }, {
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 10,
                                    "label": null,
                                    "key": "scaleY",
                                    "index": 30
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 10,
                                    "label": null,
                                    "key": "scaleY",
                                    "index": 40
                                }],
                                "scaleX": [{
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 10,
                                    "key": "scaleX",
                                    "index": 0
                                }, {
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 10,
                                    "key": "scaleX",
                                    "index": 10
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 10,
                                    "label": null,
                                    "key": "scaleX",
                                    "index": 20
                                }, {
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 10,
                                    "label": null,
                                    "key": "scaleX",
                                    "index": 30
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 10,
                                    "label": null,
                                    "key": "scaleX",
                                    "index": 40
                                }]
                            }
                        }, {
                            "target": 11,
                            "keyframes": {
                                "x": [{
                                    "value": 217,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 11,
                                    "key": "x",
                                    "index": 0
                                }, {
                                    "value": 217,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 11,
                                    "label": null,
                                    "key": "x",
                                    "index": 19
                                }, {
                                    "value": 217,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 11,
                                    "label": null,
                                    "key": "x",
                                    "index": 37
                                }],
                                "scaleY": [{
                                    "value": 1.8,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 11,
                                    "key": "scaleY",
                                    "index": 0
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 11,
                                    "key": "scaleY",
                                    "index": 10
                                }, {
                                    "value": 1.8,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 11,
                                    "label": null,
                                    "key": "scaleY",
                                    "index": 19
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 11,
                                    "label": null,
                                    "key": "scaleY",
                                    "index": 27
                                }, {
                                    "value": 1.8,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 11,
                                    "label": null,
                                    "key": "scaleY",
                                    "index": 37
                                }],
                                "scaleX": [{
                                    "value": 1.8,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 11,
                                    "key": "scaleX",
                                    "index": 0
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 11,
                                    "key": "scaleX",
                                    "index": 10
                                }, {
                                    "value": 1.8,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 11,
                                    "label": null,
                                    "key": "scaleX",
                                    "index": 19
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 11,
                                    "label": null,
                                    "key": "scaleX",
                                    "index": 27
                                }, {
                                    "value": 1.8,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 11,
                                    "label": null,
                                    "key": "scaleX",
                                    "index": 37
                                }]
                            }
                        }, {
                            "target": 12,
                            "keyframes": {
                                "x": [{
                                    "value": 212,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 12,
                                    "key": "x",
                                    "index": 0
                                }, {
                                    "value": 212,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 12,
                                    "key": "x",
                                    "index": 9
                                }, {
                                    "value": 212,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 12,
                                    "label": null,
                                    "key": "x",
                                    "index": 23
                                }, {
                                    "value": 212,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 12,
                                    "label": null,
                                    "key": "x",
                                    "index": 33
                                }, {
                                    "value": 212,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 12,
                                    "label": null,
                                    "key": "x",
                                    "index": 44
                                }],
                                "scaleY": [{
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 12,
                                    "key": "scaleY",
                                    "index": 0
                                }, {
                                    "value": 0.2,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 12,
                                    "key": "scaleY",
                                    "index": 9
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 12,
                                    "label": null,
                                    "key": "scaleY",
                                    "index": 23
                                }, {
                                    "value": 0.2,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 12,
                                    "label": null,
                                    "key": "scaleY",
                                    "index": 33
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 12,
                                    "label": null,
                                    "key": "scaleY",
                                    "index": 44
                                }],
                                "scaleX": [{
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 12,
                                    "key": "scaleX",
                                    "index": 0
                                }, {
                                    "value": 0.2,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 12,
                                    "key": "scaleX",
                                    "index": 9
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 12,
                                    "label": null,
                                    "key": "scaleX",
                                    "index": 23
                                }, {
                                    "value": 0.2,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 12,
                                    "label": null,
                                    "key": "scaleX",
                                    "index": 33
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 12,
                                    "label": null,
                                    "key": "scaleX",
                                    "index": 44
                                }]
                            }
                        }, {
                            "target": 13,
                            "keyframes": {
                                "x": [{
                                    "value": 85,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 13,
                                    "key": "x",
                                    "index": 0
                                }, {
                                    "value": 85,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 13,
                                    "key": "x",
                                    "index": 13
                                }, {
                                    "value": 85,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 13,
                                    "label": null,
                                    "key": "x",
                                    "index": 26
                                }, {
                                    "value": 85,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 13,
                                    "label": null,
                                    "key": "x",
                                    "index": 35
                                }, {
                                    "value": 85,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 13,
                                    "label": null,
                                    "key": "x",
                                    "index": 42
                                }],
                                "scaleY": [{
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 13,
                                    "key": "scaleY",
                                    "index": 0
                                }, {
                                    "value": 0.1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 13,
                                    "key": "scaleY",
                                    "index": 13
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 13,
                                    "label": null,
                                    "key": "scaleY",
                                    "index": 26
                                }, {
                                    "value": 0.1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 13,
                                    "label": null,
                                    "key": "scaleY",
                                    "index": 35
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 13,
                                    "label": null,
                                    "key": "scaleY",
                                    "index": 42
                                }],
                                "scaleX": [{
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 13,
                                    "key": "scaleX",
                                    "index": 0
                                }, {
                                    "value": 0.1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 13,
                                    "key": "scaleX",
                                    "index": 13
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 13,
                                    "label": null,
                                    "key": "scaleX",
                                    "index": 26
                                }, {
                                    "value": 0.1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 13,
                                    "label": null,
                                    "key": "scaleX",
                                    "index": 35
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 13,
                                    "label": null,
                                    "key": "scaleX",
                                    "index": 42
                                }]
                            }
                        }],
                        "name": "ani1",
                        "id": 1,
                        "frameRate": 24,
                        "action": 0
                    }, {
                        "nodes": [{
                            "target": 36,
                            "keyframes": {
                                "x": [{
                                    "value": -54,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 36,
                                    "key": "x",
                                    "index": 0
                                }, {
                                    "value": 230,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 36,
                                    "key": "x",
                                    "index": 40
                                }, {
                                    "value": 230,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 36,
                                    "label": null,
                                    "key": "x",
                                    "index": 60
                                }]
                            }
                        }],
                        "name": "ani2",
                        "id": 2,
                        "frameRate": 60,
                        "action": 2
                    }],
                    "loadList": ["sub1/ui/scale9/img_new_1.png", "sub1/ui/scale9/img_new_2.png", "sub1/ui/common/img_17.png", "sub1/ui/common/img_13.png", "sub1/ui/common/img_7.png", "sub1/ui/scale9/img_normal_1.png", "sub1/ui/common/img_10.png", "sub1/ui/first/img_59.png", "sub1/ui/scale9/img_normal_3.png"],
                    "loadList3D": []
                };
                gold.AddGoldViewUI = AddGoldViewUI;
                REG("ui.view.gold.AddGoldViewUI", AddGoldViewUI);
            })(gold = view.gold || (view.gold = {}));
        })(view = ui.view || (ui.view = {}));
    })(ui || (ui = {}));
    (function(ui) {
        var view;
        (function(view) {
            var guide;
            (function(guide) {
                class ApertureGuideItemUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.createView(ApertureGuideItemUI.uiView);
                    }
                }
                ApertureGuideItemUI.uiView = {
                    "type": "View",
                    "props": {
                        "width": 130,
                        "height": 130
                    },
                    "compId": 2,
                    "child": [{
                        "type": "Image",
                        "props": {
                            "y": 67,
                            "x": 67,
                            "skin": "sub1/ui/guide/img_2.png",
                            "anchorY": 0.5,
                            "anchorX": 0.5
                        },
                        "compId": 3
                    }, {
                        "type": "Image",
                        "props": {
                            "y": 67,
                            "x": 67,
                            "skin": "sub1/ui/guide/img_2.png",
                            "scaleY": 0.5,
                            "scaleX": 0.5,
                            "anchorY": 0.5,
                            "anchorX": 0.5
                        },
                        "compId": 5
                    }, {
                        "type": "Image",
                        "props": {
                            "y": 97,
                            "x": 99.5,
                            "width": 70,
                            "visible": false,
                            "var": "imgFinger",
                            "skin": "sub1/ui/guide/img_1.png",
                            "rotation": -108,
                            "height": 105
                        },
                        "compId": 6
                    }],
                    "animations": [{
                        "nodes": [{
                            "target": 5,
                            "keyframes": {
                                "x": [{
                                    "value": 67,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 5,
                                    "key": "x",
                                    "index": 0
                                }],
                                "scaleY": [{
                                    "value": 0.5,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 5,
                                    "key": "scaleY",
                                    "index": 0
                                }, {
                                    "value": 1.1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 5,
                                    "key": "scaleY",
                                    "index": 32
                                }],
                                "scaleX": [{
                                    "value": 0.5,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 5,
                                    "key": "scaleX",
                                    "index": 0
                                }, {
                                    "value": 1.1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 5,
                                    "key": "scaleX",
                                    "index": 32
                                }],
                                "alpha": [{
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 5,
                                    "key": "alpha",
                                    "index": 0
                                }, {
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 5,
                                    "key": "alpha",
                                    "index": 32
                                }]
                            }
                        }, {
                            "target": 3,
                            "keyframes": {
                                "x": [{
                                    "value": 67,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 3,
                                    "key": "x",
                                    "index": 0
                                }, {
                                    "value": 67,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 3,
                                    "key": "x",
                                    "index": 32
                                }],
                                "scaleY": [{
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 3,
                                    "key": "scaleY",
                                    "index": 0
                                }, {
                                    "value": 1.1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 3,
                                    "key": "scaleY",
                                    "index": 32
                                }],
                                "scaleX": [{
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 3,
                                    "key": "scaleX",
                                    "index": 0
                                }, {
                                    "value": 1.1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 3,
                                    "key": "scaleX",
                                    "index": 32
                                }],
                                "alpha": [{
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 3,
                                    "key": "alpha",
                                    "index": 0
                                }, {
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 3,
                                    "key": "alpha",
                                    "index": 32
                                }]
                            }
                        }, {
                            "target": 6,
                            "keyframes": {
                                "y": [{
                                    "value": 97,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 6,
                                    "key": "y",
                                    "index": 0
                                }, {
                                    "value": 65,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 6,
                                    "key": "y",
                                    "index": 20
                                }, {
                                    "value": 97,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 6,
                                    "label": null,
                                    "key": "y",
                                    "index": 42
                                }],
                                "x": [{
                                    "value": 85,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 6,
                                    "key": "x",
                                    "index": 0
                                }, {
                                    "value": 134.5,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 6,
                                    "key": "x",
                                    "index": 20
                                }, {
                                    "value": 85,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 6,
                                    "label": null,
                                    "key": "x",
                                    "index": 42
                                }]
                            }
                        }],
                        "name": "ani1",
                        "id": 1,
                        "frameRate": 60,
                        "action": 0
                    }],
                    "loadList": ["sub1/ui/guide/img_2.png", "sub1/ui/guide/img_1.png"],
                    "loadList3D": []
                };
                guide.ApertureGuideItemUI = ApertureGuideItemUI;
                REG("ui.view.guide.ApertureGuideItemUI", ApertureGuideItemUI);
                class FingerAniUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.createView(FingerAniUI.uiView);
                    }
                }
                FingerAniUI.uiView = {
                    "type": "View",
                    "props": {
                        "width": 50,
                        "height": 50
                    },
                    "compId": 2,
                    "child": [{
                        "type": "Image",
                        "props": {
                            "y": 19,
                            "x": -20,
                            "width": 70,
                            "skin": "sub1/ui/guide/img_1.png",
                            "rotation": -25,
                            "height": 105
                        },
                        "compId": 3
                    }],
                    "animations": [{
                        "nodes": [{
                            "target": 3,
                            "keyframes": {
                                "y": [{
                                    "value": 19,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 3,
                                    "key": "y",
                                    "index": 0
                                }, {
                                    "value": 67,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 3,
                                    "key": "y",
                                    "index": 23
                                }, {
                                    "value": 19,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 3,
                                    "label": null,
                                    "key": "y",
                                    "index": 45
                                }],
                                "x": [{
                                    "value": -20,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 3,
                                    "key": "x",
                                    "index": 0
                                }, {
                                    "value": 15,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 3,
                                    "key": "x",
                                    "index": 23
                                }, {
                                    "value": -20,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 3,
                                    "label": null,
                                    "key": "x",
                                    "index": 45
                                }]
                            }
                        }],
                        "name": "ani1",
                        "id": 1,
                        "frameRate": 60,
                        "action": 0
                    }],
                    "loadList": ["sub1/ui/guide/img_1.png"],
                    "loadList3D": []
                };
                guide.FingerAniUI = FingerAniUI;
                REG("ui.view.guide.FingerAniUI", FingerAniUI);
            })(guide = view.guide || (view.guide = {}));
        })(view = ui.view || (ui.view = {}));
    })(ui || (ui = {}));
    (function(ui) {
        var view;
        (function(view) {
            var library;
            (function(library) {
                class DetailViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/library/DetailView");
                    }
                }
                library.DetailViewUI = DetailViewUI;
                REG("ui.view.library.DetailViewUI", DetailViewUI);
                class LibraryArmItemUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.createView(LibraryArmItemUI.uiView);
                    }
                }
                LibraryArmItemUI.uiView = {
                    "type": "View",
                    "props": {
                        "width": 380,
                        "height": 165
                    },
                    "compId": 2,
                    "child": [{
                        "type": "Box",
                        "props": {
                            "y": 0,
                            "x": 0,
                            "width": 380,
                            "height": 165
                        },
                        "compId": 3,
                        "child": [{
                            "type": "Image",
                            "props": {
                                "var": "imgBg",
                                "skin": "sub1/ui/library/img_arm_1.png"
                            },
                            "compId": 4
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 15,
                                "x": 44,
                                "var": "imgIcon",
                                "skin": "sub1/equip/arm/10.png"
                            },
                            "compId": 5
                        }, {
                            "type": "Label",
                            "props": {
                                "y": 134,
                                "x": 11,
                                "width": 118,
                                "var": "txtName",
                                "valign": "middle",
                                "text": "label",
                                "height": 30,
                                "fontSize": 22,
                                "font": "SimHei",
                                "color": "#FFFFFF",
                                "align": "left"
                            },
                            "compId": 6
                        }, {
                            "type": "Box",
                            "props": {
                                "y": 0,
                                "x": 0,
                                "width": 379,
                                "var": "btnDetails",
                                "height": 165
                            },
                            "compId": 14
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 140,
                                "x": 318,
                                "var": "btnEquip",
                                "skin": "sub1/ui/scale9/img_library_6.png",
                                "anchorY": 0.5,
                                "anchorX": 0.5
                            },
                            "compId": 7,
                            "child": [{
                                "type": "Image",
                                "props": {
                                    "y": 11.5,
                                    "x": 36,
                                    "skin": "sub1/ui/library/img_4.png"
                                },
                                "compId": 8
                            }, {
                                "type": "Script",
                                "props": {
                                    "runtime": "effect/ButtonEffect.ts"
                                },
                                "compId": 9
                            }]
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 140,
                                "x": 318,
                                "var": "btnRemove",
                                "skin": "sub1/ui/scale9/img_library_7.png",
                                "anchorY": 0.5,
                                "anchorX": 0.5
                            },
                            "compId": 10,
                            "child": [{
                                "type": "Image",
                                "props": {
                                    "y": 11.5,
                                    "x": 36,
                                    "skin": "sub1/ui/library/img_2.png"
                                },
                                "compId": 11
                            }, {
                                "type": "Script",
                                "props": {
                                    "runtime": "effect/ButtonEffect.ts"
                                },
                                "compId": 12
                            }]
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 9,
                                "x": 297,
                                "var": "imgEquiped",
                                "skin": "sub1/ui/library/img_3.png"
                            },
                            "compId": 13
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 15,
                                "x": 16,
                                "var": "imgGrade",
                                "skin": "sub1/ui/library/img_grade_1.png"
                            },
                            "compId": 15
                        }]
                    }],
                    "loadList": ["sub1/ui/library/img_arm_1.png", "sub1/equip/arm/10.png", "sub1/ui/scale9/img_library_6.png", "sub1/ui/library/img_4.png", "sub1/ui/scale9/img_library_7.png", "sub1/ui/library/img_2.png", "sub1/ui/library/img_3.png", "sub1/ui/library/img_grade_1.png"],
                    "loadList3D": []
                };
                library.LibraryArmItemUI = LibraryArmItemUI;
                REG("ui.view.library.LibraryArmItemUI", LibraryArmItemUI);
                class LibraryPartsItemUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/library/LibraryPartsItem");
                    }
                }
                library.LibraryPartsItemUI = LibraryPartsItemUI;
                REG("ui.view.library.LibraryPartsItemUI", LibraryPartsItemUI);
                class LibraryPropertybarItemUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.createView(LibraryPropertybarItemUI.uiView);
                    }
                }
                LibraryPropertybarItemUI.uiView = {
                    "type": "View",
                    "props": {
                        "width": 170,
                        "height": 44
                    },
                    "compId": 2,
                    "child": [{
                        "type": "Box",
                        "props": {
                            "y": 0,
                            "x": 0,
                            "width": 303,
                            "height": 44
                        },
                        "compId": 3,
                        "child": [{
                            "type": "Label",
                            "props": {
                                "y": -1,
                                "x": 0,
                                "width": 134,
                                "var": "txtAttribute",
                                "valign": "middle",
                                "text": "火力",
                                "height": 26,
                                "fontSize": 22,
                                "font": "SimHei",
                                "color": "#FFFFFF",
                                "bold": true,
                                "align": "left"
                            },
                            "compId": 4
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 30,
                                "x": 0,
                                "width": 167,
                                "skin": "sub1/ui/scale9/img_43.png",
                                "height": 11,
                                "sizeGrid": "4,4,5,3"
                            },
                            "compId": 7
                        }, {
                            "type": "Label",
                            "props": {
                                "y": 4,
                                "x": 134,
                                "width": 113,
                                "var": "txtPro",
                                "valign": "middle",
                                "text": "100",
                                "height": 18,
                                "fontSize": 22,
                                "font": "SimHei",
                                "color": "#7AD2FF",
                                "bold": true,
                                "align": "left"
                            },
                            "compId": 5
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 30,
                                "x": 1,
                                "width": 166,
                                "var": "imgPro",
                                "skin": "sub1/ui/scale9/img_44.png",
                                "height": 11,
                                "sizeGrid": "3,4,5,5"
                            },
                            "compId": 6
                        }]
                    }],
                    "loadList": ["sub1/ui/scale9/img_43.png", "sub1/ui/scale9/img_44.png"],
                    "loadList3D": []
                };
                library.LibraryPropertybarItemUI = LibraryPropertybarItemUI;
                REG("ui.view.library.LibraryPropertybarItemUI", LibraryPropertybarItemUI);
                class LibraryRoleItemUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.createView(LibraryRoleItemUI.uiView);
                    }
                }
                LibraryRoleItemUI.uiView = {
                    "type": "View",
                    "props": {
                        "width": 224,
                        "height": 225
                    },
                    "compId": 2,
                    "child": [{
                        "type": "Box",
                        "props": {
                            "y": 0,
                            "x": 0,
                            "width": 224,
                            "height": 225
                        },
                        "compId": 3,
                        "child": [{
                            "type": "Image",
                            "props": {
                                "y": 1,
                                "x": 2,
                                "width": 221,
                                "var": "imgSelect",
                                "skin": "sub1/ui/scale9/img_library_15.png",
                                "sizeGrid": "8,12,8,10",
                                "height": 224
                            },
                            "compId": 5
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 3.5,
                                "x": 4,
                                "var": "imgGradeBg",
                                "skin": "sub1/ui/library/img_14.png"
                            },
                            "compId": 4
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 13.5,
                                "x": 7,
                                "var": "imgIcon",
                                "skin": "sub1/role/001.png"
                            },
                            "compId": 7
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 169,
                                "x": 5,
                                "width": 213,
                                "var": "imgGradeBottom",
                                "skin": "sub1/ui/library/img_11.png",
                                "height": 51,
                                "sizeGrid": "28,11,10,101"
                            },
                            "compId": 9
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 191.5,
                                "x": 13.5,
                                "var": "imgGrade",
                                "skin": "sub1/ui/library/img_grade_1.png"
                            },
                            "compId": 49
                        }, {
                            "type": "Box",
                            "props": {
                                "y": 196,
                                "x": 156,
                                "width": 116,
                                "var": "btnUse",
                                "height": 47,
                                "anchorY": 0.5,
                                "anchorX": 0.5
                            },
                            "compId": 10,
                            "child": [{
                                "type": "Image",
                                "props": {
                                    "y": 0,
                                    "x": 1,
                                    "skin": "sub1/ui/scale9/img_library_14.png"
                                },
                                "compId": 11
                            }, {
                                "type": "Label",
                                "props": {
                                    "y": 6,
                                    "x": 7.5,
                                    "width": 103,
                                    "valign": "middle",
                                    "text": "使用",
                                    "height": 33,
                                    "fontSize": 22,
                                    "font": "SimHei",
                                    "color": "#000000",
                                    "bold": true,
                                    "align": "center"
                                },
                                "compId": 12
                            }, {
                                "type": "Script",
                                "props": {
                                    "runtime": "effect/ButtonEffect.ts"
                                },
                                "compId": 13
                            }]
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 7.5,
                                "x": 140,
                                "var": "imgUsing",
                                "skin": "sub1/ui/library/img_13.png"
                            },
                            "compId": 18
                        }, {
                            "type": "Box",
                            "props": {
                                "y": 196,
                                "x": 156,
                                "width": 116,
                                "var": "btnBuy",
                                "height": 47,
                                "anchorY": 0.5,
                                "anchorX": 0.5
                            },
                            "compId": 19,
                            "child": [{
                                "type": "Image",
                                "props": {
                                    "y": 0,
                                    "x": 1,
                                    "width": 114,
                                    "skin": "sub1/ui/scale9/img_normal_1.png",
                                    "height": 47,
                                    "sizeGrid": "24,92,27,91"
                                },
                                "compId": 20
                            }, {
                                "type": "Label",
                                "props": {
                                    "y": 6,
                                    "x": 7.5,
                                    "width": 103,
                                    "valign": "middle",
                                    "text": "购买",
                                    "height": 33,
                                    "fontSize": 22,
                                    "font": "SimHei",
                                    "color": "#000000",
                                    "bold": true,
                                    "align": "center"
                                },
                                "compId": 21
                            }, {
                                "type": "Script",
                                "props": {
                                    "runtime": "effect/ButtonEffect.ts"
                                },
                                "compId": 22
                            }]
                        }, {
                            "type": "Box",
                            "props": {
                                "y": 196,
                                "x": 156,
                                "width": 116,
                                "visible": false,
                                "var": "btnAd",
                                "height": 47,
                                "anchorY": 0.5,
                                "anchorX": 0.5
                            },
                            "compId": 50,
                            "child": [{
                                "type": "Image",
                                "props": {
                                    "y": 0,
                                    "x": 1,
                                    "width": 114,
                                    "skin": "sub1/ui/scale9/img_normal_1.png",
                                    "height": 47,
                                    "sizeGrid": "24,92,27,91"
                                },
                                "compId": 51
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 14,
                                    "x": 14,
                                    "width": 21,
                                    "skin": "sub1/ui/common/img_10.png",
                                    "height": 19
                                },
                                "compId": 54
                            }, {
                                "type": "Label",
                                "props": {
                                    "y": 7,
                                    "x": 35,
                                    "width": 79,
                                    "valign": "middle",
                                    "text": "碎片X1",
                                    "height": 33,
                                    "fontSize": 22,
                                    "font": "SimHei",
                                    "color": "#000000",
                                    "bold": true,
                                    "align": "center"
                                },
                                "compId": 52
                            }, {
                                "type": "Script",
                                "props": {
                                    "runtime": "effect/ButtonEffect.ts"
                                },
                                "compId": 53
                            }]
                        }, {
                            "type": "Box",
                            "props": {
                                "y": 9,
                                "x": 103,
                                "width": 111,
                                "var": "boxCost",
                                "height": 32
                            },
                            "compId": 23,
                            "child": [{
                                "type": "Image",
                                "props": {
                                    "y": 4,
                                    "x": 23.5,
                                    "var": "img_costType",
                                    "skin": "sub1/ui/common/img_3.png",
                                    "scaleY": 0.5,
                                    "scaleX": 0.5
                                },
                                "compId": 24
                            }, {
                                "type": "Label",
                                "props": {
                                    "y": 4,
                                    "x": 42,
                                    "width": 75,
                                    "var": "txtCost",
                                    "text": "10000",
                                    "height": 21,
                                    "fontSize": 20,
                                    "font": "SimHei",
                                    "color": "#50FF21"
                                },
                                "compId": 25
                            }]
                        }, {
                            "type": "Label",
                            "props": {
                                "y": 12,
                                "x": 13.5,
                                "width": 96,
                                "var": "txtName",
                                "valign": "middle",
                                "text": "label",
                                "height": 28,
                                "fontSize": 22,
                                "font": "SimHei",
                                "color": "#FFFFFF",
                                "align": "left"
                            },
                            "compId": 26
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 45,
                                "x": 2,
                                "visible": false,
                                "var": "img_NewYearTag",
                                "skin": "sub1/ui/library/img_15.png"
                            },
                            "compId": 45
                        }, {
                            "type": "HBox",
                            "props": {
                                "y": 12,
                                "visible": false,
                                "var": "boxDebris",
                                "right": 10,
                                "height": 31
                            },
                            "compId": 56,
                            "child": [{
                                "type": "Image",
                                "props": {
                                    "y": 0,
                                    "x": 0,
                                    "var": "imgDebris",
                                    "skin": "sub1/ui/getReward/img_debris_1.png"
                                },
                                "compId": 55
                            }, {
                                "type": "Label",
                                "props": {
                                    "text": "(",
                                    "fontSize": 20,
                                    "color": "#ffffff"
                                },
                                "compId": 57
                            }, {
                                "type": "Label",
                                "props": {
                                    "y": 0,
                                    "x": 0,
                                    "var": "labelDebris",
                                    "text": "0",
                                    "fontSize": 20,
                                    "color": "#ff0400"
                                },
                                "compId": 58
                            }, {
                                "type": "Label",
                                "props": {
                                    "y": 0,
                                    "x": 0,
                                    "var": "labelDebrisAll",
                                    "text": "/10)",
                                    "fontSize": 20,
                                    "color": "#ffffff"
                                },
                                "compId": 59
                            }]
                        }]
                    }],
                    "loadList": ["sub1/ui/scale9/img_library_15.png", "sub1/ui/library/img_14.png", "sub1/role/001.png", "sub1/ui/library/img_11.png", "sub1/ui/library/img_grade_1.png", "sub1/ui/scale9/img_library_14.png", "sub1/ui/library/img_13.png", "sub1/ui/scale9/img_normal_1.png", "sub1/ui/common/img_10.png", "sub1/ui/common/img_3.png", "sub1/ui/library/img_15.png", "sub1/ui/getReward/img_debris_1.png"],
                    "loadList3D": []
                };
                library.LibraryRoleItemUI = LibraryRoleItemUI;
                REG("ui.view.library.LibraryRoleItemUI", LibraryRoleItemUI);
                class LibraryViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/library/LibraryView");
                    }
                }
                library.LibraryViewUI = LibraryViewUI;
                REG("ui.view.library.LibraryViewUI", LibraryViewUI);
            })(library = view.library || (view.library = {}));
        })(view = ui.view || (ui.view = {}));
    })(ui || (ui = {}));
    (function(ui) {
        var view;
        (function(view) {
            var load;
            (function(load) {
                class LoadingFightViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/load/LoadingFightView");
                    }
                }
                load.LoadingFightViewUI = LoadingFightViewUI;
                REG("ui.view.load.LoadingFightViewUI", LoadingFightViewUI);
                class LoadingMaskViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/load/LoadingMaskView");
                    }
                }
                load.LoadingMaskViewUI = LoadingMaskViewUI;
                REG("ui.view.load.LoadingMaskViewUI", LoadingMaskViewUI);
                class LoadingViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.createView(LoadingViewUI.uiView);
                    }
                }
                LoadingViewUI.uiView = {
                    "type": "View",
                    "props": {
                        "width": 1625,
                        "height": 750
                    },
                    "compId": 2,
                    "child": [{
                        "type": "Image",
                        "props": {
                            "top": 0,
                            "skin": "loading/img_12.jpg",
                            "right": 0,
                            "left": 1,
                            "bottom": 0
                        },
                        "compId": 4
                    }, {
                        "type": "Box",
                        "props": {
                            "width": 914,
                            "var": "boxLoading",
                            "scaleY": 1,
                            "scaleX": 1,
                            "height": 588,
                            "centerY": -29,
                            "centerX": 0
                        },
                        "compId": 6,
                        "child": [{
                            "type": "Image",
                            "props": {
                                "y": 122,
                                "x": 153,
                                "var": "imgLoading",
                                "skin": "loading/img_3.png"
                            },
                            "compId": 5
                        }]
                    }, {
                        "type": "Image",
                        "props": {
                            "y": 37,
                            "width": 72,
                            "skin": "loading/img_cadpa.png",
                            "right": 37,
                            "height": 92
                        },
                        "compId": 13
                    }, {
                        "type": "Image",
                        "props": {
                            "y": 257,
                            "x": 1105,
                            "width": 389,
                            "var": "imgRole1",
                            "skin": "loading/img_14.png",
                            "right": 131,
                            "height": 493
                        },
                        "compId": 14
                    }, {
                        "type": "Image",
                        "props": {
                            "y": 25,
                            "x": 156,
                            "width": 378,
                            "var": "imgRole2",
                            "skin": "loading/img_15.png",
                            "height": 727
                        },
                        "compId": 15
                    }, {
                        "type": "Image",
                        "props": {
                            "width": 1094,
                            "skin": "loading/img_5.png",
                            "sizeGrid": "8,15,9,11",
                            "height": 12,
                            "centerX": 0,
                            "bottom": 74
                        },
                        "compId": 8,
                        "child": [{
                            "type": "Image",
                            "props": {
                                "y": 1,
                                "x": 1,
                                "width": 1091,
                                "var": "imgPro",
                                "skin": "loading/img_2.png",
                                "sizeGrid": "13,32,15,17",
                                "height": 10
                            },
                            "compId": 9
                        }]
                    }, {
                        "type": "Label",
                        "props": {
                            "x": 459,
                            "width": 708,
                            "var": "txtPercent",
                            "valign": "middle",
                            "text": "玩命加载中，请耐心等待...(78%) ",
                            "height": 55,
                            "fontSize": 26,
                            "color": "#ffffff",
                            "centerX": 0,
                            "bottom": 21,
                            "align": "center"
                        },
                        "compId": 3
                    }, {
                        "type": "Label",
                        "props": {
                            "y": 630,
                            "x": 236,
                            "text": "抵制不良游戏，拒绝盗版游戏。  注意自我保护，谨防受骗上当。  适度游戏益脑，沉迷游戏伤身。  合理安排时间，享受健康生活。",
                            "fontSize": 20,
                            "color": "#ffffff",
                            "centerX": 0,
                            "bottom": 100
                        },
                        "compId": 12
                    }],
                    "loadList": ["loading/img_12.jpg", "loading/img_3.png", "loading/img_cadpa.png", "loading/img_14.png", "loading/img_15.png", "loading/img_5.png", "loading/img_2.png"],
                    "loadList3D": []
                };
                load.LoadingViewUI = LoadingViewUI;
                REG("ui.view.load.LoadingViewUI", LoadingViewUI);
            })(load = view.load || (view.load = {}));
        })(view = ui.view || (ui.view = {}));
    })(ui || (ui = {}));
    (function(ui) {
        var view;
        (function(view) {
            var matching;
            (function(matching) {
                class MatchingViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.createView(MatchingViewUI.uiView);
                    }
                }
                MatchingViewUI.uiView = {
                    "type": "View",
                    "props": {
                        "width": 1625,
                        "mouseEnabled": true,
                        "height": 750
                    },
                    "compId": 2,
                    "child": [{
                        "type": "Image",
                        "props": {
                            "top": 0,
                            "skin": "sub1/ui/loading/img_11.jpg",
                            "right": 0,
                            "mouseEnabled": true,
                            "left": 0,
                            "bottom": 0
                        },
                        "compId": 3
                    }, {
                        "type": "Box",
                        "props": {
                            "width": 914,
                            "var": "boxLoading",
                            "scaleY": 1,
                            "scaleX": 1,
                            "height": 588,
                            "centerY": 11,
                            "centerX": 0
                        },
                        "compId": 86,
                        "child": [{
                            "type": "Image",
                            "props": {
                                "y": -13,
                                "skin": "sub1/ui/loading/img_loading_bg.png",
                                "centerX": 0
                            },
                            "compId": 94
                        }, {
                            "type": "Label",
                            "props": {
                                "y": 418,
                                "x": 103,
                                "width": 708,
                                "var": "txtPercent",
                                "valign": "middle",
                                "text": "玩命加载中，请耐心等待...(78%) ",
                                "height": 55,
                                "fontSize": 25,
                                "color": "#000000",
                                "centerY": 151,
                                "centerX": 0,
                                "alpha": 0,
                                "align": "center"
                            },
                            "compId": 89
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 504,
                                "width": 395,
                                "skin": "sub1/ui/scale9/img_load_2.png",
                                "sizeGrid": "0,4,0,4",
                                "height": 21,
                                "centerX": -12
                            },
                            "compId": 90,
                            "child": [{
                                "type": "Image",
                                "props": {
                                    "y": 1,
                                    "x": 2,
                                    "width": 391,
                                    "var": "imgPro",
                                    "skin": "sub1/ui/scale9/img_load_1.png",
                                    "sizeGrid": "7,6,6,5",
                                    "height": 19
                                },
                                "compId": 91
                            }]
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 559,
                                "skin": "sub1/ui/loading/img_9.png",
                                "centerX": 0
                            },
                            "compId": 129
                        }, {
                            "type": "Label",
                            "props": {
                                "y": 548.5,
                                "width": 976,
                                "var": "txtContent",
                                "valign": "middle",
                                "text": "小提示：率先获得60分队伍获胜",
                                "height": 79,
                                "fontSize": 26,
                                "font": "SimHei",
                                "color": "#FFFFFF",
                                "centerX": 0,
                                "align": "center"
                            },
                            "compId": 27
                        }, {
                            "type": "Label",
                            "props": {
                                "y": 423,
                                "width": 976,
                                "var": "labelLog",
                                "valign": "middle",
                                "text": "正在进入战斗...",
                                "height": 79,
                                "fontSize": 40,
                                "font": "SimHei",
                                "color": "#FFFFFF",
                                "centerX": 0,
                                "align": "center"
                            },
                            "compId": 93
                        }]
                    }],
                    "animations": [{
                        "nodes": [{
                            "target": 42,
                            "keyframes": {
                                "y": [{
                                    "value": -14,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 42,
                                    "key": "y",
                                    "index": 0
                                }, {
                                    "value": -14,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 42,
                                    "key": "y",
                                    "index": 180
                                }, {
                                    "value": -14,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 42,
                                    "label": null,
                                    "key": "y",
                                    "index": 225
                                }],
                                "x": [{
                                    "value": -177,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 42,
                                    "key": "x",
                                    "index": 0
                                }, {
                                    "value": 451,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 42,
                                    "key": "x",
                                    "index": 180
                                }, {
                                    "value": 451,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 42,
                                    "label": null,
                                    "key": "x",
                                    "index": 225
                                }]
                            }
                        }],
                        "name": "ani1",
                        "id": 1,
                        "frameRate": 60,
                        "action": 0
                    }, {
                        "nodes": [{
                            "target": 43,
                            "keyframes": {
                                "y": [{
                                    "value": 130,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 43,
                                    "key": "y",
                                    "index": 0
                                }, {
                                    "value": -100,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 43,
                                    "key": "y",
                                    "index": 61
                                }],
                                "x": [{
                                    "value": 72,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 43,
                                    "key": "x",
                                    "index": 0
                                }],
                                "rotation": [{
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 43,
                                    "key": "rotation",
                                    "index": 0
                                }, {
                                    "value": 360,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 43,
                                    "key": "rotation",
                                    "index": 61
                                }]
                            }
                        }, {
                            "target": 57,
                            "keyframes": {
                                "y": [{
                                    "value": 198,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 57,
                                    "key": "y",
                                    "index": 0
                                }, {
                                    "value": -120,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 57,
                                    "key": "y",
                                    "index": 70
                                }],
                                "x": [{
                                    "value": 133,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 57,
                                    "key": "x",
                                    "index": 0
                                }, {
                                    "value": 133,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 57,
                                    "key": "x",
                                    "index": 70
                                }],
                                "rotation": [{
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 57,
                                    "key": "rotation",
                                    "index": 0
                                }, {
                                    "value": 360,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 57,
                                    "key": "rotation",
                                    "index": 70
                                }]
                            }
                        }, {
                            "target": 58,
                            "keyframes": {
                                "y": [{
                                    "value": 149,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 58,
                                    "key": "y",
                                    "index": 0
                                }, {
                                    "value": 149,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 58,
                                    "label": null,
                                    "key": "y",
                                    "index": 29
                                }, {
                                    "value": -100,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 58,
                                    "key": "y",
                                    "index": 106
                                }],
                                "x": [{
                                    "value": 202,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 58,
                                    "key": "x",
                                    "index": 0
                                }, {
                                    "value": 202,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 58,
                                    "label": null,
                                    "key": "x",
                                    "index": 29
                                }, {
                                    "value": 202,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 58,
                                    "key": "x",
                                    "index": 106
                                }],
                                "rotation": [{
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 58,
                                    "key": "rotation",
                                    "index": 0
                                }, {
                                    "value": 360,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 58,
                                    "key": "rotation",
                                    "index": 106
                                }]
                            }
                        }, {
                            "target": 60,
                            "keyframes": {
                                "y": [{
                                    "value": 130,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 60,
                                    "key": "y",
                                    "index": 0
                                }, {
                                    "value": 130,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 60,
                                    "label": null,
                                    "key": "y",
                                    "index": 4
                                }, {
                                    "value": -110,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 60,
                                    "key": "y",
                                    "index": 81
                                }],
                                "x": [{
                                    "value": 316,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 60,
                                    "key": "x",
                                    "index": 0
                                }, {
                                    "value": 316,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 60,
                                    "label": null,
                                    "key": "x",
                                    "index": 4
                                }, {
                                    "value": 316,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 60,
                                    "key": "x",
                                    "index": 81
                                }],
                                "rotation": [{
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 60,
                                    "key": "rotation",
                                    "index": 0
                                }, {
                                    "value": 360,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 60,
                                    "key": "rotation",
                                    "index": 81
                                }]
                            }
                        }, {
                            "target": 61,
                            "keyframes": {
                                "y": [{
                                    "value": 208,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 61,
                                    "key": "y",
                                    "index": 0
                                }, {
                                    "value": 208,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 61,
                                    "label": null,
                                    "key": "y",
                                    "index": 4
                                }, {
                                    "value": -120,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 61,
                                    "key": "y",
                                    "index": 89
                                }],
                                "x": [{
                                    "value": 269,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 61,
                                    "key": "x",
                                    "index": 0
                                }, {
                                    "value": 269,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 61,
                                    "label": null,
                                    "key": "x",
                                    "index": 4
                                }, {
                                    "value": 269,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 61,
                                    "key": "x",
                                    "index": 89
                                }],
                                "rotation": [{
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 61,
                                    "key": "rotation",
                                    "index": 0
                                }, {
                                    "value": 360,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 61,
                                    "key": "rotation",
                                    "index": 89
                                }]
                            }
                        }, {
                            "target": 62,
                            "keyframes": {
                                "y": [{
                                    "value": 149,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 62,
                                    "key": "y",
                                    "index": 0
                                }, {
                                    "value": 149,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 62,
                                    "label": null,
                                    "key": "y",
                                    "index": 18
                                }, {
                                    "value": -100,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 62,
                                    "key": "y",
                                    "index": 119
                                }],
                                "x": [{
                                    "value": 438,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 62,
                                    "key": "x",
                                    "index": 0
                                }, {
                                    "value": 438,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 62,
                                    "label": null,
                                    "key": "x",
                                    "index": 18
                                }, {
                                    "value": 438,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 62,
                                    "key": "x",
                                    "index": 119
                                }],
                                "rotation": [{
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 62,
                                    "key": "rotation",
                                    "index": 0
                                }, {
                                    "value": 360,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 62,
                                    "key": "rotation",
                                    "index": 119
                                }]
                            }
                        }],
                        "name": "ani3",
                        "id": 3,
                        "frameRate": 24,
                        "action": 0
                    }, {
                        "nodes": [{
                            "target": 63,
                            "keyframes": {
                                "y": [{
                                    "value": 196,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 63,
                                    "key": "y",
                                    "index": 0
                                }, {
                                    "value": -100,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 63,
                                    "key": "y",
                                    "index": 73
                                }],
                                "x": [{
                                    "value": 52,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 63,
                                    "key": "x",
                                    "index": 0
                                }, {
                                    "value": 52,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 63,
                                    "key": "x",
                                    "index": 73
                                }],
                                "rotation": [{
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 63,
                                    "key": "rotation",
                                    "index": 0
                                }, {
                                    "value": 360,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 63,
                                    "key": "rotation",
                                    "index": 73
                                }]
                            }
                        }, {
                            "target": 64,
                            "keyframes": {
                                "y": [{
                                    "value": 138,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 64,
                                    "key": "y",
                                    "index": 0
                                }, {
                                    "value": 138,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 64,
                                    "label": null,
                                    "key": "y",
                                    "index": 10
                                }, {
                                    "value": -100,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 64,
                                    "key": "y",
                                    "index": 100
                                }],
                                "x": [{
                                    "value": 115,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 64,
                                    "key": "x",
                                    "index": 0
                                }, {
                                    "value": 115,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 64,
                                    "label": null,
                                    "key": "x",
                                    "index": 10
                                }, {
                                    "value": 115,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 64,
                                    "key": "x",
                                    "index": 100
                                }],
                                "rotation": [{
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 64,
                                    "key": "rotation",
                                    "index": 0
                                }, {
                                    "value": 360,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 64,
                                    "key": "rotation",
                                    "index": 100
                                }]
                            }
                        }, {
                            "target": 65,
                            "keyframes": {
                                "y": [{
                                    "value": 235,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 65,
                                    "key": "y",
                                    "index": 0
                                }, {
                                    "value": 235,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 65,
                                    "label": null,
                                    "key": "y",
                                    "index": 22
                                }, {
                                    "value": -100,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 65,
                                    "key": "y",
                                    "index": 92
                                }],
                                "x": [{
                                    "value": 178,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 65,
                                    "key": "x",
                                    "index": 0
                                }, {
                                    "value": 178,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 65,
                                    "label": null,
                                    "key": "x",
                                    "index": 22
                                }, {
                                    "value": 178,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 65,
                                    "key": "x",
                                    "index": 92
                                }],
                                "rotation": [{
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 65,
                                    "key": "rotation",
                                    "index": 0
                                }, {
                                    "value": 360,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 65,
                                    "key": "rotation",
                                    "index": 92
                                }]
                            }
                        }, {
                            "target": 66,
                            "keyframes": {
                                "y": [{
                                    "value": 157,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 66,
                                    "key": "y",
                                    "index": 0
                                }, {
                                    "value": 157,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 66,
                                    "label": null,
                                    "key": "y",
                                    "index": 20
                                }, {
                                    "value": -100,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 66,
                                    "key": "y",
                                    "index": 106
                                }],
                                "x": [{
                                    "value": 316,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 66,
                                    "key": "x",
                                    "index": 0
                                }, {
                                    "value": 316,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 66,
                                    "label": null,
                                    "key": "x",
                                    "index": 20
                                }, {
                                    "value": 316,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 66,
                                    "key": "x",
                                    "index": 106
                                }],
                                "rotation": [{
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 66,
                                    "key": "rotation",
                                    "index": 0
                                }, {
                                    "value": 360,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 66,
                                    "key": "rotation",
                                    "index": 106
                                }]
                            }
                        }, {
                            "target": 67,
                            "keyframes": {
                                "y": [{
                                    "value": 275,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 67,
                                    "key": "y",
                                    "index": 0
                                }, {
                                    "value": 275,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 67,
                                    "label": null,
                                    "key": "y",
                                    "index": 33
                                }, {
                                    "value": -100,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 67,
                                    "key": "y",
                                    "index": 89
                                }],
                                "x": [{
                                    "value": 258,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 67,
                                    "key": "x",
                                    "index": 0
                                }, {
                                    "value": 258,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 67,
                                    "label": null,
                                    "key": "x",
                                    "index": 33
                                }, {
                                    "value": 258,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 67,
                                    "key": "x",
                                    "index": 89
                                }],
                                "rotation": [{
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 67,
                                    "key": "rotation",
                                    "index": 0
                                }, {
                                    "value": 360,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 67,
                                    "key": "rotation",
                                    "index": 89
                                }]
                            }
                        }, {
                            "target": 68,
                            "keyframes": {
                                "y": [{
                                    "value": 207,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 68,
                                    "key": "y",
                                    "index": 0
                                }, {
                                    "value": 207,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 68,
                                    "label": null,
                                    "key": "y",
                                    "index": 23
                                }, {
                                    "value": -100,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 68,
                                    "key": "y",
                                    "index": 117
                                }],
                                "x": [{
                                    "value": 404,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 68,
                                    "key": "x",
                                    "index": 0
                                }, {
                                    "value": 404,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 68,
                                    "label": null,
                                    "key": "x",
                                    "index": 23
                                }, {
                                    "value": 404,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 68,
                                    "key": "x",
                                    "index": 117
                                }],
                                "rotation": [{
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 68,
                                    "key": "rotation",
                                    "index": 0
                                }, {
                                    "value": 360,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 68,
                                    "key": "rotation",
                                    "index": 117
                                }]
                            }
                        }],
                        "name": "ani4",
                        "id": 4,
                        "frameRate": 24,
                        "action": 0
                    }, {
                        "nodes": [{
                            "target": 32,
                            "keyframes": {
                                "y": [{
                                    "value": 26,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 32,
                                    "key": "y",
                                    "index": 0
                                }, {
                                    "value": 19,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 32,
                                    "key": "y",
                                    "index": 5
                                }, {
                                    "value": 26,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 32,
                                    "label": null,
                                    "key": "y",
                                    "index": 10
                                }, {
                                    "value": 26,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 32,
                                    "label": null,
                                    "key": "y",
                                    "index": 15
                                }, {
                                    "value": 26,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 32,
                                    "label": null,
                                    "key": "y",
                                    "index": 20
                                }, {
                                    "value": 26,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 32,
                                    "label": null,
                                    "key": "y",
                                    "index": 85
                                }],
                                "x": [{
                                    "value": 121,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 32,
                                    "key": "x",
                                    "index": 0
                                }, {
                                    "value": 121,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 32,
                                    "label": null,
                                    "key": "x",
                                    "index": 10
                                }, {
                                    "value": 121,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 32,
                                    "label": null,
                                    "key": "x",
                                    "index": 15
                                }, {
                                    "value": 121,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 32,
                                    "label": null,
                                    "key": "x",
                                    "index": 20
                                }, {
                                    "value": 121,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 32,
                                    "label": null,
                                    "key": "x",
                                    "index": 85
                                }]
                            }
                        }, {
                            "target": 35,
                            "keyframes": {
                                "y": [{
                                    "value": 26,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 35,
                                    "key": "y",
                                    "index": 0
                                }, {
                                    "value": 19,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 35,
                                    "key": "y",
                                    "index": 10
                                }, {
                                    "value": 26,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 35,
                                    "key": "y",
                                    "index": 15
                                }, {
                                    "value": 26,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 35,
                                    "label": null,
                                    "key": "y",
                                    "index": 20
                                }, {
                                    "value": 26,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 35,
                                    "label": null,
                                    "key": "y",
                                    "index": 85
                                }],
                                "x": [{
                                    "value": 135,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 35,
                                    "key": "x",
                                    "index": 0
                                }, {
                                    "value": 135,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 35,
                                    "label": null,
                                    "key": "x",
                                    "index": 5
                                }, {
                                    "value": 135,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 35,
                                    "label": null,
                                    "key": "x",
                                    "index": 15
                                }, {
                                    "value": 135,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 35,
                                    "label": null,
                                    "key": "x",
                                    "index": 20
                                }, {
                                    "value": 135,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 35,
                                    "label": null,
                                    "key": "x",
                                    "index": 85
                                }]
                            }
                        }, {
                            "target": 36,
                            "keyframes": {
                                "y": [{
                                    "value": 26,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 36,
                                    "key": "y",
                                    "index": 0
                                }, {
                                    "value": 19,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 36,
                                    "key": "y",
                                    "index": 15
                                }, {
                                    "value": 26,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 36,
                                    "label": null,
                                    "key": "y",
                                    "index": 20
                                }, {
                                    "value": 26,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 36,
                                    "label": null,
                                    "key": "y",
                                    "index": 85
                                }],
                                "x": [{
                                    "value": 149,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 36,
                                    "key": "x",
                                    "index": 0
                                }, {
                                    "value": 149,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 36,
                                    "label": null,
                                    "key": "x",
                                    "index": 5
                                }, {
                                    "value": 149,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 36,
                                    "label": null,
                                    "key": "x",
                                    "index": 10
                                }]
                            }
                        }],
                        "name": "ani2",
                        "id": 5,
                        "frameRate": 60,
                        "action": 0
                    }],
                    "loadList": ["sub1/ui/loading/img_11.jpg", "sub1/ui/loading/img_loading_bg.png", "sub1/ui/scale9/img_load_2.png", "sub1/ui/scale9/img_load_1.png", "sub1/ui/loading/img_9.png"],
                    "loadList3D": []
                };
                matching.MatchingViewUI = MatchingViewUI;
                REG("ui.view.matching.MatchingViewUI", MatchingViewUI);
                class MatchItemUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.createView(MatchItemUI.uiView);
                    }
                }
                MatchItemUI.uiView = {
                    "type": "View",
                    "props": {
                        "width": 97,
                        "height": 95
                    },
                    "compId": 2,
                    "child": [{
                        "type": "Image",
                        "props": {
                            "y": 0,
                            "x": 0,
                            "width": 97,
                            "skin": "sub1/ui/scale9/img_37.png",
                            "height": 95,
                            "sizeGrid": "9,10,11,9"
                        },
                        "compId": 3
                    }, {
                        "type": "Image",
                        "props": {
                            "y": 0,
                            "x": 0,
                            "width": 97,
                            "var": "imgIcon",
                            "height": 95
                        },
                        "compId": 4
                    }],
                    "loadList": ["sub1/ui/scale9/img_37.png"],
                    "loadList3D": []
                };
                matching.MatchItemUI = MatchItemUI;
                REG("ui.view.matching.MatchItemUI", MatchItemUI);
            })(matching = view.matching || (view.matching = {}));
        })(view = ui.view || (ui.view = {}));
    })(ui || (ui = {}));
    (function(ui) {
        var view;
        (function(view) {
            var menu;
            (function(menu) {
                class MapMenuCellViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/menu/MapMenuCellView");
                    }
                }
                menu.MapMenuCellViewUI = MapMenuCellViewUI;
                REG("ui.view.menu.MapMenuCellViewUI", MapMenuCellViewUI);
                class MapMenuViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/menu/MapMenuView");
                    }
                }
                menu.MapMenuViewUI = MapMenuViewUI;
                REG("ui.view.menu.MapMenuViewUI", MapMenuViewUI);
            })(menu = view.menu || (view.menu = {}));
        })(view = ui.view || (ui.view = {}));
    })(ui || (ui = {}));
    (function(ui) {
        var view;
        (function(view) {
            var mode;
            (function(mode) {
                class ModeCellViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/mode/ModeCellView");
                    }
                }
                mode.ModeCellViewUI = ModeCellViewUI;
                REG("ui.view.mode.ModeCellViewUI", ModeCellViewUI);
                class ModeViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/mode/ModeView");
                    }
                }
                mode.ModeViewUI = ModeViewUI;
                REG("ui.view.mode.ModeViewUI", ModeViewUI);
            })(mode = view.mode || (view.mode = {}));
        })(view = ui.view || (ui.view = {}));
    })(ui || (ui = {}));
    (function(ui) {
        var view;
        (function(view) {
            var native;
            (function(native) {
                class NativeBanner1ViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.createView(NativeBanner1ViewUI.uiView);
                    }
                }
                NativeBanner1ViewUI.uiView = {
                    "type": "View",
                    "props": {
                        "width": 626,
                        "height": 171
                    },
                    "compId": 2,
                    "child": [{
                        "type": "Image",
                        "props": {
                            "y": 0,
                            "x": 0,
                            "width": 626,
                            "var": "imgAd",
                            "height": 171
                        },
                        "compId": 3,
                        "child": [{
                            "type": "Image",
                            "props": {
                                "y": 33,
                                "var": "btnClose",
                                "skin": "sub1/ui/native/img_1.png",
                                "scaleY": 1,
                                "scaleX": 1,
                                "right": 12,
                                "anchorY": 0.5,
                                "anchorX": 0.5
                            },
                            "compId": 11
                        }, {
                            "type": "Image",
                            "props": {
                                "skin": "sub1/ui/native/img_8.png",
                                "left": 0,
                                "bottom": 0
                            },
                            "compId": 10
                        }]
                    }],
                    "animations": [{
                        "nodes": [{
                            "target": 9,
                            "keyframes": {
                                "alpha": [{
                                    "value": 0.1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 9,
                                    "key": "alpha",
                                    "index": 0
                                }, {
                                    "value": 0.3,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 9,
                                    "key": "alpha",
                                    "index": 60
                                }, {
                                    "value": 0.1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 9,
                                    "key": "alpha",
                                    "index": 120
                                }]
                            }
                        }],
                        "name": "aniLight",
                        "id": 1,
                        "frameRate": 60,
                        "action": 2
                    }, {
                        "nodes": [],
                        "name": "aniScale",
                        "id": 1,
                        "frameRate": 60,
                        "action": 0
                    }],
                    "loadList": ["sub1/ui/native/img_1.png", "sub1/ui/native/img_8.png"],
                    "loadList3D": []
                };
                native.NativeBanner1ViewUI = NativeBanner1ViewUI;
                REG("ui.view.native.NativeBanner1ViewUI", NativeBanner1ViewUI);
                class NativeBanner2ViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.createView(NativeBanner2ViewUI.uiView);
                    }
                }
                NativeBanner2ViewUI.uiView = {
                    "type": "View",
                    "props": {
                        "width": 626,
                        "height": 171,
                        "centerX": 0
                    },
                    "compId": 2,
                    "child": [{
                        "type": "Image",
                        "props": {
                            "y": 0,
                            "width": 626,
                            "var": "imgAd",
                            "height": 171,
                            "centerX": 0
                        },
                        "compId": 3,
                        "child": [{
                            "type": "Image",
                            "props": {
                                "y": 33,
                                "var": "btnClose",
                                "skin": "sub1/ui/native/img_1.png",
                                "scaleY": 1,
                                "scaleX": 1,
                                "right": 12,
                                "anchorY": 0.5,
                                "anchorX": 0.5
                            },
                            "compId": 11
                        }, {
                            "type": "Image",
                            "props": {
                                "skin": "sub1/ui/native/img_8.png",
                                "left": 0,
                                "bottom": 0
                            },
                            "compId": 10
                        }]
                    }],
                    "animations": [{
                        "nodes": [{
                            "target": 9,
                            "keyframes": {
                                "alpha": [{
                                    "value": 0.1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 9,
                                    "key": "alpha",
                                    "index": 0
                                }, {
                                    "value": 0.3,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 9,
                                    "key": "alpha",
                                    "index": 60
                                }, {
                                    "value": 0.1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 9,
                                    "key": "alpha",
                                    "index": 120
                                }]
                            }
                        }],
                        "name": "aniLight",
                        "id": 1,
                        "frameRate": 60,
                        "action": 2
                    }, {
                        "nodes": [],
                        "name": "aniScale",
                        "id": 1,
                        "frameRate": 60,
                        "action": 0
                    }],
                    "loadList": ["sub1/ui/native/img_1.png", "sub1/ui/native/img_8.png"],
                    "loadList3D": []
                };
                native.NativeBanner2ViewUI = NativeBanner2ViewUI;
                REG("ui.view.native.NativeBanner2ViewUI", NativeBanner2ViewUI);
                class NativeBanner3ViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.createView(NativeBanner3ViewUI.uiView);
                    }
                }
                NativeBanner3ViewUI.uiView = {
                    "type": "View",
                    "props": {
                        "width": 399,
                        "height": 311
                    },
                    "compId": 2,
                    "child": [{
                        "type": "Image",
                        "props": {
                            "y": 0,
                            "x": 0,
                            "width": 399,
                            "var": "imgAd",
                            "skin": "sub1/ui/scale9/img_14.png",
                            "height": 311,
                            "sizeGrid": "2,3,4,4"
                        },
                        "compId": 3,
                        "child": [{
                            "type": "Image",
                            "props": {
                                "y": 24,
                                "var": "btnClose",
                                "skin": "sub1/ui/native/img_1.png",
                                "scaleY": 1,
                                "scaleX": 1,
                                "right": 0,
                                "anchorY": 0.5,
                                "anchorX": 0.5
                            },
                            "compId": 11
                        }, {
                            "type": "Image",
                            "props": {
                                "skin": "sub1/ui/native/img_8.png",
                                "left": 0,
                                "bottom": 0
                            },
                            "compId": 10
                        }]
                    }, {
                        "type": "Image",
                        "props": {
                            "y": 421,
                            "x": 199.5,
                            "width": 240,
                            "var": "btnAd",
                            "skin": "sub1/ui/scale9/img_normal_2.png",
                            "height": 87,
                            "anchorY": 0.5,
                            "anchorX": 0.5,
                            "sizeGrid": "21,80,30,79"
                        },
                        "compId": 13,
                        "child": [{
                            "type": "Image",
                            "props": {
                                "y": 25,
                                "x": 41,
                                "skin": "sub1/ui/native/img_5.png"
                            },
                            "compId": 14
                        }]
                    }],
                    "animations": [{
                        "nodes": [{
                            "target": 9,
                            "keyframes": {
                                "alpha": [{
                                    "value": 0.1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 9,
                                    "key": "alpha",
                                    "index": 0
                                }, {
                                    "value": 0.3,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 9,
                                    "key": "alpha",
                                    "index": 60
                                }, {
                                    "value": 0.1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 9,
                                    "key": "alpha",
                                    "index": 120
                                }]
                            }
                        }],
                        "name": "aniLight",
                        "id": 1,
                        "frameRate": 60,
                        "action": 2
                    }, {
                        "nodes": [],
                        "name": "aniScale",
                        "id": 1,
                        "frameRate": 60,
                        "action": 0
                    }],
                    "loadList": ["sub1/ui/scale9/img_14.png", "sub1/ui/native/img_1.png", "sub1/ui/native/img_8.png", "sub1/ui/scale9/img_normal_2.png", "sub1/ui/native/img_5.png"],
                    "loadList3D": []
                };
                native.NativeBanner3ViewUI = NativeBanner3ViewUI;
                REG("ui.view.native.NativeBanner3ViewUI", NativeBanner3ViewUI);
                class NativeIcon1CellUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/native/NativeIcon1Cell");
                    }
                }
                native.NativeIcon1CellUI = NativeIcon1CellUI;
                REG("ui.view.native.NativeIcon1CellUI", NativeIcon1CellUI);
                class NativeIcon2CellUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.createView(NativeIcon2CellUI.uiView);
                    }
                }
                NativeIcon2CellUI.uiView = {
                    "type": "View",
                    "props": {
                        "width": 250,
                        "height": 83
                    },
                    "compId": 2,
                    "child": [{
                        "type": "Image",
                        "props": {
                            "y": 0,
                            "x": 0,
                            "width": 219,
                            "skin": "sub1/ui/scale9/img_native_1.png",
                            "height": 83,
                            "sizeGrid": "12,13,13,13"
                        },
                        "compId": 13,
                        "child": [{
                            "type": "Image",
                            "props": {
                                "y": 2,
                                "x": 2,
                                "width": 216,
                                "var": "imgAd",
                                "height": 79
                            },
                            "compId": 3,
                            "child": [{
                                "type": "Image",
                                "props": {
                                    "y": 14.5,
                                    "var": "btnClose",
                                    "skin": "sub1/ui/native/img_1.png",
                                    "scaleY": 0.6,
                                    "scaleX": 0.6,
                                    "right": -30,
                                    "anchorY": 0.5,
                                    "anchorX": 0.5
                                },
                                "compId": 11
                            }, {
                                "type": "Image",
                                "props": {
                                    "skin": "sub1/ui/native/img_8.png",
                                    "scaleY": 0.8,
                                    "scaleX": 0.8,
                                    "left": 0,
                                    "bottom": -25
                                },
                                "compId": 10
                            }]
                        }]
                    }],
                    "animations": [{
                        "nodes": [{
                            "target": 9,
                            "keyframes": {
                                "alpha": [{
                                    "value": 0.1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 9,
                                    "key": "alpha",
                                    "index": 0
                                }, {
                                    "value": 0.3,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 9,
                                    "key": "alpha",
                                    "index": 60
                                }, {
                                    "value": 0.1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 9,
                                    "key": "alpha",
                                    "index": 120
                                }]
                            }
                        }],
                        "name": "aniLight",
                        "id": 1,
                        "frameRate": 60,
                        "action": 2
                    }, {
                        "nodes": [],
                        "name": "aniScale",
                        "id": 1,
                        "frameRate": 60,
                        "action": 0
                    }],
                    "loadList": ["sub1/ui/scale9/img_native_1.png", "sub1/ui/native/img_1.png", "sub1/ui/native/img_8.png"],
                    "loadList3D": []
                };
                native.NativeIcon2CellUI = NativeIcon2CellUI;
                REG("ui.view.native.NativeIcon2CellUI", NativeIcon2CellUI);
                class NativeInterstitialViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.createView(NativeInterstitialViewUI.uiView);
                    }
                }
                NativeInterstitialViewUI.uiView = {
                    "type": "View",
                    "props": {
                        "width": 1334,
                        "height": 750
                    },
                    "compId": 2,
                    "child": [{
                        "type": "Box",
                        "props": {
                            "width": 835,
                            "var": "boxRoot",
                            "height": 504,
                            "centerY": -48,
                            "centerX": -11
                        },
                        "compId": 13,
                        "child": [{
                            "type": "Image",
                            "props": {
                                "y": 10,
                                "x": 10,
                                "var": "imgTouch",
                                "top": 10,
                                "skin": "sub1/ui/scale9/img_native_2.png",
                                "sizeGrid": "32,28,39,39",
                                "right": 10,
                                "left": 10,
                                "bottom": 10
                            },
                            "compId": 10
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 29,
                                "x": 30,
                                "width": 777,
                                "var": "imgAd",
                                "height": 445
                            },
                            "compId": 4
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 29,
                                "var": "btnClose",
                                "skin": "sub1/ui/native/img_1.png",
                                "right": 30
                            },
                            "compId": 5
                        }, {
                            "type": "Image",
                            "props": {
                                "skin": "sub1/ui/native/img_8.png",
                                "left": 30,
                                "bottom": 446
                            },
                            "compId": 6
                        }, {
                            "type": "Label",
                            "props": {
                                "y": 382,
                                "x": 47,
                                "visible": false,
                                "var": "txtTitle",
                                "text": "title",
                                "fontSize": 35,
                                "font": "SimHei",
                                "color": "#000000",
                                "bold": true
                            },
                            "compId": 11
                        }, {
                            "type": "Label",
                            "props": {
                                "y": 430,
                                "x": 47,
                                "wordWrap": true,
                                "width": 546,
                                "visible": false,
                                "var": "txtContent",
                                "text": "content",
                                "height": 41,
                                "fontSize": 30,
                                "font": "SimHei",
                                "color": "#000000",
                                "bold": true
                            },
                            "compId": 12
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 560,
                                "x": 419,
                                "width": 316,
                                "var": "btnAd",
                                "skin": "sub1/ui/scale9/img_normal_1.png",
                                "height": 117,
                                "anchorY": 0.5,
                                "anchorX": 0.5,
                                "sizeGrid": "24,92,27,91"
                            },
                            "compId": 14,
                            "child": [{
                                "type": "Image",
                                "props": {
                                    "y": 31.5,
                                    "x": 35,
                                    "skin": "sub1/ui/native/img_4.png"
                                },
                                "compId": 16
                            }]
                        }]
                    }],
                    "loadList": ["sub1/ui/scale9/img_native_2.png", "sub1/ui/native/img_1.png", "sub1/ui/native/img_8.png", "sub1/ui/scale9/img_normal_1.png", "sub1/ui/native/img_4.png"],
                    "loadList3D": []
                };
                native.NativeInterstitialViewUI = NativeInterstitialViewUI;
                REG("ui.view.native.NativeInterstitialViewUI", NativeInterstitialViewUI);
            })(native = view.native || (view.native = {}));
        })(view = ui.view || (ui.view = {}));
    })(ui || (ui = {}));
    (function(ui) {
        var view;
        (function(view) {
            var offline;
            (function(offline) {
                class OfflineViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/offline/OfflineView");
                    }
                }
                offline.OfflineViewUI = OfflineViewUI;
                REG("ui.view.offline.OfflineViewUI", OfflineViewUI);
            })(offline = view.offline || (view.offline = {}));
        })(view = ui.view || (ui.view = {}));
    })(ui || (ui = {}));
    (function(ui) {
        var view;
        (function(view) {
            var record;
            (function(record) {
                class RecordViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/record/RecordView");
                    }
                }
                record.RecordViewUI = RecordViewUI;
                REG("ui.view.record.RecordViewUI", RecordViewUI);
            })(record = view.record || (view.record = {}));
        })(view = ui.view || (ui.view = {}));
    })(ui || (ui = {}));
    (function(ui) {
        var view;
        (function(view) {
            var review;
            (function(review) {
                class ReviewEndRecreationViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/review/ReviewEndRecreationView");
                    }
                }
                review.ReviewEndRecreationViewUI = ReviewEndRecreationViewUI;
                REG("ui.view.review.ReviewEndRecreationViewUI", ReviewEndRecreationViewUI);
                class ReviewGameViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/review/ReviewGameView");
                    }
                }
                review.ReviewGameViewUI = ReviewGameViewUI;
                REG("ui.view.review.ReviewGameViewUI", ReviewGameViewUI);
                class ReviewLoadingFightViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/review/ReviewLoadingFightView");
                    }
                }
                review.ReviewLoadingFightViewUI = ReviewLoadingFightViewUI;
                REG("ui.view.review.ReviewLoadingFightViewUI", ReviewLoadingFightViewUI);
                class ReviewLoadingViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.createView(ReviewLoadingViewUI.uiView);
                    }
                }
                ReviewLoadingViewUI.uiView = {
                    "type": "View",
                    "props": {
                        "width": 1625,
                        "height": 750
                    },
                    "compId": 2,
                    "child": [{
                        "type": "Image",
                        "props": {
                            "y": 0,
                            "x": 0,
                            "top": 0,
                            "skin": "loading/img_12.jpg",
                            "right": 0,
                            "left": 0,
                            "bottom": 0
                        },
                        "compId": 4
                    }, {
                        "type": "Image",
                        "props": {
                            "top": -2,
                            "skin": "loading/img_5.png",
                            "sizeGrid": "2,2,2,2",
                            "right": -2,
                            "left": -2,
                            "bottom": -2,
                            "alpha": 0.2
                        },
                        "compId": 11
                    }, {
                        "type": "Box",
                        "props": {
                            "width": 914,
                            "var": "boxLoading",
                            "scaleY": 1,
                            "scaleX": 1,
                            "height": 588,
                            "centerY": -79,
                            "centerX": 0
                        },
                        "compId": 6,
                        "child": [{
                            "type": "Image",
                            "props": {
                                "y": 122,
                                "x": 153,
                                "var": "imgLoading",
                                "skin": "loading/img_4.png"
                            },
                            "compId": 5
                        }, {
                            "type": "Label",
                            "props": {
                                "width": 708,
                                "var": "txtPercent",
                                "valign": "middle",
                                "text": "玩命加载中，请耐心等待...(78%) ",
                                "height": 55,
                                "fontSize": 25,
                                "color": "#000000",
                                "centerY": 117,
                                "centerX": 0,
                                "align": "center"
                            },
                            "compId": 3
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 441,
                                "width": 495,
                                "skin": "loading/img_5.png",
                                "sizeGrid": "8,15,9,11",
                                "centerX": 0
                            },
                            "compId": 8,
                            "child": [{
                                "type": "Image",
                                "props": {
                                    "y": 1.25,
                                    "x": 1,
                                    "width": 492,
                                    "var": "imgPro",
                                    "skin": "loading/img_13.png",
                                    "sizeGrid": "13,32,15,17"
                                },
                                "compId": 9
                            }]
                        }]
                    }, {
                        "type": "Label",
                        "props": {
                            "text": "抵制不良游戏，拒绝盗版游戏。  注意自我保护，谨防受骗上当。  适度游戏益脑，沉迷游戏伤身。  合理安排时间，享受健康生活。",
                            "fontSize": 20,
                            "color": "#cacaca",
                            "centerX": 0,
                            "bottom": 44
                        },
                        "compId": 12
                    }, {
                        "type": "Image",
                        "props": {
                            "y": 37,
                            "width": 72,
                            "skin": "loading/img_cadpa.png",
                            "right": 37,
                            "height": 92
                        },
                        "compId": 13
                    }],
                    "loadList": ["loading/img_12.jpg", "loading/img_5.png", "loading/img_4.png", "loading/img_13.png", "loading/img_cadpa.png"],
                    "loadList3D": []
                };
                review.ReviewLoadingViewUI = ReviewLoadingViewUI;
                REG("ui.view.review.ReviewLoadingViewUI", ReviewLoadingViewUI);
                class ReviewMatchingViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/review/ReviewMatchingView");
                    }
                }
                review.ReviewMatchingViewUI = ReviewMatchingViewUI;
                REG("ui.view.review.ReviewMatchingViewUI", ReviewMatchingViewUI);
            })(review = view.review || (view.review = {}));
        })(view = ui.view || (ui.view = {}));
    })(ui || (ui = {}));
    (function(ui) {
        var view;
        (function(view) {
            var revive;
            (function(revive) {
                class GameOverViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.createView(GameOverViewUI.uiView);
                    }
                }
                GameOverViewUI.uiView = {
                    "type": "View",
                    "props": {
                        "width": 1625,
                        "height": 750
                    },
                    "compId": 2,
                    "child": [{
                        "type": "Image",
                        "props": {
                            "y": 0,
                            "x": 0,
                            "top": 0,
                            "skin": "sub1/ui/scale9/img_28.png",
                            "right": 0,
                            "left": 0,
                            "bottom": 0,
                            "alpha": 0.7,
                            "sizeGrid": "2,3,2,2"
                        },
                        "compId": 3
                    }, {
                        "type": "Box",
                        "props": {
                            "y": 0,
                            "x": 0,
                            "width": 710,
                            "height": 614,
                            "centerY": -47,
                            "centerX": 0
                        },
                        "compId": 4,
                        "child": [{
                            "type": "Image",
                            "props": {
                                "y": 218,
                                "x": 247.5,
                                "skin": "sub1/ui/revive/img_7.png"
                            },
                            "compId": 14
                        }, {
                            "type": "Box",
                            "props": {
                                "y": 475,
                                "x": 357,
                                "width": 226,
                                "var": "btnBack",
                                "sizeGrid": "24,92,27,91",
                                "height": 90,
                                "anchorY": 0.5,
                                "anchorX": 0.5
                            },
                            "compId": 15,
                            "child": [{
                                "type": "Script",
                                "props": {
                                    "runtime": "effect/ButtonEffect.ts"
                                },
                                "compId": 17
                            }, {
                                "type": "Image",
                                "props": {
                                    "skin": "sub1/ui/scale9/img_normal_2.png",
                                    "sizeGrid": "21,80,30,79"
                                },
                                "compId": 19
                            }, {
                                "type": "Label",
                                "props": {
                                    "y": 29.5,
                                    "x": 46.5,
                                    "width": 128,
                                    "text": "退出战场",
                                    "height": 32,
                                    "fontSize": 32,
                                    "font": "SimHei",
                                    "color": "#371301",
                                    "bold": true
                                },
                                "compId": 18
                            }]
                        }]
                    }],
                    "loadList": ["sub1/ui/scale9/img_28.png", "sub1/ui/revive/img_7.png", "sub1/ui/scale9/img_normal_2.png"],
                    "loadList3D": []
                };
                revive.GameOverViewUI = GameOverViewUI;
                REG("ui.view.revive.GameOverViewUI", GameOverViewUI);
                class NewReviveViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.createView(NewReviveViewUI.uiView);
                    }
                }
                NewReviveViewUI.uiView = {
                    "type": "View",
                    "props": {
                        "width": 1625,
                        "height": 750
                    },
                    "compId": 2,
                    "child": [{
                        "type": "Image",
                        "props": {
                            "y": 0,
                            "x": 0,
                            "top": 0,
                            "skin": "sub1/ui/scale9/img_28.png",
                            "right": 0,
                            "left": 0,
                            "bottom": 0,
                            "alpha": 0.75,
                            "sizeGrid": "2,3,2,2"
                        },
                        "compId": 3
                    }, {
                        "type": "Box",
                        "props": {
                            "width": 1334,
                            "var": "boxAll",
                            "height": 750,
                            "centerY": 0,
                            "centerX": 0
                        },
                        "compId": 4,
                        "child": [{
                            "type": "Image",
                            "props": {
                                "y": 66,
                                "x": 37,
                                "width": 394,
                                "skin": "sub1/ui/scale9/img_revive_1.png",
                                "sizeGrid": "24,28,33,27",
                                "height": 120,
                                "alpha": 0.2
                            },
                            "compId": 21
                        }, {
                            "type": "Label",
                            "props": {
                                "y": 82,
                                "x": 61,
                                "width": 265,
                                "valign": "middle",
                                "text": "击败者：",
                                "height": 41,
                                "fontSize": 37,
                                "font": "SimHei",
                                "color": "#FEFEFE",
                                "bold": false,
                                "align": "left"
                            },
                            "compId": 15
                        }, {
                            "type": "Label",
                            "props": {
                                "y": 85,
                                "x": 205,
                                "width": 265,
                                "var": "txtKiller",
                                "valign": "middle",
                                "text": "罪魁祸首是",
                                "height": 41,
                                "fontSize": 33,
                                "font": "SimHei",
                                "color": "#FF3636",
                                "bold": true,
                                "align": "left"
                            },
                            "compId": 16
                        }, {
                            "type": "Label",
                            "props": {
                                "y": 136.5,
                                "x": 67.5,
                                "width": 275,
                                "var": "txtHit",
                                "text": "对我造成伤害：100",
                                "height": 21,
                                "fontSize": 24,
                                "color": "#FEFEFE"
                            },
                            "compId": 22
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 128,
                                "x": 416,
                                "var": "imgArm",
                                "skin": "sub1/equip/arm/1.png",
                                "scaleY": 0.4,
                                "scaleX": -0.4
                            },
                            "compId": 23
                        }, {
                            "type": "Label",
                            "props": {
                                "y": 437.5,
                                "x": 916,
                                "width": 312,
                                "valign": "middle",
                                "text": "观看视频后本局均可快速复活",
                                "height": 40,
                                "fontSize": 18,
                                "font": "SimHei",
                                "color": "#ffffff",
                                "bold": false,
                                "align": "center"
                            },
                            "compId": 6
                        }, {
                            "type": "Label",
                            "props": {
                                "y": 392,
                                "x": 752,
                                "width": 192,
                                "var": "txtCountDown",
                                "valign": "middle",
                                "text": "10",
                                "height": 198,
                                "fontSize": 85,
                                "font": "SimHei",
                                "color": "#ffffff",
                                "bold": true,
                                "anchorY": 0.5,
                                "anchorX": 0.5,
                                "align": "center"
                            },
                            "compId": 7
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 402,
                                "x": 1071,
                                "var": "btnRevive",
                                "skin": "sub1/ui/scale9/img_normal_1.png",
                                "anchorY": 0.5,
                                "anchorX": 0.5,
                                "sizeGrid": "24,92,27,91"
                            },
                            "compId": 8,
                            "child": [{
                                "type": "Script",
                                "props": {
                                    "runtime": "effect/ButtonEffect.ts"
                                },
                                "compId": 9
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 31,
                                    "x": 24,
                                    "skin": "sub1/ui/common/img_10.png"
                                },
                                "compId": 11
                            }, {
                                "type": "Label",
                                "props": {
                                    "y": 27,
                                    "x": 67,
                                    "width": 120,
                                    "text": "立即复活",
                                    "height": 39,
                                    "fontSize": 30,
                                    "font": "SimHei",
                                    "color": "#371E01",
                                    "bold": true
                                },
                                "compId": 24
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 6,
                                    "x": -53,
                                    "width": 53,
                                    "skin": "sub1/ui/first/img_59.png",
                                    "height": 76,
                                    "blendMode": "lighter",
                                    "alpha": 0.5
                                },
                                "compId": 25
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 48,
                                    "x": 115,
                                    "skin": "sub1/ui/scale9/img_normal_1.png",
                                    "renderType": "mask",
                                    "anchorY": 0.5,
                                    "anchorX": 0.5,
                                    "sizeGrid": "24,92,27,91"
                                },
                                "compId": 26
                            }]
                        }, {
                            "type": "Label",
                            "props": {
                                "y": 380,
                                "x": 476,
                                "width": 312,
                                "valign": "middle",
                                "text": "重生时间：",
                                "height": 40,
                                "fontSize": 38,
                                "font": "SimHei",
                                "color": "#ffffff",
                                "bold": false,
                                "align": "center"
                            },
                            "compId": 14
                        }, {
                            "type": "Image",
                            "props": {
                                "width": 512,
                                "var": "img3DCenter",
                                "height": 557,
                                "centerY": 131,
                                "centerX": -415
                            },
                            "compId": 17
                        }]
                    }],
                    "animations": [{
                        "nodes": [{
                            "target": 25,
                            "keyframes": {
                                "x": [{
                                    "value": -53,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 25,
                                    "key": "x",
                                    "index": 0
                                }, {
                                    "value": 230,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 25,
                                    "key": "x",
                                    "index": 40
                                }, {
                                    "value": 230,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 25,
                                    "label": null,
                                    "key": "x",
                                    "index": 60
                                }]
                            }
                        }],
                        "name": "ani1",
                        "id": 1,
                        "frameRate": 60,
                        "action": 0
                    }],
                    "loadList": ["sub1/ui/scale9/img_28.png", "sub1/ui/scale9/img_revive_1.png", "sub1/equip/arm/1.png", "sub1/ui/scale9/img_normal_1.png", "sub1/ui/common/img_10.png", "sub1/ui/first/img_59.png"],
                    "loadList3D": []
                };
                revive.NewReviveViewUI = NewReviveViewUI;
                REG("ui.view.revive.NewReviveViewUI", NewReviveViewUI);
                class ReviveViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.createView(ReviveViewUI.uiView);
                    }
                }
                ReviveViewUI.uiView = {
                    "type": "View",
                    "props": {
                        "width": 1625,
                        "height": 750
                    },
                    "compId": 2,
                    "child": [{
                        "type": "Image",
                        "props": {
                            "y": 0,
                            "x": 0,
                            "top": 0,
                            "skin": "sub1/ui/scale9/img_28.png",
                            "right": 0,
                            "left": 0,
                            "bottom": 0,
                            "alpha": 0.85,
                            "sizeGrid": "2,3,2,2"
                        },
                        "compId": 8
                    }, {
                        "type": "Box",
                        "props": {
                            "width": 710,
                            "height": 614,
                            "centerY": -77,
                            "centerX": 0
                        },
                        "compId": 3,
                        "child": [{
                            "type": "Image",
                            "props": {
                                "y": 57,
                                "x": 158,
                                "width": 394,
                                "skin": "sub1/ui/scale9/img_revive_1.png",
                                "sizeGrid": "24,28,33,27",
                                "height": 120,
                                "alpha": 0.2
                            },
                            "compId": 29
                        }, {
                            "type": "Label",
                            "props": {
                                "y": 284,
                                "x": 355,
                                "width": 192,
                                "var": "txtCountDown",
                                "valign": "middle",
                                "text": "10",
                                "height": 198,
                                "fontSize": 100,
                                "font": "SimHei",
                                "color": "#ffffff",
                                "bold": true,
                                "anchorY": 0.5,
                                "anchorX": 0.5,
                                "align": "center"
                            },
                            "compId": 7
                        }, {
                            "type": "Box",
                            "props": {
                                "y": 466,
                                "x": 355,
                                "width": 226,
                                "var": "btnRevive",
                                "height": 90,
                                "anchorY": 0.5,
                                "anchorX": 0.5
                            },
                            "compId": 11,
                            "child": [{
                                "type": "Script",
                                "props": {
                                    "runtime": "effect/ButtonEffect.ts"
                                },
                                "compId": 12
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 0,
                                    "x": 0,
                                    "skin": "sub1/ui/scale9/img_normal_1.png",
                                    "sizeGrid": "24,92,27,91"
                                },
                                "compId": 27
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 35,
                                    "x": 26,
                                    "skin": "sub1/ui/common/img_10.png"
                                },
                                "compId": 14
                            }, {
                                "type": "Label",
                                "props": {
                                    "y": 32,
                                    "x": 65,
                                    "width": 120,
                                    "text": "立即复活",
                                    "fontSize": 30,
                                    "font": "SimHei",
                                    "color": "#371301",
                                    "bold": true
                                },
                                "compId": 22
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 6,
                                    "x": -53,
                                    "width": 53,
                                    "skin": "sub1/ui/first/img_59.png",
                                    "height": 76,
                                    "blendMode": "lighter",
                                    "alpha": 0.5
                                },
                                "compId": 30
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 48,
                                    "x": 115,
                                    "skin": "sub1/ui/scale9/img_normal_1.png",
                                    "renderType": "mask",
                                    "anchorY": 0.5,
                                    "anchorX": 0.5,
                                    "sizeGrid": "24,92,27,91"
                                },
                                "compId": 31
                            }]
                        }, {
                            "type": "Label",
                            "props": {
                                "y": 528,
                                "x": 355,
                                "var": "btnBack",
                                "text": "不了，谢谢",
                                "fontSize": 32,
                                "color": "#ffffff",
                                "anchorY": 0.5,
                                "anchorX": 0.5
                            },
                            "compId": 16,
                            "child": [{
                                "type": "Script",
                                "props": {
                                    "runtime": "effect/ButtonEffect.ts"
                                },
                                "compId": 17
                            }]
                        }, {
                            "type": "Label",
                            "props": {
                                "y": 69,
                                "x": 187.5,
                                "width": 265,
                                "valign": "middle",
                                "text": "击败者：",
                                "height": 41,
                                "fontSize": 42,
                                "font": "SimHei",
                                "color": "#FEFEFE",
                                "bold": false,
                                "align": "left"
                            },
                            "compId": 18
                        }, {
                            "type": "Label",
                            "props": {
                                "y": 69,
                                "x": 340,
                                "width": 265,
                                "var": "txtKiller",
                                "valign": "middle",
                                "text": "罪魁祸首是",
                                "height": 41,
                                "fontSize": 33,
                                "font": "SimHei",
                                "color": "#FF3636",
                                "bold": true,
                                "align": "left"
                            },
                            "compId": 19
                        }, {
                            "type": "Label",
                            "props": {
                                "y": 128,
                                "x": 197.5,
                                "width": 275,
                                "var": "txtHit",
                                "text": "对我造成伤害：100",
                                "height": 21,
                                "fontSize": 24,
                                "color": "#FEFEFE"
                            },
                            "compId": 20
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 119,
                                "x": 526,
                                "var": "imgArm",
                                "skin": "sub1/equip/arm/1.png",
                                "scaleY": 0.4,
                                "scaleX": -0.4
                            },
                            "compId": 21
                        }, {
                            "type": "Box",
                            "props": {
                                "y": 465,
                                "width": 226,
                                "visible": false,
                                "var": "btnNo",
                                "sizeGrid": "26,35,34,37",
                                "height": 90,
                                "centerX": 136,
                                "anchorY": 0.5,
                                "anchorX": 0.5
                            },
                            "compId": 23,
                            "child": [{
                                "type": "Script",
                                "props": {
                                    "runtime": "effect/ButtonEffect.ts"
                                },
                                "compId": 24
                            }, {
                                "type": "Image",
                                "props": {
                                    "skin": "sub1/ui/scale9/img_normal_3.png",
                                    "sizeGrid": "25,29,30,26"
                                },
                                "compId": 28
                            }, {
                                "type": "Label",
                                "props": {
                                    "y": 31,
                                    "x": 46,
                                    "text": "不了,谢谢",
                                    "fontSize": 30,
                                    "color": "#ffffff",
                                    "bold": true
                                },
                                "compId": 25
                            }]
                        }]
                    }],
                    "animations": [{
                        "nodes": [{
                            "target": 30,
                            "keyframes": {
                                "x": [{
                                    "value": -53,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 30,
                                    "key": "x",
                                    "index": 0
                                }, {
                                    "value": 230,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 30,
                                    "key": "x",
                                    "index": 40
                                }, {
                                    "value": 230,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 30,
                                    "label": null,
                                    "key": "x",
                                    "index": 60
                                }]
                            }
                        }],
                        "name": "ani1",
                        "id": 1,
                        "frameRate": 60,
                        "action": 2
                    }],
                    "loadList": ["sub1/ui/scale9/img_28.png", "sub1/ui/scale9/img_revive_1.png", "sub1/ui/scale9/img_normal_1.png", "sub1/ui/common/img_10.png", "sub1/ui/first/img_59.png", "sub1/equip/arm/1.png", "sub1/ui/scale9/img_normal_3.png"],
                    "loadList3D": []
                };
                revive.ReviveViewUI = ReviveViewUI;
                REG("ui.view.revive.ReviveViewUI", ReviveViewUI);
            })(revive = view.revive || (view.revive = {}));
        })(view = ui.view || (ui.view = {}));
    })(ui || (ui = {}));
    (function(ui) {
        var view;
        (function(view) {
            var role;
            (function(role) {
                class RoleItemUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.createView(RoleItemUI.uiView);
                    }
                }
                RoleItemUI.uiView = {
                    "type": "View",
                    "props": {
                        "width": 153,
                        "height": 156
                    },
                    "compId": 2,
                    "child": [{
                        "type": "Box",
                        "props": {
                            "y": 0,
                            "x": 0,
                            "width": 153,
                            "height": 156
                        },
                        "compId": 26,
                        "child": [{
                            "type": "Image",
                            "props": {
                                "y": 6,
                                "x": 5,
                                "width": 146,
                                "var": "imgFrame",
                                "skin": "sub1/ui/scale9/img_bag_2.png",
                                "sizeGrid": "40,43,51,37",
                                "height": 146
                            },
                            "compId": 27,
                            "child": [{
                                "type": "Image",
                                "props": {
                                    "x": 17,
                                    "width": 106,
                                    "var": "imgIcon",
                                    "skin": "sub1/role/001.png",
                                    "height": 106,
                                    "bottom": 30
                                },
                                "compId": 28
                            }, {
                                "type": "Label",
                                "props": {
                                    "y": 115,
                                    "x": 12.5,
                                    "width": 124,
                                    "var": "txtName",
                                    "valign": "middle",
                                    "text": "txtName",
                                    "height": 25,
                                    "fontSize": 20,
                                    "font": "SimHei",
                                    "color": "#000000",
                                    "align": "center"
                                },
                                "compId": 29
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 18.5,
                                    "x": 28,
                                    "visible": false,
                                    "var": "imgNull",
                                    "skin": "sub1/ui/bag/img_9.png"
                                },
                                "compId": 30
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 6,
                                    "x": 6.5,
                                    "var": "imgGrade",
                                    "skin": "sub1/ui/warehouse/img_pingji_1.png"
                                },
                                "compId": 31
                            }, {
                                "type": "Box",
                                "props": {
                                    "y": 51,
                                    "x": 3,
                                    "width": 138,
                                    "var": "boxUsing",
                                    "height": 44
                                },
                                "compId": 32,
                                "child": [{
                                    "type": "Image",
                                    "props": {
                                        "y": 0,
                                        "x": 0,
                                        "width": 138,
                                        "skin": "sub1/ui/scale9/img_28.png",
                                        "height": 43,
                                        "alpha": 0.7,
                                        "sizeGrid": "2,3,2,2"
                                    },
                                    "compId": 33
                                }, {
                                    "type": "Label",
                                    "props": {
                                        "y": 3,
                                        "x": -5,
                                        "width": 149,
                                        "valign": "middle",
                                        "text": "已选择",
                                        "height": 40,
                                        "fontSize": 25,
                                        "font": "Microsoft YaHei",
                                        "color": "#ffffff",
                                        "align": "center"
                                    },
                                    "compId": 34
                                }]
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 111.5,
                                    "x": -9,
                                    "width": 155,
                                    "visible": false,
                                    "var": "imgPrice",
                                    "skin": "sub1/ui/scale9/img_55.png",
                                    "sizeGrid": "15,10,12,12",
                                    "height": 31,
                                    "alpha": 0
                                },
                                "compId": 35,
                                "child": [{
                                    "type": "Box",
                                    "props": {
                                        "y": 0,
                                        "x": 0,
                                        "width": 164,
                                        "var": "boxNoFragment",
                                        "height": 31
                                    },
                                    "compId": 36,
                                    "child": [{
                                        "type": "Image",
                                        "props": {
                                            "y": 4,
                                            "x": 30,
                                            "var": "imgType",
                                            "skin": "sub1/ui/common/img_3.png",
                                            "scaleY": 0.55,
                                            "scaleX": 0.55
                                        },
                                        "compId": 37
                                    }, {
                                        "type": "Label",
                                        "props": {
                                            "y": 7,
                                            "x": 56,
                                            "width": 124,
                                            "var": "txtPrice",
                                            "valign": "middle",
                                            "text": "100",
                                            "stroke": 2,
                                            "height": 19,
                                            "fontSize": 22,
                                            "color": "#ffffff",
                                            "align": "left"
                                        },
                                        "compId": 38
                                    }]
                                }, {
                                    "type": "Box",
                                    "props": {
                                        "y": 0,
                                        "x": 0,
                                        "width": 164,
                                        "var": "boxFragment",
                                        "height": 31
                                    },
                                    "compId": 39,
                                    "child": [{
                                        "type": "Label",
                                        "props": {
                                            "y": 5,
                                            "x": 56,
                                            "width": 124,
                                            "var": "txtAd",
                                            "valign": "middle",
                                            "text": "(0/12)",
                                            "stroke": 2,
                                            "height": 19,
                                            "fontSize": 22,
                                            "color": "#ffffff",
                                            "align": "left"
                                        },
                                        "compId": 40
                                    }, {
                                        "type": "Image",
                                        "props": {
                                            "y": 5,
                                            "x": 28,
                                            "visible": true,
                                            "skin": "sub1/ui/getReward/img_21.png",
                                            "scaleY": 0.7,
                                            "scaleX": 0.7
                                        },
                                        "compId": 41
                                    }]
                                }]
                            }]
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 0,
                                "x": 0,
                                "width": 154,
                                "var": "imgSelect",
                                "skin": "sub1/ui/scale9/img_bag_1.png",
                                "sizeGrid": "14,32,27,23",
                                "height": 154
                            },
                            "compId": 42
                        }]
                    }],
                    "loadList": ["sub1/ui/scale9/img_bag_2.png", "sub1/role/001.png", "sub1/ui/bag/img_9.png", "sub1/ui/warehouse/img_pingji_1.png", "sub1/ui/scale9/img_28.png", "sub1/ui/scale9/img_55.png", "sub1/ui/common/img_3.png", "sub1/ui/getReward/img_21.png", "sub1/ui/scale9/img_bag_1.png"],
                    "loadList3D": []
                };
                role.RoleItemUI = RoleItemUI;
                REG("ui.view.role.RoleItemUI", RoleItemUI);
                class RoleViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.createView(RoleViewUI.uiView);
                    }
                }
                RoleViewUI.uiView = {
                    "type": "View",
                    "props": {
                        "width": 1625,
                        "height": 750
                    },
                    "compId": 2,
                    "child": [{
                        "type": "Image",
                        "props": {
                            "top": 0,
                            "skin": "sub1/ui/common/img_bag_bg.jpg",
                            "right": 0,
                            "left": 0,
                            "bottom": 0
                        },
                        "compId": 3
                    }, {
                        "type": "Box",
                        "props": {
                            "x": 29,
                            "width": 591,
                            "var": "boxLeft",
                            "height": 650,
                            "centerY": 29
                        },
                        "compId": 4,
                        "child": [{
                            "type": "List",
                            "props": {
                                "y": 32,
                                "x": 133,
                                "width": 309,
                                "var": "list",
                                "height": 574
                            },
                            "compId": 6
                        }, {
                            "type": "Box",
                            "props": {
                                "y": -10,
                                "x": 442,
                                "width": 152,
                                "height": 598
                            },
                            "compId": 25,
                            "child": [{
                                "type": "Box",
                                "props": {
                                    "y": 84,
                                    "x": 82,
                                    "width": 146,
                                    "var": "btnSkin",
                                    "height": 65,
                                    "anchorY": 0.5,
                                    "anchorX": 0.5
                                },
                                "compId": 26,
                                "child": [{
                                    "type": "Script",
                                    "props": {
                                        "runtime": "effect/ButtonEffect.ts"
                                    },
                                    "compId": 28
                                }, {
                                    "type": "Image",
                                    "props": {
                                        "y": 2,
                                        "x": 10,
                                        "width": 126,
                                        "skin": "sub1/ui/common/img_btn_1.png",
                                        "scaleY": 1,
                                        "scaleX": 1,
                                        "name": "imgNormal",
                                        "height": 62
                                    },
                                    "compId": 73
                                }, {
                                    "type": "Image",
                                    "props": {
                                        "y": 2,
                                        "x": 10,
                                        "width": 126,
                                        "skin": "sub1/ui/common/img_btn_2.png",
                                        "scaleY": 1,
                                        "scaleX": 1,
                                        "name": "imgSelect",
                                        "height": 62
                                    },
                                    "compId": 82
                                }, {
                                    "type": "Image",
                                    "props": {
                                        "y": 15,
                                        "x": 41,
                                        "skin": "sub1/ui/bag/img_6.png"
                                    },
                                    "compId": 79
                                }]
                            }, {
                                "type": "Box",
                                "props": {
                                    "y": 158,
                                    "x": 82,
                                    "width": 146,
                                    "var": "btnWing",
                                    "height": 65,
                                    "anchorY": 0.5,
                                    "anchorX": 0.5
                                },
                                "compId": 75,
                                "child": [{
                                    "type": "Script",
                                    "props": {
                                        "runtime": "effect/ButtonEffect.ts"
                                    },
                                    "compId": 76
                                }, {
                                    "type": "Image",
                                    "props": {
                                        "y": 2,
                                        "x": 10,
                                        "width": 126,
                                        "skin": "sub1/ui/common/img_btn_1.png",
                                        "scaleY": 1,
                                        "scaleX": 1,
                                        "name": "imgNormal",
                                        "height": 62
                                    },
                                    "compId": 77
                                }, {
                                    "type": "Image",
                                    "props": {
                                        "y": 2,
                                        "x": 10,
                                        "width": 126,
                                        "skin": "sub1/ui/common/img_btn_2.png",
                                        "scaleY": 1,
                                        "scaleX": 1,
                                        "name": "imgSelect",
                                        "height": 62
                                    },
                                    "compId": 81
                                }, {
                                    "type": "Image",
                                    "props": {
                                        "y": 15,
                                        "x": 41,
                                        "skin": "sub1/ui/bag/img_4.png"
                                    },
                                    "compId": 78
                                }]
                            }]
                        }]
                    }, {
                        "type": "Box",
                        "props": {
                            "y": 44,
                            "x": 209,
                            "width": 190,
                            "height": 71,
                            "anchorY": 0.5,
                            "anchorX": 0.5
                        },
                        "compId": 9,
                        "child": [{
                            "type": "Box",
                            "props": {
                                "y": 32,
                                "x": 106,
                                "width": 108,
                                "var": "btnBack",
                                "height": 76,
                                "anchorY": 0.5,
                                "anchorX": 0.5
                            },
                            "compId": 11,
                            "child": [{
                                "type": "Image",
                                "props": {
                                    "y": 15.5,
                                    "x": 12,
                                    "skin": "sub1/ui/common/img_back.png"
                                },
                                "compId": 12
                            }, {
                                "type": "Script",
                                "props": {
                                    "runtime": "effect/ButtonEffect.ts"
                                },
                                "compId": 13
                            }]
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 15.5,
                                "x": 153.5,
                                "skin": "sub1/ui/common/img_12.png"
                            },
                            "compId": 24
                        }]
                    }, {
                        "type": "Box",
                        "props": {
                            "width": 291,
                            "var": "boxButtonRoot",
                            "right": 136,
                            "height": 278,
                            "centerY": 0
                        },
                        "compId": 20,
                        "child": [{
                            "type": "Image",
                            "props": {
                                "y": 175,
                                "x": 164,
                                "width": 230,
                                "var": "btnBuy",
                                "skin": "sub1/ui/scale9/img_normal_1.png",
                                "height": 89,
                                "anchorY": 0.5,
                                "anchorX": 0.5,
                                "sizeGrid": "24,92,27,91"
                            },
                            "compId": 14,
                            "child": [{
                                "type": "Script",
                                "props": {
                                    "runtime": "effect/ButtonEffect.ts"
                                },
                                "compId": 15
                            }, {
                                "type": "Box",
                                "props": {
                                    "y": 7,
                                    "x": 7,
                                    "width": 203,
                                    "visible": false,
                                    "var": "DGBox",
                                    "height": 68
                                },
                                "compId": 47,
                                "child": [{
                                    "type": "Label",
                                    "props": {
                                        "y": 14,
                                        "x": 86,
                                        "width": 161,
                                        "var": "txtPrice",
                                        "valign": "middle",
                                        "text": "label",
                                        "height": 44,
                                        "fontSize": 30,
                                        "color": "#371301",
                                        "bold": true,
                                        "align": "left"
                                    },
                                    "compId": 18
                                }, {
                                    "type": "Image",
                                    "props": {
                                        "y": 14,
                                        "x": 23,
                                        "var": "imgType",
                                        "skin": "sub1/ui/common/img_3.png"
                                    },
                                    "compId": 19
                                }]
                            }, {
                                "type": "Box",
                                "props": {
                                    "y": 13,
                                    "x": 7,
                                    "width": 203,
                                    "visible": true,
                                    "var": "WBox",
                                    "height": 68
                                },
                                "compId": 48,
                                "child": [{
                                    "type": "Image",
                                    "props": {
                                        "y": 19,
                                        "x": 4,
                                        "skin": "sub1/ui/common/img_10.png"
                                    },
                                    "compId": 50
                                }, {
                                    "type": "Label",
                                    "props": {
                                        "y": 15.5,
                                        "x": 44,
                                        "text": "获取碎片X1",
                                        "fontSize": 29,
                                        "color": "#371301",
                                        "bold": true
                                    },
                                    "compId": 102
                                }]
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 5,
                                    "x": -53,
                                    "width": 53,
                                    "skin": "sub1/ui/first/img_59.png",
                                    "height": 71,
                                    "blendMode": "lighter",
                                    "alpha": 0.5
                                },
                                "compId": 110
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 44,
                                    "x": 115,
                                    "width": 230,
                                    "skin": "sub1/ui/scale9/img_normal_1.png",
                                    "renderType": "mask",
                                    "height": 89,
                                    "anchorY": 0.5,
                                    "anchorX": 0.5,
                                    "sizeGrid": "24,92,27,91"
                                },
                                "compId": 111
                            }]
                        }, {
                            "type": "Label",
                            "props": {
                                "y": 180,
                                "x": 24,
                                "width": 251,
                                "var": "txtUsing",
                                "valign": "middle",
                                "text": "已选择",
                                "height": 67,
                                "fontSize": 42,
                                "font": "SimHei",
                                "color": "#FFFFFF",
                                "align": "center"
                            },
                            "compId": 21
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 263,
                                "x": 164,
                                "width": 230,
                                "visible": true,
                                "var": "btnTry",
                                "skin": "sub1/ui/scale9/img_normal_2.png",
                                "height": 89,
                                "anchorY": 0.5,
                                "anchorX": 0.5,
                                "sizeGrid": "21,80,30,79"
                            },
                            "compId": 52,
                            "child": [{
                                "type": "Script",
                                "props": {
                                    "runtime": "effect/ButtonEffect.ts"
                                },
                                "compId": 61
                            }, {
                                "type": "Label",
                                "props": {
                                    "y": 24,
                                    "x": 46,
                                    "text": "试用机会",
                                    "fontSize": 32,
                                    "color": "#371301",
                                    "bold": true
                                },
                                "compId": 101
                            }]
                        }, {
                            "type": "HBox",
                            "props": {
                                "y": 72,
                                "var": "boxFragment",
                                "centerX": 4
                            },
                            "compId": 62,
                            "child": [{
                                "type": "Image",
                                "props": {
                                    "y": 16.5,
                                    "x": 17,
                                    "visible": true,
                                    "skin": "sub1/ui/getReward/img_21.png",
                                    "scaleY": 1,
                                    "scaleX": 1
                                },
                                "compId": 63
                            }, {
                                "type": "Label",
                                "props": {
                                    "y": 16,
                                    "x": 62,
                                    "text": "( ",
                                    "strokeColor": "#000000",
                                    "stroke": 1,
                                    "fontSize": 28,
                                    "color": "#ffffff"
                                },
                                "compId": 64
                            }, {
                                "type": "Label",
                                "props": {
                                    "y": 16,
                                    "x": 62,
                                    "var": "txtFragment",
                                    "text": "0",
                                    "strokeColor": "#000000",
                                    "stroke": 1,
                                    "fontSize": 28,
                                    "color": "#ffffff"
                                },
                                "compId": 70
                            }, {
                                "type": "Label",
                                "props": {
                                    "y": 16,
                                    "x": 62,
                                    "var": "txtFragmentAll",
                                    "text": " /12)",
                                    "strokeColor": "#000000",
                                    "stroke": 1,
                                    "fontSize": 28,
                                    "color": "#ffffff"
                                },
                                "compId": 71
                            }]
                        }]
                    }, {
                        "type": "Image",
                        "props": {
                            "width": 833,
                            "var": "img3DCenter",
                            "height": 820,
                            "centerY": 0,
                            "centerX": 115
                        },
                        "compId": 22,
                        "child": [{
                            "type": "Image",
                            "props": {
                                "y": 578,
                                "x": 271,
                                "skin": "sub1/ui/common/img_shadow.png"
                            },
                            "compId": 103
                        }]
                    }, {
                        "type": "Label",
                        "props": {
                            "visible": false,
                            "var": "img4399",
                            "text": "4399",
                            "right": 28,
                            "italic": true,
                            "fontSize": 50,
                            "color": "#ffffff",
                            "bottom": 21,
                            "bold": true,
                            "alpha": 0.5
                        },
                        "compId": 72
                    }, {
                        "type": "Image",
                        "props": {
                            "y": 50,
                            "x": 497,
                            "visible": false,
                            "var": "btnGameCommunity",
                            "skin": "sub1/ui/first/img_56.png",
                            "anchorY": 0.5,
                            "anchorX": 0.5
                        },
                        "compId": 105,
                        "child": [{
                            "type": "Script",
                            "props": {
                                "runtime": "effect/ButtonEffect.ts"
                            },
                            "compId": 107
                        }]
                    }, {
                        "type": "Box",
                        "props": {
                            "y": 53,
                            "x": 583,
                            "width": 91,
                            "visible": false,
                            "var": "btnMoreGame",
                            "height": 68,
                            "anchorY": 0.5,
                            "anchorX": 0.5
                        },
                        "compId": 106,
                        "child": [{
                            "type": "Image",
                            "props": {
                                "y": 5,
                                "x": 3,
                                "skin": "sub1/ui/first/img_54.png"
                            },
                            "compId": 108
                        }, {
                            "type": "Script",
                            "props": {
                                "runtime": "effect/ButtonEffect.ts"
                            },
                            "compId": 109
                        }]
                    }],
                    "animations": [{
                        "nodes": [{
                            "target": 110,
                            "keyframes": {
                                "x": [{
                                    "value": -53,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 110,
                                    "key": "x",
                                    "index": 0
                                }, {
                                    "value": 242,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 110,
                                    "key": "x",
                                    "index": 40
                                }, {
                                    "value": 242,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 110,
                                    "label": null,
                                    "key": "x",
                                    "index": 60
                                }]
                            }
                        }],
                        "name": "ani1",
                        "id": 1,
                        "frameRate": 60,
                        "action": 2
                    }],
                    "loadList": ["sub1/ui/common/img_bag_bg.jpg", "sub1/ui/common/img_btn_1.png", "sub1/ui/common/img_btn_2.png", "sub1/ui/bag/img_6.png", "sub1/ui/bag/img_4.png", "sub1/ui/common/img_back.png", "sub1/ui/common/img_12.png", "sub1/ui/scale9/img_normal_1.png", "sub1/ui/common/img_3.png", "sub1/ui/common/img_10.png", "sub1/ui/first/img_59.png", "sub1/ui/scale9/img_normal_2.png", "sub1/ui/getReward/img_21.png", "sub1/ui/common/img_shadow.png", "sub1/ui/first/img_56.png", "sub1/ui/first/img_54.png"],
                    "loadList3D": []
                };
                role.RoleViewUI = RoleViewUI;
                REG("ui.view.role.RoleViewUI", RoleViewUI);
            })(role = view.role || (view.role = {}));
        })(view = ui.view || (ui.view = {}));
    })(ui || (ui = {}));
    (function(ui) {
        var view;
        (function(view) {
            var shop;
            (function(shop) {
                class ShopItemUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/shop/ShopItem");
                    }
                }
                shop.ShopItemUI = ShopItemUI;
                REG("ui.view.shop.ShopItemUI", ShopItemUI);
                class ShopViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/shop/ShopView");
                    }
                }
                shop.ShopViewUI = ShopViewUI;
                REG("ui.view.shop.ShopViewUI", ShopViewUI);
            })(shop = view.shop || (view.shop = {}));
        })(view = ui.view || (ui.view = {}));
    })(ui || (ui = {}));
    (function(ui) {
        var view;
        (function(view) {
            var sign;
            (function(sign) {
                class NewSignViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/sign/NewSignView");
                    }
                }
                sign.NewSignViewUI = NewSignViewUI;
                REG("ui.view.sign.NewSignViewUI", NewSignViewUI);
                class SignCellViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/sign/SignCellView");
                    }
                }
                sign.SignCellViewUI = SignCellViewUI;
                REG("ui.view.sign.SignCellViewUI", SignCellViewUI);
                class SignViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.createView(SignViewUI.uiView);
                    }
                }
                SignViewUI.uiView = {
                    "type": "View",
                    "props": {
                        "width": 1625,
                        "height": 750
                    },
                    "compId": 2,
                    "child": [{
                        "type": "Box",
                        "props": {
                            "width": 1282,
                            "height": 682,
                            "centerY": -14,
                            "centerX": 0
                        },
                        "compId": 3,
                        "child": [{
                            "type": "Image",
                            "props": {
                                "y": 123.5,
                                "x": 157,
                                "skin": "sub1/ui/sign/img_24.png",
                                "sizeGrid": "83,201,41,245"
                            },
                            "compId": 5
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 75.5,
                                "x": 461,
                                "skin": "sub1/ui/sign/img_25.png"
                            },
                            "compId": 32
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 47.5,
                                "x": 158,
                                "skin": "sub1/ui/sign/img_10.png"
                            },
                            "compId": 6
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 78,
                                "x": 492.5,
                                "skin": "sub1/ui/sign/img_26.png"
                            },
                            "compId": 35
                        }, {
                            "type": "HBox",
                            "props": {
                                "y": 164.5,
                                "x": 400,
                                "var": "boxOne",
                                "space": 11
                            },
                            "compId": 8
                        }, {
                            "type": "HBox",
                            "props": {
                                "y": 359.5,
                                "x": 400,
                                "var": "boxTwo",
                                "space": 11
                            },
                            "compId": 12
                        }, {
                            "type": "Box",
                            "props": {
                                "y": 157,
                                "x": 167,
                                "width": 233,
                                "sizeGrid": "0,52,0,53",
                                "height": 382
                            },
                            "compId": 17,
                            "child": [{
                                "type": "Image",
                                "props": {
                                    "y": -102,
                                    "x": -15,
                                    "width": 525,
                                    "var": "imgGunSeven",
                                    "skin": "sub1/ui/sign/img_1.png",
                                    "rotation": 55,
                                    "height": 124
                                },
                                "compId": 21
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 7,
                                    "x": 47,
                                    "var": "imgGunTwo",
                                    "skin": "sub1/ui/sign/img_2.png",
                                    "rotation": 47
                                },
                                "compId": 22
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 4.5,
                                    "x": 29,
                                    "skin": "sub1/ui/sign/img_14.png"
                                },
                                "compId": 18
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": -7,
                                    "x": 113,
                                    "var": "imgTwo",
                                    "skin": "sub1/ui/sign/img_8.png"
                                },
                                "compId": 19
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": -8,
                                    "x": 116.5,
                                    "var": "imgSeven",
                                    "skin": "sub1/ui/sign/img_9.png"
                                },
                                "compId": 20
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 338,
                                    "x": -25,
                                    "skin": "sub1/ui/sign/img_20.png"
                                },
                                "compId": 33,
                                "child": [{
                                    "type": "Label",
                                    "props": {
                                        "y": 8,
                                        "x": 30,
                                        "var": "labelName",
                                        "text": "AWM-123",
                                        "fontSize": 25,
                                        "color": "#ffffff"
                                    },
                                    "compId": 34
                                }]
                            }]
                        }, {
                            "type": "Box",
                            "props": {
                                "y": 105.5,
                                "x": 1101.5,
                                "width": 71,
                                "var": "btnBack",
                                "height": 59,
                                "anchorY": 0.5,
                                "anchorX": 0.5
                            },
                            "compId": 28,
                            "child": [{
                                "type": "Image",
                                "props": {
                                    "y": 13,
                                    "x": 18,
                                    "skin": "sub1/ui/common/img_7.png"
                                },
                                "compId": 29
                            }, {
                                "type": "Script",
                                "props": {
                                    "runtime": "effect/ButtonEffect.ts"
                                },
                                "compId": 30
                            }]
                        }, {
                            "type": "Box",
                            "props": {
                                "y": 241,
                                "x": 462,
                                "width": 100,
                                "var": "boxGuide",
                                "height": 100
                            },
                            "compId": 31
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 508,
                                "x": 135,
                                "skin": "sub1/ui/sign/img_22.png"
                            },
                            "compId": 59
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 132,
                                "x": 10,
                                "skin": "sub1/ui/sign/img_21.png",
                                "scaleY": 1.25,
                                "scaleX": 1.25
                            },
                            "compId": 58
                        }]
                    }],
                    "animations": [{
                        "nodes": [{
                            "target": 22,
                            "keyframes": {
                                "y": [{
                                    "value": 7.5,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 22,
                                    "key": "y",
                                    "index": 0
                                }, {
                                    "value": -5,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 22,
                                    "key": "y",
                                    "index": 75
                                }, {
                                    "value": 7.5,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 22,
                                    "label": null,
                                    "key": "y",
                                    "index": 150
                                }]
                            }
                        }, {
                            "target": 21,
                            "keyframes": {
                                "y": [{
                                    "value": -102,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 21,
                                    "key": "y",
                                    "index": 0
                                }, {
                                    "value": -115,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 21,
                                    "key": "y",
                                    "index": 75
                                }, {
                                    "value": -102,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 21,
                                    "label": null,
                                    "key": "y",
                                    "index": 150
                                }]
                            }
                        }],
                        "name": "ani1",
                        "id": 1,
                        "frameRate": 60,
                        "action": 2
                    }],
                    "loadList": ["sub1/ui/sign/img_24.png", "sub1/ui/sign/img_25.png", "sub1/ui/sign/img_10.png", "sub1/ui/sign/img_26.png", "sub1/ui/sign/img_1.png", "sub1/ui/sign/img_2.png", "sub1/ui/sign/img_14.png", "sub1/ui/sign/img_8.png", "sub1/ui/sign/img_9.png", "sub1/ui/sign/img_20.png", "sub1/ui/common/img_7.png", "sub1/ui/sign/img_22.png", "sub1/ui/sign/img_21.png"],
                    "loadList3D": []
                };
                sign.SignViewUI = SignViewUI;
                REG("ui.view.sign.SignViewUI", SignViewUI);
            })(sign = view.sign || (view.sign = {}));
        })(view = ui.view || (ui.view = {}));
    })(ui || (ui = {}));
    (function(ui) {
        var view;
        (function(view) {
            var superReward;
            (function(superReward) {
                class SuperRewardViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/superReward/SuperRewardView");
                    }
                }
                superReward.SuperRewardViewUI = SuperRewardViewUI;
                REG("ui.view.superReward.SuperRewardViewUI", SuperRewardViewUI);
            })(superReward = view.superReward || (view.superReward = {}));
        })(view = ui.view || (ui.view = {}));
    })(ui || (ui = {}));
    (function(ui) {
        var view;
        (function(view) {
            var superStart;
            (function(superStart) {
                class SuperStartItemUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.createView(SuperStartItemUI.uiView);
                    }
                }
                SuperStartItemUI.uiView = {
                    "type": "View",
                    "props": {
                        "width": 1334,
                        "height": 750
                    },
                    "compId": 2,
                    "child": [{
                        "type": "Image",
                        "props": {
                            "y": 179,
                            "x": 434,
                            "skin": "sub1/ui/superStart/img_8.png",
                            "scaleY": 1.25,
                            "scaleX": 1.25
                        },
                        "compId": 3
                    }],
                    "loadList": ["sub1/ui/superStart/img_8.png"],
                    "loadList3D": []
                };
                superStart.SuperStartItemUI = SuperStartItemUI;
                REG("ui.view.superStart.SuperStartItemUI", SuperStartItemUI);
                class SuperStartViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.createView(SuperStartViewUI.uiView);
                    }
                }
                SuperStartViewUI.uiView = {
                    "type": "View",
                    "props": {
                        "width": 1625,
                        "height": 750
                    },
                    "compId": 2,
                    "child": [{
                        "type": "Image",
                        "props": {
                            "y": 0,
                            "x": 0,
                            "top": 0,
                            "skin": "sub1/ui/scale9/img_27.png",
                            "right": 0,
                            "left": 0,
                            "bottom": 0,
                            "alpha": 0.8
                        },
                        "compId": 3
                    }, {
                        "type": "Box",
                        "props": {
                            "width": 1334,
                            "var": "boxAll",
                            "height": 750,
                            "centerY": 0,
                            "centerX": 0
                        },
                        "compId": 27,
                        "child": [{
                            "type": "Box",
                            "props": {
                                "y": 326,
                                "x": 930,
                                "width": 226,
                                "scaleY": 1,
                                "scaleX": 1,
                                "height": 286,
                                "anchorY": 0.5,
                                "anchorX": 0.5,
                                "alpha": 1
                            },
                            "compId": 16,
                            "child": [{
                                "type": "Image",
                                "props": {
                                    "y": 13,
                                    "x": 23.5,
                                    "skin": "sub1/ui/superStart/img_8.png",
                                    "scaleY": 1,
                                    "scaleX": 1
                                },
                                "compId": 4,
                                "child": [{
                                    "type": "Image",
                                    "props": {
                                        "y": 106,
                                        "x": 103.5,
                                        "width": 329,
                                        "skin": "sub1/ui/superStart/img_9.png",
                                        "rotation": 0,
                                        "pivotY": 167,
                                        "pivotX": 159,
                                        "height": 334
                                    },
                                    "compId": 49,
                                    "child": [{
                                        "type": "Script",
                                        "props": {
                                            "runtime": "effect/TurnEffect.ts"
                                        },
                                        "compId": 50
                                    }]
                                }, {
                                    "type": "Image",
                                    "props": {
                                        "y": 106,
                                        "x": 103,
                                        "width": 329,
                                        "skin": "sub1/ui/superStart/img_9.png",
                                        "rotation": 0,
                                        "pivotY": 167,
                                        "pivotX": 159,
                                        "height": 334
                                    },
                                    "compId": 51,
                                    "child": [{
                                        "type": "Script",
                                        "props": {
                                            "rotateSpeed": -1,
                                            "runtime": "effect/TurnEffect.ts"
                                        },
                                        "compId": 52
                                    }]
                                }]
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 57,
                                    "x": 66,
                                    "skin": "sub1/ui/superStart/img_3.png"
                                },
                                "compId": 5
                            }, {
                                "type": "Label",
                                "props": {
                                    "y": 216,
                                    "x": 66,
                                    "width": 142,
                                    "text": "护甲",
                                    "height": 29,
                                    "fontSize": 28,
                                    "font": "SimHei",
                                    "color": "#000000"
                                },
                                "compId": 6
                            }, {
                                "type": "Label",
                                "props": {
                                    "y": 216,
                                    "x": 127,
                                    "width": 142,
                                    "text": "+10%",
                                    "stroke": 2,
                                    "height": 29,
                                    "fontSize": 28,
                                    "font": "SimHei",
                                    "color": "#40EFFF"
                                },
                                "compId": 7
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 22,
                                    "x": 169,
                                    "skin": "sub1/ui/try/img_new_shop_1.png"
                                },
                                "compId": 62
                            }]
                        }, {
                            "type": "Box",
                            "props": {
                                "y": 328,
                                "x": 654,
                                "width": 221,
                                "scaleY": 1,
                                "scaleX": 1,
                                "height": 291,
                                "anchorY": 0.5,
                                "anchorX": 0.5
                            },
                            "compId": 17,
                            "child": [{
                                "type": "Image",
                                "props": {
                                    "y": 13,
                                    "x": 23.5,
                                    "skin": "sub1/ui/superStart/img_8.png",
                                    "scaleY": 1,
                                    "scaleX": 1
                                },
                                "compId": 18,
                                "child": [{
                                    "type": "Image",
                                    "props": {
                                        "y": 106,
                                        "x": 103,
                                        "width": 329,
                                        "skin": "sub1/ui/superStart/img_9.png",
                                        "rotation": 0,
                                        "pivotY": 167,
                                        "pivotX": 159,
                                        "height": 334
                                    },
                                    "compId": 53,
                                    "child": [{
                                        "type": "Script",
                                        "props": {
                                            "runtime": "effect/TurnEffect.ts"
                                        },
                                        "compId": 55
                                    }]
                                }, {
                                    "type": "Image",
                                    "props": {
                                        "y": 106,
                                        "x": 103,
                                        "width": 329,
                                        "skin": "sub1/ui/superStart/img_9.png",
                                        "rotation": 0,
                                        "pivotY": 167,
                                        "pivotX": 159,
                                        "height": 334
                                    },
                                    "compId": 54,
                                    "child": [{
                                        "type": "Script",
                                        "props": {
                                            "rotateSpeed": -1,
                                            "runtime": "effect/TurnEffect.ts"
                                        },
                                        "compId": 56
                                    }]
                                }]
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 50,
                                    "x": 56.5,
                                    "var": "imgHead",
                                    "skin": "sub1/ui/superStart/img_4.png"
                                },
                                "compId": 19
                            }, {
                                "type": "Label",
                                "props": {
                                    "y": 216,
                                    "x": 52,
                                    "width": 142,
                                    "var": "labelHead",
                                    "text": "爆头率",
                                    "height": 29,
                                    "fontSize": 28,
                                    "font": "SimHei",
                                    "color": "#000000",
                                    "bold": false
                                },
                                "compId": 20
                            }, {
                                "type": "Label",
                                "props": {
                                    "y": 216,
                                    "x": 137,
                                    "width": 142,
                                    "text": "+10%",
                                    "stroke": 2,
                                    "height": 29,
                                    "fontSize": 28,
                                    "font": "SimHei",
                                    "color": "#FF15E6",
                                    "bold": true
                                },
                                "compId": 21
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 22,
                                    "x": 169,
                                    "skin": "sub1/ui/try/img_new_shop_1.png"
                                },
                                "compId": 63
                            }]
                        }, {
                            "type": "Box",
                            "props": {
                                "y": 326,
                                "x": 387.5,
                                "width": 224,
                                "scaleY": 1,
                                "scaleX": 1,
                                "height": 290,
                                "anchorY": 0.5,
                                "anchorX": 0.5
                            },
                            "compId": 22,
                            "child": [{
                                "type": "Image",
                                "props": {
                                    "y": 13,
                                    "x": 23.5,
                                    "skin": "sub1/ui/superStart/img_8.png",
                                    "scaleY": 1,
                                    "scaleX": 1
                                },
                                "compId": 23,
                                "child": [{
                                    "type": "Image",
                                    "props": {
                                        "y": 106,
                                        "x": 103,
                                        "width": 329,
                                        "skin": "sub1/ui/superStart/img_9.png",
                                        "rotation": 0,
                                        "pivotY": 167,
                                        "pivotX": 159,
                                        "height": 334
                                    },
                                    "compId": 57,
                                    "child": [{
                                        "type": "Script",
                                        "props": {
                                            "runtime": "effect/TurnEffect.ts"
                                        },
                                        "compId": 59
                                    }]
                                }, {
                                    "type": "Image",
                                    "props": {
                                        "y": 106,
                                        "x": 103,
                                        "width": 329,
                                        "skin": "sub1/ui/superStart/img_9.png",
                                        "rotation": 0,
                                        "pivotY": 167,
                                        "pivotX": 159,
                                        "height": 334
                                    },
                                    "compId": 58,
                                    "child": [{
                                        "type": "Script",
                                        "props": {
                                            "rotateSpeed": -1,
                                            "runtime": "effect/TurnEffect.ts"
                                        },
                                        "compId": 60
                                    }]
                                }]
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 54,
                                    "x": 65.5,
                                    "skin": "sub1/ui/superStart/img_2.png"
                                },
                                "compId": 24
                            }, {
                                "type": "Label",
                                "props": {
                                    "y": 216,
                                    "x": 58,
                                    "width": 142,
                                    "text": "生命",
                                    "height": 29,
                                    "fontSize": 28,
                                    "font": "SimHei",
                                    "color": "#000000",
                                    "bold": false
                                },
                                "compId": 25
                            }, {
                                "type": "Label",
                                "props": {
                                    "y": 216,
                                    "x": 122,
                                    "width": 142,
                                    "text": "+30%",
                                    "stroke": 2,
                                    "height": 29,
                                    "fontSize": 28,
                                    "font": "SimHei",
                                    "color": "#05DC0A",
                                    "bold": true
                                },
                                "compId": 26
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 22,
                                    "x": 169,
                                    "skin": "sub1/ui/try/img_new_shop_1.png"
                                },
                                "compId": 64
                            }]
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 79,
                                "x": 530,
                                "skin": "sub1/ui/superStart/img_7.png"
                            },
                            "compId": 28
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 562.5,
                                "x": 822,
                                "width": 221,
                                "var": "btnSuperStart",
                                "skin": "sub1/ui/scale9/img_normal_1.png",
                                "anchorY": 0.5,
                                "anchorX": 0.5,
                                "sizeGrid": "24,92,27,91"
                            },
                            "compId": 29,
                            "child": [{
                                "type": "Image",
                                "props": {
                                    "y": 32,
                                    "x": 25,
                                    "skin": "sub1/ui/common/img_10.png"
                                },
                                "compId": 31
                            }, {
                                "type": "Script",
                                "props": {
                                    "runtime": "effect/ButtonEffect.ts"
                                },
                                "compId": 32
                            }, {
                                "type": "Label",
                                "props": {
                                    "y": 28.5,
                                    "x": 63,
                                    "text": "超凡开局",
                                    "fontSize": 32,
                                    "color": "#371E01",
                                    "bold": true
                                },
                                "compId": 46
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 6,
                                    "x": -74,
                                    "width": 74,
                                    "skin": "sub1/ui/first/img_59.png",
                                    "height": 79,
                                    "blendMode": "lighter",
                                    "alpha": 0.5
                                },
                                "compId": 47
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 0,
                                    "x": 0,
                                    "width": 221,
                                    "skin": "sub1/ui/scale9/img_normal_1.png",
                                    "renderType": "mask",
                                    "sizeGrid": "24,92,27,91"
                                },
                                "compId": 48
                            }]
                        }, {
                            "type": "Image",
                            "props": {
                                "y": 562.5,
                                "x": 518,
                                "width": 223,
                                "var": "btnChooseStart",
                                "skin": "sub1/ui/scale9/img_normal_3.png",
                                "anchorY": 0.5,
                                "anchorX": 0.5,
                                "sizeGrid": "25,29,30,26"
                            },
                            "compId": 30,
                            "child": [{
                                "type": "Box",
                                "props": {
                                    "y": 31.5,
                                    "x": 13.5,
                                    "width": 196,
                                    "var": "boxNoAd",
                                    "height": 52
                                },
                                "compId": 34,
                                "child": [{
                                    "type": "Label",
                                    "props": {
                                        "y": 0,
                                        "x": 38,
                                        "text": "普通开局",
                                        "fontSize": 30,
                                        "color": "#ffffff",
                                        "bold": true
                                    },
                                    "compId": 44
                                }]
                            }, {
                                "type": "Box",
                                "props": {
                                    "y": 8,
                                    "x": 15,
                                    "width": 197,
                                    "var": "boxAd",
                                    "height": 46
                                },
                                "compId": 36,
                                "child": [{
                                    "type": "Label",
                                    "props": {
                                        "y": 23,
                                        "x": 38.5,
                                        "text": "快速开始",
                                        "fontSize": 30,
                                        "color": "#ffffff",
                                        "bold": true
                                    },
                                    "compId": 45
                                }]
                            }]
                        }, {
                            "type": "Box",
                            "props": {
                                "y": 653.5,
                                "x": 450.5,
                                "width": 433,
                                "var": "boxSuperStart",
                                "height": 34
                            },
                            "compId": 39,
                            "child": [{
                                "type": "Label",
                                "props": {
                                    "y": 4,
                                    "x": 97,
                                    "width": 309,
                                    "var": "txtBox",
                                    "text": "观看视频使用超凡开局快速开始！",
                                    "height": 25,
                                    "fontSize": 22,
                                    "font": "SimHei",
                                    "color": "#FFFFFF"
                                },
                                "compId": 40
                            }, {
                                "type": "Image",
                                "props": {
                                    "y": 0,
                                    "x": 57,
                                    "skin": "sub1/ui/common/img_common_3.png"
                                },
                                "compId": 41
                            }, {
                                "type": "Box",
                                "props": {
                                    "y": -2.5,
                                    "x": 52.5,
                                    "width": 38,
                                    "var": "btnGet",
                                    "height": 34
                                },
                                "compId": 42,
                                "child": [{
                                    "type": "Image",
                                    "props": {
                                        "y": 3,
                                        "x": 4,
                                        "skin": "sub1/ui/common/img_common_4.png"
                                    },
                                    "compId": 43
                                }]
                            }]
                        }]
                    }],
                    "animations": [{
                        "nodes": [{
                            "target": 16,
                            "keyframes": {
                                "scaleY": [{
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 16,
                                    "key": "scaleY",
                                    "index": 0
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 16,
                                    "key": "scaleY",
                                    "index": 24
                                }],
                                "scaleX": [{
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 16,
                                    "key": "scaleX",
                                    "index": 0
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 16,
                                    "key": "scaleX",
                                    "index": 24
                                }]
                            }
                        }, {
                            "target": 17,
                            "keyframes": {
                                "scaleY": [{
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 17,
                                    "key": "scaleY",
                                    "index": 0
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 17,
                                    "key": "scaleY",
                                    "index": 17
                                }],
                                "scaleX": [{
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 17,
                                    "key": "scaleX",
                                    "index": 0
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 17,
                                    "key": "scaleX",
                                    "index": 17
                                }]
                            }
                        }, {
                            "target": 22,
                            "keyframes": {
                                "scaleY": [{
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 22,
                                    "key": "scaleY",
                                    "index": 0
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 22,
                                    "key": "scaleY",
                                    "index": 10
                                }],
                                "scaleX": [{
                                    "value": 0,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 22,
                                    "key": "scaleX",
                                    "index": 0
                                }, {
                                    "value": 1,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 22,
                                    "key": "scaleX",
                                    "index": 10
                                }]
                            }
                        }],
                        "name": "ani1",
                        "id": 1,
                        "frameRate": 60,
                        "action": 0
                    }, {
                        "nodes": [{
                            "target": 47,
                            "keyframes": {
                                "x": [{
                                    "value": -103,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 47,
                                    "key": "x",
                                    "index": 0
                                }, {
                                    "value": 244,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 47,
                                    "key": "x",
                                    "index": 61
                                }, {
                                    "value": 244,
                                    "tweenMethod": "linearNone",
                                    "tween": true,
                                    "target": 47,
                                    "label": null,
                                    "key": "x",
                                    "index": 89
                                }]
                            }
                        }],
                        "name": "ani2",
                        "id": 2,
                        "frameRate": 60,
                        "action": 2
                    }],
                    "loadList": ["sub1/ui/scale9/img_27.png", "sub1/ui/superStart/img_8.png", "sub1/ui/superStart/img_9.png", "sub1/ui/superStart/img_3.png", "sub1/ui/try/img_new_shop_1.png", "sub1/ui/superStart/img_4.png", "sub1/ui/superStart/img_2.png", "sub1/ui/superStart/img_7.png", "sub1/ui/scale9/img_normal_1.png", "sub1/ui/common/img_10.png", "sub1/ui/first/img_59.png", "sub1/ui/scale9/img_normal_3.png", "sub1/ui/common/img_common_3.png", "sub1/ui/common/img_common_4.png"],
                    "loadList3D": []
                };
                superStart.SuperStartViewUI = SuperStartViewUI;
                REG("ui.view.superStart.SuperStartViewUI", SuperStartViewUI);
            })(superStart = view.superStart || (view.superStart = {}));
        })(view = ui.view || (ui.view = {}));
    })(ui || (ui = {}));
    (function(ui) {
        var view;
        (function(view) {
            var task;
            (function(task) {
                class TaskCellViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/task/TaskCellView");
                    }
                }
                task.TaskCellViewUI = TaskCellViewUI;
                REG("ui.view.task.TaskCellViewUI", TaskCellViewUI);
                class TaskViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/task/TaskView");
                    }
                }
                task.TaskViewUI = TaskViewUI;
                REG("ui.view.task.TaskViewUI", TaskViewUI);
            })(task = view.task || (view.task = {}));
        })(view = ui.view || (ui.view = {}));
    })(ui || (ui = {}));
    (function(ui) {
        var view;
        (function(view) {
            var teamMatchMap;
            (function(teamMatchMap) {
                class TeamMatchMapViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.createView(TeamMatchMapViewUI.uiView);
                    }
                }
                TeamMatchMapViewUI.uiView = {
                    "type": "View",
                    "props": {
                        "width": 1334,
                        "height": 750
                    },
                    "compId": 2,
                    "child": [{
                        "type": "Image",
                        "props": {
                            "top": 0,
                            "skin": "sub1/ui/scale9/img_1.png",
                            "right": 0,
                            "left": 0,
                            "bottom": 0,
                            "sizeGrid": "7,10,8,11"
                        },
                        "compId": 3
                    }, {
                        "type": "Label",
                        "props": {
                            "width": 442,
                            "var": "map1",
                            "valign": "middle",
                            "text": "运输船",
                            "height": 127,
                            "fontSize": 70,
                            "color": "#ffffff",
                            "centerY": -190,
                            "centerX": 0,
                            "align": "center"
                        },
                        "compId": 4
                    }, {
                        "type": "Label",
                        "props": {
                            "width": 442,
                            "var": "map2",
                            "valign": "middle",
                            "text": "雪地",
                            "height": 127,
                            "fontSize": 70,
                            "color": "#ffffff",
                            "centerY": -35,
                            "centerX": 0,
                            "align": "center"
                        },
                        "compId": 6
                    }, {
                        "type": "Label",
                        "props": {
                            "width": 442,
                            "var": "map3",
                            "valign": "middle",
                            "text": "地堡",
                            "height": 127,
                            "fontSize": 70,
                            "color": "#ffffff",
                            "centerY": 117,
                            "centerX": 0,
                            "align": "center"
                        },
                        "compId": 7
                    }],
                    "loadList": ["sub1/ui/scale9/img_1.png"],
                    "loadList3D": []
                };
                teamMatchMap.TeamMatchMapViewUI = TeamMatchMapViewUI;
                REG("ui.view.teamMatchMap.TeamMatchMapViewUI", TeamMatchMapViewUI);
            })(teamMatchMap = view.teamMatchMap || (view.teamMatchMap = {}));
        })(view = ui.view || (ui.view = {}));
    })(ui || (ui = {}));
    (function(ui) {
        var view;
        (function(view) {
            var turnTable;
            (function(turnTable) {
                class TurnTableCellViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/turnTable/TurnTableCellView");
                    }
                }
                turnTable.TurnTableCellViewUI = TurnTableCellViewUI;
                REG("ui.view.turnTable.TurnTableCellViewUI", TurnTableCellViewUI);
                class TurnTableViewUI extends View {
                    constructor() {
                        super();
                    }
                    createChildren() {
                        super.createChildren();
                        this.loadScene("view/turnTable/TurnTableView");
                    }
                }
                turnTable.TurnTableViewUI = TurnTableViewUI;
                REG("ui.view.turnTable.TurnTableViewUI", TurnTableViewUI);
            })(turnTable = view.turnTable || (view.turnTable = {}));
        })(view = ui.view || (ui.view = {}));
    })(ui || (ui = {}));

    class LoadingMaskViewCtrl extends ui.view.load.LoadingMaskViewUI {
        static getInstance() {
            if (this._instance)
                return this._instance;
            this._instance = new LoadingMaskViewCtrl();
            return this._instance;
        }
        onAwake() {
            this.width = this.stage.width;
            this.height = this.stage.height;
        }
        _show(cb = null) {
            Laya.MouseManager.instance.disableMouseEvent = true;
            Laya.stage.addChild(this);
            this.zOrder = ORDER_LAYER_Z.LOADING;
            this.aniLoading.play();
            Laya.timer.once(7000, this, function() {
                cb && cb();
                LoadingMaskViewCtrl.hide();
            });
        }
        _hide() {
            Laya.MouseManager.instance.disableMouseEvent = false;
            Laya.timer.clearAll(this);
            this.removeSelf();
            this.aniLoading.stop();
        }
        static show(cb = null) {
            this.getInstance()._show(cb);
        }
        static hide() {
            this.getInstance()._hide();
        }
    }

    let CHANNEL_VIEW_LABEL = {
        DEFAULT: '默认',
        FIRST_VIEW: '首页',
        SKIN_VIEW: '皮肤界面',
        END_VIEW: '结束界面',
        GAME_VIEW: '游戏界面',
        FULL_SCREEN: '全屏导出界面',
        FLOAT: '插屏导出',
        NATIVE: '原生导出',
    };
    var CHANNEL_TYPE;
    (function(CHANNEL_TYPE) {
        CHANNEL_TYPE[CHANNEL_TYPE["SINGLE"] = 0] = "SINGLE";
        CHANNEL_TYPE[CHANNEL_TYPE["BAR"] = 1] = "BAR";
        CHANNEL_TYPE[CHANNEL_TYPE["FLOAT"] = 2] = "FLOAT";
        CHANNEL_TYPE[CHANNEL_TYPE["FULL_SCREEN"] = 3] = "FULL_SCREEN";
        CHANNEL_TYPE[CHANNEL_TYPE["FRIEND"] = 4] = "FRIEND";
        CHANNEL_TYPE[CHANNEL_TYPE["NATIVE"] = 5] = "NATIVE";
        CHANNEL_TYPE[CHANNEL_TYPE["ANIMATION"] = 6] = "ANIMATION";
    })(CHANNEL_TYPE || (CHANNEL_TYPE = {}));
    let REPORT_NATIVE_TYPE = {
        CLICK: 'click',
        DISPLAY: 'display'
    };

    class Mathf {
        static random(max = 1, min = 0) {
            Mathf.seed = ((Mathf.seed * 9301) + 49297) % 233280;
            let rnd = Mathf.seed * Mathf.randNum1;
            return ((max - min) * rnd) + min;
        }
        static clamp(value, min, max) {
            return Math.max(min, Math.min(max, value));
        }
        static toFixed(a, b) {
            return Number(a.toFixed(b));
        }
    }
    Mathf.PI = Math.PI;
    Mathf.seed = 888888;
    Mathf.randNum1 = 1 / 233280;

    class ChannelSingleCellCtrl extends ui.view.channel.ChannelSingleCellUI {
        constructor(functionTag) {
            super();
            this.channelType = CHANNEL_TYPE.SINGLE;
            this.functionTag = functionTag;
            this.setChannel();
            this.on(Laya.Event.MOUSE_DOWN, this, this.onBtnClick);
            this.txtName.visible = false;
            this.hideTag();
        }
        setView() {
            this.imgIcon.skin = this.dataSource.app_icon;
            this.txtName.text = this.dataSource.app_title;
        }
        showName() {
            this.txtName.visible = true;
            this.txtName.text = this.dataSource.app_title;
        }
        hide() {
            this.destroy();
        }
        playShakeAni(cb = null) {
            let that = this;
            Laya.Tween.to(that.imgRoot, {
                rotation: -10
            }, 70, null, Laya.Handler.create(this, function() {
                Laya.Tween.to(that.imgRoot, {
                    rotation: 10
                }, 70, null, Laya.Handler.create(this, function() {
                    Laya.Tween.to(that.imgRoot, {
                        rotation: -5
                    }, 50, null, Laya.Handler.create(this, function() {
                        Laya.Tween.to(that.imgRoot, {
                            rotation: 5
                        }, 50, null, Laya.Handler.create(this, function() {
                            Laya.Tween.to(that.imgRoot, {
                                rotation: 0
                            }, 20, null, Laya.Handler.create(this, function() {
                                if (cb)
                                    cb();
                            }));
                        }));
                    }));
                }));
            }));
        }
        showTag() {
            this.imgTag.visible = true;
        }
        hideTag() {
            this.imgTag.visible = false;
        }
        onBtnClick() {
            let that = this;
            ChannelManager.navigate2Mini(this.dataSource, true, this.functionTag, this.channelType, null, function() {
                ChannelManager.requestChannelData(function() {
                    if (!that.parent)
                        return;
                    let data = ChannelManager.list[CHANNEL_POS.DEFAULT] ? ChannelManager.list[CHANNEL_POS.DEFAULT] : [];
                    let rand = Math.floor(Math.random() * data.length) % data.length;
                    if (that.dataSource.app_icon == data[rand].app_icon) {
                        rand += 1;
                        rand %= data.length;
                    }
                    that.dataSource = data[rand];
                    that.setView();
                });
            });
        }
        onDestroy() {
            Laya.timer.clearAll(this);
            this.off(Laya.Event.MOUSE_DOWN, this, this.onBtnClick);
            this.imgIcon = null;
            this.imgTag = null;
            this.imgRoot = null;
        }
        setChannel() {
            var that = this;
            ChannelManager.requestChannelData(function() {
                let list = ChannelManager.list[CHANNEL_POS.DEFAULT] ? ChannelManager.list[CHANNEL_POS.DEFAULT] : [];
                if (list && list.length > 0) {
                    let idx = Math.floor(Mathf.random(list.length, 0));
                    let num = 1;
                    that.dataSource = list[idx];
                    that.setView();
                    let refresh = function() {
                        idx += num;
                        let cIdx = (idx) % list.length;
                        that.dataSource = list[cIdx];
                        that.setView();
                        that.playShakeAni();
                    };
                    Laya.timer.loop(3000, this, refresh);
                }
            });
        }
    }

    let CHANNEL_POS = {
        DEFAULT: 'promotion',
        BACK_AD: 'backAd'
    };
    class ChannelManager extends Laya.Script {
        static requestChannelData(success) {
            if (ChannelManager.isRequest) {
                success();
                return;
            }
            if (ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.WEB_4399) {
                ChannelManager.isRequest = true;
                ChannelManager.list = sampleList;
                success();
                return;
            }
            if (ConfigManager.platform == PLATFORM_TYPE.WX || ConfigManager.platform == PLATFORM_TYPE.TT || ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS) {
                if (!ConfigManager.navCtrl()) {
                    ChannelManager.list = {};
                    ChannelManager.isRequest = true;
                    success();
                    return;
                }
                if (ConfigManager.isReviewVersion()) {
                    ChannelManager.isRequest = true;
                    ChannelManager.list[CHANNEL_POS.DEFAULT] = [];
                    success();
                    return;
                }
            } else if (ConfigManager.platform == PLATFORM_TYPE.OPPO) {
                if (!ChannelManager.zsNavCtrl()) {
                    ChannelManager.list = {};
                    ChannelManager.isRequest = true;
                    success();
                    return;
                }
                if (ChannelManager.isZSReviewVersion()) {
                    ChannelManager.isRequest = true;
                    ChannelManager.list[CHANNEL_POS.DEFAULT] = [];
                    success();
                    return;
                }
            } else {
                ChannelManager.isRequest = true;
                ChannelManager.list[CHANNEL_POS.DEFAULT] = [];
                success();
                return;
            }
            if (ConfigManager.platform == PLATFORM_TYPE.WX) {
                ChannelManager.requestChannelDataFromOwn(success);
            } else {
                zs.sdk.loadAd(function(data) {
                    console.log('zs.sdk.loadAd', data);
                    ChannelManager.list = data;
                    ChannelManager.isRequest = true;
                    success();
                });
            }
        }
        static requestChannelDataFromOwn(success) {
            NetworkManager.request(ROUTE_MAP.CHANNEL, 'GET', {
                appId: ConfigManager.appId
            }, function(data) {
                data = data.data;
                ChannelManager.list[CHANNEL_POS.DEFAULT] = JSON.parse(data.channel.data);
                ChannelManager.isRequest = true;
                success();
            });
        }
        static createFullScreenView(callBack = null) {}
        static createFloatView(cb = null) {}
        static createInterstitialView() {}
        static navigate2Mini(itemData, isShowFullScreen = true, view = CHANNEL_VIEW_LABEL.DEFAULT, type, success = null, fail = null) {
            let data = {};
            for (let k in itemData) {
                data[k] = itemData[k];
            }
            if (ConfigManager.platform == PLATFORM_TYPE.OPPO) {
                ChannelManager.navigateEventHandle(view, 0);
                RoleManager.getInstance().getPlatformUserId(function(userId) {
                    zs.sdk.navigate2Mini(data, userId, function() {
                        ChannelManager.navigateEventHandle(view, 1);
                        ChannelManager.setJump(data.appid, function() {
                            PlatformUtil.reportAnalyise(ANALYISE_ID.NAV_SUCCESS);
                            if (RoleManager.getInstance().isNew) {
                                PlatformUtil.reportAnalyise(ANALYISE_ID.NEW_NAV_SUCCESS);
                            }
                        });
                        if (success)
                            success();
                    }, function() {
                        if (isShowFullScreen) {
                            ChannelManager.createFullScreenView(null);
                        }
                        if (fail)
                            fail();
                    }, function() {});
                });
                return;
            } else if (ConfigManager.platform == PLATFORM_TYPE.TT) {
                RoleManager.getInstance().getPlatformUserId(function(openId) {
                    let zsSdk = zs.sdk;
                    zsSdk.showMoreGamesModal(itemData, openId, function() {
                        if (success)
                            success();
                    }, function() {
                        if (fail)
                            fail();
                    });
                });
            } else if (ConfigManager.platform == PLATFORM_TYPE.WX) {
                ChannelManager.navigateEventHandle(view, 0);
                ChannelManager.navigateEventHandle(view, 1);
                PlatformUtil.reportAnalyise(ANALYISE_ID.NAV_SUCCESS);
                if (RoleManager.getInstance().isNew) {
                    PlatformUtil.reportAnalyise(ANALYISE_ID.NEW_NAV_SUCCESS);
                }
                PlatformUtil.navigateToMiniProgram(data.appid);
            } else {
                fail();
            }
        }
        static navigateEventHandle(view, event) {
            if (event == 0) {
                PlatformUtil.reportAnalyise(view + '跳转点击');
            } else if (event == 1) {
                PlatformUtil.reportAnalyise(view + '跳转成功');
            }
        }
        static clearJump() {
            let data = Laya.LocalStorage.getItem(STORAGE_ID.JUMPLIST);
            console.log('本地跳转列表:', data, typeof(data));
            if (data != null && data != '') {
                data = JSON.parse(data);
                console.log('日期判断: ', ChannelManager.getNowFormatDate(), data.date);
                if (ChannelManager.getNowFormatDate() != data.date) {
                    Laya.LocalStorage.removeItem(STORAGE_ID.JUMPLIST);
                    console.log('跳转数据清除成功');
                }
            }
        }
        static setJump(titleName, success = null) {
            let isSame = false;
            let localData = Laya.LocalStorage.getItem(STORAGE_ID.JUMPLIST);
            if (localData != null && localData != '') {
                console.log('localData', JSON.parse(localData).list);
                localData = JSON.parse(localData);
                for (let k = 0; k < localData.list.length; k++) {
                    if (localData.list[k] == titleName) {
                        isSame = true;
                    }
                }
                if (!isSame) {
                    localData.list.push(titleName);
                    let data = {
                        date: ChannelManager.getNowFormatDate(),
                        list: localData.list
                    };
                    Laya.LocalStorage.setItem(STORAGE_ID.JUMPLIST, JSON.stringify(data));
                    if (success)
                        success();
                }
            } else {
                console.log('localData无值：', localData);
                let list = [];
                list.push(titleName);
                let data = {
                    date: ChannelManager.getNowFormatDate(),
                    list: list
                };
                Laya.LocalStorage.setItem(STORAGE_ID.JUMPLIST, JSON.stringify(data));
                if (success)
                    success();
            }
        }
        static getNowFormatDate() {
            var date = new Date();
            var seperator1 = "-";
            var seperator2 = ":";
            var month = date.getMonth() + 1 < 10 ? "0" + (date.getMonth() + 1) : date.getMonth() + 1;
            var strDate = date.getDate() < 10 ? "0" + date.getDate() : date.getDate();
            var currentdate = date.getFullYear() + seperator1 + month + seperator1 + strDate;
            return currentdate;
        }
        static zsInit(success = null) {
            if (ConfigManager.isZsCtrl) {
                let sdk = zs.sdk;
                sdk.initSdkByConf({
                    channel: 'wx',
                    appId: ConfigManager.appId,
                    secret: ConfigManager.secret
                });
                sdk.login(function(openId) {
                    console.log('zsInit openId', openId);
                    Laya.LocalStorage.setItem(STORAGE_ID.PLATFORM_USER_ID, openId);
                    sdk.init(openId);
                });
            } else {
                success();
                return;
            }
            ChannelManager.requestZSCtrl(success, success);
        }
        static requestZSCtrl(success, fail) {
            if (ConfigManager.platform == PLATFORM_TYPE.VIVO) {
                let data = {
                    apk_id: ConfigManager.appId,
                };
                NetworkManager.requestWithUrl('  platform.qwpo2018.com/api/list_config/index', 'GET', [], data, function(data) {
                    console.log('requestZSCtrl', data);
                    ChannelManager.zsCtrl = data;
                    success();
                });
            } else if (ConfigManager.platform == PLATFORM_TYPE.OPPO || ConfigManager.platform == PLATFORM_TYPE.WX) {
                let sdk = zs.sdk;
                sdk.loadCfg(function(data) {
                    console.log('requestZSCtrl', data);
                    ChannelManager.zsCtrl = data;
                    success();
                }, fail);
            }
        }
        static isZSReviewVersion() {
            if (ChannelManager.zsCtrl && ChannelManager.zsCtrl.zs_version == ConfigManager.zsVer) {
                console.log('zs sdk 版本审核中');
                return true;
            }
            return false;
        }
        static zsNativeCtrl() {
            if (ConfigManager.platform != PLATFORM_TYPE.OPPO)
                return true;
            if (ChannelManager.zsCtrl && ChannelManager.zsCtrl.zs_native_click_switch == 1)
                return true;
            console.log('zs sdk 原生广告已关');
            return false;
        }
        static zsNavCtrl() {
            if (ConfigManager.platform != PLATFORM_TYPE.OPPO)
                return true;
            if (ChannelManager.zsCtrl && ChannelManager.zsCtrl.zs_jump_switch == 1)
                return true;
            console.log('zsNavCtrl 导出开关已关');
            return false;
        }
        static showMoreGamesModal(itemData, success = null, fail = null) {
            if (ConfigManager.platform != PLATFORM_TYPE.TT)
                return;
            RoleManager.getInstance().getPlatformUserId(function(openId) {
                let zsSdk = zs.sdk;
                zsSdk.showMoreGamesModal(itemData, openId, function() {
                    if (success)
                        success();
                }, function() {
                    if (fail)
                        fail();
                });
            });
        }
        static reportNativeAd(adId, type, success = null) {}
        static creatSingleCell(x, y, tag) {
            ChannelManager.requestChannelData(function() {
                if (ChannelManager.list[CHANNEL_POS.DEFAULT] != null && ChannelManager.list[CHANNEL_POS.DEFAULT].length != 0) {
                    let view = new ChannelSingleCellCtrl(tag);
                    view.x = x;
                    view.y = y;
                    let key = x + '_' + y + '_' + tag;
                    ChannelManager.singleCell[key] = view;
                    Laya.stage.addChild(view);
                }
            });
        }
        static showSingleCell(x, y, tag) {
            return;
            let key = x + '_' + y + '_' + tag;
            if (this.singleCell[key]) {
                this.singleCell[key].visible = true;
                return;
            }
            this.creatSingleCell(x, y, tag);
        }
        static hideSingleCell(x, y, tag) {
            let key = x + '_' + y + '_' + tag;
            if (this.singleCell[key]) {
                this.singleCell[key].visible = false;
                this.singleCell[key].removeSelf();
                this.singleCell[key] = null;
            }
        }
        static bannerRefreshTime() {
            if (!ConfigManager.isZsCtrl) {
                return ConfigManager.getRefreshBannerTime();
            }
            if (ChannelManager.zsCtrl && ChannelManager.zsCtrl.zs_banner_refresh_time) {
                if (ChannelManager.zsCtrl.zs_banner_refresh_time)
                    return Number(ChannelManager.zsCtrl.zs_banner_refresh_time);
                else {
                    return 30000;
                }
            } else
                return ConfigManager.getRefreshBannerTime();
        }
        static jumpBackGezi() {
            if (!ConfigManager.isZsCtrl) {
                return ConfigManager.getJumpBackGezi();
            }
            if (this.isZSReviewVersion())
                return 0;
            if (ChannelManager.zsCtrl && ChannelManager.zsCtrl.zs_jump_back_gezi) {
                let n = Number(ChannelManager.zsCtrl.zs_jump_back_gezi);
                if (n == 0)
                    return 0;
                if (n == -1)
                    return 1;
                else {
                    return n + 1;
                }
            } else
                return 0;
        }
        static protogenesisRenovate() {
            if (ChannelManager.zsCtrl && ChannelManager.zsCtrl.zs_protogenesis_renovate) {
                let n = Number(ChannelManager.zsCtrl.zs_protogenesis_renovate);
                console.log('格子刷新次数' + n);
                return n;
            } else
                return 6;
        }
        static getIPCtrl() {
            if (ChannelManager.zsCtrl && ChannelManager.zsCtrl.ip_ctrl) {
                let n = Number(ChannelManager.zsCtrl.ip_ctrl);
                return n == 1;
            } else
                return true;
        }
        static getViolenceCtrl() {
            if (ChannelManager.zsCtrl && ChannelManager.zsCtrl.violence_ctrl) {
                let n = Number(ChannelManager.zsCtrl.violence_ctrl);
                return n == 1;
            } else
                return true;
        }
        static getSwitch() {
            if (ChannelManager.zsCtrl && ChannelManager.zsCtrl.zs_switch) {
                let n = Number(ChannelManager.zsCtrl.zs_switch);
                return n == 1;
            } else
                return true;
        }
        static getbannerTouch() {
            if (ChannelManager.zsCtrl && ChannelManager.zsCtrl.banner_touch) {
                let n = Number(ChannelManager.zsCtrl.banner_touch);
                return n == 1;
            } else
                return true;
        }
        static isZsBannerCtrl() {
            if (this.getSwitch() && this.getbannerTouch())
                return true;
            return false;
        }
    }
    ChannelManager.isRequest = false;
    ChannelManager.fullScreen = null;
    ChannelManager.zsCtrl = null;
    ChannelManager.list = {};
    ChannelManager.singleCell = {};
    var sampleList = {
        promotion: [{
                app_desc: "1",
                app_icon: "  txcdn.wqop2018.com/guanggao/628b546a2626219134503104fefbb9e1.png",
                app_icon_str: "",
                app_id: "14437",
                app_qrcode: "",
                app_title: "山坡越野车1",
                app_type: "2",
                appid: "wx111d5d0d7032b58e",
                link_path: "pages/index/index",
                link_text: "1",
                open_ad: "1",
                position_type: "2",
                type: "2",
            },
            {
                app_desc: "1",
                app_icon: "  txcdn.wqop2018.com/guanggao/628b546a2626219134503104fefbb9e1.png",
                app_icon_str: "",
                app_id: "14437",
                app_qrcode: "",
                app_title: "山坡越野车2",
                app_type: "2",
                appid: "wx111d5d0d7032b58e",
                link_path: "pages/index/index",
                link_text: "1",
                open_ad: "1",
                position_type: "2",
                type: "2",
            },
            {
                app_desc: "1",
                app_icon: "  txcdn.wqop2018.com/guanggao/628b546a2626219134503104fefbb9e1.png",
                app_icon_str: "",
                app_id: "14437",
                app_qrcode: "",
                app_title: "山坡越野车3",
                app_type: "2",
                appid: "wx111d5d0d7032b58e",
                link_path: "pages/index/index",
                link_text: "1",
                open_ad: "1",
                position_type: "2",
                type: "2",
            },
            {
                app_desc: "1",
                app_icon: "  txcdn.wqop2018.com/guanggao/628b546a2626219134503104fefbb9e1.png",
                app_icon_str: "",
                app_id: "14437",
                app_qrcode: "",
                app_title: "山坡越野车4",
                app_type: "2",
                appid: "wx111d5d0d7032b58e",
                link_path: "pages/index/index",
                link_text: "1",
                open_ad: "1",
                position_type: "2",
                type: "2",
            },
            {
                app_desc: "1",
                app_icon: "  txcdn.wqop2018.com/guanggao/628b546a2626219134503104fefbb9e1.png",
                app_icon_str: "",
                app_id: "14437",
                app_qrcode: "",
                app_title: "山坡越野车5",
                app_type: "2",
                appid: "wx111d5d0d7032b58e",
                link_path: "pages/index/index",
                link_text: "1",
                open_ad: "1",
                position_type: "2",
                type: "2",
            },
            {
                app_desc: "1",
                app_icon: "  txcdn.wqop2018.com/guanggao/628b546a2626219134503104fefbb9e1.png",
                app_icon_str: "",
                app_id: "14437",
                app_qrcode: "",
                app_title: "山坡越野车6",
                app_type: "2",
                appid: "wx111d5d0d7032b58e",
                link_path: "pages/index/index",
                link_text: "1",
                open_ad: "1",
                position_type: "2",
                type: "2",
            },
            {
                app_desc: "1",
                app_icon: "  txcdn.wqop2018.com/guanggao/628b546a2626219134503104fefbb9e1.png",
                app_icon_str: "",
                app_id: "14437",
                app_qrcode: "",
                app_title: "山坡越野车7",
                app_type: "2",
                appid: "wx111d5d0d7032b58e",
                link_path: "pages/index/index",
                link_text: "1",
                open_ad: "1",
                position_type: "2",
                type: "2",
            },
            {
                app_desc: "1",
                app_icon: "  txcdn.wqop2018.com/guanggao/628b546a2626219134503104fefbb9e1.png",
                app_icon_str: "",
                app_id: "14437",
                app_qrcode: "",
                app_title: "山坡越野车8",
                app_type: "2",
                appid: "wx111d5d0d7032b58e",
                link_path: "pages/index/index",
                link_text: "1",
                open_ad: "1",
                position_type: "2",
                type: "2",
            },
            {
                app_desc: "1",
                app_icon: "  txcdn.wqop2018.com/guanggao/628b546a2626219134503104fefbb9e1.png",
                app_icon_str: "",
                app_id: "14437",
                app_qrcode: "",
                app_title: "山坡越野车9",
                app_type: "2",
                appid: "wx111d5d0d7032b58e",
                link_path: "pages/index/index",
                link_text: "1",
                open_ad: "1",
                position_type: "2",
                type: "2",
            },
            {
                app_desc: "1",
                app_icon: "  txcdn.wqop2018.com/guanggao/628b546a2626219134503104fefbb9e1.png",
                app_icon_str: "",
                app_id: "14437",
                app_qrcode: "",
                app_title: "山坡越野车10",
                app_type: "2",
                appid: "wx111d5d0d7032b58e",
                link_path: "pages/index/index",
                link_text: "1",
                open_ad: "1",
                position_type: "2",
                type: "2",
            },
        ],
    };

    const ANDROID_APP_ID = {
        TAP: 'qzryjy_android_tap',
        XM: 'qzryjy_android_xm',
        C_233: 'qzryjy_android_233',
        HYKB: 'qzryjy_android_hykb',
        MMY: 'qzryjy_android_mmy',
        TEST: 'qzryjy_android_test',
        C233_ME: 'qzryjy_android_233_me'
    };

    var AD_UTIL_EVENT_TYPE;
    (function(AD_UTIL_EVENT_TYPE) {
        AD_UTIL_EVENT_TYPE[AD_UTIL_EVENT_TYPE["SHARE"] = 1] = "SHARE";
        AD_UTIL_EVENT_TYPE[AD_UTIL_EVENT_TYPE["AD"] = 2] = "AD";
    })(AD_UTIL_EVENT_TYPE || (AD_UTIL_EVENT_TYPE = {}));
    class AdUtil {
        static setButton(button, type, styleFunc = null) {
            if (!button)
                return;
            let rewardCtrl = ConfigManager.getRewardCtrl(type);
            if (RoleManager.getInstance().isShareLimit() ||
                (!RoleManager.getInstance().isAdLimit() && rewardCtrl.list[rewardCtrl.count % rewardCtrl.list.length] == REWARD_WAY.AD)) {
                let img = AdUtil.getImageByName(button, [RES_PATH.IMG_SHARE_ICON]);
                if (img) {
                    img.skin = RES_PATH.IMG_AD_ICON;
                }
                let txt = AdUtil.getLabel(button);
                if (txt) {
                    txt.text = txt.text.replace(/分享/g, "视频");
                }
                if (styleFunc) {
                    styleFunc(AD_UTIL_EVENT_TYPE.AD);
                }
            } else {
                let img = AdUtil.getImageByName(button, [RES_PATH.IMG_AD_ICON]);
                if (img) {
                    img.skin = RES_PATH.IMG_SHARE_ICON;
                }
                let txt = AdUtil.getLabel(button);
                if (txt) {
                    txt.text = txt.text.replace(/视频/g, "分享");
                }
                if (styleFunc) {
                    styleFunc(AD_UTIL_EVENT_TYPE.SHARE);
                }
            }
        }
        static getImageByName(root, source) {
            if (!root)
                return false;
            if (root.parent) {
                for (let i = 0; i < root.numChildren; i++) {
                    let img = root.getChildAt(i);
                    if (img instanceof Laya.Image) {
                        for (let k in source) {
                            if (img.skin == source[k]) {
                                return img;
                            }
                        }
                    } else if (img.numChildren) {
                        AdUtil.getImageByName(img, source);
                    }
                }
            } else {
                return false;
            }
        }
        static getLabel(root) {
            if (!root)
                return false;
            if (root.parent) {
                for (let i = 0; i < root.numChildren; i++) {
                    let txt = root.getChildAt(i);
                    if (txt instanceof Laya.Label) {
                        if (txt.text.indexOf("视频") != -1 || txt.text.indexOf("分享") != -1) {
                            return txt;
                        }
                    } else if (txt.numChildren) {
                        AdUtil.getLabel(txt);
                    }
                }
            } else {
                return false;
            }
        }
        static setEvent(success, fail, type, button = null) {
            let rewardCtrl = ConfigManager.getRewardCtrl(type);
            if (ConfigManager.isCP) {
                success();
                return;
            }
            if (ConfigManager.isDebug) {
                success();
                return;
            }
            if (ConfigManager.platform == PLATFORM_TYPE.WEB) {
                SoundManager.resumeBGM();
                rewardCtrl.count++;
                AdUtil.setButton(button, type);
                //success();
                //test
                PlatformUtil.createRewardedVideoAd(rewardCtrl.ad_id, function() {
                    rewardCtrl.count++;
                    console.log('观看视频成功');
                    AdUtil.setButton(button, type);
                    success(AD_UTIL_EVENT_TYPE.AD);
                    SoundManager.resumeBGM();
                }, function() {
                    fail(AD_UTIL_EVENT_TYPE.AD);
                    SoundManager.resumeBGM();
                }, function() {
                    fail(AD_UTIL_EVENT_TYPE.AD);
                    SoundManager.resumeBGM();
                });
                return;
            }
            if (ConfigManager.platform == PLATFORM_TYPE.WEB_4399) {
                console.log("播放激励视频");
                AdUtil.setButton(button, type);
                LoadingMaskViewCtrl.hide();
                PlatformUtil.createRewardedVideoAd(rewardCtrl.ad_id, function() {
                    rewardCtrl.count++;
                    console.log('观看视频成功');
                    AdUtil.setButton(button, type);
                    success(AD_UTIL_EVENT_TYPE.AD);
                    SoundManager.resumeBGM();
                }, function() {
                    fail(AD_UTIL_EVENT_TYPE.AD);
                    SoundManager.resumeBGM();
                }, function() {
                    fail(AD_UTIL_EVENT_TYPE.AD);
                    SoundManager.resumeBGM();
                });
                return;
            }
            let shareSuccess = function() {
                PlatformUtil.reportAnalyise(ANALYISE_ID.SHARE + rewardCtrl.info);
                rewardCtrl.count++;
                AdUtil.setButton(button, type);
                success(AD_UTIL_EVENT_TYPE.SHARE);
            };
            let shareFail = function() {
                rewardCtrl.count++;
                AdUtil.setButton(button, type);
                fail(AD_UTIL_EVENT_TYPE.SHARE);
            };
            let adSuccess = function() {
                console.log('视频成功回调-----------------------------------');
                PlatformUtil.reportAnalyise(ANALYISE_ID.AD + rewardCtrl.info);
                rewardCtrl.count++;
                AdUtil.setButton(button, type);
                success(AD_UTIL_EVENT_TYPE.AD);
                SoundManager.resumeBGM();
                LoadingMaskViewCtrl.hide();
            }.bind(this);
            let adFil = function() {
                console.log('视频失败回调------------------------------------');
                rewardCtrl.count++;
                AdUtil.setButton(button, type);
                fail(AD_UTIL_EVENT_TYPE.AD);
                SoundManager.resumeBGM();
                LoadingMaskViewCtrl.hide();
            }.bind(this);
            let isShowLimit = RoleManager.getInstance().isShareLimit(); {
                SoundManager.stopBGM();
                LoadingMaskViewCtrl.show();
                PlatformUtil.createRewardedVideoAd(rewardCtrl.ad_id, adSuccess, function() {
                    console.log('ad fail');
                    adFil();
                    if (ConfigManager.platform == PLATFORM_TYPE.WX || ConfigManager.platform == PLATFORM_TYPE.QQ) {
                        PlatformUtil.showModal('提示', '无可观看的广告', false, null, null, '确定', null, '取消', null);
                        AdUtil.setButton(button, type);
                    }
                }.bind(this), adFil);
            }
        }
        static shareMessage(query = '', success = null, fail = null, dialog = false, sec = null, cancel = null) {
            AdUtil.share.dialog = dialog;
            AdUtil.share.configSec = sec ? sec : ConfigManager.getConfig().share_sec;
            AdUtil.share.cancel = cancel;
            let exe = function() {
                ConfigManager.getShare(function(data) {
                    if (success) {
                        AdUtil.startTimer();
                        AdUtil.share.success = function() {
                            setTimeout(function() {
                                success();
                            }, 500);
                        };
                    }
                    AdUtil.share.fail = fail;
                    PlatformUtil.shareAppMessage(data.title, data.img, query);
                });
            };
            exe();
            AdUtil.share.exe = exe;
        }
        static startTimer() {
            AdUtil.share.shareSec = Math.floor(new Date().getTime() / 1000);
        }
        static triggerShareEvent() {
            let curSec = Math.floor(new Date().getTime() / 1000);
            let sec = AdUtil.share.configSec;
            if (AdUtil.share.shareSec && curSec - AdUtil.share.shareSec > sec) {
                if (AdUtil.share.success) {
                    AdUtil.share.success();
                    AdUtil.share.shareSec = null;
                    AdUtil.share.success = null;
                    AdUtil.share.fail = null;
                    AdUtil.share.dialog = null;
                    AdUtil.share.exe = null;
                    AdUtil.share.configSec = null;
                    AdUtil.share.cancel = null;
                }
            } else {
                if (AdUtil.share.fail) {
                    AdUtil.share.fail();
                    if (AdUtil.share.dialog) {
                        AdUtil.share.configSec = 2;
                        PlatformUtil.showModal('提示', '分享失败，请分享给好友哦', true, function() {
                            if (AdUtil.share && AdUtil.share.exe)
                                AdUtil.share.exe();
                        }, function() {
                            if (AdUtil.share.cancel)
                                AdUtil.share.cancel();
                            AdUtil.share.shareSec = null;
                            AdUtil.share.success = null;
                            AdUtil.share.fail = null;
                            AdUtil.share.dialog = null;
                            AdUtil.share.exe = null;
                            AdUtil.share.configSec = null;
                            AdUtil.share.cancel = null;
                        }, '确定', '#129330', '放弃奖励', '#000000');
                    }
                }
            }
        }
        static createBannerAd() {
            if (this.isNoAd)
                return;
            let bannderId = AD_BANNER[AdUtil.bannerIdx % AD_BANNER.length];
            if (!bannderId) {
                console.log('没有可用banner id');
                return;
            }
            if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD && ConfigManager.isReviewVersion()) {
                return;
            }
            PlatformUtil.createBannerAd(AD_BANNER[AdUtil.bannerIdx % AD_BANNER.length], false);
            AdUtil.bannerIdx++;
        }
        static preloadBannerAd(cb = null) {
            if (this.isNoAd)
                return;
            if (ConfigManager.platform == PLATFORM_TYPE.QQ || ConfigManager.platform == PLATFORM_TYPE.WX || ConfigManager.platform == PLATFORM_TYPE.TT || ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD || ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS) {
                if (AdUtil.bannerIdx == null)
                    AdUtil.bannerIdx = Math.floor(Math.random() * 100) % AD_BANNER.length;
                console.log('preloadBannerAd');
                let bannderId = AD_BANNER[AdUtil.bannerIdx % AD_BANNER.length];
                if (!bannderId && ConfigManager.platform != PLATFORM_TYPE.NATIVE_ANDRIOD && ConfigManager.platform != PLATFORM_TYPE.NATIVE_IOS) {
                    console.log('没有可用banner id');
                    return;
                }
                if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD && ConfigManager.isReviewVersion()) {
                    return;
                }
                this.showBannerCount++;
                PlatformUtil.createBannerAd(AD_BANNER[AdUtil.bannerIdx % AD_BANNER.length], false, function(is) {
                    cb && cb();
                    if (!is) {
                        AdUtil.showBannerCount = 0;
                        console.log('重置BANNER次数');
                    }
                });
                AdUtil.bannerIdx++;
            }
        }
        static loop() {
            if (ConfigManager.platform == PLATFORM_TYPE.WX || ConfigManager.platform == PLATFORM_TYPE.QQ) {
                Laya.timer.loop(ChannelManager.bannerRefreshTime(), null, function() {
                    if (PlatformUtil.isHideBanner) {} else {
                        PlatformUtil.createBannerAd(AD_BANNER[AdUtil.bannerIdx % AD_BANNER.length], true);
                        AdUtil.bannerIdx++;
                        PlatformUtil.pushBannerCommand(1, function() {
                            console.log('刷新banner');
                        });
                        if (ConfigManager.platform == PLATFORM_TYPE.WX) {
                            PlatformUtil.exeBannerCommand();
                        }
                    }
                });
            }
            Laya.timer.loop(70, this, function() {
                PlatformUtil.exeCustomCommand();
                if (ConfigManager.platform == PLATFORM_TYPE.QQ)
                    PlatformUtil.exeBannerCommand();
            });
        }
        static onHide() {
            if (ConfigManager.platform == PLATFORM_TYPE.WX || ConfigManager.platform == PLATFORM_TYPE.QQ) {
                if (PlatformUtil.isHideBanner) {} else {
                    PlatformUtil.createBannerAd(AD_BANNER[AdUtil.bannerIdx % AD_BANNER.length], true);
                    AdUtil.bannerIdx++;
                    PlatformUtil.pushBannerCommand(1, function() {
                        console.log('刷新banner');
                    });
                    PlatformUtil.exeBannerCommand();
                }
            }
        }
        static hideBannerAd() {
            PlatformUtil.hideBannerAd();
            console.log('hideBannerAd');
            if (ConfigManager.platform == PLATFORM_TYPE.TT || ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD || ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS) {
                if (this.showBannerCount % ConfigManager.getBannerCount() == 0) {
                    this.preloadBannerAd(function() {});
                }
            }
        }
        static showBannerAd(x = null, y = null, viewPos = null, cb = null) {
            if (ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.WEB_4399)
                return;
            if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD && ConfigManager.isReviewVersion()) {
                return;
            }
            if (x != null) {
                if ((ConfigManager.appId == ANDROID_APP_ID.C233_ME || ConfigManager.appId == ANDROID_APP_ID.MMY || ConfigManager.appId == ANDROID_APP_ID.HYKB) || ConfigManager.appId == ANDROID_APP_ID.C_233)
                    return;
                let system = PlatformUtil.getSystemInfo();
                if (system) {
                    let windowWidth = system.windowWidth;
                    x = x / Laya.stage.width * windowWidth;
                }
            }
            if (y != null) {
                if ((ConfigManager.appId == ANDROID_APP_ID.C233_ME || ConfigManager.appId == ANDROID_APP_ID.MMY || ConfigManager.appId == ANDROID_APP_ID.HYKB) || ConfigManager.appId == ANDROID_APP_ID.C_233)
                    return;
                let system = PlatformUtil.getSystemInfo();
                if (system) {
                    let windowHeight = system.windowHeight;
                    y = y / Laya.stage.height * windowHeight;
                }
            }
            if (ConfigManager.platform == PLATFORM_TYPE.QQ || ConfigManager.platform == PLATFORM_TYPE.WX || ConfigManager.platform == PLATFORM_TYPE.TT || ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD || ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS) {
                PlatformUtil.showBannerAd(x, y, function() {
                    AdUtil.showBannerCount++;
                    let count = AdUtil.showBannerCount % ConfigManager.getBannerCount() == 0 ? ConfigManager.getBannerCount() : AdUtil.showBannerCount % ConfigManager.getBannerCount();
                    cb && cb();
                });
            } else {
                if (ConfigManager.platform == PLATFORM_TYPE.OPPO || ConfigManager.platform == PLATFORM_TYPE.VIVO) {
                    if (ConfigManager.platform == PLATFORM_TYPE.VIVO) {
                        if (this.showBannerCount % ConfigManager.getBannerCount() == 0) {
                            AdUtil.createBannerAd();
                        }
                        AdUtil.showBannerCount++;
                        PlatformUtil.showBannerAd();
                    }
                } else {
                    if (AdUtil.bannerIdx == null)
                        AdUtil.bannerIdx = Math.floor(Math.random() * 100) % AD_BANNER.length;
                    let bannderId = AD_BANNER[AdUtil.bannerIdx % AD_BANNER.length];
                    if (!bannderId) {
                        console.log('没有可用banner id');
                        return;
                    }
                    PlatformUtil.createBannerAd(bannderId, false, cb);
                    AdUtil.bannerIdx++;
                }
            }
        }
        static createInterstitialAd() {
            if (AdUtil.interstitialIdx == null)
                AdUtil.interstitialIdx = Math.floor(Math.random() * 100) % AD_INTERSTITIAL.length;
            if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD) {
                if (ConfigManager.isReviewVersion()) {
                    return;
                }
            }
            if (PLATFORM_TYPE.WX == ConfigManager.platform) {
                PlatformUtil.showInterstitialAd(AD_INTERSTITIAL[AdUtil.interstitialIdx % AD_INTERSTITIAL.length], function() {
                    Laya.timer.once(2000, this, function() {
                        AdUtil.preloadInterstitialAd();
                    });
                });
            } else
                PlatformUtil.createInterstitialAd(AD_INTERSTITIAL[AdUtil.interstitialIdx % AD_INTERSTITIAL.length]);
            AdUtil.interstitialIdx++;
        }
        static preloadInterstitialAd() {
            if (AdUtil.interstitialIdx == null)
                AdUtil.interstitialIdx = Math.floor(Math.random() * 100) % AD_INTERSTITIAL.length;
            if (ConfigManager.platform == PLATFORM_TYPE.WX) {
                PlatformUtil.preloadInterstitialAd(AD_INTERSTITIAL[AdUtil.interstitialIdx % AD_INTERSTITIAL.length], function() {});
            }
        }
        static createAppBox() {
            if (AdUtil.appBoxIdx == null)
                AdUtil.appBoxIdx = Math.floor(Math.random() * 100) % AD_APP_BOX.length;
            PlatformUtil.createAppBox(AD_APP_BOX[AdUtil.appBoxIdx % AD_APP_BOX.length]);
            AdUtil.appBoxIdx++;
        }
        static createGirdAd() {
            if (AdUtil.girdIdx == null)
                AdUtil.girdIdx = Math.floor(Math.random() * 100) % AD_GIRD.length;
            let girdIdx = AD_GIRD[AdUtil.girdIdx % AD_GIRD.length];
            if (!girdIdx) {
                console.log('没有可用gird id');
                return;
            }
            PlatformUtil.createGirdAd(AD_GIRD[AdUtil.girdIdx % AD_BANNER.length]);
            AdUtil.girdIdx++;
        }
        static hideGirdAd() {
            PlatformUtil.hideGirdAd();
        }
        static createGamePortalAd() {
            if (AdUtil.oppoGamePortalIdx == null)
                AdUtil.oppoGamePortalIdx = Math.floor(Math.random() * 100) % AD_OPPO_GAME_PORTAL.length;
            PlatformUtil.createGamePortalAd(AD_OPPO_GAME_PORTAL[AdUtil.oppoGamePortalIdx % AD_OPPO_GAME_PORTAL.length]);
            AdUtil.oppoGamePortalIdx++;
        }
        static preloadNativeAdExtend(success = null, fail = null, nativeType) {
            if (nativeType == NATIVE_TYPE.BANNER) {
                this.preloadNativeAdExtendBanner(success, fail);
            } else if (nativeType == NATIVE_TYPE.ICON) {
                this.preloadNativeAdExtendIcon(success, fail);
            }
        }
        static preloadNativeAdExtendBanner(success = null, fail = null) {
            if (ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.WEB_4399) {
                AdUtil.nativeExtendList.data = null;
                AdUtil.nativeExtendList.ad = null;
                return;
                AdUtil.nativeExtendList.ad = {
                    ad: ''
                };
                AdUtil.nativeExtendList.data = {
                    imgUrlList: [RES_PATH.IMG_SHARE_ICON],
                    adId: 0
                };
                NotifyManager.notify(NOTIFY_ID.REFRESH_NATIVE_AD);
                success && success();
                Laya.timer.clearAll(this.preloadNativeAdExtendBanner);
                let time = RoleManager.getInstance().getIsOnceGame() ? ConfigManager.getRefresh_nativeBanner_beforeOnceGame() : ConfigManager.getRefresh_nativeBanner_afterOnceGame();
                Laya.timer.once(time, this, function() {
                    AdUtil.preloadNativeAdExtend(success, fail, NATIVE_TYPE.BANNER);
                    console.log('刷新banner原生广告');
                });
                return;
            }
            if (ConfigManager.platform != PLATFORM_TYPE.OPPO && ConfigManager.platform != PLATFORM_TYPE.VIVO)
                return;
            if (AdUtil.nativeIdx == null)
                AdUtil.nativeIdx = Math.floor(Math.random() * 100) % AD_NAVITE_EXTEND.length;
            let count = 2;
            AdUtil.nativeExtendList.data = null;
            AdUtil.nativeExtendList.ad = null;
            let load = function() {
                count--;
                if (count < 0)
                    return;
                AdUtil.nativeIdx++;
                if (!AD_NAVITE_EXTEND[AdUtil.nativeIdx % AD_NAVITE_EXTEND.length]) {
                    console.log('没有可用native id');
                    return;
                }
                PlatformUtil.preLoadNativeAdExtend(AD_NAVITE_EXTEND[0], function(data, ad) {
                    AdUtil.nativeExtendList.data = data;
                    AdUtil.nativeExtendList.ad = ad;
                    NotifyManager.notify(NOTIFY_ID.REFRESH_NATIVE_AD);
                    success && success();
                }, function() {
                    AdUtil.nativeExtendList.data = null;
                    AdUtil.nativeExtendList.ad = null;
                    NotifyManager.notify(NOTIFY_ID.REFRESH_NATIVE_AD);
                    fail && fail();
                });
            };
            load();
            Laya.timer.clearAll(this.preloadNativeAdExtendBanner);
            let time = RoleManager.getInstance().getIsOnceGame() ? ConfigManager.getRefresh_nativeBanner_beforeOnceGame() : ConfigManager.getRefresh_nativeBanner_afterOnceGame();
            Laya.timer.once(time, this, function() {
                AdUtil.preloadNativeAdExtend(success, fail, NATIVE_TYPE.BANNER);
                console.log('刷新banner原生广告');
            });
        }
        static preloadNativeAdExtendIcon(success = null, fail = null) {
            if (ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.WEB_4399) {
                AdUtil.nativeExtendList.data = null;
                AdUtil.nativeExtendList.ad = null;
                return;
                AdUtil.nativeExtendIconList.ad = {
                    ad: ''
                };
                AdUtil.nativeExtendIconList.data = {
                    imgUrlList: [RES_PATH.IMG_SHARE_ICON],
                    adId: 0
                };
                NotifyManager.notify(NOTIFY_ID.REFRESH_NATIVE_AD);
                success && success();
                Laya.timer.clearAll(this.preloadNativeAdExtendIcon);
                let time = RoleManager.getInstance().getIsOnceGame() ? ConfigManager.getRefresh_nativeIcon_beforeOnceGame() : ConfigManager.getRefresh_nativeIcon_afterOnceGame();
                Laya.timer.once(time, this, function() {
                    AdUtil.preloadNativeAdExtend(success, fail, NATIVE_TYPE.ICON);
                    console.log('刷新icon原生广告');
                });
                return;
            }
            if (ConfigManager.platform != PLATFORM_TYPE.OPPO && ConfigManager.platform != PLATFORM_TYPE.VIVO)
                return;
            if (AdUtil.nativeIdx == null)
                AdUtil.nativeIdx = Math.floor(Math.random() * 100) % AD_NAVITE_EXTEND.length;
            let count = 2;
            AdUtil.nativeExtendIconList.data = null;
            AdUtil.nativeExtendIconList.ad = null;
            let load = function() {
                count--;
                if (count < 0)
                    return;
                AdUtil.nativeIdx++;
                if (!AD_NAVITE_EXTEND[AdUtil.nativeIdx % AD_NAVITE_EXTEND.length]) {
                    console.log('没有可用native id');
                    return;
                }
                PlatformUtil.preLoadNativeAdExtend(AD_NAVITE_EXTEND[1], function(data, ad) {
                    AdUtil.nativeExtendIconList.data = data;
                    AdUtil.nativeExtendIconList.ad = ad;
                    NotifyManager.notify(NOTIFY_ID.REFRESH_NATIVE_AD);
                    success && success();
                }, function() {
                    AdUtil.nativeExtendIconList.data = null;
                    AdUtil.nativeExtendIconList.ad = null;
                    NotifyManager.notify(NOTIFY_ID.REFRESH_NATIVE_AD);
                    fail && fail();
                });
            };
            load();
            Laya.timer.clearAll(this.preloadNativeAdExtendIcon);
            let time = RoleManager.getInstance().getIsOnceGame() ? ConfigManager.getRefresh_nativeIcon_beforeOnceGame() : ConfigManager.getRefresh_nativeIcon_afterOnceGame();
            Laya.timer.once(time, this, function() {
                AdUtil.preloadNativeAdExtend(success, fail, NATIVE_TYPE.ICON);
                console.log('刷新icon原生广告');
            });
        }
        static getNativeAdData(success, fail) {
            if (ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.WEB_4399) {
                success({}, {
                    imgUrlList: [RES_PATH.IMG_SHARE_ICON],
                    adId: 0
                });
                return;
            }
            PlatformUtil.showNativeAd(success, fail);
        }
        static timerRefreshNativeBanner() {
            if (ConfigManager.platform != PLATFORM_TYPE.OPPO && ConfigManager.platform != PLATFORM_TYPE.WEB && ConfigManager.platform != PLATFORM_TYPE.VIVO && ConfigManager.platform != PLATFORM_TYPE.WEB_4399)
                return;
            let load = function() {
                console.log('刷新原生广告');
                AdUtil.preloadNativeAdExtend(function(data, ad) {}, function() {}, NATIVE_TYPE.BANNER);
            };
            load();
        }
        static timerRefreshNativIcon() {
            if (ConfigManager.platform != PLATFORM_TYPE.OPPO && ConfigManager.platform != PLATFORM_TYPE.WEB && ConfigManager.platform != PLATFORM_TYPE.VIVO && ConfigManager.platform != PLATFORM_TYPE.WEB_4399)
                return;
            let load = function() {
                console.log('刷新原生广告');
                AdUtil.preloadNativeAdExtend(function(data, ad) {}, function() {}, NATIVE_TYPE.ICON);
            };
            load();
        }
        static createFullscreenVideo(id, cb) {
            let curTime = new Date().getTime();
            if (ConfigManager.isReviewVersion()) {
                cb && cb();
                return;
            }
            this.fullscreenVideoTime = curTime;
            if (ConfigManager.isShowFullscreen) {
                let isDo = true;
                LoadingMaskViewCtrl.show(function() {
                    isDo && cb && cb();
                    isDo = false;
                });
                PlatformUtil.createFullscreenVideo(id, function() {
                    LoadingMaskViewCtrl.hide();
                    isDo && cb && cb();
                    isDo = false;
                }, function() {
                    LoadingMaskViewCtrl.hide();
                });
            } else {
                cb();
            }
        }
        static createCustomAd(x, y, style, isHide = false) {
            if (this.isNoAd)
                return;
            if (PLATFORM_TYPE.NATIVE_ANDRIOD == ConfigManager.platform) {
                if (ConfigManager.appId == ANDROID_APP_ID.XM)
                    PlatformUtil.createCustomAd('andriod', x, y, style);
                return;
            }
            if (!ConfigManager.carelessCtrl())
                return;
            let customIdx = AD_CUSTOM[AdUtil.customIdx % AD_CUSTOM.length];
            if (style == WX_CUSTOM_AD_STYLE.HORIZONTAL) {
                customIdx = AD_CUSTOM_H[AdUtil.customIdx % AD_CUSTOM_H.length];
            } else if (style == WX_CUSTOM_AD_STYLE.VERTICAL) {
                customIdx = AD_CUSTOM_V[AdUtil.customIdx % AD_CUSTOM_V.length];
            } else if (style == WX_CUSTOM_AD_STYLE.MATRIX) {
                customIdx = AD_CUSTOM_MATRIX[AdUtil.customIdx % AD_CUSTOM_MATRIX.length];
            } else if (style == WX_CUSTOM_AD_STYLE.SINGLE_1) {
                customIdx = AD_CUSTOM_1[AdUtil.customIdx % AD_CUSTOM_1.length];
            }
            if (!customIdx) {
                console.log('没有可用custom id');
                return;
            }
            if (style == WX_CUSTOM_AD_STYLE.HORIZONTAL) {
                PlatformUtil.createCustomAd(AD_CUSTOM_H[AdUtil.customIdx % AD_CUSTOM_H.length], x, y, style, null, null, isHide);
            } else if (style == WX_CUSTOM_AD_STYLE.VERTICAL) {
                PlatformUtil.createCustomAd(AD_CUSTOM_V[AdUtil.customIdx % AD_CUSTOM_V.length], x, y, style, null, null, isHide);
            } else if (style == WX_CUSTOM_AD_STYLE.MATRIX) {
                PlatformUtil.createCustomAd(AD_CUSTOM_MATRIX[AdUtil.customIdx % AD_CUSTOM_MATRIX.length], x, y, style, null, null, isHide);
            } else if (style == WX_CUSTOM_AD_STYLE.SINGLE_1) {
                PlatformUtil.createCustomAd(AD_CUSTOM_1[AdUtil.customIdx % AD_CUSTOM_1.length], x, y, style, null, null, isHide);
            } else {
                PlatformUtil.createCustomAd(AD_CUSTOM[AdUtil.customIdx % AD_CUSTOM.length], x, y, style, null, null, isHide);
            }
            AdUtil.customIdx++;
        }
        static preloadCustom() {
            let size = PlatformUtil.getCustomMatrixSize();
            let x = Laya.stage.width / 2 - size.w - 16;
            let y = Laya.stage.height / 2 - size.h / 2;
            let x1 = Laya.stage.width / 2 + 16;
            this.createCustomAd(x, y, WX_CUSTOM_AD_STYLE.MATRIX, true);
            this.createCustomAd(x1, y, WX_CUSTOM_AD_STYLE.MATRIX, true);
        }
        static showCustom(x, y, style = WX_CUSTOM_AD_STYLE.SINGLE, success = null, fail = null, close = null) {
            if (ConfigManager.platform != PLATFORM_TYPE.WX && ConfigManager.platform != PLATFORM_TYPE.QQ && (ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD && ConfigManager.appId != ANDROID_APP_ID.XM))
                return;
            let customIdx = AD_CUSTOM[AdUtil.customIdx % AD_CUSTOM.length];
            if (style == WX_CUSTOM_AD_STYLE.HORIZONTAL) {
                customIdx = AD_CUSTOM_H[AdUtil.customIdx % AD_CUSTOM_H.length];
            } else if (style == WX_CUSTOM_AD_STYLE.VERTICAL) {
                customIdx = AD_CUSTOM_V[AdUtil.customIdx % AD_CUSTOM_V.length];
            } else if (style == WX_CUSTOM_AD_STYLE.MATRIX) {
                customIdx = AD_CUSTOM_MATRIX[AdUtil.customIdx % AD_CUSTOM_MATRIX.length];
            } else if (style == WX_CUSTOM_AD_STYLE.SINGLE_1) {
                customIdx = AD_CUSTOM_1[AdUtil.customIdx % AD_CUSTOM_1.length];
            }
            if (!customIdx && PLATFORM_TYPE.NATIVE_ANDRIOD != ConfigManager.platform) {
                console.log('没有可用custom id');
                return;
            }
            let adUnitId = customIdx;
            if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD) {
                adUnitId = 'andriod';
                if (style != WX_CUSTOM_AD_STYLE.SINGLE)
                    return;
            }
            let key = adUnitId + '_' + style + '_' + x + '_' + y;
            PlatformUtil.showCustomAd(adUnitId, x, y, style, function() {
                success && success();
                if (AdUtil.customCount[key] != null) {
                    AdUtil.customCount[key]++;
                } else {
                    AdUtil.customCount[key] = 0;
                }
            }, fail);
        }
        static hideCustom(x, y, style = WX_CUSTOM_AD_STYLE.SINGLE, side = 0) {
            if (ConfigManager.platform != PLATFORM_TYPE.WX && ConfigManager.platform != PLATFORM_TYPE.QQ && (ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD && ConfigManager.appId != ANDROID_APP_ID.XM))
                return;
            let customIdx = AD_CUSTOM[AdUtil.customIdx % AD_CUSTOM.length];
            if (style == WX_CUSTOM_AD_STYLE.HORIZONTAL) {
                customIdx = AD_CUSTOM_H[AdUtil.customIdx % AD_CUSTOM_H.length];
            } else if (style == WX_CUSTOM_AD_STYLE.VERTICAL) {
                customIdx = AD_CUSTOM_V[AdUtil.customIdx % AD_CUSTOM_V.length];
            } else if (style == WX_CUSTOM_AD_STYLE.MATRIX) {
                customIdx = AD_CUSTOM_MATRIX[AdUtil.customIdx % AD_CUSTOM_MATRIX.length];
            } else if (style == WX_CUSTOM_AD_STYLE.SINGLE_1) {
                customIdx = AD_CUSTOM_1[AdUtil.customIdx % AD_CUSTOM_1.length];
            }
            if (!customIdx && PLATFORM_TYPE.NATIVE_ANDRIOD != ConfigManager.platform) {
                console.log('没有可用custom id');
                return;
            }
            let adUnitId = customIdx;
            if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD) {
                adUnitId = 'andriod';
                if (style != WX_CUSTOM_AD_STYLE.SINGLE)
                    return;
            }
            PlatformUtil.hideCustomAd(adUnitId, x, y, style);
            let key = adUnitId + '_' + style + '_' + x + '_' + y;
            if (AdUtil.customCount[key] != null) {
                if (AdUtil.customCount[key] >= ConfigManager.getCustomCount()) {
                    console.log('格子刷新' + key);
                    AdUtil.customCount[key] = 0;
                    PlatformUtil.createCustomAd(adUnitId, x, y, style);
                }
            } else {
                AdUtil.customCount[key] = 0;
            }
        }
    }
    AdUtil.share = {
        success: null,
        fail: null,
        shareSec: null,
        dialog: false,
        exe: null,
        configSec: null,
        cancel: null,
    };
    AdUtil.interstitialIdx = null;
    AdUtil.bannerIdx = null;
    AdUtil.appBoxIdx = null;
    AdUtil.girdIdx = null;
    AdUtil.oppoGamePortalIdx = null;
    AdUtil.nativeIdx = null;
    AdUtil.nativeExtendList = {
        data: null,
        ad: null
    };
    AdUtil.nativeIconIdx = null;
    AdUtil.nativeExtendIconList = {
        data: null,
        ad: null
    };
    AdUtil.isNoAd = false;
    AdUtil.showBannerCount = 0;
    AdUtil.isOnceCreateBanner = true;
    AdUtil.customIdx = null;
    AdUtil.customCount = {};
    AdUtil.fullscreenVideoTime = new Date().getTime();
    AdUtil.interTouchCount = 0;

    class DanData {
        static getDataByKey(key) {
            if (DanData.cache[key])
                return DanData.cache[key];
            if (key == 1) {
                let template = new DanData();
                template.id = 1;
                template.star = 2;
                template.lv = 0;
                template.name = '菜鸟';
                template.name2 = '菜鸟';
                template.icon = 'img_1.png';
                DanData.cache[key] = template;
                return template;
            } else if (key == 2) {
                let template = new DanData();
                template.id = 2;
                template.star = 2;
                template.lv = 0;
                template.name = '黄铜';
                template.name2 = '黄铜';
                template.icon = 'img_2.png';
                DanData.cache[key] = template;
                return template;
            } else if (key == 3) {
                let template = new DanData();
                template.id = 3;
                template.star = 2;
                template.lv = 2;
                template.name = '青铜II';
                template.name2 = '青铜';
                template.icon = 'img_3.png';
                DanData.cache[key] = template;
                return template;
            } else if (key == 4) {
                let template = new DanData();
                template.id = 4;
                template.star = 2;
                template.lv = 1;
                template.name = '青铜I';
                template.name2 = '青铜';
                template.icon = 'img_3.png';
                DanData.cache[key] = template;
                return template;
            } else if (key == 5) {
                let template = new DanData();
                template.id = 5;
                template.star = 3;
                template.lv = 3;
                template.name = '白银III';
                template.name2 = '白银';
                template.icon = 'img_4.png';
                DanData.cache[key] = template;
                return template;
            } else if (key == 6) {
                let template = new DanData();
                template.id = 6;
                template.star = 3;
                template.lv = 2;
                template.name = '白银II';
                template.name2 = '白银';
                template.icon = 'img_4.png';
                DanData.cache[key] = template;
                return template;
            } else if (key == 7) {
                let template = new DanData();
                template.id = 7;
                template.star = 3;
                template.lv = 1;
                template.name = '白银I';
                template.name2 = '白银';
                template.icon = 'img_4.png';
                DanData.cache[key] = template;
                return template;
            } else if (key == 8) {
                let template = new DanData();
                template.id = 8;
                template.star = 3;
                template.lv = 3;
                template.name = '黄金III';
                template.name2 = '黄金';
                template.icon = 'img_5.png';
                DanData.cache[key] = template;
                return template;
            } else if (key == 9) {
                let template = new DanData();
                template.id = 9;
                template.star = 3;
                template.lv = 2;
                template.name = '黄金II';
                template.name2 = '黄金';
                template.icon = 'img_5.png';
                DanData.cache[key] = template;
                return template;
            } else if (key == 10) {
                let template = new DanData();
                template.id = 10;
                template.star = 3;
                template.lv = 1;
                template.name = '黄金I';
                template.name2 = '黄金';
                template.icon = 'img_5.png';
                DanData.cache[key] = template;
                return template;
            } else if (key == 11) {
                let template = new DanData();
                template.id = 11;
                template.star = 4;
                template.lv = 3;
                template.name = '铂金III';
                template.name2 = '铂金';
                template.icon = 'img_6.png';
                DanData.cache[key] = template;
                return template;
            } else if (key == 12) {
                let template = new DanData();
                template.id = 12;
                template.star = 4;
                template.lv = 2;
                template.name = '铂金II';
                template.name2 = '铂金';
                template.icon = 'img_6.png';
                DanData.cache[key] = template;
                return template;
            } else if (key == 13) {
                let template = new DanData();
                template.id = 13;
                template.star = 4;
                template.lv = 1;
                template.name = '铂金I';
                template.name2 = '铂金';
                template.icon = 'img_6.png';
                DanData.cache[key] = template;
                return template;
            } else if (key == 14) {
                let template = new DanData();
                template.id = 14;
                template.star = 4;
                template.lv = 3;
                template.name = '钻石III';
                template.name2 = '钻石';
                template.icon = 'img_7.png';
                DanData.cache[key] = template;
                return template;
            } else if (key == 15) {
                let template = new DanData();
                template.id = 15;
                template.star = 4;
                template.lv = 2;
                template.name = '钻石II';
                template.name2 = '钻石';
                template.icon = 'img_7.png';
                DanData.cache[key] = template;
                return template;
            } else if (key == 16) {
                let template = new DanData();
                template.id = 16;
                template.star = 4;
                template.lv = 1;
                template.name = '钻石I';
                template.name2 = '钻石';
                template.icon = 'img_7.png';
                DanData.cache[key] = template;
                return template;
            } else if (key == 17) {
                let template = new DanData();
                template.id = 17;
                template.star = 4;
                template.lv = 4;
                template.name = '星耀IV';
                template.name2 = '星耀';
                template.icon = 'img_8.png';
                DanData.cache[key] = template;
                return template;
            } else if (key == 18) {
                let template = new DanData();
                template.id = 18;
                template.star = 4;
                template.lv = 3;
                template.name = '星耀III';
                template.name2 = '星耀';
                template.icon = 'img_8.png';
                DanData.cache[key] = template;
                return template;
            } else if (key == 19) {
                let template = new DanData();
                template.id = 19;
                template.star = 4;
                template.lv = 2;
                template.name = '星耀II';
                template.name2 = '星耀';
                template.icon = 'img_8.png';
                DanData.cache[key] = template;
                return template;
            } else if (key == 20) {
                let template = new DanData();
                template.id = 20;
                template.star = 4;
                template.lv = 1;
                template.name = '星耀I';
                template.name2 = '星耀';
                template.icon = 'img_8.png';
                DanData.cache[key] = template;
                return template;
            } else if (key == 21) {
                let template = new DanData();
                template.id = 21;
                template.star = 5;
                template.lv = 4;
                template.name = '荣耀皇冠IV';
                template.name2 = '荣耀皇冠';
                template.icon = 'img_9.png';
                DanData.cache[key] = template;
                return template;
            } else if (key == 22) {
                let template = new DanData();
                template.id = 22;
                template.star = 5;
                template.lv = 3;
                template.name = '荣耀皇冠III';
                template.name2 = '荣耀皇冠';
                template.icon = 'img_9.png';
                DanData.cache[key] = template;
                return template;
            } else if (key == 23) {
                let template = new DanData();
                template.id = 23;
                template.star = 5;
                template.lv = 2;
                template.name = '荣耀皇冠II';
                template.name2 = '荣耀皇冠';
                template.icon = 'img_9.png';
                DanData.cache[key] = template;
                return template;
            } else if (key == 24) {
                let template = new DanData();
                template.id = 24;
                template.star = 5;
                template.lv = 1;
                template.name = '荣耀皇冠I';
                template.name2 = '荣耀皇冠';
                template.icon = 'img_9.png';
                DanData.cache[key] = template;
                return template;
            } else if (key == 25) {
                let template = new DanData();
                template.id = 25;
                template.star = 5;
                template.lv = 4;
                template.name = '最强王者IV';
                template.name2 = '最强王者';
                template.icon = 'img_10.png';
                DanData.cache[key] = template;
                return template;
            } else if (key == 26) {
                let template = new DanData();
                template.id = 26;
                template.star = 5;
                template.lv = 3;
                template.name = '最强王者III';
                template.name2 = '最强王者';
                template.icon = 'img_10.png';
                DanData.cache[key] = template;
                return template;
            } else if (key == 27) {
                let template = new DanData();
                template.id = 27;
                template.star = 5;
                template.lv = 2;
                template.name = '最强王者II';
                template.name2 = '最强王者';
                template.icon = 'img_10.png';
                DanData.cache[key] = template;
                return template;
            } else if (key == 28) {
                let template = new DanData();
                template.id = 28;
                template.star = 5;
                template.lv = 1;
                template.name = '最强王者I';
                template.name2 = '最强王者';
                template.icon = 'img_10.png';
                DanData.cache[key] = template;
                return template;
            } else if (key == 29) {
                let template = new DanData();
                template.id = 29;
                template.star = 5;
                template.lv = 4;
                template.name = '荣耀王者IV';
                template.name2 = '荣耀王者';
                template.icon = 'img_11.png';
                DanData.cache[key] = template;
                return template;
            } else if (key == 30) {
                let template = new DanData();
                template.id = 30;
                template.star = 5;
                template.lv = 3;
                template.name = '荣耀王者III';
                template.name2 = '荣耀王者';
                template.icon = 'img_11.png';
                DanData.cache[key] = template;
                return template;
            } else if (key == 31) {
                let template = new DanData();
                template.id = 31;
                template.star = 5;
                template.lv = 2;
                template.name = '荣耀王者II';
                template.name2 = '荣耀王者';
                template.icon = 'img_11.png';
                DanData.cache[key] = template;
                return template;
            } else if (key == 32) {
                let template = new DanData();
                template.id = 32;
                template.star = 5;
                template.lv = 1;
                template.name = '荣耀王者I';
                template.name2 = '荣耀王者';
                template.icon = 'img_11.png';
                DanData.cache[key] = template;
                return template;
            } else if (key == 33) {
                let template = new DanData();
                template.id = 33;
                template.star = 5;
                template.lv = 4;
                template.name = '超凡大师IV';
                template.name2 = '超凡大师';
                template.icon = 'img_12.png';
                DanData.cache[key] = template;
                return template;
            } else if (key == 34) {
                let template = new DanData();
                template.id = 34;
                template.star = 5;
                template.lv = 3;
                template.name = '超凡大师III';
                template.name2 = '超凡大师';
                template.icon = 'img_12.png';
                DanData.cache[key] = template;
                return template;
            } else if (key == 35) {
                let template = new DanData();
                template.id = 35;
                template.star = 5;
                template.lv = 2;
                template.name = '超凡大师II';
                template.name2 = '超凡大师';
                template.icon = 'img_12.png';
                DanData.cache[key] = template;
                return template;
            } else if (key == 36) {
                let template = new DanData();
                template.id = 36;
                template.star = 5;
                template.lv = 1;
                template.name = '超凡大师I';
                template.name2 = '超凡大师';
                template.icon = 'img_12.png';
                DanData.cache[key] = template;
                return template;
            } else if (key == 37) {
                let template = new DanData();
                template.id = 37;
                template.star = 100000000;
                template.lv = 0;
                template.name = '最强战神';
                template.name2 = '最强战神';
                template.icon = 'img_13.png';
                DanData.cache[key] = template;
                return template;
            }
        }
        static getDataByIndex(index) {
            if (DanData.cache[this.keys[index]])
                return DanData.cache[this.keys[index]];
            return this.getDataByKey(this.keys[index]);
        }
        static getAllData() {
            for (let index = 0; index < this.keys.length; index++) {
                this.getDataByKey(this.keys[index]);
            }
            return DanData.cache;
        }
        clear() {
            DanData.cache = {};
        }
    }
    DanData.cache = {};
    DanData.keys = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37];

    var Vector3 = Laya.Vector3;
    var ShuriKenParticle3D = Laya.ShuriKenParticle3D;
    class CommonUtil {
        static getTouch(time = 250, isEffect = true) {
            if (ConfigManager.platform == PLATFORM_TYPE.WEB_4399) {
                window.focus();
            }
            if (!CommonUtil.isTouch) {
                CommonUtil.isTouch = true;
                setTimeout(function() {
                    CommonUtil.isTouch = false;
                }, time);
                return true;
            } else {
                console.log('按钮点击过快');
                return false;
            }
        }
        static findChildByName(obj, name) {
            if (obj.name == name) {
                return obj;
            } else {
                if (obj.numChildren > 0) {
                    for (let i = 0; i < obj.numChildren; i++) {
                        let ret = CommonUtil.findChildByName(obj.getChildAt(i), name);
                        if (ret)
                            return ret;
                    }
                } else {
                    return null;
                }
            }
        }
        static checkParticle3DLive(obj) {
            if (!(obj instanceof ShuriKenParticle3D))
                return false;
            if (obj.particleSystem.isAlive) {
                return true;
            } else {
                if (obj.numChildren > 0) {
                    for (let i = 0; i < obj.numChildren; i++) {
                        let ret = CommonUtil.checkParticle3DLive(obj.getChildAt(i));
                        if (ret)
                            return ret;
                    }
                } else {
                    return false;
                }
            }
        }
        static playParticel3D(obj) {
            if (obj instanceof ShuriKenParticle3D) {
                obj.particleSystem.play();
            }
            if (obj.numChildren > 0) {
                for (let i = 0; i < obj.numChildren; i++) {
                    CommonUtil.playParticel3D(obj.getChildAt(i));
                }
            }
        }
        static pauseParticel3D(obj) {
            if (obj instanceof ShuriKenParticle3D) {
                obj.particleSystem.pause();
            }
            if (obj.numChildren > 0) {
                for (let i = 0; i < obj.numChildren; i++) {
                    CommonUtil.pauseParticel3D(obj.getChildAt(i));
                }
            }
        }
        static angle3(_a, _b) {
            let c = Vector3.dot(_a, _b);
            c = c / (Vector3.scalarLength(_a) * Vector3.scalarLength(_b));
            let angle = Math.acos(c) / Math.PI * 180;
            return angle;
        }
        static angle2(start, end) {
            let sin = start.x * end.y - end.x * start.y;
            let cos = start.x * end.x + start.y * end.y;
            return Math.atan2(sin, cos) * (180 / Math.PI);
        }
        static recordSec() {
            CommonUtil.sec = new Date().getTime();
        }
        static getTimeCost() {
            let sec = new Date().getTime();
            let cost = sec - CommonUtil.sec;
            return cost;
        }
        static getComponents(node, componentType, list) {
            let component = node.getComponent(componentType);
            if (component) {
                list.push(component);
            }
            if (node.numChildren > 0) {
                for (let i = 0; i < node.numChildren; i++) {
                    CommonUtil.getComponents(node.getChildAt(i), componentType, list);
                }
            }
        }
        static getAllChildrenByName(node, name, list) {
            if (node.name == name) {
                list.push(node);
            }
            if (node.numChildren > 0) {
                for (let i = 0; i < node.numChildren; i++) {
                    CommonUtil.getAllChildrenByName(node.getChildAt(i), name, list);
                }
            }
        }
        static getAllChildrenContainName(node, name, list) {
            if (node.name.indexOf(name) != -1) {
                list.push(node);
            }
            if (node.numChildren > 0) {
                for (let i = 0; i < node.numChildren; i++) {
                    CommonUtil.getAllChildrenContainName(node.getChildAt(i), name, list);
                }
            }
        }
        static GetRigidBodyInstance(target) {
            return target.getComponent(Laya.Rigidbody3D);
        }
        static GetPhysicsColliderInstance(target) {
            return target.getComponent(Laya.PhysicsCollider) ? target.getComponent(Laya.PhysicsCollider) : target.getComponent(Laya.PhysicsCollider);
        }
        static SetColliderGroup(target, group) {
            target.collisionGroup = group;
        }
        static CanCollideWith(target, ...canGroups) {
            let canWith = 0;
            for (let group of canGroups) {
                canWith = canWith | group;
            }
            target.canCollideWith = canWith;
        }
        static IgnoreCollision(target, ...ignore) {
            let canWith = Laya.Physics3DUtils.COLLISIONFILTERGROUP_ALLFILTER;
            for (let group of ignore) {
                canWith = canWith ^ group;
            }
            target.canCollideWith = canWith;
        }
        static getAllChildrenOfClass(node, type, list) {
            if (node instanceof type) {
                list.push(node);
            }
            if (node.numChildren > 0) {
                for (let i = 0; i < node.numChildren; i++) {
                    CommonUtil.getAllChildrenOfClass(node.getChildAt(i), type, list);
                }
            }
        }
        static getRandomInt(max, min) {
            var poor = Math.abs(max - min);
            let theRandomNumber = Math.random();
            poor = theRandomNumber * poor;
            poor = poor - poor % 1;
            if (poor + min > max) {
                return max;
            }
            return poor + min;
        }
        static getRandomIntArray(max, min, count) {
            if (count < 0 || count > max - min)
                return;
            let array = [];
            let num = this.getRandomInt(max, min);
            array.push(num);
            for (let index = 1; index < count; index++) {
                num = this.getRandomInt(max, min);
                while (array.find(function(value) {
                        if (num == value) {
                            return true;
                        } else
                            return false;
                    }) != undefined) {
                    num = this.getRandomInt(max, min);
                }
                array.push(num);
            }
            array.sort(function(a, b) {
                if (a > b)
                    return 1;
                else
                    return -1;
            });
            return array;
        }
    }
    CommonUtil.sec = 0;
    CommonUtil.isTouch = false;
    CommonUtil.Vector3 = {
        up: new Vector3(0, 1, 0),
        down: new Vector3(0, -1, 0),
        right: new Vector3(1, 0, 0),
        left: new Vector3(-1, 0, 0),
        forward: new Vector3(0, 0, 1),
        back: new Vector3(0, 0, -1),
        zero: new Vector3(),
    };
    var ColliderTarget;
    (function(ColliderTarget) {
        ColliderTarget[ColliderTarget["AI"] = Laya.Physics3DUtils.COLLISIONFILTERGROUP_CUSTOMFILTER2] = "AI";
        ColliderTarget[ColliderTarget["PLAYER"] = Laya.Physics3DUtils.COLLISIONFILTERGROUP_CHARACTERFILTER] = "PLAYER";
    })(ColliderTarget || (ColliderTarget = {}));

    class ResourceManager {
        static downloadPackage(packageName, success, fail) {
            if (ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.WEB_4399) {
                success();
                return;
            }
            ResourceManager.cleanOtherVer();
            let folderPath = `${WX_USER_PACKAGE_PATH}/${packageName}`;
            let mgr = wx.getFileSystemManager();
            let load = function() {
                CommonUtil.recordSec();
                wx.downloadFile({
                    url: `${ResourceManager.downloadUrl}/${ConfigManager.resVer}/${packageName}.zip`,
                    header: null,
                    success: function(res) {
                        console.log('download success', `${ResourceManager.downloadUrl}/${ConfigManager.resVer}/${packageName}.zip`);
                        let unZip = function() {
                            mgr.unzip({
                                zipFilePath: res.tempFilePath,
                                targetPath: folderPath,
                                success: function() {
                                    ResourceManager.logUserPackage();
                                    let data = wx.getStorageSync(STORAGE_ID.RES_VERTION + ConfigManager.resVer);
                                    let json = JSON.parse(data);
                                    json[packageName] = 1;
                                    wx.setStorageSync(STORAGE_ID.RES_VERTION + ConfigManager.resVer, JSON.stringify(json));
                                    if (success)
                                        success();
                                },
                                fail: function(res) {
                                    console.log("upzip fail", res);
                                    if (fail)
                                        fail();
                                },
                            });
                        };
                        mgr.access({
                            path: folderPath,
                            success: function() {
                                console.log(folderPath + 'is exist');
                                unZip();
                            },
                            fail: function() {
                                console.log(folderPath + 'is no');
                                mgr.mkdirSync(folderPath, true);
                                unZip();
                            }
                        });
                    },
                    fail: function() {
                        console.log(`download fail`, `${ResourceManager.downloadUrl}/${ConfigManager.resVer}/${packageName}.zip`);
                        fail();
                    },
                    complete: null
                });
            };
            let data = wx.getStorageSync(STORAGE_ID.RES_VERTION + ConfigManager.resVer);
            if (!data || data == "") {
                wx.setStorageSync(STORAGE_ID.RES_VERTION + ConfigManager.resVer, JSON.stringify({}));
                load();
            } else {
                mgr.access({
                    path: folderPath,
                    success: function() {
                        console.log(packageName + 'is exist');
                        success();
                    },
                    fail: function() {
                        console.log(packageName + 'is no');
                        load();
                    }
                });
            }
        }
        static unZip(name, success, fail) {
            if (ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.WEB_4399 || !ConfigManager.isUnZip) {
                success();
                return;
            }
            let folderPath = `${WX_USER_PACKAGE_PATH}/${name}/compress`;
            let unzip = function() {
                let exec = function() {
                    PlatformUtil.unzip(`/${name}/compress.zip`, folderPath, function() {
                        console.log(`unzip ${name} success`);
                        let data = Laya.LocalStorage.getItem(STORAGE_ID.RES_VERTION + ConfigManager.resVer);
                        let json = JSON.parse(data);
                        json[name] = 1;
                        Laya.LocalStorage.setItem(STORAGE_ID.RES_VERTION + ConfigManager.resVer, JSON.stringify(json));
                        success();
                    }, function() {
                        console.log(`unzip ${name} fail`);
                        fail();
                    });
                };
                PlatformUtil.mkdir(folderPath, function() {
                    exec();
                }, function() {
                    exec();
                });
            };
            let data = Laya.LocalStorage.getItem(STORAGE_ID.RES_VERTION + ConfigManager.resVer);
            if (!data || data == "") {
                Laya.LocalStorage.setItem(STORAGE_ID.RES_VERTION + ConfigManager.resVer, JSON.stringify({}));
            }
            PlatformUtil.accessFile(folderPath, function() {
                console.log(`${WX_USER_PACKAGE_PATH}/${name} is exist`);
                success();
            }, function() {
                console.log(`${WX_USER_PACKAGE_PATH}/${name} no exist`);
                unzip();
            });
        }
        static deletePackage(packageName) {
            if (ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.WEB_4399) {
                return;
            }
            ResourceManager.logUserPackage();
            let folderPath = `${WX_USER_PACKAGE_PATH}/${packageName}`;
            PlatformUtil.rmdir(folderPath, function() {
                console.log('deletePackage success');
                ResourceManager.logUserPackage();
                let data = Laya.LocalStorage.getItem(STORAGE_ID.RES_VERTION + ConfigManager.resVer);
                if (data && data.length > 0) {
                    let json = JSON.parse(data);
                    json[packageName] = null;
                    delete json[packageName];
                    Laya.LocalStorage.setItem(STORAGE_ID.RES_VERTION + ConfigManager.resVer, JSON.stringify(json));
                }
            }, null);
        }
        static cleanOtherVer(cb = null) {
            if (ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.WEB_4399)
                return;
            PlatformUtil.readdir(WX_USER_PACKAGE_ROOT, function(files) {
                console.log('cleanOtherVer readdir filse', files);
                if (ConfigManager.platform == PLATFORM_TYPE.VIVO) {
                    for (let k in files) {
                        let split = files[k].split(WX_USER_PACKAGE_ROOT + '/');
                        files[k] = split[1];
                    }
                }
                let cnt = 0;
                let max = 0;
                for (let k in files) {
                    if (files[k] != ConfigManager.resVer) {
                        max++;
                        Laya.LocalStorage.removeItem(STORAGE_ID.RES_VERTION + files[k]);
                        PlatformUtil.rmdir(WX_USER_PACKAGE_ROOT + '/' + files[k], function() {
                            cnt++;
                            console.log('cleanOtherVer success rmdir files = ', files[k]);
                            if (cnt == max)
                                if (cb)
                                    cb();
                        }, function() {
                            console.log('cleanOtherVer fail rmdir');
                        });
                    }
                }
                if (max == 0) {
                    if (cb)
                        cb();
                }
            }, function() {});
        }
        static logUserPackage() {
            PlatformUtil.fileStat(WX_USER_PACKAGE_ROOT, function(res) {
                console.log('logUserPackage', res);
            }, null);
        }
        static loadSubpackage(name, success, progress, fail = null) {
            if (ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.OPPO || ConfigManager.platform == PLATFORM_TYPE.WEB_4399) {
                success();
                return;
            }
            PlatformUtil.loadSubpackage(name, success, progress, fail);
        }
        static loadRes(res, complete, progress = null) {
            if (ConfigManager.platform != PLATFORM_TYPE.WEB && ConfigManager.isUnZip && ConfigManager.platform != PLATFORM_TYPE.WEB_4399) {
                if (res instanceof Object) {
                    for (let k in res) {
                        if (res[k].type != Laya.Loader.ATLAS && res[k].type != Laya.Loader.JSON) {
                            res[k].url = `${WX_USER_PACKAGE_PATH}/${res[k].url}`;
                        }
                    }
                } else {
                    let type = Laya.Loader.getTypeFromUrl(res);
                    if (type != Laya.Loader.ATLAS && type != Laya.Loader.JSON) {
                        res = `${WX_USER_PACKAGE_PATH}/${res}`;
                    }
                }
            }
            console.log(res);
            Laya.loader.create(res, complete, progress);
        }
        static getRes(res) {
            let path = res;
            if (ConfigManager.platform != PLATFORM_TYPE.WEB && ConfigManager.isUnZip && ConfigManager.platform != PLATFORM_TYPE.WEB_4399) {
                let type = Laya.Loader.getTypeFromUrl(res);
                if (type != Laya.Loader.ATLAS && type != Laya.Loader.JSON) {
                    path = `${WX_USER_PACKAGE_PATH}/${res}`;
                }
            }
            let obj = Laya.loader.getRes(path);
            return obj;
        }
        static cleanRes(res) {
            let path = res;
            if (ConfigManager.platform != PLATFORM_TYPE.WEB && ConfigManager.isUnZip && ConfigManager.platform != PLATFORM_TYPE.WEB_4399) {
                if (Laya.Loader.getTypeFromUrl(res) != Laya.Loader.ATLAS) {
                    path = `${WX_USER_PACKAGE_PATH}/${res}`;
                }
            }
            let obj = ResourceManager.getRes(res);
            if (obj && obj.destroy) {
                obj.destroy();
                console.log('清理模型与资源 path = ', res);
            }
            Laya.loader.clearRes(path);
            Laya.Resource.destroyUnusedResources();
        }
    }
    ResourceManager.downloadUrl = '  zombie-1255397116.file.myqcloud.com/';

    class RewardManager {
        static setRewardForInsufficientGoldCoins() {
            this.curLackGoldRewards = Math.floor(ARM.getDataByKey(this.id).price * Math.pow(ConfigManager.costGold, RoleManager.getInstance().getBuyByGoldNum())) * this.lackGoldMultiple;
        }
        static reduceLackGoldMultiple() {
            if (this.lackGoldMultiple != 1) {
                this.lackGoldMultiple--;
            }
        }
        static setRewardForInsufficientDiamonds() {
            let id = RoleManager.getInstance().getSynthesisMaxId() > 2 ? RoleManager.getInstance().getSynthesisMaxId() - 2 : RoleManager.getInstance().getSynthesisMaxId();
            this.curLackDiamondsRewards = (ARM.getDataByKey(id).priceByDiamond - 10 <= 0 ? 10 : ARM.getDataByKey(id).priceByDiamond) * this.lackDiamondsMultiple;
        }
        static reduceLackDiamondsMultiple() {
            if (this.lackDiamondsMultiple != 1) {
                this.lackDiamondsMultiple--;
            }
        }
        static setfreeRewardForGoldCoins() {
            this.curFreeGoldRewards = Math.floor(ARM.getDataByKey(this.id).price * Math.pow(ConfigManager.costGold, RoleManager.getInstance().getBuyByGoldNum()) * 2 - 10 + RoleManager.getInstance().getSynthesisMaxId() * (RoleManager.getInstance().getBuyByGoldNum() - RoleManager.getInstance().getSynthesisMaxId()));
        }
        static setfreeDiamondsRewards() {
            let id = RoleManager.getInstance().getSynthesisMaxId() > 2 ? RoleManager.getInstance().getSynthesisMaxId() - 2 : RoleManager.getInstance().getSynthesisMaxId();
            this.curFreeDiamondsRewards = ARM.getDataByKey(id).priceByDiamond - 10 <= 0 ? 10 : ARM.getDataByKey(id).priceByDiamond - 10;
        }
        static setOflineReawrd() {
            this.offlineReawrds = Math.floor(Math.floor(ARM.getDataByKey(this.id).price * Math.pow(ConfigManager.costGold, RoleManager.getInstance().getBuyByGoldNum()) * 5 + RoleManager.getInstance().getGold()) * RoleManager.getInstance().curOffinetime / 5);
        }
        static setSettlementWinDiamondsRewards() {
            let id = RoleManager.getInstance().getSynthesisMaxId() > 2 ? RoleManager.getInstance().getSynthesisMaxId() - 2 : RoleManager.getInstance().getSynthesisMaxId();
            this.settlementWinDiamondsRewards = ARM.getDataByKey(id).priceByDiamond - 10 <= 0 ? 10 * 2 : ARM.getDataByKey(id).priceByDiamond * 2;
        }
        static setSettlementFailDiamondsRewards() {
            let id = RoleManager.getInstance().getSynthesisMaxId() > 2 ? RoleManager.getInstance().getSynthesisMaxId() - 2 : RoleManager.getInstance().getSynthesisMaxId();
            this.settlementFailDiamondsRewards = ARM.getDataByKey(id).priceByDiamond - 10 <= 0 ? Math.floor(10 / 2) : Math.floor(ARM.getDataByKey(id).priceByDiamond / 2);
        }
        static setSettlementWinGoldsRewards() {
            this.settlementWinGoldsRewards = Math.floor((Math.floor(ARM.getDataByKey(this.id).price * Math.pow(ConfigManager.costGold, RoleManager.getInstance().getBuyByGoldNum()))) * 2);
        }
        static setSettlementFailGoldsRewards() {
            this.settlementFailGoldsRewards = Math.floor((Math.floor(ARM.getDataByKey(this.id).price * Math.pow(ConfigManager.costGold, RoleManager.getInstance().getBuyByGoldNum()))) / 2);
        }
        static getSeniorBoxReward() {
            let maxArm = RoleManager.getInstance().getMaxUnLockArm();
            console.log('maxArm:', maxArm);
            if (maxArm >= 3 && maxArm < 4) {
                this.seniorBoxReward.gold = Math.floor(ARM.getDataByKey(maxArm - 2).price * Math.pow(ConfigManager.costGold, RoleManager.getInstance().getBuyByGoldNum()));
                this.seniorBoxReward.diamonds = Math.floor(Math.floor(ARM.getDataByKey(maxArm - 1).priceByDiamond * Math.pow(ConfigManager.costDiamond, RoleManager.getInstance().getBuyByDiamondNum())) / 2);
            } else if (maxArm >= 4) {
                this.seniorBoxReward.gold = Math.floor(ARM.getDataByKey(maxArm - 3).price * Math.pow(ConfigManager.costGold, RoleManager.getInstance().getBuyByGoldNum()));
                console.log('当前金币奖励：', this.seniorBoxReward.gold, ARM.getDataByKey(maxArm - 3).price, ConfigManager.costGold, RoleManager.getInstance().getBuyByGoldNum());
                this.seniorBoxReward.diamonds = Math.floor(Math.floor(ARM.getDataByKey(maxArm - 1).priceByDiamond * Math.pow(ConfigManager.costDiamond, RoleManager.getInstance().getBuyByDiamondNum())) / 2);
            } else {
                this.seniorBoxReward.diamonds = 10;
                this.seniorBoxReward.gold = Math.floor(ARM.getDataByKey(maxArm).price * Math.pow(ConfigManager.costGold, RoleManager.getInstance().getBuyByGoldNum()));
            }
            return this.seniorBoxReward;
        }
        static getPrimaryBoxReward() {
            let maxArm = RoleManager.getInstance().getMaxUnLockArm();
            if (maxArm >= 5) {
                this.primaryBoxReward.gold = this.seniorBoxReward.gold = Math.floor(ARM.getDataByKey(maxArm - 4).price * Math.pow(ConfigManager.costGold, RoleManager.getInstance().getBuyByGoldNum()));
            } else {
                this.primaryBoxReward.gold = 150;
            }
            return this.primaryBoxReward;
        }
    }
    RewardManager.id = 1;
    RewardManager.lackGoldMultiple = 10;
    RewardManager.curLackGoldRewards = 0;
    RewardManager.lackDiamondsMultiple = 3;
    RewardManager.curLackDiamondsRewards = 0;
    RewardManager.curFreeGoldRewards = 0;
    RewardManager.curFreeDiamondsRewards = 0;
    RewardManager.offlineReawrds = 0;
    RewardManager.settlementWinDiamondsRewards = 0;
    RewardManager.settlementFailDiamondsRewards = 0;
    RewardManager.settlementWinGoldsRewards = 0;
    RewardManager.settlementFailGoldsRewards = 0;
    RewardManager.seniorBoxReward = {
        gold: 0,
        diamonds: 0
    };
    RewardManager.primaryBoxReward = {
        gold: 0
    };

    class ReportUtil {
        static reportAnalyise(eventId, data = {}, extraNum = 0, isNewOld = false) {
            PlatformUtil.reportAnalyise(eventId, null, data);
            if (isNewOld) {
                if (RoleManager.getInstance().isNew) {
                    eventId = '新用户' + eventId;
                } else {
                    eventId = '老用户' + eventId;
                }
                PlatformUtil.reportAnalyise(eventId, null, data);
            }
        }
    }

    class DebugManger {
        static log(...args) {
            if (!this._allDebug || !this._logDebug)
                return;
            console.log(...args);
        }
        static get mapDebug() {
            if (!this._allDebug)
                return false;
            return this._mapDebug;
        }
        static get fightDebug() {
            if (!this._allDebug)
                return false;
            return this._fightDebug;
        }
        static get guideDebug() {
            if (!this._allDebug)
                return false;
            return this._guideDebug;
        }
        static get gmDebug() {
            if (!this._allDebug)
                return false;
            return this._gmDebug;
        }
        static get storageDebug() {
            if (!this._allDebug)
                return false;
            return this._storageDebug;
        }
        static get skillDebug() {
            if (!this._allDebug)
                return false;
            return this._skillDebug;
        }
    }
    DebugManger._allDebug = false;
    DebugManger._mapDebug = false;
    DebugManger._logDebug = false;
    DebugManger._fightDebug = true;
    DebugManger._guideDebug = false;
    DebugManger._gmDebug = true;
    DebugManger._storageDebug = false;
    DebugManger._skillDebug = true;

    class UIManager {
        static init(viewCommon = null) {
            this.funcList = [];
            this.autoList = [];
            this.delayList = [];
            this.isAutoOpen = false;
            this.isOpening = false;
            this.viewRoot = new Laya.View();
            this.viewCommon = viewCommon;
            Laya.stage.addChild(this.viewRoot);
            this.viewCommon && Laya.stage.addChild(this.viewCommon);
        }
        static clean() {
            for (let i = this.funcList.length - 1; i >= 0; i--) {
                let func = this.funcList[i];
                func.onDisbale();
                func.onExit();
                func.viewCtrl.destroy();
                func.clean();
            }
            this.viewRoot.destroyChildren();
            this.funcList = [];
            this.autoList = [];
            this.delayList = [];
            this.newFunc = null;
        }
        static _openFunction(funcTag, mode, type, commonMenuStyle, args = null) {
            if (this.isOpening) {
                this.delayList.push({
                    funcTag,
                    args,
                    mode,
                    type,
                    commonMenuStyle
                });
                console.warn('当前有Function正在创建, 不创建新Function, 加入等待列表');
                return;
            }
            for (let i = 0; i < this.funcList.length; i++) {
                if (this.funcList[i].tag == funcTag) {
                    console.warn('不能重复打开界面', this.funcList[i].tag);
                    return;
                }
            }
            this.isOpening = true;
            let functionClass = Laya.ClassUtils.getRegClass(funcTag);
            let newFunc = new functionClass(mode, funcTag, type, commonMenuStyle, args);
            let view = newFunc.createView();
            if (type == FUNCTION_TYPE.WINDOW) {
                view.anchorX = .5;
                view.anchorY = .5;
                view.x = Laya.stage.width * .5;
                view.y = Laya.stage.height * .5;
                let root = new Laya.Box();
                root.width = Laya.stage.width;
                root.height = Laya.stage.height;
                let imgMask = new Laya.Image(RES_PATH.IMG_MASK_BG);
                imgMask.width = root.width;
                imgMask.height = root.height;
                imgMask.alpha = 0;
                imgMask.sizeGrid = '2,4,3,2';
                root.addChild(imgMask);
                root.addChild(view);
                view.scale(0, 0);
                this.commonOpenWindowAnimation(imgMask, view, 0.8);
                this.viewRoot.addChild(root);
            } else {
                this.viewRoot.addChild(view);
            }
            this.newFunc = newFunc;
            ReportUtil.reportAnalyise('打开界面', {
                '功能': this.newFunc.getFunctionName()
            });
            if (view.active) {
                this.onViewCreated();
            } else {
                view.on('onViewCreated', this, this.onViewCreated);
            }
            return newFunc;
        }
        static openFunction(funcTag, mode, type, commonMenuStyle, args = null, cb = null) {
            this.isAutoOpen = false;
            this.openSuccessCB = cb;
            return this._openFunction(funcTag, mode, type, commonMenuStyle, args);
        }
        static onViewCreated() {
            let newFunc = UIManager.newFunc;
            newFunc.request(function() {
                newFunc.setAllButtonAnalysePoint();
                let preFunc = UIManager.funcList[UIManager.funcList.length - 1];
                if (newFunc.mode == FUNCTION_OPEN_MODE.COVER) {
                    if (preFunc) {
                        preFunc.onDisbale();
                    }
                } else {
                    if (preFunc) {
                        UIManager.cleanFunction(preFunc);
                    }
                }
                UIManager.funcList.push(newFunc);
                newFunc.onEnter();
                newFunc.onEnable();
                if (UIManager.viewCommon) {
                    UIManager.viewCommon.setMenuStyle(newFunc.commonStyle);
                }
                if (UIManager.openSuccessCB) {
                    UIManager.openSuccessCB();
                    UIManager.openSuccessCB = null;
                }
                UIManager.isOpening = false;
                DebugManger.log('onViewCreated UIManager.funcList', UIManager.funcList);
                if (UIManager.delayList.length > 0) {
                    let autoData = UIManager.delayList.splice(0, 1)[0];
                    UIManager._openFunction(autoData.funcTag, autoData.mode, autoData.type, autoData.commonMenuStyle, autoData.args);
                }
            });
        }
        static cleanFunction(func) {
            UIManager.funcList.splice(UIManager.funcList.length - 1, 1);
            func.onDisbale();
            func.onExit();
            if (func.type == FUNCTION_TYPE.WINDOW) {} else {
                func.viewCtrl.destroy();
                func.clean();
            }
        }
        static closeFunction() {
            let curFunc = UIManager.funcList[UIManager.funcList.length - 1];
            if (curFunc) {
                let that = this;
                let cb = function() {
                    if (that.autoList.length > 0 && that.autoList[0].depth == that.funcList.length) {
                        let autoData = that.autoList.splice(0, 1)[0];
                        that.isAutoOpen = true;
                        that._openFunction(autoData.funcTag, autoData.mode, autoData.type, autoData.commonMenuStyle, autoData.args);
                    } else {
                        let preFunc = UIManager.funcList[UIManager.funcList.length - 1];
                        if (preFunc) {
                            if (UIManager.viewCommon) {
                                UIManager.viewCommon.setMenuStyle(preFunc.commonStyle);
                            }
                            preFunc.onEnable();
                        }
                        DebugManger.log('closeFunction UIManager.funcList', UIManager.funcList);
                    }
                };
                if (curFunc.type == FUNCTION_TYPE.VIEW) {
                    this.cleanFunction(curFunc);
                    cb();
                } else if (curFunc.type == FUNCTION_TYPE.WINDOW) {
                    let root = curFunc.viewCtrl.parent;
                    let imgMask = root.getChildAt(0);
                    let that = this;
                    this.commonCloseWindowAnimation(imgMask, curFunc.viewCtrl, function() {
                        root.destroy();
                        curFunc.clean();
                        cb();
                    });
                    this.cleanFunction(curFunc);
                }
            } else {
                console.warn('没有function可以关闭!');
            }
        }
        static registerAutoOpenFunction(funcTag, mode, type, commonMenuStyle, args = null, isCanRepetition = false, isUnshift = false) {
            if (!isCanRepetition)
                for (let i = 0; i < this.autoList.length; i++) {
                    if (this.autoList[i].funcTag == funcTag) {
                        console.warn('不能重复注册相同的function!');
                        return;
                    }
                }
            let depth = this.funcList.length;
            if (isUnshift) {
                this.autoList.push({
                    funcTag,
                    args,
                    mode,
                    type,
                    commonMenuStyle,
                    depth,
                    isCanRepetition
                });
            } else
                this.autoList.push({
                    funcTag,
                    args,
                    mode,
                    type,
                    commonMenuStyle,
                    depth,
                    isCanRepetition
                });
            let i = null;
            for (let index = 0; index < this.autoList.length; index++) {
                const element = this.autoList[index];
                if (element.funcTag == FUNCTION_TAG.GET_MODE_REWARD) {
                    i = index;
                }
            }
            if (i != null) {
                let data = this.autoList[i];
                this.autoList.splice(i, 1);
                this.autoList.push(data);
                console.log('模式选择最后弹出');
            }
            console.log(this.autoList);
        }
        static triggerAutoOpen() {
            if (this.autoList.length > 0) {
                let autoData = UIManager.autoList.splice(0, 1)[0];
                this.isAutoOpen = true;
                this._openFunction(autoData.funcTag, autoData.mode, autoData.type, autoData.commonMenuStyle, autoData.args);
            }
        }
        static getFunctionViewCtrl(funcTag) {
            for (let i = 0; i < this.funcList.length; i++) {
                if (this.funcList[i] instanceof Laya.ClassUtils.getRegClass(funcTag)) {
                    return this.funcList[i].viewCtrl;
                }
            }
            return null;
        }
        static getFunction(funcTag) {
            for (let i = 0; i < this.funcList.length; i++) {
                if (this.funcList[i] instanceof Laya.ClassUtils.getRegClass(funcTag)) {
                    return this.funcList[i];
                }
            }
            return null;
        }
        static commonOpenWindowAnimation(imgMask, boxRoot, alpha = 0.8, cb = null) {
            let time = 300;
            let root = boxRoot;
            imgMask.alpha = 0;
            root.scale(0, 0);
            root.centerX = 0.5;
            root.centerY = 0.5;
            Laya.Tween.to(root, {
                scaleX: 1,
                scaleY: 1
            }, time, Laya.Ease.backOut, Laya.Handler.create(this, function() {
                cb && cb();
            }));
            Laya.Tween.to(imgMask, {
                alpha: alpha
            }, time);
            cb && cb();
        }
        static commonCloseWindowAnimation(imgMask, boxRoot, cb = null) {
            let time = 300;
            let root = boxRoot;
            root.centerX = 0.5;
            root.centerY = 0.5;
            Laya.Tween.to(root, {
                scaleX: 0,
                scaleY: 0
            }, time, Laya.Ease.backIn, Laya.Handler.create(this, function() {
                cb && cb();
            }));
            Laya.Tween.to(imgMask, {
                alpha: 0
            }, time);
        }
        static replaceAdIcon(itemList) {
            if (ConfigManager.platform == PLATFORM_TYPE.TT || ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.WEB_4399) {
                for (let k = 0; k < itemList.length; k++) {
                    let item = itemList[k];
                    if (item.type == 1) {
                        item.img.skin = RES_PATH.ADICON.TT_AD_1;
                    }
                }
            }
        }
    }

    class PARTS {
        static getDataByKey(key) {
            if (PARTS.cache[key])
                return PARTS.cache[key];
            if (key == 1) {
                let template = new PARTS();
                template.id = 1;
                template.objName = '01';
                template.cnName = '先锋之翼';
                template.parentNode = 'decorate2';
                template.partType = 2;
                template.cost = 5;
                template.grade = 4;
                template.icon = 'sub1/parts/01.png';
                template.costType = 3;
                template.activityType = 1;
                template.hd = 0;
                PARTS.cache[key] = template;
                return template;
            } else if (key == 2) {
                let template = new PARTS();
                template.id = 2;
                template.objName = '02';
                template.cnName = '无畏之翼';
                template.parentNode = 'decorate2';
                template.partType = 2;
                template.cost = 4;
                template.grade = 4;
                template.icon = 'sub1/parts/02.png';
                template.costType = 3;
                template.activityType = 1;
                template.hd = 0;
                PARTS.cache[key] = template;
                return template;
            } else if (key == 3) {
                let template = new PARTS();
                template.id = 3;
                template.objName = '03';
                template.cnName = '守护者飞行器';
                template.parentNode = 'decorate2';
                template.partType = 2;
                template.cost = 1600;
                template.grade = 4;
                template.icon = 'sub1/parts/03.png';
                template.costType = 2;
                template.activityType = 1;
                template.hd = 0;
                PARTS.cache[key] = template;
                return template;
            } else if (key == 4) {
                let template = new PARTS();
                template.id = 4;
                template.objName = '04';
                template.cnName = '强袭之翼';
                template.parentNode = 'decorate2';
                template.partType = 2;
                template.cost = 15;
                template.grade = 3;
                template.icon = 'sub1/parts/04.png';
                template.costType = 3;
                template.activityType = 1;
                template.hd = 0;
                PARTS.cache[key] = template;
                return template;
            } else if (key == 5) {
                let template = new PARTS();
                template.id = 5;
                template.objName = '05';
                template.cnName = '阿尔法之翼';
                template.parentNode = 'decorate2';
                template.partType = 2;
                template.cost = 25;
                template.grade = 2;
                template.icon = 'sub1/parts/05.png';
                template.costType = 3;
                template.activityType = 1;
                template.hd = 0;
                PARTS.cache[key] = template;
                return template;
            } else if (key == 6) {
                let template = new PARTS();
                template.id = 6;
                template.objName = '06';
                template.cnName = '审判者之翼';
                template.parentNode = 'decorate2';
                template.partType = 2;
                template.cost = 5600;
                template.grade = 2;
                template.icon = 'sub1/parts/06.png';
                template.costType = 2;
                template.activityType = 1;
                template.hd = 0;
                PARTS.cache[key] = template;
                return template;
            } else if (key == 7) {
                let template = new PARTS();
                template.id = 7;
                template.objName = '07';
                template.cnName = '光辉之翼';
                template.parentNode = 'decorate2';
                template.partType = 2;
                template.cost = 38;
                template.grade = 1;
                template.icon = 'sub1/parts/07.png';
                template.costType = 3;
                template.activityType = 1;
                template.hd = 0;
                PARTS.cache[key] = template;
                return template;
            } else if (key == 8) {
                let template = new PARTS();
                template.id = 8;
                template.objName = '08';
                template.cnName = '传说之翼';
                template.parentNode = 'decorate2';
                template.partType = 2;
                template.cost = 40;
                template.grade = 1;
                template.icon = 'sub1/parts/08.png';
                template.costType = 3;
                template.activityType = 1;
                template.hd = 0;
                PARTS.cache[key] = template;
                return template;
            } else if (key == 9) {
                let template = new PARTS();
                template.id = 9;
                template.objName = '09';
                template.cnName = '堕天使之翼';
                template.parentNode = 'decorate2';
                template.partType = 2;
                template.cost = 39;
                template.grade = 1;
                template.icon = 'sub1/parts/09.png';
                template.costType = 3;
                template.activityType = 1;
                template.hd = 0;
                PARTS.cache[key] = template;
                return template;
            } else if (key == 10) {
                let template = new PARTS();
                template.id = 10;
                template.objName = '10';
                template.cnName = '神盾之翼';
                template.parentNode = 'decorate2';
                template.partType = 2;
                template.cost = 37;
                template.grade = 1;
                template.icon = 'sub1/parts/10.png';
                template.costType = 3;
                template.activityType = 1;
                template.hd = 0;
                PARTS.cache[key] = template;
                return template;
            } else if (key == 11) {
                let template = new PARTS();
                template.id = 11;
                template.objName = '11';
                template.cnName = '守护者之刃';
                template.parentNode = 'decorate1';
                template.partType = 1;
                template.cost = 6;
                template.grade = 4;
                template.icon = 'sub1/parts/11.png';
                template.costType = 3;
                template.activityType = 1;
                template.hd = 0;
                PARTS.cache[key] = template;
                return template;
            } else if (key == 12) {
                let template = new PARTS();
                template.id = 12;
                template.objName = '12';
                template.cnName = '离子斩魄刀';
                template.parentNode = 'decorate1';
                template.partType = 1;
                template.cost = 2500;
                template.grade = 3;
                template.icon = 'sub1/parts/12.png';
                template.costType = 2;
                template.activityType = 1;
                template.hd = 0;
                PARTS.cache[key] = template;
                return template;
            } else if (key == 13) {
                let template = new PARTS();
                template.id = 13;
                template.objName = '13';
                template.cnName = '冰息之刃';
                template.parentNode = 'decorate1';
                template.partType = 1;
                template.cost = 2800;
                template.grade = 3;
                template.icon = 'sub1/parts/13.png';
                template.costType = 2;
                template.activityType = 1;
                template.hd = 0;
                PARTS.cache[key] = template;
                return template;
            } else if (key == 14) {
                let template = new PARTS();
                template.id = 14;
                template.objName = '14';
                template.cnName = '金龙';
                template.parentNode = 'decorate1';
                template.partType = 1;
                template.cost = 18;
                template.grade = 3;
                template.icon = 'sub1/parts/14.png';
                template.costType = 3;
                template.activityType = 1;
                template.hd = 0;
                PARTS.cache[key] = template;
                return template;
            } else if (key == 15) {
                let template = new PARTS();
                template.id = 15;
                template.objName = '15';
                template.cnName = '炽天使之翼';
                template.parentNode = 'decorate2';
                template.partType = 2;
                template.cost = 29;
                template.grade = 2;
                template.icon = 'sub1/parts/15.png';
                template.costType = 3;
                template.activityType = 1;
                template.hd = 0;
                PARTS.cache[key] = template;
                return template;
            } else if (key == 17) {
                let template = new PARTS();
                template.id = 17;
                template.objName = '17';
                template.cnName = '零式之翼';
                template.parentNode = 'decorate2';
                template.partType = 2;
                template.cost = 2333;
                template.grade = 4;
                template.icon = 'sub1/parts/17.png';
                template.costType = 2;
                template.activityType = 1;
                template.hd = 0;
                PARTS.cache[key] = template;
                return template;
            } else if (key == 18) {
                let template = new PARTS();
                template.id = 18;
                template.objName = '18';
                template.cnName = '火流星之翼';
                template.parentNode = 'decorate2';
                template.partType = 2;
                template.cost = 8;
                template.grade = 4;
                template.icon = 'sub1/parts/18.png';
                template.costType = 3;
                template.activityType = 1;
                template.hd = 0;
                PARTS.cache[key] = template;
                return template;
            }
        }
        static getDataByIndex(index) {
            if (PARTS.cache[this.keys[index]])
                return PARTS.cache[this.keys[index]];
            return this.getDataByKey(this.keys[index]);
        }
        static getAllData() {
            for (let index = 0; index < this.keys.length; index++) {
                this.getDataByKey(this.keys[index]);
            }
            return PARTS.cache;
        }
        clear() {
            PARTS.cache = {};
        }
    }
    PARTS.cache = {};
    PARTS.keys = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 17, 18];

    let COLLIDENODE = {
        CUBE: 'Cube'
    };
    let OBJ_NAME = {
        PLAYER: 'player',
        CAMREA: 'Camera',
        AI: 'cook',
        LIGHT: 'Directional Light',
        NAV_MESH: 'NavMesh',
        ROBOT: 'robot',
        FIRE_EFFECT: 'fireEffect',
        BULLET: 'bullet',
        BUNKERPOINTS: 'bunkerPoints'
    };
    let EFFECT_NAME = {
        BULLET3: 'Bullet3',
        SHIELD: 'Shield',
        COMPOSE1: 'compose1',
        COMPOSE2: 'compose2',
        FIRE_END: 'jida'
    };
    let SKIN_OBJNAME = {
        ANIMAL: 'animal',
        PURSUER: 'pursuer',
        DUCK: 'duck',
        CHICKEN: 'chicken'
    };
    let HITLOCATION = {
        BODY: 'BODY',
        HEAD: 'HEAD',
        LEG: 'LEG',
        ARM: 'ARM'
    };
    let BUNKERTYPE = {
        NORMAL: 1,
        SPECIAL: 2
    };

    class TriggerQueueData {
        constructor() {}
        getKey() {
            return this.thisBody.onlyID > this.otherBody.onlyID ? this.otherBody.onlyID + "_" + this.thisBody.onlyID : this.thisBody.onlyID + "_" + this.otherBody.onlyID;
        }
        setBody(thisBody, otherBody) {
            this.thisBody = thisBody;
            this.otherBody = otherBody;
        }
    }

    class TriggerQueueDataPool {
        constructor() {
            this.point = 0;
        }
        init(len) {
            this.pool = [];
            this.pool.length = len;
            for (var i = 0; i < len; i++) {
                if (!this.pool[i]) {
                    this.pool[i] = new TriggerQueueData();
                }
            }
            this.point = len - 1;
        }
        get() {
            let ret;
            if (this.point < 0) {
                this.point = 0;
                ret = new TriggerQueueData();
            } else {
                ret = this.pool[this.point];
            }
            this.point--;
            return ret;
        }
        giveBack(value) {
            this.point++;
            if (this.point == this.pool.length) {
                this.pool.push(value);
            } else {
                this.pool[this.point] = value;
            }
        }
        static get instance() {
            if (!TriggerQueueDataPool._instance) {
                TriggerQueueDataPool._instance = new TriggerQueueDataPool();
            }
            return TriggerQueueDataPool._instance;
        }
    }

    class GlobalOnlyValueCell {
        static getOnlyID() {
            GlobalOnlyValueCell.currentID += 1;
            return GlobalOnlyValueCell.currentID;
        }
    }
    GlobalOnlyValueCell.currentID = 0;

    class RayHitResult {
        constructor(succeeded = false, collider, point, distance) {
            this.collider = collider;
            this.point = point;
            this.succeeded = succeeded;
            this.distance = distance;
        }
    }

    var BoundsOctree = Laya.BoundsOctree;
    var BoundBox = Laya.BoundBox;
    var BoundSphere = Laya.BoundSphere;
    var Vector3$1 = Laya.Vector3;
    var MeshSprite3D = Laya.MeshSprite3D;
    var SkinnedMeshSprite3D = Laya.SkinnedMeshSprite3D;
    var Sprite3D = Laya.Sprite3D;
    var Matrix4x4 = Laya.Matrix4x4;
    class CubePhysicsCompnent {
        constructor(owner, isStatic = false, layer = 0) {
            this._boundBox = new BoundBox(new Vector3$1(0, 0, 0), new Vector3$1(0, 0, 0));
            this._boundSpheres = new BoundSphere(new Vector3$1(0, 0, 0), 0);
            this._indexInOctreeMotionList = -1;
            this.isActive = true;
            this.isStatic = isStatic;
            this.layer = layer;
            this.owner = owner;
            this.onlyID = GlobalOnlyValueCell.getOnlyID();
        }
        static overwrite() {}
        isCollision(other) {
            return 0;
        }
        intersectsRay(ray, out) {
            return -1;
        }
        static updataBoundBox() {
            CubePhysicsCompnent.boundBox.setCenterAndExtent(CubePhysicsCompnent.centerSprite, CubePhysicsCompnent.extents);
        }
        static findAllMesh(sprite, Mesharray, renderspriteArray) {
            var tempMesh;
            var childsprite;
            if (!Mesharray)
                Mesharray = [];
            if (sprite instanceof Sprite3D) {
                if (sprite instanceof MeshSprite3D) {
                    tempMesh = sprite.meshFilter.sharedMesh;
                    if (tempMesh)
                        Mesharray.push(tempMesh);
                    renderspriteArray.push(sprite);
                    if ((sprite).numChildren != 0) {
                        for (var i = 0; i < sprite.numChildren; i++) {
                            childsprite = (sprite).getChildAt(i);
                            CubePhysicsCompnent.findAllMesh(childsprite, Mesharray, renderspriteArray);
                        }
                    }
                } else if (sprite instanceof SkinnedMeshSprite3D) {
                    tempMesh = sprite.meshFilter.sharedMesh;
                    if (tempMesh)
                        Mesharray.push(tempMesh);
                    renderspriteArray.push(sprite);
                    if ((sprite).numChildren != 0) {
                        for (var j = 0; j < sprite.numChildren; j++) {
                            childsprite = sprite.getChildAt(j);
                            CubePhysicsCompnent.findAllMesh(childsprite, Mesharray, renderspriteArray);
                        }
                    }
                } else {
                    if ((sprite).numChildren != 0) {
                        for (var k = 0; k < sprite.numChildren; k++) {
                            childsprite = sprite.getChildAt(k);
                            CubePhysicsCompnent.findAllMesh(childsprite, Mesharray, renderspriteArray);
                        }
                    }
                }
            }
        }
        _getOctreeNode() {
            return this._octreeNode;
        }
        _setOctreeNode(value) {
            this._octreeNode = value;
        }
        _getIndexInMotionList() {
            return this._indexInOctreeMotionList;
        }
        _setIndexInMotionList(value) {
            this._indexInOctreeMotionList = value;
        }
        get boundingSphere() {
            return this._boundSpheres;
        }
        get boundingBox() {
            return this._boundBox;
        }
        static isBoundsCollision(Physics1, Physics2) {
            if (!Physics2._octreeNode.isCollidingWithBoundBox(Physics1.boundingBox)) {
                return false;
            }
            return true;
        }
        static rayCastAll(ray, out, layer) {
            let instance = TriggerManager.instance;
            let staticList = instance.staticList;
            for (let k in staticList) {
                let collider = staticList[k];
                if (layer == collider.layer) {
                    let point = new Vector3$1();
                    let distance = collider.intersectsRay(ray, point);
                    if (distance != -1) {
                        let hit = new RayHitResult(true, collider, point, distance);
                        out.push(hit);
                    }
                }
            }
        }
        static rayCast(ray, layer) {
            let rayResultList = new Array();
            CubePhysicsCompnent.rayCastAll(ray, rayResultList, layer);
            if (rayResultList.length > 0) {
                let distance = 0xfffffff;
                let idx = 0;
                for (let i = 0; i < rayResultList.length; i++) {
                    if (rayResultList[i].distance < distance) {
                        idx = i;
                        distance = rayResultList[i].distance;
                    }
                }
                return rayResultList[idx];
            } else {
                return null;
            }
        }
        static clamps(origin, target, clamp, point, excludeList = []) {
            if (origin.x == target.x && origin.y == target.y && origin.z == target.z) {
                target.cloneTo(clamp);
                target.cloneTo(point);
                return;
            }
            let list = [];
            Laya.Vector3.subtract(target, origin, this._ray1.direction);
            Laya.Vector3.normalize(this._ray1.direction, this._ray1.direction);
            origin.cloneTo(this._ray1.origin);
            let max = Laya.Vector3.distance(origin, target);
            let octree = CubePhysicsCompnent.getOCTree();
            octree.getCollidingWithRay(this._ray1, list, max, -1);
            let min = 0xffffff;
            let obb;
            let collider;
            for (let i = 0, len = list.length; i < len; i++) {
                let isExclude = false;
                for (let j = 0; j < excludeList.length; j++) {
                    let obj = list[i];
                    if (obj.onlyID == excludeList[j]) {
                        isExclude = true;
                        break;
                    } else if (obj.layer != -1) {
                        isExclude = true;
                        break;
                    }
                }
                if (isExclude)
                    continue;
                let orientedBoundBox = list[i].orientedBoundBox;
                Vector3$1.scale(orientedBoundBox.extents, -1, this._tempV31);
                orientedBoundBox.transformation.invert(this._tempM0);
                Vector3$1.TransformNormal(this._ray1.direction, this._tempM0, this._ray2.direction);
                Vector3$1.transformCoordinate(this._ray1.origin, this._tempM0, this._ray2.origin);
                this._boxBound1.min = this._tempV31;
                this._boxBound1.max = orientedBoundBox.extents;
                let dis = Laya.CollisionUtils.intersectsRayAndBoxRD(this._ray2, this._boxBound1);
                if (dis != -1 && dis < min) {
                    min = dis;
                    this._ray2.direction.cloneTo(this._ray3.direction);
                    this._ray2.origin.cloneTo(this._ray3.origin);
                    this._boxBound1.cloneTo(this._boxBound2);
                    this._tempM0.cloneTo(this._tempM1);
                    obb = orientedBoundBox;
                    collider = list[i];
                }
            }
            if (min < 0xffffff) {
                if (min > max) {
                    target.cloneTo(clamp);
                    target.cloneTo(point);
                    return;
                }
                Vector3$1.scale(this._ray3.direction, min, point);
                Vector3$1.add(this._ray3.origin, point, point);
                if (Math.abs(point.x - this._boxBound2.min.x) < 1e-5) {
                    this._tempV32.setValue(-1, 0, 0);
                    this._tempV33.setValue(this._boxBound2.min.x, 0, 0);
                } else if (Math.abs(point.x - this._boxBound2.max.x) < 1e-5) {
                    this._tempV32.setValue(1, 0, 0);
                    this._tempV33.setValue(this._boxBound2.max.x, 0, 0);
                } else if (Math.abs(point.y - this._boxBound2.min.y) < 1e-5) {
                    this._tempV32.setValue(0, -1, 0);
                    this._tempV33.setValue(0, this._boxBound2.min.y, 0);
                } else if (Math.abs(point.y - this._boxBound2.max.y) < 1e-5) {
                    this._tempV32.setValue(0, 1, 0);
                    this._tempV33.setValue(0, this._boxBound2.max.y, 0);
                } else if (Math.abs(point.z - this._boxBound2.min.z) < 1e-5) {
                    this._tempV32.setValue(0, 0, -1);
                    this._tempV33.setValue(0, 0, this._boxBound2.min.z);
                } else if (Math.abs(point.z - this._boxBound2.max.z) < 1e-5) {
                    this._tempV32.setValue(0, 0, 1);
                    this._tempV33.setValue(0, 0, this._boxBound2.max.z);
                }
                if (min == 0 && Vector3$1.dot(this._tempV32, this._ray3.direction) >= 0) {
                    target.cloneTo(clamp);
                    Vector3$1.transformV3ToV3(point, obb.transformation, point);
                    return collider;
                }
                Vector3$1.transformV3ToV3(target, this._tempM1, this._tempV34);
                let constant = Vector3$1.dot(this._tempV33, this._tempV32);
                Vector3$1.scale(this._tempV32, -1, this._tempV32);
                let scale = (Vector3$1.dot(this._tempV32, this._tempV34) + constant) * -1;
                this._tempV32.cloneTo(clamp);
                Vector3$1.scale(clamp, scale, clamp);
                Vector3$1.add(clamp, this._tempV34, clamp);
                Vector3$1.transformV3ToV3(clamp, obb.transformation, clamp);
                Vector3$1.transformV3ToV3(point, obb.transformation, point);
                return collider;
            } else {
                target.cloneTo(clamp);
                target.cloneTo(point);
                return;
            }
        }
        static isCollisionFloor(vecOrigin, vecTarget) {
            if (vecTarget.y > vecOrigin.y) {
                return {
                    isCollise: false,
                    y: vecTarget.y
                };
            }
            vecOrigin.cloneTo(this._ray1.origin);
            this._ray1.direction.setValue(0, -1, 0);
            vecTarget.y -= 0.1;
            let max = 1;
            let yDis = Math.abs(vecOrigin.y - vecTarget.y);
            if (yDis > max) {
                max = yDis;
            }
            let list = [];
            let octree = CubePhysicsCompnent.getOCTree();
            octree.getCollidingWithRayWithLayer(this._ray1, list, max, -1);
            let min = 0xffffff;
            let obb;
            let collider;
            for (let i = 0, len = list.length; i < len; i++) {
                let isExclude = false;
                let obj = list[i];
                if (obj.layer != -1) {
                    isExclude = true;
                    break;
                }
                if (isExclude)
                    continue;
                let orientedBoundBox = list[i].orientedBoundBox;
                Vector3$1.scale(orientedBoundBox.extents, -1, this._tempV31);
                orientedBoundBox.transformation.invert(this._tempM0);
                Vector3$1.TransformNormal(this._ray1.direction, this._tempM0, this._ray2.direction);
                Vector3$1.transformCoordinate(this._ray1.origin, this._tempM0, this._ray2.origin);
                this._boxBound1.min = this._tempV31;
                this._boxBound1.max = orientedBoundBox.extents;
                let dis = Laya.CollisionUtils.intersectsRayAndBoxRD(this._ray2, this._boxBound1);
                Vector3$1.scale(this._ray2.direction, dis, this._tempV32);
                Vector3$1.add(this._ray2.origin, this._tempV32, this._tempV32);
                let isUpFace = false;
                if (Math.abs(this._tempV32.x - this._boxBound1.min.x) < 1e-5) {} else if (Math.abs(this._tempV32.x - this._boxBound1.max.x) < 1e-5) {} else if (Math.abs(this._tempV32.y - this._boxBound1.min.y) < 1e-5) {} else if (Math.abs(this._tempV32.y - this._boxBound1.max.y) < 1e-5) {
                    isUpFace = true;
                } else if (Math.abs(this._tempV32.z - this._boxBound1.min.z) < 1e-5) {} else if (Math.abs(this._tempV32.z - this._boxBound1.max.z) < 1e-5) {}
                if (dis < min && dis >= 0 && yDis >= dis && isUpFace) {
                    min = dis;
                    this._ray2.direction.cloneTo(this._ray3.direction);
                    this._ray2.origin.cloneTo(this._ray3.origin);
                    this._boxBound1.cloneTo(this._boxBound2);
                    this._tempM0.cloneTo(this._tempM1);
                    obb = orientedBoundBox;
                    collider = list[i];
                }
            }
            if (min < 0xffffff) {
                Vector3$1.scale(this._ray3.direction, min, this._tempV35);
                Vector3$1.add(this._ray3.origin, this._tempV35, this._tempV35);
                Vector3$1.transformV3ToV3(this._tempV35, obb.transformation, this._tempV35);
                yDis = Math.abs(this._tempV35.y - vecOrigin.y);
                if (Math.abs(min - yDis) > 0.0001) {
                    return {
                        isCollise: false,
                        y: vecTarget.y
                    };
                }
                return {
                    isCollise: true,
                    y: this._tempV35.y
                };
            } else {
                return {
                    isCollise: false,
                    y: vecTarget.y
                };
            }
        }
        enable() {
            this.isActive = true;
            if (this.isStatic) {
                TriggerManager.instance.addStatic(this);
            } else {
                TriggerManager.instance.addDY(this);
            }
        }
        disable() {
            this.isActive = false;
            this.remove();
        }
        destory() {
            if (this._octreeNode)
                this._octreeNode.remove(this);
            this._localmatrix4x4 = null;
            this._worldMatrix4x4 = null;
            this._boundBox = null;
            this._boundSpheres = null;
            this._octreeNode = null;
            this.bounds = null;
            this.owner = null;
        }
        remove() {
            if (this.isStatic) {
                TriggerManager.instance.removeStatic(this);
            } else {
                TriggerManager.instance.removeDY(this);
            }
        }
        setOwner(owner) {
            this.owner = owner;
        }
        static getOCTree() {
            if (!this._octree) {
                this.createOCTree();
            }
            return this._octree;
        }
        static createOCTree() {
            this._octree = new BoundsOctree(this.octreeInitialSize, new Vector3$1(0, 0, 0), this.octreeMinNodeSize, this.octreeLooseness);
        }
    }
    CubePhysicsCompnent.TYPE_BOX = 0;
    CubePhysicsCompnent.TYPE_SPHERE = 1;
    CubePhysicsCompnent.TYPE_CUBESPRIT3D = 2;
    CubePhysicsCompnent.centerSprite = new Vector3$1(0, 0, 0);
    CubePhysicsCompnent.extents = new Vector3$1(8, 8, 8);
    CubePhysicsCompnent.boundBox = new BoundBox(new Vector3$1(), new Vector3$1());
    CubePhysicsCompnent.octreeInitialSize = 64;
    CubePhysicsCompnent.octreeLooseness = 1.25;
    CubePhysicsCompnent.octreeMinNodeSize = 2;
    CubePhysicsCompnent._tempV31 = new Vector3$1();
    CubePhysicsCompnent._tempV32 = new Vector3$1();
    CubePhysicsCompnent._tempV33 = new Vector3$1();
    CubePhysicsCompnent._tempV34 = new Vector3$1();
    CubePhysicsCompnent._tempV35 = new Vector3$1();
    CubePhysicsCompnent._tempM0 = new Matrix4x4();
    CubePhysicsCompnent._tempM1 = new Matrix4x4();
    CubePhysicsCompnent._boxBound1 = new BoundBox(new Vector3$1(), new Vector3$1());
    CubePhysicsCompnent._boxBound2 = new BoundBox(new Vector3$1(), new Vector3$1());
    CubePhysicsCompnent._ray1 = new Laya.Ray(new Laya.Vector3(), new Laya.Vector3());
    CubePhysicsCompnent._ray2 = new Laya.Ray(new Laya.Vector3(), new Laya.Vector3());
    CubePhysicsCompnent._ray3 = new Laya.Ray(new Laya.Vector3(), new Laya.Vector3());
    CubePhysicsCompnent.VectorOne = new Vector3$1(1, 1, 1);
    CubePhysicsCompnent.isDebug = false;
    CubePhysicsCompnent.overwrite();

    class TriggerStateDetection {
        constructor() {
            this._lastTriggerQueue = {};
            this._triggerQueue = {};
            TriggerQueueDataPool.instance.init(10);
        }
        allTriggerDetection(staticSprite3DQueue, dynamicSprite3DQueue) {
            this._lastTriggerQueue = this._triggerQueue;
            this._triggerQueue = {};
            if (!dynamicSprite3DQueue) {
                return;
            }
            for (var i in dynamicSprite3DQueue) {
                var body = dynamicSprite3DQueue[i];
                body.isDetection = false;
            }
            for (var i in dynamicSprite3DQueue) {
                var body = dynamicSprite3DQueue[i];
                let list = [];
                CubePhysicsCompnent.getOCTree().getCollidingWithBoundBox(body.boundingBox, list);
                for (let j = 0, len = list.length; j < len; j++) {
                    if (list[j].isActive)
                        this.singleTriggerDetection(body, list[j]);
                }
                for (var k in dynamicSprite3DQueue) {
                    var target = dynamicSprite3DQueue[k];
                    if (!target.isDetection) {
                        this.singleTriggerDetection(body, target);
                    }
                }
                body.isDetection = true;
            }
        }
        singleTriggerDetection(thisBody, otherBody) {
            if (thisBody.onlyID != otherBody.onlyID) {
                var isTrigger = thisBody.isCollision(otherBody);
                if (isTrigger != 0) {
                    var data = TriggerQueueDataPool.instance.get();
                    data.setBody(thisBody, otherBody);
                    var key = this.getKey(thisBody, otherBody);
                    this._triggerQueue[key] = data;
                }
            }
        }
        getKey(thisBody, otherBody) {
            return thisBody.onlyID > otherBody.onlyID ? otherBody.onlyID + "_" + thisBody.onlyID : thisBody.onlyID + "_" + otherBody.onlyID;
        }
        get lastTriggerQueue() {
            return this._lastTriggerQueue;
        }
        get triggerQueue() {
            return this._triggerQueue;
        }
        clean() {
            this._lastTriggerQueue = {};
            this._triggerQueue = {};
        }
    }

    class TriggerEvent {}
    TriggerEvent.TRIGGER_ENTER = "TriggerEnter";
    TriggerEvent.TRIGGER_STAY = "TriggerStay";
    TriggerEvent.TRIGGER_EXIT = "TriggerExit";

    class DistributedTriggerEvent {
        distributedAllEvent(lastTriggerQueue, currentTriggerQueue) {
            for (var i in currentTriggerQueue) {
                var value = lastTriggerQueue[i];
                if (value) {
                    this.distributedEvent(TriggerEvent.TRIGGER_STAY, currentTriggerQueue[i]);
                    TriggerQueueDataPool.instance.giveBack(value);
                    delete lastTriggerQueue[i];
                } else {
                    this.distributedEvent(TriggerEvent.TRIGGER_ENTER, currentTriggerQueue[i]);
                }
            }
            for (var i in lastTriggerQueue) {
                var value = lastTriggerQueue[i];
                this.distributedEvent(TriggerEvent.TRIGGER_EXIT, value);
                TriggerQueueDataPool.instance.giveBack(value);
            }
        }
        distributedEvent(triggerEvent, queue) {
            queue.thisBody.owner.event(triggerEvent, queue.otherBody);
            queue.otherBody.owner.event(triggerEvent, queue.thisBody);
        }
    }

    class TriggerManager {
        constructor() {
            this._ray = new Laya.Ray(new Laya.Vector3(), new Laya.Vector3());
            this.staticSprite3D = {};
            this.dySprite3D = {};
            this.triggerStateDetection = new TriggerStateDetection();
            this.distributedTriggerEvent = new DistributedTriggerEvent();
        }
        static get instance() {
            if (!TriggerManager._instance) {
                TriggerManager._instance = new TriggerManager();
            }
            return TriggerManager._instance;
        }
        update() {
            this.detection();
        }
        detection() {
            for (let k in this.dySprite3D) {
                this.dySprite3D[k].onUpdate();
            }
        }
        addStatic(trigger) {
            this.staticSprite3D[trigger.onlyID] = trigger;
        }
        addDY(trigger) {
            this.dySprite3D[trigger.onlyID] = trigger;
        }
        get staticList() {
            return this.staticSprite3D;
        }
        get dyList() {
            return this.dySprite3D;
        }
        removeStatic(trigger) {
            delete this.staticSprite3D[trigger.onlyID];
        }
        removeDY(trigger) {
            delete this.dySprite3D[trigger.onlyID];
        }
        static clean() {
            if (TriggerManager._instance) {
                TriggerManager._instance.triggerStateDetection.clean();
                for (let k in TriggerManager._instance.staticSprite3D) {
                    TriggerManager._instance.staticSprite3D[k].destory();
                }
                TriggerManager._instance.staticSprite3D = {};
                for (let k in TriggerManager._instance.dySprite3D) {
                    TriggerManager._instance.dySprite3D[k].destory();
                }
                TriggerManager._instance.dySprite3D = {};
                CubePhysicsCompnent.createOCTree();
            }
        }
    }

    class LogicTimer {
        constructor(delta) {
            this.scale = 1;
            this.currTimer = 0;
            this.currFrame = 0;
            this._delta = 0;
            this._map = [];
            this._handlers = [];
            this._temp = [];
            this._count = 0;
            this.fixDelta = 0;
            this.setFixDelta(delta);
            this.currTimer = new Date().getTime();
        }
        static create(delta) {
            if (LogicTimer.gSysTimer)
                return LogicTimer.gSysTimer;
            LogicTimer.gSysTimer = new LogicTimer(delta);
            return LogicTimer.gSysTimer;
        }
        get delta() {
            return this._delta;
        }
        setFixDelta(delta) {
            this.fixDelta = delta;
            this._delta = this.fixDelta * this.scale;
        }
        update() {
            if (this.scale <= 0) {
                this._delta = 0;
                return;
            }
            var frame = this.currFrame = this.currFrame + this.scale;
            this._delta = this.fixDelta * this.scale;
            var timer = this.currTimer = this.currTimer + this._delta;
            var handlers = this._handlers;
            this._count = 0;
            for (var i = 0, n = handlers.length; i < n; i++) {
                var handler = handlers[i];
                if (handler.method !== null) {
                    var t = handler.userFrame ? frame : timer;
                    if (t >= handler.exeTime) {
                        if (handler.repeat) {
                            while (t >= handler.exeTime) {
                                handler.exeTime += handler.delay;
                                handler.run(false);
                            }
                        } else {
                            handler.run(true);
                        }
                    }
                } else {
                    this._count++;
                }
            }
            if (this._count > 30 || frame % 200 === 0)
                this._clearHandlers();
        }
        _clearHandlers() {
            var handlers = this._handlers;
            for (var i = 0, n = handlers.length; i < n; i++) {
                var handler = handlers[i];
                if (handler.method !== null)
                    this._temp.push(handler);
                else
                    this._recoverHandler(handler);
            }
            this._handlers = this._temp;
            handlers.length = 0;
            this._temp = handlers;
        }
        _recoverHandler(handler) {
            if (this._map[handler.key] == handler)
                this._map[handler.key] = null;
            handler.clear();
            LogicTimer._pool.push(handler);
        }
        _create(useFrame, repeat, delay, caller, method, args, coverBefore) {
            if (!delay) {
                method.apply(caller, args);
                return null;
            }
            if (coverBefore) {
                var handler = this._getHandler(caller, method);
                if (handler) {
                    handler.repeat = repeat;
                    handler.userFrame = useFrame;
                    handler.delay = delay;
                    handler.caller = caller;
                    handler.method = method;
                    handler.args = args;
                    handler.exeTime = delay + (useFrame ? this.currFrame : this.currTimer);
                    return handler;
                }
            }
            handler = LogicTimer._pool.length > 0 ? LogicTimer._pool.pop() : new TimerHandler();
            handler.repeat = repeat;
            handler.userFrame = useFrame;
            handler.delay = delay;
            handler.caller = caller;
            handler.method = method;
            handler.args = args;
            handler.exeTime = delay + (useFrame ? this.currFrame : this.currTimer);
            this._indexHandler(handler);
            this._handlers.push(handler);
            return handler;
        }
        _indexHandler(handler) {
            var caller = handler.caller;
            var method = handler.method;
            var cid = caller ? caller.$_GID || (caller.$_GID = Laya.Utils.getGID()) : 0;
            var mid = method.$_TID || (method.$_TID = (LogicTimer._mid++) * 100000);
            handler.key = cid + mid;
            this._map[handler.key] = handler;
        }
        once(delay, caller, method, args = null, coverBefore = true) {
            this._create(false, false, delay, caller, method, args, coverBefore);
        }
        loop(delay, caller, method, args = null, coverBefore = true, jumpFrame = false) {
            var handler = this._create(false, true, delay, caller, method, args, coverBefore);
            if (handler)
                handler.jumpFrame = jumpFrame;
        }
        frameOnce(delay, caller, method, args = null, coverBefore = true) {
            this._create(true, false, delay, caller, method, args, coverBefore);
        }
        frameLoop(delay, caller, method, args = null, coverBefore = true) {
            this._create(true, true, delay, caller, method, args, coverBefore);
        }
        toString() {
            return " handlers:" + this._handlers.length + " pool:" + LogicTimer._pool.length;
        }
        clear(caller, method) {
            var handler = this._getHandler(caller, method);
            if (handler) {
                this._map[handler.key] = null;
                handler.key = 0;
                handler.clear();
            }
        }
        clearAll(caller) {
            if (!caller)
                return;
            for (var i = 0, n = this._handlers.length; i < n; i++) {
                var handler = this._handlers[i];
                if (handler.caller === caller) {
                    this._map[handler.key] = null;
                    handler.key = 0;
                    handler.clear();
                }
            }
        }
        _getHandler(caller, method) {
            var cid = caller ? caller.$_GID || (caller.$_GID = Laya.Utils.getGID()) : 0;
            var mid = method.$_TID || (method.$_TID = (LogicTimer._mid++) * 100000);
            return this._map[cid + mid];
        }
        callLater(caller, method, args = null) {
            Laya.CallLater.I.callLater(caller, method, args);
        }
        runCallLater(caller, method) {
            Laya.CallLater.I.runCallLater(caller, method);
        }
        runTimer(caller, method) {
            var handler = this._getHandler(caller, method);
            if (handler && handler.method != null) {
                this._map[handler.key] = null;
                handler.run(true);
            }
        }
        pause() {
            this.scale = 0;
        }
        resume() {
            this.scale = 1;
        }
    }
    LogicTimer.gSysTimer = null;
    LogicTimer._pool = [];
    LogicTimer._mid = 1;
    class TimerHandler {
        clear() {
            this.caller = null;
            this.method = null;
            this.args = null;
        }
        run(withClear) {
            var caller = this.caller;
            if (caller && caller.destroyed)
                return this.clear();
            var method = this.method;
            var args = this.args;
            withClear && this.clear();
            if (method == null)
                return;
            args ? method.apply(caller, args) : method.call(caller);
        }
    }

    class EffectManger {
        static getEffect(name) {
            let list = this.effect[name];
            if (!list) {
                list = [];
                this.effect[name] = list;
            }
            for (let i = 0, len = list.length; i < len; i++) {
                let effect = list[i];
                if (!effect.active && effect.transform) {
                    effect.active = true;
                    return effect;
                }
            }
            let effect = ResourceManager.getRes(RES_PATH.EFFECT_PREFEB).getChildByName(name).clone();
            list.push(effect);
            return effect;
        }
        static recycleEffect(effect) {
            effect.active = false;
            effect.removeSelf();
        }
        static playfire(args) {
            let effect = this.getEffect(OBJ_NAME.FIRE_EFFECT);
            let pos = effect.transform.localPosition;
            pos.x = 0;
            pos.y = 0;
            pos.z = 0;
            effect.transform.localPosition = pos;
            let euler = effect.transform.localRotation;
            euler.x = 0;
            euler.z = 0;
            euler.y = 0;
            args.parent.addChild(effect);
            return effect;
        }
        static playFireEnd(args) {
            let effect = this.getEffect(EFFECT_NAME.FIRE_END);
            GameScene.scene3d.addChild(effect);
            let pos = effect.transform.localPosition;
            pos.x = args.pos.x;
            pos.y = args.pos.y;
            pos.z = args.pos.z;
            effect.transform.localPosition = pos;
            Laya.timer.once(1000, GameScene.scene3d, function() {
                if (effect) {
                    EffectManger.recycleEffect(effect);
                }
            });
            return effect;
        }
        static playfireTrajectory(args) {}
        static playImpactSparks(args) {}
        static playBombs(pos) {
            let effect = this.getEffect(EFFECT_NAME.BULLET3);
            effect.transform.position = pos;
            GameScene.scene3d.addChild(effect);
            effect.myCoutdown = 2000;
        }
        static playShield(arg) {
            if (!arg)
                return;
            if (!arg.parent)
                return;
            let effect = this.getEffect(EFFECT_NAME.SHIELD);
            arg.parent.addChild(effect);
            return effect;
        }
        static playSynthesis1(parent) {
            let ori = ResourceManager.getRes(RES_PATH.EFFECT_PREFEB).getChildByName(EFFECT_NAME.COMPOSE1);
            let newObj = Laya.ShuriKenParticle3D.instantiate(ori, parent, false);
            newObj.particleSystem.play();
            return newObj;
        }
        static playSynthesis2(parent) {
            let ori = ResourceManager.getRes(RES_PATH.EFFECT_PREFEB).getChildByName(EFFECT_NAME.COMPOSE2);
            let newObj = Laya.ShuriKenParticle3D.instantiate(ori, parent, false);
            newObj.particleSystem.stop();
            return newObj;
        }
        static timer() {
            for (let k in this.effect) {
                let list = this.effect[k];
                for (let i = 0, len = list.length; i < len; i++) {
                    let effect = list[i];
                    if (effect.active) {
                        effect.myCoutdown -= 20;
                        if (effect.myCoutdown <= 0) {
                            effect.active = false;
                            effect.removeSelf();
                        }
                    }
                }
            }
        }
        static clean() {
            for (let k in this.effect) {
                let list = this.effect[k];
                for (let i = 0, len = list.length; i < len; i++) {
                    let effect = list[i];
                    effect.myCoutdown = 0;
                    effect.active = false;
                    effect.removeSelf();
                }
            }
        }
    }
    EffectManger.zeroVec = new Laya.Vector3(0, 0, 0);
    EffectManger.effect = {};
    EffectManger.liveTimer = {};

    class BombCtrl extends Laya.Script3D {
        constructor(logic = null) {
            super();
            this.isThrow = false;
            this._bombCount = 6000;
            this.hit = 100;
            this.isBomb = false;
            this.logic = null;
            this.isResetGetArm = false;
            this.canThrow = false;
            this.aniEndTime = 200;
            this.isTouch = false;
            this.cb = null;
            this.logic = logic;
        }
        onAwake() {}
        onUpdate() {
            if (CharacterManger.gameOver || CharacterManger._isWin || !this.logic) {
                this.owner.destroy();
                return;
            }
            if (this.isTouch) {
                this._bombCount -= Laya.timer.delta;
                this.aniEndTime -= Laya.timer.delta;
                if (this.aniEndTime <= 0) {
                    this.canThrow = true;
                }
                if (this._bombCount < 0) {
                    if (!this.isBomb) {
                        let pos = this.owner.transform.position.clone();
                        SoundManager.playEffect(SOUND_PATH.BOMB);
                        EffectManger.playBombs(pos);
                        CharacterManger.bombHit(pos, this.hit, this.logic);
                    }
                    if (!this.isThrow) {
                        this.cb && this.cb();
                    } else {}
                    if (!this.isBomb) {
                        this.isBomb = true;
                        this.owner.active = false;
                        this.owner.removeSelf();
                        this.owner.destroy();
                    }
                }
            }
        }
        onDestroy() {
            console.log('移除');
            this.isThrow = null;
            this._bombCount = null;
            this.isTouch = null;
        }
        retSet() {
            this._bombCount = 6000;
            this.isTouch = false;
        }
        get bombCount() {
            return this._bombCount;
        }
    }

    class RandomUtil {
        static onlyOneRandomInt(min, max) {
            return Math.floor(Math.random() * (min - max) + max);
        }
        static onlyOneRandomIntOrFloat(min, max) {
            return Math.random() * (min - max) + max;
        }
        static getRandomArrayElements(arr, count) {
            var shuffled = arr.slice(0),
                i = arr.length,
                min = i - count,
                temp, index;
            while (i-- > min) {
                index = Math.floor((i + 1) * Math.random());
                temp = shuffled[index];
                shuffled[index] = shuffled[i];
                shuffled[i] = temp;
            }
            return shuffled.slice(min);
        }
        static roa(arr, count) {
            let temp = [];
            for (let i = 0; i < count; i++) {
                var num = Math.floor(Math.random() * arr.length);
                temp.push(arr[num]);
                arr.splice(num, 1);
            }
            return temp;
        }
    }

    class AIItemCtrl extends ui.view.game.AIItemUI {
        constructor(logic) {
            super();
            this.logic = null;
            this.logic = logic;
        }
        onAwake() {
            if (this.logic.getRoleType() == ROLE_TYPE.TYPE_0) {
                this.imgFrame.skin = RES_PATH.HEAD_TOP_FRAME_UI.FRIENDLY;
            } else if (this.logic.getRoleType() == ROLE_TYPE.TYPE_1) {
                this.imgFrame.skin = RES_PATH.HEAD_TOP_FRAME_UI.ENEMY;
            }
            Laya.timer.loop(50, this, this.setState);
        }
        onDestroy() {
            this.logic = null;
            this.imgFrame = null;
            this.imgState = null;
        }
        setState() {
            if (!this.logic.getIsDie()) {
                this.imgState.skin = RES_PATH.TOP_HRAD_STATE_UI.NORMAL;
            } else {
                this.imgState.skin = RES_PATH.TOP_HRAD_STATE_UI.DIE;
            }
        }
    }

    class PlayerItemCtrl extends ui.view.game.PlayerItemUI {
        constructor(logic) {
            super();
            this.logic = null;
            this.logic = logic;
        }
        onAwake() {}
        onDestroy() {
            this.imgState = null;
        }
        setState() {
            if (!this.logic.getIsDie()) {
                this.imgState.skin = RES_PATH.TOP_HRAD_STATE_UI.NORMAL;
            } else {
                this.imgState.skin = RES_PATH.TOP_HRAD_STATE_UI.DIE;
            }
        }
    }

    class RevengeItemCtrl extends ui.view.game.RevengeItemUI {
        constructor() {
            super();
            this.centerX = 0;
            this.bottom = 128;
        }
        play() {
            this.ani1.play(0, false);
            SoundManager.playEffect(SOUND_PATH.REVENGE);
        }
    }

    class BuffManager {
        static setBuffGain(isGet = false, defenseGain = 0, hpGain = 0, headshotGain = 0) {
            this.defenseGain = 30;
            this.hpGain = 0;
            this.headshotGain = 0;
            if (isGet) {
                this.defenseGain += defenseGain;
                this.hpGain += hpGain;
                this.headshotGain += headshotGain;
            } else {
                this.defenseGain = 30;
                this.hpGain = 0;
                this.headshotGain = 0;
            }
        }
    }
    BuffManager.defenseGain = 30;
    BuffManager.hpGain = 0;
    BuffManager.headshotGain = 0;

    class PROP {
        static getDataByKey(key) {
            if (PROP.cache[key])
                return PROP.cache[key];
            if (key == 8001) {
                let template = new PROP();
                template.id = 8001;
                template.name = '手榴弹';
                template.objName = '8001';
                template.type = 8;
                template.interval = 500;
                template.attackSound = 'FileInTheHole.mp3';
                template.magazineBullet = 1;
                template.bullets = 1;
                template.bulletChangeTimer = 1900;
                template.hit = 60;
                template.isCanOpMirror = 0;
                template.cutScale = 0;
                template.attackDis = -1;
                template.icon = 'sub1/equip/prop/1.png';
                template.recoilForce = -1;
                template.reloadsound = '手枪reload.mp3';
                template.firestarter = 'm4_Effect';
                template.ballistic = 'fire';
                template.bullethole = 'impactSparks';
                template.price = -1;
                template.produce = 5;
                template.priceByDiamond = 10;
                template.grade = 1;
                template.lv = 1;
                template.pierceThrough = 50;
                template.range = 21;
                template.sight = -1;
                template.movingSpeed = 0.12;
                template.biochemicalCharging = 0;
                template.accurate = 50;
                PROP.cache[key] = template;
                return template;
            } else if (key == 2001) {
                let template = new PROP();
                template.id = 2001;
                template.name = '刀子';
                template.objName = '2001';
                template.type = 2;
                template.interval = 1700;
                template.attackSound = 'knife1.mp3';
                template.magazineBullet = -1;
                template.bullets = -1;
                template.bulletChangeTimer = 2660;
                template.hit = 80;
                template.isCanOpMirror = 0;
                template.cutScale = 0;
                template.attackDis = 2;
                template.icon = 'sub1/equip/prop/2.png';
                template.recoilForce = [1.5, 0];
                template.reloadsound = '散弹枪reload.mp3';
                template.firestarter = 'm4_Effect';
                template.ballistic = 'fire';
                template.bullethole = 'impactSparks';
                template.price = 450000;
                template.produce = 65;
                template.priceByDiamond = 2300;
                template.grade = 4;
                template.lv = 1;
                template.pierceThrough = 75;
                template.range = 15;
                template.sight = -1;
                template.movingSpeed = 0.18;
                template.biochemicalCharging = 130;
                template.accurate = 76;
                PROP.cache[key] = template;
                return template;
            }
        }
        static getDataByIndex(index) {
            if (PROP.cache[this.keys[index]])
                return PROP.cache[this.keys[index]];
            return this.getDataByKey(this.keys[index]);
        }
        static getAllData() {
            for (let index = 0; index < this.keys.length; index++) {
                this.getDataByKey(this.keys[index]);
            }
            return PROP.cache;
        }
        clear() {
            PROP.cache = {};
        }
    }
    PROP.cache = {};
    PROP.keys = [8001, 2001];

    class LayaExtend {
        static autoUnlinkUIReference(view) {
            if (!view.viewUrl)
                return;
            let uiConfig = Laya.loader.getRes(view.viewUrl);
            let keyList = [];
            this.getUIChildReference(uiConfig, keyList);
            let animationList = this.getUIAnimationReference(uiConfig);
            for (let i = 0; i < keyList.length; i++) {
                view[keyList[i]] = null;
            }
            for (let i = 0; i < animationList.length; i++) {
                view[animationList[i]] && view[animationList[i]].stop();
                view[animationList[i]] = null;
            }
        }
        static getUIChildReference(json, keyList) {
            if (json.props && json.props.var) {
                keyList.push(json.props.var);
            }
            if (json.child) {
                for (let i = 0; i < json.child.length; i++) {
                    this.getUIChildReference(json.child[i], keyList);
                }
            }
        }
        static getUIAnimationReference(json) {
            let keyList = [];
            if (json.animations) {
                for (let i = 0; i < json.animations.length; i++) {
                    if (json.animations[i].name) {
                        keyList.push(json.animations[i].name);
                    }
                }
            }
            return keyList;
        }
        static overwrite() {
            this._loadScene();
            this._collision();
        }
        static _loadScene() {
            Laya.Scene.prototype.loadScene = function(path) {
                var url = path.indexOf(".") > -1 ? path : path + ".scene";
                var view = Laya.loader.getRes(url);
                this.viewUrl = url;
                if (view) {
                    this.createView(view);
                    this.uiView = view;
                } else {
                    this._setBit(Laya.Const.NOT_READY, true);
                    Laya.loader.resetProgress();
                    var loader = new Laya.SceneLoader();
                    loader.on(Laya.Event.COMPLETE, this, this._onSceneLoaded, [url]);
                    loader.load(url);
                }
            };
        }
        static _collision() {
            let octreeNode = Laya.BoundsOctreeNode;
            octreeNode.prototype['getCollidingWithRayWithLayer'] = function(ray, result, maxDistance = Number.MAX_VALUE, layer) {
                var distance = Laya.CollisionUtils.intersectsRayAndBoxRD(ray, this._bounds);
                if (distance == -1 || distance > maxDistance)
                    return;
                for (var i = 0, n = this._objects.length; i < n; i++) {
                    var object = this._objects[i];
                    if (object && object.layer == layer) {
                        distance = Laya.CollisionUtils.intersectsRayAndBoxRD(ray, object.bounds._getBoundBox());
                        if (distance !== -1 && distance <= maxDistance)
                            result.push(object);
                    }
                }
                if (this._children != null) {
                    for (i = 0; i < 8; i++) {
                        var child = this._children[i];
                        child && child.getCollidingWithRayWithLayer(ray, result, maxDistance, layer);
                    }
                }
            };
            octreeNode.prototype['getCollidingWithRay'] = function(ray, result, maxDistance = Number.MAX_VALUE) {
                var distance = Laya.CollisionUtils.intersectsRayAndBoxRD(ray, this._bounds);
                if (distance == -1 || distance > maxDistance)
                    return;
                for (var i = 0, n = this._objects.length; i < n; i++) {
                    var object = this._objects[i];
                    distance = Laya.CollisionUtils.intersectsRayAndBoxRD(ray, object.bounds._getBoundBox());
                    if (distance !== -1 && distance <= maxDistance)
                        result.push(object);
                }
                if (this._children != null) {
                    for (i = 0; i < 8; i++) {
                        var child = this._children[i];
                        child && child.getCollidingWithRay(ray, result, maxDistance);
                    }
                }
            };
            octreeNode.prototype['isCollidingWithBoundBox'] = function(checkBound) {
                if (!(Laya.CollisionUtils.intersectsBoxAndBox(this._bounds, checkBound)))
                    return false;
                for (var i = 0, n = this._objects.length; i < n; i++) {
                    var object = this._objects[i];
                    if (Laya.CollisionUtils.intersectsBoxAndBox(object.bounds._getBoundBox(), checkBound))
                        return true;
                }
                if (this._children != null) {
                    for (i = 0; i < 8; i++) {
                        var child = this._children[i];
                        if (child && child.isCollidingWithBoundBox(checkBound))
                            return true;
                    }
                }
                return false;
            };
            octreeNode.prototype['isCollidingWithRay'] = function(ray, maxDistance = Number.MAX_VALUE) {
                var distance = Laya.CollisionUtils.intersectsRayAndBoxRD(ray, this._bounds);
                if (distance == -1 || distance > maxDistance)
                    return false;
                for (var i = 0, n = this._objects.length; i < n; i++) {
                    var object = this._objects[i];
                    distance = Laya.CollisionUtils.intersectsRayAndBoxRD(ray, object.bounds._getBoundBox());
                    if (distance !== -1 && distance <= maxDistance)
                        return true;
                }
                if (this._children != null) {
                    for (i = 0; i < 8; i++) {
                        var child = this._children[i];
                        if (child && child.isCollidingWithRay(ray, maxDistance))
                            return true;
                    }
                }
                return false;
            };
            octreeNode.prototype['isCollidingWithRayWithLayer'] = function(ray, maxDistance = Number.MAX_VALUE, layer) {
                var distance = Laya.CollisionUtils.intersectsRayAndBoxRD(ray, this._bounds);
                if (distance == -1 || distance > maxDistance)
                    return false;
                for (var i = 0, n = this._objects.length; i < n; i++) {
                    var object = this._objects[i];
                    if (object && object.layer == layer) {
                        distance = Laya.CollisionUtils.intersectsRayAndBoxRD(ray, object.bounds._getBoundBox());
                        if (distance !== -1 && distance <= maxDistance)
                            return true;
                    }
                }
                if (this._children != null) {
                    for (i = 0; i < 8; i++) {
                        var child = this._children[i];
                        if (child && child.isCollidingWithRayWithLayer(ray, maxDistance, layer))
                            return true;
                    }
                }
                return false;
            };
            let octree = Laya.BoundsOctree;
            octree.prototype['getCollidingWithRayWithLayer'] = function(ray, result, maxDistance = Number.MAX_VALUE, layer) {
                this._rootNode.getCollidingWithRayWithLayer(ray, result, maxDistance, layer);
            };
            octree.prototype['isCollidingWithRayWithLayer'] = function(ray, maxDistance = Number.MAX_VALUE, layer) {
                return this._rootNode.isCollidingWithRayWithLayer(ray, maxDistance, layer);
            };
        }
    }

    let StringUtil = {
        parseURI: function(str) {
            console.log('parseURI', str);
            if (str == '' || !str) {
                return {};
            }
            let root = str.split('?');
            if (!root[1]) {
                return {};
            }
            let kvList = root[1].split('&');
            let ret = {};
            for (let k in kvList) {
                let kv = kvList[k].split('=');
                ret[kv[0]] = kv[1];
            }
            return ret;
        },
        convertNum: function(amount) {
            var num = 0;
            var result = [];
            amount = new String(amount);
            let length = 0;
            if ((amount.indexOf('E') != -1) || (amount.indexOf('e') != -1)) {
                (amount.indexOf('E') != -1) ? num = amount.indexOf('E'): num = amount.indexOf('e');
                var decimal = amount.substr(0, num);
                var decArr = decimal.split('.', 2);
                if (amount.indexOf('E') != -1) {
                    length = parseInt((amount.split('E'))[1]);
                } else if (amount.indexOf('e') != -1) {
                    length = parseInt((amount.split('e'))[1]);
                }
                var power = amount.substr(num + 1, length);
                var symbol = power.substr(0, 1);
                power = power.substr(1, power.length);
                power = power * 1.0;
                if ('+' == symbol) {
                    power = power - decArr[1].length;
                    while (power > 0) {
                        result.unshift(0);
                        power -= 1;
                    }
                    result.unshift(decArr[1] * 1.0);
                    result.unshift(decArr[0] * 1.0);
                } else {
                    power = power - decArr[1].length;
                    var result = [];
                    result.push(0);
                    result.push('.');
                    while (power > 0) {
                        result.push(0);
                        power -= 1;
                    }
                    result.push(decArr);
                }
            } else {
                return amount + '';
            }
            result.join("");
            let strResult = result + '';
            amount = strResult.replace(/,/g, '');
            if (amount.length < length + 1) {
                amount += '0';
            }
            return amount;
        },
        parseGold: function(count) {
            let unitList = [{
                    unit: 'K',
                    length: 4
                },
                {
                    unit: 'M',
                    length: 7
                },
                {
                    unit: 'G',
                    length: 10
                },
                {
                    unit: 'T',
                    length: 13
                },
                {
                    unit: 'P',
                    length: 16
                },
                {
                    unit: 'E',
                    length: 19
                },
                {
                    unit: 'Z',
                    length: 22
                },
                {
                    unit: 'Y',
                    length: 25
                },
                {
                    unit: '∞',
                    length: 28
                },
            ];
            count = new Number(count);
            count = Math.floor(count);
            let strCount = StringUtil.convertNum(count);
            if (strCount.length < unitList[0].length) {
                return count;
            }
            let j = 1;
            for (let i = 0; i < unitList.length; i++) {
                if (!unitList[j]) {
                    return unitList[i].unit;
                }
                if (strCount.length >= unitList[i].length && strCount.length < unitList[j].length) {
                    let parseCount = (count / Math.pow(10, unitList[i].length - 1)).toFixed(2);
                    return parseCount + unitList[i].unit;
                }
                j++;
            }
        },
        parseTimeMS: function(sec) {
            sec = parseInt(sec);
            if (sec < 0) {
                return '00:00';
            }
            let minutes = Math.floor(sec / 60);
            let second = sec - minutes * 60;
            let strM = '' + minutes;
            let strS = '' + second;
            if (strM.length == 1) {
                strM = '0' + strM;
            }
            if (strS.length == 1) {
                strS = '0' + strS;
            }
            return strM + ':' + strS;
        },
        parseTimeHMS: function(sec) {
            sec = parseInt(sec);
            if (sec < 0) {
                return '00:00:00';
            }
            let hours = Math.floor(sec / 3600);
            let minutes = Math.floor((sec - hours * 3600) / 60);
            let second = sec - hours * 3600 - minutes * 60;
            let strH = '' + hours;
            let strM = '' + minutes;
            let strS = '' + second;
            if (strH.length == 1) {
                strH = '0' + strH;
            }
            if (strM.length == 1) {
                strM = '0' + strM;
            }
            if (strS.length == 1) {
                strS = '0' + strS;
            }
            return strH + ':' + strM + ':' + strS;
        },
        toQueryString: function(obj, symbol1 = '=', symbol2 = '&') {
            return Object.keys(obj).filter(function(key) {
                return key != 'sign' && obj[key] !== undefined && obj[key] !== '';
            }).sort().map(function(key) {
                return key + symbol1 + obj[key];
            }).join(symbol2);
        },
    };

    ;
    var COMMON_MENU_STYLE;
    (function(COMMON_MENU_STYLE) {
        COMMON_MENU_STYLE[COMMON_MENU_STYLE["HIDE"] = 0] = "HIDE";
        COMMON_MENU_STYLE[COMMON_MENU_STYLE["ALL_SHOW"] = 1] = "ALL_SHOW";
        COMMON_MENU_STYLE[COMMON_MENU_STYLE["DIAMOND"] = 2] = "DIAMOND";
        COMMON_MENU_STYLE[COMMON_MENU_STYLE["GOLD"] = 3] = "GOLD";
    })(COMMON_MENU_STYLE || (COMMON_MENU_STYLE = {}));
    class CommonMenuTopBarCtrl extends ui.view.common.CommonMenuTopBarUI {
        constructor() {
            super();
            this.diamondChangeDelay = 0;
            this.targetDiamondNum = 0;
            this.curDiamOndNum = 0;
            this.goldChangeDelay = 0;
            this.targetGoldNum = 0;
            this.curGoldNum = 0;
        }
        onAwake() {
            this.setInfo();
            this.curDiamOndNum = RoleManager.getInstance().getDiamond();
            this.targetDiamondNum = this.curDiamOndNum;
            this.curGoldNum = RoleManager.getInstance().getGold();
            this.targetGoldNum = this.curGoldNum;
            this.timer.loop(1, this, this.update);
            this.timer.loop(1000, this, this.update1000ms);
            this.viewDiamond.on(Laya.Event.CLICK, this, this.onBtnDiamond);
            this.viewGold.on(Laya.Event.CLICK, this, this.onBtnGold);
        }
        onDestroy() {
            Laya.timer.clearAll(this);
            LayaExtend.autoUnlinkUIReference(this.viewDiamond);
            LayaExtend.autoUnlinkUIReference(this);
        }
        setMenuStyle(style) {
            this.viewDiamond.visible = false;
            this.viewGold.visible = false;
            this.visible = true;
            if (style == COMMON_MENU_STYLE.ALL_SHOW) {
                this.viewDiamond.visible = true;
                this.viewGold.visible = true;
            } else if (style == COMMON_MENU_STYLE.DIAMOND) {
                this.viewDiamond.visible = true;
            } else if (style == COMMON_MENU_STYLE.HIDE) {
                this.visible = false;
            } else if (style == COMMON_MENU_STYLE.GOLD) {
                this.viewGold.visible = true;
            }
        }
        onBtnDiamond() {
            if (!CommonUtil.getTouch())
                return;
            UIManager.openFunction(FUNCTION_TAG.ADD_DIAMONDS, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.WINDOW, COMMON_MENU_STYLE.DIAMOND);
        }
        onBtnGold() {
            if (!CommonUtil.getTouch())
                return;
            UIManager.openFunction(FUNCTION_TAG.ADD_GOLD, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.WINDOW, COMMON_MENU_STYLE.GOLD);
        }
        setInfo() {
            this.viewDiamond.txtCount.text = RoleManager.getInstance().getDiamond().toString();
            this.viewGold.txtCount.text = RoleManager.getInstance().getGold().toString();
        }
        update() {
            this.updateDiamondAni();
            this.updateGoldAni();
        }
        update1000ms() {
            if (!this.visible)
                return;
        }
        getDiamondPos() {
            return this.viewDiamond.imgDiamond.localToGlobal(new Laya.Point(this.viewDiamond.imgDiamond.width / 2, this.viewDiamond.imgDiamond.width / 2));
        }
        getDiamondIcon() {
            return this.viewDiamond.imgDiamond;
        }
        getGoldPos() {
            return this.viewGold.imgGold.localToGlobal(new Laya.Point(this.viewGold.imgGold.width / 2, this.viewGold.imgGold.width / 2));
        }
        getGoldIcon() {
            return this.viewGold.imgGold;
        }
        updateDiamondAni() {
            this.targetDiamondNum = RoleManager.getInstance().getDiamond();
            if (this.targetDiamondNum - this.curDiamOndNum > 1) {
                this.diamondChangeDelay += Laya.timer.delta;
                if (this.diamondChangeDelay >= 1000) {
                    this.curDiamOndNum = Math.ceil(this.curDiamOndNum + (this.targetDiamondNum - this.curDiamOndNum) * Laya.timer.delta * 0.005);
                }
            } else {
                this.diamondChangeDelay = 0;
                this.curDiamOndNum = this.targetDiamondNum;
            }
            let strGold = StringUtil.parseGold(this.curDiamOndNum);
            if (this.viewDiamond.txtCount.text != strGold) {
                this.viewDiamond.txtCount.text = strGold;
            }
        }
        updateGoldAni() {
            this.targetGoldNum = RoleManager.getInstance().getGold();
            if (this.targetGoldNum - this.curGoldNum > 1) {
                this.goldChangeDelay += Laya.timer.delta;
                if (this.goldChangeDelay >= 1000) {
                    this.curGoldNum = Math.ceil(this.curGoldNum + (this.targetGoldNum - this.curGoldNum) * Laya.timer.delta * 0.005);
                }
            } else {
                this.goldChangeDelay = 0;
                this.curGoldNum = this.targetGoldNum;
            }
            let strGold = StringUtil.parseGold(this.curGoldNum);
            if (this.viewGold.txtCount.text != strGold) {
                this.viewGold.txtCount.text = strGold;
            }
        }
    }

    var Vector3$2 = Laya.Vector3;
    var Matrix4x4$1 = Laya.Matrix4x4;
    var Ray = Laya.Ray;
    var BoundBox$1 = Laya.BoundBox;
    var MathUtils3D = Laya.MathUtils3D;
    var CollisionUtils = Laya.CollisionUtils;
    var ContainmentType;
    (function(ContainmentType) {
        ContainmentType[ContainmentType["Intersects"] = 2] = "Intersects";
        ContainmentType[ContainmentType["Contains"] = 1] = "Contains";
        ContainmentType[ContainmentType["Disjoint"] = 0] = "Disjoint";
    })(ContainmentType || (ContainmentType = {}));
    class OrientedBoundBox {
        constructor(extents, transformation) {
            this.extents = extents;
            this.transformation = transformation;
        }
        static createByBoundBox(box, out) {
            var min = box.min;
            var max = box.max;
            Vector3$2.subtract(max, min, OrientedBoundBox._tempV30);
            Vector3$2.scale(OrientedBoundBox._tempV30, 0.5, OrientedBoundBox._tempV30);
            Vector3$2.add(min, OrientedBoundBox._tempV30, OrientedBoundBox._tempV31);
            Vector3$2.subtract(max, OrientedBoundBox._tempV31, OrientedBoundBox._tempV32);
            Matrix4x4$1.translation(OrientedBoundBox._tempV31, OrientedBoundBox._tempM0);
            var extents = OrientedBoundBox._tempV32.clone();
            var transformation = OrientedBoundBox._tempM0.clone();
            out.extents = extents;
            out.transformation = transformation;
        }
        static createByMinAndMaxVertex(min, max) {
            Vector3$2.subtract(max, min, OrientedBoundBox._tempV30);
            Vector3$2.scale(OrientedBoundBox._tempV30, 0.5, OrientedBoundBox._tempV30);
            Vector3$2.add(min, OrientedBoundBox._tempV30, OrientedBoundBox._tempV31);
            Vector3$2.subtract(max, OrientedBoundBox._tempV31, OrientedBoundBox._tempV32);
            Matrix4x4$1.translation(OrientedBoundBox._tempV31, OrientedBoundBox._tempM0);
            var obb = new OrientedBoundBox(OrientedBoundBox._tempV32, OrientedBoundBox._tempM0);
            return obb;
        }
        getCorners(corners) {
            var xve = OrientedBoundBox._tempV30;
            var yve = OrientedBoundBox._tempV31;
            var zve = OrientedBoundBox._tempV32;
            var extentsE = this.extents;
            xve.x = extentsE.x;
            xve.y = xve.z = 0;
            yve.y = extentsE.y;
            yve.x = yve.z = 0;
            zve.z = extentsE.z;
            zve.x = zve.y = 0;
            Vector3$2.TransformNormal(OrientedBoundBox._tempV30, this.transformation, OrientedBoundBox._tempV30);
            Vector3$2.TransformNormal(OrientedBoundBox._tempV31, this.transformation, OrientedBoundBox._tempV31);
            Vector3$2.TransformNormal(OrientedBoundBox._tempV32, this.transformation, OrientedBoundBox._tempV32);
            var center = OrientedBoundBox._tempV33;
            this.transformation.getTranslationVector(center);
            corners.length = 8;
            Vector3$2.add(center, OrientedBoundBox._tempV30, OrientedBoundBox._tempV34);
            Vector3$2.add(OrientedBoundBox._tempV34, OrientedBoundBox._tempV31, OrientedBoundBox._tempV34);
            Vector3$2.add(OrientedBoundBox._tempV34, OrientedBoundBox._tempV32, corners[0]);
            Vector3$2.add(center, OrientedBoundBox._tempV30, OrientedBoundBox._tempV34);
            Vector3$2.add(OrientedBoundBox._tempV34, OrientedBoundBox._tempV31, OrientedBoundBox._tempV34);
            Vector3$2.subtract(OrientedBoundBox._tempV34, OrientedBoundBox._tempV32, corners[1]);
            Vector3$2.subtract(center, OrientedBoundBox._tempV30, OrientedBoundBox._tempV34);
            Vector3$2.add(OrientedBoundBox._tempV34, OrientedBoundBox._tempV31, OrientedBoundBox._tempV34);
            Vector3$2.subtract(OrientedBoundBox._tempV34, OrientedBoundBox._tempV32, corners[2]);
            Vector3$2.subtract(center, OrientedBoundBox._tempV30, OrientedBoundBox._tempV34);
            Vector3$2.add(OrientedBoundBox._tempV34, OrientedBoundBox._tempV31, OrientedBoundBox._tempV34);
            Vector3$2.add(OrientedBoundBox._tempV34, OrientedBoundBox._tempV32, corners[3]);
            Vector3$2.add(center, OrientedBoundBox._tempV30, OrientedBoundBox._tempV34);
            Vector3$2.subtract(OrientedBoundBox._tempV34, OrientedBoundBox._tempV31, OrientedBoundBox._tempV34);
            Vector3$2.add(OrientedBoundBox._tempV34, OrientedBoundBox._tempV32, corners[4]);
            Vector3$2.add(center, OrientedBoundBox._tempV30, OrientedBoundBox._tempV34);
            Vector3$2.subtract(OrientedBoundBox._tempV34, OrientedBoundBox._tempV31, OrientedBoundBox._tempV34);
            Vector3$2.subtract(OrientedBoundBox._tempV34, OrientedBoundBox._tempV32, corners[5]);
            Vector3$2.subtract(center, OrientedBoundBox._tempV30, OrientedBoundBox._tempV34);
            Vector3$2.subtract(OrientedBoundBox._tempV34, OrientedBoundBox._tempV31, OrientedBoundBox._tempV34);
            Vector3$2.subtract(OrientedBoundBox._tempV34, OrientedBoundBox._tempV32, corners[6]);
            Vector3$2.subtract(center, OrientedBoundBox._tempV30, OrientedBoundBox._tempV34);
            Vector3$2.subtract(OrientedBoundBox._tempV34, OrientedBoundBox._tempV31, OrientedBoundBox._tempV34);
            Vector3$2.add(OrientedBoundBox._tempV34, OrientedBoundBox._tempV32, corners[7]);
        }
        transform(mat) {
            Matrix4x4$1.multiply(this.transformation, mat, this.transformation);
        }
        scale(scaling) {
            Vector3$2.multiply(this.extents, scaling, this.extents);
        }
        translate(translation) {
            this.transformation.getTranslationVector(OrientedBoundBox._tempV30);
            Vector3$2.add(OrientedBoundBox._tempV30, translation, OrientedBoundBox._tempV31);
            this.transformation.setTranslationVector(OrientedBoundBox._tempV31);
        }
        Size(out) {
            Vector3$2.scale(this.extents, 2, out);
        }
        getSize(out) {
            var extentsE = this.extents;
            OrientedBoundBox._tempV30.x = extentsE.x;
            OrientedBoundBox._tempV31.y = extentsE.y;
            OrientedBoundBox._tempV32.z = extentsE.z;
            Vector3$2.TransformNormal(OrientedBoundBox._tempV30, this.transformation, OrientedBoundBox._tempV30);
            Vector3$2.TransformNormal(OrientedBoundBox._tempV31, this.transformation, OrientedBoundBox._tempV31);
            Vector3$2.TransformNormal(OrientedBoundBox._tempV31, this.transformation, OrientedBoundBox._tempV32);
            var oe = out;
            oe.x = Vector3$2.scalarLength(OrientedBoundBox._tempV30);
            oe.y = Vector3$2.scalarLength(OrientedBoundBox._tempV31);
            oe.z = Vector3$2.scalarLength(OrientedBoundBox._tempV32);
        }
        getSizeSquared(out) {
            var extentsE = this.extents;
            OrientedBoundBox._tempV30.x = extentsE.x;
            OrientedBoundBox._tempV31.y = extentsE.y;
            OrientedBoundBox._tempV32.z = extentsE.z;
            Vector3$2.TransformNormal(OrientedBoundBox._tempV30, this.transformation, OrientedBoundBox._tempV30);
            Vector3$2.TransformNormal(OrientedBoundBox._tempV31, this.transformation, OrientedBoundBox._tempV31);
            Vector3$2.TransformNormal(OrientedBoundBox._tempV31, this.transformation, OrientedBoundBox._tempV32);
            var oe = out;
            oe.x = Vector3$2.scalarLengthSquared(OrientedBoundBox._tempV30);
            oe.y = Vector3$2.scalarLengthSquared(OrientedBoundBox._tempV31);
            oe.z = Vector3$2.scalarLengthSquared(OrientedBoundBox._tempV32);
        }
        getCenter(center) {
            this.transformation.getTranslationVector(center);
        }
        containsPoint(point) {
            var extentsE = this.extents;
            var extentsEX = extentsE.x;
            var extentsEY = extentsE.y;
            var extentsEZ = extentsE.z;
            this.transformation.invert(OrientedBoundBox._tempM0);
            Vector3$2.transformCoordinate(point, OrientedBoundBox._tempM0, OrientedBoundBox._tempV30);
            var _tempV30e = OrientedBoundBox._tempV30;
            var _tempV30ex = Math.abs(_tempV30e.x);
            var _tempV30ey = Math.abs(_tempV30e.y);
            var _tempV30ez = Math.abs(_tempV30e.z);
            if (MathUtils3D.nearEqual(_tempV30ex, extentsEX) && MathUtils3D.nearEqual(_tempV30ey, extentsEY) && MathUtils3D.nearEqual(_tempV30ez, extentsEZ))
                return ContainmentType.Intersects;
            if (_tempV30ex < extentsEX && _tempV30ey < extentsEY && _tempV30ez < extentsEZ)
                return ContainmentType.Contains;
            else
                return ContainmentType.Disjoint;
        }
        containsPoints(points) {
            var extentse = this.extents;
            var extentsex = extentse.x;
            var extentsey = extentse.y;
            var extentsez = extentse.z;
            this.transformation.invert(OrientedBoundBox._tempM0);
            var containsAll = true;
            var containsAny = false;
            for (var i = 0; i < points.length; i++) {
                Vector3$2.transformCoordinate(points[i], OrientedBoundBox._tempM0, OrientedBoundBox._tempV30);
                var _tempV30e = OrientedBoundBox._tempV30;
                var _tempV30ex = Math.abs(_tempV30e[0]);
                var _tempV30ey = Math.abs(_tempV30e[1]);
                var _tempV30ez = Math.abs(_tempV30e[2]);
                if (MathUtils3D.nearEqual(_tempV30ex, extentsex) && MathUtils3D.nearEqual(_tempV30ey, extentsey) && MathUtils3D.nearEqual(_tempV30ez, extentsez))
                    containsAny = true;
                if (_tempV30ex < extentsex && _tempV30ey < extentsey && _tempV30ez < extentsez)
                    containsAny = true;
                else
                    containsAll = false;
            }
            if (containsAll)
                return ContainmentType.Contains;
            else if (containsAny)
                return ContainmentType.Intersects;
            else
                return ContainmentType.Disjoint;
        }
        containsSphere(sphere, ignoreScale = false) {
            var extentsE = this.extents;
            var extentsEX = extentsE.x;
            var extentsEY = extentsE.y;
            var extentsEZ = extentsE.z;
            var sphereR = sphere.radius;
            this.transformation.invert(OrientedBoundBox._tempM0);
            Vector3$2.transformCoordinate(sphere.center, OrientedBoundBox._tempM0, OrientedBoundBox._tempV30);
            var locRadius;
            if (ignoreScale) {
                locRadius = sphereR;
            } else {
                Vector3$2.scale(OrientedBoundBox.UnitX, sphereR, OrientedBoundBox._tempV31);
                Vector3$2.TransformNormal(OrientedBoundBox._tempV31, OrientedBoundBox._tempM0, OrientedBoundBox._tempV31);
                locRadius = Vector3$2.scalarLength(OrientedBoundBox._tempV31);
            }
            Vector3$2.scale(this.extents, -1, OrientedBoundBox._tempV32);
            Vector3$2.Clamp(OrientedBoundBox._tempV30, OrientedBoundBox._tempV32, this.extents, OrientedBoundBox._tempV33);
            var distance = Vector3$2.distanceSquared(OrientedBoundBox._tempV30, OrientedBoundBox._tempV33);
            if (distance > locRadius * locRadius)
                return ContainmentType.Disjoint;
            var tempV30e = OrientedBoundBox._tempV30;
            var tempV30ex = tempV30e.x;
            var tempV30ey = tempV30e.y;
            var tempV30ez = tempV30e.z;
            var tempV32e = OrientedBoundBox._tempV32;
            var tempV32ex = tempV32e.x;
            var tempV32ey = tempV32e.y;
            var tempV32ez = tempV32e.z;
            if ((((tempV32ex + locRadius <= tempV30ex) && (tempV30ex <= extentsEX - locRadius)) && ((extentsEX - tempV32ex > locRadius) && (tempV32ey + locRadius <= tempV30ey))) && (((tempV30ey <= extentsEY - locRadius) && (extentsEY - tempV32ey > locRadius)) && (((tempV32ez + locRadius <= tempV30ez) && (tempV30ez <= extentsEZ - locRadius)) && (extentsEZ - tempV32ez > locRadius)))) {
                return ContainmentType.Contains;
            }
            return ContainmentType.Intersects;
        }
        static _getRows(mat, out) {
            out.length = 3;
            var mate = mat.elements;
            var row0e = out[0];
            row0e.x = mate[0];
            row0e.y = mate[1];
            row0e.z = mate[2];
            var row1e = out[1];
            row1e.x = mate[4];
            row1e.y = mate[5];
            row1e.z = mate[6];
            var row2e = out[2];
            row2e.x = mate[8];
            row2e.y = mate[9];
            row2e.z = mate[10];
        }
        containsOrientedBoundBox(obb) {
            var i, k;
            obb.getCorners(OrientedBoundBox._corners);
            var cornersCheck = this.containsPoints(OrientedBoundBox._corners);
            if (cornersCheck != ContainmentType.Disjoint)
                return cornersCheck;
            var sizeAe = [this.extents.x, this.extents.y, this.extents.z];
            obb.extents.cloneTo(OrientedBoundBox._tempV35);
            var sizeBe = [OrientedBoundBox._tempV35.x, OrientedBoundBox._tempV35.y, OrientedBoundBox._tempV35.z];
            OrientedBoundBox._getRows(this.transformation, OrientedBoundBox._rows1);
            OrientedBoundBox._getRows(obb.transformation, OrientedBoundBox._rows2);
            var extentA, extentB, separation, dotNumber;
            for (i = 0; i < 4; i++) {
                for (k = 0; k < 4; k++) {
                    if (i == 3 || k == 3) {
                        OrientedBoundBox._tempM0.setElementByRowColumn(i, k, 0);
                        OrientedBoundBox._tempM1.setElementByRowColumn(i, k, 0);
                    } else {
                        dotNumber = Vector3$2.dot(OrientedBoundBox._rows1[i], OrientedBoundBox._rows2[k]);
                        OrientedBoundBox._tempM0.setElementByRowColumn(i, k, dotNumber);
                        OrientedBoundBox._tempM1.setElementByRowColumn(i, k, Math.abs(dotNumber));
                    }
                }
            }
            obb.getCenter(OrientedBoundBox._tempV34);
            this.getCenter(OrientedBoundBox._tempV36);
            Vector3$2.subtract(OrientedBoundBox._tempV34, OrientedBoundBox._tempV36, OrientedBoundBox._tempV30);
            var vsepAe = OrientedBoundBox._tempV31;
            vsepAe.x = Vector3$2.dot(OrientedBoundBox._tempV30, OrientedBoundBox._rows1[0]);
            vsepAe.y = Vector3$2.dot(OrientedBoundBox._tempV30, OrientedBoundBox._rows1[1]);
            vsepAe.z = Vector3$2.dot(OrientedBoundBox._tempV30, OrientedBoundBox._rows1[2]);
            var _tempV32e = OrientedBoundBox._tempV32;
            var _tempV33e = OrientedBoundBox._tempV33;
            for (i = 0; i < 3; i++) {
                _tempV32e.x = OrientedBoundBox._tempM1.getElementByRowColumn(i, 0);
                _tempV32e.y = OrientedBoundBox._tempM1.getElementByRowColumn(i, 1);
                _tempV32e.z = OrientedBoundBox._tempM1.getElementByRowColumn(i, 2);
                extentA = sizeAe[i];
                extentB = Vector3$2.dot(OrientedBoundBox._tempV35, OrientedBoundBox._tempV32);
                separation = Math.abs(vsepAe[i]);
                if (separation > extentA + extentB)
                    return ContainmentType.Disjoint;
            }
            for (k = 0; k < 3; k++) {
                _tempV32e.x = OrientedBoundBox._tempM1.getElementByRowColumn(0, k);
                _tempV32e.y = OrientedBoundBox._tempM1.getElementByRowColumn(1, k);
                _tempV32e.z = OrientedBoundBox._tempM1.getElementByRowColumn(2, k);
                _tempV33e.x = OrientedBoundBox._tempM0.getElementByRowColumn(0, k);
                _tempV33e.y = OrientedBoundBox._tempM0.getElementByRowColumn(1, k);
                _tempV33e.z = OrientedBoundBox._tempM0.getElementByRowColumn(2, k);
                extentA = Vector3$2.dot(this.extents, OrientedBoundBox._tempV32);
                extentB = sizeBe[k];
                separation = Math.abs(Vector3$2.dot(OrientedBoundBox._tempV31, OrientedBoundBox._tempV33));
                if (separation > extentA + extentB)
                    return ContainmentType.Disjoint;
            }
            for (i = 0; i < 3; i++) {
                for (k = 0; k < 3; k++) {
                    var i1 = (i + 1) % 3,
                        i2 = (i + 2) % 3;
                    var k1 = (k + 1) % 3,
                        k2 = (k + 2) % 3;
                    extentA = sizeAe[i1] * OrientedBoundBox._tempM1.getElementByRowColumn(i2, k) + sizeAe[i2] * OrientedBoundBox._tempM1.getElementByRowColumn(i1, k);
                    extentB = sizeBe[k1] * OrientedBoundBox._tempM1.getElementByRowColumn(i, k2) + sizeBe[k2] * OrientedBoundBox._tempM1.getElementByRowColumn(i, k1);
                    separation = Math.abs(vsepAe[i2] * OrientedBoundBox._tempM0.getElementByRowColumn(i1, k) - vsepAe[i1] * OrientedBoundBox._tempM0.getElementByRowColumn(i2, k));
                    if (separation > extentA + extentB)
                        return ContainmentType.Disjoint;
                }
            }
            return ContainmentType.Intersects;
        }
        containsLine(point1, point2) {
            OrientedBoundBox._corners[0] = point1;
            OrientedBoundBox._corners[1] = point2;
            var cornersCheck = this.containsPoints(OrientedBoundBox._corners);
            if (cornersCheck != ContainmentType.Disjoint)
                return cornersCheck;
            var extentsE = this.extents;
            var extentsX = extentsE.x;
            var extentsY = extentsE.y;
            var extentsZ = extentsE.z;
            this.transformation.invert(OrientedBoundBox._tempM0);
            Vector3$2.transformCoordinate(point1, OrientedBoundBox._tempM0, OrientedBoundBox._tempV30);
            Vector3$2.transformCoordinate(point2, OrientedBoundBox._tempM0, OrientedBoundBox._tempV31);
            Vector3$2.add(OrientedBoundBox._tempV30, OrientedBoundBox._tempV31, OrientedBoundBox._tempV32);
            Vector3$2.scale(OrientedBoundBox._tempV32, 0.5, OrientedBoundBox._tempV32);
            Vector3$2.subtract(OrientedBoundBox._tempV30, OrientedBoundBox._tempV32, OrientedBoundBox._tempV33);
            var _tempV33e = OrientedBoundBox._tempV33;
            var _tempV33X = _tempV33e.x;
            var _tempV33Y = _tempV33e.y;
            var _tempV33Z = _tempV33e.z;
            var _tempV34e = OrientedBoundBox._tempV34;
            var _tempV34X = _tempV34e.x = Math.abs(_tempV33e.x);
            var _tempV34Y = _tempV34e.y = Math.abs(_tempV33e.y);
            var _tempV34Z = _tempV34e.z = Math.abs(_tempV33e.z);
            var _tempV32e = OrientedBoundBox._tempV32;
            var _tempV32X = _tempV32e.x;
            var _tempV32Y = _tempV32e.y;
            var _tempV32Z = _tempV32e.z;
            if (Math.abs(_tempV32X) > extentsX + _tempV34X)
                return ContainmentType.Disjoint;
            if (Math.abs(_tempV32Y) > extentsY + _tempV34Y)
                return ContainmentType.Disjoint;
            if (Math.abs(_tempV32Z) > extentsZ + _tempV34Z)
                return ContainmentType.Disjoint;
            if (Math.abs(_tempV32Y * _tempV33Z - _tempV32Z * _tempV33Y) > (extentsY * _tempV34Z + extentsZ * _tempV34Y))
                return ContainmentType.Disjoint;
            if (Math.abs(_tempV32X * _tempV33Z - _tempV32Z * _tempV33X) > (extentsX * _tempV34Z + extentsZ * _tempV34X))
                return ContainmentType.Disjoint;
            if (Math.abs(_tempV32X * _tempV33Y - _tempV32Y * _tempV33X) > (extentsX * _tempV34Y + extentsY * _tempV34X))
                return ContainmentType.Disjoint;
            return ContainmentType.Intersects;
        }
        containsBoundBox(box) {
            var i, k;
            var min = box.min;
            var max = box.max;
            box.getCorners(OrientedBoundBox._corners);
            var cornersCheck = this.containsPoints(OrientedBoundBox._corners);
            if (cornersCheck != ContainmentType.Disjoint)
                return cornersCheck;
            Vector3$2.subtract(max, min, OrientedBoundBox._tempV30);
            Vector3$2.scale(OrientedBoundBox._tempV30, 0.5, OrientedBoundBox._tempV30);
            Vector3$2.add(min, OrientedBoundBox._tempV30, OrientedBoundBox._tempV30);
            Vector3$2.subtract(max, OrientedBoundBox._tempV30, OrientedBoundBox._tempV31);
            var sizeAe = [this.extents.x, this.extents.y, this.extents.z];
            var sizeBe = [OrientedBoundBox._tempV31.x, OrientedBoundBox._tempV31.y, OrientedBoundBox._tempV31.z];
            OrientedBoundBox._getRows(this.transformation, OrientedBoundBox._rows1);
            this.transformation.invert(OrientedBoundBox._tempM0);
            var extentA, extentB, separation, dotNumber;
            for (i = 0; i < 3; i++) {
                for (k = 0; k < 3; k++) {
                    OrientedBoundBox._tempM1.setElementByRowColumn(i, k, Math.abs(OrientedBoundBox._tempM0.getElementByRowColumn(i, k)));
                }
            }
            this.getCenter(OrientedBoundBox._tempV35);
            Vector3$2.subtract(OrientedBoundBox._tempV30, OrientedBoundBox._tempV35, OrientedBoundBox._tempV32);
            var vsepAe = [OrientedBoundBox._tempV31.x, OrientedBoundBox._tempV31.y, OrientedBoundBox._tempV31.z];
            vsepAe[0] = Vector3$2.dot(OrientedBoundBox._tempV32, OrientedBoundBox._rows1[0]);
            vsepAe[1] = Vector3$2.dot(OrientedBoundBox._tempV32, OrientedBoundBox._rows1[1]);
            vsepAe[2] = Vector3$2.dot(OrientedBoundBox._tempV32, OrientedBoundBox._rows1[2]);
            var _tempV33e = [OrientedBoundBox._tempV33.x, OrientedBoundBox._tempV33.y, OrientedBoundBox._tempV33.z];
            var _tempV34e = [OrientedBoundBox._tempV34.x, OrientedBoundBox._tempV34.y, OrientedBoundBox._tempV34.z];
            for (i = 0; i < 3; i++) {
                _tempV33e[0] = OrientedBoundBox._tempM1.getElementByRowColumn(i, 0);
                _tempV33e[1] = OrientedBoundBox._tempM1.getElementByRowColumn(i, 1);
                _tempV33e[2] = OrientedBoundBox._tempM1.getElementByRowColumn(i, 2);
                extentA = sizeAe[i];
                extentB = Vector3$2.dot(OrientedBoundBox._tempV31, OrientedBoundBox._tempV33);
                separation = Math.abs(vsepAe[i]);
                if (separation > extentA + extentB)
                    return ContainmentType.Disjoint;
            }
            for (k = 0; k < 3; k++) {
                _tempV33e[0] = OrientedBoundBox._tempM1.getElementByRowColumn(0, k);
                _tempV33e[1] = OrientedBoundBox._tempM1.getElementByRowColumn(1, k);
                _tempV33e[2] = OrientedBoundBox._tempM1.getElementByRowColumn(2, k);
                _tempV34e[0] = OrientedBoundBox._tempM0.getElementByRowColumn(0, k);
                _tempV34e[1] = OrientedBoundBox._tempM0.getElementByRowColumn(1, k);
                _tempV34e[2] = OrientedBoundBox._tempM0.getElementByRowColumn(2, k);
                extentA = Vector3$2.dot(this.extents, OrientedBoundBox._tempV33);
                extentB = sizeBe[k];
                separation = Math.abs(Vector3$2.dot(OrientedBoundBox._tempV31, OrientedBoundBox._tempV34));
                if (separation > extentA + extentB)
                    return ContainmentType.Disjoint;
            }
            for (i = 0; i < 3; i++) {
                for (k = 0; k < 3; k++) {
                    var i1 = (i + 1) % 3,
                        i2 = (i + 2) % 3;
                    var k1 = (k + 1) % 3,
                        k2 = (k + 2) % 3;
                    extentA = sizeAe[i1] * OrientedBoundBox._tempM1.getElementByRowColumn(i2, k) + sizeAe[i2] * OrientedBoundBox._tempM1.getElementByRowColumn(i1, k);
                    extentB = sizeBe[k1] * OrientedBoundBox._tempM1.getElementByRowColumn(i, k2) + sizeBe[k2] * OrientedBoundBox._tempM1.getElementByRowColumn(i, k1);
                    separation = Math.abs(vsepAe[i2] * OrientedBoundBox._tempM0.getElementByRowColumn(i1, k) - vsepAe[i1] * OrientedBoundBox._tempM0.getElementByRowColumn(i2, k));
                    if (separation > extentA + extentB)
                        return ContainmentType.Disjoint;
                }
            }
            return ContainmentType.Intersects;
        }
        intersectsRay(ray, out) {
            Vector3$2.scale(this.extents, -1, OrientedBoundBox._tempV30);
            this.transformation.invert(OrientedBoundBox._tempM0);
            Vector3$2.TransformNormal(ray.direction, OrientedBoundBox._tempM0, OrientedBoundBox._ray.direction);
            Vector3$2.transformCoordinate(ray.origin, OrientedBoundBox._tempM0, OrientedBoundBox._ray.origin);
            OrientedBoundBox._boxBound1.min = OrientedBoundBox._tempV30;
            OrientedBoundBox._boxBound1.max = this.extents;
            var intersects = CollisionUtils.intersectsRayAndBoxRP(OrientedBoundBox._ray, OrientedBoundBox._boxBound1, out);
            if (intersects !== -1)
                Vector3$2.transformCoordinate(out, this.transformation, out);
            return intersects;
        }
        clamp(origin, target, clamp, point) {
            Vector3$2.scale(this.extents, -1, OrientedBoundBox._tempV30);
            this.transformation.invert(OrientedBoundBox._tempM0);
            Vector3$2.subtract(target, origin, OrientedBoundBox._ray.direction);
            origin.cloneTo(OrientedBoundBox._ray.origin);
            Vector3$2.TransformNormal(OrientedBoundBox._ray.direction, OrientedBoundBox._tempM0, OrientedBoundBox._ray.direction);
            Vector3$2.transformV3ToV3(OrientedBoundBox._ray.origin, OrientedBoundBox._tempM0, OrientedBoundBox._ray.origin);
            OrientedBoundBox._boxBound1.min = OrientedBoundBox._tempV30;
            OrientedBoundBox._boxBound1.max = this.extents;
            var intersects = CollisionUtils.intersectsRayAndBoxRD(OrientedBoundBox._ray, OrientedBoundBox._boxBound1);
            if (intersects !== -1) {
                if (intersects * intersects > Vector3$2.distanceSquared(origin, target)) {
                    return ContainmentType.Disjoint;
                }
                Vector3$2.scale(OrientedBoundBox._ray.direction, intersects, point);
                Vector3$2.add(OrientedBoundBox._ray.origin, point, point);
                if (Math.abs(point.x - OrientedBoundBox._boxBound1.min.x) < 0.01) {
                    OrientedBoundBox._tempV32.setValue(-1, 0, 0);
                    OrientedBoundBox._tempV33.setValue(OrientedBoundBox._boxBound1.min.x, 0, 0);
                } else if (Math.abs(point.x - OrientedBoundBox._boxBound1.max.x) < 0.01) {
                    OrientedBoundBox._tempV32.setValue(1, 0, 0);
                    OrientedBoundBox._tempV33.setValue(OrientedBoundBox._boxBound1.max.x, 0, 0);
                } else if (Math.abs(point.y - OrientedBoundBox._boxBound1.min.y) < 0.01) {
                    OrientedBoundBox._tempV32.setValue(0, -1, 0);
                    OrientedBoundBox._tempV33.setValue(0, OrientedBoundBox._boxBound1.min.y, 0);
                } else if (Math.abs(point.y - OrientedBoundBox._boxBound1.max.y) < 0.01) {
                    OrientedBoundBox._tempV32.setValue(0, 1, 0);
                    OrientedBoundBox._tempV33.setValue(0, OrientedBoundBox._boxBound1.max.y, 0);
                } else if (Math.abs(point.z - OrientedBoundBox._boxBound1.min.z) < 0.01) {
                    OrientedBoundBox._tempV32.setValue(0, 0, -1);
                    OrientedBoundBox._tempV33.setValue(0, 0, OrientedBoundBox._boxBound1.min.z);
                } else if (Math.abs(point.z - OrientedBoundBox._boxBound1.max.z) < 0.01) {
                    OrientedBoundBox._tempV32.setValue(0, 0, 1);
                    OrientedBoundBox._tempV33.setValue(0, 0, OrientedBoundBox._boxBound1.max.z);
                }
                Vector3$2.transformV3ToV3(target, OrientedBoundBox._tempM0, OrientedBoundBox._tempV34);
                let constant = Vector3$2.dot(OrientedBoundBox._tempV33, OrientedBoundBox._tempV32);
                Vector3$2.scale(OrientedBoundBox._tempV32, -1, OrientedBoundBox._tempV32);
                let scale = (Vector3$2.dot(OrientedBoundBox._tempV32, OrientedBoundBox._tempV34) + constant) * -1;
                OrientedBoundBox._tempV32.cloneTo(clamp);
                Vector3$2.scale(clamp, scale, clamp);
                Vector3$2.add(clamp, OrientedBoundBox._tempV34, clamp);
                Vector3$2.transformV3ToV3(clamp, this.transformation, clamp);
                Vector3$2.transformV3ToV3(point, this.transformation, point);
            }
            return intersects;
        }
        _getLocalCorners(corners) {
            corners.length = 8;
            var extentsE = this.extents;
            OrientedBoundBox._tempV30.x = extentsE.x;
            OrientedBoundBox._tempV31.y = extentsE.y;
            OrientedBoundBox._tempV32.z = extentsE.z;
            Vector3$2.add(OrientedBoundBox._tempV30, OrientedBoundBox._tempV31, OrientedBoundBox._tempV33);
            Vector3$2.add(OrientedBoundBox._tempV33, OrientedBoundBox._tempV32, corners[0]);
            Vector3$2.add(OrientedBoundBox._tempV30, OrientedBoundBox._tempV31, OrientedBoundBox._tempV33);
            Vector3$2.subtract(OrientedBoundBox._tempV33, OrientedBoundBox._tempV32, corners[1]);
            Vector3$2.subtract(OrientedBoundBox._tempV31, OrientedBoundBox._tempV30, OrientedBoundBox._tempV33);
            Vector3$2.subtract(OrientedBoundBox._tempV33, OrientedBoundBox._tempV30, corners[2]);
            Vector3$2.subtract(OrientedBoundBox._tempV31, OrientedBoundBox._tempV30, OrientedBoundBox._tempV33);
            Vector3$2.add(OrientedBoundBox._tempV33, OrientedBoundBox._tempV32, corners[3]);
            Vector3$2.subtract(OrientedBoundBox._tempV30, OrientedBoundBox._tempV31, OrientedBoundBox._tempV33);
            Vector3$2.add(OrientedBoundBox._tempV33, OrientedBoundBox._tempV32, corners[4]);
            Vector3$2.subtract(OrientedBoundBox._tempV30, OrientedBoundBox._tempV31, OrientedBoundBox._tempV33);
            Vector3$2.subtract(OrientedBoundBox._tempV33, OrientedBoundBox._tempV32, corners[5]);
            Vector3$2.scale(corners[0], -1, corners[6]);
            Vector3$2.subtract(OrientedBoundBox._tempV32, OrientedBoundBox._tempV30, OrientedBoundBox._tempV33);
            Vector3$2.subtract(OrientedBoundBox._tempV33, OrientedBoundBox._tempV31, corners[7]);
        }
        static getObbtoObbMatrix4x4(a, b, noMatrixScaleApplied, out) {
            var at = a.transformation;
            var bt = b.transformation;
            if (noMatrixScaleApplied) {
                OrientedBoundBox._getRows(at, OrientedBoundBox._rows1);
                OrientedBoundBox._getRows(bt, OrientedBoundBox._rows2);
                for (var i = 0; i < 3; i++) {
                    for (var k = 0; k < 3; k++) {
                        out.setElementByRowColumn(i, k, Vector3$2.dot(OrientedBoundBox._rows2[i], OrientedBoundBox._rows1[k]));
                    }
                }
                b.getCenter(OrientedBoundBox._tempV30);
                a.getCenter(OrientedBoundBox._tempV31);
                Vector3$2.subtract(OrientedBoundBox._tempV30, OrientedBoundBox._tempV31, OrientedBoundBox._tempV32);
                var AtoBMe = out.elements;
                AtoBMe[12] = Vector3$2.dot(OrientedBoundBox._tempV32, OrientedBoundBox._rows1[0]);
                AtoBMe[13] = Vector3$2.dot(OrientedBoundBox._tempV32, OrientedBoundBox._rows1[1]);
                AtoBMe[14] = Vector3$2.dot(OrientedBoundBox._tempV32, OrientedBoundBox._rows1[2]);
                AtoBMe[15] = 1;
            } else {
                at.invert(OrientedBoundBox._tempM0);
                Matrix4x4$1.multiply(bt, OrientedBoundBox._tempM0, out);
            }
        }
        static merge(a, b, noMatrixScaleApplied) {
            var ae = a.extents;
            var at = a.transformation;
            OrientedBoundBox.getObbtoObbMatrix4x4(a, b, noMatrixScaleApplied, OrientedBoundBox._tempM0);
            b._getLocalCorners(OrientedBoundBox._corners);
            Vector3$2.transformCoordinate(OrientedBoundBox._corners[0], OrientedBoundBox._tempM0, OrientedBoundBox._corners[0]);
            Vector3$2.transformCoordinate(OrientedBoundBox._corners[1], OrientedBoundBox._tempM0, OrientedBoundBox._corners[1]);
            Vector3$2.transformCoordinate(OrientedBoundBox._corners[2], OrientedBoundBox._tempM0, OrientedBoundBox._corners[2]);
            Vector3$2.transformCoordinate(OrientedBoundBox._corners[3], OrientedBoundBox._tempM0, OrientedBoundBox._corners[3]);
            Vector3$2.transformCoordinate(OrientedBoundBox._corners[4], OrientedBoundBox._tempM0, OrientedBoundBox._corners[4]);
            Vector3$2.transformCoordinate(OrientedBoundBox._corners[5], OrientedBoundBox._tempM0, OrientedBoundBox._corners[5]);
            Vector3$2.transformCoordinate(OrientedBoundBox._corners[6], OrientedBoundBox._tempM0, OrientedBoundBox._corners[6]);
            Vector3$2.transformCoordinate(OrientedBoundBox._corners[7], OrientedBoundBox._tempM0, OrientedBoundBox._corners[7]);
            Vector3$2.scale(ae, -1, OrientedBoundBox._boxBound1.min);
            ae.cloneTo(OrientedBoundBox._boxBound1.max);
            BoundBox$1.createfromPoints(OrientedBoundBox._corners, OrientedBoundBox._boxBound2);
            BoundBox$1.merge(OrientedBoundBox._boxBound2, OrientedBoundBox._boxBound1, OrientedBoundBox._boxBound3);
            var box3Min = OrientedBoundBox._boxBound3.min;
            var box3Max = OrientedBoundBox._boxBound3.max;
            Vector3$2.subtract(box3Max, box3Min, OrientedBoundBox._tempV30);
            Vector3$2.scale(OrientedBoundBox._tempV30, 0.5, OrientedBoundBox._tempV30);
            Vector3$2.add(box3Min, OrientedBoundBox._tempV30, OrientedBoundBox._tempV32);
            Vector3$2.subtract(box3Max, OrientedBoundBox._tempV32, ae);
            Vector3$2.transformCoordinate(OrientedBoundBox._tempV32, at, OrientedBoundBox._tempV33);
        }
        equals(obb) {
            return this.extents == obb.extents && this.transformation == obb.transformation;
        }
        cloneTo(destObject) {
            var dest = destObject;
            this.extents.cloneTo(dest.extents);
            this.transformation.cloneTo(dest.transformation);
        }
    }
    OrientedBoundBox._tempV30 = new Vector3$2();
    OrientedBoundBox._tempV31 = new Vector3$2();
    OrientedBoundBox._tempV32 = new Vector3$2();
    OrientedBoundBox._tempV33 = new Vector3$2();
    OrientedBoundBox._tempV34 = new Vector3$2();
    OrientedBoundBox._tempV35 = new Vector3$2();
    OrientedBoundBox._tempV36 = new Vector3$2();
    OrientedBoundBox._tempM0 = new Matrix4x4$1();
    OrientedBoundBox._tempM1 = new Matrix4x4$1();
    OrientedBoundBox._corners = new Array(new Vector3$2(), new Vector3$2(), new Vector3$2(), new Vector3$2(), new Vector3$2(), new Vector3$2(), new Vector3$2(), new Vector3$2());
    OrientedBoundBox._rows1 = new Array(new Vector3$2(), new Vector3$2(), new Vector3$2());
    OrientedBoundBox._rows2 = new Array(new Vector3$2(), new Vector3$2(), new Vector3$2());
    OrientedBoundBox._ray = new Ray(new Vector3$2(), new Vector3$2());
    OrientedBoundBox._boxBound1 = new BoundBox$1(new Vector3$2(), new Vector3$2());
    OrientedBoundBox._boxBound2 = new BoundBox$1(new Vector3$2(), new Vector3$2());
    OrientedBoundBox._boxBound3 = new BoundBox$1(new Vector3$2(), new Vector3$2());
    OrientedBoundBox.UnitX = new Vector3$2(1, 0, 0);

    var Vector3$3 = Laya.Vector3;
    var Matrix4x4$2 = Laya.Matrix4x4;
    var PixelLineSprite3D = Laya.PixelLineSprite3D;
    var BoundBox$2 = Laya.BoundBox;
    var Color = Laya.Color;
    class CubeBoxCollider extends CubePhysicsCompnent {
        constructor(owner, isStatic, layer = 0) {
            super(owner, isStatic, layer);
            this.oriBoundCenter = new Vector3$3();
            this.position = new Vector3$3(0, 0, 0);
            this.scale = new Vector3$3(2, 2, 2);
            this.privateScale = new Vector3$3(0, 0, 0);
            this.lineActive = false;
            this.temp = new Vector3$3(0, 0, 0);
            this._vec1 = new Vector3$3();
            this._vec2 = new Vector3$3();
            this.scaleMatrix = new Matrix4x4$2();
            this.W_minx = 9999;
            this.W_miny = 9999;
            this.W_minz = 9999;
            this.W_maxx = -9999;
            this.W_maxy = -9999;
            this.W_maxz = -9999;
            this.OBBWorldPointList = [];
            this.orientedBoundBox = new OrientedBoundBox(new Vector3$3(), new Matrix4x4$2());
            this._primitPosition = new Vector3$3();
            this._disparity = new Vector3$3();
            this.tempVector = new Vector3$3();
            this.isUpdate = true;
            this.OBBpoints = [];
            this.cubePoint = new Vector3$3();
            this.type = CubePhysicsCompnent.TYPE_BOX;
            let child = this.owner.getChildByName('box');
            if (!child) {
                if (!(this.owner instanceof Laya.MeshSprite3D)) {
                    throw new Error('is not MeshSprite3D');
                }
                this._sprite3D = this.owner;
            } else {
                this._sprite3D = child;
                this._sprite3D.meshRenderer.enable = false;
            }
            for (var k = 0; k < 8; k++) {
                this.OBBWorldPointList.push(new Vector3$3());
            }
            this.tran = this._sprite3D.transform;
            let mesh = this._sprite3D.meshFilter.sharedMesh;
            let min = new Vector3$3();
            let max = new Vector3$3();
            Vector3$3.subtract(mesh.bounds.getCenter(), mesh.bounds.getExtent(), min);
            Vector3$3.add(mesh.bounds.getCenter(), mesh.bounds.getExtent(), max);
            let boundbox = new BoundBox$2(min, max);
            let v1 = new Vector3$3();
            Vector3$3.subtract(this._sprite3D.transform.position, this._sprite3D.transform.localPosition, v1);
            Vector3$3.add(boundbox.max, v1, boundbox.max);
            Vector3$3.add(boundbox.min, v1, boundbox.min);
            OrientedBoundBox.createByBoundBox(boundbox, this.orientedBoundBox);
            var vect = this.orientedBoundBox.extents;
            this.privateScale.setValue(vect.x, vect.y, vect.z);
            var OBBcenter = new Vector3$3();
            this.orientedBoundBox.getCenter(OBBcenter);
            this._boundBox = boundbox;
            this.enable();
            this.updataMinMax();
            this.bounds = new Laya.Bounds(new Vector3$3(this.W_minx, this.W_miny, this.W_minz), new Vector3$3(this.W_maxx, this.W_maxy, this.W_maxz));
            if (this.isStatic) {
                if (ConfigManager.platform == PLATFORM_TYPE.VIVO) {
                    let octree = CubePhysicsCompnent.getOCTree();
                    octree.add(this);
                } else {
                    CubePhysicsCompnent.getOCTree().addRender(this);
                }
            } else {}
            if (CubePhysicsCompnent.isDebug) {
                this.pixelline = new PixelLineSprite3D(20);
                this._sprite3D.scene.addChild(this.pixelline);
            }
            if (CubePhysicsCompnent.isDebug) {
                this._showline();
            }
        }
        onUpdate() {
            if (!this.isUpdate)
                return;
            if (CubePhysicsCompnent.isDebug) {
                this._showline();
            }
            if (this.isStatic)
                return;
            var extend = this.orientedBoundBox.extents;
            var transform = this._sprite3D.transform;
            let pos = transform.position;
            this._boundBox.max.setValue(pos.x + extend.x, pos.y + extend.y, pos.z + extend.z);
            this._boundBox.min.setValue(pos.x - extend.x, pos.y - extend.y, pos.z - extend.z);
        }
        updataObbTranform() {
            var obbMat = this.orientedBoundBox.transformation;
            var rotation = this.tran.rotation;
            var scale1 = this.tran.getWorldLossyScale();
            let pos = this.tran.position;
            Vector3$3.add(this._primitPosition, this.position, this._disparity);
            Matrix4x4$2.createAffineTransformation(pos, rotation, CubePhysicsCompnent.VectorOne, obbMat);
            this.orientedBoundBox.transformation = obbMat;
            var extentsE = this.orientedBoundBox.extents;
            extentsE.x = scale1.x * this.privateScale.x;
            extentsE.y = scale1.y * this.privateScale.y;
            extentsE.z = scale1.z * this.privateScale.z;
            this.orientedBoundBox.extents = extentsE;
            var extend = this.orientedBoundBox.extents;
            this._boundBox.max.setValue(pos.x + extend.x, pos.y + extend.y, pos.z + extend.z);
            this._boundBox.min.setValue(pos.x - extend.x, pos.y - extend.y, pos.z - extend.z);
        }
        updateTransfrom() {
            var extend = this.orientedBoundBox.extents;
            let pos = this.tran.position;
            this._boundBox.max.setValue(pos.x + extend.x, pos.y + extend.y, pos.z + extend.z);
            this._boundBox.min.setValue(pos.x - extend.x, pos.y - extend.y, pos.z - extend.z);
        }
        isCollision(other) {
            switch (other.type) {
                case 0:
                    return this.boxAndBox(other);
                    break;
                case 1:
                    return this.boxAndSphere(other);
                    break;
                default:
                    return 999;
            }
        }
        clamp(origin, target, clamp, point) {
            return this.orientedBoundBox.clamp(origin, target, clamp, point);
        }
        intersectsRay(ray, out) {
            return this.orientedBoundBox.intersectsRay(ray, out);
        }
        _showline() {
            this.pixelline.active = true;
            this.drawBound();
        }
        _noShowLine() {
            this.pixelline.active = false;
        }
        drawBound(color = Color.BLACK) {
            this.pixelline.clear();
            this.orientedBoundBox.getCorners(this.OBBWorldPointList);
            this.pixelline.addLine(this.OBBWorldPointList[0], this.OBBWorldPointList[1], color, color);
            this.pixelline.addLine(this.OBBWorldPointList[1], this.OBBWorldPointList[2], color, color);
            this.pixelline.addLine(this.OBBWorldPointList[2], this.OBBWorldPointList[3], color, color);
            this.pixelline.addLine(this.OBBWorldPointList[3], this.OBBWorldPointList[0], color, color);
            this.pixelline.addLine(this.OBBWorldPointList[0], this.OBBWorldPointList[4], color, color);
            this.pixelline.addLine(this.OBBWorldPointList[1], this.OBBWorldPointList[5], color, color);
            this.pixelline.addLine(this.OBBWorldPointList[2], this.OBBWorldPointList[6], color, color);
            this.pixelline.addLine(this.OBBWorldPointList[3], this.OBBWorldPointList[7], color, color);
            this.pixelline.addLine(this.OBBWorldPointList[4], this.OBBWorldPointList[5], color, color);
            this.pixelline.addLine(this.OBBWorldPointList[5], this.OBBWorldPointList[6], color, color);
            this.pixelline.addLine(this.OBBWorldPointList[6], this.OBBWorldPointList[7], color, color);
            this.pixelline.addLine(this.OBBWorldPointList[7], this.OBBWorldPointList[4], color, color);
        }
        boxAndSphere(other) {
            return this.orientedBoundBox.containsSphere(other._boundSphere, true);
        }
        boxAndBox(other) {
            return this.orientedBoundBox.containsOrientedBoundBox(other.orientedBoundBox);
        }
        updataMinMax() {
            this.orientedBoundBox.getCorners(this.OBBWorldPointList);
            for (var i = 0; i < this.OBBWorldPointList.length; i++) {
                if (this.OBBWorldPointList[i].x > this.W_maxx)
                    this.W_maxx = this.OBBWorldPointList[i].x;
                if (this.OBBWorldPointList[i].x < this.W_minx)
                    this.W_minx = this.OBBWorldPointList[i].x;
                if (this.OBBWorldPointList[i].y > this.W_maxy)
                    this.W_maxy = this.OBBWorldPointList[i].y;
                if (this.OBBWorldPointList[i].y < this.W_miny)
                    this.W_miny = this.OBBWorldPointList[i].y;
                if (this.OBBWorldPointList[i].z > this.W_maxz)
                    this.W_maxz = this.OBBWorldPointList[i].z;
                if (this.OBBWorldPointList[i].z < this.W_minz)
                    this.W_minz = this.OBBWorldPointList[i].z;
            }
        }
        initmaxmin() {
            this.W_minx = 9999;
            this.W_miny = 9999;
            this.W_minz = 9999;
            this.W_maxx = -9999;
            this.W_maxy = -9999;
            this.W_maxz = -9999;
        }
        init2maxmin() {
            this.W_minx = Math.floor(this.W_minx);
            this.W_miny = Math.floor(this.W_miny);
            this.W_minz = Math.floor(this.W_minz);
            this.W_maxx = Math.ceil(this.W_maxx);
            this.W_maxy = Math.ceil(this.W_maxy);
            this.W_maxz = Math.ceil(this.W_maxz);
        }
        destory() {
            this.clearLine();
            super.destory();
            this.isUpdate = false;
        }
        disable() {
            super.disable();
            if (this.pixelline) {
                this._noShowLine();
            }
            this.isUpdate = false;
        }
        enable() {
            super.enable();
            this.updataObbTranform();
            if (this.pixelline) {
                this.pixelline.active = true;
            }
            this.isUpdate = true;
        }
        remove() {
            super.remove();
            if (this.pixelline) {
                this._noShowLine();
            }
            this.isUpdate = false;
        }
        clearLine() {
            if (this.pixelline) {
                this.pixelline.clear();
                this.pixelline.destroy();
            }
        }
        resizeBound() {
            var Mesharray = [];
            var spriteArray = [];
            CubePhysicsCompnent.findAllMesh(this._sprite3D, Mesharray, spriteArray);
            var AllPositions = [];
            for (var i = 0, n = Mesharray.length; i < n; i++) {
                var positions = [];
                Mesharray[i].getPositions(positions);
                var worldmatrix = spriteArray[i].transform.worldMatrix;
                for (var j = 0; j < positions.length; j++) {
                    Vector3$3.transformCoordinate(positions[j], worldmatrix, positions[j]);
                    AllPositions.push(positions[j]);
                }
            }
            var boundbox = new BoundBox$2(new Vector3$3(0, 0, 0), new Vector3$3(0, 0, 0));
            BoundBox$2.createfromPoints(AllPositions, boundbox);
            OrientedBoundBox.createByBoundBox(boundbox, this.orientedBoundBox);
            var vect = this.orientedBoundBox.extents;
            this.privateScale.setValue(vect.x, vect.y, vect.z);
            var OBBcenter = new Vector3$3();
            this.orientedBoundBox.getCenter(OBBcenter);
            Vector3$3.subtract(OBBcenter, this._sprite3D.transform.position, this._primitPosition);
        }
    }

    class Face {
        constructor(a = 0, b = 0, c = 0) {
            this.c = c;
            this.b = b;
            this.a = a;
        }
    }

    class Geometry {
        constructor() {
            this.faces = [];
            this.vertices = [];
        }
        static mergeVertices(geometry) {
            var verticesMap = {};
            var unique = [],
                changes = [];
            var v, key;
            var precisionPoints = 4;
            var precision = 100000;
            var i, il, face;
            var indices, j, jl;
            for (i = 0, il = geometry.vertices.length; i < il; i++) {
                v = geometry.vertices[i];
                key = Math.round(v.x * precision) + '_' +
                    Math.round(v.y * precision) + '_' +
                    Math.round(v.z * precision);
                if (verticesMap[key] === undefined) {
                    verticesMap[key] = i;
                    unique.push(v);
                    changes[i] = unique.length - 1;
                } else {
                    changes[i] = changes[verticesMap[key]];
                }
            };
            var faceIndicesToRemove = [];
            for (i = 0, il = geometry.faces.length; i < il; i++) {
                face = geometry.faces[i];
                face.a = changes[face.a];
                face.b = changes[face.b];
                face.c = changes[face.c];
                indices = [face.a, face.b, face.c];
                for (var n = 0; n < 3; n++) {
                    if (indices[n] === indices[(n + 1) % 3]) {
                        faceIndicesToRemove.push(i);
                        break;
                    }
                }
            }
            for (i = faceIndicesToRemove.length - 1; i >= 0; i--) {
                var idx = faceIndicesToRemove[i];
                geometry.faces.splice(idx, 1);
            };
            var diff = geometry.vertices.length - unique.length;
            geometry.vertices = unique;
            return diff;
        }
    }

    class FixedVector3 {
        constructor(x = 0, y = 0, z = 0) {
            this.x = x;
            this.y = y;
            this.z = z;
        }
        clean() {
            this.x = null;
            this.y = null;
            this.z = null;
        }
        static add(left, right, out) {
            out.x = left.x + right.x;
            out.y = left.y + right.y;
            out.z = left.z + right.z;
        }
        static sub(left, right, out) {
            out.x = left.x - right.x;
            out.y = left.y - right.y;
            out.z = left.z - right.z;
        }
        static dot(left, right) {
            let x = left.x * right.x;
            let y = left.y * right.y;
            let z = left.z * right.z;
            return x + y + z;
        }
        static scalar(left, right, out) {
            out.x = left.x * right;
            out.y = left.y * right;
            out.z = left.z * right;
        }
        static normalize(origin, out) {
            FixedVector3.scalar(origin, 1 / FixedVector3.scalarLength(origin), out);
        }
        static scalarLength(a) {
            let lenSqrt = FixedVector3.scalarLengthSquared(a);
            return Math.sqrt(lenSqrt);
        }
        static distanceToSquared(a, b) {
            var dx = a.x - b.x;
            var dy = a.y - b.y;
            var dz = a.z - b.z;
            let x = dx * dx;
            let y = dy * dy;
            let z = dz * dz;
            return x + y + z;
        }
        static distanceTo(a, b) {
            var dx = a.x - b.x;
            var dy = a.y - b.y;
            var dz = a.z - b.z;
            let x = dx * dx;
            let y = dy * dy;
            let z = dz * dz;
            return Math.sqrt(x + y + z);
        }
        static MagnitudeXZ(a, b) {
            var dx = a.x - b.x;
            var dz = a.z - b.z;
            let x = dx * dx;
            let z = dz * dz;
            return Math.sqrt(x + z);
        }
        static MagnitudeXZToSquared(a, b) {
            var dx = a.x - b.x;
            var dz = a.z - b.z;
            let x = dx * dx;
            let z = dz * dz;
            return x + z;
        }
        static scalarLengthSquared(a) {
            let x = a.x * a.x;
            let y = a.y * a.y;
            let z = a.z * a.z;
            return x + y + z;
        }
        static cross(left, right, out) {
            var ax = left.x,
                ay = left.y,
                az = left.z,
                bx = right.x,
                by = right.y,
                bz = right.z;
            out.x = ay * bz - az * by;
            out.y = az * bx - ax * bz;
            out.z = ax * by - ay * bx;
        }
        static angleTo(left, right) {
            const denominator = Math.sqrt(FixedVector3.scalarLengthSquared(left) * FixedVector3.scalarLengthSquared(right));
            if (denominator == 0)
                return Mathf.PI / 2;
            const theta = FixedVector3.dot(left, right) / denominator;
            let a = Mathf.clamp(theta, -1, 1);
            return Math.acos(a);
        }
        set(x, y, z) {
            this.x = x;
            this.y = y;
            this.z = z;
        }
        copy(a) {
            this.x = a.x;
            this.y = a.y;
            this.z = a.z;
        }
        clone() {
            return new FixedVector3(this.x, this.y, this.z);
        }
        log() {
            console.log(`{x = ${this.x}, y = ${this.y}, z = ${this.z}}`);
        }
        static isParallel(a, b) {
            if (a.x * b.z - a.z * b.x == 0) {
                return true;
            }
            return false;
        }
        static angle(a, b) {
            let c = FixedVector3.dot(a, b);
            c = c / (FixedVector3.scalarLength(a) * FixedVector3.scalarLength(b));
            let angle = Math.acos(c) / Math.PI * 180;
            return angle;
        }
    }
    FixedVector3.up = new FixedVector3(0, 1, 0);

    class BinaryHeap {
        constructor(scoreFunction) {
            this.content = [];
            this.scoreFunction = scoreFunction;
        }
        push(element) {
            this.content.push(element);
            this.sinkDown(this.content.length - 1);
        }
        pop() {
            const result = this.content[0];
            const end = this.content.pop();
            if (this.content.length > 0) {
                this.content[0] = end;
                this.bubbleUp(0);
            }
            return result;
        }
        remove(node) {
            const i = this.content.indexOf(node);
            const end = this.content.pop();
            if (i !== this.content.length - 1) {
                this.content[i] = end;
                if (this.scoreFunction(end) < this.scoreFunction(node)) {
                    this.sinkDown(i);
                } else {
                    this.bubbleUp(i);
                }
            }
        }
        size() {
            return this.content.length;
        }
        rescoreElement(node) {
            this.sinkDown(this.content.indexOf(node));
        }
        sinkDown(n) {
            const element = this.content[n];
            while (n > 0) {
                const parentN = ((n + 1) >> 1) - 1;
                const parent = this.content[parentN];
                if (this.scoreFunction(element) < this.scoreFunction(parent)) {
                    this.content[parentN] = element;
                    this.content[n] = parent;
                    n = parentN;
                } else {
                    break;
                }
            }
        }
        bubbleUp(n) {
            const length = this.content.length,
                element = this.content[n],
                elemScore = this.scoreFunction(element);
            while (true) {
                const child2N = (n + 1) << 1,
                    child1N = child2N - 1;
                let swap = null;
                let child1Score;
                if (child1N < length) {
                    const child1 = this.content[child1N];
                    child1Score = this.scoreFunction(child1);
                    if (child1Score < elemScore) {
                        swap = child1N;
                    }
                }
                if (child2N < length) {
                    const child2 = this.content[child2N],
                        child2Score = this.scoreFunction(child2);
                    if (child2Score < (swap === null ? elemScore : child1Score)) {
                        swap = child2N;
                    }
                }
                if (swap !== null) {
                    this.content[n] = this.content[swap];
                    this.content[swap] = element;
                    n = swap;
                } else {
                    break;
                }
            }
        }
    }

    const _vec1 = new FixedVector3();
    const _vec2 = new FixedVector3();
    const _vec3 = new FixedVector3();
    const _vec4 = new FixedVector3();
    const _lowestPoint = 100000;
    const _highestPoint = -100000;
    class Utils {
        static computeCentroids(geometry) {
            var f, fl, face;
            for (f = 0, fl = geometry.faces.length; f < fl; f++) {
                face = geometry.faces[f];
                face.centroid = new FixedVector3(0, 0, 0);
                FixedVector3.add(face.centroid, geometry.vertices[face.a], face.centroid);
                FixedVector3.add(face.centroid, geometry.vertices[face.b], face.centroid);
                FixedVector3.add(face.centroid, geometry.vertices[face.c], face.centroid);
                FixedVector3.scalar(face.centroid, 1 / 3, face.centroid);
            }
        }
        static roundNumber(value, decimals) {
            return Mathf.toFixed(value, decimals);
        }
        static sample(list) {
            let rand = Mathf.random();
            let n = Math.floor(rand);
            let idx = n * list.length;
            return list[idx];
        }
        static mergeVertexIds(aList, bList) {
            var sharedVertices = [];
            aList.forEach((vID) => {
                if (bList.indexOf(vID) >= 0) {
                    sharedVertices.push(vID);
                }
            });
            if (sharedVertices.length < 2)
                return [];
            if (sharedVertices.indexOf(aList[0]) != -1 && sharedVertices.indexOf(aList[aList.length - 1]) != -1) {
                aList.push(aList.shift());
            }
            if (sharedVertices.indexOf(bList[0]) != -1 && sharedVertices.indexOf(bList[bList.length - 1]) != -1) {
                bList.push(bList.shift());
            }
            sharedVertices = [];
            aList.forEach((vId) => {
                if (bList.includes(vId)) {
                    sharedVertices.push(vId);
                }
            });
            var clockwiseMostSharedVertex = sharedVertices[1];
            var counterClockwiseMostSharedVertex = sharedVertices[0];
            var cList = aList.slice();
            while (cList[0] !== clockwiseMostSharedVertex) {
                cList.push(cList.shift());
            }
            var c = 0;
            var temp = bList.slice();
            while (temp[0] !== counterClockwiseMostSharedVertex) {
                temp.push(temp.shift());
                if (c++ > 10)
                    throw new Error('Unexpected state');
            }
            temp.shift();
            temp.pop();
            cList = cList.concat(temp);
            return cList;
        }
        static setPolygonCentroid(polygon, navigationMesh) {
            var sum = new FixedVector3();
            var vertices = navigationMesh.vertices;
            polygon.vertexIds.forEach((vId) => {
                FixedVector3.add(sum, vertices[vId], sum);
            });
            FixedVector3.scalar(sum, 1 / polygon.vertexIds.length, sum);
            polygon.centroid.copy(sum);
        }
        static cleanPolygon(polygon, navigationMesh) {
            var newVertexIds = [];
            var vertices = navigationMesh.vertices;
            for (var i = 0; i < polygon.vertexIds.length; i++) {
                var vertex = vertices[polygon.vertexIds[i]];
                var nextVertexId, previousVertexId;
                var nextVertex, previousVertex;
                if (i === 0) {
                    nextVertexId = polygon.vertexIds[1];
                    previousVertexId = polygon.vertexIds[polygon.vertexIds.length - 1];
                } else if (i === polygon.vertexIds.length - 1) {
                    nextVertexId = polygon.vertexIds[0];
                    previousVertexId = polygon.vertexIds[polygon.vertexIds.length - 2];
                } else {
                    nextVertexId = polygon.vertexIds[i + 1];
                    previousVertexId = polygon.vertexIds[i - 1];
                }
                nextVertex = vertices[nextVertexId];
                previousVertex = vertices[previousVertexId];
                var a = new FixedVector3();
                FixedVector3.sub(nextVertex.clone(), vertex, a);
                var b = new FixedVector3();
                FixedVector3.sub(previousVertex.clone(), vertex, b);
                var angle = FixedVector3.angleTo(a, b);
                if (angle > Mathf.PI - 0.01 && angle < Mathf.PI + 0.01) {
                    var goodNeighbours = [];
                    polygon.neighbours.forEach((neighbour) => {
                        if (!neighbour.vertexIds.includes(polygon.vertexIds[i])) {
                            goodNeighbours.push(neighbour);
                        }
                    });
                    polygon.neighbours = goodNeighbours;
                } else {
                    newVertexIds.push(polygon.vertexIds[i]);
                }
            }
            polygon.vertexIds = newVertexIds;
            this.setPolygonCentroid(polygon, navigationMesh);
        }
        static isConvex(polygon, navigationMesh) {
            var vertices = navigationMesh.vertices;
            if (polygon.vertexIds.length < 3)
                return false;
            var convex = true;
            var total = 0;
            var results = [];
            for (var i = 0; i < polygon.vertexIds.length; i++) {
                var vertex = vertices[polygon.vertexIds[i]];
                var nextVertex, previousVertex;
                if (i === 0) {
                    nextVertex = vertices[polygon.vertexIds[1]];
                    previousVertex = vertices[polygon.vertexIds[polygon.vertexIds.length - 1]];
                } else if (i === polygon.vertexIds.length - 1) {
                    nextVertex = vertices[polygon.vertexIds[0]];
                    previousVertex = vertices[polygon.vertexIds[polygon.vertexIds.length - 2]];
                } else {
                    nextVertex = vertices[polygon.vertexIds[i + 1]];
                    previousVertex = vertices[polygon.vertexIds[i - 1]];
                }
                var a = nextVertex.clone().sub(vertex);
                var b = previousVertex.clone().sub(vertex);
                var angle = FixedVector3.angleTo(a, b);
                total += angle;
                if (angle === Math.PI || angle === 0)
                    return false;
                FixedVector3.cross(a, b, a);
                var r = a.y;
                results.push(r);
            }
            results.forEach((r) => {
                if (r === 0)
                    convex = false;
            });
            if (results[0] > 0) {
                results.forEach((r) => {
                    if (r < 0)
                        convex = false;
                });
            } else {
                results.forEach((r) => {
                    if (r > 0)
                        convex = false;
                });
            }
            return convex;
        }
        static distanceToSquared(a, b) {
            return FixedVector3.distanceToSquared(a, b);
        }
        static isPointInPoly(poly, pt) {
            for (var c = false, i = -1, l = poly.length, j = l - 1; ++i < l; j = i)
                ((poly[i].z <= pt.z && pt.z < poly[j].z) || (poly[j].z <= pt.z && pt.z < poly[i].z)) && (pt.x < (poly[j].x - poly[i].x) * (pt.z - poly[i].z) / (poly[j].z - poly[i].z) + poly[i].x) && (c = !c);
            return c;
        }
        static isVectorInPolygon(vector, polygon, vertices) {
            var lowestPoint = _lowestPoint;
            var highestPoint = _highestPoint;
            var polygonVertices = [];
            polygon.vertexIds.forEach((vId) => {
                lowestPoint = Math.min(vertices[vId].y, lowestPoint);
                highestPoint = Math.max(vertices[vId].y, highestPoint);
                polygonVertices.push(vertices[vId]);
            });
            if (vector.y < highestPoint + 0.5 && vector.y > lowestPoint - 0.5 &&
                this.isPointInPoly(polygonVertices, vector)) {
                return true;
            }
            return false;
        }
        static triarea2(a, b, c) {
            var ax = b.x - a.x;
            var az = b.z - a.z;
            var bx = c.x - a.x;
            var bz = c.z - a.z;
            return bx * az - ax * bz;
        }
        static vequal(a, b) {
            return this.distanceToSquared(a, b) < 0.00001;
        }
        static pointinTriangle(A, B, C, P) {
            let v0 = _vec1;
            FixedVector3.sub(C, A, v0);
            let v1 = _vec2;
            FixedVector3.sub(B, A, v1);
            let v2 = _vec3;
            FixedVector3.sub(P, A, v2);
            let dot00 = FixedVector3.dot(v0, v0);
            let dot01 = FixedVector3.dot(v0, v1);
            let dot02 = FixedVector3.dot(v0, v2);
            let dot11 = FixedVector3.dot(v1, v1);
            let dot12 = FixedVector3.dot(v1, v2);
            let inverDeno = 1 / (dot00 * dot11 - dot01 * dot01);
            let u = (dot11 * dot02 - dot01 * dot12) * inverDeno;
            if (u < 0 || u > 1) {
                return false;
            }
            let v = (dot00 * dot12 - dot01 * dot02) * inverDeno;
            if (v < 0 || v > 1) {
                return false;
            }
            return u + v <= 1;
        }
        static nearestPointStrictXZ(lineStart, lineEnd, point, out) {
            FixedVector3.sub(lineEnd, lineStart, _vec1);
            _vec2.copy(_vec1);
            FixedVector3.normalize(_vec2, _vec3);
            FixedVector3.sub(point, lineStart, _vec4);
            let closestPoint = FixedVector3.dot(_vec4, _vec3);
            closestPoint = Mathf.clamp(closestPoint, 0, FixedVector3.scalarLength(_vec2));
            FixedVector3.scalar(_vec3, closestPoint, _vec3);
            FixedVector3.add(lineStart, _vec3, out);
        }
        static projectPoint(lineStart, lineEnd, point, out) {
            FixedVector3.sub(lineEnd, lineStart, _vec1);
            _vec2.copy(_vec1);
            FixedVector3.normalize(_vec2, _vec3);
            FixedVector3.sub(point, lineStart, _vec4);
            let closestPoint = FixedVector3.dot(_vec4, _vec3);
            FixedVector3.scalar(_vec3, closestPoint, _vec3);
            FixedVector3.add(lineStart, _vec3, out);
        }
    }
    Utils.vecTmp1 = new FixedVector3();

    class AStar {
        static init(graph) {
            for (let x = 0; x < graph.length; x++) {
                const node = graph[x];
                node.f = 0;
                node.g = 0;
                node.h = 0;
                node.cost = 1;
                node.visited = false;
                node.closed = false;
                node.parent = null;
            }
        }
        static cleanUp(graph) {
            for (let x = 0; x < graph.length; x++) {
                const node = graph[x];
                delete node.f;
                delete node.g;
                delete node.h;
                delete node.cost;
                delete node.visited;
                delete node.closed;
                delete node.parent;
            }
        }
        static heap() {
            return new BinaryHeap(function(node) {
                return node.f;
            });
        }
        static search(graph, start, end) {
            this.init(graph);
            const openHeap = this.heap();
            openHeap.push(start);
            while (openHeap.size() > 0) {
                const currentNode = openHeap.pop();
                if (currentNode === end) {
                    let curr = currentNode;
                    const ret = [];
                    while (curr.parent) {
                        ret.push(curr);
                        curr = curr.parent;
                    }
                    this.cleanUp(ret);
                    return ret.reverse();
                }
                currentNode.closed = true;
                const neighbours = this.neighbours(graph, currentNode);
                for (let i = 0, il = neighbours.length; i < il; i++) {
                    const neighbour = neighbours[i];
                    if (neighbour.closed) {
                        continue;
                    }
                    const gScore = currentNode.g + neighbour.cost;
                    const beenVisited = neighbour.visited;
                    if (!beenVisited || gScore < neighbour.g) {
                        neighbour.visited = true;
                        neighbour.parent = currentNode;
                        if (!neighbour.centroid || !end.centroid)
                            throw new Error('Unexpected state');
                        neighbour.h = neighbour.h || this.heuristic(neighbour.centroid, end.centroid);
                        neighbour.g = gScore;
                        neighbour.f = neighbour.h + neighbour.g;
                        if (!beenVisited) {
                            openHeap.push(neighbour);
                        } else {
                            openHeap.rescoreElement(neighbour);
                        }
                    }
                }
            }
            return [];
        }
        static heuristic(pos1, pos2) {
            return Utils.distanceToSquared(pos1, pos2);
        }
        static neighbours(graph, node) {
            const ret = [];
            for (let e = 0; e < node.neighbours.length; e++) {
                ret.push(graph[node.neighbours[e]]);
            }
            return ret;
        }
    }

    let polygonId = 1;
    class Builder {
        static buildZone(geometry) {
            const navMesh = this._buildNavigationMesh(geometry);
            const zone = {};
            navMesh.vertices.forEach((v) => {
                v.x = Utils.roundNumber(v.x, 2);
                v.y = Utils.roundNumber(v.y, 2);
                v.z = Utils.roundNumber(v.z, 2);
            });
            zone.vertices = navMesh.vertices;
            const groups = this._buildPolygonGroups(navMesh);
            zone.groups = [];
            const findPolygonIndex = function(group, p) {
                for (let i = 0; i < group.length; i++) {
                    if (p === group[i])
                        return i;
                }
            };
            groups.forEach((group) => {
                const newGroup = [];
                group.forEach((p) => {
                    const neighbours = p.neighbours.map((n) => findPolygonIndex(group, n));
                    const portals = p.neighbours.map((n) => this._getSharedVerticesInOrder(p, n));
                    p.centroid.x = Utils.roundNumber(p.centroid.x, 2);
                    p.centroid.y = Utils.roundNumber(p.centroid.y, 2);
                    p.centroid.z = Utils.roundNumber(p.centroid.z, 2);
                    newGroup.push({
                        id: findPolygonIndex(group, p),
                        neighbours: neighbours,
                        vertexIds: p.vertexIds,
                        centroid: p.centroid,
                        portals: portals
                    });
                });
                zone.groups.push(newGroup);
            });
            return zone;
        }
        static _buildNavigationMesh(geometry) {
            Utils.computeCentroids(geometry);
            Geometry.mergeVertices(geometry);
            return this._buildPolygonsFromGeometry(geometry);
        }
        static _buildPolygonGroups(navigationMesh) {
            const polygons = navigationMesh.polygons;
            const polygonGroups = [];
            let groupCount = 0;
            const spreadGroupId = function(polygon) {
                polygon.neighbours.forEach((neighbour) => {
                    if (neighbour.group === undefined) {
                        neighbour.group = polygon.group;
                        spreadGroupId(neighbour);
                    }
                });
            };
            polygons.forEach((polygon) => {
                if (polygon.group === undefined) {
                    polygon.group = groupCount++;
                    spreadGroupId(polygon);
                }
                if (!polygonGroups[polygon.group])
                    polygonGroups[polygon.group] = [];
                polygonGroups[polygon.group].push(polygon);
            });
            return polygonGroups;
        }
        static _buildPolygonNeighbours(polygon, navigationMesh, vertexPolygonMap) {
            const neighbors = new Set();
            const groupA = vertexPolygonMap.get(polygon.vertexIds[0]);
            const groupB = vertexPolygonMap.get(polygon.vertexIds[1]);
            const groupC = vertexPolygonMap.get(polygon.vertexIds[2]);
            groupA.forEach((candidate) => {
                if (groupB.has(candidate) || groupC.has(candidate)) {
                    if (navigationMesh.polygons[candidate].id != polygon.id) {
                        neighbors.add(navigationMesh.polygons[candidate]);
                    }
                }
            });
            groupB.forEach((candidate) => {
                if (groupC.has(candidate)) {
                    if (navigationMesh.polygons[candidate].id != polygon.id) {
                        neighbors.add(navigationMesh.polygons[candidate]);
                    }
                }
            });
            polygon.neighbours = Array.from(neighbors);
        }
        static _buildPolygonsFromGeometry(geometry) {
            const polygons = [];
            const vertices = geometry.vertices;
            const vertexPolygonMap = new Map();
            for (let i = 0; i < vertices.length; i++) {
                vertexPolygonMap.set(i, new Set());
            }
            geometry.faces.forEach((face) => {
                polygons.push({
                    id: polygonId++,
                    vertexIds: [face.a, face.b, face.c],
                    centroid: face.centroid,
                    neighbours: []
                });
                vertexPolygonMap.get(face.a).add(polygons.length - 1);
                vertexPolygonMap.get(face.b).add(polygons.length - 1);
                vertexPolygonMap.get(face.c).add(polygons.length - 1);
            });
            const navigationMesh = {
                polygons: polygons,
                vertices: vertices,
            };
            polygons.forEach((polygon) => {
                this._buildPolygonNeighbours(polygon, navigationMesh, vertexPolygonMap);
            });
            return navigationMesh;
        }
        static _getSharedVerticesInOrder(a, b) {
            const aList = a.vertexIds;
            const bList = b.vertexIds;
            const sharedVertices = new Set();
            aList.forEach((vId) => {
                if (bList.includes(vId)) {
                    sharedVertices.add(vId);
                }
            });
            if (sharedVertices.size < 2)
                return [];
            if (sharedVertices.has(aList[0]) && sharedVertices.has(aList[aList.length - 1])) {
                aList.push(aList.shift());
            }
            if (sharedVertices.has(bList[0]) && sharedVertices.has(bList[bList.length - 1])) {
                bList.push(bList.shift());
            }
            const sharedVerticesOrdered = [];
            aList.forEach((vId) => {
                if (bList.includes(vId)) {
                    sharedVerticesOrdered.push(vId);
                }
            });
            return sharedVerticesOrdered;
        }
        static setGeometryVertices(geometry) {
            let vertices = [];
            geometry.vertices.forEach((v) => {
                vertices.push(new FixedVector3(v.x, v.y, v.z));
            });
            geometry.vertices = vertices;
        }
    }

    class Channel {
        constructor() {
            this.portals = [];
        }
        push(p1, p2) {
            this.portals.push({
                left: p1,
                right: p2
            });
        }
        stringPull() {
            const portals = this.portals;
            const pts = [];
            let portalApex, portalLeft, portalRight;
            let apexIndex = 0,
                leftIndex = 0,
                rightIndex = 0;
            portalApex = portals[0].left;
            portalLeft = portals[0].left;
            portalRight = portals[0].right;
            pts.push(portalApex);
            for (let i = 1; i < portals.length; i++) {
                const left = portals[i].left;
                const right = portals[i].right;
                if (Utils.triarea2(portalApex, portalRight, right) <= 0) {
                    if (Utils.vequal(portalApex, portalRight) || Utils.triarea2(portalApex, portalLeft, right) >= 0) {
                        portalRight = right;
                        rightIndex = i;
                    } else {
                        pts.push(portalLeft);
                        portalApex = portalLeft;
                        apexIndex = leftIndex;
                        portalLeft = portalApex;
                        portalRight = portalApex;
                        leftIndex = apexIndex;
                        rightIndex = apexIndex;
                        i = apexIndex;
                        continue;
                    }
                }
                if (Utils.triarea2(portalApex, portalLeft, left) >= 0) {
                    if (Utils.vequal(portalApex, portalLeft) || Utils.triarea2(portalApex, portalRight, left) < 0) {
                        portalLeft = left;
                        leftIndex = i;
                    } else {
                        pts.push(portalRight);
                        portalApex = portalRight;
                        apexIndex = rightIndex;
                        portalLeft = portalApex;
                        portalRight = portalApex;
                        leftIndex = apexIndex;
                        rightIndex = apexIndex;
                        i = apexIndex;
                        continue;
                    }
                }
            }
            if ((pts.length === 0) || (!Utils.vequal(pts[pts.length - 1], portals[portals.length - 1].left))) {
                pts.push(portals[portals.length - 1].left);
            }
            this.path = pts;
            return pts;
        }
    }

    const _vector1 = new FixedVector3();
    const _vector2 = new FixedVector3();
    class FixedPlane {
        constructor(normal, constant) {
            this.normal = normal;
            this.constant = constant;
        }
        clean() {
            this.normal.clean();
            this.normal = null;
            this.constant = null;
        }
        setFromNormalAndCoplanarPoint(normal, point) {
            this.normal.copy(normal);
            this.constant = FixedVector3.dot(point, this.normal) * -1;
            return this;
        }
        setFromCoplanarPoints(a, b, c) {
            FixedVector3.sub(c, b, _vector1);
            FixedVector3.sub(a, b, _vector2);
            FixedVector3.cross(_vector1, _vector2, _vector1);
            FixedVector3.normalize(_vector1, _vector1);
            this.setFromNormalAndCoplanarPoint(_vector1, a);
            return this;
        }
        distanceToPoint(point) {
            return FixedVector3.dot(this.normal, point) + this.constant;
        }
        projectPoint(point, target) {
            target.copy(this.normal);
            let scale = this.distanceToPoint(point) * -1;
            FixedVector3.scalar(target, scale, target);
            FixedVector3.add(target, point, target);
        }
    }

    const _vab = new FixedVector3();
    const _vac = new FixedVector3();
    const _vbc = new FixedVector3();
    const _vap = new FixedVector3();
    const _vbp = new FixedVector3();
    const _vcp = new FixedVector3();
    class FixedTriangle {
        constructor(a, b, c) {
            this.a = a;
            this.b = b;
            this.c = c;
        }
        clean() {
            this.a.clean();
            this.b.clean();
            this.c.clean();
            this.a = null;
            this.b = null;
            this.c = null;
        }
        set(a, b, c) {
            this.a.copy(a);
            this.b.copy(b);
            this.c.copy(c);
            return this;
        }
        closestPointToPoint(p, target) {
            const a = this.a,
                b = this.b,
                c = this.c;
            let v, w;
            FixedVector3.sub(b, a, _vab);
            FixedVector3.sub(c, a, _vac);
            FixedVector3.sub(p, a, _vap);
            const d1 = FixedVector3.dot(_vab, _vap);
            const d2 = FixedVector3.dot(_vac, _vap);
            if (d1 <= 0 && d2 <= 0) {
                return target.copy(a);
            }
            FixedVector3.sub(p, b, _vbp);
            const d3 = FixedVector3.dot(_vab, _vbp);
            const d4 = FixedVector3.dot(_vac, _vbp);
            if (d3 >= 0 && d4 <= d3) {
                return target.copy(b);
            }
            const vc = (d1 * d4 - d3 * d2);
            if (vc <= 0 && d1 >= 0 && d3 <= 0) {
                v = d1 / (d1 - d3);
                target.copy(a);
                FixedVector3.scalar(_vab, v, _vab);
                return FixedVector3.add(target, _vab, target);
            }
            FixedVector3.sub(p, c, _vcp);
            const d5 = FixedVector3.dot(_vab, _vcp);
            const d6 = FixedVector3.dot(_vac, _vcp);
            if (d6 >= 0 && d5 <= d6) {
                return target.copy(c);
            }
            const vb = d5 * d2 - d1 * d6;
            if (vb <= 0 && d2 >= 0 && d6 <= 0) {
                w = d2 / (d2 - d6);
                target.copy(a);
                FixedVector3.scalar(_vac, w, _vac);
                return FixedVector3.add(target, _vac, target);
            }
            const va = d3 * d6 - d5 * d4;
            if (va <= 0 && d4 - d3 >= 0 && d5 - d6 >= 0) {
                FixedVector3.sub(c, b, _vbc);
                w = (d4 - d3) / ((d4 - d3) + (d5 - d6));
                target.copy(b);
                FixedVector3.scalar(_vbc, w, _vbc);
                return FixedVector3.add(target, _vbc, target);
            }
            const denom = 1 / ((va + vb) + vc);
            v = vb * denom;
            w = vc * denom;
            target.copy(a);
            FixedVector3.scalar(_vab, v, _vab);
            FixedVector3.scalar(_vac, w, _vac);
            FixedVector3.add(target, _vab, target);
            FixedVector3.add(target, _vac, target);
            return;
        }
    }

    const _vec1$1 = new FixedVector3();
    const _vec2$1 = new FixedVector3();
    const _vec3$1 = new FixedVector3();
    const _vec4$1 = new FixedVector3();
    class Pathfinding {
        constructor() {
            this.zones = {};
            this.point = new FixedVector3();
            this.plane = new FixedPlane(new FixedVector3(), 0);
            this.triangle = new FixedTriangle(new FixedVector3(), new FixedVector3(), new FixedVector3());
            this.closestPoint = new FixedVector3();
        }
        clean() {
            this.zones = null;
            this.point = null;
            this.plane = null;
            this.triangle = null;
            this.closestNode = null;
            this.closestPoint = null;
        }
        static createZone(geometry) {
            return Builder.buildZone(geometry);
        }
        setZoneData(zoneID, zone) {
            this.zones[zoneID] = zone;
        }
        getGroup(zoneID, position) {
            if (!this.zones[zoneID])
                return null;
            let fixedPosition = new FixedVector3(position.x, position.y, position.z);
            let closestNodeGroup = null;
            let distance = Math.pow(50, 2);
            let groups = this.zones[zoneID].groups,
                node, group, measuredDistance, i, j;
            for (i = 0; i < groups.length; i++) {
                group = groups[i];
                for (j = 0; j < group.length; j++) {
                    node = group[j];
                    measuredDistance = Utils.distanceToSquared(node.centroid, fixedPosition);
                    if (measuredDistance < distance) {
                        closestNodeGroup = i;
                        distance = measuredDistance;
                    }
                }
            }
            return closestNodeGroup;
        }
        getRandomNode(zoneID, groupID, nearPosition, nearRange) {
            if (!this.zones[zoneID])
                return new FixedVector3();
            nearPosition = nearPosition || null;
            nearRange = nearRange || 0;
            let fixedNearPoisition;
            if (nearPosition)
                fixedNearPoisition = new FixedVector3(nearPosition.x, nearPosition.y, nearPosition.z);
            const candidates = [];
            const polygons = this.zones[zoneID].groups[groupID];
            let fixedRange = nearRange;
            let p;
            for (let i = 0; i < polygons.length; i++) {
                p = polygons[i];
                if (nearPosition && nearRange) {
                    if (Utils.distanceToSquared(fixedNearPoisition, p.centroid < fixedRange * fixedRange)) {
                        candidates.push(p.centroid);
                    }
                } else {
                    candidates.push(p.centroid);
                }
            }
            return Utils.sample(candidates) || new FixedVector3();
        }
        getClosestNode(position, zoneID, groupID, checkPolygon = false) {
            const nodes = this.zones[zoneID].groups[groupID];
            const vertices = this.zones[zoneID].vertices;
            let closestNode = null;
            let closestDistance = Infinity;
            for (let i = 0; i < nodes.length; i++) {
                let node = nodes[i];
                const distance = Utils.distanceToSquared(node.centroid, position);
                if (distance < closestDistance && (!checkPolygon || Utils.isVectorInPolygon(position, node, vertices))) {
                    closestNode = node;
                    closestDistance = distance;
                }
            }
            return closestNode;
        }
        getClosestNodeFixed(position, zoneID, groupID, checkPolygon = false) {
            const nodes = this.zones[zoneID].groups[groupID];
            const vertices = this.zones[zoneID].vertices;
            let closestNode = null;
            let closestDistance = Infinity;
            let fixedPosition = new FixedVector3(position.x, position.y, position.z);
            let node;
            for (let i = 0; i < nodes.length; i++) {
                node = nodes[i];
                const distance = Utils.distanceToSquared(node.centroid, fixedPosition);
                if (distance < closestDistance && (!checkPolygon || Utils.isVectorInPolygon(fixedPosition, node, vertices))) {
                    closestNode = node;
                    closestDistance = distance;
                }
            }
            return closestNode;
        }
        findPath(startPosition, targetPosition, zoneID, groupID) {
            let fixedStartPosition = new FixedVector3(startPosition.x, startPosition.y, startPosition.z);
            let fixedTargetPosition = new FixedVector3(targetPosition.x, targetPosition.y, targetPosition.z);
            const nodes = this.zones[zoneID].groups[groupID];
            const vertices = this.zones[zoneID].vertices;
            const closestNode = this.getClosestNode(fixedStartPosition, zoneID, groupID);
            const farthestNode = this.getClosestNode(fixedTargetPosition, zoneID, groupID, true);
            if (!closestNode || !farthestNode) {
                return null;
            }
            const paths = AStar.search(nodes, closestNode, farthestNode);
            const getPortalFromTo = function(a, b) {
                for (var i = 0; i < a.neighbours.length; i++) {
                    if (a.neighbours[i] === b.id) {
                        return a.portals[i];
                    }
                }
            };
            const channel = new Channel();
            channel.push(fixedStartPosition, fixedStartPosition);
            for (let i = 0; i < paths.length; i++) {
                const polygon = paths[i];
                const nextPolygon = paths[i + 1];
                if (nextPolygon) {
                    const portals = getPortalFromTo(polygon, nextPolygon);
                    channel.push(vertices[portals[0]], vertices[portals[1]]);
                }
            }
            channel.push(fixedTargetPosition, fixedTargetPosition);
            channel.stringPull();
            const path = channel.path.map((c) => new FixedVector3(c.x, c.y, c.z));
            return path;
        }
        findPathWithNode(startPosition, targetPosition, closestNode, farthestNode, zoneID, groupID) {
            const nodes = this.zones[zoneID].groups[groupID];
            const vertices = this.zones[zoneID].vertices;
            if (!closestNode || !farthestNode) {
                return null;
            }
            const paths = AStar.search(nodes, closestNode, farthestNode);
            const getPortalFromTo = function(a, b) {
                for (var i = 0; i < a.neighbours.length; i++) {
                    if (a.neighbours[i] === b.id) {
                        return a.portals[i];
                    }
                }
            };
            const channel = new Channel();
            channel.push(startPosition, startPosition);
            for (let i = 0; i < paths.length; i++) {
                const polygon = paths[i];
                const nextPolygon = paths[i + 1];
                if (nextPolygon) {
                    const portals = getPortalFromTo(polygon, nextPolygon);
                    channel.push(vertices[portals[0]], vertices[portals[1]]);
                }
            }
            channel.push(targetPosition, targetPosition);
            channel.stringPull();
            const path = channel.path.map((c) => new FixedVector3(c.x, c.y, c.z));
            return path;
        }
        alongNavMesh(startPos, startNode, endPos, clampedPos, zoneID, groupID) {
            let stack = [];
            let closed = [];
            let bestPos = _vec1$1;
            let point = _vec2$1;
            let bestDist = Infinity;
            let dis;
            let bestRef = null;
            let searchPos = _vec3$1;
            let isCollise = false;
            FixedVector3.add(startPos, endPos, searchPos);
            FixedVector3.scalar(searchPos, 0.5, searchPos);
            let searchRadius = FixedVector3.MagnitudeXZToSquared(startPos, endPos) * 0.5;
            bestPos.copy(startPos);
            stack[0] = startNode;
            closed[0] = startNode;
            const vertices = this.zones[zoneID].vertices;
            const groups = this.zones[zoneID].groups[groupID];
            if (!startNode) {
                return startNode;
            }
            let p1;
            let p2;
            let len = 0;
            while (stack.length > 0) {
                let cur = stack.shift();
                let poly = cur;
                if (Utils.isVectorInPolygon(endPos, poly, vertices)) {
                    bestRef = cur;
                    bestPos.copy(endPos);
                    isCollise = false;
                    break;
                }
                for (let i = 0, j = 2; i < 3; j = i++) {
                    let sp = poly.vertexIds[j];
                    let sq = poly.vertexIds[i];
                    let blocking = true;
                    let conn = null;
                    for (let q = 0; q < cur.neighbours.length; q++) {
                        conn = groups[cur.neighbours[q]];
                        if (conn == null)
                            continue;
                        for (let i2 = 0, j2 = 2; i2 < 3; j2 = i2++) {
                            let sp2 = conn.vertexIds[j2];
                            let sq2 = conn.vertexIds[i2];
                            if ((sp2 == sp && sq2 == sq) || (sp2 == sq && sq2 == sp)) {
                                blocking = false;
                                break;
                            }
                        }
                        if (!blocking) {
                            break;
                        }
                    }
                    if (blocking) {
                        Utils.nearestPointStrictXZ(vertices[sp], vertices[sq], endPos, point);
                        dis = FixedVector3.MagnitudeXZToSquared(point, endPos);
                        if (dis < bestDist) {
                            bestPos.copy(point);
                            bestDist = dis;
                            bestRef = cur;
                            isCollise = true;
                            p1 = vertices[sp];
                            p2 = vertices[sq];
                        }
                    } else {
                        if (closed.indexOf(conn) != -1)
                            continue;
                        closed[closed.length] = conn;
                        Utils.nearestPointStrictXZ(vertices[sp], vertices[sq], searchPos, point);
                        dis = FixedVector3.MagnitudeXZToSquared(point, searchPos);
                        if (dis <= searchRadius) {
                            stack[stack.length] = conn;
                        }
                    }
                }
            }
            if (!bestRef) {
                console.error('alongMesh error');
                bestRef = startNode;
                bestPos = startPos;
            }
            this.plane.setFromCoplanarPoints(vertices[bestRef.vertexIds[0]], vertices[bestRef.vertexIds[1]], vertices[bestRef.vertexIds[2]]);
            this.plane.projectPoint(bestPos, _vec4$1);
            clampedPos.x = _vec4$1.x;
            clampedPos.y = _vec4$1.y;
            clampedPos.z = _vec4$1.z;
            return {
                node: bestRef,
                isCollise,
                p1,
                p2,
            };
        }
        getProjectByNode(vecPoint, navNode, out, zoneId) {
            const vertices = this.zones[zoneId].vertices;
            this.plane.setFromCoplanarPoints(vertices[navNode.vertexIds[0]], vertices[navNode.vertexIds[1]], vertices[navNode.vertexIds[2]]);
            _vec1$1.copy(vecPoint);
            this.plane.projectPoint(_vec1$1, out);
        }
    }
    const Zone = {};
    const Group = {};
    const Node = {};

    class PerformanceManager {}
    PerformanceManager.isCloseAILogic = false;
    PerformanceManager.isCloseAI = false;
    PerformanceManager.isCloseAni = false;
    PerformanceManager.isCloseEffect = false;
    PerformanceManager.isCloseSound = false;
    PerformanceManager.isCloseCharacterCtrl = true;
    PerformanceManager.isCloseAniCtrl = false;
    PerformanceManager.isCloseAttack = false;
    PerformanceManager.isCloseAILogicBaseLayer = false;
    PerformanceManager.isCloseZD = false;
    PerformanceManager.isDebug = false;

    var Vector3$4 = Laya.Vector3;
    class MapManager {
        static loadMap() {
            MapManager.curMap = GameScene.scene3d.getChildByName('map');
            MapManager.curMap.name = 'map';
            MapManager.curObjNav = GameScene.scene3d.getChildByName(OBJ_NAME.NAV_MESH);
            this.setNavMesh();
            if (PerformanceManager.isCloseCharacterCtrl) {
                let collider = MapManager.curMap.getChildByName('collide');
                let list = [];
                CommonUtil.getAllChildrenOfClass(collider, Laya.MeshSprite3D, list);
                for (let i = 0; i < list.length; i++) {
                    let box = list[i];
                    let scaleX = Math.abs(box.transform.localScaleX);
                    let scaleZ = Math.abs(box.transform.localScaleZ);
                    box.transform.localScaleX = Math.abs(box.transform.localScaleX) + 1;
                    box.transform.localScaleY = Math.abs(box.transform.localScaleY);
                    box.transform.localScaleZ = Math.abs(box.transform.localScaleZ) + 1;
                    box.meshRenderer.enable = false;
                    new CubeBoxCollider(box, true, -1);
                    box.transform.localScaleX = scaleX;
                    box.transform.localScaleZ = scaleZ;
                    new CubeBoxCollider(box, true, -2);
                }
                let phy = [];
                for (let i = 0; i < phy.length; i++) {}
            }
        }
        static cleanMap() {
            if (GameScene.scene3d) {
                console.log('清除主场景');
                GameScene.scene3d.removeSelf();
                GameScene.scene3d = null;
            }
        }
        static setNavMesh() {
            let mesh = MapManager.curObjNav.meshFilter.sharedMesh;
            let vertices = [];
            let floatVertices = new Float32Array(mesh.getVertices());
            let verDec = mesh.getVertexDeclaration();
            var element = verDec.getVertexElementByIndex(0);
            var uint8VerStr = verDec.vertexStride;
            var floatVerStr = uint8VerStr / 4;
            var uint8EleOffset = element.offset;
            var floatEleOffset = uint8EleOffset / 4;
            for (var i = 0; i < mesh.vertexCount; i++) {
                var offset = floatVerStr * i + floatEleOffset;
                vertices[i] = new FixedVector3(floatVertices[offset], floatVertices[offset + 1], floatVertices[offset + 2]);
            }
            let indices = mesh.getIndices();
            let faces = [];
            for (let i = 0; i < indices.length; i += 3) {
                let idx1 = parseInt(indices[i].toString());
                let idx2 = parseInt(indices[i + 1].toString());
                let idx3 = parseInt(indices[i + 2].toString());
                faces.push(new Face(idx3, idx2, idx1));
            }
            let g = new Geometry();
            g.faces = faces;
            g.vertices = vertices;
            let zoneNodes = Pathfinding.createZone(g);
            let pathfinder = new Pathfinding();
            pathfinder.setZoneData(MapManager.zoneID, zoneNodes);
            MapManager.pathfinder = pathfinder;
            MapManager.navGroup = pathfinder.getGroup(MapManager.zoneID, new Vector3$4());
        }
        static drawNavMesh(vertices, faces) {
            MapManager.pixelline = new Laya.PixelLineSprite3D(faces.length * 3);
            GameScene.scene3d.addChild(MapManager.pixelline);
            for (var i = 0; i < faces.length; i++) {
                var vertex0 = new Vector3$4(vertices[faces[i].a].x, vertices[faces[i].a].y, vertices[faces[i].a].z);
                var vertex1 = new Vector3$4(vertices[faces[i].b].x, vertices[faces[i].b].y, vertices[faces[i].b].z);
                var vertex2 = new Vector3$4(vertices[faces[i].c].x, vertices[faces[i].c].y, vertices[faces[i].c].z);
                MapManager.pixelline.addLine(vertex0, vertex1, Laya.Color.RED, Laya.Color.RED);
                MapManager.pixelline.addLine(vertex1, vertex2, Laya.Color.RED, Laya.Color.RED);
                MapManager.pixelline.addLine(vertex2, vertex0, Laya.Color.RED, Laya.Color.RED);
            }
        }
    }
    MapManager.scene = null;
    MapManager.curMap = null;
    MapManager.curObjNav = null;
    MapManager.zoneID = 'level';
    MapManager.mapList = [{
            sub: 'sub8',
            path: 'sub8/3d/LayaScene_map1/Conventional/map1.ls'
        },
        {
            sub: 'sub9',
            path: 'sub9/3d/LayaScene_map2/Conventional/map2.ls',
        },
    ];

    class SceneManager {
        static pushScene(scene) {
            this.curScene = new scene();
            Laya.stage.addChild(this.curScene);
            this.curScene.onEnter();
        }
        static getCurScene() {
            return SceneManager.curScene;
        }
    }
    SceneManager.curScene = null;

    var GAME_MODE_TYPE;
    (function(GAME_MODE_TYPE) {
        GAME_MODE_TYPE[GAME_MODE_TYPE["TEAMCOMPETITION"] = 1] = "TEAMCOMPETITION";
        GAME_MODE_TYPE[GAME_MODE_TYPE["BIOCHEMISTRY"] = 2] = "BIOCHEMISTRY";
        GAME_MODE_TYPE[GAME_MODE_TYPE["SNIPERMODE"] = 3] = "SNIPERMODE";
        GAME_MODE_TYPE[GAME_MODE_TYPE["TWOVSTWOMODE"] = 4] = "TWOVSTWOMODE";
        GAME_MODE_TYPE[GAME_MODE_TYPE["KNIFEWARMODE"] = 5] = "KNIFEWARMODE";
        GAME_MODE_TYPE[GAME_MODE_TYPE["ONEVSONEMODE"] = 6] = "ONEVSONEMODE";
    })(GAME_MODE_TYPE || (GAME_MODE_TYPE = {}));
    var GAME_MAP;
    (function(GAME_MAP) {
        GAME_MAP[GAME_MAP["UN_MAP"] = -1] = "UN_MAP";
        GAME_MAP[GAME_MAP["RAND"] = 0] = "RAND";
        GAME_MAP[GAME_MAP["SHIP"] = 1] = "SHIP";
        GAME_MAP[GAME_MAP["SNOWFIELD"] = 2] = "SNOWFIELD";
        GAME_MAP[GAME_MAP["FRORTRESS"] = 3] = "FRORTRESS";
        GAME_MAP[GAME_MAP["SNIPER_FIELD"] = 4] = "SNIPER_FIELD";
        GAME_MAP[GAME_MAP["BIOCHEMICAL_DESERT"] = 5] = "BIOCHEMICAL_DESERT";
        GAME_MAP[GAME_MAP["BIOCHEMICAL_DESERT1"] = 6] = "BIOCHEMICAL_DESERT1";
    })(GAME_MAP || (GAME_MAP = {}));
    class ModeManager {
        static modeChoose(mode) {
            this.mode = mode;
        }
        static isCanOpenSniperMode() {
            let gameCurLib = RoleManager.getInstance().getSkinGameCurLib();
            for (let k = 0; k < gameCurLib.length; k++) {
                if (ARM.getDataByKey(gameCurLib[k]).type == 3) {
                    return true;
                }
            }
            return false;
        }
        static isCanOpenKnifeMode() {
            let gameCurLib = RoleManager.getInstance().getGameCurPropLib();
            for (let k = 0; k < gameCurLib.length; k++) {
                console.log(PROP.getDataByKey(gameCurLib[k]));
                if (PROP.getDataByKey(gameCurLib[k]).type == 2) {
                    return true;
                }
            }
            return false;
        }
        static modeLoad(isTest = false) {
            GameScene.synthesisViewCtrl.removeSelf();
            UIManager.clean();
            UIManager.openFunction(FUNCTION_TAG.GAME, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE);
            let id = 0;
            if (isTest) {
                this.mode = GAME_MODE_TYPE.TEAMCOMPETITION;
                this.map = RandomUtil.onlyOneRandomInt(1, 3);
                ModeManager.modeLoadSubPackage(function() {
                    console.log('获取得地图：', ModeManager.map);
                    id = this.map - 1;
                    let data = MapManager.mapList[id];
                    let str = '';
                    if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD || ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS)
                        str = 'native/';
                    SceneManager.getCurScene().createAllModeMap(str + data.path);
                }.bind(this));
                return;
            }
            console.log('获取得地图：', ModeManager.map);
            id = this.map - 1;
            let data = MapManager.mapList[id];
            let str = '';
            if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD || ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS)
                str = 'native/';
            SceneManager.getCurScene().createAllModeMap(str + data.path);
        }
        static modeLoadSubPackage(success) {
            let id = this.map - 1;
            let data1 = MapManager.mapList[id];
            let subPack = [
                data1.sub,
            ];
            if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD || ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS) {
                subPack = ['native'];
            }
            if (this.isFristLoad) {
                subPack.push(SUB_NAME.GAME_SOUND);
                this.isFristLoad = false;
            }
            let idx = 0;
            let load = function() {
                if (!subPack[idx]) {
                    success();
                    return;
                }
                ResourceManager.loadSubpackage(subPack[idx], function() {
                    idx++;
                    load();
                }, function(percent) {});
            };
            load();
        }
    }
    ModeManager.mode = GAME_MODE_TYPE.TEAMCOMPETITION;
    ModeManager.map = GAME_MAP.SHIP;
    ModeManager.isFristLoad = true;

    class RoleData {
        static getDataByKey(key) {
            if (RoleData.cache[key])
                return RoleData.cache[key];
            if (key == 1) {
                let template = new RoleData();
                template.id = 1;
                template.objName = '001';
                template.cnName = '艾莎';
                template.cost = 0;
                template.grade = 4;
                template.icon = 'sub1/role/001.png';
                template.camp = 2;
                template.costType = 1;
                template.activityType = 1;
                template.hd = 0;
                RoleData.cache[key] = template;
                return template;
            } else if (key == 2) {
                let template = new RoleData();
                template.id = 2;
                template.objName = '002';
                template.cnName = '夏露';
                template.cost = 5;
                template.grade = 3;
                template.icon = 'sub1/role/002.png';
                template.camp = 1;
                template.costType = 2;
                template.activityType = 1;
                template.hd = 0;
                RoleData.cache[key] = template;
                return template;
            } else if (key == 3) {
                let template = new RoleData();
                template.id = 3;
                template.objName = '003';
                template.cnName = '小樱';
                template.cost = 1000;
                template.grade = 4;
                template.icon = 'sub1/role/003.png';
                template.camp = 2;
                template.costType = 1;
                template.activityType = 1;
                template.hd = 0;
                RoleData.cache[key] = template;
                return template;
            } else if (key == 4) {
                let template = new RoleData();
                template.id = 4;
                template.objName = '004';
                template.cnName = '艾莉';
                template.cost = 15;
                template.grade = 3;
                template.icon = 'sub1/role/004.png';
                template.camp = 2;
                template.costType = 3;
                template.activityType = 1;
                template.hd = 0;
                RoleData.cache[key] = template;
                return template;
            } else if (key == 5) {
                let template = new RoleData();
                template.id = 5;
                template.objName = '005';
                template.cnName = '米拉';
                template.cost = 7;
                template.grade = 4;
                template.icon = 'sub1/role/005.png';
                template.camp = 1;
                template.costType = 3;
                template.activityType = 1;
                template.hd = 0;
                RoleData.cache[key] = template;
                return template;
            } else if (key == 6) {
                let template = new RoleData();
                template.id = 6;
                template.objName = '006';
                template.cnName = '露西';
                template.cost = 20;
                template.grade = 2;
                template.icon = 'sub1/role/006.png';
                template.camp = 1;
                template.costType = 3;
                template.activityType = 1;
                template.hd = 0;
                RoleData.cache[key] = template;
                return template;
            } else if (key == 7) {
                let template = new RoleData();
                template.id = 7;
                template.objName = '007';
                template.cnName = '神乐';
                template.cost = 25;
                template.grade = 2;
                template.icon = 'sub1/role/007.png';
                template.camp = 2;
                template.costType = 3;
                template.activityType = 1;
                template.hd = 0;
                RoleData.cache[key] = template;
                return template;
            } else if (key == 8) {
                let template = new RoleData();
                template.id = 8;
                template.objName = '008';
                template.cnName = '小舞';
                template.cost = 30;
                template.grade = 1;
                template.icon = 'sub1/role/008.png';
                template.camp = 1;
                template.costType = 3;
                template.activityType = 1;
                template.hd = 0;
                RoleData.cache[key] = template;
                return template;
            }
        }
        static getDataByIndex(index) {
            if (RoleData.cache[this.keys[index]])
                return RoleData.cache[this.keys[index]];
            return this.getDataByKey(this.keys[index]);
        }
        static getAllData() {
            for (let index = 0; index < this.keys.length; index++) {
                this.getDataByKey(this.keys[index]);
            }
            return RoleData.cache;
        }
        clear() {
            RoleData.cache = {};
        }
    }
    RoleData.cache = {};
    RoleData.keys = [1, 2, 3, 4, 5, 6, 7, 8];

    var PLAY_ANI;
    (function(PLAY_ANI) {
        PLAY_ANI["IDLE"] = "idle";
        PLAY_ANI["RUN"] = "run";
        PLAY_ANI["DUNXIA"] = "dunxia";
        PLAY_ANI["DEATH"] = "death";
        PLAY_ANI["ATTACK"] = "attack";
        PLAY_ANI["RELOAD"] = "reload";
        PLAY_ANI["UP"] = "up";
        PLAY_ANI["MENU_IDLE"] = "shouye_idle";
        PLAY_ANI["RUN_LEFT"] = "run_left";
        PLAY_ANI["RUN_RIGHT"] = "run_right";
        PLAY_ANI["JUMP"] = "jump";
        PLAY_ANI["SWITCH"] = "switch";
        PLAY_ANI["ATTACK8_1"] = "attack8_1";
        PLAY_ANI["ATTACK8_2"] = "attack8_2";
    })(PLAY_ANI || (PLAY_ANI = {}));

    class SkinManager {
        static createSkin(pos, objName, isMySelf = true, newObjName, parent = GameScene.scene3d, isMenu = false, type = -1, skinId = null) {
            let skin = RoleManager.getInstance().getSelectRoleSkin();
            if (RoleManager.getInstance().trialSkin) {
                skin = RoleManager.getInstance().trialSkin;
            }
            if (skinId) {
                skin = skinId;
            }
            if (!isMenu) {
                if (!isMySelf) {
                    let list = [];
                    if (CharacterManger.playerLogicalBaseLayer.skinType == 1) {
                        if (type == ROLE_TYPE.TYPE_0) {
                            for (let k in RoleData.keys) {
                                let i = RoleData.getDataByKey(RoleData.keys[k]);
                                if (i.camp == 1) {
                                    if (i.hd) {
                                        if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS || ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD) {
                                            list.push(i);
                                        }
                                    } else
                                        list.push(i);
                                }
                            }
                        } else {
                            for (let k in RoleData.keys) {
                                let i = RoleData.getDataByKey(RoleData.keys[k]);
                                if (i.camp == 2) {
                                    if (i.hd) {
                                        if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS || ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD) {
                                            list.push(i);
                                        }
                                    } else
                                        list.push(i);
                                }
                            }
                        }
                    } else if (CharacterManger.playerLogicalBaseLayer.skinType == 2) {
                        if (type == ROLE_TYPE.TYPE_0) {
                            for (let k in RoleData.keys) {
                                let i = RoleData.getDataByKey(RoleData.keys[k]);
                                if (i.camp == 2) {
                                    if (i.hd) {
                                        if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS || ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD) {
                                            list.push(i);
                                        }
                                    } else
                                        list.push(i);
                                }
                            }
                        } else {
                            for (let k in RoleData.keys) {
                                let i = RoleData.getDataByKey(RoleData.keys[k]);
                                if (i.camp == 1) {
                                    if (i.hd) {
                                        if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS || ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD) {
                                            list.push(i);
                                        }
                                    } else
                                        list.push(i);
                                }
                            }
                        }
                    }
                    skin = list[RandomUtil.onlyOneRandomInt(0, list.length)].id;
                    if (ConfigManager.isReviewVersion() && ConfigManager.isHideSkinById(skin)) {
                        skin = 6;
                    }
                }
            }
            if (!isMySelf && !isMenu) {
                CharacterManger.drSkinList.push(skin);
            }
            let ori = ResourceManager.getRes(RES_PATH.SKIN_PREFEB).getChildByName(RoleData.getDataByKey(skin).objName);
            let newObj = Laya.Sprite3D.instantiate(ori, parent);
            if (!isMenu) {
                if (type == ROLE_TYPE.TYPE_0) {} else {}
            }
            if (!isMySelf) {
                let camera = CommonUtil.findChildByName(newObj, OBJ_NAME.CAMREA);
                if (camera)
                    camera.destroy();
            } else {
                let camera = CommonUtil.findChildByName(newObj, OBJ_NAME.CAMREA);
                RoleManager.getInstance().trialSkin = null;
            }
            newObj.name = newObjName;
            newObj.getChildAt(0).name = newObjName;
            newObj.transform.position = pos;
            let node = CommonUtil.findChildByName(newObj, 'jiaobiao');
            node.active = false;
            let node1 = CommonUtil.findChildByName(newObj, 'halo');
            node1.active = false;
            return newObj;
        }
        static createHand(pos, newObjName, parent = GameScene.scene3d) {
            let skin = RoleManager.getInstance().getSelectRoleSkin();
            if (RoleManager.getInstance().trialSkin) {
                skin = RoleManager.getInstance().trialSkin;
            }
            let ori = ResourceManager.getRes(RES_PATH.HAND_PREFEB).getChildByName('1' + RoleData.getDataByKey(skin).objName);
            let newObj = Laya.Sprite3D.instantiate(ori, parent);
            let camera = CommonUtil.findChildByName(newObj, OBJ_NAME.CAMREA);
            newObj.name = newObjName;
            newObj.getChildAt(0).name = newObjName;
            newObj.transform.position = pos;
            RoleManager.getInstance().trialSkin = null;
            return newObj;
        }
        static createZombie(pos, newObjName, parent = GameScene.scene3d) {
            let ori = ResourceManager.getRes(RES_PATH.SKIN_ZOMBIE).getChildByName('001');
            console.log('ZOMBIE' + ori);
            let newObj = Laya.Sprite3D.instantiate(ori, parent);
            let newLife;
            let ori1 = ResourceManager.getRes(RES_PATH.SKIN_PREFEB).getChildByName('life1');
            newLife = Laya.Sprite3D.instantiate(ori1, newObj.getChildAt(0));
            newLife.transform.localPosition = new Laya.Vector3(0, 3.25, 0);
            newLife.name = 'life';
            newObj.name = newObjName;
            newObj.getChildAt(0).name = newObjName;
            newObj.transform.position = pos;
            return newObj;
        }
        static createRoleViewSkin(pos, parent, isMySelf, id) {
            let ori = ResourceManager.getRes(RES_PATH.SKIN_PREFEB).getChildByName(RoleData.getDataByKey(id).objName);
            let newObj = Laya.Sprite3D.instantiate(ori, parent);
            if (!isMySelf) {
                let camera = CommonUtil.findChildByName(newObj, OBJ_NAME.CAMREA);
                if (camera)
                    camera.destroy();
            } else {}
            newObj.transform.position = pos;
            let node = CommonUtil.findChildByName(newObj, 'jiaobiao');
            node.active = false;
            let node1 = CommonUtil.findChildByName(newObj, 'halo');
            node1.active = false;
            return newObj;
        }
        static createMenuArm(id, model, armType = 0) {
            let buqiang = CommonUtil.findChildByName(model, 'buqiang');
            let shouqiang = CommonUtil.findChildByName(model, 'shouqiang');
            let dao = CommonUtil.findChildByName(model, 'dao');
            let shouliudan = CommonUtil.findChildByName(model, 'shouliudan');
            buqiang.destroyChildren();
            shouqiang.destroyChildren();
            dao.destroyChildren();
            shouliudan.destroyChildren();
            let shouye_buqiang = CommonUtil.findChildByName(model, 'shouye_buqiang');
            let shouye_shouqiang = CommonUtil.findChildByName(model, 'shouye_shouqiang');
            let shouye_dao = CommonUtil.findChildByName(model, 'shouye_dao');
            let shouye_shouliudan = CommonUtil.findChildByName(model, 'shouye_shouliudan');
            shouye_buqiang.destroyChildren();
            shouye_shouqiang.destroyChildren();
            shouye_dao.destroyChildren();
            shouye_shouliudan.destroyChildren();
            let data = ARM.getDataByKey(id) ? ARM.getDataByKey(id) : PROP.getDataByKey(id);
            let ori = ResourceManager.getRes(RES_PATH.WEAPON_PREFEB).getChildByName(data.objName);
            let newObj;
            if (data.type == 2) {
                newObj = Laya.Sprite3D.instantiate(ori, shouye_dao);
            } else if (data.type == 4) {
                newObj = Laya.Sprite3D.instantiate(ori, shouye_shouqiang);
            } else if (data.type == 8) {
                newObj = Laya.Sprite3D.instantiate(ori, shouye_shouliudan);
            } else {
                newObj = Laya.Sprite3D.instantiate(ori, shouye_buqiang);
            }
            newObj.transform.localPosition = new Laya.Vector3();
            newObj.transform.localRotationEuler = new Laya.Vector3();
            let ctrl = model.getChildAt(0).getComponent(Laya.Animator);
            ctrl.play(PLAY_ANI.MENU_IDLE + ((data.type == 5 || data.type == 6 || data.type == 7) ? '1' : ARM.getDataByKey(id) ? ARM.getDataByKey(id).type : PROP.getDataByKey(id).type));
            return newObj;
        }
        static onLyToCreateArm(id, parent) {
            console.log('传入ID：', id);
            let ori = ResourceManager.getRes(RES_PATH.WEAPON_PREFEB).getChildByName(ARM.getDataByKey(id) ? ARM.getDataByKey(id).objName : PROP.getDataByKey(id).objName);
            let newObj = Laya.Sprite3D.instantiate(ori, parent);
            return newObj;
        }
        static getTrialArm(id) {
            RoleManager.getInstance().trialArm = id;
        }
        static createParts(id, parent, scale, decorate = null, isRole = true) {
            if (!parent)
                return;
            if (id != null) {
                let data = PARTS.getDataByKey(id);
                if (data.hd) {
                    if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD || ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS) {} else {
                        return null;
                    }
                }
                if (isRole) {
                    for (let k = 0; k < PARTS.keys.length; k++) {
                        if (PARTS.getDataByKey(id).partType == PARTS.getDataByKey(PARTS.keys[k]).partType) {
                            let item = CommonUtil.findChildByName(parent, PARTS.getDataByKey(PARTS.keys[k]).parentNode);
                            item && item.destroyChildren();
                        }
                    }
                }
                console.log('创建的部件：', parent, data.parentNode);
                let decorate = CommonUtil.findChildByName(parent, data.parentNode);
                if (!decorate) {
                    decorate = parent;
                }
                let ori = ResourceManager.getRes(RES_PATH.PARTS_PREFEB).getChildByName(data.objName);
                let newObj = Laya.Sprite3D.instantiate(ori, decorate);
                newObj.transform.localPosition = new Laya.Vector3(0, 0, 0);
                newObj.transform.localRotationEuler = new Laya.Vector3(0, 0, 0);
                newObj.transform.localScale = scale;
                console.log('父级：', newObj);
                return newObj;
            } else {
                if (decorate == null) {} else {
                    if (decorate == 1 || decorate == 3) {
                        let decorate1 = CommonUtil.findChildByName(parent, 'decorate1');
                        decorate1 && decorate1.destroyChildren();
                    } else if (decorate == 2) {
                        let decorate1 = CommonUtil.findChildByName(parent, 'decorate2');
                        decorate1 && decorate1.destroyChildren();
                    }
                }
                return null;
            }
        }
        static removePartsByTS(num, parent) {
            console.log('num:', num, parent);
            let decorate1 = CommonUtil.findChildByName(parent, 'decorate1');
            let decorate2 = CommonUtil.findChildByName(parent, 'decorate2');
            console.log('decorate1:', decorate1, 'decorate2:', decorate2);
            if (num == 1 || num == 3) {
                decorate1.destroyChildren();
            } else if (num == 2) {
                decorate2.destroyChildren();
            }
        }
        static createPartsByLocal(parent, scale = new Laya.Vector3(1, 1, 1)) {
            let decorate1 = CommonUtil.findChildByName(parent, 'decorate1');
            let decorate2 = CommonUtil.findChildByName(parent, 'decorate2');
            decorate1.destroyChildren();
            decorate2.destroyChildren();
            let bag = RoleManager.getInstance().getTargetPart(1);
            if (bag != null) {
                this.createParts(bag, parent, scale);
            }
            let head = RoleManager.getInstance().getTargetPart(2);
            if (head != null) {
                this.createParts(head, parent, scale);
            }
            let wing = RoleManager.getInstance().getTargetPart(3);
            if (wing != null) {
                this.createParts(wing, parent, scale);
            }
            console.log('获取本地数据：', bag, head, wing, RoleManager.getInstance().getPartsSkin());
        }
    }

    class TaskData {
        static getDataByKey(key) {
            if (TaskData.cache[key])
                return TaskData.cache[key];
            if (key == 1) {
                let template = new TaskData();
                template.id = 1;
                template.name = '一';
                template.info = '累计完成10场比赛';
                template.award = 188;
                template.awardType = 3;
                template.taskType = '1_10';
                TaskData.cache[key] = template;
                return template;
            } else if (key == 2) {
                let template = new TaskData();
                template.id = 2;
                template.name = '二';
                template.info = '累计胜利20场比赛';
                template.award = 5;
                template.awardType = 10;
                template.taskType = '5_20';
                TaskData.cache[key] = template;
                return template;
            } else if (key == 3) {
                let template = new TaskData();
                template.id = 3;
                template.name = '三';
                template.info = '累计完成暴击88次';
                template.award = 2;
                template.awardType = 11;
                template.taskType = '2_88';
                TaskData.cache[key] = template;
                return template;
            } else if (key == 4) {
                let template = new TaskData();
                template.id = 4;
                template.name = '四';
                template.info = '非刀战模式，用刀击败敌人68次';
                template.award = 1000;
                template.awardType = 3;
                template.taskType = '3_68';
                TaskData.cache[key] = template;
                return template;
            } else if (key == 5) {
                let template = new TaskData();
                template.id = 5;
                template.name = '五';
                template.info = '娱乐模式累计完成击败188次';
                template.award = 2;
                template.awardType = 10;
                template.taskType = '6_188';
                TaskData.cache[key] = template;
                return template;
            } else if (key == 6) {
                let template = new TaskData();
                template.id = 6;
                template.name = '六';
                template.info = '用狙击枪累计完成击败168次';
                template.award = 2;
                template.awardType = 11;
                template.taskType = '7_168';
                TaskData.cache[key] = template;
                return template;
            } else if (key == 7) {
                let template = new TaskData();
                template.id = 7;
                template.name = '七';
                template.info = '娱乐模式累计完成击败188次';
                template.award = 2000;
                template.awardType = 3;
                template.taskType = '6_188';
                TaskData.cache[key] = template;
                return template;
            }
        }
        static getDataByIndex(index) {
            if (TaskData.cache[this.keys[index]])
                return TaskData.cache[this.keys[index]];
            return this.getDataByKey(this.keys[index]);
        }
        static getAllData() {
            for (let index = 0; index < this.keys.length; index++) {
                this.getDataByKey(this.keys[index]);
            }
            return TaskData.cache;
        }
        clear() {
            TaskData.cache = {};
        }
    }
    TaskData.cache = {};
    TaskData.keys = [1, 2, 3, 4, 5, 6, 7];

    var GuideStep;
    (function(GuideStep) {
        GuideStep[GuideStep["GAME_1"] = 1] = "GAME_1";
        GuideStep[GuideStep["EQUIP"] = 2] = "EQUIP";
        GuideStep[GuideStep["BUY"] = 3] = "BUY";
        GuideStep[GuideStep["SYNTHESIS"] = 4] = "SYNTHESIS";
        GuideStep[GuideStep["WAREHOUSE"] = 5] = "WAREHOUSE";
        GuideStep[GuideStep["CHOOSEARM"] = 6] = "CHOOSEARM";
        GuideStep[GuideStep["TOEQUIP"] = 7] = "TOEQUIP";
        GuideStep[GuideStep["GAME_2"] = 8] = "GAME_2";
        GuideStep[GuideStep["SIGN"] = 9] = "SIGN";
        GuideStep[GuideStep["GAME_3"] = 10] = "GAME_3";
        GuideStep[GuideStep["NEWGIFT"] = 11] = "NEWGIFT";
        GuideStep[GuideStep["GAME_4"] = 12] = "GAME_4";
        GuideStep[GuideStep["SUPERARM"] = 13] = "SUPERARM";
        GuideStep[GuideStep["GAME_5"] = 14] = "GAME_5";
        GuideStep[GuideStep["GAME_6"] = 15] = "GAME_6";
        GuideStep[GuideStep["UNLOCKFUNMODE"] = 16] = "UNLOCKFUNMODE";
        GuideStep[GuideStep["FUNGAME_1"] = 17] = "FUNGAME_1";
        GuideStep[GuideStep["FUNGAME_2"] = 18] = "FUNGAME_2";
        GuideStep[GuideStep["UNLOCKSHMODE"] = 19] = "UNLOCKSHMODE";
        GuideStep[GuideStep["SHMODEGAME_1"] = 20] = "SHMODEGAME_1";
        GuideStep[GuideStep["FINISH"] = 21] = "FINISH";
        GuideStep[GuideStep["MAX"] = 999] = "MAX";
    })(GuideStep || (GuideStep = {}));
    let GUIDE_INFO = {};
    GUIDE_INFO[GuideStep.GAME_1] = '1.开始游戏1';
    GUIDE_INFO[GuideStep.EQUIP] = '2.打开装备库';
    GUIDE_INFO[GuideStep.GAME_2] = '3.开始游戏2';
    GUIDE_INFO[GuideStep.SIGN] = '4.签到点击领取';
    var GUIDE_BTN;
    (function(GUIDE_BTN) {
        GUIDE_BTN[GUIDE_BTN["SING"] = 1] = "SING";
        GUIDE_BTN[GUIDE_BTN["RANK"] = 2] = "RANK";
        GUIDE_BTN[GUIDE_BTN["MODE"] = 3] = "MODE";
        GUIDE_BTN[GUIDE_BTN["BIOCHEMISTRY"] = 4] = "BIOCHEMISTRY";
        GUIDE_BTN[GUIDE_BTN["TASK"] = 5] = "TASK";
        GUIDE_BTN[GUIDE_BTN["EQUIP"] = 6] = "EQUIP";
        GUIDE_BTN[GUIDE_BTN["NEW_GIFT"] = 7] = "NEW_GIFT";
        GUIDE_BTN[GUIDE_BTN["SUPER_EQUIP"] = 8] = "SUPER_EQUIP";
    })(GUIDE_BTN || (GUIDE_BTN = {}));

    class ZombiePassData {
        static getDataByKey(key) {
            if (ZombiePassData.cache[key])
                return ZombiePassData.cache[key];
            if (key == 1) {
                let template = new ZombiePassData();
                template.id = 1;
                template.time = 300;
                template.initialZombieNum = 3;
                template.ronds = 3;
                ZombiePassData.cache[key] = template;
                return template;
            } else if (key == 2) {
                let template = new ZombiePassData();
                template.id = 2;
                template.time = 350;
                template.initialZombieNum = 5;
                template.ronds = 3;
                ZombiePassData.cache[key] = template;
                return template;
            }
        }
        static getDataByIndex(index) {
            if (ZombiePassData.cache[this.keys[index]])
                return ZombiePassData.cache[this.keys[index]];
            return this.getDataByKey(this.keys[index]);
        }
        static getAllData() {
            for (let index = 0; index < this.keys.length; index++) {
                this.getDataByKey(this.keys[index]);
            }
            return ZombiePassData.cache;
        }
        clear() {
            ZombiePassData.cache = {};
        }
    }
    ZombiePassData.cache = {};
    ZombiePassData.keys = [1, 2];

    class BulletSupplyCtrl extends Laya.Script3D {
        constructor() {
            super();
            this.isGet = false;
            this.model = null;
            this.idx = 0;
            this.tran = null;
            this.pos = new Laya.Vector3();
        }
        onAwake() {
            this.model = this.owner;
            this.idx = this.model.id;
            this.tran = this.model.transform;
            this.pos = this.tran.position.clone();
        }
        onUpdate() {
            if (CharacterManger.gameOver) {
                return;
            }
            if (this.isGet)
                return;
            this.tran.localRotationEulerY++;
            for (let k = 0; k < CharacterManger.logicalBaseLayer.length; k++) {
                let item = CharacterManger.logicalBaseLayer[k];
                if (!item.isZombie) {
                    if (Laya.Vector3.distanceSquared(item.getPresentationBaseLayer().getModelPosByVector3(), this.pos) < 3 * 3) {
                        if (item.magazineBullet < item.getArmCtrl().getMagazineBullet() || item.bullets < item.getArmCtrl().getBullets()) {
                            if (!this.isGet) {
                                this.isGet = true;
                                this.getCtrl(item);
                            }
                        }
                    }
                }
            }
        }
        onDestroy() {
            this.isGet = null;
            this.model = null;
            this.idx = null;
            this.tran = null;
        }
        getCtrl(logic) {
            this.model.active = false;
            logic.bulletFill();
        }
    }

    class LifeSupplyCtrl extends Laya.Script3D {
        constructor() {
            super();
            this.isGet = false;
            this.model = null;
            this.idx = 0;
            this.tran = null;
            this.pos = new Laya.Vector3();
        }
        onAwake() {
            this.model = this.owner;
            this.idx = this.model.id;
            this.tran = this.model.transform;
            this.pos = this.tran.position.clone();
        }
        onUpdate() {
            if (CharacterManger.gameOver) {
                return;
            }
            if (this.isGet)
                return;
            this.tran.localRotationEulerY++;
            for (let k = 0; k < CharacterManger.logicalBaseLayer.length; k++) {
                let item = CharacterManger.logicalBaseLayer[k];
                if (!item.isZombie) {
                    if (Laya.Vector3.distanceSquared(item.getPresentationBaseLayer().getModelPosByVector3(), this.pos) < 3 * 3) {
                        if (item.getHP() < item.getMaxHP()) {
                            if (!this.isGet) {
                                this.isGet = true;
                                this.getCtrl(item);
                            }
                        }
                    }
                }
            }
        }
        onDestroy() {
            this.isGet = null;
            this.model = null;
            this.idx = null;
            this.tran = null;
        }
        getCtrl(logic) {
            this.model.active = false;
            logic.setHP = 100;
        }
    }

    class AIData {
        static getDataByKey(key) {
            if (AIData.cache[key])
                return AIData.cache[key];
            if (key == 0) {
                let template = new AIData();
                template.id = 0;
                template.hitRate = 0.01;
                template.burstHeadRate = 0;
                template.teamHitRate = 50;
                template.teamBurstHeadRate = 30;
                template.enemyCheckAngle = 160;
                template.teamCheckAngle = 270;
                template.normal = '1_500_500|2_1000000_2000';
                template.track = '3_4000_6000';
                template.attack = '6_500_3000|7_3000000_5000';
                template.escape = '4_5000_6000';
                template.die = '1_500_5000';
                template.search = '8_5000_5000';
                AIData.cache[key] = template;
                return template;
            } else if (key == 1) {
                let template = new AIData();
                template.id = 1;
                template.hitRate = 5;
                template.burstHeadRate = 2;
                template.teamHitRate = 15;
                template.teamBurstHeadRate = 5;
                template.enemyCheckAngle = 270;
                template.teamCheckAngle = 270;
                template.normal = '1_500_500|2_1000000_2000';
                template.track = '3_4000_6000';
                template.attack = '6_500_3000|7_3000000_5000';
                template.escape = '4_5000_6000';
                template.die = '1_500_5000';
                template.search = '8_5000_5000';
                AIData.cache[key] = template;
                return template;
            } else if (key == 2) {
                let template = new AIData();
                template.id = 2;
                template.hitRate = 50;
                template.burstHeadRate = 5;
                template.teamHitRate = 5;
                template.teamBurstHeadRate = 2;
                template.enemyCheckAngle = 300;
                template.teamCheckAngle = 270;
                template.normal = '1_500_500|2_1000000_2000';
                template.track = '3_4000_6000';
                template.attack = '6_500_3000|7_3000000_5000';
                template.escape = '4_5000_6000';
                template.die = '1_500_5000';
                template.search = '8_5000_5000';
                AIData.cache[key] = template;
                return template;
            } else if (key == 3) {
                let template = new AIData();
                template.id = 3;
                template.hitRate = 60;
                template.burstHeadRate = 10;
                template.teamHitRate = 5;
                template.teamBurstHeadRate = 5;
                template.enemyCheckAngle = 320;
                template.teamCheckAngle = 270;
                template.normal = '1_500_500|2_1000000_2000';
                template.track = '3_4000_6000';
                template.attack = '6_500_3000|7_3000000_5000';
                template.escape = '4_5000_6000';
                template.die = '1_500_5000';
                template.search = '8_5000_5000';
                AIData.cache[key] = template;
                return template;
            }
        }
        static getDataByIndex(index) {
            if (AIData.cache[this.keys[index]])
                return AIData.cache[this.keys[index]];
            return this.getDataByKey(this.keys[index]);
        }
        static getAllData() {
            for (let index = 0; index < this.keys.length; index++) {
                this.getDataByKey(this.keys[index]);
            }
            return AIData.cache;
        }
        clear() {
            AIData.cache = {};
        }
    }
    AIData.cache = {};
    AIData.keys = [0, 1, 2, 3];

    var DIFFICULTY_TYPE;
    (function(DIFFICULTY_TYPE) {
        DIFFICULTY_TYPE[DIFFICULTY_TYPE["EASILY"] = 0] = "EASILY";
        DIFFICULTY_TYPE[DIFFICULTY_TYPE["NORMAL"] = 1] = "NORMAL";
        DIFFICULTY_TYPE[DIFFICULTY_TYPE["SLIGHTLYDIFFICULTY"] = 2] = "SLIGHTLYDIFFICULTY";
        DIFFICULTY_TYPE[DIFFICULTY_TYPE["DIFFICULTY"] = 3] = "DIFFICULTY";
    })(DIFFICULTY_TYPE || (DIFFICULTY_TYPE = {}));
    class DifficultyManager {
        static setDifficulty() {
            if (ModeManager.mode != GAME_MODE_TYPE.TEAMCOMPETITION) {
                this.curDifficult = DIFFICULTY_TYPE.NORMAL;
                return;
            }
            if (RoleManager.getInstance().getGuide() == GuideStep.GAME_1) {
                this.curDifficult = DIFFICULTY_TYPE.EASILY;
                return;
            }
            console.log('当前比赛列表：', this.matchList);
            if (this.matchList.length != 0) {
                for (let k = 0; k < this.matchList.length; k++) {
                    if (this.matchList[k].gameNum == this.curGamesNum) {
                        if (this.matchList[k].result == -1) {
                            console.log('前一局暂停退出了:', this.matchList[k]);
                            this.curDifficult = this.matchList[k].difficulty;
                            return;
                        }
                    }
                }
            }
            let data = {
                gameNum: this.curGamesNum,
                result: -1,
                difficulty: DIFFICULTY_TYPE.NORMAL
            };
            if (this.curDifficult == DIFFICULTY_TYPE.NORMAL) {
                if (this.matchList.length == 0) {
                    data.difficulty = DIFFICULTY_TYPE.NORMAL;
                    this.curDifficult = DIFFICULTY_TYPE.NORMAL;
                } else if (this.matchList.length == 1) {
                    data.difficulty = DIFFICULTY_TYPE.NORMAL;
                    this.curDifficult = DIFFICULTY_TYPE.NORMAL;
                } else {
                    let normalWinNum = 0;
                    for (let k = 0; k < this.matchList.length; k++) {
                        let item = this.matchList[k];
                        if (item.difficulty == DIFFICULTY_TYPE.NORMAL) {
                            if (item.result == 1) {
                                normalWinNum++;
                            } else {
                                normalWinNum--;
                            }
                        }
                    }
                    console.log('赢得次数：', normalWinNum);
                    if (normalWinNum == 0 || normalWinNum == 1) {
                        data.difficulty = DIFFICULTY_TYPE.NORMAL;
                        this.curDifficult = DIFFICULTY_TYPE.NORMAL;
                    } else if (normalWinNum == -1 || normalWinNum == -2) {
                        data.difficulty = DIFFICULTY_TYPE.EASILY;
                        this.curDifficult = DIFFICULTY_TYPE.EASILY;
                        this.matchList = [];
                    } else {
                        data.difficulty = DIFFICULTY_TYPE.SLIGHTLYDIFFICULTY;
                        this.curDifficult = DIFFICULTY_TYPE.SLIGHTLYDIFFICULTY;
                        this.matchList = [];
                    }
                }
            } else if (this.curDifficult == DIFFICULTY_TYPE.EASILY) {
                let isWin = false;
                for (let k = 0; k < this.matchList.length; k++) {
                    let item = this.matchList[k];
                    if (item.difficulty == DIFFICULTY_TYPE.EASILY) {
                        if (item.result == 1) {
                            isWin = true;
                            break;
                        }
                    }
                }
                if (isWin) {
                    data.difficulty = DIFFICULTY_TYPE.NORMAL;
                    this.curDifficult = DIFFICULTY_TYPE.NORMAL;
                    this.matchList = [];
                }
            } else if (this.curDifficult == DIFFICULTY_TYPE.SLIGHTLYDIFFICULTY) {
                let isWin = false;
                for (let k = 0; k < this.matchList.length; k++) {
                    let item = this.matchList[k];
                    if (item.difficulty == DIFFICULTY_TYPE.SLIGHTLYDIFFICULTY) {
                        if (item.result == 1) {
                            isWin = true;
                        }
                    }
                }
                if (isWin) {
                    data.difficulty = DIFFICULTY_TYPE.DIFFICULTY;
                    this.curDifficult = DIFFICULTY_TYPE.DIFFICULTY;
                    this.matchList = [];
                } else {
                    data.difficulty = DIFFICULTY_TYPE.NORMAL;
                    this.curDifficult = DIFFICULTY_TYPE.NORMAL;
                    this.matchList = [];
                }
            } else if (this.curDifficult == DIFFICULTY_TYPE.DIFFICULTY) {
                let isFail = false;
                for (let k = 0; k < this.matchList.length; k++) {
                    let item = this.matchList[k];
                    if (item.difficulty == DIFFICULTY_TYPE.DIFFICULTY) {
                        if (item.result == 0) {
                            isFail = true;
                        }
                    }
                }
                if (isFail) {
                    data.difficulty = DIFFICULTY_TYPE.NORMAL;
                    this.curDifficult = DIFFICULTY_TYPE.NORMAL;
                    this.matchList = [];
                } else {
                    data.difficulty = DIFFICULTY_TYPE.DIFFICULTY;
                    this.curDifficult = DIFFICULTY_TYPE.DIFFICULTY;
                    this.matchList = [];
                }
            }
            this.matchList.push(data);
        }
        static setCurGamesResult() {
            if (ModeManager.mode != GAME_MODE_TYPE.TEAMCOMPETITION)
                return;
            if (RoleManager.getInstance().getGuide() == GuideStep.EQUIP)
                return;
            console.log('执行了吗----------:', this.matchList, this.curGamesNum, CharacterManger._isWin);
            for (let k = 0; k < this.matchList.length; k++) {
                let item = this.matchList[k];
                if (item.gameNum == this.curGamesNum) {
                    item.result = CharacterManger._isWin ? 1 : 0;
                    console.log('最终结果：', item.result);
                }
            }
            this.curGamesNum++;
        }
    }
    DifficultyManager.matchList = [];
    DifficultyManager.curGamesNum = 1;
    DifficultyManager.curDifficult = DIFFICULTY_TYPE.NORMAL;

    class BehaviourNode {
        constructor(weight, time) {
            this.isDone = false;
            this.weight = weight;
            let rand = -1000 + Math.floor(Math.random() * 2000);
            this.time = time - rand;
        }
        clean() {
            this.character = null;
            this.context = null;
        }
        get type() {
            return this._type;
        }
        execute(context) {
            this.context = context;
            this.isDone = false;
            this.character = context.aiLogic.character;
            this.preTime = LogicTimer.gSysTimer.currTimer;
        }
        update() {
            if (LogicTimer.gSysTimer.currTimer - this.preTime >= this.time) {
                this.isDone = true;
            }
        }
    }

    var Vector3$5 = Laya.Vector3;
    class BehaviourAttack extends BehaviourNode {
        constructor(weight, time) {
            super(weight, time);
            this.findCoutDown = 0;
            this.paths = null;
            this.turnTo = new Laya.Quaternion();
            this.nextPos = new Laya.Vector3();
            this.idx = 1;
            this.vecVel = new FixedVector3();
            this.vecDir = new FixedVector3();
            this.testBoxList = [];
            this._type = AI_BEHAVIOUR_TYPE.AI_BEHAVIOUR_ATTACK;
        }
        clean() {
            super.clean();
            this.target = null;
        }
        execute(context) {
            super.execute(context);
            this.target = context.target;
            if (this.character.isZombie) {
                this.time = 500000000;
            }
            this.character.setIsMoving = false;
            this.character.setIsAttack = true;
            this.character.isCrouch = false;
            this.character.getPresentationBaseLayer().toResetRandAttackData();
        }
        setPaths() {
            if (!this.character.isZombie) {
                if (this.character.getArmCtrl().getType() == 2) {
                    if (this.target.getIsMySelf()) {
                        this.target.getPresentationBaseLayer().initNavNode();
                    }
                    this.idx = 1;
                    if (this.target.getPresentationBaseLayer().navNode) {
                        this.paths = MapManager.pathfinder.findPathWithNode(this.character.getPresentationBaseLayer().getModelPosByFixedVector(), this.target.getPresentationBaseLayer().getModelPosByFixedVector(), this.character.getPresentationBaseLayer().navNode, this.target.getPresentationBaseLayer().navNode, MapManager.zoneID, MapManager.navGroup);
                    }
                }
            } else {
                if (this.target.getIsMySelf()) {
                    if (!PerformanceManager.isCloseCharacterCtrl) {
                        this.target.getPresentationBaseLayer().initNavNode();
                    }
                }
                this.idx = 1;
                if (this.target.getPresentationBaseLayer().navNode) {
                    this.paths = MapManager.pathfinder.findPathWithNode(this.character.getPresentationBaseLayer().getModelPosByFixedVector(), this.target.getPresentationBaseLayer().getModelPosByFixedVector(), this.character.getPresentationBaseLayer().navNode, this.target.getPresentationBaseLayer().navNode, MapManager.zoneID, MapManager.navGroup);
                }
            }
        }
        testPoint(pos) {
            let testBox = GameScene.scene3d.addChild(new Laya.MeshSprite3D(Laya.PrimitiveMesh.createBox(1, 1, 1)));
            testBox.transform.rotate(new Laya.Vector3(0, 45, 0), false, false);
            var material = new Laya.BlinnPhongMaterial();
            Laya.Texture2D.load("res/layabox.png", Laya.Handler.create(null, function(tex) {
                material.albedoTexture = tex;
            }));
            testBox.transform.position = pos;
            testBox.meshRenderer.material = material;
            if (this.character.getRoleType() == ROLE_TYPE.TYPE_0) {
                testBox.meshRenderer.sharedMaterial.albedoColor = new Laya.Vector4(1.0, 0.0, 0.0, 1.0);
            }
            this.testBoxList.push(testBox);
        }
        cleanTestBox() {
            for (let k = 0; k < this.testBoxList.length; k++) {
                let a = this.testBoxList[k];
                a.removeSelf();
                a = null;
            }
            this.testBoxList = [];
        }
        update() {
            super.update();
            if (!this.character.getPresentationBaseLayer())
                return;
            if (!this.character || !this.target) {
                this.isDone = true;
                return;
            }
            if (this.character.getIsDie()) {
                this.target = null;
                this.isDone = true;
                return;
            }
            if (this.target.getIsDie()) {
                this.target = null;
                this.isDone = true;
                return;
            }
            if (this.target.isInvincible) {
                this.target = null;
                this.character.setIsAttack = false;
                this.isDone = true;
                return;
            }
            if (ModeManager.mode != GAME_MODE_TYPE.BIOCHEMISTRY) {
                if (this.character.armCtrlList.length == 0) {
                    this.target = null;
                    this.isDone = true;
                    return;
                }
            }
            this.findCoutDown -= LogicTimer.gSysTimer.delta;
            if (this.findCoutDown < 0) {
                this.findCoutDown = 500;
                this.setPaths();
                if (PerformanceManager.isDebug) {
                    this.cleanTestBox();
                    for (let k = 0; k < this.paths.length; k++) {
                        let pos = new Laya.Vector3();
                        pos.x = this.paths[k].x;
                        pos.z = this.paths[k].z;
                        pos.y = 0.5;
                        this.testPoint(pos);
                    }
                }
                if (ModeManager.mode == GAME_MODE_TYPE.BIOCHEMISTRY) {
                    if (!this.character.getPresentationBaseLayer().sectorDetection()) {
                        this.isDone = true;
                        return;
                    }
                } else {
                    if (!this.character.getPresentationBaseLayer().sectorDetection()) {
                        this.isDone = true;
                        return;
                    }
                }
            }
            if (this.character.isStartHuaBullet) {
                this.isDone = true;
                return;
            }
            this.armCtrl();
        }
        armCtrl() {
            if (!this.character.isZombie) {
                if (this.character.getArmCtrl().getType() == 2) {
                    if (this.paths && this.paths[this.idx]) {
                        FixedVector3.sub(this.paths[this.idx], this.character.getPresentationBaseLayer().getModelPosByFixedVector(), this.vecDir);
                        FixedVector3.sub(this.paths[this.idx], this.paths[this.idx - 1], this.vecVel);
                        let pos = new Laya.Vector3();
                        pos.x = this.paths[this.idx].x;
                        pos.y = this.paths[this.idx].y;
                        pos.z = this.paths[this.idx].z;
                        if (Laya.Vector3.distanceSquared(this.character.getPresentationBaseLayer().getModelPosByVector3(), this.target.getPresentationBaseLayer().getModelPosByVector3()) <= this.character.getArmCtrl().getAttackDis() * this.character.getArmCtrl().getAttackDis()) {
                            if (this.character.getPresentationBaseLayer()._isCollise) {
                                this.character.setIsMoving = true;
                                this.character.getPresentationBaseLayer().moveAttackRandomPos();
                            }
                            let hitRide = this.character.getRoleType() == ROLE_TYPE.TYPE_1 ? this.context.aiLogic.aiData.hitRate : this.context.aiLogic.aiData.teamHitRate;
                            let burstHeadRate = this.character.getRoleType() == ROLE_TYPE.TYPE_1 ? this.context.aiLogic.aiData.burstHeadRate : this.context.aiLogic.aiData.teamBurstHeadRate;
                            this.character.getPresentationBaseLayer().setDirectionByTarget(this.target);
                            this.character.getPresentationBaseLayer().attack(hitRide, this.target, burstHeadRate);
                            if (!this.target.getIsMoving()) {
                                this.character.setIsMoving = false;
                            }
                            return;
                        }
                        if (FixedVector3.dot(this.vecDir, this.vecVel) < 0 ||
                            (this.vecVel.x == 0 && this.vecVel.y == 0 && this.vecVel.z == 0) || (Laya.Vector3.distanceSquared(this.character.getPresentationBaseLayer().getModelPosByVector3(), pos) <
                                0.5 * 0.5)) {
                            this.idx++;
                        } else {
                            this.character.setIsMoving = true;
                            this.character.getPresentationBaseLayer().jump();
                            FixedVector3.normalize(this.vecDir, this.vecDir);
                            this.character.setMyOrientation(this.vecDir.x, 0, this.vecDir.z);
                            if (!this.character.getPresentationBaseLayer().isAIStartRandomRotate) {
                                let qua = this.character.getPresentationBaseLayer().getModel().transform.rotation;
                                let myPos = CommonUtil.Vector3.zero;
                                this.nextPos.x = this.vecDir.x;
                                this.nextPos.z = this.vecDir.z;
                                this.nextPos.x *= -1;
                                this.nextPos.z *= -1;
                                Laya.Quaternion.lookAt(myPos, this.nextPos, CommonUtil.Vector3.up, this.turnTo);
                                this.turnTo.invert(this.turnTo);
                                Laya.Quaternion.lerp(qua, this.turnTo, 1, qua);
                                this.character.setDirection(this.turnTo);
                                this.character.getPresentationBaseLayer().setDirection();
                            }
                        }
                    }
                } else {
                    if (this.character.getPresentationBaseLayer()._isCollise) {
                        this.character.setIsMoving = true;
                        this.character.getPresentationBaseLayer().moveAttackRandomPos();
                    }
                    let hitRide = this.character.getRoleType() == ROLE_TYPE.TYPE_1 ? this.context.aiLogic.aiData.hitRate : this.context.aiLogic.aiData.teamHitRate;
                    let burstHeadRate = this.character.getRoleType() == ROLE_TYPE.TYPE_1 ? this.context.aiLogic.aiData.burstHeadRate : this.context.aiLogic.aiData.teamBurstHeadRate;
                    this.character.getPresentationBaseLayer().jump();
                    this.character.getPresentationBaseLayer().setDirectionByTarget(this.target);
                    if (this.character.getArmCtrl().getType() == 8) {
                        if (this.character.getPresentationBaseLayer().isTouchBomb) {
                            this.character.getPresentationBaseLayer().isTouchBomb = false;
                            this.character.getPresentationBaseLayer().throwBomb();
                        }
                    } else {
                        this.character.getPresentationBaseLayer().isTouchBomb = false;
                        this.character.getPresentationBaseLayer().attack(hitRide, this.target, burstHeadRate);
                    }
                }
            } else {
                if (this.paths && this.paths[this.idx]) {
                    FixedVector3.sub(this.paths[this.idx], this.character.getPresentationBaseLayer().getModelPosByFixedVector(), this.vecDir);
                    FixedVector3.sub(this.paths[this.idx], this.paths[this.idx - 1], this.vecVel);
                    let pos = new Laya.Vector3();
                    pos.x = this.paths[this.idx].x;
                    pos.y = this.paths[this.idx].y;
                    pos.z = this.paths[this.idx].z;
                    if (Laya.Vector3.distanceSquared(this.character.getPresentationBaseLayer().getModelPosByVector3(), this.target.getPresentationBaseLayer().getModelPosByVector3()) <= 2 * 2) {
                        if (!this.target.getIsMoving()) {
                            this.character.setIsMoving = false;
                        }
                        let hitRide = this.character.getRoleType() == ROLE_TYPE.TYPE_1 ? this.context.aiLogic.aiData.hitRate : this.context.aiLogic.aiData.teamHitRate;
                        let burstHeadRate = this.character.getRoleType() == ROLE_TYPE.TYPE_1 ? this.context.aiLogic.aiData.burstHeadRate : this.context.aiLogic.aiData.teamBurstHeadRate;
                        this.character.getPresentationBaseLayer().setDirectionByTarget(this.target);
                        this.character.getPresentationBaseLayer().attack(hitRide, this.target, burstHeadRate);
                        return;
                    }
                    if (FixedVector3.dot(this.vecDir, this.vecVel) < 0 ||
                        (this.vecVel.x == 0 && this.vecVel.y == 0 && this.vecVel.z == 0) || (Laya.Vector3.distanceSquared(this.character.getPresentationBaseLayer().getModelPosByVector3(), pos) <
                            0.5 * 0.5)) {
                        this.idx++;
                    } else {
                        this.character.setIsMoving = true;
                        this.character.getPresentationBaseLayer().jump();
                        FixedVector3.normalize(this.vecDir, this.vecDir);
                        this.character.setMyOrientation(this.vecDir.x, 0, this.vecDir.z);
                        if (!this.character.getPresentationBaseLayer().isAIStartRandomRotate) {
                            if (Vector3$5.distanceSquared(this.character.getPresentationBaseLayer().getModelPosByVector3(), this.target.getPresentationBaseLayer().getModelPosByVector3()) > 3 * 3) {
                                let qua = this.character.getPresentationBaseLayer().getModel().transform.rotation;
                                let myPos = CommonUtil.Vector3.zero;
                                this.nextPos.x = this.vecDir.x;
                                this.nextPos.z = this.vecDir.z;
                                this.nextPos.x *= -1;
                                this.nextPos.z *= -1;
                                Laya.Quaternion.lookAt(myPos, this.nextPos, CommonUtil.Vector3.up, this.turnTo);
                                this.turnTo.invert(this.turnTo);
                                Laya.Quaternion.lerp(qua, this.turnTo, 1, qua);
                                this.character.setDirection(this.turnTo);
                                this.character.getPresentationBaseLayer().setDirection();
                            }
                        }
                    }
                }
            }
        }
    }

    class BehaviourCrouchAttack extends BehaviourNode {
        constructor(weight, time) {
            super(weight, time);
            this.findCoutDown = 0;
            this.targetList = [];
            this._type = AI_BEHAVIOUR_TYPE.AI_BEHAVIOUR_CROUCHATTACK;
        }
        clean() {
            super.clean();
            this.target = null;
        }
        execute(context) {
            super.execute(context);
            this.target = context.target;
            this.character.setIsMoving = false;
            this.character.setIsAttack = true;
            this.character.isCrouch = true;
        }
        judgeTarget() {
            if (this.targetList.length == 0) {
                for (let k = 0; k < CharacterManger.logicalBaseLayer.length; k++) {
                    let target = CharacterManger.logicalBaseLayer[k];
                    if (!target.getIsDie() && !this.character.getIsDie() && target.getRoleType() != this.context.aiLogic.character.getRoleType()) {
                        this.targetList.push(target);
                    }
                }
            }
            if (this.targetList.length == 0)
                return;
            let tar = this.targetList[0];
            let min = Laya.Vector3.distanceSquared(this.character.getPresentationBaseLayer().getModelPosByVector3(), this.targetList[0].getPresentationBaseLayer().getModelPosByVector3());
            for (let k = 0; k < this.targetList.length; k++) {
                let item = this.targetList[k];
                let dis = Laya.Vector3.distanceSquared(this.character.getPresentationBaseLayer().getModelPosByVector3(), this.targetList[k].getPresentationBaseLayer().getModelPosByVector3());
                if (min > dis) {
                    min = dis;
                    tar = item;
                }
            }
            this.target = tar;
            this.character.attackLogicalBaseLayer = this.target;
        }
        setPaths() {
            this.idx = 1;
            if (this.paths) {
                for (let i = 0, len = this.paths.length; i < len; i++) {
                    this.paths[i].clean();
                    this.paths[i] = null;
                }
                this.paths = null;
            }
            if (this.character && this.target) {
                this.paths = MapManager.pathfinder.findPath(this.character.getPresentationBaseLayer().getModelPosByFixedVector(), this.target.getPresentationBaseLayer().getModelPosByFixedVector(), MapManager.zoneID, MapManager.navGroup);
                this.character.paths = this.paths;
            }
        }
        update() {
            super.update();
            if (!this.character || !this.target)
                return;
            this.findCoutDown -= LogicTimer.gSysTimer.delta;
            if (this.findCoutDown < 0) {
                this.findCoutDown = 500;
                this.judgeTarget();
            }
            if (this.character.getIsDie()) {
                this.isDone = true;
                return;
            }
            if (this.target.getIsDie()) {
                this.isDone = true;
                return;
            }
            let hitRide = this.context.aiLogic.aiData.hitRate;
            let burstHeadRate = this.context.aiLogic.aiData.burstHeadRate;
            this.character.getPresentationBaseLayer().attack(hitRide, this.target, burstHeadRate);
        }
    }

    class BunkerCtrl extends Laya.Script3D {
        constructor(_type, point, _camp = -1) {
            super();
            this._type = 0;
            this.point = null;
            this._isUse = false;
            this._camp = -1;
            this.vecFixedVector3 = new FixedVector3();
            this.firstFinish = false;
            this.secondFinish = false;
            this.thirdFinish = false;
            this.myTran = null;
            this.name = '';
            this._type = _type;
            this._camp = _camp;
            this.point = point;
            this.myTran = this.point.transform;
            this.name = this.point.name;
        }
        init() {
            this.firstFinish = false;
            this.secondFinish = false;
            this.thirdFinish = false;
            this._isUse = false;
        }
        getModeID() {
            return this.point.id;
        }
        initFinishData() {
            this.firstFinish = false;
            this.secondFinish = false;
            this.thirdFinish = false;
        }
        turnPosFixedVector3(tran) {
            this.vecFixedVector3.x = tran.position.x;
            this.vecFixedVector3.y = tran.position.y;
            this.vecFixedVector3.z = tran.position.z;
            return this.vecFixedVector3;
        }
        getNowPosFixedVector3() {
            return this.vecFixedVector3;
        }
        getPos() {
            return this.myTran.position;
        }
        initClosestNodeMySelf() {
            return MapManager.pathfinder.getClosestNode(this.turnPosFixedVector3(this.point.transform), MapManager.zoneID, MapManager.navGroup, true);
        }
        initClosestNodeChild1() {
            return MapManager.pathfinder.getClosestNode(this.turnPosFixedVector3(this.point.getChildAt(0).transform), MapManager.zoneID, MapManager.navGroup, true);
        }
        initClosestNodeChild2() {
            return MapManager.pathfinder.getClosestNode(this.turnPosFixedVector3(this.point.getChildAt(1).transform), MapManager.zoneID, MapManager.navGroup, true);
        }
        getPointName() {
            return this.name;
        }
        onDestroy() {
            this._type = null;
            this.point = null;
            this._isUse = null;
            this._camp = null;
        }
    }

    class BunkerManager {
        static addBunkersList() {
            this.cleanBunkers();
            let bunkerPoints = GameScene.scene3d.getChildByName(OBJ_NAME.BUNKERPOINTS);
            let num = bunkerPoints.numChildren - 2;
            for (let k = 0; k < num; k++) {
                let item = bunkerPoints.getChildByName('000' + (k + 1).toString());
                this.bunkersList.push(item);
                let ctrl = item.addComponentIntance(new BunkerCtrl(BUNKERTYPE.NORMAL, item));
                this.bunkersCtrlList.push(ctrl);
            }
            let specialPoints1 = bunkerPoints.getChildByName('specialPoints1');
            let specialPoints2 = bunkerPoints.getChildByName('specialPoints2');
            let num1 = specialPoints1.numChildren;
            let num2 = specialPoints2.numChildren;
            let _camp1 = -1;
            let _camp2 = -1;
            if (CharacterManger.playerLogicalBaseLayer) {
                let len1 = Laya.Vector3.distanceSquared(CharacterManger.playerLogicalBaseLayer.getPresentationBaseLayer().getModelPosByVector3(), specialPoints1.transform.position);
                let len2 = Laya.Vector3.distanceSquared(CharacterManger.playerLogicalBaseLayer.getPresentationBaseLayer().getModelPosByVector3(), specialPoints2.transform.position);
                if (len1 > len2) {
                    console.log('2近主角');
                    _camp1 = ROLE_TYPE.TYPE_1;
                } else {
                    console.log('1近主角');
                    _camp1 = ROLE_TYPE.TYPE_0;
                }
            }
            if (_camp1 == ROLE_TYPE.TYPE_0) {
                _camp2 = ROLE_TYPE.TYPE_1;
            } else {
                _camp2 = ROLE_TYPE.TYPE_0;
            }
            for (let k = 0; k < num1; k++) {
                let item = specialPoints1.getChildByName('000' + (k + 1).toString());
                this.bunkersList.push(item);
                let ctrl = item.addComponentIntance(new BunkerCtrl(BUNKERTYPE.SPECIAL, item, _camp1));
                this.bunkersCtrlList.push(ctrl);
            }
            for (let k = 0; k < num2; k++) {
                let item = specialPoints2.getChildByName('000' + (k + 1).toString());
                this.bunkersList.push(item);
                let ctrl = item.addComponentIntance(new BunkerCtrl(BUNKERTYPE.SPECIAL, item, _camp2));
                this.bunkersCtrlList.push(ctrl);
            }
        }
        static cleanBunkers() {
            this.bunkersList = [];
            this.bunkersCtrlList = [];
        }
        static getRangeBunkers(target) {
            let returnCtrl = this.bunkersCtrlList[0];
            let index = 0;
            let isGet = false;
            this.useData();
            for (let k = 0; k < this.bunkersCtrlList.length; k++) {
                let ctrl = this.bunkersCtrlList[k];
                if (ctrl) {
                    if (target.curPointCtrl) {
                        if (target.curPointCtrl.getModeID() == ctrl.getModeID() || this.checkOtherPoint(ctrl, target)) {
                            continue;
                        }
                    }
                    let dis = Laya.Vector3.distanceSquared(target.getPresentationBaseLayer().getModelPosByVector3(), ctrl.point.transform.position);
                    if (dis < 10 * 10) {
                        if (ctrl._type == BUNKERTYPE.SPECIAL) {
                            if (!ctrl._isUse) {
                                console.log('获取特殊点');
                                index = k;
                                ctrl._isUse = true;
                                isGet = true;
                                returnCtrl = ctrl;
                                break;
                            }
                        } else {
                            if (ctrl._camp == target.getRoleType()) {
                                if (!ctrl._isUse) {
                                    console.log('获取未使用的点');
                                    index = k;
                                    ctrl._isUse = true;
                                    isGet = true;
                                    returnCtrl = ctrl;
                                    break;
                                }
                            }
                        }
                    }
                }
            }
            if (!isGet) {
                console.log('没有获取到可用点');
                for (let k = 0; k < this.bunkersCtrlList.length; k++) {
                    let ctrl = this.bunkersCtrlList[k];
                    if (ctrl) {
                        if (target.curPointCtrl) {
                            if (target.curPointCtrl.getModeID() == ctrl.getModeID()) {
                                continue;
                            }
                        }
                        if (!ctrl._isUse) {
                            console.log('没有获取到可用点, 从全部点中寻找:', ctrl._isUse);
                            index = k;
                            ctrl._isUse = true;
                            isGet = true;
                            returnCtrl = ctrl;
                            break;
                        }
                    }
                }
            }
            if (target.getRoleType() == ROLE_TYPE.TYPE_0) {}
            if (target.curPointCtrl)
                target.curPointCtrl.init();
            return returnCtrl;
        }
        static checkOtherPoint(point, target) {
            for (let k = 0; k < CharacterManger.logicalBaseLayer.length; k++) {
                let logic = CharacterManger.logicalBaseLayer[k];
                if (logic.getEventID() != target.getEventID() && logic.getRoleType() != target.getRoleType()) {
                    if (logic.curPointCtrl) {
                        if (logic.curPointCtrl.getModeID() == point.getModeID()) {
                            return false;
                        }
                    }
                }
            }
            return true;
        }
        static getBunkerNum() {
            let num = 0;
            for (let k = 0; k < this.bunkersCtrlList.length; k++) {
                let item = this.bunkersCtrlList[0];
                if (!item._isUse) {
                    num++;
                }
            }
            return num;
        }
        static getFarBunker(target) {
            if (!target.getPresentationBaseLayer())
                return;
            let far = this.bunkersCtrlList[0];
            let pos = this.bunkersCtrlList[0].getPos();
            let max = Laya.Vector3.distanceSquared(target.getPresentationBaseLayer().getModelPosByVector3(), pos);
            for (let k = 0; k < this.bunkersList.length; k++) {
                let item = this.bunkersCtrlList[k];
                let dis = Laya.Vector3.distanceSquared(target.getPresentationBaseLayer().getModelPosByVector3(), item.getPos());
                if (max < dis) {
                    max = dis;
                    far = item;
                }
            }
            return far;
        }
        static resetAllNodeUse() {
            for (let k = 0; k < CharacterManger.logicalBaseLayer.length; k++) {
                let logic = CharacterManger.logicalBaseLayer[k];
                logic.curPointCtrl = null;
            }
            for (let k = 0; k < this.bunkersCtrlList.length; k++) {
                let ctrl = this.bunkersCtrlList[k];
                if (ctrl) {
                    ctrl._isUse = false;
                }
            }
        }
        static useData() {
            let len = 0;
            for (let k = 0; k < this.bunkersCtrlList.length; k++) {
                let ctrl = this.bunkersCtrlList[k];
                if (ctrl) {
                    if (!ctrl._isUse) {
                        len++;
                    }
                }
            }
        }
        static getRandBunker(targetLogicalBaseLayer) {}
    }
    BunkerManager.bunkersList = [];
    BunkerManager.bunkersCtrlList = [];

    class BehaviourEscape extends BehaviourNode {
        constructor(weight, time) {
            super(weight, time);
            this.vecVel = new FixedVector3();
            this.vecPrePos = new FixedVector3();
            this.vecDir = new FixedVector3();
            this.targetPointCtrl = null;
            this._type = AI_BEHAVIOUR_TYPE.AI_BEHAVIOUR_ESCAPE;
        }
        clean() {
            super.clean();
            this.vecVel.clean();
            this.vecVel = null;
            this.vecPrePos.clean();
            this.vecPrePos = null;
        }
        execute(context) {
            super.execute(context);
            this.target = context.target;
            this.character.isCrouch = false;
            if (!this.target)
                return;
            this.setPaths();
            this.isDone = false;
        }
        setPaths() {
            if (this.character && this.character.getPresentationBaseLayer()) {
                this.idx = 1;
                this.targetPointCtrl = BunkerManager.getFarBunker(this.target);
                if (this.targetPointCtrl) {
                    let node = this.targetPointCtrl.initClosestNodeMySelf();
                    this.paths = MapManager.pathfinder.findPathWithNode(this.character.getPresentationBaseLayer().getModelPosByFixedVector(), this.targetPointCtrl.getNowPosFixedVector3(), this.character.getPresentationBaseLayer().navNode, node, MapManager.zoneID, MapManager.navGroup);
                }
            }
        }
        update() {
            super.update();
            if (!this.character.getPresentationBaseLayer())
                return;
            if (!this.target) {
                this.isDone = true;
                return;
            }
            if (this.character.getIsDie()) {
                this.paths = null;
                this.character.setMyOrientation(0, 0, 0);
                this.isDone = true;
                return;
            }
            if (!this.character.isStartHuaBullet) {
                this.isDone = true;
                return;
            }
            if (this.character.getPresentationBaseLayer()._isCollise) {
                this.character.setIsMoving = true;
                this.character.getPresentationBaseLayer().moveAttackRandomPos();
                this.isDone = true;
                return;
            }
            if (this.paths && this.paths[this.idx]) {
                FixedVector3.sub(this.paths[this.idx], this.character.getPresentationBaseLayer().getModelPosByFixedVector(), this.vecDir);
                FixedVector3.sub(this.paths[this.idx], this.paths[this.idx - 1], this.vecVel);
                if (FixedVector3.dot(this.vecDir, this.vecVel) < 0 ||
                    (this.vecVel.x == 0 && this.vecVel.y == 0 && this.vecVel.z == 0)) {
                    this.idx++;
                } else {
                    this.character.setIsMoving = true;
                    let isRotate = this.character.getPresentationBaseLayer().startRanomRotate();
                    this.character.getPresentationBaseLayer().jump();
                    FixedVector3.normalize(this.vecDir, this.vecDir);
                    this.character.setMyOrientation(this.vecDir.x, 0, this.vecDir.z);
                }
            } else {}
        }
    }

    class BehaviourIdle extends BehaviourNode {
        constructor(weight, time) {
            super(weight, time);
            this.findCoutDown = 0;
            this._type = AI_BEHAVIOUR_TYPE.AI_BEHAVIOUR_IDLE;
        }
        execute(context) {
            super.execute(context);
            this.character.setIsMoving = false;
            this.character.setIsAttack = false;
        }
        clean() {
            this.findCoutDown = null;
        }
        update() {
            super.update();
            this.findCoutDown -= LogicTimer.gSysTimer.delta;
            if (this.findCoutDown < 0) {
                this.findCoutDown = 500;
                if (this.character.getPresentationBaseLayer().sectorDetection()) {
                    this.isDone = true;
                    return;
                }
            }
        }
    }

    var Vector3$6 = Laya.Vector3;
    class BehaviourMoveAttack extends BehaviourNode {
        constructor(weight, time) {
            super(weight, time);
            this.findCoutDown = 0;
            this.paths = null;
            this.turnTo = new Laya.Quaternion();
            this.nextPos = new Laya.Vector3();
            this.idx = 1;
            this.vecVel = new FixedVector3();
            this.vecDir = new FixedVector3();
            this._type = AI_BEHAVIOUR_TYPE.AI_BEHAVIOUR_MOVEATTACK;
        }
        clean() {
            super.clean();
            this.target = null;
            this.findCoutDown = null;
        }
        execute(context) {
            super.execute(context);
            this.target = context.target;
            this.character.setIsMoving = true;
            this.character.setIsAttack = true;
            this.character.isCrouch = false;
        }
        setPaths() {
            if (!this.character.isZombie) {
                if (this.character.getArmCtrl().getType() == 2) {
                    if (this.target.getIsMySelf()) {
                        this.target.getPresentationBaseLayer().initNavNode();
                    }
                    this.idx = 1;
                    if (this.target.getPresentationBaseLayer().navNode) {
                        this.paths = MapManager.pathfinder.findPathWithNode(this.character.getPresentationBaseLayer().getModelPosByFixedVector(), this.target.getPresentationBaseLayer().getModelPosByFixedVector(), this.character.getPresentationBaseLayer().navNode, this.target.getPresentationBaseLayer().navNode, MapManager.zoneID, MapManager.navGroup);
                    }
                }
            } else {
                if (this.target.getIsMySelf()) {
                    if (!PerformanceManager.isCloseCharacterCtrl) {
                        this.target.getPresentationBaseLayer().initNavNode();
                    }
                }
                this.idx = 1;
                if (this.target.getPresentationBaseLayer().navNode) {
                    this.paths = MapManager.pathfinder.findPathWithNode(this.character.getPresentationBaseLayer().getModelPosByFixedVector(), this.target.getPresentationBaseLayer().getModelPosByFixedVector(), this.character.getPresentationBaseLayer().navNode, this.target.getPresentationBaseLayer().navNode, MapManager.zoneID, MapManager.navGroup);
                }
            }
        }
        update() {
            super.update();
            if (!this.character.getPresentationBaseLayer())
                return;
            if (!this.character || !this.target) {
                this.character.setIsAttack = false;
                this.isDone = true;
                return;
            }
            if (this.character.getIsDie()) {
                this.character.getPresentationBaseLayer().toResetRandAttackData();
                this.target = null;
                this.character.setIsAttack = false;
                this.isDone = true;
                return;
            }
            if (this.target.getIsDie()) {
                this.character.getPresentationBaseLayer().toResetRandAttackData();
                this.target = null;
                this.character.setIsAttack = false;
                this.isDone = true;
                return;
            }
            if (this.target.isInvincible) {
                this.target = null;
                this.character.setIsAttack = false;
                this.isDone = true;
                return;
            }
            if (ModeManager.mode != GAME_MODE_TYPE.BIOCHEMISTRY) {
                if (this.character.armCtrlList.length == 0) {
                    this.character.getPresentationBaseLayer().toResetRandAttackData();
                    this.target = null;
                    this.isDone = true;
                    return;
                }
            }
            this.findCoutDown -= LogicTimer.gSysTimer.delta;
            if (this.findCoutDown < 0) {
                this.findCoutDown = 500;
                this.setPaths();
                if (ModeManager.mode == GAME_MODE_TYPE.BIOCHEMISTRY) {
                    if (!this.character.getPresentationBaseLayer().sectorDetection()) {
                        this.isDone = true;
                        return;
                    }
                } else {
                    if (!this.character.getPresentationBaseLayer().sectorDetection()) {
                        this.isDone = true;
                        return;
                    }
                }
            }
            if (this.character.isStartHuaBullet) {
                this.isDone = true;
                return;
            }
            this.armCtrl();
        }
        armCtrl() {
            if (!this.character.isZombie) {
                if (this.character.getArmCtrl().getType() == 2) {
                    if (this.paths && this.paths[this.idx]) {
                        FixedVector3.sub(this.paths[this.idx], this.character.getPresentationBaseLayer().getModelPosByFixedVector(), this.vecDir);
                        FixedVector3.sub(this.paths[this.idx], this.paths[this.idx - 1], this.vecVel);
                        let pos = new Laya.Vector3();
                        pos.x = this.paths[this.idx].x;
                        pos.y = this.paths[this.idx].y;
                        pos.z = this.paths[this.idx].z;
                        if (Laya.Vector3.distanceSquared(this.character.getPresentationBaseLayer().getModelPosByVector3(), this.target.getPresentationBaseLayer().getModelPosByVector3()) <= this.character.getArmCtrl().getAttackDis() * this.character.getArmCtrl().getAttackDis()) {
                            this.character.getPresentationBaseLayer().jump();
                            this.character.getPresentationBaseLayer().moveAttackRandomPos();
                            this.character.getPresentationBaseLayer().setDirectionByTarget(this.target);
                            let hitRide = this.character.getRoleType() == ROLE_TYPE.TYPE_1 ? this.context.aiLogic.aiData.hitRate : this.context.aiLogic.aiData.teamHitRate;
                            let burstHeadRate = this.character.getRoleType() == ROLE_TYPE.TYPE_1 ? this.context.aiLogic.aiData.burstHeadRate : this.context.aiLogic.aiData.teamBurstHeadRate;
                            this.character.getPresentationBaseLayer().attack(hitRide, this.target, burstHeadRate);
                            return;
                        }
                        if (FixedVector3.dot(this.vecDir, this.vecVel) < 0 ||
                            (this.vecVel.x == 0 && this.vecVel.y == 0 && this.vecVel.z == 0) || (Laya.Vector3.distanceSquared(this.character.getPresentationBaseLayer().getModelPosByVector3(), pos) <
                                0.5 * 0.5)) {
                            this.idx++;
                        } else {
                            this.character.setIsMoving = true;
                            this.character.getPresentationBaseLayer().jump();
                            FixedVector3.normalize(this.vecDir, this.vecDir);
                            this.character.setMyOrientation(this.vecDir.x, 0, this.vecDir.z);
                            if (!this.character.getPresentationBaseLayer().isAIStartRandomRotate) {
                                let qua = this.character.getPresentationBaseLayer().getModel().transform.rotation;
                                let myPos = CommonUtil.Vector3.zero;
                                this.nextPos.x = this.vecDir.x;
                                this.nextPos.z = this.vecDir.z;
                                this.nextPos.x *= -1;
                                this.nextPos.z *= -1;
                                Laya.Quaternion.lookAt(myPos, this.nextPos, CommonUtil.Vector3.up, this.turnTo);
                                this.turnTo.invert(this.turnTo);
                                Laya.Quaternion.lerp(qua, this.turnTo, 1, qua);
                                this.character.setDirection(this.turnTo);
                                this.character.getPresentationBaseLayer().setDirection();
                            }
                        }
                    }
                } else {
                    this.character.getPresentationBaseLayer().jump();
                    this.character.getPresentationBaseLayer().moveAttackRandomPos();
                    this.character.getPresentationBaseLayer().setDirectionByTarget(this.target);
                    let hitRide = this.character.getRoleType() == ROLE_TYPE.TYPE_1 ? this.context.aiLogic.aiData.hitRate : this.context.aiLogic.aiData.teamHitRate;
                    let burstHeadRate = this.character.getRoleType() == ROLE_TYPE.TYPE_1 ? this.context.aiLogic.aiData.burstHeadRate : this.context.aiLogic.aiData.teamBurstHeadRate;
                    if (this.character.getArmCtrl().getType() == 8) {
                        if (this.character.getPresentationBaseLayer().isTouchBomb) {
                            this.character.getPresentationBaseLayer().isTouchBomb = false;
                            this.character.getPresentationBaseLayer().throwBomb();
                        }
                    } else {
                        this.character.getPresentationBaseLayer().isTouchBomb = false;
                        this.character.getPresentationBaseLayer().attack(hitRide, this.target, burstHeadRate);
                    }
                }
            } else {
                if (this.paths && this.paths[this.idx]) {
                    FixedVector3.sub(this.paths[this.idx], this.character.getPresentationBaseLayer().getModelPosByFixedVector(), this.vecDir);
                    FixedVector3.sub(this.paths[this.idx], this.paths[this.idx - 1], this.vecVel);
                    let pos = new Laya.Vector3();
                    pos.x = this.paths[this.idx].x;
                    pos.y = this.paths[this.idx].y;
                    pos.z = this.paths[this.idx].z;
                    if (Laya.Vector3.distanceSquared(this.character.getPresentationBaseLayer().getModelPosByVector3(), this.target.getPresentationBaseLayer().getModelPosByVector3()) <= 2 * 2) {
                        this.character.getPresentationBaseLayer().jump();
                        this.character.getPresentationBaseLayer().moveAttackRandomPos();
                        this.character.getPresentationBaseLayer().setDirectionByTarget(this.target);
                        let hitRide = this.character.getRoleType() == ROLE_TYPE.TYPE_1 ? this.context.aiLogic.aiData.hitRate : this.context.aiLogic.aiData.teamHitRate;
                        let burstHeadRate = this.character.getRoleType() == ROLE_TYPE.TYPE_1 ? this.context.aiLogic.aiData.burstHeadRate : this.context.aiLogic.aiData.teamBurstHeadRate;
                        this.character.getPresentationBaseLayer().attack(hitRide, this.target, burstHeadRate);
                        return;
                    }
                    if (FixedVector3.dot(this.vecDir, this.vecVel) < 0 ||
                        (this.vecVel.x == 0 && this.vecVel.y == 0 && this.vecVel.z == 0) || (Laya.Vector3.distanceSquared(this.character.getPresentationBaseLayer().getModelPosByVector3(), pos) <
                            0.5 * 0.5)) {
                        this.idx++;
                    } else {
                        this.character.setIsMoving = true;
                        this.character.getPresentationBaseLayer().jump();
                        FixedVector3.normalize(this.vecDir, this.vecDir);
                        this.character.setMyOrientation(this.vecDir.x, 0, this.vecDir.z);
                        if (!this.character.getPresentationBaseLayer().isAIStartRandomRotate) {
                            if (Vector3$6.distanceSquared(this.character.getPresentationBaseLayer().getModelPosByVector3(), this.target.getPresentationBaseLayer().getModelPosByVector3()) > 3 * 3) {
                                let qua = this.character.getPresentationBaseLayer().getModel().transform.rotation;
                                let myPos = CommonUtil.Vector3.zero;
                                this.nextPos.x = this.vecDir.x;
                                this.nextPos.z = this.vecDir.z;
                                this.nextPos.x *= -1;
                                this.nextPos.z *= -1;
                                Laya.Quaternion.lookAt(myPos, this.nextPos, CommonUtil.Vector3.up, this.turnTo);
                                this.turnTo.invert(this.turnTo);
                                Laya.Quaternion.lerp(qua, this.turnTo, 1, qua);
                                this.character.setDirection(this.turnTo);
                                this.character.getPresentationBaseLayer().setDirection();
                            }
                        }
                    }
                }
            }
        }
    }

    class BehaviourNone extends BehaviourNode {
        constructor(weight, time) {
            super(weight, time);
            this.findCoutDown = null;
            this._type = AI_BEHAVIOUR_TYPE.AI_BEHAVIOUR_NONE;
        }
        execute(context) {
            super.execute(context);
            this.character.setIsAttack = false;
            this.character.isStartAttack = false;
            this.character.getPresentationBaseLayer().toResetRandAttackData();
        }
        update() {
            super.update();
            if (!this.character.getPresentationBaseLayer())
                return;
            this.character.setIsMoving = false;
            if (this.findCoutDown < 0) {
                this.findCoutDown = 500;
                if (this.character.getPresentationBaseLayer().sectorDetection()) {
                    this.isDone = true;
                    return;
                }
            }
            let isRotate = this.character.getPresentationBaseLayer().startRanomRotate();
            this.character.getPresentationBaseLayer().jump();
        }
    }

    class BehaviourPatrol extends BehaviourNode {
        constructor(weight, time) {
            super(weight, time);
            this.pointCtrl = null;
            this.vecVel = new FixedVector3();
            this.vecDir = new FixedVector3();
            this.findCoutDown = 0;
            this.idx = 1;
            this.turnTo = new Laya.Quaternion();
            this.nextPos = new Laya.Vector3();
            this.onceStart = false;
            this.isStartTime = false;
            this.pointNavNode = null;
            this.finishNum = 0;
            this.nextFinishNum = 0;
            this.timer = RandomUtil.onlyOneRandomInt(200, 400);
            this.paths = null;
            this.rotateType = ['dy', 'st'];
            this.rotateData = [0.1, 99.9];
            this.myTempPos = new Laya.Vector3();
            this.testBoxList = [];
            this._type = AI_BEHAVIOUR_TYPE.AI_BEHAVIOUR_PATROL;
        }
        clean() {
            super.clean();
            this.vecVel.clean();
            this.vecVel = null;
            this.pointCtrl = null;
            this.vecDir.clean();
            this.vecDir = null;
            this.findCoutDown = null;
            this.idx = null;
            this.turnTo = null;
            this.nextPos = null;
        }
        setPaths() {
            if (this.pointCtrl) {
                if (this.pointCtrl.thirdFinish) {
                    this.pointCtrl = null;
                    if (this.paths) {
                        for (let i = 0, len = this.paths.length; i < len; i++) {
                            this.paths[i].clean();
                            this.paths[i] = null;
                        }
                        this.paths = null;
                    }
                    this.isDone = true;
                    return;
                }
            }
            if (this.paths) {
                if (this.paths.length != this.idx)
                    return;
                if (this.paths.length == this.idx) {
                    if (this.pointCtrl) {
                        if (!this.pointCtrl.firstFinish) {
                            this.pointCtrl.firstFinish = true;
                            this.idx = 1;
                            this.nextFinishNum = 1;
                        } else {
                            if (!this.pointCtrl.secondFinish) {
                                this.pointCtrl.secondFinish = true;
                                this.idx = 1;
                                this.nextFinishNum = 2;
                            } else {
                                if (!this.pointCtrl.thirdFinish) {
                                    this.pointCtrl.thirdFinish = true;
                                    this.idx = 1;
                                    this.nextFinishNum = 0;
                                    this.finishNum = 0;
                                }
                            }
                        }
                    }
                }
            }
            if (!this.pointCtrl) {
                this.pointCtrl = BunkerManager.getRangeBunkers(this.character);
                this.character.curPointCtrl = this.pointCtrl;
                this.finishNum = 0;
                this.nextFinishNum = 0;
            }
            if (this.pointCtrl) {
                if (!this.pointCtrl.firstFinish) {
                    this.pointNavNode = this.pointCtrl.initClosestNodeMySelf();
                }
                if (this.pointCtrl.firstFinish && !this.pointCtrl.secondFinish) {
                    this.pointNavNode = this.pointCtrl.initClosestNodeChild1();
                }
                if (this.pointCtrl.firstFinish && this.pointCtrl.secondFinish && !this.pointCtrl.thirdFinish) {
                    this.pointNavNode = this.pointCtrl.initClosestNodeChild2();
                }
                if (this.pointNavNode && this.character.getPresentationBaseLayer().navNode) {
                    if (this.finishNum == 0) {
                        this.paths = MapManager.pathfinder.findPathWithNode(this.character.getPresentationBaseLayer().getModelPosByFixedVector(), this.pointCtrl.getNowPosFixedVector3(), this.character.getPresentationBaseLayer().navNode, this.pointNavNode, MapManager.zoneID, MapManager.navGroup);
                        this.finishNum = this.nextFinishNum;
                    } else if (this.finishNum != this.nextFinishNum) {
                        this.paths = MapManager.pathfinder.findPathWithNode(this.character.getPresentationBaseLayer().getModelPosByFixedVector(), this.pointCtrl.getNowPosFixedVector3(), this.character.getPresentationBaseLayer().navNode, this.pointNavNode, MapManager.zoneID, MapManager.navGroup);
                        this.finishNum = this.nextFinishNum;
                    }
                }
            }
        }
        execute(context) {
            super.execute(context);
            this.character.setIsAttack = false;
            this.character.isStartAttack = false;
            this.character.getPresentationBaseLayer().toResetRandAttackData();
            this.cleanTestBox();
            if (this.pointCtrl) {
                this.pointCtrl = null;
                this.idx = 1;
                this.nextFinishNum = 0;
                this.paths = null;
            }
            this.timer = RandomUtil.onlyOneRandomInt(200, 400);
        }
        resetPointCtrl() {}
        testPoint(pos) {
            let testBox = GameScene.scene3d.addChild(new Laya.MeshSprite3D(Laya.PrimitiveMesh.createBox(1, 1, 1)));
            testBox.transform.rotate(new Laya.Vector3(0, 45, 0), false, false);
            var material = new Laya.BlinnPhongMaterial();
            Laya.Texture2D.load("res/layabox.png", Laya.Handler.create(null, function(tex) {
                material.albedoTexture = tex;
            }));
            testBox.transform.position = pos;
            testBox.meshRenderer.material = material;
            if (this.character.getRoleType() == ROLE_TYPE.TYPE_0) {
                testBox.meshRenderer.sharedMaterial.albedoColor = new Laya.Vector4(1.0, 0.0, 0.0, 1.0);
            }
            this.testBoxList.push(testBox);
        }
        cleanTestBox() {
            for (let k = 0; k < this.testBoxList.length; k++) {
                let a = this.testBoxList[k];
                a.removeSelf();
                a = null;
            }
            this.testBoxList = [];
        }
        update() {
            super.update();
            if (!this.character.getPresentationBaseLayer())
                return;
            this.findCoutDown -= LogicTimer.gSysTimer.delta;
            if (!this.isStartTime) {
                this.isStartTime = true;
                Laya.timer.once(this.timer, this, function cd() {
                    this.onceStart = true;
                    Laya.timer.clear(this, cd);
                });
            }
            if (!this.onceStart)
                return;
            if (this.character.getIsDie() || this.character.isRevive) {
                this.character.setMyOrientation(0, 0, 0);
                this.isDone = true;
                return;
            }
            if (ModeManager.mode != GAME_MODE_TYPE.BIOCHEMISTRY) {
                if (this.character.armCtrlList.length == 0) {
                    this.character.setMyOrientation(0, 0, 0);
                    this.isDone = true;
                    return;
                }
            }
            if (this.findCoutDown < 0) {
                this.findCoutDown = 500;
                if (this.character.getPresentationBaseLayer().sectorDetection()) {
                    this.isDone = true;
                    return;
                }
                this.setPaths();
                if (PerformanceManager.isDebug) {
                    this.cleanTestBox();
                    for (let k = 0; k < this.paths.length; k++) {
                        let pos = new Laya.Vector3();
                        pos.x = this.paths[k].x;
                        pos.z = this.paths[k].z;
                        pos.y = 0.5;
                        this.testPoint(pos);
                    }
                }
                this.character.getPresentationBaseLayer().startRanomRotate();
            }
            if (this.paths && this.paths[this.idx]) {
                FixedVector3.sub(this.paths[this.idx], this.character.getPresentationBaseLayer().getModelPosByFixedVector(), this.vecDir);
                FixedVector3.sub(this.paths[this.idx], this.paths[this.idx - 1], this.vecVel);
                this.myTempPos.x = this.paths[this.idx].x;
                this.myTempPos.y = this.paths[this.idx].y;
                this.myTempPos.z = this.paths[this.idx].z;
                if (FixedVector3.dot(this.vecDir, this.vecVel) < 0 ||
                    (this.vecVel.x == 0 && this.vecVel.y == 0 && this.vecVel.z == 0) || (Laya.Vector3.distanceSquared(this.character.getPresentationBaseLayer().getModelPosByVector3(), this.myTempPos) <
                        0.5 * 0.5)) {
                    this.idx++;
                } else {
                    this.character.setIsMoving = true;
                    this.character.getPresentationBaseLayer().jump();
                    FixedVector3.normalize(this.vecDir, this.vecDir);
                    this.character.setMyOrientation(this.vecDir.x, 0, this.vecDir.z);
                    if (!this.character.getPresentationBaseLayer().isAIStartRandomRotate) {
                        let qua = this.character.getPresentationBaseLayer().getModel().transform.rotation;
                        let myPos = CommonUtil.Vector3.zero;
                        this.nextPos.x = this.vecDir.x;
                        this.nextPos.z = this.vecDir.z;
                        this.nextPos.x *= -1;
                        this.nextPos.z *= -1;
                        Laya.Quaternion.lookAt(myPos, this.nextPos, CommonUtil.Vector3.up, this.turnTo);
                        this.turnTo.invert(this.turnTo);
                        Laya.Quaternion.lerp(qua, this.turnTo, 1, qua);
                        this.character.setDirection(this.turnTo);
                        this.character.getPresentationBaseLayer().setDirection();
                    }
                }
            }
        }
    }

    class ArmPropCtrl extends Laya.Script3D {
        constructor(pos = new Laya.Vector3, type = 1) {
            super();
            this.isGet = false;
            this.model = null;
            this.idx = 0;
            this.pos = new Laya.Vector3();
            this.tran = null;
            this.type = 1;
            this.pos = pos;
            this.type = type;
        }
        onAwake() {
            this.model = this.owner;
            this.idx = this.model.id;
            this.model.transform.position = this.pos;
            this.tran = this.model.transform;
        }
        onUpdate() {
            if (CharacterManger.gameOver) {
                return;
            }
            if (this.isGet)
                return;
            for (let k = 0; k < CharacterManger.logicalBaseLayer.length; k++) {
                let item = CharacterManger.logicalBaseLayer[k];
                if (item.getIsMySelf()) {
                    if (Laya.Vector3.distanceSquared(item.getPresentationBaseLayer().getModelPosByVector3(), this.pos) < 3 * 3) {
                        if ((item.armCtrlList.length == 0) || (item.armCtrlList.length == 1 && item.getArmCtrl().getType() != 8 && this.model.name == '8001') || (item.armCtrlList.length == 1 && item.getArmCtrl().getType() == 8 && this.model.name != '8001') || (item.armCtrlList.length == 1 && item.getArmCtrl().getType() == 8 && this.model.name == '8001' && item.getArmCtrl().curBullets == 0)) {
                            if (!this.isGet) {
                                this.isGet = true;
                                this.getCtrl(item);
                                return;
                            }
                        }
                    }
                } else {
                    if (Laya.Vector3.distanceSquared(item.getPresentationBaseLayer().getModelPosByVector3(), this.pos) < 3 * 3 && item.armCtrlList.length == 0) {
                        if (!this.isGet) {
                            this.isGet = true;
                            this.getCtrl(item);
                            return;
                        }
                    }
                }
            }
        }
        onDestroy() {
            this.isGet = null;
            this.model = null;
            this.idx = null;
            this.pos = null;
            this.tran = null;
            this.type = null;
        }
        getCtrl(logic) {
            this.model.active = false;
            PlaceArmManager.addCacheArmList(this);
            logic.pickUpTheGun(this.model.name);
            Laya.timer.once(1500, this, function cd() {
                PlaceArmManager.resetGenerateArm(this);
                Laya.timer.clear(this, cd);
            });
        }
    }

    class PlaceArmManager {
        static addPlaceList() {
            if (ModeManager.mode != GAME_MODE_TYPE.ONEVSONEMODE && ModeManager.mode != GAME_MODE_TYPE.SNIPERMODE)
                return;
            this.clean();
            let parent = null;
            if (ModeManager.mode == GAME_MODE_TYPE.SNIPERMODE) {
                parent = GameScene.scene3d.getChildByName('sniperGameObject');
            } else {
                parent = GameScene.scene3d.getChildByName('GameObject');
            }
            let len = parent.numChildren;
            for (let k = 0; k < len; k++) {
                this.placeList.push(parent.getChildAt(k));
            }
            this.randomGenerateArms();
        }
        static randomGenerateArms() {
            if (ModeManager.mode == GAME_MODE_TYPE.SNIPERMODE) {
                for (let i in ARM.keys) {
                    if (ARM.getDataByKey(ARM.keys[i]).type == 3) {
                        this.idList.push(ARM.keys[i]);
                    }
                }
            }
            for (let k = 0; k < this.placeList.length; k++) {
                let obj = this.placeList[k];
                let pos = obj.transform.position.clone();
                pos.y += 0.2;
                let type = parseInt(obj.name);
                let arm = null;
                if (ModeManager.mode == GAME_MODE_TYPE.SNIPERMODE) {
                    arm = SkinManager.onLyToCreateArm(this.idList[RandomUtil.onlyOneRandomInt(0, this.idList.length)], GameScene.scene3d);
                } else if (ModeManager.mode == GAME_MODE_TYPE.ONEVSONEMODE) {
                    let list = [];
                    for (let i in ARM.keys) {
                        if (ARM.getDataByKey(ARM.keys[i]).type == parseInt(obj.name)) {
                            list.push(ARM.keys[i]);
                        }
                    }
                    for (let i in PROP.keys) {
                        if (PROP.getDataByKey(PROP.keys[i]).type == parseInt(obj.name)) {
                            list.push(PROP.keys[i]);
                        }
                    }
                    console.log('list:', list);
                    let id = list[RandomUtil.onlyOneRandomInt(0, list.length)];
                    console.log('随机的枪械ID：', id);
                    arm = SkinManager.onLyToCreateArm(id, GameScene.scene3d);
                }
                arm.addComponentIntance(new ArmPropCtrl(pos, type));
                this.armList.push(arm);
            }
        }
        static resetGenerateArm(ctrl) {
            let newObj = null;
            if (!newObj) {
                if (ModeManager.mode == GAME_MODE_TYPE.SNIPERMODE) {
                    newObj = SkinManager.onLyToCreateArm(this.idList[RandomUtil.onlyOneRandomInt(0, this.idList.length)], GameScene.scene3d);
                } else {
                    let list = [];
                    for (let i in ARM.keys) {
                        if (ARM.getDataByKey(ARM.keys[i]).type == ctrl.type) {
                            list.push(ARM.keys[i]);
                        }
                    }
                    for (let i in PROP.keys) {
                        if (PROP.getDataByKey(PROP.keys[i]).type == ctrl.type) {
                            list.push(PROP.keys[i]);
                        }
                    }
                    newObj = SkinManager.onLyToCreateArm(list[RandomUtil.onlyOneRandomInt(0, list.length)], GameScene.scene3d);
                }
                newObj.transform.position = ctrl.pos;
                newObj.addComponentIntance(new ArmPropCtrl(ctrl.model.transform.position.clone(), ctrl.type));
            }
            newObj.transform.position = ctrl.pos;
            for (let k = 0; k < this.armList.length; k++) {
                let myCtrl = this.armList[k].getComponent(ArmPropCtrl);
                if (ctrl.idx == myCtrl.idx) {
                    this.armList[k] = newObj;
                    break;
                }
            }
        }
        static addCacheArmList(ctrl) {
            for (let k = 0; k < this.cacheArmList.length; k++) {
                let ctrl1 = this.cacheArmList[k].getComponent(ArmPropCtrl);
                if (ctrl1.idx == ctrl.idx)
                    return;
            }
            this.cacheArmList.push(ctrl.model);
        }
        static getNearArm(logic) {
            let obj = this.armList[0];
            let min = Laya.Vector3.distanceSquared(logic.getPresentationBaseLayer().getModelPosByVector3(), this.armList[0].transform.position);
            for (let k = 0; k < this.armList.length; k++) {
                let item = this.armList[k];
                let ctrl = item.getComponent(ArmPropCtrl);
                let dis = Laya.Vector3.distanceSquared(logic.getPresentationBaseLayer().getModelPosByVector3(), item.transform.position.clone());
                if (!logic.isGetBombLast) {
                    if (dis < min && !ctrl.isGet) {
                        obj = item;
                        min = dis;
                    }
                } else {
                    if (ctrl.type == 8)
                        continue;
                    if (dis < min && !ctrl.isGet) {
                        obj = item;
                        min = dis;
                    }
                }
            }
            return obj;
        }
        static clean() {
            for (let k = 0; k < this.armList.length; k++) {
                let item = this.armList[k];
                if (item) {
                    item.destroy();
                    item = null;
                }
            }
            for (let k = 0; k < this.cacheArmList.length; k++) {
                let item = this.cacheArmList[k];
                if (item) {
                    item.destroy();
                    item = null;
                }
            }
            this.placeList = [];
            this.armList = [];
            this.cacheArmList = [];
            this.idList = [];
        }
    }
    PlaceArmManager.placeList = [];
    PlaceArmManager.armList = [];
    PlaceArmManager.cacheArmList = [];
    PlaceArmManager.idList = [];

    class BehaviourSearch extends BehaviourNode {
        constructor(weight, time) {
            super(weight, time);
            this.findCoutDown = 0;
            this.paths = null;
            this.turnTo = new Laya.Quaternion();
            this.nextPos = new Laya.Vector3();
            this.idx = 1;
            this.vecVel = new FixedVector3();
            this.vecDir = new FixedVector3();
            this.targetPos = new FixedVector3();
            this.isSearchBullet = false;
            this.isSearchHP = false;
            this._type = AI_BEHAVIOUR_TYPE.AI_BEHAVIOUR_SEARCH;
        }
        execute(context) {
            super.execute(context);
            this.isSearchBullet = false;
            this.isSearchHP = false;
            this.character.setIsMoving = true;
            this.character.setIsAttack = false;
            this.character.isStartAttack = false;
        }
        setPaths() {
            if (ModeManager.mode != GAME_MODE_TYPE.BIOCHEMISTRY) {
                let obj = PlaceArmManager.getNearArm(this.character);
                this.targetPos.x = obj.transform.position.x;
                this.targetPos.y = 0;
                this.targetPos.z = obj.transform.position.z;
                let navNode = MapManager.pathfinder.getClosestNode(this.targetPos, MapManager.zoneID, MapManager.navGroup, true);
                this.idx = 1;
                this.paths = MapManager.pathfinder.findPathWithNode(this.character.getPresentationBaseLayer().getModelPosByFixedVector(), this.targetPos, this.character.getPresentationBaseLayer().navNode, navNode, MapManager.zoneID, MapManager.navGroup);
            } else {
                if (this.character.getHP() / this.character.getMaxHP() < 0.3) {
                    this.isSearchHP = true;
                    let obj = BiochemistryManager.getNearHPSupply(this.character);
                    this.targetPos.x = obj.transform.position.x;
                    this.targetPos.y = 0;
                    this.targetPos.z = obj.transform.position.z;
                    let navNode = MapManager.pathfinder.getClosestNode(this.targetPos, MapManager.zoneID, MapManager.navGroup, true);
                    this.idx = 1;
                    this.paths = MapManager.pathfinder.findPathWithNode(this.character.getPresentationBaseLayer().getModelPosByFixedVector(), this.targetPos, this.character.getPresentationBaseLayer().navNode, navNode, MapManager.zoneID, MapManager.navGroup);
                    return;
                }
                if (this.character.bullets == 0 && this.character.magazineBullet == 0) {
                    this.isSearchBullet = true;
                    let obj = BiochemistryManager.getNearBulletSupply(this.character);
                    this.targetPos.x = obj.transform.position.x;
                    this.targetPos.y = 0;
                    this.targetPos.z = obj.transform.position.z;
                    let navNode = MapManager.pathfinder.getClosestNode(this.targetPos, MapManager.zoneID, MapManager.navGroup, true);
                    this.idx = 1;
                    this.paths = MapManager.pathfinder.findPathWithNode(this.character.getPresentationBaseLayer().getModelPosByFixedVector(), this.targetPos, this.character.getPresentationBaseLayer().navNode, navNode, MapManager.zoneID, MapManager.navGroup);
                    return;
                }
            }
        }
        update() {
            super.update();
            if (!this.character.getPresentationBaseLayer())
                return;
            if (ModeManager.mode == GAME_MODE_TYPE.ONEVSONEMODE || ModeManager.mode == GAME_MODE_TYPE.SNIPERMODE) {
                if (this.character.armCtrlList.length != 0) {
                    this.character.attackLogicalBaseLayer = null;
                    this.isDone = true;
                    return;
                }
            }
            if (ModeManager.mode == GAME_MODE_TYPE.BIOCHEMISTRY) {
                if (this.isSearchBullet) {
                    if (this.character.bullets != 0 && this.character.magazineBullet != 0) {
                        this.character.attackLogicalBaseLayer = null;
                        this.isDone = true;
                        return;
                    }
                }
                if (this.isSearchHP) {
                    if (this.character.getHP() == 100) {
                        this.character.attackLogicalBaseLayer = null;
                        this.isDone = true;
                        return;
                    }
                }
            }
            this.findCoutDown -= LogicTimer.gSysTimer.delta;
            if (this.findCoutDown < 0) {
                this.findCoutDown = 500;
                this.setPaths();
            }
            if (this.paths && this.paths[this.idx]) {
                FixedVector3.sub(this.paths[this.idx], this.character.getPresentationBaseLayer().getModelPosByFixedVector(), this.vecDir);
                FixedVector3.sub(this.paths[this.idx], this.paths[this.idx - 1], this.vecVel);
                let pos = new Laya.Vector3();
                pos.x = this.paths[this.idx].x;
                pos.y = this.paths[this.idx].y;
                pos.z = this.paths[this.idx].z;
                if (FixedVector3.dot(this.vecDir, this.vecVel) < 0 ||
                    (this.vecVel.x == 0 && this.vecVel.y == 0 && this.vecVel.z == 0) || (Laya.Vector3.distanceSquared(this.character.getPresentationBaseLayer().getModelPosByVector3(), pos) <
                        0.5 * 0.5)) {
                    this.idx++;
                } else {
                    this.character.setIsMoving = true;
                    this.character.getPresentationBaseLayer().jump();
                    FixedVector3.normalize(this.vecDir, this.vecDir);
                    this.character.setMyOrientation(this.vecDir.x, 0, this.vecDir.z);
                    if (!this.character.getPresentationBaseLayer().isAIStartRandomRotate) {
                        let qua = this.character.getPresentationBaseLayer().getModel().transform.rotation;
                        let myPos = CommonUtil.Vector3.zero;
                        this.nextPos.x = this.vecDir.x;
                        this.nextPos.z = this.vecDir.z;
                        this.nextPos.x *= -1;
                        this.nextPos.z *= -1;
                        Laya.Quaternion.lookAt(myPos, this.nextPos, CommonUtil.Vector3.up, this.turnTo);
                        this.turnTo.invert(this.turnTo);
                        Laya.Quaternion.lerp(qua, this.turnTo, 1, qua);
                        this.character.setDirection(this.turnTo);
                        this.character.getPresentationBaseLayer().setDirection();
                    }
                }
            }
        }
    }

    class BehaviourTrack extends BehaviourNode {
        constructor(weight, time) {
            super(weight, time);
            this.vecVel = new FixedVector3();
            this.vecDir = new FixedVector3();
            this.findCoutDown = 0;
            this.vecTarget = new FixedVector3();
            this.isRevenge = false;
            this.turnTo = new Laya.Quaternion();
            this.nextPos = new Laya.Vector3();
            this.escapePoint = new FixedVector3();
            this.targetList = [];
            this.mayPos = new Laya.Vector3();
            this.nextPath = new Laya.Vector3();
            this.testBox = null;
            this._type = AI_BEHAVIOUR_TYPE.AI_BEHAVIOUR_TRACK;
        }
        clean() {
            this.vecVel.clean();
            this.vecVel = null;
            this.vecDir.clean();
            this.vecDir = null;
            this.target = null;
            this.vecTarget.clean();
            this.vecTarget = null;
            this.targetList = null;
        }
        execute(context) {
            super.execute(context);
            this.isRevenge = context.isRevenge;
            this.target = context.target;
            this.findCoutDown = 0;
            this.character.isCrouch = false;
            this.character.setIsAttack = false;
            this.isDone = false;
        }
        testPoint(pos) {
            if (!this.testBox) {
                this.testBox = GameScene.scene3d.addChild(new Laya.MeshSprite3D(Laya.PrimitiveMesh.createBox(1, 1, 1)));
                this.testBox.transform.rotate(new Laya.Vector3(0, 45, 0), false, false);
                var material = new Laya.BlinnPhongMaterial();
                Laya.Texture2D.load("res/layabox.png", Laya.Handler.create(null, function(tex) {
                    material.albedoTexture = tex;
                }));
                this.testBox.transform.position = pos;
                this.testBox.meshRenderer.material = material;
            } else {
                this.testBox.transform.position = pos;
            }
        }
        setPaths() {
            this.idx = 1;
            if (this.character && this.target) {
                if (this.character.getIsDie() || this.target.getIsDie()) {
                    this.character.paths = null;
                    return;
                }
                if (this.character.paths) {
                    if (this.character.paths.length <= 2)
                        return;
                }
                if (this.target.getIsMySelf()) {
                    this.target.getPresentationBaseLayer().initNavNode();
                }
                this.character.paths = MapManager.pathfinder.findPathWithNode(this.character.getPresentationBaseLayer().getModelPosByFixedVector(), this.target.getPresentationBaseLayer().getModelPosByFixedVector(), this.character.getPresentationBaseLayer().navNode, this.target.getPresentationBaseLayer().navNode, MapManager.zoneID, MapManager.navGroup);
            }
        }
        mySelfAndOtherDis() {
            if (this.targetList.length == 0) {
                for (let k = 0; k < CharacterManger.logicalBaseLayer.length; k++) {
                    let target = CharacterManger.logicalBaseLayer[k];
                    if (!target.getIsDie() && !this.character.getIsDie() && target.getRoleType() != this.context.aiLogic.character.getRoleType()) {
                        this.targetList.push(target);
                    }
                }
            }
            if (this.targetList.length == 0)
                return false;
            for (let k = 0; k < this.targetList.length; k++) {
                let item = this.targetList[k];
                let dis = Laya.Vector3.distanceSquared(this.character.getPresentationBaseLayer().getModelPosByVector3(), item.getPresentationBaseLayer().getModelPosByVector3());
                if (dis < 30 * 30) {
                    return true;
                }
            }
            return false;
        }
        judgeTarget() {
            if (this.targetList.length == 0) {
                for (let k = 0; k < CharacterManger.logicalBaseLayer.length; k++) {
                    let target = CharacterManger.logicalBaseLayer[k];
                    if (!target.getIsDie() && !this.character.getIsDie() && target.getRoleType() != this.context.aiLogic.character.getRoleType()) {
                        this.targetList.push(target);
                    }
                }
            }
            if (this.targetList.length == 0)
                return false;
            if (this.character.paths) {
                let tar = this.targetList[0];
                let min = Laya.Vector3.distanceSquared(this.character.getPresentationBaseLayer().getModelPosByVector3(), this.targetList[0].getPresentationBaseLayer().getModelPosByVector3());
                for (let k = 0; k < this.targetList.length; k++) {
                    let item = this.targetList[k];
                    let dis = Laya.Vector3.distanceSquared(this.character.getPresentationBaseLayer().getModelPosByVector3(), this.targetList[k].getPresentationBaseLayer().getModelPosByVector3());
                    if (min > dis && !item.getIsDie()) {
                        min = dis;
                        tar = item;
                    }
                }
                if (tar.getPresentationBaseLayer().getModelID() == this.target.getPresentationBaseLayer().getModelID())
                    return;
                this.character.attackLogicalBaseLayer = tar;
                this.target = this.character.attackLogicalBaseLayer;
            }
        }
        update() {
            super.update();
            if (this.character.getRoleType() == ROLE_TYPE.TYPE_1) {}
            if (!this.target || !this.character)
                return;
            if (this.character.getIsDie()) {
                this.character.paths = null;
                this.character.setIsMoving = false;
                this.isDone = true;
                this.character.setMyOrientation(0, 0, 0);
                return;
            }
            if (this.target.getIsDie()) {
                this.character.paths = null;
                this.character.setIsMoving = false;
                this.isDone = true;
                this.character.setMyOrientation(0, 0, 0);
                return;
            }
            this.judgeTarget();
            if (this.character.getRoleType() == ROLE_TYPE.TYPE_1) {};
            this.findCoutDown -= LogicTimer.gSysTimer.delta;
            if (this.findCoutDown < 0) {
                this.findCoutDown = 1500;
                this.setPaths();
                if (this.character.getRoleType() == ROLE_TYPE.TYPE_1) {}
                if (this.character.paths) {
                    if (this.character.paths.length == 2) {
                        if (this.mySelfAndOtherDis()) {
                            this.idx = 0;
                            this.character.setIsMoving = false;
                            this.isDone = true;
                            this.character.setMyOrientation(0, 0, 0);
                            return;
                        }
                    }
                }
            }
            if (this.character.getRoleType() == ROLE_TYPE.TYPE_1) {}
            if (this.character.paths && this.character.paths[this.idx]) {
                FixedVector3.sub(this.character.paths[this.idx], this.character.getPresentationBaseLayer().getModelPosByFixedVector(), this.vecDir);
                FixedVector3.sub(this.character.paths[this.idx], this.character.paths[this.idx - 1], this.vecVel);
                if (this.character.paths.length == 2) {
                    if (this.mySelfAndOtherDis()) {
                        this.idx = 0;
                        this.character.setIsMoving = false;
                        this.isDone = true;
                        this.character.setMyOrientation(0, 0, 0);
                        return;
                    }
                }
                if (this.character.getRoleType() == ROLE_TYPE.TYPE_1) {}
                let pos = this.character.getPresentationBaseLayer().getModelPosByVector3();
                this.nextPath.x = this.character.paths[this.idx].x;
                this.nextPath.y = this.character.paths[this.idx].y;
                this.nextPath.z = this.character.paths[this.idx].z;
                let len = Laya.Vector3.distance(pos, this.nextPath);
                if (FixedVector3.dot(this.vecDir, this.vecVel) < 0 || (Math.abs(len) < 2) ||
                    (this.vecVel.x == 0 && this.vecVel.y == 0 && this.vecVel.z == 0)) {
                    this.idx++;
                } else {
                    this.mayPos.x = this.character.paths[this.idx].x;
                    this.mayPos.y = this.character.paths[this.idx].y;
                    this.mayPos.z = this.character.paths[this.idx].z;
                    this.character.setIsMoving = true;
                    if (Math.abs(Laya.Vector3.distance(this.character.getPresentationBaseLayer().getModelPosByVector3(), this.mayPos)) < 1) {
                        this.idx++;
                    }
                    FixedVector3.normalize(this.vecDir, this.vecDir);
                    this.character.getPresentationBaseLayer().jump();
                    let isRotate = this.character.getPresentationBaseLayer().startRanomRotate();
                    this.character.setMyOrientation(this.vecDir.x, 0, this.vecDir.z);
                    if (!isRotate) {
                        let qua = this.character.getPresentationBaseLayer().getModel().transform.rotation;
                        let myPos = CommonUtil.Vector3.zero;
                        this.nextPos.x = this.vecDir.x;
                        this.nextPos.z = this.vecDir.z;
                        this.nextPos.x *= -1;
                        this.nextPos.z *= -1;
                        Laya.Quaternion.lookAt(myPos, this.nextPos, CommonUtil.Vector3.up, this.turnTo);
                        this.turnTo.invert(this.turnTo);
                        Laya.Quaternion.lerp(qua, this.turnTo, 1, qua);
                        this.character.setDirection(this.turnTo);
                        this.character.getPresentationBaseLayer().setDirection();
                    }
                }
            } else {}
        }
    }

    class AIState {
        constructor(data, context) {
            this.behaviourList = [];
            this.weight = 0;
            this.context = context;
            let strBehaviours = data.split('|');
            for (let i = 0, len = strBehaviours.length; i < len; i++) {
                let behaviourData = strBehaviours[i].split('_');
                let behaviour;
                let time = parseInt(behaviourData[1]);
                let weight = parseInt(behaviourData[2]);
                switch (parseInt(behaviourData[0])) {
                    case AI_BEHAVIOUR_TYPE.AI_BEHAVIOUR_NONE:
                        {
                            behaviour = new BehaviourNone(weight, time);
                            break;
                        }
                    case AI_BEHAVIOUR_TYPE.AI_BEHAVIOUR_ATTACK:
                        {
                            behaviour = new BehaviourAttack(weight, time);
                            break;
                        }
                    case AI_BEHAVIOUR_TYPE.AI_BEHAVIOUR_IDLE:
                        {
                            behaviour = new BehaviourIdle(weight, time);
                            break;
                        }
                    case AI_BEHAVIOUR_TYPE.AI_BEHAVIOUR_PATROL:
                        {
                            behaviour = new BehaviourPatrol(weight, time);
                            break;
                        }
                    case AI_BEHAVIOUR_TYPE.AI_BEHAVIOUR_TRACK:
                        {
                            behaviour = new BehaviourTrack(weight, time);
                            break;
                        }
                    case AI_BEHAVIOUR_TYPE.AI_BEHAVIOUR_ESCAPE:
                        {
                            behaviour = new BehaviourEscape(weight, time);
                            break;
                        }
                    case AI_BEHAVIOUR_TYPE.AI_BEHAVIOUR_CROUCHATTACK:
                        {
                            behaviour = new BehaviourCrouchAttack(weight, time);
                            break;
                        }
                    case AI_BEHAVIOUR_TYPE.AI_BEHAVIOUR_MOVEATTACK:
                        {
                            behaviour = new BehaviourMoveAttack(weight, time);
                            break;
                        }
                    case AI_BEHAVIOUR_TYPE.AI_BEHAVIOUR_SEARCH:
                        {
                            behaviour = new BehaviourSearch(weight, time);
                            break;
                        }
                }
                this.behaviourList.push(behaviour);
                this.weight += this.behaviourList[i].weight;
            }
        }
        setBehaviour() {
            let weight = 0;
            let newWeight = Math.floor(Math.random() * (this.weight - 1));
            for (let i = 0, len = this.behaviourList.length; i < len; i++) {
                if (this.behaviourList[i].weight >= newWeight) {
                    this.curBehaviour = this.behaviourList[i];
                    break;
                } else {
                    newWeight -= this.behaviourList[i].weight;
                }
            }
            this.curBehaviour.isDone = false;
            this.curBehaviour.execute(this.context);
        }
        think() {}
        update() {
            if (this.curBehaviour) {
                this.curBehaviour.update();
            }
        }
        clean() {
            for (let k in this.behaviourList) {
                this.behaviourList[k].clean();
                this.behaviourList[k] = null;
            }
            this.behaviourList = null;
            this.curBehaviour = null;
            this.context = null;
        }
    }

    class Condition {}

    class ConditionEscape extends Condition {
        static pass(context) {
            let character = context.aiLogic.character;
            if (character.isZombie)
                return false;
            if (ModeManager.mode == GAME_MODE_TYPE.BIOCHEMISTRY) {
                if (!character.isZombie) {
                    if (!BiochemistryManager.isHasLifeSupply()) {
                        return true;
                    } else {
                        if (character.getHP() / character.getMaxHP() <= 0.3)
                            return false;
                    }
                    if (!BiochemistryManager.isHasBulletSupply()) {
                        return true;
                    } else {
                        if (character.bullets == 0 && character.magazineBullet == 0)
                            return false;
                    }
                }
            }
            if (character.attackLogicalBaseLayer) {
                if (!character.attackLogicalBaseLayer.getIsDie() && character.isStartHuaBullet) {
                    context.target = character.attackLogicalBaseLayer;
                    return true;
                } else {
                    return false;
                }
            } else {
                return false;
            }
        }
    }

    class ConditionNormal extends Condition {
        static pass(context) {
            let character = context.aiLogic.character;
            if (character.getIsDie())
                return false;
            if (!character.isZombie) {
                if (character.armCtrlList.length == 0)
                    return false;
            }
            if (ModeManager.mode == GAME_MODE_TYPE.BIOCHEMISTRY) {
                if (!character.isZombie) {
                    if (character.getHP() / character.getMaxHP() <= 0.3)
                        return false;
                    if (character.bullets == 0 && character.magazineBullet == 0)
                        return false;
                }
            }
            if (character.attackLogicalBaseLayer) {
                if (character.attackLogicalBaseLayer.getIsDie()) {
                    if (character.attackLogicalBaseLayer.killerLogicalBaseLayer)
                        character.attackLogicalBaseLayer.killerLogicalBaseLayer = null;
                    if (context.target.killerLogicalBaseLayer)
                        context.target.killerLogicalBaseLayer = null;
                    character.attackLogicalBaseLayer = null;
                    context.target = character.attackLogicalBaseLayer;
                } else {
                    if (character.attackLogicalBaseLayer || context.target.isInvincible)
                        return true;
                }
            }
            if (character.isZombie) {
                if (!character.attackLogicalBaseLayer)
                    return true;
            }
            if (character.isStartHuaBullet)
                return false;
            if (character.bullets == 0) {
                if (character.magazineBullet != 0) {
                    if (character.attackLogicalBaseLayer == null || (character.attackLogicalBaseLayer && character.attackLogicalBaseLayer.getIsDie())) {
                        return true;
                    } else {
                        return false;
                    }
                } else {
                    return true;
                }
            } else {
                if (character.attackLogicalBaseLayer == null || (character.attackLogicalBaseLayer && character.attackLogicalBaseLayer.getIsDie())) {
                    return true;
                } else {
                    return false;
                }
            }
        }
    }

    class ConditionDie extends Condition {
        static pass(context) {
            let character = context.aiLogic.character;
            if (character.getIsDie())
                return true;
            return false;
        }
    }

    class ConditionSearch extends Condition {
        static pass(context) {
            let character = context.aiLogic.character;
            if (!character.isZombie) {
                if (character.armCtrlList.length == 0) {
                    return true;
                }
            }
            if (ModeManager.mode == GAME_MODE_TYPE.BIOCHEMISTRY) {
                if (!character.isZombie) {
                    if (BiochemistryManager.isHasLifeSupply()) {
                        if (character.getHP() / character.getMaxHP() <= 0.3)
                            return true;
                    } else {
                        return false;
                    }
                    if (BiochemistryManager.isHasBulletSupply()) {
                        if (character.bullets == 0 && character.magazineBullet == 0)
                            return true;
                    } else {
                        return false;
                    }
                }
            }
            return false;
        }
    }

    class AIAttacktate extends AIState {
        enter() {
            this.context.isRevenge = false;
            this.type = AI_STATE.ATTACK;
            this.setBehaviour();
            this.preTime = LogicTimer.gSysTimer.currTimer;
        }
        exit() {}
        setBehaviour() {
            super.setBehaviour();
        }
        update() {
            super.update();
            if (this.curBehaviour.isDone) {
                this.setBehaviour();
                this.preTime = LogicTimer.gSysTimer.currTimer;
                if (ConditionSearch.pass(this.context)) {
                    this.context.aiLogic.setState(AI_STATE.SEARCH);
                    return;
                }
                if (ConditionDie.pass(this.context)) {
                    this.context.aiLogic.setState(AI_STATE.DIE);
                    return;
                }
                if (ConditionNormal.pass(this.context)) {
                    this.context.aiLogic.setState(AI_STATE.NORMAL);
                    return;
                }
                if (ConditionEscape.pass(this.context)) {
                    this.context.aiLogic.setState(AI_STATE.ESCAPE);
                }
            }
        }
        think() {
            super.think();
            if (this.curBehaviour.isDone) {
                this.setBehaviour();
                if (ConditionSearch.pass(this.context)) {
                    this.context.aiLogic.setState(AI_STATE.SEARCH);
                    return;
                }
                if (ConditionDie.pass(this.context)) {
                    this.context.aiLogic.setState(AI_STATE.DIE);
                    return;
                }
                if (ConditionNormal.pass(this.context)) {
                    this.context.aiLogic.setState(AI_STATE.NORMAL);
                    return;
                }
                if (ConditionEscape.pass(this.context)) {
                    this.context.aiLogic.setState(AI_STATE.ESCAPE);
                }
            }
        }
    }

    class ConditionAttack extends Condition {
        static pass(context) {
            if (PerformanceManager.isCloseAttack)
                return false;
            let character = context.aiLogic.character;
            context.target = character.attackLogicalBaseLayer;
            if (character.getIsDie())
                return false;
            if (!character.isZombie) {
                if (character.armCtrlList.length == 0)
                    return false;
            }
            if (ModeManager.mode == GAME_MODE_TYPE.BIOCHEMISTRY) {
                if (!character.isZombie) {
                    if (character.getHP() / character.getMaxHP() <= 0.3) {
                        return false;
                    }
                    if (character.bullets == 0 && character.magazineBullet == 0) {
                        return false;
                    }
                }
            }
            if (context.target == null) {
                return false;
            } else {
                if (character.isZombie) {
                    if (context.target.getIsDie())
                        return false;
                    return true;
                }
                if (character.magazineBullet == 0) {
                    if (character.bullets != 0) {
                        if (context.target.getIsDie())
                            return false;
                        if (character.isStartHuaBullet)
                            return false;
                        if (context.target.isInvincible)
                            return false;
                        return true;
                    } else {
                        return false;
                    }
                } else {
                    if (context.target.getIsDie())
                        return false;
                    if (character.isStartHuaBullet)
                        return false;
                    if (context.target.isInvincible)
                        return false;
                    return true;
                }
            }
        }
    }

    class AINormalState extends AIState {
        enter() {
            this.type = AI_STATE.NORMAL;
            this.setBehaviour();
            this.preTime = LogicTimer.gSysTimer.currTimer;
        }
        exit() {}
        setBehaviour() {
            super.setBehaviour();
        }
        update() {
            super.update();
            if (this.curBehaviour.isDone) {
                this.setBehaviour();
                this.preTime = LogicTimer.gSysTimer.currTimer;
                if (ConditionSearch.pass(this.context)) {
                    this.context.aiLogic.setState(AI_STATE.SEARCH);
                    return;
                }
                if (ConditionAttack.pass(this.context)) {
                    this.context.aiLogic.setState(AI_STATE.ATTACK);
                    return;
                }
                if (ConditionDie.pass(this.context)) {
                    this.context.aiLogic.setState(AI_STATE.DIE);
                }
            }
        }
        think() {
            super.think();
            if (this.curBehaviour.isDone) {
                this.setBehaviour();
                this.preTime = LogicTimer.gSysTimer.currTimer;
                if (ConditionSearch.pass(this.context)) {
                    this.context.aiLogic.setState(AI_STATE.SEARCH);
                    return;
                }
                if (ConditionAttack.pass(this.context)) {
                    this.context.aiLogic.setState(AI_STATE.ATTACK);
                    return;
                }
                if (ConditionDie.pass(this.context)) {
                    this.context.aiLogic.setState(AI_STATE.DIE);
                }
            }
        }
    }

    class AITrackState extends AIState {
        enter() {
            this.type = AI_STATE.TRACK;
            this.setBehaviour();
            this.preTime = LogicTimer.gSysTimer.currTimer;
        }
        exit() {}
        setBehaviour() {
            super.setBehaviour();
        }
        update() {
            super.update();
            if (this.context.target && this.context.aiLogic.character.attackLogicalBaseLayer) {
                if (this.context.target.getPresentationBaseLayer().getModelID() != this.context.aiLogic.character.attackLogicalBaseLayer.getPresentationBaseLayer().getModelID()) {
                    this.context.target = this.context.aiLogic.character.attackLogicalBaseLayer;
                }
            }
            if (this.curBehaviour.isDone) {
                this.setBehaviour();
                this.preTime = LogicTimer.gSysTimer.currTimer;
                if (ConditionAttack.pass(this.context)) {
                    this.context.aiLogic.setState(AI_STATE.ATTACK);
                    return;
                }
            }
        }
        think() {
            super.think();
            if (this.curBehaviour.isDone) {
                this.setBehaviour();
                this.preTime = LogicTimer.gSysTimer.currTimer;
            }
        }
    }

    class Context {
        constructor(aiLogic) {
            this.isRevenge = false;
            this.aiLogic = aiLogic;
        }
        clean() {
            this.target = null;
            this.aiLogic = null;
        }
    }

    class AIEScapeState extends AIState {
        enter() {
            this.type = AI_STATE.ESCAPE;
            this.setBehaviour();
            this.preTime = LogicTimer.gSysTimer.currTimer;
        }
        exit() {}
        setBehaviour() {
            super.setBehaviour();
        }
        update() {
            super.update();
            if (this.curBehaviour.isDone) {
                this.setBehaviour();
                this.preTime = LogicTimer.gSysTimer.currTimer;
                if (ConditionSearch.pass(this.context)) {
                    this.context.aiLogic.setState(AI_STATE.SEARCH);
                    return;
                }
                if (ConditionAttack.pass(this.context)) {
                    this.context.aiLogic.setState(AI_STATE.ATTACK);
                    return;
                }
                if (ConditionNormal.pass(this.context)) {
                    this.context.aiLogic.setState(AI_STATE.NORMAL);
                }
            }
        }
        think() {
            super.think();
            if (this.curBehaviour.isDone) {
                this.setBehaviour();
                this.preTime = LogicTimer.gSysTimer.currTimer;
                if (ConditionSearch.pass(this.context)) {
                    this.context.aiLogic.setState(AI_STATE.SEARCH);
                    return;
                }
                if (ConditionAttack.pass(this.context)) {
                    this.context.aiLogic.setState(AI_STATE.ATTACK);
                    return;
                }
                if (ConditionNormal.pass(this.context)) {
                    this.context.aiLogic.setState(AI_STATE.NORMAL);
                }
            }
        }
    }

    class ConditionTrack extends Condition {
        static pass(context) {
            let character = context.aiLogic.character;
            let list = [];
            if (list.length == 0) {
                for (let k = 0; k < CharacterManger.logicalBaseLayer.length; k++) {
                    let target = CharacterManger.logicalBaseLayer[k];
                    if (!target.getIsDie() && !character.getIsDie() && target.getRoleType() != context.aiLogic.character.getRoleType()) {
                        list.push(target);
                    }
                }
            }
            if (list.length == 0) {
                return false;
            } else {
                if (character.magazineBullet == 0) {
                    if (character.bullets == 0) {
                        return false;
                    }
                } else {
                    if (character.bullets == 0) {
                        return false;
                    }
                }
                let tar = list[RandomUtil.onlyOneRandomInt(0, list.length)];
                context.target = tar;
                context.target.killerLogicalBaseLayer = character;
                return true;
            }
        }
        static clean() {}
    }

    class AISearchState extends AIState {
        enter() {
            this.context.isRevenge = true;
            this.type = AI_STATE.SEARCH;
            this.setBehaviour();
        }
        exit() {
            this.context.isRevenge = false;
        }
        setBehaviour() {
            super.setBehaviour();
        }
        update() {
            super.update();
            if (this.curBehaviour.isDone) {
                this.setBehaviour();
                if (ConditionDie.pass(this.context)) {
                    this.context.aiLogic.setState(AI_STATE.DIE);
                    return;
                }
                if (ConditionAttack.pass(this.context)) {
                    this.context.aiLogic.setState(AI_STATE.ATTACK);
                    return;
                }
                if (ConditionNormal.pass(this.context)) {
                    this.context.aiLogic.setState(AI_STATE.NORMAL);
                    return;
                }
            }
        }
        think() {
            super.think();
            if (this.curBehaviour.isDone) {
                this.setBehaviour();
                if (ConditionDie.pass(this.context)) {
                    this.context.aiLogic.setState(AI_STATE.DIE);
                    return;
                }
                if (ConditionAttack.pass(this.context)) {
                    this.context.aiLogic.setState(AI_STATE.ATTACK);
                    return;
                }
                if (ConditionNormal.pass(this.context)) {
                    this.context.aiLogic.setState(AI_STATE.NORMAL);
                    return;
                }
            }
        }
    }

    class AIDieState extends AIState {
        enter() {
            this.type = AI_STATE.DIE;
            this.setBehaviour();
            this.preTime = LogicTimer.gSysTimer.currTimer;
        }
        exit() {}
        setBehaviour() {
            super.setBehaviour();
        }
        update() {
            super.update();
            if (this.curBehaviour.isDone) {
                this.setBehaviour();
                this.preTime = LogicTimer.gSysTimer.currTimer;
                if (ConditionSearch.pass(this.context)) {
                    this.context.aiLogic.setState(AI_STATE.SEARCH);
                    return;
                }
                if (ConditionAttack.pass(this.context)) {
                    this.context.aiLogic.setState(AI_STATE.ATTACK);
                    return;
                }
                if (ConditionNormal.pass(this.context)) {
                    this.context.aiLogic.setState(AI_STATE.NORMAL);
                }
            }
        }
        think() {
            super.think();
            if (this.curBehaviour.isDone) {
                this.setBehaviour();
                this.preTime = LogicTimer.gSysTimer.currTimer;
                if (ConditionSearch.pass(this.context)) {
                    this.context.aiLogic.setState(AI_STATE.SEARCH);
                    return;
                }
                if (ConditionAttack.pass(this.context)) {
                    this.context.aiLogic.setState(AI_STATE.ATTACK);
                    return;
                }
                if (ConditionNormal.pass(this.context)) {
                    this.context.aiLogic.setState(AI_STATE.NORMAL);
                }
            }
        }
    }

    const REVIVE_COUT_DOWN = 5000;
    class AILogic {
        constructor(character, data) {
            this.stateList = {};
            this.reviveCoutDown = REVIVE_COUT_DOWN;
            this.aiData = data;
            this.character = character;
            this.context = new Context(this);
            LogicTimer.gSysTimer.frameLoop(1, this, this.update);
            LogicTimer.gSysTimer.frameLoop(20, this, this.think);
            this.stateList[AI_STATE.NORMAL] = new AINormalState(data.normal, this.context);
            this.stateList[AI_STATE.TRACK] = new AITrackState(data.track, this.context);
            this.stateList[AI_STATE.ATTACK] = new AIAttacktate(data.attack, this.context);
            this.stateList[AI_STATE.ESCAPE] = new AIEScapeState(data.escape, this.context);
            this.stateList[AI_STATE.DIE] = new AIDieState(data.die, this.context);
            this.stateList[AI_STATE.SEARCH] = new AISearchState(data.search, this.context);
            this.setState(AI_STATE.NORMAL);
        }
        clean() {
            ConditionTrack.clean();
            LogicTimer.gSysTimer.clearAll(this);
            this.context.clean();
            this.context = null;
            this.character = null;
            this.curState = null;
            for (let k in this.stateList) {
                this.stateList[k].clean();
                this.stateList[k] = null;
            }
            this.stateList = null;
        }
        setState(state) {
            if (this.curState) {
                this.curState.exit();
            }
            this.curState = this.stateList[state];
            this.curState.enter();
        }
        returnCurState() {
            return this.curState;
        }
        update() {
            if (CharacterManger.gameOver || CharacterManger.gameStop) {
                console.log('游戏结束停止状态更新');
                return;
            }
            if (!this.character.getPresentationBaseLayer()) {
                return;
            }
            if (this.character.getRoleType() == ROLE_TYPE.TYPE_0) {}
            this.curState.update();
        }
        think() {
            if (CharacterManger.gameOver || CharacterManger.gameStop) {
                console.log('游戏结束停止状态思考');
                return;
            }
            if (!this.character.getPresentationBaseLayer()) {
                return;
            }
            this.curState.think();
        }
    }

    const DataAvatar = [{
            "id": 1,
            "avatar": "sub1/avatar/i1.jpg",
            "nick": "逆光",
            "type": 1
        },
        {
            "id": 2,
            "avatar": "sub1/avatar/i2.jpg",
            "nick": "暖风昔人",
            "type": 1
        },
        {
            "id": 3,
            "avatar": "sub1/avatar/i3.jpg",
            "nick": "柠檬",
            "type": 1
        },
        {
            "id": 4,
            "avatar": "sub1/avatar/i4.jpg",
            "nick": "格子的夏天",
            "type": 1
        },
        {
            "id": 5,
            "avatar": "sub1/avatar/i5.jpg",
            "nick": "冰雨忧蓝",
            "type": 1
        },
        {
            "id": 6,
            "avatar": "sub1/avatar/i6.jpg",
            "nick": "何以心动",
            "type": 1
        },
        {
            "id": 7,
            "avatar": "sub1/avatar/i7.jpg",
            "nick": "眷恋",
            "type": 1
        },
        {
            "id": 8,
            "avatar": "sub1/avatar/i8.jpg",
            "nick": "琼窗梦回",
            "type": 1
        },
        {
            "id": 9,
            "avatar": "sub1/avatar/i9.jpg",
            "nick": "紫竹語嫣",
            "type": 1
        },
        {
            "id": 10,
            "avatar": "sub1/avatar/i10.jpg",
            "nick": "终陌。",
            "type": 1
        },
        {
            "id": 11,
            "avatar": "sub1/avatar/i11.jpg",
            "nick": "柒月。",
            "type": 1
        },
        {
            "id": 12,
            "avatar": "sub1/avatar/i12.jpg",
            "nick": "三分注定",
            "type": 1
        },
        {
            "id": 13,
            "avatar": "sub1/avatar/i13.jpg",
            "nick": "七分饶幸",
            "type": 1
        },
        {
            "id": 14,
            "avatar": "sub1/avatar/i14.jpg",
            "nick": "琉璃梦幻",
            "type": 1
        },
        {
            "id": 15,
            "avatar": "sub1/avatar/i15.jpg",
            "nick": "让我眼熟你.",
            "type": 1
        },
        {
            "id": 16,
            "avatar": "sub1/avatar/i16.jpg",
            "nick": "傲娇萝莉攻",
            "type": 1
        },
        {
            "id": 17,
            "avatar": "sub1/avatar/i17.jpg",
            "nick": "一笑百媚生",
            "type": 1
        },
        {
            "id": 18,
            "avatar": "sub1/avatar/i18.jpg",
            "nick": "yoyo",
            "type": 1
        },
        {
            "id": 19,
            "avatar": "sub1/avatar/i19.jpg",
            "nick": "厌世.",
            "type": 1
        },
        {
            "id": 20,
            "avatar": "sub1/avatar/i20.jpg",
            "nick": "闲身",
            "type": 1
        },
        {
            "id": 21,
            "avatar": "sub1/avatar/i21.jpg",
            "nick": "好甜",
            "type": 1
        },
        {
            "id": 22,
            "avatar": "sub1/avatar/i22.jpg",
            "nick": "服软",
            "type": 1
        },
        {
            "id": 23,
            "avatar": "sub1/avatar/i23.jpg",
            "nick": "矫情",
            "type": 1
        },
        {
            "id": 24,
            "avatar": "sub1/avatar/i24.jpg",
            "nick": "人皮目录",
            "type": 1
        },
        {
            "id": 25,
            "avatar": "sub1/avatar/i25.jpg",
            "nick": "水晶透心",
            "type": 1
        },
        {
            "id": 26,
            "avatar": "sub1/avatar/i26.jpg",
            "nick": "海螺姑娘",
            "type": 1
        },
        {
            "id": 27,
            "avatar": "sub1/avatar/i27.jpg",
            "nick": "懵逼小萝莉",
            "type": 1
        },
        {
            "id": 28,
            "avatar": "sub1/avatar/i28.jpg",
            "nick": "无字情书",
            "type": 1
        },
        {
            "id": 29,
            "avatar": "sub1/avatar/i29.jpg",
            "nick": "一世浮沉",
            "type": 1
        },
        {
            "id": 30,
            "avatar": "sub1/avatar/i30.jpg",
            "nick": "与君绝",
            "type": 1
        },
        {
            "id": 31,
            "avatar": "sub1/avatar/i31.jpg",
            "nick": "画骨i",
            "type": 1
        },
        {
            "id": 32,
            "avatar": "sub1/avatar/i32.jpg",
            "nick": "初心",
            "type": 1
        },
        {
            "id": 33,
            "avatar": "sub1/avatar/i33.jpg",
            "nick": "浪漫人生路",
            "type": 2
        },
        {
            "id": 34,
            "avatar": "sub1/avatar/i34.jpg",
            "nick": "倾听者",
            "type": 2
        },
        {
            "id": 35,
            "avatar": "sub1/avatar/i35.jpg",
            "nick": "荒人说梦",
            "type": 2
        },
        {
            "id": 36,
            "avatar": "sub1/avatar/i36.jpg",
            "nick": "川水往事",
            "type": 2
        },
        {
            "id": 37,
            "avatar": "sub1/avatar/i37.jpg",
            "nick": "羁客",
            "type": 2
        },
        {
            "id": 38,
            "avatar": "sub1/avatar/i38.jpg",
            "nick": "征骨岁月",
            "type": 2
        },
        {
            "id": 39,
            "avatar": "sub1/avatar/i39.jpg",
            "nick": "溺爱和你",
            "type": 2
        },
        {
            "id": 40,
            "avatar": "sub1/avatar/i40.jpg",
            "nick": "杀生予夺",
            "type": 2
        },
        {
            "id": 41,
            "avatar": "sub1/avatar/i41.jpg",
            "nick": "末日狂欢",
            "type": 2
        },
        {
            "id": 42,
            "avatar": "sub1/avatar/i42.jpg",
            "nick": "老街孤人",
            "type": 2
        },
        {
            "id": 43,
            "avatar": "sub1/avatar/i43.jpg",
            "nick": "痴意少年",
            "type": 2
        },
        {
            "id": 44,
            "avatar": "sub1/avatar/i44.jpg",
            "nick": "高冷怪",
            "type": 2
        },
        {
            "id": 45,
            "avatar": "sub1/avatar/i45.jpg",
            "nick": "一江月",
            "type": 2
        },
        {
            "id": 46,
            "avatar": "sub1/avatar/i46.jpg",
            "nick": "小太阳",
            "type": 2
        },
        {
            "id": 47,
            "avatar": "sub1/avatar/i47.jpg",
            "nick": "冰纨",
            "type": 2
        },
        {
            "id": 48,
            "avatar": "sub1/avatar/i48.jpg",
            "nick": "倒影年华",
            "type": 2
        },
        {
            "id": 49,
            "avatar": "sub1/avatar/i49.jpg",
            "nick": "玉婳",
            "type": 2
        },
        {
            "id": 50,
            "avatar": "sub1/avatar/i50.jpg",
            "nick": "瀚海阑干",
            "type": 2
        },
        {
            "id": 51,
            "avatar": "sub1/avatar/i51.jpg",
            "nick": "心未眠 ",
            "type": 2
        },
        {
            "id": 52,
            "avatar": "sub1/avatar/i52.jpg",
            "nick": "岛未晴",
            "type": 2
        },
        {
            "id": 53,
            "avatar": "sub1/avatar/i53.jpg",
            "nick": "紧扣心弦i ",
            "type": 2
        },
        {
            "id": 54,
            "avatar": "sub1/avatar/i54.jpg",
            "nick": "活着好累!",
            "type": 2
        },
        {
            "id": 55,
            "avatar": "sub1/avatar/i55.jpg",
            "nick": "承诺",
            "type": 2
        },
        {
            "id": 56,
            "avatar": "sub1/avatar/i56.jpg",
            "nick": "冰冰",
            "type": 2
        },
        {
            "id": 57,
            "avatar": "sub1/avatar/i57.jpg",
            "nick": "少年 舍我其谁。",
            "type": 2
        },
        {
            "id": 58,
            "avatar": "sub1/avatar/i58.jpg",
            "nick": "蝶恋花つ",
            "type": 2
        },
        {
            "id": 59,
            "avatar": "sub1/avatar/i59.jpg",
            "nick": "剩蛋姐",
            "type": 2
        },
        {
            "id": 60,
            "avatar": "sub1/avatar/i60.jpg",
            "nick": "煽情戏子゛",
            "type": 2
        },
        {
            "id": 61,
            "avatar": "sub1/avatar/i61.jpg",
            "nick": "薄荷凉@",
            "type": 2
        },
        {
            "id": 62,
            "avatar": "sub1/avatar/i62.jpg",
            "nick": "迟月",
            "type": 2
        },
        {
            "id": 63,
            "avatar": "sub1/avatar/i63.jpg",
            "nick": "凉凉",
            "type": 2
        },
        {
            "id": 64,
            "avatar": "sub1/avatar/i64.jpg",
            "nick": "马上有对象",
            "type": 2
        },
        {
            "id": 65,
            "avatar": "sub1/avatar/i65.jpg",
            "nick": "@倒带",
            "type": 2
        },
        {
            "id": 66,
            "avatar": "sub1/avatar/i66.jpg",
            "nick": "三生一梦 ",
            "type": 3
        },
        {
            "id": 67,
            "avatar": "sub1/avatar/i67.jpg",
            "nick": "情浅凉心 ",
            "type": 3
        },
        {
            "id": 68,
            "avatar": "sub1/avatar/i68.jpg",
            "nick": "〃温暖了心ぐ ",
            "type": 3
        },
        {
            "id": 69,
            "avatar": "sub1/avatar/i69.jpg",
            "nick": "鸢尾情人 ",
            "type": 3
        },
        {
            "id": 70,
            "avatar": "sub1/avatar/i70.jpg",
            "nick": "会唱歌的小包子",
            "type": 3
        },
        {
            "id": 71,
            "avatar": "sub1/avatar/i71.jpg",
            "nick": "ぴ安之若素°",
            "type": 3
        },
        {
            "id": 72,
            "avatar": "sub1/avatar/i72.jpg",
            "nick": "小新愛蜡筆 ",
            "type": 3
        },
        {
            "id": 73,
            "avatar": "sub1/avatar/i73.jpg",
            "nick": "缺1份矜持ゝ ",
            "type": 3
        },
        {
            "id": 74,
            "avatar": "sub1/avatar/i74.jpg",
            "nick": "齐逐 〃 ",
            "type": 3
        },
        {
            "id": 75,
            "avatar": "sub1/avatar/i75.jpg",
            "nick": "少根弦╮ ",
            "type": 3
        },
        {
            "id": 76,
            "avatar": "sub1/avatar/i76.jpg",
            "nick": "好自为之、",
            "type": 3
        },
        {
            "id": 77,
            "avatar": "sub1/avatar/i77.jpg",
            "nick": "苦情歌 ",
            "type": 3
        },
        {
            "id": 78,
            "avatar": "sub1/avatar/i78.jpg",
            "nick": "瞎闹腾i",
            "type": 3
        },
        {
            "id": 79,
            "avatar": "sub1/avatar/i79.jpg",
            "nick": "一干为尽 ",
            "type": 3
        },
        {
            "id": 80,
            "avatar": "sub1/avatar/i80.jpg",
            "nick": "心酸",
            "type": 3
        },
        {
            "id": 81,
            "avatar": "sub1/avatar/i81.jpg",
            "nick": "淘汰",
            "type": 3
        },
        {
            "id": 82,
            "avatar": "sub1/avatar/i82.jpg",
            "nick": "飞",
            "type": 3
        },
        {
            "id": 83,
            "avatar": "sub1/avatar/i83.jpg",
            "nick": "兜圈",
            "type": 3
        },
        {
            "id": 84,
            "avatar": "sub1/avatar/i84.jpg",
            "nick": "小情歌",
            "type": 3
        },
        {
            "id": 85,
            "avatar": "sub1/avatar/i85.jpg",
            "nick": "说谎",
            "type": 3
        },
        {
            "id": 86,
            "avatar": "sub1/avatar/i86.jpg",
            "nick": "信我有鬼",
            "type": 3
        },
        {
            "id": 87,
            "avatar": "sub1/avatar/i87.jpg",
            "nick": "蛋炒饭",
            "type": 3
        },
        {
            "id": 88,
            "avatar": "sub1/avatar/i88.jpg",
            "nick": "肥仔快乐",
            "type": 3
        },
        {
            "id": 89,
            "avatar": "sub1/avatar/i89.jpg",
            "nick": "一叶知秋",
            "type": 3
        },
        {
            "id": 90,
            "avatar": "sub1/avatar/i90.jpg",
            "nick": "拾荒",
            "type": 3
        },
        {
            "id": 91,
            "avatar": "sub1/avatar/i91.jpg",
            "nick": "勉强幸福",
            "type": 3
        },
        {
            "id": 92,
            "avatar": "sub1/avatar/i92.jpg",
            "nick": "晚霞",
            "type": 3
        },
        {
            "id": 93,
            "avatar": "sub1/avatar/i93.jpg",
            "nick": "看！飞碟",
            "type": 3
        },
        {
            "id": 94,
            "avatar": "sub1/avatar/i94.jpg",
            "nick": "星晴",
            "type": 3
        },
        {
            "id": 95,
            "avatar": "sub1/avatar/i95.jpg",
            "nick": "诱",
            "type": 3
        },
        {
            "id": 96,
            "avatar": "sub1/avatar/i96.jpg",
            "nick": "歇斯底里",
            "type": 3
        },
        {
            "id": 97,
            "avatar": "sub1/avatar/i97.jpg",
            "nick": "越反越爱",
            "type": 3
        }
    ];

    var VIEWTYPE;
    (function(VIEWTYPE) {
        VIEWTYPE["FIRSTVIEW"] = "FIRSTVIEW";
        VIEWTYPE["GAMEVIEW"] = "GAMEVIEW";
        VIEWTYPE["ENDVIEW"] = "ENDVIEW";
        VIEWTYPE["EQUIPVIEW"] = "EQUIPVIEW";
        VIEWTYPE["NEWEQUIPUNLOCKVIEW"] = "NEWEQUIPUNLOCKVIEW";
        VIEWTYPE["SHOPVIEW"] = "SHOPVIEW";
        VIEWTYPE["SYNTHESISVIEW"] = "SYNTHESISVIEW";
        VIEWTYPE["MATCHINGVIEW"] = "MATCHINGVIEW";
        VIEWTYPE["ROLEVIEW"] = "ROLEVIEW";
        VIEWTYPE["SUPERREWARDVIEW"] = "SUPERREWARDVIEW";
        VIEWTYPE["ADDGOLDVIEW"] = "ADDGOLDVIEW";
        VIEWTYPE["ADDDIAMONDSVIEW"] = "ADDDIAMONDSVIEW";
        VIEWTYPE["GETGOLDREWARDVIEW"] = "GETGOLDREWARDVIEW";
        VIEWTYPE["GETDIAMONDSREWARDVIEW"] = "GETDIAMONDSREWARDVIEW";
        VIEWTYPE["OFFLINEVIEW"] = "OFFLINEVIEW";
        VIEWTYPE["GAMEBOXVIEW"] = "GAMEBOXVIEW";
    })(VIEWTYPE || (VIEWTYPE = {}));
    var HANDLETYPE;
    (function(HANDLETYPE) {
        HANDLETYPE[HANDLETYPE["ONLYMOVE"] = 1] = "ONLYMOVE";
        HANDLETYPE[HANDLETYPE["ONLYROT"] = 2] = "ONLYROT";
        HANDLETYPE[HANDLETYPE["MOVEANDROT_TOUCHLEFTAFTER"] = 3] = "MOVEANDROT_TOUCHLEFTAFTER";
        HANDLETYPE[HANDLETYPE["MOVEANDROT_TOUCHRIGHTAFTER"] = 4] = "MOVEANDROT_TOUCHRIGHTAFTER";
    })(HANDLETYPE || (HANDLETYPE = {}));
    let TOUCHIDSTATE = {
        ADD: 1,
        REMOVE: 2,
        NORMAL: 3
    };
    var COST_TYPE;
    (function(COST_TYPE) {
        COST_TYPE[COST_TYPE["DIAMOND"] = 0] = "DIAMOND";
        COST_TYPE[COST_TYPE["GOLD"] = 1] = "GOLD";
    })(COST_TYPE || (COST_TYPE = {}));

    class NotificationItemSprite extends ui.view.common.LogViewUI {
        constructor(ctrl) {
            super();
            this.notificationView = ctrl;
        }
        onDestroy() {
            this.imgBg = null;
            this.labelLog = null;
        }
        setContent(content, delay = 2000) {
            this.labelLog.text = content;
            let width = this.labelLog.width;
            this.imgBg.width = width + 20;
            this.alpha = 1;
            this.visible = true;
            Laya.Tween.to(this, {
                alpha: 0
            }, 1000, null, Laya.Handler.create(this, function() {
                this.notificationView.hide();
            }), delay);
        }
    }

    class NotificationViewCtrl extends ui.view.common.NotificationViewUI {
        constructor() {
            super();
            this.items = [];
            this.height = this.stage.height;
            this.width = this.stage.width;
        }
        setContent(content, delay = 2000) {
            this.visible = true;
            let item;
            for (let k in this.items) {
                if (!this.items[k].visible) {
                    item = this.items[k];
                    item.visible = true;
                }
            }
            if (!item) {
                item = new NotificationItemSprite(this);
                this.items.push(item);
            }
            item.setContent(content, delay);
            this.boxContent.addChild(item);
            for (let i = this.boxContent.numChildren - 1; i >= 0; i--) {
                let child = this.boxContent.getChildAt(i);
                child.y = 0 - (this.boxContent.numChildren - i - 1) * 70;
            }
        }
        onDestroy() {
            this.boxContent = null;
        }
        hide() {
            this.boxContent.numChildren == 0 ? this.visible = false : this.visible = true;
        }
    }

    class LogManager {
        static init() {
            if (!LogManager.notificationView) {
                LogManager.notificationView = Laya.stage.addChild(new NotificationViewCtrl());
                LogManager.notificationView.hide();
                LogManager.notificationView.zOrder = ORDER_LAYER_Z.NOTIFY;
            }
        }
        static showNotification(content, showTime = 2000) {
            if (!LogManager.notificationView) {
                LogManager.notificationView = Laya.stage.addChild(new NotificationViewCtrl());
            }
            LogManager.notificationView.zOrder = ORDER_LAYER_Z.NOTIFY;
            LogManager.notificationView.setContent(content, showTime);
        }
        static showNotificationClick(content) {
            UIManager.openFunction(FUNCTION_TAG.NOTIFY_CLICK, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.WINDOW, COMMON_MENU_STYLE.HIDE, content);
        }
        static showDebug(content) {
            if (!this.isDebug) {
                console.log(content);
                return;
            }
            this.showNotification(content);
        }
    }
    LogManager.isDebug = false;

    class GameAirCrazyViewCtrl extends ui.view.gameAir.GameAirCrazyViewUI {
        constructor(arg) {
            super();
            this.time = 360;
            this.isDone = false;
            this.cb = null;
            this.id = 1;
            this.percent = 0;
            this.target = 1;
            this.isDie = false;
            this.name = 'GameAirCrazyView';
            this.cb = arg.cb;
            this.id = arg.id;
            this.width = this.stage.width;
            this.height = this.stage.height;
            this.fullPercentWidth = this.imgProgress.width;
            this.target = 1;
            if (ConfigManager.platform == PLATFORM_TYPE.WEB_4399 && Laya.Browser.onPC) {
                Laya.Browser.document.exitPointerLock();
            }
        }
        onAwake() {
            this.ani1.play(0, false);
            this.ani2.play(0, true);
            this.init();
            this.setBtnEvent();
        }
        onDestroy() {}
        onTap() {
            if (!CommonUtil.getTouch(1) || this.isDie) {
                return;
            }
            this.percent += 0.15;
            if (this.percent >= this.target) {
                if (this.percent > 1) {
                    this.percent = 1;
                }
                this.isDie = true;
                Laya.timer.once(300, this, this.get);
            }
        }
        init() {
            this.imgIcon.skin = ARM.getDataByKey(this.id).icon;
            this.txtName.text = ARM.getDataByKey(this.id).name;
            this.timer.loop(1, this, this.update);
        }
        update() {
            this.percent -= Laya.timer.delta * 0.0003;
            if (this.percent < 0)
                this.percent = 0;
            this.imgProgress.width = (this.fullPercentWidth * this.percent);
            if (this.time == 0) {
                this.back();
                this.timer.clear(this, this.update);
                return;
            }
            this.txtTime.text = StringUtil.parseTimeMS(this.time);
            this.time--;
        }
        setBtnEvent() {
            this.btnGet.on(Laya.Event.CLICK, this, this.onTap);
        }
        onBtnGet() {
            if (!CommonUtil.getTouch())
                return;
            let that = this;
            CharacterManger.gameStop = true;
            this.timer.pause();
            AdUtil.setEvent(function() {
                that.timer.resume();
                that.get();
            }, function() {
                that.timer.resume();
                CharacterManger.gameStop = false;
            }, REWARD_CTRL_TYPE.GAMEAIR);
        }
        back() {
            if (this.isDone)
                return;
            this.timer.resume();
            this.isDone = true;
            GameScene.isShowRevivieCrazy = true;
            CharacterManger.gameStop = false;
            Laya.Tween.to(this.boxAll, {
                scaleX: 1.1,
                scaleY: 1.1
            }, 120, null, Laya.Handler.create(this, () => {
                Laya.Tween.to(this.boxAll, {
                    scaleX: 0,
                    scaleY: 0
                }, 80, null, Laya.Handler.create(this, () => {
                    this.destroy();
                }));
            }));
        }
        get() {
            if (this.isDone)
                return;
            this.timer.resume();
            this.isDone = true;
            if (ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.WEB_4399) {
                GameScene.isShowRevivieCrazy = false;
            }
            CharacterManger.gameStop = false;
            this.cb && this.cb();
            Laya.Tween.to(this.boxAll, {
                scaleX: 1.1,
                scaleY: 1.1
            }, 120, null, Laya.Handler.create(this, () => {
                Laya.Tween.to(this.boxAll, {
                    scaleX: 0,
                    scaleY: 0
                }, 80, null, Laya.Handler.create(this, () => {
                    this.destroy();
                }));
            }));
            LogManager.showNotificationClick('恭喜试用');
        }
    }

    class GameAirViewCtrl extends ui.view.gameAir.GameAirViewUI {
        constructor(arg) {
            super();
            this.time = 360;
            this.isDone = false;
            this.cb = null;
            this.id = 1;
            this.name = 'GameAirView';
            this.cb = arg.cb;
            this.id = arg.id;
            this.width = this.stage.width;
            this.height = this.stage.height;
            if (ConfigManager.platform == PLATFORM_TYPE.WEB_4399 && Laya.Browser.onPC) {
                Laya.Browser.document.exitPointerLock();
            }
        }
        onAwake() {
            this.init();
            this.setBtnEvent();
        }
        onDestroy() {
            if (ConfigManager.platform == PLATFORM_TYPE.WEB_4399 && Laya.Browser.onPC) {
                let view = UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME);
                view.onBtnDown(true);
            }
            this.timer.clearAll(this);
        }
        init() {
            this.uiPlatformConfig();
            this.imgIcon.skin = ARM.getDataByKey(this.id).icon;
            this.txtName.text = ARM.getDataByKey(this.id).name;
            this.timer.once(2000, this, function cd() {
                this.on(Laya.Event.CLICK, this, this.onBtnStage);
            });
            this.timer.loop(1, this, this.update);
        }
        onBtnStage(e) {
            if (!this.btnGet.hitTestPoint(e.stageX, e.stageY))
                this.back();
        }
        update() {
            if (this.time == 0) {
                this.back();
                this.timer.clear(this, this.update);
                return;
            }
            this.txtTime.text = StringUtil.parseTimeMS(this.time);
            this.time--;
            this.imgPro.width = this.time * 370 / 360;
        }
        setBtnEvent() {
            this.btnBack.on(Laya.Event.CLICK, this, this.onBtnClose);
            this.btnGet.on(Laya.Event.CLICK, this, this.onBtnGet);
            this.btnNo.on(Laya.Event.CLICK, this, this.onBtnClose);
        }
        stageUp() {
            this.back();
        }
        onBtnClose() {
            if (!CommonUtil.getTouch())
                return;
            this.back();
        }
        onBtnGet() {
            if (!CommonUtil.getTouch())
                return;
            let that = this;
            CharacterManger.gameStop = true;
            this.timer.pause();
            AdUtil.setEvent(function() {
                that.timer.resume();
                that.get();
            }, function() {
                that.timer.resume();
                CharacterManger.gameStop = false;
            }, REWARD_CTRL_TYPE.GAMEAIR);
        }
        back() {
            if (this.isDone)
                return;
            this.timer.resume();
            this.isDone = true;
            CharacterManger.gameStop = false;
            GameScene.isShowRevivieCrazy = true;
            Laya.Tween.to(this.boxAll, {
                scaleX: 1.1,
                scaleY: 1.1
            }, 120, null, Laya.Handler.create(this, () => {
                Laya.Tween.to(this.boxAll, {
                    scaleX: 0,
                    scaleY: 0
                }, 80, null, Laya.Handler.create(this, () => {
                    this.destroy();
                }));
            }));
        }
        get() {
            if (this.isDone)
                return;
            this.timer.resume();
            this.isDone = true;
            CharacterManger.gameStop = false;
            this.cb && this.cb();
            Laya.Tween.to(this.boxAll, {
                scaleX: 1.1,
                scaleY: 1.1
            }, 120, null, Laya.Handler.create(this, () => {
                Laya.Tween.to(this.boxAll, {
                    scaleX: 0,
                    scaleY: 0
                }, 80, null, Laya.Handler.create(this, () => {
                    this.destroy();
                }));
            }));
        }
        uiPlatformConfig() {
            UIManager.replaceAdIcon([{
                img: this.btnGet.getChildAt(0),
                type: 1
            }]);
            if (ConfigManager.platform == PLATFORM_TYPE.TT || ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.WEB_4399) {
                this.btnGet.centerX = -this.btnNo.centerX;
                this.btnNo.visible = true;
                this.btnBack.visible = false;
            }
        }
    }

    class ArmCtrl {
        constructor(logic, key, isGetArmData = true) {
            this.logic = null;
            this.interval = 0;
            this.speed = 0;
            this.hit = 0;
            this.attackSound = '';
            this.magazineBullet = 0;
            this.bullets = 0;
            this.bulletChangeTimer = 0;
            this.type = null;
            this.attackDis = 0;
            this.name = '';
            this.icon = '';
            this.recoilForce = [];
            this.firestarter = '';
            this.ballistic = '';
            this.bullethole = '';
            this.reloadsound = '';
            this.isCanOpMirror = 0;
            this.curMagazineBullet = 0;
            this.curBullets = 0;
            this.isGetArmData = false;
            this.isWaitingRescue = false;
            this.id = 1;
            this.headHit = 0;
            this.limbHit = 0;
            this.isGetArmData = isGetArmData;
            this.logic = logic;
            this.init(key);
        }
        init(id) {
            this.curBaseData = this.isGetArmData ? ARM.getDataByKey(id) : PROP.getDataByKey(id);
            this.interval = this.curBaseData.interval;
            this.speed = this.curBaseData.interval;
            this.hit = this.curBaseData.hit;
            this.id = this.curBaseData.id;
            this.attackSound = SOUND_PATH.ATTACKSOUNDROOT + this.curBaseData.attackSound;
            this.magazineBullet = this.curBaseData.magazineBullet;
            this.bullets = this.curBaseData.bullets;
            this.bulletChangeTimer = this.curBaseData.bulletChangeTimer;
            this.type = this.curBaseData.type;
            this.attackDis = this.curBaseData.attackDis;
            this.name = this.curBaseData.name;
            this.icon = this.curBaseData.icon;
            this.recoilForce = this.curBaseData.recoilForce;
            this.firestarter = this.curBaseData.firestarter;
            this.ballistic = this.curBaseData.ballistic;
            this.bullethole = this.curBaseData.bullethole;
            this.reloadsound = SOUND_PATH.ATTACKSOUNDROOT + this.curBaseData.reloadsound;
            this.isCanOpMirror = this.curBaseData.isCanOpMirror;
            this.curMagazineBullet = this.magazineBullet;
            this.curBullets = this.bullets;
            this.headHit = this.curBaseData.headHit ? this.curBaseData.headHit : 0;
            this.limbHit = this.curBaseData.limbHit ? this.curBaseData.limbHit : 0;
        }
        getID() {
            return this.curBaseData.id;
        }
        getType() {
            return this.type;
        }
        getInterval() {
            return this.interval;
        }
        getSpeed() {
            return this.speed;
        }
        getHit() {
            return this.hit;
        }
        getAttackSound() {
            return this.attackSound;
        }
        getAttackDis() {
            return this.attackDis;
        }
        clearArm() {
            if (this.logic.getPresentationBaseLayer().getFireEffect()) {
                EffectManger.recycleEffect(this.logic.getPresentationBaseLayer().getFireEffect());
                this.logic.getPresentationBaseLayer().cleanFireEffect();
            }
            let buqiang = CommonUtil.findChildByName(this.logic.getPresentationBaseLayer().getModel(), 'buqiang');
            let shouqiang = CommonUtil.findChildByName(this.logic.getPresentationBaseLayer().getModel(), 'shouqiang');
            let dao = CommonUtil.findChildByName(this.logic.getPresentationBaseLayer().getModel(), 'dao');
            let shouliudan = CommonUtil.findChildByName(this.logic.getPresentationBaseLayer().getModel(), 'shouliudan');
            buqiang.destroyChildren();
            shouqiang.destroyChildren();
            dao.destroyChildren();
            shouliudan.destroyChildren();
        }
        switchArm() {
            if (this.logic.getPresentationBaseLayer().getFireEffect()) {
                EffectManger.recycleEffect(this.logic.getPresentationBaseLayer().getFireEffect());
                this.logic.getPresentationBaseLayer().cleanFireEffect();
            }
            let objName = this.curBaseData.objName;
            let buqiang = CommonUtil.findChildByName(this.logic.getPresentationBaseLayer().getModel(), 'buqiang');
            let shouqiang = CommonUtil.findChildByName(this.logic.getPresentationBaseLayer().getModel(), 'shouqiang');
            let dao = CommonUtil.findChildByName(this.logic.getPresentationBaseLayer().getModel(), 'dao');
            let shouliudan = CommonUtil.findChildByName(this.logic.getPresentationBaseLayer().getModel(), 'shouliudan');
            buqiang.destroyChildren();
            shouqiang.destroyChildren();
            dao.destroyChildren();
            shouliudan.destroyChildren();
            let ori = ResourceManager.getRes(RES_PATH.WEAPON_PREFEB).getChildByName(objName);
            let newObj;
            if (this.curBaseData.type == 2) {
                newObj = Laya.Sprite3D.instantiate(ori, dao);
            } else if (this.curBaseData.type == 8) {
                newObj = Laya.Sprite3D.instantiate(ori, shouliudan);
                let spTrail = newObj.getChildByName('Trail');
                spTrail.active = false;
            } else if (this.curBaseData.type == 4) {
                newObj = Laya.Sprite3D.instantiate(ori, shouqiang);
            } else {
                newObj = Laya.Sprite3D.instantiate(ori, buqiang);
            }
            newObj.transform.localPosition = new Laya.Vector3();
            newObj.transform.localRotationEuler = new Laya.Vector3();
            if (this.type != 2 && this.type != 8) {
                this.logic.getPresentationBaseLayer().muzzleTran = CommonUtil.findChildByName(newObj, 'kou').transform;
            }
            this.logic.getPresentationBaseLayer().perAttackTime = this.getInterval();
            return newObj;
        }
        getMagazineBullet() {
            return this.magazineBullet;
        }
        getBullets() {
            return this.bullets;
        }
        getBulletChangeTimer() {
            return this.bulletChangeTimer;
        }
        getArmName() {
            return this.name;
        }
        getIcon() {
            return this.icon;
        }
        getRecoilForce() {
            return this.recoilForce;
        }
        getFirestarter() {
            return this.firestarter;
        }
        getBallistic() {
            return this.ballistic;
        }
        getBullethole() {
            return this.bullethole;
        }
        getReloadsound() {
            return this.reloadsound;
        }
        getIsCanOpMirror() {
            return this.isCanOpMirror;
        }
        clean() {
            console.log('清除装备数据');
            this.curBaseData = null;
            this.interval = null;
            this.speed = null;
            this.hit = null;
            this.attackSound = null;
            this.magazineBullet = null;
            this.bullets = null;
            this.bulletChangeTimer = null;
            this.type = null;
            this.name = null;
            this.icon = null;
            this.recoilForce = null;
            this.firestarter = null;
            this.ballistic = null;
            this.bullethole = null;
            this.reloadsound = null;
            this.isCanOpMirror = null;
            this.curMagazineBullet = null;
            this.curBullets = null;
            this.isWaitingRescue = null;
        }
    }

    var Vector3$7 = Laya.Vector3;
    var Matrix4x4$3 = Laya.Matrix4x4;
    var BoundBox$3 = Laya.BoundBox;
    class CharacterCtrl extends Laya.Script3D {
        constructor() {
            super(...arguments);
            this.vecDir = new Vector3$7();
            this.vecTarget = new Vector3$7();
            this.vecClamp = new Vector3$7();
            this.vecClose = new Vector3$7();
            this.vecOrigin = new Vector3$7();
            this._isGrounded = true;
            this.yVel = 0;
            this.isResetYVel = false;
            this.stepHeight = 0;
            this.gravity = 9;
            this.fowardVel = 1;
        }
        onAwake() {
            let owner = this.owner;
            this.tran = owner.transform;
        }
        move(x, z) {
            this.vecDir.x = x;
            this.vecDir.z = z;
        }
        stop() {
            this.vecDir.x = 0;
            this.vecDir.y = 0;
            this.vecDir.z = 0;
        }
        jump(yVel = 5) {
            if (this.yVel == 0) {
                this.yVel = yVel;
            }
        }
        resetPos(pos) {
            this.tran.position = pos;
            this.vecDir.setValue(0, 0, 0);
            this.vecOrigin.setValue(0, 0, 0);
            this.vecTarget.setValue(0, 0, 0);
            this.yVel = 0;
            this.isResetYVel = false;
        }
        onUpdate() {
            this.tran.position.cloneTo(this.vecOrigin);
            let y = this.vecOrigin.y;
            this.vecOrigin.y += 0.5;
            this.vecTarget.x = this.vecOrigin.x + this.vecDir.x * this.fowardVel * Laya.timer.delta * 0.01;
            this.vecTarget.y = this.vecOrigin.y;
            this.vecTarget.z = this.vecOrigin.z + this.vecDir.z * this.fowardVel * Laya.timer.delta * 0.01;
            let list = [];
            let collider = CubePhysicsCompnent.clamps(this.vecOrigin, this.vecTarget, this.vecClamp, this.vecClose, list);
            this.vecClamp.y -= 0.5;
            this.vecClamp.cloneTo(this.vecTarget);
            this.vecClose.cloneTo(this.vecOrigin);
            if (collider) {
                list.push(collider.onlyID);
                let collider2 = CubePhysicsCompnent.clamps(this.vecOrigin, this.vecTarget, this.vecClamp, this.vecClose, list);
            }
            this.vecClamp.cloneTo(this.vecTarget);
            this.vecClamp.cloneTo(this.vecOrigin);
            this.vecOrigin.y = y + 0.5;
            this.vecTarget.y += this.yVel * CharacterCtrl.fixDetal * 0.005;
            if (this.isResetYVel && this.vecTarget.y < this.vecClamp.y) {
                this.yVel = 0;
                this.isResetYVel = false;
            }
            let ret = CharacterCtrl.isCollisionFloor(this.vecOrigin, this.vecTarget);
            if (ret.isCollise) {
                this._isGrounded = true;
                this.isResetYVel = true;
                this.yVel = 0;
            } else {
                this.yVel -= this.gravity * CharacterCtrl.fixDetal * 0.0025;
                this._isGrounded = false;
            }
            let pos = this.tran.position;
            this.vecClamp.cloneTo(pos);
            if (collider && collider.boundingBox.max.y - this.vecClose.y <= this.stepHeight) {
                pos.y = y + CharacterCtrl.fixDetal * 0.01;
            } else {
                pos.y = ret.y;
            }
            this.tran.position = pos;
        }
        static isCollisionFloor(vecOrigin, vecTarget) {
            if (vecTarget.y > vecOrigin.y) {
                return {
                    isCollise: false,
                    y: vecTarget.y
                };
            }
            vecOrigin.cloneTo(this._ray1.origin);
            vecTarget.y -= 0.1;
            let max = 1;
            let yDis = Math.abs(vecOrigin.y - vecTarget.y);
            if (yDis > max) {
                max = yDis;
            }
            let list = [];
            let octree = CubePhysicsCompnent.getOCTree();
            octree.getCollidingWithRayWithLayer(this._ray1, list, max, -1);
            let min = 0xffffff;
            let obb;
            let collider;
            for (let i = 0, len = list.length; i < len; i++) {
                let isExclude = false;
                let obj = list[i];
                if (obj.layer != -1) {
                    isExclude = true;
                    break;
                }
                if (isExclude)
                    continue;
                let orientedBoundBox = list[i].orientedBoundBox;
                Vector3$7.scale(orientedBoundBox.extents, -1, this._tempV31);
                orientedBoundBox.transformation.invert(this._tempM0);
                Vector3$7.TransformNormal(this._ray1.direction, this._tempM0, this._ray2.direction);
                Vector3$7.transformCoordinate(this._ray1.origin, this._tempM0, this._ray2.origin);
                this._boxBound1.min = this._tempV31;
                this._boxBound1.max = orientedBoundBox.extents;
                let dis = Laya.CollisionUtils.intersectsRayAndBoxRD(this._ray2, this._boxBound1);
                Vector3$7.scale(this._ray2.direction, dis, this._tempV32);
                Vector3$7.add(this._ray2.origin, this._tempV32, this._tempV32);
                let isUpFace = false;
                if (Math.abs(this._tempV32.x - this._boxBound1.min.x) < 1e-5) {} else if (Math.abs(this._tempV32.x - this._boxBound1.max.x) < 1e-5) {} else if (Math.abs(this._tempV32.y - this._boxBound1.min.y) < 1e-5) {} else if (Math.abs(this._tempV32.y - this._boxBound1.max.y) < 1e-5) {
                    isUpFace = true;
                } else if (Math.abs(this._tempV32.z - this._boxBound1.min.z) < 1e-5) {} else if (Math.abs(this._tempV32.z - this._boxBound1.max.z) < 1e-5) {}
                if (dis < min && dis >= 0 && yDis >= dis && isUpFace) {
                    min = dis;
                    this._ray2.direction.cloneTo(this._ray3.direction);
                    this._ray2.origin.cloneTo(this._ray3.origin);
                    this._boxBound1.cloneTo(this._boxBound2);
                    this._tempM0.cloneTo(this._tempM1);
                    obb = orientedBoundBox;
                    collider = list[i];
                }
            }
            if (min < 0xffffff) {
                Vector3$7.scale(this._ray3.direction, min, this._tempV35);
                Vector3$7.add(this._ray3.origin, this._tempV35, this._tempV35);
                Vector3$7.transformV3ToV3(this._tempV35, obb.transformation, this._tempV35);
                yDis = Math.abs(this._tempV35.y - vecOrigin.y);
                if (Math.abs(min - yDis) > 0.0001) {
                    return {
                        isCollise: false,
                        y: vecTarget.y
                    };
                }
                return {
                    isCollise: true,
                    y: this._tempV35.y
                };
            } else {
                return {
                    isCollise: false,
                    y: vecTarget.y
                };
            }
        }
        get isGrounded() {
            return this._isGrounded;
        }
    }
    CharacterCtrl.fixDetal = 16;
    CharacterCtrl._tempV31 = new Vector3$7();
    CharacterCtrl._tempV32 = new Vector3$7();
    CharacterCtrl._tempV33 = new Vector3$7();
    CharacterCtrl._tempV34 = new Vector3$7();
    CharacterCtrl._tempV35 = new Vector3$7();
    CharacterCtrl._tempM0 = new Matrix4x4$3();
    CharacterCtrl._tempM1 = new Matrix4x4$3();
    CharacterCtrl._boxBound1 = new BoundBox$3(new Vector3$7(), new Vector3$7());
    CharacterCtrl._boxBound2 = new BoundBox$3(new Vector3$7(), new Vector3$7());
    CharacterCtrl._ray1 = new Laya.Ray(new Laya.Vector3(), new Laya.Vector3(0, -1, 0));
    CharacterCtrl._ray2 = new Laya.Ray(new Laya.Vector3(), new Laya.Vector3());
    CharacterCtrl._ray3 = new Laya.Ray(new Laya.Vector3(), new Laya.Vector3());

    var Vector3$8 = Laya.Vector3;
    var Matrix4x4$4 = Laya.Matrix4x4;
    var BoundBox$4 = Laya.BoundBox;
    class DyanmicObjCtrl extends Laya.Script3D {
        constructor() {
            super(...arguments);
            this.vecForwardDir = new Vector3$8();
            this.vecTarget = new Vector3$8();
            this.vecClamp = new Vector3$8();
            this.vecClose = new Vector3$8();
            this.vecOrigin = new Vector3$8();
            this._isGrounded = true;
            this.yVel = 0;
            this.xzVel = 0;
            this.isResetYVel = false;
            this.gravity = 10 * 0.2;
            this.friction = 1;
            this._isStart = false;
        }
        onAwake() {
            let owner = this.owner;
            this.tran = owner.transform;
        }
        setVelocityDir(vecDir) {
            this.yVel = vecDir.y;
            this.vecForwardDir.x = vecDir.x;
            this.vecForwardDir.z = vecDir.z;
            this.xzVel = Vector3$8.scalarLength(this.vecForwardDir);
            this.vecForwardDir.x /= this.xzVel;
            this.vecForwardDir.z /= this.xzVel;
            this.yVel = vecDir.y;
        }
        start() {
            this._isStart = true;
        }
        getXZVel() {
            return this.xzVel;
        }
        onUpdate() {
            if (this.vecForwardDir.x == 0 && this.vecForwardDir.z == 0 && this._isGrounded && !this._isStart) {
                return;
            }
            this.tran.position.cloneTo(this.vecOrigin);
            let y = this.vecOrigin.y;
            this.vecOrigin.y += 0.01;
            this.vecTarget.x = this.vecOrigin.x + this.vecForwardDir.x * this.xzVel * Laya.timer.delta * 0.01;
            this.vecTarget.y = this.vecOrigin.y;
            this.vecTarget.z = this.vecOrigin.z + this.vecForwardDir.z * this.xzVel * Laya.timer.delta * 0.01;
            let list = [];
            let collider = CubePhysicsCompnent.clamps(this.vecOrigin, this.vecTarget, this.vecClamp, this.vecClose, list);
            this.vecClamp.cloneTo(this.vecTarget);
            this.vecClose.cloneTo(this.vecOrigin);
            if (collider) {
                list.push(collider.onlyID);
                let collider2 = CubePhysicsCompnent.clamps(this.vecOrigin, this.vecTarget, this.vecClamp, this.vecClose, list);
                if (collider2) {}
            }
            this.vecClamp.cloneTo(this.vecTarget);
            this.vecClamp.cloneTo(this.vecOrigin);
            this.vecOrigin.y = y + 0.5;
            this.vecTarget.y += this.yVel * Laya.timer.delta * 0.01;
            if (this.isResetYVel && this.vecTarget.y < this.vecClamp.y) {
                this.yVel = 0;
                this.isResetYVel = false;
            }
            let ret = CubePhysicsCompnent.isCollisionFloor(this.vecOrigin, this.vecTarget);
            if (ret.isCollise) {
                this._isGrounded = true;
                this.isResetYVel = true;
                this.yVel = 0;
                this.xzVel -= this.friction * Laya.timer.delta * 0.01;
                if (this.xzVel <= 0) {
                    this.vecForwardDir.x = 0;
                    this.vecForwardDir.z = 0;
                }
            } else {
                this.yVel -= this.gravity * Laya.timer.delta * 0.01;
            }
            let pos = this.tran.position;
            this.vecClamp.cloneTo(pos);
            pos.y = ret.y;
            this.tran.position = pos;
        }
    }
    DyanmicObjCtrl._tempV31 = new Vector3$8();
    DyanmicObjCtrl._tempV32 = new Vector3$8();
    DyanmicObjCtrl._tempV33 = new Vector3$8();
    DyanmicObjCtrl._tempV34 = new Vector3$8();
    DyanmicObjCtrl._tempV35 = new Vector3$8();
    DyanmicObjCtrl._tempM0 = new Matrix4x4$4();
    DyanmicObjCtrl._tempM1 = new Matrix4x4$4();
    DyanmicObjCtrl._boxBound1 = new BoundBox$4(new Vector3$8(), new Vector3$8());
    DyanmicObjCtrl._boxBound2 = new BoundBox$4(new Vector3$8(), new Vector3$8());
    DyanmicObjCtrl._ray1 = new Laya.Ray(new Laya.Vector3(), new Laya.Vector3(0, -1, 0));
    DyanmicObjCtrl._ray2 = new Laya.Ray(new Laya.Vector3(), new Laya.Vector3());
    DyanmicObjCtrl._ray3 = new Laya.Ray(new Laya.Vector3(), new Laya.Vector3());

    var Quaternion = Laya.Quaternion;
    var Vector3$9 = Laya.Vector3;
    var BULLET_STATE;
    (function(BULLET_STATE) {
        BULLET_STATE[BULLET_STATE["DIE"] = 0] = "DIE";
        BULLET_STATE[BULLET_STATE["LIVE"] = 1] = "LIVE";
    })(BULLET_STATE || (BULLET_STATE = {}));
    class BulletObj {
        clean() {
            this.tran.owner.destroy();
            this.vecDir = null;
            this.vecEnd = null;
            this.tran = null;
        }
    }
    class BulletManager {
        static shot(vecDir, vecStartPos, vecEndPos) {
            let bullet;
            for (let i = 0, len = this.bullet.length; i < len; i++) {
                let obj = this.bullet[i];
                if (obj.state == BULLET_STATE.DIE) {
                    bullet = obj;
                    break;
                }
            }
            if (!bullet) {
                let effect = ResourceManager.getRes(RES_PATH.EFFECT_PREFEB).getChildByName(OBJ_NAME.BULLET).clone();
                GameScene.scene3d.addChild(effect);
                bullet = new BulletObj();
                bullet.tran = effect.transform;
                bullet.vecDir = new Vector3$9();
                bullet.vecEnd = new Vector3$9();
                this.bullet.push(bullet);
            }
            bullet.state = BULLET_STATE.LIVE;
            vecDir.cloneTo(bullet.vecDir);
            vecEndPos.cloneTo(bullet.vecEnd);
            let pos = bullet.tran.position;
            pos.x = vecStartPos.x;
            pos.y = vecStartPos.y;
            pos.z = vecStartPos.z;
            bullet.tran.position = pos;
            let qua = bullet.tran.rotation;
            Quaternion.lookAt(CommonUtil.Vector3.zero, vecDir, CommonUtil.Vector3.up, qua);
            qua.invert(qua);
            bullet.tran.localRotation = qua;
        }
        static update() {
            for (let i = 0, len = BulletManager.bullet.length; i < len; i++) {
                let bullet = BulletManager.bullet[i];
                if (bullet.state == BULLET_STATE.LIVE) {
                    let pos = bullet.tran.position;
                    pos.x += bullet.vecDir.x * Laya.timer.delta * 0.1;
                    pos.y += bullet.vecDir.y * Laya.timer.delta * 0.1;
                    pos.z += bullet.vecDir.z * Laya.timer.delta * 0.1;
                    BulletManager.vecTmp1;
                    Vector3$9.subtract(bullet.vecEnd, pos, BulletManager.vecTmp1);
                    if (BulletManager.vecTmp1.x * bullet.vecDir.x < 0) {
                        bullet.state = BULLET_STATE.DIE;
                        pos.x = 0xffffff;
                        pos.y = 0xffffff;
                        pos.z = 0xffffff;
                    }
                    bullet.tran.position = pos;
                }
            }
        }
        static clean() {
            for (let k in this.bullet) {
                this.bullet[k].clean();
            }
            this.bullet = [];
        }
    }
    BulletManager.bullet = [];
    BulletManager.vecTmp1 = new Vector3$9();

    class CustomMaterial extends Laya.UnlitMaterial {
        constructor() {
            super();
            this.setShaderName("CustomShader");
        }
        get diffuseTexture() {
            return this._shaderValues.getTexture(CustomMaterial.DIFFUSETEXTURE);
        }
        set diffuseTexture(value) {
            this._shaderValues.setTexture(CustomMaterial.DIFFUSETEXTURE, value);
        }
        set marginalColor(value) {
            this._shaderValues.setVector3(CustomMaterial.MARGINALCOLOR, value);
        }
        set customColor(value) {
            this._shaderValues.setNumber(CustomMaterial.CUSTOMCOLOE, value);
        }
    }
    CustomMaterial.DIFFUSETEXTURE = Laya.Shader3D.propertyNameToID("u_texture");
    CustomMaterial.MARGINALCOLOR = Laya.Shader3D.propertyNameToID("u_marginalColor");
    CustomMaterial.CUSTOMCOLOE = Laya.Shader3D.propertyNameToID("u_custom_Color");

    class ProbUtil {
        static sum(key) {
            let obj = this.obj;
            let sum = 0;
            for (let i in obj) {
                sum += obj[i][key];
            }
            return sum;
        }
        static getResult(arr) {
            var leng = 0;
            for (var i = 0; i < arr.length; i++) {
                leng += arr[i];
            }
            for (var i = 0; i < arr.length; i++) {
                var random = Math.random() * leng;
                if (random < arr[i]) {
                    return i;
                } else {
                    leng -= arr[i];
                }
            }
        }
    }
    ProbUtil.obj = [];

    class BuoyCtrl extends ui.view.game.BuoyUI {
        constructor(tran, logicalBaseLayer) {
            super();
            this.perPos = new Laya.Vector4();
            this.tran = null;
            this.logicalBaseLayer = null;
            this.tempPos2D = new Laya.Vector3();
            this.vec2Tmp0 = new Laya.Vector2();
            this.vec2Tmp1 = new Laya.Vector2();
            this.tran = tran;
            this.logicalBaseLayer = logicalBaseLayer;
        }
        static create(tran, logicalBaseLayer) {
            let ins = new BuoyCtrl(tran, logicalBaseLayer);
            this.list.push(ins);
            return ins;
        }
        static clean() {
            BuoyCtrl.list = [];
        }
        setTagPos() {
            if (SceneManager.getCurScene().getViewportPoint(this.tran.position).w >= 0.1) {
                SceneManager.getCurScene().getViewportPoint(this.tran.position).cloneTo(this.perPos);
            }
            this.visible = false;
            this.vec2Tmp0.x = this.perPos.x - Laya.stage.width * 0.5;
            this.vec2Tmp0.y = this.perPos.y - Laya.stage.height * 0.5;
            if (this.perPos.y >= Laya.stage.height) {
                this.perPos.y = Laya.stage.height;
                this.visible = true;
                this.vec2Tmp1.x = 0;
                this.vec2Tmp1.y = 1;
            } else if (this.perPos.y <= 0) {
                this.perPos.y = 0;
                this.visible = true;
                this.vec2Tmp1.x = 0;
                this.vec2Tmp1.y = 1;
            }
            if (this.perPos.x < 0) {
                this.vec2Tmp1.x = 0;
                this.vec2Tmp1.y = -1;
                this.visible = true;
                this.perPos.x = -30;
            } else if (this.perPos.x >= Laya.stage.width - 50) {
                this.vec2Tmp1.x = 0;
                this.vec2Tmp1.y = -1;
                this.visible = true;
                this.perPos.x = Laya.stage.width - 30;
            }
            if (this.visible) {
                this.perPos.x = this.perPos.x <= Laya.stage.width - this.width + 30 ? this.perPos.x : Laya.stage.width - this.width + 30;
                this.perPos.y = this.perPos.y <= Laya.stage.height - this.height ? this.perPos.y : Laya.stage.height - this.height;
                if (Math.abs(this.buoy.rotation) > 100 && Math.abs(this.buoy.rotation) <= 180 && this.perPos.y == 0) {
                    this.perPos.y -= 70;
                }
                this.pos(this.perPos.x, this.perPos.y);
                if (this.perPos.x >= Laya.stage.width - this.width && this.y >= Laya.stage.height - this.height) {
                    this.buoy.rotation = -40;
                    return;
                }
                if (this.perPos.x <= 0 && this.y >= Laya.stage.height - this.height) {
                    this.buoy.rotation = 40;
                    return;
                }
                if (this.y < Laya.stage.height - this.height) {
                    let angle = CommonUtil.angle2(this.vec2Tmp1, this.vec2Tmp0);
                    this.buoy.rotation = -angle;
                } else {
                    let angle = CommonUtil.angle2(this.vec2Tmp1, this.vec2Tmp0);
                    this.buoy.rotation = -angle;
                }
            }
        }
    }
    BuoyCtrl.list = [];

    class DoubleKillItemCtrl extends ui.view.game.DoubleKillItemUI {
        constructor() {
            super();
            this.isStart = false;
            this.centerX = 0;
            this.bottom = 128;
        }
        onDestroy() {
            this.imgDouble = null;
            this.ani1 = null;
            this.ani2 = null;
            this.isStart = null;
        }
        onAwake() {
            this.ani2.on(Laya.Event.COMPLETE, this, () => {
                this.isStart = false;
            });
        }
        start(data) {
            this.ani1.play(0, false);
            this.update(data);
        }
        startBomb() {
            this.ani1.play(0, false);
            this.imgDouble.skin = 'sub1/ui/game/bomb_kill.png';
        }
        close() {
            if (this.isStart) {
                this.ani2.play(0, false);
            }
        }
        update(data) {
            this.imgDouble.skin = 'sub1/ui/game/Kill_Logo_' + data + '.png';
        }
    }

    class FntManager {
        static loadFont(path, txt, fontName = '') {
            var bitmapFont = new Laya.BitmapFont();
            bitmapFont.loadFont(path, new Laya.Handler(this, this.onFontLoaded, [bitmapFont, txt, fontName]));
            return bitmapFont;
        }
        static onFontLoaded(bitmapFont, txt, fontName) {
            bitmapFont.setSpaceWidth(10);
            Laya.Text.registerBitmapFont(fontName, bitmapFont);
            txt.wordWrap = true;
            txt.font = fontName;
        }
    }

    class FloatingbloodItemCtrl extends ui.view.game.FloatingbloodItemUI {
        constructor() {
            super();
            this.isPlaying = false;
            FntManager.loadFont(RES_PATH.FNT.FNT5, this.txtHit);
        }
        onAwake() {
            this.ani1.on(Laya.Event.COMPLETE, this, () => {
                this.isPlaying = false;
            });
        }
        onDestroy() {
            this.txtHit = null;
            this.ani1 = null;
        }
        play(num) {
            if (this.isPlaying)
                return;
            this.txtHit.text = num.toString();
            this.isPlaying = true;
            this.txtHit.x = -14.5;
            this.txtHit.y = 61;
            this.txtHit.alpha = 1;
            const x = this.txtHit.x;
            const y = this.txtHit.y;
            let rand = RandomUtil.onlyOneRandomIntOrFloat(0, 1) > 0.5 ? 50 : -50;
            Laya.Tween.to(this.txtHit, {
                x: x + 50,
                y: y - 15
            }, 150, null, Laya.Handler.create(this, () => {
                Laya.Tween.to(this.txtHit, {
                    y: y - 60,
                    alpha: 0
                }, 650, null, Laya.Handler.create(this, () => {
                    this.isPlaying = false;
                }), 100);
            }));
        }
    }

    class HeadshotCtrl extends ui.view.game.HeadshotUI {
        constructor() {
            super();
            this.isStart = false;
            this.centerX = 0;
            this.bottom = 128;
        }
        onAwake() {
            this.baotou.on(Laya.Event.COMPLETE, this, () => {
                this.isStart = false;
                this.visible = false;
            });
        }
        onDestroy() {
            this.baotou = null;
        }
        playAni() {
            this.visible = true;
            this.isStart = true;
            if (ConfigManager.platform == PLATFORM_TYPE.VIVO) {
                console.log('播放爆头音效:', SOUND_PATH.KILL_HEADSHOT);
                SoundManager.playEffect(SOUND_PATH.KILL_HEADSHOT);
            } else {
                console.log('播放爆头音效:', SOUND_PATH.KILL_HEADSHOT_ROOT + CharacterManger.playerLogicalBaseLayer.headShotHit.toString() + '.mp3');
                SoundManager.playEffect(SOUND_PATH.KILL_HEADSHOT_ROOT + CharacterManger.playerLogicalBaseLayer.headShotHit.toString() + '.mp3');
            }
            this.baotou.play(0, false);
        }
    }

    class InvincibleProCtrl extends ui.view.game.InvincibleProUI {
        constructor() {
            super();
            this.visible = false;
            this.centerX = 0;
            this.centerY = 80;
            this.imgPro.width = 0;
        }
        onAwake() {}
        onDestroy() {
            this.imgPro = null;
        }
        setPro(pro) {
            if (!this.visible)
                this.visible = true;
            this.imgPro.width = pro;
        }
        resetCtrl() {
            this.imgPro.width = 0;
            this.visible = false;
        }
    }

    class WaitingforrescueViewCtrl extends ui.view.game.WaitingforrescueViewUI {
        constructor() {
            super();
        }
    }

    var Vector3$a = Laya.Vector3;
    let BEARINGTYPE = {
        LEFT: 1,
        RIGHT: 2
    };
    let ROTATESTATE = {
        STATIC: 1,
        DYNAMIC: 2
    };
    let JUMPSTATE = {
        STATIC: 1,
        DYNAMIC: 2
    };
    let HITSTATE = {
        HIT: 1,
        EMPTY: 2
    };
    let HEADSHOTSTATE = {
        HIT: 1,
        EMPTY: 2
    };
    let RAY_COLLIDER_NAME = {
        BOX: 'boxRoot',
        BODY: 'boxBody',
        HEAD: 'boxHead',
        AIM: 'boxAim',
        FOOT: 'foot',
    };
    class PresentationBaseLayer {
        constructor(eventId, model, logicalBaseLayer) {
            this.model = null;
            this.aniCtrl = null;
            this.logicalBaseLayer = null;
            this.bombEffectPos = new Laya.Vector3();
            this.buoy = null;
            this.eventId = null;
            this.characterCtrl = null;
            this.point = new Laya.Vector2();
            this.myHitResult = new RayHitResult();
            this.perAttackTime = 0;
            this.lastPerAttackTime = 0;
            this.upperlimbName = null;
            this.thelegsName = null;
            this.attackAniAfterOtherAniCount = 0;
            this.isCanAttackAniAfterPlayOtherAni = false;
            this.baseData = {
                tempJump: new Vector3$a(0, 20, 0),
                startPos: new Vector3$a(),
                forwardDir: new Vector3$a(),
                forward: new Vector3$a(),
                crossRide: new Vector3$a(),
                forwardToAngle: new Vector3$a(),
                angleOut: new Vector3$a(),
                targetPos: new Vector3$a(),
                tempFace: new Vector3$a(),
                quaModel: new Laya.Quaternion(),
                curPos: new Laya.Vector3(),
                vecTmp: new Vector3$a()
            };
            this.fixedVector3Data = {
                startPos: new FixedVector3(),
                targetPos: new FixedVector3(),
                vecDir: new FixedVector3(),
                vecVel: new FixedVector3(),
                nextPos: new FixedVector3(),
                points: []
            };
            this.isCanShowHitUI = false;
            this.isCanShowHitScale = false;
            this.boxGhost = null;
            this.headshotCtrl = null;
            this.gamingHeadCtrl = null;
            this.invincibleProCtrl = null;
            this.invincibleProCount = 3000;
            this.invincibleProCountMax = 3000;
            this.isCanPlayAttackAni = false;
            this.isStartJump = false;
            this.isStartPlayAttackAni = false;
            this.attackDownCount = 1000;
            this._isCollise = false;
            this.fireRecycleCountDown = 50;
            this.vecShtoPos = new Laya.Vector3();
            this.vecShotEndPos = new Laya.Vector3();
            this.muzzleTran = null;
            this.flyUp = 0.2;
            this.flyDown = 0;
            this.isAIStartRandomRotate = false;
            this.rotateRange = 0;
            this.isStartDeviation = false;
            this.bearing = null;
            this.curAngle = 0;
            this.isStartMoveAttackRandom = false;
            this.moveAttackRandPosList = {
                curPos: new Laya.Vector3(),
                target1: new Laya.Vector3(),
                target2: new Laya.Vector3(),
                target1Finish: false,
                target2Finish: false,
                tempPos1: new Laya.Vector3(),
                tempPos2: new Laya.Vector3(),
                onceToType: 0,
                out1: new Laya.Vector3(),
                out2: new Laya.Vector3(),
                dis1: new Laya.Vector3(),
                dis2: new Laya.Vector3(),
                isCollideFinish1: false,
                isCollideFinish2: false,
                testCollideNum: 0
            };
            this.randRotateType = [ROTATESTATE.DYNAMIC, ROTATESTATE.STATIC];
            this.randRotateData = [1, 99];
            this.randJumpType = [JUMPSTATE.DYNAMIC, JUMPSTATE.STATIC];
            this.randJumpData = [0.01, 99.99];
            this.randHitType = [HITSTATE.HIT, HITSTATE.EMPTY];
            this.randHitData = [20, 80];
            this.randHeadshotType = [HEADSHOTSTATE.HIT, HEADSHOTSTATE.EMPTY];
            this.randHeadshotData = [10, 90];
            this.rhgt = new Laya.Vector3();
            this.cosValue = 0;
            this.lifeTran = null;
            this.lifeParentTran = null;
            this.spMarkTran = null;
            this.doubleKillItemCtrl = null;
            this.hitPoint1 = new Vector3$a();
            this.isTouchBomb = false;
            this.isThrowBomb = false;
            this.gravity = new Laya.Vector3(0, -50, 0);
            this.mass = 10;
            this.linearVelocity = new Laya.Vector3();
            this.throwTheArmCount = RandomUtil.onlyOneRandomInt(12000, 20000);
            this.floatingBloodList = [];
            this.waitingforrescueViewCtrl = null;
            this.waitingCount = 30000;
            this.isRescuing = false;
            this.rescuingCount = 30000;
            this.rescuingSp = null;
            this.isInterrupt = false;
            this.isBehit = false;
            this.hitPoint = new Vector3$a();
            this.playTimeTheLegs = 0;
            this.isCanQH = true;
            this.isStartQH = false;
            this.enemy = null;
            this.temVec4 = new Laya.Vector4();
            this.albedoColor1 = new Laya.Vector4(0.9905, 0.0887, 0.0887, 1);
            this.albedoColor2 = new Laya.Vector4(1, 1, 1, 1);
            this.lastPoint = new Laya.Vector3();
            this.isThrowing = false;
            this.isShowBulletInsufficient = false;
            this.separation = null;
            this.separationAniCtrl = null;
            this.spriteHole = null;
            this.isJump = false;
            this.isFootSound = false;
            this.footSoundIndex = 0;
            this.outs = [];
            this.cubeList = [];
            this.shieldSp = null;
            this.isFist = true;
            this.tst = false;
            this.lineSprite1 = null;
            this.lineSprite2 = null;
            this.mySecondHitResult = new RayHitResult();
            this.vecTarget = new Vector3$a();
            this.temVec = new Vector3$a();
            this.bomblist = [];
            this.eventId = eventId;
            this.model = model;
            this.logicalBaseLayer = logicalBaseLayer;
            this.getAniCtrl();
            this.registerEvent();
            this.registerCharacterCtrl();
            this.createRay();
            this.setAttackDownCount();
            this.initNavNode();
            this.initRotate();
            this.addLifeTran();
            this.model.transform.localRotationEuler.cloneTo(this.logicalBaseLayer.eulerAngle);
            let data = AIData.getDataByKey(DifficultyManager.curDifficult ? DifficultyManager.curDifficult : DIFFICULTY_TYPE.NORMAL);
            let angle = 0;
            if (this.logicalBaseLayer.getRoleType() == ROLE_TYPE.TYPE_0) {
                angle = data.teamCheckAngle;
            } else {
                angle = data.enemyCheckAngle;
            }
            this.cosValue = Math.cos(180 * Math.PI / angle);
            Laya.timer.loop(1, this, this.update);
            this.logicalBaseLayer.eulerAngle.y = this.getOnceChild().transform.localRotationEulerY;
            if (this.logicalBaseLayer.isZombie) {
                this.perAttackTime = 3800;
            }
            this.startGameCtrl();
            this.spriteHole = CommonUtil.findChildByName(this.model, 'halo');
            if (this.spriteHole) {
                this.spriteHole.active = true;
                this.spriteHole.transform.localPositionY = 0.02;
            }
            if (ConfigManager.platform != PLATFORM_TYPE.NATIVE_ANDRIOD && ConfigManager.platform != PLATFORM_TYPE.NATIVE_IOS && PlatformUtil.isIOS()) {
                this.aniCtrl.updateMode = Laya.AnimatorUpdateMode.LowFrame;
                if (this.separationAniCtrl)
                    this.separationAniCtrl.updateMode = Laya.AnimatorUpdateMode.LowFrame;
                this.setAnimatorDelay(2);
            } else {}
            let node = CommonUtil.findChildByName(this.model, 'Helmet');
            if (node) {
                if (this.logicalBaseLayer.getIsMySelf()) {
                    node.active = false;
                }
            }
            if (!this.logicalBaseLayer.isZombie) {
                if (this.logicalBaseLayer.getRoleType() == ROLE_TYPE.TYPE_1) {
                    let node = CommonUtil.findChildByName(this.model, 'jiaobiao');
                    node.active = true;
                    this.spMarkTran = node.transform;
                }
            }
            if (!this.logicalBaseLayer.getIsMySelf()) {
                this.model.transform.localScale = new Laya.Vector3(1.14, 1.14, 1.14);
            }
            this.initRayCollider();
            if (!SceneManager.getCurScene().isShowUnder) {
                if (this.logicalBaseLayer.getIsMySelf()) {
                    this.model.getChildAt(0).transform.localRotationEuler = new Laya.Vector3(0, -180, 0);
                    this.logicalBaseLayer.eulerAngle.y = this.getOnceChild().transform.localRotationEulerY;
                }
            }
        }
        getSeparation() {
            if (!ConfigManager.isRefinedVersion)
                return;
            if (this.logicalBaseLayer.isZombie)
                return;
            this.separation = CommonUtil.findChildByName(this.model, 'wudi');
            if (this.separation)
                this.separation.active = false;
            console.log('分身：', this.separation);
            this.getSeparationAniCtrl();
        }
        activeSeparation(isActive) {
            if (this.logicalBaseLayer.isZombie)
                return;
            if (!ConfigManager.isRefinedVersion)
                return;
            if (this.separation)
                this.separation.active = isActive;
        }
        setShader() {
            if (ConfigManager.isRefinedVersion)
                return;
            if (this.logicalBaseLayer.isZombie)
                return;
            this.logicalBaseLayer.initShader();
            let npc_body = CommonUtil.findChildByName(this.model, 'npc_body');
            let npc_head = CommonUtil.findChildByName(this.model, 'npc_head');
            if (npc_body) {
                let tex1 = npc_body.skinnedMeshRenderer.sharedMaterial.albedoTexture;
                var customMaterial1 = new CustomMaterial();
                customMaterial1.diffuseTexture = tex1;
                npc_body.skinnedMeshRenderer.sharedMaterial = customMaterial1;
            }
            if (npc_head) {
                let tex2 = npc_head.skinnedMeshRenderer.sharedMaterial.albedoTexture;
                var customMaterial2 = new CustomMaterial();
                customMaterial2.diffuseTexture = tex2;
                npc_head.skinnedMeshRenderer.sharedMaterial = customMaterial2;
            }
        }
        setCustomColor(num = 0) {
            if (ConfigManager.isRefinedVersion)
                return;
            if (this.logicalBaseLayer.isZombie)
                return;
            let npc_body = CommonUtil.findChildByName(this.model, 'npc_body');
            let npc_head = CommonUtil.findChildByName(this.model, 'npc_head');
            if (npc_body) {
                npc_body.skinnedMeshRenderer.sharedMaterial.customColor = num;
            }
            if (npc_head) {
                npc_head.skinnedMeshRenderer.sharedMaterial.customColor = num;
            }
        }
        startGameCtrl() {
            if (ModeManager.mode == GAME_MODE_TYPE.ONEVSONEMODE) {
                const y = this.model.getChildAt(0).transform.localPositionY;
                this.model.getChildAt(0).transform.localPositionY += 3;
                Laya.Tween.to(this.model.getChildAt(0).transform, {
                    localPositionY: y
                }, 150, null, Laya.Handler.create(this, () => {}), 300);
            }
        }
        addLifeTran() {
            if (!this.logicalBaseLayer.isZombie)
                return;
            this.lifeTran = CommonUtil.findChildByName(this.model, 'life').getChildByName('03').transform;
            this.lifeParentTran = CommonUtil.findChildByName(this.model, 'life').transform;
            this.lifeParentTran.localPositionY -= 1;
        }
        scaleLifeTran() {
            if (this.lifeTran) {
                let curHp = this.logicalBaseLayer.getHP();
                let scale = 0;
                if (curHp > 0) {
                    scale = Math.floor(curHp / this.logicalBaseLayer.getMaxHP() * 100) / 100;
                }
                if (scale != this.lifeTran.localScaleX) {
                    this.lifeTran.localScaleX = scale;
                }
            }
        }
        initRotate() {}
        registerEvent() {
            NotifyManager.register(NOTIFY_ID.PLAY_UPPER_LIMB_ANI + this.eventId, this.playUpperlimbAni, this);
            NotifyManager.register(NOTIFY_ID.PLAY_THE_LEGS_ANI + this.eventId, this.playThelegsAni, this);
            NotifyManager.register(NOTIFY_ID.PLAY_EFFECT + this.eventId, this.playEffect, this);
            NotifyManager.register(NOTIFY_ID.PLAY_SOUND + this.eventId, this.playSound, this);
        }
        unregisterEvent() {
            NotifyManager.unregisterByEventId(NOTIFY_ID.PLAY_UPPER_LIMB_ANI + this.eventId);
            NotifyManager.unregisterByEventId(NOTIFY_ID.PLAY_THE_LEGS_ANI + this.eventId);
            NotifyManager.unregisterByEventId(NOTIFY_ID.PLAY_EFFECT + this.eventId);
            NotifyManager.unregisterByEventId(NOTIFY_ID.PLAY_SOUND + this.eventId);
        }
        getFireEffect() {
            return this.fireEffect;
        }
        cleanFireEffect() {
            this.fireEffect = null;
        }
        initNavNode() {
            this.navNode = MapManager.pathfinder.getClosestNode(this.getModelPosByFixedVector(), MapManager.zoneID, MapManager.navGroup, true);
        }
        setAttackDownCount() {
            this.attackDownCount = 1200;
        }
        createInvincibleProCtrl() {
            if (this.logicalBaseLayer.getIsMySelf()) {
                console.log('创建进度条');
                this.invincibleProCtrl = new InvincibleProCtrl();
                UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).addChild(this.invincibleProCtrl);
            }
        }
        createRay() {
            this._ray = new Laya.Ray(new Laya.Vector3(0, 0, 0), new Laya.Vector3(0, 0, 0));
            this.point.x = Laya.stage.width / 2;
            this.point.y = Laya.stage.height / 2;
            this._ray2 = new Laya.Ray(new Laya.Vector3(0, 0, 0), new Laya.Vector3(0, 0, 0));
        }
        setPos(pos) {
            if (this.logicalBaseLayer.getIsMySelf()) {
                if (!SceneManager.getCurScene().isShowUnder) {
                    if (this.logicalBaseLayer.getIsMySelf()) {
                        this.model.getChildAt(0).transform.localRotationEuler = new Laya.Vector3(0, -180, 0);
                        this.logicalBaseLayer.eulerAngle.y = this.getOnceChild().transform.localRotationEulerY;
                    }
                } else {
                    this.model.getChildAt(0).transform.localRotationEuler = new Laya.Vector3(0, 0, 0);
                    this.logicalBaseLayer.eulerAngle.y = this.getOnceChild().transform.localRotationEulerY;
                }
                if (CharacterManger.playerBeHitImg) {
                    CharacterManger.playerBeHitImg.visible = false;
                }
                this.characterCtrl.resetPos(pos);
            } else {
                this.model.transform.position = pos;
            }
            this.logicalBaseLayer.attackLogicalBaseLayer = null;
            this.resetFowardVel();
            this.initNavNode();
            if (ModeManager.mode == GAME_MODE_TYPE.ONEVSONEMODE) {
                const y = this.model.getChildAt(0).transform.localPositionY;
                this.model.getChildAt(0).transform.localPositionY += 3;
                Laya.Tween.to(this.model.getChildAt(0).transform, {
                    localPositionY: y
                }, 150, null, Laya.Handler.create(this, () => {}));
            } else if (ModeManager.mode == GAME_MODE_TYPE.BIOCHEMISTRY) {
                this.waitingCount = 30000;
                if (this.lifeParentTran) {
                    if (!this.lifeParentTran.owner.active) {
                        this.lifeParentTran.owner.active = true;
                    }
                }
            }
        }
        rayCtrl(direction, origin) {
            this._ray.direction = direction;
            this._ray.origin;
        }
        getModelPosByFixedVector() {
            this.model.transform.position.cloneTo(this.fixedVector3Data.startPos);
            return this.fixedVector3Data.startPos;
        }
        getModelPosByVector3() {
            this.model.transform.position.cloneTo(this.baseData.startPos);
            return this.baseData.startPos;
        }
        radiographicTesting() {
            if (!this.logicalBaseLayer.getArmCtrl()) {
                return;
            }
            if (this.isTouchBomb) {
                return;
            }
            if (this.logicalBaseLayer.isStartAttack) {
                return;
            }
            GameScene.camera.viewportPointToRay(this.point, this._ray);
            if (this.logicalBaseLayer.getArmCtrl().getType() == 3) {
                let fac = RandomUtil.onlyOneRandomIntOrFloat(0, 1);
                if (fac > 0.2) {
                    this.getIntersectsRayAndEnemyExact(this._ray, this.myHitResult, false);
                } else {
                    this.getIntersectsRayAndEnemyExact(this._ray, this.myHitResult);
                }
            } else {
                this.getIntersectsRayAndEnemyExact(this._ray, this.myHitResult);
            }
            if (this.logicalBaseLayer.getArmCtrl().getType() != 2 && GameScene.handleType != HANDLETYPE.ONLYMOVE && GameScene.handleType != null) {
                let empty = ModeManager.mode == GAME_MODE_TYPE.BIOCHEMISTRY ? this.getIntersectsRayAndEnemy(this._ray, true) : this.getIntersectsRayAndEnemyAim(this._ray, true);
                if (empty && !empty.getIsDie()) {
                    GameScene.camera.worldToViewportPoint(empty.getModelPosByVector3(), this.temVec4);
                    this.point.x = this.temVec4.x;
                    GameScene.camera.viewportPointToRay(this.point, this._ray);
                    let dis = Vector3$a.distance(empty.getModelPosByVector3(), this.getModelPosByVector3());
                    if (this.isCollidingsRayAndWall(this._ray, dis)) {
                        this.enemy = null;
                    } else
                        this.enemy = empty;
                    this.point.x = Laya.stage.width / 2;
                } else {
                    this.enemy = null;
                }
            } else {
                this.enemy = null;
            }
            CharacterManger.hitLocation = '';
            if (this.myHitResult.succeeded) {
                let owner = this.myHitResult.collider.owner;
                if (owner.name == RAY_COLLIDER_NAME.BODY || owner.name == RAY_COLLIDER_NAME.HEAD) {
                    if (owner.name == RAY_COLLIDER_NAME.BODY) {
                        CharacterManger.getTargetLogic({
                            ID: (owner).parent.parent.id
                        });
                        CharacterManger.hitLocation = HITLOCATION.BODY;
                    } else if (owner.name == RAY_COLLIDER_NAME.HEAD) {
                        CharacterManger.hitLocation = HITLOCATION.HEAD;
                        CharacterManger.getTargetLogic({
                            ID: (owner).parent.parent.id
                        });
                    }
                    if (CharacterManger.targetLogicalBaseLayer && CharacterManger.targetLogicalBaseLayer.getIsDie()) {
                        if (this.logicalBaseLayer.getIsTouchAttack()) {} else {
                            this.logicalBaseLayer.setIsAttack = false;
                        }
                    } else {
                        if (!this.logicalBaseLayer.getIsTouchAttack()) {
                            if (CharacterManger.targetLogicalBaseLayer) {
                                if (CharacterManger.targetLogicalBaseLayer.getRoleType() == ROLE_TYPE.TYPE_0) {
                                    this.logicalBaseLayer.setIsAttack = false;
                                    return;
                                }
                                if (!this.logicalBaseLayer.isAutoAttack) {
                                    this.logicalBaseLayer.setIsAttack = false;
                                    return;
                                }
                            }
                        }
                        if (this.logicalBaseLayer.getArmCtrl().getType() != 3) {
                            if (this.logicalBaseLayer.getArmCtrl().getType() != 2) {
                                this.logicalBaseLayer.setIsAttack = true;
                            } else {
                                if (this.sectorDetectionByKnifeWar(CharacterManger.targetLogicalBaseLayer)) {
                                    this.logicalBaseLayer.setIsAttack = true;
                                }
                            }
                        }
                    }
                } else {
                    if (this.logicalBaseLayer.getArmCtrl()) {
                        if (this.logicalBaseLayer.getArmCtrl().getType() != 2) {
                            if (this.logicalBaseLayer.getIsMySelf()) {
                                CharacterManger.targetLogicalBaseLayer = null;
                            }
                        }
                    } else {
                        if (this.logicalBaseLayer.getIsMySelf()) {
                            CharacterManger.targetLogicalBaseLayer = null;
                        }
                    }
                    if (!this.logicalBaseLayer.getIsTouchAttack()) {
                        this.logicalBaseLayer.setIsAttack = false;
                    }
                }
            } else {
                if (this.logicalBaseLayer.getArmCtrl()) {
                    if (this.logicalBaseLayer.getArmCtrl().getType() != 2) {
                        if (this.logicalBaseLayer.getIsMySelf()) {
                            CharacterManger.targetLogicalBaseLayer = null;
                        }
                    }
                } else {
                    if (this.logicalBaseLayer.getIsMySelf()) {
                        CharacterManger.targetLogicalBaseLayer = null;
                    }
                }
                if (!this.logicalBaseLayer.getIsTouchAttack()) {
                    this.logicalBaseLayer.setIsAttack = false;
                }
            }
        }
        set setPerAttackTime(perAttackTime) {
            this.perAttackTime = perAttackTime;
        }
        manualAmmunitionChange(start, finish) {
            if (!this.logicalBaseLayer.getArmCtrl())
                return;
            if (this.logicalBaseLayer.getIsDie())
                return;
            if (this.logicalBaseLayer.magazineBullet == this.logicalBaseLayer.getArmCtrl().getMagazineBullet())
                return;
            if (!this.logicalBaseLayer.isStartHuaBullet) {
                if (this.logicalBaseLayer.bullets != 0) {
                    this.logicalBaseLayer.isStartHuaBullet = true;
                    if (this.logicalBaseLayer.getIsMySelf()) {
                        NotifyManager.notify(NOTIFY_ID.PLAY_SOUND + this.eventId, {
                            url: this.logicalBaseLayer.getArmCtrl().getReloadsound(),
                            sound: 1
                        });
                    }
                    start();
                    var that = this;
                    Laya.timer.once(this.logicalBaseLayer.getArmCtrl().getBulletChangeTimer(), this, function cd() {
                        if (!this.logicalBaseLayer.getArmCtrl()) {
                            Laya.timer.clear(this, cd);
                            return;
                        }
                        if (this.logicalBaseLayer.bullets >= this.logicalBaseLayer.getArmCtrl().getMagazineBullet()) {
                            this.logicalBaseLayer.bullets -= this.logicalBaseLayer.getArmCtrl().getMagazineBullet() - this.logicalBaseLayer.magazineBullet;
                            this.logicalBaseLayer.getArmCtrl().curBullets = this.logicalBaseLayer.bullets;
                            this.logicalBaseLayer.magazineBullet = this.logicalBaseLayer.getArmCtrl().getMagazineBullet();
                            this.logicalBaseLayer.getArmCtrl().curMagazineBullet = this.logicalBaseLayer.getArmCtrl().getMagazineBullet();
                        } else {
                            this.logicalBaseLayer.magazineBullet += this.logicalBaseLayer.bullets;
                            this.logicalBaseLayer.getArmCtrl().curMagazineBullet += this.logicalBaseLayer.bullets;
                            this.logicalBaseLayer.bullets = 0;
                            this.logicalBaseLayer.getArmCtrl().curBullets = this.logicalBaseLayer.bullets;
                        }
                        this.logicalBaseLayer.isStartHuaBullet = false;
                        finish();
                        if (that.logicalBaseLayer.getIsMySelf())
                            NotifyManager.notify(NOTIFY_ID.REFRESH_MAIN_ARM);
                        Laya.timer.clear(this, cd);
                    });
                }
                return;
            }
        }
        idleCtrl() {
            if (this.logicalBaseLayer.isStartHuaBullet)
                return;
            if (this.logicalBaseLayer.getIsMoving()) {
                if (this.isStartMoveAttackRandom) {
                    if (this.logicalBaseLayer.isZombie) {
                        NotifyManager.notify(NOTIFY_ID.PLAY_THE_LEGS_ANI + this.eventId, {
                            name: PLAY_ANI.RUN
                        });
                    } else {
                        if (!this.moveAttackRandPosList.target1Finish && !this.moveAttackRandPosList.target2Finish) {
                            NotifyManager.notify(NOTIFY_ID.PLAY_THE_LEGS_ANI + this.eventId, {
                                name: PLAY_ANI.RUN_LEFT
                            });
                        } else if (this.moveAttackRandPosList.target1Finish && !this.moveAttackRandPosList.target2Finish) {
                            NotifyManager.notify(NOTIFY_ID.PLAY_THE_LEGS_ANI + this.eventId, {
                                name: PLAY_ANI.RUN_RIGHT
                            });
                        }
                    }
                } else {
                    NotifyManager.notify(NOTIFY_ID.PLAY_THE_LEGS_ANI + this.eventId, {
                        name: PLAY_ANI.RUN
                    });
                }
                return;
            }
            NotifyManager.notify(NOTIFY_ID.PLAY_UPPER_LIMB_ANI + this.eventId, {
                name: PLAY_ANI.IDLE
            });
        }
        setRecoilForce() {
            Laya.Tween.clearAll(this.model.transform);
            if (this.logicalBaseLayer.getArmCtrl().getType() == 3 || this.logicalBaseLayer.getArmCtrl().getType() == 7) {
                let list = this.logicalBaseLayer.getArmCtrl().getRecoilForce();
                let numX = RandomUtil.onlyOneRandomIntOrFloat(0, 1);
                if (numX > 0.5) {
                    list[0] *= -1;
                }
                let numY = RandomUtil.onlyOneRandomIntOrFloat(0, 1);
                if (numY > 0.5) {
                    list[1] *= -1;
                }
                GameScene.camera.transform.localRotationEulerX = SceneManager.getCurScene().camreaData.rot.x;
                GameScene.camera.transform.localRotationEulerY = SceneManager.getCurScene().camreaData.rot.y;
                GameScene.camera.transform.localPositionZ = SceneManager.getCurScene().camreaData.pos.z;
                const x = GameScene.camera.transform.localRotationEulerX;
                const y = GameScene.camera.transform.localRotationEulerY;
                Laya.Tween.to(GameScene.camera.transform, {
                    localRotationEulerX: x + list[0],
                    localRotationEulerY: y + list[1]
                }, 20, null, Laya.Handler.create(this, () => {
                    Laya.Tween.to(GameScene.camera.transform, {
                        localRotationEulerX: x,
                        localRotationEulerY: y
                    }, 400, null, Laya.Handler.create(this, () => {
                        Laya.Tween.clearAll(GameScene.camera.transform);
                    }));
                }));
            } else {
                let list = this.logicalBaseLayer.getArmCtrl().getRecoilForce();
                GameScene.camera.transform.localRotationEulerX = SceneManager.getCurScene().camreaData.rot.x;
                GameScene.camera.transform.localRotationEulerY = SceneManager.getCurScene().camreaData.rot.y;
                GameScene.camera.transform.localPositionZ = SceneManager.getCurScene().camreaData.pos.z;
                Laya.Tween.to(GameScene.camera.transform, {
                    localPositionZ: SceneManager.getCurScene().camreaData.pos.z + 0.1
                }, 30, null, Laya.Handler.create(this, () => {
                    Laya.Tween.to(GameScene.camera.transform, {
                        localPositionZ: SceneManager.getCurScene().camreaData.pos.z
                    }, 200, null, Laya.Handler.create(this, () => {
                        Laya.Tween.clearAll(GameScene.camera.transform);
                    }));
                }));
            }
        }
        attack(hitRide = 0, target = null, burstHeadRate = 0) {
            if (!this.model)
                return;
            if (this.logicalBaseLayer.isSwitching)
                return;
            if (CharacterManger.gameOver)
                return;
            if (this.logicalBaseLayer.isZombie) {
                this.attackFromZomBie(hitRide, target, burstHeadRate);
            } else {
                this.attackFromHuman(hitRide, target, burstHeadRate);
            }
        }
        attackFromZomBie(hitRide = 0, target = null, burstHeadRate = 0) {
            if (this.logicalBaseLayer.getIsDie())
                return;
            if (this.logicalBaseLayer.getIsAttack()) {
                this.toAttack(hitRide, target, burstHeadRate);
                if (this.isCanAttackAniAfterPlayOtherAni) {
                    if (!this.logicalBaseLayer.isZombie) {
                        this.idleCtrl();
                    }
                }
            }
            if (!this.logicalBaseLayer.isStartAttack) {
                if (this.perAttackTime != (this.logicalBaseLayer.getArmCtrl() ? this.logicalBaseLayer.getArmCtrl().getInterval() : 3800)) {
                    this.perAttackTime = this.logicalBaseLayer.getArmCtrl() ? this.logicalBaseLayer.getArmCtrl().getInterval() : 3800;
                    this.isCanAttackAniAfterPlayOtherAni = true;
                }
            } else {
                this.perAttackTime -= LogicTimer.gSysTimer.delta;
                this.attackAniAfterOtherAniCount -= LogicTimer.gSysTimer.delta;
                if (this.attackAniAfterOtherAniCount < 0) {
                    if (!this.isCanAttackAniAfterPlayOtherAni) {
                        this.isCanAttackAniAfterPlayOtherAni = true;
                    }
                }
                if (this.perAttackTime < 0) {
                    this.perAttackTime = this.logicalBaseLayer.getArmCtrl() ? this.logicalBaseLayer.getArmCtrl().getInterval() : 3800;
                    this.logicalBaseLayer.isStartAttack = false;
                }
            }
        }
        attackFromHuman(hitRide = 0, target = null, burstHeadRate = 0) {
            if (!this.logicalBaseLayer.getArmCtrl())
                return;
            this.isCanShowHitScale = false;
            if (!this.logicalBaseLayer.getIsAttack()) {
                this.isCanShowHitUI = false;
            } else {
                this.isCanPlayAttackAni = false;
            }
            if (this.isTouchBomb)
                return;
            if (this.logicalBaseLayer.getIsDie())
                return;
            if (this.logicalBaseLayer.magazineBullet != 0 || this.logicalBaseLayer.bullets != 0) {
                this.isShowBulletInsufficient = false;
            }
            if (this.logicalBaseLayer.getIsMySelf()) {
                if (this.logicalBaseLayer.magazineBullet == 0 && this.logicalBaseLayer.bullets == 0)
                    if (!this.isShowBulletInsufficient) {
                        this.isShowBulletInsufficient = true;
                        LogManager.showNotification("子弹不足");
                    }
            }
            if (!this.logicalBaseLayer.isStartHuaBullet) {
                if (this.logicalBaseLayer.magazineBullet == 0) {
                    if (this.logicalBaseLayer.bullets != 0) {
                        this.logicalBaseLayer.isStartHuaBullet = true;
                        if (this.logicalBaseLayer.getIsMySelf()) {
                            this.playSound({
                                url: this.logicalBaseLayer.getArmCtrl().getReloadsound(),
                                sound: null
                            });
                        }
                        var that = this;
                        Laya.timer.once(this.logicalBaseLayer.getArmCtrl().getBulletChangeTimer(), this, function cd() {
                            if (!this.logicalBaseLayer.getArmCtrl()) {
                                Laya.timer.clear(this, cd);
                                return;
                            }
                            if (this.logicalBaseLayer.bullets >= this.logicalBaseLayer.getArmCtrl().getMagazineBullet()) {
                                this.logicalBaseLayer.bullets -= this.logicalBaseLayer.getArmCtrl().getMagazineBullet() - this.logicalBaseLayer.magazineBullet;
                                this.logicalBaseLayer.getArmCtrl().curBullets = this.logicalBaseLayer.bullets;
                                this.logicalBaseLayer.magazineBullet = this.logicalBaseLayer.getArmCtrl().getMagazineBullet();
                                this.logicalBaseLayer.getArmCtrl().curMagazineBullet = this.logicalBaseLayer.getArmCtrl().getMagazineBullet();
                            } else {
                                this.logicalBaseLayer.magazineBullet += this.logicalBaseLayer.bullets;
                                this.logicalBaseLayer.getArmCtrl().curMagazineBullet += this.logicalBaseLayer.bullets;
                                this.logicalBaseLayer.bullets = 0;
                                this.logicalBaseLayer.getArmCtrl().curBullets = this.logicalBaseLayer.bullets;
                            }
                            this.logicalBaseLayer.isStartHuaBullet = false;
                            if (that.logicalBaseLayer.getIsMySelf())
                                NotifyManager.notify(NOTIFY_ID.REFRESH_MAIN_ARM);
                        });
                    }
                    return;
                }
            }
            if (this.logicalBaseLayer.isStartHuaBullet)
                return;
            if (this.logicalBaseLayer.getIsAttack()) {
                this.toAttack(hitRide, target, burstHeadRate);
                if (this.isCanAttackAniAfterPlayOtherAni) {
                    this.idleCtrl();
                }
            }
            if (!this.logicalBaseLayer.isStartAttack) {
                if (this.perAttackTime != (this.logicalBaseLayer.getArmCtrl() ? this.logicalBaseLayer.getArmCtrl().getInterval() : 2000)) {
                    this.perAttackTime = this.logicalBaseLayer.getArmCtrl() ? this.logicalBaseLayer.getArmCtrl().getInterval() : 2000;
                    this.isCanAttackAniAfterPlayOtherAni = true;
                }
            } else {
                this.perAttackTime -= LogicTimer.gSysTimer.delta;
                this.attackAniAfterOtherAniCount -= LogicTimer.gSysTimer.delta;
                if (this.attackAniAfterOtherAniCount < 0) {
                    if (!this.isCanAttackAniAfterPlayOtherAni) {
                        this.isCanAttackAniAfterPlayOtherAni = true;
                    }
                }
                if (this.perAttackTime < 0) {
                    this.perAttackTime = this.logicalBaseLayer.getArmCtrl() ? this.logicalBaseLayer.getArmCtrl().getInterval() : 2000;
                    this.logicalBaseLayer.isStartAttack = false;
                }
            }
        }
        toAttack(hitRide = 0, target = null, burstHeadRate = 0) {
            if (!this.logicalBaseLayer.isStartAttack) {
                this.logicalBaseLayer.isStartAttack = true;
                let fac = 50;
                if (!this.logicalBaseLayer.isZombie) {
                    if (this.logicalBaseLayer.getArmCtrl().getType() == 3 || this.logicalBaseLayer.getArmCtrl().getType() == 7) {
                        fac = 1000;
                    } else if (this.logicalBaseLayer.getArmCtrl().getType() == 1 || this.logicalBaseLayer.getArmCtrl().getType() == 5 || this.logicalBaseLayer.getArmCtrl().getType() == 6) {
                        fac = 50;
                    } else if (this.logicalBaseLayer.getArmCtrl().getType() == 2) {
                        fac = 200;
                    }
                } else {
                    fac = 2000;
                }
                this.attackAniAfterOtherAniCount = this.logicalBaseLayer.getArmCtrl() ? this.logicalBaseLayer.getArmCtrl().getInterval() - fac : 2000;
                this.isCanAttackAniAfterPlayOtherAni = false;
                this.isCanShowHitScale = true;
                if (!this.logicalBaseLayer.isZombie) {
                    if (this.logicalBaseLayer.getArmCtrl().getType() != 2) {
                        this.getOnceChild().transform.getForward(this.baseData.forwardDir);
                        Vector3$a.scale(this.baseData.forwardDir, -1, this.baseData.forwardDir);
                        if (!this.muzzleTran) {
                            let kou = CommonUtil.findChildByName(this.model, 'kou');
                            this.muzzleTran = kou.transform;
                        }
                        this.muzzleTran.position.cloneTo(this.vecShtoPos);
                        this.vecShotEndPos.x = this.vecShtoPos.x + this.baseData.forwardDir.x * 100;
                        this.vecShotEndPos.y = this.vecShtoPos.y + this.baseData.forwardDir.y * 100;
                        this.vecShotEndPos.z = this.vecShtoPos.z + this.baseData.forwardDir.z * 100;
                        if (!PerformanceManager.isCloseEffect) {
                            if (Laya.Vector3.equals(this.lastPoint, this.hitPoint)) {
                                BulletManager.shot(this.baseData.forwardDir, this.vecShtoPos, this.lastPoint);
                            } else {
                                this._ray2.origin = this.vecShtoPos;
                                this._ray2.direction = this.baseData.forwardDir;
                                this.isCollidingsRayAndWall(this._ray2, 100);
                                this.lastPoint.x = this.hitPoint.x;
                                this.lastPoint.y = this.hitPoint.y;
                                this.lastPoint.z = this.hitPoint.z;
                                BulletManager.shot(this.baseData.forwardDir, this.vecShtoPos, this.lastPoint);
                            }
                        }
                    }
                }
                NotifyManager.notify(NOTIFY_ID.PLAY_UPPER_LIMB_ANI + this.eventId, {
                    name: PLAY_ANI.ATTACK
                });
                if (!this.logicalBaseLayer.isZombie) {
                    if ((ConfigManager.platform == PLATFORM_TYPE.TT || ConfigManager.platform == PLATFORM_TYPE.WX || ConfigManager.platform == PLATFORM_TYPE.QQ) && PlatformUtil.isIOS()) {
                        this.playSound({
                            url: this.logicalBaseLayer.getArmCtrl().getAttackSound(),
                            sound: 0.5
                        });
                    } else {
                        this.playSound({
                            url: this.logicalBaseLayer.getArmCtrl().getAttackSound(),
                            sound: 0.5
                        });
                    }
                }
                if (!this.logicalBaseLayer.isZombie) {
                    if (this.logicalBaseLayer.getIsMySelf()) {
                        if (this.logicalBaseLayer.getArmCtrl().getType() == 2) {
                            let that = this;
                            Laya.timer.once(200, this, function cd() {
                                if (!that.model)
                                    return;
                                if (that.sectorDetectionByKnifeWar(CharacterManger.targetLogicalBaseLayer)) {
                                    this.setRecoilForce();
                                    this.perAttackTime = this.logicalBaseLayer.getArmCtrl().getInterval();
                                    this.sendEffectNotify(false);
                                    SoundManager.vibrateShort();
                                    if (CharacterManger.targetLogicalBaseLayer && CharacterManger.targetLogicalBaseLayer.getRoleType() == ROLE_TYPE.TYPE_0)
                                        return;
                                    if (CharacterManger.targetLogicalBaseLayer && CharacterManger.targetLogicalBaseLayer.isInvincible)
                                        return;
                                    this.isCanShowHitUI = true;
                                    CharacterManger.hit({
                                        isMySelf: true,
                                        hit: this.logicalBaseLayer.getArmCtrl().getHit()
                                    });
                                }
                                Laya.timer.clear(this, cd);
                            });
                        }
                        if (this.myHitResult.succeeded) {
                            let owner = this.myHitResult.collider.owner;
                            if (owner.name == RAY_COLLIDER_NAME.BODY || owner.name == RAY_COLLIDER_NAME.HEAD) {
                                if (this.logicalBaseLayer.getArmCtrl().getType() == 2) {} else {
                                    this.setRecoilForce();
                                    this.perAttackTime = this.logicalBaseLayer.getArmCtrl().getInterval();
                                    this.sendEffectNotify(false);
                                    SoundManager.vibrateShort();
                                    if (CharacterManger.targetLogicalBaseLayer && CharacterManger.targetLogicalBaseLayer.getRoleType() == ROLE_TYPE.TYPE_0)
                                        return;
                                    if (CharacterManger.targetLogicalBaseLayer && CharacterManger.targetLogicalBaseLayer.isInvincible)
                                        return;
                                    this.isCanShowHitUI = true;
                                    let hit = this.logicalBaseLayer.getArmCtrl().getHit();
                                    if (CharacterManger.hitLocation == HITLOCATION.HEAD) {
                                        hit = this.logicalBaseLayer.getArmCtrl().headHit;
                                    } else if (CharacterManger.hitLocation == HITLOCATION.ARM) {
                                        hit = this.logicalBaseLayer.getArmCtrl().limbHit;
                                    } else if (CharacterManger.hitLocation == HITLOCATION.BODY) {
                                        hit *= 1;
                                    } else if (CharacterManger.hitLocation == HITLOCATION.LEG) {
                                        hit = this.logicalBaseLayer.getArmCtrl().limbHit;
                                    }
                                    hit = Math.floor(hit);
                                    CharacterManger.hit({
                                        isMySelf: true,
                                        hit: hit
                                    });
                                }
                            } else {
                                this.setRecoilForce();
                                this.perAttackTime = this.logicalBaseLayer.getArmCtrl().getInterval();
                                this.sendEffectNotify(true);
                                SoundManager.vibrateShort();
                            }
                        } else {
                            this.setRecoilForce();
                            this.perAttackTime = this.logicalBaseLayer.getArmCtrl().getInterval();
                            this.sendEffectNotify(false);
                            this.upperlimbName = null;
                            SoundManager.vibrateShort();
                        }
                        this.isCanPlayAttackAni = true;
                        if (this.logicalBaseLayer.getArmCtrl().getType() != 2) {
                            this.logicalBaseLayer.magazineBullet--;
                            this.logicalBaseLayer.getArmCtrl().curMagazineBullet--;
                        }
                        if (this.logicalBaseLayer.getIsMySelf())
                            NotifyManager.notify(NOTIFY_ID.REFRESH_MAIN_ARM);
                    } else {
                        this.isCanPlayAttackAni = true;
                        if (this.logicalBaseLayer.getArmCtrl().getType() == 2) {
                            let that = this;
                            this.perAttackTime = this.logicalBaseLayer.getArmCtrl().getInterval();
                            Laya.timer.once(400, this, function cd() {
                                if (that.sectorDetectionByKnifeWar(target)) {
                                    this.sendEffectNotify(false);
                                    this.randHitData[0] = 100;
                                    this.randHitData[1] = 100 - hitRide;
                                    this.randHeadshotData[0] = 30;
                                    this.randHeadshotData[1] = 100 - burstHeadRate;
                                    if (target && target.isInvincible)
                                        return;
                                    this.data = this.randHitType[ProbUtil.getResult(this.randHitData)];
                                    this.data2 = this.randHeadshotType[ProbUtil.getResult(this.randHeadshotData)];
                                    if (this.data2 == HEADSHOTSTATE.HIT) {
                                        CharacterManger.hit({
                                            isMySelf: false,
                                            killer: this.logicalBaseLayer,
                                            target: target,
                                            hit: this.logicalBaseLayer.getArmCtrl().getHit() * 2,
                                            isHitLocation: true,
                                            isDoubleHit: true
                                        });
                                    } else {
                                        if (this.data == HITSTATE.HIT) {
                                            CharacterManger.hit({
                                                isMySelf: false,
                                                killer: this.logicalBaseLayer,
                                                target: target,
                                                hit: this.logicalBaseLayer.getArmCtrl().getHit(),
                                                isHitLocation: false,
                                                isDoubleHit: false
                                            });
                                        }
                                    }
                                }
                                Laya.timer.clear(this, cd);
                            });
                        } else {
                            this.logicalBaseLayer.magazineBullet--;
                            this.logicalBaseLayer.getArmCtrl().curMagazineBullet--;
                            this.perAttackTime = this.logicalBaseLayer.getArmCtrl().getInterval();
                            this.sendEffectNotify(false);
                            this.randHitData[0] = ModeManager.mode == GAME_MODE_TYPE.SNIPERMODE ? 40 : hitRide;
                            if (ModeManager.mode == GAME_MODE_TYPE.ONEVSONEMODE) {
                                this.randHitData[0] = 50;
                            }
                            this.randHitData[1] = 100 - this.randHitData[0];
                            this.randHeadshotData[0] = ModeManager.mode == GAME_MODE_TYPE.SNIPERMODE ? 20 : burstHeadRate;
                            if (ModeManager.mode == GAME_MODE_TYPE.ONEVSONEMODE) {
                                this.randHeadshotData[0] = 10;
                            }
                            this.randHeadshotData[1] = 100 - this.randHeadshotData[0];
                            if (target && target.isInvincible)
                                return;
                            this.data = this.randHitType[ProbUtil.getResult(this.randHitData)];
                            this.data2 = this.randHeadshotType[ProbUtil.getResult(this.randHeadshotData)];
                            if (this.data2 == HEADSHOTSTATE.HIT) {
                                CharacterManger.hit({
                                    isMySelf: false,
                                    killer: this.logicalBaseLayer,
                                    target: target,
                                    hit: this.logicalBaseLayer.getArmCtrl().getHit() * 2,
                                    isHitLocation: true,
                                    isDoubleHit: true
                                });
                            } else {
                                if (this.data == HITSTATE.HIT) {
                                    CharacterManger.hit({
                                        isMySelf: false,
                                        killer: this.logicalBaseLayer,
                                        target: target,
                                        hit: this.logicalBaseLayer.getArmCtrl().getHit(),
                                        isHitLocation: false,
                                        isDoubleHit: false
                                    });
                                }
                            }
                        }
                    }
                } else {
                    let that = this;
                    this.perAttackTime = this.logicalBaseLayer.getArmCtrl() ? this.logicalBaseLayer.getArmCtrl().getInterval() : 3800;
                    Laya.timer.once(700, this, function cd() {
                        if (!that.model || !target.getPresentationBaseLayer())
                            return;
                        if (that.sectorDetectionByKnifeWar(target)) {
                            this.randHitData[0] = 100;
                            this.randHitData[1] = 100 - hitRide;
                            this.randHeadshotData[0] = 30;
                            this.randHeadshotData[1] = 100 - burstHeadRate;
                            if (target && target.isInvincible)
                                return;
                            this.data = this.randHitType[ProbUtil.getResult(this.randHitData)];
                            this.data2 = this.randHeadshotType[ProbUtil.getResult(this.randHeadshotData)];
                            CharacterManger.hit({
                                isMySelf: false,
                                killer: this.logicalBaseLayer,
                                target: target,
                                hit: this.logicalBaseLayer.getArmCtrl() ? this.logicalBaseLayer.getArmCtrl().getHit() : 20,
                                isHitLocation: false
                            });
                        }
                        Laya.timer.clear(this, cd);
                    });
                }
            }
        }
        TransformPoint(origin, point) {
            var value = new Laya.Vector3();
            Laya.Vector3.transformQuat(point, origin.rotation, value);
            Laya.Vector3.add(value, origin.position, value);
            return value;
        }
        testPoint(pos, num) {
            if (this.cubeList.length == 2) {
                for (let k = 0; k < this.cubeList.length; k++) {
                    let i = this.cubeList[k];
                    i.removeSelf();
                }
                this.cubeList = [];
            }
            let testBox = null;
            testBox = GameScene.scene3d.addChild(new Laya.MeshSprite3D(Laya.PrimitiveMesh.createBox(0.3, 0.3, 0.3)));
            var material = new Laya.BlinnPhongMaterial();
            Laya.Texture2D.load("res/layabox.png", Laya.Handler.create(null, function(tex) {
                material.albedoTexture = tex;
            }));
            testBox.transform.position = pos;
            testBox.meshRenderer.material = material;
            if (num == 1) {
                testBox.meshRenderer.sharedMaterial.albedoColor = new Laya.Vector4(1.0, 0.0, 0.0, 1.0);
            }
            this.cubeList.push(testBox);
        }
        sendEffectNotify(isCollide) {
            if (!this.logicalBaseLayer.getArmCtrl())
                return;
            if (this.logicalBaseLayer.getIsMySelf()) {
                NotifyManager.notify(NOTIFY_ID.PLAY_EFFECT + this.eventId, {
                    name: this.logicalBaseLayer.getArmCtrl().getFirestarter(),
                    pos: null,
                    isBulletHole: false
                });
            }
            NotifyManager.notify(NOTIFY_ID.PLAY_EFFECT + this.eventId, {
                name: this.logicalBaseLayer.getArmCtrl().getBallistic(),
                pos: null,
                isBulletHole: false
            });
            if (this.logicalBaseLayer.getIsMySelf()) {
                if (!isCollide) {
                    console.log('击中敌人');
                    NotifyManager.notify(NOTIFY_ID.PLAY_EFFECT + this.eventId, {
                        name: EFFECT_NAME.FIRE_END,
                        pos: this.myHitResult.point,
                        isBulletHole: true
                    });
                }
            }
        }
        addBuoy() {
            if (this.logicalBaseLayer.getIsMySelf())
                return;
            if (this.buoy) {
                this.buoy.destroy();
                this.buoy = null;
            }
            this.buoy = BuoyCtrl.create(this.model.transform, this.logicalBaseLayer);
            UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).floatingLayer.addChild(this.buoy);
        }
        getModel() {
            return this.model;
        }
        getModelID() {
            return this.model.id;
        }
        getAniCtrl() {
            this.aniCtrl = this.model.getChildAt(0).getComponent(Laya.Animator);
        }
        getSeparationAniCtrl() {
            if (!ConfigManager.isRefinedVersion)
                return;
            if (this.logicalBaseLayer.isZombie)
                return;
            if (this.separation)
                this.separationAniCtrl = this.separation.getChildAt(0).getComponent(Laya.Animator);
            console.log('分身控制器：', this.separationAniCtrl);
        }
        setDirection() {
            if (this.logicalBaseLayer.getIsMySelf()) {
                this.logicalBaseLayer.assistAim();
                let angle = this.logicalBaseLayer.getEulerAngle();
                this.model.getChildAt(0).transform.localRotationEuler = angle;
            } else {
                let angle = this.logicalBaseLayer.getRotatingQuaternion();
                this.model.transform.rotation = angle;
            }
        }
        setDirectionByTarget(target) {
            if (!target.getPresentationBaseLayer())
                return;
            let myPos = this.model.transform.position;
            let targetPos = target.getPresentationBaseLayer().getModelPosByVector3();
            targetPos.y = myPos.y;
            Laya.Vector3.subtract(targetPos, myPos, this.baseData.forwardDir);
            Laya.Vector3.normalize(this.baseData.forwardDir, this.baseData.forwardDir);
            this.baseData.forward.x = 0;
            this.baseData.forward.y = 0;
            this.baseData.forward.z = 0;
            this.model.transform.getForward(this.baseData.forward);
            this.baseData.forward.x *= -1;
            this.baseData.forward.z *= -1;
            Laya.Vector3.normalize(this.baseData.forward, this.baseData.forward);
            const value = Laya.Vector3.dot(this.baseData.forwardDir, this.baseData.forward);
            let deltaAng = (Math.acos(value) * 180) / Math.PI;
            Laya.Vector3.cross(this.baseData.forward, this.baseData.forwardDir, this.baseData.crossRide);
            if (this.baseData.crossRide.y < 0)
                deltaAng = -deltaAng;
            this.baseData.forwardToAngle.x = 0;
            this.baseData.forwardToAngle.z = 0;
            this.baseData.forwardToAngle.y = deltaAng;
            if (isNaN(this.baseData.forwardToAngle.y))
                return;
            this.model.transform.rotate(this.baseData.forwardToAngle, true, false);
        }
        updateBuoy() {
            if (this.logicalBaseLayer.getIsMySelf())
                return;
            this.buoy.setTagPos();
        }
        forceSetPos() {}
        playUpperlimbAni(args) {
            if (PerformanceManager.isCloseAni)
                return;
            if (!this.aniCtrl)
                return;
            if (this.isThrowing) {
                if (args.name != PLAY_ANI.ATTACK8_2 && args.name != PLAY_ANI.ATTACK8_1 && args.name != PLAY_ANI.RELOAD && args.name != PLAY_ANI.ATTACK && args.name != PLAY_ANI.DEATH)
                    return;
            }
            if (this.logicalBaseLayer.isSwitching) {
                if (args.name != PLAY_ANI.RELOAD && args.name != PLAY_ANI.ATTACK && args.name != PLAY_ANI.SWITCH && args.name != PLAY_ANI.DEATH)
                    return;
            }
            let type = this.logicalBaseLayer.getArmCtrl() ? (this.logicalBaseLayer.getArmCtrl().getType() == 5 || this.logicalBaseLayer.getArmCtrl().getType() == 6 || this.logicalBaseLayer.getArmCtrl().getType() == 7) ? '1' : this.logicalBaseLayer.getArmCtrl().getType() : '2';
            if (this.logicalBaseLayer.isZombie) {
                args.name = args.name;
            } else {
                if (args.name != PLAY_ANI.ATTACK8_1 && args.name != PLAY_ANI.ATTACK8_2)
                    args.name = args.name + type;
            }
            if (this.logicalBaseLayer.isZombie || (this.logicalBaseLayer.getArmCtrl() && this.logicalBaseLayer.getArmCtrl().getType() == 2 && this.logicalBaseLayer.getIsMySelf())) {
                if (args.name != PLAY_ANI.SWITCH + type) {
                    if (!this.isCanAttackAniAfterPlayOtherAni) {
                        if (!this.logicalBaseLayer.isZombie) {
                            if (args.name != PLAY_ANI.ATTACK + type) {
                                if (!this.logicalBaseLayer.isStartHuaBullet) {
                                    return;
                                }
                            }
                        } else {
                            if (args.name != PLAY_ANI.ATTACK) {
                                if (!this.logicalBaseLayer.isStartHuaBullet) {
                                    return;
                                }
                            }
                        }
                    }
                }
            }
            if (this.upperlimbName != args.name) {
                if (this.logicalBaseLayer.getIsMySelf()) {
                    console.log('当前播放动画:', args.name);
                }
                if (PlatformUtil.isIOS() && this.aniCtrl.speed <= 1)
                    this.aniCtrl.speed *= 2;
                this.aniCtrl.play(args.name, 1, 0);
                if (this.separationAniCtrl)
                    this.separationAniCtrl.play(args.name, 1, 0);
                this.upperlimbName = args.name;
            }
        }
        playUpperlimbAniQZ(name) {
            let type = this.logicalBaseLayer.getArmCtrl() ? (this.logicalBaseLayer.getArmCtrl().getType() == 5 || this.logicalBaseLayer.getArmCtrl().getType() == 6 || this.logicalBaseLayer.getArmCtrl().getType() == 7) ? '1' : this.logicalBaseLayer.getArmCtrl().getType() : '2';
            if (this.logicalBaseLayer.isZombie) {
                name = name;
            } else {
                name = name + type;
            }
            if (this.upperlimbName != name) {
                if (PlatformUtil.isIOS() && this.aniCtrl.speed <= 1)
                    this.aniCtrl.speed *= 2;
                this.aniCtrl.play(name, 1, 0);
                if (this.separationAniCtrl)
                    this.separationAniCtrl.play(name, 1, 0);
                this.upperlimbName = name;
            }
        }
        playThelegsAni(args) {
            if (this.isStartJump) {
                if (args.name != PLAY_ANI.JUMP)
                    return;
            }
            this.playTimeTheLegs -= LogicTimer.gSysTimer.delta;
            if (this.playTimeTheLegs < 0) {
                this.isCanQH = true;
                this.isStartQH = false;
            }
            if (args.name == PLAY_ANI.IDLE || args.name == PLAY_ANI.RUN || args.name == PLAY_ANI.RUN_LEFT || args.name == PLAY_ANI.RUN_RIGHT) {
                if (!this.isCanQH)
                    return;
            }
            if (PerformanceManager.isCloseAni)
                return;
            if (!this.aniCtrl)
                return;
            let type = this.logicalBaseLayer.getArmCtrl() ? (this.logicalBaseLayer.getArmCtrl().getType() == 5 || this.logicalBaseLayer.getArmCtrl().getType() == 6 || this.logicalBaseLayer.getArmCtrl().getType() == 7) ? '1' : this.logicalBaseLayer.getArmCtrl().getType() : '2';
            if ((this.thelegsName == PLAY_ANI.IDLE + type || this.thelegsName == PLAY_ANI.RUN + type || this.thelegsName == PLAY_ANI.RUN_LEFT + type || this.thelegsName == PLAY_ANI.RUN_RIGHT + type) && this.thelegsName != args.name) {
                if (!this.isStartQH) {
                    this.isStartQH = true;
                    this.playTimeTheLegs = 400;
                    this.isCanQH = false;
                }
            }
            let ani = args.name;
            if (this.logicalBaseLayer.isZombie) {
                args.name = args.name;
            } else {
                args.name = args.name + type;
            }
            if (this.thelegsName != args.name) {
                if (this.logicalBaseLayer.getIsMySelf()) {
                    if (ani == PLAY_ANI.RUN) {
                        this.aniCtrl.speed = 0.8;
                        if (this.separationAniCtrl)
                            this.separationAniCtrl.speed = 0.8;
                    } else {
                        this.aniCtrl.speed = 1;
                        if (this.separationAniCtrl)
                            this.separationAniCtrl.speed = 1;
                    }
                }
                if (PlatformUtil.isIOS() && this.aniCtrl.speed <= 1)
                    this.aniCtrl.speed *= 2;
                this.aniCtrl.play(args.name, 0, 0);
                if (this.separationAniCtrl)
                    this.separationAniCtrl.play(args.name, 0, 0);
                this.thelegsName = args.name;
            }
        }
        playEffect(args) {
            if (PerformanceManager.isCloseEffect)
                return;
            if (this.logicalBaseLayer.getArmCtrl().getType() != 2) {
                if (args.isBulletHole) {
                    if (!this.myHitResult.collider)
                        return;
                    if (!this.myHitResult.collider.owner)
                        return;
                    if (this.logicalBaseLayer.getIsMySelf()) {
                        EffectManger.playFireEnd({
                            name: args.name,
                            pos: this.hitPoint1
                        });
                    }
                } else {
                    if (!this.model)
                        return;
                    let kou = CommonUtil.findChildByName(this.model, 'kou');
                    if (!kou)
                        return;
                    if (this.fireEffect && this.fireEffect.parent) {
                        let pos = this.fireEffect.transform.localPosition;
                        pos.x = 0;
                        pos.y = 0;
                        pos.z = 0;
                        this.fireEffect.transform.localPosition = pos;
                    } else {
                        kou.transform.localRotationEulerX = 0;
                        this.fireEffect = EffectManger.playfire({
                            name: args.name,
                            parent: kou
                        });
                        let pos = this.fireEffect.transform.localPosition;
                        pos.x = 0;
                        pos.y = 0;
                        pos.z = 0;
                    }
                    let scale = this.fireEffect.transform.localScale;
                    scale.x = 0;
                    scale.y = 0;
                    scale.z = 0;
                    this.fireEffect.transform.localScale = scale;
                    this.fireEffect.transform.localRotationEulerZ = Math.random() * 45;
                    this.fireRecycleCountDown = 50;
                    if (this.logicalBaseLayer.getArmCtrl().getType() != 4) {
                        EffectManger.playfireTrajectory({
                            name: args.name,
                            parent: kou
                        });
                    }
                }
            }
        }
        playSound(args) {
            if (PerformanceManager.isCloseSound)
                return;
            if (args.url != SOUND_PATH.HEADSHOT && args.url != SOUND_PATH.DEATH && args.url != SOUND_PATH.DOUBLE.FIFTH && args.url != SOUND_PATH.DOUBLE.FIRST && args.url != SOUND_PATH.DOUBLE.FOURTH &&
                args.url != SOUND_PATH.DOUBLE.SEDOND && args.url != SOUND_PATH.DOUBLE.THIRD) {
                let pos = this.getModelPosByVector3();
                if (this.logicalBaseLayer.getIsMySelf()) {
                    pos = null;
                }
                if (ConfigManager.platform == PLATFORM_TYPE.VIVO && PresentationBaseLayer.sound3dCount > 8)
                    return;
                if (args.sound) {
                    SoundManager.playEffect3D(args.url, pos, 1, args.sound);
                } else {
                    SoundManager.playEffect3D(args.url, pos, 1, args.sound);
                }
                PresentationBaseLayer.sound3dCount += 1;
                Laya.timer.once(1000, this, () => {
                    PresentationBaseLayer.sound3dCount -= 1;
                    if (PresentationBaseLayer.sound3dCount < 0)
                        PresentationBaseLayer.sound3dCount = 0;
                });
            } else {
                if (this.logicalBaseLayer.getIsMySelf())
                    if (args.sound)
                        SoundManager.play(args.url, 1, true, args.sound);
                    else {
                        SoundManager.play(args.url, 1, true, 5);
                    }
            }
        }
        registerCharacterCtrl() {
            if (!this.logicalBaseLayer.getIsMySelf())
                return;
            if (PerformanceManager.isCloseCharacterCtrl) {
                this.characterCtrl = this.model.addComponent(CharacterCtrl);
                this.characterCtrl.stepHeight = 1.5;
                this.characterCtrl.gravity = 1;
                this.characterCtrl.fowardVel = 0.6;
                return;
            };
            let colliderGroup = Laya.Physics3DUtils.COLLISIONFILTERGROUP_CHARACTERFILTER;
            if (!this.logicalBaseLayer.getIsMySelf()) {
                colliderGroup = Laya.Physics3DUtils.COLLISIONFILTERGROUP_CUSTOMFILTER2;
            }
            var character = this.model.addComponentIntance(new Laya.CharacterController(0.1, null, colliderGroup));
            var sphereShape = new Laya.CapsuleColliderShape(0.5, 2);
            sphereShape.localOffset = new Laya.Vector3(0, 1, 0);
            character.colliderShape = sphereShape;
            character.gravity = new Laya.Vector3(0, -80, 0);
            console.log('当前重力：', character.gravity);
            this.characterCtrl = character;
            this.characterCtrl.simulation.continuousCollisionDetection = false;
            this.characterCtrl.stepHeight = 2;
            CommonUtil.IgnoreCollision(character, ColliderTarget.AI, ColliderTarget.PLAYER);
        }
        judgeIsGrounded() {
            if (this.characterCtrl.isGrounded)
                return true;
            return false;
        }
        speedCtrl() {
            if (!this.logicalBaseLayer.getIsMySelf())
                return;
            if (!this.isBehit) {
                console.log('速度减慢');
                this.isBehit = true;
                this.characterCtrl.fowardVel = 0.3;
                let that = this;
                Laya.timer.once(500, this, function cd() {
                    if (CharacterManger.gameOver)
                        return;
                    if (that.characterCtrl) {
                        that.characterCtrl.fowardVel = 0.6;
                        that.isBehit = false;
                    }
                });
            }
        }
        resetFowardVel() {
            if (!this.logicalBaseLayer.getIsMySelf())
                return;
            this.characterCtrl.fowardVel = 0.6;
        }
        move() {
            if (CharacterManger.gameOver) {
                if (this.logicalBaseLayer.getIsMySelf()) {
                    if (PerformanceManager.isCloseCharacterCtrl) {
                        this.characterCtrl.stop();
                    } else {
                        this.characterCtrl.move(this.logicalBaseLayer.getMyOrientation());
                    }
                }
                return;
            }
            if (!this.model)
                return;
            if (this.lifeParentTran)
                this.lifeParentTran.lookAt(CharacterManger.playerLogicalBaseLayer.getPresentationBaseLayer().getModelPosByVector3(), CommonUtil.Vector3.up, false);
            if (this.spMarkTran)
                this.spMarkTran.lookAt(CharacterManger.playerLogicalBaseLayer.getPresentationBaseLayer().getModelPosByVector3(), CommonUtil.Vector3.up, false);
            this.scaleLifeTran();
            this.AIToThrowTheArm();
            if (this.logicalBaseLayer.getHP() == 0) {
                if (!this.logicalBaseLayer.getIsDie()) {
                    this.logicalBaseLayer.setIsMoving = false;
                    this.logicalBaseLayer.setDie();
                    if (this.logicalBaseLayer.getIsMySelf()) {
                        NotifyManager.notify(NOTIFY_ID.PLAY_SOUND + this.eventId, {
                            url: SOUND_PATH.DEATH
                        });
                    }
                    if (this.upperlimbName != PLAY_ANI.DEATH) {
                        NotifyManager.notify(NOTIFY_ID.PLAY_THE_LEGS_ANI + this.eventId, {
                            name: PLAY_ANI.DEATH
                        });
                    }
                    if (this.thelegsName != PLAY_ANI.DEATH) {
                        NotifyManager.notify(NOTIFY_ID.PLAY_UPPER_LIMB_ANI + this.eventId, {
                            name: PLAY_ANI.DEATH
                        });
                    }
                }
            }
            if (this.logicalBaseLayer.isZombie) {
                if (this.logicalBaseLayer.getIsDie())
                    return;
            }
            this.setInvincible();
            this.floatingBloodMove();
            if (!this.logicalBaseLayer.getIsDie()) {
                if (this.logicalBaseLayer.getIsMoving()) {
                    if (this.logicalBaseLayer.getIsAttack()) {
                        if (this.logicalBaseLayer.magazineBullet != 0) {
                            if (this.logicalBaseLayer.isStartHuaBullet) {
                                NotifyManager.notify(NOTIFY_ID.PLAY_UPPER_LIMB_ANI + this.eventId, {
                                    name: PLAY_ANI.RELOAD
                                });
                            } else {}
                        } else {
                            if (this.logicalBaseLayer.isStartHuaBullet) {
                                NotifyManager.notify(NOTIFY_ID.PLAY_UPPER_LIMB_ANI + this.eventId, {
                                    name: PLAY_ANI.RELOAD
                                });
                            } else {
                                NotifyManager.notify(NOTIFY_ID.PLAY_UPPER_LIMB_ANI + this.eventId, {
                                    name: PLAY_ANI.IDLE
                                });
                            }
                        }
                        if (this.logicalBaseLayer.isCrouch) {
                            NotifyManager.notify(NOTIFY_ID.PLAY_THE_LEGS_ANI + this.eventId, {
                                name: PLAY_ANI.DUNXIA
                            });
                        } else {
                            if (this.isStartMoveAttackRandom) {
                                if (this.logicalBaseLayer.isZombie) {
                                    NotifyManager.notify(NOTIFY_ID.PLAY_THE_LEGS_ANI + this.eventId, {
                                        name: PLAY_ANI.RUN
                                    });
                                } else {
                                    if (!this.moveAttackRandPosList.target1Finish && !this.moveAttackRandPosList.target2Finish) {
                                        NotifyManager.notify(NOTIFY_ID.PLAY_THE_LEGS_ANI + this.eventId, {
                                            name: PLAY_ANI.RUN_LEFT
                                        });
                                    } else if (this.moveAttackRandPosList.target1Finish && !this.moveAttackRandPosList.target2Finish) {
                                        NotifyManager.notify(NOTIFY_ID.PLAY_THE_LEGS_ANI + this.eventId, {
                                            name: PLAY_ANI.RUN_RIGHT
                                        });
                                    }
                                }
                            } else {
                                NotifyManager.notify(NOTIFY_ID.PLAY_THE_LEGS_ANI + this.eventId, {
                                    name: PLAY_ANI.RUN
                                });
                            }
                        }
                    } else {
                        if (this.logicalBaseLayer.isStartHuaBullet) {
                            NotifyManager.notify(NOTIFY_ID.PLAY_UPPER_LIMB_ANI + this.eventId, {
                                name: PLAY_ANI.RELOAD
                            });
                        } else {
                            NotifyManager.notify(NOTIFY_ID.PLAY_UPPER_LIMB_ANI + this.eventId, {
                                name: PLAY_ANI.IDLE
                            });
                        }
                        if (this.logicalBaseLayer.isCrouch) {
                            NotifyManager.notify(NOTIFY_ID.PLAY_THE_LEGS_ANI + this.eventId, {
                                name: PLAY_ANI.DUNXIA
                            });
                        } else {
                            if (this.isStartMoveAttackRandom) {
                                if (this.logicalBaseLayer.isZombie) {
                                    NotifyManager.notify(NOTIFY_ID.PLAY_THE_LEGS_ANI + this.eventId, {
                                        name: PLAY_ANI.RUN
                                    });
                                } else {
                                    if (!this.moveAttackRandPosList.target1Finish && !this.moveAttackRandPosList.target2Finish) {
                                        NotifyManager.notify(NOTIFY_ID.PLAY_THE_LEGS_ANI + this.eventId, {
                                            name: PLAY_ANI.RUN_LEFT
                                        });
                                    } else if (this.moveAttackRandPosList.target1Finish && !this.moveAttackRandPosList.target2Finish) {
                                        NotifyManager.notify(NOTIFY_ID.PLAY_THE_LEGS_ANI + this.eventId, {
                                            name: PLAY_ANI.RUN_RIGHT
                                        });
                                    }
                                }
                            } else {
                                NotifyManager.notify(NOTIFY_ID.PLAY_THE_LEGS_ANI + this.eventId, {
                                    name: PLAY_ANI.RUN
                                });
                            }
                        }
                    }
                    this.playFootSound();
                } else {
                    if (!this.logicalBaseLayer.getIsAttack()) {
                        if (this.logicalBaseLayer.isStartHuaBullet) {
                            NotifyManager.notify(NOTIFY_ID.PLAY_UPPER_LIMB_ANI + this.eventId, {
                                name: PLAY_ANI.RELOAD
                            });
                        } else {
                            NotifyManager.notify(NOTIFY_ID.PLAY_UPPER_LIMB_ANI + this.eventId, {
                                name: PLAY_ANI.IDLE
                            });
                        }
                        if (this.logicalBaseLayer.isCrouch) {
                            NotifyManager.notify(NOTIFY_ID.PLAY_THE_LEGS_ANI + this.eventId, {
                                name: PLAY_ANI.DUNXIA
                            });
                        } else {
                            NotifyManager.notify(NOTIFY_ID.PLAY_THE_LEGS_ANI + this.eventId, {
                                name: PLAY_ANI.IDLE
                            });
                        }
                    } else {
                        if (this.logicalBaseLayer.magazineBullet != 0) {
                            if (this.logicalBaseLayer.isStartHuaBullet) {
                                NotifyManager.notify(NOTIFY_ID.PLAY_UPPER_LIMB_ANI + this.eventId, {
                                    name: PLAY_ANI.RELOAD
                                });
                            } else {}
                        } else {
                            if (this.logicalBaseLayer.isStartHuaBullet) {
                                NotifyManager.notify(NOTIFY_ID.PLAY_UPPER_LIMB_ANI + this.eventId, {
                                    name: PLAY_ANI.RELOAD
                                });
                            } else {
                                NotifyManager.notify(NOTIFY_ID.PLAY_UPPER_LIMB_ANI + this.eventId, {
                                    name: PLAY_ANI.IDLE
                                });
                            }
                        }
                        if (this.logicalBaseLayer.isCrouch) {
                            NotifyManager.notify(NOTIFY_ID.PLAY_THE_LEGS_ANI + this.eventId, {
                                name: PLAY_ANI.DUNXIA
                            });
                        } else {
                            NotifyManager.notify(NOTIFY_ID.PLAY_THE_LEGS_ANI + this.eventId, {
                                name: PLAY_ANI.IDLE
                            });
                        }
                    }
                }
            }
            let that = this;
            if (ModeManager.mode != GAME_MODE_TYPE.BIOCHEMISTRY) {
                if (!this.logicalBaseLayer.isZombie) {
                    if (!this.logicalBaseLayer.getIsMySelf()) {
                        this.logicalBaseLayer.revive(function() {
                            that.setPos(that.logicalBaseLayer.getInitPos());
                            if (that.logicalBaseLayer.isStartHuaBullet) {
                                NotifyManager.notify(NOTIFY_ID.PLAY_UPPER_LIMB_ANI + that.eventId, {
                                    name: PLAY_ANI.RELOAD
                                });
                            } else {
                                NotifyManager.notify(NOTIFY_ID.PLAY_UPPER_LIMB_ANI + that.eventId, {
                                    name: PLAY_ANI.IDLE
                                });
                            }
                            NotifyManager.notify(NOTIFY_ID.PLAY_THE_LEGS_ANI + that.eventId, {
                                name: PLAY_ANI.IDLE
                            });
                        });
                    } else {
                        if (CharacterManger.isWarmUp) {
                            this.logicalBaseLayer.revive(function() {
                                that.setPos(that.logicalBaseLayer.getInitPos());
                                if (that.logicalBaseLayer.isStartHuaBullet) {
                                    NotifyManager.notify(NOTIFY_ID.PLAY_UPPER_LIMB_ANI + that.eventId, {
                                        name: PLAY_ANI.RELOAD
                                    });
                                } else {
                                    NotifyManager.notify(NOTIFY_ID.PLAY_UPPER_LIMB_ANI + that.eventId, {
                                        name: PLAY_ANI.IDLE
                                    });
                                }
                                NotifyManager.notify(NOTIFY_ID.PLAY_THE_LEGS_ANI + that.eventId, {
                                    name: PLAY_ANI.IDLE
                                });
                            });
                        }
                    }
                }
            } else {
                if (this.logicalBaseLayer.getIsMySelf()) {}
            }
            if (!this.logicalBaseLayer.getIsDie()) {
                if (this.logicalBaseLayer.getIsMySelf()) {
                    if (PerformanceManager.isCloseCharacterCtrl) {
                        if (this.characterCtrl) {
                            if (!this.logicalBaseLayer.getIsMoving()) {
                                this.characterCtrl.stop();
                            } else {
                                this.characterCtrl.move(this.logicalBaseLayer.vecDir.x * 0.7, this.logicalBaseLayer.vecDir.z * 0.7);
                            }
                        } else {
                            let time = Laya.timer.delta * 0.062;
                            this.fixedVector3Data.targetPos.x = this.getModelPosByFixedVector().x + this.logicalBaseLayer.getMyOrientation().x * time;
                            this.fixedVector3Data.targetPos.y = this.getModelPosByFixedVector().y + this.logicalBaseLayer.getMyOrientation().y * time;
                            this.fixedVector3Data.targetPos.z = this.getModelPosByFixedVector().z + this.logicalBaseLayer.getMyOrientation().z * time;
                            let result = MapManager.pathfinder.alongNavMesh(this.getModelPosByFixedVector(), this.navNode, this.fixedVector3Data.targetPos, this.fixedVector3Data.nextPos, MapManager.zoneID, MapManager.navGroup);
                            this.navNode = result.node;
                            this.baseData.targetPos.x = this.fixedVector3Data.nextPos.x;
                            this.baseData.targetPos.y = this.fixedVector3Data.nextPos.y;
                            this.baseData.targetPos.z = this.fixedVector3Data.nextPos.z;
                            this.model.transform.position = this.baseData.targetPos;
                            this._isCollise = result.isCollise;
                        }
                    } else {
                        this.characterCtrl.move(this.logicalBaseLayer.getMyOrientation());
                    }
                    this.getBombPoint();
                } else {
                    let time = Laya.timer.delta * 0.062;
                    this.fixedVector3Data.targetPos.x = this.getModelPosByFixedVector().x + this.logicalBaseLayer.getMyOrientation().x * time;
                    this.fixedVector3Data.targetPos.y = this.getModelPosByFixedVector().y + this.logicalBaseLayer.getMyOrientation().y * time;
                    this.fixedVector3Data.targetPos.z = this.getModelPosByFixedVector().z + this.logicalBaseLayer.getMyOrientation().z * time;
                    let result = MapManager.pathfinder.alongNavMesh(this.getModelPosByFixedVector(), this.navNode, this.fixedVector3Data.targetPos, this.fixedVector3Data.nextPos, MapManager.zoneID, MapManager.navGroup);
                    this.navNode = result.node;
                    this.baseData.targetPos.x = this.fixedVector3Data.nextPos.x;
                    this.baseData.targetPos.y = this.fixedVector3Data.nextPos.y;
                    this.baseData.targetPos.z = this.fixedVector3Data.nextPos.z;
                    this.model.transform.position = this.baseData.targetPos;
                    this._isCollise = result.isCollise;
                }
            } else {
                if (this.logicalBaseLayer.getIsMySelf()) {
                    if (PerformanceManager.isCloseCharacterCtrl) {
                        if (this.characterCtrl)
                            this.characterCtrl.stop();
                    } else {
                        if (this.characterCtrl)
                            this.characterCtrl.move(this.logicalBaseLayer.getMyOrientation());
                    }
                }
            }
        }
        setAuxiliaryShooting() {
            if (this.logicalBaseLayer.getIsMySelf()) {
                console.log('主角是否扫描到：', this.sectorDetection());
                if (this.sectorDetection()) {
                    if (this.logicalBaseLayer.attackLogicalBaseLayer) {
                        console.log('扫描到的敌人：', this.logicalBaseLayer.attackLogicalBaseLayer.getRoleType(), this.logicalBaseLayer.attackLogicalBaseLayer.gameName);
                    }
                }
            }
        }
        setKillingSituation(killer) {
            if (CharacterManger.isWarmUp)
                return;
            if (ModeManager.mode == GAME_MODE_TYPE.BIOCHEMISTRY)
                return;
            if (this.logicalBaseLayer.getRoleType() == ROLE_TYPE.TYPE_0) {
                CharacterManger.updateEnemyScore();
                if (TaskManager.targetKillSore - CharacterManger.enemyKillScore == 5 || TaskManager.targetKillSore - CharacterManger.enemyKillScore == 3 || TaskManager.targetKillSore - CharacterManger.enemyKillScore == 1) {
                    NotifyManager.notify(NOTIFY_ID.MATCH_KILL, {
                        type: WHO_KILL.ENEMY
                    });
                }
                NotifyManager.notify(NOTIFY_ID.KILL, {
                    role: ROLE_TYPE.TYPE_1
                });
            }
            if (this.logicalBaseLayer.getRoleType() == ROLE_TYPE.TYPE_1) {
                CharacterManger.updateWeScore();
                if (TaskManager.targetKillSore - CharacterManger.ourKillScore == 5 || TaskManager.targetKillSore - CharacterManger.ourKillScore == 3 || TaskManager.targetKillSore - CharacterManger.ourKillScore == 1) {
                    NotifyManager.notify(NOTIFY_ID.MATCH_KILL, {
                        type: WHO_KILL.FRIEND
                    });
                }
                NotifyManager.notify(NOTIFY_ID.KILL, {
                    role: ROLE_TYPE.TYPE_0
                });
            }
            if (CharacterManger.ourKillScore >= TaskManager.targetKillSore) {
                console.log('我方胜利');
                CharacterManger.gameOver = true;
                CharacterManger._isWin = true;
                return;
            }
            if (CharacterManger.enemyKillScore >= TaskManager.targetKillSore) {
                console.log('敌方胜利');
                CharacterManger.gameOver = true;
                CharacterManger._isWin = false;
                return;
            }
        }
        setGamimgHead(view) {
            this.gamingHeadCtrl = view;
        }
        setGamingHeadState() {
            if (this.gamingHeadCtrl)
                this.gamingHeadCtrl.setState();
        }
        playHeadshot() {
            if (!this.headshotCtrl) {
                this.headshotCtrl = new HeadshotCtrl();
                UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).addChild(this.headshotCtrl);
            }
            this.headshotCtrl.playAni();
        }
        setGhostUICtrl() {
            if (!this.boxGhost)
                return;
            let img = this.boxGhost.getChildAt(0);
            img.y = 0;
            img.alpha = 1;
        }
        dieGhostUI() {
            if (!this.logicalBaseLayer.getIsDie()) {
                if (this.boxGhost) {
                    let img = this.boxGhost.getChildAt(0);
                    if (img.alpha != 0) {
                        img.alpha = 0;
                    }
                }
                return;
            }
            if (!this.boxGhost) {
                this.boxGhost = new Laya.Box();
                let imgGhost = new Laya.Image(RES_PATH.FLOATING_UP_GHOST_UI);
                UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).addChild(this.boxGhost);
                let vec = this.getModelPosByVector3();
                vec.x += 1;
                vec.y += 3;
                let pos = SceneManager.getCurScene().getViewportPoint(vec);
                this.boxGhost.x = pos.x;
                this.boxGhost.y = pos.y;
                this.boxGhost.addChild(imgGhost);
            }
            let imgGhost = this.boxGhost.getChildAt(0);
            if (imgGhost.alpha <= 0)
                return;
            let vec = this.getModelPosByVector3();
            vec.x += 1;
            vec.y += 3;
            let pos = SceneManager.getCurScene().getViewportPoint(vec);
            this.boxGhost.x = pos.x;
            this.boxGhost.y = pos.y;
            let dis = Laya.Vector3.distance(GameScene.camera.transform.position, this.getModelPosByVector3());
            this.boxGhost.scaleX = this.boxGhost.scaleY = 1 / (dis * 1 / 2) * 10 <= 1 ? 1 / (dis * 1 / 2) * 10 : 1;
            imgGhost.y--;
            imgGhost.alpha -= 0.015;
        }
        setInvincible() {
            if (this.logicalBaseLayer.isInvincible) {
                this.invincibleProCount -= LogicTimer.gSysTimer.delta;
                let w = 320 - this.invincibleProCount * 320 / this.invincibleProCountMax;
                this.activeSeparation(true);
                if (!this.logicalBaseLayer.getIsMySelf()) {
                    if (!this.shieldSp) {
                        this.shieldSp = EffectManger.playShield({
                            parent: this.model
                        });
                        this.shieldSp.transform.localPositionY = 1;
                    }
                }
                if (this.logicalBaseLayer.getIsMySelf()) {
                    this.invincibleProCtrl.setPro(w);
                }
                if (this.invincibleProCount < 0) {
                    this.activeSeparation(false);
                    this.invincibleProCount = this.invincibleProCountMax;
                    if (this.logicalBaseLayer.getIsMySelf()) {
                        this.invincibleProCtrl.resetCtrl();
                    }
                    if (this.shieldSp)
                        EffectManger.recycleEffect(this.shieldSp);
                    this.shieldSp = null;
                    this.logicalBaseLayer.isInvincible = false;
                }
            }
        }
        openMirror() {
            if (!GameScene.camera)
                return;
            if (!this.logicalBaseLayer.getIsMySelf())
                return;
        }
        init(model) {
            this.model = model;
            this.getAniCtrl();
        }
        update() {
            if (CharacterManger.gameOver)
                return;
            if (this.fireEffect) {
                if (!this.fireEffect.parent)
                    return;
                if (this.fireRecycleCountDown > -1000) {
                    this.fireRecycleCountDown -= Laya.timer.delta;
                    if (this.fireRecycleCountDown < 0) {
                        let pos = this.fireEffect.transform.localPosition;
                        pos.x = -100000;
                        pos.y = -100000;
                        pos.z = -100000;
                        this.fireEffect.transform.localPosition = pos;
                    } else {
                        let scale = this.fireEffect.transform.localScale;
                        scale.x += Laya.timer.delta * 0.02;
                        scale.y += Laya.timer.delta * 0.02;
                        scale.z += Laya.timer.delta * 0.02;
                        if (scale.x > 1) {
                            scale.x = 1;
                            scale.y = 1;
                            scale.z = 1;
                        }
                        this.fireEffect.transform.localScale = scale;
                    }
                }
            }
            this.rayBox.updateTransfrom();
            if (this.isJump) {
                if (this.judgeIsGrounded()) {
                    this.isJump = false;
                    SoundManager.playEffect(SOUND_PATH.DROP);
                }
            }
        }
        startRanomRotate() {
            if (this.randRotateType[ProbUtil.getResult(this.randRotateData)] == ROTATESTATE.STATIC)
                return false;
            if (!this.isAIStartRandomRotate) {
                this.isAIStartRandomRotate = true;
                this.isStartDeviation = true;
                let rand = RandomUtil.onlyOneRandomInt(-60, 60);
                if (this.bearing == BEARINGTYPE.LEFT) {
                    rand = Math.abs(rand);
                } else if (this.bearing == BEARINGTYPE.RIGHT) {
                    if (rand > 0) {
                        rand = -rand;
                    }
                }
                this.rotateRange = this.model.transform.localRotationEulerY + rand;
                this.bearing = rand > 0 ? BEARINGTYPE.RIGHT : BEARINGTYPE.LEFT;
                this.curAngle = this.model.transform.localRotationEulerY;
            }
            return true;
        }
        toRandomRotate() {
            if (!this.isAIStartRandomRotate)
                return;
            if (this.isStartDeviation) {
                if (this.bearing == BEARINGTYPE.LEFT) {
                    if (this.rotateRange < this.model.transform.localRotationEulerY) {
                        this.model.transform.localRotationEulerY -= 2;
                    } else {
                        this.isStartDeviation = false;
                    }
                } else {
                    if (this.rotateRange > this.model.transform.localRotationEulerY) {
                        this.model.transform.localRotationEulerY += 2;
                    } else {
                        this.isStartDeviation = false;
                    }
                }
            } else {
                if (this.model.transform.localRotationEulerY != this.curAngle) {
                    if (this.bearing == BEARINGTYPE.LEFT) {
                        if (this.model.transform.localRotationEulerY < this.curAngle) {
                            this.model.transform.localRotationEulerY += 2;
                        } else {
                            this.isAIStartRandomRotate = false;
                        }
                    } else {
                        if (this.model.transform.localRotationEulerY > this.curAngle) {
                            this.model.transform.localRotationEulerY -= 2;
                        } else {
                            this.isAIStartRandomRotate = false;
                        }
                    }
                } else {
                    this.isAIStartRandomRotate = false;
                }
            }
        }
        jump() {
            if (this.logicalBaseLayer.getIsDie())
                return;
            if (this.logicalBaseLayer.isZombie)
                return;
            if (!this.logicalBaseLayer.getIsMySelf()) {
                if (this.randJumpType[ProbUtil.getResult(this.randJumpData)] == JUMPSTATE.STATIC)
                    return;
            }
            if (!this.characterCtrl) {
                if (!this.isStartJump) {
                    this.flyUp = 0.2;
                    this.flyDown = 0;
                    this.isStartJump = true;
                }
            } else {
                if (this.isJump)
                    return;
                if (!this.judgeIsGrounded())
                    return;
                if (this.logicalBaseLayer.getIsMySelf())
                    SoundManager.playEffect(SOUND_PATH.JUMP);
                this.isJump = true;
                if (PerformanceManager.isCloseCharacterCtrl) {
                    this.characterCtrl.jump(2.2);
                } else {
                    this.characterCtrl.jump(this.baseData.tempJump);
                }
            }
        }
        toJump() {
            if (!this.isStartJump)
                return;
            if (!this.characterCtrl) {
                NotifyManager.notify(NOTIFY_ID.PLAY_THE_LEGS_ANI + this.eventId, {
                    name: PLAY_ANI.JUMP
                });
                let model = this.model.getChildAt(0);
                let time = Laya.timer.delta * 0.0555;
                if (this.spriteHole) {
                    this.spriteHole.transform.localScaleX = Math.min(0.5, 1.3 - model.transform.localPositionY);
                    this.spriteHole.transform.localScaleZ = Math.min(0.5, 1.3 - model.transform.localPositionY);
                }
                if (this.flyUp > 0) {
                    model.transform.localPositionY += this.flyUp * time;
                    this.flyUp -= 0.01 * time;
                } else {
                    if (this.spriteHole) {
                        this.spriteHole.transform.localScaleX = 1.3;
                        this.spriteHole.transform.localScaleZ = 1.3;
                    }
                    if (model.transform.localPositionY > 0) {
                        model.transform.localPositionY -= this.flyDown * time;
                        this.flyDown += 0.01 * time;
                    } else {
                        this.flyUp = 0.2 * time;
                        this.flyDown = 0;
                        this.isStartJump = false;
                        model.transform.localPositionY = 0;
                    }
                }
            } else {}
        }
        moveAttackRandomPos() {
            if (!this.isStartMoveAttackRandom) {
                this.isStartMoveAttackRandom = true;
                this.moveAttackRandPosList.onceToType = 0;
                this.moveAttackRandPosList.curPos.x = this.model.transform.position.x;
                this.moveAttackRandPosList.curPos.y = this.model.transform.position.y;
                this.moveAttackRandPosList.curPos.z = this.model.transform.position.z;
                this.moveAttackRandPosList.target1.x = 0;
                this.moveAttackRandPosList.target1.y = 0;
                this.moveAttackRandPosList.target1.z = 0;
                this.moveAttackRandPosList.target2.x = 0;
                this.moveAttackRandPosList.target2.y = 0;
                this.moveAttackRandPosList.target2.z = 0;
                this.moveAttackRandPosList.tempPos1.x = 0;
                this.moveAttackRandPosList.tempPos1.y = 0;
                this.moveAttackRandPosList.tempPos1.z = 0;
                this.moveAttackRandPosList.tempPos2.x = 0;
                this.moveAttackRandPosList.tempPos2.y = 0;
                this.moveAttackRandPosList.tempPos2.z = 0;
                this.moveAttackRandPosList.target1Finish = false;
                this.moveAttackRandPosList.target2Finish = false;
                this.moveAttackRandPosList.isCollideFinish1 = false;
                this.moveAttackRandPosList.isCollideFinish2 = false;
                this.moveAttackRandPosList.testCollideNum = 0;
                this.model.transform.getForward(this.baseData.forwardDir);
                Laya.Vector3.scale(this.baseData.forwardDir, -1, this.baseData.forwardDir);
                this.model.transform.position.cloneTo(this.moveAttackRandPosList.curPos);
                this.model.transform.position.cloneTo(this.baseData.curPos);
                this.baseData.curPos.x += this.baseData.forwardDir.x * Laya.timer.delta * 0.1;
                this.baseData.curPos.z += this.baseData.forwardDir.z * Laya.timer.delta * 0.1;
                let k1 = this.baseData.curPos.x / this.baseData.curPos.z;
                if (Math.abs(this.model.transform.localRotationEulerY) >= 45 && Math.abs(this.model.transform.localRotationEulerY) <= 120) {
                    k1 = this.baseData.curPos.z / this.baseData.curPos.x;
                }
                let k2 = -k1;
                let x = RandomUtil.onlyOneRandomInt(3, 6);
                if (RandomUtil.onlyOneRandomIntOrFloat(0, 1) > 0.5)
                    x = -x;
                if (x > 0) {
                    this.moveAttackRandPosList.onceToType = 1;
                } else {
                    this.moveAttackRandPosList.onceToType = 2;
                }
                let y = k2 * x;
                this.moveAttackRandPosList.tempPos1.x = x;
                this.moveAttackRandPosList.tempPos1.z = y;
                this.model.transform.position.cloneTo(this.moveAttackRandPosList.target1);
                this.moveAttackRandPosList.target1.x += this.moveAttackRandPosList.tempPos1.x;
                this.moveAttackRandPosList.target1.z += this.moveAttackRandPosList.tempPos1.z;
                this.moveAttackRandPosList.target1.y = 0.5;
                x = -x;
                y = k2 * x;
                this.moveAttackRandPosList.tempPos2.x = x;
                this.moveAttackRandPosList.tempPos2.z = y;
                this.model.transform.position.cloneTo(this.moveAttackRandPosList.target2);
                this.moveAttackRandPosList.target2.x += this.moveAttackRandPosList.tempPos2.x;
                this.moveAttackRandPosList.target2.z += this.moveAttackRandPosList.tempPos2.z;
                this.moveAttackRandPosList.target2.y = 0.5;
            }
            this.toRandAttackMove();
        }
        toRandAttackMove() {
            if (this.isStartMoveAttackRandom) {
                if (!this.moveAttackRandPosList.target1Finish) {
                    this.moveAttackRandPosList.out1.x = 0;
                    this.moveAttackRandPosList.out1.y = 0;
                    this.moveAttackRandPosList.out1.z = 0;
                    this.moveAttackRandPosList.dis1.x = 0;
                    this.moveAttackRandPosList.dis1.y = 0;
                    this.moveAttackRandPosList.dis1.z = 0;
                    Laya.Vector3.subtract(this.moveAttackRandPosList.target1, this.model.transform.position, this.moveAttackRandPosList.out1);
                    Laya.Vector3.normalize(this.moveAttackRandPosList.out1, this.moveAttackRandPosList.out1);
                    Laya.Vector3.scale(this.moveAttackRandPosList.out2, 0.1, this.moveAttackRandPosList.out2);
                    this.moveAttackRandPosList.dis1.x = this.model.transform.position.x + this.moveAttackRandPosList.out1.x;
                    this.moveAttackRandPosList.dis1.y = this.model.transform.position.y + this.moveAttackRandPosList.out1.y;
                    this.moveAttackRandPosList.dis1.z = this.model.transform.position.z + this.moveAttackRandPosList.out1.z;
                    this.moveAttackRandPosList.out1.y = 0;
                    Laya.Vector3.scale(this.moveAttackRandPosList.out1, 0.001, this.moveAttackRandPosList.out1);
                    this.logicalBaseLayer.setMyOrientation(this.moveAttackRandPosList.out1.x, this.moveAttackRandPosList.out1.y, this.moveAttackRandPosList.out1.z);
                    if (Laya.Vector3.distanceSquared(this.moveAttackRandPosList.target1, this.moveAttackRandPosList.dis1) < 0.7 * 0.7) {
                        this._isCollise = false;
                        this.moveAttackRandPosList.target1Finish = true;
                        this.moveAttackRandPosList.isCollideFinish1 = false;
                        this.moveAttackRandPosList.isCollideFinish2 = false;
                        this.logicalBaseLayer.setMyOrientation(0, 0, 0);
                        return;
                    }
                    if (!this.moveAttackRandPosList.isCollideFinish2) {
                        if (this._isCollise) {
                            this._isCollise = false;
                            this.moveAttackRandPosList.target1Finish = true;
                            this.moveAttackRandPosList.isCollideFinish1 = true;
                            this.moveAttackRandPosList.isCollideFinish2 = false;
                            this.logicalBaseLayer.setMyOrientation(0, 0, 0);
                            return;
                        }
                    }
                    if (Laya.Vector3.distanceSquared(this.model.transform.position, this.moveAttackRandPosList.target2) > 2 * 2) {
                        if (this._isCollise) {
                            this._isCollise = false;
                            this.moveAttackRandPosList.target1Finish = true;
                            this.moveAttackRandPosList.isCollideFinish1 = true;
                            this.logicalBaseLayer.setMyOrientation(0, 0, 0);
                            return;
                        }
                    }
                } else {
                    if (!this.moveAttackRandPosList.target2Finish) {
                        this.moveAttackRandPosList.out2.x = 0;
                        this.moveAttackRandPosList.out2.y = 0;
                        this.moveAttackRandPosList.out2.z = 0;
                        this.moveAttackRandPosList.dis2.x = 0;
                        this.moveAttackRandPosList.dis2.y = 0;
                        this.moveAttackRandPosList.dis2.z = 0;
                        Laya.Vector3.subtract(this.moveAttackRandPosList.target2, this.model.transform.position, this.moveAttackRandPosList.out2);
                        Laya.Vector3.normalize(this.moveAttackRandPosList.out2, this.moveAttackRandPosList.out2);
                        Laya.Vector3.scale(this.moveAttackRandPosList.out2, 0.1, this.moveAttackRandPosList.out2);
                        this.moveAttackRandPosList.dis2.x = this.model.transform.position.x + this.moveAttackRandPosList.out2.x;
                        this.moveAttackRandPosList.dis2.y = this.model.transform.position.y + this.moveAttackRandPosList.out2.y;
                        this.moveAttackRandPosList.dis2.z = this.model.transform.position.z + this.moveAttackRandPosList.out2.z;
                        this.moveAttackRandPosList.out2.y = 0;
                        Laya.Vector3.scale(this.moveAttackRandPosList.out2, 0.001, this.moveAttackRandPosList.out2);
                        if (this._isCollise) {
                            this.moveAttackRandPosList.testCollideNum++;
                        }
                        this.logicalBaseLayer.setMyOrientation(this.moveAttackRandPosList.out2.x, this.moveAttackRandPosList.out2.y, this.moveAttackRandPosList.out2.z);
                        if (this.moveAttackRandPosList.testCollideNum >= 5) {
                            this.moveAttackRandPosList.target2Finish = true;
                            this.moveAttackRandPosList.isCollideFinish2 = false;
                            this.logicalBaseLayer.setMyOrientation(0, 0, 0);
                        }
                        if (Laya.Vector3.distanceSquared(this.moveAttackRandPosList.target2, this.moveAttackRandPosList.dis2) < 0.7 * 0.7) {
                            this.moveAttackRandPosList.target2Finish = true;
                            this.moveAttackRandPosList.isCollideFinish2 = false;
                            this.logicalBaseLayer.setMyOrientation(0, 0, 0);
                            return;
                        }
                    } else {
                        if (this.moveAttackRandPosList.target1Finish && this.moveAttackRandPosList.target2Finish) {
                            this.toResetRandAttackData();
                        }
                        this.moveAttackRandPosList.target1Finish = false;
                        this.moveAttackRandPosList.target2Finish = false;
                        this.logicalBaseLayer.setMyOrientation(0, 0, 0);
                    }
                }
            }
        }
        toResetRandAttackData() {
            this.isStartMoveAttackRandom = false;
        }
        sectorDetectionByKnifeWar(target) {
            if (!target)
                return false;
            if (!target.getPresentationBaseLayer())
                return false;
            this.model.transform.getForward(this.baseData.forwardDir);
            Vector3$a.scale(this.baseData.forwardDir, -1, this.baseData.forwardDir);
            this.model.transform.position.cloneTo(this.baseData.curPos);
            if (target.getIsDie()) {
                return false;
            }
            Vector3$a.subtract(target.getPresentationBaseLayer().getModelPosByVector3(), this.getModelPosByVector3(), this.baseData.vecTmp);
            if ((this.baseData.vecTmp.x == 0 && this.baseData.vecTmp.y == 0)) {
                return true;
            } else {
                let dotValue = Vector3$a.dot(this.baseData.vecTmp, this.baseData.forwardDir);
                let a = Vector3$a.scalarLength(this.baseData.vecTmp);
                let b = Vector3$a.scalarLength(this.baseData.forwardDir);
                let cos = dotValue / (a * b);
                if (cos > this.cosValue) {
                    if (Vector3$a.distanceSquared(this.getModelPosByVector3(), target.getPresentationBaseLayer().getModelPosByVector3()) < (this.logicalBaseLayer.getArmCtrl() ? this.logicalBaseLayer.getArmCtrl().getAttackDis() * this.logicalBaseLayer.getArmCtrl().getAttackDis() : 9 * 9)) {
                        return true;
                    } else {
                        return false;
                    }
                }
            }
            return false;
        }
        sectorDetection() {
            if (this.logicalBaseLayer.getIsDie())
                return;
            if (!this.logicalBaseLayer.isZombie) {
                if (this.logicalBaseLayer.bullets == 0 && this.logicalBaseLayer.magazineBullet == 0) {
                    return false;
                }
            }
            this.model.transform.getForward(this.baseData.forwardDir);
            Vector3$a.scale(this.baseData.forwardDir, -1, this.baseData.forwardDir);
            this.model.transform.position.cloneTo(this.baseData.curPos);
            let target = null;
            let minTarget = null;
            for (let k = 0; k < CharacterManger.logicalBaseLayer.length; k++) {
                let i = CharacterManger.logicalBaseLayer[k];
                if (i.getIsDie()) {
                    if (i.killerLogicalBaseLayer)
                        i.killerLogicalBaseLayer = null;
                }
                if (i.getRoleType() != this.logicalBaseLayer.getRoleType() && !i.getIsDie() && !i.isInvincible) {
                    let posA = i.getPresentationBaseLayer().getModelPosByVector3();
                    let posB = this.getModelPosByVector3();
                    Vector3$a.subtract(posA, posB, this.baseData.vecTmp);
                    if ((this.baseData.vecTmp.x == 0 && this.baseData.vecTmp.y == 0)) {
                        minTarget = i;
                        break;
                    } else {
                        let dotValue = Vector3$a.dot(this.baseData.vecTmp, this.baseData.forwardDir);
                        let a = Vector3$a.scalarLength(this.baseData.vecTmp);
                        let b = Vector3$a.scalarLength(this.baseData.forwardDir);
                        let cos = dotValue / (a * b);
                        if (cos > this.cosValue) {
                            if (minTarget == null) {
                                minTarget = i;
                            } else {
                                if (Vector3$a.distanceSquared(posB, minTarget.getPresentationBaseLayer().getModelPosByVector3()) >
                                    Vector3$a.distanceSquared(posB, posA)) {
                                    minTarget = i;
                                }
                            }
                        }
                    }
                }
            }
            target = minTarget;
            if (target == null) {
                this.logicalBaseLayer.attackLogicalBaseLayer = null;
                return false;
            } else {
                if (this.lineDetection(target)) {
                    this.logicalBaseLayer.attackLogicalBaseLayer = target;
                    target.killerLogicalBaseLayer = this.logicalBaseLayer;
                    return true;
                } else {
                    this.logicalBaseLayer.attackLogicalBaseLayer = null;
                    if (target.killerLogicalBaseLayer)
                        target.killerLogicalBaseLayer = null;
                    return false;
                }
            }
        }
        startPlayDoubleKill() {
            if (!this.doubleKillItemCtrl) {
                this.doubleKillItemCtrl = new DoubleKillItemCtrl();
                SceneManager.getCurScene().addChild(this.doubleKillItemCtrl);
            }
            if (this.logicalBaseLayer.doubleKill == 1) {
                NotifyManager.notify(NOTIFY_ID.PLAY_SOUND + this.eventId, {
                    url: SOUND_PATH.DOUBLE.FIRST
                });
            } else if (this.logicalBaseLayer.doubleKill == 2) {
                NotifyManager.notify(NOTIFY_ID.PLAY_SOUND + this.eventId, {
                    url: SOUND_PATH.DOUBLE.SEDOND
                });
            } else if (this.logicalBaseLayer.doubleKill == 3) {
                NotifyManager.notify(NOTIFY_ID.PLAY_SOUND + this.eventId, {
                    url: SOUND_PATH.DOUBLE.THIRD
                });
            } else if (this.logicalBaseLayer.doubleKill == 4) {
                NotifyManager.notify(NOTIFY_ID.PLAY_SOUND + this.eventId, {
                    url: SOUND_PATH.DOUBLE.FOURTH
                });
            } else if (this.logicalBaseLayer.doubleKill == 5) {
                NotifyManager.notify(NOTIFY_ID.PLAY_SOUND + this.eventId, {
                    url: SOUND_PATH.DOUBLE.FIFTH
                });
            } else {
                NotifyManager.notify(NOTIFY_ID.PLAY_SOUND + this.eventId, {
                    url: SOUND_PATH.DOUBLE.SIX
                });
            }
            this.doubleKillItemCtrl.start(this.logicalBaseLayer.doubleKill);
        }
        startPlayBombKill() {
            if (!this.doubleKillItemCtrl) {
                this.doubleKillItemCtrl = new DoubleKillItemCtrl();
                SceneManager.getCurScene().addChild(this.doubleKillItemCtrl);
            }
            NotifyManager.notify(NOTIFY_ID.PLAY_SOUND + this.eventId, {
                url: SOUND_PATH.BOMB_KILL
            });
            this.doubleKillItemCtrl.startBomb();
        }
        closeDoubleKill() {
            if (this.doubleKillItemCtrl)
                this.doubleKillItemCtrl.close();
        }
        getOnceChild() {
            return this.model.getChildAt(0);
        }
        lineDetection(target) {
            let pos1 = this.getModelPosByVector3();
            let pos2 = target.getPresentationBaseLayer().getModelPosByVector3();
            pos1.cloneTo(this._ray.origin);
            Laya.Vector3.subtract(pos2, pos1, this._ray.direction);
            this._ray.direction.y += 1;
            this._ray.origin.y += 1;
            let distance = Vector3$a.distance(pos1, pos2);
            this._ray.direction.x /= distance;
            this._ray.direction.y /= distance;
            this._ray.direction.z /= distance;
            if (!this.isCollidingsRayAndWall(this._ray, distance)) {
                return true;
            }
            return false;
        }
        throwBomb() {
            let bomb = this.cacheBombSp;
            if (!bomb)
                return;
            let ctrl = bomb.getComponent(BombCtrl);
            if (ctrl) {
                Laya.timer.once(ctrl.aniEndTime, this, () => {
                    if (ctrl && ctrl.isTouch) {
                        SoundManager.playEffect(SOUND_PATH.FIRE_IN_TEH_HOLE);
                    } else {
                        return;
                    }
                    let spTrail = this.cacheBombSp.getChildByName('Trail');
                    spTrail.active = true;
                    this.cacheBombSp = null;
                    NotifyManager.notify(NOTIFY_ID.PLAY_UPPER_LIMB_ANI + this.eventId, {
                        name: PLAY_ANI.ATTACK8_2
                    });
                    ctrl.isThrow = true;
                    let pos = bomb.transform.position.clone();
                    GameScene.scene3d.addChild(bomb);
                    bomb.transform.position = pos;
                    this.logicalBaseLayer.getPresentationBaseLayer().getOnceChild().transform.getForward(CommonUtil.Vector3.forward);
                    Laya.Vector3.scale(CommonUtil.Vector3.forward, 17, CommonUtil.Vector3.forward);
                    CommonUtil.Vector3.forward.x *= -1;
                    CommonUtil.Vector3.forward.z *= -1;
                    CommonUtil.Vector3.forward.y = this.logicalBaseLayer.getPresentationBaseLayer().getOnceChild().transform.rotationEuler.x - 12;
                    CommonUtil.Vector3.forward.y *= -1;
                    console.log('CommonUtil.Vector3.forward:', CommonUtil.Vector3.forward);
                    this.linearVelocity.x = CommonUtil.Vector3.forward.x * 0.3;
                    this.linearVelocity.y = CommonUtil.Vector3.forward.y * 0.13;
                    this.linearVelocity.z = CommonUtil.Vector3.forward.z * 0.3;
                    let dyCtrl = bomb.addComponent(DyanmicObjCtrl);
                    dyCtrl.setVelocityDir(this.linearVelocity);
                    dyCtrl.start();
                    Laya.timer.once(180, this, () => {
                        this.isThrowing = false;
                        this.isTouchBomb = false;
                        if (!this.logicalBaseLayer.getArmCtrl())
                            return;
                        if (this.logicalBaseLayer.getArmCtrl() && this.logicalBaseLayer.getArmCtrl().getType() != 8)
                            return;
                        if (this.logicalBaseLayer.magazineBullet <= 0)
                            return;
                        if (!this.isThrowBomb) {
                            if (this.logicalBaseLayer.bullets != 0) {
                                this.logicalBaseLayer.bullets--;
                                this.logicalBaseLayer.magazineBullet = 1;
                                this.logicalBaseLayer.getArmCtrl().curMagazineBullet = this.logicalBaseLayer.magazineBullet;
                                this.logicalBaseLayer.getArmCtrl().curBullets = this.logicalBaseLayer.bullets;
                            } else {
                                this.logicalBaseLayer.bullets = 0;
                                this.logicalBaseLayer.magazineBullet = 0;
                                this.logicalBaseLayer.getArmCtrl().curMagazineBullet = this.logicalBaseLayer.magazineBullet;
                                this.logicalBaseLayer.getArmCtrl().curBullets = this.logicalBaseLayer.bullets;
                                this.isThrowBomb = true;
                            }
                            this.logicalBaseLayer.bullets = 0;
                            this.logicalBaseLayer.magazineBullet = 0;
                            this.logicalBaseLayer.getArmCtrl().curMagazineBullet = this.logicalBaseLayer.magazineBullet;
                            this.logicalBaseLayer.getArmCtrl().curBullets = this.logicalBaseLayer.bullets;
                            this.isThrowBomb = true;
                            this.logicalBaseLayer.switchArm();
                            this.logicalBaseLayer.getArmCtrl().switchArm();
                            if (this.logicalBaseLayer.getIsMySelf()) {}
                        }
                    });
                });
            }
        }
        throwBombEnd(cb = null) {
            cb && cb();
            if (this.logicalBaseLayer.bullets != 0) {
                this.logicalBaseLayer.bullets--;
                this.logicalBaseLayer.magazineBullet = 1;
                this.logicalBaseLayer.getArmCtrl().curMagazineBullet = this.logicalBaseLayer.magazineBullet;
                this.logicalBaseLayer.getArmCtrl().curBullets = this.logicalBaseLayer.bullets;
            } else {
                this.logicalBaseLayer.bullets = 0;
                this.logicalBaseLayer.magazineBullet = 0;
                this.logicalBaseLayer.getArmCtrl().curMagazineBullet = this.logicalBaseLayer.magazineBullet;
                this.logicalBaseLayer.getArmCtrl().curBullets = this.logicalBaseLayer.bullets;
                this.isThrowBomb = true;
            }
            this.logicalBaseLayer.bullets = 0;
            this.logicalBaseLayer.magazineBullet = 0;
            this.logicalBaseLayer.getArmCtrl().curMagazineBullet = this.logicalBaseLayer.magazineBullet;
            this.logicalBaseLayer.getArmCtrl().curBullets = this.logicalBaseLayer.bullets;
            let bomb = this.cacheBombSp;
            let ctrl = bomb.getComponent(BombCtrl);
            let pos = bomb.transform.position.clone();
            GameScene.scene3d.addChild(bomb);
            bomb.transform.position = pos;
            this.isThrowing = false;
            this.isTouchBomb = false;
            this.isThrowBomb = true;
            this.logicalBaseLayer.switchArm();
            this.logicalBaseLayer.getArmCtrl().switchArm();
        }
        throwBombBefore(cb) {
            NotifyManager.notify(NOTIFY_ID.PLAY_UPPER_LIMB_ANI + this.eventId, {
                name: PLAY_ANI.ATTACK8_1
            });
            if (!this.logicalBaseLayer.getArmCtrl())
                return;
            let sphere = this.logicalBaseLayer.getArmCtrl().switchArm();
            sphere.addComponentIntance(new BombCtrl(this.logicalBaseLayer));
            this.cacheBombSp = sphere;
            console.log('扔出炸弹前');
            let bomb = this.cacheBombSp;
            let ctrl = bomb.getComponent(BombCtrl);
            this.bombSp = bomb;
            ctrl.isTouch = true;
            ctrl.aniEndTime = 200;
            ctrl.cb = () => {
                {
                    cb && cb();
                    this.throwBombEnd();
                }
            };
            this.isThrowing = true;
        }
        createBombModel() {
            if (!this.logicalBaseLayer.getArmCtrl())
                return;
            let sphere = this.logicalBaseLayer.getArmCtrl().switchArm();
            sphere.addComponentIntance(new BombCtrl(this.logicalBaseLayer));
            this.cacheBombSp = sphere;
        }
        resetBomb() {}
        getBombPoint() {
            if (!this.logicalBaseLayer.getIsMySelf())
                return;
            let bomb = this.cacheBombSp;
            if (!bomb) {
                if (!this.boxBomb) {
                    this.boxBomb = new Laya.Sprite3D();
                    this.boxBomb.transform.localPosition = CommonUtil.Vector3.zero.clone();
                    GameScene.scene3d.addChild(this.boxBomb);
                }
                this.boxBomb.removeChildren();
                return;
            }
            let ctrl = bomb.getComponent(BombCtrl);
            if (ctrl && ctrl.isTouch && ctrl.canThrow) {} else {
                if (!this.boxBomb) {
                    this.boxBomb = new Laya.Sprite3D();
                    this.boxBomb.transform.localPosition = CommonUtil.Vector3.zero.clone();
                    GameScene.scene3d.addChild(this.boxBomb);
                }
                this.boxBomb.removeChildren();
                return;
            }
            if (!this.boxBomb) {
                this.boxBomb = new Laya.Sprite3D();
                this.boxBomb.transform.localPosition = CommonUtil.Vector3.zero.clone();
                GameScene.scene3d.addChild(this.boxBomb);
            } else {
                this.boxBomb.removeChildren();
            }
            this.logicalBaseLayer.getPresentationBaseLayer().getOnceChild().transform.getForward(CommonUtil.Vector3.forward);
            Laya.Vector3.scale(CommonUtil.Vector3.forward, 17, CommonUtil.Vector3.forward);
            CommonUtil.Vector3.forward.x *= -1;
            CommonUtil.Vector3.forward.z *= -1;
            CommonUtil.Vector3.forward.y = this.logicalBaseLayer.getPresentationBaseLayer().getOnceChild().transform.rotationEuler.x - 12;
            CommonUtil.Vector3.forward.y *= -1;
            console.log('CommonUtil.Vector3.forward:', CommonUtil.Vector3.forward);
            this.linearVelocity.x = CommonUtil.Vector3.forward.x * 0.25;
            this.linearVelocity.y = CommonUtil.Vector3.forward.y * 0.35;
            this.linearVelocity.z = CommonUtil.Vector3.forward.z * 0.25;
            let yVel = this.linearVelocity.y;
            this.linearVelocity.y = 0;
            let xzVel = Vector3$a.scalarLength(this.linearVelocity);
            this.temVec.x = this.cacheBombSp.transform.position.x;
            this.temVec.y = this.cacheBombSp.transform.position.y - 0.1;
            this.temVec.z = this.cacheBombSp.transform.position.z;
            console.log(this.temVec);
            let fisrt = false;
            if (this.bomblist.length == 0) {
                fisrt = true;
            }
            for (let index = 0; index < 30; index++) {
                let y = yVel - (Laya.timer.delta * 0.01 * index * 3);
                this.vecTarget.x = this.temVec.x + xzVel * Laya.timer.delta * 0.01 * index * 0.1 * this.linearVelocity.x * 3;
                this.vecTarget.y = this.temVec.y + y * Laya.timer.delta * 0.01 * index * 0.1 * 3;
                this.vecTarget.z = this.temVec.z + xzVel * Laya.timer.delta * 0.01 * index * 0.1 * this.linearVelocity.z * 3;
                if (fisrt) {
                    let ori = ResourceManager.getRes(RES_PATH.WEAPON_PREFEB).getChildByName('Cube');
                    let shouliudan = CommonUtil.findChildByName(this.getModel(), 'shouliudan');
                    let newObj = Laya.Sprite3D.instantiate(ori, shouliudan);
                    let pos = newObj.transform.position.clone();
                    this.boxBomb.addChild(newObj);
                    newObj.transform.position = this.vecTarget.clone();
                    newObj.transform.localScaleX *= 5;
                    newObj.transform.localScaleY *= 5;
                    newObj.transform.localScaleZ *= 5;
                    this.bomblist.push(newObj);
                } else {
                    this.bomblist[index].transform.position = this.vecTarget.clone();
                    this.boxBomb.addChild(this.bomblist[index]);
                }
            }
        }
        AIToThrowTheArm() {
            if (ModeManager.mode != GAME_MODE_TYPE.ONEVSONEMODE)
                return;
            if (this.logicalBaseLayer.getIsMySelf())
                return;
            if (this.logicalBaseLayer.armCtrlList.length == 0)
                return;
            this.throwTheArmCount -= LogicTimer.gSysTimer.delta;
            if (this.logicalBaseLayer.getArmCtrl()) {
                if (this.logicalBaseLayer.bullets == 0) {
                    this.throwTheArmCount = RandomUtil.onlyOneRandomInt(12000, 20000);
                    this.logicalBaseLayer.removeTheGun();
                    return;
                }
            }
            if (this.throwTheArmCount < 0) {
                this.throwTheArmCount = RandomUtil.onlyOneRandomInt(12000, 20000);
                this.logicalBaseLayer.removeTheGun();
            }
        }
        modelSink(cb) {
            if (CharacterManger.gameOver)
                return;
            Laya.Tween.to(this.getOnceChild().transform, {
                localPositionY: this.getOnceChild().transform.localPositionY - 2
            }, 200, null, Laya.Handler.create(this, () => {
                if (CharacterManger.gameOver)
                    return;
                if (this.model) {
                    if (this.model.parent) {
                        this.model.active = false;
                    }
                }
            }), 3000);
            Laya.timer.once(5000, this, () => {
                if (CharacterManger.gameOver)
                    return;
                cb();
            });
        }
        setloatingBlood(num) {
            let item = null;
            for (let k = 0; k < this.floatingBloodList.length; k++) {
                let obj = this.floatingBloodList[k];
                if (!obj.isPlaying) {
                    let vec = this.getModelPosByVector3();
                    let dis = Laya.Vector3.distanceSquared(GameScene.camera.transform.position, this.getModelPosByVector3());
                    vec.x += dis > 100 ? 2 : 0;
                    vec.y += dis > 100 ? 4.5 : 3;
                    let pos = SceneManager.getCurScene().getViewportPoint(vec);
                    if (pos.w > 0.1) {
                        obj.x = pos.x;
                        obj.y = pos.y;
                        obj.scaleX = obj.scaleY = 1 / (dis * 1 / 2) * 10 <= 1 ? 1 / (dis * 1 / 2) * 10 : 1;
                        obj.scaleX = obj.scaleY = obj.scaleX * 0.85;
                    }
                    item = obj;
                    break;
                }
            }
            if (!item) {
                item = new FloatingbloodItemCtrl();
                UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).addChild(item);
                let vec = this.getModelPosByVector3();
                let dis = Laya.Vector3.distanceSquared(GameScene.camera.transform.position, this.getModelPosByVector3());
                vec.x += dis > 100 ? 2 : 0;
                vec.y += dis > 100 ? 3.5 : 3;
                let pos = SceneManager.getCurScene().getViewportPoint(vec);
                if (pos.w > 0.1) {
                    item.x = pos.x;
                    item.y = pos.y;
                    item.scaleX = item.scaleY = 1 / (dis * 1 / 2) * 10 <= 1 ? 1 / (dis * 1 / 2) * 10 : 1;
                    item.scaleX = item.scaleY = item.scaleX * 0.85;
                }
                this.floatingBloodList.push(item);
            }
            item.play(num);
        }
        floatingBloodMove() {
            let vec = this.getModelPosByVector3();
            let dis = Laya.Vector3.distance(GameScene.camera.transform.position, this.getModelPosByVector3());
            vec.x += dis > 10 ? 2 : 0;
            vec.y += dis > 10 ? 3.5 : 3;
            for (let k = 0; k < this.floatingBloodList.length; k++) {
                let obj = this.floatingBloodList[k];
                if (obj.isPlaying) {
                    let pos = SceneManager.getCurScene().getViewportPoint(vec);
                    if (pos.w > 0.1) {
                        obj.x = pos.x;
                        obj.y = pos.y;
                        obj.scaleX = obj.scaleY = 1 / (dis * 1 / 2) * 10 <= 1 ? 1 / (dis * 1 / 2) * 10 : 1;
                    }
                }
            }
        }
        setWaitingforrescueViewCtrl() {
            if (ModeManager.mode != GAME_MODE_TYPE.BIOCHEMISTRY)
                return;
            if (!this.waitingforrescueViewCtrl) {
                this.waitingforrescueViewCtrl = new WaitingforrescueViewCtrl();
                UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).addChild(this.waitingforrescueViewCtrl);
            }
            let vec = this.getModelPosByVector3();
            vec.y += 3;
            vec.x += 2;
            let pos = SceneManager.getCurScene().getViewportPoint(vec);
            if (pos.w > 0.1) {
                this.waitingforrescueViewCtrl.x = pos.x;
                this.waitingforrescueViewCtrl.y = pos.y;
                let dis = Laya.Vector3.distance(GameScene.camera.transform.position, this.getModelPosByVector3());
                this.waitingforrescueViewCtrl.scaleX = this.waitingforrescueViewCtrl.scaleY = 1 / (dis * 1 / 2) * 10 <= 1 ? 1 / (dis * 1 / 2) * 10 : 1;
            }
        }
        setVisibleWaitingforrescueViewCtrl(isVisisble) {
            if (ModeManager.mode != GAME_MODE_TYPE.BIOCHEMISTRY)
                return;
            if (this.waitingforrescueViewCtrl) {
                this.waitingforrescueViewCtrl.visible = isVisisble;
            }
        }
        zombieModeTeamDie() {
            if (ModeManager.mode != GAME_MODE_TYPE.BIOCHEMISTRY)
                return;
            if (this.logicalBaseLayer.isZombie)
                return;
            if (this.logicalBaseLayer.getIsMySelf())
                return;
            if (this.logicalBaseLayer.dieRealFromZombie) {
                this.setVisibleWaitingforrescueViewCtrl(false);
                return;
            };
            if (!this.logicalBaseLayer.getIsDie()) {
                if (this.rescuingSp) {
                    this.rescuingSp.active = false;
                }
                this.setVisibleWaitingforrescueViewCtrl(false);
                return;
            }
            if (this.lifeParentTran) {
                if (this.lifeParentTran.owner.active) {
                    this.lifeParentTran.owner.active = false;
                }
            }
            this.waitingCount -= LogicTimer.gSysTimer.delta;
            this.setResueDownCountDown();
            if (this.waitingCount < 0) {
                if (this.rescuingSp) {
                    this.rescuingSp.active = false;
                }
                this.logicalBaseLayer.dieRealFromZombie = true;
                this.setWaitingforrescueViewCtrl();
                this.setVisibleWaitingforrescueViewCtrl(false);
                return;
            }
            if (this && this.getModel()) {
                if (Vector3$a.distanceSquared(this.getModelPosByVector3(), CharacterManger.playerLogicalBaseLayer.getPresentationBaseLayer().getModelPosByVector3()) > 5 * 5) {
                    this.isRescuing = false;
                    this.isInterrupt = false;
                    this.setWaitingforrescueViewCtrl();
                    this.setVisibleWaitingforrescueViewCtrl(true);
                } else {
                    if (!this.isInterrupt) {
                        this.setWaitingforrescueViewCtrl();
                        this.setVisibleWaitingforrescueViewCtrl(false);
                    } else {
                        this.setWaitingforrescueViewCtrl();
                        this.setVisibleWaitingforrescueViewCtrl(true);
                    }
                }
            }
        }
        setResueDownCountDown() {
            if (!this.rescuingSp) {
                let ori = ResourceManager.getRes(RES_PATH.SKIN_PREFEB).getChildByName('life1');
                this.rescuingSp = Laya.Sprite3D.instantiate(ori, this.getOnceChild());
                this.rescuingSp.transform.localPosition = new Laya.Vector3(0, 3.25, 0);
                this.rescuingSp.name = 'resueSp';
            }
            this.rescuingSp.active = true;
            this.rescuingSp.transform.lookAt(CharacterManger.playerLogicalBaseLayer.getPresentationBaseLayer().getModelPosByVector3(), CommonUtil.Vector3.up, false);
            this.rescuingSp.getChildAt(1).transform.localScaleX = this.waitingCount >= 0 ? this.waitingCount / 30000 : 0;
        }
        setAnimatorDelay(delayFrame) {
            this.aniCtrl.lowUpdateDelty = delayFrame;
            if (this.separationAniCtrl)
                this.separationAniCtrl.lowUpdateDelty = delayFrame;
        }
        initRayCollider() {
            let box = [];
            CommonUtil.getAllChildrenByName(this.model, RAY_COLLIDER_NAME.BOX, box);
            this.rayBox = new CubeBoxCollider(box[0], false);
            let body = [];
            CommonUtil.getAllChildrenByName(this.model, RAY_COLLIDER_NAME.BODY, body);
            this.rayBody = new CubeBoxCollider(body[0], false);
            let head = [];
            CommonUtil.getAllChildrenByName(this.model, RAY_COLLIDER_NAME.HEAD, head);
            this.rayHead = new CubeBoxCollider(head[0], false);
            if (!this.logicalBaseLayer.getIsMySelf()) {
                let aim = [];
                CommonUtil.getAllChildrenByName(this.model, RAY_COLLIDER_NAME.AIM, aim);
                this.rayAim = new CubeBoxCollider(aim[0], false);
            }
        }
        getIntersectsRayAndEnemy(ray, isCheckWall = true) {
            let maxDis = Laya.MathUtils3D.MaxValue;
            let ret = null;
            for (let i = 0, len = CharacterManger.logicalBaseLayer.length; i < len; i++) {
                let logic = CharacterManger.logicalBaseLayer[i];
                if (this.logicalBaseLayer.getRoleType() != logic.getRoleType() && !logic.getIsDie()) {
                    let render = logic.getPresentationBaseLayer();
                    let dis = Laya.CollisionUtils.intersectsRayAndBoxRD(ray, render.rayBox.boundingBox);
                    if (dis > 0 && dis < maxDis) {
                        ret = render;
                        maxDis = dis;
                    }
                }
            }
            if (ret && isCheckWall) {
                let octree = CubePhysicsCompnent.getOCTree();
                let list = [];
                octree.getCollidingWithRayWithLayer(ray, list, maxDis, -2);
                for (let i = 0, len = list.length; i < len; i++) {
                    let collider = list[i];
                    if (collider.intersectsRay(ray, this.hitPoint) > 0) {
                        return null;
                    }
                }
            }
            return ret;
        }
        getIntersectsRayAndEnemyExact(ray, hitRes, isCheckWall = true) {
            let render = this.getIntersectsRayAndEnemy(ray, isCheckWall);
            if (render) {
                render.rayHead.updateTransfrom();
                let dis = Laya.CollisionUtils.intersectsRayAndBoxRP(ray, render.rayBody.boundingBox, this.hitPoint);
                if (dis > 0) {
                    this.myHitResult.collider = render.rayHead;
                    this.myHitResult.succeeded = true;
                    CharacterManger.hitLocation = HITLOCATION.HEAD;
                    this.hitPoint1.x = this.hitPoint.x;
                    this.hitPoint1.y = this.hitPoint.y;
                    this.hitPoint1.z = this.hitPoint.z;
                    return true;
                } else {
                    render.rayBody.updateTransfrom();
                    let dis = Laya.CollisionUtils.intersectsRayAndBoxRP(ray, render.rayBody.boundingBox, this.hitPoint);
                    if (dis > 0) {
                        this.myHitResult.collider = render.rayBody;
                        this.myHitResult.succeeded = true;
                        let pos = render.rayBody.owner.transform.position;
                        let legPosY = pos.y + 0.2;
                        let armPosY = pos.y + 0.6;
                        if (this.hitPoint.y > armPosY) {
                            CharacterManger.hitLocation = HITLOCATION.ARM;
                        } else if (this.hitPoint.y > legPosY) {
                            CharacterManger.hitLocation = HITLOCATION.BODY;
                        } else {
                            CharacterManger.hitLocation = HITLOCATION.LEG;
                        }
                        this.hitPoint1.x = this.hitPoint.x;
                        this.hitPoint1.y = this.hitPoint.y;
                        this.hitPoint1.z = this.hitPoint.z;
                        return true;
                    }
                    this.myHitResult.succeeded = false;
                    this.myHitResult.collider = null;
                    return false;
                }
            } else {
                this.myHitResult.succeeded = false;
                this.myHitResult.collider = null;
                return false;
            }
        }
        getIntersectsRayAndEnemyAim(ray, isCheckWall = true) {
            let maxDis = Laya.MathUtils3D.MaxValue;
            let ret = null;
            for (let i = 0, len = CharacterManger.logicalBaseLayer.length; i < len; i++) {
                let logic = CharacterManger.logicalBaseLayer[i];
                if (this.logicalBaseLayer.getRoleType() != logic.getRoleType() && !logic.getIsDie()) {
                    let render = logic.getPresentationBaseLayer();
                    if (!render.logicalBaseLayer.getIsDie()) {
                        render.rayAim.updateTransfrom();
                        let dis = Laya.CollisionUtils.intersectsRayAndBoxRD(ray, render.rayAim.boundingBox);
                        if (dis > 0 && dis < maxDis) {
                            ret = render;
                            maxDis = dis;
                        }
                    }
                }
            }
            if (ret && isCheckWall) {
                let octree = CubePhysicsCompnent.getOCTree();
                let list = [];
                octree.getCollidingWithRayWithLayer(ray, list, maxDis, -2);
                for (let i = 0, len = list.length; i < len; i++) {
                    let collider = list[i];
                    if (collider.intersectsRay(ray, this.hitPoint) > 0) {
                        return null;
                    }
                }
            }
            return ret;
        }
        isCollidingsRayAndWall(ray, distance) {
            let octree = CubePhysicsCompnent.getOCTree();
            let list = [];
            octree.getCollidingWithRayWithLayer(ray, list, distance, -2);
            for (let i = 0, len = list.length; i < len; i++) {
                let collider = list[i];
                if (collider.intersectsRay(ray, this.hitPoint) > 0) {
                    return true;
                }
            }
            return false;
        }
        clean() {
            Laya.timer.clearAll(this);
            this.unregisterEvent();
            if (this.doubleKillItemCtrl)
                this.doubleKillItemCtrl.destroy();
            if (this.gamingHeadCtrl)
                this.gamingHeadCtrl.destroy();
            if (this.headshotCtrl)
                this.headshotCtrl.destroy();
            if (this.boxGhost)
                this.boxGhost.destroy();
            if (this.invincibleProCtrl)
                this.invincibleProCtrl.destroy();
            this.aniCtrl = null;
            this.bombEffectPos = null;
            this.buoy = null;
            this.eventId = null;
            if (this.characterCtrl)
                this.characterCtrl.destroy();
            this.characterCtrl = null;
            this.point = null;
            this._ray = null;
            this.myHitResult = null;
            this.perAttackTime = null;
            this.upperlimbName = null;
            this.thelegsName = null;
            this.boxGhost = null;
            this.headshotCtrl = null;
            this.gamingHeadCtrl = null;
            this.invincibleProCtrl = null;
            this.invincibleProCount = null;
            this.invincibleProCountMax = null;
            this.shieldSp = null;
            this.isCanPlayAttackAni = null;
            this.isStartJump = null;
            this.isStartPlayAttackAni = null;
            this.attackDownCount = null;
            this.navNode = null;
            this._isCollise = null;
            this.flyUp = null;
            this.flyDown = null;
            if (this.fireEffect)
                EffectManger.recycleEffect(this.fireEffect);
            this.fireEffect = null;
            this.fireRecycleCountDown = null;
            this.vecShtoPos = null;
            this.vecShotEndPos = null;
            this.muzzleTran = null;
            this.isTouchBomb = null;
            this.isThrowBomb = null;
            if (this.bombSp)
                this.bombSp.destroy();
            if (this.cacheBombSp)
                this.cacheBombSp.destroy();
            this.gravity = null;
            this.mass = null;
            this.linearVelocity = null;
            this.bombSp = null;
            this.cacheBombSp = null;
            this.doubleKillItemCtrl = null;
            this.model = null;
            this.floatingBloodList = null;
        }
        getIsDie() {
            return this.logicalBaseLayer.getIsDie();
        }
        playFootSound() {
            if (this.isFootSound)
                return;
            this.isFootSound = true;
            let time = 772;
            if (this.footSoundIndex % SOUND_PATH.FOOT.length == 1) {
                time = 872;
            }
            Laya.timer.once(time, this, () => {
                this.isFootSound = false;
            });
            SoundManager.playEffect3D(SOUND_PATH.FOOT[this.footSoundIndex % SOUND_PATH.FOOT.length], this.getModelPosByVector3());
            this.footSoundIndex += 1;
        }
        closeMark() {
            if (this.logicalBaseLayer.getRoleType() == ROLE_TYPE.TYPE_1) {
                let node = CommonUtil.findChildByName(this.model, 'jiaobiao');
                node.active = false;
            }
        }
        openMark() {
            if (this.logicalBaseLayer.getRoleType() == ROLE_TYPE.TYPE_1) {
                let node = CommonUtil.findChildByName(this.model, 'jiaobiao');
                node.active = true;
            }
        }
    }
    PresentationBaseLayer.sound3dCount = 0;

    var Vector3$b = Laya.Vector3;
    var Quaternion$1 = Laya.Quaternion;
    class LogicalBaseLayer {
        constructor(_isMySelf = false, _roleType, model, intoID = 1000, isZombie = false) {
            this.eventId = null;
            this.speed = 0;
            this.initPos = new Vector3$b();
            this.myOrientation = new Vector3$b();
            this.isDie = false;
            this.eulerAngle = new Vector3$b();
            this.rotatingQuaternion = new Quaternion$1();
            this.oldX = 0;
            this.oldY = null;
            this.isMoving = false;
            this.HP = 100;
            this.maxHP = 100;
            this.curArmor = 100;
            this.maxArmor = 100;
            this.isTouchAttack = false;
            this.isAttack = false;
            this._isMySelf = false;
            this.presentationBaseLayer = null;
            this.armCtrl = null;
            this.paths = null;
            this.attackLogicalBaseLayer = null;
            this.killerLogicalBaseLayer = null;
            this.magazineBullet = 0;
            this.bullets = 0;
            this.isStartHuaBullet = false;
            this.isRevive = false;
            this.isCrouch = false;
            this.isAutoAttack = true;
            this.isFirstGun = true;
            this.gameName = '精英';
            this.isInvincible = false;
            this.isStartAttack = false;
            this.isOpenMioing = false;
            this.armCtrlList = [];
            this.playerKillCount = 0;
            this.playerBeKillCount = 0;
            this.score = 0;
            this.head = '';
            this.doubleHit = 0;
            this.intoID = 0;
            this.isResetSearched = false;
            this.curPointCtrl = null;
            this.skinType = 1;
            this.doubleKill = 0;
            this.isResetDoubleKill = false;
            this.doubleKillTime = 10000;
            this.maxDoubleKill = 0;
            this.isStartDoubleKill = false;
            this.knifePropList = [];
            this.curKnifeProp = null;
            this.isZombie = false;
            this.isGetBombLast = false;
            this.dieRealFromZombie = false;
            this.freeReviveNum = 3;
            this.vecDir = new Vector3$b();
            this.aimAssistCount = 2000;
            this.curSkin = '001';
            this.doubleClasses = 1;
            this.headShotHit = 0;
            this.headShotClasses = 1;
            this.isStartHeadShotDoubleKill = false;
            this.headKillTime = 10000;
            this.temV3 = new Vector3$b();
            this.isSwitching = false;
            this.isStartSwitchCount = 750;
            this.randID = null;
            this.tar = 3;
            this.testV = new Laya.Quaternion();
            model.transform.localRotationEuler = new Laya.Vector3(0, 0, 0);
            if (!_isMySelf) {
                this.speed = 0.000001;
                this.isAutoAttack = true;
            }
            this.intoID = intoID;
            this.eventId = Laya.Utils.getGID();
            this.curSkin = CharacterManger.drSkinList[this.intoID] ? CharacterManger.drSkinList[this.intoID] : '001';
            if (!_isMySelf) {
                let num = RandomUtil.onlyOneRandomInt(0, DataAvatar.length - 1);
                if (DataAvatar[num]) {
                    this.gameName = DataAvatar[num].nick;
                    this.head = DataAvatar[num].avatar;
                } else {
                    let num1 = RandomUtil.onlyOneRandomInt(0, this.cacheAvatar().length - 1);
                    this.gameName = this.cacheAvatar()[num1].nick;
                    this.head = this.cacheAvatar()[num1].avatar;
                }
            } else {
                this.gameName = '我';
                this.skinType = RoleData.getDataByKey(RoleManager.getInstance().getSelectRoleSkin()).camp;
            }
            this.isZombie = isZombie;
            this._isMySelf = _isMySelf;
            this.roleType = _roleType;
            this.isStartHuaBullet = false;
            if (this.isZombie) {
                this.HP = 700;
                this.maxHP = 700;
            } else {
                if (this._isMySelf) {
                    this.HP = 100 + Math.floor(100 * BuffManager.hpGain / 100);
                    this.maxHP = 100 + Math.floor(100 * BuffManager.hpGain / 100);
                }
            }
            this.setInitPos(model.transform.position.clone());
            this.presentationBaseLayer = new PresentationBaseLayer(this.eventId, model, this);
            this.armsCtrl();
            this.addNameAndHead();
            CharacterManger.addLogicalBaseLayer(this);
        }
        cacheAvatar() {
            let list = [{
                    "id": 1,
                    "avatar": "sub1/avatar/i1.jpg",
                    "nick": "逆光",
                    "type": 1
                },
                {
                    "id": 2,
                    "avatar": "sub1/avatar/i2.jpg",
                    "nick": "暖风昔人",
                    "type": 1
                },
                {
                    "id": 3,
                    "avatar": "sub1/avatar/i3.jpg",
                    "nick": "柠檬",
                    "type": 1
                },
                {
                    "id": 4,
                    "avatar": "sub1/avatar/i4.jpg",
                    "nick": "格子的夏天",
                    "type": 1
                },
                {
                    "id": 5,
                    "avatar": "sub1/avatar/i5.jpg",
                    "nick": "冰雨忧蓝",
                    "type": 1
                },
                {
                    "id": 6,
                    "avatar": "sub1/avatar/i6.jpg",
                    "nick": "何以心动",
                    "type": 1
                },
                {
                    "id": 7,
                    "avatar": "sub1/avatar/i7.jpg",
                    "nick": "眷恋",
                    "type": 1
                },
                {
                    "id": 8,
                    "avatar": "sub1/avatar/i8.jpg",
                    "nick": "琼窗梦回",
                    "type": 1
                },
                {
                    "id": 9,
                    "avatar": "sub1/avatar/i9.jpg",
                    "nick": "紫竹語嫣",
                    "type": 1
                },
                {
                    "id": 10,
                    "avatar": "sub1/avatar/i10.jpg",
                    "nick": "终陌。",
                    "type": 1
                },
                {
                    "id": 11,
                    "avatar": "sub1/avatar/i11.jpg",
                    "nick": "柒月。",
                    "type": 1
                },
                {
                    "id": 12,
                    "avatar": "sub1/avatar/i12.jpg",
                    "nick": "三分注定",
                    "type": 1
                },
                {
                    "id": 13,
                    "avatar": "sub1/avatar/i13.jpg",
                    "nick": "七分饶幸",
                    "type": 1
                },
                {
                    "id": 14,
                    "avatar": "sub1/avatar/i14.jpg",
                    "nick": "琉璃梦幻",
                    "type": 1
                },
                {
                    "id": 15,
                    "avatar": "sub1/avatar/i15.jpg",
                    "nick": "让我眼熟你.",
                    "type": 1
                },
                {
                    "id": 16,
                    "avatar": "sub1/avatar/i16.jpg",
                    "nick": "傲娇萝莉攻",
                    "type": 1
                },
                {
                    "id": 17,
                    "avatar": "sub1/avatar/i17.jpg",
                    "nick": "一笑百媚生",
                    "type": 1
                },
                {
                    "id": 18,
                    "avatar": "sub1/avatar/i18.jpg",
                    "nick": "yoyo",
                    "type": 1
                },
                {
                    "id": 19,
                    "avatar": "sub1/avatar/i19.jpg",
                    "nick": "厌世.",
                    "type": 1
                },
                {
                    "id": 20,
                    "avatar": "sub1/avatar/i20.jpg",
                    "nick": "闲身",
                    "type": 1
                },
                {
                    "id": 21,
                    "avatar": "sub1/avatar/i21.jpg",
                    "nick": "好甜",
                    "type": 1
                },
                {
                    "id": 22,
                    "avatar": "sub1/avatar/i22.jpg",
                    "nick": "服软",
                    "type": 1
                },
                {
                    "id": 23,
                    "avatar": "sub1/avatar/i23.jpg",
                    "nick": "矫情",
                    "type": 1
                },
                {
                    "id": 24,
                    "avatar": "sub1/avatar/i24.jpg",
                    "nick": "人皮目录",
                    "type": 1
                },
                {
                    "id": 25,
                    "avatar": "sub1/avatar/i25.jpg",
                    "nick": "水晶透心",
                    "type": 1
                },
                {
                    "id": 26,
                    "avatar": "sub1/avatar/i26.jpg",
                    "nick": "海螺姑娘",
                    "type": 1
                },
                {
                    "id": 27,
                    "avatar": "sub1/avatar/i27.jpg",
                    "nick": "懵逼小萝莉",
                    "type": 1
                },
                {
                    "id": 28,
                    "avatar": "sub1/avatar/i28.jpg",
                    "nick": "无字情书",
                    "type": 1
                },
                {
                    "id": 29,
                    "avatar": "sub1/avatar/i29.jpg",
                    "nick": "一世浮沉",
                    "type": 1
                },
                {
                    "id": 30,
                    "avatar": "sub1/avatar/i30.jpg",
                    "nick": "与君绝",
                    "type": 1
                },
                {
                    "id": 31,
                    "avatar": "sub1/avatar/i31.jpg",
                    "nick": "画骨i",
                    "type": 1
                },
                {
                    "id": 32,
                    "avatar": "sub1/avatar/i32.jpg",
                    "nick": "初心",
                    "type": 1
                },
                {
                    "id": 33,
                    "avatar": "sub1/avatar/i33.jpg",
                    "nick": "浪漫人生路",
                    "type": 2
                },
                {
                    "id": 34,
                    "avatar": "sub1/avatar/i34.jpg",
                    "nick": "倾听者",
                    "type": 2
                },
                {
                    "id": 35,
                    "avatar": "sub1/avatar/i35.jpg",
                    "nick": "荒人说梦",
                    "type": 2
                },
                {
                    "id": 36,
                    "avatar": "sub1/avatar/i36.jpg",
                    "nick": "川水往事",
                    "type": 2
                },
                {
                    "id": 37,
                    "avatar": "sub1/avatar/i37.jpg",
                    "nick": "羁客",
                    "type": 2
                }
            ];
            return list;
        }
        addNameAndHead() {
            if (!this._isMySelf) {
                if (this.roleType == ROLE_TYPE.TYPE_0) {
                    let item = CharacterManger.outDataList[this.intoID];
                    if (item) {
                        if (!item.isUse) {
                            item.isUse = true;
                            this.head = item.data.avatar;
                            this.gameName = item.data.nick;
                        }
                    } else {
                        let num = RandomUtil.onlyOneRandomInt(0, DataAvatar.length - 1);
                        if (DataAvatar[num]) {
                            this.head = DataAvatar[num].avatar;
                            this.gameName = DataAvatar[num].nick;
                        }
                    }
                } else if (this.roleType == ROLE_TYPE.TYPE_1) {
                    let item = CharacterManger.enemyDataList[this.intoID];
                    if (item) {
                        if (!item.isUse) {
                            item.isUse = true;
                            this.head = item.data.avatar;
                            this.gameName = item.data.nick;
                        }
                    } else {
                        let num = RandomUtil.onlyOneRandomInt(0, DataAvatar.length - 1);
                        if (DataAvatar[num]) {
                            this.head = DataAvatar[num].avatar;
                            this.gameName = DataAvatar[num].nick;
                        }
                    }
                }
                if (ConfigManager.platform == PLATFORM_TYPE.WEB_4399) {
                    this.gameName = '4399玩家' + Laya.Utils.getGID();
                    this.head = 'sub1/ui/common/img_4399_' + Math.floor(Mathf.random(4, 1)).toString() + '.png';
                }
            } else {
                if (ConfigManager.platform == PLATFORM_TYPE.WEB_4399) {
                    this.head = 'sub1/ui/common/img_4399_1.png';
                }
            }
        }
        init() {
            this.magazineBullet = this.armCtrl.getMagazineBullet();
            this.bullets = this.armCtrl.getBullets();
        }
        getEventID() {
            return this.eventId;
        }
        setInitPos(pos) {
            this.initPos = pos;
        }
        getInitPos() {
            if (!this.presentationBaseLayer)
                return;
            if (ModeManager.mode == GAME_MODE_TYPE.ONEVSONEMODE) {
                if (this.roleType == ROLE_TYPE.TYPE_0) {
                    return GameRoleCreateManager.rolePos.team[RandomUtil.onlyOneRandomInt(0, GameRoleCreateManager.rolePos.team.length)];
                } else {
                    return GameRoleCreateManager.rolePos.enemy[RandomUtil.onlyOneRandomInt(0, GameRoleCreateManager.rolePos.enemy.length)];
                }
            } else if (ModeManager.mode == GAME_MODE_TYPE.BIOCHEMISTRY) {
                if (!this._isMySelf) {
                    return this.presentationBaseLayer.getModelPosByVector3();
                }
            }
            return this.initPos;
        }
        pickUpTheGun(name) {
            if (this._isMySelf) {
                SoundManager.playEffect(SOUND_PATH.COMPOND);
            }
            if (this.armCtrlList.length == 1) {
                if (this.getArmCtrl().getType() == 8) {
                    if (this.getArmCtrl().curBullets == 0) {
                        if (name == '8001') {
                            let obj = this.armCtrl.switchArm();
                            this.magazineBullet = this.getArmCtrl().getMagazineBullet();
                            this.bullets = this.getArmCtrl().getBullets();
                            this.getArmCtrl().curMagazineBullet = this.getArmCtrl().getMagazineBullet();
                            this.getArmCtrl().curBullets = this.getArmCtrl().getBullets();
                            this.presentationBaseLayer.isThrowBomb = false;
                            this.presentationBaseLayer.isTouchBomb = true;
                            if (!this.presentationBaseLayer.cacheBombSp) {
                                obj.addComponentIntance(new BombCtrl(this));
                                this.presentationBaseLayer.bombSp = obj;
                            } else {
                                this.presentationBaseLayer.cacheBombSp.addComponentIntance(new BombCtrl(this));
                                this.presentationBaseLayer.bombSp = this.presentationBaseLayer.cacheBombSp;
                            }
                            if (this._isMySelf)
                                NotifyManager.notify(NOTIFY_ID.REFRESH_MAIN_ARM);
                            return;
                        }
                    }
                }
            }
            for (let k = 0; k < ARM.keys.length; k++) {
                let item = ARM.getDataByKey(ARM.keys[k]);
                if (item.objName == name) {
                    let obj = new ArmCtrl(this, ARM.keys[k], true);
                    this.armCtrlList.push(obj);
                }
            }
            for (let k = 0; k < PROP.keys.length; k++) {
                let item = PROP.getDataByKey(PROP.keys[k]);
                if (item.objName == name) {
                    let obj = new ArmCtrl(this, PROP.keys[k], false);
                    this.armCtrlList.push(obj);
                }
            }
            if (this.armCtrlList.length == 2) {
                if (this.armCtrlList[0].getType() == 8) {
                    const a = this.armCtrlList[1];
                    this.armCtrlList[1] = this.armCtrlList[0];
                    this.armCtrlList[0] = a;
                }
            }
            if (this.armCtrlList.length != 0) {
                this.armCtrl = this.armCtrlList[0];
                let obj = this.armCtrl.switchArm();
                this.magazineBullet = this.armCtrl.curMagazineBullet;
                this.bullets = this.armCtrl.curBullets;
                if (this.armCtrl.getType() == 8) {
                    this.isGetBombLast = true;
                    this.presentationBaseLayer.isThrowBomb = false;
                    this.presentationBaseLayer.isTouchBomb = true;
                    if (!this.presentationBaseLayer.cacheBombSp) {
                        obj.addComponentIntance(new BombCtrl(this));
                        this.presentationBaseLayer.bombSp = obj;
                    } else {
                        this.presentationBaseLayer.cacheBombSp.addComponentIntance(new BombCtrl(this));
                        this.presentationBaseLayer.bombSp = this.presentationBaseLayer.cacheBombSp;
                    }
                } else {
                    this.presentationBaseLayer.isThrowBomb = false;
                    this.presentationBaseLayer.isTouchBomb = false;
                    this.isGetBombLast = false;
                }
                if (this._isMySelf) {
                    if (this.armCtrl.getType() == 3) {
                        UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).btnLeftAttack.visible = false;
                    } else {
                        UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).btnLeftAttack.visible = true;
                    }
                    UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).pickUpTheGun();
                    UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).btnRightAttack.skin = CharacterManger.playerLogicalBaseLayer.getArmCtrl().getType() == 8 ? RES_PATH.BOMB_UI.TOUCH : RES_PATH.ATTACK_UI.TOUCH;
                    UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).btnLeftAttack.getChildAt(0).skin = CharacterManger.playerLogicalBaseLayer.getArmCtrl().getType() == 8 ? RES_PATH.BOMB_UI.TOUCH : RES_PATH.ATTACK_UI.TOUCH;
                }
            }
        }
        switchArm() {
            if (this.armCtrlList.length >= 2) {
                if (this.getArmCtrl().getType() == ARM_TYPE.BOMB) {
                    if (this.getArmCtrl().curBullets == 0) {
                        for (let k = 0; k < this.armCtrlList.length; k++) {
                            if (this.armCtrlList[k].getType() == ARM_TYPE.BOMB) {
                                this.armCtrlList.splice(k, 1);
                            }
                        }
                        if (this._isMySelf) {
                            UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).curIndex = 0;
                            UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).pickUpTheGun();
                            UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).onArmSelect(0);
                            UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).changeAttackSkin();
                        }
                        for (let k in this.armCtrlList) {
                            let obj = this.armCtrlList[k];
                            if (obj.getType() != ARM_TYPE.BOMB) {
                                this.armCtrl = obj;
                                this.magazineBullet = this.armCtrl.curMagazineBullet;
                                this.bullets = this.armCtrl.curBullets;
                                if (this._isMySelf) {
                                    UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).curIndex = parseInt(k);
                                    UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).onArmSelect(UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).curIndex);
                                    UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).changeAttackSkin();
                                }
                                break;
                            }
                        }
                    }
                }
            } else {
                if (ModeManager.mode == GAME_MODE_TYPE.ONEVSONEMODE) {
                    for (let k = 0; k < this.armCtrlList.length; k++) {
                        if (this.armCtrlList[k].getType() == 8) {
                            this.getArmCtrl().clearArm();
                            this.armCtrlList.splice(k, 1);
                            if (this._isMySelf) {
                                UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).curIndex = 0;
                                UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).pickUpTheGun();
                            }
                        }
                    }
                }
            }
        }
        removeTheGun() {
            this.getArmCtrl().clearArm();
            this.armCtrlList = [];
            this.armCtrl = null;
        }
        removeTheGunByJudge() {
            if (this.armCtrlList.length >= 2) {
                for (let k = 0; k < this.armCtrlList.length; k++) {
                    if (this.armCtrlList[k].id == this.armCtrl.id) {
                        this.armCtrlList.splice(k, 1);
                        if (this._isMySelf) {
                            UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).curIndex = 0;
                            UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).pickUpTheGun();
                            UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).onArmSelect(UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).curIndex);
                        }
                    }
                }
                this.armCtrl = this.armCtrlList[0];
                let obj = this.armCtrl.switchArm();
                this.magazineBullet = this.armCtrl.curMagazineBullet;
                this.bullets = this.armCtrl.curBullets;
                if (this.armCtrl.getType() == 8) {
                    this.isGetBombLast = true;
                    this.presentationBaseLayer.isThrowBomb = false;
                    this.presentationBaseLayer.isTouchBomb = true;
                    if (!this.presentationBaseLayer.cacheBombSp) {
                        obj.addComponentIntance(new BombCtrl(this));
                        this.presentationBaseLayer.bombSp = obj;
                    } else {
                        this.presentationBaseLayer.cacheBombSp.addComponentIntance(new BombCtrl(this));
                        this.presentationBaseLayer.bombSp = this.presentationBaseLayer.cacheBombSp;
                    }
                } else {
                    this.presentationBaseLayer.isThrowBomb = false;
                    this.presentationBaseLayer.isTouchBomb = false;
                    this.isGetBombLast = false;
                }
            } else {
                this.getArmCtrl().clearArm();
                this.armCtrlList = [];
                this.armCtrl = null;
            }
        }
        armsCtrl() {
            this.modeCtrl();
        }
        modeCtrl() {
            if (ModeManager.mode == GAME_MODE_TYPE.SNIPERMODE || ModeManager.mode == GAME_MODE_TYPE.KNIFEWARMODE) {
                this.doubleKillTime = 40000;
            } else {
                this.doubleKillTime = 10000;
            }
            if (this._isMySelf) {
                let gameCurLib = RoleManager.getInstance().getSkinGameCurLib();
                for (var i = 0; i < gameCurLib.length; i++) {
                    if (gameCurLib[i] === RoleManager.getInstance().getSelectSkin()) {
                        gameCurLib.splice(i, 1);
                        break;
                    }
                }
                gameCurLib.unshift(RoleManager.getInstance().getSelectSkin());
                let propGameCueLib = RoleManager.getInstance().getGameCurPropLib();
                if (ModeManager.mode == GAME_MODE_TYPE.TEAMCOMPETITION || ModeManager.mode == GAME_MODE_TYPE.TWOVSTWOMODE) {
                    if (ModeManager.mode == GAME_MODE_TYPE.TEAMCOMPETITION) {
                        if (this._isMySelf) {
                            if (RoleManager.getInstance().getGuide() == GuideStep.GAME_1) {
                                RoleManager.getInstance().trialArm = 43;
                            }
                        }
                    }
                    let num = 0;
                    if (RoleManager.getInstance().trialArm != null) {
                        if (gameCurLib.length == 1) {
                            let obj = new ArmCtrl(this, RoleManager.getInstance().trialArm, true);
                            this.armCtrlList.push(obj);
                            RoleManager.getInstance().trialArm = null;
                        } else {
                            num = 1;
                            let obj = new ArmCtrl(this, RoleManager.getInstance().trialArm, true);
                            this.armCtrlList.push(obj);
                            RoleManager.getInstance().trialArm = null;
                        }
                    }
                    for (let k = 0; k < gameCurLib.length - num; k++) {
                        let obj = new ArmCtrl(this, gameCurLib[k], true);
                        this.armCtrlList.push(obj);
                    }
                    for (let k = propGameCueLib.length - 1; k >= 0; k--) {
                        let obj = new ArmCtrl(this, propGameCueLib[k], false);
                        this.armCtrlList.push(obj);
                    }
                } else if (ModeManager.mode == GAME_MODE_TYPE.SNIPERMODE || ModeManager.mode == GAME_MODE_TYPE.ONEVSONEMODE) {
                    let num = 0;
                    if (RoleManager.getInstance().trialArm != null) {
                        if (gameCurLib.length == 1) {
                            let obj = new ArmCtrl(this, RoleManager.getInstance().trialArm, true);
                            this.armCtrlList.push(obj);
                            RoleManager.getInstance().trialArm = null;
                        } else {
                            num = 1;
                            let obj = new ArmCtrl(this, RoleManager.getInstance().trialArm, true);
                            this.armCtrlList.push(obj);
                            RoleManager.getInstance().trialArm = null;
                        }
                    }
                } else if (ModeManager.mode == GAME_MODE_TYPE.BIOCHEMISTRY) {
                    let num = 0;
                    if (RoleManager.getInstance().trialArm != null) {
                        if (gameCurLib.length == 1) {
                            let obj = new ArmCtrl(this, RoleManager.getInstance().trialArm, true);
                            this.armCtrlList.push(obj);
                            RoleManager.getInstance().trialArm = null;
                        } else {
                            num = 1;
                            let obj = new ArmCtrl(this, RoleManager.getInstance().trialArm, true);
                            this.armCtrlList.push(obj);
                            RoleManager.getInstance().trialArm = null;
                        }
                    }
                    for (let k = 0; k < gameCurLib.length - num; k++) {
                        let obj = new ArmCtrl(this, gameCurLib[k], true);
                        this.armCtrlList.push(obj);
                    }
                    for (let k = propGameCueLib.length - 1; k >= 0; k--) {
                        let obj = new ArmCtrl(this, propGameCueLib[k], false);
                        this.armCtrlList.push(obj);
                    }
                } else if (ModeManager.mode == GAME_MODE_TYPE.KNIFEWARMODE) {
                    for (let k = 0; k < propGameCueLib.length; k++) {
                        if (PROP.getDataByKey(propGameCueLib[k]).type == 2) {
                            let obj = new ArmCtrl(this, propGameCueLib[k], false);
                            this.armCtrlList.push(obj);
                        }
                    }
                }
                if (this.armCtrlList.length != 0) {
                    this.armCtrl = this.armCtrlList[0];
                    this.armCtrl.switchArm();
                    this.magazineBullet = this.armCtrl.curMagazineBullet;
                    this.bullets = this.armCtrl.curBullets;
                }
            } else {
                if (ModeManager.mode == GAME_MODE_TYPE.TEAMCOMPETITION || ModeManager.mode == GAME_MODE_TYPE.TWOVSTWOMODE) {
                    let id = ARM.keys[RandomUtil.onlyOneRandomInt(0, ARM.keys.length)];
                    let obj = new ArmCtrl(this, id);
                    this.armCtrlList.push(obj);
                } else if (ModeManager.mode == GAME_MODE_TYPE.SNIPERMODE) {} else if (ModeManager.mode == GAME_MODE_TYPE.BIOCHEMISTRY) {
                    if (this.getRoleType() == ROLE_TYPE.TYPE_0) {
                        let obj = new ArmCtrl(this, ARM.keys[RandomUtil.onlyOneRandomInt(0, ARM.keys.length)]);
                        this.armCtrlList.push(obj);
                    }
                } else if (ModeManager.mode == GAME_MODE_TYPE.KNIFEWARMODE) {
                    let obj = new ArmCtrl(this, 2001, false);
                    this.armCtrlList.push(obj);
                }
                if (this.armCtrlList.length != 0) {
                    this.armCtrl = this.armCtrlList[0];
                    this.armCtrl.switchArm();
                    this.magazineBullet = this.armCtrl.curMagazineBullet;
                    this.bullets = this.armCtrl.curBullets;
                }
            }
        }
        resetArmList() {
            let isHaveBomb = false;
            for (let k in this.armCtrlList) {
                this.armCtrlList[k].curMagazineBullet = this.armCtrlList[k].getMagazineBullet();
                this.armCtrlList[k].curBullets = this.armCtrlList[k].getBullets();
                if (this.armCtrlList[k].getType() == ARM_TYPE.BOMB) {
                    isHaveBomb = true;
                }
            }
            if (this._isMySelf) {
                if (ModeManager.mode != GAME_MODE_TYPE.ONEVSONEMODE && ModeManager.mode != GAME_MODE_TYPE.KNIFEWARMODE && ModeManager.mode != GAME_MODE_TYPE.SNIPERMODE) {
                    if (!isHaveBomb) {
                        let obj = new ArmCtrl(this, 8001, false);
                        this.armCtrlList.push(obj);
                    }
                }
                UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).setData();
            }
        }
        chooseArm(index) {
            this.presentationBaseLayer.playUpperlimbAniQZ(PLAY_ANI.IDLE);
            this.isStartSwitchCount = 50;
            this.armCtrl = this.armCtrlList[index];
            this.magazineBullet = this.armCtrl.curMagazineBullet;
            this.bullets = this.armCtrl.curBullets;
            let soundIndex = this.armCtrl.getType();
            if (soundIndex != 1 && soundIndex != 2 && soundIndex != 4 && soundIndex != 8) {
                soundIndex = 1;
            }
            SoundManager.playEffect(SOUND_PATH.SWITCH_ARM.ROOT + soundIndex + '.mp3');
            if (!this.isSwitching) {
                console.log('开始换枪倒计时');
                Laya.timer.loop(1, this, function cd1() {
                    if (this.isStartSwitchCount == 0) {
                        this.isSwitching = false;
                        console.log('换枪结束');
                        Laya.timer.clear(this, cd1);
                    }
                    this.isStartSwitchCount--;
                });
            }
            Laya.timer.once(200, this, function cd() {
                let obj = this.armCtrl.switchArm();
                this.presentationBaseLayer.isTouchBomb = false;
                if (this.armCtrl.getType() == 3) {
                    UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).btnLeftAttack.visible = false;
                } else {
                    UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).btnLeftAttack.visible = true;
                }
                if (this.armCtrl.getType() == ARM_TYPE.HAND_GUN) {
                    UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).quasiCenter1.visible = true;
                    UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).quasiCenter.visible = false;
                } else {
                    UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).quasiCenter1.visible = false;
                    UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).quasiCenter.visible = true;
                }
                if (this.armCtrl.getType() == 8) {
                    this.presentationBaseLayer.isTouchBomb = true;
                    if (!this.presentationBaseLayer.cacheBombSp) {
                        obj.addComponentIntance(new BombCtrl(this));
                        this.presentationBaseLayer.bombSp = obj;
                    } else {
                        this.presentationBaseLayer.cacheBombSp.addComponentIntance(new BombCtrl(this));
                        this.presentationBaseLayer.bombSp = this.presentationBaseLayer.cacheBombSp;
                    }
                }
                UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).changeAttackSkin();
                Laya.timer.clear(this, cd);
            });
            this.isSwitching = true;
            NotifyManager.notify(NOTIFY_ID.PLAY_UPPER_LIMB_ANI + this.eventId, {
                name: PLAY_ANI.SWITCH
            });
        }
        getIsMySelf() {
            return this._isMySelf;
        }
        getRoleType() {
            return this.roleType;
        }
        getSpeed() {
            return this.speed;
        }
        getArmCtrl() {
            return this.armCtrl;
        }
        getIsTouchAttack() {
            return this.isTouchAttack;
        }
        getIsAttack() {
            return this.isAttack;
        }
        getPresentationBaseLayer() {
            return this.presentationBaseLayer;
        }
        getIsDie() {
            return this.isDie;
        }
        set setIsTouchAttack(isTouchAttack) {
            this.isTouchAttack = isTouchAttack;
        }
        set setIsAttack(isAttack) {
            this.isAttack = isAttack;
        }
        set IsDie(isDie) {
            this.isDie = isDie;
        }
        set setHP(HP) {
            this.HP = HP < 0 ? 0 : HP;
            if (this._isMySelf) {
                NotifyManager.notify(NOTIFY_ID.REFRESH_PLAYER_HP_UI);
            }
        }
        set setCurArmor(armor) {
            this.curArmor = armor < 0 ? 0 : armor;
            if (this._isMySelf) {
                console.log('刷新护甲', armor);
                NotifyManager.notify(NOTIFY_ID.REFRESH_PLAYER_ARMOR_UI);
            }
        }
        set setSpeed(speed) {
            this.speed = speed;
        }
        getHP() {
            return this.HP;
        }
        getArmor() {
            return this.curArmor;
        }
        getMaxArmor() {
            return this.maxArmor;
        }
        getMaxHP() {
            return this.maxHP;
        }
        set setMouseX(x) {
            this.oldX = x;
        }
        set setMouseY(y) {
            this.oldY = y;
        }
        assistAim() {
            if (this.presentationBaseLayer.enemy) {
                if (GameScene.handleType != HANDLETYPE.ONLYMOVE && GameScene.handleType != null) {
                    if (this.presentationBaseLayer.enemy.getIsDie()) {
                        this.presentationBaseLayer.enemy = null;
                        return;
                    }
                    let myTran = this.getPresentationBaseLayer().getOnceChild().transform;
                    let enemyTran = this.presentationBaseLayer.enemy.getOnceChild().transform;
                    this.eulerAngle = myTran.localRotationEuler.clone();
                    Vector3$b.subtract(enemyTran.position, myTran.position, this.temV3);
                    this.temV3.x = -this.temV3.x;
                    this.temV3.y = -this.temV3.y;
                    this.temV3.z = -this.temV3.z;
                    Quaternion$1.lookAt(CommonUtil.Vector3.zero, this.temV3, CommonUtil.Vector3.up, this.testV);
                    this.temV3 = this.eulerAngle.clone();
                    this.testV.invert(this.testV);
                    myTran.localRotation = this.testV.clone();
                    this.eulerAngle = myTran.localRotationEuler;
                    this.eulerAngle.z = 0;
                    this.eulerAngle.y -= 2;
                    if (Math.abs(this.eulerAngle.y - this.temV3.y) > 30) {
                        this.eulerAngle = this.temV3.clone();
                        console.log('bug特殊处理');
                        return;
                    }
                    Vector3$b.lerp(this.temV3, this.eulerAngle, LogicTimer.gSysTimer.delta * 0.001, this.eulerAngle);
                }
            }
        }
        setDirection(aiRotation = null, e = null) {
            if (this._isMySelf) {
                if (ConfigManager.platform == PLATFORM_TYPE.WEB_4399 && Laya.Browser.onPC) {
                    this.eulerAngle = this.getPresentationBaseLayer().getOnceChild().transform.localRotationEuler;
                    if (e.stageX != this.oldX) {
                        if (this.oldX == null) {
                            this.oldX = e.stageX;
                        }
                        let rotation = -e.stageX;
                        this.oldX = e.stageX;
                        let fac = 0.2;
                        if (this.isOpenMioing) {
                            fac = 0.08;
                        }
                        this.eulerAngle.y += rotation * fac;
                        if (this.eulerAngle.y >= 180) {
                            this.eulerAngle.y -= 360;
                        }
                        if (this.eulerAngle.y <= -180) {
                            this.eulerAngle.y += 360;
                        }
                    }
                    if (e.stageY != this.oldY) {
                        if (this.oldY == null) {
                            this.oldY = e.stageY;
                        }
                        let y = e.stageY;
                        let fac = 0.2;
                        if (this.isOpenMioing) {
                            fac = 0.08;
                        }
                        let rotX = this.eulerAngle.x + y * fac;
                        if (Math.abs(rotX) > 70) {
                            if (rotX < 0) {
                                rotX = -70;
                            } else {
                                rotX = 70;
                            }
                        }
                        this.oldY = e.stageY;
                        this.eulerAngle.x = rotX;
                    }
                } else {
                    this.eulerAngle = this.getPresentationBaseLayer().getOnceChild().transform.localRotationEuler;
                    if (e.stageX != this.oldX && GameScene.handleType != HANDLETYPE.ONLYMOVE && GameScene.handleType != null) {
                        if (e.stageX > Laya.stage.width / 2) {
                            if (this.oldX == null) {
                                this.oldX = e.stageX;
                            }
                            let rotation = this.oldX - e.stageX;
                            this.oldX = e.stageX;
                            let fac = 0.2;
                            if (this.isOpenMioing) {
                                fac = 0.08;
                            }
                            this.eulerAngle.y += rotation * fac;
                            if (this.eulerAngle.y >= 180) {
                                this.eulerAngle.y -= 360;
                            }
                            if (this.eulerAngle.y <= -180) {
                                this.eulerAngle.y += 360;
                            }
                        }
                    }
                    if (e.stageY != this.oldY && GameScene.handleType != HANDLETYPE.ONLYMOVE && GameScene.handleType != null) {
                        if (e.stageX > Laya.stage.width / 2) {
                            if (this.oldY == null) {
                                this.oldY = e.stageY;
                            }
                            let y = e.stageY - this.oldY;
                            let fac = 0.2;
                            if (this.isOpenMioing) {
                                fac = 0.08;
                            }
                            let rotX = this.eulerAngle.x + y * fac;
                            if (Math.abs(rotX) > 70) {
                                if (rotX < 0) {
                                    rotX = -70;
                                } else {
                                    rotX = 70;
                                }
                            }
                            this.oldY = e.stageY;
                            this.eulerAngle.x = rotX;
                        }
                    }
                }
            } else {
                this.rotatingQuaternion = aiRotation;
            }
        }
        getEulerAngle() {
            return this.eulerAngle;
        }
        getRotatingQuaternion() {
            return this.rotatingQuaternion;
        }
        setMyOrientation(x = 0, y = 0, z = 0) {
            if (this.isDie)
                return;
            this.myOrientation.x = x;
            this.myOrientation.z = z;
            Vector3$b.normalize(this.myOrientation, this.myOrientation);
            this.myOrientation.cloneTo(this.vecDir);
            this.myOrientation.x *= 0.14;
            this.myOrientation.z *= 0.14;
            if (!this._isMySelf) {
                this.myOrientation.x *= 0.6;
                this.myOrientation.z *= 0.6;
            }
            if (this.isAttack) {
                this.myOrientation.x *= 0.7;
                this.myOrientation.z *= 0.7;
            }
            if (this.isCrouch) {
                this.myOrientation.x *= 0.5;
                this.myOrientation.z *= 0.5;
            }
            this.myOrientation.x *= 0.6;
            this.myOrientation.z *= 0.6;
            if (this.isZombie) {}
        }
        set setIsMoving(isMoving) {
            this.isMoving = isMoving;
        }
        getIsMoving() {
            return this.isMoving;
        }
        getMyOrientation() {
            let vec = this.myOrientation;
            if (this.isDie || !this.isMoving || CharacterManger.gameOver || CharacterManger.gameStop) {
                vec.x = 0;
                vec.y = 0;
                vec.z = 0;
            }
            if (!this._isMySelf) {
                if (this.isCrouch) {
                    vec.x = 0;
                    vec.y = 0;
                    vec.z = 0;
                }
            }
            return vec;
        }
        setDie() {
            this.isDie = true;
            this.presentationBaseLayer.enemy = null;
            this.presentationBaseLayer.setGhostUICtrl();
            if (this.isZombie) {
                let that = this;
                BiochemistryManager.setEliminateZomBieNum();
                this.presentationBaseLayer.modelSink(function() {
                    CharacterManger.cleanTargetLogic(that.eventId);
                });
            } else {
                if (this._isMySelf) {
                    if (ModeManager.mode == GAME_MODE_TYPE.BIOCHEMISTRY) {
                        if (ConfigManager.isReviewVersion() && ConfigManager.gameType == GAME_MJB_TYPE.QZHXJY) {
                            CharacterManger.gameOver = true;
                        } else {
                            UIManager.openFunction(FUNCTION_TAG.REVIVE, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE, false);
                        }
                    } else {
                        let that = this;
                        if (!CharacterManger.isWarmUp) {
                            if (UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).getChildByName('GameAirView')) {
                                UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).getChildByName('GameAirView').destroy();
                            }
                            if (UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).getChildByName('GameAirCrazyView')) {
                                UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).getChildByName('GameAirCrazyView').destroy();
                            }
                            if (this.freeReviveNum == 0) {
                                this.createRevive();
                            } else {
                                if (ModeManager.mode == GAME_MODE_TYPE.KNIFEWARMODE || ModeManager.mode == GAME_MODE_TYPE.ONEVSONEMODE) {
                                    this.freeReviveNum = 0;
                                    this.presentationBaseLayer.invincibleProCount = 3000;
                                    this.presentationBaseLayer.invincibleProCountMax = 3000;
                                    if (UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).getChildByName('GameAirView')) {
                                        UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).getChildByName('GameAirView').destroy();
                                    }
                                    if (UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).getChildByName('GameAirCrazyView')) {
                                        UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).getChildByName('GameAirCrazyView').destroy();
                                    }
                                    UIManager.openFunction(FUNCTION_TAG.REVIVE, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE, false);
                                } else {
                                    if (this.getAriArm() && this.armCtrlList.length != 0) {
                                        this.reviveBeforeThree();
                                    } else {
                                        this.createAutoRevive();
                                    }
                                }
                            }
                        }
                    }
                } else {
                    console.log('ai死亡');
                    this.presentationBaseLayer.closeMark();
                }
            }
        }
        resetReviveData(cb) {
            this.presentationBaseLayer.invincibleProCount = 10000;
            this.presentationBaseLayer.invincibleProCountMax = 10000;
            if (UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).getChildByName('GameAirView')) {
                UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).getChildByName('GameAirView').destroy();
            }
            if (UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).getChildByName('GameAirCrazyView')) {
                UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).getChildByName('GameAirCrazyView').destroy();
            }
            CharacterManger.gameStop = true;
            if (CharacterManger.gameStop) {
                Laya.timer.once(1000, this, () => {
                    CharacterManger.gameStop = false;
                    if (CharacterManger.playerLogicalBaseLayer.freeReviveNum > 0) {
                        CharacterManger.playerLogicalBaseLayer.freeReviveNum--;
                    }
                    CharacterManger.playerLogicalBaseLayer.directRevive(function() {
                        CharacterManger.playerLogicalBaseLayer.getPresentationBaseLayer().setPos(CharacterManger.playerLogicalBaseLayer.getInitPos());
                    });
                    cb();
                });
            }
        }
        reviveBeforeThree() {
            let that = this;
            let func = function() {
                if (GameScene.gameNum >= 3) {
                    if (ConfigManager.platform == PLATFORM_TYPE.WX || ConfigManager.platform == PLATFORM_TYPE.WEB) {
                        if (RoleManager.getInstance().isBannerTouch() && GameScene.isShowRevivieCrazy) {
                            that.createGameAirCrazy();
                        } else {
                            that.createGameAir();
                        }
                    } else {
                        that.createGameAir();
                    }
                } else {
                    if (ConfigManager.platform == PLATFORM_TYPE.WX || ConfigManager.platform == PLATFORM_TYPE.WEB) {
                        if (RoleManager.getInstance().isNew) {
                            that.createGameAir();
                        } else {
                            if (RoleManager.getInstance().isBannerTouch() && GameScene.isShowRevivieCrazy) {
                                that.createGameAirCrazy();
                            } else {
                                that.createGameAir();
                            }
                        }
                    } else {
                        that.createGameAir();
                    }
                }
            };
            this.resetReviveData(func);
        }
        createGameAir() {
            let that = this;
            UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).addChild(new GameAirViewCtrl({
                id: that.getAriArm(),
                cb: () => {
                    that.ariArmCallBack();
                },
            }));
        }
        createGameAirCrazy() {
            let that = this;
            UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).addChild(new GameAirCrazyViewCtrl({
                id: that.getAriArm(),
                cb: () => {
                    that.ariArmCallBack();
                },
            }));
        }
        createRevive() {
            this.presentationBaseLayer.invincibleProCount = 3000;
            this.presentationBaseLayer.invincibleProCountMax = 3000;
            UIManager.openFunction(FUNCTION_TAG.REVIVE, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE, false);
        }
        createAutoRevive() {
            UIManager.openFunction(FUNCTION_TAG.AUTOREVIVE, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE, {
                cb: function() {}
            });
        }
        getSuperArmByNew(id) {
            CharacterManger.gameStop = false;
            UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).curIndex = 0;
            let item = new ArmCtrl(this, id);
            this.armCtrlList[0] = item;
            this.armCtrl = this.armCtrlList[0];
            this.armCtrl.switchArm();
            this.magazineBullet = this.armCtrl.curMagazineBullet;
            this.bullets = this.armCtrl.curBullets;
            UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).pickUpTheGun();
            UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).onArmSelect(UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).curIndex);
            UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).btnRightAttack.skin = CharacterManger.playerLogicalBaseLayer.getArmCtrl().getType() == 8 ? RES_PATH.BOMB_UI.TOUCH : RES_PATH.ATTACK_UI.TOUCH;
            UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).btnLeftAttack.getChildAt(0).skin = CharacterManger.playerLogicalBaseLayer.getArmCtrl().getType() == 8 ? RES_PATH.BOMB_UI.TOUCH : RES_PATH.ATTACK_UI.TOUCH;
            CharacterManger.replaceZDArm(0, this.armCtrl.getIcon());
        }
        getAriArm() {
            let curlist = RoleManager.getInstance().getSkinLib();
            let hasList = [];
            for (let k = 0; k < curlist.length; k++) {
                hasList.push(curlist[k]);
            }
            for (let k = 0; k < this.armCtrlList.length; k++) {
                hasList.push(this.armCtrlList[k].id);
            }
            console.log('当前已经拥有得武器：', hasList);
            if (this.getArmCtrl()) {
                let list = [];
                for (let k = 0; k < ARM.keys.length; k++) {
                    let isHas = false;
                    let a = ARM.getDataByKey(ARM.keys[k]);
                    if (a.type == this.getArmCtrl().getType() && a.id > this.getArmCtrl().getID()) {
                        for (let i = 0; i < hasList.length; i++) {
                            if (a.id == hasList[i]) {
                                isHas = true;
                            }
                        }
                        if (!isHas) {
                            list.push(ARM.keys[k]);
                        }
                    }
                }
                if (this.getArmCtrl().getType() != 2 && this.getArmCtrl().getType() != 8) {
                    if (list.length == 0 || list.length == 1 || list.length == 2) {
                        for (let k = 0; k < ARM.keys.length; k++) {
                            let isHas = false;
                            let a = ARM.getDataByKey(ARM.keys[k]);
                            if (a.type == this.getArmCtrl().getType()) {
                                for (let i = 0; i < hasList.length; i++) {
                                    if (a.id == hasList[i]) {
                                        isHas = true;
                                    }
                                }
                                if (!isHas) {
                                    list.push(ARM.keys[k]);
                                }
                            }
                        }
                        if (list.length == 0) {
                            for (let k = 0; k < ARM.keys.length; k++) {
                                let isHas = false;
                                let a = ARM.getDataByKey(ARM.keys[k]);
                                if (a.type == this.getArmCtrl().getType() && a.id != this.getArmCtrl().getID()) {
                                    list.push(ARM.keys[k]);
                                }
                            }
                        }
                        if (this.tar == 0) {
                            this.tar = list.length;
                        }
                        let num = list.length - this.tar;
                        if (num <= 0) {
                            num = list.length - 1;
                        }
                        let randID = list[num];
                        this.randID = randID;
                        this.tar--;
                        return this.randID;
                    } else {
                        if (this.tar == 0) {
                            this.tar = list.length;
                        }
                        let num = list.length - this.tar;
                        if (num <= 0) {
                            num = list.length - 1;
                        }
                        let randID = list[num];
                        this.randID = randID;
                        this.tar--;
                        return this.randID;
                    }
                } else {
                    for (let k = 0; k < ARM.keys.length; k++) {
                        let isHas = false;
                        let a = ARM.getDataByKey(ARM.keys[k]);
                        if (a.type == this.armCtrlList[0].getType()) {
                            for (let i = 0; i < hasList.length; i++) {
                                if (a.id == hasList[i]) {
                                    isHas = true;
                                }
                            }
                            if (!isHas) {
                                list.push(ARM.keys[k]);
                            }
                        }
                    }
                    if (list.length == 0) {
                        for (let k = 0; k < ARM.keys.length; k++) {
                            let isHas = false;
                            let a = ARM.getDataByKey(ARM.keys[k]);
                            if (a.type == this.armCtrlList[0].getType() && a.id != this.armCtrlList[0].getID()) {
                                list.push(ARM.keys[k]);
                            }
                        }
                    }
                    if (this.tar == 0) {
                        this.tar = list.length;
                    }
                    let num = list.length - this.tar;
                    if (num <= 0) {
                        num = list.length - 1;
                    }
                    let randID = list[num];
                    this.randID = randID;
                    this.tar--;
                    return this.randID;
                }
            } else {
                console.log('没有武器----');
                if (ModeManager.mode == GAME_MODE_TYPE.SNIPERMODE) {
                    let list = [];
                    if (list.length == 0 || list.length == 1 || list.length == 2) {
                        for (let k = 0; k < ARM.keys.length; k++) {
                            let isHas = false;
                            let a = ARM.getDataByKey(ARM.keys[k]);
                            if (a.type == 3) {
                                for (let i = 0; i < hasList.length; i++) {
                                    if (a.id == hasList[i]) {
                                        isHas = true;
                                    }
                                }
                                if (!isHas) {
                                    list.push(ARM.keys[k]);
                                }
                            }
                        }
                        if (list.length == 0) {
                            for (let k = 0; k < ARM.keys.length; k++) {
                                let isHas = false;
                                let a = ARM.getDataByKey(ARM.keys[k]);
                                if (a.type == 3) {
                                    list.push(ARM.keys[k]);
                                }
                            }
                        }
                        if (this.tar == 0) {
                            this.tar = list.length;
                        }
                        let num = list.length - this.tar;
                        if (num <= 0) {
                            num = list.length - 1;
                        }
                        let randID = list[num];
                        this.randID = randID;
                        this.tar--;
                        return this.randID;
                    } else {
                        if (this.tar == 0) {
                            this.tar = list.length;
                        }
                        let num = list.length - this.tar;
                        if (num <= 0) {
                            num = list.length - 1;
                        }
                        let randID = list[num];
                        this.randID = randID;
                        this.tar--;
                        return this.randID;
                    }
                } else {
                    let randID = ARM.keys[RandomUtil.onlyOneRandomInt(0, ARM.keys.length)];
                    this.randID = randID;
                    return this.randID;
                }
            }
        }
        ariArmCallBack() {
            if (this.getArmCtrl()) {
                if (this.getArmCtrl().getType() != 8 && this.getArmCtrl().getType() != 2) {
                    let index = UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).curIndex;
                    let item = new ArmCtrl(this, this.randID);
                    this.armCtrlList[index] = item;
                    this.armCtrl = item;
                    this.armCtrl.switchArm();
                    this.magazineBullet = this.armCtrl.curMagazineBullet;
                    this.bullets = this.armCtrl.curBullets;
                    UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).pickUpTheGun();
                    UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).onArmSelect(UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).curIndex);
                    UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).btnRightAttack.skin = CharacterManger.playerLogicalBaseLayer.getArmCtrl().getType() == 8 ? RES_PATH.BOMB_UI.TOUCH : RES_PATH.ATTACK_UI.TOUCH;
                    UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).btnLeftAttack.getChildAt(0).skin = CharacterManger.playerLogicalBaseLayer.getArmCtrl().getType() == 8 ? RES_PATH.BOMB_UI.TOUCH : RES_PATH.ATTACK_UI.TOUCH;
                    CharacterManger.replaceZDArm(index, this.armCtrl.getIcon());
                } else {
                    UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).curIndex = 0;
                    let item = new ArmCtrl(this, this.randID);
                    this.armCtrlList[0] = item;
                    this.armCtrl = this.armCtrlList[0];
                    this.armCtrl.switchArm();
                    this.magazineBullet = this.armCtrl.curMagazineBullet;
                    this.bullets = this.armCtrl.curBullets;
                    UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).pickUpTheGun();
                    UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).onArmSelect(UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).curIndex);
                    UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).btnRightAttack.skin = CharacterManger.playerLogicalBaseLayer.getArmCtrl().getType() == 8 ? RES_PATH.BOMB_UI.TOUCH : RES_PATH.ATTACK_UI.TOUCH;
                    UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).btnLeftAttack.getChildAt(0).skin = CharacterManger.playerLogicalBaseLayer.getArmCtrl().getType() == 8 ? RES_PATH.BOMB_UI.TOUCH : RES_PATH.ATTACK_UI.TOUCH;
                    CharacterManger.replaceZDArm(0, this.armCtrl.getIcon());
                    CharacterManger.convenientSelectArm();
                }
            } else {
                if (ModeManager.mode != GAME_MODE_TYPE.SNIPERMODE) {
                    UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).curIndex = 0;
                    let item = new ArmCtrl(this, this.randID);
                    this.armCtrlList[0] = item;
                    this.armCtrl = this.armCtrlList[0];
                    this.armCtrl.switchArm();
                    this.magazineBullet = this.armCtrl.curMagazineBullet;
                    this.bullets = this.armCtrl.curBullets;
                    UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).pickUpTheGun();
                    UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).onArmSelect(UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).curIndex);
                    UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).btnRightAttack.skin = CharacterManger.playerLogicalBaseLayer.getArmCtrl().getType() == 8 ? RES_PATH.BOMB_UI.TOUCH : RES_PATH.ATTACK_UI.TOUCH;
                    UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).btnLeftAttack.getChildAt(0).skin = CharacterManger.playerLogicalBaseLayer.getArmCtrl().getType() == 8 ? RES_PATH.BOMB_UI.TOUCH : RES_PATH.ATTACK_UI.TOUCH;
                } else {
                    UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).curIndex = 0;
                    let item = new ArmCtrl(this, this.randID);
                    this.armCtrlList.push(item);
                    this.armCtrl = this.armCtrlList[0];
                    this.armCtrl.switchArm();
                    this.magazineBullet = this.armCtrl.curMagazineBullet;
                    this.bullets = this.armCtrl.curBullets;
                    UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).pickUpTheGun();
                    UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).onArmSelect(UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).curIndex);
                    UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).btnRightAttack.skin = CharacterManger.playerLogicalBaseLayer.getArmCtrl().getType() == 8 ? RES_PATH.BOMB_UI.TOUCH : RES_PATH.ATTACK_UI.TOUCH;
                    UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).btnLeftAttack.getChildAt(0).skin = CharacterManger.playerLogicalBaseLayer.getArmCtrl().getType() == 8 ? RES_PATH.BOMB_UI.TOUCH : RES_PATH.ATTACK_UI.TOUCH;
                }
            }
        }
        resetDouble() {
            this.isStartDoubleKill = false;
            this.isStartHeadShotDoubleKill = false;
            this.doubleKill = 0;
            this.doubleClasses = 1;
            this.headShotHit = 0;
            this.headShotClasses = 1;
            this.maxDoubleKill = 0;
            var that = this;
            that.isInvincible = true;
            that.isDie = false;
            that.isRevive = false;
            that.setHP = that.maxHP;
            that.setCurArmor = that.maxArmor;
            if (that.armCtrl) {
                that.magazineBullet = that.armCtrl.getMagazineBullet();
                that.bullets = that.armCtrl.getBullets();
            }
            that.resetArmList();
            that.presentationBaseLayer.setGamingHeadState();
            if (that.armCtrl) {
                if (that.armCtrl.getType() == 8) {
                    that.presentationBaseLayer.isTouchBomb = true;
                }
            }
            that.presentationBaseLayer.isThrowBomb = false;
            if (that._isMySelf) {
                NotifyManager.notify(NOTIFY_ID.REFRESH_PLAYER_ARMOR_UI);
                NotifyManager.notify(NOTIFY_ID.REFRESH_PLAYER_HP_UI);
                NotifyManager.notify(NOTIFY_ID.REFRESH_MAIN_ARM);
            }
            that.presentationBaseLayer.openMark();
        }
        revive(cb) {
            if (this.isDie) {
                if (!this.isRevive) {
                    this.freeReviveNum--;
                    let that = this;
                    this.isRevive = true;
                    this.isStartDoubleKill = false;
                    this.isStartHeadShotDoubleKill = false;
                    this.presentationBaseLayer.enemy = null;
                    this.resetDoubleKillTime();
                    this.doubleKill = 0;
                    this.doubleClasses = 1;
                    if (this._isMySelf) {
                        this.getPresentationBaseLayer().closeDoubleKill();
                    }
                    let time = 2000;
                    if (ModeManager.mode == GAME_MODE_TYPE.ONEVSONEMODE) {
                        time = 3000;
                    }
                    if (ConfigManager.platform == PLATFORM_TYPE.WEB_4399) {
                        time = 500;
                    }
                    Laya.timer.once(time, this, function cd() {
                        console.log('AI复活------');
                        if (SceneManager.getCurScene().state != GAME_STATE.START)
                            return;
                        if (!that.getPresentationBaseLayer())
                            return;
                        that.isInvincible = true;
                        that.isDie = false;
                        that.isRevive = false;
                        that.setHP = that.maxHP;
                        that.setCurArmor = that.maxArmor;
                        if (that.armCtrl) {
                            that.magazineBullet = that.armCtrl.getMagazineBullet();
                            that.bullets = that.armCtrl.getBullets();
                        }
                        that.resetArmList();
                        that.presentationBaseLayer.setGamingHeadState();
                        if (that.armCtrl) {
                            if (that.armCtrl.getType() == 8) {
                                that.presentationBaseLayer.isTouchBomb = true;
                            }
                        }
                        that.presentationBaseLayer.isThrowBomb = false;
                        if (that._isMySelf) {
                            NotifyManager.notify(NOTIFY_ID.REFRESH_PLAYER_ARMOR_UI);
                            NotifyManager.notify(NOTIFY_ID.REFRESH_PLAYER_HP_UI);
                            NotifyManager.notify(NOTIFY_ID.REFRESH_MAIN_ARM);
                        }
                        that.presentationBaseLayer.openMark();
                        cb();
                        Laya.timer.clear(that, cd);
                    });
                }
            }
        }
        directRevive(cb) {
            if (!this.getPresentationBaseLayer())
                return;
            if (this.isDie) {
                if (!this.isRevive) {
                    this.isRevive = true;
                    this.isStartDoubleKill = false;
                    this.isStartHeadShotDoubleKill = false;
                    this.resetDoubleKillTime();
                    this.doubleKill = 0;
                    this.doubleClasses = 1;
                    if (this._isMySelf) {
                        this.getPresentationBaseLayer().closeDoubleKill();
                    }
                    if (SceneManager.getCurScene().state != GAME_STATE.START)
                        return;
                    this.isInvincible = true;
                    this.isDie = false;
                    this.isRevive = false;
                    this.setHP = this.maxHP;
                    this.setCurArmor = this.maxArmor;
                    if (this.armCtrl) {
                        this.magazineBullet = this.armCtrl.getMagazineBullet();
                        this.bullets = this.armCtrl.getBullets();
                    }
                    this.resetArmList();
                    this.presentationBaseLayer.setGamingHeadState();
                    if (this.armCtrl) {
                        if (this.armCtrl.getType() == 8) {
                            this.presentationBaseLayer.isTouchBomb = true;
                        }
                    }
                    this.presentationBaseLayer.isThrowBomb = false;
                    if (this._isMySelf) {
                        NotifyManager.notify(NOTIFY_ID.REFRESH_PLAYER_ARMOR_UI);
                        NotifyManager.notify(NOTIFY_ID.REFRESH_PLAYER_HP_UI);
                        NotifyManager.notify(NOTIFY_ID.REFRESH_MAIN_ARM);
                    }
                    cb();
                }
            }
        }
        bulletFill() {
            if (this.armCtrl) {
                this.magazineBullet = this.armCtrl.getMagazineBullet();
                this.bullets = this.armCtrl.getBullets();
            }
            this.resetArmList();
            this.presentationBaseLayer.isThrowBomb = false;
            if (this._isMySelf) {
                NotifyManager.notify(NOTIFY_ID.REFRESH_MAIN_ARM);
            }
        }
        setDoubleKill() {
            if (this.doubleClasses >= 3) {
                if (!this.isStartDoubleKill)
                    return;
                this.doubleKillTime -= LogicTimer.gSysTimer.delta;
                if (this.doubleKillTime < 0) {
                    this.isStartDoubleKill = false;
                    this.doubleKill = 0;
                    this.doubleClasses = 1;
                    if (this._isMySelf) {
                        this.getPresentationBaseLayer().closeDoubleKill();
                    }
                }
            }
            if (this.headShotClasses >= 2) {
                if (!this.isStartHeadShotDoubleKill)
                    return;
                this.doubleKillTime -= LogicTimer.gSysTimer.delta;
                if (this.doubleKillTime < 0) {
                    this.isStartHeadShotDoubleKill = false;
                    this.headShotHit = 0;
                    this.headShotClasses = 1;
                }
            }
        }
        resetDoubleKill() {
            this.isStartDoubleKill = true;
            this.resetDoubleKillTime();
            this.addDoubleKill();
        }
        resetDoubleKillTime() {
            if (ModeManager.mode == GAME_MODE_TYPE.SNIPERMODE || ModeManager.mode == GAME_MODE_TYPE.KNIFEWARMODE) {
                this.doubleKillTime = 40000;
            } else {
                this.doubleKillTime = 10000;
            }
        }
        addDoubleKill() {
            if (this.doubleKill != 7) {
                this.doubleKill++;
                if (this._isMySelf) {}
                if (this.maxDoubleKill < this.doubleKill) {
                    this.maxDoubleKill = this.doubleKill;
                }
            }
            if (this.doubleKill == 7) {
                if (this.doubleClasses < 3) {
                    this.doubleClasses++;
                    this.doubleKill = 1;
                }
            }
        }
        resetHeadKill() {
            this.isStartHeadShotDoubleKill = true;
            this.resetHeadTime();
            this.addHeadKill();
        }
        resetHeadTime() {
            if (ModeManager.mode == GAME_MODE_TYPE.SNIPERMODE || ModeManager.mode == GAME_MODE_TYPE.KNIFEWARMODE) {
                this.headKillTime = 40000;
            } else {
                this.headKillTime = 10000;
            }
        }
        addHeadKill() {
            if (this.headShotHit != 7) {
                this.headShotHit++;
                if (this._isMySelf) {}
            }
            if (this.headShotHit == 7) {
                if (this.headShotClasses < 2) {
                    this.headShotClasses++;
                    this.headShotHit = 1;
                }
            }
        }
        playerDoubleHitUIAndSound() {}
        resetPointCtrl() {
            if (this.curPointCtrl)
                this.curPointCtrl.init();
        }
        initShader() {
            var attributeMap = {
                'a_Position': Laya.VertexMesh.MESH_POSITION0,
                'a_Normal': Laya.VertexMesh.MESH_NORMAL0,
                'a_Texcoord': Laya.VertexMesh.MESH_TEXTURECOORDINATE0,
                'a_BoneWeights': Laya.VertexMesh.MESH_BLENDWEIGHT0,
                'a_BoneIndices': Laya.VertexMesh.MESH_BLENDINDICES0
            };
            var uniformMap = {
                'u_Bones': Laya.Shader3D.PERIOD_CUSTOM,
                'u_CameraPos': Laya.Shader3D.PERIOD_CAMERA,
                'u_MvpMatrix': Laya.Shader3D.PERIOD_SPRITE,
                'u_WorldMat': Laya.Shader3D.PERIOD_SPRITE,
                'u_texture': Laya.Shader3D.PERIOD_MATERIAL,
                'u_marginalColor': Laya.Shader3D.PERIOD_MATERIAL,
                'u_SunLight.color': Laya.Shader3D.PERIOD_SCENE,
                'u_custom_Color': Laya.Shader3D.PERIOD_MATERIAL,
            };
            var vs = `
        #include "Lighting.glsl";
        attribute vec4 a_Position;
        attribute vec2 a_Texcoord;
        attribute vec3 a_Normal;
        uniform mat4 u_MvpMatrix;
        uniform mat4 u_WorldMat;
        varying vec2 v_Texcoord;
        varying vec3 v_Normal;
        #ifdef BONE
        attribute vec4 a_BoneIndices;
        attribute vec4 a_BoneWeights;
        const int c_MaxBoneCount = 24;
        uniform mat4 u_Bones[c_MaxBoneCount];
        #endif
        #if defined(DIRECTIONLIGHT)
        varying vec3 v_PositionWorld;
        #endif
        void main()
        {
        #ifdef BONE
        mat4 skinTransform=mat4(0.0);
        skinTransform += u_Bones[int(a_BoneIndices.x)] * a_BoneWeights.x;
        skinTransform += u_Bones[int(a_BoneIndices.y)] * a_BoneWeights.y;
        skinTransform += u_Bones[int(a_BoneIndices.z)] * a_BoneWeights.z;
        skinTransform += u_Bones[int(a_BoneIndices.w)] * a_BoneWeights.w;
        vec4 position = skinTransform * a_Position;
        gl_Position=u_MvpMatrix * position;
        mat3 worldMat=mat3(u_WorldMat * skinTransform);
        #else
        gl_Position=u_MvpMatrix * a_Position;
        mat3 worldMat=mat3(u_WorldMat);
        #endif
        v_Texcoord=a_Texcoord;
        v_Normal=worldMat*a_Normal;
        #if defined(DIRECTIONLIGHT)
        #ifdef BONE
        v_PositionWorld=(u_WorldMat*position).xyz;
        #else
        v_PositionWorld=(u_WorldMat*a_Position).xyz;
        #endif
        #endif
        gl_Position=remapGLPositionZ(gl_Position); 
        }`;
            var ps = `
        #ifdef FSHIGHPRECISION
            precision highp float;
        #else
            precision mediump float;
        #endif
        #include "Lighting.glsl";
        varying vec2 v_Texcoord;
        uniform sampler2D u_texture;
        uniform vec3 u_marginalColor;
        uniform float u_custom_Color;
        varying vec3 v_Normal;
        #if defined(DIRECTIONLIGHT)
            uniform vec3 u_CameraPos;
            varying vec3 v_PositionWorld;
            uniform DirectionLight u_SunLight;
        #endif
        void main()
        {
            gl_FragColor = texture2D(u_texture, v_Texcoord) + vec4(u_custom_Color, 0.0, 0.0, 1.0);
        }`;
            var customShader = Laya.Shader3D.add("CustomShader");
            var subShader = new Laya.SubShader(attributeMap, uniformMap);
            customShader.addSubShader(subShader);
            subShader.addShaderPass(vs, ps);
        }
        clean() {
            console.log('清除逻辑类');
            Laya.timer.clearAll(this);
            if (this.armCtrl)
                this.armCtrl.clean();
            this.presentationBaseLayer.clean();
            this.armCtrl = null;
            this.presentationBaseLayer = null;
            this.eventId = null;
            this.speed = 0;
            this.initPos = null;
            this.myOrientation = null;
            this.isDie = null;
            this.eulerAngle = null;
            this.rotatingQuaternion = null;
            this.oldX = null;
            this.oldY = null;
            this.isMoving = null;
            this.roleType = null;
            this.HP = null;
            this.isTouchAttack = null;
            this.isAttack = null;
            this._isMySelf = null;
            this.presentationBaseLayer = null;
            this.armCtrl = null;
            this.paths = null;
            this.attackLogicalBaseLayer = null;
            this.magazineBullet = null;
            this.bullets = null;
            this.isStartHuaBullet = null;
            this.isRevive = null;
            this.isCrouch = null;
            this.isAutoAttack = null;
            this.gameName = null;
            this.isFirstGun = null;
            this.isInvincible = null;
            this.playerBeKillCount = null;
            this.playerKillCount = null;
            this.score = null;
            this.head = null;
            this.doubleHit = null;
            this.intoID = null;
            this.isZombie = null;
            this.isGetBombLast = null;
        }
    }

    class AICtrl extends Laya.Script3D {
        constructor(_roleType, intoID, isZombie = false) {
            super();
            this.logicalBaseLayer = null;
            this.intoID = 0;
            this.isZombie = false;
            this.roleType = _roleType;
            this.intoID = intoID;
            this.isZombie = isZombie;
        }
        onAwake() {
            let owner = this.owner;
            if (PerformanceManager.isCloseAILogicBaseLayer)
                return;
            console.log('当前AI等级：', DifficultyManager.curDifficult, '当前指引进度:', RoleManager.getInstance().getGuide());
            let data = AIData.getDataByKey(DifficultyManager.curDifficult ? DifficultyManager.curDifficult : DIFFICULTY_TYPE.NORMAL);
            this.logicalBaseLayer = new LogicalBaseLayer(false, this.roleType, owner, this.intoID, this.isZombie);
            if (PerformanceManager.isCloseAILogic)
                return;
            this.aiLogic = new AILogic(this.logicalBaseLayer, data);
        }
        onDestroy() {
            this.aiLogic.clean();
            this.logicalBaseLayer.clean();
            this.logicalBaseLayer = null;
            this.roleType = null;
            this.aiLogic = null;
            this.intoID = null;
        }
    }

    class PlayerCtrl extends Laya.Script3D {
        constructor() {
            super();
            this.logicalBaseLayer = null;
        }
        onAwake() {
            let owner = this.owner;
            this.logicalBaseLayer = new LogicalBaseLayer(true, ROLE_TYPE.TYPE_0, owner);
        }
        onDestroy() {
            this.logicalBaseLayer.clean();
            this.logicalBaseLayer = null;
        }
    }

    class GameRoleCreateManager {
        static getRolePos() {
            this.rolePos.team = [];
            this.rolePos.enemy = [];
            this.rolePos.team.push(GameScene.scene3d.getChildByName('playerPos').transform.position.clone());
            this.rolePos.team.push(GameScene.scene3d.getChildByName('myTeam1Pos').transform.position.clone());
            this.rolePos.team.push(GameScene.scene3d.getChildByName('myTeam2Pos').transform.position.clone());
            this.rolePos.team.push(GameScene.scene3d.getChildByName('myTeam3Pos').transform.position.clone());
            this.rolePos.enemy.push(GameScene.scene3d.getChildByName('robot1Pos').transform.position.clone());
            this.rolePos.enemy.push(GameScene.scene3d.getChildByName('robot2Pos').transform.position.clone());
            this.rolePos.enemy.push(GameScene.scene3d.getChildByName('robot3Pos').transform.position.clone());
            this.rolePos.enemy.push(GameScene.scene3d.getChildByName('robot4Pos').transform.position.clone());
        }
        static createPlayer() {
            let gameScene = SceneManager.getCurScene();
            let pos = GameScene.scene3d.getChildByName('playerPos').transform.position.clone();
            let list = ['under', 'up'];
            let arr = [60, 40];
            let data = list[ProbUtil.getResult(arr)];
            if (ModeManager.mode == GAME_MODE_TYPE.ONEVSONEMODE || ModeManager.mode == GAME_MODE_TYPE.BIOCHEMISTRY) {
                data = 'under';
            }
            gameScene.isShowUnder = true;
            if (data == 'up') {
                gameScene.isShowUnder = false;
                pos = GameScene.scene3d.getChildByName('robot1Pos').transform.position.clone();
            }
            let player = SkinManager.createHand(pos, OBJ_NAME.PLAYER);
            player.name = OBJ_NAME.PLAYER;
            gameScene.playerCtrl = player.addComponentIntance(new PlayerCtrl());
            player.transform.localScaleX *= 0.9;
            player.transform.localScaleY *= 0.9;
            player.transform.localScaleZ *= 0.9;
        }
        static createAI() {
            let gameScene = SceneManager.getCurScene();
            if (PerformanceManager.isCloseAI)
                return;
            let pos1 = GameScene.scene3d.getChildByName('robot1Pos').transform.position.clone();
            let pos2 = GameScene.scene3d.getChildByName('robot2Pos').transform.position.clone();
            let pos3 = GameScene.scene3d.getChildByName('myTeam1Pos').transform.position.clone();
            let pos4 = GameScene.scene3d.getChildByName('myTeam2Pos').transform.position.clone();
            let pos5 = GameScene.scene3d.getChildByName('myTeam3Pos').transform.position.clone();
            let pos6 = GameScene.scene3d.getChildByName('robot3Pos').transform.position.clone();
            let pos7 = GameScene.scene3d.getChildByName('robot4Pos').transform.position.clone();
            if (!gameScene.isShowUnder) {
                pos1 = GameScene.scene3d.getChildByName('playerPos').transform.position.clone();
                pos2 = GameScene.scene3d.getChildByName('myTeam1Pos').transform.position.clone();
                pos3 = GameScene.scene3d.getChildByName('robot2Pos').transform.position.clone();
                pos4 = GameScene.scene3d.getChildByName('robot3Pos').transform.position.clone();
                pos5 = GameScene.scene3d.getChildByName('robot4Pos').transform.position.clone();
                pos6 = GameScene.scene3d.getChildByName('myTeam2Pos').transform.position.clone();
                pos7 = GameScene.scene3d.getChildByName('myTeam3Pos').transform.position.clone();
            }
            let len = 7;
            if (ModeManager.mode == GAME_MODE_TYPE.ONEVSONEMODE) {
                len = 1;
            } else if (ModeManager.mode == GAME_MODE_TYPE.TWOVSTWOMODE) {
                len = 3;
            } else if (ModeManager.mode == GAME_MODE_TYPE.SNIPERMODE) {
                len = 7;
            }
            let weNum = 0;
            let eNum = 0;
            if (ModeManager.mode != GAME_MODE_TYPE.BIOCHEMISTRY) {
                for (let k = 0; k < len; k++) {
                    let obj;
                    if (ModeManager.mode != GAME_MODE_TYPE.TWOVSTWOMODE) {
                        if (k == 4 || k == 5 || k == 6 || k == 7) {
                            let pos = pos3;
                            if (k == 5) {
                                pos = pos4;
                            } else if (k == 6) {
                                pos = pos5;
                            } else if (k == 7) {
                                pos = pos5;
                            }
                            obj = SkinManager.createSkin(pos, '001', false, OBJ_NAME.ROBOT, GameScene.scene3d, false, ROLE_TYPE.TYPE_0);
                            obj.addComponentIntance(new AICtrl(ROLE_TYPE.TYPE_0, weNum));
                            weNum++;
                        } else {
                            let pos = pos1;
                            if (k == 0) {
                                pos = pos2;
                            }
                            if (k == 2) {
                                pos = pos6;
                            }
                            if (k == 3) {
                                pos = pos7;
                            }
                            obj = SkinManager.createSkin(pos, '002', false, OBJ_NAME.ROBOT, GameScene.scene3d, false, ROLE_TYPE.TYPE_1);
                            obj.addComponentIntance(new AICtrl(ROLE_TYPE.TYPE_1, eNum));
                            eNum++;
                        }
                    } else {
                        if (k == 1) {
                            let pos = pos3;
                            obj = SkinManager.createSkin(pos, '001', false, OBJ_NAME.ROBOT, GameScene.scene3d, false, ROLE_TYPE.TYPE_0);
                            obj.addComponentIntance(new AICtrl(ROLE_TYPE.TYPE_0, weNum));
                            weNum++;
                        } else {
                            let pos = pos1;
                            if (k == 0) {
                                pos = pos2;
                            }
                            if (k == 2) {
                                pos = pos6;
                            }
                            if (k == 3) {
                                pos = pos7;
                            }
                            obj = SkinManager.createSkin(pos, '002', false, OBJ_NAME.ROBOT, GameScene.scene3d, false, ROLE_TYPE.TYPE_1);
                            obj.addComponentIntance(new AICtrl(ROLE_TYPE.TYPE_1, eNum));
                            eNum++;
                        }
                    }
                    obj.transform.localScaleX *= 0.9;
                    obj.transform.localScaleY *= 0.9;
                    obj.transform.localScaleZ *= 0.9;
                }
            } else {
                for (let k = 0; k < len; k++) {
                    let obj;
                    let pos = pos1;
                    if (k == 1) {
                        pos = pos2;
                    } else if (k == 2) {
                        pos = pos3;
                    } else if (k == 3) {
                        pos = pos4;
                    }
                    obj = SkinManager.createSkin(pos, '001', false, OBJ_NAME.ROBOT, GameScene.scene3d, false, ROLE_TYPE.TYPE_0);
                    obj.addComponentIntance(new AICtrl(ROLE_TYPE.TYPE_0, weNum));
                    weNum++;
                    obj.transform.localScaleX *= 0.9;
                    obj.transform.localScaleY *= 0.9;
                    obj.transform.localScaleZ *= 0.9;
                }
            }
        }
        static createZombie(pos, eNum) {
            let obj = SkinManager.createZombie(pos, OBJ_NAME.ROBOT, GameScene.scene3d);
            obj.addComponentIntance(new AICtrl(ROLE_TYPE.TYPE_1, eNum, true));
        }
    }
    GameRoleCreateManager.rolePos = {
        team: [],
        enemy: []
    };

    class BiochemistryManager {
        static addZombieBirthList() {
            if (ModeManager.mode != GAME_MODE_TYPE.BIOCHEMISTRY)
                return;
            this.zombieBirthList = [];
            let ZombieBirth = GameScene.scene3d.getChildByName('ZombieBirth');
            let len = ZombieBirth.numChildren;
            for (let k = 0; k < len; k++) {
                let item = ZombieBirth.getChildAt(k);
                this.zombieBirthList.push(item);
            }
            this.init();
            this.addBulletSupplyList();
            this.addLifeSupplyList();
        }
        static init() {
            let level = RoleManager.getInstance().getLevel();
            let data = ZombiePassData.getDataByKey(level);
            this.eachRound = data.initialZombieNum;
            this.rondNum = data.ronds;
            this.maxRound = this.eachRound + (this.round - 1) * this.eachRound;
            UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).setZomBieNum();
        }
        static matchingShow() {
            let level = RoleManager.getInstance().getLevel();
            let data = ZombiePassData.getDataByKey(level);
            this.eachRound = data.initialZombieNum;
            this.rondNum = data.ronds;
            let num = data.ronds;
            let sum = 0;
            for (let k = 0; k < num; k++) {
                console.log('获取僵尸个数：', sum);
                sum += this.eachRound + k * this.eachRound;
            }
            return sum;
        }
        static getTaskZombieNum() {
            let level = RoleManager.getInstance().getLevel();
            let data = ZombiePassData.getDataByKey(level);
            let num = data.ronds;
            let sum = 0;
            for (let k = 0; k < num; k++) {
                sum += this.eachRound + k * this.eachRound;
            }
            return sum;
        }
        static generateZombies() {
            if (CharacterManger.gameOver) {
                return;
            }
            if (ModeManager.mode != GAME_MODE_TYPE.BIOCHEMISTRY)
                return;
            this.isFinish = false;
            let eachRound = this.eachRound + (this.round - 1) * this.eachRound;
            this.maxRound = eachRound;
            let every = Math.floor(eachRound / this.zombieBirthList.length);
            let firstBirth = every + (eachRound - every * this.zombieBirthList.length > 0 ? eachRound - every * this.zombieBirthList.length : 0);
            for (let k = 0; k < firstBirth; k++) {
                GameRoleCreateManager.createZombie(this.zombieBirthList[0].transform.position.clone(), 1);
            }
            for (let k = 1; k < this.zombieBirthList.length; k++) {
                for (let i = 0; i < every; i++) {
                    GameRoleCreateManager.createZombie(this.zombieBirthList[k].transform.position.clone(), 1);
                }
            }
        }
        static setEliminateZomBieNum() {
            if (ModeManager.mode != GAME_MODE_TYPE.BIOCHEMISTRY)
                return;
            if (this.maxRound != 0) {
                this.maxRound--;
                UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).setZomBieNum();
            } else {
                UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).setZomBieNum();
            }
        }
        static finishCtrl() {
            if (ModeManager.mode != GAME_MODE_TYPE.BIOCHEMISTRY)
                return;
            if (this.maxRound == 0) {
                if (!this.isFinish) {
                    this.isFinish = true;
                    console.log('完成');
                    UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).zomBieEliminate();
                    if (this.round != this.rondNum) {
                        this.round++;
                    } else {
                        CharacterManger.gameOver = true;
                        CharacterManger._isWin = true;
                        return;
                    }
                    UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).zomBieComingDownTime(5000);
                }
            }
        }
        static addCacheDieZomBieList(logic) {
            for (let k = 0; k < this.cacheDieZomBieList.length; k++) {
                if (logic.getEventID() == this.cacheDieZomBieList[k].getEventID())
                    return;
            }
            this.cacheDieZomBieList.push(logic);
            console.log('当前保存的cacheDieZomBieList：', this.cacheDieZomBieList);
        }
        static createBulletModel(pos) {
            let ori = ResourceManager.getRes(RES_PATH.WEAPON_PREFEB).getChildByName('ammo');
            let newObj = Laya.Sprite3D.instantiate(ori, GameScene.scene3d);
            newObj.transform.position = pos;
            return newObj;
        }
        static createHpModel(pos) {
            let ori = ResourceManager.getRes(RES_PATH.WEAPON_PREFEB).getChildByName('health');
            let newObj = Laya.Sprite3D.instantiate(ori, GameScene.scene3d);
            newObj.transform.position = pos;
            return newObj;
        }
        static addBulletSupplyList() {
            let parent = GameScene.scene3d.getChildByName('bulletSupplyPoint');
            let len = parent.numChildren;
            for (let k = 0; k < len; k++) {
                let item = parent.getChildAt(k);
                let pos = item.transform.position.clone();
                pos.y = 1;
                let obj = this.createBulletModel(pos);
                obj.addComponentIntance(new BulletSupplyCtrl);
                this.bulletSupplyList.push(obj);
            }
        }
        static isHasBulletSupply() {
            for (let k = 0; k < this.bulletSupplyList.length; k++) {
                let ctrl = this.bulletSupplyList[k].getComponent(BulletSupplyCtrl);
                if (!ctrl.isGet)
                    return true;
            }
            return false;
        }
        static addLifeSupplyList() {
            let parent = GameScene.scene3d.getChildByName('lifeSupplyPoint');
            let len = parent.numChildren;
            for (let k = 0; k < len; k++) {
                let item = parent.getChildAt(k);
                let pos = item.transform.position.clone();
                pos.y = 1;
                let obj = this.createHpModel(pos);
                obj.addComponentIntance(new LifeSupplyCtrl);
                this.lifeSupplyList.push(obj);
            }
        }
        static isHasLifeSupply() {
            for (let k = 0; k < this.lifeSupplyList.length; k++) {
                let ctrl = this.lifeSupplyList[k].getComponent(LifeSupplyCtrl);
                if (!ctrl.isGet)
                    return true;
            }
            return false;
        }
        static resetGenerateBulletSupply() {
            if (ModeManager.mode != GAME_MODE_TYPE.BIOCHEMISTRY)
                return;
            let has = 0;
            for (let k in this.bulletSupplyList) {
                if (!this.bulletSupplyList[k].getComponent(BulletSupplyCtrl).isGet) {
                    has++;
                }
            }
            if (has != 3) {
                this.bulletSupplyCount -= LogicTimer.gSysTimer.delta;
                if (this.bulletSupplyCount < 0) {
                    this.bulletSupplyCount = 4000;
                    for (let k in this.bulletSupplyList) {
                        if (this.bulletSupplyList[k].getComponent(BulletSupplyCtrl).isGet) {
                            this.bulletSupplyList[k].getComponent(BulletSupplyCtrl).isGet = false;
                            this.bulletSupplyList[k].getComponent(BulletSupplyCtrl).model.active = true;
                        }
                    }
                }
            }
        }
        static resetGenerateLifeSupply() {
            if (ModeManager.mode != GAME_MODE_TYPE.BIOCHEMISTRY)
                return;
            let has = 0;
            for (let k in this.lifeSupplyList) {
                if (!this.lifeSupplyList[k].getComponent(LifeSupplyCtrl).isGet) {
                    has++;
                }
            }
            if (has != 3) {
                this.lifeSupplyCount -= LogicTimer.gSysTimer.delta;
                if (this.lifeSupplyCount < 0) {
                    this.lifeSupplyCount = 4000;
                    for (let k in this.lifeSupplyList) {
                        if (this.lifeSupplyList[k].getComponent(LifeSupplyCtrl).isGet) {
                            this.lifeSupplyList[k].getComponent(LifeSupplyCtrl).isGet = false;
                            this.lifeSupplyList[k].getComponent(LifeSupplyCtrl).model.active = true;
                        }
                    }
                }
            }
        }
        static getNearBulletSupply(logic) {
            let obj = this.bulletSupplyList[0];
            let min = Laya.Vector3.distanceSquared(logic.getPresentationBaseLayer().getModelPosByVector3(), this.bulletSupplyList[0].transform.position);
            for (let k = 0; k < this.bulletSupplyList.length; k++) {
                let item = this.bulletSupplyList[k];
                let ctrl = item.getComponent(BulletSupplyCtrl);
                if (Laya.Vector3.distanceSquared(logic.getPresentationBaseLayer().getModelPosByVector3(), this.bulletSupplyList[k].transform.position) < min && !ctrl.isGet) {
                    obj = item;
                    break;
                }
            }
            return obj;
        }
        static getNearHPSupply(logic) {
            let obj = this.lifeSupplyList[0];
            let min = Laya.Vector3.distanceSquared(logic.getPresentationBaseLayer().getModelPosByVector3(), this.lifeSupplyList[0].transform.position);
            for (let k = 0; k < this.lifeSupplyList.length; k++) {
                let item = this.lifeSupplyList[k];
                let ctrl = item.getComponent(LifeSupplyCtrl);
                if (Laya.Vector3.distanceSquared(logic.getPresentationBaseLayer().getModelPosByVector3(), this.lifeSupplyList[k].transform.position) < min && !ctrl.isGet) {
                    obj = item;
                    break;
                }
            }
            return obj;
        }
        static clean() {
            this.zombieBirthList = [];
            this.cacheDieZomBieList = [];
            this.birthCount = 1500;
            this.eachRound = 5;
            this.round = 1;
            this.isFinish = false;
            this.bulletSupplyCount = 4000;
            this.lifeSupplyCount = 7000;
            this.maxRound = 5;
            this.rondNum = 1;
            for (let k = 0; k < this.bulletSupplyList.length; k++) {
                if (this.bulletSupplyList[k]) {
                    this.bulletSupplyList[k].destroy();
                    this.bulletSupplyList[k] = null;
                }
            }
            for (let k = 0; k < this.lifeSupplyList.length; k++) {
                if (this.lifeSupplyList[k]) {
                    this.lifeSupplyList[k].destroy();
                    this.lifeSupplyList[k] = null;
                }
            }
            this.bulletSupplyList = [];
            this.lifeSupplyList = [];
        }
    }
    BiochemistryManager.zombieBirthList = [];
    BiochemistryManager.birthCount = 5000;
    BiochemistryManager.eachRound = 5;
    BiochemistryManager.maxRound = 5;
    BiochemistryManager.round = 1;
    BiochemistryManager.cacheDieZomBieList = [];
    BiochemistryManager.isFinish = false;
    BiochemistryManager.bulletSupplyList = [];
    BiochemistryManager.bulletSupplyCount = 4000;
    BiochemistryManager.lifeSupplyList = [];
    BiochemistryManager.lifeSupplyCount = 7000;
    BiochemistryManager.taskZombieNum = 0;
    BiochemistryManager.rondNum = 1;

    class GameTimeManager {
        static startGameTime(txt) {
            this.fixedTime = this.gameTime;
            Laya.timer.loop(1000, this, this.update, [txt]);
        }
        static matchingShow() {
            if (ModeManager.mode == GAME_MODE_TYPE.BIOCHEMISTRY) {
                this.gameTime = 300;
            }
            if (ModeManager.mode == GAME_MODE_TYPE.TWOVSTWOMODE) {
                this.gameTime = 200;
            } else {
                this.gameTime = 300;
            }
            this.fixedTime = this.gameTime;
        }
        static update(txt) {
            if (CharacterManger.gameStop)
                return;
            if (CharacterManger.gameOver) {
                Laya.timer.clear(this, this.update);
                return;
            }
            if (txt)
                txt.text = ModeManager.mode == GAME_MODE_TYPE.BIOCHEMISTRY ? StringUtil.parseTimeMS(this.gameTime) : StringUtil.parseTimeMS(this.gameTime);
            UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).setZomBieDownTimeBg();
            if (this.gameTime == 0) {
                Laya.timer.clear(this, this.update);
                CharacterManger.gameOver = true;
                return;
            }
            this.gameTime--;
        }
        static clear() {
            Laya.timer.clear(this, this.update);
        }
        static pause() {
            Laya.timer.pause();
        }
    }
    GameTimeManager.gameTime = 300;
    GameTimeManager.fixedTime = 300;

    var TASK_TYPE;
    (function(TASK_TYPE) {
        TASK_TYPE[TASK_TYPE["COMPLETE_GAME"] = 1] = "COMPLETE_GAME";
        TASK_TYPE[TASK_TYPE["HEADSHOT"] = 2] = "HEADSHOT";
        TASK_TYPE[TASK_TYPE["KNIFE_KILL"] = 3] = "KNIFE_KILL";
        TASK_TYPE[TASK_TYPE["DAN_UP"] = 4] = "DAN_UP";
        TASK_TYPE[TASK_TYPE["GAME_WIN"] = 5] = "GAME_WIN";
        TASK_TYPE[TASK_TYPE["MODE_KILL"] = 6] = "MODE_KILL";
        TASK_TYPE[TASK_TYPE["SNIPE_KILL"] = 7] = "SNIPE_KILL";
    })(TASK_TYPE || (TASK_TYPE = {}));
    class TaskManager {
        static setModelTargetKillSore() {
            if (ModeManager.mode == GAME_MODE_TYPE.ONEVSONEMODE) {
                this.targetKillSore = 20;
            } else if (ModeManager.mode == GAME_MODE_TYPE.TWOVSTWOMODE) {
                this.targetKillSore = 30;
            } else if (ModeManager.mode == GAME_MODE_TYPE.SNIPERMODE) {
                this.targetKillSore = 80;
            } else {
                this.targetKillSore = 60;
                if (ModeManager.mode == GAME_MODE_TYPE.TEAMCOMPETITION) {
                    this.targetKillSore = 50;
                }
                if (RoleManager.getInstance().getGuide() != GuideStep.FINISH && RoleManager.getInstance().getGuide() != GuideStep.MAX) {
                    if (GameScene.gameNum == 1) {
                        this.targetKillSore = 25;
                    } else if (GameScene.gameNum == 2) {
                        this.targetKillSore = 40;
                    } else if (GameScene.gameNum == 3) {
                        this.targetKillSore = 40;
                    }
                }
            }
        }
        static getTaskType(str) {
            let data = str.split('_');
            return {
                type: Number(data[0]),
                data: Number(data[1])
            };
        }
        static taskEntry() {
            let txt = '';
            if (ModeManager.mode == GAME_MODE_TYPE.BIOCHEMISTRY) {
                txt = GameTimeManager.fixedTime + 's内消灭' + BiochemistryManager.getTaskZombieNum() + '只僵尸';
            } else {
                txt = GameTimeManager.fixedTime + 's内获取' + this.targetKillSore + '分';
            }
            return txt;
        }
        static completeTask(taskType) {
            for (let index = 1; index <= 7; index++) {
                if (TaskManager.getTaskType(TaskData.getDataByKey(index).taskType).type == taskType)
                    RoleManager.getInstance().doTaksByDay(index, 1);
            }
        }
    }
    TaskManager.targetKillSore = 60;
    TaskManager.singleKillScore = 2;

    class CharacterManger {
        static addLogicalBaseLayer(logicalBaseLayer) {
            if (logicalBaseLayer.getIsMySelf()) {
                this.playerLogicalBaseLayer = logicalBaseLayer;
            }
            this.logicalBaseLayer.push(logicalBaseLayer);
        }
        static clean() {
            TriggerManager.clean();
            for (let k = 0; k < this.logicalBaseLayer.length; k++) {
                let item = this.logicalBaseLayer[k];
                item.getPresentationBaseLayer().getModel().destroy();
            }
            this.logicalBaseLayer = [];
            this.playerLogicalBaseLayer = null;
            this.fisrtPoint = null;
            this.targetLogicalBaseLayer = null;
            this.ourKillScore = 0;
            this.enemyKillScore = 0;
            this.hitLocation = '';
            this.gameOver = false;
            this._isWin = false;
            this.killerLogic = null;
            if (this.playerBeHitImg)
                this.playerBeHitImg.destroy();
            this.playerBeHitImg = null;
            this.isOpenBeHitImg = false;
            this.countDown = 1000;
            this.drSkinList = [];
            this.isWarmUp = true;
            this.revengeItemCtrl = null;
            this.curFRArmList = [];
            this.curTargetNum = {
                index: 0,
                icon: ''
            };
        }
        static createAIParts() {
            if (ModeManager.mode != GAME_MODE_TYPE.KNIFEWARMODE && ModeManager.mode != GAME_MODE_TYPE.SNIPERMODE && ModeManager.mode != GAME_MODE_TYPE.TEAMCOMPETITION)
                return;
            let rand = RandomUtil.onlyOneRandomIntOrFloat(0, 1);
            let myTamHasNum = 2;
            let drHasNum = 2;
            if (rand > 0.5) {
                myTamHasNum = 3;
                drHasNum = 1;
            }
            let myTeamList = [];
            let drList = [];
            for (let k = 0; k < this.logicalBaseLayer.length; k++) {
                let data = this.logicalBaseLayer[k];
                if (data.getRoleType() == ROLE_TYPE.TYPE_0 && !data.getIsMySelf()) {
                    myTeamList.push(data);
                } else if (data.getRoleType() == ROLE_TYPE.TYPE_1) {
                    drList.push(data);
                }
            }
            if (myTeamList.length > 2) {
                let model1 = myTeamList[0].getPresentationBaseLayer().getModel();
                let model2 = myTeamList[1].getPresentationBaseLayer().getModel();
                let model3 = myTeamList[2].getPresentationBaseLayer().getModel();
                let list1 = [];
                let list2 = [];
                for (let k = 0; k < PARTS.keys.length; k++) {
                    if (PARTS.getDataByKey(PARTS.keys[k]).partType == 1 || PARTS.getDataByKey(PARTS.keys[k]).partType == 3) {
                        list1.push(PARTS.keys[k]);
                    } else if (PARTS.getDataByKey(PARTS.keys[k]).partType == 2) {
                        list2.push(PARTS.keys[k]);
                    }
                }
                if (myTamHasNum == 2) {
                    SkinManager.createParts(list1[RandomUtil.onlyOneRandomInt(0, list1.length)], model1, new Laya.Vector3(1, 1, 1));
                    SkinManager.createParts(list2[RandomUtil.onlyOneRandomInt(0, list2.length)], model1, new Laya.Vector3(1, 1, 1));
                    SkinManager.createParts(list1[RandomUtil.onlyOneRandomInt(0, list1.length)], model2, new Laya.Vector3(1, 1, 1));
                    SkinManager.createParts(list2[RandomUtil.onlyOneRandomInt(0, list2.length)], model2, new Laya.Vector3(1, 1, 1));
                } else if (myTamHasNum == 3) {
                    SkinManager.createParts(list1[RandomUtil.onlyOneRandomInt(0, list1.length)], model1, new Laya.Vector3(1, 1, 1));
                    SkinManager.createParts(list2[RandomUtil.onlyOneRandomInt(0, list2.length)], model1, new Laya.Vector3(1, 1, 1));
                    SkinManager.createParts(list1[RandomUtil.onlyOneRandomInt(0, list1.length)], model2, new Laya.Vector3(1, 1, 1));
                    SkinManager.createParts(list2[RandomUtil.onlyOneRandomInt(0, list2.length)], model2, new Laya.Vector3(1, 1, 1));
                    SkinManager.createParts(list1[RandomUtil.onlyOneRandomInt(0, list1.length)], model3, new Laya.Vector3(1, 1, 1));
                    SkinManager.createParts(list2[RandomUtil.onlyOneRandomInt(0, list2.length)], model3, new Laya.Vector3(1, 1, 1));
                } else if (myTamHasNum == 3) {}
            }
            if (drList.length > 2) {
                let model1 = drList[0].getPresentationBaseLayer().getModel();
                let model2 = drList[1].getPresentationBaseLayer().getModel();
                let list1 = [];
                let list2 = [];
                for (let k = 0; k < PARTS.keys.length; k++) {
                    if (PARTS.getDataByKey(PARTS.keys[k]).partType == 1 || PARTS.getDataByKey(PARTS.keys[k]).partType == 3) {
                        list1.push(PARTS.keys[k]);
                    } else if (PARTS.getDataByKey(PARTS.keys[k]).partType == 2) {
                        list2.push(PARTS.keys[k]);
                    }
                }
                if (drHasNum == 2) {
                    SkinManager.createParts(list1[RandomUtil.onlyOneRandomInt(0, list1.length)], model1, new Laya.Vector3(1, 1, 1));
                    SkinManager.createParts(list2[RandomUtil.onlyOneRandomInt(0, list2.length)], model1, new Laya.Vector3(1, 1, 1));
                    SkinManager.createParts(list1[RandomUtil.onlyOneRandomInt(0, list1.length)], model2, new Laya.Vector3(1, 1, 1));
                    SkinManager.createParts(list2[RandomUtil.onlyOneRandomInt(0, list2.length)], model2, new Laya.Vector3(1, 1, 1));
                } else if (drHasNum == 1) {
                    SkinManager.createParts(list1[RandomUtil.onlyOneRandomInt(0, list1.length)], model1, new Laya.Vector3(1, 1, 1));
                    SkinManager.createParts(list2[RandomUtil.onlyOneRandomInt(0, list2.length)], model1, new Laya.Vector3(1, 1, 1));
                }
            }
        }
        static cleanTargetLogic(id) {
            for (let k = 0; k < this.logicalBaseLayer.length; k++) {
                let item = this.logicalBaseLayer[k];
                if (id == item.getEventID()) {
                    item.getPresentationBaseLayer().getModel().destroy();
                    this.logicalBaseLayer.splice(k, 1);
                }
            }
        }
        static destoryZDArm() {
            for (let k = 0; k < this.curFRArmList.length; k++) {
                if (this.curFRArmList[k].index == this.curTargetNum.index) {
                    this.curFRArmList.splice(k, 1);
                }
            }
        }
        static pushZDArm(pushIndex, icon = '') {
            return;
            if (ModeManager.mode == GAME_MODE_TYPE.ONEVSONEMODE)
                return;
            if (icon != '') {
                this.curFRArmList.push({
                    index: pushIndex,
                    icon: icon
                });
            }
            this.curTargetNum.index = icon != '' ? pushIndex : this.curFRArmList[0].index;
            this.curTargetNum.icon = icon != '' ? icon : this.curFRArmList[0].icon;
            UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).imgArm.skin = this.curTargetNum.icon;
        }
        static replaceZDArm(index, icon = '') {
            for (let k = 0; k < this.curFRArmList.length; k++) {
                if (this.curFRArmList[k].index == index) {
                    this.curFRArmList[k].icon = icon;
                }
            }
        }
        static pushFRArmList(index, icon = '', isFirst = false) {
            if (this.judgeSame(index)) {
                let data = {
                    index: index,
                    icon: icon
                };
                this.curTargetNum = this.getUnSame(index) ? this.getUnSame(index) : data;
                UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).imgArm.skin = this.curTargetNum.icon;
                return;
            }
            if (this.curFRArmList.length == 2) {
                for (let k = 0; k < this.curFRArmList.length; k++) {
                    if (this.curFRArmList[k].index == this.curTargetNum.index) {
                        this.curFRArmList.splice(k, 1);
                    }
                }
            }
            this.curFRArmList.push({
                index: index,
                icon: icon
            });
            if (!isFirst) {
                let data = {
                    index: index,
                    icon: icon
                };
                this.curTargetNum = this.getUnSame(index) ? this.getUnSame(index) : data;
                UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).imgArm.skin = this.curTargetNum.icon;
            } else {
                this.curTargetNum.index = index;
                this.curTargetNum.icon = icon;
            }
            console.log('添加：', index, this.curFRArmList);
        }
        static convenientSelectArm() {
            let data = null;
            console.log('this.curTargetNum:', this.curTargetNum, this.curFRArmList);
            if (this.curFRArmList.length == 2) {
                if (this.curTargetNum.index == this.curFRArmList[0].index) {
                    this.curTargetNum = this.curFRArmList[1];
                    data = this.curFRArmList[0].index;
                } else if (this.curTargetNum.index == this.curFRArmList[1].index) {
                    this.curTargetNum = this.curFRArmList[0];
                    data = this.curFRArmList[1].index;
                }
            }
            if (data != null) {
                UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).imgArm.skin = this.curTargetNum.icon;
                UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).updateSelectArm(data);
            }
        }
        static closeBomb() {
            let ctrl = this.playerLogicalBaseLayer.getPresentationBaseLayer().cacheBombSp.getComponent(BombCtrl);
            if (ctrl) {
                ctrl.retSet();
                this.playerLogicalBaseLayer.getPresentationBaseLayer().cacheBombSp = null;
                this.playerLogicalBaseLayer.getPresentationBaseLayer().isThrowBomb = false;
                this.playerLogicalBaseLayer.getPresentationBaseLayer().isThrowing = false;
                this.playerLogicalBaseLayer.setIsAttack = false;
                this.playerLogicalBaseLayer.getPresentationBaseLayer().idleCtrl();
            }
        }
        static judgeSame(index) {
            for (let k = 0; k < this.curFRArmList.length; k++) {
                if (this.curFRArmList[k].index == index) {
                    return true;
                }
            }
            return false;
        }
        static getUnSame(index) {
            for (let k = 0; k < this.curFRArmList.length; k++) {
                if (this.curFRArmList[k].index != index) {
                    return this.curFRArmList[k];
                }
            }
            return null;
        }
        static cleanDataList() {
            this.outDataList = [];
            this.enemyDataList = [];
        }
        static updateWeScore() {
            this.ourKillScore = 0;
            for (let k = 0; k < this.logicalBaseLayer.length; k++) {
                let item = this.logicalBaseLayer[k];
                if (item.getRoleType() == ROLE_TYPE.TYPE_0) {
                    this.ourKillScore += item.score;
                }
            }
        }
        static updateEnemyScore() {
            this.enemyKillScore = 0;
            for (let k = 0; k < this.logicalBaseLayer.length; k++) {
                let item = this.logicalBaseLayer[k];
                if (item.getRoleType() == ROLE_TYPE.TYPE_1) {
                    this.enemyKillScore += item.score;
                }
            }
        }
        static playerReStart() {}
        static addHead() {
            CharacterManger.playerLogicalBaseLayer.getPresentationBaseLayer().createInvincibleProCtrl();
            if (ModeManager.mode == GAME_MODE_TYPE.BIOCHEMISTRY)
                return;
            let teamList = [];
            let eneList = [];
            for (let k = 0; k < this.logicalBaseLayer.length; k++) {
                let item = this.logicalBaseLayer[k];
                if (item.getIsMySelf()) {
                    let view = new PlayerItemCtrl(item);
                    UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).boxTop.addChild(view);
                    view.pos(164, 6.5);
                    item.getPresentationBaseLayer().setGamimgHead(view);
                } else {
                    if (item.getRoleType() == ROLE_TYPE.TYPE_0) {
                        teamList.push(item);
                    } else if (item.getRoleType() == ROLE_TYPE.TYPE_1) {
                        eneList.push(item);
                    }
                }
            }
            for (let k = 0; k < teamList.length; k++) {
                let item = teamList[k];
                let ctrl = new AIItemCtrl(item);
                UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).boxTop.addChild(ctrl);
                ctrl.pos(164 - 44 * k - 44, 6.5);
            }
            for (let k = 0; k < eneList.length; k++) {
                let item = eneList[k];
                let ctrl = new AIItemCtrl(item);
                UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).boxTop.addChild(ctrl);
                if (k == 0) {
                    ctrl.pos(586, 6.5);
                } else {
                    ctrl.pos(586 + 44 * k, 6.5);
                }
            }
        }
        static addBuoy() {
            for (let k = 0; k < this.logicalBaseLayer.length; k++) {
                let logicalBaseLayer = this.logicalBaseLayer[k];
                logicalBaseLayer.getPresentationBaseLayer().addBuoy();
            }
        }
        static zombieModeTeamDie() {
            if (ModeManager.mode != GAME_MODE_TYPE.BIOCHEMISTRY)
                return;
            for (let k = 0; k < this.logicalBaseLayer.length; k++) {
                let logicalBaseLayer = this.logicalBaseLayer[k];
                if (logicalBaseLayer.getPresentationBaseLayer()) {
                    logicalBaseLayer.getPresentationBaseLayer().zombieModeTeamDie();
                }
            }
        }
        static warmUpAfterToSetPos() {
            for (let k = 0; k < this.logicalBaseLayer.length; k++) {
                let item = this.logicalBaseLayer[k];
                if (!item.getIsMySelf()) {
                    item.setDie();
                } else {
                    item.getPresentationBaseLayer().setPos(item.getInitPos());
                }
            }
        }
        static getzomBieModeNearDieTeam() {
            if (ModeManager.mode != GAME_MODE_TYPE.BIOCHEMISTRY)
                return;
            if (this.gameOver)
                return;
            let playerPos = CharacterManger.playerLogicalBaseLayer.getPresentationBaseLayer().getModelPosByVector3();
            let logic = null;
            for (let k = 0; k < this.logicalBaseLayer.length; k++) {
                let l = this.logicalBaseLayer[k];
                if (!l.getIsMySelf()) {
                    if (!l.isZombie) {
                        if (l.getIsDie()) {
                            logic = l;
                            break;
                        }
                    }
                }
            }
            if (logic) {
                let min = Laya.Vector3.distanceSquared(logic.getPresentationBaseLayer().getModelPosByVector3(), playerPos);
                for (let k = 0; k < this.logicalBaseLayer.length; k++) {
                    let logicalBaseLayer = this.logicalBaseLayer[k];
                    if (!logicalBaseLayer.getIsMySelf()) {
                        if (!logicalBaseLayer.dieRealFromZombie) {
                            let logicPos = logicalBaseLayer.getPresentationBaseLayer().getModelPosByVector3();
                            let dis = Laya.Vector3.distanceSquared(playerPos, logicPos);
                            if (logicalBaseLayer.getIsDie() && dis < min) {
                                if (dis < 5 * 5) {
                                    logic = logicalBaseLayer;
                                    min = dis;
                                }
                            }
                        }
                    }
                }
            }
            return logic ? Laya.Vector3.distanceSquared(logic.getPresentationBaseLayer().getModelPosByVector3(), playerPos) < 5 * 5 ? logic : null : null;
        }
        static rescueNearTeam() {
            if (ModeManager.mode != GAME_MODE_TYPE.BIOCHEMISTRY)
                return;
            let logic = this.getzomBieModeNearDieTeam();
            this.zombieModeRescueLogic = logic;
            if (logic) {
                if (!logic.getPresentationBaseLayer())
                    return;
                if (logic.isZombie)
                    return;
                if (logic.dieRealFromZombie) {
                    UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).rescuingItemCtrl.resetCoutDown();
                    UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).rescuingItemCtrl.isInterrupt = true;
                    UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).setRescuingVisible(false);
                    UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).setBtnRescueVisible(false);
                    return;
                }
                if (CharacterManger.zombieModeRescueLogic.getPresentationBaseLayer().isInterrupt) {
                    UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).rescuingItemCtrl.resetCoutDown();
                    UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).rescuingItemCtrl.isInterrupt = true;
                    UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).setRescuingVisible(false);
                    UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).setBtnRescueVisible(true);
                } else {
                    UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).rescuingItemCtrl.isInterrupt = false;
                    if (!UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).rescuing.visible) {
                        UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).setBtnRescueVisible(true);
                    } else {
                        UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).setBtnRescueVisible(false);
                    }
                }
            } else {
                UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).rescuingItemCtrl.resetCoutDown();
                UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).rescuingItemCtrl.isInterrupt = true;
                UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).setRescuingVisible(false);
                UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).setBtnRescueVisible(false);
            }
        }
        static getZombieModeSurvivalWeNum() {
            let len = 0;
            let tar = null;
            for (let k = 0; k < this.logicalBaseLayer.length; k++) {
                if (!this.logicalBaseLayer[k].isZombie && !this.logicalBaseLayer[k].getIsDie()) {
                    len++;
                    tar = this.logicalBaseLayer[k];
                }
            }
            return {
                len: len,
                tar: tar
            };
        }
        static attack() {
            CharacterManger.playerLogicalBaseLayer.getPresentationBaseLayer().radiographicTesting();
            CharacterManger.playerLogicalBaseLayer.getPresentationBaseLayer().attack();
        }
        static move() {
            for (let k = 0; k < this.logicalBaseLayer.length; k++) {
                let logicalBaseLayer = this.logicalBaseLayer[k];
                if (logicalBaseLayer != null) {
                    logicalBaseLayer.getPresentationBaseLayer().move();
                    if (logicalBaseLayer.getIsMySelf()) {
                        logicalBaseLayer.getPresentationBaseLayer().setDirection();
                    }
                }
            }
        }
        static jump() {
            for (let k = 0; k < this.logicalBaseLayer.length; k++) {
                let logicalBaseLayer = this.logicalBaseLayer[k];
                if (logicalBaseLayer != null) {
                    logicalBaseLayer.getPresentationBaseLayer().toJump();
                }
            }
        }
        static randomRotate() {
            for (let k = 0; k < this.logicalBaseLayer.length; k++) {
                let logicalBaseLayer = this.logicalBaseLayer[k];
                if (logicalBaseLayer != null) {
                    if (!logicalBaseLayer.getIsMySelf()) {
                        logicalBaseLayer.getPresentationBaseLayer().toRandomRotate();
                    }
                }
            }
        }
        static hit(arg) {
            if (arg.isMySelf) {
                if (!this.targetLogicalBaseLayer)
                    return;
                if (!this.targetLogicalBaseLayer.getPresentationBaseLayer())
                    return;
                if (this.targetLogicalBaseLayer.getIsDie())
                    return;
                let hit = arg.hit;
                this.targetLogicalBaseLayer.setCurArmor = this.targetLogicalBaseLayer.getArmor() - Math.floor(hit * 30 / 100) < 0 ? 0 : this.targetLogicalBaseLayer.getArmor() - Math.floor(hit * 30 / 100);
                this.targetLogicalBaseLayer.setHP = this.targetLogicalBaseLayer.getHP() - Math.floor(hit * 70 / 100) < 0 ? 0 : this.targetLogicalBaseLayer.getHP() - Math.floor(hit * 70 / 100);
                this.targetLogicalBaseLayer.getPresentationBaseLayer().setloatingBlood(hit);
                if (this.targetLogicalBaseLayer.getHP() == 0) {
                    SoundManager.vibrateShort('heavy');
                    if (this.targetLogicalBaseLayer) {
                        if (this.targetLogicalBaseLayer.isZombie) {
                            SoundManager.play(SOUND_PATH.ZOMBIEBEATTACK);
                        }
                    }
                    this.playerLogicalBaseLayer.resetDoubleKill();
                    if (!CharacterManger.isWarmUp) {
                        this.playerLogicalBaseLayer.playerKillCount++;
                        this.targetLogicalBaseLayer.playerBeKillCount++;
                        this.playerLogicalBaseLayer.score = this.playerLogicalBaseLayer.playerKillCount * TaskManager.singleKillScore;
                    }
                    this.targetLogicalBaseLayer.getPresentationBaseLayer().setKillingSituation(this.playerLogicalBaseLayer);
                    this.targetLogicalBaseLayer.getPresentationBaseLayer().setGamingHeadState();
                    let isHead = false;
                    let isRevenge = false;
                    if (ModeManager.mode != GAME_MODE_TYPE.BIOCHEMISTRY) {
                        if (this.targetLogicalBaseLayer.gameName == this.killerName) {
                            isRevenge = true;
                            this.killerName = null;
                        }
                    }
                    if (this.playerLogicalBaseLayer.getArmCtrl()) {
                        if (this.playerLogicalBaseLayer.getArmCtrl().getType() == 3) {
                            TaskManager.completeTask(TASK_TYPE.SNIPE_KILL);
                        }
                    }
                    if (ModeManager.mode == GAME_MODE_TYPE.KNIFEWARMODE || ModeManager.mode == GAME_MODE_TYPE.ONEVSONEMODE || ModeManager.mode == GAME_MODE_TYPE.SNIPERMODE || ModeManager.mode == GAME_MODE_TYPE.TWOVSTWOMODE) {
                        TaskManager.completeTask(TASK_TYPE.MODE_KILL);
                    }
                    if (this.hitLocation == HITLOCATION.HEAD) {
                        TaskManager.completeTask(TASK_TYPE.HEADSHOT);
                    }
                    if (isRevenge) {
                        if (!this.revengeItemCtrl) {
                            this.revengeItemCtrl = new RevengeItemCtrl();
                            UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).addChild(this.revengeItemCtrl);
                        }
                        this.revengeItemCtrl.play();
                    }
                    if (this.hitLocation == HITLOCATION.HEAD) {
                        isHead = true;
                        this.playerLogicalBaseLayer.resetHeadKill();
                        if (!isRevenge) {
                            this.playerLogicalBaseLayer.getPresentationBaseLayer().playHeadshot();
                        }
                    }
                    if (!isRevenge) {
                        if (isHead) {
                            Laya.timer.once(900, this, function cd() {
                                this.playerLogicalBaseLayer.getPresentationBaseLayer().startPlayDoubleKill();
                                Laya.timer.clear(this, cd);
                            });
                        } else {
                            this.playerLogicalBaseLayer.getPresentationBaseLayer().startPlayDoubleKill();
                        }
                    }
                    NotifyManager.notify(NOTIFY_ID.PLAYER_WAR_SITUATION);
                    let isHitLocation = this.hitLocation == HITLOCATION.HEAD ? true : false;
                    let killerIsPlayer = true;
                    let beKillerIsPlayer = false;
                    NotifyManager.notify(NOTIFY_ID.PLAYER_KILL_DETAILS, {
                        armName: CharacterManger.playerLogicalBaseLayer.getArmCtrl().getArmName(),
                        targetName: CharacterManger.targetLogicalBaseLayer.gameName
                    });
                    NotifyManager.notify(NOTIFY_ID.KILL_BROADCAST, {
                        killerIsPlayer: killerIsPlayer,
                        beKillerIsPlayer: beKillerIsPlayer,
                        killer: CharacterManger.playerLogicalBaseLayer.gameName,
                        beKiller: this.targetLogicalBaseLayer.gameName,
                        armType: 1,
                        isHitLocation: isHitLocation,
                        killerLogic: CharacterManger.playerLogicalBaseLayer
                    });
                    this.targetLogicalBaseLayer = null;
                    if (ModeManager.mode != GAME_MODE_TYPE.KNIFEWARMODE) {
                        if (CharacterManger.playerLogicalBaseLayer) {
                            if (CharacterManger.playerLogicalBaseLayer.getArmCtrl().getType() == 2) {
                                TaskManager.completeTask(TASK_TYPE.KNIFE_KILL);
                            }
                        }
                    }
                    if (ModeManager.mode == GAME_MODE_TYPE.ONEVSONEMODE) {
                        Laya.timer.once(2000, this, function cd() {
                            if (CharacterManger.gameOver)
                                return;
                            this.playerLogicalBaseLayer.getPresentationBaseLayer().setPos(this.playerLogicalBaseLayer.getInitPos());
                            Laya.timer.clear(this, cd);
                        });
                    }
                }
            } else {
                if (!arg.target)
                    return;
                if (!arg.target.getPresentationBaseLayer())
                    return;
                if (arg.target.getIsDie())
                    return;
                let hit = arg.hit;
                let fy = 30;
                if (arg.target.getIsMySelf()) {
                    fy = BuffManager.defenseGain;
                }
                let a = 100 - fy;
                arg.target.setCurArmor = arg.target.getArmor() - Math.floor(hit * fy / 100) < 0 ? 0 : arg.target.getArmor() - Math.floor(hit * fy / 100);
                arg.target.setHP = arg.target.getHP() - Math.floor(hit * a / 100) < 0 ? 0 : arg.target.getHP() - Math.floor(hit * a / 100);
                if (arg.target.getIsMySelf()) {
                    if (arg.isDoubleHit) {
                        SoundManager.playEffect3D(SOUND_PATH.BULLETHIT);
                        arg.target.getPresentationBaseLayer().speedCtrl();
                    }
                    if (arg.target.getHP() == 0) {
                        this.killerName = arg.killer.gameName;
                        this.killerSkin = arg.killer.curSkin;
                        this.killerLogic = arg.killer;
                        NotifyManager.notify(NOTIFY_ID.PLAYER_WAR_SITUATION);
                    }
                    UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).beZomBieHit();
                    this.playerBeHit(arg.killer);
                }
                if (arg.target.getHP() == 0) {
                    arg.killer.resetDoubleKill();
                    arg.killer.paths = null;
                    if (!CharacterManger.isWarmUp) {
                        arg.killer.playerKillCount++;
                        arg.target.playerBeKillCount++;
                        arg.killer.score = arg.killer.playerKillCount * TaskManager.singleKillScore;
                    }
                    arg.target.getPresentationBaseLayer().setKillingSituation(arg.killer);
                    arg.target.getPresentationBaseLayer().setGamingHeadState();
                    NotifyManager.notify(NOTIFY_ID.PLAYER_WAR_SITUATION);
                    if (ModeManager.mode == GAME_MODE_TYPE.ONEVSONEMODE) {
                        Laya.timer.once(3000, this, function cd() {
                            if (CharacterManger.gameOver)
                                return;
                            arg.killer.getPresentationBaseLayer().setPos(arg.killer.getInitPos());
                            Laya.timer.clear(this, cd);
                        });
                        Laya.timer.once(500, this, function cb() {
                            if (CharacterManger.gameOver)
                                return;
                            UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).toGiveUp();
                            Laya.timer.clear(this, cb);
                        });
                    }
                    if (arg.target) {
                        if (arg.target.isZombie) {
                            SoundManager.play(SOUND_PATH.ZOMBIEBEATTACK);
                        }
                    }
                }
                if (arg.target.getHP() == 0) {
                    let killerIsPlayer = (arg.killer.getRoleType() == ROLE_TYPE.TYPE_0) ? true : false;
                    let beKillerIsPlayer = (arg.target.getRoleType() == ROLE_TYPE.TYPE_0) ? true : false;
                    NotifyManager.notify(NOTIFY_ID.KILL_BROADCAST, {
                        killerIsPlayer: killerIsPlayer,
                        beKillerIsPlayer: beKillerIsPlayer,
                        killer: arg.killer.gameName,
                        beKiller: arg.target.gameName,
                        armType: 1,
                        isHitLocation: arg.isHitLocation,
                        killerLogic: arg.killer
                    });
                }
            }
        }
        static bombHit(pos, hit, logic) {
            for (let k = 0; k < this.logicalBaseLayer.length; k++) {
                let item = this.logicalBaseLayer[k];
                if (Laya.Vector3.distanceSquared(pos, item.getPresentationBaseLayer().getModelPosByVector3()) < 100 && logic.getRoleType() != item.getRoleType()) {
                    item.setHP = item.getHP() - hit < 0 ? 0 : item.getHP() - hit;
                    if (item.getHP() === 0) {
                        let killerIsPlayer = false;
                        let beKillerIsPlayer = false;
                        let killer = logic.gameName;
                        let target = item.gameName;
                        if (!CharacterManger.isWarmUp) {
                            logic.playerKillCount++;
                            item.playerBeKillCount++;
                            logic.score = logic.playerKillCount * TaskManager.singleKillScore;
                        }
                        item.getPresentationBaseLayer().setKillingSituation(logic);
                        item.getPresentationBaseLayer().setGamingHeadState();
                        if (logic.getRoleType() == ROLE_TYPE.TYPE_0) {
                            killerIsPlayer = true;
                        }
                        if (item.getRoleType() == ROLE_TYPE.TYPE_0) {
                            beKillerIsPlayer = true;
                        }
                        if (ModeManager.mode == GAME_MODE_TYPE.ONEVSONEMODE) {
                            Laya.timer.once(3000, this, function cd() {
                                if (CharacterManger.gameOver)
                                    return;
                                logic.getPresentationBaseLayer().setPos(logic.getInitPos());
                                Laya.timer.clear(this, cd);
                            });
                            Laya.timer.once(500, this, function cb() {
                                if (CharacterManger.gameOver)
                                    return;
                                UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).toGiveUp();
                                Laya.timer.clear(this, cb);
                            });
                        }
                        if (logic.getIsMySelf()) {
                            NotifyManager.notify(NOTIFY_ID.PLAYER_KILL_DETAILS, {
                                armName: '炸弹',
                                targetName: target
                            });
                        }
                        if (ModeManager.mode == GAME_MODE_TYPE.KNIFEWARMODE || ModeManager.mode == GAME_MODE_TYPE.ONEVSONEMODE || ModeManager.mode == GAME_MODE_TYPE.SNIPERMODE || ModeManager.mode == GAME_MODE_TYPE.TWOVSTWOMODE) {
                            TaskManager.completeTask(TASK_TYPE.MODE_KILL);
                        }
                        this.playerLogicalBaseLayer.getPresentationBaseLayer().startPlayBombKill();
                        NotifyManager.notify(NOTIFY_ID.PLAYER_WAR_SITUATION);
                        killerIsPlayer = (logic.getRoleType() == ROLE_TYPE.TYPE_0) ? true : false;
                        beKillerIsPlayer = (item.getRoleType() == ROLE_TYPE.TYPE_0) ? true : false;
                        NotifyManager.notify(NOTIFY_ID.KILL_BROADCAST, {
                            killerIsPlayer: killerIsPlayer,
                            beKillerIsPlayer: beKillerIsPlayer,
                            killer: killer,
                            beKiller: target,
                            armType: ARM_TYPE.BOMB,
                            isHitLocation: false,
                            killerLogic: logic
                        });
                    }
                }
            }
        }
        static resetGetArm(logic) {
            logic.getArmCtrl().switchArm();
        }
        static getTargetLogic(arg) {
            for (let k = 0; k < this.logicalBaseLayer.length; k++) {
                let logicalBaseLayer = this.logicalBaseLayer[k];
                if (logicalBaseLayer.getPresentationBaseLayer().getModelID() == arg.ID) {
                    this.targetLogicalBaseLayer = logicalBaseLayer;
                }
            }
        }
        static setDoubleKill() {
            for (let k = 0; k < this.logicalBaseLayer.length; k++) {
                let logicalBaseLayer = this.logicalBaseLayer[k];
                if (logicalBaseLayer != null) {
                    logicalBaseLayer.setDoubleKill();
                }
            }
        }
        static aiResetGetTargetLogic(selfLogic, oriLogic) {
            let min = Laya.Vector3.distanceSquared(selfLogic.getPresentationBaseLayer().getModelPosByVector3(), oriLogic.getPresentationBaseLayer().getModelPosByVector3());
            let tar = oriLogic;
            for (let k = 0; k < this.logicalBaseLayer.length; k++) {
                let logicalBaseLayer = this.logicalBaseLayer[k];
                if (logicalBaseLayer.getRoleType() != selfLogic.getRoleType() && logicalBaseLayer.getPresentationBaseLayer().getModelID() != oriLogic.getPresentationBaseLayer().getModelID()) {
                    let dis = Laya.Vector3.distanceSquared(selfLogic.getPresentationBaseLayer().getModelPosByVector3(), logicalBaseLayer.getPresentationBaseLayer().getModelPosByVector3());
                    if (min > dis) {
                        min = dis;
                        tar = logicalBaseLayer;
                    }
                }
            }
            return tar;
        }
        static playerBeHit(logic) {
            if (!this.playerBeHitImg) {
                this.playerBeHitImg = new Laya.Image(RES_PATH.BEHIT_UI);
                SceneManager.getCurScene().addChild(this.playerBeHitImg);
                this.playerBeHitImg.x = Laya.stage.width / 2;
                this.playerBeHitImg.y = Laya.stage.height / 2;
                this.playerBeHitImg.anchorY = 1;
                this.playerBeHitImg.anchorX = 0;
            }
            if (logic) {
                if (logic.isInvincible) {
                    this.playerBeHitImg.visible = false;
                    return;
                }
            }
            this.countDown = 1000;
            this.isOpenBeHitImg = true;
            this.playerBeHitImg.visible = true;
            let pos = SceneManager.getCurScene().getViewportPoint(logic.getPresentationBaseLayer().getModelPosByVector3());
            let atan = Math.atan(pos.y / pos.x);
            let angle = 180 / Math.PI * atan;
            angle += 70;
            this.playerBeHitImg.rotation = angle;
        }
        static countDownBeHit() {
            if (!this.isOpenBeHitImg)
                return;
            this.countDown -= LogicTimer.gSysTimer.delta;
            if (this.countDown < 0) {
                if (this.playerBeHitImg)
                    this.playerBeHitImg.visible = false;
                this.isOpenBeHitImg = false;
            }
        }
        static moveToEnemyCamp() {}
    }
    CharacterManger.playerLogicalBaseLayer = null;
    CharacterManger.logicalBaseLayer = [];
    CharacterManger._isWin = false;
    CharacterManger.fisrtPoint = null;
    CharacterManger.targetLogicalBaseLayer = null;
    CharacterManger.ourKillScore = 0;
    CharacterManger.enemyKillScore = 0;
    CharacterManger.hitLocation = '';
    CharacterManger.gameOver = false;
    CharacterManger.outDataList = [];
    CharacterManger.enemyDataList = [];
    CharacterManger.playerBeHitImg = null;
    CharacterManger.isOpenBeHitImg = false;
    CharacterManger.countDown = 1000;
    CharacterManger.zombieModeRescueLogic = null;
    CharacterManger.gameStop = false;
    CharacterManger.killerName = '';
    CharacterManger.drSkinList = [];
    CharacterManger.killerSkin = '001';
    CharacterManger.killerLogic = null;
    CharacterManger.isWarmUp = true;
    CharacterManger.revengeItemCtrl = null;
    CharacterManger.curFRArmList = [];
    CharacterManger.curTargetNum = {
        index: 0,
        icon: ''
    };

    class LoadingViewCtrl extends ui.view.load.LoadingViewUI {
        constructor(maxPart = 1) {
            super();
            this.startSec = 0;
            this.maxLen = 0;
            this.startSec = Laya.timer.currTimer;
            this.height = Laya.stage.height;
            this.width = this.stage.width;
            this.maxLen = this.imgPro.width;
            this.imgPro.width = 0;
            this.txtPercent.text = '玩命加载中，请耐心等待...(0%)';
            this.maxPart = maxPart;
            if (ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.TT) {
                this.imgRole1.visible = false;
                this.imgRole2.visible = false;
            }
        }
        onAwake() {
            this.setPlatformStyle();
            AdUtil.hideBannerAd();
            if (ConfigManager.gameType == GAME_MJB_TYPE.YHXYQZ) {
                this.imgLoading.skin = 'loading/img_3.png';
            } else if (ConfigManager.gameType == GAME_MJB_TYPE.YHQZSN) {
                this.imgLoading.skin = 'loading/img_17.png';
            }
            if (ConfigManager.platform != PLATFORM_TYPE.WX) {
                this.imgLoading.skin = 'loading/img_18.png';
            }
        }
        close() {
            let delta = Laya.timer.currTimer - this.startSec;
            if (delta < 1500) {
                this.timer.once(1500 - delta, this, function() {
                    this.destroy();
                });
            } else {
                this.destroy();
            }
        }
        setProgress(percent, curPart = 1) {
            if (isNaN(percent))
                return;
            let allPercent = ((curPart - 1) / this.maxPart) + percent * (1 / this.maxPart);
            this.txtPercent.text = Math.floor(allPercent * 100) + '%';
            let width = this.maxLen * allPercent;
            Laya.Tween.clearAll(this.imgPro);
            Laya.Tween.to(this.imgPro, {
                width: width
            }, 200);
        }
        onDestroy() {
            Laya.timer.clearAll(this);
            this.txtPercent = null;
            if (UIManager.newFunc.tag != FUNCTION_TAG.FIRST) {
                AdUtil.hideBannerAd();
            } else {
                if (ConfigManager.appId == PLATFORM_TYPE.WX || ConfigManager.platform == PLATFORM_TYPE.QQ || ConfigManager.appId == ANDROID_APP_ID.XM)
                    AdUtil.showBannerAd(14, PlatformUtil.getBannerCenterPos().y + (PlatformUtil.isIOS() ? 30 : 0));
            }
        }
        setPlatformStyle() {
            switch (ConfigManager.platform) {
                case PLATFORM_TYPE.WX:
                    {
                        this.setWXPlatform();
                        break;
                    }
                case PLATFORM_TYPE.QQ:
                    {
                        this.setQQPlatform();
                        break;
                    }
                case PLATFORM_TYPE.WEB:
                    {
                        this.setWXPlatform();
                        break;
                    }
                case PLATFORM_TYPE.WEB_4399:
                    {
                        this.setWeb4399Platform();
                        break;
                    }
                case PLATFORM_TYPE.VIVO:
                    {
                        this.setVIVOPlatform();
                        break;
                    }
                case PLATFORM_TYPE.OPPO:
                    {
                        this.setOPPOPlatform();
                        break;
                    }
                case PLATFORM_TYPE.NATIVE_IOS:
                    {
                        this.setNativeIOSPlatform();
                        break;
                    }
                case PLATFORM_TYPE.NATIVE_ANDRIOD:
                    {
                        this.setNativeAndroidPlatform();
                        break;
                    }
                case PLATFORM_TYPE.TT:
                    {
                        this.setTTPlatform();
                        break;
                    }
            }
        }
        setWXPlatform() {
            if (PlatformUtil.isIOS()) {
                this.boxLoading.y -= 60;
            }
        }
        setQQPlatform() {}
        setWebPlatform() {}
        setWeb4399Platform() {}
        setVIVOPlatform() {}
        setOPPOPlatform() {}
        setNativeIOSPlatform() {}
        setNativeAndroidPlatform() {}
        setTTPlatform() {}
    }

    class NativeBanner2ViewCtrl extends ui.view.native.NativeBanner2ViewUI {
        constructor() {
            super();
            this.isCanRefresh = true;
            this.isFirstTouch = true;
            this.isCanAutoShow = true;
        }
        onAwake() {
            this.left = 0;
            this.bottom = 10;
            this.on(Laya.Event.CLICK, this, this.onBtnAd);
            this.btnClose.on(Laya.Event.CLICK, this, this.onBtnClose);
            this.funcId = NotifyManager.register(NOTIFY_ID.REFRESH_NATIVE_AD, this.refresh, this);
            this.refresh();
        }
        onDestroy() {
            Laya.timer.clearAll(this);
            NotifyManager.unregisterByFuncId(this.funcId);
            LayaExtend.autoUnlinkUIReference(this);
            AdUtil.hideBannerAd();
        }
        onBtnAd() {
            if (!CommonUtil.getTouch())
                return;
            if (ConfigManager.platform == PLATFORM_TYPE.OPPO || ConfigManager.platform == PLATFORM_TYPE.VIVO) {
                AdUtil.nativeExtendList.ad && AdUtil.nativeExtendList.ad.reportAdClick({
                    adId: AdUtil.nativeExtendList.data.adId.toString()
                });
            }
            if (ConfigManager.platform == PLATFORM_TYPE.VIVO) {
                let that = this;
                AdUtil.preloadNativeAdExtend(function() {}, function() {}, NATIVE_TYPE.BANNER);
            }
        }
        onBtnClose() {
            this.destroy();
        }
        refresh() {
            if (!this.isCanRefresh)
                return;
            if (!this.imgAd)
                return;
            if (AdUtil.nativeExtendList.ad) {
                AdUtil.hideBannerAd();
                this.isCanAutoShow && this.show();
                if (ConfigManager.platform == PLATFORM_TYPE.OPPO || ConfigManager.platform == PLATFORM_TYPE.VIVO) {
                    AdUtil.nativeExtendList.ad && AdUtil.nativeExtendList.ad.reportAdShow({
                        adId: AdUtil.nativeExtendList.data.adId.toString()
                    });
                }
                this.imgAd.skin = AdUtil.nativeExtendList.data.imgUrlList[0];
            } else {
                this.autoHide();
                AdUtil.showBannerAd();
            }
        }
        hide() {
            if (this.destroyed)
                return;
            this.isCanAutoShow = false;
            this.mouseEnabled = false;
            this.visible = false;
        }
        autoHide() {
            this.mouseEnabled = false;
            this.visible = false;
        }
        show() {
            if (this.destroyed)
                return;
            this.isCanAutoShow = true;
            if (!AdUtil.nativeExtendList.ad)
                return;
            this.mouseEnabled = true;
            this.visible = true;
        }
    }

    class MatchingViewCtrl extends ui.view.matching.MatchingViewUI {
        constructor() {
            super();
            this.maxLen = 0;
            this.playerList = [];
            this.playerNum = 0;
            this.dataList = [];
            this.ready = {
                resReady: false,
                matching: false,
                mapUrl: null
            };
            this.activeTime = 0;
            this.step = 0;
            this.width = this.stage.width;
            this.height = this.stage.height;
            this.maxLen = this.imgPro.width;
            this.imgPro.width = 0;
        }
        onAwake() {
            this.init();
            this.setPlatformStyle();
            var that = this;
            this.timer.loop(100, this, function() {
                that.activeTime += 100;
                if (that.activeTime == 2500) {
                    that.doStep();
                } else {}
            });
        }
        doStep() {
            this.step++;
            if (this.step >= 2) {
                this.imgPro.width = 0;
                Laya.Tween.clearAll(this.imgPro);
                Laya.Tween.to(this.imgPro, {
                    width: this.maxLen
                }, 200, null, Laya.Handler.create(this, function() {
                    this.destroy();
                }));
            }
        }
        onDestroy() {
            this.timer.clearAll(this);
            this.maxLen = null;
            this.playerList = null;
            this.playerNum = null;
            this.ready = null;
            this.txtContent = null;
            this.txtPercent = null;
            this.ani1 = null;
            this.ani2 = null;
            this.ani3 = null;
            this.ani4 = null;
            this.dataList = null;
            UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).setNewPlayerArm();
        }
        init() {
            if (ConfigManager.platform == PLATFORM_TYPE.OPPO || ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.WEB_4399) {
                this.nativeBanner = new NativeBanner2ViewCtrl();
                this.addChild(this.nativeBanner);
                this.nativeBanner && this.nativeBanner.show();
            }
            AdUtil.hideBannerAd();
            CharacterManger.cleanDataList();
            this.ani2.play(0, true);
            this.ani1.play(0, true);
            this.ani3.play(0, false);
            this.ani3.on(Laya.Event.COMPLETE, this, () => {
                this.ani4.play(0, false);
            });
            this.ani4.on(Laya.Event.COMPLETE, this, () => {
                this.ani3.play(0, false);
            });
            TaskManager.setModelTargetKillSore();
            GameTimeManager.matchingShow();
            if (ModeManager.mode == GAME_MODE_TYPE.BIOCHEMISTRY) {
                this.txtContent.text = '目标：' + GameTimeManager.fixedTime + 's内' + '清除' + BiochemistryManager.matchingShow() + '只僵尸';
            } else {
                this.txtContent.text = '目标：率先获得' + TaskManager.targetKillSore + '分队伍获胜';
            }
        }
        onBtnClose() {
            if (!CommonUtil.getTouch())
                return;
            if (this.ready.matching && this.ready.resReady && this.ready.mapUrl != null)
                return;
            this.destroy();
        }
        setProgress(percent) {
            this.txtPercent.text = Math.floor(percent * 100) + '%';
            let width = this.maxLen * percent;
            Laya.Tween.clearAll(this.imgPro);
            Laya.Tween.to(this.imgPro, {
                width: width
            }, 200);
        }
        close() {
            this.doStep();
        }
        setPlatformStyle() {
            switch (ConfigManager.platform) {
                case PLATFORM_TYPE.WX:
                    {
                        this.setWXPlatform();
                        break;
                    }
                case PLATFORM_TYPE.QQ:
                    {
                        this.setQQPlatform();
                        break;
                    }
                case PLATFORM_TYPE.WEB:
                    {
                        this.setWXPlatform();
                        break;
                    }
                case PLATFORM_TYPE.VIVO:
                    {
                        this.setVIVOPlatform();
                        break;
                    }
                case PLATFORM_TYPE.OPPO:
                    {
                        this.setOPPOPlatform();
                        break;
                    }
                case PLATFORM_TYPE.NATIVE_IOS:
                    {
                        this.setNativeIOSPlatform();
                        break;
                    }
                case PLATFORM_TYPE.NATIVE_ANDRIOD:
                    {
                        this.setNativeAndroidPlatform();
                        break;
                    }
                case PLATFORM_TYPE.TT:
                    {
                        this.setTTPlatform();
                        break;
                    }
            }
        }
        setWXPlatform() {}
        setQQPlatform() {}
        setWebPlatform() {}
        setVIVOPlatform() {}
        setOPPOPlatform() {}
        setNativeIOSPlatform() {}
        setNativeAndroidPlatform() {}
        setTTPlatform() {}
    }

    class ProduceGoldCtrl extends ui.view.equip.ProduceGoldUI {
        constructor(price, isAddGold = true) {
            super();
            this.price = null;
            this.isAddGold = true;
            this.price = price;
            this.txtProduce.text = '+' + this.price.toString();
            this.anchorX = .5;
            this.anchorY = .5;
            this.isAddGold = isAddGold;
        }
        onAwake() {}
        onDestroy() {
            this.txtProduce = null;
            this.price = null;
        }
        updateGold() {
            if (this.price < 0) {
                this.visible = false;
                return;
            }
            this.visible = true;
            if (this.isAddGold) {
                RoleManager.getInstance().rewardGold(this.price);
                if (UIManager.getFunctionViewCtrl(FUNCTION_TAG.FIRST)) {
                    UIManager.getFunctionViewCtrl(FUNCTION_TAG.FIRST).price += this.price;
                }
            }
        }
        setSpecial(price) {
            this.txtProduce.text = '+' + this.price.toString();
        }
        resetSetData(price) {
            this.price = price;
            if (!this.price) {
                this.price = 0;
            }
            if (this.price <= 0) {
                this.visible = false;
            }
            this.txtProduce.text = '+' + this.price.toString();
        }
    }

    class SynthesisCellCtrl extends ui.view.equip.SynthesisCellUI {
        constructor(curData) {
            super();
            this.curData = null;
            this.productGold = null;
            this.countDown = 1000;
            this.synthesisAni = null;
            this.curData = curData;
            console.log('当前数据ID：', this.curData);
            this.init();
        }
        setBgStyle(style) {
            if (style == 0) {
                this.imgBg.skin = RES_PATH.SYNTHESIS_UI.CELL_STYLE_1;
            } else {
                this.imgBg.skin = RES_PATH.SYNTHESIS_UI.CELL_STYLE_2;
            }
        }
        onAwake() {}
        onDestroy() {
            this.curData = null;
            this.productGold = null;
            this.countDown = null;
            this.synthesisAni = null;
            this.imgBg = null;
            this.imgLock = null;
            this.imgSelect = null;
            this.imgTarget = null;
            this.txtLv = null;
            this.txtName = null;
        }
        init() {
            this.addEffect();
            this.setState();
            this.createProductGold();
        }
        addEffect() {
            this.synthesisAni = new Laya.Animation();
            this.synthesisAni.loadAnimation(RES_PATH.SYNTHESIS_UI.SYNTHESIS_ANI);
            this.synthesisAni.x = this.width / 2;
            this.synthesisAni.y = this.height / 2;
            this.synthesisAni.visible = false;
            this.synthesisAni.on(Laya.Event.COMPLETE, this, () => {
                this.synthesisAni.visible = false;
            });
            this.addChild(this.synthesisAni);
        }
        playAni() {
            if (this.synthesisAni) {
                this.synthesisAni.visible = true;
                this.synthesisAni.play(0, false);
            }
        }
        sameSelect() {
            this.imgSelect.visible = true;
            this.imgTarget.alpha = 1;
            this.ani2.play(0, true);
        }
        unSameAsh() {
            this.imgBg.disabled = true;
            this.imgTarget.disabled = true;
        }
        exitAsh() {
            this.imgBg.disabled = false;
            this.imgTarget.disabled = false;
        }
        select() {
            this.imgSelect.visible = true;
            this.imgTarget.alpha = 0.3;
        }
        unSelect() {
            this.imgSelect.visible = false;
            this.imgTarget.alpha = 1;
            this.ani2.stop();
            this.imgTarget.rotation = 0;
            this.imgBg.disabled = false;
            this.imgTarget.disabled = false;
        }
        autoToLight() {
            this.timer.once(1000, this, () => {});
        }
        autoToLightNoAn() {}
        autoToAn() {}
        createProductGold() {
            this.productGold = new ProduceGoldCtrl((this.curData != undefined && this.curData != -1 && this.curData != -2) ? ARM.getDataByKey(this.curData).produce : -100);
            this.productGold.alpha = 0;
            this.productGold.x = this.width / 2;
            this.productGold.y = this.height / 2;
            this.addChild(this.productGold);
        }
        setState(toBuy = false) {
            this.imgSelect.visible = false;
            this.imgLock.visible = false;
            this.imgSelect.visible = false;
            this.imgTarget.visible = false;
            this.txtLv.visible = false;
            this.txtName.visible = false;
            this.imgBg.alpha = 1;
            if (this.curData == -1) {
                this.imgBg.disabled = false;
            } else if (this.curData == undefined) {
                this.imgBg.disabled = true;
                this.imgLock.visible = true;
            } else {
                this.imgBg.disabled = false;
                this.imgTarget.visible = true;
                this.txtLv.visible = true;
                let data = ARM.getDataByKey(this.curData);
                if (data) {
                    this.imgTarget.scale(0.2, 0.2);
                    Laya.Tween.clearAll(this.imgTarget);
                    if (!toBuy) {
                        Laya.Tween.to(this.imgTarget, {
                            scaleX: 1,
                            scaleY: 1
                        }, 300, Laya.Ease.backOut, Laya.Handler.create(this, () => {
                            this.imgTarget.scale(1, 1);
                        }));
                    } else {
                        Laya.Tween.to(this.imgTarget, {
                            scaleX: 1.3,
                            scaleY: 1.3
                        }, 300, Laya.Ease.backOut, Laya.Handler.create(this, () => {
                            Laya.Tween.to(this.imgTarget, {
                                scaleX: 1,
                                scaleY: 1
                            }, 300, Laya.Ease.backOut, Laya.Handler.create(this, () => {
                                this.imgTarget.scale(1, 1);
                            }));
                        }));
                    }
                    this.imgTarget.skin = data.icon;
                    this.txtName.text = data.name;
                    this.txtLv.text = data.id.toString();
                } else {
                    this.imgBg.disabled = false;
                    this.imgTarget.visible = false;
                    this.txtLv.visible = false;
                    this.txtName.visible = false;
                }
            }
        }
        playProductGoldAni() {
            if (this.curData == -1 || this.curData == undefined)
                return;
            this.countDown -= LogicTimer.gSysTimer.delta;
            if (this.countDown < 0) {
                this.countDown = 5000;
                Laya.Tween.clearAll(this.productGold);
                if (this.parent.parent.parent) {
                    this.productGold.y = this.height / 2;
                    this.productGold.alpha = 1;
                    this.ani1.play(0, false);
                    Laya.Tween.to(this.productGold, {
                        y: 0
                    }, 500, null, Laya.Handler.create(this, () => {
                        Laya.Tween.to(this.productGold, {
                            y: -5,
                            alpha: 0
                        }, 800, null, Laya.Handler.create(this, () => {
                            Laya.Tween.clearAll(this.productGold);
                        }));
                    }), 200);
                }
                this.productGold.updateGold();
            }
        }
    }

    class AirdropItemCtrl extends ui.view.equip.AirdropItemUI {
        constructor(data) {
            super();
            this.data = null;
            this.isUse = false;
            this.data = data;
            this.isUse = this.data.isUse;
        }
        resetData(data) {
            this.visible = true;
            this.data = data;
            this.isUse = this.data.isUse;
        }
        onAwake() {
            this.ani1.play(0, true);
            this.on(Laya.Event.CLICK, this, this.onBtnTouch);
        }
        onDestroy() {
            this.ani1 = null;
        }
        onBtnTouch() {
            console.log('点击宝箱:', this.data);
            let that = this;
            SoundManager.play(SOUND_PATH.TOUCHBOX);
            if (this.data.type == AIRDROP_TYPE.DIRECT_OPEN) {
                this.data.direct();
                this.visible = false;
                this.isUse = true;
            } else {
                if (PeopleFactory.getInstance().getEmptyPosNum() == 1) {
                    this.data.type = AIRDROP_TYPE.SUPERREWARD_SINGLE;
                }
                let data = {
                    data: this.data,
                    commonCb: function() {
                        that.visible = false;
                        that.isUse = true;
                    }
                };
                UIManager.openFunction(FUNCTION_TAG.SUPER_REWARD, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE, data);
            }
        }
    }

    class ApertureGuideItemCtrl extends ui.view.guide.ApertureGuideItemUI {
        constructor() {
            super();
            this.visible = false;
        }
        onDestroy() {
            this.ani1 = null;
        }
        play(isPlayFinger) {
            if (!this.visible)
                this.visible = true;
            this.ani1.play(0, true);
            if (isPlayFinger) {
                if (!this.imgFinger.visible)
                    this.imgFinger.visible = true;
            }
        }
        stop() {
            if (this.visible)
                this.visible = false;
            this.ani1.stop();
        }
    }

    class FingerAniCtrl extends ui.view.guide.FingerAniUI {
        constructor() {
            super();
            this.visible = false;
        }
        onDestroy() {
            this.ani1 = null;
        }
        play() {
            if (!this.visible)
                this.visible = true;
            this.ani1.play(0, true);
        }
        stop() {
            if (this.visible)
                this.visible = false;
            this.ani1.stop();
        }
    }

    class GuideManager {
        static createCommonAperture(parent) {
            let item = new ApertureGuideItemCtrl();
            parent.addChild(item);
            return item;
        }
        static createFinger(parent) {
            let img = new Laya.Image('sub1/ui/guide/img_1.png');
            parent.addChild(img);
            return img;
        }
        static createFingerAniCtrl(parent) {
            let item = new FingerAniCtrl();
            parent.addChild(item);
            return item;
        }
    }
    GuideManager.synthesisGuidanceSteps = 1;
    GuideManager.curEquiplLibraryStep = GuideStep.BUY;

    let BOX_ID = {
        EMPTY_BOX: -1,
        AIRDROP_BOX: -2
    };
    let AIRDROP_TYPE = {
        DIRECT_OPEN: 1,
        SUPERREWARD_SINGLE: 2,
        SUPERREWARD_DOUBLE: 3
    };
    class PeopleFactory extends Laya.Script {
        constructor() {
            super();
            this.container = null;
            this.arrCache = [];
            this.isSynthesising = false;
            this.airdropNum = 0;
            this.maxAirdropNum = 3;
            this.isCanShowTwoSuperNum = false;
            this.superRewardNum = 0;
            this.airDropList = [];
            this.newID = 1;
            this.imgDailyGuideFinger = null;
            this.dailyAperture = null;
            this.newcacheList = [];
            this.isDailyGudeCompounding = false;
            this.isDailyGudeToBuy = false;
        }
        static getInstance() {
            if (!PeopleFactory.instance) {
                PeopleFactory.instance = new PeopleFactory();
            }
            return PeopleFactory.instance;
        }
        setContent(container, cols, rows) {
            this.container = container;
            this.arrCache = [];
            this.init(cols, rows);
        }
        init(cols, rows) {
            let matrix = RoleManager.getInstance().getMatrix();
            let count = 0;
            for (let i = 0; i < rows; i++) {
                for (let j = 0; j < cols; j++) {
                    count++;
                    let cell = new SynthesisCellCtrl(matrix[count - 1]);
                    cell.x = 1 + (cell.width + 2) * j;
                    cell.y = (cell.height + 3.5) * i;
                    this.arrCache.push(cell);
                    this.container.addChild(cell);
                    cell.setBgStyle((i + j) % 2);
                }
            }
            this.initAirDrop();
        }
        addArm(targetCell, index, id, toBuy = false) {
            console.log('当前格子的武器ID:', targetCell);
            if (!targetCell)
                return;
            targetCell.curData = id;
            console.log('当前格子的武器ID:', targetCell.curData);
            targetCell.setState(toBuy);
            let matrix = RoleManager.getInstance().getMatrix();
            matrix[index] = id;
            targetCell.sameSelect();
            Laya.timer.once(500, this, function() {
                targetCell.unSelect();
            });
            if (targetCell.productGold)
                targetCell.productGold.resetSetData(ARM.getDataByKey(id).produce);
            RoleManager.getInstance().updateMatrix(matrix);
            if (GuideManager.curEquiplLibraryStep >= GuideStep.TOEQUIP || RoleManager.getInstance().getGuide() >= GuideStep.TOEQUIP) {
                this.stopDailyGuideCompound();
            }
        }
        createImgDailyGuideFinger(parent) {
            if (!this.imgDailyGuideFinger) {
                this.imgDailyGuideFinger = GuideManager.createFinger(parent);
                this.imgDailyGuideFinger.visible = false;
                this.imgDailyGuideFinger.rotation = -45;
            }
        }
        createDailyAperture(parent) {
            if (!this.dailyAperture) {
                this.dailyAperture = GuideManager.createCommonAperture(parent);
                this.dailyAperture.visible = false;
                this.dailyAperture.anchorX = .5;
                this.dailyAperture.anchorY = .5;
                this.dailyAperture.centerX = 0;
                this.dailyAperture.centerY = 0;
            }
        }
        setDailyGuideCompound() {
            if (!this.isDailyGudeCompounding) {
                let that = this;
                this.newcacheList = [];
                for (let k = 0; k < this.arrCache.length; k++) {
                    let item = this.arrCache[k];
                    if (item.curData != undefined && item.curData != BOX_ID.AIRDROP_BOX && item.curData != BOX_ID.EMPTY_BOX) {
                        for (let i = 0; i < this.newcacheList.length; i++) {
                            if (this.newcacheList[i].curData == item.curData) {
                                item.autoToLightNoAn();
                                this.newcacheList[i].autoToLightNoAn();
                                this.imgDailyGuideFinger.visible = true;
                                let pos = new Laya.Point();
                                let action = function() {
                                    pos.x = 0;
                                    pos.y = 0;
                                    that.newcacheList[i].localToGlobal(pos);
                                    that.imgDailyGuideFinger.x = pos.x + that.newcacheList[i].width / 2;
                                    that.imgDailyGuideFinger.y = pos.y + that.newcacheList[i].height / 2;
                                    pos.x = 0;
                                    pos.y = 0;
                                    item.localToGlobal(pos);
                                    Laya.Tween.to(that.imgDailyGuideFinger, {
                                        x: pos.x + item.width / 2,
                                        y: pos.y + item.height / 2
                                    }, 2000, Laya.Ease.cubicOut, Laya.Handler.create(that, action));
                                };
                                action();
                                this.isDailyGudeCompounding = true;
                                return;
                            }
                        }
                        this.newcacheList.push(item);
                    }
                }
                this.isDailyGudeCompounding = false;
            }
        }
        getIsHasSame() {
            let list = [];
            for (let k = 0; k < this.arrCache.length; k++) {
                let item = this.arrCache[k];
                if (item.curData != undefined && item.curData != BOX_ID.AIRDROP_BOX && item.curData != BOX_ID.EMPTY_BOX) {
                    for (let i = 0; i < list.length; i++) {
                        if (list[i].curData == item.curData) {
                            return true;
                        }
                    }
                    list.push(item);
                }
            }
            return false;
        }
        stopDailyGuideCompound() {
            this.imgDailyGuideFinger.visible = false;
            this.isDailyGudeCompounding = false;
            for (let k = 0; k < this.arrCache.length; k++) {
                let item = this.arrCache[k];
                item.autoToAn();
            }
            Laya.Tween.clearAll(this.imgDailyGuideFinger);
        }
        guideDailyGuideToBuy() {
            console.log('是否还有空位：', this.checkEmptyPos(), this.isDailyGudeCompounding);
            if (this.checkEmptyPos()) {
                if (!this.isDailyGudeCompounding) {
                    if (!this.isDailyGudeToBuy) {
                        this.isDailyGudeToBuy = true;
                        this.imgDailyGuideFinger.visible = false;
                        this.dailyAperture.play(true);
                    }
                } else {
                    this.isDailyGudeToBuy = false;
                    this.dailyAperture.stop();
                }
            } else {
                if (!this.isDailyGudeCompounding) {
                    this.isDailyGudeToBuy = false;
                    this.imgDailyGuideFinger.visible = false;
                    this.dailyAperture.stop();
                }
            }
        }
        action(x, y) {
            Laya.Tween.to(this.imgDailyGuideFinger, {
                x: this.imgDailyGuideFinger.x + 30,
                y: this.imgDailyGuideFinger.y + 30
            }, 400, Laya.Ease.cubicOut, Laya.Handler.create(this, function() {
                Laya.Tween.to(this.imgDailyGuideFinger, {
                    x: x,
                    y: y
                }, 400, Laya.Ease.cubicOut, Laya.Handler.create(this, function() {
                    this.action(x, y);
                }));
            }));
        }
        checkEmptyPos() {
            let matrix = RoleManager.getInstance().getMatrix();
            for (let k = 0; k < matrix.length; k++) {
                if (matrix[k] == BOX_ID.EMPTY_BOX)
                    return true;
            }
            return false;
        }
        getLowerArm() {
            let hasArmList = RoleManager.getInstance().getSkinLib();
            let lower = hasArmList[0];
            for (let k = 0; k < hasArmList.length; k++) {
                if (lower > hasArmList[k]) {
                    lower = hasArmList[k];
                }
            }
            return lower;
        }
        getMaxArm() {
            let max = RoleManager.getInstance().getSynthesisMaxId();
            return max;
        }
        initAirDrop() {
            let matrix = RoleManager.getInstance().getMatrix();
            for (let k = 0; k < matrix.length; k++) {
                let targetIndex = 0;
                if (matrix[k] == BOX_ID.AIRDROP_BOX) {
                    this.airdropNum++;
                    targetIndex = k;
                    let airDropItem = new AirdropItemCtrl(this.airDropData(this.arrCache[targetIndex], targetIndex));
                    airDropItem.x = this.arrCache[targetIndex].width / 2;
                    airDropItem.y = this.arrCache[targetIndex].height / 2;
                    airDropItem.anchorX = .5;
                    airDropItem.anchorY = .5;
                    this.arrCache[targetIndex].addChild(airDropItem);
                    this.arrCache[targetIndex].curData = BOX_ID.AIRDROP_BOX;
                    this.airDropList.push(airDropItem);
                }
            }
        }
        getRandomEmptyPosToAddAirDrop() {
            if (this.isSynthesising)
                return;
            if (this.getEmptyPosNum() <= 3)
                return;
            if (UIManager.getFunction(FUNCTION_TAG.SUPER_REWARD))
                return;
            if (this.checkEmptyPos()) {
                if (this.airdropNum < this.maxAirdropNum) {
                    this.airdropNum++;
                    let targetIndex = 0;
                    let matrix = RoleManager.getInstance().getMatrix();
                    for (let k = 0; k < matrix.length; k++) {
                        if (matrix[k] == BOX_ID.EMPTY_BOX) {
                            targetIndex = k;
                            break;
                        }
                    }
                    let airDropItem = null;
                    let isHasCache = false;
                    for (let i = 0; i < this.airDropList.length; i++) {
                        let item = this.airDropList[i];
                        if (item.isUse) {
                            airDropItem = item;
                            isHasCache = true;
                        }
                    }
                    if (airDropItem == null) {
                        airDropItem = new AirdropItemCtrl(this.airDropData(this.arrCache[targetIndex], targetIndex));
                    } else {
                        airDropItem.resetData(this.airDropData(this.arrCache[targetIndex], targetIndex));
                    }
                    airDropItem.x = this.arrCache[targetIndex].width / 2;
                    airDropItem.y = this.arrCache[targetIndex].height / 2;
                    airDropItem.anchorX = .5;
                    airDropItem.anchorY = .5;
                    this.arrCache[targetIndex].addChild(airDropItem);
                    this.arrCache[targetIndex].curData = BOX_ID.AIRDROP_BOX;
                    if (!isHasCache) {
                        this.airDropList.push(airDropItem);
                    }
                    matrix[targetIndex] = BOX_ID.AIRDROP_BOX;
                    RoleManager.getInstance().updateMatrix(matrix);
                }
            }
        }
        getEmptyPosNum() {
            let num = 0;
            let matrix = RoleManager.getInstance().getMatrix();
            for (let k = 0; k < matrix.length; k++) {
                if (matrix[k] == BOX_ID.EMPTY_BOX) {
                    num++;
                }
            }
            return num;
        }
        getTwoEmptyPos(num) {
            let list = [];
            let matrix = RoleManager.getInstance().getMatrix();
            for (let k = 0; k < matrix.length; k++) {
                if (matrix[k] == BOX_ID.EMPTY_BOX) {
                    if (num != 0) {
                        num--;
                        let data = {
                            cell: this.arrCache[k],
                            index: k
                        };
                        list.push(data);
                    }
                }
            }
            return list;
        }
        airDropData(curCell, tarIndex) {
            let lower = this.getLowerArm();
            let max = this.getMaxArm();
            console.log('当前合成最高武器等级：', max, lower);
            let that = this;
            if (max == 1 || max == 2) {
                let data = {
                    type: AIRDROP_TYPE.DIRECT_OPEN,
                    showMax: null,
                    showLower: null,
                    direct: function() {
                        that.addArm(curCell, tarIndex, lower, false);
                        curCell.autoToLight();
                        if (that.airdropNum != 0) {
                            that.airdropNum--;
                        }
                    },
                    isUse: false,
                    viewSuccess: null,
                    viewFail: null
                };
                return data;
            } else {
                let type = AIRDROP_TYPE.SUPERREWARD_SINGLE;
                console.log('第几次获取数据：', this.superRewardNum);
                if (this.superRewardNum % 4 == 0) {
                    this.isCanShowTwoSuperNum = true;
                }
                this.superRewardNum++;
                if (this.getEmptyPosNum() > 1 && this.isCanShowTwoSuperNum) {
                    type = AIRDROP_TYPE.SUPERREWARD_DOUBLE;
                    this.isCanShowTwoSuperNum = false;
                }
                let a = RandomUtil.onlyOneRandomIntOrFloat(0, 1) > 0.5 ? 2 : 3;
                let showMax = max == 3 ? max : RandomUtil.onlyOneRandomInt(3, max);
                let showLower = showMax == 3 ? lower : showMax - a;
                let data = {
                    type: type,
                    direct: null,
                    showMax: showMax,
                    showLower: showLower,
                    isUse: false,
                    viewSuccess: function() {
                        if (type == AIRDROP_TYPE.SUPERREWARD_SINGLE) {
                            console.log('单个超级武器奖励格子：', curCell);
                            that.addArm(curCell, tarIndex, showMax, false);
                            curCell.autoToLight();
                        } else {
                            let list = that.getTwoEmptyPos(1);
                            console.log('多个超级武器奖励格子：', curCell, list, list.length);
                            if (list.length > 0) {
                                that.addArm(list[0].cell, list[0].index, showMax, false);
                                that.addArm(curCell, tarIndex, showMax, false);
                                list[0].cell.autoToLight();
                                curCell.autoToLight();
                            } else {
                                that.addArm(curCell, tarIndex, showMax, false);
                                curCell.autoToLight();
                            }
                        }
                        if (that.airdropNum != 0) {
                            that.airdropNum--;
                        }
                    },
                    viewFail: function() {
                        that.addArm(curCell, tarIndex, showLower, false);
                        curCell.autoToLight();
                        if (that.airdropNum != 0) {
                            that.airdropNum--;
                        }
                    }
                };
                return data;
            }
        }
        removeAirDrop() {}
        removeArm(targetCell, index, id) {
            targetCell.curData = id;
            console.log('移除武器：', targetCell.curData);
            targetCell.setState();
            let matrix = RoleManager.getInstance().getMatrix();
            matrix[index] = id;
            RoleManager.getInstance().updateMatrix(matrix);
            targetCell.productGold.resetSetData(-100);
        }
        getArrCache() {
            return this.arrCache;
        }
        checkUpgrade(id) {
            let matrix = RoleManager.getInstance().getMatrix();
            let max = matrix[0];
            for (let k = 0; k < matrix.length; k++) {
                let a = matrix[k];
                if (a > max) {
                    max = a;
                }
            }
            if (id > RoleManager.getInstance().getSynthesisMaxId()) {
                console.log('解锁了新的枪支');
                this.refreshMatrix();
                RoleManager.getInstance().setSkinLib(id);
                this.addNewArmQuality(id);
                RoleManager.getInstance().updateWarehouseGroove();
                this.newID = id;
                UIManager.openFunction(FUNCTION_TAG.NEW_EQUIP_UNLOCK, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE, id);
                RoleManager.getInstance().updateSkinGameCurLib(id);
            }
        }
        getEquip(id, cb = null, time = null, isAutoOpen = true) {
            console.log('解锁了新的枪支:', id);
            if (time) {
                console.log('获得非永久枪支');
                RoleManager.getInstance().setEquipHaveTime(id, time);
            } else {
                if (RoleManager.getInstance().getEquipHaveTime(id)) {
                    console.log('设置为永久枪支');
                    RoleManager.getInstance().setEquipHaveTime(id);
                }
            }
            RoleManager.getInstance().setSkinLib(id);
            this.addNewArmQuality(id);
            RoleManager.getInstance().updateSkinGameCurLib(id);
            RoleManager.getInstance().updateWarehouseGroove();
            let itemId = ITEM_TYPE.EQUIP.toString() + (id > 99 ? id : id > 9 ? '0' + id : '00' + id);
            if (isAutoOpen)
                UIManager.openFunction(FUNCTION_TAG.GET_EQUIP_REWARD, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE, {
                    id: itemId,
                    cb: cb
                });
            else {
                UIManager.registerAutoOpenFunction(FUNCTION_TAG.GET_EQUIP_REWARD, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE, {
                    id: itemId,
                    cb: cb
                });
            }
        }
        addNewArmQuality(id) {
            let data = {
                id: id,
                lv: 1,
                fire: ARM.getDataByKey(id).hit,
                pierceThrough: ARM.getDataByKey(id).pierceThrough,
                firingRate: ARM.getDataByKey(id).interval,
                numberOfBullets: ARM.getDataByKey(id).magazineBullet,
                range: ARM.getDataByKey(id).range,
                accurate: 100,
                ammunitionChange: ARM.getDataByKey(id).bullets,
                sight: ARM.getDataByKey(id).sight,
                movingSpeed: ARM.getDataByKey(id).movingSpeed,
                biochemicalCharging: ARM.getDataByKey(id).biochemicalCharging,
                bodyMultiple: ARM.getDataByKey(id).bodyMultiple,
                headHit: ARM.getDataByKey(id).headHit,
                limbMultiple: ARM.getDataByKey(id).limbMultiple,
                limbHit: ARM.getDataByKey(id).limbHit,
                maxBodyHit: ARM.getDataByKey(id).maxBodyHit,
                maxHeadHit: ARM.getDataByKey(id).maxHeadHit,
                maxLimbHit: ARM.getDataByKey(id).maxLimbHit
            };
            RoleManager.getInstance().addNewArmQuality(data);
        }
        refreshMatrix() {
            RoleManager.getInstance().openNewMatrix();
            let matrix = RoleManager.getInstance().getMatrix();
            console.log('matrix:', matrix);
            for (let i in this.arrCache) {
                let item = this.arrCache[i];
                item.curData = matrix[i];
                item.setState();
            }
        }
        synthesis(targetCell, curCell, targetIndex, curIndex) {
            if (!targetCell)
                return;
            if (!curCell)
                return;
            if (this.isSynthesising)
                return;
            this.isSynthesising = true;
            let img1 = new Laya.Image(targetCell.imgTarget.skin);
            let img2 = new Laya.Image(targetCell.imgTarget.skin);
            targetCell.addChild(img1);
            targetCell.addChild(img2);
            img1.anchorX = .5;
            img1.anchorY = .5;
            img2.anchorX = .5;
            img2.anchorY = .5;
            img1.x = targetCell.width / 2 - 20;
            img1.y = targetCell.height / 2 + 10;
            img2.x = targetCell.width / 2 + 20;
            img2.y = targetCell.height / 2 + 10;
            Laya.Tween.to(img1, {
                x: targetCell.width / 2
            }, 250, Laya.Ease.backIn, Laya.Handler.create(this, () => {
                Laya.Tween.clearAll(img1);
                img1.destroy();
            }));
            Laya.Tween.to(img2, {
                x: targetCell.width / 2
            }, 250, Laya.Ease.backIn, Laya.Handler.create(this, () => {
                Laya.Tween.clearAll(img2);
                img2.destroy();
                let targetID = targetCell.curData + 1;
                console.log('合成时候的当前矩阵：', RoleManager.getInstance().getMatrix());
                console.log('合成时候的目标ID：', targetID, '第几个:', targetIndex);
                SoundManager.playEffect(SOUND_PATH.COMPOND);
                this.isSynthesising = false;
                targetCell.playAni();
                this.checkUpgrade(targetID);
                this.addArm(targetCell, targetIndex, targetID);
                this.removeArm(curCell, curIndex, BOX_ID.EMPTY_BOX);
                GameScene.synthesisViewCtrl.updateGuide();
                RoleManager.getInstance().refreshCanbuyArm();
                RoleManager.getInstance().updateSynthesisMaxId(targetID);
            }));
            if (GuideManager.curEquiplLibraryStep >= GuideStep.TOEQUIP || RoleManager.getInstance().getGuide() >= GuideStep.TOEQUIP) {
                this.stopDailyGuideCompound();
            }
        }
        exchange(targetCell, curCell, targetIndex, curIndex) {
            if (this.isSynthesising)
                return;
            if (!targetCell)
                return;
            if (!curCell)
                return;
            let curCellID = curCell.curData;
            let preCurIndex = curIndex;
            this.addArm(curCell, preCurIndex, targetCell.curData);
            this.addArm(targetCell, targetIndex, curCellID);
            if (GuideManager.curEquiplLibraryStep >= GuideStep.TOEQUIP || RoleManager.getInstance().getGuide() >= GuideStep.TOEQUIP) {
                this.stopDailyGuideCompound();
            }
        }
        moveToEmptyEquip(targetCell, curCell, targetIndex, curIndex) {
            if (this.isSynthesising)
                return;
            if (!targetCell)
                return;
            if (!curCell)
                return;
            this.addArm(targetCell, targetIndex, curCell.curData);
            this.removeArm(curCell, curIndex, BOX_ID.EMPTY_BOX);
            if (GuideManager.curEquiplLibraryStep >= GuideStep.TOEQUIP || RoleManager.getInstance().getGuide() >= GuideStep.TOEQUIP) {
                this.stopDailyGuideCompound();
            }
        }
        getAirData() {
            if (this.getEmptyPosNum() <= 3)
                return null;
            if (!this.checkEmptyPos()) {
                return null;
            }
            if (this.getMaxArm() < 3)
                return null;
            let targetIndex = 0;
            let matrix = RoleManager.getInstance().getMatrix();
            for (let k = 0; k < matrix.length; k++) {
                if (matrix[k] == BOX_ID.EMPTY_BOX) {
                    targetIndex = k;
                    break;
                }
            }
            return this.airDropData(this.arrCache[targetIndex], targetIndex);
        }
    }

    class NativeIcon1CellCtrl extends ui.view.native.NativeIcon1CellUI {
        constructor() {
            super();
            this.isCanRefresh = true;
            this.isFirstTouch = true;
            this.isCanAutoShow = true;
        }
        onAwake() {
            this.on(Laya.Event.CLICK, this, this.onBtnAd);
            this.btnClose.on(Laya.Event.CLICK, this, this.onBtnClose);
            this.funcId = NotifyManager.register(NOTIFY_ID.REFRESH_NATIVE_AD, this.refresh, this);
            this.refresh();
        }
        onDestroy() {
            Laya.timer.clearAll(this);
            NotifyManager.unregisterByFuncId(this.funcId);
            LayaExtend.autoUnlinkUIReference(this);
            AdUtil.hideBannerAd();
        }
        onBtnAd() {
            if (!CommonUtil.getTouch())
                return;
            if (ConfigManager.platform == PLATFORM_TYPE.OPPO || ConfigManager.platform == PLATFORM_TYPE.VIVO) {
                AdUtil.nativeExtendIconList.ad && AdUtil.nativeExtendIconList.ad.reportAdClick({
                    adId: AdUtil.nativeExtendIconList.data.adId.toString()
                });
            }
            if (ConfigManager.platform == PLATFORM_TYPE.VIVO) {
                let that = this;
                AdUtil.preloadNativeAdExtend(function() {}, function() {}, NATIVE_TYPE.BANNER);
            }
        }
        onBtnClose() {
            this.destroy();
        }
        refresh() {
            if (!this.isCanRefresh)
                return;
            if (!this.imgAd)
                return;
            if (AdUtil.nativeExtendIconList.ad) {
                AdUtil.hideBannerAd();
                this.isCanAutoShow && this.show();
                if (ConfigManager.platform == PLATFORM_TYPE.OPPO || ConfigManager.platform == PLATFORM_TYPE.VIVO) {
                    AdUtil.nativeExtendIconList.ad && AdUtil.nativeExtendIconList.ad.reportAdShow({
                        adId: AdUtil.nativeExtendIconList.data.adId.toString()
                    });
                }
                this.imgAd.skin = AdUtil.nativeExtendIconList.data.imgUrlList[0];
            } else {
                this.autoHide();
                AdUtil.showBannerAd();
            }
        }
        hide() {
            if (this.destroyed)
                return;
            this.isCanAutoShow = false;
            this.mouseEnabled = false;
            this.visible = false;
        }
        autoHide() {
            this.mouseEnabled = false;
            this.visible = false;
        }
        show() {
            if (this.destroyed)
                return;
            this.isCanAutoShow = true;
            if (!AdUtil.nativeExtendIconList.ad)
                return;
            this.mouseEnabled = true;
            this.visible = true;
        }
    }

    class SynthesisViewCtrl extends ui.view.equip.SynthesisViewUI {
        constructor() {
            super();
            this.preTouchXY = {
                x: 0,
                y: 0
            };
            this.curImgData = {
                img: null,
                ID: -1,
                curIndex: -1,
                curCell: null
            };
            this.price = 0;
            this.curBuyID = 1;
            this.btnDorpAir = null;
            this.step = 1;
            this.isCheckNoLocal = false;
            this.normalCount = 5000;
            this.isOpen = false;
            this.onceHC = false;
            this.warehouseAperture = null;
            if (ConfigManager.platform != PLATFORM_TYPE.WEB_4399)
                this.bottom = 0;
            this.zOrder = ORDER_LAYER_Z.SYNTESIS;
            this.setGameEvent();
            this.init();
            this.setBtnEvent();
        }
        onAwake() {
            if (ConfigManager.platform == PLATFORM_TYPE.WX || ConfigManager.platform == PLATFORM_TYPE.QQ) {
                this.btnRecovery.x -= 60;
                this.btnShop.x += 60;
            }
        }
        onDestroy() {
            this.preTouchXY = null;
            this.curImgData = null;
            this.price = null;
            this.curBuyID = null;
            this.imgCurArm = null;
            this.txtLv = null;
            this.txtPrice = null;
            this.boxContentRoot = null;
            this.btnBuy = null;
            this.btnRecovery = null;
            this.btnShop = null;
            NotifyManager.unregisterByEventId(NOTIFY_ID.REFRESH_CANBUY_ARM);
            NotifyManager.unregisterByEventId(NOTIFY_ID.ADDARM_BY_SHOP);
        }
        onDisable() {
            if (GuideManager.curEquiplLibraryStep >= GuideStep.TOEQUIP || RoleManager.getInstance().getGuide() >= GuideStep.TOEQUIP) {
                PeopleFactory.getInstance().stopDailyGuideCompound();
            }
            this.isOpen = false;
        }
        init() {
            this.adCtrl();
            this.step = GuideManager.synthesisGuidanceSteps;
            PeopleFactory.getInstance().setContent(this.boxContentRoot, 4, 4);
            this.timer.frameLoop(1, this, this.updateTimer);
            RoleManager.getInstance().refreshCanbuyArm();
            PeopleFactory.getInstance().createImgDailyGuideFinger(this);
            PeopleFactory.getInstance().createDailyAperture(this.btnBuy);
            let guide = RoleManager.getInstance().getGuide();
            if (GuideManager.curEquiplLibraryStep > guide) {
                console.log('本地比较大--------------');
                guide = GuideManager.curEquiplLibraryStep;
                this.isCheckNoLocal = true;
            }
            console.log('这个guide-------------------------------:', guide);
            if (guide < GuideStep.TOEQUIP) {}
            this.timer.frameLoop(1, this, this.update);
        }
        createWarehouseAperture(parent) {
            if (!this.warehouseAperture) {
                this.warehouseAperture = GuideManager.createCommonAperture(parent);
                this.warehouseAperture.visible = false;
                this.warehouseAperture.anchorX = .5;
                this.warehouseAperture.anchorY = .5;
                this.warehouseAperture.centerX = 0;
                this.warehouseAperture.centerY = 0;
                this.warehouseAperture.stop();
            } else {
                this.warehouseAperture.visible = false;
                this.warehouseAperture.stop();
            }
        }
        unlockNewArm() {}
        adCtrl() {
            if (ConfigManager.platform == PLATFORM_TYPE.OPPO || ConfigManager.platform == PLATFORM_TYPE.WEB) {
                console.log('创建合成格子');
                this.nativeIcon1 = new NativeIcon1CellCtrl();
                this.addChild(this.nativeIcon1);
                this.nativeIcon2 = new NativeIcon1CellCtrl();
                this.addChild(this.nativeIcon2);
                this.nativeIcon1.x = this.width / 2 + 200;
                this.nativeIcon2.x = this.width / 2 - 290;
                this.nativeIcon1.bottom = 30;
                this.nativeIcon2.bottom = 30;
                this.nativeIcon1.scale(0.8, 0.8);
                this.nativeIcon2.scale(0.8, 0.8);
            }
        }
        update() {
            if (GuideManager.curEquiplLibraryStep >= GuideStep.TOEQUIP || RoleManager.getInstance().getGuide() >= GuideStep.TOEQUIP) {
                if (!this.isOpen)
                    return;
                this.normalCount -= Laya.timer.delta;
                if (this.normalCount < 0) {
                    this.normalCount = 5000;
                    if (GuideManager.curEquiplLibraryStep >= GuideStep.TOEQUIP || RoleManager.getInstance().getGuide() >= GuideStep.TOEQUIP) {
                        PeopleFactory.getInstance().setDailyGuideCompound();
                    }
                }
            }
        }
        setGuide() {
            console.log('合成界面指引:', GuideManager.curEquiplLibraryStep, RoleManager.getInstance().getGuide(), this.step);
            let guide = RoleManager.getInstance().getGuide();
            if (GuideManager.curEquiplLibraryStep > guide) {
                guide = GuideManager.curEquiplLibraryStep;
                this.isCheckNoLocal = true;
            }
            switch (guide) {
                case GuideStep.BUY:
                    console.log('购买指引');
                    if (this.step == 1) {
                        PeopleFactory.getInstance().dailyAperture.play(true);
                    } else {
                        switch (guide) {
                            case GuideStep.BUY:
                                console.log('更新购买指引');
                                PeopleFactory.getInstance().dailyAperture.stop();
                                if (this.step == 2) {
                                    console.log('一次合成');
                                    PeopleFactory.getInstance().setDailyGuideCompound();
                                } else if (this.step == 3) {
                                    console.log('二次购买');
                                    PeopleFactory.getInstance().stopDailyGuideCompound();
                                    PeopleFactory.getInstance().dailyAperture.play(true);
                                } else if (this.step == 4) {
                                    console.log('三次购买');
                                    PeopleFactory.getInstance().stopDailyGuideCompound();
                                    PeopleFactory.getInstance().dailyAperture.play(true);
                                } else if (this.step == 5) {
                                    console.log('二次合成');
                                    PeopleFactory.getInstance().stopDailyGuideCompound();
                                    PeopleFactory.getInstance().setDailyGuideCompound();
                                } else {
                                    console.log('最后一次合成指引');
                                    PeopleFactory.getInstance().stopDailyGuideCompound();
                                    RoleManager.getInstance().setGuide();
                                    this.setGuide();
                                }
                                break;
                            case GuideStep.SYNTHESIS:
                                console.log('更新合成指引');
                                PeopleFactory.getInstance().stopDailyGuideCompound();
                                RoleManager.getInstance().setGuide();
                                UIManager.getFunctionViewCtrl(FUNCTION_TAG.EQUIP).setGuide();
                                break;
                        }
                    }
                    break;
                case GuideStep.SYNTHESIS:
                    console.log('合成指引');
                    if (this.step == 6) {
                        PeopleFactory.getInstance().setDailyGuideCompound();
                    }
                    break;
                case GuideStep.WAREHOUSE:
                    console.log('指引进入仓库');
                    break;
            }
        }
        updateGuide() {
            if (!this.onceHC && this.step == 2)
                return;
            this.step++;
            if (this.step == 4) {
                if (PeopleFactory.getInstance().getIsHasSame()) {
                    this.step++;
                }
            }
            GuideManager.synthesisGuidanceSteps = this.step;
            let guide = RoleManager.getInstance().getGuide();
            if (GuideManager.curEquiplLibraryStep > guide) {
                guide = GuideManager.curEquiplLibraryStep;
            }
            switch (guide) {
                case GuideStep.BUY:
                    console.log('更新购买指引');
                    PeopleFactory.getInstance().dailyAperture.stop();
                    if (this.step == 2) {
                        console.log('一次合成');
                        PeopleFactory.getInstance().setDailyGuideCompound();
                    } else if (this.step == 3) {
                        console.log('二次购买');
                        PeopleFactory.getInstance().stopDailyGuideCompound();
                        PeopleFactory.getInstance().dailyAperture.play(true);
                    } else if (this.step == 4) {
                        console.log('三次购买');
                        PeopleFactory.getInstance().stopDailyGuideCompound();
                        PeopleFactory.getInstance().dailyAperture.play(true);
                    } else if (this.step == 5) {
                        console.log('二次合成');
                        PeopleFactory.getInstance().stopDailyGuideCompound();
                        PeopleFactory.getInstance().setDailyGuideCompound();
                    } else {
                        console.log('最后一次合成指引');
                        PeopleFactory.getInstance().stopDailyGuideCompound();
                        if (this.isCheckNoLocal) {
                            GuideManager.curEquiplLibraryStep++;
                        } else {
                            RoleManager.getInstance().setGuide();
                        }
                        this.setGuide();
                    }
                    break;
                case GuideStep.SYNTHESIS:
                    console.log('更新合成指引');
                    PeopleFactory.getInstance().stopDailyGuideCompound();
                    if (this.isCheckNoLocal) {
                        GuideManager.curEquiplLibraryStep++;
                    } else {
                        RoleManager.getInstance().setGuide();
                    }
                    UIManager.getFunctionViewCtrl(FUNCTION_TAG.EQUIP).setGuide();
                    this.setGuide();
                    break;
            }
        }
        moveButNoHC() {
            if (RoleManager.getInstance().getGuide() == GuideStep.BUY) {
                if (this.step == 2) {
                    PeopleFactory.getInstance().stopDailyGuideCompound();
                    PeopleFactory.getInstance().setDailyGuideCompound();
                } else if (this.step == 5) {
                    PeopleFactory.getInstance().stopDailyGuideCompound();
                    PeopleFactory.getInstance().setDailyGuideCompound();
                }
            } else if (RoleManager.getInstance().getGuide() == GuideStep.SYNTHESIS) {
                PeopleFactory.getInstance().stopDailyGuideCompound();
                PeopleFactory.getInstance().setDailyGuideCompound();
            }
        }
        updateTimer() {
            for (let k = 0; k < RoleManager.getInstance().getMatrix().length; k++) {
                let item = RoleManager.getInstance().getMatrix()[k];
                if (item != BOX_ID.EMPTY_BOX && item != BOX_ID.AIRDROP_BOX) {
                    if (PeopleFactory.getInstance().getArrCache()[k]) {
                        PeopleFactory.getInstance().getArrCache()[k].playProductGoldAni();
                    }
                }
            }
            if (this.btnDorpAir && this.btnDorpAir.visible) {}
        }
        setGameEvent() {
            NotifyManager.register(NOTIFY_ID.REFRESH_CANBUY_ARM, this.refreshCanBuyArm, this);
            NotifyManager.register(NOTIFY_ID.ADDARM_BY_SHOP, this.refreshAddArm, this);
        }
        refreshAddArm(args) {
            if (!CommonUtil.getTouch())
                return;
            if (ARM.getDataByKey(this.curBuyID).price > RoleManager.getInstance().getGold())
                return;
            let targetCell = null;
            let index = 0;
            for (let i in PeopleFactory.getInstance().getArrCache()) {
                let item = PeopleFactory.getInstance().getArrCache()[i];
                if (item.curData == BOX_ID.EMPTY_BOX) {
                    targetCell = item;
                    index = parseInt(i);
                    break;
                }
            }
            if (targetCell) {
                PeopleFactory.getInstance().addArm(targetCell, index, args.id);
            }
        }
        setBtnEvent() {
            this.on(Laya.Event.MOUSE_DOWN, this, this.touchBegin);
            this.on(Laya.Event.MOUSE_MOVE, this, this.touchMove);
            this.on(Laya.Event.MOUSE_UP, this, this.touchEnd);
            this.btnBuy.on(Laya.Event.CLICK, this, this.onBtnBuy);
            this.btnShop.on(Laya.Event.CLICK, this, this.onBtnShop);
        }
        onBtnWarehouseDown() {}
        onBtnWarehouseOut() {}
        onBtnWarehouse() {
            UIManager.openFunction(FUNCTION_TAG.LIBRARY, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.ALL_SHOW);
        }
        refreshCanBuyArm(args) {
            RewardManager.id = args.id;
            this.imgCurArm.skin = ARM.getDataByKey(args.id).icon;
            this.txtPrice.text = StringUtil.parseGold(Math.floor(ARM.getDataByKey(args.id).price * Math.pow(ConfigManager.costGold, RoleManager.getInstance().getBuyByGoldNum()))).toString();
            this.txtLv.text = ARM.getDataByKey(args.id).id.toString();
            this.price = Math.floor(ARM.getDataByKey(args.id).price * Math.pow(ConfigManager.costGold, RoleManager.getInstance().getBuyByGoldNum()));
            this.curBuyID = args.id;
            console.log('刷新购买枪支--:', this.curBuyID, '\n当前枪支价格：', ARM.getDataByKey(args.id).price, '\n人物消耗倍数：', ConfigManager.costGold, '\n当前购买次数：', RoleManager.getInstance().getBuyByGoldNum(), '\n最终所需价格：', this.price, '\n文本显示：', this.txtPrice.text);
        }
        recovery() {
            if (!this.curImgData.curCell)
                return;
            console.log('当前移除枪支:', this.curImgData);
            let view = new ProduceGoldCtrl(this.price, true);
            this.addChild(view);
            view.setSpecial(this.price);
            let point = new Laya.Point(-this.btnRecovery.width, -this.btnRecovery.height);
            let newPoint = this.btnRecovery.localToGlobal(point);
            view.x = newPoint.x;
            view.y = newPoint.y;
            view.x -= 70;
            view.alpha = 1;
            SoundManager.playEffect(SOUND_PATH.COMPOND);
            Laya.Tween.to(view, {
                y: view.y - 7
            }, 500, null, Laya.Handler.create(this, () => {
                Laya.Tween.to(view, {
                    y: view.y - 5,
                    alpha: 0
                }, 800, null, Laya.Handler.create(this, () => {
                    Laya.Tween.clearAll(view);
                    view.updateGold();
                    view.destroy();
                }));
            }));
            PeopleFactory.getInstance().removeArm(this.curImgData.curCell, this.curImgData.curIndex, BOX_ID.EMPTY_BOX);
        }
        onBtnShop() {
            if (!CommonUtil.getTouch())
                return;
            this.normalCount = 5000;
            UIManager.openFunction(FUNCTION_TAG.SHOP, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.WINDOW, COMMON_MENU_STYLE.HIDE);
        }
        onBtnBuy() {
            console.log('金币价格' + this.price);
            let data = PeopleFactory.getInstance().getAirData();
            if (data && Math.random() > 0.7) {
                if (PeopleFactory.getInstance().getEmptyPosNum() == 1) {
                    data.type = AIRDROP_TYPE.SUPERREWARD_SINGLE;
                }
                let d = {
                    data: data,
                    commonCb: function() {}
                };
                UIManager.openFunction(FUNCTION_TAG.SUPER_REWARD, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE, d);
                return;
            }
            if (this.price > RoleManager.getInstance().getGold()) {
                UIManager.openFunction(FUNCTION_TAG.ADD_GOLD, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.WINDOW, COMMON_MENU_STYLE.GOLD, 1);
                return;
            }
            let targetCell = null;
            let index = 0;
            for (let i in PeopleFactory.getInstance().getArrCache()) {
                let item = PeopleFactory.getInstance().getArrCache()[i];
                if (item.curData == BOX_ID.EMPTY_BOX) {
                    targetCell = item;
                    index = parseInt(i);
                    break;
                }
            }
            if (targetCell) {
                RoleManager.getInstance().costGold(this.price);
                SoundManager.playEffect(SOUND_PATH.COMPOND);
                RoleManager.getInstance().updateBuyByGoldNum();
                this.txtPrice.text = StringUtil.parseGold(Math.floor(ARM.getDataByKey(this.curBuyID).price * Math.pow(ConfigManager.costGold, RoleManager.getInstance().getBuyByGoldNum()))).toString();
                this.price = Math.floor(ARM.getDataByKey(this.curBuyID).price * Math.pow(ConfigManager.costGold, RoleManager.getInstance().getBuyByGoldNum()));
                PeopleFactory.getInstance().addArm(targetCell, index, this.curBuyID, true);
                console.log('当前购买次数：', RoleManager.getInstance().getBuyByGoldNum());
                if (this.step < 5) {
                    this.updateGuide();
                }
            } else {
                LogManager.showNotificationClick('卡槽已满，请合成或回收枪械');
            }
        }
        touchBegin(e) {
            console.log('touchBegin');
            this.normalCount = 5000;
            let id = null;
            this.preTouchXY.x = e.stageX;
            this.preTouchXY.y = e.stageY;
            for (let i in PeopleFactory.getInstance().getArrCache()) {
                let item = PeopleFactory.getInstance().getArrCache()[i];
                if (item.hitTestPoint(e.stageX, e.stageY)) {
                    if (item.curData != BOX_ID.EMPTY_BOX && item.curData != BOX_ID.AIRDROP_BOX && item.curData != undefined) {
                        if (!this.curImgData.img) {
                            this.curImgData.img = new Laya.Image(item.imgTarget.skin);
                            this.curImgData.img.anchorX = 0.5;
                            this.curImgData.img.anchorY = 0.5;
                            this.boxContentRoot.addChild(this.curImgData.img);
                        } else {
                            this.curImgData.img.skin = item.imgTarget.skin;
                        }
                        this.curImgData.img.x = item.x + item.width / 2;
                        this.curImgData.img.y = item.y + item.height / 2;
                        this.curImgData.ID = item.curData;
                        id = item.curData;
                        this.curImgData.curIndex = parseInt(i);
                        this.curImgData.curCell = item;
                        item.select();
                        this.btnRecovery.getChildAt(0).alpha = 0.8;
                    }
                } else {}
            }
            if (id == null)
                return;
            for (let i in PeopleFactory.getInstance().getArrCache()) {
                let item = PeopleFactory.getInstance().getArrCache()[i];
                if (this.curImgData.curIndex != parseInt(i) && id == item.curData) {
                    item.sameSelect();
                } else if (this.curImgData.curIndex != parseInt(i) && id != item.curData && item.curData != BOX_ID.EMPTY_BOX) {
                    item.unSameAsh();
                }
            }
        }
        touchMove(e) {
            console.log('touchMove');
            this.normalCount = 5000;
            if (this.curImgData.img) {
                let point = new Laya.Point(e.stageX, e.stageY);
                let localPoint = this.boxContentRoot.globalToLocal(point);
                this.curImgData.img.x = localPoint.x;
                this.curImgData.img.y = localPoint.y;
            }
        }
        touchEnd(e) {
            this.normalCount = 5000;
            this.btnRecovery.getChildAt(0).alpha = 1;
            console.log('touchEnd');
            let isHitTestPoint = false;
            let targetData = null;
            let index = 0;
            for (let i in PeopleFactory.getInstance().getArrCache()) {
                let item = PeopleFactory.getInstance().getArrCache()[i];
                console.log('当前item.curData：', item.curData);
                if (item.curData == this.curImgData.ID) {
                    item.unSelect();
                } else if (item.curData != this.curImgData.ID && item.curData != undefined) {
                    item.exitAsh();
                }
            }
            for (let i in PeopleFactory.getInstance().getArrCache()) {
                let item = PeopleFactory.getInstance().getArrCache()[i];
                if (item.hitTestPoint(e.stageX, e.stageY)) {
                    index = parseInt(i);
                    targetData = item;
                    isHitTestPoint = true;
                } else {}
            }
            if (this.btnRecovery.hitTestPoint(e.stageX, e.stageY)) {
                this.recovery();
                this.curImgData.ID = BOX_ID.EMPTY_BOX;
                this.curImgData.curIndex = BOX_ID.EMPTY_BOX;
                if (this.curImgData.img)
                    this.curImgData.img.destroy();
                this.curImgData.img = null;
                this.curImgData.curCell = null;
                return;
            }
            if (isHitTestPoint) {
                if (this.curImgData.ID == targetData.curData && this.curImgData.ID != BOX_ID.EMPTY_BOX && this.curImgData.ID != BOX_ID.AIRDROP_BOX && this.curImgData.ID != undefined && index != this.curImgData.curIndex) {
                    if (this.step == 2) {
                        this.onceHC = true;
                    }
                    PeopleFactory.getInstance().synthesis(targetData, this.curImgData.curCell, index, this.curImgData.curIndex);
                    this.curImgData.ID = BOX_ID.EMPTY_BOX;
                    this.curImgData.curIndex = BOX_ID.EMPTY_BOX;
                    if (this.curImgData.img)
                        this.curImgData.img.destroy();
                    this.curImgData.img = null;
                    this.curImgData.curCell = null;
                } else {
                    if (this.curImgData.ID != targetData.curData && targetData.curData != BOX_ID.EMPTY_BOX && targetData.curData != BOX_ID.AIRDROP_BOX && targetData.curData != undefined) {
                        PeopleFactory.getInstance().exchange(targetData, this.curImgData.curCell, index, this.curImgData.curIndex);
                        this.moveButNoHC();
                        this.curImgData.ID = BOX_ID.EMPTY_BOX;
                        this.curImgData.curIndex = BOX_ID.EMPTY_BOX;
                        if (this.curImgData.img)
                            this.curImgData.img.destroy();
                        this.curImgData.img = null;
                        this.curImgData.curCell = null;
                    } else if (this.curImgData.ID != targetData.curData && targetData.curData == BOX_ID.EMPTY_BOX) {
                        PeopleFactory.getInstance().moveToEmptyEquip(targetData, this.curImgData.curCell, index, this.curImgData.curIndex);
                        this.moveButNoHC();
                        this.curImgData.ID = BOX_ID.EMPTY_BOX;
                        this.curImgData.curIndex = BOX_ID.EMPTY_BOX;
                        if (this.curImgData.img)
                            this.curImgData.img.destroy();
                        this.curImgData.img = null;
                        this.curImgData.curCell = null;
                    } else {
                        this.curImgData.ID = BOX_ID.EMPTY_BOX;
                        this.curImgData.curIndex = BOX_ID.EMPTY_BOX;
                        if (this.curImgData.img)
                            this.curImgData.img.destroy();
                        this.curImgData.img = null;
                        this.curImgData.curCell = null;
                    }
                }
            } else {
                this.curImgData.ID = BOX_ID.EMPTY_BOX;
                this.curImgData.curIndex = BOX_ID.EMPTY_BOX;
                if (this.curImgData.img)
                    this.curImgData.img.destroy();
                this.curImgData.img = null;
                this.curImgData.curCell = null;
            }
        }
        onBtnDropAir() {
            let targetCell = null;
            let index = 0;
            for (let i in PeopleFactory.getInstance().getArrCache()) {
                let item = PeopleFactory.getInstance().getArrCache()[i];
                if (item.curData == BOX_ID.EMPTY_BOX) {
                    targetCell = item;
                    index = parseInt(i);
                    break;
                }
            }
            if (targetCell) {
                PeopleFactory.getInstance().addArm(targetCell, index, RoleManager.getInstance().getMaxUnLockArm(), true);
            } else {
                RewardManager.setfreeRewardForGoldCoins();
                let gold = RewardManager.curFreeGoldRewards;
                UIManager.openFunction(FUNCTION_TAG.GET_GOLD_REWARD, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.GOLD, gold);
            }
        }
        onEnable() {
            this.isOpen = true;
            this.normalCount = 5000;
            if (GuideManager.curEquiplLibraryStep >= GuideStep.TOEQUIP || RoleManager.getInstance().getGuide() >= GuideStep.TOEQUIP) {
                PeopleFactory.getInstance().stopDailyGuideCompound();
            }
            let guide = RoleManager.getInstance().getGuide();
            if (GuideManager.curEquiplLibraryStep > guide) {
                guide = GuideManager.curEquiplLibraryStep;
                this.isCheckNoLocal = true;
            }
            if (guide > GuideStep.TOEQUIP) {
                if (this.warehouseAperture) {
                    this.warehouseAperture.stop();
                    this.warehouseAperture.visible = false;
                }
            }
            this.setPlatformStyle();
        }
        setPlatformStyle() {
            switch (ConfigManager.platform) {
                case PLATFORM_TYPE.WX:
                    {
                        this.setWXPlatform();
                        break;
                    }
                case PLATFORM_TYPE.QQ:
                    {
                        this.setQQPlatform();
                        break;
                    }
                case PLATFORM_TYPE.WEB:
                    {
                        this.setWXPlatform();
                        break;
                    }
                case PLATFORM_TYPE.VIVO:
                    {
                        this.setVIVOPlatform();
                        break;
                    }
                case PLATFORM_TYPE.WEB_4399:
                    {
                        this.setWeb4399Platform();
                        break;
                    }
                case PLATFORM_TYPE.OPPO:
                    {
                        this.setOPPOPlatform();
                        break;
                    }
                case PLATFORM_TYPE.NATIVE_IOS:
                    {
                        this.setNativeIOSPlatform();
                        break;
                    }
                case PLATFORM_TYPE.NATIVE_ANDRIOD:
                    {
                        this.setNativeAndroidPlatform();
                        break;
                    }
                case PLATFORM_TYPE.TT:
                    {
                        this.setTTPlatform();
                        break;
                    }
            }
        }
        setWXPlatform() {}
        setQQPlatform() {
            this.btnRecovery.x = 39;
            this.btnShop.x = 914;
            this.centerX = 21;
        }
        setWebPlatform() {
            this.nativeIcon1 && this.nativeIcon1.show();
            this.nativeIcon2 && this.nativeIcon2.show();
        }
        setVIVOPlatform() {
            this.btnRecovery.x = 39;
            this.btnShop.x = 914;
            this.nativeIcon1 && this.nativeIcon1.show();
            this.nativeIcon2 && this.nativeIcon2.show();
        }
        setWeb4399Platform() {
            this.centerX = 21;
            this.bottom = 0;
        }
        setOPPOPlatform() {
            this.btnRecovery.x = 39;
            this.nativeIcon1 && this.nativeIcon1.show();
            this.nativeIcon2 && this.nativeIcon2.show();
        }
        setNativeIOSPlatform() {}
        setNativeAndroidPlatform() {
            if (ConfigManager.appId == ANDROID_APP_ID.XM) {
                this.btnRecovery.x = 39;
                this.btnShop.x = 914;
                this.centerX = 21;
            }
        }
        setTTPlatform() {}
        onMyEnable() {
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || PLATFORM_TYPE.WX == ConfigManager.platform || ConfigManager.appId == ANDROID_APP_ID.XM) {
                let pos = new Laya.Point(0, 0);
                this.btnBuy.localToGlobal(pos);
                let x1 = pos.x - PlatformUtil.getCustomSize().w - 5;
                let x = pos.x + this.btnBuy.width + 5;
                let y = Laya.stage.height - PlatformUtil.getCustomSize().h;
                if (PLATFORM_TYPE.WX == ConfigManager.platform) {
                    AdUtil.showCustom(x1, y);
                    AdUtil.showCustom(x, y);
                }
                AdUtil.showCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
            }
        }
        onMyDisable() {
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || PLATFORM_TYPE.WX == ConfigManager.platform || ConfigManager.appId == ANDROID_APP_ID.XM) {
                let pos = new Laya.Point(0, 0);
                this.btnBuy.localToGlobal(pos);
                let x1 = pos.x - PlatformUtil.getCustomSize().w - 5;
                let x = pos.x + this.btnBuy.width + 5;
                let y = Laya.stage.height - PlatformUtil.getCustomSize().h;
                AdUtil.hideCustom(x1, y);
                AdUtil.hideCustom(x, y);
                AdUtil.hideCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
            }
        }
    }

    let AD_TYPE = {
        VIDEO: 0,
        NATIVE: 1
    };
    class OVAdManager {
        static init() {
            OVAdManager.count = ConfigManager.getOppo_end_count();
            OVAdManager.isDone = false;
        }
        static adDown() {
            if (ConfigManager.platform != PLATFORM_TYPE.OPPO && ConfigManager.platform != PLATFORM_TYPE.VIVO && ConfigManager.platform != PLATFORM_TYPE.WEB && ConfigManager.platform != PLATFORM_TYPE.WEB_4399)
                return;
            if (!this.isStartCountDown) {
                this.isStartCountDown = true;
                Laya.timer.frameLoop(1, this, this.update);
            }
        }
        static update() {
            this.count -= Laya.timer.delta;
            if (this.count < 0) {
                if (!this.isDone) {
                    this.isDone = true;
                }
            } else {
                if (this.isDone) {
                    this.isDone = false;
                }
            }
        }
        static register(cb) {
            if (ConfigManager.platform != PLATFORM_TYPE.OPPO && ConfigManager.platform != PLATFORM_TYPE.VIVO && ConfigManager.platform != PLATFORM_TYPE.WEB && ConfigManager.platform != PLATFORM_TYPE.WEB_4399)
                return;
            let funId = NotifyManager.register(NOTIFY_ID.REFRESH_OV_AD, cb, this);
            this.funId = funId;
        }
        static unregisterByFuncId() {
            if (ConfigManager.platform != PLATFORM_TYPE.OPPO && ConfigManager.platform != PLATFORM_TYPE.VIVO && ConfigManager.platform != PLATFORM_TYPE.WEB && ConfigManager.platform != PLATFORM_TYPE.WEB_4399)
                return;
            if (this.funId)
                NotifyManager.unregisterByFuncId(this.funId);
            this.funId = null;
        }
        static setAdType(isFinish) {
            if (this.isFirst) {
                this.isFirst = false;
                this.prior = ConfigManager.getOppo_prior_ad();
                if (this.prior == 0) {
                    console.log('当前广告类型优先为视频');
                } else {
                    console.log('当前广告类型优先为原生');
                }
            }
            if (this.prior == AD_TYPE.VIDEO) {
                if (this.forceToChange) {
                    console.log('1当前为强制转, 不可接受其他转化');
                    this.forceToChange = false;
                    return;
                }
                if (isFinish) {
                    this.curAdType = AD_TYPE.VIDEO;
                } else {
                    this.curAdType = AD_TYPE.NATIVE;
                }
            } else if (this.prior == AD_TYPE.NATIVE) {
                if (this.forceToChange) {
                    console.log('2当前为强制转, 不可接受其他转化');
                    this.forceToChange = false;
                    return;
                }
                console.log('当前选择的原生次数：', this.nativeNum);
                if (this.nativeNum > 2) {
                    this.nativeNum = 0;
                    this.curAdType = AD_TYPE.VIDEO;
                } else {
                    this.curAdType = AD_TYPE.NATIVE;
                }
                this.nativeNum++;
            }
        }
        static setAdTypeInNext() {
            if (this.isFirst) {
                this.isFirst = false;
                this.prior = ConfigManager.getOppo_prior_ad();
                if (this.prior == 0) {
                    console.log('当前广告类型优先为视频');
                } else {
                    console.log('当前广告类型优先为原生');
                }
                this.curAdType = this.prior;
                if (this.prior == AD_TYPE.NATIVE) {
                    this.nativeNum++;
                }
            }
        }
        static forceToSetAdType() {
            this.curAdType = AD_TYPE.NATIVE;
            this.forceToChange = true;
            console.log('强制转为原生');
        }
        static execute(cb, once = false, isExecuteCbAfterVideo = false) {
            cb();
            return;
            if (!ConfigManager.getoOppo_end_adTotal() && !RoleManager.getInstance().isBannerTouch()) {
                console.log('处于屏蔽状态, 不可执行误触事件');
                cb();
                return;
            }
            if (once) {
                this.adDown();
                this.reset();
                AdUtil.setEvent(function() {
                    OVAdManager.reset();
                    NotifyManager.notify(NOTIFY_ID.REFRESH_OV_AD);
                    OVAdManager.setAdType(true);
                }, function() {
                    OVAdManager.reset();
                    OVAdManager.setAdType(true);
                    if (isExecuteCbAfterVideo) {
                        cb();
                    }
                }, REWARD_CTRL_TYPE.MTOUCH);
            } else {
                if (!this.isDone) {
                    console.log('倒计时未结束');
                    cb();
                    return;
                }
                if (this.curAdType == AD_TYPE.VIDEO) {
                    console.log('当前为视频误触');
                    OVAdManager.reset();
                    AdUtil.setEvent(function() {
                        OVAdManager.setAdType(true);
                        OVAdManager.reset();
                        NotifyManager.notify(NOTIFY_ID.REFRESH_OV_AD);
                    }, function() {
                        OVAdManager.reset();
                        OVAdManager.setAdType(false);
                        OVAdManager.forceToSetAdType();
                        if (isExecuteCbAfterVideo) {
                            cb();
                        }
                    }, REWARD_CTRL_TYPE.MTOUCH);
                } else {
                    console.log('当前为原生误触');
                    OVAdManager.setAdType(true);
                    OVAdManager.reset();
                    if (ConfigManager.platform != PLATFORM_TYPE.WEB && ConfigManager.platform != PLATFORM_TYPE.WEB_4399) {
                        AdUtil.nativeExtendList.ad && AdUtil.nativeExtendList.ad.reportAdClick({
                            adId: AdUtil.nativeExtendList.data.adId.toString()
                        });
                    }
                    Laya.timer.once(200, this, () => {
                        OVAdManager.reset();
                        NotifyManager.notify(NOTIFY_ID.REFRESH_OV_AD);
                    });
                }
            }
        }
        static reset() {
            OVAdManager.count = ConfigManager.getOppo_end_count();
            OVAdManager.isDone = false;
        }
    }
    OVAdManager.isStartCountDown = false;
    OVAdManager.isDone = false;
    OVAdManager.count = 2000;
    OVAdManager.curAdType = AD_TYPE.VIDEO;
    OVAdManager.isFirst = true;
    OVAdManager.funId = null;
    OVAdManager.prior = 0;
    OVAdManager.nativeNum = 0;
    OVAdManager.forceToChange = false;

    class PrivateDetailViewCtrl extends ui.view.common.PrivateDetailViewUI {
        constructor(isFunction) {
            super();
            this.isFunction = isFunction;
        }
        onAwake() {
            this.width = this.stage.width;
            this.height = this.stage.height;
            this.txtClose1.on(Laya.Event.CLICK, this, this.onBtnCloseDetail);
            this.txtClose2.on(Laya.Event.CLICK, this, this.onBtnCloseDetail);
            this.panel.vScrollBarSkin = '';
            this.panel.width = 1334;
            this.txtContent.width = this.panel.width;
        }
        onBtnCloseDetail() {
            if (!CommonUtil.getTouch())
                return;
            if (this.isFunction) {
                UIManager.closeFunction();
            } else {
                this.destroy();
            }
        }
    }

    class PrivateDialogViewCtrl extends ui.view.common.PrivateDialogViewUI {
        constructor(cb) {
            super();
            this.cb = cb;
        }
        static create(cb) {
            if ((ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.QQ || ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD || ConfigManager.platform == PLATFORM_TYPE.VIVO || ConfigManager.platform == PLATFORM_TYPE.OPPO)) {
                Laya.LocalStorage.setItem(STORAGE_ID.PRIVATE_STATE, '1');
                let state = Laya.LocalStorage.getItem(STORAGE_ID.PRIVATE_STATE);
                console.log('shishtis-------', state);
                if (ConfigManager.appId == ANDROID_APP_ID.C233_ME) {
                    state = '1';
                }
                if (state == '1') {
                    let PlatformClass = window['PlatformClass'];
                    if (PlatformClass)
                        PlatformClass.createClass('demo.JSBridge').call('onBtnPrivateOK');
                    cb && cb();
                } else {
                    Laya.timer.once(100, this, function() {
                        let layer = new PrivateDialogViewCtrl(cb);
                        layer.zOrder = ORDER_LAYER_Z.MAX;
                        Laya.stage.addChild(layer);
                    });
                }
            } else {
                cb && cb();
            }
        }
        onAwake() {
            this.width = this.stage.width;
            this.height = this.stage.height;
            this.btnCancel.on(Laya.Event.CLICK, this, this.onBtnRefuse);
            this.btnOK.on(Laya.Event.CLICK, this, this.onBtnOK);
            this.txtDetail.on(Laya.Event.CLICK, this, this.onBtnDetail);
            AdUtil.hideBannerAd();
        }
        onDestroy() {
            this.cb = null;
        }
        onBtnRefuse() {
            if (!CommonUtil.getTouch())
                return;
            if (ConfigManager.platform == PLATFORM_TYPE.QQ) {
                let platform = qq;
                platform.exitMiniProgram({});
            } else if (ConfigManager.platform == PLATFORM_TYPE.VIVO || ConfigManager.platform == PLATFORM_TYPE.OPPO) {
                let platform = qg;
                platform.exitApplication({});
            } else {
                let PlatformClass = window['PlatformClass'];
                if (PlatformClass)
                    PlatformClass.createClass('demo.JSBridge').call('onBtnPrivateRefuse');
            }
            this.destroy();
        }
        onBtnOK() {
            if (!CommonUtil.getTouch())
                return;
            Laya.LocalStorage.setItem(STORAGE_ID.PRIVATE_STATE, '1');
            let PlatformClass = window['PlatformClass'];
            if (PlatformClass)
                PlatformClass.createClass('demo.JSBridge').call('onBtnPrivateOK');
            this.cb && this.cb();
            this.aniOpen.wrapMode = Laya.AnimationBase.WRAP_REVERSE;
            this.aniOpen.play(0, false);
            this.aniOpen.on(Laya.Event.COMPLETE, this, function() {
                this.destroy();
            });
        }
        onBtnDetail() {
            if (!CommonUtil.getTouch())
                return;
            if (ConfigManager.platform == PLATFORM_TYPE.QQ) {}
            if (window["conch"]) {
                var l = 0;
                var t = 0;
                var w = window.innerWidth - l * 2;
                var h = window.innerHeight - t * 2;
                if (ConfigManager.appId == ANDROID_APP_ID.C_233) {
                    window["conch"].setExternalLinkEx('  webgame-1255397116.cos.ap-guangzhou.myqcloud.com/AppPrivateWeb/233.html', l, t, w, h, true);
                } else if (ConfigManager.appId == ANDROID_APP_ID.XM) {
                    window["conch"].setExternalLinkEx('  webgame-1255397116.cos.ap-guangzhou.myqcloud.com/AppPrivateWeb/xm.html', l, t, w, h, true);
                } else {
                    window["conch"].setExternalLinkEx('  webgame-1255397116.cos.ap-guangzhou.myqcloud.com/AppPrivateWeb/privacy.html', l, t, w, h, true);
                }
            } else {
                let view = new PrivateDetailViewCtrl(false);
                view.x = 0;
                view.y = 0;
                this.addChild(view);
            }
        }
    }

    class LoseFocusViewCtrl extends ui.view.common.LoseFocusViewUI {
        constructor() {
            super();
            this.width = Laya.stage.width;
            this.height = Laya.stage.height;
        }
        onAwake() {
            var that = this;
            this.btnEnter.on(Laya.Event.CLICK, this, function() {
                window.focus();
                Laya.timer.scale = 1;
                that.destroy();
                if (GameScene.loseFocusViewCtrl) {
                    GameScene.loseFocusViewCtrl = null;
                }
            });
        }
        onDestroy() {
            this.btnEnter = null;
            this.txtGold = null;
        }
    }

    class Item {
        static getDataByKey(key) {
            if (Item.cache[key])
                return Item.cache[key];
            if (key == '1001') {
                let template = new Item();
                template.id = '1001';
                template.name = '金币';
                template.type = 1;
                template.quality = 0;
                template.icon = '1001.png';
                template.extra = function() {
                    return null;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '2001') {
                let template = new Item();
                template.id = '2001';
                template.name = '钻石';
                template.type = 2;
                template.quality = 0;
                template.icon = '2001.png';
                template.extra = function() {
                    return null;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '3001') {
                let template = new Item();
                template.id = '3001';
                template.name = '经验';
                template.type = 3;
                template.quality = 0;
                template.icon = '3001.png';
                template.extra = function() {
                    return null;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '5001') {
                let template = new Item();
                template.id = '5001';
                template.name = '艾莎';
                template.type = 5;
                template.quality = 4;
                template.icon = '001.png';
                template.extra = function() {
                    return 1;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '5002') {
                let template = new Item();
                template.id = '5002';
                template.name = '夏露';
                template.type = 5;
                template.quality = 3;
                template.icon = '002.png';
                template.extra = function() {
                    return 2;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '5003') {
                let template = new Item();
                template.id = '5003';
                template.name = '小樱';
                template.type = 5;
                template.quality = 4;
                template.icon = '003.png';
                template.extra = function() {
                    return 3;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '5004') {
                let template = new Item();
                template.id = '5004';
                template.name = '艾莉';
                template.type = 5;
                template.quality = 3;
                template.icon = '004.png';
                template.extra = function() {
                    return 4;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '5005') {
                let template = new Item();
                template.id = '5005';
                template.name = '米拉';
                template.type = 5;
                template.quality = 4;
                template.icon = '005.png';
                template.extra = function() {
                    return 5;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '5006') {
                let template = new Item();
                template.id = '5006';
                template.name = '露西';
                template.type = 5;
                template.quality = 2;
                template.icon = '006.png';
                template.extra = function() {
                    return 6;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '5007') {
                let template = new Item();
                template.id = '5007';
                template.name = '神乐';
                template.type = 5;
                template.quality = 2;
                template.icon = '007.png';
                template.extra = function() {
                    return 7;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '5008') {
                let template = new Item();
                template.id = '5008';
                template.name = '小舞';
                template.type = 5;
                template.quality = 1;
                template.icon = '008.png';
                template.extra = function() {
                    return 8;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '6001') {
                let template = new Item();
                template.id = '6001';
                template.name = '艾莎碎片';
                template.type = 6;
                template.quality = 4;
                template.icon = '001.png';
                template.extra = function() {
                    return 1;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '6002') {
                let template = new Item();
                template.id = '6002';
                template.name = '夏露碎片';
                template.type = 6;
                template.quality = 3;
                template.icon = '002.png';
                template.extra = function() {
                    return 2;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '6003') {
                let template = new Item();
                template.id = '6003';
                template.name = '小樱碎片';
                template.type = 6;
                template.quality = 4;
                template.icon = '003.png';
                template.extra = function() {
                    return 3;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '6004') {
                let template = new Item();
                template.id = '6004';
                template.name = '艾莉碎片';
                template.type = 6;
                template.quality = 3;
                template.icon = '004.png';
                template.extra = function() {
                    return 4;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '6005') {
                let template = new Item();
                template.id = '6005';
                template.name = '米拉碎片';
                template.type = 6;
                template.quality = 4;
                template.icon = '005.png';
                template.extra = function() {
                    return 5;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '6006') {
                let template = new Item();
                template.id = '6006';
                template.name = '露西碎片';
                template.type = 6;
                template.quality = 2;
                template.icon = '006.png';
                template.extra = function() {
                    return 6;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '6007') {
                let template = new Item();
                template.id = '6007';
                template.name = '神乐碎片';
                template.type = 6;
                template.quality = 2;
                template.icon = '007.png';
                template.extra = function() {
                    return 7;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '6008') {
                let template = new Item();
                template.id = '6008';
                template.name = '小舞碎片';
                template.type = 6;
                template.quality = 1;
                template.icon = '008.png';
                template.extra = function() {
                    return 8;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '4001') {
                let template = new Item();
                template.id = '4001';
                template.name = '猎人手枪';
                template.type = 4;
                template.quality = 1;
                template.icon = '1.png';
                template.extra = function() {
                    return 1;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '4002') {
                let template = new Item();
                template.id = '4002';
                template.name = '代号-37';
                template.type = 4;
                template.quality = 1;
                template.icon = '2.png';
                template.extra = function() {
                    return 2;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '4003') {
                let template = new Item();
                template.id = '4003';
                template.name = '星环';
                template.type = 4;
                template.quality = 1;
                template.icon = '3.png';
                template.extra = function() {
                    return 3;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '4004') {
                let template = new Item();
                template.id = '4004';
                template.name = 'Q97-红龙';
                template.type = 4;
                template.quality = 1;
                template.icon = '4.png';
                template.extra = function() {
                    return 4;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '4005') {
                let template = new Item();
                template.id = '4005';
                template.name = 'M50-挑战者';
                template.type = 4;
                template.quality = 1;
                template.icon = '5.png';
                template.extra = function() {
                    return 5;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '4006') {
                let template = new Item();
                template.id = '4006';
                template.name = '星耀';
                template.type = 4;
                template.quality = 1;
                template.icon = '6.png';
                template.extra = function() {
                    return 6;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '4007') {
                let template = new Item();
                template.id = '4007';
                template.name = '星爵';
                template.type = 4;
                template.quality = 1;
                template.icon = '7.png';
                template.extra = function() {
                    return 7;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '4008') {
                let template = new Item();
                template.id = '4008';
                template.name = 'M7-开拓者';
                template.type = 4;
                template.quality = 1;
                template.icon = '8.png';
                template.extra = function() {
                    return 8;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '4009') {
                let template = new Item();
                template.id = '4009';
                template.name = '打击者';
                template.type = 4;
                template.quality = 1;
                template.icon = '9.png';
                template.extra = function() {
                    return 9;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '4010') {
                let template = new Item();
                template.id = '4010';
                template.name = '幻影';
                template.type = 4;
                template.quality = 1;
                template.icon = '10.png';
                template.extra = function() {
                    return 10;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '4011') {
                let template = new Item();
                template.id = '4011';
                template.name = 'Q97-猩红猎手';
                template.type = 4;
                template.quality = 1;
                template.icon = '11.png';
                template.extra = function() {
                    return 11;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '4012') {
                let template = new Item();
                template.id = '4012';
                template.name = 'M8-金色幻想';
                template.type = 4;
                template.quality = 1;
                template.icon = '12.png';
                template.extra = function() {
                    return 12;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '4013') {
                let template = new Item();
                template.id = '4013';
                template.name = 'SKG-突击者';
                template.type = 4;
                template.quality = 1;
                template.icon = '13.png';
                template.extra = function() {
                    return 13;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '4014') {
                let template = new Item();
                template.id = '4014';
                template.name = '粒子风暴';
                template.type = 4;
                template.quality = 1;
                template.icon = '14.png';
                template.extra = function() {
                    return 14;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '4015') {
                let template = new Item();
                template.id = '4015';
                template.name = 'AWM-闪击者';
                template.type = 4;
                template.quality = 1;
                template.icon = '15.png';
                template.extra = function() {
                    return 15;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '4016') {
                let template = new Item();
                template.id = '4016';
                template.name = 'M700';
                template.type = 4;
                template.quality = 1;
                template.icon = '16.png';
                template.extra = function() {
                    return 16;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '4017') {
                let template = new Item();
                template.id = '4017';
                template.name = '星际霸者';
                template.type = 4;
                template.quality = 1;
                template.icon = '17.png';
                template.extra = function() {
                    return 17;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '4018') {
                let template = new Item();
                template.id = '4018';
                template.name = '伪装者';
                template.type = 4;
                template.quality = 1;
                template.icon = '18.png';
                template.extra = function() {
                    return 18;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '4019') {
                let template = new Item();
                template.id = '4019';
                template.name = '正义仲裁者';
                template.type = 4;
                template.quality = 1;
                template.icon = '19.png';
                template.extra = function() {
                    return 19;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '4020') {
                let template = new Item();
                template.id = '4020';
                template.name = '绿魔';
                template.type = 4;
                template.quality = 1;
                template.icon = '20.png';
                template.extra = function() {
                    return 20;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '4021') {
                let template = new Item();
                template.id = '4021';
                template.name = '空之律者';
                template.type = 4;
                template.quality = 1;
                template.icon = '21.png';
                template.extra = function() {
                    return 21;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '4022') {
                let template = new Item();
                template.id = '4022';
                template.name = '神圣骑士';
                template.type = 4;
                template.quality = 1;
                template.icon = '22.png';
                template.extra = function() {
                    return 22;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '4023') {
                let template = new Item();
                template.id = '4023';
                template.name = '咆哮';
                template.type = 4;
                template.quality = 2;
                template.icon = '23.png';
                template.extra = function() {
                    return 23;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '4024') {
                let template = new Item();
                template.id = '4024';
                template.name = '恶灵骑士';
                template.type = 4;
                template.quality = 2;
                template.icon = '24.png';
                template.extra = function() {
                    return 24;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '4025') {
                let template = new Item();
                template.id = '4025';
                template.name = '幽冥双子星';
                template.type = 4;
                template.quality = 2;
                template.icon = '25.png';
                template.extra = function() {
                    return 25;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '4026') {
                let template = new Item();
                template.id = '4026';
                template.name = '玫瑰精灵';
                template.type = 4;
                template.quality = 2;
                template.icon = '26.png';
                template.extra = function() {
                    return 26;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '4027') {
                let template = new Item();
                template.id = '4027';
                template.name = '黄金M4A1';
                template.type = 4;
                template.quality = 2;
                template.icon = '27.png';
                template.extra = function() {
                    return 27;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '4028') {
                let template = new Item();
                template.id = '4028';
                template.name = '天启者';
                template.type = 4;
                template.quality = 2;
                template.icon = '28.png';
                template.extra = function() {
                    return 28;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '4029') {
                let template = new Item();
                template.id = '4029';
                template.name = '聚灵';
                template.type = 4;
                template.quality = 2;
                template.icon = '29.png';
                template.extra = function() {
                    return 29;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '4030') {
                let template = new Item();
                template.id = '4030';
                template.name = '逆转次元';
                template.type = 4;
                template.quality = 2;
                template.icon = '30.png';
                template.extra = function() {
                    return 30;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '4031') {
                let template = new Item();
                template.id = '4031';
                template.name = '超级照明灯';
                template.type = 4;
                template.quality = 2;
                template.icon = '31.png';
                template.extra = function() {
                    return 31;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '4032') {
                let template = new Item();
                template.id = '4032';
                template.name = 'MK50-魅影';
                template.type = 4;
                template.quality = 2;
                template.icon = '32.png';
                template.extra = function() {
                    return 32;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '4033') {
                let template = new Item();
                template.id = '4033';
                template.name = '等离子电磁炮';
                template.type = 4;
                template.quality = 2;
                template.icon = '33.png';
                template.extra = function() {
                    return 33;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '4034') {
                let template = new Item();
                template.id = '4034';
                template.name = '红莲审判';
                template.type = 4;
                template.quality = 2;
                template.icon = '34.png';
                template.extra = function() {
                    return 34;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '4035') {
                let template = new Item();
                template.id = '4035';
                template.name = '圣诞大喇叭';
                template.type = 4;
                template.quality = 2;
                template.icon = '35.png';
                template.extra = function() {
                    return 35;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '4036') {
                let template = new Item();
                template.id = '4036';
                template.name = '病毒T-800';
                template.type = 4;
                template.quality = 3;
                template.icon = '36.png';
                template.extra = function() {
                    return 36;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '4037') {
                let template = new Item();
                template.id = '4037';
                template.name = '圣枪-翎羽';
                template.type = 4;
                template.quality = 3;
                template.icon = '37.png';
                template.extra = function() {
                    return 37;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '4038') {
                let template = new Item();
                template.id = '4038';
                template.name = '阿波菲斯之怒';
                template.type = 4;
                template.quality = 3;
                template.icon = '38.png';
                template.extra = function() {
                    return 38;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '4039') {
                let template = new Item();
                template.id = '4039';
                template.name = '明月之祝福';
                template.type = 4;
                template.quality = 3;
                template.icon = '39.png';
                template.extra = function() {
                    return 39;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '4040') {
                let template = new Item();
                template.id = '4040';
                template.name = '时空电流';
                template.type = 4;
                template.quality = 3;
                template.icon = '40.png';
                template.extra = function() {
                    return 40;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '4041') {
                let template = new Item();
                template.id = '4041';
                template.name = '钻石星尘';
                template.type = 4;
                template.quality = 3;
                template.icon = '41.png';
                template.extra = function() {
                    return 41;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '4042') {
                let template = new Item();
                template.id = '4042';
                template.name = '毁灭风暴';
                template.type = 4;
                template.quality = 3;
                template.icon = '42.png';
                template.extra = function() {
                    return 42;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '4043') {
                let template = new Item();
                template.id = '4043';
                template.name = '黎明之眼';
                template.type = 4;
                template.quality = 3;
                template.icon = '43.png';
                template.extra = function() {
                    return 43;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '4044') {
                let template = new Item();
                template.id = '4044';
                template.name = '魔影之龙';
                template.type = 4;
                template.quality = 3;
                template.icon = '44.png';
                template.extra = function() {
                    return 44;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '4045') {
                let template = new Item();
                template.id = '4045';
                template.name = '魔女的暗水枪';
                template.type = 4;
                template.quality = 4;
                template.icon = '45.png';
                template.extra = function() {
                    return 45;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '4046') {
                let template = new Item();
                template.id = '4046';
                template.name = '裂空之啸';
                template.type = 4;
                template.quality = 4;
                template.icon = '46.png';
                template.extra = function() {
                    return 46;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '4047') {
                let template = new Item();
                template.id = '4047';
                template.name = '王者之怒';
                template.type = 4;
                template.quality = 4;
                template.icon = '47.png';
                template.extra = function() {
                    return 47;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '4048') {
                let template = new Item();
                template.id = '4048';
                template.name = '时空主宰者';
                template.type = 4;
                template.quality = 4;
                template.icon = '48.png';
                template.extra = function() {
                    return 48;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '4049') {
                let template = new Item();
                template.id = '4049';
                template.name = '星际绝影';
                template.type = 4;
                template.quality = 4;
                template.icon = '49.png';
                template.extra = function() {
                    return 49;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '4050') {
                let template = new Item();
                template.id = '4050';
                template.name = '纳罗时空';
                template.type = 4;
                template.quality = 4;
                template.icon = '50.png';
                template.extra = function() {
                    return 50;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '10001') {
                let template = new Item();
                template.id = '10001';
                template.name = '爆竹';
                template.type = 10;
                template.quality = 0;
                template.icon = '10001.png';
                template.extra = function() {
                    return null;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '8001') {
                let template = new Item();
                template.id = '8001';
                template.name = '先锋之翼';
                template.type = 8;
                template.quality = 4;
                template.icon = '01.png';
                template.extra = function() {
                    return 1;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '8002') {
                let template = new Item();
                template.id = '8002';
                template.name = '无畏之翼';
                template.type = 8;
                template.quality = 4;
                template.icon = '02.png';
                template.extra = function() {
                    return 2;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '8003') {
                let template = new Item();
                template.id = '8003';
                template.name = '守护者飞行器';
                template.type = 8;
                template.quality = 4;
                template.icon = '03.png';
                template.extra = function() {
                    return 3;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '8004') {
                let template = new Item();
                template.id = '8004';
                template.name = '强袭之翼';
                template.type = 8;
                template.quality = 3;
                template.icon = '04.png';
                template.extra = function() {
                    return 4;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '8005') {
                let template = new Item();
                template.id = '8005';
                template.name = '阿尔法之翼';
                template.type = 8;
                template.quality = 2;
                template.icon = '05.png';
                template.extra = function() {
                    return 5;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '8006') {
                let template = new Item();
                template.id = '8006';
                template.name = '审判者之翼';
                template.type = 8;
                template.quality = 2;
                template.icon = '06.png';
                template.extra = function() {
                    return 6;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '8007') {
                let template = new Item();
                template.id = '8007';
                template.name = '光辉之翼';
                template.type = 8;
                template.quality = 1;
                template.icon = '07.png';
                template.extra = function() {
                    return 7;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '8008') {
                let template = new Item();
                template.id = '8008';
                template.name = '传说之翼';
                template.type = 8;
                template.quality = 1;
                template.icon = '08.png';
                template.extra = function() {
                    return 8;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '8009') {
                let template = new Item();
                template.id = '8009';
                template.name = '堕天使之翼';
                template.type = 8;
                template.quality = 1;
                template.icon = '09.png';
                template.extra = function() {
                    return 9;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '8010') {
                let template = new Item();
                template.id = '8010';
                template.name = '神盾之翼';
                template.type = 8;
                template.quality = 1;
                template.icon = '10.png';
                template.extra = function() {
                    return 10;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '8011') {
                let template = new Item();
                template.id = '8011';
                template.name = '守护者之刃';
                template.type = 8;
                template.quality = 4;
                template.icon = '11.png';
                template.extra = function() {
                    return 11;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '8012') {
                let template = new Item();
                template.id = '8012';
                template.name = '离子斩魄刀';
                template.type = 8;
                template.quality = 3;
                template.icon = '12.png';
                template.extra = function() {
                    return 12;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '8013') {
                let template = new Item();
                template.id = '8013';
                template.name = '冰息之刃';
                template.type = 8;
                template.quality = 3;
                template.icon = '13.png';
                template.extra = function() {
                    return 13;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '8014') {
                let template = new Item();
                template.id = '8014';
                template.name = '金龙';
                template.type = 8;
                template.quality = 3;
                template.icon = '14.png';
                template.extra = function() {
                    return 14;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '8015') {
                let template = new Item();
                template.id = '8015';
                template.name = '炽天使之翼';
                template.type = 8;
                template.quality = 2;
                template.icon = '15.png';
                template.extra = function() {
                    return 15;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '8016') {
                let template = new Item();
                template.id = '8016';
                template.name = '狱天使之翼';
                template.type = 8;
                template.quality = 2;
                template.icon = '16.png';
                template.extra = function() {
                    return 16;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '8017') {
                let template = new Item();
                template.id = '8017';
                template.name = '零式之翼';
                template.type = 8;
                template.quality = 4;
                template.icon = '17.png';
                template.extra = function() {
                    return 17;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '8018') {
                let template = new Item();
                template.id = '8018';
                template.name = '火流星之翼';
                template.type = 8;
                template.quality = 4;
                template.icon = '18.png';
                template.extra = function() {
                    return 18;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '7001') {
                let template = new Item();
                template.id = '7001';
                template.name = '先锋之翼碎片';
                template.type = 7;
                template.quality = 4;
                template.icon = '01.png';
                template.extra = function() {
                    return 1;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '7002') {
                let template = new Item();
                template.id = '7002';
                template.name = '无畏之翼碎片';
                template.type = 7;
                template.quality = 4;
                template.icon = '02.png';
                template.extra = function() {
                    return 2;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '7003') {
                let template = new Item();
                template.id = '7003';
                template.name = '守护者飞行器碎片';
                template.type = 7;
                template.quality = 4;
                template.icon = '03.png';
                template.extra = function() {
                    return 3;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '7004') {
                let template = new Item();
                template.id = '7004';
                template.name = '强袭之翼碎片';
                template.type = 7;
                template.quality = 3;
                template.icon = '04.png';
                template.extra = function() {
                    return 4;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '7005') {
                let template = new Item();
                template.id = '7005';
                template.name = '阿尔法之翼碎片';
                template.type = 7;
                template.quality = 2;
                template.icon = '05.png';
                template.extra = function() {
                    return 5;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '7006') {
                let template = new Item();
                template.id = '7006';
                template.name = '审判者之翼碎片';
                template.type = 7;
                template.quality = 2;
                template.icon = '06.png';
                template.extra = function() {
                    return 6;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '7007') {
                let template = new Item();
                template.id = '7007';
                template.name = '光辉之翼碎片';
                template.type = 7;
                template.quality = 1;
                template.icon = '07.png';
                template.extra = function() {
                    return 7;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '7008') {
                let template = new Item();
                template.id = '7008';
                template.name = '传说之翼碎片';
                template.type = 7;
                template.quality = 1;
                template.icon = '08.png';
                template.extra = function() {
                    return 8;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '7009') {
                let template = new Item();
                template.id = '7009';
                template.name = '堕天使之翼碎片';
                template.type = 7;
                template.quality = 1;
                template.icon = '09.png';
                template.extra = function() {
                    return 9;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '7010') {
                let template = new Item();
                template.id = '7010';
                template.name = '神盾之翼碎片';
                template.type = 7;
                template.quality = 1;
                template.icon = '10.png';
                template.extra = function() {
                    return 10;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '7011') {
                let template = new Item();
                template.id = '7011';
                template.name = '守护者之刃碎片';
                template.type = 7;
                template.quality = 4;
                template.icon = '11.png';
                template.extra = function() {
                    return 11;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '7012') {
                let template = new Item();
                template.id = '7012';
                template.name = '离子斩魄刀碎片';
                template.type = 7;
                template.quality = 3;
                template.icon = '12.png';
                template.extra = function() {
                    return 12;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '7013') {
                let template = new Item();
                template.id = '7013';
                template.name = '冰息之刃碎片';
                template.type = 7;
                template.quality = 3;
                template.icon = '13.png';
                template.extra = function() {
                    return 13;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '7014') {
                let template = new Item();
                template.id = '7014';
                template.name = '金龙碎片';
                template.type = 7;
                template.quality = 3;
                template.icon = '14.png';
                template.extra = function() {
                    return 14;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '7015') {
                let template = new Item();
                template.id = '7015';
                template.name = '炽天使之翼碎片';
                template.type = 7;
                template.quality = 2;
                template.icon = '15.png';
                template.extra = function() {
                    return 15;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '7016') {
                let template = new Item();
                template.id = '7016';
                template.name = '狱天使之翼碎片';
                template.type = 7;
                template.quality = 2;
                template.icon = '16.png';
                template.extra = function() {
                    return 16;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '7017') {
                let template = new Item();
                template.id = '7017';
                template.name = '零式之翼碎片';
                template.type = 7;
                template.quality = 4;
                template.icon = '17.png';
                template.extra = function() {
                    return 17;
                };
                Item.cache[key] = template;
                return template;
            } else if (key == '7018') {
                let template = new Item();
                template.id = '7018';
                template.name = '火流星之翼碎片';
                template.type = 7;
                template.quality = 4;
                template.icon = '18.png';
                template.extra = function() {
                    return 18;
                };
                Item.cache[key] = template;
                return template;
            }
        }
        static getDataByIndex(index) {
            if (Item.cache[this.keys[index]])
                return Item.cache[this.keys[index]];
            return this.getDataByKey(this.keys[index]);
        }
        static getAllData() {
            for (let index = 0; index < this.keys.length; index++) {
                this.getDataByKey(this.keys[index]);
            }
            return Item.cache;
        }
        clear() {
            Item.cache = {};
        }
    }
    Item.cache = {};
    Item.keys = ['1001', '2001', '3001', '5001', '5002', '5003', '5004', '5005', '5006', '5007', '5008', '6001', '6002', '6003', '6004', '6005', '6006', '6007', '6008', '4001', '4002', '4003', '4004', '4005', '4006', '4007', '4008', '4009', '4010', '4011', '4012', '4013', '4014', '4015', '4016', '4017', '4018', '4019', '4020', '4021', '4022', '4023', '4024', '4025', '4026', '4027', '4028', '4029', '4030', '4031', '4032', '4033', '4034', '4035', '4036', '4037', '4038', '4039', '4040', '4041', '4042', '4043', '4044', '4045', '4046', '4047', '4048', '4049', '4050', '10001', '8001', '8002', '8003', '8004', '8005', '8006', '8007', '8008', '8009', '8010', '8011', '8012', '8013', '8014', '8015', '8016', '8017', '8018', '7001', '7002', '7003', '7004', '7005', '7006', '7007', '7008', '7009', '7010', '7011', '7012', '7013', '7014', '7015', '7016', '7017', '7018'];

    class ReviewLoadingViewCtrl extends ui.view.review.ReviewLoadingViewUI {
        constructor(maxPart = 1) {
            super();
            this.startSec = 0;
            this.maxLen = 0;
            this.startSec = Laya.timer.currTimer;
            this.height = Laya.stage.height;
            this.width = this.stage.width;
            this.maxLen = this.imgPro.width;
            this.imgPro.width = 0;
            this.txtPercent.text = '玩命加载中，请耐心等待...(0%)';
            this.maxPart = maxPart;
        }
        onAwake() {
            if (ConfigManager.appId == ANDROID_APP_ID.C233_ME || ConfigManager.appId == ANDROID_APP_ID.MMY || ConfigManager.appId == ANDROID_APP_ID.HYKB || ConfigManager.platform == PLATFORM_TYPE.VIVO) {
                AdUtil.hideBannerAd();
            } else
                AdUtil.showBannerAd();
            this.setPlatformStyle();
        }
        close() {
            let delta = Laya.timer.currTimer - this.startSec;
            if (delta < 1500) {
                this.timer.once(1500 - delta, this, function() {
                    this.destroy();
                });
            } else {
                this.destroy();
            }
        }
        setProgress(percent, curPart = 1) {
            if (isNaN(percent))
                return;
            let allPercent = ((curPart - 1) / this.maxPart) + percent * (1 / this.maxPart);
            this.txtPercent.text = Math.floor(allPercent * 100) + '%';
            let width = this.maxLen * allPercent;
            Laya.Tween.clearAll(this.imgPro);
            Laya.Tween.to(this.imgPro, {
                width: width
            }, 200);
        }
        onDestroy() {
            Laya.timer.clearAll(this);
            this.txtPercent = null;
            if (UIManager.newFunc.tag != FUNCTION_TAG.FIRST) {
                AdUtil.hideBannerAd();
            } else {
                if (ConfigManager.appId == PLATFORM_TYPE.WX || ConfigManager.platform == PLATFORM_TYPE.QQ || ConfigManager.appId == ANDROID_APP_ID.XM)
                    AdUtil.showBannerAd(14, PlatformUtil.getBannerCenterPos().y + (PlatformUtil.isIOS() ? 30 : 0));
            }
        }
        setPlatformStyle() {
            switch (ConfigManager.platform) {
                case PLATFORM_TYPE.WX:
                    {
                        this.setWXPlatform();
                        break;
                    }
                case PLATFORM_TYPE.QQ:
                    {
                        this.setQQPlatform();
                        break;
                    }
                case PLATFORM_TYPE.WEB:
                    {
                        this.setWXPlatform();
                        break;
                    }
                case PLATFORM_TYPE.WEB_4399:
                    {
                        this.setWeb4399Platform();
                        break;
                    }
                case PLATFORM_TYPE.VIVO:
                    {
                        this.setVIVOPlatform();
                        break;
                    }
                case PLATFORM_TYPE.OPPO:
                    {
                        this.setOPPOPlatform();
                        break;
                    }
                case PLATFORM_TYPE.NATIVE_IOS:
                    {
                        this.setNativeIOSPlatform();
                        break;
                    }
                case PLATFORM_TYPE.NATIVE_ANDRIOD:
                    {
                        this.setNativeAndroidPlatform();
                        break;
                    }
                case PLATFORM_TYPE.TT:
                    {
                        this.setTTPlatform();
                        break;
                    }
            }
        }
        setWXPlatform() {
            if (PlatformUtil.isIOS()) {
                this.boxLoading.y -= 60;
            }
        }
        setQQPlatform() {}
        setWebPlatform() {}
        setWeb4399Platform() {}
        setVIVOPlatform() {}
        setOPPOPlatform() {}
        setNativeIOSPlatform() {}
        setNativeAndroidPlatform() {}
        setTTPlatform() {}
    }

    class ReviewMatchingViewCtrl extends ui.view.review.ReviewMatchingViewUI {
        constructor() {
            super();
            this.maxLen = 0;
            this.playerList = [];
            this.playerNum = 0;
            this.dataList = [];
            this.ready = {
                resReady: false,
                matching: false,
                mapUrl: null
            };
            this.activeTime = 0;
            this.step = 0;
            this.width = this.stage.width;
            this.height = this.stage.height;
            this.maxLen = this.imgPro.width;
            this.imgPro.width = 0;
        }
        onAwake() {
            this.init();
            this.setPlatformStyle();
            var that = this;
            this.timer.loop(100, this, function() {
                that.activeTime += 100;
                if (that.activeTime == 2500) {
                    that.doStep();
                } else {}
            });
        }
        doStep() {
            this.step++;
            if (this.step >= 2) {
                this.imgPro.width = 0;
                Laya.Tween.clearAll(this.imgPro);
                Laya.Tween.to(this.imgPro, {
                    width: this.maxLen
                }, 200, null, Laya.Handler.create(this, function() {
                    this.destroy();
                }));
            }
        }
        onDestroy() {
            this.timer.clearAll(this);
            this.maxLen = null;
            this.playerList = null;
            this.playerNum = null;
            this.ready = null;
            this.txtPercent = null;
            this.dataList = null;
            UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).setNewPlayerArm();
        }
        init() {
            if (ConfigManager.platform == PLATFORM_TYPE.OPPO || ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.WEB_4399) {
                this.nativeBanner = new NativeBanner2ViewCtrl();
                this.addChild(this.nativeBanner);
                this.nativeBanner && this.nativeBanner.show();
            }
            AdUtil.hideBannerAd();
            CharacterManger.cleanDataList();
            TaskManager.setModelTargetKillSore();
            GameTimeManager.matchingShow();
        }
        onBtnClose() {
            if (!CommonUtil.getTouch())
                return;
            if (this.ready.matching && this.ready.resReady && this.ready.mapUrl != null)
                return;
            this.destroy();
        }
        setProgress(percent) {
            this.txtPercent.text = Math.floor(percent * 100) + '%';
            let width = this.maxLen * percent;
            Laya.Tween.clearAll(this.imgPro);
            Laya.Tween.to(this.imgPro, {
                width: width
            }, 200);
        }
        close() {
            this.doStep();
        }
        setPlatformStyle() {
            switch (ConfigManager.platform) {
                case PLATFORM_TYPE.WX:
                    {
                        this.setWXPlatform();
                        break;
                    }
                case PLATFORM_TYPE.QQ:
                    {
                        this.setQQPlatform();
                        break;
                    }
                case PLATFORM_TYPE.WEB:
                    {
                        this.setWXPlatform();
                        break;
                    }
                case PLATFORM_TYPE.VIVO:
                    {
                        this.setVIVOPlatform();
                        break;
                    }
                case PLATFORM_TYPE.OPPO:
                    {
                        this.setOPPOPlatform();
                        break;
                    }
                case PLATFORM_TYPE.NATIVE_IOS:
                    {
                        this.setNativeIOSPlatform();
                        break;
                    }
                case PLATFORM_TYPE.NATIVE_ANDRIOD:
                    {
                        this.setNativeAndroidPlatform();
                        break;
                    }
                case PLATFORM_TYPE.TT:
                    {
                        this.setTTPlatform();
                        break;
                    }
            }
        }
        setWXPlatform() {}
        setQQPlatform() {}
        setWebPlatform() {}
        setVIVOPlatform() {}
        setOPPOPlatform() {}
        setNativeIOSPlatform() {}
        setNativeAndroidPlatform() {}
        setTTPlatform() {}
    }

    let FONT_NAME = [
        'number1',
        'number2',
        'number3'
    ];

    var Vector3$c = Laya.Vector3;
    var GAME_STATE;
    (function(GAME_STATE) {
        GAME_STATE[GAME_STATE["MENU"] = 0] = "MENU";
        GAME_STATE[GAME_STATE["START"] = 1] = "START";
        GAME_STATE[GAME_STATE["OVER"] = 2] = "OVER";
        GAME_STATE[GAME_STATE["PAUSE"] = 3] = "PAUSE";
    })(GAME_STATE || (GAME_STATE = {}));
    class GameScene extends ui.scene.GameSceneUI {
        constructor() {
            super();
            this.isFailLogin = false;
            this.isPause = false;
            this.cameraMoveCtrl = null;
            this.outPos = new Laya.Vector4();
            this.menuPlayer = null;
            this.isShowUnder = false;
            this.isPlayMove = false;
            this.imgBg = null;
            this.camreaData = {
                rot: new Laya.Vector3(),
                pos: new Laya.Vector3()
            };
            this.lastSceneType = null;
            this.isFirstGame = true;
            this.timerOnce(100, this, function() {
                this.height = Laya.stage.height;
                this.width = Laya.stage.width;
            }, null, false);
        }
        onExit() { super.onExit(); }
        onEnter() {
            let loadingView;
            if (ConfigManager.gameType == GAME_MJB_TYPE.QZHXJY) {
                loadingView = new ReviewLoadingViewCtrl(9);
            } else {
                loadingView = new LoadingViewCtrl(9);
            }
            loadingView.zOrder = ORDER_LAYER_Z.LOADING;
            this.stage.addChild(loadingView);
            let that = this;
            let step = 0;
            this.loadMainSub(loadingView, function() {
                let exec = function() {
                    console.log('加载步骤：', step);
                    step++;
                    if (step == 2) {
                        that.init();
                        loadingView.close();
                    }
                };
                that.login(exec);
                that.loadMainRes(exec, loadingView, [{
                        url: RES_PATH.PFB_UI_BREAK_STAR,
                        type: Laya.Loader.PREFAB
                    },
                    {
                        url: RES_PATH.JSON_UI_MAP,
                        type: Laya.Loader.JSON
                    },
                    {
                        url: RES_PATH.MENU_SCENE
                    },
                    {
                        url: RES_PATH.EFFECT_PREFEB
                    },
                    {
                        url: RES_PATH.PARTS_PREFEB
                    },
                    {
                        url: 'sub1/sky_box/sky.lmat',
                        type: Laya.Loader.MATERIAL
                    },
                    {
                        url: RES_PATH.WEAPON_PREFEB
                    },
                    {
                        url: RES_PATH.SKIN_PREFEB
                    },
                    {
                        url: RES_PATH.HAND_PREFEB
                    }
                ]);
            });
            if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD) {
                let PlatformClass = window['PlatformClass'];
                if (PlatformClass)
                    PlatformClass.createClass('demo.JSBridge').call('setChannelId');
                if (PlatformClass)
                    PlatformClass.createClass('demo.JSBridge').call("setSystemInfo");
            }
            if (ConfigManager.platform == PLATFORM_TYPE.WX || ConfigManager.platform == PLATFORM_TYPE.QQ) {
                AdUtil.preloadBannerAd(function() {
                    AdUtil.hideBannerAd();
                });
                PlatformUtil.preloadRewardVideoAd(AdData[0].ad_id);
                AdUtil.preloadCustom();
            }
        }
        login(exec) {
            let that = this;
            let func = function() {
                NetworkManager.request(ROUTE_MAP.CONFIG, 'GET', {
                    appId: ConfigManager.appId
                }, function(data) {
                    console.log('data', data.data.config);
                    data = data.data;
                    RoleManager.getInstance().initData();
                    ConfigManager.setData(JSON.parse(data.share), data.config, data.region);
                    if (ConfigManager.exitCtrl() == 1) {
                        let PlatformClass = window['PlatformClass'];
                        if (PlatformClass)
                            PlatformClass.createClass('demo.JSBridge').call('onBtnPrivateRefuse');
                    }
                    if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD && ConfigManager.isReviewVersion()) {
                        let PlatformClass = window['PlatformClass'];
                        if (PlatformClass)
                            PlatformClass.createClass('demo.JSBridge').call('setReview');
                    }
                    if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD) {
                        let PlatformClass = window['PlatformClass'];
                        if (PlatformClass)
                            PlatformClass.createClass('demo.JSBridge').call('setSplashTime', ConfigManager.getNativeSplashTime().toString());
                    }
                    AdUtil.loop();
                    if (!that.isFailLogin) {
                        PrivateDialogViewCtrl.create(function() {
                            exec();
                        });
                    }
                }, function() {
                    if (that.isFailLogin)
                        return;
                    that.isFailLogin = true;
                    RoleManager.getInstance().initData();
                    let share = [];
                    share[0] = {
                        title: '【你的好友@了你一下】在吗，一起来山坡上竞个速',
                        img: 'main/share/1.jpg'
                    };
                    ConfigManager.setData(share, null, null);
                    console.log('登录失败---');
                    AdUtil.loop();
                    PrivateDialogViewCtrl.create(function() {
                        exec();
                    });
                });
            };
            ChannelManager.zsInit(func);
        }
        loadMainRes(exec, loadingView, resList = []) {
            console.log('加载资源');
            console.log('ConfigManager.platform:'+ConfigManager.platform);
            ResourceManager.loadRes(resList, Laya.Handler.create(this, function() {
                console.log('加载成功——----------------------1');
                Laya.Scene.setUIMap(RES_PATH.JSON_UI_MAP);
                console.log('加载成功——----------------------2');
                this.loadFont(exec);
            }), Laya.Handler.create(this, function(percent) {
                loadingView.setProgress(percent, 9);
            }));
        }
        loadFont(exec) {
            let idx = 0;
            let load = function() {
                if (!RES_PATH.FNT_NUMBER[idx]) {
                    exec();
                    return;
                }
                let bitmapFont1 = new Laya.BitmapFont();
                bitmapFont1.loadFont(RES_PATH.FNT_NUMBER[idx], new Laya.Handler(this, function() {
                    bitmapFont1.setSpaceWidth(4);
                    Laya.Text.registerBitmapFont(FONT_NAME[idx], bitmapFont1);
                    if (idx == FONT_NAME.length - 1) {
                        exec();
                    } else {
                        idx++;
                        load();
                    }
                }, [bitmapFont1]));
            };
            load();
        }
        loadSub(name, progress, loadingView) {
            return new Promise((resolve, reject) => {
                let loadProgress = function(percent) {
                    loadingView.setProgress(percent);
                };
                ResourceManager.loadSubpackage(name, resolve, loadProgress);
            });
        }
        loadMainSub(loadingView, success) {
            let subPack = [
                SUB_NAME.SUB1,
                SUB_NAME.SUB2,
                SUB_NAME.SUB3,
                SUB_NAME.SUB18,
                SUB_NAME.ROLE,
            ];
            let idx = 0;
            let load = function() {
                if (!subPack[idx]) {
                    success();
                    return;
                }
                ResourceManager.loadSubpackage(subPack[idx], function() {
                    idx++;
                    load();
                }, function(percent) {
                    loadingView.setProgress(percent, idx + 1);
                });
            };
            load();
        }
        init() {
            if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD) {
                AdUtil.preloadBannerAd();
                let PlatformClass = window['PlatformClass'];
                if (PlatformClass)
                    PlatformClass.createClass('demo.JSBridge').call('setChannelId');
            }
            this.reSetDataName();
            OVAdManager.init();
            this.adCtrl();
            LogicTimer.create(32);
            let view = new CommonMenuTopBarCtrl();
            if (!PlatformUtil.isFullScreen()) {
                view.pos(800, 21);
            } else {
                view.pos(900, 21);
            }
            UIManager.init(view);
            this.setGameState(GAME_STATE.MENU);
            this.setFrame();
            this.createFirstImgBg();
            let time = 300;
            LogManager.init();
            NotifyManager.register(NOTIFY_ID.REFRESH_SKIN, this.updateMenuScene3D, this);
            RewardManager.id = RoleManager.getInstance().getSynthesisMaxId();
            RewardManager.setfreeRewardForGoldCoins();
            RewardManager.setfreeDiamondsRewards();
            RewardManager.setOflineReawrd();
            if (ConfigManager.platform == PLATFORM_TYPE.WEB_4399) {
                Laya.stage.on(Laya.Event.BLUR, GameScene, function() {
                    if (!GameScene.loseFocusViewCtrl) {
                        let view = new LoseFocusViewCtrl();
                        Laya.stage.addChild(view);
                        view.zOrder = ORDER_LAYER_Z.MAX + 100;
                        GameScene.loseFocusViewCtrl = view;
                        if (view) {
                            if (SceneManager.getCurScene().state == GAME_STATE.START) {
                                SceneManager.getCurScene().pause();
                            }
                            Laya.timer.scale = 0;
                        }
                    }
                });
            }
        }
        adCtrl() {
            if (ConfigManager.platform == PLATFORM_TYPE.OPPO || ConfigManager.platform == PLATFORM_TYPE.WEB) {
                AdUtil.timerRefreshNativeBanner();
                AdUtil.timerRefreshNativIcon();
            }
        }
        createFirstImgBg() {
            if (!this.imgBg) {
                this.imgBg = new Laya.Image('sub1/ui/first/img_19.jpg');
                if (ConfigManager.platform == PLATFORM_TYPE.TT || ConfigManager.platform == PLATFORM_TYPE.WEB) {
                    if (ConfigManager.isReviewVersion()) {
                        this.imgBg.skin = 'sub1/ui/first/img_2.jpg';
                    }
                }
                this.imgBg.width = Laya.stage.width;
                this.imgBg.height = Laya.stage.height;
                Laya.stage.addChildAt(this.imgBg, 0);
            }
        }
        removeFirstImgBg() {}
        createSynthesis() {
            if (GameScene.synthesisViewCtrl)
                return;
            GameScene.synthesisViewCtrl = new SynthesisViewCtrl();
        }
        updateMenuScene3D() {
            if (this.isPlayMove)
                return;
            if (this.menuPlayer)
                this.menuPlayer.destroy();
            this.menuPlayer = null;
            console.log('刷新主界面角色');
            this.createMenuPlayer();
        }
        createMenu(type = 0, view = null, roleId = null) {
            if (this.lastSceneType == type)
                return;
            if (this.menuPlayer)
                this.menuPlayer.destroy();
            if (GameScene.scene3d) {
                GameScene.scene3d.removeSelf();
            }
            if (type == 1 || type == 3) {
                MapManager.cleanMap();
                GameScene.scene3d = ResourceManager.getRes(RES_PATH.MENU_SCENE);
                console.log('菜单摄像机：', GameScene.scene3d.getChildByName('Main Camera').enableHDR);
                GameScene.scene3d.getChildByName('Main Camera').enableHDR = false;
                if (view)
                    view.addChild(GameScene.scene3d);
                else {
                    Laya.stage.addChild(GameScene.scene3d);
                }
                this.createMenuPlayer(type);
                this.lastSceneType = type;
                return;
            } else {
                if (type == 2) {
                    MapManager.cleanMap();
                    GameScene.scene3d = ResourceManager.getRes(RES_PATH.MENU_SCENE);
                    console.log('菜单摄像机：', GameScene.scene3d.getChildByName('Main Camera').enableHDR);
                    GameScene.scene3d.getChildByName('Main Camera').enableHDR = false;
                    Laya.stage.addChild(GameScene.scene3d);
                    this.lastSceneType = type;
                    this.createMenuPlayer(type, roleId);
                    return;
                }
            }
            EffectManger.clean();
            this.menuPlayer = null;
            this.isPlayMove = false;
            GameTimeManager.gameTime = 300;
            SoundManager.cleanEffect();
            CharacterManger.clean();
            MapManager.cleanMap();
            BulletManager.clean();
            PlaceArmManager.clean();
            BiochemistryManager.clean();
            MapManager.cleanMap();
            this.lastSceneType = type;
            GameScene.scene3d = ResourceManager.getRes(RES_PATH.MENU_SCENE);
            console.log('菜单摄像机：', GameScene.scene3d.getChildByName('Main Camera').enableHDR);
            GameScene.scene3d.getChildByName('Main Camera').enableHDR = false;
            if (ConfigManager.isReviewVersion() && ConfigManager.gameType == GAME_MJB_TYPE.QZHXJY) {
                Laya.stage.addChild(GameScene.scene3d);
            } else {
                this.addChild(GameScene.scene3d);
            }
            this.createMenuPlayer();
        }
        cleanMenu() {
            if (this.menuPlayer)
                this.menuPlayer.destroy();
            GameScene.scene3d && GameScene.scene3d.removeSelf();
        }
        createMenuPlayer(type = 0, roleId = null) {
            let player = SkinManager.createSkin(new Laya.Vector3(0, 0, 0), '001', false, OBJ_NAME.PLAYER, GameScene.scene3d, true);
            this.menuPlayer = player;
            this.menuPlayer.transform.localRotationEulerY = 25;
            this.menuPlayer.transform.localPositionX = -2.5;
            this.menuPlayer.transform.localPositionY = -5.5;
            this.menuPlayer.transform.localScale = new Vector3$c(6, 6, 6);
            let id = RoleManager.getInstance().getSelectSkin();
            if (type == 2) {
                this.menuPlayer.transform.localPositionX = 0;
                this.menuPlayer.transform.localPositionY = -2.5;
                this.menuPlayer.transform.localScale = new Vector3$c(4.5, 4.5, 4.5);
            }
            if (type == 3) {
                this.menuPlayer.transform.localPositionX = -5;
                this.menuPlayer.transform.localPositionY = -2.5;
                this.menuPlayer.transform.localScale = new Vector3$c(4.5, 4.5, 4.5);
            }
            if (type == 0) {
                this.menuPlayer.transform.localPositionX = -1;
                this.menuPlayer.transform.localPositionY = -0.3;
                this.menuPlayer.transform.localRotationEulerY = -25;
                this.menuPlayer.transform.localScale = new Vector3$c(3, 3, 3);
            }
            SkinManager.createMenuArm(id, this.menuPlayer);
            SkinManager.createPartsByLocal(this.menuPlayer);
            this.resetPlayMenuPlayerAni(type);
        }
        moveMenuPlayer(isLoading) {
            if (this.menuPlayer) {
                this.isPlayMove = true;
                var that = this;
                Laya.Tween.to(this.menuPlayer.transform, {
                    localPositionX: isLoading ? 0 : -1
                }, 500, null, Laya.Handler.create(this, function() {
                    that.isPlayMove = false;
                }));
            }
        }
        resetPlayMenuPlayerAni(type = 0) {
            let id = RoleManager.getInstance().getSelectSkin();
            if (type == 1) {
                if (UIManager.getFunction(FUNCTION_TAG.FIRST))
                    id = RoleManager.getInstance().getSelectSkin();
                else
                    id = CharacterManger.playerLogicalBaseLayer.armCtrl ? CharacterManger.playerLogicalBaseLayer.armCtrl.id : RoleManager.getInstance().getSelectSkin();
            }
            let equip = SkinManager.createMenuArm(id, this.menuPlayer);
            equip.transform.localScale = new Vector3$c(1, 1, 1);
        }
        createMap(url) {
            CharacterManger.clean();
            MapManager.cleanMap();
            console.log('添加主场景');
            GameScene.scene3d = ResourceManager.getRes(url);
            this.lastSceneType = -1;
            Laya.stage.addChildAt(GameScene.scene3d, 0);
            PlaceArmManager.addPlaceList();
            BiochemistryManager.addZombieBirthList();
        }
        createObj() {
            MapManager.loadMap();
            this.createSky();
            GameRoleCreateManager.getRolePos();
            this.createPlayer();
            BunkerManager.addBunkersList();
            this.createAI();
            this.cameraCtrl();
        }
        createSky() {
            let skyMaterial = ResourceManager.getRes('sub1/sky_box/sky.lmat');
            GameScene.scene3d.skyRenderer.material = skyMaterial;
        }
        getViewportPoint(pos) {
            let camrea = GameScene.camera;
            camrea.viewport.project(pos, camrea.projectionViewMatrix, this.outPos);
            this.outPos.x = this.outPos.x / Laya.stage.clientScaleX;
            this.outPos.y = this.outPos.y / Laya.stage.clientScaleY;
            return this.outPos;
        }
        setLightShadow() {
            let directionLight = GameScene.scene3d.getChildByName(OBJ_NAME.LIGHT);
            directionLight.shadowMode = Laya.ShadowMode.Hard;
            directionLight.shadowDistance = 33;
            directionLight.shadowResolution = 2048;
            directionLight.shadowCascadesMode = Laya.ShadowCascadesMode.NoCascades;
            directionLight.shadowNormalBias = 5;
            directionLight.shadowStrength = 0.5;
        }
        cameraCtrl() {
            let camrea = CommonUtil.findChildByName(GameScene.scene3d.getChildByName(OBJ_NAME.PLAYER), OBJ_NAME.CAMREA);
            GameScene.camera = camrea;
            GameScene.camera.nearPlane = 0.01;
            camrea.enableHDR = false;
            this.camreaData.pos = GameScene.camera.transform.localPosition.clone();
            this.camreaData.rot = GameScene.camera.transform.localRotationEuler.clone();
        }
        createPlayer() {
            GameRoleCreateManager.createPlayer();
        }
        createAI() {
            GameRoleCreateManager.createAI();
        }
        update() {
            if (CharacterManger.gameStop) {
                if (CharacterManger.playerLogicalBaseLayer) {
                    if (CharacterManger.playerLogicalBaseLayer.getPresentationBaseLayer()) {
                        if (PerformanceManager.isCloseCharacterCtrl) {
                            CharacterManger.playerLogicalBaseLayer.getPresentationBaseLayer().characterCtrl.stop();
                        } else {
                            CharacterManger.playerLogicalBaseLayer.getPresentationBaseLayer().characterCtrl.move(CharacterManger.playerLogicalBaseLayer.getMyOrientation());
                        }
                    }
                }
                return;
            }
            if (CharacterManger.gameOver) {
                if (this.state != GAME_STATE.OVER) {
                    if (!GameScene.isOpenOverView) {
                        GameScene.isOpenOverView = true;
                        Laya.timer.once(1500, this, () => {
                            console.log('创建结算界面');
                            DifficultyManager.setCurGamesResult();
                            this.setGameState(GAME_STATE.OVER);
                        });
                    }
                }
                if (CharacterManger.playerLogicalBaseLayer) {
                    if (CharacterManger.playerLogicalBaseLayer.getPresentationBaseLayer()) {
                        if (PerformanceManager.isCloseCharacterCtrl) {
                            CharacterManger.playerLogicalBaseLayer.getPresentationBaseLayer().characterCtrl.stop();
                        } else {
                            CharacterManger.playerLogicalBaseLayer.getPresentationBaseLayer().characterCtrl.move(CharacterManger.playerLogicalBaseLayer.getMyOrientation());
                        }
                    }
                }
                return;
            }
            LogicTimer.gSysTimer.update();
            if (this.state != GAME_STATE.START)
                return;
            CharacterManger.attack();
            CharacterManger.move();
            CharacterManger.jump();
            CharacterManger.randomRotate();
            CharacterManger.setDoubleKill();
            CharacterManger.countDownBeHit();
            BiochemistryManager.finishCtrl();
            BiochemistryManager.resetGenerateBulletSupply();
            BiochemistryManager.resetGenerateLifeSupply();
            CharacterManger.zombieModeTeamDie();
            CharacterManger.getzomBieModeNearDieTeam();
            CharacterManger.rescueNearTeam();
            BulletManager.update();
            if (CharacterManger.playerLogicalBaseLayer.getPresentationBaseLayer().sectorDetection()) {
                if (UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME)) {
                    if (!UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).isToGudeAttack) {
                        UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).isToGudeAttack = true;
                        UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).setGuide();
                    }
                }
            }
        }
        setFrame() {
            Laya.timer.frameLoop(1, this, this.update);
        }
        pause() {
            this.isPause = true;
        }
        resume() {
            this.isPause = false;
        }
        setGameState(state, args = null) {
            if (this.state == state)
                return;
            this.preState = this.state;
            this.state = state;
            let that = this;
            switch (state) {
                case GAME_STATE.MENU:
                    {
                        if (this.preState == GAME_STATE.OVER &&
                            CharacterManger._isWin &&
                            ConfigManager.appId == ANDROID_APP_ID.XM) {}
                        GameScene.isGaming = false;
                        this.createSynthesis();
                        if (this.imgBg)
                            this.imgBg.visible = true;
                        if (ConfigManager.gameType == GAME_MJB_TYPE.QZHXJY && ConfigManager.isReviewVersion()) {
                            UIManager.openFunction(FUNCTION_TAG.FIRST, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE, {});
                        } else {
                            UIManager.openFunction(FUNCTION_TAG.FIRST, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.ALL_SHOW, {});
                        }
                        break;
                    }
                case GAME_STATE.START:
                    {
                        if (this.imgBg)
                            this.imgBg.visible = false;
                        GameScene.startGameNum++;
                        GameScene.isGaming = true;
                        UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).start();
                        break;
                    }
                case GAME_STATE.OVER:
                    {
                        TaskManager.completeTask(TASK_TYPE.COMPLETE_GAME);
                        GameScene.realGameNum++;
                        RoleManager.getInstance().updatePopUpRuleGameNum();
                        PlatformUtil.endRecordGame(function(path) {
                            PlatformUtil.path = path;
                        });
                        if (CharacterManger._isWin)
                            TaskManager.completeTask(TASK_TYPE.GAME_WIN);
                        let overFunc = function() {
                            if (ConfigManager.isReviewVersion() && ConfigManager.gameType == GAME_MJB_TYPE.QZHXJY) {
                                UIManager.openFunction(FUNCTION_TAG.END_RECREATION, FUNCTION_OPEN_MODE.REPLACE, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE);
                            } else {
                                UIManager.clean();
                                UIManager.openFunction(FUNCTION_TAG.END_ANI, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE, function() {
                                    if (ModeManager.mode == GAME_MODE_TYPE.TEAMCOMPETITION) {
                                        UIManager.openFunction(FUNCTION_TAG.END, FUNCTION_OPEN_MODE.REPLACE, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE, null, function() {
                                            UIManager.openFunction(FUNCTION_TAG.END_MYSELF, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE);
                                            UIManager.registerAutoOpenFunction(FUNCTION_TAG.DAN_ANI, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE, CharacterManger._isWin);
                                            let id = RoleManager.getInstance().getSuperEquipId();
                                            if (id) {
                                                let exec = function() {
                                                    if (RoleManager.getInstance().getGuide() >= GuideStep.FINISH) {
                                                        UIManager.registerAutoOpenFunction(FUNCTION_TAG.SUPER_EQUIP, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.WINDOW, COMMON_MENU_STYLE.HIDE, {
                                                            id: id,
                                                            isEndOpen: true
                                                        });
                                                    }
                                                };
                                                if (ConfigManager.platform == PLATFORM_TYPE.TT || ConfigManager.platform == PLATFORM_TYPE.WEB) {
                                                    if (!ConfigManager.isReviewVersion()) {
                                                        exec();
                                                    }
                                                } else {
                                                    exec();
                                                }
                                            }
                                            if (ConfigManager.platform == PLATFORM_TYPE.OPPO) {
                                                UIManager.registerAutoOpenFunction(FUNCTION_TAG.OPPOGAMEBOX, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE);
                                            } else {
                                                UIManager.registerAutoOpenFunction(FUNCTION_TAG.ENDGAMEBOX, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE, {
                                                    viewType: 1
                                                });
                                            }
                                        });
                                    } else {
                                        UIManager.openFunction(FUNCTION_TAG.END_RECREATION, FUNCTION_OPEN_MODE.REPLACE, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE, null, function() {
                                            UIManager.openFunction(FUNCTION_TAG.END_MYSELF, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE);
                                            let id = RoleManager.getInstance().getSuperEquipId();
                                            if (id) {
                                                let exec = function() {
                                                    if (RoleManager.getInstance().getGuide() >= GuideStep.FINISH) {
                                                        UIManager.registerAutoOpenFunction(FUNCTION_TAG.SUPER_EQUIP, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.WINDOW, COMMON_MENU_STYLE.HIDE, {
                                                            id: id,
                                                            isEndOpen: true
                                                        });
                                                    }
                                                };
                                                if (ConfigManager.platform == PLATFORM_TYPE.TT || ConfigManager.platform == PLATFORM_TYPE.WEB) {
                                                    if (!ConfigManager.isReviewVersion()) {
                                                        exec();
                                                    }
                                                } else {
                                                    exec();
                                                }
                                            }
                                            if (ConfigManager.platform == PLATFORM_TYPE.OPPO) {
                                                UIManager.registerAutoOpenFunction(FUNCTION_TAG.OPPOGAMEBOX, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE);
                                            } else {
                                                UIManager.registerAutoOpenFunction(FUNCTION_TAG.ENDGAMEBOX, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE, {
                                                    viewType: 1
                                                });
                                            }
                                        });
                                    }
                                });
                            }
                        };
                        if ((ConfigManager.appId == PLATFORM_TYPE.NATIVE_IOS && ModeManager.mode != GAME_MODE_TYPE.TEAMCOMPETITION) || ConfigManager.appId == ANDROID_APP_ID.C_233) {
                            AdUtil.createFullscreenVideo(null, function() {
                                overFunc();
                            });
                        } else {
                            if (ModeManager.mode != GAME_MODE_TYPE.TEAMCOMPETITION &&
                                ConfigManager.appId == ANDROID_APP_ID.XM) {
                                AdUtil.createFullscreenVideo(null, function() {
                                    overFunc();
                                });
                            } else
                                overFunc();
                        }
                        break;
                    }
            }
        }
        getCurView() {
            return this.view;
        }
        createAllModeMap(url) {
            let matchingView;
            if (ConfigManager.isReviewVersion() && ConfigManager.gameType == GAME_MJB_TYPE.QZHXJY) {
                matchingView = new ReviewMatchingViewCtrl();
            } else {
                matchingView = new MatchingViewCtrl();
            }
            matchingView.zOrder = ORDER_LAYER_Z.LOADING;
            Laya.stage.addChild(matchingView);
            let that = this;
            let exec = function() {
                matchingView.ready.resReady = true;
                matchingView.ready.mapUrl = url;
                matchingView.close();
                that.startByClassicMode(url);
            };
            let list = [{
                url: url,
                type: null
            }];
            if (ModeManager.mode == GAME_MODE_TYPE.BIOCHEMISTRY) {
                list.push({
                    url: RES_PATH.SKIN_ZOMBIE,
                    type: null
                });
            }
            this.loadMainRes(exec, matchingView, list);
        }
        startByClassicMode(url) {
            DifficultyManager.setDifficulty();
            this.createMap(url);
            this.createObj();
            this.setGameState(GAME_STATE.START);
            CharacterManger.playerReStart();
            PresentationBaseLayer.sound3dCount = 0;
        }
        static touchCtrl(id, touchIDState) {
            if (touchIDState == TOUCHIDSTATE.ADD) {
                let a = false;
                let index = 0;
                for (let k = 0; k < this.touchIDs.length; k++) {
                    if (id == this.touchIDs[k]) {
                        a = true;
                        index = k;
                        break;
                    }
                }
                if (!a) {
                    if (this.touchIDs.length < 2) {
                        this.touchIDs.push(id);
                    }
                }
            } else if (touchIDState == TOUCHIDSTATE.REMOVE) {
                let a = false;
                let index = 0;
                for (let k = 0; k < this.touchIDs.length; k++) {
                    if (id == this.touchIDs[k]) {
                        a = true;
                        index = k;
                        break;
                    }
                }
                if (a) {
                    this.touchIDs.splice(index, 1);
                }
            }
            if (this.touchIDs.length == 1) {
                if (touchIDState == TOUCHIDSTATE.ADD) {
                    if (Laya.MouseManager.instance.mouseX < Laya.stage.width / 2) {
                        this.handleType = HANDLETYPE.ONLYMOVE;
                    } else {
                        this.handleType = HANDLETYPE.ONLYROT;
                    }
                }
            } else if (this.touchIDs.length == 2) {
                if (this.curX != Laya.MouseManager.instance.mouseX) {
                    if (Laya.MouseManager.instance.mouseX <= Laya.stage.width / 2) {
                        this.handleType = HANDLETYPE.MOVEANDROT_TOUCHLEFTAFTER;
                    } else {
                        this.handleType = HANDLETYPE.MOVEANDROT_TOUCHRIGHTAFTER;
                    }
                    this.curX = Laya.MouseManager.instance.mouseX;
                }
            } else {
                this.handleType = null;
            }
        }
        reSetDataName() {
            if (!ConfigManager.getViolenceCtrl() && ConfigManager.platform == PLATFORM_TYPE.WEB_4399) {
                for (let index = 0; index < Item.keys.length; index++) {
                    const element = Item.getDataByIndex(index);
                    if (element.extra() == SPECIAL_ID.RED_TASSEL_EQUIP) {
                        element.name = 'P90-突击者';
                        console.log(element.name);
                    }
                    let str = element.name;
                    str = str.replace("杀", "");
                    element.name = str;
                }
                for (let index = 0; index < ARM.keys.length; index++) {
                    const element = ARM.getDataByIndex(index);
                    if (element.id == SPECIAL_ID.RED_TASSEL_EQUIP) {
                        element.name = 'P90-突击者';
                        console.log(element.name);
                    }
                    let str = element.name;
                    str = str.replace("杀", "");
                    element.name = str;
                }
            }
        }
    }
    GameScene.myPhyworld = null;
    GameScene.touchLeft = false;
    GameScene.touchRight = false;
    GameScene.leftPointX = null;
    GameScene.rightPointX = null;
    GameScene.touchIDs = [];
    GameScene.firstPoints = {
        id: 0,
        pointX: 0
    };
    GameScene.secondPoints = {
        id: 0,
        pointX: 0
    };
    GameScene.curX = 0;
    GameScene.isGaming = false;
    GameScene.synthesisViewCtrl = null;
    GameScene.isReading = false;
    GameScene.isOpenOverView = false;
    GameScene.gameNum = 1;
    GameScene.isShowRevivieCrazy = false;
    GameScene.isLevelUp = false;
    GameScene.realGameNum = 0;
    GameScene.popNum = 0;
    GameScene.startGameNum = 0;

    class DanAniViewCtrl extends ui.view.ani.DanAniViewUI {
        constructor(isWin) {
            super();
            this.isWin = null;
            this.colorMatrix = [
                1, 0, 0, 0, 0,
                0, 1, 0, 0, 0,
                0, 0, 1, 0, 0,
                0, 0, 0, 1, 0,
            ];
            this.rewardGold = 200;
            this.width = Laya.stage.width;
            this.height = Laya.stage.height;
            this.isWin = isWin;
            this.init(isWin);
            this.setPlatformStyle();
        }
        onAwake() {}
        onDestroy() {
            this.timer.clearAll(this);
        }
        init(isWin) {
            this.setPreDan();
            this.setDanInfo(isWin);
        }
        onBtnClose() {
            if (!CommonUtil.getTouch())
                return;
            RewardManager.setSettlementWinGoldsRewards();
            let gold = RewardManager.settlementWinGoldsRewards;
            UIManager.closeFunction();
        }
        setDanInfo(isWin) {
            let that = this;
            this.imgLightWin.visible = false;
            this.imgLightLose.visible = false;
            this.imgWinBg.visible = isWin;
            this.imgLoseBg.visible = !isWin;
            if (isWin) {
                let ret = RoleManager.getInstance().increaseStar();
                this.imgLightWin.visible = true;
                this.ani4.play(0, true);
                if (ret) {
                    this.ani1.play(0, false);
                    this.setDan();
                    this.ani1.on(Laya.Event.COMPLETE, this, function() {
                        that.setStar(false);
                        that.playStarAni();
                        that.ani4.play(0, true);
                        that.playDropDebris();
                    });
                    this.imgWin1.visible = true;
                } else {
                    this.aniWin.play(0, false);
                    that.setDan();
                    this.aniWin.on(Laya.Event.COMPLETE, this, function() {
                        that.setStar(false);
                        that.playStarAni();
                        that.ani4.play(0, true);
                        that.playDropDebris();
                    });
                    this.imgWin.visible = true;
                }
            } else {
                let ret = RoleManager.getInstance().reduceStar();
                that.setDan();
                this.imgLightLose.visible = true;
                this.imgLose.visible = true;
                if (ret) {
                    this.ani1.play(0, false);
                    this.ani1.on(Laya.Event.COMPLETE, this, function() {
                        that.setStar(true);
                        that.playDropStarAni();
                    });
                } else {
                    this.aniWin.play(0, false);
                    this.aniWin.on(Laya.Event.COMPLETE, this, function() {
                        that.setStar(true);
                        that.playDropStarAni();
                    });
                }
            }
        }
        setStar(isDrop = false) {
            let myDan = RoleManager.getInstance().getDanInfo();
            let danId = myDan.id;
            let curStar = myDan.star;
            let danData = DanData.getDataByKey(danId);
            if (danData.star > 5) {
                this.boxStarN.visible = true;
                this.txtStarNum.text = 'x' + curStar;
            } else {
                let boxStar = this["boxStar" + danData.star];
                if (this["boxStar" + (danData.star - 1)] && this["boxStar" + (danData.star - 1)].visible) {
                    this["boxStar" + (danData.star - 1)].visible = false;
                }
                if (!boxStar)
                    return;
                boxStar.visible = true;
                for (let i = 0, len = boxStar.numChildren; i < len; i++) {
                    let imgStarBg = boxStar.getChildAt(i);
                    let imgStar = imgStarBg.getChildAt(0);
                    if (i < curStar) {
                        imgStar.visible = true;
                        if (i == curStar - 1 && !isDrop) {
                            SoundManager.vibrateShort();
                            let prefab = ResourceManager.getRes(RES_PATH.PFB_UI_BREAK_STAR).create();
                            prefab.ani1.wrapMode = Laya.Animation.WRAP_REVERSE;
                            prefab.ani1.play(0, false);
                            this.starAniPrefab = prefab;
                            imgStarBg.addChild(prefab);
                            imgStar.visible = false;
                            prefab.x = -2;
                            prefab.y = -2;
                        }
                    } else {
                        if (i == curStar && isDrop) {
                            SoundManager.vibrateShort();
                            let prefab = ResourceManager.getRes(RES_PATH.PFB_UI_BREAK_STAR).create();
                            prefab.ani1.wrapMode = Laya.Animation.WRAP_PINGPONG;
                            prefab.ani1.play(0, false);
                            this.starAniPrefab = prefab;
                            imgStarBg.addChild(prefab);
                            imgStar.visible = false;
                            prefab.x = -2;
                            prefab.y = -2;
                        }
                        imgStar.visible = false;
                    }
                }
            }
            var that = this;
            if (this.starAniPrefab) {
                this.starAniPrefab.ani1.on(Laya.Event.COMPLETE, this, function() {
                    console.log('gameNum' + GameScene.gameNum);
                    if (!RoleManager.getInstance().isNew || GameScene.gameNum != 2) {
                        if (ConfigManager.appId == ANDROID_APP_ID.XM || ConfigManager.appId == ANDROID_APP_ID.C233_ME || ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS || ConfigManager.appId == ANDROID_APP_ID.C_233) {
                            AdUtil.createFullscreenVideo(0, function() {});
                        }
                        if ((ConfigManager.appId == ANDROID_APP_ID.MMY || ConfigManager.appId == ANDROID_APP_ID.HYKB) && that.isWin) {
                            AdUtil.createFullscreenVideo(0, function() {});
                        }
                    }
                    that.on(Laya.Event.CLICK, that, that.onBtnClose);
                });
            } else {
                if (!RoleManager.getInstance().isNew || GameScene.gameNum != 2) {
                    if (ConfigManager.appId == ANDROID_APP_ID.XM || ConfigManager.appId == ANDROID_APP_ID.C233_ME || ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS || ConfigManager.appId == ANDROID_APP_ID.C_233) {
                        AdUtil.createFullscreenVideo(0, function() {});
                    }
                    if ((ConfigManager.appId == ANDROID_APP_ID.MMY || ConfigManager.appId == ANDROID_APP_ID.HYKB) && that.isWin) {
                        AdUtil.createFullscreenVideo(0, function() {});
                    }
                }
                that.on(Laya.Event.CLICK, that, that.onBtnClose);
            }
            if (ConfigManager.platform == PLATFORM_TYPE.TT) {
                if (RoleManager.getInstance().isBannerTouch() && ConfigManager.getAutoPlayVideo()) {
                    AdUtil.setEvent(function() {}, function() {}, REWARD_CTRL_TYPE.AUTO);
                    LoadingMaskViewCtrl.hide();
                }
            }
        }
        setDan() {
            let myDan = RoleManager.getInstance().getDanInfo();
            let danData = DanData.getDataByKey(myDan.id);
            for (let i = 1; i < 10; i++) {
                if (this["boxStar" + i]) {
                    this["boxStar" + i].visible = false;
                } else {
                    break;
                }
            }
            this.boxStarN.visible = false;
            this.imgIcon.skin = RES_PATH.IMG_DAN_ROOT + danData.icon;
            let img = new Laya.Image(RES_PATH.IMG_DAN_ROOT + danData.icon);
            this.imgIcon.mask = img;
            this.txtName.text = danData.name;
            if (danData.lv) {
                this.imgLv.visible = true;
                this.imgLv.skin = 'sub1/ui/dan/img_lv_' + danData.lv + '.png';
            } else {
                this.imgLv.visible = false;
            }
        }
        setPreDan() {
            let myDan = RoleManager.getInstance().getDanInfo();
            let danData = DanData.getDataByKey(myDan.id);
            let imgIcon = this.boxPreDan.getChildAt(0).getChildByName('imgIcon');
            let imgLv = this.boxPreDan.getChildAt(0).getChildByName('imgLv');
            imgIcon.skin = RES_PATH.IMG_DAN_ROOT + danData.icon;
            if (danData.lv) {
                imgLv.visible = true;
                imgLv.skin = 'sub1/ui/dan/img_lv_' + danData.lv + '.png';
            } else {
                imgLv.visible = false;
            }
        }
        playStarAni(cb = null) {
            var filter = new Laya.ColorFilter(this.colorMatrix);
            this.boxDanRoot.filters = [filter];
            let tween = Laya.Tween.to(this.colorMatrix, {
                "4": 255,
                "9": 255,
                "14": 255
            }, 300, null, null, 500);
            tween.update = Laya.Handler.create(this, function() {
                filter.setByMatrix(this.colorMatrix);
            }, null, false);
            let tween2 = Laya.Tween.to(this.colorMatrix, {
                "4": 0,
                "9": 0,
                "14": 0
            }, 300, null, null, 800);
            tween2.update = Laya.Handler.create(this, function() {
                filter.setByMatrix(this.colorMatrix);
            }, null, false);
            Laya.Tween.to(this.boxDanRoot, {
                scaleX: 1.1,
                scaleY: 1.1
            }, 300, Laya.Ease.backOut, null, 500);
            Laya.Tween.to(this.boxDanRoot, {
                scaleX: 1,
                scaleY: 1
            }, 300, null, Laya.Handler.create(this, function() {
                cb && cb();
            }), 800);
        }
        playDropStarAni(cb = null) {
            this.colorMatrix[0] = 1;
            this.colorMatrix[6] = 1;
            this.colorMatrix[12] = 1;
            var filter = new Laya.ColorFilter(this.colorMatrix);
            this.boxDanRoot.filters = [filter];
            let tween = Laya.Tween.to(this.colorMatrix, {
                "0": 0,
                "6": 0,
                "12": 0
            }, 300, null, null, 500);
            tween.update = Laya.Handler.create(this, function() {
                filter.setByMatrix(this.colorMatrix);
            }, null, false);
            let tween2 = Laya.Tween.to(this.colorMatrix, {
                "0": 1,
                "6": 1,
                "12": 1
            }, 300, null, null, 800);
            tween2.update = Laya.Handler.create(this, function() {
                filter.setByMatrix(this.colorMatrix);
            }, null, false);
            Laya.Tween.to(this.boxDanRoot, {
                scaleX: 0.9,
                scaleY: 0.9
            }, 300, Laya.Ease.backIn, null, 500);
            Laya.Tween.to(this.boxDanRoot, {
                scaleX: 1,
                scaleY: 1
            }, 300, null, Laya.Handler.create(this, function() {
                cb && cb();
            }), 800);
        }
        playDropDebris() {}
        dropAni(img) {
            img.alpha = Math.random() * 0.5 + 0.5;
            let startY = Laya.stage.height * 2 / 7;
            let endY = (Laya.stage.height * 2 / 5) * Math.random() + Laya.stage.height / 5;
            let startX = Laya.stage.width / 2;
            let endX = (Laya.stage.width * 2 / 7) * Math.random() + Laya.stage.width * 5 / 14;
            img.y = startY;
            img.x = startX;
            img.alpha = 1;
            let startR = Math.random() * 360;
            img.rotation = startR;
            let endR = 40 * Math.random() + startR - 10;
            var that = this;
            Laya.Tween.to(img, {
                alpha: 1,
                y: endY,
                x: endX,
                rotation: endR
            }, 800, Laya.Ease.strongOut, Laya.Handler.create(img, function() {
                Laya.Tween.to(img, {
                    alpha: 0,
                    y: endY + 50
                }, 1000, null, Laya.Handler.create(img, function() {
                    img.alpha = 0;
                }));
            }));
        }
        setPlatformStyle() {
            switch (ConfigManager.platform) {
                case PLATFORM_TYPE.WX:
                    {
                        this.setWXPlatform();
                        break;
                    }
                case PLATFORM_TYPE.QQ:
                    {
                        this.setQQPlatform();
                        break;
                    }
                case PLATFORM_TYPE.WEB:
                    {
                        this.setWXPlatform();
                        break;
                    }
                case PLATFORM_TYPE.WEB_4399:
                    {
                        this.setWeb4399Platform();
                        break;
                    }
                case PLATFORM_TYPE.VIVO:
                    {
                        this.setVIVOPlatform();
                        break;
                    }
                case PLATFORM_TYPE.OPPO:
                    {
                        this.setOPPOPlatform();
                        break;
                    }
                case PLATFORM_TYPE.NATIVE_IOS:
                    {
                        this.setNativeIOSPlatform();
                        break;
                    }
                case PLATFORM_TYPE.NATIVE_ANDRIOD:
                    {
                        this.setNativeAndroidPlatform();
                        break;
                    }
                case PLATFORM_TYPE.TT:
                    {
                        this.setTTPlatform();
                        break;
                    }
            }
        }
        setWXPlatform() {
            if (PlatformUtil.isIOS()) {
                this.boxDanRoot.centerY -= 30;
            }
        }
        setQQPlatform() {}
        setWebPlatform() {}
        setWeb4399Platform() {}
        setVIVOPlatform() {}
        setOPPOPlatform() {}
        setNativeIOSPlatform() {}
        setNativeAndroidPlatform() {}
        setTTPlatform() {}
    }

    class BaseFunction {
        constructor(mode, tag, type, style, args) {
            this._mode = mode;
            this._args = args;
            this._tag = tag;
            this._type = type;
            this.style = style;
        }
        clean() {
            LayaExtend.autoUnlinkUIReference(this._viewCtrl);
            this._viewCtrl = null;
            this._args = null;
        }
        setButtonAnalysePoint(node, tag = null) {
            let labelList = [];
            CommonUtil.getAllChildrenOfClass(node, Laya.Label, labelList);
            if (tag) {} else if (labelList.length > 0) {
                tag = labelList[0].text;
            } else {
                tag = '按钮未设置事件';
            }
            let event = this.getFunctionName() + '按钮事件:' + tag;
            node.on(Laya.Event.MOUSE_UP, null, function() {
                console.log(event);
            });
        }
        get tag() {
            return this._tag;
        }
        get viewCtrl() {
            return this._viewCtrl;
        }
        get mode() {
            return this._mode;
        }
        get args() {
            return this._args;
        }
        get type() {
            return this._type;
        }
        get commonStyle() {
            return this.style;
        }
		onEnter() {
			//console.log("webviewHandle onEnter class="+this._tag+", functionName="+this.getFunctionName());
			window.GameMainActivity.handleInGame(this.getFunctionName(),true);
		}
		onExit() {
			///console.log("webviewHandle onExit class="+this._tag+", functionName="+this.getFunctionName());
			window.GameMainActivity.handleInGame(this.getFunctionName(),false);
		}
        onEnable() {

        }
        onDisbale() {

        }
    }

    class DanAniFunction extends BaseFunction {
        createView() {
            this._viewCtrl = new DanAniViewCtrl(this.args);
            return this._viewCtrl;
        }
        getFunctionName() {
            return '段位动画界面';
        }
        onEnter() { super.onEnter(); }
        onExit() { super.onExit();}
        onEnable() {
            super.onEnable();
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || ConfigManager.platform == PLATFORM_TYPE.WX) {
                AdUtil.showCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                AdUtil.showCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
            }
        }
        onDisbale() {
            super.onDisbale();
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || ConfigManager.platform == PLATFORM_TYPE.WX) {
                AdUtil.hideCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                AdUtil.hideCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
            }
        }
        setAllButtonAnalysePoint() {}
        request(cb) {
            cb();
        }
    }

    class NewGiftViewCtrl extends ui.view.award.NewGiftViewUI {
        constructor(cb = null) {
            super();
            this.list = [
                12, 7, 14, 5
            ];
            this.isDown = false;
            this.cb = null;
            this.width = this.stage.width;
            this.height = this.stage.height;
            this.cb = cb;
            this.btnBack.on(Laya.Event.CLICK, this, this.onBtnBack);
            this.btnCancel.on(Laya.Event.CLICK, this, this.onBtnBack);
            this.btnGet.on(Laya.Event.CLICK, this, this.onBtnGet);
        }
        onAwake() {
            if (ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.TT) {
                this.btnBack.visible = false;
                this.btnCancel.visible = true;
            } else {
                this.btnBack.visible = true;
                this.btnCancel.visible = false;
            }
        }
        onDestroy() {
            if (this.cb)
                this.cb();
        }
        onBtnBack() {
            if (!CommonUtil.getTouch())
                return;
            UIManager.closeFunction();
        }
        onBtnGet() {
            if (!CommonUtil.getTouch())
                return;
            if (this.isDown)
                return;
            this.isDown = true;
            var that = this;
            AdUtil.setEvent(function() {
                that.isDown = false;
                UIManager.closeFunction();
                that.getEggHero();
                RoleManager.getInstance().reciveNewGift();
            }, function() {
                that.isDown = false;
            }, REWARD_CTRL_TYPE.NEW_GIFT);
        }
        getEggHero() {
            let data = this.list.pop();
            if (data) {
                var that = this;
                PeopleFactory.getInstance().getEquip(data, function() {
                    that.getEggHero();
                });
            }
        }
    }

    class NewGiftFunction extends BaseFunction {
        createView() {
            this._viewCtrl = new NewGiftViewCtrl(this._args ? this._args.cb : null);
            return this._viewCtrl;
        }
        getFunctionName() {
            return '新手礼包界面';
        }
        onEnter() { super.onEnter();}
        onExit() { super.onExit();}
        onEnable() {
            super.onEnable();
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || ConfigManager.platform == PLATFORM_TYPE.WX) {
                AdUtil.showCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                AdUtil.showCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
            }
            if (ConfigManager.platform == PLATFORM_TYPE.VIVO || ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS || ConfigManager.appId == ANDROID_APP_ID.XM || ConfigManager.appId == ANDROID_APP_ID.C233_ME || ConfigManager.appId == ANDROID_APP_ID.MMY || ConfigManager.appId == ANDROID_APP_ID.HYKB || ConfigManager.appId == ANDROID_APP_ID.C_233) {
                AdUtil.showBannerAd();
            }
            if (PLATFORM_TYPE.QQ == ConfigManager.platform) {
                AdUtil.showCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                AdUtil.showCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
            }
            if (ConfigManager.platform == PLATFORM_TYPE.WX) {
                AdUtil.showCustom(Laya.stage.width / 2 - PlatformUtil.getCustomSize().w - 525, Laya.stage.height / 2 - PlatformUtil.getCustomSize().h - 84, WX_CUSTOM_AD_STYLE.SINGLE_1);
            }
        }
        onDisbale() {
            super.onDisbale();
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || ConfigManager.platform == PLATFORM_TYPE.WX) {
                AdUtil.hideCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                AdUtil.hideCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
            }
            if (ConfigManager.platform == PLATFORM_TYPE.VIVO || ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS || ConfigManager.appId == ANDROID_APP_ID.XM || ConfigManager.appId == ANDROID_APP_ID.C233_ME || ConfigManager.appId == ANDROID_APP_ID.MMY || ConfigManager.appId == ANDROID_APP_ID.HYKB || ConfigManager.appId == ANDROID_APP_ID.C_233) {
                AdUtil.hideBannerAd();
            }
            if (PLATFORM_TYPE.QQ == ConfigManager.platform) {
                AdUtil.hideCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                AdUtil.hideCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
            }
            if (ConfigManager.platform == PLATFORM_TYPE.WX) {
                AdUtil.hideCustom(Laya.stage.width / 2 - PlatformUtil.getCustomSize().w - 525, Laya.stage.height / 2 - PlatformUtil.getCustomSize().h - 84, WX_CUSTOM_AD_STYLE.SINGLE_1);
            }
        }
        setAllButtonAnalysePoint() {}
        request(cb) {
            cb();
        }
    }

    class SuperEquipViewCtrl extends ui.view.award.SuperEquipViewUI {
        constructor(arg) {
            super();
            this.isDown = false;
            this.isEndOpen = false;
            this.width = this.stage.width;
            this.height = this.stage.height;
            this.superEquipId = arg.id;
            this.isEndOpen = arg.isEndOpen ? arg.isEndOpen : false;
            this.adCtrl();
            this.btnBack.on(Laya.Event.CLICK, this, this.onBtnBack);
            this.btnBack1.on(Laya.Event.CLICK, this, this.onBtnBack);
            this.btnCancel.on(Laya.Event.CLICK, this, this.onBtnBack);
            this.btnCancel1.on(Laya.Event.CLICK, this, this.onBtnBack);
            this.btnGet.on(Laya.Event.CLICK, this, this.onBtnGet);
            this.btnGet1.on(Laya.Event.CLICK, this, this.onBtnGet);
            this.box1.visible = false;
            this.box0.visible = false;
            if (this.superEquipId == SPECIAL_ID.RED_TASSEL_EQUIP) {
                this.box0.visible = true;
            } else {
                if (this.superEquipId == SPECIAL_ID.RED_SPIRIT_EQUIP) {
                    this.box1.visible = true;
                }
            }
            var that = this;
            if (this.isEndOpen) {
                OVAdManager.adDown();
            }
            if (!ConfigManager.getViolenceCtrl() && ConfigManager.platform == PLATFORM_TYPE.WEB_4399) {
                let str = this.imgName.skin;
                str = str.replace(".png", "_4399.png");
                this.imgName.skin = str;
            }
            if (ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.TT) {
                this.btnGet.centerX = -this.btnCancel.centerX;
                this.btnGet1.x = 907;
                this.btnCancel.visible = true;
                this.btnCancel1.visible = true;
                this.btnBack.visible = false;
                this.btnBack1.visible = false;
            } else {
                this.btnCancel.visible = false;
                this.btnCancel1.visible = false;
            }
            if (ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.TT) {
                if (ConfigManager.isReviewVersion()) {
                    this.imgRole.visible = false;
                }
            }
        }
        adCtrl() {
            let that = this;
            OVAdManager.register(function() {
                console.log('oppoSuperEquip广告关闭');
                that.isDown = false;
                let id = that.superEquipId;
                UIManager.closeFunction();
                PeopleFactory.getInstance().getEquip(id);
            });
        }
        onAwake() {}
        onDestroy() {
            OVAdManager.unregisterByFuncId();
        }
        onBtnBack() {
            if (!CommonUtil.getTouch())
                return;
            if (ConfigManager.platform == PLATFORM_TYPE.OPPO || ConfigManager.platform == PLATFORM_TYPE.WEB) {
                if (this.isEndOpen) {
                    console.log('结算关闭');
                    OVAdManager.execute(function() {
                        console.log('进入超级武器结算正常回调');
                        if (UIManager.getFunction(FUNCTION_TAG.SUPER_EQUIP))
                            UIManager.closeFunction();
                    }, true, true);
                } else {
                    UIManager.closeFunction();
                }
            } else {
                UIManager.closeFunction();
            }
        }
        onBtnGet() {
            if (!CommonUtil.getTouch())
                return;
            if (this.isDown)
                return;
            this.isDown = true;
            var that = this;
            AdUtil.setEvent(function() {
                that.isDown = false;
                let id = that.superEquipId;
                UIManager.closeFunction();
                PeopleFactory.getInstance().getEquip(id);
            }, function() {
                that.isDown = false;
            }, REWARD_CTRL_TYPE.SUPER_EQUIP);
        }
        onMyEnable() {
            if ((ConfigManager.platform == PLATFORM_TYPE.VIVO || ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS || ConfigManager.appId == ANDROID_APP_ID.C233_ME || ConfigManager.appId == ANDROID_APP_ID.MMY || ConfigManager.appId == ANDROID_APP_ID.HYKB) || ConfigManager.appId == ANDROID_APP_ID.C_233) {
                if (this.box0.visible) {
                    AdUtil.showBannerAd();
                } else {}
            }
        }
        onMyDisable() {
            AdUtil.hideBannerAd();
        }
    }

    class SuperEquipFunction extends BaseFunction {
        createView() {
            this._viewCtrl = new SuperEquipViewCtrl(this._args);
            return this._viewCtrl;
        }
        getFunctionName() {
            return '超级武器界面';
        }
        onEnter() { super.onEnter(); }
        onExit() { super.onExit(); }
        onEnable() {
            super.onEnable();
            let view = this._viewCtrl;
            view.onMyEnable();
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || ConfigManager.platform == PLATFORM_TYPE.WX) {
                AdUtil.showCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
            }
        }
        onDisbale() {
            super.onDisbale();
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || ConfigManager.platform == PLATFORM_TYPE.WX) {
                AdUtil.hideCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
            }
            let view = this._viewCtrl;
            view.onMyDisable();
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || ConfigManager.platform == PLATFORM_TYPE.WX) {
                AdUtil.hideCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
            }
        }
        setAllButtonAnalysePoint() {}
        request(cb) {
            cb();
        }
    }

    class AddDiamondsViewCtrl extends ui.view.diamonds.AddDiamondsViewUI {
        constructor(type) {
            super();
            this.type = 0;
            this.reward = 20;
            this.height = this.stage.height;
            this.width = this.stage.width;
            this.type = type;
            this.name = 'AddDiamondsViewCtrl';
        }
        onAwake() {
            this.uiPlatformConfig();
            this.init();
            this.setEvent();
        }
        onDestroy() {
            this.type = null;
            this.reward = null;
            this.btnClose = null;
            this.btnGold = null;
            this.ani1 = null;
        }
        init() {
            this.ani1.play(0, true);
            RewardManager.setfreeDiamondsRewards();
            RewardManager.setRewardForInsufficientDiamonds();
            if (this.type == 1) {
                this.labelTag.text = '钻石不足!';
                this.labelTag.color = '#FF0C00';
                this.reward = RewardManager.curLackDiamondsRewards;
            } else {
                this.reward = RewardManager.curFreeDiamondsRewards;
            }
            if (this.reward == 0) {
                this.reward = 10;
            }
            this.txtGold.text = '钻石x' + StringUtil.parseGold(this.reward.toString());
        }
        setEvent() {
            this.btnGold.on(Laya.Event.CLICK, this, this.onBtnGold);
            this.btnClose.on(Laya.Event.CLICK, this, this.onBtnClose);
            this.btnNo.on(Laya.Event.CLICK, this, this.onBtnClose);
        }
        onBtnGold() {
            if (!CommonUtil.getTouch())
                return;
            let that = this;
            AdUtil.setEvent(function() {
                if (that.type == 1) {
                    RewardManager.reduceLackDiamondsMultiple();
                }
                UIManager.openFunction(FUNCTION_TAG.GET_DIAMONDS_REWARD, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.DIAMOND, {
                    reward: that.reward,
                    cb: null
                });
            }, function() {}, REWARD_CTRL_TYPE.DIAMOND_REWARD);
        }
        onBtnClose() {
            if (!CommonUtil.getTouch())
                return;
            UIManager.closeFunction();
        }
        uiPlatformConfig() {
            UIManager.replaceAdIcon([{
                img: this.btnGold.getChildAt(0),
                type: 1
            }]);
            if (ConfigManager.platform == PLATFORM_TYPE.TT) {
                this.btnGold.centerX = -this.btnNo.centerX;
                this.btnNo.visible = true;
            }
        }
    }

    class AddDiamondsFunction extends BaseFunction {
        createView() {
            this._viewCtrl = new AddDiamondsViewCtrl(this.args);
            return this._viewCtrl;
        }
        getFunctionName() {
            return '钻石补充界面';
        }
        onEnter() {
            super.onEnter();
            if (ConfigManager.platform == PLATFORM_TYPE.OPPO || ConfigManager.platform == PLATFORM_TYPE.WEB) {
                this.nativeBanner = new NativeBanner2ViewCtrl();
                let view = this._viewCtrl;
                view.addChild(this.nativeBanner);
                this.nativeIcon1 = new NativeIcon1CellCtrl();
                view.addChild(this.nativeIcon1);
                this.nativeIcon2 = new NativeIcon1CellCtrl();
                view.addChild(this.nativeIcon2);
                this.nativeIcon1.x = Laya.stage.width / 2 - 550;
                this.nativeIcon2.x = Laya.stage.width / 2 + 400;
                this.nativeIcon1.bottom = 30;
                this.nativeIcon2.bottom = 30;
            }
        }
        onExit() { super.onExit();}
        onEnable() {
            super.onEnable();
            let view = this._viewCtrl;
            ///view.onMyEnable();
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || ConfigManager.platform == PLATFORM_TYPE.WX) {
                AdUtil.showCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
            }
            AdUtil.showBannerAd();
            this.nativeBanner && this.nativeBanner.show();
            this.nativeIcon1 && this.nativeIcon1.show();
            this.nativeIcon2 && this.nativeIcon2.show();
            GameScene.synthesisViewCtrl.nativeIcon1 && GameScene.synthesisViewCtrl.nativeIcon1.hide();
            GameScene.synthesisViewCtrl.nativeIcon2 && GameScene.synthesisViewCtrl.nativeIcon2.hide();
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || PLATFORM_TYPE.WX == ConfigManager.platform || PLATFORM_TYPE.NATIVE_ANDRIOD == ConfigManager.platform) {
                let x = PlatformUtil.getBannerCenterPos().x + PlatformUtil.getBannerWeight() + 30;
                let y = Laya.stage.height - PlatformUtil.getCustomSize().h;
                let x1 = PlatformUtil.getBannerCenterPos().x - PlatformUtil.getCustomSize().w - 30;
                if (ConfigManager.platform == PLATFORM_TYPE.WX) {
                    AdUtil.showCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                    AdUtil.showCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                } else {
                    AdUtil.showCustom(x, y);
                    AdUtil.showCustom(x1, y);
                }
            }
        }
        onDisbale() {
            super.onDisbale();
            AdUtil.hideBannerAd();
            this.nativeBanner && this.nativeBanner.hide();
            this.nativeIcon1 && this.nativeIcon1.hide();
            this.nativeIcon2 && this.nativeIcon2.hide();
            GameScene.synthesisViewCtrl.nativeIcon1 && GameScene.synthesisViewCtrl.nativeIcon1.show();
            GameScene.synthesisViewCtrl.nativeIcon2 && GameScene.synthesisViewCtrl.nativeIcon2.show();
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || PLATFORM_TYPE.WX == ConfigManager.platform || PLATFORM_TYPE.NATIVE_ANDRIOD == ConfigManager.platform) {
                let x = PlatformUtil.getBannerCenterPos().x + PlatformUtil.getBannerWeight() + 30;
                let y = Laya.stage.height - PlatformUtil.getCustomSize().h;
                let x1 = PlatformUtil.getBannerCenterPos().x - PlatformUtil.getCustomSize().w - 30;
                if (ConfigManager.platform == PLATFORM_TYPE.WX) {
                    AdUtil.hideCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                    AdUtil.hideCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                } else {
                    AdUtil.hideCustom(x, y);
                    AdUtil.hideCustom(x1, y);
                }
            }
        }
        setAllButtonAnalysePoint() {}
        request(cb) {
            cb();
        }
    }

    class EndItemCtrl extends ui.view.end.EndItemUI {
        constructor(data, index) {
            super();
            this.data = null;
            this.index = 0;
            this.isActive = false;
            this.random = 0;
            this.num = 0;
            this.data = data;
            this.index = index;
            this.btnSend.on(Laya.Event.CLICK, this, this.onBtnSend);
            this.btnGood.on(Laya.Event.CLICK, this, this.onBtnGood);
            this.setView();
        }
        onDestroy() {
            this.timer.clearAll(this);
            this.data = null;
            this.index = null;
            this.imgFist = null;
            this.imgHead = null;
            this.imgPlayerBg = null;
            this.txtBeBeat = null;
            this.txtBeat = null;
            this.txtName = null;
            this.txtScore = null;
        }
        setGood() {
            this.ani1.play(0, false);
            this.txtGoodNum.text = this.num.toString();
            if (this.num == 0) {
                this.txtGoodNum.visible = false;
                this.imgGood.skin = 'sub1/ui/end/img_25.png';
            } else {
                this.txtGoodNum.visible = true;
                this.imgGood.skin = 'sub1/ui/end/img_24.png';
            }
        }
        passiveGood() {
            this.random = RandomUtil.onlyOneRandomInt(2, 7);
            let randTime = RandomUtil.onlyOneRandomInt(400, 1200);
            if (this.data.playerKillCount - this.data.playerBeKillCount < -4) {
                return;
            }
            let that = this;
            let cb = function() {
                if (that.random != 0) {
                    that.num++;
                    that.setGood();
                    let randTime1 = RandomUtil.onlyOneRandomInt(400, 1200);
                    that.timer.once(randTime1, that, cb);
                } else {
                    return;
                }
                this.random--;
            };
            this.timer.once(randTime, this, cb);
        }
        onBtnGood() {
            if (!this.isActive) {
                this.isActive = true;
                this.num++;
                this.setGood();
            }
        }
        onBtnSend() {
            LogManager.showNotificationClick('已发送申请');
        }
        setView() {
            this.imgFist.visible = false;
            if (this.data) {
                this.imgPlayerBg.visible = false;
                this.txtName.text = this.data.gameName;
                this.txtBeat.text = this.data.playerKillCount.toString();
                this.txtBeBeat.text = this.data.playerBeKillCount.toString();
                this.txtScore.text = this.data.score.toString();
                if (this.data.maxDoubleKill == 3) {
                    this.imgDouble.skin = RES_PATH.END_UI.DOUBLE_UI.THREE;
                } else if (this.data.maxDoubleKill == 4) {
                    this.imgDouble.skin = RES_PATH.END_UI.DOUBLE_UI.FOUR;
                } else if (this.data.maxDoubleKill == 5) {
                    this.imgDouble.skin = RES_PATH.END_UI.DOUBLE_UI.FIVE;
                } else if (this.data.maxDoubleKill >= 6) {
                    this.imgDouble.skin = RES_PATH.END_UI.DOUBLE_UI.SIX;
                }
                if (this.data.getIsMySelf()) {
                    this.imgPlayerBg.visible = true;
                    this.btnSend.visible = false;
                    let userInfo = RoleManager.getInstance().getPlatfromUserInfo();
                    if (userInfo) {
                        this.txtName.text = userInfo.nickName;
                        this.imgHead.skin = userInfo.avatarUrl;
                    }
                    if (ConfigManager.platform == PLATFORM_TYPE.WEB_4399) {
                        this.imgHead.skin = this.data.head;
                    }
                } else {
                    this.imgHead.skin = this.data.head;
                }
                if (this.index == 0) {
                    this.imgFist.visible = true;
                    if (CharacterManger._isWin) {
                        if (this.data.getRoleType() == ROLE_TYPE.TYPE_0) {
                            this.imgFist.skin = RES_PATH.END_UI.MVP_UI.FIRST;
                        } else {
                            this.imgFist.skin = RES_PATH.END_UI.MVP_UI.SECOND;
                        }
                    } else {
                        if (this.data.getRoleType() == ROLE_TYPE.TYPE_0) {
                            this.imgFist.skin = RES_PATH.END_UI.MVP_UI.SECOND;
                        } else {
                            this.imgFist.skin = RES_PATH.END_UI.MVP_UI.FIRST;
                        }
                    }
                }
            }
        }
    }

    class EndViewCtrl extends ui.view.end.EndViewUI {
        constructor() {
            super();
            this.weCellList = [];
            this.enemyCellList = [];
            this.rewardGold = 200;
            this.rewardExp = 100;
            this.rewardDiamonds = 10;
            this.myScore = 0;
            this.isDown = false;
            this.height = Laya.stage.height;
            this.width = Laya.stage.width;
            if (!PlatformUtil.isFullScreen()) {
                this.boxMain.scaleX = 0.9;
            }
        }
        onAwake() {
            this.init();
            this.setBtnEvent();
            if (ConfigManager.platform != PLATFORM_TYPE.WX && ConfigManager.platform != PLATFORM_TYPE.QQ) {
                this.btnShare.visible = false;
            }
        }
        onDestroy() {
            this.weCellList = null;
            this.enemyCellList = null;
            this.rewardGold = null;
            this.rewardExp = null;
            this.txtEnemyScore = null;
            this.txtRewardExp = null;
            this.txtRewardGold = null;
            this.txtWeScore = null;
            NotifyManager.unregisterByEventId(NOTIFY_ID.REFRESH_AI_GOOD);
        }
        init() {
            RoleManager.getInstance().updateOnceGame(1);
            GameScene.gameNum++;
            if (RoleManager.getInstance().getGuide() == GuideStep.GAME_1 || RoleManager.getInstance().getGuide() == GuideStep.GAME_2 || RoleManager.getInstance().getGuide() == GuideStep.GAME_3 || RoleManager.getInstance().getGuide() == GuideStep.GAME_4 || RoleManager.getInstance().getGuide() == GuideStep.GAME_5 || RoleManager.getInstance().getGuide() == GuideStep.GAME_6 || RoleManager.getInstance().getGuide() == GuideStep.FUNGAME_1 || RoleManager.getInstance().getGuide() == GuideStep.FUNGAME_2 || RoleManager.getInstance().getGuide() == GuideStep.SHMODEGAME_1) {
                RoleManager.getInstance().setGuide();
            }
            GameScene.isOpenOverView = false;
            let weList = [];
            let eList = [];
            if (ModeManager.mode != GAME_MODE_TYPE.BIOCHEMISTRY) {
                CharacterManger.updateWeScore();
                CharacterManger.updateEnemyScore();
                let ourKillScore = CharacterManger.ourKillScore <= TaskManager.targetKillSore ? CharacterManger.ourKillScore : TaskManager.targetKillSore;
                this.txtWeScore.text = ourKillScore.toString();
                let enemyKillScore = CharacterManger.enemyKillScore <= TaskManager.targetKillSore ? CharacterManger.enemyKillScore : TaskManager.targetKillSore;
                this.txtEnemyScore.text = enemyKillScore.toString();
            }
            this.btnBack.visible = false;
            this.btnShare.visible = false;
            if (ModeManager.mode != GAME_MODE_TYPE.BIOCHEMISTRY) {
                for (let k = 0; k < CharacterManger.logicalBaseLayer.length; k++) {
                    let item = CharacterManger.logicalBaseLayer[k];
                    if (item.getIsMySelf()) {
                        this.myScore = item.score;
                    }
                    if (item.getRoleType() == ROLE_TYPE.TYPE_0) {
                        weList.push(item);
                    } else {
                        eList.push(item);
                    }
                }
                let newWeList = this.sort(weList);
                let newEList = this.sort(eList);
                for (let k = 0; k < 4; k++) {
                    let item = new EndItemCtrl(newWeList[k], k);
                    item.y = k * 106.5;
                    this.boxWe.addChild(item);
                    this.weCellList.push(item);
                }
                for (let k = 0; k < 4; k++) {
                    let item = new EndItemCtrl(newEList[k], k);
                    item.y = k * 106.5;
                    this.boxEnemy.addChild(item);
                    this.enemyCellList.push(item);
                }
            }
            if (CharacterManger._isWin) {
                this.btnBack.visible = true;
                this.btnShare.visible = false;
                this.rewardGold = 50 * (this.myScore + 2);
                this.rewardExp = 8 * (this.myScore + 2);
                RewardManager.setSettlementWinDiamondsRewards();
                RewardManager.setSettlementWinGoldsRewards();
                this.rewardGold = RewardManager.settlementWinGoldsRewards;
                this.rewardDiamonds = RewardManager.settlementWinDiamondsRewards;
            } else {
                this.labelLog.text = '团队失败';
                this.rewardGold = 50 * (this.myScore + 2);
                this.rewardExp = 8 * (this.myScore + 2);
                this.btnBack.visible = true;
                this.btnShare.visible = false;
                this.btnBack.skin = 'sub1/ui/scale9/img_normal_2.png';
                RewardManager.setSettlementFailDiamondsRewards();
                RewardManager.setSettlementFailGoldsRewards();
                this.rewardGold = RewardManager.settlementFailGoldsRewards;
                this.rewardDiamonds = RewardManager.settlementFailDiamondsRewards;
            }
            this.txtRewardGold.text = this.rewardGold.toString();
            this.txtRewardExp.text = this.rewardExp.toString();
            NotifyManager.register(NOTIFY_ID.REFRESH_AI_GOOD, this.aiShowGood, this);
        }
        aiShowGood() {
            if (!this.weCellList)
                return;
            if (!this.enemyCellList)
                return;
            for (let k = 0; k < this.weCellList.length; k++) {
                let item = this.weCellList[k];
                item.passiveGood();
            }
            for (let k = 0; k < this.enemyCellList.length; k++) {
                let item = this.enemyCellList[k];
                item.passiveGood();
            }
        }
        sort(logicList) {
            var oValue;
            for (var i = 0, len = logicList.length; i < len; i++) {
                for (var j = 0; j <= i; j++) {
                    if (logicList[i].score > logicList[j].score) {
                        oValue = logicList[i];
                        logicList[i] = logicList[j];
                        logicList[j] = oValue;
                    }
                }
            }
            return logicList;
        }
        setBtnEvent() {
            this.btnBack.on(Laya.Event.CLICK, this, function() {
                if (!CommonUtil.getTouch())
                    return;
                UIManager.clean();
                SceneManager.getCurScene().setGameState(GAME_STATE.MENU);
            });
            this.btnShare.on(Laya.Event.CLICK, this, function() {
                if (!CommonUtil.getTouch())
                    return;
                AdUtil.shareMessage();
            });
            if (CharacterManger._isWin) {}
        }
    }

    class EndFunction extends BaseFunction {
        createView() {
            this._viewCtrl = new EndViewCtrl();
            return this._viewCtrl;
        }
        getFunctionName() {
            return '结束界面';
        }
        onEnter() { super.onEnter(); }
        onExit() { super.onExit(); }
        onEnable() {
            super.onEnable();
            this._viewCtrl.init();
            AdUtil.showBannerAd();
            if (ConfigManager.platform == PLATFORM_TYPE.WX && PlatformUtil.isFullScreen()) {
                AdUtil.showCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                AdUtil.showCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
            }
        }
        onDisbale() {
            super.onDisbale();
            AdUtil.hideBannerAd();
            if (ConfigManager.platform == PLATFORM_TYPE.WX && PlatformUtil.isFullScreen()) {
                AdUtil.hideCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                AdUtil.hideCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
            }
        }
        setAllButtonAnalysePoint() {}
        request(cb) {
            cb();
        }
    }

    let imgBgUrl = ['sub1/ui/end/img_13.png', 'sub1/ui/end/img_14.png'];
    let imgIconUrl = ['sub1/ui/end/img_20.png', 'sub1/ui/end/img_21.png'];
    class EndRecreationViewCtrl extends ui.view.end.EndRecreationViewUI {
        constructor() {
            super();
            this.cost = 0;
            this.scene3D = null;
            this._translate2 = new Laya.Vector3(5, -10, 1);
            this._translate = new Laya.Vector3(0, 0, 0);
            this.sp = null;
            this._pos = new Laya.Vector3(310, 500, 0);
            this.height = this.stage.height;
            this.width = this.stage.width;
        }
        onAwake() {
            this.init();
            this.setBtnEvent();
        }
        onDestroy() {}
        init() {
            RoleManager.getInstance().updateOnceGame(1);
            GameScene.gameNum++;
            if (RoleManager.getInstance().getGuide() == GuideStep.GAME_1 || RoleManager.getInstance().getGuide() == GuideStep.GAME_2 || RoleManager.getInstance().getGuide() == GuideStep.GAME_3 || RoleManager.getInstance().getGuide() == GuideStep.GAME_4 || RoleManager.getInstance().getGuide() == GuideStep.GAME_5 || RoleManager.getInstance().getGuide() == GuideStep.GAME_6 || RoleManager.getInstance().getGuide() == GuideStep.FUNGAME_1 || RoleManager.getInstance().getGuide() == GuideStep.FUNGAME_2 || RoleManager.getInstance().getGuide() == GuideStep.SHMODEGAME_1) {
                RoleManager.getInstance().setGuide();
            }
            GameScene.isOpenOverView = false;
            this.imgWin.visible = false;
            this.imgLogBgWin.visible = false;
            this.imgLose.visible = false;
            this.imgLogBgLose.visible = false;
            this.btnBack.visible = true;
            this.boxWin.visible = false;
            this.boxLose.visible = false;
            if (CharacterManger._isWin) {
                this.boxWin.visible = true;
                this.btnBack.skin = 'sub1/ui/scale9/img_normal_1.png';
                this.imgWin.visible = true;
                this.imgLogBgWin.visible = true;
                RewardManager.setSettlementWinDiamondsRewards();
                RewardManager.setSettlementWinGoldsRewards();
            } else {
                this.btnBack.skin = 'sub1/ui/scale9/img_normal_2.png';
                this.imgLose.visible = true;
                this.boxLose.visible = true;
                this.imgLogBgLose.visible = true;
                RewardManager.setSettlementFailDiamondsRewards();
                RewardManager.setSettlementFailGoldsRewards();
            }
            this.labelInfo.text = TaskManager.taskEntry();
            this.boxTagBg.width = this.boxInfo.x + this.boxInfo.width;
        }
        setBtnEvent() {
            var that = this;
            Laya.timer.once(1000, this, function() {
                that.btnBack.on(Laya.Event.CLICK, that, that.onBtnBack);
            });
        }
        onBtnShare() {
            AdUtil.shareMessage();
        }
        onBtnBack() {
            if (!CommonUtil.getTouch())
                return;
            SceneManager.getCurScene().cleanMenu();
            UIManager.clean();
            if (ConfigManager.appId == ANDROID_APP_ID.XM)
                AdUtil.createInterstitialAd();
            SceneManager.getCurScene().setGameState(GAME_STATE.MENU);
        }
        create3D() {
            var scene = this.addChild(new Laya.Scene3D());
            var camera = scene.addChild(new Laya.Camera(0, 0.1, 1000));
            this.scene3D = scene;
            camera.transform.translate(this._translate2);
            camera.orthographic = false;
            camera.enableHDR = false;
            camera.clearColor = new Laya.Vector4(0.0, 0.0, 0.0, 0.0);
            var renderTexture = new Laya.RenderTexture(512, 512, Laya.RenderTextureFormat.R8G8B8A8, Laya.RenderTextureDepthFormat.DEPTH_16);
            camera.renderTarget = renderTexture;
            camera.orthographicVerticalSize = 10;
            scene.addChild(new Laya.DirectionLight());
            camera.convertScreenCoordToOrthographicCoord(this._pos, this._translate);
            this._translate.x += 3;
            this._translate.y -= 2;
            camera.transform.localPositionX = 0;
            camera.transform.localPositionY = 0;
            camera.transform.localPositionZ = 3;
            this.img3DCenter.source = new Laya.Texture(renderTexture);
        }
        showModel(id) {
            console.log('传入人物ID：', id);
            if (this.sp) {
                this.sp.destroy();
                this.sp = null;
            }
            this.sp = SkinManager.createRoleViewSkin(this._translate, this.scene3D, false, id);
            this.sp.transform.localRotationEulerY = 20;
            this.sp.transform.localScaleX = 1;
            this.sp.transform.localScaleY = 1;
            this.sp.transform.localScaleZ = 1;
            this.sp.transform.localPositionX = 0;
            this.sp.transform.localPositionY = -1;
            this.sp.transform.localPositionZ = 0;
            let obj = SkinManager.createMenuArm(RoleManager.getInstance().getSelectSkin(), this.sp);
            obj.transform.localScaleX = 1;
            obj.transform.localScaleY = 1;
            obj.transform.localScaleZ = 1;
            SkinManager.createPartsByLocal(this.sp, new Laya.Vector3(1, 1, 1));
        }
        showPartsModel(id, decorate = null) {
            console.log('传入部件ID：', id);
            let obj = SkinManager.createParts(id, this.sp, new Laya.Vector3(1, 1, 1), decorate);
        }
        onMyEnable() {
            SceneManager.getCurScene().createMenu(3, this.box3d);
            this.ani1.play(0, false);
        }
    }

    class ReviewEndRecreationViewCtrl extends ui.view.review.ReviewEndRecreationViewUI {
        constructor() {
            super();
            this.rewardGold = 200;
            this.rewardExp = 100;
            this.goldReward = 0;
            this.diamondsReward = 0;
            this.height = this.stage.height;
            this.width = this.stage.width;
            this.boxBg.scaleX = this.stage.width / this.boxBg.width;
        }
        onAwake() {
            this.init();
            this.setBtnEvent();
            if (ConfigManager.platform != PLATFORM_TYPE.WX && ConfigManager.platform != PLATFORM_TYPE.QQ) {
                this.btnShare.visible = false;
            }
        }
        onDestroy() {
            this.rewardGold = null;
            this.rewardExp = null;
        }
        init() {
            RoleManager.getInstance().updateOnceGame(1);
            GameScene.gameNum++;
            if (RoleManager.getInstance().getGuide() == GuideStep.GAME_1 || RoleManager.getInstance().getGuide() == GuideStep.GAME_2 || RoleManager.getInstance().getGuide() == GuideStep.GAME_3 || RoleManager.getInstance().getGuide() == GuideStep.GAME_4 || RoleManager.getInstance().getGuide() == GuideStep.GAME_5 || RoleManager.getInstance().getGuide() == GuideStep.GAME_6 || RoleManager.getInstance().getGuide() == GuideStep.FUNGAME_1 || RoleManager.getInstance().getGuide() == GuideStep.FUNGAME_2 || RoleManager.getInstance().getGuide() == GuideStep.SHMODEGAME_1) {
                RoleManager.getInstance().setGuide();
            }
            GameScene.isOpenOverView = false;
            this.imgWin.visible = false;
            this.imgLogBgWin.visible = false;
            this.imgLose.visible = false;
            this.imgLogBgLose.visible = false;
            this.btnShare.visible = false;
            this.btnBack.visible = true;
            this.boxWin.visible = false;
            this.boxLose.visible = false;
            if (CharacterManger._isWin) {
                this.boxWin.visible = true;
                this.btnBack.skin = 'sub1/ui/scale9/img_normal_1.png';
                this.imgBack.skin = 'sub1/ui/end/img_22.png';
                this.imgWin.visible = true;
                this.imgLogBgWin.visible = true;
                if (ConfigManager.platform == PLATFORM_TYPE.WX) {
                    this.btnShare.visible = false;
                }
                RewardManager.setSettlementWinDiamondsRewards();
                RewardManager.setSettlementWinGoldsRewards();
                this.goldReward = RewardManager.settlementWinGoldsRewards;
                this.diamondsReward = RewardManager.settlementWinDiamondsRewards;
            } else {
                this.btnBack.skin = 'sub1/ui/scale9/img_normal_2.png';
                this.imgBack.skin = 'sub1/ui/end/img_35.png';
                this.imgLose.visible = true;
                this.boxLose.visible = true;
                this.imgLogBgLose.visible = true;
                RewardManager.setSettlementFailDiamondsRewards();
                RewardManager.setSettlementFailGoldsRewards();
                this.goldReward = RewardManager.settlementFailGoldsRewards;
                this.diamondsReward = RewardManager.settlementFailDiamondsRewards;
            }
            this.labelInfo.text = TaskManager.taskEntry();
            this.boxTagBg.width = this.boxInfo.x + this.boxInfo.width;
        }
        setBtnEvent() {
            var that = this;
            Laya.timer.once(1000, this, function() {
                that.btnBack.on(Laya.Event.CLICK, that, that.onBtnBack);
                that.btnShare.on(Laya.Event.CLICK, that, that.onBtnShare);
            });
            if (ConfigManager.platform == PLATFORM_TYPE.TT) {
                that.btnShare.visible = false;
            }
        }
        onBtnShare() {
            AdUtil.shareMessage();
        }
        onBtnBack() {
            if (!CommonUtil.getTouch())
                return;
            UIManager.clean();
            if (ConfigManager.appId == ANDROID_APP_ID.XM)
                AdUtil.createInterstitialAd();
            SceneManager.getCurScene().setGameState(GAME_STATE.MENU);
        }
    }

    class EndRecreationFunction extends BaseFunction {
        createView() {
            if (ConfigManager.isReviewVersion() && ConfigManager.gameType == GAME_MJB_TYPE.QZHXJY) {
                this._viewCtrl = new ReviewEndRecreationViewCtrl();
            } else {
                this._viewCtrl = new EndRecreationViewCtrl();
            }
            return this._viewCtrl;
        }
        getFunctionName() {
            return '娱乐模式结束界面';
        }
        onEnter() {
            super.onEnter();
            if (ConfigManager.platform == PLATFORM_TYPE.OPPO || ConfigManager.platform == PLATFORM_TYPE.WEB) {
                this.nativeBanner = new NativeBanner2ViewCtrl();
                let view = this._viewCtrl;
                view.addChild(this.nativeBanner);
                if (!CharacterManger._isWin) {
                    this.nativeIcon1 = new NativeIcon1CellCtrl();
                    view.boxAll.addChild(this.nativeIcon1);
                    this.nativeIcon2 = new NativeIcon1CellCtrl();
                    view.boxAll.addChild(this.nativeIcon2);
                    this.nativeIcon1.x = 80;
                    this.nativeIcon2.x = 1190;
                    this.nativeIcon1.y = 252;
                    this.nativeIcon2.y = 252;
                }
            }
        }
        onExit() { super.onExit(); }
        onEnable() {
            super.onEnable();
            AdUtil.showBannerAd();
            this.nativeBanner && this.nativeBanner.show();
            this.nativeIcon1 && this.nativeIcon1.show();
            this.nativeIcon2 && this.nativeIcon2.show();
            let view = this.viewCtrl;
            if (view instanceof EndRecreationViewCtrl) {
                view.onMyEnable();
            }
        }
        onDisbale() {
            super.onDisbale();
            AdUtil.hideBannerAd();
            this.nativeBanner && this.nativeBanner.show();
            this.nativeIcon1 && this.nativeIcon1.hide();
            this.nativeIcon2 && this.nativeIcon2.hide();
        }
        setAllButtonAnalysePoint() {}
        request(cb) {
            cb();
        }
    }

    let LIBRARY_ARM_STATE = {
        EQUIP: 1,
        REMOVE: 2,
    };
    let urlBg = ['sub1/ui/scale9/img_Item_bg_4.png', 'sub1/ui/scale9/img_Item_bg_3.png', 'sub1/ui/scale9/img_Item_bg_2.png', 'sub1/ui/scale9/img_Item_bg_1.png'];
    class EquipLibraryItemCtrl extends ui.view.equip.EquipLibraryItemUI {
        constructor() {
            super();
            this.armAperture = null;
            this.isCheckNoLocal = false;
            this.createArmAperture(this.btnEquip);
            this.btnEquip.on(Laya.Event.CLICK, this, this.onBtnEquip);
            this.btnRemove.on(Laya.Event.CLICK, this, this.onBtnRemove);
            this.on(Laya.Event.CLICK, this, this.onSelect);
            this.imgSelect.visible = false;
        }
        setView() {
            let data = this.dataSource.data;
            console.log('data:', data);
            this.imgIcon.skin = data.icon;
            let str = '';
            if (RoleManager.getInstance().getEquipHaveTime(data.id)) {
                let time = RoleManager.getInstance().getEquipHaveTime(data.id) - RoleManager.getInstance().getTime();
                if (time > 3600 * 24) {
                    console.log('超过一天到期');
                    str = ' (' + Math.floor(time / (3600 * 24)) + '天)';
                } else {
                    if (time > 3600) {
                        console.log('超过一小时到期');
                        str = ' (' + Math.floor(time / 3600) + '小时)';
                    } else {
                        str = ' (' + Math.floor(time / (60)) + '分钟)';
                    }
                }
            }
            this.imgGrade.skin = RES_PATH.GRADE_UI.GRADE_TAB_ROOT + data.grade + '.png';
            this.txtName.text = data.name + str;
            this.imgBg.skin = urlBg[data.grade - 1];
            this.setState();
            let guide = RoleManager.getInstance().getGuide();
            if (GuideManager.curEquiplLibraryStep > guide) {
                guide = GuideManager.curEquiplLibraryStep;
                this.isCheckNoLocal = true;
            }
            if (guide == GuideStep.TOEQUIP) {
                if (this.dataSource.myIndex == 0) {
                    this.armAperture.play(true);
                }
            }
        }
        setState() {
            this.imgEquiped.visible = false;
            this.btnEquip.visible = false;
            this.btnRemove.visible = false;
            if (this.dataSource.state == LIBRARY_ARM_STATE.EQUIP) {
                this.btnEquip.visible = true;
            } else if (this.dataSource.state == LIBRARY_ARM_STATE.REMOVE) {
                this.imgEquiped.visible = true;
                this.btnRemove.visible = true;
            }
            if (this.dataSource.data.type == ARM_TYPE.KNIFE || this.dataSource.data.type == ARM_TYPE.BOMB) {
                this.btnEquip.visible = false;
                this.btnRemove.visible = false;
            }
        }
        createArmAperture(parent) {
            if (!this.armAperture) {
                this.armAperture = GuideManager.createCommonAperture(parent);
                this.armAperture.visible = false;
                this.armAperture.anchorX = .5;
                this.armAperture.anchorY = .5;
                this.armAperture.x = parent.width / 2;
                this.armAperture.y = parent.height / 2;
            }
        }
        onBtnEquip() {
            this.armAperture.stop();
            this.armAperture.visible = false;
            let guide = RoleManager.getInstance().getGuide();
            console.log('当前格子指引：', GuideManager.curEquiplLibraryStep, guide);
            let view = UIManager.getFunctionViewCtrl(FUNCTION_TAG.EQUIP).equipLibraryCtrl;
            if (GuideManager.curEquiplLibraryStep == GuideStep.TOEQUIP || guide == GuideStep.TOEQUIP) {
                if (guide < GuideStep.FINISH && RoleManager.getInstance().isNew) {
                    view.setGuideByCell();
                    UIManager.getFunctionViewCtrl(FUNCTION_TAG.EQUIP).toGuideClose();
                }
            }
            let isArm = true;
            console.log(view.curListInBottom);
            console.log('当前单元格：', view.index);
            if (this.dataSource.data.type == 2 || this.dataSource.data.type == 8) {
                RoleManager.getInstance().updateSkinGameCurPropLib(this.dataSource.data.id);
                isArm = false;
            } else {
                let lastId = null;
                if (view.curListInBottom[view.index]) {
                    lastId = view.curListInBottom[view.index];
                }
                RoleManager.getInstance().updateSkinGameCurLib(this.dataSource.data.id, lastId);
                RoleManager.getInstance().setSelectSkin(this.dataSource.data.id);
            }
            this.dataSource.state = LIBRARY_ARM_STATE.REMOVE;
            this.setView();
            view.updateBottomArm();
            view.btnCtrlRight(this.dataSource.data.id, isArm);
            view.showRoleModel(RoleManager.getInstance().getSelectRoleSkin(), this.dataSource.data.id);
        }
        onBtnRemove() {
            let list = (this.dataSource.data.type == 2 || this.dataSource.data.type == 8) ? RoleManager.getInstance().getGameCurPropLib() : RoleManager.getInstance().getSkinGameCurLib();
            if (list.length == 1) {
                if ((this.dataSource.data.type == 2 || this.dataSource.data.type == 8)) {} else {
                    LogManager.showNotificationClick('至少携带一把主武器');
                    return;
                }
            }
            for (let k = 0; k < list.length; k++) {
                if (list[k] == this.dataSource.data.id) {
                    list.splice(k, 1);
                }
            }
            let isArm = true;
            if (this.dataSource.data.type == 2 || this.dataSource.data.type == 8) {
                RoleManager.getInstance().removeSkinGameCurPropLib(list);
                isArm = false;
            } else {
                RoleManager.getInstance().removeSkinGameCurLib(list);
            }
            this.dataSource.state = LIBRARY_ARM_STATE.EQUIP;
            this.setView();
            let view = UIManager.getFunctionViewCtrl(FUNCTION_TAG.EQUIP).equipLibraryCtrl;
            view.updateBottomArm();
            view.btnCtrlRight(this.dataSource.data.id, isArm);
            view.showRoleModel(RoleManager.getInstance().getSelectRoleSkin());
        }
        onSelect() {
            if (EquipLibraryItemCtrl.preImgSelect) {
                EquipLibraryItemCtrl.preImgSelect.visible = false;
            }
            this.imgSelect.visible = true;
            EquipLibraryItemCtrl.preImgSelect = this.imgSelect;
            let view = UIManager.getFunctionViewCtrl(FUNCTION_TAG.EQUIP).equipLibraryCtrl;
            view.selectEquip(this.dataSource.data.id);
        }
    }

    class PropertybarItemCtrl extends ui.view.equip.PropertybarItemUI {
        constructor(data) {
            super();
            this.data = null;
            this.data = data;
        }
        onAwake() {
            this.init();
        }
        onDestroy() {}
        init() {
            this.txtAttribute.text = this.data.attribute;
            this.txtPro.text = this.data.pro;
            let percent = this.data.pro / this.data.maxPro;
            if (percent > 1)
                percent = 1;
            this.imgPro.width = 100 * this.data.pro / this.data.maxPro;
        }
        update() {}
    }

    let ARM_KIND = {
        RIFLE: 'RIFLE',
        CHARGE: 'CHARGE',
        SNIPER: 'SNIPER',
        SHRAPNEL: 'SHRAPNEL',
        PISTOL: 'PISTOL',
        MACHINE: 'MACHINE',
        OTHER: 'OTHER',
        WAISTDECORATIONS: 'WAISTDECORATIONS',
        WING: 'WING',
    };
    class EquipLibarayViewCtrl extends ui.view.equip.EquipLibarayViewUI {
        constructor() {
            super();
            this.armType = 'RIFLE';
            this.index = 0;
            this.curListInBottom = [];
            this.scene3D = null;
            this._translate2 = new Laya.Vector3(5, -10, 1);
            this._translate = new Laya.Vector3(0, 0, 0);
            this.sp = null;
            this._pos = new Laya.Vector3(310, 500, 0);
            this.rotMouseX = 0;
            this.curRole = null;
            this.isCheckNoLocal = false;
            this.closeAperture = null;
            this.curID = 1;
            this.curTryType = 1;
            this.curBtnType = 1;
            this.myIndex = 1;
            this.isrefresh = false;
            this.isFirstEnable = true;
            this.isMouseDown = false;
            this.cacheList = [];
            this.myArmData = {};
            this.width = this.stage.width;
            this.height = this.stage.height;
        }
        onAwake() {
            let guide = RoleManager.getInstance().getGuide();
            if (GuideManager.curEquiplLibraryStep == 5) {
                GuideManager.curEquiplLibraryStep++;
            }
            if (guide == 5) {
                RoleManager.getInstance().setGuide();
            }
            if (GuideManager.curEquiplLibraryStep == 7) {
                GuideManager.curEquiplLibraryStep = 6;
            }
            if (guide == 7) {
                RoleManager.getInstance().setGuide(6);
            }
            this.init();
            this.setBtnEvent();
            this.setGuide();
        }
        onDestroy() {}
        createArmAperture(parent) {
            if (!this.closeAperture) {
                this.closeAperture = GuideManager.createCommonAperture(parent);
                this.closeAperture.visible = false;
                this.closeAperture.anchorX = .5;
                this.closeAperture.anchorY = .5;
                this.closeAperture.x = parent.width / 2;
                this.closeAperture.y = parent.height / 2;
            }
        }
        setGuide() {
            let guide = RoleManager.getInstance().getGuide();
            if (GuideManager.curEquiplLibraryStep > guide) {
                guide = GuideManager.curEquiplLibraryStep;
                this.isCheckNoLocal = true;
            }
            switch (guide) {
                case GuideStep.CHOOSEARM:
                    if (GuideManager.curEquiplLibraryStep == 6) {
                        GuideManager.curEquiplLibraryStep++;
                    }
                    if (guide == 6) {
                        RoleManager.getInstance().setGuide();
                    }
                    this.setGuide();
                    break;
                case GuideStep.TOEQUIP:
                    console.log('去装备');
                    this.onBtnCharge();
                    break;
            }
        }
        init() {
            let max = RoleManager.getInstance().getSkinGameCurLib()[0];
            for (let k = 0; k < RoleManager.getInstance().getSkinGameCurLib().length; k++) {
                if (max < RoleManager.getInstance().getSkinGameCurLib()[k]) {
                    max = RoleManager.getInstance().getSkinGameCurLib()[k];
                }
            }
            RoleManager.getInstance().setSelectSkin(max);
            this.getArmListType();
            this.setData(this.armType, true);
            this.create3D();
        }
        create3D() {
            var scene = this.addChild(new Laya.Scene3D());
            var camera = scene.addChild(new Laya.Camera(0, 0.1, 1000));
            this.scene3D = scene;
            camera.transform.translate(this._translate2);
            camera.orthographic = true;
            camera.enableHDR = false;
            camera.clearColor = new Laya.Vector4(0.0, 0.0, 0.0, 0.0);
            var renderTexture = new Laya.RenderTexture(1024, 1024, Laya.RenderTextureFormat.R8G8B8A8, Laya.RenderTextureDepthFormat.DEPTH_16);
            camera.renderTarget = renderTexture;
            camera.orthographicVerticalSize = 10;
            scene.addChild(new Laya.DirectionLight());
            camera.convertScreenCoordToOrthographicCoord(this._pos, this._translate);
            this._translate.x += 3;
            this._translate.y -= 2.2;
            this.img3DCenter.source = new Laya.Texture(renderTexture);
            this.showRoleModel(RoleManager.getInstance().getSelectRoleSkin());
            this.showModel(RoleManager.getInstance().getSelectSkin(), 0);
        }
        showRoleModel(id, armID = null) {
            if (this.sp) {
                this.sp.destroy();
                this.sp = null;
            }
            this.sp = SkinManager.createRoleViewSkin(this._translate, this.scene3D, false, id);
            this.sp.transform.localRotationEulerY = 90;
            Laya.Tween.to(this.sp.transform, {
                localRotationEulerY: 20
            }, 300);
            this.sp.transform.localRotationEulerY = 20;
            this.sp.transform.localPositionZ -= 1;
            this.sp.transform.localPositionY += 1.3;
            this.sp.transform.localScaleX = 3;
            this.sp.transform.localScaleY = 3;
            this.sp.transform.localScaleZ = 3;
            let arm = armID ? armID : RoleManager.getInstance().getSelectSkin();
            let obj = SkinManager.createMenuArm(arm, this.sp);
            obj.transform.localScaleX = 1.3;
            obj.transform.localScaleY = 1.3;
            obj.transform.localScaleZ = 1.3;
            SkinManager.createPartsByLocal(this.sp, new Laya.Vector3(1, 1, 1));
        }
        showModel(id, armType) {
            let obj = SkinManager.createMenuArm(id, this.sp, armType);
            obj.transform.localScaleX = 0.9;
            obj.transform.localScaleY = 0.9;
            obj.transform.localScaleZ = 0.9;
        }
        setBtnEvent() {
            this.bottomCtrl();
            this.btnCharge.on(Laya.Event.CLICK, this, this.onBtnCharge);
            this.btnOther.on(Laya.Event.CLICK, this, this.onBtnOther);
            this.btnPistol.on(Laya.Event.CLICK, this, this.onBtnPistol);
            this.btnRifle.on(Laya.Event.CLICK, this, this.onBtnRifle);
            this.btnSniper.on(Laya.Event.CLICK, this, this.onBtnSniper);
            this.btnShrapnel.on(Laya.Event.CLICK, this, this.onBtnShrapnel);
            this.btnMachine.on(Laya.Event.CLICK, this, this.onBtnMachine);
            this.btnTry.on(Laya.Event.CLICK, this, this.onBtnTry);
            this.on(Laya.Event.MOUSE_DOWN, this, this.onBtnMouseDown);
            this.on(Laya.Event.MOUSE_UP, this, this.onBtnMouseUp);
            this.on(Laya.Event.MOUSE_MOVE, this, this.onBtnRot);
        }
        onBtnMouseUp() {
            this.isMouseDown = false;
        }
        onBtnMouseDown(e) {
            this.isMouseDown = true;
            this.rotMouseX = e.stageX;
        }
        onBtnTry() {
            if (!CommonUtil.getTouch())
                return;
            let modelType = this.curTryType;
            let id = this.curID;
            UIManager.openFunction(FUNCTION_TAG.ROLETRY, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.WINDOW, COMMON_MENU_STYLE.HIDE, {
                modelType: modelType,
                id: id
            });
        }
        onBtnRot(e) {
            if (this.isMouseDown)
                if (this.sp) {
                    let fac = e.stageX - this.rotMouseX;
                    this.sp.transform.localRotationEulerY += fac * 0.4;
                    this.rotMouseX = e.stageX;
                }
        }
        bottomCtrl() {
            for (let k = 0; k < this.bottomArm.numChildren; k++) {
                let item = this.bottomArm.getChildAt(k);
                item.on(Laya.Event.CLICK, this, this.onBtnItem);
            }
            this.updateBottomArm();
            let id = RoleManager.getInstance().getUseEquip();
            let k = 0;
            for (let index = 0; index < this.curListInBottom.length; index++) {
                const element = this.curListInBottom[index];
                if (element == id) {
                    k = index;
                }
            }
            this.index = k;
            this.updateBottomArm();
        }
        onBtnItem(e) {
            this.selectId = null;
            if (e.target.name == 'arm1') {
                this.index = 0;
                let id = this.curListInBottom[this.index];
                if (id != -1) {
                    this.btnCtrlRight(id, true);
                    this.showModel(id, 0);
                    RoleManager.getInstance().setSelectSkin(id);
                }
            } else if (e.target.name == 'arm2') {
                this.index = 1;
                let id = this.curListInBottom[this.index];
                if (id != -1) {
                    this.btnCtrlRight(id, true);
                    this.showModel(id, 0);
                    RoleManager.getInstance().setSelectSkin(id);
                }
            } else if (e.target.name == 'other1') {
                this.index = 2;
                let id = this.curListInBottom[this.index];
                if (id != -1) {
                    this.btnCtrlRight(id, false);
                    this.showModel(id, 1);
                }
            } else if (e.target.name == 'other2') {
                this.index = 3;
                let id = this.curListInBottom[this.index];
                if (id != -1) {
                    this.btnCtrlRight(id, false);
                    this.showModel(id, 1);
                }
            }
            this.updateBottomArm();
        }
        btnCtrlRight(id, isArm = true) {
            this.selectId = id;
            if (isArm) {
                if (ARM.getDataByKey(id).type == 1) {
                    this.armType = ARM_KIND.RIFLE;
                } else if (ARM.getDataByKey(id).type == 3) {
                    this.armType = ARM_KIND.SNIPER;
                } else if (ARM.getDataByKey(id).type == 4) {
                    this.armType = ARM_KIND.PISTOL;
                } else if (ARM.getDataByKey(id).type == 5) {
                    this.armType = ARM_KIND.CHARGE;
                } else if (ARM.getDataByKey(id).type == 6) {
                    this.armType = ARM_KIND.MACHINE;
                } else if (ARM.getDataByKey(id).type == 7) {
                    this.armType = ARM_KIND.SHRAPNEL;
                }
            } else {
                this.armType = ARM_KIND.OTHER;
            }
            this.setData(this.armType, false);
        }
        setTryBtn(skin) {
            this.imgType.skin = skin;
        }
        updateBottomArm() {
            this.curListInBottom = [];
            let armGaming = RoleManager.getInstance().getSkinGameCurLib();
            let propGaming = RoleManager.getInstance().getGameCurPropLib();
            for (let k = 0; k < this.bottomArm.numChildren; k++) {
                let item = this.bottomArm.getChildAt(k);
                let imgIcon = item.getChildByName('imgIcon');
                let imgSelect = item.getChildByName('imgSelect');
                imgSelect.visible = false;
                if (k == 0) {
                    imgIcon.skin = ARM.getDataByKey(armGaming[0]).icon;
                    this.curListInBottom.push(ARM.getDataByKey(armGaming[0]).id);
                    imgIcon.scale(0.8, 0.8);
                } else if (k == 1) {
                    if (armGaming.length == 1) {
                        imgIcon.skin = 'sub1/ui/equip/img_eq_lib_1.png';
                        this.curListInBottom.push(-1);
                        imgIcon.scale(1, 1);
                    } else {
                        imgIcon.skin = ARM.getDataByKey(armGaming[1]).icon;
                        this.curListInBottom.push(ARM.getDataByKey(armGaming[1]).id);
                        imgIcon.scale(0.8, 0.8);
                    }
                } else if (k == 2) {
                    let isHas = false;
                    for (let k = 0; k < propGaming.length; k++) {
                        let item = PROP.getDataByKey(propGaming[k]);
                        if (item.type == 2) {
                            imgIcon.skin = item.icon;
                            imgIcon.scale(0.8, 0.8);
                            this.curListInBottom.push(item.id);
                            isHas = true;
                        }
                    }
                    if (!isHas) {
                        this.curListInBottom.push(-1);
                        imgIcon.skin = 'sub1/ui/equip/img_eq_lib_3.png';
                        imgIcon.scale(1, 1);
                    }
                } else if (k == 3) {
                    let isHas = false;
                    for (let k = 0; k < propGaming.length; k++) {
                        let item = PROP.getDataByKey(propGaming[k]);
                        if (item.type == 8) {
                            imgIcon.skin = item.icon;
                            imgIcon.scale(0.8, 0.8);
                            this.curListInBottom.push(item.id);
                            isHas = true;
                        }
                    }
                    if (!isHas) {
                        this.curListInBottom.push(-1);
                        imgIcon.skin = 'sub1/ui/equip/img_eq_lib_2.png';
                        imgIcon.scale(1, 1);
                    }
                }
                if (this.index == k) {
                    imgSelect.visible = true;
                } else {
                    imgSelect.visible = false;
                }
            }
        }
        setData(target = ARM_KIND.RIFLE, isFirst = false) {
            this.armType = target;
            this.rightBtn(target);
            if (target != ARM_KIND.WAISTDECORATIONS && target != ARM_KIND.WING) {
                this.updateData(isFirst);
            }
        }
        rightBtn(target = ARM_KIND.RIFLE) {
            let list = [this.btnRifle, this.btnCharge, this.btnSniper, this.btnShrapnel, this.btnPistol, this.btnMachine, this.btnOther];
            let targets = [ARM_KIND.RIFLE, ARM_KIND.CHARGE, ARM_KIND.SNIPER, ARM_KIND.SHRAPNEL, ARM_KIND.PISTOL, ARM_KIND.MACHINE, ARM_KIND.OTHER];
            for (let k in list) {
                let node = list[k];
                let imgNormal = node.getChildByName('imgNormal');
                let imgSelect = node.getChildByName('imgSelect');
                imgNormal.visible = true;
                imgSelect.visible = false;
                if (targets[k] == target) {
                    imgNormal.visible = false;
                    imgSelect.visible = true;
                }
            }
        }
        updateData(isFirst = false) {
            if (isFirst) {
                let list = this.getList();
                this.armList.itemRender = EquipLibraryItemCtrl;
                this.armList.vScrollBarSkin = '';
                this.armList.dataSource = list;
                this.armList.renderHandler = new Laya.Handler(this, this.updateSkinItem);
            } else {
                let list = this.getList();
                this.armList.dataSource = list;
                this.armList.refresh();
            }
            if (EquipLibraryItemCtrl.preImgSelect) {
                EquipLibraryItemCtrl.preImgSelect.visible = false;
            }
        }
        updateSkinItem(cell, index) {
            let cellCtrl = cell;
            cellCtrl.setView();
            console.log('this.selectId', this.selectId);
            if (cell.dataSource.data.id == this.selectId) {
                cellCtrl.onSelect();
            }
        }
        getArmListType() {
            let id = RoleManager.getInstance().getSelectSkin();
            this.selectId = id;
            if (ARM.getDataByKey(id).type == 1) {
                this.armType = ARM_KIND.RIFLE;
            } else if (ARM.getDataByKey(id).type == 3) {
                this.armType = ARM_KIND.SNIPER;
            } else if (ARM.getDataByKey(id).type == 4) {
                this.armType = ARM_KIND.PISTOL;
            } else if (ARM.getDataByKey(id).type == 5) {
                this.armType = ARM_KIND.CHARGE;
            } else if (ARM.getDataByKey(id).type == 6) {
                this.armType = ARM_KIND.MACHINE;
            } else if (ARM.getDataByKey(id).type == 7) {
                this.armType = ARM_KIND.SHRAPNEL;
            }
        }
        getList() {
            let list = [];
            let oriList = [];
            let gamingList = (this.armType == ARM_KIND.OTHER) ? RoleManager.getInstance().getGameCurPropLib() : RoleManager.getInstance().getSkinGameCurLib();
            let hasList = (this.armType == ARM_KIND.OTHER) ? RoleManager.getInstance().getPropLib() : RoleManager.getInstance().getSkinLib();
            if (this.armType != ARM_KIND.OTHER) {
                for (let k = 0; k < hasList.length; k++) {
                    let item = hasList[k];
                    if (this.armType == ARM_KIND.RIFLE) {
                        if (ARM.getDataByKey(item).type == 1) {
                            oriList.push(ARM.getDataByKey(item));
                        }
                    } else if (this.armType == ARM_KIND.CHARGE) {
                        if (ARM.getDataByKey(item).type == 5) {
                            oriList.push(ARM.getDataByKey(item));
                        }
                    } else if (this.armType == ARM_KIND.PISTOL) {
                        if (ARM.getDataByKey(item).type == 4) {
                            oriList.push(ARM.getDataByKey(item));
                        }
                    } else if (this.armType == ARM_KIND.SHRAPNEL) {
                        if (ARM.getDataByKey(item).type == 7) {
                            oriList.push(ARM.getDataByKey(item));
                        }
                    } else if (this.armType == ARM_KIND.SNIPER) {
                        if (ARM.getDataByKey(item).type == 3) {
                            oriList.push(ARM.getDataByKey(item));
                        }
                    } else if (this.armType == ARM_KIND.MACHINE) {
                        if (ARM.getDataByKey(item).type == 6) {
                            oriList.push(ARM.getDataByKey(item));
                        }
                    }
                }
            } else {
                for (let k = 0; k < hasList.length; k++) {
                    let item = hasList[k];
                    oriList.push(PROP.getDataByKey(item));
                }
            }
            for (let k = 0; k < oriList.length; k++) {
                let data = {
                    myIndex: k,
                    data: oriList[k],
                    state: LIBRARY_ARM_STATE.EQUIP
                };
                for (let i = 0; i < gamingList.length; i++) {
                    if (oriList[k].id == gamingList[i]) {
                        data.state = LIBRARY_ARM_STATE.REMOVE;
                    }
                }
                list.push(data);
            }
            list = this.pjsort(list);
            return list;
        }
        pjsort(arr) {
            var len = arr.length;
            for (var i = 0; i < len - 1; i++) {
                for (var j = 0; j < len - 1 - i; j++) {
                    if (arr[j].data.grade > arr[j + 1].data.grade) {
                        var temp = arr[j];
                        arr[j] = arr[j + 1];
                        arr[j + 1] = temp;
                    }
                }
            }
            return arr;
        }
        setGuideByCell() {
            for (let k = 0; k < this.armList.dataSource.length; k++) {
                let cell = this.armList.getCell(k);
                if (cell) {
                    if (cell.armAperture) {
                        cell.armAperture.stop();
                        cell.armAperture.visible = false;
                    }
                }
            }
            let guide = RoleManager.getInstance().getGuide();
            if (GuideManager.curEquiplLibraryStep == GuideStep.TOEQUIP) {
                GuideManager.curEquiplLibraryStep++;
            }
            if (guide == GuideStep.TOEQUIP) {
                RoleManager.getInstance().setGuide();
            }
            console.log('开启关闭指引');
            if (this.closeAperture) {
                this.closeAperture.rotation = 60;
                this.closeAperture.play(true);
                GameScene.synthesisViewCtrl && GameScene.synthesisViewCtrl.warehouseAperture && GameScene.synthesisViewCtrl.warehouseAperture.stop();
            }
        }
        pushNewList(targetSkinList, list) {
            for (let k = 0; k < list.length; k++) {
                targetSkinList.push(list[k]);
            }
        }
        onBtnCharge() {
            this.setData(ARM_KIND.CHARGE);
        }
        onBtnOther() {
            if (!CommonUtil.getTouch())
                return;
            this.setData(ARM_KIND.OTHER);
        }
        onBtnPistol() {
            if (!CommonUtil.getTouch())
                return;
            this.setData(ARM_KIND.PISTOL);
        }
        onBtnRifle() {
            if (!CommonUtil.getTouch())
                return;
            this.setData(ARM_KIND.RIFLE);
        }
        onBtnSniper() {
            if (!CommonUtil.getTouch())
                return;
            this.setData(ARM_KIND.SNIPER);
        }
        onBtnShrapnel() {
            if (!CommonUtil.getTouch())
                return;
            this.setData(ARM_KIND.SHRAPNEL);
        }
        onBtnMachine() {
            if (!CommonUtil.getTouch())
                return;
            this.setData(ARM_KIND.MACHINE);
        }
        selectEquip(id) {
            this.selectId = id;
            if (this.armType == ARM_KIND.OTHER) {
                this.showModel(id, 1);
            } else {
                this.showModel(id, 0);
            }
            let data;
            if (this.armType != ARM_KIND.OTHER) {
                this.myArmData.data = RoleManager.getInstance().getArmQualityByID(id);
                data = ARM.getDataByKey(id);
            } else {
                this.myArmData.data = this.notUpdateProp(id);
                data = PROP.getDataByKey(id);
            }
            this.myArmData.name = data.name;
            this.myArmData.type = +data.type;
            this.setLeftData();
        }
        setLeftData() {
            if (this.myArmData) {
                this.cleanCacheList();
                this.txtName.text = this.myArmData.name;
                let type = '';
                if (this.myArmData.type == 1) {
                    type = '(步枪)';
                } else if (this.myArmData.type == 2) {
                    type = '(刀)';
                } else if (this.myArmData.type == 3) {
                    type = '(狙击枪)';
                } else if (this.myArmData.type == 4) {
                    type = '(手枪)';
                } else if (this.myArmData.type == 5) {
                    type = '(冲锋枪)';
                } else if (this.myArmData.type == 6) {
                    type = '(机枪)';
                } else if (this.myArmData.type == 7) {
                    type = '(散弹枪)';
                } else if (this.myArmData.type == 8) {
                    type = '(手榴弹）';
                }
                let data = [];
                if (this.myArmData.type == 1 || this.myArmData.type == 2 || this.myArmData.type == 4 || this.myArmData.type == 5 || this.myArmData.type == 6 || this.myArmData.type == 7 || this.myArmData.type == 8) {
                    data = [{
                            attribute: '火力',
                            pro: this.myArmData.data.fire,
                            maxPro: 250
                        },
                        {
                            attribute: '护甲穿透',
                            pro: this.myArmData.data.pierceThrough,
                            maxPro: 100
                        },
                        {
                            attribute: '射速',
                            pro: this.myArmData.data.firingRate,
                            maxPro: 2000
                        },
                        {
                            attribute: '子弹数',
                            pro: this.myArmData.data.numberOfBullets,
                            maxPro: 100
                        },
                        {
                            attribute: '有效射程',
                            pro: this.myArmData.data.range,
                            maxPro: 100
                        },
                        {
                            attribute: '精准',
                            pro: this.myArmData.data.accurate,
                            maxPro: 400
                        },
                        {
                            attribute: '换弹',
                            pro: this.myArmData.data.ammunitionChange,
                            maxPro: 100
                        },
                        {
                            attribute: '移动速度',
                            pro: this.myArmData.data.movingSpeed,
                            maxPro: 1
                        },
                        {
                            attribute: '生化充能',
                            pro: this.myArmData.data.biochemicalCharging,
                            maxPor: 0
                        }
                    ];
                } else {
                    data = [{
                            attribute: '火力',
                            pro: this.myArmData.data.fire,
                            maxPro: 250
                        },
                        {
                            attribute: '护甲穿透',
                            pro: this.myArmData.data.pierceThrough,
                            maxPro: 100
                        },
                        {
                            attribute: '射速',
                            pro: this.myArmData.data.firingRate,
                            maxPro: 2000
                        },
                        {
                            attribute: '子弹数',
                            pro: this.myArmData.data.numberOfBullets,
                            maxPro: 100
                        },
                        {
                            attribute: '有效射程',
                            pro: this.myArmData.data.range,
                            maxPro: 100
                        },
                        {
                            attribute: '精准',
                            pro: this.myArmData.data.accurate,
                            maxPro: 400
                        },
                        {
                            attribute: '换弹',
                            pro: this.myArmData.data.ammunitionChange,
                            maxPro: 100
                        },
                        {
                            attribute: '瞄准镜',
                            pro: this.myArmData.data.sight,
                            maxPro: 100
                        },
                        {
                            attribute: '移动速度',
                            pro: this.myArmData.data.movingSpeed,
                            maxPro: 1
                        },
                        {
                            attribute: '生化充能',
                            pro: this.myArmData.data.biochemicalCharging,
                            maxPor: 0
                        }
                    ];
                }
                this.txtType.text = type;
                this.addCacheList(data);
            }
        }
        cleanCacheList() {
            for (let k = 0; k < this.cacheList.length; k++) {
                this.cacheList[k].destroy();
                this.cacheList[k] = null;
            }
            this.cacheList = [];
        }
        addCacheList(data) {
            for (let k = 0; k < data.length; k++) {
                let item = data[k];
                let layer = new PropertybarItemCtrl(item);
                layer.x = 0;
                layer.y = 21 * k;
                this.boxPropertybar.addChild(layer);
                this.cacheList.push(layer);
            }
        }
        notUpdateProp(id) {
            let data = {
                id: id,
                lv: 1,
                fire: PROP.getDataByKey(id).hit,
                pierceThrough: PROP.getDataByKey(id).pierceThrough,
                firingRate: PROP.getDataByKey(id).interval,
                numberOfBullets: PROP.getDataByKey(id).magazineBullet,
                range: PROP.getDataByKey(id).range,
                accurate: 100,
                ammunitionChange: PROP.getDataByKey(id).bullets,
                sight: PROP.getDataByKey(id).sight,
                movingSpeed: PROP.getDataByKey(id).movingSpeed,
                biochemicalCharging: PROP.getDataByKey(id).biochemicalCharging
            };
            return data;
        }
    }

    let MODULAR = {
        SYNTHESIS: 'SYNTHESIS',
        WAREHOUSE: 'WAREHOUSE'
    };
    class EquipViewCtrl extends ui.view.equip.EquipViewUI {
        constructor() {
            super();
            this.curTouchModular = MODULAR.SYNTHESIS;
            this.equipLibraryCtrl = null;
            this.isAirDropPlay = false;
            this.isDown = false;
            this.apertureCtrl = null;
            this.fingerCtrl = null;
            this.point = new Laya.Point();
            this.a = new Laya.Point();
            this.isCheckNoLocal = false;
            this.name = 'EquipViewCtrl';
            this.width = this.stage.width;
            this.height = this.stage.height;
        }
        onAwake() {
            this.init();
            this.setBtnEvent();
            this.update();
            Laya.timer.loop(1000, this, this.update);
            if (ConfigManager.platform == PLATFORM_TYPE.WEB_4399) {
                this.label4399.visible = true;
            }
            this.btnEquipLib.on(Laya.Event.CLICK, this, this.onBtnEquipLib);
            this.btnSynthesis.on(Laya.Event.CLICK, this, this.onBtnSynthesis);
            this.onBtnSynthesis();
            if (ConfigManager.isReviewVersion()) {
                this.btnFreeEquip.visible = false;
            }
        }
        update() {}
        onDestroy() {
            this.timer.clearAll(this);
            GameScene.synthesisViewCtrl.removeSelf();
            Laya.MouseManager.multiTouchEnabled = true;
            this.btnClose = null;
            this.imgBg = null;
            this.curTouchModular = null;
            if (this.equipLibraryCtrl)
                this.equipLibraryCtrl.destroy();
            this.equipLibraryCtrl = null;
        }
        init() {
            Laya.MouseManager.multiTouchEnabled = false;
            this.fingerCtrl = GuideManager.createFingerAniCtrl(this);
            this.apertureCtrl = GuideManager.createCommonAperture(this);
            this.btnUICtrl();
            if (PlatformUtil.isFullScreen()) {}
            this.resetData();
            this.setGuide(true);
            this.isCanOpenOffLine();
            this.timer.loop(9000, this, this.updateAirDropTimer);
            this.timer.loop(30000, this, this.updateAirDrop);
        }
        resetData() {
            this.point.x = 0;
            this.point.y = 0;
            this.a.x = 0;
            this.a.y = 0;
        }
        setGuide(isFirst = false) {
            let guide = RoleManager.getInstance().getGuide();
            if (GuideManager.curEquiplLibraryStep > guide) {
                guide = GuideManager.curEquiplLibraryStep;
                this.isCheckNoLocal = true;
            }
            if (RoleManager.getInstance().getGuide() == GuideStep.CHOOSEARM || RoleManager.getInstance().getGuide() == GuideStep.TOEQUIP) {
                RoleManager.getInstance().setGuide(GuideStep.WAREHOUSE);
            }
            if (this.isCheckNoLocal) {
                if (GuideManager.curEquiplLibraryStep == GuideStep.CHOOSEARM || GuideManager.curEquiplLibraryStep == GuideStep.TOEQUIP) {
                    GuideManager.curEquiplLibraryStep = GuideStep.WAREHOUSE;
                    guide = GuideManager.curEquiplLibraryStep;
                }
            }
            console.log('装备库当前新手步骤：', GuideManager.curEquiplLibraryStep, RoleManager.getInstance().getGuide());
            if (GuideManager.curEquiplLibraryStep < RoleManager.getInstance().getGuide()) {
                guide = RoleManager.getInstance().getGuide();
            }
            switch (guide) {
                case GuideStep.WAREHOUSE:
                    {
                        if (this.a.x == 0 && this.a.y == 0) {
                            this.point = new Laya.Point(!isFirst ? this.btnEquipLib.width / 2 : this.btnEquipLib.width / 10, !isFirst ? this.btnEquipLib.height / 2 : this.btnEquipLib.height / 10);
                            this.a = this.btnEquipLib.localToGlobal(this.point);
                            this.setGudePos(this.a, this.a, this.btnEquipLib);
                        }
                        break;
                    }
            }
        }
        toGuideClose() {
            let point1 = new Laya.Point(this.btnClose.width / 2, this.btnClose.height / 2);
            let a = this.btnClose.localToGlobal(point1);
            this.fingerCtrl.visible = true;
            this.fingerCtrl.play();
            this.fingerCtrl.x = a.x;
            this.fingerCtrl.y = a.y;
        }
        setGudePos(a, b, targetBtn) {
            targetBtn.mouseEnabled = true;
            this.fingerCtrl.visible = true;
            this.fingerCtrl.play();
            this.fingerCtrl.x = a.x;
            this.fingerCtrl.y = a.y;
            this.apertureCtrl.visible = true;
            this.apertureCtrl.play(false);
            this.apertureCtrl.x = b.x - this.apertureCtrl.width / 2;
            this.apertureCtrl.y = b.y - this.apertureCtrl.height / 2;
        }
        updateGuide() {
            let guide = RoleManager.getInstance().getGuide();
            if (GuideManager.curEquiplLibraryStep > guide) {
                guide = GuideManager.curEquiplLibraryStep;
            }
            switch (guide) {
                case GuideStep.GAME_1:
                    {
                        break;
                    }
                case GuideStep.EQUIP:
                    {
                        break;
                    }
                case GuideStep.WAREHOUSE:
                    {
                        this.fingerCtrl.stop();
                        this.apertureCtrl.stop();
                        if (this.isCheckNoLocal) {
                            GuideManager.curEquiplLibraryStep++;
                        } else {
                            RoleManager.getInstance().setGuide();
                        }
                    }
            }
        }
        isCanOpenOffLine() {
            if (RoleManager.getInstance().isCanOpenOfflineView()) {
                UIManager.openFunction(FUNCTION_TAG.OFF_LINE, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.WINDOW, COMMON_MENU_STYLE.GOLD);
            }
        }
        updateAirDropTimer() {
            if (this.curTouchModular != MODULAR.SYNTHESIS)
                return;
            if (!this.btnFreeEquip.visible) {
                PeopleFactory.getInstance().getRandomEmptyPosToAddAirDrop();
            }
        }
        updateAirDrop() {
            if (this.curTouchModular != MODULAR.SYNTHESIS)
                return;
            if (RoleManager.getInstance().getGuide() <= GuideStep.GAME_2)
                return;
            if (PeopleFactory.getInstance().getEmptyPosNum() >= 1 && !this.isAirDropPlay) {
                Laya.Tween.clearAll(this.btnFreeEquip);
                this.isAirDropPlay = true;
                this.btnFreeEquip.y = -99;
                var that = this;
                if (!ConfigManager.isReviewVersion()) {
                    this.btnFreeEquip.visible = true;
                }
                Laya.Tween.to(this.btnFreeEquip, {
                    y: Laya.stage.height + 99
                }, 15000, null, Laya.Handler.create(this, function() {
                    that.isAirDropPlay = false;
                    that.btnFreeEquip.visible = false;
                }));
            }
        }
        setBtnEvent() {
            this.btnClose.on(Laya.Event.CLICK, this, this.onBtnClose);
            this.btnFreeEquip.on(Laya.Event.CLICK, this, this.onBtnFreeEquip);
        }
        btnUICtrl() {
            if (this.curTouchModular == MODULAR.SYNTHESIS) {
                if (this.equipLibraryCtrl) {
                    this.equipLibraryCtrl.destroy();
                    this.equipLibraryCtrl = null;
                }
                this.boxSynthesis.addChild(GameScene.synthesisViewCtrl);
                GameScene.synthesisViewCtrl.onMyEnable();
                GameScene.synthesisViewCtrl.zOrder = 1;
                this.btnFreeEquip.zOrder = 100;
                this.updateAirDrop();
                GameScene.synthesisViewCtrl.btnDorpAir = this.btnFreeEquip;
                GameScene.synthesisViewCtrl.setGuide();
                this.boxSynthesis.visible = true;
                this.boxEquipLib.visible = false;
            } else {
                this.btnFreeEquip.visible = false;
                this.isAirDropPlay = false;
                this.boxSynthesis.visible = false;
                this.boxEquipLib.visible = true;
                GameScene.synthesisViewCtrl.btnDorpAir = null;
                GameScene.synthesisViewCtrl.removeSelf();
                if (!this.equipLibraryCtrl) {
                    this.equipLibraryCtrl = new EquipLibarayViewCtrl();
                    this.boxEquipLib.addChild(this.equipLibraryCtrl);
                    GameScene.synthesisViewCtrl.onMyDisable();
                }
            }
        }
        onBtnSynthesis() {
            let imgNormal, imgSelect;
            imgNormal = this.btnEquipLib.getChildByName('imgNormal');
            imgSelect = this.btnEquipLib.getChildByName('imgSelect');
            imgNormal.visible = true;
            imgSelect.visible = false;
            imgNormal = this.btnSynthesis.getChildByName('imgNormal');
            imgSelect = this.btnSynthesis.getChildByName('imgSelect');
            imgNormal.visible = false;
            imgSelect.visible = true;
            if (this.curTouchModular == MODULAR.SYNTHESIS)
                return;
            this.curTouchModular = MODULAR.SYNTHESIS;
            this.resetData();
            this.setGuide();
            this.btnUICtrl();
        }
        onBtnEquipLib() {
            if (!CommonUtil.getTouch())
                return;
            if (this.curTouchModular == MODULAR.WAREHOUSE)
                return;
            this.curTouchModular = MODULAR.WAREHOUSE;
            this.updateGuide();
            this.btnUICtrl();
            let imgNormal, imgSelect;
            imgNormal = this.btnEquipLib.getChildByName('imgNormal');
            imgSelect = this.btnEquipLib.getChildByName('imgSelect');
            imgNormal.visible = false;
            imgSelect.visible = true;
            imgNormal = this.btnSynthesis.getChildByName('imgNormal');
            imgSelect = this.btnSynthesis.getChildByName('imgSelect');
            imgNormal.visible = true;
            imgSelect.visible = false;
        }
        onBtnClose() {
            if (!CommonUtil.getTouch())
                return;
            GameScene.synthesisViewCtrl.btnDorpAir = null;
            GameScene.synthesisViewCtrl.removeSelf();
            if (GuideManager.curEquiplLibraryStep == GuideStep.GAME_2) {
                if (RoleManager.getInstance().getGuide() > GuideStep.GAME_1 && RoleManager.getInstance().getGuide() < GuideStep.GAME_2) {
                    RoleManager.getInstance().setGuide();
                }
            }
            if (RoleManager.getInstance().getGuide() == GuideStep.GAME_2) {
                UIManager.getFunctionViewCtrl(FUNCTION_TAG.FIRST).resetData();
            }
            UIManager.getFunctionViewCtrl(FUNCTION_TAG.FIRST).setGuide();
            UIManager.closeFunction();
        }
        onBtnFreeEquip() {
            if (!CommonUtil.getTouch())
                return;
            var that = this;
            if (that.isDown)
                return;
            that.isDown = true;
            AdUtil.setEvent(function() {
                that.btnFreeEquip.visible = false;
                that.isDown = false;
                that.isAirDropPlay = false;
                GameScene.synthesisViewCtrl.onBtnDropAir();
            }, function() {
                that.isDown = false;
            }, REWARD_CTRL_TYPE.DROP_AIR);
        }
        onMyDisable() {
            if (this.curTouchModular == MODULAR.SYNTHESIS) {
                GameScene.synthesisViewCtrl.onMyDisable();
            }
            AdUtil.hideCustom(135, 329, WX_CUSTOM_AD_STYLE.SINGLE_1);
        }
        onMyEnable() {
            if (this.curTouchModular == MODULAR.SYNTHESIS) {
                GameScene.synthesisViewCtrl.onMyEnable();
            }
            AdUtil.showCustom(135, 329, WX_CUSTOM_AD_STYLE.SINGLE_1);
        }
    }

    class EquipFunction extends BaseFunction {
        createView() {
            this._viewCtrl = new EquipViewCtrl();
            return this._viewCtrl;
        }
        getFunctionName() {
            return '装备库界面';
        }
        onEnter() { super.onEnter();}
        onExit() { super.onExit();}
        onEnable() {
            super.onEnable();
            let view = this.viewCtrl;
            view.onMyEnable();
            if (PlatformUtil.isFullScreen()) {
                AdUtil.showBannerAd(1);
            }
        }
        onDisbale() {
            super.onDisbale();
            let view = this.viewCtrl;
            view.onMyDisable();
            if (PlatformUtil.isFullScreen()) {
                AdUtil.hideBannerAd();
            }
        }
        setAllButtonAnalysePoint() {}
        request(cb) {
            cb();
        }
    }

    class NewEquipUnLockViewCtrl extends ui.view.equip.NewEquipUnLockViewUI {
        constructor(data) {
            super();
            this.scene3D = null;
            this.sp1 = null;
            this.sp2 = null;
            this.sp3 = null;
            this.width = this.stage.width;
            this.height = this.stage.height;
            this.data = data;
        }
        onAwake() {
            SoundManager.playEffect(SOUND_PATH.HCXQ);
            this.setPlatformStyle();
            this.init();
            this.setEvent();
        }
        onDestroy() {
            this.timer.clearAll(this);
            this.data = null;
            this.imgCenter = null;
            this.txtLv = null;
            this.txtName = null;
            this.btnBack = null;
            this.btnShare = null;
            this.img1 = null;
            this.img2 = null;
            this.img3 = null;
            this.sp1.destroy();
            this.sp2.destroy();
            this.sp3.destroy();
            this.sp1 = null;
            this.sp2 = null;
            this.sp3 = null;
            this.scene3D.destroy();
            this.scene3D = null;
            this.ani1 = null;
        }
        init() {
            this.boxSuccess.visible = false;
            this.img1.visible = false;
            this.img2.visible = false;
            this.img3.visible = false;
            this.txtName.text = ARM.getDataByKey(this.data).name;
            this.txtLv.text = ARM.getDataByKey(this.data).id.toString();
            this.timer.once(1000, this, () => {});
            this.frameLoop(1, this, this.update);
            this.create3D();
            if (ConfigManager.platform != PLATFORM_TYPE.WX && ConfigManager.platform != PLATFORM_TYPE.QQ) {
                this.btnShare.visible = false;
                this.btnBack.x = 353.5;
            }
        }
        update() {
            if (this.sp3)
                this.sp3.transform.localRotationEulerY++;
        }
        create3D() {
            var scene = this.addChild(new Laya.Scene3D());
            this.scene3D = scene;
            var camera = (scene.addChild(new Laya.Camera(0, 0.1, 100)));
            camera.transform.position = new Laya.Vector3();
            camera.transform.localPositionX -= 5.2;
            camera.transform.localPositionY -= 2.3;
            camera.enableHDR = false;
            camera.clearFlag = Laya.CameraClearFlags.DepthOnly;
            var directionLight = scene.addChild(new Laya.DirectionLight());
            directionLight.color = new Laya.Vector3(0.6, 0.6, 0.6);
            directionLight.transform.worldMatrix.setForward(new Laya.Vector3(0, 0, -0.5));
            let efffect1 = EffectManger.playSynthesis1(scene);
            efffect1.transform.localScaleX = 4;
            efffect1.transform.localScaleY = 4;
            efffect1.transform.localScaleZ = 4;
            efffect1.transform.localPositionZ -= 11;
            efffect1.transform.localPositionY -= 1;
            efffect1.active = false;
            let efffect2 = EffectManger.playSynthesis2(scene);
            efffect2 = efffect2;
            efffect2.active = false;
            efffect2.transform.localPositionZ -= 11;
            efffect2.transform.localScaleX = 6;
            efffect2.transform.localScaleY = 6;
            efffect2.transform.localScaleZ = 6;
            this.sp1 = SkinManager.onLyToCreateArm(this.data - 1, this.scene3D);
            this.sp1.transform.localRotationEulerY = -90;
            this.sp1.transform.localScaleX = 6;
            this.sp1.transform.localScaleY = 6;
            this.sp1.transform.localScaleZ = 6;
            this.sp1.transform.position = efffect1.transform.position.clone();
            this.sp1.transform.localPositionX += 5;
            this.sp2 = SkinManager.onLyToCreateArm(this.data - 1, this.scene3D);
            this.sp2.transform.localRotationEulerY = -90;
            this.sp2.transform.localScaleX = 6;
            this.sp2.transform.localScaleY = 6;
            this.sp2.transform.localScaleZ = 6;
            this.sp2.transform.position = efffect1.transform.position.clone();
            this.sp2.transform.localPositionX -= 5;
            this.sp3 = SkinManager.onLyToCreateArm(this.data, this.scene3D);
            this.sp3.transform.localRotationEulerY = -90;
            this.sp3.transform.localScaleX = 6;
            this.sp3.transform.localScaleY = 4;
            this.sp3.transform.localScaleZ = 6;
            this.sp3.transform.position = efffect1.transform.position.clone();
            this.sp3.active = false;
            this.playAni();
        }
        playAni() {
            let tran1 = this.sp1.transform;
            let tran2 = this.sp2.transform;
            let tran3 = this.sp3.transform;
            this.playTween(tran1);
            this.playTween(tran2);
        }
        playTween(tran) {
            const x = tran.localPositionX;
            Laya.Tween.to(tran, {
                localRotationEulerX: -5
            }, 50, null, Laya.Handler.create(this, () => {
                Laya.Tween.to(tran, {
                    localRotationEulerX: 5
                }, 50, null, Laya.Handler.create(this, () => {
                    Laya.Tween.to(tran, {
                        localRotationEulerX: -5
                    }, 50, null, Laya.Handler.create(this, () => {
                        Laya.Tween.to(tran, {
                            localRotationEulerX: 5
                        }, 50, null, Laya.Handler.create(this, () => {
                            Laya.Tween.to(tran, {
                                localRotationEulerX: -5
                            }, 50, null, Laya.Handler.create(this, () => {
                                Laya.Tween.to(tran, {
                                    localRotationEulerX: 5
                                }, 50, null, Laya.Handler.create(this, () => {
                                    Laya.Tween.to(tran, {
                                        localRotationEulerX: 0
                                    }, 50, null, Laya.Handler.create(this, () => {
                                        Laya.Tween.to(tran, {
                                            localPositionX: x < 0 ? x - 2 : x + 2
                                        }, 80, null, Laya.Handler.create(this, () => {
                                            Laya.Tween.to(tran, {
                                                localPositionX: x < 0 ? x + 4 : x - 4
                                            }, 200, null, Laya.Handler.create(this, () => {
                                                Laya.Tween.to(tran, {
                                                    localPositionX: this.sp3.transform.position.x
                                                }, 700, null, Laya.Handler.create(this, () => {
                                                    Laya.Tween.clearAll(tran);
                                                    tran.owner.active = false;
                                                    if (!this.sp3)
                                                        return;
                                                    if (!this.sp3.active) {
                                                        SoundManager.playEffect(SOUND_PATH.NEWEQUIP);
                                                        this.sp3.active = true;
                                                        this.imgCenter.alpha = 1;
                                                        this.imgCenter.alpha = 1;
                                                        this.btnBack.alpha = 1;
                                                        this.btnShare.alpha = 1;
                                                        this.boxSuccess.visible = true;
                                                        this.ani2.play(0, false);
                                                    }
                                                }));
                                            }));
                                        }));
                                    }));
                                }));
                            }));
                        }));
                    }));
                }));
            }));
        }
        setEvent() {
            this.btnBack.on(Laya.Event.CLICK, this, this.onBtnBack);
            this.btnShare.on(Laya.Event.CLICK, this, this.onBtnShare);
        }
        onBtnBack() {
            if (!CommonUtil.getTouch())
                return;
            RewardManager.setfreeDiamondsRewards();
            let gold = RewardManager.curFreeDiamondsRewards;
            let cb = function() {
                GameScene.synthesisViewCtrl.unlockNewArm();
            };
            UIManager.openFunction(FUNCTION_TAG.GET_DIAMONDS_REWARD, FUNCTION_OPEN_MODE.REPLACE, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.DIAMOND, {
                reward: gold,
                cb: cb
            });
        }
        onBtnShare() {
            if (!CommonUtil.getTouch())
                return;
            AdUtil.shareMessage();
        }
        setPlatformStyle() {
            switch (ConfigManager.platform) {
                case PLATFORM_TYPE.WX:
                    {
                        this.setWXPlatform();
                        break;
                    }
                case PLATFORM_TYPE.QQ:
                    {
                        this.setQQPlatform();
                        break;
                    }
                case PLATFORM_TYPE.WEB:
                    {
                        this.setWXPlatform();
                        break;
                    }
                case PLATFORM_TYPE.VIVO:
                    {
                        this.setVIVOPlatform();
                        break;
                    }
                case PLATFORM_TYPE.OPPO:
                    {
                        this.setOPPOPlatform();
                        break;
                    }
                case PLATFORM_TYPE.NATIVE_IOS:
                    {
                        this.setNativeIOSPlatform();
                        break;
                    }
                case PLATFORM_TYPE.NATIVE_ANDRIOD:
                    {
                        this.setNativeAndroidPlatform();
                        break;
                    }
                case PLATFORM_TYPE.TT:
                    {
                        this.setTTPlatform();
                        break;
                    }
            }
        }
        setWXPlatform() {
            if (PlatformUtil.isIOS()) {
                this.btnBack.y -= 30;
                this.btnShare.y -= 30;
                this.imgCenter.y -= 30;
            }
        }
        setQQPlatform() {}
        setWebPlatform() {}
        setVIVOPlatform() {}
        setOPPOPlatform() {}
        setNativeIOSPlatform() {
            this.btnShare.visible = false;
            this.btnBack.x = 353;
        }
        setNativeAndroidPlatform() {
            this.btnShare.visible = false;
            this.btnBack.x = 353;
        }
        setTTPlatform() {}
    }

    class NewEquipUnLockFunction extends BaseFunction {
        createView() {
            this._viewCtrl = new NewEquipUnLockViewCtrl(this.args);
            return this._viewCtrl;
        }
        getFunctionName() {
            return '结算新枪支界面';
        }
        onEnter() { super.onEnter(); }
        onExit() {
            super.onExit();
            NewEquipUnLockFunction.isNewEquip = true;
        }
        onEnable() {
            super.onEnable();
            AdUtil.showBannerAd();
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || ConfigManager.platform == PLATFORM_TYPE.WX) {
                AdUtil.showCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                AdUtil.showCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
            }
        }
        onDisbale() {
            super.onDisbale();
            AdUtil.hideBannerAd();
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || ConfigManager.platform == PLATFORM_TYPE.WX) {
                AdUtil.hideCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                AdUtil.hideCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
            }
        }
        setAllButtonAnalysePoint() {}
        request(cb) {
            cb();
        }
    }
    NewEquipUnLockFunction.isNewEquip = false;

    class SynthesisFunction extends BaseFunction {
        createView() {
            this._viewCtrl = new SynthesisViewCtrl();
            return this._viewCtrl;
        }
        getFunctionName() {
            return '合成界面';
        }
        onEnter() { super.onEnter(); }
        onExit() { super.onExit(); }
        onEnable() { super.onEnable(); }
        onDisbale() { super.onDisbale(); }
        setAllButtonAnalysePoint() {}
        request(cb) {
            cb();
        }
    }

    class ExitViewCtrl extends ui.view.exit.ExitViewUI {
        constructor() {
            super();
            this.width = this.stage.width;
            this.height = this.stage.height;
        }
        onAwake() {
            CharacterManger.gameStop = true;
            this.btnBack.on(Laya.Event.CLICK, this, this.onBtnBack);
            this.btnOK.on(Laya.Event.CLICK, this, this.onBtnOK);
        }
        onDestroy() {
            this.btnBack = null;
            this.btnOK = null;
        }
        onBtnBack() {
            if (!CommonUtil.getTouch())
                return;
            UIManager.closeFunction();
            CharacterManger.gameStop = false;
        }
        onBtnOK() {
            if (!CommonUtil.getTouch())
                return;
            UIManager.clean();
            EffectManger.clean();
            CharacterManger.clean();
            SceneManager.getCurScene().setGameState(GAME_STATE.MENU);
            CharacterManger.gameStop = false;
            if (RoleManager.getInstance().getGuide() <= GuideStep.FINISH) {
                UIManager.triggerAutoOpen();
            }
        }
    }

    class ExitFunction extends BaseFunction {
        createView() {
            this._viewCtrl = new ExitViewCtrl();
            return this._viewCtrl;
        }
        getFunctionName() {
            return '退出界面';
        }
        onEnter() {
            super.onEnter();
            if (ConfigManager.platform == PLATFORM_TYPE.OPPO || ConfigManager.platform == PLATFORM_TYPE.WEB) {
                this.nativeBanner = new NativeBanner2ViewCtrl();
                let view = this._viewCtrl;
                view.addChild(this.nativeBanner);
            }
        }
        onExit() { super.onExit(); }
        onEnable() {
            super.onEnable();
            AdUtil.showBannerAd();
            this.nativeBanner && this.nativeBanner.show();
        }
        onDisbale() {
            super.onDisbale();
            AdUtil.hideBannerAd();
            this.nativeBanner && this.nativeBanner.hide();
        }
        setAllButtonAnalysePoint() {}
        request(cb) {
            cb();
        }
    }

    class GameOverViewCtrl extends ui.view.revive.GameOverViewUI {
        constructor() {
            super();
            this.width = this.stage.width;
            this.height = this.stage.height;
        }
        onAwake() {
            if (ConfigManager.platform == PLATFORM_TYPE.WEB_4399 && Laya.Browser.onPC) {
                Laya.Browser.document.exitPointerLock();
            }
            this.btnBack.on(Laya.Event.CLICK, this, this.onBtnBack);
            if (PlatformUtil.isIOS()) {
                this.btnBack.y -= 80;
            }
        }
        onDestroy() {
            this.btnBack = null;
        }
        onBtnBack() {
            if (!CommonUtil.getTouch())
                return;
            UIManager.closeFunction();
            CharacterManger.gameStop = false;
            CharacterManger.gameOver = true;
            CharacterManger._isWin = false;
        }
    }

    class GameOverFunction extends BaseFunction {
        createView() {
            this._viewCtrl = new GameOverViewCtrl();
            return this._viewCtrl;
        }
        getFunctionName() {
            return '游戏死亡结束界面';
        }
        onEnter() { super.onEnter(); }
        onExit() { super.onExit(); }
        onEnable() {
            super.onEnable();
            AdUtil.showBannerAd();
        }
        onDisbale() {
            super.onDisbale();
            AdUtil.hideBannerAd();
        }
        setAllButtonAnalysePoint() {}
        request(cb) {
            cb();
        }
    }

    let tryList1 = [
        30, 27, 28
    ];
    let tryList2 = [
        37, 43, 32
    ];
    let tryList3 = [
        41, 21, 45
    ];
    class EquipTryViewCtrl extends ui.view.equipTry.EquipTryViewUI {
        constructor() {
            super();
            this.isDown = false;
            this.tryList = [];
            this.width = Laya.stage.width;
            this.height = Laya.stage.height;
            this.btnBack.on(Laya.Event.CLICK, this, this.onBtnBack);
            this.btnBack1.on(Laya.Event.CLICK, this, this.onBtnBack);
            this.btnCancel.on(Laya.Event.CLICK, this, this.onBtnBack);
            this.btnNo.on(Laya.Event.CLICK, this, this.onBtnBack);
            let mode = ModeManager.mode;
            let myEquip = RoleManager.getInstance().getSkinLib();
            let list = [];
            let tryList = [tryList1[Math.floor(Mathf.random(tryList1.length, 0))],
                tryList2[Math.floor(Mathf.random(tryList2.length, 0))],
                tryList3[Math.floor(Mathf.random(tryList3.length, 0))]
            ];
            let sniperList = [];
            for (let index = 0; index < ARM.keys.length; index++) {
                const element = ARM.keys[index];
                if (ARM.getDataByIndex(index).type == ARM_TYPE.SNIPER_GUN) {
                    sniperList.push(element);
                }
            }
            if (mode == GAME_MODE_TYPE.SNIPERMODE) {
                let rand = Math.floor(Mathf.random(sniperList.length, 0));
                let count = 1;
                let rand1 = (rand + count) % sniperList.length;
                let rand2 = (rand1 + count) % sniperList.length;
                tryList = [sniperList[rand], sniperList[rand1], sniperList[rand2]];
            }
            for (let index = 0; index < tryList.length; index++) {
                const element = tryList[index];
                let isHave = false;
                for (let i = 0; i < myEquip.length; i++) {
                    const item = myEquip[i];
                    if (item == element) {
                        isHave = true;
                        continue;
                    }
                }
                if (!isHave) {
                    if (RoleManager.getInstance().getEquipTryCount(element) < 10)
                        list.push(element);
                }
            }
            if (list.length < 3) {
                let canUse = [];
                for (let index = 0; index < ARM.keys.length; index++) {
                    const element = ARM.keys[index];
                    let isHave = false;
                    for (let i = 0; i < myEquip.length; i++) {
                        const item = myEquip[i];
                        if (item == element) {
                            isHave = true;
                            continue;
                        }
                    }
                    if (mode == GAME_MODE_TYPE.SNIPERMODE) {
                        if (ARM.getDataByKey(element).type != ARM_TYPE.SNIPER_GUN)
                            continue;
                    }
                    if (!isHave) {
                        if (RoleManager.getInstance().getEquipTryCount(element) < 10)
                            canUse.push(element);
                    }
                }
                if (canUse.length == 0) {} else {
                    for (let i = 0; i < canUse.length; i++) {
                        const element = canUse[i];
                        list.push(element);
                    }
                }
            }
            if (list.length >= 3) {
                let trylist = CommonUtil.getRandomIntArray(list.length, 0, 3);
                tryList.sort(function(a, b) {
                    if (Math.random() > 0.5)
                        return -1;
                    else
                        return 1;
                });
                for (let index = 0; index < trylist.length; index++) {
                    const element = list[trylist[index]];
                    this.tryList.push({
                        id: element,
                        isHave: false
                    });
                }
            } else {
                for (let index = 0; index < 3; index++) {
                    const element = list[index];
                    if (element) {
                        this.tryList.push({
                            id: element,
                            isHave: false
                        });
                    } else {
                        this.tryList.push({
                            id: ARM.keys[Math.floor(Math.random() * ARM.keys.length)],
                            isHave: true
                        });
                    }
                }
            }
            this.setView();
            if (ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.TT) {
                this.btnBack1.visible = false;
                this.btnBack.visible = false;
                this.btnCancel.visible = true;
                this.imgAd1.visible = true;
                this.imgAd2.visible = true;
                this.imgAd3.visible = true;
                this.imgAdTotal1.visible = false;
                this.imgAdTotal2.visible = false;
                this.imgAdTotal3.visible = false;
            } else {
                this.btnBack1.visible = true;
                this.btnBack.visible = false;
                this.imgAd1.visible = false;
                this.imgAd2.visible = false;
                this.imgAd3.visible = false;
            }
        }
        setView() {
            for (let index = 0; index < this.tryList.length; index++) {
                const element = this.tryList[index];
                this['imgIcon' + (index + 1).toString()].skin = ARM.getDataByKey(element.id).icon;
                this['labelName' + (index + 1).toString()].text = ARM.getDataByKey(element.id).name;
                if (element.isHave) {
                    this['labelAd' + (index + 1).toString()].parent.visible = false;
                } else {
                    this['labelAd' + (index + 1).toString()].text = '/10)';
                    this['labelAd' + (index + 1).toString() + '_1'].text = RoleManager.getInstance().getEquipTryCount(element.id).toString();
                    if (RoleManager.getInstance().getEquipTryCount(element.id) == 0) {
                        this['labelAd' + (index + 1).toString() + '_1'].color = '#FF1C1C';
                    } else {
                        this['labelAd' + (index + 1).toString() + '_1'].color = '#2AFF00';
                    }
                }
                this['btnAd' + (index + 1).toString()].on(Laya.Event.CLICK, this, this.onBtnAd, [index + 1]);
                if (ConfigManager.platform != PLATFORM_TYPE.TT) {
                    this['boxAd' + (index + 1).toString()].on(Laya.Event.CLICK, this, this.onBtnAd, [index + 1]);
                }
            }
        }
        onBtnBack() {
            if (!CommonUtil.getTouch())
                return;
            if (this.ani2.isPlaying)
                return;
            this.playEnd();
        }
        onBtnAd(index) {
            if (!CommonUtil.getTouch())
                return;
            if (this.ani2.isPlaying)
                return;
            if (this.isDown)
                return;
            console.log('index' + index);
            this.isDown = true;
            var that = this;
            AdUtil.setEvent(function() {
                that.isDown = false;
                let id = that.tryList[index - 1].id;
                console.log('试用id' + id);
                RoleManager.getInstance().addEquipTryCount(id);
                if (RoleManager.getInstance().getEquipTryCount(id) >= 10) {
                    let itemId = ITEM_TYPE.EQUIP.toString() + (id > 99 ? id : id > 9 ? '0' + id : '00' + id);
                    PeopleFactory.getInstance().getEquip(id, function() {
                        SkinManager.getTrialArm(id);
                        that.playEnd();
                    });
                } else {
                    SkinManager.getTrialArm(id);
                    that.playEnd();
                }
            }, function() {
                that.isDown = false;
            }, REWARD_CTRL_TYPE.EQUIP_TRY);
        }
        endAni() {
            UIManager.closeFunction();
            UIManager.getFunctionViewCtrl(FUNCTION_TAG.FIRST).loading();
        }
        playEnd() {
            this.ani2.wrapMode = Laya.Animation.WRAP_REVERSE;
            this.ani2.play(0, false);
            this.ani2.on(Laya.Event.COMPLETE, this, this.endAni);
        }
    }

    class EquipTryFunction extends BaseFunction {
        createView() {
            this._viewCtrl = new EquipTryViewCtrl();
            return this._viewCtrl;
        }
        getFunctionName() {
            return '武器试用界面';
        }
        onEnter() { super.onEnter(); }
        onExit() { super.onExit(); }
        onEnable() {
            super.onEnable();
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || ConfigManager.platform == PLATFORM_TYPE.WX) {
                AdUtil.showCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                AdUtil.showCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
            }
        }
        onDisbale() {
            super.onDisbale();
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || ConfigManager.platform == PLATFORM_TYPE.WX) {
                AdUtil.hideCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                AdUtil.hideCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
            }
        }
        setAllButtonAnalysePoint() {}
        request(cb) {
            cb();
        }
    }

    var MODE_REWARD_TYPE;
    (function(MODE_REWARD_TYPE) {
        MODE_REWARD_TYPE[MODE_REWARD_TYPE["RECREATION"] = 0] = "RECREATION";
        MODE_REWARD_TYPE[MODE_REWARD_TYPE["BIOCHEMISTRY"] = 1] = "BIOCHEMISTRY";
    })(MODE_REWARD_TYPE || (MODE_REWARD_TYPE = {}));
    let url = ["sub1/ui/first/img_29.png", "sub1/ui/first/img_39.png"];
    let text = ["娱乐模式包含：狙击模式，双人模式，单人挑战。 全新的玩法，体验不一样的刺激战场！", "生化模式，全新的玩法，体验不一样的刺激战场！"];
    class GetModeRewardViewCtrl extends ui.view.getReward.GetModeRewardViewUI {
        constructor(type, cb) {
            super();
            this.type = MODE_REWARD_TYPE.RECREATION;
            this.width = this.stage.width;
            this.height = this.stage.height;
            this.type = type;
            this.cb = cb;
        }
        onAwake() {
            this.init();
            this.setEvent();
            this.setView();
        }
        onDestroy() {
            this.timer.clearAll(this);
            this.ani1 = null;
        }
        setView() {
            this.labelInfo.text = text[this.type];
            if (this.type == MODE_REWARD_TYPE.RECREATION) {
                this.imgIcon1.visible = true;
            } else if (this.type == MODE_REWARD_TYPE.BIOCHEMISTRY) {
                this.imgIcon2.visible = true;
            }
        }
        init() {
            this.ani1.play(0, false);
        }
        setEvent() {
            var that = this;
            Laya.timer.once(500, this, function() {
                that.on(Laya.Event.CLICK, that, that.onBtnBack);
            });
        }
        onBtnBack() {
            if (!CommonUtil.getTouch())
                return;
            UIManager.closeFunction();
            this.cb && this.cb();
        }
        pointCtrl(img, time) {}
    }

    let modeListId = {
        1: 7,
        2: 3,
        3: 1,
        4: 4,
        5: 2,
        6: 5,
    };
    class ModeCellViewCtrl extends ui.view.mode.ModeCellViewUI {
        constructor(type) {
            super();
            this.setView(type);
            this.type = type;
            this.imgSelect.visible = false;
        }
        onAwake() {
            this.on(Laya.Event.MOUSE_UP, this, this.onBtnDown);
            var that = this;
            this.on(Laya.Event.MOUSE_DOWN, this, function() {
                that.imgSelect.visible = true;
            });
            this.on(Laya.Event.MOUSE_OUT, this, function() {
                that.imgSelect.visible = false;
            });
        }
        select() {
            this.imgSelect.visible = true;
        }
        unSelect() {
            this.imgSelect.visible = false;
        }
        onDestroy() {
            this.boxMain = null;
            this.imgIcon = null;
        }
        setView(type) {
            this.imgIcon.skin = 'sub1/ui/mode/img_' + modeListId[type] + '.png';
        }
        onBtnDown() {
            if (!CommonUtil.getTouch())
                return;
            this.type = Number(this.type);
            switch (this.type) {
                case GAME_MODE_TYPE.SNIPERMODE:
                    break;
                case GAME_MODE_TYPE.KNIFEWARMODE:
                    if (!ModeManager.isCanOpenKnifeMode()) {
                        LogManager.showNotification('至少携带一把近身武器');
                        return;
                    }
                    break;
            }
            ModeManager.modeChoose(this.type);
            UIManager.openFunction(FUNCTION_TAG.MAP_MENU, FUNCTION_OPEN_MODE.REPLACE, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE, this.type);
        }
    }

    var MODE_TYPE;
    (function(MODE_TYPE) {
        MODE_TYPE[MODE_TYPE["ALL"] = 0] = "ALL";
        MODE_TYPE[MODE_TYPE["RECREATION"] = 1] = "RECREATION";
    })(MODE_TYPE || (MODE_TYPE = {}));
    class ModeViewCtrl extends ui.view.mode.ModeViewUI {
        constructor(type = MODE_TYPE.ALL) {
            super();
            this.cellCtrlList = [];
            this.width = this.stage.width;
            this.height = this.stage.height;
            this.type = type;
            this.setView();
        }
        onAwake() {
            this.btnClose.on(Laya.Event.CLICK, this, () => {
                UIManager.closeFunction();
            });
        }
        onDestroy() {}
        setView() {
            this.panel.hScrollBarSkin = '';
            if (this.type == MODE_TYPE.ALL) {
                for (const key in modeListId) {
                    if (Object.prototype.hasOwnProperty.call(modeListId, key)) {
                        let ctrl = new ModeCellViewCtrl(key);
                        this.boxCell.addChild(ctrl);
                        this.cellCtrlList.push(ctrl);
                    }
                }
            } else {
                for (let index = 1; index < 6; index++) {
                    for (const key in modeListId) {
                        if (Object.prototype.hasOwnProperty.call(modeListId, key)) {
                            const element = modeListId[key];
                            if (element == index) {
                                if (Number(key) == GAME_MODE_TYPE.BIOCHEMISTRY)
                                    continue;
                                let ctrl = new ModeCellViewCtrl(key);
                                this.boxCell.addChild(ctrl);
                                this.cellCtrlList.push(ctrl);
                            }
                        }
                    }
                }
            }
            let box = new Laya.Box();
            box.width = 199;
            this.boxCell.addChild(box);
        }
        updateSelect() {
            for (let index = 0; index < this.cellCtrlList.length; index++) {
                const element = this.cellCtrlList[index];
                if (element.type == ModeManager.mode) {
                    element.select();
                } else
                    element.unSelect();
            }
            ModeViewCtrl.setMap();
        }
        onBtnStart() {
            if (!CommonUtil.getTouch())
                return;
            ModeViewCtrl.setMap();
            if (ConfigManager.platform != PLATFORM_TYPE.TT) {
                UIManager.openFunction(FUNCTION_TAG.SUPERSTART, FUNCTION_OPEN_MODE.REPLACE, FUNCTION_TYPE.WINDOW, COMMON_MENU_STYLE.HIDE, {
                    cb: function() {
                        if (ModeManager.mode != GAME_MODE_TYPE.KNIFEWARMODE) {
                            if (!RoleManager.getInstance().isNew && RoleManager.getInstance().getGuide() != GuideStep.GAME_1) {
                                UIManager.openFunction(FUNCTION_TAG.EQUIP_TRY, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE);
                            } else {
                                UIManager.getFunctionViewCtrl(FUNCTION_TAG.FIRST).loading();
                            }
                        } else
                            UIManager.getFunctionViewCtrl(FUNCTION_TAG.FIRST).loading();
                    }
                });
            } else {
                if (ConfigManager.isReviewVersion()) {
                    if (ModeManager.mode != GAME_MODE_TYPE.KNIFEWARMODE) {
                        if (!RoleManager.getInstance().isNew && RoleManager.getInstance().getGuide() != GuideStep.GAME_1) {
                            UIManager.openFunction(FUNCTION_TAG.EQUIP_TRY, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE);
                        } else {
                            UIManager.getFunctionViewCtrl(FUNCTION_TAG.FIRST).loading();
                        }
                    } else
                        UIManager.getFunctionViewCtrl(FUNCTION_TAG.FIRST).loading();
                } else {
                    UIManager.openFunction(FUNCTION_TAG.SUPERSTART, FUNCTION_OPEN_MODE.REPLACE, FUNCTION_TYPE.WINDOW, COMMON_MENU_STYLE.HIDE, {
                        cb: function() {
                            if (ModeManager.mode != GAME_MODE_TYPE.KNIFEWARMODE) {
                                if (!RoleManager.getInstance().isNew && RoleManager.getInstance().getGuide() != GuideStep.GAME_1) {
                                    UIManager.openFunction(FUNCTION_TAG.EQUIP_TRY, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE);
                                } else {
                                    UIManager.getFunctionViewCtrl(FUNCTION_TAG.FIRST).loading();
                                }
                            } else
                                UIManager.getFunctionViewCtrl(FUNCTION_TAG.FIRST).loading();
                        }
                    });
                }
            }
        }
        static setMap() {
            let data = [];
            switch (ModeManager.mode) {
                case GAME_MODE_TYPE.TEAMCOMPETITION:
                    data.push(1);
                    data.push(2);
                    break;
                case GAME_MODE_TYPE.KNIFEWARMODE:
                case GAME_MODE_TYPE.TWOVSTWOMODE:
                    data.push(1);
                    data.push(2);
                    break;
                case GAME_MODE_TYPE.ONEVSONEMODE:
                    data.push(1);
                    break;
                case GAME_MODE_TYPE.BIOCHEMISTRY:
                    data.push(7);
                    break;
                case GAME_MODE_TYPE.SNIPERMODE:
                    data.push(1);
                    break;
            }
            console.log('地图列表：', data);
            ModeManager.map = data[Math.floor(Mathf.random(data.length, 0))];
        }
    }

    var ACTIVITY_TYPE;
    (function(ACTIVITY_TYPE) {
        ACTIVITY_TYPE[ACTIVITY_TYPE["DOUBLE_FOX"] = 0] = "DOUBLE_FOX";
        ACTIVITY_TYPE[ACTIVITY_TYPE["BARRETT"] = 1] = "BARRETT";
    })(ACTIVITY_TYPE || (ACTIVITY_TYPE = {}));
    class ActivityEquipViewCtrl extends ui.view.award.ActivityEquipViewUI {
        constructor(type) {
            super();
            this.isDown = false;
            this.list = [];
            this.width = this.stage.width;
            this.height = this.stage.height;
            this.activityType = type;
            this.btnBack.on(Laya.Event.CLICK, this, this.onBtnBack);
            this.btnBack1.on(Laya.Event.CLICK, this, this.onBtnBack);
            this.btnGet.on(Laya.Event.CLICK, this, this.onBtnGet);
            this.btnGet1.on(Laya.Event.CLICK, this, this.onBtnGet);
            this.box0.visible = false;
            this.box1.visible = false;
            if (!ConfigManager.getViolenceCtrl() && ConfigManager.platform == PLATFORM_TYPE.WEB_4399) {
                let str = this.imgName1.skin;
                str = str.replace(".png", "_4399.png");
                this.imgName1.skin = str;
            }
            switch (this.activityType) {
                case ACTIVITY_TYPE.DOUBLE_FOX:
                    this.box0.visible = true;
                    this.list.push(SPECIAL_ID.ACTIVITY_EQUIP1);
                    this.list.push(SPECIAL_ID.ACTIVITY_EQUIP2);
                    break;
                case ACTIVITY_TYPE.BARRETT:
                    this.box1.visible = true;
                    this.list.push(SPECIAL_ID.ACTIVITY_BARRETT);
                    break;
                default:
                    break;
            }
        }
        onAwake() {}
        onDestroy() {}
        onBtnBack() {
            if (!CommonUtil.getTouch())
                return;
            UIManager.closeFunction();
        }
        onBtnGet() {
            if (!CommonUtil.getTouch())
                return;
            if (this.isDown)
                return;
            this.isDown = true;
            var that = this;
            AdUtil.setEvent(function() {
                that.isDown = false;
                UIManager.closeFunction();
                if (that.list == null || that.list.length == 0) {
                    return;
                }
                that.getEggHero();
            }, function() {
                that.isDown = false;
            }, REWARD_CTRL_TYPE.SUPER_EQUIP);
        }
        getEggHero() {
            let data = this.list.pop();
            if (data) {
                var that = this;
                PeopleFactory.getInstance().getEquip(data, function() {
                    that.getEggHero();
                });
            }
        }
    }

    var ACTIVITY_ENTRANCE;
    (function(ACTIVITY_ENTRANCE) {
        ACTIVITY_ENTRANCE[ACTIVITY_ENTRANCE["NEW_GIFT"] = 1] = "NEW_GIFT";
        ACTIVITY_ENTRANCE[ACTIVITY_ENTRANCE["EQUIP_1"] = 2] = "EQUIP_1";
        ACTIVITY_ENTRANCE[ACTIVITY_ENTRANCE["EQUIP_2"] = 3] = "EQUIP_2";
        ACTIVITY_ENTRANCE[ACTIVITY_ENTRANCE["EQUIP_3"] = 4] = "EQUIP_3";
        ACTIVITY_ENTRANCE[ACTIVITY_ENTRANCE["ACTIVITY_EQUIP_1"] = 5] = "ACTIVITY_EQUIP_1";
        ACTIVITY_ENTRANCE[ACTIVITY_ENTRANCE["ACTIVITY_EQUIP_2"] = 6] = "ACTIVITY_EQUIP_2";
        ACTIVITY_ENTRANCE[ACTIVITY_ENTRANCE["NEW_YEAR_GIFT"] = 7] = "NEW_YEAR_GIFT";
        ACTIVITY_ENTRANCE[ACTIVITY_ENTRANCE["DFL"] = 8] = "DFL";
    })(ACTIVITY_ENTRANCE || (ACTIVITY_ENTRANCE = {}));
    class FirstViewCtrl extends ui.view.fisrt.FirstViewUI {
        constructor() {
            super();
            this.rotMouseX = 0;
            this.progressWight = 0;
            this.lastExpWight = null;
            this.apertureCtrl = null;
            this.fingerCtrl = null;
            this.point = new Laya.Point();
            this.a = new Laya.Point();
            this.isFisrt = true;
            this.isFirstOnEnable = true;
            this.isInOther = false;
            this.price = 0;
            this.isProductAniPlay = false;
            this.activityList = [];
            this.activityIndex = 0;
            this.isTouchBoxLeft = false;
            this.showInterstitialAdTime = 0;
            this.isloadingClose = false;
            this.isMouseDown = false;
            this.height = this.stage.height;
            this.width = this.stage.width;
        }
        onAwake() {
            if (DebugManger.gmDebug) {
                for (let index = 0; index < RoleData.keys.length; index++) {
                    const element = RoleData.getDataByIndex(index);
                    RoleManager.getInstance().setRoleSkinLib(element.id);
                }
                for (let index = 0; index < ARM.keys.length; index++) {
                    const element = ARM.getDataByIndex(index);
                    RoleManager.getInstance().setSkinLib(element.id);
                }
            }
            this.btnBiochemistry.gray = true;
        }
        onEnable() {
            this.init();
            this.setBtnEvent();
        }
        onDestroy() {
            this.btnGameCommunity = null;
            this.btnEquip = null;
            this.btnSign = null;
            this.btnTask = null;
            this.btnTreasureChest = null;
        }
        init() {
            GameScene.isShowRevivieCrazy = false;
            this.point.x = 0;
            this.point.y = 0;
            this.a.x = 0;
            this.a.y = 0;
            this.progressWight = this.imgExp.width;
            this.fingerCtrl = GuideManager.createFingerAniCtrl(this.boxGuide);
            this.apertureCtrl = GuideManager.createCommonAperture(this.boxGuide);
            this.setPlatformStyle();
            this.fingerCtrl.stop();
            this.apertureCtrl.stop();
            this.setGuide();
            SoundManager.playBGM(SOUND_PATH.BGM);
            this.setRoleInfo();
            GameTimeManager.clear();
            Laya.timer.loop(1000, this, this.update);
            this.update();
            this.createProductGold();
            this.btnConfigCtrl();
            if (ConfigManager.gameType == GAME_MJB_TYPE.QZHXJY && ConfigManager.isReviewVersion()) {
                this.boxReview.visible = true;
            }
        }
        btnConfigCtrl() {}
        hideGuide() {
            if (this.fingerCtrl && this.apertureCtrl) {
                this.fingerCtrl.visible = false;
                this.apertureCtrl.visible = false;
            }
        }
        visibleGuide() {
            if (RoleManager.getInstance().getGuide() == GuideStep.FINISH || RoleManager.getInstance().getGuide() == GuideStep.MAX)
                return;
            if (this.fingerCtrl && this.apertureCtrl) {
                if (RoleManager.getInstance().getGuide() == GuideStep.GAME_1 || RoleManager.getInstance().getGuide() == GuideStep.EQUIP || RoleManager.getInstance().getGuide() == GuideStep.GAME_2 || RoleManager.getInstance().getGuide() == GuideStep.BUY ||
                    RoleManager.getInstance().getGuide() == GuideStep.SYNTHESIS || RoleManager.getInstance().getGuide() == GuideStep.WAREHOUSE || RoleManager.getInstance().getGuide() == GuideStep.CHOOSEARM || RoleManager.getInstance().getGuide() == GuideStep.TOEQUIP ||
                    RoleManager.getInstance().getGuide() == GuideStep.FUNGAME_1) {
                    this.fingerCtrl.visible = true;
                    this.apertureCtrl.visible = true;
                } else if (RoleManager.getInstance().getGuide() == GuideStep.GAME_3) {
                    this.apertureCtrl.visible = true;
                }
            }
        }
        resetData() {
            if (!this.isFisrt)
                return;
            this.isFisrt = false;
            this.point.x = 0;
            this.point.y = 0;
            this.a.x = 0;
            this.a.y = 0;
        }
        setGuide() {
            console.log('首页新手教程：', GuideManager.curEquiplLibraryStep, RoleManager.getInstance().getGuide());
            let guide = RoleManager.getInstance().getGuide();
            if (GuideManager.curEquiplLibraryStep > RoleManager.getInstance().getGuide() && RoleManager.getInstance().getGuide() > GuideStep.GAME_1) {
                guide = GuideManager.curEquiplLibraryStep;
            }
            switch (guide) {
                case GuideStep.GAME_1:
                    {
                        this.btnBiochemistry.gray = true;
                        this.btnRecreation.gray = true;
                        if (this.a.x == 0 && this.a.y == 0) {
                            console.log('新手第一步');
                            this.point = new Laya.Point(this.btnRanking.width / 2, this.btnRanking.height / 2);
                            this.a = this.btnRanking.localToGlobal(this.point);
                            this.setGudePos(this.a, this.a, this.btnRanking);
                        }
                        break;
                    }
                case GuideStep.EQUIP:
                    {
                        this.btnBiochemistry.gray = true;
                        this.btnRecreation.gray = true;
                        if (this.a.x == 0 && this.a.y == 0) {
                            console.log('新手指引进入仓库');
                            this.point = new Laya.Point(this.btnEquip.width / 2, this.btnEquip.height / 2);
                            this.a = this.btnEquip.localToGlobal(this.point);
                            this.setGudePos(this.a, this.a, this.btnEquip);
                        }
                        break;
                    }
                case GuideStep.GAME_2:
                    {
                        this.btnBiochemistry.gray = true;
                        this.btnRecreation.gray = true;
                        if (this.a.x == 0 && this.a.y == 0) {
                            console.log('新手指引第二局');
                            this.point = new Laya.Point(this.isFisrt ? this.btnRanking.width / 2 : this.btnRanking.width, this.isFisrt ? this.btnRanking.height / 2 : this.btnRanking.height);
                            this.a = this.btnRanking.localToGlobal(this.point);
                            this.setGudePos(this.a, this.a, this.btnRanking);
                        }
                        break;
                    }
                case GuideStep.BUY:
                    {
                        this.btnBiochemistry.gray = true;
                        this.btnRecreation.gray = true;
                        if (this.a.x == 0 && this.a.y == 0) {
                            console.log('新手指引进入合成');
                            this.point = new Laya.Point(this.btnEquip.width / 2, this.btnEquip.height / 2);
                            this.a = this.btnEquip.localToGlobal(this.point);
                            this.setGudePos(this.a, this.a, this.btnEquip);
                        }
                        break;
                    }
                case GuideStep.SYNTHESIS:
                    {
                        this.btnBiochemistry.gray = true;
                        this.btnRecreation.gray = true;
                        if (this.a.x == 0 && this.a.y == 0) {
                            console.log('新手指引进入合成');
                            this.point = new Laya.Point(this.btnEquip.width / 2, this.btnEquip.height / 2);
                            this.a = this.btnEquip.localToGlobal(this.point);
                            this.setGudePos(this.a, this.a, this.btnEquip);
                        }
                        break;
                    }
                case GuideStep.WAREHOUSE:
                    {
                        this.btnBiochemistry.gray = true;
                        this.btnRecreation.gray = true;
                        if (this.a.x == 0 && this.a.y == 0) {
                            console.log('新手指引进入仓库1');
                            this.point = new Laya.Point(this.btnWarehouse.width / 2, this.btnWarehouse.height / 2);
                            this.a = this.btnWarehouse.localToGlobal(this.point);
                            this.setGudePos(this.a, this.a, this.btnWarehouse);
                        }
                        break;
                    }
                case GuideStep.CHOOSEARM:
                    {
                        this.btnBiochemistry.gray = true;
                        this.btnRecreation.gray = true;
                        if (this.a.x == 0 && this.a.y == 0) {
                            console.log('新手指引进入仓库2');
                            this.point = new Laya.Point(this.btnWarehouse.width / 2, this.btnWarehouse.height / 2);
                            this.a = this.btnWarehouse.localToGlobal(this.point);
                            this.setGudePos(this.a, this.a, this.btnWarehouse);
                        }
                        break;
                    }
                case GuideStep.TOEQUIP:
                    {
                        this.btnBiochemistry.gray = true;
                        this.btnRecreation.gray = true;
                        if (this.a.x == 0 && this.a.y == 0) {
                            console.log('新手指引进入仓库3');
                            this.point = new Laya.Point(this.btnWarehouse.width / 2, this.btnWarehouse.height / 2);
                            this.a = this.btnWarehouse.localToGlobal(this.point);
                            this.setGudePos(this.a, this.a, this.btnWarehouse);
                        }
                        break;
                    }
                case GuideStep.GAME_3:
                    {
                        console.log('新手指引第三局');
                        this.btnBiochemistry.gray = true;
                        this.btnRecreation.gray = true;
                        if (this.a.x == 0 && this.a.y == 0) {
                            console.log('新手指引第三局');
                            this.point = new Laya.Point(this.isFisrt ? this.btnRanking.width / 2 : this.btnRanking.width, this.isFisrt ? this.btnRanking.height / 2 : this.btnRanking.height);
                            this.a = this.btnRanking.localToGlobal(this.point);
                            this.setGudePos(this.a, this.a, this.btnRanking, false);
                        }
                        break;
                    }
                case GuideStep.GAME_4:
                    {
                        console.log('新手指引第四局');
                        this.btnBiochemistry.gray = true;
                        this.btnRecreation.gray = true;
                        break;
                    }
                case GuideStep.GAME_5:
                    {
                        console.log('新手指引第五局');
                        this.btnBiochemistry.gray = true;
                        this.btnRecreation.gray = true;
                        break;
                    }
                case GuideStep.GAME_6:
                    {
                        console.log('新手指引第六局');
                        this.btnBiochemistry.gray = true;
                        this.btnRecreation.gray = true;
                        break;
                    }
                case GuideStep.UNLOCKFUNMODE:
                    {
                        console.log('娱乐模式解锁');
                        let that = this;
                        this.btnBiochemistry.gray = true;
                        this.btnRecreation.gray = true;
                        UIManager.registerAutoOpenFunction(FUNCTION_TAG.GET_MODE_REWARD, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE, {
                            mode: MODE_REWARD_TYPE.RECREATION,
                            cb: function() {
                                console.log('关闭界面');
                                that.updateGuide();
                            }
                        });
                        break;
                    }
                case GuideStep.FUNGAME_1:
                    {
                        console.log('新手指引娱乐模式第一局');
                        this.btnBiochemistry.gray = true;
                        this.btnRecreation.gray = false;
                        if (this.a.x == 0 && this.a.y == 0) {
                            console.log('新手指引娱乐模式第一局');
                            this.point = new Laya.Point(this.btnRecreation.width / 2, this.btnRecreation.height / 2);
                            if (this.isFisrt) {
                                this.point.y += this.btnRecreation.height / 2 - 50;
                            } else {
                                this.point.y += this.btnRecreation.height / 2;
                            }
                            this.a = this.btnRecreation.localToGlobal(this.point);
                            this.setGudePos(this.a, this.a, this.btnRecreation);
                        }
                        break;
                    }
                case GuideStep.SIGN:
                    {
                        let that = this;
                        this.btnBiochemistry.gray = true;
                        this.btnRecreation.gray = false;
                        console.log('新手指引打开签到');
                        if (RoleManager.getInstance().getSign().state != 1) {
                            UIManager.registerAutoOpenFunction(FUNCTION_TAG.SIGN, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.WINDOW, COMMON_MENU_STYLE.HIDE, {
                                cb: function() {
                                    that.updateGuide();
                                }
                            });
                        } else {
                            that.updateGuide();
                        }
                        break;
                    }
                case GuideStep.FUNGAME_2:
                    {
                        console.log('新手指引娱乐模式第二局');
                        this.btnBiochemistry.gray = true;
                        this.btnRecreation.gray = false;
                        this.fingerCtrl.stop();
                        this.apertureCtrl.stop();
                        break;
                    }
                case GuideStep.NEWGIFT:
                    {
                        console.log('新手指引打开新手礼包');
                        let that = this;
                        this.btnBiochemistry.gray = true;
                        this.btnRecreation.gray = false;
                        if (!ConfigManager.isReviewVersion()) {
                            UIManager.registerAutoOpenFunction(FUNCTION_TAG.NEW_GIFT, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.WINDOW, COMMON_MENU_STYLE.HIDE, {
                                cb: function() {
                                    that.updateGuide();
                                }
                            });
                        } else {
                            that.updateGuide();
                        }
                        break;
                    }
                case GuideStep.UNLOCKSHMODE:
                    {
                        console.log('新手指引生化模式解锁');
                        let that = this;
                        that.updateGuide();
                        break;
                    }
                case GuideStep.SHMODEGAME_1:
                    {
                        this.fingerCtrl.stop();
                        this.apertureCtrl.stop();
                        this.btnBiochemistry.gray = false;
                        this.btnRecreation.gray = false;
                        break;
                    }
                case GuideStep.SUPERARM:
                    {
                        console.log('新手指引超级武器');
                        let that = this;
                        let id = RoleManager.getInstance().getSuperEquipId();
                        if (id) {
                            UIManager.registerAutoOpenFunction(FUNCTION_TAG.SUPER_EQUIP, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.WINDOW, COMMON_MENU_STYLE.HIDE, {
                                id: id,
                                isEndOpen: false
                            });
                        }
                        that.updateGuide();
                        break;
                    }
            }
            if (RoleManager.getInstance().isNew && GameScene.startGameNum < 6) {
                this.btnRecreation.gray = true;
            } else {
                this.btnRecreation.gray = false;
            }
            if (ConfigManager.platform == PLATFORM_TYPE.TT || ConfigManager.platform == PLATFORM_TYPE.WEB) {
                if (ConfigManager.isReviewVersion()) {
                    this.btnRecreation.gray = true;
                }
            } else if (ConfigManager.platform == PLATFORM_TYPE.WEB_4399) {
                this.btnRecreation.visible = false;
                this.btnBiochemistry.visible = false;
            }
            this.btnBiochemistry.gray = true;
        }
        updateGuide() {
            switch (RoleManager.getInstance().getGuide()) {
                case GuideStep.GAME_1:
                    {
                        break;
                    }
                case GuideStep.EQUIP:
                    {
                        RoleManager.getInstance().setGuide();
                        break;
                    }
                case GuideStep.UNLOCKFUNMODE:
                    {
                        this.point.x = 0;
                        this.point.y = 0;
                        this.a.x = 0;
                        this.a.y = 0;
                        this.resetData();
                        RoleManager.getInstance().setGuide();
                        this.setGuide();
                        break;
                    }
                case GuideStep.SIGN:
                    {
                        this.resetData();
                        RoleManager.getInstance().setGuide();
                        this.setGuide();
                        break;
                    }
                case GuideStep.NEWGIFT:
                    {
                        this.point.x = 0;
                        this.point.y = 0;
                        this.a.x = 0;
                        this.a.y = 0;
                        RoleManager.getInstance().setGuide();
                        this.setGuide();
                        break;
                    }
                case GuideStep.UNLOCKSHMODE:
                    {
                        this.point.x = 0;
                        this.point.y = 0;
                        this.a.x = 0;
                        this.a.y = 0;
                        RoleManager.getInstance().setGuide();
                        this.setGuide();
                        break;
                    }
                case GuideStep.SUPERARM:
                    {
                        this.point.x = 0;
                        this.point.y = 0;
                        this.a.x = 0;
                        this.a.y = 0;
                        RoleManager.getInstance().setGuide();
                        this.setGuide();
                        break;
                    }
            }
        }
        setGudePos(a, b, targetBtn, isPlayFinger = true) {
            targetBtn.mouseEnabled = true;
            if (isPlayFinger) {
                this.fingerCtrl.visible = true;
                this.fingerCtrl.play();
                this.fingerCtrl.x = a.x - targetBtn.width / 2;
                this.fingerCtrl.y = a.y - targetBtn.height / 2;
            } else {
                this.fingerCtrl.stop();
            }
            this.apertureCtrl.visible = true;
            this.apertureCtrl.play(false);
            this.apertureCtrl.x = b.x - targetBtn.width / 2 - this.apertureCtrl.width / 2;
            this.apertureCtrl.y = b.y - targetBtn.height / 2 - this.apertureCtrl.height / 2;
            if (targetBtn.name == 'btnWarehouse') {
                this.fingerCtrl.rotation = -80;
            } else {
                this.fingerCtrl.rotation = 0;
            }
        }
        banAllMouseTouch() {
            this.btnGameCommunity.mouseEnabled = false;
            this.btnSeason.mouseEnabled = false;
            this.btnSign.mouseEnabled = false;
            this.btnTask.mouseEnabled = false;
            this.btnTreasureChest.mouseEnabled = false;
            this.btnEquip.mouseEnabled = false;
            this.btnRanking.mouseEnabled = false;
            this.btnBiochemistry.mouseEnabled = false;
        }
        update() {
            this.setDot();
            this.updateGun();
            this.updateProductGold();
        }
        updateGun() {
            let id = RoleManager.getInstance().getMaxUnLockArm();
            let data = ARM.getDataByKey(id);
            this.imgGun.skin = data.icon;
            this.labelGunLv.text = data.id.toString();
        }
        setBtnEvent() {
            this.btnMoreGame.on(Laya.Event.CLICK, this, this.onBtnMoreGame);
            this.btnWarehouse.on(Laya.Event.CLICK, this, this.onBtnWarehouse);
            this.btnGameCommunity.on(Laya.Event.CLICK, this, this.onBtnGameCommunity);
            this.btnTurnTable.on(Laya.Event.CLICK, this, this.onBtnTurnTable);
            this.btnRecreation.on(Laya.Event.CLICK, this, this.onBtnRecreation);
            this.btnSeason.on(Laya.Event.CLICK, this, this.onBtnSeason);
            this.btnSign.on(Laya.Event.CLICK, this, this.onBtnSign);
            this.btnTask.on(Laya.Event.CLICK, this, this.onBtnTask);
            this.btnTreasureChest.on(Laya.Event.CLICK, this, this.onBtnTreasureChest);
            this.btnEquip.on(Laya.Event.CLICK, this, this.onBtnEquip);
            this.on(Laya.Event.MOUSE_DOWN, this, this.onBtnMouseDown);
            this.on(Laya.Event.MOUSE_UP, this, this.onBtnMouseUp);
            this.on(Laya.Event.MOUSE_MOVE, this, this.onBtnRot);
            this.btnRanking.on(Laya.Event.CLICK, this, this.onBtnRanking);
            this.btnBiochemistry.on(Laya.Event.CLICK, this, this.onBtnBiochemistry);
            this.btnSuperEquip.on(Laya.Event.CLICK, this, this.onBtnSuperEquip);
            this.btnNewGiftAct.on(Laya.Event.CLICK, this, this.onBtnNewGift);
            this.btnGoldGunAct.on(Laya.Event.CLICK, this, this.onBtnGoldGun);
            this.btnCDKey.on(Laya.Event.CLICK, this, this.onBtnCDKey);
            this.boxLeft.on(Laya.Event.MOUSE_DOWN, this, () => {
                this.isTouchBoxLeft = true;
            });
            this.boxLeft.on(Laya.Event.MOUSE_OUT, this, () => {
                this.isTouchBoxLeft = false;
            });
            this.btnReviewStart.on(Laya.Event.CLICK, this, this.onBtnBiochemistry);
            for (let index = 1; index <= 4; index++) {
                const box = this['box' + index];
                box.on(Laya.Event.CLICK, this, this.onBtnActivityEntrance, [index]);
            }
            this.limitByTT();
        }
        limitByTT() {}
        onBtnTurnTable() {
            if (!CommonUtil.getTouch())
                return;
            UIManager.openFunction(FUNCTION_TAG.TURNTABLE, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.WINDOW, COMMON_MENU_STYLE.HIDE);
        }
        onBtnMoreGame() {
            if (!CommonUtil.getTouch())
                return;
            switch (ConfigManager.platform) {
                case PLATFORM_TYPE.WEB:
                    break;
                case PLATFORM_TYPE.WX:
                    {
                        let size = PlatformUtil.getCustomMatrixSize();
                        let x = Laya.stage.width / 2 - size.w - 16;
                        let y = Laya.stage.height / 2 - size.h / 2;
                        let x1 = Laya.stage.width / 2 + 16;
                        let step = 0;
                        let step1 = 0;
                        AdUtil.showCustom(x, y, WX_CUSTOM_AD_STYLE.MATRIX, function() {
                            if (step >= 1)
                                return;
                            step += 1;
                            UIManager.openFunction(FUNCTION_TAG.MORE_GAME, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE, true);
                        }, function() {
                            step1++;
                            if (step1 == 2) {
                                LogManager.showNotification('敬请期待');
                            }
                            console.log('显示失败');
                        });
                        AdUtil.showCustom(x1, y, WX_CUSTOM_AD_STYLE.MATRIX, function() {
                            if (step >= 1)
                                return;
                            step += 1;
                            UIManager.openFunction(FUNCTION_TAG.MORE_GAME, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE, true);
                        }, function() {
                            step1++;
                            if (step1 == 2) {
                                LogManager.showNotification('敬请期待');
                            }
                            console.log('显示失败');
                        });
                    }
                    break;
                case PLATFORM_TYPE.QQ:
                    AdUtil.createAppBox();
                    break;
            }
        }
        onBtnActivityEntrance(index) {
            const box = this['box' + index];
            if (!CommonUtil.getTouch())
                return;
            let entrance = box.dataSource;
            switch (entrance) {
                case ACTIVITY_ENTRANCE.NEW_GIFT:
                    if (!ConfigManager.isReviewVersion())
                        UIManager.openFunction(FUNCTION_TAG.NEW_GIFT, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.WINDOW, COMMON_MENU_STYLE.HIDE, true);
                    break;
                case ACTIVITY_ENTRANCE.EQUIP_2:
                    UIManager.openFunction(FUNCTION_TAG.SUPER_EQUIP, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.WINDOW, COMMON_MENU_STYLE.HIDE, {
                        id: SPECIAL_ID.RED_SPIRIT_EQUIP,
                        isEndOpen: false
                    });
                    break;
                case ACTIVITY_ENTRANCE.EQUIP_1:
                    UIManager.openFunction(FUNCTION_TAG.SUPER_EQUIP, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.WINDOW, COMMON_MENU_STYLE.HIDE, {
                        id: SPECIAL_ID.RED_TASSEL_EQUIP,
                        isEndOpen: false
                    });
                    break;
                case ACTIVITY_ENTRANCE.EQUIP_3:
                    break;
                case ACTIVITY_ENTRANCE.ACTIVITY_EQUIP_2:
                    break;
                case ACTIVITY_ENTRANCE.ACTIVITY_EQUIP_1:
                    break;
                case ACTIVITY_ENTRANCE.NEW_YEAR_GIFT:
                    UIManager.openFunction(FUNCTION_TAG.NEW_YEAR_GIFT, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.WINDOW, COMMON_MENU_STYLE.HIDE);
                    break;
                case ACTIVITY_ENTRANCE.DFL:
                    UIManager.openFunction(FUNCTION_TAG.ACTIVITYPLAYER, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.WINDOW, COMMON_MENU_STYLE.HIDE);
                    break;
            }
        }
        setDot() {
            this.isShowSuperEquip();
            this.setEquipDot();
            this.setTaskDot();
            this.setSignDot();
            this.setRoleInfo();
            if (RoleManager.getInstance().getNewGiftInfo().state == 1) {
                this.btnNewGiftAct.visible = false;
            }
            if (RoleManager.getInstance().getActGoldGunState() == 1) {
                this.btnGoldGunAct.visible = false;
            }
        }
        setSignDot() {
            let img = this.btnSign.getChildByName('imgDot');
            if (RoleManager.getInstance().getSign().state != 1) {
                img.visible = true;
            } else {
                img.visible = false;
            }
        }
        setTaskDot() {
            let img = this.btnTask.getChildByName('imgDot');
            if (RoleManager.getInstance().isShowTaskRed()) {
                img.visible = true;
            } else {
                img.visible = false;
            }
        }
        setEquipDot() {
            let img = this.btnEquip.getChildByName('imgDot');
            img.visible = RoleManager.getInstance().isShowEquipRed();
        }
        onBtnMouseDown(e) {
            this.isMouseDown = true;
            this.rotMouseX = e.stageX;
        }
        onBtnRot(e) {
            if (this.isMouseDown) {
                if (SceneManager.getCurScene().menuPlayer) {
                    let fac = e.stageX - this.rotMouseX;
                    SceneManager.getCurScene().menuPlayer.transform.localRotationEulerY += fac * 0.4;
                    this.rotMouseX = e.stageX;
                }
            }
        }
        onBtnMouseUp() {
            this.isMouseDown = false;
        }
        onBtnRanking() {
            if (!CommonUtil.getTouch())
                return;
            ModeManager.modeChoose(GAME_MODE_TYPE.TEAMCOMPETITION);
            UIManager.openFunction(FUNCTION_TAG.MAP_MENU, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE, GAME_MODE_TYPE.TEAMCOMPETITION);
        }
        onBtnBiochemistry() {
            LogManager.showNotification('暂未开放');
            return;
            if (ConfigManager.gameType == GAME_MJB_TYPE.QZHXJY && ConfigManager.isReviewVersion()) {
                SceneManager.getCurScene().menuPlayer.active = false;
                ModeManager.modeChoose(GAME_MODE_TYPE.BIOCHEMISTRY);
                ModeViewCtrl.setMap();
                UIManager.getFunctionViewCtrl(FUNCTION_TAG.FIRST).loading();
                return;
            }
            if (!CommonUtil.getTouch())
                return;
            ModeManager.modeChoose(GAME_MODE_TYPE.BIOCHEMISTRY);
            if (RoleManager.getInstance().getGuide() < GuideStep.UNLOCKSHMODE) {
                LogManager.showNotification('完成8局游戏解锁该模式');
                return;
            }
            ModeViewCtrl.setMap();
            if (ConfigManager.platform != PLATFORM_TYPE.TT) {
                UIManager.openFunction(FUNCTION_TAG.SUPERSTART, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.WINDOW, COMMON_MENU_STYLE.HIDE, {
                    cb: function() {
                        if (RoleManager.getInstance().isNew && ModeManager.mode == GAME_MODE_TYPE.TEAMCOMPETITION || ModeManager.mode == GAME_MODE_TYPE.BIOCHEMISTRY) {
                            if (!RoleManager.getInstance().isNew && RoleManager.getInstance().getGuide() != GuideStep.GAME_1) {
                                UIManager.openFunction(FUNCTION_TAG.EQUIP_TRY, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE);
                            } else {
                                UIManager.getFunctionViewCtrl(FUNCTION_TAG.FIRST).loading();
                            }
                        } else
                            UIManager.getFunctionViewCtrl(FUNCTION_TAG.FIRST).loading();
                    }
                });
            } else {
                if (ConfigManager.isReviewVersion()) {
                    if (RoleManager.getInstance().isNew && ModeManager.mode == GAME_MODE_TYPE.TEAMCOMPETITION || ModeManager.mode == GAME_MODE_TYPE.BIOCHEMISTRY) {
                        if (!RoleManager.getInstance().isNew && RoleManager.getInstance().getGuide() != GuideStep.GAME_1) {
                            UIManager.openFunction(FUNCTION_TAG.EQUIP_TRY, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE);
                        } else {
                            UIManager.getFunctionViewCtrl(FUNCTION_TAG.FIRST).loading();
                        }
                    } else
                        UIManager.getFunctionViewCtrl(FUNCTION_TAG.FIRST).loading();
                } else {
                    UIManager.openFunction(FUNCTION_TAG.SUPERSTART, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.WINDOW, COMMON_MENU_STYLE.HIDE, {
                        cb: function() {
                            if (RoleManager.getInstance().isNew && ModeManager.mode == GAME_MODE_TYPE.TEAMCOMPETITION || ModeManager.mode == GAME_MODE_TYPE.BIOCHEMISTRY) {
                                if (!RoleManager.getInstance().isNew && RoleManager.getInstance().getGuide() != GuideStep.GAME_1) {
                                    UIManager.openFunction(FUNCTION_TAG.EQUIP_TRY, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE);
                                } else {
                                    UIManager.getFunctionViewCtrl(FUNCTION_TAG.FIRST).loading();
                                }
                            } else
                                UIManager.getFunctionViewCtrl(FUNCTION_TAG.FIRST).loading();
                        }
                    });
                }
            }
        }
        onBtnWarehouse() {
            if (!CommonUtil.getTouch())
                return;
            UIManager.openFunction(FUNCTION_TAG.ROLE, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.ALL_SHOW);
        }
        onBtnGameCommunity() {
            if (!CommonUtil.getTouch())
                return;
        }
        onBtnRecreation() {
            if (!CommonUtil.getTouch())
                return;
            if (ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.TT) {
                if (ConfigManager.isReviewVersion()) {
                    LogManager.showNotification('敬请期待');
                    return;
                }
            }
            if (RoleManager.getInstance().isNew && GameScene.startGameNum < 6) {
                LogManager.showNotification('进行6局游戏解锁该模式', 2000);
                return;
            }
            ModeManager.modeChoose(GAME_MODE_TYPE.SNIPERMODE);
            UIManager.openFunction(FUNCTION_TAG.MODE, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE, MODE_TYPE.RECREATION);
        }
        onBtnSeason() {
            if (!CommonUtil.getTouch())
                return;
        }
        onBtnSign() {
            if (!CommonUtil.getTouch())
                return;
            UIManager.openFunction(FUNCTION_TAG.SIGN, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.WINDOW, COMMON_MENU_STYLE.HIDE);
        }
        onBtnTask() {
            if (!CommonUtil.getTouch())
                return;
            UIManager.openFunction(FUNCTION_TAG.TASK, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.WINDOW, COMMON_MENU_STYLE.HIDE);
        }
        onBtnTreasureChest() {
            if (!CommonUtil.getTouch())
                return;
            UIManager.openFunction(FUNCTION_TAG.GAMEBOX, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE, {
                viewType: 0
            });
        }
        onBtnEquip() {
            this.updateGuide();
            UIManager.openFunction(FUNCTION_TAG.EQUIP, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.ALL_SHOW);
        }
        onBtnMap() {}
        onMyEnable() {
            this.setDot();
            this.setActivityView();
            AdUtil.showCustom(361, 125);
            if (!this.isloadingClose)
                SceneManager.getCurScene().createMenu();
            else {
                this.isloadingClose = false;
            }
            if (PLATFORM_TYPE.WX == ConfigManager.platform) {}
            FirstViewCtrl.btnPlatfromUserInfo && FirstViewCtrl.btnPlatfromUserInfo.show();
            FirstViewCtrl.btnGameClub && FirstViewCtrl.btnGameClub.show();
            this.isInOther = false;
            NotifyManager.notify(NOTIFY_ID.REFRESH_SKIN);
            if (this.isFirstOnEnable) {
                if (!FirstViewCtrl.isFirst) {
                    this.registerAutoOpen();
                }
            }
            this.autoOpen();
            if (this.isFirstOnEnable) {
                this.isFirstOnEnable = false;
                if (RoleManager.getInstance().getGuide() > GuideStep.NEWGIFT && RoleManager.getInstance().getGuide() != GuideStep.FUNGAME_1) {
                    RoleManager.getInstance().guideBtnType == GUIDE_BTN.RANK;
                    Laya.timer.clear(this, this.setGuideBtn);
                    Laya.timer.once(3000, this, this.setGuideBtn);
                }
            } else {
                if (RoleManager.getInstance().getGuide() > GuideStep.NEWGIFT && RoleManager.getInstance().getGuide() != GuideStep.FUNGAME_1) {
                    Laya.timer.clear(this, this.setGuideBtn);
                    Laya.timer.once(3000, this, this.setGuideBtn);
                }
            }
        }
        onMyDisable() {
            FirstViewCtrl.btnPlatfromUserInfo && FirstViewCtrl.btnPlatfromUserInfo.hide();
            FirstViewCtrl.btnGameClub && FirstViewCtrl.btnGameClub.hide();
            Laya.timer.clear(this, this.setGuideBtn);
            this.hideNew();
            this.isInOther = true;
            AdUtil.hideCustom(361, 125);
        }
        onBtnSuperEquip() {
            if (!CommonUtil.getTouch())
                return;
            let id = RoleManager.getInstance().getSuperEquipId();
            if (id) {
                UIManager.openFunction(FUNCTION_TAG.SUPER_EQUIP, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.WINDOW, COMMON_MENU_STYLE.HIDE, {
                    id: id,
                    isEndOpen: false
                });
            }
        }
        onBtnNewGift() {
            if (!CommonUtil.getTouch())
                return;
            UIManager.openFunction(FUNCTION_TAG.NEW_GIFT, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.WINDOW, COMMON_MENU_STYLE.HIDE, true);
        }
        onBtnGoldGun() {
            if (!CommonUtil.getTouch())
                return;
            UIManager.openFunction(FUNCTION_TAG.ACT_GOLD_GUN, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.WINDOW, COMMON_MENU_STYLE.HIDE, true);
        }
        onBtnCDKey() {
            if (!CommonUtil.getTouch())
                return;
            UIManager.openFunction(FUNCTION_TAG.CD_KEY, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.WINDOW, COMMON_MENU_STYLE.HIDE, true);
        }
        loading() {
            this.aniLoadOpen.wrapMode = Laya.Animation.WRAP_POSITIVE;
            this.aniLoadOpen.play(0, false);
            SceneManager.getCurScene().moveMenuPlayer(true);
            UIManager.openFunction(FUNCTION_TAG.LOADING_FIGHT, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.ALL_SHOW);
            Laya.Tween.to(UIManager.viewCommon, {
                y: -200
            }, 300);
            this.boxGuide.visible = false;
        }
        closeLoading() {
            this.aniLoadOpen.wrapMode = Laya.Animation.WRAP_REVERSE;
            this.aniLoadOpen.play(0, false);
            SceneManager.getCurScene().moveMenuPlayer(false);
            this.isloadingClose = true;
            this.boxGuide.visible = true;
        }
        setRoleInfo() {
            let expData = RoleManager.getInstance().getRoleExpData();
            this.txtLv.text = 'lv.' + expData.lv.toString();
            if (this.lastExpWight == null) {
                this.lastExpWight = (expData.curExp / expData.exp);
            }
            let width = this.progressWight * (expData.curExp / expData.exp);
            this.imgExp.width = width;
            this.setDan();
        }
        setDan() {
            let myDan = RoleManager.getInstance().getDanInfo();
            let danData = DanData.getDataByKey(myDan.id);
            this.imgDan.skin = RES_PATH.IMG_DAN_ROOT + danData.icon;
            this.labelDan.text = danData.name;
            if (danData.lv) {
                this.imgLv.visible = true;
                this.imgLv.skin = 'sub1/ui/dan/img_lv_' + danData.lv + '.png';
            } else {
                this.imgLv.visible = false;
            }
        }
        setGuideBtn() {
            console.log('当前若引导：', RoleManager.getInstance().getGuide());
            if (RoleManager.getInstance().getGuide() == GuideStep.FUNGAME_1 || RoleManager.getInstance().getGuide() == GuideStep.UNLOCKFUNMODE)
                return;
            if (RoleManager.getInstance().getGuide() < GuideStep.NEWGIFT) {
                return;
            }
            Laya.timer.clear(this, this.randNew);
            Laya.timer.clear(this, this.hideNew);
            this.newGuideBtnType();
            this.isInOther = true;
            switch (RoleManager.getInstance().guideBtnType) {
                case GUIDE_BTN.SING:
                    this.setGuideEffect(this.btnSign);
                    break;
                case GUIDE_BTN.RANK:
                    this.setGuideEffect(this.btnRanking);
                    break;
                case GUIDE_BTN.MODE:
                    if (ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.TT) {
                        if (ConfigManager.isReviewVersion()) {
                            break;
                        }
                    }
                    this.setGuideEffect(this.btnRecreation);
                    break;
                case GUIDE_BTN.BIOCHEMISTRY:
                    break;
                case GUIDE_BTN.TASK:
                    this.setGuideEffect(this.btnTask);
                    break;
                case GUIDE_BTN.EQUIP:
                    this.setGuideEffect(this.btnEquip);
                    break;
                default:
                    break;
            }
            Laya.timer.once(3000, this, this.hideNew);
            Laya.timer.once(8000, this, this.randNew);
        }
        hideNew() {
            if (RoleManager.getInstance().getGuide() >= GuideStep.FINISH) {
                this.isInOther = false;
                this.apertureCtrl.stop();
            }
        }
        randNew() {
            this.setGuideBtn();
        }
        newGuideBtnType() {
            let id = RoleManager.getInstance().guideBtnType;
            let list = {};
            list[GUIDE_BTN.SING] = RoleManager.getInstance().getSign().state == 0 ? true : false;
            list[GUIDE_BTN.RANK] = true;
            list[GUIDE_BTN.MODE] = RoleManager.getInstance().getGuide() > GuideStep.FUNGAME_1 ? true : false;
            list[GUIDE_BTN.BIOCHEMISTRY] = RoleManager.getInstance().getGuide() > GuideStep.UNLOCKSHMODE ? true : false;
            list[GUIDE_BTN.TASK] = RoleManager.getInstance().isShowTaskRed();
            list[GUIDE_BTN.EQUIP] = RoleManager.getInstance().isShowEquipRed();
            list[GUIDE_BTN.NEW_GIFT] = RoleManager.getInstance().getNewGiftInfo().state == 1 ? false : true;
            let isHave = false;
            let lib = RoleManager.getInstance().getSkinLib();
            for (let index = 0; index < lib.length; index++) {
                const element = lib[index];
                if (element == SPECIAL_ID.RED_TASSEL_EQUIP)
                    isHave = true;
            }
            list[GUIDE_BTN.SUPER_EQUIP] = !isHave;
            let canUse = [];
            let lastIdHave = false;
            for (let index = 1; index <= GUIDE_BTN.SUPER_EQUIP; index++) {
                const element = list[index];
                if (element) {
                    if (index == RoleManager.getInstance().guideBtnType) {
                        lastIdHave = true;
                    } else {
                        canUse.push(index);
                    }
                }
            } {
                let i = Math.floor(Math.random() * canUse.length);
                if (canUse.length == 0) {
                    if (lastIdHave) {
                        id = RoleManager.getInstance().guideBtnType;
                    } else
                        id = 0;
                } else {
                    id = canUse[i];
                }
            }
            RoleManager.getInstance().guideBtnType = id;
        }
        setGuideEffect(btn) {
            let pos = new Laya.Point(btn.width / 2, btn.height / 2);
            btn.localToGlobal(pos);
            this.apertureCtrl.pos(pos.x - this.apertureCtrl.width / 2, pos.y - this.apertureCtrl.height / 2);
            this.apertureCtrl.play(false);
            var that = this;
        }
        setPlatformStyle() {
            switch (ConfigManager.platform) {
                case PLATFORM_TYPE.WX:
                    {
                        this.setWXPlatform();
                        break;
                    }
                case PLATFORM_TYPE.QQ:
                    {
                        this.setQQPlatform();
                        break;
                    }
                case PLATFORM_TYPE.WEB:
                    {
                        this.setTTPlatform();
                        break;
                    }
                case PLATFORM_TYPE.VIVO:
                    {
                        this.setVIVOPlatform();
                        break;
                    }
                case PLATFORM_TYPE.WEB_4399:
                    {
                        this.setWeb4399Platform();
                        break;
                    }
                case PLATFORM_TYPE.OPPO:
                    {
                        this.setOPPOPlatform();
                        break;
                    }
                case PLATFORM_TYPE.NATIVE_IOS:
                    {
                        this.setNativeIOSPlatform();
                        break;
                    }
                case PLATFORM_TYPE.NATIVE_ANDRIOD:
                    {
                        this.setNativeAndroidPlatform();
                        break;
                    }
                case PLATFORM_TYPE.TT:
                    {
                        this.setTTPlatform();
                        break;
                    }
            }
        }
        setWeb4399Platform() {
            this.imgHead.skin = 'sub1/ui/common/img_4399_1.png';
            this.label4399.visible = true;
        }
        setWXPlatform() {
            this.btnMoreGame.visible = true;
            this.createGameClub();
            this.btnGameCommunity.visible = true;
            let userInfo = RoleManager.getInstance().getPlatfromUserInfo();
            if (!userInfo)
                this.createUserInfoButton();
            else
                this.setUserInfo();
        }
        setQQPlatform() {}
        setWebPlatform() {}
        setVIVOPlatform() {}
        setOPPOPlatform() {}
        setNativeIOSPlatform() {}
        setNativeAndroidPlatform() {}
        setTTPlatform() {
            this.btnCDKey.visible = false;
            if (ConfigManager.isReviewVersion()) {
                this.btnNewGiftAct.visible = false;
            }
        }
        createGameClub() {
            if (FirstViewCtrl.btnGameClub)
                return;
            if (ConfigManager.platform != PLATFORM_TYPE.WX)
                return;
            let system = PlatformUtil.getSystemInfo();
            let pos = this.btnGameCommunity.localToGlobal(new Laya.Point(-this.btnGameCommunity.width * 0.5, -this.btnGameCommunity.height * 0.5));
            let factor = system.screenWidth / this.stage.width;
            var that = this;
            FirstViewCtrl.btnGameClub = wx.createGameClubButton({
                icon: 'image',
                style: {
                    left: pos.x * factor,
                    top: pos.y * factor,
                    width: that.btnGameCommunity.width * factor,
                    height: that.btnGameCommunity.height * factor,
                }
            });
        }
        createUserInfoButton() {
            if (ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.WEB_4399)
                return;
            if (FirstViewCtrl.btnPlatfromUserInfo)
                return;
            let system = PlatformUtil.getSystemInfo();
            let factor = system.screenHeight / this.stage.height;
            let pos = this.imgHead.localToGlobal(new Laya.Point());
            let button = wx.createUserInfoButton({
                type: 'image',
                style: {
                    left: pos.x * factor,
                    top: pos.y * factor,
                    width: this.imgHead.width * factor,
                    height: this.imgHead.height * factor,
                }
            });
            button.onTap((res) => {
                if (res && res.userInfo) {
                    RoleManager.getInstance().setPlatfromUserInfo(res.userInfo);
                    if (SceneManager.getCurScene().state == GAME_STATE.MENU) {
                        let firstView = UIManager.getFunctionViewCtrl(FUNCTION_TAG.FIRST);
                        firstView.setUserInfo();
                    }
                    button.destroy();
                    button.offTap(this);
                    FirstViewCtrl.btnPlatfromUserInfo = null;
                }
            });
            FirstViewCtrl.btnPlatfromUserInfo = button;
        }
        setUserInfo() {
            let userInfo = RoleManager.getInstance().getPlatfromUserInfo();
            this.txtName.text = userInfo.nickName;
            this.imgHead.skin = userInfo.avatarUrl;
            console.log('userInfo.avatarUrl', userInfo.avatarUrl);
        }
        autoOpen() {
            if (ConfigManager.isReviewVersion() && ConfigManager.gameType == GAME_MJB_TYPE.QZHXJY)
                return;
            if (FirstViewCtrl.isFirst) {
                AdUtil.preloadInterstitialAd();
                FirstViewCtrl.isFirst = false;
                let popData = RoleManager.getInstance().getPopUpRule();
                if (!popData.isNew && RoleManager.getInstance().isCanAutoOpenFunction()) {
                    let exec = function() {
                        if (!RoleManager.getInstance().checkIsHasRoleSkin(SPECIAL_ID.LAN))
                            if (RoleManager.getInstance().getSign().state != 1)
                                UIManager.registerAutoOpenFunction(FUNCTION_TAG.SIGN, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.WINDOW, COMMON_MENU_STYLE.HIDE);
                        if (RoleManager.getInstance().getNewGiftInfo().state != 1 && !ConfigManager.isReviewVersion())
                            UIManager.registerAutoOpenFunction(FUNCTION_TAG.NEW_GIFT, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.WINDOW, COMMON_MENU_STYLE.HIDE, true);
                        let id = RoleManager.getInstance().getSuperEquipId();
                        if (id) {
                            UIManager.registerAutoOpenFunction(FUNCTION_TAG.SUPER_EQUIP, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.WINDOW, COMMON_MENU_STYLE.HIDE, {
                                id: id,
                                isEndOpen: false
                            });
                        }
                        if (RoleManager.getInstance().isShowTaskAtuo())
                            UIManager.registerAutoOpenFunction(FUNCTION_TAG.TASK, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.WINDOW, COMMON_MENU_STYLE.HIDE);
                    };
                    if (ConfigManager.platform == PLATFORM_TYPE.TT || ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.WEB_4399) {
                        if (!ConfigManager.isReviewVersion()) {
                            exec();
                        }
                    } else {
                        exec();
                    }
                }
                if (UIManager.autoList.length == 0 && FirstViewCtrl.isFirstView) {
                    FirstViewCtrl.isFirstView = false;
                }
            } else {
                if (!this.isFirstOnEnable) {
                    if (ConfigManager.appId == ANDROID_APP_ID.XM) {
                        ConfigManager.otherViewComBackMenu++;
                        console.log('ConfigManager.otherViewComBackMenu' + ConfigManager.otherViewComBackMenu);
                        if (ConfigManager.getInterstitial_times() != 0) {
                            if (ConfigManager.otherViewComBackMenu % ConfigManager.getInterstitial_times() == 0) {
                                AdUtil.createInterstitialAd();
                            }
                        }
                    }
                }
                if (!FirstViewCtrl.isFirstView)
                    if ((ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS && !this.isFirstOnEnable) ||
                        (ConfigManager.appId == ANDROID_APP_ID.C233_ME ||
                            ConfigManager.appId == ANDROID_APP_ID.MMY ||
                            ConfigManager.appId == ANDROID_APP_ID.HYKB) ||
                        ConfigManager.appId == ANDROID_APP_ID.C_233) {
                        if (UIManager.autoList.length == 0) {
                            let time = 40;
                            if (ConfigManager.appId == ANDROID_APP_ID.C_233) {
                                time = 30;
                            }
                            if (this.showInterstitialAdTime + time < RoleManager.getInstance().getTime()) {
                                this.showInterstitialAdTime = RoleManager.getInstance().getTime();
                                console.log(time + '后可弹出插屏');
                                AdUtil.createInterstitialAd();
                            }
                        }
                    }
                if (UIManager.autoList.length == 0 && FirstViewCtrl.isFirstView) {
                    FirstViewCtrl.isFirstView = false;
                }
            }
            if (GameScene.isLevelUp) {
                UIManager.registerAutoOpenFunction(FUNCTION_TAG.ACCOUNTUPGRADE, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE);
            } else {
                if (UIManager.autoList.length == 0) {
                    if (UIManager.newFunc.tag != FUNCTION_TAG.MORE_GAME) {
                        FirstFunction.jumpBackCount++;
                        console.log('ChannelManager.jumpBackGezi()', ChannelManager.jumpBackGezi());
                    }
                }
            }
            UIManager.triggerAutoOpen();
        }
        createProductGold() {
            this.productGold = new ProduceGoldCtrl(0, false);
            this.productGold.alpha = 0;
            this.boxGold.addChild(this.productGold);
        }
        updateProductGold() {
            if (this.productGold) {
                if (this.isProductAniPlay)
                    return;
                this.productGold.resetSetData(this.price);
                this.productGold.visible = true;
                this.productGold.x = 0;
                this.productGold.alpha = 0;
                Laya.Tween.clearAll(this.productGold);
                if (this.price > 0) {
                    this.isProductAniPlay = true;
                    this.productGold.y = 53;
                    this.productGold.alpha = 1;
                    Laya.Tween.to(this.productGold, {
                        y: 0
                    }, 500, null, Laya.Handler.create(this, () => {
                        Laya.Tween.to(this.productGold, {
                            y: -5,
                            alpha: 0
                        }, 800, null, Laya.Handler.create(this, () => {
                            Laya.Tween.clearAll(this.productGold);
                            this.isProductAniPlay = false;
                        }));
                    }), 200);
                    this.ani4.play(0, false);
                }
                this.price = 0;
            }
        }
        setActivityList() {
            this.activityList = [];
            if (RoleManager.getInstance().getNewGiftInfo().state != 1 && !ConfigManager.isReviewVersion()) {
                this.activityList.push(ACTIVITY_ENTRANCE.NEW_GIFT);
            }
            if (!RoleManager.getInstance().isHaveEquipById(SPECIAL_ID.RED_TASSEL_EQUIP)) {
                this.activityList.push(ACTIVITY_ENTRANCE.EQUIP_1);
            }
            if (!RoleManager.getInstance().isHaveEquipById(SPECIAL_ID.RED_SPIRIT_EQUIP)) {
                this.activityList.push(ACTIVITY_ENTRANCE.EQUIP_2);
            }
            if (RoleManager.getInstance().isCanGetActivityByType(ACTIVITY_TYPE.DOUBLE_FOX)) {
                this.activityList.push(ACTIVITY_ENTRANCE.ACTIVITY_EQUIP_1);
            }
            if (RoleManager.getInstance().isCanGetActivityByType(ACTIVITY_TYPE.BARRETT)) {
                this.activityList.push(ACTIVITY_ENTRANCE.ACTIVITY_EQUIP_2);
            }
            if (RoleManager.getInstance().isShowNewYearGift()) {
                this.activityList.push(ACTIVITY_ENTRANCE.NEW_YEAR_GIFT);
            }
            if (!RoleManager.getInstance().checkIsHasRoleSkin(SPECIAL_ID.LAN)) {
                this.activityList.push(ACTIVITY_ENTRANCE.DFL);
            }
        }
        setActivityView() {
            Laya.timer.clear(this, this.setActivityView);
            if (this.isTouchBoxLeft) {
                Laya.timer.once(5000, this, this.setActivityView);
                return;
            }
            this.setActivityList();
            if (this.activityIndex >= this.activityList.length) {
                this.activityIndex = 0;
            }
            for (let index = 1; index <= 4; index++) {
                const box = this['box' + index];
                box.visible = false;
            }
            let count = this.activityList.length >= 4 ? 4 : this.activityList.length;
            if (this.activityList.length > 0) {
                for (let index = 1, i = this.activityIndex; index <= count; index++) {
                    const element = this.activityList[i];
                    const box = this['box' + index];
                    const img = this['img' + index];
                    if (element) {
                        box.visible = true;
                        this.setActivityImg(img, element);
                        box.dataSource = element;
                    }
                    i += 1;
                    if (i >= this.activityList.length) {
                        i = 0;
                    }
                }
            }
            this.activityIndex++;
            Laya.timer.once(5000, this, this.setActivityView);
        }
        setActivityImg(img, entrance) {
            img.skin = 'sub1/ui/first/' + entrance + '.png';
        }
        registerAutoOpen() {
            let getPopUpRule = RoleManager.getInstance().getPopUpRule();
            console.log('弹窗规则:', getPopUpRule, '当前局数-（非本地“）', GameScene.realGameNum);
            if (getPopUpRule.isNew) {
                if (getPopUpRule.gameNum == 1) {
                    if (RoleManager.getInstance().getNewGiftInfo().state != 1 && !ConfigManager.isReviewVersion())
                        UIManager.registerAutoOpenFunction(FUNCTION_TAG.NEW_GIFT, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.WINDOW, COMMON_MENU_STYLE.HIDE, true);
                } else if (getPopUpRule.gameNum == 2) {
                    if (RoleManager.getInstance().getSign().state != 1)
                        UIManager.registerAutoOpenFunction(FUNCTION_TAG.SIGN, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.WINDOW, COMMON_MENU_STYLE.HIDE);
                } else if (getPopUpRule.gameNum == 3) {
                    let id = RoleManager.getInstance().getSuperEquipId();
                    if (id) {
                        UIManager.registerAutoOpenFunction(FUNCTION_TAG.SUPER_EQUIP, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.WINDOW, COMMON_MENU_STYLE.HIDE, {
                            id: id,
                            isEndOpen: false
                        });
                    }
                    RoleManager.getInstance().setPopUpRuleIsNew();
                } else {
                    if (getPopUpRule.gameNum >= 3) {
                        RoleManager.getInstance().setPopUpRuleIsNew();
                    }
                }
            } else {
                {
                    if (GameScene.popNum == POPUPLIST.length) {
                        GameScene.popNum = 0;
                    }
                    GameScene.popNum = Math.floor(Math.random() * POPUPLIST.length);
                    console.log('需要获取列表哪个字段:', GameScene.popNum);
                    let item = POPUPLIST[GameScene.popNum];
                    if (item == FUNCTION_TAG.NEW_GIFT) {
                        if (RoleManager.getInstance().getNewGiftInfo().state != 1 && !ConfigManager.isReviewVersion()) {
                            UIManager.registerAutoOpenFunction(FUNCTION_TAG.NEW_GIFT, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.WINDOW, COMMON_MENU_STYLE.HIDE, true);
                        } else {
                            GameScene.popNum++;
                            item = POPUPLIST[GameScene.popNum];
                        }
                    }
                    if (item == FUNCTION_TAG.ACT_GOLD_GUN) {
                        if (RoleManager.getInstance().getActGoldGunState() != 1) {
                            UIManager.registerAutoOpenFunction(FUNCTION_TAG.ACT_GOLD_GUN, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.WINDOW, COMMON_MENU_STYLE.HIDE, true);
                        } else {
                            GameScene.popNum++;
                            item = POPUPLIST[GameScene.popNum];
                        }
                    }
                    if (item == FUNCTION_TAG.SUPER_EQUIP) {
                        let id = RoleManager.getInstance().getSuperEquipId();
                        if (id) {
                            UIManager.registerAutoOpenFunction(FUNCTION_TAG.SUPER_EQUIP, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.WINDOW, COMMON_MENU_STYLE.HIDE, {
                                id: id,
                                isEndOpen: false
                            });
                        } else {
                            GameScene.popNum++;
                            item = POPUPLIST[GameScene.popNum];
                        }
                    }
                    if (item == FUNCTION_TAG.TURNTABLE) {
                        UIManager.registerAutoOpenFunction(FUNCTION_TAG.TURNTABLE, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.WINDOW, COMMON_MENU_STYLE.HIDE);
                    }
                    if (item == FUNCTION_TAG.TASK) {
                        UIManager.registerAutoOpenFunction(FUNCTION_TAG.TASK, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.WINDOW, COMMON_MENU_STYLE.HIDE);
                    }
                    GameScene.popNum++;
                }
            }
            UIManager.registerAutoOpenFunction(FUNCTION_TAG.GAMEBOX, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE, {
                viewType: 0
            });
        }
        isShowSuperEquip() {
            this.btnSuperEquip.visible = false;
            let id = RoleManager.getInstance().getSuperEquipId();
            if (id) {
                this.btnSuperEquip.visible = true;
            }
        }
    }
    FirstViewCtrl.isFirst = true;
    FirstViewCtrl.isFirstView = true;

    class NativeBanner1ViewCtrl extends ui.view.native.NativeBanner1ViewUI {
        constructor() {
            super();
            this.isCanRefresh = true;
            this.isFirstTouch = true;
            this.isCanAutoShow = true;
        }
        onAwake() {
            this.bottom = 10;
            this.on(Laya.Event.CLICK, this, this.onBtnAd);
            this.btnClose.on(Laya.Event.CLICK, this, this.onBtnClose);
            this.funcId = NotifyManager.register(NOTIFY_ID.REFRESH_NATIVE_AD, this.refresh, this);
            this.refresh();
        }
        onDestroy() {
            Laya.timer.clearAll(this);
            NotifyManager.unregisterByFuncId(this.funcId);
            LayaExtend.autoUnlinkUIReference(this);
            AdUtil.hideBannerAd();
        }
        onBtnAd() {
            if (!CommonUtil.getTouch())
                return;
            if (ConfigManager.platform == PLATFORM_TYPE.OPPO || ConfigManager.platform == PLATFORM_TYPE.VIVO) {
                AdUtil.nativeExtendList.ad && AdUtil.nativeExtendList.ad.reportAdClick({
                    adId: AdUtil.nativeExtendList.data.adId.toString()
                });
            }
            if (ConfigManager.platform == PLATFORM_TYPE.VIVO) {
                let that = this;
                AdUtil.preloadNativeAdExtend(function() {}, function() {}, NATIVE_TYPE.BANNER);
            }
        }
        onBtnClose() {
            this.destroy();
        }
        refresh() {
            if (!this.isCanRefresh)
                return;
            if (!this.imgAd)
                return;
            if (AdUtil.nativeExtendList.ad) {
                AdUtil.hideBannerAd();
                this.isCanAutoShow && this.show();
                if (ConfigManager.platform == PLATFORM_TYPE.OPPO || ConfigManager.platform == PLATFORM_TYPE.VIVO) {
                    AdUtil.nativeExtendList.ad && AdUtil.nativeExtendList.ad.reportAdShow({
                        adId: AdUtil.nativeExtendList.data.adId.toString()
                    });
                }
                this.imgAd.skin = AdUtil.nativeExtendList.data.imgUrlList[0];
            } else {
                this.autoHide();
                AdUtil.showBannerAd();
            }
        }
        hide() {
            if (this.destroyed)
                return;
            this.isCanAutoShow = false;
            this.mouseEnabled = false;
            this.visible = false;
        }
        autoHide() {
            this.mouseEnabled = false;
            this.visible = false;
        }
        show() {
            if (this.destroyed)
                return;
            this.isCanAutoShow = true;
            if (!AdUtil.nativeExtendList.ad)
                return;
            this.mouseEnabled = true;
            this.visible = true;
        }
    }

    class FirstFunction extends BaseFunction {
        createView() {
            this._viewCtrl = new FirstViewCtrl();
            return this._viewCtrl;
        }
        getFunctionName() {
            return '首页界面';
        }
        onEnter() {
            super.onEnter();
            if (ConfigManager.platform == PLATFORM_TYPE.OPPO || ConfigManager.platform == PLATFORM_TYPE.WEB) {
                this.nativeBanner = new NativeBanner1ViewCtrl();
                let view = this._viewCtrl;
                view.addChild(this.nativeBanner);
                this.nativeIcon = new NativeIcon1CellCtrl();
                view.addChild(this.nativeIcon);
                this.nativeIcon.x = 540;
                this.nativeIcon.y = 10;
                this.nativeBanner.x = 20;
            }
        }
        onExit() { super.onExit(); }
        onEnable() {
            super.onEnable();
            let view = this.viewCtrl;
            if (ConfigManager.platform == PLATFORM_TYPE.WX || ConfigManager.platform == PLATFORM_TYPE.QQ || ConfigManager.appId == ANDROID_APP_ID.XM) {
                if (PlatformUtil.isFullScreen()) {
                    AdUtil.showBannerAd(14, PlatformUtil.getBannerCenterPos().y + (PlatformUtil.isIOS() ? 30 : 0));
                }
            }
            view.onMyEnable();
            if (!GameScene.isReading) {
                if (this.nativeBanner) {
                    this.nativeBanner.x = 20;
                    this.nativeBanner.show();
                }
                this.nativeIcon && this.nativeIcon.show();
            } else {
                if (this.nativeBanner) {
                    this.nativeBanner.x = Laya.stage.width / 2 - this.nativeBanner.width / 2;
                    this.nativeBanner.show();
                }
            }
        }
        onDisbale() {
            super.onDisbale();
            let view = this.viewCtrl;
            view.onMyDisable();
            this.nativeBanner && this.nativeBanner.hide();
            this.nativeIcon && this.nativeIcon.hide();
            if (ConfigManager.platform == PLATFORM_TYPE.WX || ConfigManager.platform == PLATFORM_TYPE.QQ || ConfigManager.appId == ANDROID_APP_ID.XM)
                AdUtil.hideBannerAd();
        }
        setAllButtonAnalysePoint() {}
        request(cb) {
            cb();
        }
    }
    FirstFunction.jumpBackCount = 0;

    class RockerMoveViewCtrl extends ui.view.characterCtrl.RockerMoveViewUI {
        constructor(touchSp) {
            super();
            this.curTouchId = 0;
            this.isDown = false;
            this.angle = -1;
            this.radians = Math.PI;
            this.time = 0;
            this.vecDir = new Laya.Vector3();
            this.dir = new Laya.Point();
            this.globalToLocalPoint = new Laya.Point();
            this.frame = 0;
            this.isReset = false;
            this.isStartRest = false;
            this.keyCodeList = {};
            this.maxDistance = 0;
            this.touchRect = touchSp;
            if (ConfigManager.platform == PLATFORM_TYPE.WEB_4399 && Laya.Browser.onPC) {
                this.visible = false;
                Laya.stage.on(Laya.Event.KEY_DOWN, this, this.onKeyDown1);
                Laya.stage.on(Laya.Event.KEY_UP, this, this.onKeyUp1);
                Laya.stage.on(Laya.Event.KEY_PRESS, this, this.onKeyPress1);
            } else {
                this.touchRect.on(Laya.Event.MOUSE_DOWN, this, this.onMouseDown);
                this.touchRect.on(Laya.Event.MOUSE_OUT, this, this.onMouseUp);
                this.touchRect.on(Laya.Event.MOUSE_MOVE, this, this.onMove);
            }
            if (ConfigManager.platform == PLATFORM_TYPE.WEB_4399 && Laya.Browser.onPC) {}
            this.originPiont = new Laya.Point(this.width / 2, this.height / 2);
        }
        onDestroy() {
            Laya.stage.off(Laya.Event.KEY_DOWN, this, this.onKeyDown1);
            Laya.stage.off(Laya.Event.KEY_PRESS, this, this.onKeyPress1);
            Laya.stage.off(Laya.Event.KEY_UP, this, this.onKeyUp1);
            Laya.stage.off(Laya.Event.MOUSE_DOWN, this, this.onBtnDown);
        }
        onBtnDown() {
            let canvas = Laya.Browser.document.querySelector('canvas');
            canvas.requestPointerLock();
        }
        onMouseDown(e) {
            console.log('点击移动-----:', GameScene.handleType);
            this.ani1.stop();
            GameScene.touchCtrl(e.touchId, TOUCHIDSTATE.ADD);
            let view = UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME);
            if (view.listArm.hitTestPoint(e.stageX, e.stageY))
                return;
            if (GameScene.handleType != HANDLETYPE.ONLYMOVE && GameScene.handleType != HANDLETYPE.MOVEANDROT_TOUCHLEFTAFTER) {
                if (GameScene.handleType == HANDLETYPE.ONLYROT) {
                    this.visible = false;
                }
                return;
            }
            console.log('可以移动');
            this.curTouchId = e.touchId;
            this.pos(Laya.stage.mouseX - (this.width / 2), Laya.stage.mouseY - (this.height / 2));
            this.imgKnob.pos(this.width / 2, this.height / 2);
            this.visible = true;
            this.angle = 0;
            this.setOrientation();
            view.hideMoveGuide();
        }
        onMouseUp(e) {
            console.log('取消移动:', GameScene.handleType);
            if (GameScene.handleType == HANDLETYPE.ONLYROT)
                return;
            if (e.touchId != this.curTouchId) {
                return;
            } else {
                CharacterManger.playerLogicalBaseLayer.setIsMoving = false;
            }
            console.log('可以取消移动');
            this.visible = false;
            this.radians = this.angle = -1;
            this.dir.x = 0;
            this.dir.y = 0;
            this.setOrientation();
        }
        onMove(e) {
            GameScene.touchCtrl(e.touchId, TOUCHIDSTATE.NORMAL);
            if (GameScene.handleType == HANDLETYPE.ONLYROT)
                return;
            if (e.touchId != this.curTouchId)
                return;
            CharacterManger.playerLogicalBaseLayer.setIsMoving = true;
            this.globalToLocalPoint.x = Laya.stage.mouseX;
            this.globalToLocalPoint.y = Laya.stage.mouseY;
            let locationPos = this.globalToLocal(this.globalToLocalPoint, false);
            this.imgKnob.pos(locationPos.x, locationPos.y);
            this.deltaX = locationPos.x - this.originPiont.x;
            this.deltaY = locationPos.y - this.originPiont.y;
            var dx = this.deltaX * this.deltaX;
            var dy = this.deltaY * this.deltaY;
            this.angle = Math.atan2(this.deltaX, this.deltaY) * 180 / Math.PI;
            if (this.angle < 0)
                this.angle += 360;
            this.angle = Math.round(this.angle);
            this.radians = Math.PI / 180 * this.angle;
            if (dx + dy >= 90 * 90) {
                var x = Math.floor(Math.sin(this.radians) * 90 + this.originPiont.x);
                var y = Math.floor(Math.cos(this.radians) * 90 + this.originPiont.y);
                this.imgKnob.pos(x, y);
            } else {
                this.imgKnob.pos(locationPos.x, locationPos.y);
            }
            this.setOrientation();
        }
        setOrientation() {
            if (this.radians == -1) {
                CharacterManger.playerLogicalBaseLayer.setSpeed = 0;
                return;
            }
            CharacterManger.playerLogicalBaseLayer.setSpeed = 0.12;
            let posX = 0;
            let posZ = 0;
            let angleAll = this.angle + CharacterManger.playerLogicalBaseLayer.getPresentationBaseLayer().getOnceChild().transform.localRotationEulerY;
            let rad = Math.PI / 180 * angleAll;
            posX = -Math.sin(rad) * CharacterManger.playerLogicalBaseLayer.getSpeed();
            posZ = -Math.cos(rad) * CharacterManger.playerLogicalBaseLayer.getSpeed();
            CharacterManger.playerLogicalBaseLayer.setMyOrientation(posX, 0, posZ);
        }
        onEnable() {}
        onDisable() {}
        onKeyDown1(e) {
            this.keyCodeList[e.keyCode] = 1;
            switch (e.keyCode) {
                case 65:
                    this.dir.x = -1;
                    this.dir.y = 0;
                    if (this.keyCodeList[68])
                        this.dir.x = 0;
                    if (this.keyCodeList[87])
                        this.dir.y = -1;
                    if (this.keyCodeList[83])
                        this.dir.y = 1;
                    break;
                case 87:
                    this.dir.x = 0;
                    this.dir.y = -1;
                    if (this.keyCodeList[65])
                        this.dir.x = -1;
                    if (this.keyCodeList[68])
                        this.dir.x = 1;
                    if (this.keyCodeList[83])
                        this.dir.y = 0;
                    break;
                case 68:
                    this.dir.x = 1;
                    this.dir.y = 0;
                    if (this.keyCodeList[87])
                        this.dir.y = -1;
                    if (this.keyCodeList[65])
                        this.dir.x = 0;
                    if (this.keyCodeList[83])
                        this.dir.y = 1;
                    break;
                case 83:
                    this.dir.x = 0;
                    this.dir.y = 1;
                    if (this.keyCodeList[65])
                        this.dir.x = -1;
                    if (this.keyCodeList[68])
                        this.dir.x = 1;
                    if (this.keyCodeList[87])
                        this.dir.y = 0;
                    break;
            }
            if (this.dir.x != 0 || this.dir.y != 0) {
                GameScene.touchCtrl(1111, TOUCHIDSTATE.ADD);
                GameScene.touchCtrl(e.touchId, TOUCHIDSTATE.NORMAL);
                CharacterManger.playerLogicalBaseLayer.setIsMoving = true;
                CharacterManger.playerLogicalBaseLayer.setSpeed = 0.12;
                this.angle = Math.atan2(this.dir.x, this.dir.y) * 180 / Math.PI;
                if (this.angle < 0)
                    this.angle += 360;
                this.angle = Math.round(this.angle);
                this.radians = Math.PI / 180 * this.angle;
                this.setOrientation();
            }
        }
        onKeyPress1(e) {
            this.keyCodeList[e.keyCode] = 1;
            switch (e.keyCode) {
                case 65:
                    this.dir.x = -1;
                    this.dir.y = 0;
                    if (this.keyCodeList[68])
                        this.dir.x = 0;
                    if (this.keyCodeList[87])
                        this.dir.y = -1;
                    if (this.keyCodeList[83])
                        this.dir.y = 1;
                    break;
                case 87:
                    this.dir.x = 0;
                    this.dir.y = -1;
                    if (this.keyCodeList[65])
                        this.dir.x = -1;
                    if (this.keyCodeList[68])
                        this.dir.x = 1;
                    if (this.keyCodeList[83])
                        this.dir.y = 0;
                    break;
                case 68:
                    this.dir.x = 1;
                    this.dir.y = 0;
                    if (this.keyCodeList[87])
                        this.dir.y = -1;
                    if (this.keyCodeList[65])
                        this.dir.x = 0;
                    if (this.keyCodeList[83])
                        this.dir.y = 1;
                    break;
                case 83:
                    this.dir.x = 0;
                    this.dir.y = 1;
                    if (this.keyCodeList[65])
                        this.dir.x = -1;
                    if (this.keyCodeList[68])
                        this.dir.x = 1;
                    if (this.keyCodeList[87])
                        this.dir.y = 0;
                    break;
            }
            if (this.dir.x != 0 || this.dir.y != 0) {
                GameScene.touchCtrl(e.touchId, TOUCHIDSTATE.NORMAL);
                CharacterManger.playerLogicalBaseLayer.setIsMoving = true;
                CharacterManger.playerLogicalBaseLayer.setSpeed = 0.12;
                this.angle = Math.atan2(this.dir.x, this.dir.y) * 180 / Math.PI;
                if (this.angle < 0)
                    this.angle += 360;
                this.angle = Math.round(this.angle);
                this.radians = Math.PI / 180 * this.angle;
                this.setOrientation();
            }
        }
        onKeyUp1(e) {
            console.log(e.keyCode);
            this.keyCodeList[e.keyCode] = 0;
            switch (e.keyCode) {
                case 65:
                    this.dir.x = 0;
                    this.dir.y = 0;
                    if (this.keyCodeList[68])
                        this.dir.x = 1;
                    if (this.keyCodeList[87])
                        this.dir.y = -1;
                    if (this.keyCodeList[83])
                        this.dir.y = 1;
                    break;
                case 87:
                    this.dir.x = 0;
                    this.dir.y = 0;
                    if (this.keyCodeList[65])
                        this.dir.x = -1;
                    if (this.keyCodeList[68])
                        this.dir.x = 1;
                    if (this.keyCodeList[83])
                        this.dir.y = 1;
                    break;
                case 68:
                    this.dir.x = 0;
                    this.dir.y = 0;
                    if (this.keyCodeList[87])
                        this.dir.y = -1;
                    if (this.keyCodeList[65])
                        this.dir.x = -1;
                    if (this.keyCodeList[83])
                        this.dir.y = 1;
                    break;
                case 83:
                    this.dir.x = 0;
                    this.dir.y = 0;
                    if (this.keyCodeList[65])
                        this.dir.x = -1;
                    if (this.keyCodeList[68])
                        this.dir.x = 1;
                    if (this.keyCodeList[87])
                        this.dir.y = -1;
                    break;
            }
            if (!this.keyCodeList[65] && !this.keyCodeList[87] && !this.keyCodeList[68] && !this.keyCodeList[83]) {
                this.dir.x = 0;
                this.dir.y = 0;
                CharacterManger.playerLogicalBaseLayer.setIsMoving = false;
                CharacterManger.playerLogicalBaseLayer.setSpeed = 0;
            } else {
                this.angle = Math.atan2(this.dir.x, this.dir.y) * 180 / Math.PI;
                if (this.angle < 0)
                    this.angle += 360;
                this.angle = Math.round(this.angle);
                this.radians = Math.PI / 180 * this.angle;
                this.setOrientation();
            }
        }
    }

    class SingleBroadcastCtrl extends ui.view.game.SingleBroadcastUI {
        constructor(killerIsPlayer, beKillerIsPlayer, killer, beKiller, type, isHitLocation, killerLogic) {
            super();
            this.killerLogic = null;
            this.txtKiller.text = killer;
            this.txtBeKiller.text = beKiller;
            if (killerIsPlayer) {
                this.txtKiller.color = '#3398FF';
            } else {
                this.txtKiller.color = '#FF351A';
            }
            if (beKillerIsPlayer) {
                this.txtBeKiller.color = '#3398FF';
            } else {
                this.txtBeKiller.color = '#FF351A';
            }
            console.log('killer:', killer, 'beKiller:', beKiller);
            if (killer == '我') {
                this.txtKiller.color = '#FFFFFF';
            }
            if (beKiller == '我') {
                this.txtBeKiller.color = '#FFFFFF';
            }
            this.killerLogic = killerLogic;
            if (this.killerLogic.getArmCtrl()) {
                this.imgIcon.skin = this.killerLogic.getArmCtrl().getIcon();
            }
            if (type == ARM_TYPE.BOMB) {
                this.imgIcon.skin = PROP.getDataByKey(8001).icon;
            }
            if (isHitLocation) {
                this.update();
            } else {
                this.boxHead.visible = false;
            }
        }
        onDestroy() {
            this.txtBeKiller = null;
            this.txtKiller = null;
        }
        setView(killerIsPlayer, beKillerIsPlayer, killer, beKiller, type, isHitLocation, killerLogic) {
            this.txtKiller.text = killer;
            this.txtBeKiller.text = beKiller;
            if (killerIsPlayer) {
                this.txtKiller.color = '#3398FF';
            } else {
                this.txtKiller.color = '#FF351A';
            }
            if (beKillerIsPlayer) {
                this.txtBeKiller.color = '#3398FF';
            } else {
                this.txtBeKiller.color = '#FF351A';
            }
            console.log('killer:', killer, 'beKiller:', beKiller);
            if (killer == '我') {
                this.txtKiller.color = '#FFFFFF';
            }
            if (beKiller == '我') {
                this.txtBeKiller.color = '#FFFFFF';
            }
            this.killerLogic = killerLogic;
            if (this.killerLogic.getArmCtrl()) {
                this.imgIcon.skin = this.killerLogic.getArmCtrl().getIcon();
            }
            if (type == ARM_TYPE.BOMB) {
                this.imgIcon.skin = PROP.getDataByKey(8001).icon;
            }
            if (isHitLocation) {
                this.update();
            } else {
                this.boxHead.visible = false;
            }
        }
        update() {
            this.boxHead.visible = true;
        }
    }

    class BroadcastViewCtrl extends ui.view.game.BroadcastViewUI {
        constructor() {
            super();
            this.broadcastList = [];
        }
        onAwake() {
            this.timerLoop(10000, this, this.update);
            NotifyManager.register(NOTIFY_ID.KILL_BROADCAST, this.refreshKillBroadcast, this);
        }
        onDestroy() {
            this.timer.clearAll(this);
            this.broadcastList = null;
            NotifyManager.unregisterByEventId(NOTIFY_ID.KILL_BROADCAST);
        }
        update() {
            if (this.broadcastList.length == 0)
                return;
            this.broadcastList[0].visible = false;
            let y = this.broadcastList[this.broadcastList.length - 1].y;
            let item0 = this.broadcastList[0];
            for (let k = 0; k < this.broadcastList.length; k++) {
                if (k != 0) {
                    this.broadcastList[k - 1] = this.broadcastList[k];
                    this.broadcastList[k - 1].y = 40 * (k - 1);
                }
            }
            this.broadcastList[this.broadcastList.length - 1] = item0;
            this.broadcastList[this.broadcastList.length - 1].y = y;
        }
        refreshKillBroadcast(arg) {
            if (this.broadcastList.length == 0) {
                let item;
                item = new SingleBroadcastCtrl(arg.killerIsPlayer, arg.beKillerIsPlayer, arg.killer, arg.beKiller, arg.armType, arg.isHitLocation, arg.killerLogic);
                this.addChild(item);
                this.broadcastList.push(item);
            } else {
                if (!this.broadcastList[this.broadcastList.length - 1].visible) {
                    this.broadcastList[this.broadcastList.length - 1].visible = true;
                    this.broadcastList[this.broadcastList.length - 1].setView(arg.killerIsPlayer, arg.beKillerIsPlayer, arg.killer, arg.beKiller, arg.armType, arg.isHitLocation, arg.killerLogic);
                } else {
                    if (this.broadcastList.length == 4) {
                        let y = this.broadcastList[this.broadcastList.length - 1].y;
                        let item0 = this.broadcastList[0];
                        for (let k = 0; k < this.broadcastList.length; k++) {
                            if (k != 0) {
                                this.broadcastList[k - 1] = this.broadcastList[k];
                                this.broadcastList[k - 1].y = 40 * (k - 1);
                            }
                        }
                        this.broadcastList[this.broadcastList.length - 1] = item0;
                        this.broadcastList[this.broadcastList.length - 1].y = y;
                        this.broadcastList[this.broadcastList.length - 1].setView(arg.killerIsPlayer, arg.beKillerIsPlayer, arg.killer, arg.beKiller, arg.armType, arg.isHitLocation, arg.killerLogic);
                    } else {
                        let item;
                        item = new SingleBroadcastCtrl(arg.killerIsPlayer, arg.beKillerIsPlayer, arg.killer, arg.beKiller, arg.armType, arg.isHitLocation, arg.killerLogic);
                        item.y = 40 + 40 * (this.broadcastList.length - 1);
                        this.addChild(item);
                        this.broadcastList.push(item);
                    }
                }
            }
        }
    }

    var ARM_STATE;
    (function(ARM_STATE) {
        ARM_STATE["NORMAL"] = "NORMAL";
        ARM_STATE["CHOOSE"] = "CHOOSE";
    })(ARM_STATE || (ARM_STATE = {}));
    class GameArmItemCtrl extends ui.view.game.GameArmItemUI {
        constructor(data, viewCtrl) {
            super();
            this.myIndex = 0;
            this.myView = null;
            this.data = data;
            this.myView = viewCtrl;
            this.setView();
        }
        onAwake() {
            this.on(Laya.Event.MOUSE_DOWN, this, this.onBtnTouch);
        }
        onDestroy() {}
        onBtnTouch() {
            if (CharacterManger.playerLogicalBaseLayer) {
                if (CharacterManger.playerLogicalBaseLayer.getPresentationBaseLayer().isThrowing)
                    return;
                if (CharacterManger.playerLogicalBaseLayer.isOpenMioing)
                    return;
                CharacterManger.playerLogicalBaseLayer.setIsTouchAttack = false;
            }
            this.myView.onArmSelect(this.myIndex);
        }
        setView() {
            this.myIndex = this.data.index;
            this.box2.visible = false;
            this.box1.visible = false;
            if (this.data.armType == ARM_TYPE.BOMB || this.data.armType == ARM_TYPE.KNIFE) {
                this.box2.visible = true;
                this.box = this.box2;
            } else {
                this.box1.visible = true;
                this.box = this.box1;
            }
            this.width = this.box.width;
            this.getNameAs('imgIcon', this.box).skin = this.data.icon;
            this.setState(this.data.state);
        }
        setState(state) {
            if (state == ARM_STATE.CHOOSE) {
                this.getNameAs('imgTrue', this.box).visible = true;
                this.getNameAs('imgSelect', this.box).visible = true;
            } else {
                this.getNameAs('imgTrue', this.box).visible = false;
                this.getNameAs('imgSelect', this.box).visible = false;
            }
            this.getNameAs('txtData', this.box).visible = true;
            this.getNameAs('txtAll', this.box).visible = true;
            this.getNameAs('txtData', this.box).text = this.data.magazineBullet.toString();
            this.getNameAs('txtAll', this.box).text = '/' + this.data.bullets.toString();
            if (this.data.armType == ARM_TYPE.KNIFE) {
                this.getNameAs('txtAll', this.box).visible = false;
                this.getNameAs('txtData', this.box).visible = false;
            }
            if (this.data.armType == ARM_TYPE.BOMB) {
                this.getNameAs('txtAll', this.box).visible = false;
                this.getNameAs('txtData', this.box).text = this.data.bullets.toString();
            }
        }
        getNameAs(name, box) {
            return box.getChildByName(name);
        }
    }

    class MatchSituationCtrl extends ui.view.game.MatchSituationUI {
        constructor() {
            super();
            this.centerX = 0;
            this.centerY = -264;
        }
        onAwake() {
            NotifyManager.register(NOTIFY_ID.MATCH_KILL, this.refreshData, this);
        }
        onDestroy() {
            this.txtContent = null;
            this.txtData = null;
            NotifyManager.unregisterByEventId(NOTIFY_ID.MATCH_KILL);
        }
        refreshData(args) {
            this.ani1.play(0, false);
            if (args.type == WHO_KILL.ENEMY) {
                this.txtContent.text = '敌方剩余分数：';
                this.txtData.text = (TaskManager.targetKillSore - CharacterManger.enemyKillScore).toString();
            } else if (args.type == WHO_KILL.FRIEND) {
                this.txtContent.text = '我方剩余分数：';
                this.txtData.text = (TaskManager.targetKillSore - CharacterManger.ourKillScore).toString();
            }
        }
    }

    class PlayerKillBroadcastCtrl extends ui.view.game.PlayerKillBroadcastUI {
        constructor() {
            super();
            this.alpha = 0;
            if (!CharacterManger.targetLogicalBaseLayer)
                return;
            let str = '击杀了';
            if (!ConfigManager.getViolenceCtrl())
                str = '击倒了';
            this.txttKill.text = '你使用' + CharacterManger.playerLogicalBaseLayer.getArmCtrl().getArmName() + str + CharacterManger.targetLogicalBaseLayer.gameName;
        }
        onAwake() {
            NotifyManager.register(NOTIFY_ID.PLAYER_KILL_DETAILS, this.setView, this);
        }
        onDestroy() {
            Laya.Tween.clearAll(this);
            this.txttKill = null;
            NotifyManager.unregisterByEventId(NOTIFY_ID.PLAYER_KILL_DETAILS);
        }
        setView(args) {
            if (!CharacterManger.targetLogicalBaseLayer)
                return;
            if (ModeManager.mode == GAME_MODE_TYPE.BIOCHEMISTRY)
                return;
            let str = '击杀了';
            if (!ConfigManager.getViolenceCtrl())
                str = '击倒了';
            this.txttKill.text = '你使用' + args.armName + str + args.targetName;
            Laya.Tween.clearAll(this);
            Laya.Tween.to(this, {
                alpha: 1
            }, 350, null, Laya.Handler.create(this, () => {
                Laya.Tween.to(this, {
                    alpha: 0
                }, 350, null, Laya.Handler.create(this, () => {}), 2000);
            }));
        }
    }

    class RescuingItemCtrl extends ui.view.game.RescuingItemUI {
        constructor() {
            super();
            this.isDoing = false;
            this.coutDown = 2000;
            this.isInterrupt = false;
            this.fixCountDown = 2000;
        }
        onAwake() {
            this.sprPie.removeSelf();
        }
        fire(cb) {
            if (this.isDoing)
                return false;
            this.isDoing = true;
            this.txtTime.visible = true;
            this.imgMask.visible = true;
            this.coutDown = this.fixCountDown;
            this.txtTime.text = Math.ceil(this.coutDown / 1000).toString() + 's';
            this.drawMask();
            this.box.gray = true;
            Laya.timer.loop(20, this, function() {
                if (this.isInterrupt) {
                    Laya.timer.clearAll(this);
                    return;
                }
                this.coutDown -= 20;
                this.txtTime.text = Math.ceil(this.coutDown / 1000).toString() + 's';
                this.drawMask();
                if (this.coutDown <= 0) {
                    this.isDoing = false;
                    Laya.timer.clearAll(this);
                    this.imgMask.visible = true;
                    this.box.gray = false;
                    this.isInterrupt = false;
                    cb();
                }
            });
        }
        drawMask() {
            this.sprPie.graphics.clear();
            this.sprPie.graphics.drawPie(32, 32, 200, 360 - 90, -90 + (1 - ((this.coutDown - this.fixCountDown) / this.fixCountDown)) * 360, "#ff0000");
            this.imgMask.mask = null;
            this.imgMask.mask = this.sprPie;
        }
        resetCoutDown() {
            this.coutDown = this.fixCountDown;
            this.isDoing = false;
        }
    }

    class ZombieComingViewCtrl extends ui.view.game.ZombieComingViewUI {
        constructor() {
            super();
            this.anchorX = .5;
            this.anchorY = .5;
            this.visible = false;
            this.x = Laya.stage.width / 2;
            this.y = Laya.stage.height / 2 - 20;
        }
        onAwake() {
            this.setData();
        }
        onDestroy() {
            this.imgZomBieComingBg = null;
            this.imgZombieComing = null;
        }
        setData() {
            if (BiochemistryManager.round == 1) {
                this.imgZombieComing.skin = RES_PATH.ZOMBIEMODE_GAMING_UI.ROUND_UI.ONE;
            } else if (BiochemistryManager.round == 2) {
                this.imgZombieComing.skin = RES_PATH.ZOMBIEMODE_GAMING_UI.ROUND_UI.TWO;
            } else if (BiochemistryManager.round == 3) {
                this.imgZombieComing.skin = RES_PATH.ZOMBIEMODE_GAMING_UI.ROUND_UI.THREE;
            }
        }
        start() {
            this.visible = true;
            this.ani1.play(0, true);
        }
        stop() {
            this.timer.once(2000, this, function cd() {
                this.visible = false;
                this.ani1.stop();
            });
        }
    }

    class GameViewCtrl extends ui.view.game.GameViewUI {
        constructor() {
            super();
            this.playerKillBroadcastCtrl = null;
            this.matchSituationCtrl = null;
            this.isTouchRightAttack = false;
            this.isTouchLeftAttack = false;
            this.curIndex = 0;
            this.curTouchId = 0;
            this.ZomBieComingView = null;
            this.rescuingItemCtrl = null;
            this.touchNum = 0;
            this.moveCtrl = null;
            this.fingerCtrl = null;
            this.step = 1;
            this.isToGudeAttack = false;
            this.isOpenGun = false;
            this.isAutoOpen = false;
            this.armCellCtrlList = [];
            this.recordSec = 0;
            this.lastArmIndex = 0;
            this.isCameraMove = false;
            this.isOpenCamera = false;
            this.isHideImgEnemy = false;
            this.height = this.stage.height;
            this.width = this.stage.width;
            this.canvas = Laya.Browser.document.querySelector('canvas');
            document.addEventListener('pointerlockchange', this.lockChangeAlert, false);
            document.addEventListener('mozpointerlockchange', this.lockChangeAlert, false);
        }
        onAwake() {
            if (ConfigManager.platform == PLATFORM_TYPE.VIVO) {
                SoundManager.playEffect(SOUND_PATH.KILL_HEADSHOT, 1, false, 0.1);
            }
            this.maxHpWigth = this.imgEnemyHp.width;
            if (ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.TT) {
                this.btnRecord.visible = false;
                this.btnRecording.visible = false;
                this.btnShare.visible = false;
                this.startRecord();
            } else {
                this.btnRecord.visible = false;
                this.btnRecording.visible = false;
                this.btnShare.visible = false;
            }
        }
        start() {
            if (DifficultyManager.curDifficult == 0) {
                console.log('难度等级：【容易】');
                this.txtCurDiff.text = '难度等级：【容易】';
            } else if (DifficultyManager.curDifficult == 1) {
                console.log('难度等级：【正常】');
                this.txtCurDiff.text = '难度等级：【正常】';
            } else if (DifficultyManager.curDifficult == 2) {
                console.log('难度等级：【偏难】');
                this.txtCurDiff.text = '难度等级：【偏难】';
            } else if (DifficultyManager.curDifficult == 3) {
                console.log('难度等级：【困难】');
                this.txtCurDiff.text = '难度等级：【困难】';
            }
            this.init();
            this.setData();
            this.setBtnEvent();
            this.setGameEvent();
            if (ConfigManager.platform == PLATFORM_TYPE.WEB_4399 && Laya.Browser.onPC) {
                CharacterManger.fisrtPoint = null;
                CharacterManger.playerLogicalBaseLayer.setMouseX = null;
                CharacterManger.playerLogicalBaseLayer.setMouseY = null;
                this.btnJump.visible = false;
                this.btnRightAttack.visible = false;
                this.btnLeftAttack.visible = false;
                this.btnCloseMirror.alpha = 0;
                this.btnLeftAttack.alpha = 0;
                this.btnLeftAttack.off(Laya.Event.MOUSE_DOWN, this, this.onBtnLeftAttackDown);
                this.btnAmmunitionChange.visible = false;
                this.btnGiveUp.visible = false;
                this.btnConvenient.visible = false;
                Laya.stage.on(Laya.Event.KEY_DOWN, this, this.onKeyDown);
                this.onBtnAutoAttack();
            }
            let that = this;
            this.timer.frameLoop(1, this, () => {
                if (CharacterManger.gameOver)
                    return;
                if (this.isTouchRightAttack) {
                    if (CharacterManger.playerLogicalBaseLayer.getArmCtrl()) {
                        if (CharacterManger.playerLogicalBaseLayer.getArmCtrl().getType() == 3) {
                            if (!CharacterManger.playerLogicalBaseLayer.isStartAttack && !CharacterManger.playerLogicalBaseLayer.isOpenMioing) {
                                if (!this.isAutoOpen) {
                                    this.isAutoOpen = true;
                                    that.attack();
                                }
                            }
                        }
                    }
                }
                if (CharacterManger.targetLogicalBaseLayer) {
                    this.setEnemyHp(CharacterManger.targetLogicalBaseLayer);
                } else {
                    this.hideEnemyHp();
                }
                if (CharacterManger.playerLogicalBaseLayer.getPresentationBaseLayer().bombSp) {
                    let ctrl = CharacterManger.playerLogicalBaseLayer.getPresentationBaseLayer().bombSp.getComponent(BombCtrl);
                    if (ctrl) {
                        if (ctrl.bombCount <= 0) {
                            that.imgBomb.visible = false;
                        } else
                            that.bombTime.text = (Math.floor(ctrl.bombCount / 1000) + 1).toString();
                    } else {
                        that.imgBomb.visible = false;
                    }
                }
            });
        }
        onBtnDown(viewEnd = false) {
            if (UIManager.funcList.length > 1 && viewEnd == false)
                return;
            console.log('锁定鼠标');
            window.focus();
            this.canvas.requestPointerLock();
            this.canvas.removeEventListener('mousemove', this.mouseMove);
            this.canvas.addEventListener('mousemove', this.mouseMove, false);
        }
        lockChangeAlert() {
            if (document.pointerLockElement === this.canvas ||
                Laya.Browser.document.mozPointerLockElement === this.canvas) {
                console.log('The pointer lock status is now locked');
            } else {
                console.log('The pointer lock status is now unlocked');
            }
        }
        mouseMove(e) {
            let data = {
                stageX: e.movementX * 0.7,
                stageY: e.movementY * 0.7
            };
            CharacterManger.playerLogicalBaseLayer.setDirection(null, data);
        }
        onKeyDown(e) {
            switch (e.keyCode) {
                case 32:
                    CharacterManger.playerLogicalBaseLayer.getPresentationBaseLayer().jump();
                    break;
                case 81:
                    {
                        this.onBtnConvenient();
                    }
                    break;
                case 82:
                    this.onBtnAmmunitionChange();
                    break;
                case 71:
                    this.onBtnGiveUp();
                    break;
                case 69:
                    this.onBtnRescue();
                    break;
            }
            if (e.keyCode <= 57 && e.keyCode > 47) {
                let length = e.keyCode == 48 ? 10 : e.keyCode - 48;
                if (length <= this.armCellCtrlList.length) {
                    if (CharacterManger.playerLogicalBaseLayer) {
                        if (!CharacterManger.playerLogicalBaseLayer.isOpenMioing)
                            CharacterManger.playerLogicalBaseLayer.setIsTouchAttack = false;
                    }
                    if (!CharacterManger.playerLogicalBaseLayer.isOpenMioing) {
                        if (e.keyCode == 48) {
                            this.lastArmIndex = this.curIndex;
                            this.onArmSelect(9);
                        } else {
                            this.lastArmIndex = this.curIndex;
                            console.log('武器索引:', e.keyCode - 49);
                            this.onArmSelect(e.keyCode - 49);
                        }
                    }
                }
            }
        }
        setNewPlayerArm() {
            let that = this;
            if (ConfigManager.isReviewVersion() && ConfigManager.gameType == GAME_MJB_TYPE.QZHXJY)
                return;
            if (RoleManager.getInstance().isNew && GameScene.gameNum == 1 && (ModeManager.mode != GAME_MODE_TYPE.SNIPERMODE && ModeManager.mode != GAME_MODE_TYPE.ONEVSONEMODE && ModeManager.mode != GAME_MODE_TYPE.KNIFEWARMODE)) {
                CharacterManger.gameStop = true;
                UIManager.openFunction(FUNCTION_TAG.NEWPLAYERTRYARM, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.WINDOW, COMMON_MENU_STYLE.HIDE, {
                    cb: function(id) {
                        CharacterManger.playerLogicalBaseLayer.getSuperArmByNew(id);
                        if (ModeManager.mode != GAME_MODE_TYPE.BIOCHEMISTRY) {
                            that.modeFunc();
                        }
                    }
                });
            } else {
                if (ModeManager.mode != GAME_MODE_TYPE.BIOCHEMISTRY) {
                    that.modeFunc();
                }
            }
        }
        onDestroy() {
            let that = this;
            this.endRecord(false);
            this.timer.clearAll(this);
            this.txtCurEnePro = null;
            this.txtCurFriPro = null;
            this.txtCurTask = null;
            this.txtCurTime = null;
            this.txtHP = null;
            this.txtMySelfWarSituation = null;
            this.boxCenter = null;
            this.boxWarSituation = null;
            this.matchSituationCtrl = null;
            this.playerKillBroadcastCtrl = null;
            this.imgHP = null;
            this.imgMirror = null;
            Laya.stage.off(Laya.Event.KEY_DOWN, this, this.onKeyDown);
            this.canvas.removeEventListener('mousemove', this.mouseMove);
            this.canvas.removeEventListener('mouseup', this.mouseUpHandle, false);
            this.canvas.removeEventListener('mousedown', this.mouseDownHandle, false);
            NotifyManager.unregisterByEventId(NOTIFY_ID.KILL);
            NotifyManager.unregisterByEventId(NOTIFY_ID.REFRESH_PLAYER_HP_UI);
            NotifyManager.unregisterByEventId(NOTIFY_ID.PLAYER_WAR_SITUATION);
            NotifyManager.unregisterByEventId(NOTIFY_ID.REFRESH_MAIN_ARM);
            NotifyManager.unregisterByEventId(NOTIFY_ID.REFRESH_PLAYER_ARMOR_UI);
        }
        init() {
            console.log('当前游戏内部指引步骤：', RoleManager.getInstance().getGuide());
            this.fingerCtrl = GuideManager.createFingerAniCtrl(this);
            SoundManager.stopBGM();
            this.modelCtrl();
            this.setMirrorScale();
            CharacterManger.addHead();
            Laya.MouseManager.multiTouchEnabled = true;
            this.playerKillBroadcastCtrl = new PlayerKillBroadcastCtrl();
            this.addChild(this.playerKillBroadcastCtrl);
            this.playerKillBroadcastCtrl.centerX = 0;
            this.playerKillBroadcastCtrl.bottom = 133;
            let view = new RockerMoveViewCtrl(this);
            view.x = view.width + 100;
            view.y = this.stage.height - view.height - 100;
            this.boxJoystick.addChild(view);
            this.moveCtrl = view;
            this.setGuide();
            this.boxWarSituation.addChild(new BroadcastViewCtrl());
            this.matchSituationCtrl = new MatchSituationCtrl();
            this.addChild(this.matchSituationCtrl);
            let str = '击杀:';
            if (!ConfigManager.getViolenceCtrl())
                str = '击倒:';
            this.txtMySelfWarSituation.text = str + 0 + ' 被淘汰：' + 0;
            if (ModeManager.mode == GAME_MODE_TYPE.BIOCHEMISTRY) {
                this.txtPlayerZombieKillNum.text = str + 0;
            }
        }
        setGuide() {
            if (RoleManager.getInstance().getGuide() != GuideStep.FINISH && RoleManager.getInstance().getGuide() != GuideStep.MAX) {
                if (this.step == 1) {
                    console.log('设置移动指引');
                    this.fingerCtrl.stop();
                    this.moveCtrl.ani1.play(0, false);
                } else if (this.step == 2) {
                    console.log('设置攻击指引');
                    this.fingerCtrl.visible = true;
                    let point1 = new Laya.Point(this.btnRightAttack.width / 2, this.btnRightAttack.height / 2);
                    let a = this.btnRightAttack.localToGlobal(point1);
                    this.setGudePos(a);
                    this.fingerCtrl.play();
                }
            }
        }
        hideMoveGuide() {
            if (this.step == 1) {
                if (this.fingerCtrl) {
                    this.fingerCtrl.visible = false;
                }
                this.step++;
            }
        }
        hideAttackGuide() {
            if (this.isToGudeAttack) {
                if (this.step == 2) {
                    if (this.fingerCtrl) {
                        this.fingerCtrl.visible = false;
                    }
                    this.step++;
                }
            }
        }
        setGudePos(a) {
            this.fingerCtrl.visible = true;
            this.fingerCtrl.play();
            this.fingerCtrl.x = a.x;
            this.fingerCtrl.y = a.y;
        }
        modelCtrl() {
            this.btnRescue.visible = false;
            this.rescuing.visible = false;
            this.boxTopBiochemical.visible = false;
            this.boxTopNonBiochemical.visible = false;
            this.boxLeftBiochemical.visible = false;
            this.boxLeftNonBiochemical.visible = false;
            this.txtTeamDown.visible = false;
            this.txtZomBieAppearDown.visible = false;
            this.txtZomBieAppearDown.x = this.stage.width / 2;
            this.txtZomBieAppearDown.y = this.stage.height / 2 - 70;
            if (ModeManager.mode == GAME_MODE_TYPE.ONEVSONEMODE || ModeManager.mode == GAME_MODE_TYPE.SNIPERMODE) {
                this.btnGiveUp.visible = true;
                this.btnConvenient.visible = false;
            } else {
                this.btnConvenient.visible = true;
                this.btnGiveUp.visible = false;
            }
            if (ModeManager.mode == GAME_MODE_TYPE.BIOCHEMISTRY) {
                this.boxTopBiochemical.visible = true;
                if (!ConfigManager.getViolenceCtrl()) {
                    let str = this.imgHead.skin;
                    str = str.replace(".png", "_4399.png");
                    this.imgHead.skin = str;
                }
                this.boxLeftBiochemical.visible = true;
                this.imgZombieTimeBg.visible = false;
                this.ZomBieComingView = new ZombieComingViewCtrl();
                this.addChild(this.ZomBieComingView);
                this.zomBieComingDownTime(2000);
                GameTimeManager.startGameTime(this.txtZombieDownTime);
                this.rescuingItemCtrl = new RescuingItemCtrl();
                this.rescuing.addChild(this.rescuingItemCtrl);
                this.rescuingItemCtrl.anchorX = .5;
                this.rescuingItemCtrl.anchorY = .5;
                this.rescuingItemCtrl.x = this.rescuing.width / 2;
                this.rescuingItemCtrl.y = this.rescuing.height / 2;
                CharacterManger.isWarmUp = false;
            } else {
                CharacterManger.gameStop = true;
            }
        }
        modeFunc() {
            CharacterManger.gameStop = false;
            let that = this;
            let time = 15;
            that.txtWarmUp.text = '热身时间 ' + time + 's';
            if (PerformanceManager.isCloseAILogic) {
                time = 1;
            }
            that.timer.loop(1000, that, function cd() {
                if (time == 1) {
                    that.gameStart();
                    that.txtWarmUp.text = '热身时间 ' + time + 's';
                    that.timer.clear(that, cd);
                }
                time--;
                that.txtWarmUp.text = '热身时间 ' + time + 's';
            });
            that.txtCurTask.text = TaskManager.targetKillSore.toString();
            that.boxTopNonBiochemical.visible = true;
            that.boxLeftNonBiochemical.visible = true;
        }
        gameStart() {
            CharacterManger.playerLogicalBaseLayer.setHP = CharacterManger.playerLogicalBaseLayer.getMaxHP();
            NotifyManager.notify(NOTIFY_ID.REFRESH_PLAYER_HP_UI);
            BunkerManager.resetAllNodeUse();
            let time = 3;
            this.txtTeamDown.visible = true;
            this.txtTeamDown.text = time.toString();
            this.imgWarmUp.visible = false;
            CharacterManger.warmUpAfterToSetPos();
            SoundManager.playEffect(SOUND_PATH.GAME_DOWN_START.ROOT + time.toString() + '.mp3');
            var that = this;
            CharacterManger.playerLogicalBaseLayer.resetDouble();
            this.setData();
            this.timer.loop(1000, this, function cd() {
                if (time == 1) {
                    SoundManager.playEffect(SOUND_PATH.GAME_DOWN_START.START);
                    this.txtTeamDown.visible = false;
                    this.ani6.play(0, false);
                    CharacterManger.isWarmUp = false;
                    GameTimeManager.startGameTime(this.txtCurTime);
                    this.timer.clear(this, cd);
                }
                time--;
                SoundManager.playEffect(SOUND_PATH.GAME_DOWN_START.ROOT + time.toString() + '.mp3');
                that.txtTeamDown.text = time.toString();
            });
        }
        zomBieComingDownTime(time) {
            let t = 5;
            let that = this;
            this.txtZomBieAppearDown.text = t.toString();
            this.timerOnce(time, this, function cd() {
                that.txtZomBieAppearDown.visible = true;
                that.timer.loop(1000, that, function update() {
                    if (CharacterManger.gameStop)
                        return;
                    if (t != 0) {
                        t--;
                        that.txtZomBieAppearDown.text = t.toString();
                    } else {
                        that.txtZomBieAppearDown.text = t.toString();
                        that.zomBieCtrl();
                        that.timer.clear(that, update);
                    }
                });
            });
        }
        setZomBieDownTimeBg() {
            if (ModeManager.mode != GAME_MODE_TYPE.BIOCHEMISTRY)
                return;
            if (GameTimeManager.gameTime > 10) {
                let url = RES_PATH.ZOMBIEMODE_GAMING_UI.DOWNTIME_BG_UI.BEFORE10S;
                if (this.imgZombieTimeBg.skin != url) {
                    this.imgZombieTimeBg.alpha = 1;
                    this.imgZombieTimeBg.skin = url;
                }
            } else {
                let url = RES_PATH.ZOMBIEMODE_GAMING_UI.DOWNTIME_BG_UI.AFTER10S;
                if (this.imgZombieTimeBg.skin != url) {
                    this.imgZombieTimeBg.skin = url;
                    this.ani4.play(0, true);
                }
            }
        }
        beZomBieHit() {
            if (ModeManager.mode != GAME_MODE_TYPE.BIOCHEMISTRY)
                return;
            if (!ConfigManager.isReviewVersion())
                return;
            if (ConfigManager.appId == ANDROID_APP_ID.C_233)
                return;
            this.ani5.play(0, false);
        }
        zomBieCtrl() {
            this.txtZomBieAppearDown.visible = false;
            this.imgZombieTimeBg.visible = true;
            SoundManager.play(SOUND_PATH.ZOMBIESHOW);
            if (this.imgTopZomBieBg.y <= -78) {
                this.txtZombieRound.text = '第' + BiochemistryManager.round.toString() + '批';
                this.setZomBieNum();
                this.down.play(0, false);
            } else {
                this.up.play(0, false);
                this.timerOnce(500, this, () => {
                    this.down.play(0, false);
                    this.setZomBieNum();
                    this.txtZombieRound.text = '第' + BiochemistryManager.round.toString() + '批';
                });
            }
            this.ZomBieComingView.setData();
            this.ZomBieComingView.start();
            this.ZomBieComingView.stop();
            BiochemistryManager.generateZombies();
        }
        setZomBieNum() {
            this.txtZombieNum.text = '剩余僵尸：' + BiochemistryManager.maxRound.toString();
        }
        zomBieEliminate() {
            if (BiochemistryManager.round != 3) {
                let img = new Laya.Image(RES_PATH.ZOMBIEMODE_GAMING_UI.CLEANSCUESS);
                img.anchorX = .5;
                img.anchorY = .5;
                img.x = this.stage.width / 2;
                img.y = this.stage.height / 2 - 20;
                img.alpha = 0;
                this.addChild(img);
                Laya.Tween.to(img, {
                    alpha: 1
                }, 200, null, Laya.Handler.create(this, () => {
                    Laya.Tween.to(img, {
                        alpha: 0
                    }, 200, null, Laya.Handler.create(this, () => {
                        img.destroy();
                    }), 1200);
                }));
            } else {
                let img = new Laya.Image(RES_PATH.ZOMBIEMODE_GAMING_UI.CLEANFINISH);
                img.anchorX = .5;
                img.anchorY = .5;
                img.x = this.stage.width / 2;
                img.y = this.stage.height / 2 - 20;
                this.addChild(img);
                Laya.Tween.to(img, {
                    alpha: 1
                }, 200, null, Laya.Handler.create(this, () => {
                    Laya.Tween.to(img, {
                        alpha: 0
                    }, 200, null, Laya.Handler.create(this, () => {
                        img.destroy();
                    }), 1200);
                }));
            }
        }
        setMirrorScale() {
            let scaleX = 1;
            let scaleY = 1;
            this.imgMirror.scale(scaleX, scaleY);
        }
        setData() {
            let skinData = [];
            let len = CharacterManger.playerLogicalBaseLayer.armCtrlList.length;
            for (let index = 0; index < this.armCellCtrlList.length; index++) {
                const element = this.armCellCtrlList[index];
                element.removeSelf();
                element.destroy();
            }
            this.curIndex = this.curIndex ? this.curIndex : 0;
            this.armCellCtrlList = [];
            CharacterManger.curFRArmList = [];
            let index = 0;
            for (let k = 0; k < CharacterManger.playerLogicalBaseLayer.armCtrlList.length; k++) {
                let item = CharacterManger.playerLogicalBaseLayer.armCtrlList[k];
                let data = {
                    index: index,
                    magazineBullet: item.curMagazineBullet,
                    bullets: item.curBullets,
                    icon: item.getIcon(),
                    state: ARM_STATE.NORMAL,
                    armType: item.getType()
                };
                if (item.id == CharacterManger.playerLogicalBaseLayer.armCtrl.id) {
                    data.state = ARM_STATE.CHOOSE;
                }
                if (k == 0) {
                    CharacterManger.pushFRArmList(0, item.getIcon(), true);
                    this.imgArm.skin = item.getIcon();
                }
                if (k == 1) {
                    CharacterManger.pushFRArmList(1, item.getIcon(), true);
                    this.imgArm.skin = item.getIcon();
                }
                index++;
                skinData.push(data);
                let ctrl = new GameArmItemCtrl(data, this);
                this.armCellCtrlList.push(ctrl);
                this.boxArmCell.addChild(ctrl);
                if (data.state == ARM_STATE.CHOOSE) {
                    if (data.armType == ARM_TYPE.HAND_GUN) {
                        this.quasiCenter1.visible = true;
                        this.quasiCenter.visible = false;
                    } else {
                        this.quasiCenter.visible = true;
                        this.quasiCenter1.visible = false;
                    }
                }
            }
            if (skinData.length == 0) {
                this.quasiCenter.visible = true;
                this.quasiCenter1.visible = false;
            }
        }
        pickUpTheGun() {
            let skinData = [];
            let len = CharacterManger.playerLogicalBaseLayer.armCtrlList.length;
            for (let index = 0; index < this.armCellCtrlList.length; index++) {
                const element = this.armCellCtrlList[index];
                element.removeSelf();
                element.destroy();
            }
            this.curIndex = 0;
            this.armCellCtrlList = [];
            let index = 0;
            CharacterManger.curFRArmList = [];
            for (let k = 0; k < CharacterManger.playerLogicalBaseLayer.armCtrlList.length; k++) {
                let item = CharacterManger.playerLogicalBaseLayer.armCtrlList[k];
                let data = {
                    index: index,
                    magazineBullet: item.curMagazineBullet,
                    bullets: item.curBullets,
                    icon: item.getIcon(),
                    state: index == 0 ? ARM_STATE.CHOOSE : ARM_STATE.NORMAL,
                    armType: item.getType()
                };
                index++;
                if (k == 0) {
                    CharacterManger.pushFRArmList(0, item.getIcon(), true);
                    this.imgArm.skin = item.getIcon();
                }
                if (k == 1) {
                    CharacterManger.pushFRArmList(1, item.getIcon(), true);
                    this.imgArm.skin = item.getIcon();
                }
                skinData.push(data);
                let ctrl = new GameArmItemCtrl(data, this);
                this.armCellCtrlList.push(ctrl);
                this.boxArmCell.addChild(ctrl);
                if (data.state == ARM_STATE.CHOOSE) {
                    if (data.armType == ARM_TYPE.HAND_GUN) {
                        this.quasiCenter1.visible = true;
                        this.quasiCenter.visible = false;
                    } else {
                        this.quasiCenter.visible = true;
                        this.quasiCenter1.visible = false;
                    }
                }
            }
            if (skinData.length == 0) {
                this.quasiCenter.visible = true;
                this.quasiCenter1.visible = false;
            }
        }
        setBtnEvent() {
            this.btnJump.on(Laya.Event.MOUSE_DOWN, this, this.onBtnJumpDown);
            this.btnJump.on(Laya.Event.MOUSE_UP, this, this.onBtnJumpOut);
            this.btnRightAttack.on(Laya.Event.MOUSE_DOWN, this, this.onBtnRightAttackDown);
            this.btnLeftAttack.on(Laya.Event.MOUSE_DOWN, this, this.onBtnLeftAttackDown);
            this.btnRightAttack.on(Laya.Event.MOUSE_UP, this, this.onBtnRightAttackUp);
            this.btnLeftAttack.on(Laya.Event.MOUSE_UP, this, this.onBtnLeftAttackUp);
            if (ConfigManager.platform == PLATFORM_TYPE.WEB_4399 && Laya.Browser.onPC) {
                this.onBtnDown();
                this.mouseDownHandle = this.onBtnLeftAttackDown.bind(this);
                this.mouseUpHandle = this.onBtnLeftAttackUp.bind(this);
                this.canvas.addEventListener('mousedown', this.mouseDownHandle, false);
                this.canvas.addEventListener('mouseup', this.mouseUpHandle, false);
                this.boxTouch.on(Laya.Event.MOUSE_DOWN, this, this.onBtnDown);
            } else {
                this.on(Laya.Event.MOUSE_MOVE, this, this.onBtnViewMove);
                this.on(Laya.Event.MOUSE_DOWN, this, this.onBtnViewDown);
                this.on(Laya.Event.MOUSE_UP, this, this.onBtnViewOver);
            }
            this.btnAmmunitionChange.on(Laya.Event.MOUSE_DOWN, this, this.onBtnAmmunitionChange);
            this.btnBack.on(Laya.Event.CLICK, this, this.onBtnBack);
            this.btnAutoAttack.on(Laya.Event.CLICK, this, this.onBtnAutoAttack);
            this.btnSquat.on(Laya.Event.MOUSE_DOWN, this, this.onBtnSquatDown);
            this.btnSquat.on(Laya.Event.MOUSE_UP, this, this.onBtnSquatOut);
            this.btnGiveUp.on(Laya.Event.CLICK, this, this.onBtnGiveUp);
            this.btnGiveUp.on(Laya.Event.MOUSE_DOWN, this, this.onBtnGiveUpDown);
            this.btnGiveUp.on(Laya.Event.MOUSE_UP, this, this.onBtnGiveUpOut);
            this.btnRescue.on(Laya.Event.CLICK, this, this.onBtnRescue);
            this.btnResueCancel.on(Laya.Event.CLICK, this, this.onBtnResueCancel);
            this.btnCloseMirror.on(Laya.Event.MOUSE_DOWN, this, this.onBtnCloseMirrorDown);
            this.btnCloseMirror.on(Laya.Event.MOUSE_UP, this, this.onBtnCloseMirrorOut);
            this.btnConvenient.on(Laya.Event.CLICK, this, this.onBtnConvenient);
            this.btnCloseBomb.on(Laya.Event.MOUSE_UP, this, this.onBtnCloseBombUp);
            this.btnRecording.on(Laya.Event.CLICK, this, this.onBtnRecording);
            this.btnRecord.on(Laya.Event.CLICK, this, this.onBtnRecord);
            this.btnShare.on(Laya.Event.CLICK, this, this.onBtnShare);
        }
        onBtnCloseBombUp() {
            CharacterManger.closeBomb();
            this.imgBomb.visible = false;
            this.btnCloseBomb.visible = false;
        }
        onBtnConvenient() {
            CharacterManger.convenientSelectArm();
        }
        onBtnCloseMirrorDown() {
            this.onlySniperClose();
        }
        onBtnCloseMirrorOut() {}
        onBtnResueCancel() {
            if (!CommonUtil.getTouch())
                return;
            if (CharacterManger.zombieModeRescueLogic) {
                CharacterManger.zombieModeRescueLogic.getPresentationBaseLayer().isInterrupt = true;
            }
        }
        onBtnGiveUp() {
            if (!CommonUtil.getTouch())
                return;
            if (ModeManager.mode != GAME_MODE_TYPE.ONEVSONEMODE && ModeManager.mode != GAME_MODE_TYPE.SNIPERMODE)
                return;
            if (CharacterManger.playerLogicalBaseLayer.isOpenMioing)
                return;
            if (!CharacterManger.playerLogicalBaseLayer.getArmCtrl())
                return;
            SoundManager.play(SOUND_PATH.XIEXIA);
            CharacterManger.playerLogicalBaseLayer.removeTheGunByJudge();
            this.pickUpTheGun();
            this.sniperClose();
        }
        onBtnGiveUpDown() {
            this.btnGiveUp.skin = RES_PATH.DISCARD_UI.TOUCHED;
        }
        toGiveUp() {
            if (!CharacterManger.playerLogicalBaseLayer.getArmCtrl())
                return;
            CharacterManger.playerLogicalBaseLayer.removeTheGun();
            this.pickUpTheGun();
            this.sniperClose();
        }
        onBtnGiveUpOut() {
            this.btnGiveUp.skin = RES_PATH.DISCARD_UI.TOUCH;
        }
        onBtnRescue() {
            if (!CommonUtil.getTouch())
                return;
            if (CharacterManger.zombieModeRescueLogic) {
                CharacterManger.zombieModeRescueLogic.getPresentationBaseLayer().isRescuing = true;
                CharacterManger.zombieModeRescueLogic.getPresentationBaseLayer().isInterrupt = false;
                this.setRescuingVisible(true);
                this.setBtnRescueVisible(false);
            }
            if (this.rescuingItemCtrl) {
                this.rescuingItemCtrl.resetCoutDown();
                this.rescuingItemCtrl.fire(function() {
                    if (CharacterManger.gameOver)
                        return;
                    if (CharacterManger.zombieModeRescueLogic) {
                        CharacterManger.zombieModeRescueLogic.directRevive(function() {
                            CharacterManger.zombieModeRescueLogic.getPresentationBaseLayer().setPos(CharacterManger.zombieModeRescueLogic.getInitPos());
                        });
                    }
                });
            }
        }
        setBtnRescueVisible(isVisible) {
            this.btnRescue.visible = isVisible;
        }
        setRescuingVisible(isVisible) {
            this.rescuing.visible = isVisible;
        }
        startRescuing(param) {}
        setGameEvent() {
            NotifyManager.register(NOTIFY_ID.KILL, this.setKill, this);
            NotifyManager.register(NOTIFY_ID.REFRESH_PLAYER_HP_UI, this.refreshHP, this);
            NotifyManager.register(NOTIFY_ID.PLAYER_WAR_SITUATION, this.refreshPlayerWarSituation, this);
            NotifyManager.register(NOTIFY_ID.REFRESH_MAIN_ARM, this.refreshArmData, this);
            NotifyManager.register(NOTIFY_ID.REFRESH_PLAYER_ARMOR_UI, this.refreshArmor, this);
            NotifyManager.notify(NOTIFY_ID.REFRESH_PLAYER_HP_UI);
        }
        refreshArmData() {
            if (!this.armCellCtrlList[this.curIndex])
                return;
            if (!this.armCellCtrlList[this.curIndex].data)
                return;
            if (this.armCellCtrlList[this.curIndex].data.armType == ARM_TYPE.KNIFE)
                return;
            this.armCellCtrlList[this.curIndex].data.magazineBullet = CharacterManger.playerLogicalBaseLayer.armCtrlList[this.curIndex].curMagazineBullet;
            this.armCellCtrlList[this.curIndex].data.bullets = CharacterManger.playerLogicalBaseLayer.armCtrlList[this.curIndex].curBullets;
            this.armCellCtrlList[this.curIndex].setState(this.armCellCtrlList[this.curIndex].data.state);
            for (let k in this.armCellCtrlList) {
                if (parseInt(k) != this.curIndex) {
                    this.armCellCtrlList[k].data.magazineBullet = CharacterManger.playerLogicalBaseLayer.armCtrlList[parseInt(k)].curMagazineBullet;
                    this.armCellCtrlList[k].data.bullets = CharacterManger.playerLogicalBaseLayer.armCtrlList[parseInt(k)].curBullets;
                    if (this.armCellCtrlList[k])
                        (this.armCellCtrlList[k]).setState(this.armCellCtrlList[k].data.state);
                }
            }
        }
        setKill(args) {
            if (args.role == ROLE_TYPE.TYPE_0) {
                this.txtCurFriPro.text = CharacterManger.ourKillScore.toString();
            } else if (args.role == ROLE_TYPE.TYPE_1) {
                this.txtCurEnePro.text = CharacterManger.enemyKillScore.toString();
            }
            this.txtCurFriPro.fontSize = 34;
            this.txtCurEnePro.fontSize = 34;
            if (CharacterManger.ourKillScore > CharacterManger.enemyKillScore) {
                this.txtCurFriPro.fontSize = 46;
            } else {
                if (CharacterManger.ourKillScore != CharacterManger.enemyKillScore) {
                    this.txtCurEnePro.fontSize = 46;
                }
            }
        }
        refreshHP() {
            let maxHP = CharacterManger.playerLogicalBaseLayer.getMaxHP();
            let hp = CharacterManger.playerLogicalBaseLayer.getHP();
            this.txtHP.text = hp.toString() + '/' + maxHP.toString();
            if (hp == 100) {
                this.ani7.play(0, false);
            }
            if (hp >= 30) {
                this.imgHP.skin = RES_PATH.HP_PRO_UI.HP_MORE_30;
            } else {
                this.imgHP.skin = RES_PATH.HP_PRO_UI.HP_LESS_30;
            }
            Laya.Tween.clearAll(this.imgHP);
            let targetWidth = hp * 244 / maxHP;
            Laya.Tween.to(this.imgHP, {
                width: targetWidth
            }, 100);
        }
        refreshArmor() {
            let maxArmor = CharacterManger.playerLogicalBaseLayer.getMaxArmor();
            let armor = CharacterManger.playerLogicalBaseLayer.getArmor();
            this.txtArmor.text = armor.toString() + '/' + maxArmor.toString();
            Laya.Tween.clearAll(this.imgArmor);
            let targetWidth = armor * 244 / maxArmor;
            Laya.Tween.to(this.imgArmor, {
                width: targetWidth
            }, 100);
        }
        refreshPlayerWarSituation() {
            let str = '击杀:';
            if (!ConfigManager.getViolenceCtrl())
                str = '击倒:';
            this.txtMySelfWarSituation.text = str + CharacterManger.playerLogicalBaseLayer.playerKillCount + '  被淘汰：' + CharacterManger.playerLogicalBaseLayer.playerBeKillCount;
            if (ModeManager.mode == GAME_MODE_TYPE.BIOCHEMISTRY) {
                this.txtPlayerZombieKillNum.text = str + CharacterManger.playerLogicalBaseLayer.playerKillCount;
            }
        }
        onArmSelect(index) {
            if (index == this.curIndex)
                return;
            this.updateSelectArm(index);
        }
        updateSelectArm(index) {
            if (CharacterManger.playerLogicalBaseLayer.isStartHuaBullet)
                return;
            this.curIndex = index;
            for (let k in this.armCellCtrlList) {
                if (k != index) {
                    this.armCellCtrlList[k].data.state = ARM_STATE.NORMAL;
                    this.armCellCtrlList[k].data.magazineBullet = CharacterManger.playerLogicalBaseLayer.armCtrlList[parseInt(k)].curMagazineBullet;
                    this.armCellCtrlList[k].data.bullets = CharacterManger.playerLogicalBaseLayer.armCtrlList[parseInt(k)].curBullets;
                    if (this.armCellCtrlList[k])
                        (this.armCellCtrlList[k]).setState(this.armCellCtrlList[k].data.state);
                }
            }
            this.armCellCtrlList[index].data.state = ARM_STATE.CHOOSE;
            CharacterManger.playerLogicalBaseLayer.getPresentationBaseLayer().isTouchBomb = false;
            this.armCellCtrlList[index].data.magazineBullet = CharacterManger.playerLogicalBaseLayer.armCtrlList[parseInt(index)].curMagazineBullet;
            this.armCellCtrlList[index].data.bullets = CharacterManger.playerLogicalBaseLayer.armCtrlList[parseInt(index)].curBullets;
            CharacterManger.playerLogicalBaseLayer.chooseArm(index);
            if (this.armCellCtrlList[index])
                (this.armCellCtrlList[index]).setState(this.armCellCtrlList[index].data.state);
            CharacterManger.pushFRArmList(index, this.armCellCtrlList[index].data.icon);
        }
        changeAttackSkin() {
            this.btnRightAttack.skin = CharacterManger.playerLogicalBaseLayer.getPresentationBaseLayer().isTouchBomb ? RES_PATH.BOMB_UI.TOUCH : RES_PATH.ATTACK_UI.TOUCH;
            this.btnLeftAttack.getChildAt(0).skin = CharacterManger.playerLogicalBaseLayer.getPresentationBaseLayer().isTouchBomb ? RES_PATH.BOMB_UI.TOUCH : RES_PATH.ATTACK_UI.TOUCH;
        }
        onBtnViewMove(e) {
            CharacterManger.playerLogicalBaseLayer.setDirection(null, e);
        }
        onBtnViewDown(e) {
            GameScene.touchCtrl(e.touchId, TOUCHIDSTATE.ADD);
            if (GameScene.handleType == HANDLETYPE.ONLYMOVE)
                return;
            this.curTouchId = e.touchId;
            CharacterManger.fisrtPoint = null;
            if (e.stageX >= Laya.stage.width / 2) {
                CharacterManger.fisrtPoint = null;
                CharacterManger.playerLogicalBaseLayer.setMouseX = null;
                CharacterManger.playerLogicalBaseLayer.setMouseY = null;
            }
        }
        onBtnViewOver(e) {
            CharacterManger.fisrtPoint = null;
            CharacterManger.playerLogicalBaseLayer.setMouseX = null;
            CharacterManger.playerLogicalBaseLayer.setMouseY = null;
            if (!CharacterManger.playerLogicalBaseLayer.getArmCtrl())
                return;
            GameScene.touchCtrl(e.touchId, TOUCHIDSTATE.REMOVE);
            if (this.isTouchRightAttack) {
                if (Laya.MouseManager.instance.mouseX < Laya.stage.width / 2)
                    return;
                this.attackAfter();
                this.btnRightAttack.skin = CharacterManger.playerLogicalBaseLayer.getArmCtrl().getType() == 8 ? RES_PATH.BOMB_UI.TOUCH : RES_PATH.ATTACK_UI.TOUCH;
                this.isTouchRightAttack = false;
            }
            if (this.isTouchLeftAttack) {
                if (Laya.MouseManager.instance.mouseX >= Laya.stage.width / 2)
                    return;
                this.attackAfter();
                this.btnLeftAttack.getChildAt(0).skin = CharacterManger.playerLogicalBaseLayer.getArmCtrl().getType() == 8 ? RES_PATH.BOMB_UI.TOUCH : RES_PATH.ATTACK_UI.TOUCH;
                this.isTouchLeftAttack = false;
            }
        }
        onBtnJumpDown() {
            this.btnJump.skin = RES_PATH.JUMP_UI.TOUCHED;
            CharacterManger.playerLogicalBaseLayer.getPresentationBaseLayer().jump();
        }
        onBtnJumpOut() {
            this.btnJump.skin = RES_PATH.JUMP_UI.TOUCH;
        }
        onBtnRightAttackDown() {
            if (!CharacterManger.playerLogicalBaseLayer.getArmCtrl())
                return;
            this.btnRightAttack.skin = CharacterManger.playerLogicalBaseLayer.getPresentationBaseLayer().isTouchBomb ? RES_PATH.BOMB_UI.TOUCHED : RES_PATH.ATTACK_UI.TOUCHED;
            this.isTouchRightAttack = true;
            this.attack();
        }
        onBtnRightAttackUp() {}
        onBtnLeftAttackUp(e) {
            if (ConfigManager.platform == PLATFORM_TYPE.WEB_4399 && Laya.Browser.onPC) {
                if (!CharacterManger.playerLogicalBaseLayer)
                    return;
                CharacterManger.playerLogicalBaseLayer.setIsAttack = false;
                if (this.isTouchLeftAttack) {
                    this.attackAfter(e);
                    this.isTouchLeftAttack = false;
                }
            }
        }
        onBtnLeftAttackDown(e) {
            if (!CharacterManger.playerLogicalBaseLayer)
                return;
            if (!CharacterManger.playerLogicalBaseLayer.getArmCtrl())
                return;
            this.isTouchLeftAttack = true;
            if (this.imgMirror) {
                this.attack(e);
                console.log('攻击');
            }
        }
        attack(e = null) {
            this.hideAttackGuide();
            if (CharacterManger.playerLogicalBaseLayer.magazineBullet == 0 && CharacterManger.playerLogicalBaseLayer.bullets == 0 && (CharacterManger.playerLogicalBaseLayer.getArmCtrl() && CharacterManger.playerLogicalBaseLayer.getArmCtrl().getType() != ARM_TYPE.BOMB)) {
                LogManager.showNotification('子弹不足');
            }
            if (CharacterManger.playerLogicalBaseLayer.getPresentationBaseLayer().isTouchBomb) {
                CharacterManger.playerLogicalBaseLayer.getPresentationBaseLayer().throwBombBefore(() => {
                    this.imgBomb.visible = false;
                    this.btnCloseBomb.visible = false;
                    this.isTouchRightAttack = false;
                    this.isTouchLeftAttack = false;
                });
                CharacterManger.playerLogicalBaseLayer.setIsAttack = true;
                if (!(ConfigManager.platform == PLATFORM_TYPE.WEB_4399 && Laya.Browser.onPC)) {
                    this.imgBomb.visible = true;
                    this.btnCloseBomb.visible = true;
                }
                return;
            }
            if (CharacterManger.playerLogicalBaseLayer.getIsDie())
                return;
            CharacterManger.playerLogicalBaseLayer.setIsTouchAttack = true;
            if (CharacterManger.playerLogicalBaseLayer.getArmCtrl().getType() != ARM_TYPE.SNIPER_GUN) {
                CharacterManger.playerLogicalBaseLayer.setIsAttack = true;
            } else {
                console.log('isStartAttack:', CharacterManger.playerLogicalBaseLayer.isStartAttack, 'isStartHuaBullet:', CharacterManger.playerLogicalBaseLayer.isStartHuaBullet, 'isOpenMioing:', CharacterManger.playerLogicalBaseLayer.isOpenMioing);
                if (CharacterManger.playerLogicalBaseLayer.isStartAttack)
                    return;
                if (CharacterManger.playerLogicalBaseLayer.isStartHuaBullet)
                    return;
                if (!CharacterManger.playerLogicalBaseLayer.isOpenMioing) {
                    if (ConfigManager.platform == PLATFORM_TYPE.WEB_4399 && Laya.Browser.onPC) {
                        if (e.button == 2) {
                            this.sniperOpen();
                        } else {
                            CharacterManger.playerLogicalBaseLayer.setIsTouchAttack = true;
                            CharacterManger.playerLogicalBaseLayer.setIsAttack = true;
                        }
                    } else
                        this.sniperOpen();
                } else {
                    this.sniperClose(e);
                }
            }
        }
        hideBombBtn() {
            this.btnCloseBomb.visible = false;
            this.imgBomb.visible = false;
        }
        sniperOpen() {
            if (CharacterManger.playerLogicalBaseLayer.getArmCtrl().curBullets == 0 && CharacterManger.playerLogicalBaseLayer.getArmCtrl().curMagazineBullet == 0)
                return;
            this.imgMirror.visible = true;
            this.ani8.play(0, false);
            this.btnCloseMirror.visible = true;
            CharacterManger.playerLogicalBaseLayer.isOpenMioing = true;
            this.boxQuasi.visible = false;
            Laya.Tween.clearAll(GameScene.camera);
            Laya.Tween.to(GameScene.camera, {
                fieldOfView: 13
            }, 80);
        }
        sniperClose(e = null) {
            if (GameScene.camera.fieldOfView != 60) {
                if (this.isOpenGun)
                    return;
                this.isOpenGun = true;
                this.imgMirror.visible = false;
                Laya.Tween.clearAll(GameScene.camera);
                this.btnCloseMirror.visible = false;
                Laya.Tween.to(GameScene.camera, {
                    fieldOfView: 60
                }, 80);
                this.boxQuasi.visible = true;
                this.isAutoOpen = false;
                var that = this;
                if (ConfigManager.platform == PLATFORM_TYPE.WEB_4399 && Laya.Browser.onPC) {
                    if (e.button == 0) {
                        CharacterManger.playerLogicalBaseLayer.setIsTouchAttack = true;
                        CharacterManger.playerLogicalBaseLayer.setIsAttack = true;
                    } else {
                        CharacterManger.playerLogicalBaseLayer.setIsTouchAttack = false;
                        CharacterManger.playerLogicalBaseLayer.setIsAttack = false;
                        that.isOpenGun = false;
                        CharacterManger.playerLogicalBaseLayer.isOpenMioing = false;
                        CharacterManger.playerLogicalBaseLayer.setIsTouchAttack = false;
                        CharacterManger.playerLogicalBaseLayer.setIsAttack = false;
                        return;
                    }
                } else {
                    CharacterManger.playerLogicalBaseLayer.setIsTouchAttack = true;
                    CharacterManger.playerLogicalBaseLayer.setIsAttack = true;
                }
                Laya.timer.once(880, this, function cd() {
                    that.isOpenGun = false;
                    CharacterManger.playerLogicalBaseLayer.isOpenMioing = false;
                    CharacterManger.playerLogicalBaseLayer.setIsTouchAttack = false;
                    CharacterManger.playerLogicalBaseLayer.setIsAttack = false;
                    Laya.timer.clear(this, cd);
                });
            }
        }
        onlySniperClose() {
            this.imgMirror.visible = false;
            Laya.Tween.clearAll(GameScene.camera);
            this.btnCloseMirror.visible = false;
            CharacterManger.playerLogicalBaseLayer.isOpenMioing = false;
            Laya.Tween.to(GameScene.camera, {
                fieldOfView: 60
            }, 80);
            CharacterManger.playerLogicalBaseLayer.setIsTouchAttack = false;
            CharacterManger.playerLogicalBaseLayer.setIsAttack = false;
        }
        attackAfter(e = null) {
            if (!CharacterManger.playerLogicalBaseLayer.getArmCtrl())
                return;
            if (CharacterManger.playerLogicalBaseLayer.getArmCtrl().getType() == ARM_TYPE.BOMB) {
                if (CharacterManger.playerLogicalBaseLayer.getPresentationBaseLayer().isTouchBomb) {
                    console.log('attackAfter');
                    CharacterManger.playerLogicalBaseLayer.getPresentationBaseLayer().throwBomb();
                    this.btnCloseBomb.visible = false;
                    return;
                }
            }
            if (CharacterManger.playerLogicalBaseLayer.getArmCtrl().getType() != 3) {
                CharacterManger.playerLogicalBaseLayer.setIsTouchAttack = false;
                CharacterManger.playerLogicalBaseLayer.setIsAttack = false;
            } else {
                if (ConfigManager.platform == PLATFORM_TYPE.WEB_4399 && Laya.Browser.onPC) {} else
                    this.sniperClose(e);
            }
        }
        onBtnAmmunitionChange() {
            if (!CharacterManger.playerLogicalBaseLayer.getArmCtrl())
                return;
            if (CharacterManger.playerLogicalBaseLayer.getPresentationBaseLayer().isTouchBomb)
                return;
            let timer = CharacterManger.playerLogicalBaseLayer.getArmCtrl().getBulletChangeTimer() / 1000;
            let that = this;
            CharacterManger.playerLogicalBaseLayer.getPresentationBaseLayer().manualAmmunitionChange(function() {
                that.btnAmmunitionChanging.visible = true;
                that.imgAmmunitionChang.visible = false;
                that.txtAmmunitionChangTime.text = timer.toString() + 's';
                that.ani1.play(0, true);
                that.timer.loop(100, that, function cd() {
                    if (timer > 0) {
                        timer = parseFloat((timer - 0.1).toFixed(1));
                        that.txtAmmunitionChangTime.text = timer.toString() + 's';
                    } else {
                        timer = 0;
                        that.txtAmmunitionChangTime.text = timer.toString() + 's';
                        that.ani1.stop();
                        that.timer.clear(that, cd);
                    }
                });
            }, function() {
                that.btnAmmunitionChanging.visible = false;
                that.imgAmmunitionChang.visible = true;
            });
        }
        onBtnBack() {
            UIManager.openFunction(FUNCTION_TAG.EXIT, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE, false);
        }
        onBtnAutoAttack() {
            if (CharacterManger.playerLogicalBaseLayer.isAutoAttack) {
                this.btnAutoAttack.skin = RES_PATH.AUTO_ATTACK_UI.NOT_AUTO_ATTACK;
                CharacterManger.playerLogicalBaseLayer.isAutoAttack = false;
            } else {
                this.btnAutoAttack.skin = RES_PATH.AUTO_ATTACK_UI.AUTO_ATTACK;
                CharacterManger.playerLogicalBaseLayer.isAutoAttack = true;
            }
        }
        onBtnSquatDown() {
            this.btnSquat.skin = RES_PATH.SQUATDOWN_UI.TOUCHED;
            CharacterManger.playerLogicalBaseLayer.isCrouch = true;
            GameScene.camera.transform.localPositionY = 2.235;
            let tran = GameScene.camera.transform;
            Laya.Tween.clearAll(tran);
            tran.localPositionY = 2.235;
            Laya.Tween.to(tran, {
                localPositionY: 2.235 - 0.3
            }, 150);
        }
        onBtnSquatOut() {
            this.btnSquat.skin = RES_PATH.SQUATDOWN_UI.TOUCH;
            CharacterManger.playerLogicalBaseLayer.isCrouch = false;
            let tran = GameScene.camera.transform;
            Laya.Tween.clearAll(tran);
            Laya.Tween.to(tran, {
                localPositionY: 2.235
            }, 10);
        }
        setEnemyHp(ctrl) {
            Laya.timer.clear(this, this.hideImgEnemy);
            this.imgEnemy.visible = true;
            this.isHideImgEnemy = false;
            this.imgEnemyHp.width = (ctrl.getHP() / ctrl.getMaxHP()) * this.maxHpWigth;
            this.labelName.text = ctrl.gameName;
            this.labelCount.text = ctrl.getHP().toString();
        }
        hideEnemyHp() {
            if (!this.isHideImgEnemy) {
                this.isHideImgEnemy = true;
                Laya.timer.once(500, this, this.hideImgEnemy);
            }
            if (CharacterManger.playerLogicalBaseLayer.getArmCtrl()) {
                if (CharacterManger.playerLogicalBaseLayer.getArmCtrl().getType() != ARM_TYPE.KNIFE &&
                    CharacterManger.playerLogicalBaseLayer.getArmCtrl().getType() != ARM_TYPE.SNIPER_GUN) {
                    if (this.isOpenCamera) {
                        Laya.Tween.clearAll(GameScene.camera);
                        this.isOpenCamera = false;
                        this.isCameraMove = true;
                        Laya.Tween.to(GameScene.camera, {
                            fieldOfView: 60
                        }, 300 * 1.3, null, Laya.Handler.create(GameScene.camera, () => {
                            this.isCameraMove = false;
                        }));
                    }
                }
            }
        }
        hideImgEnemy() {
            this.imgEnemy.visible = false;
        }
        onBtnRecording() {
            if (!CommonUtil.getTouch())
                return;
            if (this.recordSec > 7) {
                this.endRecord();
            } else {
                LogManager.showNotification('录制中，请稍等');
            }
        }
        onBtnRecord() {
            if (!CommonUtil.getTouch())
                return;
            if (this.recordSec == 0) {
                this.startRecord();
            }
        }
        onBtnShare() {
            if (!CommonUtil.getTouch())
                return;
            if (this.recordVideoPath) {
                this.btnShare.visible = false;
                this.btnRecord.visible = false;
                UIManager.openFunction(FUNCTION_TAG.RECORD, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.WINDOW, COMMON_MENU_STYLE.HIDE, {
                    path: this.recordVideoPath
                });
            }
        }
        startRecord() {
            console.log('startRecord');
            this.btnRecord.visible = false;
            this.btnRecording.visible = false;
            if (ConfigManager.platform == PLATFORM_TYPE.TT) {
                let that = this;
                PlatformUtil.startRecordGame(function() {
                    console.log('sthsithithihti-----------------------------');
                    that.btnRecord.visible = false;
                    that.btnRecording.visible = false;
                });
            }
            this.recordSec = 0;
            let that = this;
            Laya.timer.loop(1000, this.btnRecording, function() {
                that.recordSec++;
                if (that.recordSec >= 60) {
                    that.endRecord();
                }
            });
        }
        endRecord(isShowSuccessLog = true) {
            console.log('endRecord');
            this.recordSec = 0;
            Laya.timer.clearAll(this.btnRecording);
            if (ConfigManager.platform == PLATFORM_TYPE.TT) {
                let that = this;
                PlatformUtil.endRecordGame(function(resPath) {
                    that.recordVideoPath = resPath;
                    that.btnRecording.visible = false;
                    that.btnShare.visible = false;
                }, function() {
                    that.recordVideoPath = null;
                    that.btnRecord.visible = false;
                    that.btnRecording.visible = false;
                    LogManager.showNotification('录屏失败');
                });
            } else {
                this.btnRecording.visible = false;
                this.btnShare.visible = false;
                this.recordVideoPath = 'test';
            }
        }
    }

    class ReviewGameViewCtrl extends ui.view.review.ReviewGameViewUI {
        constructor() {
            super();
            this.playerKillBroadcastCtrl = null;
            this.matchSituationCtrl = null;
            this.isTouchRightAttack = false;
            this.isTouchLeftAttack = false;
            this.curIndex = 0;
            this.curTouchId = 0;
            this.ZomBieComingView = null;
            this.rescuingItemCtrl = null;
            this.touchNum = 0;
            this.moveCtrl = null;
            this.fingerCtrl = null;
            this.step = 1;
            this.isToGudeAttack = false;
            this.isOpenGun = false;
            this.isAutoOpen = false;
            this.lastArmIndex = 0;
            this.height = this.stage.height;
            this.width = this.stage.width;
            this.canvas = Laya.Browser.document.querySelector('canvas');
            document.addEventListener('pointerlockchange', this.lockChangeAlert, false);
            document.addEventListener('mozpointerlockchange', this.lockChangeAlert, false);
        }
        onAwake() {
            if (ConfigManager.platform == PLATFORM_TYPE.VIVO) {
                SoundManager.playEffect(SOUND_PATH.KILL_HEADSHOT, 1, false, 0.1);
            }
        }
        start() {
            if (DifficultyManager.curDifficult == 0) {
                console.log('难度等级：【容易】');
                this.txtCurDiff.text = '难度等级：【容易】';
            } else if (DifficultyManager.curDifficult == 1) {
                console.log('难度等级：【正常】');
                this.txtCurDiff.text = '难度等级：【正常】';
            } else if (DifficultyManager.curDifficult == 2) {
                console.log('难度等级：【偏难】');
                this.txtCurDiff.text = '难度等级：【偏难】';
            } else if (DifficultyManager.curDifficult == 3) {
                console.log('难度等级：【困难】');
                this.txtCurDiff.text = '难度等级：【困难】';
            }
            this.init();
            this.setData();
            this.setBtnEvent();
            this.setGameEvent();
            if (ConfigManager.platform == PLATFORM_TYPE.WEB_4399 && Laya.Browser.onPC) {
                CharacterManger.fisrtPoint = null;
                CharacterManger.playerLogicalBaseLayer.setMouseX = null;
                CharacterManger.playerLogicalBaseLayer.setMouseY = null;
                this.btnJump.visible = false;
                this.btnRightAttack.visible = false;
                this.btnLeftAttack.visible = false;
                this.btnCloseMirror.alpha = 0;
                this.btnLeftAttack.alpha = 0;
                this.btnLeftAttack.off(Laya.Event.MOUSE_DOWN, this, this.onBtnLeftAttackDown);
                this.btnAmmunitionChange.visible = false;
                this.btnGiveUp.visible = false;
                this.btnConvenient.visible = false;
                Laya.stage.on(Laya.Event.KEY_DOWN, this, this.onKeyDown);
                this.onBtnAutoAttack();
            }
            let that = this;
            this.timer.frameLoop(1, this, () => {
                if (CharacterManger.gameOver)
                    return;
                if (this.isTouchRightAttack) {
                    if (CharacterManger.playerLogicalBaseLayer.getArmCtrl()) {
                        if (CharacterManger.playerLogicalBaseLayer.getArmCtrl().getType() == 3) {
                            if (!CharacterManger.playerLogicalBaseLayer.isStartAttack && !CharacterManger.playerLogicalBaseLayer.isOpenMioing) {
                                if (!this.isAutoOpen) {
                                    this.isAutoOpen = true;
                                    that.attack();
                                }
                            }
                        }
                    }
                }
            });
        }
        onBtnDown(viewEnd = false) {
            if (UIManager.funcList.length > 1 && viewEnd == false)
                return;
            console.log('锁定鼠标');
            window.focus();
            this.canvas.requestPointerLock();
            this.canvas.removeEventListener('mousemove', this.mouseMove);
            this.canvas.addEventListener('mousemove', this.mouseMove, false);
        }
        lockChangeAlert() {
            if (document.pointerLockElement === this.canvas ||
                Laya.Browser.document.mozPointerLockElement === this.canvas) {
                console.log('The pointer lock status is now locked');
            } else {
                console.log('The pointer lock status is now unlocked');
            }
        }
        mouseMove(e) {
            let data = {
                stageX: e.movementX * 0.7,
                stageY: e.movementY * 0.7
            };
            CharacterManger.playerLogicalBaseLayer.setDirection(null, data);
        }
        onKeyDown(e) {
            switch (e.keyCode) {
                case 32:
                    CharacterManger.playerLogicalBaseLayer.getPresentationBaseLayer().jump();
                    break;
                case 81:
                    {
                        this.onBtnConvenient();
                    }
                    break;
                case 82:
                    this.onBtnAmmunitionChange();
                    break;
                case 71:
                    this.onBtnGiveUp();
                    break;
                case 69:
                    this.onBtnRescue();
                    break;
            }
            if (e.keyCode <= 57 && e.keyCode > 47) {
                let length = e.keyCode == 48 ? 10 : e.keyCode - 48;
                if (length <= this.listArm.dataSource.length) {
                    if (CharacterManger.playerLogicalBaseLayer) {
                        if (!CharacterManger.playerLogicalBaseLayer.isOpenMioing)
                            CharacterManger.playerLogicalBaseLayer.setIsTouchAttack = false;
                    }
                    if (!CharacterManger.playerLogicalBaseLayer.isOpenMioing) {
                        if (e.keyCode == 48) {
                            this.lastArmIndex = this.curIndex;
                            this.onArmSelect(9);
                        } else {
                            this.lastArmIndex = this.curIndex;
                            console.log('武器索引:', e.keyCode - 49);
                            this.onArmSelect(e.keyCode - 49);
                        }
                    }
                }
            }
        }
        setNewPlayerArm() {
            let that = this;
            if (ConfigManager.isReviewVersion() && ConfigManager.gameType == GAME_MJB_TYPE.QZHXJY)
                return;
            if (RoleManager.getInstance().isNew && GameScene.gameNum == 1 && (ModeManager.mode != GAME_MODE_TYPE.SNIPERMODE && ModeManager.mode != GAME_MODE_TYPE.ONEVSONEMODE && ModeManager.mode != GAME_MODE_TYPE.KNIFEWARMODE)) {
                CharacterManger.gameStop = true;
                UIManager.openFunction(FUNCTION_TAG.NEWPLAYERTRYARM, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.WINDOW, COMMON_MENU_STYLE.HIDE, {
                    cb: function(id) {
                        CharacterManger.playerLogicalBaseLayer.getSuperArmByNew(id);
                        if (ModeManager.mode != GAME_MODE_TYPE.BIOCHEMISTRY) {
                            that.modeFunc();
                        }
                    }
                });
            } else {
                if (ModeManager.mode != GAME_MODE_TYPE.BIOCHEMISTRY) {
                    that.modeFunc();
                }
            }
        }
        onDestroy() {
            this.timer.clearAll(this);
            this.txtCurEnePro = null;
            this.txtCurFriPro = null;
            this.txtCurTask = null;
            this.txtCurTime = null;
            this.txtHP = null;
            this.txtMySelfWarSituation = null;
            this.boxCenter = null;
            this.boxWarSituation = null;
            this.matchSituationCtrl = null;
            this.playerKillBroadcastCtrl = null;
            this.imgHP = null;
            this.imgMirror = null;
            Laya.stage.off(Laya.Event.KEY_DOWN, this, this.onKeyDown);
            this.canvas.removeEventListener('mousemove', this.mouseMove);
            this.canvas.removeEventListener('mouseup', this.onBtnLeftAttackUp);
            this.canvas.removeEventListener('mousedown', this.onBtnLeftAttackDown);
            NotifyManager.unregisterByEventId(NOTIFY_ID.KILL);
            NotifyManager.unregisterByEventId(NOTIFY_ID.REFRESH_PLAYER_HP_UI);
            NotifyManager.unregisterByEventId(NOTIFY_ID.PLAYER_WAR_SITUATION);
            NotifyManager.unregisterByEventId(NOTIFY_ID.REFRESH_MAIN_ARM);
            NotifyManager.unregisterByEventId(NOTIFY_ID.REFRESH_PLAYER_ARMOR_UI);
        }
        init() {
            console.log('当前游戏内部指引步骤：', RoleManager.getInstance().getGuide());
            this.fingerCtrl = GuideManager.createFingerAniCtrl(this);
            SoundManager.stopBGM();
            this.modelCtrl();
            this.setMirrorScale();
            CharacterManger.addHead();
            Laya.MouseManager.multiTouchEnabled = true;
            this.playerKillBroadcastCtrl = new PlayerKillBroadcastCtrl();
            this.addChild(this.playerKillBroadcastCtrl);
            this.playerKillBroadcastCtrl.centerX = 0;
            this.playerKillBroadcastCtrl.bottom = 133;
            let view = new RockerMoveViewCtrl(this);
            view.x = view.width + 100;
            view.y = this.stage.height - view.height - 100;
            this.boxJoystick.addChild(view);
            this.moveCtrl = view;
            this.setGuide();
            this.boxWarSituation.addChild(new BroadcastViewCtrl());
            this.matchSituationCtrl = new MatchSituationCtrl();
            this.addChild(this.matchSituationCtrl);
            let str = '击杀:';
            if (!ConfigManager.getViolenceCtrl())
                str = '击倒:';
            this.txtMySelfWarSituation.text = str + 0 + '  被淘汰：' + 0;
            if (ModeManager.mode == GAME_MODE_TYPE.BIOCHEMISTRY) {
                this.txtPlayerZombieKillNum.text = str + 0;
            }
        }
        setGuide() {
            if (RoleManager.getInstance().getGuide() != GuideStep.FINISH && RoleManager.getInstance().getGuide() != GuideStep.MAX) {
                if (this.step == 1) {
                    console.log('设置移动指引');
                    this.fingerCtrl.stop();
                    this.moveCtrl.ani1.play(0, false);
                } else if (this.step == 2) {
                    console.log('设置攻击指引');
                    this.fingerCtrl.visible = true;
                    let point1 = new Laya.Point(this.btnRightAttack.width / 2, this.btnRightAttack.height / 2);
                    let a = this.btnRightAttack.localToGlobal(point1);
                    this.setGudePos(a);
                    this.fingerCtrl.play();
                }
            }
        }
        hideMoveGuide() {
            if (this.step == 1) {
                if (this.fingerCtrl) {
                    this.fingerCtrl.visible = false;
                }
                this.step++;
            }
        }
        hideAttackGuide() {
            if (this.isToGudeAttack) {
                if (this.step == 2) {
                    if (this.fingerCtrl) {
                        this.fingerCtrl.visible = false;
                    }
                    this.step++;
                }
            }
        }
        setGudePos(a) {
            this.fingerCtrl.visible = true;
            this.fingerCtrl.play();
            this.fingerCtrl.x = a.x;
            this.fingerCtrl.y = a.y;
        }
        modelCtrl() {
            this.btnRescue.visible = false;
            this.rescuing.visible = false;
            this.boxTopBiochemical.visible = false;
            this.boxTopNonBiochemical.visible = false;
            this.boxLeftBiochemical.visible = false;
            this.boxLeftNonBiochemical.visible = false;
            this.txtTeamDown.visible = false;
            this.txtZomBieAppearDown.visible = false;
            this.txtZomBieAppearDown.x = this.stage.width / 2;
            this.txtZomBieAppearDown.y = this.stage.height / 2 - 70;
            if (ModeManager.mode == GAME_MODE_TYPE.ONEVSONEMODE || ModeManager.mode == GAME_MODE_TYPE.SNIPERMODE) {
                this.btnGiveUp.visible = true;
                this.btnConvenient.visible = false;
            } else {
                this.btnConvenient.visible = true;
                this.btnGiveUp.visible = false;
            }
            if (ModeManager.mode == GAME_MODE_TYPE.BIOCHEMISTRY) {
                this.boxTopBiochemical.visible = true;
                if (!ConfigManager.getViolenceCtrl()) {}
                this.boxLeftBiochemical.visible = true;
                this.imgZombieTimeBg.visible = false;
                this.ZomBieComingView = new ZombieComingViewCtrl();
                this.addChild(this.ZomBieComingView);
                this.zomBieComingDownTime(2000);
                GameTimeManager.startGameTime(this.txtZombieDownTime);
                this.rescuingItemCtrl = new RescuingItemCtrl();
                this.rescuing.addChild(this.rescuingItemCtrl);
                this.rescuingItemCtrl.anchorX = .5;
                this.rescuingItemCtrl.anchorY = .5;
                this.rescuingItemCtrl.x = this.rescuing.width / 2;
                this.rescuingItemCtrl.y = this.rescuing.height / 2;
                CharacterManger.isWarmUp = false;
            } else {
                CharacterManger.gameStop = true;
            }
        }
        modeFunc() {
            CharacterManger.gameStop = false;
            let that = this;
            let time = 15;
            that.txtWarmUp.text = '热身时间 ' + time + 's';
            that.timer.loop(1000, that, function cd() {
                if (time == 1) {
                    that.gameStart();
                    that.txtWarmUp.text = '热身时间 ' + time + 's';
                    that.timer.clear(that, cd);
                }
                time--;
                that.txtWarmUp.text = '热身时间 ' + time + 's';
            });
            that.txtCurTask.text = TaskManager.targetKillSore.toString();
            that.boxTopNonBiochemical.visible = true;
            that.boxLeftNonBiochemical.visible = true;
        }
        gameStart() {
            CharacterManger.playerLogicalBaseLayer.setHP = CharacterManger.playerLogicalBaseLayer.getMaxHP();
            NotifyManager.notify(NOTIFY_ID.REFRESH_PLAYER_HP_UI);
            BunkerManager.resetAllNodeUse();
            let time = 3;
            this.txtTeamDown.visible = true;
            this.txtTeamDown.text = time.toString();
            this.imgWarmUp.visible = false;
            CharacterManger.warmUpAfterToSetPos();
            SoundManager.playEffect(SOUND_PATH.GAME_DOWN_START.ROOT + time.toString() + '.mp3');
            this.timer.loop(1000, this, function cd() {
                if (time == 1) {
                    SoundManager.playEffect(SOUND_PATH.GAME_DOWN_START.START);
                    this.txtTeamDown.visible = false;
                    this.ani6.play(0, false);
                    CharacterManger.playerLogicalBaseLayer.resetDouble();
                    CharacterManger.isWarmUp = false;
                    GameTimeManager.startGameTime(this.txtCurTime);
                    this.timer.clear(this, cd);
                }
                time--;
                SoundManager.playEffect(SOUND_PATH.GAME_DOWN_START.ROOT + time.toString() + '.mp3');
                this.txtTeamDown.text = time.toString();
            });
        }
        zomBieComingDownTime(time) {
            let t = 5;
            let that = this;
            this.txtZomBieAppearDown.text = t.toString();
            this.timerOnce(time, this, function cd() {
                that.txtZomBieAppearDown.visible = true;
                that.timer.loop(1000, that, function update() {
                    if (CharacterManger.gameStop)
                        return;
                    if (t != 0) {
                        t--;
                        that.txtZomBieAppearDown.text = t.toString();
                    } else {
                        that.txtZomBieAppearDown.text = t.toString();
                        that.zomBieCtrl();
                        that.timer.clear(that, update);
                    }
                });
            });
        }
        setZomBieDownTimeBg() {
            if (ModeManager.mode != GAME_MODE_TYPE.BIOCHEMISTRY)
                return;
            if (GameTimeManager.gameTime > 10) {
                let url = RES_PATH.ZOMBIEMODE_GAMING_UI.DOWNTIME_BG_UI.BEFORE10S;
                if (this.imgZombieTimeBg.skin != url) {
                    this.imgZombieTimeBg.alpha = 1;
                    this.imgZombieTimeBg.skin = url;
                }
            } else {
                let url = RES_PATH.ZOMBIEMODE_GAMING_UI.DOWNTIME_BG_UI.AFTER10S;
                if (this.imgZombieTimeBg.skin != url) {
                    this.imgZombieTimeBg.skin = url;
                    this.ani4.play(0, true);
                }
            }
        }
        beZomBieHit() {
            if (ModeManager.mode != GAME_MODE_TYPE.BIOCHEMISTRY)
                return;
            if (!ConfigManager.isReviewVersion())
                return;
            if (ConfigManager.appId == ANDROID_APP_ID.C_233)
                return;
            this.ani5.play(0, false);
        }
        zomBieCtrl() {
            this.txtZomBieAppearDown.visible = false;
            this.imgZombieTimeBg.visible = true;
            SoundManager.play(SOUND_PATH.ZOMBIESHOW);
            if (this.imgTopZomBieBg.y <= -78) {
                this.txtZombieRound.text = '第' + BiochemistryManager.round.toString() + '批';
                this.setZomBieNum();
                this.down.play(0, false);
            } else {
                this.up.play(0, false);
                this.timerOnce(500, this, () => {
                    this.down.play(0, false);
                    this.setZomBieNum();
                    this.txtZombieRound.text = '第' + BiochemistryManager.round.toString() + '批';
                });
            }
            this.ZomBieComingView.setData();
            this.ZomBieComingView.start();
            this.ZomBieComingView.stop();
            BiochemistryManager.generateZombies();
        }
        setZomBieNum() {
            this.txtZombieNum.text = '剩余僵尸：' + BiochemistryManager.maxRound.toString();
        }
        zomBieEliminate() {
            if (BiochemistryManager.round != 3) {
                let img = new Laya.Image(RES_PATH.ZOMBIEMODE_GAMING_UI.CLEANSCUESS);
                img.anchorX = .5;
                img.anchorY = .5;
                img.x = this.stage.width / 2;
                img.y = this.stage.height / 2 - 20;
                img.alpha = 0;
                this.addChild(img);
                Laya.Tween.to(img, {
                    alpha: 1
                }, 200, null, Laya.Handler.create(this, () => {
                    Laya.Tween.to(img, {
                        alpha: 0
                    }, 200, null, Laya.Handler.create(this, () => {
                        img.destroy();
                    }), 1200);
                }));
            } else {
                let img = new Laya.Image(RES_PATH.ZOMBIEMODE_GAMING_UI.CLEANFINISH);
                img.anchorX = .5;
                img.anchorY = .5;
                img.x = this.stage.width / 2;
                img.y = this.stage.height / 2 - 20;
                this.addChild(img);
                Laya.Tween.to(img, {
                    alpha: 1
                }, 200, null, Laya.Handler.create(this, () => {
                    Laya.Tween.to(img, {
                        alpha: 0
                    }, 200, null, Laya.Handler.create(this, () => {
                        img.destroy();
                    }), 1200);
                }));
            }
        }
        setMirrorScale() {
            let scaleX = 1;
            let scaleY = 1;
            this.imgMirror.scale(scaleX, scaleY);
        }
        setData() {
            let skinData = [];
            let len = CharacterManger.playerLogicalBaseLayer.armCtrlList.length;
            this.listArm.width = 190 * len;
            this.listArm.x = this.stage.width / 2;
            let index = 0;
            for (let k = 0; k < CharacterManger.playerLogicalBaseLayer.armCtrlList.length; k++) {
                let item = CharacterManger.playerLogicalBaseLayer.armCtrlList[k];
                let data = {
                    index: index,
                    type: item.getType(),
                    magazineBullet: item.curMagazineBullet,
                    bullets: item.curBullets,
                    icon: item.getIcon(),
                    state: index == 0 ? ARM_STATE.CHOOSE : ARM_STATE.NORMAL,
                    armType: 0
                };
                if (k == 0) {
                    CharacterManger.pushFRArmList(0, item.getIcon(), true);
                    this.imgArm.skin = item.getIcon();
                }
                if (k == 1) {
                    CharacterManger.pushFRArmList(1, item.getIcon(), true);
                    this.imgArm.skin = item.getIcon();
                }
                index++;
                skinData.push(data);
            }
            this.listArm.itemRender = GameArmItemCtrl;
            this.listArm.vScrollBarSkin = '';
            this.listArm.dataSource = skinData;
            this.listArm.selectEnable = true;
            this.listArm.renderHandler = new Laya.Handler(this, this.updateArmItem);
        }
        pickUpTheGun() {
            let skinData = [];
            let len = CharacterManger.playerLogicalBaseLayer.armCtrlList.length;
            this.listArm.width = 190 * len;
            this.listArm.x = this.stage.width / 2;
            let index = 0;
            for (let k = 0; k < CharacterManger.playerLogicalBaseLayer.armCtrlList.length; k++) {
                let item = CharacterManger.playerLogicalBaseLayer.armCtrlList[k];
                let data = {
                    index: index,
                    type: item.getType(),
                    magazineBullet: item.curMagazineBullet,
                    bullets: item.curBullets,
                    icon: item.getIcon(),
                    state: index == 0 ? ARM_STATE.CHOOSE : ARM_STATE.NORMAL,
                    armType: 0
                };
                index++;
                skinData.push(data);
            }
            this.listArm.dataSource = skinData;
            this.listArm.refresh();
        }
        setBtnEvent() {
            this.btnJump.on(Laya.Event.MOUSE_DOWN, this, this.onBtnJumpDown);
            this.btnJump.on(Laya.Event.MOUSE_OUT, this, this.onBtnJumpOut);
            this.btnRightAttack.on(Laya.Event.MOUSE_DOWN, this, this.onBtnRightAttackDown);
            this.btnLeftAttack.on(Laya.Event.MOUSE_DOWN, this, this.onBtnLeftAttackDown);
            this.btnRightAttack.on(Laya.Event.MOUSE_OUT, this, this.onBtnRightAttackUp);
            this.btnLeftAttack.on(Laya.Event.MOUSE_OUT, this, this.onBtnLeftAttackUp);
            if (ConfigManager.platform == PLATFORM_TYPE.WEB_4399 && Laya.Browser.onPC) {
                this.onBtnDown();
                this.canvas.addEventListener('mousedown', this.onBtnLeftAttackDown.bind(this), false);
                this.canvas.addEventListener('mouseup', this.onBtnLeftAttackUp.bind(this), false);
                this.boxTouch.on(Laya.Event.MOUSE_DOWN, this, this.onBtnDown);
            } else {
                this.on(Laya.Event.MOUSE_MOVE, this, this.onBtnViewMove);
                this.on(Laya.Event.MOUSE_DOWN, this, this.onBtnViewDown);
                this.on(Laya.Event.MOUSE_OUT, this, this.onBtnViewOver);
            }
            this.btnAmmunitionChange.on(Laya.Event.MOUSE_DOWN, this, this.onBtnAmmunitionChange);
            this.btnBack.on(Laya.Event.CLICK, this, this.onBtnBack);
            this.btnAutoAttack.on(Laya.Event.CLICK, this, this.onBtnAutoAttack);
            this.btnSquat.on(Laya.Event.MOUSE_DOWN, this, this.onBtnSquatDown);
            this.btnSquat.on(Laya.Event.MOUSE_OUT, this, this.onBtnSquatOut);
            this.btnGiveUp.on(Laya.Event.CLICK, this, this.onBtnGiveUp);
            this.btnGiveUp.on(Laya.Event.MOUSE_DOWN, this, this.onBtnGiveUpDown);
            this.btnGiveUp.on(Laya.Event.MOUSE_OUT, this, this.onBtnGiveUpOut);
            this.btnRescue.on(Laya.Event.CLICK, this, this.onBtnRescue);
            this.btnResueCancel.on(Laya.Event.CLICK, this, this.onBtnResueCancel);
            this.btnCloseMirror.on(Laya.Event.MOUSE_DOWN, this, this.onBtnCloseMirrorDown);
            this.btnCloseMirror.on(Laya.Event.MOUSE_OUT, this, this.onBtnCloseMirrorOut);
            this.btnConvenient.on(Laya.Event.CLICK, this, this.onBtnConvenient);
        }
        onBtnConvenient() {
            CharacterManger.convenientSelectArm();
        }
        onBtnCloseMirrorDown() {
            this.onlySniperClose();
        }
        onBtnCloseMirrorOut() {}
        onBtnResueCancel() {
            if (!CommonUtil.getTouch())
                return;
            if (CharacterManger.zombieModeRescueLogic) {
                CharacterManger.zombieModeRescueLogic.getPresentationBaseLayer().isInterrupt = true;
            }
        }
        onBtnGiveUp() {
            if (!CommonUtil.getTouch())
                return;
            if (ModeManager.mode != GAME_MODE_TYPE.ONEVSONEMODE && ModeManager.mode != GAME_MODE_TYPE.SNIPERMODE)
                return;
            if (CharacterManger.playerLogicalBaseLayer.isOpenMioing)
                return;
            if (!CharacterManger.playerLogicalBaseLayer.getArmCtrl())
                return;
            SoundManager.play(SOUND_PATH.XIEXIA);
            CharacterManger.playerLogicalBaseLayer.removeTheGunByJudge();
            this.pickUpTheGun();
            this.sniperClose();
        }
        onBtnGiveUpDown() {
            this.btnGiveUp.skin = RES_PATH.DISCARD_UI.TOUCHED;
        }
        toGiveUp() {
            if (!CharacterManger.playerLogicalBaseLayer.getArmCtrl())
                return;
            CharacterManger.playerLogicalBaseLayer.removeTheGun();
            this.pickUpTheGun();
            this.sniperClose();
        }
        onBtnGiveUpOut() {
            this.btnGiveUp.skin = RES_PATH.DISCARD_UI.TOUCH;
        }
        onBtnRescue() {
            if (!CommonUtil.getTouch())
                return;
            if (CharacterManger.zombieModeRescueLogic) {
                CharacterManger.zombieModeRescueLogic.getPresentationBaseLayer().isRescuing = true;
                CharacterManger.zombieModeRescueLogic.getPresentationBaseLayer().isInterrupt = false;
                this.setRescuingVisible(true);
                this.setBtnRescueVisible(false);
            }
            if (this.rescuingItemCtrl) {
                this.rescuingItemCtrl.resetCoutDown();
                this.rescuingItemCtrl.fire(function() {
                    if (CharacterManger.gameOver)
                        return;
                    if (CharacterManger.zombieModeRescueLogic) {
                        CharacterManger.zombieModeRescueLogic.directRevive(function() {
                            CharacterManger.zombieModeRescueLogic.getPresentationBaseLayer().setPos(CharacterManger.zombieModeRescueLogic.getInitPos());
                        });
                    }
                });
            }
        }
        setBtnRescueVisible(isVisible) {
            this.btnRescue.visible = isVisible;
        }
        setRescuingVisible(isVisible) {
            this.rescuing.visible = isVisible;
        }
        startRescuing(param) {}
        setGameEvent() {
            NotifyManager.register(NOTIFY_ID.KILL, this.setKill, this);
            NotifyManager.register(NOTIFY_ID.REFRESH_PLAYER_HP_UI, this.refreshHP, this);
            NotifyManager.register(NOTIFY_ID.PLAYER_WAR_SITUATION, this.refreshPlayerWarSituation, this);
            NotifyManager.register(NOTIFY_ID.REFRESH_MAIN_ARM, this.refreshArmData, this);
            NotifyManager.register(NOTIFY_ID.REFRESH_PLAYER_ARMOR_UI, this.refreshArmor, this);
            NotifyManager.notify(NOTIFY_ID.REFRESH_PLAYER_HP_UI);
        }
        refreshArmData() {
            if (!this.listArm.getCell(this.curIndex))
                return;
            if (!this.listArm.getCell(this.curIndex).dataSource)
                return;
            if (this.listArm.getCell(this.curIndex).dataSource.type == 2)
                return;
            this.listArm.getCell(this.curIndex).txtData.text = (CharacterManger.playerLogicalBaseLayer.magazineBullet.toString());
            this.listArm.getCell(this.curIndex).txtAll.text = ('/' + CharacterManger.playerLogicalBaseLayer.bullets.toString());
            for (let k in this.listArm.dataSource) {
                if (parseInt(k) != this.curIndex) {
                    this.listArm.dataSource[k].magazineBullet = CharacterManger.playerLogicalBaseLayer.armCtrlList[parseInt(k)].curMagazineBullet;
                    this.listArm.dataSource[k].bullets = CharacterManger.playerLogicalBaseLayer.armCtrlList[parseInt(k)].curBullets;
                    if (this.listArm.getCell(parseInt(k)))
                        this.listArm.getCell(parseInt(k)).setState(this.listArm.dataSource[k].state);
                }
            }
        }
        setKill(args) {
            if (args.role == ROLE_TYPE.TYPE_0) {
                this.txtCurFriPro.text = CharacterManger.ourKillScore.toString();
            } else if (args.role == ROLE_TYPE.TYPE_1) {
                this.txtCurEnePro.text = CharacterManger.enemyKillScore.toString();
            }
        }
        refreshHP() {
            let maxHP = CharacterManger.playerLogicalBaseLayer.getMaxHP();
            let hp = CharacterManger.playerLogicalBaseLayer.getHP();
            this.txtHP.text = hp.toString() + '/' + maxHP.toString();
            if (hp == 100) {
                this.ani7.play(0, false);
            }
            Laya.Tween.clearAll(this.imgHP);
            let targetWidth = hp * 322 / maxHP;
            Laya.Tween.to(this.imgHP, {
                width: targetWidth
            }, 100);
        }
        refreshArmor() {
            let maxArmor = CharacterManger.playerLogicalBaseLayer.getMaxArmor();
            let armor = CharacterManger.playerLogicalBaseLayer.getArmor();
            this.txtArmor.text = armor.toString();
        }
        refreshPlayerWarSituation() {
            let str = '击杀:';
            if (!ConfigManager.getViolenceCtrl())
                str = '击倒:';
            this.txtMySelfWarSituation.text = str + CharacterManger.playerLogicalBaseLayer.playerKillCount + '  被淘汰：' + CharacterManger.playerLogicalBaseLayer.playerBeKillCount;
            if (ModeManager.mode == GAME_MODE_TYPE.BIOCHEMISTRY) {
                this.txtPlayerZombieKillNum.text = str + CharacterManger.playerLogicalBaseLayer.playerKillCount;
            }
        }
        onArmSelect(index) {
            if (index == this.curIndex)
                return;
            this.updateSelectArm(index);
        }
        updateSelectArm(index) {
            if (CharacterManger.playerLogicalBaseLayer.isStartHuaBullet)
                return;
            this.curIndex = index;
            for (let k in this.listArm.dataSource) {
                if (k != index) {
                    this.listArm.dataSource[k].state = ARM_STATE.NORMAL;
                    this.listArm.dataSource[k].magazineBullet = CharacterManger.playerLogicalBaseLayer.armCtrlList[parseInt(k)].curMagazineBullet;
                    this.listArm.dataSource[k].bullets = CharacterManger.playerLogicalBaseLayer.armCtrlList[parseInt(k)].curBullets;
                    if (this.listArm.getCell(parseInt(k)))
                        this.listArm.getCell(parseInt(k)).setState(this.listArm.dataSource[k].state);
                }
            }
            this.listArm.dataSource[index].state = ARM_STATE.CHOOSE;
            CharacterManger.playerLogicalBaseLayer.getPresentationBaseLayer().isTouchBomb = false;
            this.listArm.dataSource[index].magazineBullet = CharacterManger.playerLogicalBaseLayer.armCtrlList[parseInt(index)].curMagazineBullet;
            this.listArm.dataSource[index].bullets = CharacterManger.playerLogicalBaseLayer.armCtrlList[parseInt(index)].curBullets;
            CharacterManger.playerLogicalBaseLayer.chooseArm(index);
            this.btnRightAttack.skin = CharacterManger.playerLogicalBaseLayer.getPresentationBaseLayer().isTouchBomb ? RES_PATH.BOMB_UI.TOUCH : RES_PATH.ATTACK_UI.TOUCH;
            this.btnLeftAttack.skin = CharacterManger.playerLogicalBaseLayer.getPresentationBaseLayer().isTouchBomb ? RES_PATH.BOMB_UI.TOUCH : RES_PATH.ATTACK_UI.TOUCH;
            if (this.listArm.getCell(parseInt(index)))
                this.listArm.getCell(parseInt(index)).setState(this.listArm.dataSource[index].state);
            CharacterManger.pushFRArmList(index, this.listArm.dataSource[index].icon);
        }
        updateArmItem(cell, index) {}
        onBtnViewMove(e) {
            CharacterManger.playerLogicalBaseLayer.setDirection(null, e);
        }
        onBtnViewDown(e) {
            GameScene.touchCtrl(e.touchId, TOUCHIDSTATE.ADD);
            if (GameScene.handleType == HANDLETYPE.ONLYMOVE)
                return;
            this.curTouchId = e.touchId;
            CharacterManger.fisrtPoint = null;
            if (e.stageX >= Laya.stage.width / 2) {
                CharacterManger.fisrtPoint = null;
                CharacterManger.playerLogicalBaseLayer.setMouseX = null;
                CharacterManger.playerLogicalBaseLayer.setMouseY = null;
            }
        }
        onBtnViewOver(e) {
            CharacterManger.fisrtPoint = null;
            CharacterManger.playerLogicalBaseLayer.setMouseX = null;
            CharacterManger.playerLogicalBaseLayer.setMouseY = null;
            if (!CharacterManger.playerLogicalBaseLayer.getArmCtrl())
                return;
            GameScene.touchCtrl(e.touchId, TOUCHIDSTATE.REMOVE);
            if (this.isTouchRightAttack) {
                if (Laya.MouseManager.instance.mouseX < Laya.stage.width / 2)
                    return;
                this.attackAfter();
                this.btnRightAttack.skin = CharacterManger.playerLogicalBaseLayer.getArmCtrl().getType() == 8 ? RES_PATH.BOMB_UI.TOUCH : RES_PATH.ATTACK_UI.TOUCH;
                this.isTouchRightAttack = false;
            }
            if (this.isTouchLeftAttack) {
                if (Laya.MouseManager.instance.mouseX >= Laya.stage.width / 2)
                    return;
                this.attackAfter();
                this.btnLeftAttack.skin = CharacterManger.playerLogicalBaseLayer.getArmCtrl().getType() == 8 ? RES_PATH.BOMB_UI.TOUCH : RES_PATH.ATTACK_UI.TOUCH;
                this.isTouchLeftAttack = false;
            }
        }
        onBtnJumpDown() {
            this.btnJump.skin = RES_PATH.JUMP_UI.TOUCHED;
            CharacterManger.playerLogicalBaseLayer.getPresentationBaseLayer().jump();
        }
        onBtnJumpOut() {
            this.btnJump.skin = RES_PATH.JUMP_UI.TOUCH;
        }
        onBtnRightAttackDown() {
            if (!CharacterManger.playerLogicalBaseLayer.getArmCtrl())
                return;
            this.btnRightAttack.skin = CharacterManger.playerLogicalBaseLayer.getPresentationBaseLayer().isTouchBomb ? RES_PATH.BOMB_UI.TOUCHED : RES_PATH.ATTACK_UI.TOUCHED;
            this.isTouchRightAttack = true;
            this.attack();
        }
        onBtnRightAttackUp() {}
        onBtnLeftAttackUp(e) {
            if (ConfigManager.platform == PLATFORM_TYPE.WEB_4399 && Laya.Browser.onPC) {
                if (!CharacterManger.playerLogicalBaseLayer)
                    return;
                CharacterManger.playerLogicalBaseLayer.setIsAttack = false;
                if (this.isTouchLeftAttack) {
                    this.attackAfter(e);
                    this.isTouchLeftAttack = false;
                }
            }
        }
        onBtnLeftAttackDown(e) {
            if (!CharacterManger.playerLogicalBaseLayer)
                return;
            if (!CharacterManger.playerLogicalBaseLayer.getArmCtrl())
                return;
            this.isTouchLeftAttack = true;
            if (this.imgMirror) {
                this.attack(e);
                console.log('攻击');
            }
        }
        attack(e = null) {
            this.hideAttackGuide();
            if (CharacterManger.playerLogicalBaseLayer.magazineBullet == 0 && CharacterManger.playerLogicalBaseLayer.bullets == 0) {
                LogManager.showNotification('子弹不足');
            }
            if (CharacterManger.playerLogicalBaseLayer.getPresentationBaseLayer().isTouchBomb)
                return;
            if (CharacterManger.playerLogicalBaseLayer.getIsDie())
                return;
            CharacterManger.playerLogicalBaseLayer.setIsTouchAttack = true;
            if (CharacterManger.playerLogicalBaseLayer.getArmCtrl().getType() != 3) {
                CharacterManger.playerLogicalBaseLayer.setIsAttack = true;
            } else {
                console.log('isStartAttack:', CharacterManger.playerLogicalBaseLayer.isStartAttack, 'isStartHuaBullet:', CharacterManger.playerLogicalBaseLayer.isStartHuaBullet, 'isOpenMioing:', CharacterManger.playerLogicalBaseLayer.isOpenMioing);
                if (CharacterManger.playerLogicalBaseLayer.isStartAttack)
                    return;
                if (CharacterManger.playerLogicalBaseLayer.isStartHuaBullet)
                    return;
                if (!CharacterManger.playerLogicalBaseLayer.isOpenMioing) {
                    if (ConfigManager.platform == PLATFORM_TYPE.WEB_4399 && Laya.Browser.onPC) {
                        if (e.button == 2) {
                            this.sniperOpen();
                        } else {
                            CharacterManger.playerLogicalBaseLayer.setIsTouchAttack = true;
                            CharacterManger.playerLogicalBaseLayer.setIsAttack = true;
                        }
                    } else
                        this.sniperOpen();
                } else {
                    this.sniperClose(e);
                }
            }
        }
        sniperOpen() {
            if (CharacterManger.playerLogicalBaseLayer.getArmCtrl().curBullets == 0 && CharacterManger.playerLogicalBaseLayer.getArmCtrl().curMagazineBullet == 0)
                return;
            this.imgMirror.visible = true;
            this.ani8.play(0, false);
            this.btnCloseMirror.visible = true;
            CharacterManger.playerLogicalBaseLayer.isOpenMioing = true;
            this.quasiCenter.visible = false;
            Laya.Tween.clearAll(GameScene.camera);
            Laya.Tween.to(GameScene.camera, {
                fieldOfView: 13
            }, 80);
        }
        sniperClose(e = null) {
            if (GameScene.camera.fieldOfView != 60) {
                if (this.isOpenGun)
                    return;
                this.isOpenGun = true;
                this.imgMirror.visible = false;
                Laya.Tween.clearAll(GameScene.camera);
                this.btnCloseMirror.visible = false;
                Laya.Tween.to(GameScene.camera, {
                    fieldOfView: 60
                }, 80);
                this.quasiCenter.visible = true;
                this.isAutoOpen = false;
                var that = this;
                if (ConfigManager.platform == PLATFORM_TYPE.WEB_4399 && Laya.Browser.onPC) {
                    if (e.button == 0) {
                        CharacterManger.playerLogicalBaseLayer.setIsTouchAttack = true;
                        CharacterManger.playerLogicalBaseLayer.setIsAttack = true;
                    } else {
                        CharacterManger.playerLogicalBaseLayer.setIsTouchAttack = false;
                        CharacterManger.playerLogicalBaseLayer.setIsAttack = false;
                        that.isOpenGun = false;
                        CharacterManger.playerLogicalBaseLayer.isOpenMioing = false;
                        CharacterManger.playerLogicalBaseLayer.setIsTouchAttack = false;
                        CharacterManger.playerLogicalBaseLayer.setIsAttack = false;
                        return;
                    }
                } else {
                    CharacterManger.playerLogicalBaseLayer.setIsTouchAttack = true;
                    CharacterManger.playerLogicalBaseLayer.setIsAttack = true;
                }
                Laya.timer.once(880, this, function cd() {
                    that.isOpenGun = false;
                    CharacterManger.playerLogicalBaseLayer.isOpenMioing = false;
                    CharacterManger.playerLogicalBaseLayer.setIsTouchAttack = false;
                    CharacterManger.playerLogicalBaseLayer.setIsAttack = false;
                    Laya.timer.clear(this, cd);
                });
            }
        }
        onlySniperClose() {
            this.imgMirror.visible = false;
            Laya.Tween.clearAll(GameScene.camera);
            this.btnCloseMirror.visible = false;
            CharacterManger.playerLogicalBaseLayer.isOpenMioing = false;
            Laya.Tween.to(GameScene.camera, {
                fieldOfView: 60
            }, 80);
            CharacterManger.playerLogicalBaseLayer.setIsTouchAttack = false;
            CharacterManger.playerLogicalBaseLayer.setIsAttack = false;
        }
        attackAfter(e = null) {
            if (!CharacterManger.playerLogicalBaseLayer.getArmCtrl())
                return;
            if (CharacterManger.playerLogicalBaseLayer.getArmCtrl().getType() == 8) {
                if (CharacterManger.playerLogicalBaseLayer.getPresentationBaseLayer().isTouchBomb) {
                    CharacterManger.playerLogicalBaseLayer.getPresentationBaseLayer().throwBomb();
                    SoundManager.playEffect(SOUND_PATH.FIRE_IN_TEH_HOLE);
                    return;
                }
            }
            if (CharacterManger.playerLogicalBaseLayer.getArmCtrl().getType() != 3) {
                CharacterManger.playerLogicalBaseLayer.setIsTouchAttack = false;
                CharacterManger.playerLogicalBaseLayer.setIsAttack = false;
            } else {
                if (ConfigManager.platform == PLATFORM_TYPE.WEB_4399 && Laya.Browser.onPC) {} else
                    this.sniperClose(e);
            }
        }
        onBtnAmmunitionChange() {
            if (!CharacterManger.playerLogicalBaseLayer.getArmCtrl())
                return;
            if (CharacterManger.playerLogicalBaseLayer.getPresentationBaseLayer().isTouchBomb)
                return;
            let timer = CharacterManger.playerLogicalBaseLayer.getArmCtrl().getBulletChangeTimer() / 1000;
            let that = this;
            CharacterManger.playerLogicalBaseLayer.getPresentationBaseLayer().manualAmmunitionChange(function() {
                that.btnAmmunitionChanging.visible = true;
                that.imgAmmunitionChang.visible = false;
                that.txtAmmunitionChangTime.text = timer.toString() + 's';
                that.ani1.play(0, true);
                that.timer.loop(100, that, function cd() {
                    if (timer > 0) {
                        timer = parseFloat((timer - 0.1).toFixed(1));
                        that.txtAmmunitionChangTime.text = timer.toString() + 's';
                    } else {
                        timer = 0;
                        that.txtAmmunitionChangTime.text = timer.toString() + 's';
                        that.ani1.stop();
                        that.timer.clear(that, cd);
                    }
                });
            }, function() {
                that.btnAmmunitionChanging.visible = false;
                that.imgAmmunitionChang.visible = true;
            });
        }
        onBtnBack() {
            UIManager.openFunction(FUNCTION_TAG.EXIT, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE, false);
        }
        onBtnAutoAttack() {
            if (CharacterManger.playerLogicalBaseLayer.isAutoAttack) {
                this.btnAutoAttack.skin = RES_PATH.AUTO_ATTACK_UI.NOT_AUTO_ATTACK;
                CharacterManger.playerLogicalBaseLayer.isAutoAttack = false;
            } else {
                this.btnAutoAttack.skin = RES_PATH.AUTO_ATTACK_UI.AUTO_ATTACK;
                CharacterManger.playerLogicalBaseLayer.isAutoAttack = true;
            }
        }
        onBtnSquatDown() {
            this.btnSquat.skin = RES_PATH.SQUATDOWN_UI.TOUCHED;
            CharacterManger.playerLogicalBaseLayer.isCrouch = true;
            GameScene.camera.transform.localPositionY = 2.235;
            let tran = GameScene.camera.transform;
            Laya.Tween.clearAll(tran);
            tran.localPositionY = 2.235;
            Laya.Tween.to(tran, {
                localPositionY: 2.235 - 0.3
            }, 150);
        }
        onBtnSquatOut() {
            this.btnSquat.skin = RES_PATH.SQUATDOWN_UI.TOUCH;
            CharacterManger.playerLogicalBaseLayer.isCrouch = false;
            let tran = GameScene.camera.transform;
            Laya.Tween.clearAll(tran);
            Laya.Tween.to(tran, {
                localPositionY: 2.235
            }, 10);
        }
    }

    class GameFunction extends BaseFunction {
        createView() {
            if (ConfigManager.isReviewVersion() && ConfigManager.gameType == GAME_MJB_TYPE.QZHXJY) {
                this._viewCtrl = new ReviewGameViewCtrl();
            } else {
                this._viewCtrl = new GameViewCtrl();
            }
            return this._viewCtrl;
        }
        getFunctionName() {
            return '游戏界面';
        }
        onEnter() {
            super.onEnter();
            if (ConfigManager.platform == PLATFORM_TYPE.OPPO || ConfigManager.platform == PLATFORM_TYPE.WEB) {
                let view = this._viewCtrl;
                this.nativeIcon = new NativeIcon1CellCtrl();
                view.addChild(this.nativeIcon);
                this.nativeIcon.scale(0.7, 0.7);
                this.nativeIcon.x = 360;
                this.nativeIcon.y = 70;
            }
        }
        onExit() { super.onExit(); }
        onEnable() {
            super.onEnable();
            this.nativeIcon && this.nativeIcon.show();
            if (ConfigManager.platform == PLATFORM_TYPE.QQ || ConfigManager.platform == PLATFORM_TYPE.WX || ConfigManager.appId == ANDROID_APP_ID.XM) {
                let x = Laya.stage.width / 2 - PlatformUtil.getCustomSize().w - 350;
                let y = 60;
                let x1 = Laya.stage.width / 2 + 350;
                if (ConfigManager.appId == ANDROID_APP_ID.XM) {
                    AdUtil.showCustom(x1, y);
                    AdUtil.showCustom(x, y);
                } else {
                    AdUtil.showCustom(x1, y, WX_CUSTOM_AD_STYLE.SINGLE_1);
                    AdUtil.showCustom(x, y, WX_CUSTOM_AD_STYLE.SINGLE_1);
                }
            }
        }
        onDisbale() {
            super.onDisbale();
            this.nativeIcon && this.nativeIcon.hide();
            if (ConfigManager.platform == PLATFORM_TYPE.QQ || ConfigManager.platform == PLATFORM_TYPE.WX || ConfigManager.appId == ANDROID_APP_ID.XM) {
                let x = Laya.stage.width / 2 - PlatformUtil.getCustomSize().w - 350;
                let y = 60;
                let x1 = Laya.stage.width / 2 + 350;
                if (ConfigManager.appId == ANDROID_APP_ID.XM) {
                    AdUtil.hideCustom(x1, y);
                    AdUtil.hideCustom(x, y);
                } else {
                    AdUtil.hideCustom(x1, y, WX_CUSTOM_AD_STYLE.SINGLE_1);
                    AdUtil.hideCustom(x, y, WX_CUSTOM_AD_STYLE.SINGLE_1);
                }
            }
        }
        setAllButtonAnalysePoint() {}
        request(cb) {
            cb();
        }
    }

    class GoldMoveAnimation extends Laya.View {
        constructor(posArray, endPos, txtGold = null, rewardCount = null, success = null, type = 1, imgType = COST_TYPE.GOLD, endSacle = null) {
            super();
            this.posArray = [];
            this.type = 1;
            this.curGoldNum = 0;
            this.targetGoldNum = 0;
            this.goldChangeDelay = 0;
            this.imgType = COST_TYPE.DIAMOND;
            this.endScale = null;
            this.zOrder = 999999999;
            this.width = Laya.stage.width;
            this.height = Laya.stage.height;
            this.posArray = posArray;
            this.endPos = endPos;
            this.type = type;
            this.success = success;
            this.txtGold = txtGold;
            this.curGoldNum = imgType == COST_TYPE.GOLD ? RoleManager.getInstance().getGold() - rewardCount : RoleManager.getInstance().getDiamond() - rewardCount;
            this.targetGoldNum = imgType == COST_TYPE.GOLD ? RoleManager.getInstance().getGold() : RoleManager.getInstance().getDiamond();
            Laya.timer.loop(1, this, this.updateGoldAni);
            this.imgType = imgType;
            this.endScale = endSacle;
        }
        onAwake() {
            this.addGolds(this.success);
        }
        addGoldAni(pos, endPos, isEnd = false) {
            let prefab = new Laya.Image();
            switch (this.imgType) {
                case COST_TYPE.DIAMOND:
                    prefab.skin = RES_PATH.IMG_DIAMOND_ICON;
                    break;
                case COST_TYPE.GOLD:
                    prefab.skin = RES_PATH.IMG_GOLD_ICON;
                    break;
            }
            prefab.anchorX = 0.5;
            prefab.anchorY = 0.5;
            this.addChild(prefab);
            prefab.x = pos.x;
            prefab.y = pos.y;
            prefab.scaleX = 0.5;
            prefab.scaleY = 0.5;
            var that = this;
            prefab.width = this.endScale ? this.endScale.x : prefab.width;
            prefab.height = this.endScale ? this.endScale.y : prefab.height;
            Laya.Tween.to(prefab, {
                scaleX: 1,
                scaleY: 1
            }, 500, null, Laya.Handler.create(prefab, function() {
                Laya.Tween.to(prefab, {
                    x: endPos.x,
                    y: endPos.y,
                    scaleX: 1,
                    scaleY: 1
                }, 500, null, Laya.Handler.create(prefab, function() {
                    if (!isEnd)
                        Laya.timer.once(100, prefab, function() {
                            prefab.destroy();
                        });
                    else {
                        Laya.timer.once(1000, prefab, function() {
                            prefab.destroy();
                        });
                        prefab.anchorX = 0.5;
                        prefab.anchorY = 0.5;
                        Laya.Tween.to(prefab, {
                            scaleX: 1 + 0.2,
                            scaleY: 1 + 0.2
                        }, 250, Laya.Ease.bounceOut);
                        Laya.Tween.to(prefab, {
                            scaleX: 1,
                            scaleY: 1
                        }, 250, null, null, 250);
                        Laya.Tween.to(prefab, {
                            scaleX: 1 + 0.2,
                            scaleY: 1 + 0.2
                        }, 250, Laya.Ease.bounceOut, null, 500);
                        Laya.Tween.to(prefab, {
                            scaleX: 1,
                            scaleY: 1
                        }, 250, null, null, 750);
                    }
                    switch (that.imgType) {
                        case COST_TYPE.DIAMOND:
                            SoundManager.playEffect(SOUND_PATH.GOLD2);
                            break;
                        case COST_TYPE.GOLD:
                            SoundManager.playEffect(SOUND_PATH.GOLD2);
                            break;
                    }
                }));
            }));
        }
        addGolds(success) {
            let endPos = this.endPos;
            var that = this;
            let maxTime = 0;
            switch (this.imgType) {
                case COST_TYPE.DIAMOND:
                    SoundManager.playEffect(SOUND_PATH.GOLD1);
                    break;
                case COST_TYPE.GOLD:
                    SoundManager.playEffect(SOUND_PATH.GOLD1);
                    break;
            }
            for (let index = 0; index < this.posArray.length; index++) {
                const item = this.posArray[index];
                let max = this.getRandomInt(15, 10);
                if (max > maxTime) {
                    maxTime = max;
                }
                for (let i = 0; i < max; i++) {
                    let pos;
                    if (this.type == 1)
                        pos = new Laya.Point(item.x + this.getRandomInt(35, -35), item.y + this.getRandomInt(35, -35));
                    else {
                        pos = new Laya.Point(item.x + this.getRandomInt(75, -75), item.y + this.getRandomInt(75, -75));
                    }
                    Laya.timer.once(50 * i, this, function() {
                        that.addGoldAni(pos, endPos, i == max - 1);
                    }, null, false);
                }
            }
            Laya.timer.once(50 * maxTime + 1600, this, function() {
                if (success)
                    success();
                that.destroy();
            });
        }
        getRandomInt(max, min) {
            var poor = Math.abs(max - min);
            let theRandomNumber = Math.random();
            poor = theRandomNumber * poor;
            poor = poor - poor % 1;
            if (poor + min > max) {
                return max;
            }
            return poor + min;
        }
        updateGoldAni() {
            if (!this.txtGold || !this.txtGold.parent)
                return;
            this.targetGoldNum = this.imgType == COST_TYPE.GOLD ? RoleManager.getInstance().getGold() : RoleManager.getInstance().getDiamond();
            if (this.targetGoldNum - this.curGoldNum > 1) {
                this.goldChangeDelay += Laya.timer.delta;
                if (this.goldChangeDelay >= 1000) {
                    this.curGoldNum = Math.ceil(this.curGoldNum + (this.targetGoldNum - this.curGoldNum) * Laya.timer.delta * 0.005);
                }
            } else {
                this.goldChangeDelay = 0;
                this.curGoldNum = this.targetGoldNum;
            }
            let strGold = StringUtil.parseGold(this.curGoldNum);
            if (this.txtGold.text != strGold) {
                this.txtGold.text = strGold;
            }
        }
    }

    class GetDiamondsRewardViewCtrl extends ui.view.getReward.GetDiamondsRewardViewUI {
        constructor(param) {
            super();
            this.reward = 0;
            this.isDown = false;
            this.cb = null;
            this.width = this.stage.width;
            this.height = this.stage.height;
            this.boxBg.scaleX = this.stage.width / this.boxBg.width;
            this.reward = param.reward;
            if (param.cb)
                this.cb = param.cb;
        }
        onAwake() {
            this.init();
            this.setEvent();
        }
        onDestroy() {
            if (this.cb)
                this.cb();
            this.timer.clearAll(this);
            this.ani1 = null;
            this.txtReward = null;
            this.imgGold = null;
            this.cb = null;
        }
        init() {
            this.txtReward.text = StringUtil.parseGold(this.reward.toString());
            this.ani1.play(0, false);
        }
        setEvent() {
            var that = this;
            Laya.timer.once(500, this, function() {
                that.on(Laya.Event.CLICK, that, that.onBtnBack);
            });
        }
        onBtnBack() {
            if (!CommonUtil.getTouch())
                return;
            if (this.isDown)
                return;
            this.isDown = true;
            let that = this;
            let a = this.imgGold.localToGlobal(new Laya.Point(this.imgGold.width / 2, this.imgGold.height / 2));
            let startPos = new Laya.Point(a.x, a.y);
            let target = UIManager.viewCommon.viewDiamond.txtCount;
            let endPos = UIManager.viewCommon.getDiamondPos();
            RoleManager.getInstance().rewardDiamond(that.reward);
            Laya.stage.addChild(new GoldMoveAnimation([startPos], endPos, target, that.reward, function() {
                that.isDown = false;
                UIManager.closeFunction();
            }, 2, COST_TYPE.DIAMOND));
        }
    }

    class GetDiamondsRewardFunction extends BaseFunction {
        createView() {
            this._viewCtrl = new GetDiamondsRewardViewCtrl(this._args);
            return this._viewCtrl;
        }
        getFunctionName() {
            return '获取钻石界面';
        }
        onEnter() { super.onEnter(); }
        onExit() {
            super.onExit();
            if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS || (ConfigManager.appId == ANDROID_APP_ID.C233_ME || ConfigManager.appId == ANDROID_APP_ID.MMY || ConfigManager.appId == ANDROID_APP_ID.HYKB) || ConfigManager.appId == ANDROID_APP_ID.C_233) {
                if (RoleManager.getInstance().getMaxUnLockArm() >= 4 && NewEquipUnLockFunction.isNewEquip) {
                    let view = UIManager.getFunctionViewCtrl(FUNCTION_TAG.FIRST);
                    let time = 40;
                    if (ConfigManager.appId == ANDROID_APP_ID.C_233) {
                        time = 30;
                    }
                    if (view) {
                        if (view.showInterstitialAdTime + time < RoleManager.getInstance().getTime()) {
                            view.showInterstitialAdTime = RoleManager.getInstance().getTime();
                            console.log(time + '后可弹出插屏');
                            AdUtil.createInterstitialAd();
                        }
                    }
                }
                NewEquipUnLockFunction.isNewEquip = false;
            }
        }
        onEnable() {
            super.onEnable();
            AdUtil.showBannerAd();
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || ConfigManager.platform == PLATFORM_TYPE.WX) {
                AdUtil.showCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                AdUtil.showCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
            }
        }
        onDisbale() {
            super.onDisbale();
            AdUtil.hideBannerAd();
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || ConfigManager.platform == PLATFORM_TYPE.WX) {
                AdUtil.hideCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                AdUtil.hideCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
            }
        }
        setAllButtonAnalysePoint() {}
        request(cb) {
            cb();
        }
    }

    class GetGoldRewardViewCtrl extends ui.view.getReward.GetGoldRewardViewUI {
        constructor(reward = 100) {
            super();
            this.reward = 0;
            this.isDown = false;
            this.width = this.stage.width;
            this.height = this.stage.height;
            this.reward = reward;
            this.boxBg.scaleX = this.stage.width / this.boxBg.width;
        }
        onAwake() {
            this.init();
            this.setEvent();
        }
        onDestroy() {
            this.timer.clearAll(this);
            this.txtReward = null;
            this.imgGold = null;
            if (SceneManager.getCurScene().state == GAME_STATE.OVER) {
                if (ConfigManager.platform == PLATFORM_TYPE.OPPO) {
                    UIManager.openFunction(FUNCTION_TAG.NATIVE_INTERSTITIAL, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE);
                }
            }
        }
        init() {
            this.txtReward.text = StringUtil.parseGold(this.reward.toString());
        }
        setEvent() {
            var that = this;
            Laya.timer.once(500, this, function() {
                that.on(Laya.Event.CLICK, that, that.onBtnBack);
            });
        }
        onBtnBack() {
            if (!CommonUtil.getTouch())
                return;
            if (this.isDown)
                return;
            this.isDown = true;
            let that = this;
            let a = this.imgGold.localToGlobal(new Laya.Point(this.imgGold.width / 2, this.imgGold.height / 2));
            let startPos = new Laya.Point(a.x, a.y);
            let target = UIManager.viewCommon.viewGold.txtCount;
            let endPos = UIManager.viewCommon.getGoldPos();
            RoleManager.getInstance().rewardGold(that.reward);
            Laya.stage.addChild(new GoldMoveAnimation([startPos], endPos, target, that.reward, function() {
                that.isDown = false;
                UIManager.closeFunction();
            }, 2, COST_TYPE.GOLD));
        }
    }

    class GetGoldRewardFunction extends BaseFunction {
        createView() {
            this._viewCtrl = new GetGoldRewardViewCtrl(this._args);
            return this._viewCtrl;
        }
        getFunctionName() {
            return '获取金币界面';
        }
        onEnter() { super.onEnter(); }
        onExit() { super.onExit(); }
        onEnable() {
            super.onEnable();
            AdUtil.showBannerAd();
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || ConfigManager.platform == PLATFORM_TYPE.WX) {
                AdUtil.showCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                AdUtil.showCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
            }
        }
        onDisbale() {
            super.onDisbale();
            AdUtil.hideBannerAd();
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || ConfigManager.platform == PLATFORM_TYPE.WX) {
                AdUtil.hideCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                AdUtil.hideCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
            }
        }
        setAllButtonAnalysePoint() {}
        request(cb) {
            cb();
        }
    }

    var SHOW_TYPE;
    (function(SHOW_TYPE) {
        SHOW_TYPE[SHOW_TYPE["HIDE"] = 0] = "HIDE";
        SHOW_TYPE[SHOW_TYPE["SHOW"] = 1] = "SHOW";
    })(SHOW_TYPE || (SHOW_TYPE = {}));
    class ItemCellViewCtrl extends ui.view.getReward.ItemCellViewUI {
        constructor(itemId, count) {
            super();
            this.type = SHOW_TYPE.HIDE;
            this.itemData = Item.getDataByKey(itemId);
            this.count = count;
            this.setView();
        }
        setView() {
            switch (this.itemData.type) {
                case ITEM_TYPE.GOLD:
                case ITEM_TYPE.DIAMOND:
                case ITEM_TYPE.EXP:
                    this.imgIcon.skin = RES_PATH.ITEM_ROOT + this.itemData.icon;
                    this.labelName.text = this.itemData.name;
                    this.labelCount.text = StringUtil.parseGold(this.count);
                    break;
            }
        }
        show(cb = null) {
            this.aniOpen.wrapMode = Laya.AnimationBase.WRAP_POSITIVE;
            this.aniOpen.offAll(Laya.Event.COMPLETE);
            this.aniOpen.play(0, false);
            var that = this;
            this.aniOpen.on(Laya.Event.COMPLETE, this, function() {
                that.type = SHOW_TYPE.SHOW;
                cb && cb();
            });
        }
        hide(cb = null) {
            this.aniOpen.wrapMode = Laya.AnimationBase.WRAP_REVERSE;
            this.aniOpen.offAll(Laya.Event.COMPLETE);
            this.aniOpen.play(0, false);
            var that = this;
            this.aniOpen.on(Laya.Event.COMPLETE, this, function() {
                that.type = SHOW_TYPE.HIDE;
                cb && cb();
            });
        }
        wordPos() {
            let point = new Laya.Point(this.width / 2, this.height / 2);
            this.localToGlobal(point);
            return point;
        }
    }

    let ITEM_POS_LIST = {
        2: [341, 85, 1, 494, 85, 1],
        3: [261, 85, 1, 416, 85, 1, 574, 85, 1],
        4: [188, 85, 1, 341, 85, 1, 494, 85, 1, 647, 85, 1],
        6: [261, 16, 1, 416, 16, 1, 574, 16, 1, 261, 174, 1, 416, 174, 1, 574, 174, 1],
        8: [188, 16, 1, 341, 16, 1, 494, 16, 1, 647, 16, 1, 188, 174, 1, 341, 174, 1, 494, 174, 1, 647, 174, 1],
    };
    class GetThreeRewardViewCtrl extends ui.view.getReward.GetThreeRewardViewUI {
        constructor(itemList) {
            super();
            this.itemList = [];
            this.isShowThree = false;
            this.itemCellList = {};
            this.isAni = false;
            this.isDown = false;
            this.width = this.stage.width;
            this.height = this.stage.height;
            this.itemList = itemList;
        }
        onAwake() {
            this.init();
            this.setEvent();
        }
        onDestroy() {
            this.timer.clearAll(this);
            this.ani2 = null;
        }
        init() {
            this.ani1.play(0, false);
            this.ani2.play(0, true);
            for (let index = 0; index < this.imgRewardBg.numChildren; index++) {
                const element = this.imgRewardBg.getChildAt(index);
                this.pointCtrl(element, Math.random() * 500);
            }
            for (let index = 0; index < this.itemList.length; index++) {
                const element = this.itemList[index];
                let ctrl = new ItemCellViewCtrl(element.itemId, element.count);
                let ctrl1 = new ItemCellViewCtrl(element.itemId, element.count * 2);
                this.boxCell.addChild(ctrl);
                this.boxCell.addChild(ctrl1);
                this.itemCellList[index] = ctrl;
                this.itemCellList[index + this.itemList.length] = ctrl1;
            }
            this.isShowThree = true;
            this.showThree();
        }
        setEvent() {
            this.btnEnter.on(Laya.Event.CLICK, this, this.onBtnBack);
            this.btnThree.on(Laya.Event.CLICK, this, this.onBtnThree);
        }
        onBtnBack() {
            if (!CommonUtil.getTouch())
                return;
            if (this.isDown)
                return;
            this.isDown = true;
            let startGoldPos = [];
            COST_TYPE.DIAMOND;
            let startDiamond = [];
            let goldCount = 0;
            let diamondCount = 0;
            let expCount = 0;
            for (const key in this.itemCellList) {
                if (Object.prototype.hasOwnProperty.call(this.itemCellList, key)) {
                    const element = this.itemCellList[key];
                    if (Number(key) < this.itemList.length) {
                        switch (element.itemData.type) {
                            case ITEM_TYPE.GOLD:
                                startGoldPos.push(element.wordPos());
                                goldCount += element.count;
                                break;
                            case ITEM_TYPE.DIAMOND:
                                startDiamond.push(element.wordPos());
                                diamondCount += element.count;
                                break;
                            case ITEM_TYPE.EXP:
                                expCount += element.count;
                                break;
                        }
                    } else {
                        if (this.isShowThree) {
                            switch (element.itemData.type) {
                                case ITEM_TYPE.GOLD:
                                    goldCount += element.count;
                                    startGoldPos.push(element.wordPos());
                                    break;
                                case ITEM_TYPE.DIAMOND:
                                    startDiamond.push(element.wordPos());
                                    diamondCount += element.count;
                                    break;
                                case ITEM_TYPE.EXP:
                                    expCount += element.count;
                                    break;
                            }
                        }
                    }
                }
            }
            let funcGold = function() {
                let target = UIManager.viewCommon.viewGold.txtCount;
                let endPos = UIManager.viewCommon.getGoldPos();
                RoleManager.getInstance().rewardGold(goldCount);
                Laya.stage.addChild(new GoldMoveAnimation(startGoldPos, endPos, target, goldCount, function() {}, 1, COST_TYPE.GOLD));
            };
            let funcDiamond = function() {
                let target = UIManager.viewCommon.viewDiamond.txtCount;
                let endPos = UIManager.viewCommon.getDiamondPos();
                RoleManager.getInstance().rewardDiamond(diamondCount);
                Laya.stage.addChild(new GoldMoveAnimation(startDiamond, endPos, target, diamondCount, function() {}, 1, COST_TYPE.DIAMOND));
            };
            var that = this;
            let success = function() {
                if (startDiamond.length > 0) {
                    funcDiamond();
                }
                if (startGoldPos.length > 0) {
                    funcGold();
                }
                if (startGoldPos.length > 0 || startDiamond.length > 0) {
                    Laya.timer.once(1000, that, function() {
                        that.isDown = false;
                        UIManager.closeFunction();
                    });
                }
                RoleManager.getInstance().increaseExp(expCount);
            };
            if (this.isShowThree) {
                AdUtil.setEvent(success, function() {
                    that.isDown = false;
                }, REWARD_CTRL_TYPE.END_DOUBLE_REWARD);
            } else {
                success();
            }
        }
        pointCtrl(img, time) {
            let x = RandomUtil.onlyOneRandomInt(30, this.imgRewardBg.width - 120);
            let y = RandomUtil.onlyOneRandomInt(30, this.imgRewardBg.height - 60);
            img.x = x;
            img.y = y;
            img.alpha = 0;
            Laya.timer.clearAll(img);
            Laya.Tween.clearAll(img);
            var that = this;
            let func = function() {
                if (img) {
                    Laya.Tween.to(img, {
                        alpha: 1
                    }, 400, null, Laya.Handler.create(img, () => {
                        Laya.Tween.to(img, {
                            alpha: 0
                        }, 400, null, Laya.Handler.create(img, () => {
                            that.pointCtrl(img, Math.random() * 1000);
                        }));
                    }));
                } else {
                    Laya.Tween.clearAll(img);
                }
            };
            Laya.timer.once(time, img, func);
        }
        showThree() {
            this.isAni = true;
            this.imgThree.visible = true;
            this.boxNormal.visible = false;
            this.boxThree.visible = true;
            var that = this;
            if (!this.isShowThree) {
                for (const key in this.itemCellList) {
                    if (Object.prototype.hasOwnProperty.call(this.itemCellList, key)) {
                        const element = this.itemCellList[key];
                        if (element) {
                            let x1 = ITEM_POS_LIST[this.itemList.length * 2][Number(key) * 3];
                            let y1 = ITEM_POS_LIST[this.itemList.length * 2][Number(key) * 3 + 1];
                            let s1 = ITEM_POS_LIST[this.itemList.length * 2][Number(key) * 3 + 2];
                            if (Number(key) < this.itemList.length) {
                                let x = ITEM_POS_LIST[this.itemList.length][Number(key) * 3];
                                let y = ITEM_POS_LIST[this.itemList.length][Number(key) * 3 + 1];
                                let s = ITEM_POS_LIST[this.itemList.length][Number(key) * 3 + 2];
                                element.pos(x, y);
                                element.scale(s, s);
                                Laya.Tween.to(element, {
                                    x: x1,
                                    y: y1,
                                    scaleX: s1,
                                    scaleY: s1
                                }, 200);
                            } else {
                                element.pos(x1, y1);
                                element.scale(s1, s1);
                                Laya.timer.once((Number(key) / 2) * 100, this, function() {
                                    element.show();
                                    if (Number(key) == that.itemList.length * 2 - 1) {
                                        that.isAni = false;
                                    }
                                });
                            }
                        }
                    }
                }
            } else {
                for (const key in this.itemCellList) {
                    if (Object.prototype.hasOwnProperty.call(this.itemCellList, key)) {
                        const element = this.itemCellList[key];
                        if (element) {
                            let x1 = ITEM_POS_LIST[this.itemList.length * 2][Number(key) * 3];
                            let y1 = ITEM_POS_LIST[this.itemList.length * 2][Number(key) * 3 + 1];
                            let s1 = ITEM_POS_LIST[this.itemList.length * 2][Number(key) * 3 + 2];
                            if (Number(key) < this.itemList.length) {
                                let x = ITEM_POS_LIST[this.itemList.length][Number(key) * 3];
                                let y = ITEM_POS_LIST[this.itemList.length][Number(key) * 3 + 1];
                                let s = ITEM_POS_LIST[this.itemList.length][Number(key) * 3 + 2];
                                element.pos(x1, y1);
                                element.scale(s1, s1);
                                Laya.timer.once((Number(key)) * 50, this, function() {
                                    element.show();
                                });
                            } else {
                                element.pos(x1, y1);
                                element.scale(s1, s1);
                                Laya.timer.once((Number(key)) * 50, this, function() {
                                    element.show();
                                    if (Number(key) == that.itemList.length * 2 - 1) {
                                        that.isAni = false;
                                    }
                                });
                            }
                        }
                    }
                }
            }
        }
        showNormal() {
            this.isAni = true;
            var that = this;
            this.imgThree.visible = false;
            this.boxNormal.visible = true;
            this.boxThree.visible = false;
            if (this.isShowThree) {
                for (const key in this.itemCellList) {
                    if (Object.prototype.hasOwnProperty.call(this.itemCellList, key)) {
                        const element = this.itemCellList[key];
                        if (element) {
                            let x1 = ITEM_POS_LIST[this.itemList.length * 2][Number(key) * 3];
                            let y1 = ITEM_POS_LIST[this.itemList.length * 2][Number(key) * 3 + 1];
                            let s1 = ITEM_POS_LIST[this.itemList.length * 2][Number(key) * 3 + 2];
                            if (Number(key) < this.itemList.length) {
                                let x = ITEM_POS_LIST[this.itemList.length][Number(key) * 3];
                                let y = ITEM_POS_LIST[this.itemList.length][Number(key) * 3 + 1];
                                let s = ITEM_POS_LIST[this.itemList.length][Number(key) * 3 + 2];
                                element.pos(x1, y1);
                                element.scale(s1, s1);
                                Laya.Tween.to(element, {
                                    x: x,
                                    y: y,
                                    scaleX: s,
                                    scaleY: s
                                }, 200, null, Laya.Handler.create(this, function() {
                                    that.isAni = false;
                                }), Number(this.itemList.length) * 100);
                            } else {
                                Laya.timer.once((this.itemList.length - Number(key)) * 50, this, function() {
                                    element.hide();
                                });
                            }
                        }
                    }
                }
            } else {
                for (const key in this.itemCellList) {
                    if (Object.prototype.hasOwnProperty.call(this.itemCellList, key)) {
                        const element = this.itemCellList[key];
                        if (Number(key) >= this.itemList.length)
                            break;
                        if (element) {
                            let x = ITEM_POS_LIST[this.itemList.length][Number(key) * 3];
                            let y = ITEM_POS_LIST[this.itemList.length][Number(key) * 3 + 1];
                            let s = ITEM_POS_LIST[this.itemList.length][Number(key) * 3 + 2];
                            element.pos(x, y);
                            element.scale(s, s);
                            Laya.timer.once(Number(key) * 100, this, function() {
                                element.show();
                                if (Number(key) == that.itemList.length - 1) {
                                    that.isAni = false;
                                }
                            });
                        }
                    }
                }
            }
        }
        onBtnThree() {
            if (!CommonUtil.getTouch())
                return;
            if (this.isAni)
                return;
            if (this.isShowThree) {
                this.showNormal();
                this.isShowThree = false;
            } else {
                this.showThree();
                this.isShowThree = true;
            }
        }
    }

    class GetThreeRewardFunction extends BaseFunction {
        createView() {
            this._viewCtrl = new GetThreeRewardViewCtrl(this._args);
            return this._viewCtrl;
        }
        getFunctionName() {
            return '获取金币界面';
        }
        onEnter() { super.onEnter(); }
        onExit() {
            super.onExit();
            if (RoleManager.getInstance().getGuide() <= GuideStep.FINISH) {
                UIManager.triggerAutoOpen();
            }
            if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD || ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS) {
                AdUtil.createInterstitialAd();
            }
        }
        onEnable() {
            super.onEnable();
            AdUtil.showBannerAd();
        }
        onDisbale() {
            super.onDisbale();
            AdUtil.hideBannerAd();
        }
        setAllButtonAnalysePoint() {}
        request(cb) {
            cb();
        }
    }

    class AddGoldViewCtrl extends ui.view.gold.AddGoldViewUI {
        constructor(type) {
            super();
            this.type = 0;
            this.reward = 800;
            this.height = this.stage.height;
            this.width = this.stage.width;
            this.type = type;
            this.name = 'AddGoldViewCtrl';
        }
        onAwake() {
            this.uiPlatformConfig();
            this.init();
            this.setEvent();
        }
        onDestroy() {
            this.type = null;
            this.reward = null;
            this.btnClose = null;
            this.btnGold = null;
            this.ani1 = null;
        }
        init() {
            this.ani1.play(0, true);
            RewardManager.setfreeRewardForGoldCoins();
            RewardManager.setRewardForInsufficientGoldCoins();
            if (this.type == 1) {
                this.labelTag.text = '金币不足!';
                this.labelTag.color = '#FF0C00';
                this.reward = RewardManager.curLackGoldRewards;
            } else {
                this.reward = RewardManager.curFreeGoldRewards;
            }
            this.txtGold.text = '金币x' + StringUtil.parseGold(this.reward.toString());
        }
        setEvent() {
            this.btnGold.on(Laya.Event.CLICK, this, this.onBtnGold);
            this.btnClose.on(Laya.Event.CLICK, this, this.onBtnClose);
            this.btnNo.on(Laya.Event.CLICK, this, this.onBtnClose);
        }
        onBtnGold() {
            if (!CommonUtil.getTouch())
                return;
            let that = this;
            AdUtil.setEvent(function() {
                if (that.type == 1) {
                    RewardManager.reduceLackGoldMultiple();
                }
                UIManager.openFunction(FUNCTION_TAG.GET_GOLD_REWARD, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.GOLD, that.reward);
            }, function() {}, REWARD_CTRL_TYPE.GOLD_REWARD);
        }
        onBtnClose() {
            if (!CommonUtil.getTouch())
                return;
            UIManager.closeFunction();
        }
        uiPlatformConfig() {
            UIManager.replaceAdIcon([{
                img: this.btnGold.getChildAt(0),
                type: 1
            }]);
            if (ConfigManager.platform == PLATFORM_TYPE.TT) {
                this.btnGold.centerX = -this.btnNo.centerX;
                this.btnNo.visible = true;
            }
        }
    }

    class AddGoldFunction extends BaseFunction {
        createView() {
            this._viewCtrl = new AddGoldViewCtrl(this._args);
            return this._viewCtrl;
        }
        getFunctionName() {
            return '增加金币界面';
        }
        onEnter() {
            super.onEnter();
            if (ConfigManager.platform == PLATFORM_TYPE.OPPO || ConfigManager.platform == PLATFORM_TYPE.WEB) {
                this.nativeBanner = new NativeBanner2ViewCtrl();
                let view = this._viewCtrl;
                view.addChild(this.nativeBanner);
                this.nativeIcon1 = new NativeIcon1CellCtrl();
                view.addChild(this.nativeIcon1);
                this.nativeIcon2 = new NativeIcon1CellCtrl();
                view.addChild(this.nativeIcon2);
                this.nativeIcon1.x = Laya.stage.width / 2 - 550;
                this.nativeIcon2.x = Laya.stage.width / 2 + 400;
                this.nativeIcon1.bottom = 30;
                this.nativeIcon2.bottom = 30;
            }
        }
        onExit() { super.onExit(); }
        onEnable() {
            super.onEnable();
            AdUtil.showBannerAd();
            this.nativeBanner && this.nativeBanner.show();
            this.nativeIcon1 && this.nativeIcon1.show();
            this.nativeIcon2 && this.nativeIcon2.show();
            GameScene.synthesisViewCtrl.nativeIcon1 && GameScene.synthesisViewCtrl.nativeIcon1.hide();
            GameScene.synthesisViewCtrl.nativeIcon2 && GameScene.synthesisViewCtrl.nativeIcon2.hide();
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || PLATFORM_TYPE.WX == ConfigManager.platform || PLATFORM_TYPE.NATIVE_ANDRIOD == ConfigManager.platform) {
                let x = PlatformUtil.getBannerCenterPos().x + PlatformUtil.getBannerWeight() + 30;
                let y = Laya.stage.height - PlatformUtil.getCustomSize().h;
                let x1 = PlatformUtil.getBannerCenterPos().x - PlatformUtil.getCustomSize().w - 30;
                if (ConfigManager.platform == PLATFORM_TYPE.WX) {
                    AdUtil.showCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                    AdUtil.showCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                } else {
                    AdUtil.showCustom(x, y);
                    AdUtil.showCustom(x1, y);
                }
            }
        }
        onDisbale() {
            super.onDisbale();
            AdUtil.hideBannerAd();
            this.nativeBanner && this.nativeBanner.hide();
            this.nativeIcon1 && this.nativeIcon1.hide();
            this.nativeIcon2 && this.nativeIcon2.hide();
            GameScene.synthesisViewCtrl.nativeIcon1 && GameScene.synthesisViewCtrl.nativeIcon1.show();
            GameScene.synthesisViewCtrl.nativeIcon2 && GameScene.synthesisViewCtrl.nativeIcon2.show();
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || PLATFORM_TYPE.WX == ConfigManager.platform || PLATFORM_TYPE.NATIVE_ANDRIOD == ConfigManager.platform) {
                let x = PlatformUtil.getBannerCenterPos().x + PlatformUtil.getBannerWeight() + 30;
                let y = Laya.stage.height - PlatformUtil.getCustomSize().h;
                let x1 = PlatformUtil.getBannerCenterPos().x - PlatformUtil.getCustomSize().w - 30;
                if (ConfigManager.platform == PLATFORM_TYPE.WX) {
                    AdUtil.hideCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                    AdUtil.hideCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                } else {
                    AdUtil.hideCustom(x, y);
                    AdUtil.hideCustom(x1, y);
                }
            }
        }
        setAllButtonAnalysePoint() {}
        request(cb) {
            cb();
        }
    }

    class MapMenuCellViewCtrl extends ui.view.menu.MapMenuCellViewUI {
        constructor(type) {
            super();
            this.type = type;
            this.imgSelect.visible = false;
            this.setView();
        }
        onAwake() {
            this.on(Laya.Event.CLICK, this, this.onBtnDown);
        }
        onDestroy() {
            this.boxMain = null;
            this.imgIcon = null;
        }
        setView() {
            if (ConfigManager.platform == PLATFORM_TYPE.TT || ConfigManager.platform == PLATFORM_TYPE.WEB) {
                if (ConfigManager.isReviewVersion()) {
                    this.imgIcon.skin = 'sub1/ui/menu/' + (this.type) + '.png';
                }
            }
            this.imgIcon.skin = 'sub1/ui/menu/' + (this.type) + '.png';
        }
        onBtnDown() {
            if (!CommonUtil.getTouch())
                return;
            if (this.type == GAME_MAP.UN_MAP)
                return;
            ModeManager.map = this.type;
            if (ModeManager.map == GAME_MAP.RAND) {
                ModeManager.map = UIManager.getFunctionViewCtrl(FUNCTION_TAG.MAP_MENU).dataList[RandomUtil.onlyOneRandomInt(1, UIManager.getFunctionViewCtrl(FUNCTION_TAG.MAP_MENU).dataList.length - 1)];
            }
            UIManager.getFunctionViewCtrl(FUNCTION_TAG.MAP_MENU).changeCellSelect();
            this.changeSelect(true);
        }
        changeSelect(visible) {
            this.imgSelect.visible = visible;
        }
    }

    let mapCount = 3;
    class MapMenuViewCtrl extends ui.view.menu.MapMenuViewUI {
        constructor(mode) {
            super();
            this.list = [];
            this.dataList = [];
            this.apertureCtrl = null;
            this.fingerCtrl = null;
            this.width = Laya.stage.width;
            this.height = Laya.stage.height;
            this.mode = mode;
            this.setView();
        }
        onAwake() {
            this.fingerCtrl = GuideManager.createFingerAniCtrl(this);
            this.apertureCtrl = GuideManager.createCommonAperture(this);
            this.btnClose.on(Laya.Event.CLICK, this, () => {
                UIManager.closeFunction();
            });
            this.btnStart.on(Laya.Event.CLICK, this, this.onBtnStart);
            if (ConfigManager.platform == PLATFORM_TYPE.TT || ConfigManager.platform == PLATFORM_TYPE.WEB) {
                if (ConfigManager.isReviewVersion()) {
                    this.imgBg.skin = 'sub1/ui/first/img_2.jpg';
                }
            }
        }
        onDestroy() {}
        setGuide() {
            console.log('当前新手步骤：', RoleManager.getInstance().getGuide());
            switch (RoleManager.getInstance().getGuide()) {
                case GuideStep.GAME_1:
                    {
                        console.log('游戏1');
                        let point1 = new Laya.Point(this.btnStart.width / 2, this.btnStart.height / 2);
                        let a = this.btnStart.localToGlobal(point1);
                        let point2 = new Laya.Point(this.btnStart.width / 2, this.btnStart.height / 2);
                        let b = this.btnStart.localToGlobal(point2);
                        this.setGudePos(a, b, this.btnStart);
                        break;
                    }
                case GuideStep.GAME_2:
                    {
                        console.log('游戏2');
                        let point1 = new Laya.Point(this.btnStart.width / 2, this.btnStart.height / 2);
                        let a = this.btnStart.localToGlobal(point1);
                        let point2 = new Laya.Point(this.btnStart.width / 2, this.btnStart.height / 2);
                        let b = this.btnStart.localToGlobal(point2);
                        this.setGudePos(a, b, this.btnStart);
                        break;
                    }
                case GuideStep.FUNGAME_1:
                    {
                        console.log('游戏3');
                        let point1 = new Laya.Point(this.btnStart.width / 2, this.btnStart.height / 2);
                        let a = this.btnStart.localToGlobal(point1);
                        let point2 = new Laya.Point(this.btnStart.width / 2, this.btnStart.height / 2);
                        let b = this.btnStart.localToGlobal(point2);
                        this.setGudePos(a, b, this.btnStart);
                        break;
                    }
            }
        }
        setGudePos(a, b, targetBtn) {
            targetBtn.mouseEnabled = true;
            this.fingerCtrl.visible = true;
            this.fingerCtrl.play();
            this.fingerCtrl.x = a.x;
            this.fingerCtrl.y = a.y;
            this.apertureCtrl.visible = true;
            this.apertureCtrl.play(false);
            this.apertureCtrl.x = b.x - this.apertureCtrl.width / 2;
            this.apertureCtrl.y = b.y - this.apertureCtrl.height / 2;
        }
        setView() {
            this.panel.hScrollBarSkin = '';
            this.boxCell.width = 0;
            let data = [];
            switch (this.mode) {
                case GAME_MODE_TYPE.TEAMCOMPETITION:
                    data.push(0);
                    data.push(1);
                    data.push(2);
                    break;
                case GAME_MODE_TYPE.KNIFEWARMODE:
                case GAME_MODE_TYPE.TWOVSTWOMODE:
                    data.push(0);
                    data.push(1);
                    data.push(2);
                    break;
                case GAME_MODE_TYPE.ONEVSONEMODE:
                    data.push(1);
                    break;
                case GAME_MODE_TYPE.BIOCHEMISTRY:
                    data.push(7);
                    break;
                case GAME_MODE_TYPE.SNIPERMODE:
                    data.push(1);
                    break;
            }
            if (ConfigManager.platform != PLATFORM_TYPE.WEB_4399) {
                data.push(-1);
            }
            this.dataList = data;
            console.log('地图列表：', this.dataList);
            let width = 0;
            for (let index = 0; index < data.length; index++) {
                let ctrl = new MapMenuCellViewCtrl(data[index]);
                this.list.push(ctrl);
                this.boxCell.addChild(ctrl);
                this.boxCell.width += ctrl.width;
                width += ctrl.width;
                if (index == 0) {
                    ctrl.changeSelect(true);
                    ModeManager.map = ctrl.type;
                    if (ModeManager.map == GAME_MAP.RAND) {
                        ModeManager.map = this.dataList[RandomUtil.onlyOneRandomInt(1, this.dataList.length - 1)];
                    }
                }
            }
            this.boxCell.width = width + 150;
            this.panel.refresh();
            if (this.boxCell.numChildren <= 3) {
                this.boxCell.x = (Laya.stage.width - width) * 0.5;
                console.log('this.boxCell.x', this.boxCell.x);
            } else {
                this.boxCell.width += 200;
            }
        }
        onBtnStart() {
            if (!CommonUtil.getTouch())
                return;
            let that = this;
            if (ConfigManager.platform != PLATFORM_TYPE.TT && ConfigManager.platform != PLATFORM_TYPE.WEB) {
                UIManager.openFunction(FUNCTION_TAG.ROLETRY, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.WINDOW, COMMON_MENU_STYLE.HIDE, {
                    cb: function() {
                        UIManager.openFunction(FUNCTION_TAG.SUPERSTART, FUNCTION_OPEN_MODE.REPLACE, FUNCTION_TYPE.WINDOW, COMMON_MENU_STYLE.HIDE, {
                            cb: function() {
                                if (that.mode != GAME_MODE_TYPE.KNIFEWARMODE) {
                                    if (!RoleManager.getInstance().isNew && RoleManager.getInstance().getGuide() != GuideStep.GAME_1) {
                                        UIManager.openFunction(FUNCTION_TAG.EQUIP_TRY, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE);
                                    } else {
                                        UIManager.getFunctionViewCtrl(FUNCTION_TAG.FIRST).loading();
                                    }
                                } else
                                    UIManager.getFunctionViewCtrl(FUNCTION_TAG.FIRST).loading();
                            }
                        });
                    }
                });
            } else {
                if (ConfigManager.isReviewVersion()) {
                    UIManager.closeFunction();
                    UIManager.getFunctionViewCtrl(FUNCTION_TAG.FIRST).loading();
                } else {
                    UIManager.openFunction(FUNCTION_TAG.ROLETRY, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.WINDOW, COMMON_MENU_STYLE.HIDE, {
                        cb: function() {
                            UIManager.openFunction(FUNCTION_TAG.SUPERSTART, FUNCTION_OPEN_MODE.REPLACE, FUNCTION_TYPE.WINDOW, COMMON_MENU_STYLE.HIDE, {
                                cb: function() {
                                    if (that.mode != GAME_MODE_TYPE.KNIFEWARMODE) {
                                        if (!RoleManager.getInstance().isNew && RoleManager.getInstance().getGuide() != GuideStep.GAME_1) {
                                            UIManager.openFunction(FUNCTION_TAG.EQUIP_TRY, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE);
                                        } else {
                                            UIManager.getFunctionViewCtrl(FUNCTION_TAG.FIRST).loading();
                                        }
                                    } else
                                        UIManager.getFunctionViewCtrl(FUNCTION_TAG.FIRST).loading();
                                }
                            });
                        }
                    });
                }
            }
        }
        changeCellSelect() {
            for (let index = 0; index < this.list.length; index++) {
                const element = this.list[index];
                element.changeSelect(false);
            }
        }
    }

    class MapMenuFunction extends BaseFunction {
        createView() {
            this._viewCtrl = new MapMenuViewCtrl(this.args);
            return this._viewCtrl;
        }
        getFunctionName() {
            return '菜单选择界面';
        }
        onEnter() {
            super.onEnter();
            if (ConfigManager.platform == PLATFORM_TYPE.OPPO || ConfigManager.platform == PLATFORM_TYPE.WEB) {
                this.nativeBanner = new NativeBanner2ViewCtrl();
                let view = this._viewCtrl;
                view.addChild(this.nativeBanner);
                this.nativeIcon1 = new NativeIcon1CellCtrl();
                view.addChild(this.nativeIcon1);
                this.nativeIcon2 = new NativeIcon1CellCtrl();
                view.addChild(this.nativeIcon2);
                this.nativeIcon1.x = Laya.stage.width / 2 - 450;
                this.nativeIcon2.x = Laya.stage.width / 2 + 280;
                this.nativeIcon1.bottom = 30;
                this.nativeIcon2.bottom = 30;
                this.nativeBanner.scale(0.8, 0.8);
                this.nativeIcon1.scale(0.8, 0.8);
                this.nativeIcon2.scale(0.8, 0.8);
                if (!PlatformUtil.isFullScreen()) {
                    this.nativeBanner.left = NaN;
                    this.nativeBanner.centerX = NaN;
                    this.nativeBanner.x = Laya.stage.width / 2 - this.nativeBanner.width / 2 - 8;
                    this.nativeIcon2.x -= 60;
                }
            }
        }
        onExit() { super.onExit(); }
        onEnable() {
            super.onEnable();
            AdUtil.showBannerAd();
            this.nativeBanner && this.nativeBanner.show();
            this.nativeIcon1 && this.nativeIcon1.show();
            this.nativeIcon2 && this.nativeIcon2.show();
            if (ConfigManager.platform == PLATFORM_TYPE.QQ || ConfigManager.platform == PLATFORM_TYPE.WX || ConfigManager.appId == ANDROID_APP_ID.XM) {
                AdUtil.showCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
            }
        }
        onDisbale() {
            super.onDisbale();
            AdUtil.hideBannerAd();
            this.nativeBanner && this.nativeBanner.hide();
            this.nativeIcon1 && this.nativeIcon1.hide();
            this.nativeIcon2 && this.nativeIcon2.hide();
            if (ConfigManager.platform == PLATFORM_TYPE.QQ || ConfigManager.platform == PLATFORM_TYPE.WX || ConfigManager.appId == ANDROID_APP_ID.XM) {
                AdUtil.hideCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
            }
        }
        setAllButtonAnalysePoint() {}
        request(cb) {
            cb();
        }
    }

    class ModeFunction extends BaseFunction {
        createView() {
            this._viewCtrl = new ModeViewCtrl(this.args);
            return this._viewCtrl;
        }
        getFunctionName() {
            return '模式选择界面';
        }
        onEnter() {
            super.onEnter();
            if (ConfigManager.platform == PLATFORM_TYPE.OPPO || ConfigManager.platform == PLATFORM_TYPE.WEB) {
                this.nativeBanner = new NativeBanner2ViewCtrl();
                let view = this._viewCtrl;
                view.addChild(this.nativeBanner);
                this.nativeIcon1 = new NativeIcon1CellCtrl();
                view.addChild(this.nativeIcon1);
                this.nativeIcon2 = new NativeIcon1CellCtrl();
                view.addChild(this.nativeIcon2);
                this.nativeIcon1.x = Laya.stage.width / 2 - 550;
                this.nativeIcon2.x = Laya.stage.width / 2 + 400;
                this.nativeIcon1.bottom = 30;
                this.nativeIcon2.bottom = 30;
            }
        }
        onExit() { super.onExit(); }
        onEnable() {
            super.onEnable();
            AdUtil.showBannerAd();
            this.nativeBanner && this.nativeBanner.show();
            this.nativeIcon1 && this.nativeIcon1.show();
            this.nativeIcon2 && this.nativeIcon2.show();
            if (PLATFORM_TYPE.WX == ConfigManager.platform) {
                let x = PlatformUtil.getBannerCenterPos().x + PlatformUtil.getBannerWeight() + 30;
                let y = Laya.stage.height - PlatformUtil.getCustomSize().h;
                let x1 = PlatformUtil.getBannerCenterPos().x - PlatformUtil.getCustomSize().w - 30;
                AdUtil.showCustom(x1, y);
                AdUtil.showCustom(x, y);
            }
        }
        onDisbale() {
            super.onDisbale();
            AdUtil.hideBannerAd();
            this.nativeBanner && this.nativeBanner.hide();
            this.nativeIcon1 && this.nativeIcon1.hide();
            this.nativeIcon2 && this.nativeIcon2.hide();
            if (PLATFORM_TYPE.WX == ConfigManager.platform) {
                let x = PlatformUtil.getBannerCenterPos().x + PlatformUtil.getBannerWeight() + 30;
                let y = Laya.stage.height - PlatformUtil.getCustomSize().h;
                let x1 = PlatformUtil.getBannerCenterPos().x - PlatformUtil.getCustomSize().w - 30;
                AdUtil.hideCustom(x1, y);
                AdUtil.hideCustom(x, y);
            }
        }
        setAllButtonAnalysePoint() {}
        request(cb) {
            cb();
        }
    }

    class OfflineViewCtrl extends ui.view.offline.OfflineViewUI {
        constructor() {
            super();
            this.reward = 800;
            this.width = this.stage.width;
            this.height = this.stage.height;
        }
        onAwake() {
            this.uiPlatformConfig();
            this.init();
            this.setEvent();
            if (ConfigManager.platform == PLATFORM_TYPE.WX || ConfigManager.platform == PLATFORM_TYPE.TT || ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.WEB_4399) {
                this.btnNo.visible = true;
                this.btnClose.visible = false;
                this.btnAd.centerX = -this.btnNo.centerX;
            } else {
                this.btnNo.visible = false;
            }
        }
        onDestroy() {
            RoleManager.getInstance().setOfflineTime();
            this.ani1 = null;
            this.btnAd = null;
            this.btnClose = null;
        }
        init() {
            RewardManager.setOflineReawrd();
            this.ani1.play(0, true);
            this.reward = RewardManager.offlineReawrds;
            this.txtContent.text = RoleManager.getInstance().curOffinetime + '小时的离线收益';
            this.txtGold.text = '金币x' + StringUtil.parseGold(this.reward.toString());
        }
        setEvent() {
            this.btnAd.on(Laya.Event.CLICK, this, this.onbtnAd);
            this.btnClose.on(Laya.Event.CLICK, this, this.onBtnClose);
            this.btnNo.on(Laya.Event.CLICK, this, this.onBtnClose);
        }
        onbtnAd() {
            if (!CommonUtil.getTouch())
                return;
            let that = this;
            AdUtil.setEvent(function() {
                UIManager.closeFunction();
                UIManager.openFunction(FUNCTION_TAG.GET_GOLD_REWARD, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.ALL_SHOW, that.reward * 2);
            }, function() {}, REWARD_CTRL_TYPE.GOLD_REWARD);
        }
        onBtnClose() {
            if (!CommonUtil.getTouch())
                return;
            UIManager.closeFunction();
            UIManager.openFunction(FUNCTION_TAG.GET_GOLD_REWARD, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.ALL_SHOW, this.reward);
        }
        onBtnSingle() {
            if (!CommonUtil.getTouch())
                return;
            UIManager.closeFunction();
            UIManager.openFunction(FUNCTION_TAG.GET_GOLD_REWARD, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.ALL_SHOW, this.reward);
        }
        uiPlatformConfig() {
            UIManager.replaceAdIcon([{
                img: this.btnAd.getChildAt(0),
                type: 1
            }]);
        }
    }

    class OffLineFunction extends BaseFunction {
        createView() {
            this._viewCtrl = new OfflineViewCtrl();
            return this._viewCtrl;
        }
        getFunctionName() {
            return '离线奖励界面';
        }
        onEnter() { super.onEnter(); }
        onExit() { super.onExit(); }
        onEnable() {
            super.onEnable();
            AdUtil.showBannerAd();
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || ConfigManager.platform == PLATFORM_TYPE.WX) {
                AdUtil.showCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                AdUtil.showCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
            }
        }
        onDisbale() {
            super.onDisbale();
            AdUtil.hideBannerAd();
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || ConfigManager.platform == PLATFORM_TYPE.WX) {
                AdUtil.hideCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                AdUtil.hideCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
            }
        }
        setAllButtonAnalysePoint() {}
        request(cb) {
            cb();
        }
    }

    class ReviveViewCtrl extends ui.view.revive.ReviveViewUI {
        constructor() {
            super();
            this.countDown = 10;
            this.isDone = false;
            this.width = this.stage.width;
            this.height = this.stage.height;
            if (ConfigManager.platform == PLATFORM_TYPE.WEB_4399 && Laya.Browser.onPC) {
                Laya.Browser.document.exitPointerLock();
            }
        }
        onAwake() {
            this.uiPlatformConfig();
            CharacterManger.gameStop = true;
            this.txtCountDown.text = this.countDown.toString();
            this.txtHit.text = '对我造成伤害：' + RandomUtil.onlyOneRandomInt(50, 100).toString();
            this.timerLoop(1000, this, this.update);
            this.btnBack.on(Laya.Event.CLICK, this, this.onBtnBack);
            this.btnNo.on(Laya.Event.CLICK, this, this.onBtnBack);
            this.btnRevive.on(Laya.Event.CLICK, this, this.onBtnRevive);
            this.setPlatformStyle();
            this.txtKiller.text = ModeManager.mode == GAME_MODE_TYPE.BIOCHEMISTRY ? '丧尸' : CharacterManger.killerName;
            if (CharacterManger.killerLogic) {
                if (CharacterManger.killerLogic.getArmCtrl())
                    this.imgArm.skin = CharacterManger.killerLogic.getArmCtrl().getIcon();
            }
            if (ConfigManager.platform == PLATFORM_TYPE.TT || ConfigManager.platform == PLATFORM_TYPE.WX || ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.WEB_4399) {
                this.btnNo.visible = true;
                this.btnRevive.centerX = -this.btnNo.centerX;
                this.btnBack.visible = false;
            }
        }
        onDestroy() {
            this.countDown = null;
            this.isDone = null;
            if (ConfigManager.platform == PLATFORM_TYPE.WEB_4399 && Laya.Browser.onPC) {
                let view = UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME);
                view.onBtnDown(true);
            }
        }
        update() {
            if (this.countDown != 0) {
                this.countDown--;
                this.txtCountDown.text = this.countDown.toString();
            } else {
                this.txtCountDown.text = this.countDown.toString();
                this.over();
                this.timer.clear(this, this.update);
            }
        }
        over() {
            if (!this.isDone) {
                this.isDone = true;
                this.timer.resume();
                UIManager.clean();
                UIManager.openFunction(FUNCTION_TAG.GAMEOVER, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE, false);
            }
        }
        revive() {
            this.isDone = true;
            this.timer.resume();
            UIManager.closeFunction();
            CharacterManger.gameStop = false;
            CharacterManger.playerLogicalBaseLayer.directRevive(function() {
                CharacterManger.playerLogicalBaseLayer.getPresentationBaseLayer().setPos(CharacterManger.playerLogicalBaseLayer.getInitPos());
            });
        }
        onBtnBack() {
            if (!CommonUtil.getTouch())
                return;
            this.over();
        }
        onBtnRevive() {
            if (!CommonUtil.getTouch())
                return;
            let that = this;
            this.timer.pause();
            AdUtil.setEvent(function() {
                that.revive();
            }, function() {
                that.timer.resume();
            }, REWARD_CTRL_TYPE.REVIVE);
        }
        setPlatformStyle() {
            switch (ConfigManager.platform) {
                case PLATFORM_TYPE.WX:
                    {
                        this.setWXPlatform();
                        break;
                    }
                case PLATFORM_TYPE.QQ:
                    {
                        this.setQQPlatform();
                        break;
                    }
                case PLATFORM_TYPE.WEB:
                    {
                        this.setWXPlatform();
                        break;
                    }
                case PLATFORM_TYPE.WEB_4399:
                    {
                        this.setWeb4399Platform();
                        break;
                    }
                case PLATFORM_TYPE.VIVO:
                    {
                        this.setVIVOPlatform();
                        break;
                    }
                case PLATFORM_TYPE.OPPO:
                    {
                        this.setOPPOPlatform();
                        break;
                    }
                case PLATFORM_TYPE.NATIVE_IOS:
                    {
                        this.setNativeIOSPlatform();
                        break;
                    }
                case PLATFORM_TYPE.NATIVE_ANDRIOD:
                    {
                        this.setNativeAndroidPlatform();
                        break;
                    }
                case PLATFORM_TYPE.TT:
                    {
                        this.setTTPlatform();
                        break;
                    }
            }
        }
        setWXPlatform() {
            if (PlatformUtil.isIOS()) {
                this.btnBack.y -= 30;
                this.btnRevive.y -= 30;
                this.btnNo.y -= 30;
            }
        }
        setQQPlatform() {}
        setWebPlatform() {}
        setVIVOPlatform() {}
        setOPPOPlatform() {}
        setNativeIOSPlatform() {}
        setWeb4399Platform() {}
        setNativeAndroidPlatform() {}
        setTTPlatform() {}
        uiPlatformConfig() {}
    }

    class ReviveFunction extends BaseFunction {
        createView() {
            this._viewCtrl = new ReviveViewCtrl();
            return this._viewCtrl;
        }
        getFunctionName() {
            return '复活界面';
        }
        onEnter() {
            super.onEnter();
            if (ConfigManager.platform == PLATFORM_TYPE.OPPO || ConfigManager.platform == PLATFORM_TYPE.WEB) {
                this.nativeBanner = new NativeBanner2ViewCtrl();
                let view = this._viewCtrl;
                view.addChild(this.nativeBanner);
            }
        }
        onExit() { super.onExit(); }
        onEnable() {
            super.onEnable();
            AdUtil.showBannerAd();
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || ConfigManager.platform == PLATFORM_TYPE.WX) {
                AdUtil.showCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                AdUtil.showCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
            }
        }
        onDisbale() {
            super.onDisbale();
            AdUtil.hideBannerAd();
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || ConfigManager.platform == PLATFORM_TYPE.WX) {
                AdUtil.hideCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                AdUtil.hideCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
            }
        }
        setAllButtonAnalysePoint() {}
        request(cb) {
            cb();
        }
    }

    class NewYearGiftData {
        static getDataByKey(key) {
            if (NewYearGiftData.cache[key])
                return NewYearGiftData.cache[key];
            if (key == 1) {
                let template = new NewYearGiftData();
                template.id = 1;
                template.info = '24小时';
                template.award = 60;
                template.awardType = 2;
                template.cost = 10;
                template.armTime = 86400;
                NewYearGiftData.cache[key] = template;
                return template;
            } else if (key == 2) {
                let template = new NewYearGiftData();
                template.id = 2;
                template.info = '500';
                template.award = 500;
                template.awardType = 3;
                template.cost = 30;
                template.armTime = 0;
                NewYearGiftData.cache[key] = template;
                return template;
            } else if (key == 3) {
                let template = new NewYearGiftData();
                template.id = 3;
                template.info = '永久';
                template.award = 59;
                template.awardType = 2;
                template.cost = 60;
                template.armTime = 0;
                NewYearGiftData.cache[key] = template;
                return template;
            } else if (key == 4) {
                let template = new NewYearGiftData();
                template.id = 4;
                template.info = '1.50k';
                template.award = 1500;
                template.awardType = 3;
                template.cost = 90;
                template.armTime = 0;
                NewYearGiftData.cache[key] = template;
                return template;
            } else if (key == 5) {
                let template = new NewYearGiftData();
                template.id = 5;
                template.info = '永久';
                template.award = 60;
                template.awardType = 2;
                template.cost = 120;
                template.armTime = 0;
                NewYearGiftData.cache[key] = template;
                return template;
            }
        }
        static getDataByIndex(index) {
            if (NewYearGiftData.cache[this.keys[index]])
                return NewYearGiftData.cache[this.keys[index]];
            return this.getDataByKey(this.keys[index]);
        }
        static getAllData() {
            for (let index = 0; index < this.keys.length; index++) {
                this.getDataByKey(this.keys[index]);
            }
            return NewYearGiftData.cache;
        }
        clear() {
            NewYearGiftData.cache = {};
        }
    }
    NewYearGiftData.cache = {};
    NewYearGiftData.keys = [1, 2, 3, 4, 5];

    var SHOW_TYPE$1;
    (function(SHOW_TYPE) {
        SHOW_TYPE[SHOW_TYPE["HIDE"] = 0] = "HIDE";
        SHOW_TYPE[SHOW_TYPE["SHOW"] = 1] = "SHOW";
    })(SHOW_TYPE$1 || (SHOW_TYPE$1 = {}));
    let urlBg$1 = ['sub1/ui/scale9/img_Item_bg_4.png',
        'sub1/ui/scale9/img_Item_bg_3.png',
        'sub1/ui/scale9/img_Item_bg_2.png',
        'sub1/ui/scale9/img_Item_bg_1.png'
    ];
    let urlTag = ['sub1/ui/library/img_grade_1.png',
        'sub1/ui/library/img_grade_2.png',
        'sub1/ui/library/img_grade_3.png',
        'sub1/ui/library/img_grade_4.png'
    ];
    let urlDebris = ['sub1/ui/getReward/img_debris_4.png',
        'sub1/ui/getReward/img_debris_3.png',
        'sub1/ui/getReward/img_debris_2.png',
        'sub1/ui/getReward/img_debris_1.png'
    ];
    class BoxItemCellViewCtrl extends ui.view.getReward.BoxItemCellViewUI {
        constructor() {
            super();
            this.type = SHOW_TYPE$1.HIDE;
            this.isExtara = false;
            this.targetP = 0;
            this.visible = false;
            this.type = SHOW_TYPE$1.HIDE;
            this.maxPWigth = this.imgP.width;
        }
        setView(itemId, count, isExtra = false) {
            console.log('shit', itemId);
            this.itemData = Item.getDataByKey(itemId);
            console.log('shit', this.itemData);
            this.count = count;
            this.targetP = 0;
            this.imgDebris.visible = false;
            this.labelExtra.visible = false;
            this.imgIcon.scale(1.9, 1.9);
            this.visible = false;
            this.type = SHOW_TYPE$1.HIDE;
            this.imgGrade.visible = false;
            this.boxDebrisP.visible = false;
            this.labelCount.visible = true;
            switch (this.itemData.type) {
                case ITEM_TYPE.GOLD:
                case ITEM_TYPE.DIAMOND:
                case ITEM_TYPE.EXP:
                case ITEM_TYPE.OTHER:
                    this.imgIcon.skin = RES_PATH.ITEM_ROOT + this.itemData.icon;
                    this.labelName.text = this.itemData.name;
                    this.labelCount.text = StringUtil.parseGold(this.count);
                    this.imgBg.skin = 'sub1/ui/scale9/img_Item_bg_1.png';
                    break;
                case ITEM_TYPE.HERO_DEBRIS:
                    {
                        this.labelCount.visible = false;
                        this.imgIcon.scale(1.4, 1.4);
                        this.imgIcon.skin = RES_PATH.ROLE_ROOT + this.itemData.icon;
                        this.labelName.text = this.itemData.name;
                        this.labelCount.text = 'x' + StringUtil.parseGold(this.count);
                        this.boxDebrisP.visible = true;
                        this.labelName.text = this.itemData.name;
                        this.imgGrade.visible = true;
                        this.imgBg.skin = urlBg$1[Math.max(0, this.itemData.quality - 1)];
                        this.imgGrade.skin = urlTag[Math.max(0, this.itemData.quality - 1)];
                        console.log(this.itemData.name + RoleManager.getInstance().getTargetFragment({
                            type: ITEM_TYPE.HERO_DEBRIS,
                            id: this.itemData.id
                        }));
                        let a = RoleManager.getInstance().getTargetFragment({
                            type: ITEM_TYPE.HERO_DEBRIS,
                            id: this.itemData.id
                        });
                        let b = RoleData.getDataByKey(this.itemData.extra()).cost;
                        this.imgP.width = this.maxPWigth * Math.min(1, (a - this.count) / b);
                        this.labelDebris.text = '(' + a + '/' + b + ')';
                        this.labelDebrisCount.text = 'x' + StringUtil.parseGold(this.count);
                        this.targetP = this.maxPWigth * Math.min(1, a / b);
                        this.imgDebris.skin = urlDebris[Math.max(0, this.itemData.quality - 1)];
                    }
                    break;
                case ITEM_TYPE.PART_DEBRIS:
                    {
                        this.labelCount.visible = false;
                        this.imgIcon.scale(1, 1);
                        this.imgIcon.skin = PARTS.getDataByKey(this.itemData.extra()).icon;
                        this.labelName.text = this.itemData.name;
                        this.labelCount.text = 'x' + StringUtil.parseGold(this.count);
                        this.boxDebrisP.visible = true;
                        this.labelName.text = this.itemData.name;
                        this.imgGrade.visible = true;
                        this.imgBg.skin = urlBg$1[Math.max(0, this.itemData.quality - 1)];
                        this.imgGrade.skin = urlTag[Math.max(0, this.itemData.quality - 1)];
                        let a = RoleManager.getInstance().getTargetFragment({
                            type: ITEM_TYPE.PART_DEBRIS,
                            id: this.itemData.id
                        });
                        let b = PARTS.getDataByKey(this.itemData.extra()).cost;
                        this.imgP.width = this.maxPWigth * Math.min(1, (a - count) / b);
                        this.labelDebris.text = '(' + a + '/' + b + ')';
                        this.labelDebrisCount.text = 'x' + StringUtil.parseGold(this.count);
                        this.targetP = this.maxPWigth * Math.min(1, a / b);
                        this.imgDebrisP.skin = urlDebris[Math.max(0, this.itemData.quality - 1)];
                        this.imgDebris.skin = urlDebris[Math.max(0, this.itemData.quality - 1)];
                    }
                    break;
            }
            if (isExtra) {
                this.isExtara = true;
                this.imgBg.skin = 'sub1/ui/scale9/img_Item_bg_0.png';
                this.labelExtra.visible = true;
                if (this.itemData.type == ITEM_TYPE.PART_DEBRIS || ITEM_TYPE.HERO_DEBRIS == this.itemData.type) {
                    this.imgGrade.visible = true;
                }
            }
        }
        show(cb = null) {
            this.visible = true;
            this.aniOpen.wrapMode = Laya.AnimationBase.WRAP_POSITIVE;
            this.aniOpen.offAll(Laya.Event.COMPLETE);
            this.aniOpen.play(0, false);
            var that = this;
            Laya.Tween.clearAll(this.imgP);
            this.aniOpen.on(Laya.Event.COMPLETE, this, function() {
                that.type = SHOW_TYPE$1.SHOW;
                if (that.targetP) {
                    Laya.Tween.to(this.imgP, {
                        width: that.targetP
                    }, 500);
                }
                cb && cb();
            });
        }
        hide(cb = null) {
            this.aniOpen.wrapMode = Laya.AnimationBase.WRAP_REVERSE;
            this.aniOpen.offAll(Laya.Event.COMPLETE);
            this.aniOpen.play(0, false);
            var that = this;
            this.aniOpen.on(Laya.Event.COMPLETE, this, function() {
                that.type = SHOW_TYPE$1.HIDE;
                that.visible = false;
                cb && cb();
            });
        }
        wordPos() {
            let point = new Laya.Point(this.width / 2, this.height / 2);
            this.localToGlobal(point);
            return point;
        }
    }

    let ITEM_POS_LIST$1 = {
        1: [420, 66, 0.6],
        2: [347, 65, 0.6, 501, 65, 0.6],
        3: [267, 65, 0.6, 421, 65, 0.6, 576, 65, 0.6],
        4: [194, 65, 0.6, 347, 65, 0.6, 501, 65, 0.6, 656, 65, 0.6],
        5: [114, 65, 0.6, 267, 65, 0.6, 421, 65, 0.6, 576, 65, 0.6, 732, 65, 0.6],
        6: [261, 16, 1, 416, 16, 1, 574, 16, 1, 261, 174, 1, 416, 174, 1, 574, 174, 1],
        8: [188, 16, 1, 341, 16, 1, 494, 16, 1, 647, 16, 1, 188, 174, 1, 341, 174, 1, 494, 174, 1, 647, 174, 1],
    };
    class GetBoxRewardNextViewCtrl extends ui.view.getReward.GetBoxRewardNextViewUI {
        constructor(itemList) {
            super();
            this.itemList = [];
            this.itemCellList = {};
            this.isAni = false;
            this.isDown = false;
            this.isHaveExtra = false;
            this.width = this.stage.width;
            this.height = this.stage.height;
            this.itemList = itemList;
            this.boxBg.scaleX = this.stage.width / this.boxBg.width;
        }
        onAwake() {
            this.init();
            this.setEvent();
        }
        onDestroy() {
            this.timer.clearAll(this);
            if (UIManager.getFunction(FUNCTION_TAG.NEW_YEAR_GIFT))
                UIManager.triggerAutoOpen();
        }
        init() {
            if (this.itemList[0].isExtra)
                GetBoxRewardNextViewCtrl.adSuccess(this.itemList, true);
            let isHaveExtra = false;
            for (let index = 0; index < this.itemList.length; index++) {
                const element = this.itemList[index];
                let ctrl = new BoxItemCellViewCtrl();
                ctrl.setView(element.itemId, element.count, element.isExtra);
                this.boxCell.addChild(ctrl);
                if (element.isExtra) {
                    isHaveExtra = true;
                    this.isHaveExtra = true;
                }
                this.itemCellList[index] = ctrl;
            }
            this.showNormal();
            if (isHaveExtra)
                this.boxNormal.visible = true;
            else {
                this.boxNormal.visible = false;
                this.btnBack.visible = true;
                this.on(Laya.Event.CLICK, this, this.onBtnBack);
                AdUtil.showBannerAd();
                this.isHaveExtra = false;
            }
        }
        setEvent() {
            this.btnAd.on(Laya.Event.CLICK, this, this.onBtnAd);
            this.btnNo.on(Laya.Event.CLICK, this, this.onBtnBack);
        }
        onBtnBack() {
            if (!CommonUtil.getTouch())
                return;
            if (this.isDown)
                return;
            this.isDown = true;
            var that = this;
            if (!that.isHaveExtra) {
                AdUtil.hideBannerAd();
            }
            UIManager.closeFunction();
            GetBoxRewardNextViewCtrl.endFunc();
            UIManager.triggerAutoOpen();
        }
        onBtnAd() {
            if (!CommonUtil.getTouch())
                return;
            if (this.isDown)
                return;
            this.isDown = true;
            var that = this;
            AdUtil.setEvent(function() {
                that.isDown = false;
                UIManager.openFunction(FUNCTION_TAG.GET_BOX_REWARD_NEXT_EXTRA, FUNCTION_OPEN_MODE.REPLACE, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE, that.itemList);
            }, function() {
                that.isDown = false;
            }, REWARD_CTRL_TYPE.REWARD_EXTRA);
        }
        showNormal() {
            this.isAni = true;
            var that = this;
            for (const key in this.itemCellList) {
                if (Object.prototype.hasOwnProperty.call(this.itemCellList, key)) {
                    const element = this.itemCellList[key];
                    if (element) {
                        let x = ITEM_POS_LIST$1[this.itemList.length][Number(key) * 3];
                        let y = ITEM_POS_LIST$1[this.itemList.length][Number(key) * 3 + 1];
                        let s = ITEM_POS_LIST$1[this.itemList.length][Number(key) * 3 + 2];
                        element.pos(x, y);
                        element.scale(s, s);
                        Laya.timer.once(Number(key) * 100, this, function() {
                            element.show();
                            if (Number(key) == that.itemList.length - 1) {
                                that.isAni = false;
                            }
                        });
                    }
                }
            }
        }
        static adSuccess(itemList, isNormal = false) {
            let startGoldPos = [];
            let startDiamond = [];
            let goldCount = 0;
            let diamondCount = 0;
            let expCount = 0;
            let firecrackerCount = 0;
            for (const key in itemList) {
                if (Object.prototype.hasOwnProperty.call(itemList, key)) {
                    const element = itemList[key];
                    let itemData = Item.getDataByKey(element.itemId);
                    if (element.isExtra && isNormal) {
                        continue;
                    }
                    switch (itemData.type) {
                        case ITEM_TYPE.GOLD:
                            goldCount += element.count;
                            break;
                        case ITEM_TYPE.DIAMOND:
                            diamondCount += element.count;
                            break;
                        case ITEM_TYPE.EXP:
                            expCount += element.count;
                            break;
                        case ITEM_TYPE.OTHER:
                            if (itemData.id == SPECIAL_ID.FIRECRACKER) {
                                firecrackerCount += element.count;
                            }
                            break;
                        case ITEM_TYPE.HERO_DEBRIS:
                        case ITEM_TYPE.PART_DEBRIS:
                            if (RoleManager.getInstance().setFragmentList({
                                    type: itemData.type,
                                    id: itemData.id,
                                    num: element.count
                                })) {
                                if (ITEM_TYPE.HERO_DEBRIS == itemData.type) {
                                    let id = itemData.extra();
                                    let itemId = ITEM_TYPE.HERO.toString() + (id > 99 ? id : id > 9 ? '0' + id : '00' + id);
                                    UIManager.registerAutoOpenFunction(FUNCTION_TAG.GET_EQUIP_REWARD, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE, {
                                        id: itemId,
                                        cb: null
                                    }, true, true);
                                } else {
                                    let id = itemData.extra();
                                    let itemId = ITEM_TYPE.PART.toString() + (id > 99 ? id : id > 9 ? '0' + id : '00' + id);
                                    UIManager.registerAutoOpenFunction(FUNCTION_TAG.GET_EQUIP_REWARD, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE, {
                                        id: itemId,
                                        cb: null
                                    }, true, true);
                                }
                            }
                            break;
                    }
                }
            }
            let funcGold = function() {
                RoleManager.getInstance().rewardGold(goldCount);
            };
            let funcDiamond = function() {
                RoleManager.getInstance().rewardDiamond(diamondCount);
            };
            let success = function() {
                funcDiamond();
                funcGold();
                RoleManager.getInstance().increaseExp(expCount);
            };
            GetBoxRewardNextViewCtrl.getFirecrackerAward(firecrackerCount);
            success();
        }
        static getFirecrackerAward(firecrackerCount) {
            let i = 0;
            for (let index = 0; index < NewYearGiftData.keys.length; index++) {
                const element = NewYearGiftData.keys[index];
                if (RoleManager.getInstance().getFirecrackerInfo().count >= NewYearGiftData.getDataByKey(element).cost) {
                    i = element;
                }
            }
            i += 1;
            RoleManager.getInstance().reciveFirecracker(firecrackerCount);
            if (i > NewYearGiftData.keys.length)
                return;
            if (RoleManager.getInstance().getFirecrackerInfo().count >= NewYearGiftData.getDataByKey(i).cost) {
                switch (NewYearGiftData.getDataByKey(i).awardType) {
                    case 1:
                        UIManager.registerAutoOpenFunction(FUNCTION_TAG.GET_GOLD_REWARD, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.GOLD, NewYearGiftData.getDataByKey(i).award, true);
                        break;
                    case 2:
                        PeopleFactory.getInstance().getEquip(NewYearGiftData.getDataByKey(i).award, function() {}, NewYearGiftData.getDataByKey(i).armTime, false);
                        break;
                    case 3:
                        UIManager.registerAutoOpenFunction(FUNCTION_TAG.GET_DIAMONDS_REWARD, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.DIAMOND, {
                            reward: NewYearGiftData.getDataByKey(i).award,
                            cb: null
                        }, true);
                        break;
                    default:
                        break;
                }
            }
        }
        static endFunc() {
            if (SceneManager.getCurScene().state == GAME_STATE.OVER) {
                if (ConfigManager.platform == PLATFORM_TYPE.OPPO) {
                    UIManager.openFunction(FUNCTION_TAG.NATIVE_INTERSTITIAL, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE);
                }
                if (ConfigManager.platform == PLATFORM_TYPE.QQ) {
                    if (GameScene.gameNum % 2 == 0)
                        AdUtil.createInterstitialAd();
                    else {
                        if (RoleManager.getInstance().isBannerTouch())
                            AdUtil.createAppBox();
                        else {
                            AdUtil.createInterstitialAd();
                        }
                    }
                }
                if (ConfigManager.platform == PLATFORM_TYPE.VIVO) {
                    AdUtil.createInterstitialAd();
                }
            }
            NotifyManager.notify(NOTIFY_ID.REFRESH_AI_GOOD);
        }
        static getAward(itemList, mode, isNormal = false) {
            GetBoxRewardNextViewCtrl.adSuccess(itemList, isNormal);
            UIManager.openFunction(FUNCTION_TAG.GET_BOX_REWARD_NEXT, mode, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE, itemList);
        }
    }

    var ROLE_SKIN_CELL_STATE;
    (function(ROLE_SKIN_CELL_STATE) {
        ROLE_SKIN_CELL_STATE[ROLE_SKIN_CELL_STATE["UNLOCK_NORMAL"] = 1] = "UNLOCK_NORMAL";
        ROLE_SKIN_CELL_STATE[ROLE_SKIN_CELL_STATE["UNLOCK_SELECT"] = 2] = "UNLOCK_SELECT";
        ROLE_SKIN_CELL_STATE[ROLE_SKIN_CELL_STATE["LOCK_NORMAL"] = 3] = "LOCK_NORMAL";
        ROLE_SKIN_CELL_STATE[ROLE_SKIN_CELL_STATE["LOCK_SELECT"] = 4] = "LOCK_SELECT";
        ROLE_SKIN_CELL_STATE[ROLE_SKIN_CELL_STATE["USE_NORMAL"] = 5] = "USE_NORMAL";
        ROLE_SKIN_CELL_STATE[ROLE_SKIN_CELL_STATE["USE_SELECT"] = 6] = "USE_SELECT";
    })(ROLE_SKIN_CELL_STATE || (ROLE_SKIN_CELL_STATE = {}));
    class RoleItemCtrl extends ui.view.role.RoleItemUI {
        constructor() {
            super();
            this.myIndex = 0;
            this.on(Laya.Event.CLICK, this, this.select);
        }
        setView(index) {
            this.myIndex = index;
            this.imgNull.visible = false;
            this.imgGrade.visible = true;
            this.boxFragment.visible = false;
            this.boxNoFragment.visible = false;
            this.txtName.text = this.dataSource.roleName;
            this.txtPrice.text = this.dataSource.cost.toString();
            if (this.dataSource.id != null) {
                let id = this.dataSource.id;
                let itemId = (this.dataSource.modelType == 1 ? ITEM_TYPE.HERO_DEBRIS.toString() : ITEM_TYPE.PART_DEBRIS.toString()) + (id > 99 ? id : id > 9 ? '0' + id : '00' + id);
                this.txtAd.text = '(' + RoleManager.getInstance().getTargetFragment({
                    type: this.dataSource.modelType == 1 ? ITEM_TYPE.HERO_DEBRIS : ITEM_TYPE.PART_DEBRIS,
                    id: itemId
                }).toString() + '/' + (this.dataSource.modelType == 1 ? RoleData.getDataByKey(this.dataSource.id).cost : PARTS.getDataByKey(this.dataSource.id).cost) + ')';
            }
            this.imgGrade.skin = RES_PATH.WAREHOUSE_UI.GRADE_LABEL_ROOT + this.dataSource.grade.toString() + '.png';
            if (this.dataSource.modelType == 1) {
                this.imgFrame.skin = RES_PATH.ROLE_VIEW_UI.GRADE_FRAME_UI_ROOT + (1 + this.dataSource.grade).toString() + '.png';
            } else {
                this.imgFrame.skin = RES_PATH.ROLE_VIEW_UI.GRADE_FRAME_UI_ROOT + (1 + this.dataSource.grade).toString() + '.png';
                if (this.dataSource.id == null) {
                    this.imgFrame.skin = RES_PATH.ROLE_VIEW_UI.GRADE_FRAME_UI_ROOT + 5 + '.png';
                    this.imgGrade.visible = false;
                }
            }
            this.imgIcon.skin = this.dataSource.url;
            this.setState(this.dataSource.state);
            this.imgIcon.skin = this.dataSource.url;
            this.imgType.skin = this.dataSource.costType == 1 ? 'sub1/ui/common/img_3.png' : 'sub1/ui/common/img_4.png';
            if (this.dataSource.costType == 1 || this.dataSource.costType == 2) {
                this.boxNoFragment.visible = true;
            } else if (this.dataSource.costType == 3) {
                this.boxFragment.visible = true;
            }
            if (this.dataSource.id == null) {
                this.imgNull.visible = true;
                this.boxUsing.visible = false;
            }
        }
        onDestroy() {
            this.imgFrame = null;
            this.imgGrade = null;
            this.imgIcon = null;
            this.imgPrice = null;
            this.imgSelect = null;
            this.txtName = null;
            this.txtPrice = null;
        }
        select() {
            UIManager.getFunctionViewCtrl(FUNCTION_TAG.ROLE).onSelectSkin(this.myIndex);
        }
        mySelect() {
            if (this.dataSource.state == ROLE_SKIN_CELL_STATE.UNLOCK_NORMAL) {
                this.dataSource.state = ROLE_SKIN_CELL_STATE.USE_SELECT;
                this.setState(ROLE_SKIN_CELL_STATE.USE_SELECT);
            } else if (this.dataSource.state == ROLE_SKIN_CELL_STATE.LOCK_NORMAL) {
                this.dataSource.state = ROLE_SKIN_CELL_STATE.LOCK_SELECT;
                this.setState(ROLE_SKIN_CELL_STATE.LOCK_SELECT);
            } else if (this.dataSource.state == ROLE_SKIN_CELL_STATE.USE_NORMAL) {
                this.dataSource.state = ROLE_SKIN_CELL_STATE.USE_SELECT;
                this.setState(ROLE_SKIN_CELL_STATE.USE_SELECT);
            }
        }
        setState(state) {
            switch (state) {
                case ROLE_SKIN_CELL_STATE.UNLOCK_NORMAL:
                    {
                        this.boxUsing.visible = false;
                        this.imgPrice.visible = false;
                        this.imgIcon.disabled = false;
                        this.imgSelect.visible = false;
                        break;
                    }
                case ROLE_SKIN_CELL_STATE.UNLOCK_SELECT:
                    {
                        this.imgSelect.visible = true;
                        this.boxUsing.visible = false;
                        this.imgPrice.visible = false;
                        this.imgIcon.disabled = false;
                        break;
                    }
                case ROLE_SKIN_CELL_STATE.LOCK_NORMAL:
                    {
                        this.boxUsing.visible = false;
                        this.imgPrice.visible = true;
                        this.imgSelect.visible = false;
                        this.imgIcon.disabled = true;
                        break;
                    }
                case ROLE_SKIN_CELL_STATE.LOCK_SELECT:
                    {
                        this.imgSelect.visible = true;
                        this.boxUsing.visible = false;
                        this.imgPrice.visible = true;
                        this.imgIcon.disabled = true;
                        break;
                    }
                case ROLE_SKIN_CELL_STATE.USE_NORMAL:
                    {
                        if (this.dataSource.id != null) {
                            this.boxUsing.visible = true;
                        }
                        this.imgPrice.visible = false;
                        this.imgSelect.visible = false;
                        this.imgIcon.disabled = false;
                        break;
                    }
                case ROLE_SKIN_CELL_STATE.USE_SELECT:
                    {
                        if (this.dataSource.id != null) {
                            this.boxUsing.visible = true;
                        }
                        this.imgSelect.visible = true;
                        this.imgPrice.visible = false;
                        this.imgIcon.disabled = false;
                        break;
                    }
            }
        }
    }

    let BTNTYPE = [
        1,
        2,
        3,
    ];
    class RoleViewCtrl extends ui.view.role.RoleViewUI {
        constructor() {
            super();
            this.cost = 0;
            this.scene3D = null;
            this._translate2 = new Laya.Vector3(5, -10, 1);
            this._translate = new Laya.Vector3(0, 0, 0);
            this.sp = null;
            this._pos = new Laya.Vector3(310, 500, 0);
            this.rotMouseX = 0;
            this.costType = 1;
            this.curBtnType = 1;
            this.myIndex = 1;
            this.isrefresh = false;
            this.isFirstEnable = true;
            this.isDown = false;
            this.width = this.stage.width;
            this.height = this.stage.height;
        }
        onAwake() {
            this.init();
            this.setBtnEvent();
            if (ConfigManager.platform == PLATFORM_TYPE.WEB_4399) {
                this.img4399.visible = true;
            }
            if (PlatformUtil.isIOS()) {
                this.boxButtonRoot.centerY -= 70;
            }
        }
        onDestroy() {
            this.img3DCenter = null;
            this.btnBuy = null;
            this.txtPrice = null;
            this.txtUsing = null;
            this.btnBack = null;
            if (this.sp)
                this.sp.destroy();
            this.sp = null;
            if (this.scene3D)
                this.scene3D.destroy();
            this.scene3D = null;
            this.cost = null;
            this._translate2 = null;
            this._translate = null;
            this._pos = null;
            this.rotMouseX = null;
        }
        create3D() {
            var scene = this.addChild(new Laya.Scene3D());
            var camera = scene.addChild(new Laya.Camera(0, 0.1, 1000));
            this.scene3D = scene;
            camera.transform.translate(this._translate2);
            camera.orthographic = false;
            camera.enableHDR = false;
            scene.addChild(new Laya.DirectionLight());
            this._translate.x += 3;
            this._translate.y -= 2;
            camera.transform.localPositionX = 1;
            camera.transform.localPositionY = 0;
            camera.transform.localPositionZ = 3;
            camera.clearFlag = Laya.CameraClearFlags.DepthOnly;
        }
        showModel(id) {
            console.log('传入人物ID：', id);
            if (this.sp) {
                this.sp.destroy();
                this.sp = null;
            }
            this.sp = SkinManager.createRoleViewSkin(this._translate, this.scene3D, false, id);
            this.sp.transform.localRotationEulerY = -25;
            this.sp.transform.localScaleX = 1;
            this.sp.transform.localScaleY = 1;
            this.sp.transform.localScaleZ = 1;
            this.sp.transform.localPositionX = 1.5;
            this.sp.transform.localPositionY = -1;
            this.sp.transform.localPositionZ = 0;
            let obj = SkinManager.createMenuArm(RoleManager.getInstance().getSelectSkin(), this.sp);
            obj.transform.localScaleX = 1;
            obj.transform.localScaleY = 1;
            obj.transform.localScaleZ = 1;
            SkinManager.createPartsByLocal(this.sp, new Laya.Vector3(1, 1, 1));
        }
        showPartsModel(id, decorate = null) {
            console.log('传入部件ID：', id);
            let obj = SkinManager.createParts(id, this.sp, new Laya.Vector3(1, 1, 1), decorate);
        }
        init() {
            FntManager.loadFont(RES_PATH.FNT.FNT1, this.txtPrice);
            if (PlatformUtil.isFullScreen()) {
                this.img3DCenter.x = 0;
            }
            this.create3D();
            this.setAllData(BTNTYPE[0], true);
        }
        setAllData(num, isFrist = false) {
            this.btnCtrl(num);
            this.updateList(isFrist);
        }
        btnCtrl(num) {
            this.btnBuy.visible = false;
            this.txtUsing.visible = false;
            this.boxFragment.visible = false;
            this.btnTry.visible = false;
            this.curBtnType = num;
            this.btnWing.getChildByName('imgSelect').visible = false;
            this.btnSkin.getChildByName('imgSelect').visible = false;
            if (this.curBtnType == BTNTYPE[0]) {
                this.btnSkin.getChildByName('imgSelect').visible = true;
            } else if (this.curBtnType == BTNTYPE[2]) {
                this.btnWing.getChildByName('imgSelect').visible = true;
            }
        }
        updateList(isFirst) {
            if (isFirst) {
                let list = this.getList();
                this.list.itemRender = RoleItemCtrl;
                this.list.vScrollBarSkin = '';
                this.list.dataSource = list;
                this.list.selectEnable = true;
                this.list.renderHandler = new Laya.Handler(this, this.updateSkinItem);
            } else {
                this.isrefresh = true;
                let list = this.getList();
                this.list.dataSource = list;
                console.log('更新完之后得数据：', this.list.dataSource);
                this.list.refresh();
            }
        }
        getList() {
            if (this.curBtnType == BTNTYPE[0]) {
                let skinData = [];
                let mySkinLib = RoleManager.getInstance().getRoleSkinLib();
                let selectSkin = RoleManager.getInstance().getSelectRoleSkin();
                for (let k = 0; k < RoleData.keys.length; k++) {
                    let roleData = RoleData.getDataByKey(k + 1);
                    if (ConfigManager.isReviewVersion() && ConfigManager.isHideSkinById(roleData.id)) {
                        continue;
                    }
                    let data = {
                        id: roleData.id,
                        url: roleData.icon,
                        cost: roleData.cost,
                        grade: roleData.grade,
                        roleName: roleData.cnName,
                        costType: roleData.costType,
                        modelType: 1,
                        state: ROLE_SKIN_CELL_STATE.LOCK_NORMAL
                    };
                    if (selectSkin == roleData.id) {
                        data.state = ROLE_SKIN_CELL_STATE.USE_SELECT;
                        Laya.timer.once(1, this, function() {
                            this.showModel(roleData.id);
                        }, null, false);
                        this.btnBuy.visible = false;
                        this.txtUsing.visible = true;
                        this.myIndex = k;
                    } else {
                        for (let k2 in mySkinLib) {
                            if (mySkinLib[k2] == roleData.id) {
                                data.state = ROLE_SKIN_CELL_STATE.UNLOCK_NORMAL;
                                break;
                            }
                        }
                    }
                    skinData.push(data);
                }
                let sort = function(a, b) {
                    if (a.state == ROLE_SKIN_CELL_STATE.USE_SELECT) {
                        return -1;
                    } else {
                        if (b.state == ROLE_SKIN_CELL_STATE.USE_SELECT)
                            return 1;
                    }
                    if (a.state == b.state) {
                        if (a.grade < b.grade) {
                            return 1;
                        } else {
                            return -1;
                        }
                    } else {
                        if (a.state == ROLE_SKIN_CELL_STATE.LOCK_NORMAL) {
                            return 1;
                        } else {
                            if (a.state == ROLE_SKIN_CELL_STATE.UNLOCK_NORMAL && b.state == ROLE_SKIN_CELL_STATE.UNLOCK_SELECT) {
                                if (a.grade < b.grade) {
                                    return 1;
                                } else {
                                    return -1;
                                }
                            } else {
                                return -1;
                            }
                        }
                    }
                };
                skinData.sort(sort);
                return skinData;
            } else {
                this.myIndex = 0;
                let list = [];
                let mySkinLib = RoleManager.getInstance().getPartLib();
                let selectSkin = RoleManager.getInstance().getTargetPart(this.curBtnType - 1);
                console.log('mySkinLib:', mySkinLib, 'selectSkin:', selectSkin);
                let tarID = RoleManager.getInstance().getTargetPart(this.curBtnType - 1);
                let partType = tarID ? PARTS.getDataByKey(tarID).partType : null;
                let data = {
                    id: null,
                    url: '',
                    cost: 0,
                    grade: 1,
                    roleName: '无',
                    costType: 0,
                    partType: partType,
                    modelType: 0,
                    state: tarID ? ROLE_SKIN_CELL_STATE.UNLOCK_NORMAL : ROLE_SKIN_CELL_STATE.USE_SELECT
                };
                list.push(data);
                for (let k = 0; k < PARTS.keys.length; k++) {
                    let data = {
                        id: PARTS.getDataByIndex(k).id,
                        url: PARTS.getDataByIndex(k).icon,
                        cost: PARTS.getDataByIndex(k).cost,
                        grade: PARTS.getDataByIndex(k).grade,
                        roleName: PARTS.getDataByIndex(k).cnName,
                        costType: PARTS.getDataByIndex(k).costType,
                        partType: PARTS.getDataByIndex(k).partType,
                        modelType: 0,
                        state: ROLE_SKIN_CELL_STATE.LOCK_NORMAL
                    };
                    if (selectSkin == PARTS.getDataByIndex(k).id) {
                        data.state = ROLE_SKIN_CELL_STATE.USE_SELECT;
                        Laya.timer.once(1, this, function() {
                            this.showPartsModel(PARTS.getDataByIndex(k).id);
                        }, null, false);
                        this.myIndex = k;
                        this.txtUsing.visible = true;
                        this.btnBuy.visible = false;
                    } else {
                        for (let k2 in mySkinLib) {
                            if (mySkinLib[k2] == PARTS.getDataByIndex(k).id) {
                                data.state = ROLE_SKIN_CELL_STATE.UNLOCK_NORMAL;
                                break;
                            }
                        }
                    }
                    if (data.partType == this.curBtnType - 1) {
                        list.push(data);
                    }
                }
                let sort = function(a, b) {
                    if (b.id == null)
                        return;
                    console.log('a:', a, 'b:', b);
                    if (a.state == ROLE_SKIN_CELL_STATE.USE_SELECT) {
                        return -1;
                    } else {
                        if (b.state == ROLE_SKIN_CELL_STATE.USE_SELECT)
                            return 1;
                    }
                    if (a.state == b.state) {
                        if (a.grade < b.grade) {
                            return 1;
                        } else {
                            return -1;
                        }
                    } else {
                        if (a.state == ROLE_SKIN_CELL_STATE.LOCK_NORMAL) {
                            return 1;
                        } else {
                            if (a.state == ROLE_SKIN_CELL_STATE.UNLOCK_NORMAL && b.state == ROLE_SKIN_CELL_STATE.UNLOCK_SELECT) {
                                if (a.grade < b.grade) {
                                    return 1;
                                } else {
                                    return -1;
                                }
                            } else {
                                return -1;
                            }
                        }
                    }
                };
                list.sort(sort);
                return list;
            }
        }
        pushNewList(targetSkinList, list) {
            for (let k = 0; k < list.length; k++) {
                targetSkinList.push(list[k]);
            }
        }
        getTargetList(skinData = [], costType) {
            let list = [];
            for (let k = 0; k < skinData.length; k++) {
                if (skinData[k].costType == costType && skinData[k].state == ROLE_SKIN_CELL_STATE.LOCK_NORMAL) {
                    list.push(skinData[k]);
                }
            }
            list = this.bSort(list);
            return list;
        }
        bSort(arr) {
            var len = arr.length;
            for (var i = 0; i < len - 1; i++) {
                for (var j = 0; j < len - 1 - i; j++) {
                    if (arr[j].cost > arr[j + 1].cost) {
                        var temp = arr[j];
                        arr[j] = arr[j + 1];
                        arr[j + 1] = temp;
                    }
                }
            }
            return arr;
        }
        setBtnEvent() {
            if (ConfigManager.platform == PLATFORM_TYPE.WX) {
                this.btnMoreGame.visible = true;
                this.btnGameCommunity.visible = true;
                this.btnMoreGame.on(Laya.Event.CLICK, this, () => {
                    {
                        let size = PlatformUtil.getCustomMatrixSize();
                        let x = Laya.stage.width / 2 - size.w - 16;
                        let y = Laya.stage.height / 2 - size.h / 2;
                        let x1 = Laya.stage.width / 2 + 16;
                        let step = 0;
                        let step1 = 0;
                        AdUtil.showCustom(x, y, WX_CUSTOM_AD_STYLE.MATRIX, function() {
                            if (step >= 1)
                                return;
                            step += 1;
                            UIManager.openFunction(FUNCTION_TAG.MORE_GAME, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE, true);
                        }, function() {
                            step1++;
                            if (step1 == 2) {
                                LogManager.showNotification('敬请期待');
                            }
                            console.log('显示失败');
                        });
                        AdUtil.showCustom(x1, y, WX_CUSTOM_AD_STYLE.MATRIX, function() {
                            if (step >= 1)
                                return;
                            step += 1;
                            UIManager.openFunction(FUNCTION_TAG.MORE_GAME, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE, true);
                        }, function() {
                            step1++;
                            if (step1 == 2) {
                                LogManager.showNotification('敬请期待');
                            }
                            console.log('显示失败');
                        });
                    }
                });
            }
            this.btnBack.on(Laya.Event.CLICK, this, this.onBtnBack);
            this.btnBuy.on(Laya.Event.CLICK, this, this.onBtnBuy);
            this.on(Laya.Event.MOUSE_DOWN, this, this.onBtnMouseDown);
            this.on(Laya.Event.MOUSE_MOVE, this, this.onBtnRot);
            this.btnSkin.on(Laya.Event.CLICK, this, this.onBtnSkin);
            this.btnWing.on(Laya.Event.CLICK, this, this.onBtnWing);
            this.btnTry.on(Laya.Event.CLICK, this, this.onBtnTry);
        }
        onBtnTry() {
            if (!CommonUtil.getTouch())
                return;
            let that = this;
            for (let k in this.list.dataSource) {
                if (this.list.dataSource[k].state == ROLE_SKIN_CELL_STATE.LOCK_SELECT) {
                    UIManager.openFunction(FUNCTION_TAG.ROLETRY, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.WINDOW, COMMON_MENU_STYLE.HIDE, {
                        id: this.list.dataSource[this.myIndex].id,
                        modelType: this.list.dataSource[this.myIndex].modelType
                    });
                    return;
                }
            }
        }
        onBtnSkin() {
            if (!CommonUtil.getTouch())
                return;
            this.setAllData(BTNTYPE[0]);
        }
        onBtnBag() {
            if (!CommonUtil.getTouch())
                return;
            this.setAllData(BTNTYPE[1]);
        }
        onBtnHeadress() {
            if (!CommonUtil.getTouch())
                return;
            this.setAllData(BTNTYPE[2]);
        }
        onBtnWing() {
            if (!CommonUtil.getTouch())
                return;
            this.setAllData(BTNTYPE[2]);
        }
        onBtnMouseDown(e) {
            this.rotMouseX = e.stageX;
        }
        onBtnRot(e) {
            if (this.sp) {
                let fac = e.stageX - this.rotMouseX;
                this.sp.transform.localRotationEulerY += fac * 0.4;
                this.rotMouseX = e.stageX;
            }
        }
        onSelectSkin(index) {
            SoundManager.playEffect(SOUND_PATH.CLICK);
            this.myIndex = index;
            console.log('选择：', index, this.list.dataSource[index].state);
            for (let k in this.list.dataSource) {
                let cellCtrl = this.list.getCell(parseInt(k));
                if (this.list.dataSource[index].state == ROLE_SKIN_CELL_STATE.LOCK_SELECT || this.list.dataSource[index].state == ROLE_SKIN_CELL_STATE.LOCK_NORMAL) {
                    if (this.list.dataSource[k].state == ROLE_SKIN_CELL_STATE.USE_SELECT) {
                        this.list.dataSource[k].state = ROLE_SKIN_CELL_STATE.USE_NORMAL;
                    } else if (this.list.dataSource[k].state == ROLE_SKIN_CELL_STATE.LOCK_SELECT) {
                        this.list.dataSource[k].state = ROLE_SKIN_CELL_STATE.LOCK_NORMAL;
                    }
                } else if (this.list.dataSource[index].state == ROLE_SKIN_CELL_STATE.USE_SELECT) {
                    if (this.list.dataSource[k].state == ROLE_SKIN_CELL_STATE.USE_SELECT) {
                        this.list.dataSource[k].state = ROLE_SKIN_CELL_STATE.UNLOCK_NORMAL;
                    } else if (this.list.dataSource[k].state == ROLE_SKIN_CELL_STATE.LOCK_SELECT) {
                        this.list.dataSource[k].state = ROLE_SKIN_CELL_STATE.LOCK_NORMAL;
                    } else if (this.list.dataSource[k].state == ROLE_SKIN_CELL_STATE.USE_NORMAL) {
                        this.list.dataSource[k].state = ROLE_SKIN_CELL_STATE.UNLOCK_NORMAL;
                    }
                } else if (this.list.dataSource[index].state == ROLE_SKIN_CELL_STATE.USE_NORMAL || this.list.dataSource[index].state == ROLE_SKIN_CELL_STATE.UNLOCK_NORMAL) {
                    if (this.list.dataSource[k].state == ROLE_SKIN_CELL_STATE.LOCK_SELECT) {
                        this.list.dataSource[k].state = ROLE_SKIN_CELL_STATE.LOCK_NORMAL;
                    } else if (this.list.dataSource[k].state == ROLE_SKIN_CELL_STATE.USE_SELECT) {
                        this.list.dataSource[k].state = ROLE_SKIN_CELL_STATE.UNLOCK_NORMAL;
                    } else if (this.list.dataSource[k].state == ROLE_SKIN_CELL_STATE.USE_NORMAL) {
                        this.list.dataSource[k].state = ROLE_SKIN_CELL_STATE.UNLOCK_NORMAL;
                    }
                }
                if (this.isrefresh) {
                    if (cellCtrl) {
                        cellCtrl.setState(this.list.dataSource[k].state);
                    }
                }
            }
            this.isrefresh = false;
            let cellCtrl = this.list.getCell(this.myIndex);
            if (cellCtrl) {
                cellCtrl.mySelect();
            }
            this.btnBuy.visible = false;
            this.txtUsing.visible = false;
            this.boxFragment.visible = false;
            this.btnTry.visible = false;
            this.DGBox.visible = false;
            this.WBox.visible = false;
            if (this.list.dataSource[index].state == ROLE_SKIN_CELL_STATE.UNLOCK_NORMAL || this.list.dataSource[index].state == ROLE_SKIN_CELL_STATE.UNLOCK_SELECT) {
                this.txtUsing.visible = true;
                if (this.curBtnType == BTNTYPE[0]) {
                    RoleManager.getInstance().setSelectRoleSkin(this.list.dataSource[index].id);
                } else {
                    if (this.list.dataSource[index].id != null) {
                        RoleManager.getInstance().setTargetPart(this.list.dataSource[index].id);
                    }
                }
            } else if (this.list.dataSource[index].state == ROLE_SKIN_CELL_STATE.USE_NORMAL || this.list.dataSource[index].state == ROLE_SKIN_CELL_STATE.USE_SELECT) {
                this.txtUsing.visible = true;
                if (this.curBtnType == BTNTYPE[0]) {
                    RoleManager.getInstance().setSelectRoleSkin(this.list.dataSource[index].id);
                } else {
                    if (this.list.dataSource[index].id != null) {
                        RoleManager.getInstance().setTargetPart(this.list.dataSource[index].id);
                    }
                }
            } else if (this.list.dataSource[index].state == ROLE_SKIN_CELL_STATE.LOCK_NORMAL || this.list.dataSource[index].state == ROLE_SKIN_CELL_STATE.LOCK_SELECT) {
                if (this.list.dataSource[index].costType == 1) {
                    this.imgType.skin = 'sub1/ui/common/img_3.png';
                } else if (this.list.dataSource[index].costType == 2) {
                    this.imgType.skin = 'sub1/ui/common/img_4.png';
                }
                if (this.list.dataSource[index].costType == 3) {
                    this.boxFragment.visible = true;
                    this.WBox.visible = true;
                    let data;
                    let count;
                    if (this.list.dataSource[index].modelType) {
                        data = RoleData.getDataByKey(this.list.dataSource[index].id);
                        let id = data.id;
                        let itemId = ITEM_TYPE.HERO_DEBRIS.toString() + (id > 99 ? id : id > 9 ? '0' + id : '00' + id);
                        count = RoleManager.getInstance().getTargetFragment({
                            type: ITEM_TYPE.HERO_DEBRIS,
                            id: itemId
                        });
                    } else {
                        data = PARTS.getDataByKey(this.list.dataSource[index].id);
                        let id = data.id;
                        let itemId = ITEM_TYPE.PART_DEBRIS.toString() + (id > 99 ? id : id > 9 ? '0' + id : '00' + id);
                        count = RoleManager.getInstance().getTargetFragment({
                            type: ITEM_TYPE.PART_DEBRIS,
                            id: itemId
                        });
                    }
                    this.txtFragmentAll.text = ' /' + data.cost + ')';
                    this.txtFragment.text = count.toString();
                    if (count == 0) {
                        this.txtFragment.color = '#FF2A20';
                    } else {
                        this.txtFragment.color = '#ffffff';
                    }
                } else {
                    this.DGBox.visible = true;
                }
                this.costType = this.list.dataSource[index].costType;
                this.btnBuy.visible = true;
                this.btnTry.visible = true;
                this.txtPrice.text = this.list.dataSource[index].cost.toString();
                this.cost = this.list.dataSource[index].cost;
            }
            if (this.curBtnType == BTNTYPE[0]) {
                this.showModel(this.list.dataSource[index].id);
            } else {
                if (this.list.dataSource[index].id == null) {
                    console.log('部件模型无值');
                    RoleManager.getInstance().removePart(this.curBtnType - 1);
                    SkinManager.removePartsByTS(this.curBtnType - 1, this.sp);
                } else {
                    console.log('部件模型有值');
                    this.showPartsModel(this.list.dataSource[index].id);
                }
            }
        }
        updateSkinItem(cell, index) {
            let cellCtrl = cell;
            cellCtrl.setView(index);
        }
        onBtnBuy() {
            if (!CommonUtil.getTouch())
                return;
            if (this.isDown)
                return;
            if (this.costType == 1) {
                if (RoleManager.getInstance().costGold(this.cost)) {
                    LogManager.showNotification('购买成功');
                    for (let k in this.list.dataSource) {
                        if (this.list.dataSource[k].state == ROLE_SKIN_CELL_STATE.LOCK_SELECT) {
                            this.list.dataSource[k].state = ROLE_SKIN_CELL_STATE.USE_SELECT;
                            if (this.curBtnType == BTNTYPE[0]) {
                                RoleManager.getInstance().setRoleSkinLib(this.list.dataSource[k].id);
                            } else {
                                RoleManager.getInstance().setPartsSkin(this.list.dataSource[k].id);
                            }
                            let id = this.list.dataSource[k].id;
                            this.onSelectSkin(k);
                            this.list.refresh();
                            if (this.curBtnType == BTNTYPE[0]) {
                                let itemId = ITEM_TYPE.HERO.toString() + (id > 99 ? id : id > 9 ? '0' + id : '00' + id);
                                UIManager.openFunction(FUNCTION_TAG.GET_EQUIP_REWARD, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE, {
                                    id: itemId,
                                    cb: null
                                });
                            } else {
                                let itemId = ITEM_TYPE.PART.toString() + (id > 99 ? id : id > 9 ? '0' + id : '00' + id);
                                UIManager.openFunction(FUNCTION_TAG.GET_EQUIP_REWARD, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE, {
                                    id: itemId,
                                    cb: null
                                });
                            }
                            break;
                        }
                    }
                } else {
                    UIManager.openFunction(FUNCTION_TAG.ADD_GOLD, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.WINDOW, COMMON_MENU_STYLE.GOLD, 1);
                }
            } else if (this.costType == 2) {
                if (RoleManager.getInstance().costDiamond(this.cost)) {
                    LogManager.showNotification('购买成功');
                    for (let k in this.list.dataSource) {
                        if (this.list.dataSource[k].state == ROLE_SKIN_CELL_STATE.LOCK_SELECT) {
                            this.list.dataSource[k].state = ROLE_SKIN_CELL_STATE.USE_SELECT;
                            if (this.curBtnType == BTNTYPE[0]) {
                                RoleManager.getInstance().setRoleSkinLib(this.list.dataSource[k].id);
                            } else {
                                RoleManager.getInstance().setPartsSkin(this.list.dataSource[k].id);
                            }
                            let id = this.list.dataSource[k].id;
                            this.onSelectSkin(k);
                            this.list.refresh();
                            if (this.curBtnType == BTNTYPE[0]) {
                                let itemId = ITEM_TYPE.HERO.toString() + (id > 99 ? id : id > 9 ? '0' + id : '00' + id);
                                UIManager.openFunction(FUNCTION_TAG.GET_EQUIP_REWARD, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE, {
                                    id: itemId,
                                    cb: null
                                });
                            } else {
                                let itemId = ITEM_TYPE.PART.toString() + (id > 99 ? id : id > 9 ? '0' + id : '00' + id);
                                UIManager.openFunction(FUNCTION_TAG.GET_EQUIP_REWARD, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE, {
                                    id: itemId,
                                    cb: null
                                });
                            }
                            break;
                        }
                    }
                } else {
                    UIManager.openFunction(FUNCTION_TAG.ADD_DIAMONDS, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.WINDOW, COMMON_MENU_STYLE.DIAMOND, 1);
                }
            } else if (this.costType == 3) {
                var that = this;
                that.isDown = true;
                let func = function() {
                    that.isDown = false;
                    for (let k in that.list.dataSource) {
                        if (that.list.dataSource[k].state == ROLE_SKIN_CELL_STATE.LOCK_SELECT) {
                            let id = that.list.dataSource[k].id;
                            that.onSelectSkin(k);
                            that.list.refresh();
                            if (that.curBtnType == BTNTYPE[0]) {
                                let itemId = ITEM_TYPE.HERO_DEBRIS.toString() + (id > 99 ? id : id > 9 ? '0' + id : '00' + id);
                                GetBoxRewardNextViewCtrl.adSuccess([{
                                    itemId: itemId,
                                    count: 1
                                }], true);
                                UIManager.openFunction(FUNCTION_TAG.GET_BOX_REWARD_NEXT, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE, [{
                                    itemId: itemId,
                                    count: 1
                                }]);
                            } else {
                                let itemId = ITEM_TYPE.PART_DEBRIS.toString() + (id > 99 ? id : id > 9 ? '0' + id : '00' + id);
                                GetBoxRewardNextViewCtrl.adSuccess([{
                                    itemId: itemId,
                                    count: 1
                                }], true);
                                UIManager.openFunction(FUNCTION_TAG.GET_BOX_REWARD_NEXT, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE, [{
                                    itemId: itemId,
                                    count: 1
                                }]);
                            }
                            break;
                        }
                    }
                };
                AdUtil.setEvent(func, function() {
                    that.isDown = false;
                }, REWARD_CTRL_TYPE.GET_DEBRIS);
            }
        }
        onBtnBack() {
            if (!CommonUtil.getTouch())
                return;
            UIManager.closeFunction();
        }
        onMyEnable() {
            if (!this.isFirstEnable && this.list.dataSource) {
                if (this.list.dataSource[this.myIndex].state == ROLE_SKIN_CELL_STATE.LOCK_SELECT) {
                    switch (this.list.dataSource[this.myIndex].modelType) {
                        case 1:
                            if (RoleManager.getInstance().checkIsHasRoleSkin(this.list.dataSource[this.myIndex].id)) {
                                this.list.dataSource[this.myIndex].state = ROLE_SKIN_CELL_STATE.UNLOCK_NORMAL;
                            }
                            break;
                        case 0:
                            if (RoleManager.getInstance().checkPart(this.list.dataSource[this.myIndex].id)) {
                                this.list.dataSource[this.myIndex].state = ROLE_SKIN_CELL_STATE.UNLOCK_NORMAL;
                            }
                            break;
                    }
                }
                this.onSelectSkin(this.myIndex);
                this.list.refresh();
            }
            this.isFirstEnable = false;
            FirstViewCtrl.btnGameClub && FirstViewCtrl.btnGameClub.show();
        }
    }

    class RoleFunction extends BaseFunction {
        createView() {
            this._viewCtrl = new RoleViewCtrl();
            return this._viewCtrl;
        }
        getFunctionName() {
            return '角色商店界面';
        }
        onEnter() { super.onEnter(); }
        onExit() { super.onExit(); }
        onEnable() {
            super.onEnable();
            let view = this.viewCtrl;
            view.onMyEnable();
            if (ConfigManager.platform != PLATFORM_TYPE.NATIVE_ANDRIOD && ConfigManager.appId != ANDROID_APP_ID.C233_ME)
                AdUtil.showBannerAd(Laya.stage.width - 600);
            AdUtil.showCustom(497, 287);
        }
        onDisbale() {
            super.onDisbale();
            AdUtil.hideBannerAd();
            FirstViewCtrl.btnGameClub && FirstViewCtrl.btnGameClub.hide();
            AdUtil.hideCustom(497, 287);
        }
        setAllButtonAnalysePoint() {}
        request(cb) {
            cb();
        }
    }

    var SHOPITEMSTATE;
    (function(SHOPITEMSTATE) {
        SHOPITEMSTATE["CANBUYBYGOLD"] = "CANBUYBYGOLD";
        SHOPITEMSTATE["CANBUYBYDIAMONDS"] = "CANBUYBYDIAMONDS";
        SHOPITEMSTATE["LOCKARMLESSTWO"] = "LOCKARMLESSTWO";
        SHOPITEMSTATE["LOCKARM"] = "LOCKARM";
    })(SHOPITEMSTATE || (SHOPITEMSTATE = {}));
    let normalMatrix = new Laya.ColorFilter([
        1, 0, 0, 0, 0,
        0, 1, 0, 0, 0,
        0, 0, 1, 0, 0,
        0, 0, 0, 1, 0
    ]);
    let lockMatrix = new Laya.ColorFilter([
        0, 0, 0, 0, 0,
        0, 0, 0, 0, 0,
        0, 0, 0, 0, 0,
        0, 0, 0, 1, 0
    ]);
    class ShopItemCtrl extends ui.view.shop.ShopItemUI {
        constructor() {
            super();
            this.btnBuy.on(Laya.Event.CLICK, this, this.onBtnBuy);
            this.btnTry.on(Laya.Event.CLICK, this, this.onBtnTry);
        }
        onDestroy() {
            LayaExtend.autoUnlinkUIReference(this);
        }
        onBtnBuy() {
            if (this.dataSource.state == SHOPITEMSTATE.LOCKARM) {
                let id = this.dataSource.id;
                UIManager.openFunction(FUNCTION_TAG.SHOPTRY, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.WINDOW, COMMON_MENU_STYLE.HIDE, {
                    id: id
                });
            } else {
                if (!PeopleFactory.getInstance().checkEmptyPos()) {
                    console.log('没有空位');
                    LogManager.showNotification('购买失败，无空卡槽');
                    return;
                }
            }
            if (this.dataSource.state == SHOPITEMSTATE.CANBUYBYGOLD) {
                if (RoleManager.getInstance().costGold(this.dataSource.price)) {
                    LogManager.showNotification('购买成功');
                    NotifyManager.notify(NOTIFY_ID.ADDARM_BY_SHOP, {
                        id: this.dataSource.armData.id
                    });
                    RoleManager.getInstance().updateBuyByGoldNum();
                    console.log('当前金币数值：', this.dataSource.price);
                    this.dataSource.price = Math.floor(this.dataSource.armData.price * Math.pow(ConfigManager.costGold, RoleManager.getInstance().getBuyByGoldNum()));
                    console.log('进阶金币数值：', this.dataSource.price);
                    this.setState();
                } else {
                    RewardManager.setRewardForInsufficientGoldCoins();
                    UIManager.openFunction(FUNCTION_TAG.ADD_GOLD, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.WINDOW, COMMON_MENU_STYLE.GOLD, 1);
                }
            } else if (this.dataSource.state == SHOPITEMSTATE.CANBUYBYDIAMONDS) {
                if (RoleManager.getInstance().costDiamond(this.dataSource.price)) {
                    LogManager.showNotification('购买成功');
                    NotifyManager.notify(NOTIFY_ID.ADDARM_BY_SHOP, {
                        id: this.dataSource.armData.id
                    });
                    RoleManager.getInstance().updateBuyByDiamondNum();
                    this.dataSource.price = Math.floor(this.dataSource.armData.priceByDiamond * Math.pow(ConfigManager.costDiamond, RoleManager.getInstance().getBuyByDiamondNum()));
                    this.setState();
                } else {
                    RewardManager.setRewardForInsufficientDiamonds();
                    UIManager.openFunction(FUNCTION_TAG.ADD_DIAMONDS, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.WINDOW, COMMON_MENU_STYLE.DIAMOND, 1);
                }
            }
        }
        onBtnTry() {
            let id = this.dataSource.id;
            UIManager.openFunction(FUNCTION_TAG.SHOPTRY, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.WINDOW, COMMON_MENU_STYLE.HIDE, {
                id: id
            });
        }
        setView(data) {
            this.dataSource = data;
            this.setState();
        }
        setState() {
            this.txtLv.text = this.dataSource.armData.id.toString();
            this.txtName.text = this.dataSource.armData.name.toString();
            this.imgIcon.skin = this.dataSource.armData.icon;
            this.txtSecond.text = Math.ceil(this.dataSource.armData.produce / 5).toString() + '/秒';
            this.txtPrice.text = StringUtil.parseGold(this.dataSource.price);
            let num = this.dataSource.armData.id + 2;
            this.txtUnlockLv.text = '需合成' + num + '级';
            this.btnBuy.visible = false;
            this.btnTry.visible = false;
            this.btnLock.visible = false;
            this.imgLockBg.visible = false;
            this.txtLockSecond.visible = false;
            this.txtSecond.visible = false;
            this.txtLock.visible = false;
            if (this.dataSource.state == SHOPITEMSTATE.CANBUYBYGOLD || this.dataSource.state == SHOPITEMSTATE.CANBUYBYDIAMONDS) {
                this.txtSecond.visible = true;
                this.imgIcon.filters = [normalMatrix];
                this.btnBuy.visible = true;
                if (this.dataSource.state == SHOPITEMSTATE.CANBUYBYGOLD) {
                    this.imgBuyType.skin = RES_PATH.BUYTYPE_UI.GOLD;
                } else {
                    this.imgBuyType.skin = RES_PATH.BUYTYPE_UI.DIAMOND;
                }
            } else if (this.dataSource.state == SHOPITEMSTATE.LOCKARM) {
                this.txtLock.visible = true;
                this.imgIcon.filters = [lockMatrix];
                this.imgLockBg.visible = true;
                this.txtLockSecond.visible = true;
                if (this.checkInCurID() && RoleManager.getInstance().getGuide() > GuideStep.GAME_1) {
                    if (RoleManager.getInstance().isNew) {
                        if (GameScene.gameNum > 1) {
                            this.imgLockBg.visible = false;
                            this.txtLock.visible = false;
                            this.btnTry.visible = true;
                        }
                    } else {
                        this.imgLockBg.visible = false;
                        this.txtLock.visible = false;
                        this.btnTry.visible = true;
                    }
                }
            } else if (this.dataSource.state == SHOPITEMSTATE.LOCKARMLESSTWO) {
                this.imgIcon.filters = [normalMatrix];
                this.btnLock.visible = true;
                this.txtSecond.visible = true;
            }
        }
        checkInCurID() {
            let showViewCtrl = UIManager.getFunctionViewCtrl(FUNCTION_TAG.SHOP);
            if (!showViewCtrl)
                return;
            let id = showViewCtrl.curID;
            let myId = this.dataSource.id;
            if (myId > id && myId <= id + 5) {
                return true;
            }
            return false;
        }
    }

    class ShopViewCtrl extends ui.view.shop.ShopViewUI {
        constructor() {
            super();
            this.curID = 1;
            this.width = this.stage.width;
            this.height = this.stage.height;
        }
        onAwake() {
            this.init();
            this.setEvent();
        }
        onDestroy() {
            this.list.renderHandler = null;
            this.btnClose = null;
            this.list = null;
        }
        init() {
            this.setData();
        }
        setData() {
            let shopData = [];
            let maxArm = RoleManager.getInstance().getMaxUnLockArm();
            for (let k = 0; k < ARM.keys.length; k++) {
                let data = ARM.getDataByKey(ARM.keys[k]);
                let newData = {
                    id: data.id,
                    armData: data,
                    buyType: 0,
                    price: 0,
                    state: SHOPITEMSTATE.CANBUYBYGOLD,
                };
                console.log('当前ID：', data.id, '本地最大的武器ID：', maxArm);
                if (data.id < maxArm) {
                    if (data.id == maxArm - 1 || data.id == maxArm - 2) {
                        newData.buyType = 1;
                        newData.price = Math.floor(data.priceByDiamond * Math.pow(ConfigManager.costDiamond, RoleManager.getInstance().getBuyByDiamondNum()));
                        newData.state = SHOPITEMSTATE.CANBUYBYDIAMONDS;
                    } else {
                        newData.buyType = 0;
                        newData.price = Math.floor(data.price * Math.pow(ConfigManager.costGold, RoleManager.getInstance().getBuyByGoldNum()));
                        console.log('当前---：', newData.price, data.price, ConfigManager.costGold, RoleManager.getInstance().getBuyByGoldNum());
                        newData.state = SHOPITEMSTATE.CANBUYBYGOLD;
                    }
                    if (data.id == 1) {
                        newData.buyType = 0;
                        newData.price = Math.floor(data.price * Math.pow(ConfigManager.costGold, RoleManager.getInstance().getBuyByGoldNum()));
                        newData.state = SHOPITEMSTATE.CANBUYBYGOLD;
                    }
                } else if (data.id == maxArm) {
                    if (data.id == 1) {
                        newData.buyType = 0;
                        newData.price = Math.floor(data.price * Math.pow(ConfigManager.costGold, RoleManager.getInstance().getBuyByGoldNum()));
                        newData.state = SHOPITEMSTATE.CANBUYBYGOLD;
                    } else {
                        newData.state = SHOPITEMSTATE.LOCKARMLESSTWO;
                        newData.buyType = 1;
                        this.curID = data.id;
                    }
                } else {
                    newData.state = SHOPITEMSTATE.LOCKARM;
                }
                shopData.push(newData);
            }
            this.list.itemRender = ShopItemCtrl;
            this.list.vScrollBarSkin = '';
            this.list.dataSource = shopData;
            this.list.selectEnable = true;
            this.list.renderHandler = new Laya.Handler(this, this.updateSkinItem);
        }
        updateSkinItem(cell, index) {
            let cellCtrl = cell;
            cellCtrl.setView(cell.dataSource);
        }
        onSelectShopItem(index) {
            if (!PeopleFactory.getInstance().checkEmptyPos()) {
                console.log('没有空位');
                return;
            }
            if (this.list.getCell(index).dataSource.state == SHOPITEMSTATE.CANBUYBYGOLD) {
                if (RoleManager.getInstance().costGold(this.list.getCell(index).dataSource.price)) {
                    NotifyManager.notify(NOTIFY_ID.ADDARM_BY_SHOP, {
                        id: this.list.getCell(index).dataSource.armData.id
                    });
                    RoleManager.getInstance().updateBuyByGoldNum();
                    console.log('当前金币数值：', this.list.getCell(index).dataSource.price);
                    this.list.getCell(index).dataSource.price = Math.floor(this.list.getCell(index).dataSource.armData.price * Math.pow(ConfigManager.costGold, RoleManager.getInstance().getBuyByGoldNum()));
                    console.log('进阶金币数值：', this.list.getCell(index).dataSource.price);
                    this.list.getCell(index).setState();
                }
            } else if (this.list.getCell(index).dataSource.state == SHOPITEMSTATE.CANBUYBYDIAMONDS) {
                if (RoleManager.getInstance().costDiamond(this.list.getCell(index).dataSource.price)) {
                    NotifyManager.notify(NOTIFY_ID.ADDARM_BY_SHOP, {
                        id: this.list.getCell(index).dataSource.armData.id
                    });
                    RoleManager.getInstance().updateBuyByDiamondNum();
                    this.list.getCell(index).dataSource.price = Math.floor(this.list.getCell(index).dataSource.armData.priceByDiamond * Math.pow(ConfigManager.costDiamond, RoleManager.getInstance().getBuyByDiamondNum()));
                    this.list.getCell(index).setState();
                }
            }
        }
        setEvent() {
            this.btnClose.on(Laya.Event.CLICK, this, this.onBtnClose);
        }
        onBtnClose() {
            if (!CommonUtil.getTouch())
                return;
            this.list.stopDrag();
            UIManager.closeFunction();
        }
    }

    class ShopFunction extends BaseFunction {
        createView() {
            this._viewCtrl = new ShopViewCtrl();
            return this._viewCtrl;
        }
        getFunctionName() {
            return '商店界面';
        }
        onEnter() { super.onEnter(); }
        onExit() { super.onExit(); }
        onEnable() {
            super.onEnable();
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || ConfigManager.platform == PLATFORM_TYPE.WX) {
                AdUtil.showCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                AdUtil.showCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
            }
        }
        onDisbale() {
            super.onDisbale();
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || ConfigManager.platform == PLATFORM_TYPE.WX) {
                AdUtil.hideCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                AdUtil.hideCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
            }
        }
        setAllButtonAnalysePoint() {}
        request(cb) {
            cb();
        }
    }

    class SignData {
        static getDataByKey(key) {
            if (SignData.cache[key])
                return SignData.cache[key];
            if (key == 1) {
                let template = new SignData();
                template.day = 1;
                template.name = '第一天';
                template.info = '钻石x50';
                template.award = 50;
                template.awardType = 2;
                template.itemId = 2001;
                SignData.cache[key] = template;
                return template;
            } else if (key == 2) {
                let template = new SignData();
                template.day = 2;
                template.name = '第二天';
                template.info = '红莲审判';
                template.award = 1;
                template.awardType = 4;
                template.itemId = 4045;
                SignData.cache[key] = template;
                return template;
            } else if (key == 3) {
                let template = new SignData();
                template.day = 3;
                template.name = '第三天';
                template.info = '传说之翼碎片x1';
                template.award = 1;
                template.awardType = 7;
                template.itemId = 7008;
                SignData.cache[key] = template;
                return template;
            } else if (key == 4) {
                let template = new SignData();
                template.day = 4;
                template.name = '第四天';
                template.info = '钻石x150';
                template.award = 150;
                template.awardType = 2;
                template.itemId = 2001;
                SignData.cache[key] = template;
                return template;
            } else if (key == 5) {
                let template = new SignData();
                template.day = 5;
                template.name = '第五天';
                template.info = '鬼面修罗碎片x1';
                template.award = 1;
                template.awardType = 6;
                template.itemId = 6002;
                SignData.cache[key] = template;
                return template;
            } else if (key == 6) {
                let template = new SignData();
                template.day = 6;
                template.name = '第六天';
                template.info = '钻石x300';
                template.award = 300;
                template.awardType = 2;
                template.itemId = 2001;
                SignData.cache[key] = template;
                return template;
            } else if (key == 7) {
                let template = new SignData();
                template.day = 7;
                template.name = '第七天';
                template.info = '超级宝箱x1';
                template.award = 1;
                template.awardType = 4;
                template.itemId = 4046;
                SignData.cache[key] = template;
                return template;
            }
        }
        static getDataByIndex(index) {
            if (SignData.cache[this.keys[index]])
                return SignData.cache[this.keys[index]];
            return this.getDataByKey(this.keys[index]);
        }
        static getAllData() {
            for (let index = 0; index < this.keys.length; index++) {
                this.getDataByKey(this.keys[index]);
            }
            return SignData.cache;
        }
        clear() {
            SignData.cache = {};
        }
    }
    SignData.cache = {};
    SignData.keys = [1, 2, 3, 4, 5, 6, 7];

    class NewSignViewCtrl extends ui.view.sign.NewSignViewUI {
        constructor(cb = null) {
            super();
            this.cb = cb;
        }
        onAwake() {
            this.width = this.stage.width;
            this.height = this.stage.height;
            this.setEvent();
            this.setCellsReward();
            this.setState();
            this.btnAd.on(Laya.Event.CLICK, this, this.onBtnSignDouble);
            if (ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.TT) {
                this.btnAd.visible = true;
            } else {
                this.btnAd.visible = false;
            }
            let sign = RoleManager.getInstance().getSign();
            let data = SignData.getDataByKey(sign.day);
            if (data.awardType == ITEM_TYPE.EQUIP || sign.state == 1) {
                this.btnAd.visible = false;
            }
            if (ConfigManager.isReviewVersion()) {
                this.btnAd.visible = false;
            }
        }
        onDestroy() {
            this.cb && this.cb();
        }
        setEvent() {
            this.btnBack.on(Laya.Event.CLICK, this, this.onBtnClose);
            for (let i = 0; i < this.boxCells.numChildren; i++) {
                let cell = this.boxCells.getChildAt(i);
                cell.on(Laya.Event.CLICK, this, function() {
                    this.onBtnSign(i);
                });
            }
        }
        onBtnSign(idx) {
            if (!CommonUtil.getTouch())
                return;
            let sign = RoleManager.getInstance().getSign();
            if (sign.state == 0 && sign.day == idx + 1) {
                let that = this;
                if (ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.TT) {
                    that.sign(idx + 1);
                } else {
                    AdUtil.setEvent(function() {
                        that.sign(idx + 1);
                        LogManager.showNotification('签到成功');
                    }, function() {
                        LogManager.showNotification('未看完视频，签到失败');
                    }, REWARD_CTRL_TYPE.SIGN);
                }
            }
        }
        onBtnSignDouble() {
            if (!CommonUtil.getTouch())
                return;
            let sign = RoleManager.getInstance().getSign();
            if (sign.state == 0) {
                let that = this;
                AdUtil.setEvent(function() {
                    that.sign(sign.day, 2);
                }, function() {
                    LogManager.showNotification('未看完视频，签到失败');
                }, REWARD_CTRL_TYPE.SIGN);
            }
        }
        onBtnClose() {
            if (!CommonUtil.getTouch())
                return;
            UIManager.closeFunction();
        }
        setCellsReward() {
            for (let i = 0; i < this.boxCells.numChildren; i++) {
                let cell = this.boxCells.getChildAt(i);
                let txtDay = cell.getChildByName('txtDay');
                let imgGold = cell.getChildByName('imgGold');
                let imgDiamond = cell.getChildByName('imgDiamond');
                let imgGun = cell.getChildByName('imgGun');
                let boxItem = cell.getChildByName('boxItem');
                let imgAd = cell.getChildByName('imgAd');
                let imgSign = cell.getChildByName('imgSign');
                let imgSigned = cell.getChildByName('imgSigned');
                let txtInfo = cell.getChildByName('txtInfo');
                imgGold.visible = false;
                imgDiamond.visible = false;
                imgGun.visible = false;
                boxItem.visible = false;
                imgAd.visible = false;
                imgSign.visible = false;
                imgSigned.visible = false;
                let data = SignData.getDataByIndex(i);
                let itemData = Item.getDataByKey(data.itemId.toString());
                txtDay.text = `第${i + 1}天`;
                if (data.awardType == ITEM_TYPE.DIAMOND) {
                    imgDiamond.visible = true;
                } else if (data.awardType == ITEM_TYPE.GOLD) {
                    imgGold.visible = true;
                } else if (data.awardType == ITEM_TYPE.EQUIP) {
                    imgGun.visible = true;
                    imgGun.skin = RES_PATH.IMG_GUN_ROOT + itemData.icon;
                } else {
                    let item = new BoxItemCellViewCtrl();
                    boxItem.addChild(item);
                    boxItem.visible = true;
                    item.setView(data.itemId, data.award);
                    item.show();
                    item.labelName.visible = false;
                    item.imgDebris.visible = true;
                    item.boxDebrisP.visible = false;
                    item.imgDebris.scale(2, 2);
                    item.imgDebris.parent.right = 2;
                }
                txtInfo.text = itemData.name + 'x' + data.award;
            }
        }
        setState() {
            let sign = RoleManager.getInstance().getSign();
            for (let i = 0; i < this.boxCells.numChildren; i++) {
                let cell = this.boxCells.getChildAt(i);
                let imgAd = cell.getChildByName('imgAd');
                let imgSign = cell.getChildByName('imgSign');
                let imgSigned = cell.getChildByName('imgSigned');
                let imgLight = cell.getChildByName('imgLight');
                imgAd.visible = false;
                imgSign.visible = false;
                imgSigned.visible = false;
                imgLight.visible = false;
                if (sign.day > i + 1) {
                    imgSigned.visible = true;
                } else if (sign.day == i + 1) {
                    if (sign.state == 0) {
                        if (ConfigManager.platform != PLATFORM_TYPE.TT && ConfigManager.platform != PLATFORM_TYPE.WEB) {
                            imgAd.visible = true;
                        }
                        imgSign.visible = true;
                        imgLight.visible = true;
                        Laya.Tween.clearAll(imgLight);
                        this.playLight(imgLight);
                    } else {
                        imgSigned.visible = true;
                    }
                } else {}
            }
        }
        playLight(imgLight) {
            let that = this;
            let action = function() {
                imgLight.x = 0;
                imgLight.alpha = 0;
                Laya.timer.once(1000, that, function() {
                    imgLight.alpha = 1;
                    Laya.Tween.to(imgLight, {
                        x: 111,
                        alpha: 0
                    }, 600, null, Laya.Handler.create(that, function() {
                        action();
                    }));
                });
            };
            action();
        }
        sign(day, count = 1) {
            this.btnAd.visible = false;
            console.log('sign', day);
            RoleManager.getInstance().setSign();
            let data = SignData.getDataByKey(day);
            if (data.awardType == ITEM_TYPE.EQUIP) {
                let itemData = Item.getDataByKey(data.itemId + '');
                PeopleFactory.getInstance().getEquip(itemData.extra());
            } else {
                if (data.awardType == ITEM_TYPE.GOLD)
                    UIManager.openFunction(FUNCTION_TAG.GET_GOLD_REWARD, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.ALL_SHOW, SignData.getDataByKey(day).award * count);
                else {
                    if (data.awardType == ITEM_TYPE.DIAMOND) {
                        UIManager.openFunction(FUNCTION_TAG.GET_DIAMONDS_REWARD, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.DIAMOND, {
                            reward: SignData.getDataByKey(day).award * count
                        });
                    } else {
                        if (data.awardType == 7 || data.awardType == 6) {
                            GetBoxRewardNextViewCtrl.adSuccess([{
                                itemId: data.itemId,
                                count: data.award
                            }], true);
                            UIManager.openFunction(FUNCTION_TAG.GET_BOX_REWARD_NEXT, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE, [{
                                itemId: data.itemId,
                                count: data.award
                            }]);
                        }
                    }
                }
            }
            this.setState();
        }
    }

    class SignFunction extends BaseFunction {
        createView() {
            this._viewCtrl = new NewSignViewCtrl(this._args ? this._args.cb : null);
            return this._viewCtrl;
        }
        getFunctionName() {
            return '签到界面';
        }
        onEnter() { super.onEnter(); }
        onExit() { super.onExit(); }
        onEnable() {
            super.onEnable();
            if (ConfigManager.platform == PLATFORM_TYPE.VIVO || ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS || ConfigManager.appId == ANDROID_APP_ID.C_233 || (ConfigManager.appId == ANDROID_APP_ID.C233_ME || ConfigManager.appId == ANDROID_APP_ID.MMY || ConfigManager.appId == ANDROID_APP_ID.HYKB)) {
                AdUtil.showBannerAd();
            }
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || ConfigManager.platform == PLATFORM_TYPE.WX) {
                AdUtil.showCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                AdUtil.showCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
            }
        }
        onDisbale() {
            super.onDisbale();
            if (ConfigManager.platform == PLATFORM_TYPE.VIVO || ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS || ConfigManager.appId == ANDROID_APP_ID.C_233 || (ConfigManager.appId == ANDROID_APP_ID.C233_ME || ConfigManager.appId == ANDROID_APP_ID.MMY || ConfigManager.appId == ANDROID_APP_ID.HYKB)) {
                AdUtil.hideBannerAd();
            }
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || ConfigManager.platform == PLATFORM_TYPE.WX) {
                AdUtil.hideCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                AdUtil.hideCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
            }
        }
        setAllButtonAnalysePoint() {}
        request(cb) {
            cb();
        }
    }

    class SuperRewardViewCtrl extends ui.view.superReward.SuperRewardViewUI {
        constructor(data) {
            super();
            this.data = null;
            this.scene3D = null;
            this.sp1 = null;
            this.sp2 = null;
            this._translate2 = new Laya.Vector3(5, -10, 1);
            this._translate = new Laya.Vector3(0, 0, 0);
            this.sp = null;
            this._pos = new Laya.Vector3(310, 500, 0);
            this.isDone = false;
            this.width = this.stage.width;
            this.height = this.stage.height;
            this.data = data;
            console.log('当前数据：', this.data);
        }
        onAwake() {
            this.setPlatformStyle();
            this.init();
            this.setBtnEvent();
        }
        onDestroy() {
            this.timer.clearAll(this);
            this.btnBack = null;
            this.btnLevelUp = null;
            this.imgLevelReward = null;
            this.txtSingleName = null;
            this.txtDoubleLv1 = null;
            this.txtDoubleLv2 = null;
            this.txtDoubleName1 = null;
            this.txtDoubleName2 = null;
            this.txtLowerLv = null;
            this.txtLowerName = null;
            this.txtSingleLv = null;
            this.sp.destroy();
            if (this.sp1)
                this.sp1.destroy();
            if (this.sp2)
                this.sp2.destroy();
            this.sp = null;
            this.sp1 = null;
            this.sp2 = null;
            this._translate2 = null;
            this._translate = null;
            this._pos = null;
            this.scene3D.destroy();
            this.scene3D = null;
        }
        init() {
            this.uiPlatformConfig();
            this.boxDouble.visible = false;
            this.boxSingle.visible = false;
            this.txtLowerLv.text = ARM.getDataByKey(this.data.data.showLower).id.toString();
            this.txtLowerName.text = ARM.getDataByKey(this.data.data.showLower).name;
            if (this.data.data.type == AIRDROP_TYPE.SUPERREWARD_SINGLE) {
                this.boxSingle.visible = true;
                this.txtSingleLv.text = ARM.getDataByKey(this.data.data.showMax).id.toString();
                this.txtSingleName.text = ARM.getDataByKey(this.data.data.showMax).name;
                this.txtContent.text = '可立即获得1把' + ARM.getDataByKey(this.data.data.showMax).id.toString() + '级武器';
            } else {
                this.boxDouble.visible = true;
                this.txtDoubleLv1.text = ARM.getDataByKey(this.data.data.showMax).id.toString();
                this.txtDoubleLv2.text = ARM.getDataByKey(this.data.data.showMax).id.toString();
                this.txtDoubleName1.text = ARM.getDataByKey(this.data.data.showMax).name;
                this.txtDoubleName2.text = ARM.getDataByKey(this.data.data.showMax).name;
                this.txtContent.text = '可立即获得2把' + ARM.getDataByKey(this.data.data.showMax).id.toString() + '级武器';
            }
            let num = this.data.data.showMax - this.data.data.showLower;
            if (num == 2) {
                this.imgLevelReward.skin = 'sub1/ui/superReward/img_4.png';
            } else {
                this.imgLevelReward.skin = 'sub1/ui/superReward/img_5.png';
            }
            this.create3D();
            this.frameLoop(1, this, this.update);
        }
        update() {
            if (this.sp) {
                this.sp.transform.localRotationEulerY++;
            }
            if (this.sp1) {
                this.sp1.transform.localRotationEulerY++;
            }
            if (this.sp2) {
                this.sp2.transform.localRotationEulerY++;
            }
        }
        create3D() {
            var scene = this.box3d.addChild(new Laya.Scene3D());
            var camera = scene.addChild(new Laya.Camera(0, 0.1, 1000));
            this.scene3D = scene;
            camera.transform.translate(this._translate2);
            camera.orthographic = true;
            camera.enableHDR = false;
            camera.clearColor = new Laya.Vector4(0.0, 0.0, 0.0, 0.0);
            var renderTexture = new Laya.RenderTexture(1024, 1024, Laya.RenderTextureFormat.R8G8B8A8, Laya.RenderTextureDepthFormat.DEPTH_16);
            camera.renderTarget = renderTexture;
            camera.orthographicVerticalSize = 10;
            let light = new Laya.DirectionLight();
            light.color = new Laya.Vector3(1, 1, 1);
            var mat = light.transform.worldMatrix;
            mat.setForward(new Laya.Vector3(0, -1.0, -1.0));
            light.transform.worldMatrix = mat;
            scene.addChild(light);
            camera.convertScreenCoordToOrthographicCoord(this._pos, this._translate);
            this._translate.x += 3;
            this._translate.y -= 2;
            this.img3DCenter.source = new Laya.Texture(renderTexture);
            if (this.sp) {
                this.sp.destroy();
                this.sp = null;
            }
            this.sp = SkinManager.onLyToCreateArm(this.data.data.showLower, this.scene3D);
            this.sp.transform.position = camera.transform.position;
            this.sp.transform.localPositionZ -= 2;
            this.sp.transform.localPositionX -= 3.3;
            this.sp.transform.localPositionY += 1.5;
            this.sp.transform.localRotationEulerY = 90;
            this.sp.transform.localRotationEulerX = -20;
            this.sp.transform.localScaleX = 4.5;
            this.sp.transform.localScaleY = 4.5;
            this.sp.transform.localScaleZ = 4.5;
            if (this.data.data.type == AIRDROP_TYPE.SUPERREWARD_SINGLE) {
                this.sp1 = SkinManager.onLyToCreateArm(this.data.data.showMax, this.scene3D);
                this.sp1.transform.position = camera.transform.position;
                this.sp1.transform.localPositionZ -= 2;
                this.sp1.transform.localPositionX += 2.5;
                this.sp1.transform.localPositionY += 1.5;
                this.sp1.transform.localRotationEulerY = 90;
                this.sp1.transform.localRotationEulerX = -20;
                this.sp1.transform.localScaleX = 4.5;
                this.sp1.transform.localScaleY = 4.5;
                this.sp1.transform.localScaleZ = 4.5;
            } else {
                this.sp1 = SkinManager.onLyToCreateArm(this.data.data.showMax, this.scene3D);
                this.sp1.transform.position = camera.transform.position;
                this.sp1.transform.localPositionZ -= 2;
                this.sp1.transform.localPositionX += 3;
                this.sp1.transform.localPositionY += 3.2;
                this.sp1.transform.localRotationEulerY = 90;
                this.sp1.transform.localRotationEulerX = -15;
                this.sp1.transform.localScaleX = 4.5;
                this.sp1.transform.localScaleY = 4.5;
                this.sp1.transform.localScaleZ = 4.5;
                this.sp2 = SkinManager.onLyToCreateArm(this.data.data.showMax, this.scene3D);
                this.sp2.transform.position = camera.transform.position;
                this.sp2.transform.localPositionZ -= 2;
                this.sp2.transform.localPositionX += 3;
                this.sp2.transform.localPositionY -= 0.5;
                this.sp2.transform.localRotationEulerY = 90;
                this.sp2.transform.localRotationEulerX = -20;
                this.sp2.transform.localScaleX = 4.5;
                this.sp2.transform.localScaleY = 4.5;
                this.sp2.transform.localScaleZ = 4.5;
            }
        }
        setBtnEvent() {
            this.btnLevelUp.on(Laya.Event.CLICK, this, this.onBtnLevelUp);
            this.btnBack.on(Laya.Event.CLICK, this, this.onBtnBack);
            this.btnNo.on(Laya.Event.CLICK, this, this.onBtnBack);
        }
        onBtnLevelUp() {
            if (!CommonUtil.getTouch())
                return;
            let that = this;
            AdUtil.setEvent(function() {
                if (that.isDone)
                    return;
                that.isDone = true;
                that.data.commonCb();
                that.data.data.viewSuccess();
                UIManager.closeFunction();
            }, function() {
                if (that.isDone)
                    return;
                that.isDone = true;
                that.data.commonCb();
                that.data.data.viewFail();
                UIManager.closeFunction();
            }, REWARD_CTRL_TYPE.SUPER_REWARD);
        }
        onBtnBack() {
            if (!CommonUtil.getTouch())
                return;
            this.data.commonCb();
            this.data.data.viewFail();
            UIManager.closeFunction();
        }
        setPlatformStyle() {
            switch (ConfigManager.platform) {
                case PLATFORM_TYPE.WX:
                    {
                        this.setWXPlatform();
                        break;
                    }
                case PLATFORM_TYPE.QQ:
                    {
                        this.setQQPlatform();
                        break;
                    }
                case PLATFORM_TYPE.WEB:
                    {
                        this.setWXPlatform();
                        break;
                    }
                case PLATFORM_TYPE.WEB_4399:
                    {
                        this.setWeb4399Platform();
                        break;
                    }
                case PLATFORM_TYPE.VIVO:
                    {
                        this.setVIVOPlatform();
                        break;
                    }
                case PLATFORM_TYPE.OPPO:
                    {
                        this.setOPPOPlatform();
                        break;
                    }
                case PLATFORM_TYPE.NATIVE_IOS:
                    {
                        this.setNativeIOSPlatform();
                        break;
                    }
                case PLATFORM_TYPE.NATIVE_ANDRIOD:
                    {
                        this.setNativeAndroidPlatform();
                        break;
                    }
                case PLATFORM_TYPE.TT:
                    {
                        this.setTTPlatform();
                        break;
                    }
            }
        }
        setWXPlatform() {
            if (PlatformUtil.isIOS()) {
                this.btnLevelUp.y -= 10;
                this.btnBack.y -= 10;
                this.txtContent.y -= 10;
                this.btnNo.y -= 10;
            }
            this.btnNo.visible = true;
            this.btnBack.visible = false;
            this.btnLevelUp.y -= 60;
            this.btnBack.y -= 60;
            this.txtContent.y -= 60;
            this.btnNo.y -= 60;
        }
        setQQPlatform() {}
        setWebPlatform() {}
        setVIVOPlatform() {}
        setOPPOPlatform() {}
        setNativeIOSPlatform() {}
        setNativeAndroidPlatform() {}
        setWeb4399Platform() {}
        setTTPlatform() {
            this.txtContent.y -= 60;
            this.btnNo.visible = true;
            this.btnBack.visible = false;
            this.btnLevelUp.y -= 60;
            this.btnBack.y -= 60;
            this.btnNo.y -= 60;
        }
        uiPlatformConfig() {
            UIManager.replaceAdIcon([{
                img: this.btnLevelUp.getChildAt(1),
                type: 1
            }]);
        }
    }

    class SuperRewardFunction extends BaseFunction {
        createView() {
            this._viewCtrl = new SuperRewardViewCtrl(this._args);
            return this._viewCtrl;
        }
        getFunctionName() {
            return '超级奖励界面';
        }
        onEnter() {
            super.onEnter();
            if (ConfigManager.platform == PLATFORM_TYPE.OPPO || ConfigManager.platform == PLATFORM_TYPE.WEB) {
                this.nativeBanner = new NativeBanner2ViewCtrl();
                let view = this._viewCtrl;
                view.addChild(this.nativeBanner);
                this.nativeIcon1 = new NativeIcon1CellCtrl();
                view.addChild(this.nativeIcon1);
                this.nativeIcon2 = new NativeIcon1CellCtrl();
                view.addChild(this.nativeIcon2);
                this.nativeIcon1.x = Laya.stage.width / 2 - 550;
                this.nativeIcon2.x = Laya.stage.width / 2 + 400;
                this.nativeIcon1.bottom = 30;
                this.nativeIcon2.bottom = 30;
            }
        }
        onExit() { super.onExit();}
        onEnable() {
            super.onEnable();
            AdUtil.showBannerAd();
            this.nativeBanner && this.nativeBanner.show();
            this.nativeIcon1 && this.nativeIcon1.show();
            this.nativeIcon2 && this.nativeIcon2.show();
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || PLATFORM_TYPE.WX == ConfigManager.platform || PLATFORM_TYPE.NATIVE_ANDRIOD == ConfigManager.platform) {
                let x = PlatformUtil.getBannerCenterPos().x + PlatformUtil.getBannerWeight() + 30;
                let y = Laya.stage.height - PlatformUtil.getCustomSize().h;
                let x1 = PlatformUtil.getBannerCenterPos().x - PlatformUtil.getCustomSize().w - 30;
                if (ConfigManager.platform == PLATFORM_TYPE.WX) {
                    AdUtil.showCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                    AdUtil.showCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                } else {
                    AdUtil.showCustom(x, y);
                    AdUtil.showCustom(x1, y);
                }
            }
        }
        onDisbale() {
            super.onDisbale();
            AdUtil.hideBannerAd();
            this.nativeBanner && this.nativeBanner.hide();
            this.nativeIcon1 && this.nativeIcon1.hide();
            this.nativeIcon2 && this.nativeIcon2.hide();
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || PLATFORM_TYPE.WX == ConfigManager.platform || PLATFORM_TYPE.NATIVE_ANDRIOD == ConfigManager.platform) {
                let x = PlatformUtil.getBannerCenterPos().x + PlatformUtil.getBannerWeight() + 30;
                let y = Laya.stage.height - PlatformUtil.getCustomSize().h;
                let x1 = PlatformUtil.getBannerCenterPos().x - PlatformUtil.getCustomSize().w - 30;
                if (ConfigManager.platform == PLATFORM_TYPE.WX) {
                    AdUtil.hideCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                    AdUtil.hideCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                } else {
                    AdUtil.hideCustom(x, y);
                    AdUtil.hideCustom(x1, y);
                }
            }
        }
        setAllButtonAnalysePoint() {}
        request(cb) {
            cb();
        }
    }

    class TaskCellViewCtrl extends ui.view.task.TaskCellViewUI {
        constructor() {
            super();
            this.isDown = false;
        }
        onAwake() {}
        onDestroy() {}
        setView(d) {
            if (d == this.d)
                return;
            this.isDown = false;
            this.btnEnter.offAll();
            let data = TaskData.getDataByKey(d.index);
            this.labelDay.text = data.name.toString();
            this.imgGet.visible = false;
            this.imgGo.visible = false;
            this.imgLock.visible = false;
            this.imgUse.visible = false;
            this.btnBule.visible = false;
            this.btnGreen.visible = false;
            this.labelPer.visible = false;
            this.labelPer1.visible = false;
            this.imgAdGet.visible = false;
            this.btnEnter.alpha = 1;
            let str = data.info;
            this.labelDebris.visible = false;
            if (!ConfigManager.getViolenceCtrl()) {
                str = str.replace("爆头", "暴击");
                console.log(str);
                str = str.replace("击杀", "击败");
                console.log(str);
            }
            if (data.awardType == 1 || data.awardType == 3) {
                this.imgQuality.skin = urlBg$1[2];
            } else {
                this.imgQuality.skin = urlBg$1[0];
            }
            this.labelTake.text = str;
            let taskType = TaskManager.getTaskType(data.taskType);
            this.d = d;
            this.setImgIcon(data);
            switch (d.state) {
                case TASK_STATE.COMPLETE:
                    this.btnGreen.visible = true;
                    if ((RoleManager.getInstance().loginDay() % 7) + 1 <= this.d.index) {
                        this.imgGet.visible = true;
                    } else {
                        this.imgAdGet.visible = true;
                    }
                    this.labelPer.visible = true;
                    this.labelPer1.visible = true;
                    this.labelPer.text = taskType.data.toString();
                    this.labelPer1.text = '/' + taskType.data.toString();
                    this.btnEnter.on(Laya.Event.CLICK, this, this.onBtnEnter);
                    this.btnEnter.on(Laya.Event.MOUSE_DOWN, this, this.onMouseDown);
                    this.btnEnter.on(Laya.Event.MOUSE_OUT, this, this.onMouseUp);
                    break;
                case TASK_STATE.UNINDAY:
                    this.btnBule.visible = true;
                    this.btnEnter.alpha = 0.5;
                    this.imgLock.visible = true;
                    this.labelPer.visible = true;
                    this.labelPer1.visible = true;
                    this.labelPer.text = '0';
                    this.labelPer1.text = '/' + taskType.data.toString();
                    break;
                case TASK_STATE.GET:
                    this.imgUse.visible = true;
                    break;
                default:
                    this.btnBule.visible = true;
                    this.imgGo.visible = true;
                    this.labelPer.visible = true;
                    this.labelPer1.visible = true;
                    this.labelPer.text = d.state.toString();
                    this.labelPer1.text = '/' + taskType.data.toString();
                    this.btnEnter.on(Laya.Event.CLICK, this, this.onBtnEnter);
                    this.btnEnter.on(Laya.Event.MOUSE_DOWN, this, this.onMouseDown);
                    this.btnEnter.on(Laya.Event.MOUSE_OUT, this, this.onMouseUp);
                    break;
            }
        }
        onBtnEnter() {
            if (this.isDown)
                return;
            if (this.d) {
                if (this.d.state != TASK_STATE.GET || this.d.state != TASK_STATE.UNINDAY) {
                    if (!CommonUtil.getTouch())
                        return;
                    if (this.d.state == TASK_STATE.COMPLETE) {
                        this.isDown = true;
                        var that = this;
                        let func = function() {
                            that.isDown = false;
                            let data = TaskData.getDataByKey(that.d.index);
                            if (data.awardType == 10 || data.awardType == 11) {
                                let info = RoleManager.getInstance().getBoxTragmentId(data.awardType == 10, data.awardType == 11);
                                GetBoxRewardNextViewCtrl.getAward([{
                                    itemId: info.itemId,
                                    count: data.award
                                }], FUNCTION_OPEN_MODE.COVER, true);
                            } else {
                                if (data.awardType == 3) {
                                    UIManager.openFunction(FUNCTION_TAG.GET_DIAMONDS_REWARD, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.DIAMOND, {
                                        reward: data.award,
                                        cb: null
                                    });
                                } else {
                                    UIManager.openFunction(FUNCTION_TAG.GET_GOLD_REWARD, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.ALL_SHOW, data.award);
                                }
                            }
                            RoleManager.getInstance().reciveTaskAwardByDay(that.d.index);
                            UIManager.getFunctionViewCtrl(FUNCTION_TAG.TASK).setView();
                        };
                        if (this.imgAdGet.visible) {
                            AdUtil.setEvent(func, function() {
                                that.isDown = false;
                            }, REWARD_CTRL_TYPE.TASK);
                        } else {
                            func();
                        }
                    } else {
                        UIManager.closeFunction();
                    }
                }
            }
        }
        onMouseUp() {
            this.btnEnter.alpha = 1;
        }
        onMouseDown() {
            this.btnEnter.alpha = 0.6;
        }
        setImgIcon(data) {
            this.labelCount.text = data.award.toString();
            this.imgTag.visible = false;
            this.labelDebris.visible = false;
            this.labelCount.bottom = 7;
            switch (data.awardType) {
                case 1:
                    this.imgIcon.skin = RES_PATH.ITEM_ROOT + SPECIAL_ID.GOLD + '.png';
                    this.labelDebris.text = '金币x' + data.award.toString();
                    this.labelDebris.visible = true;
                    this.labelCount.text = 'x' + data.award.toString();
                    break;
                case 3:
                    this.imgIcon.skin = RES_PATH.ITEM_ROOT + SPECIAL_ID.DIAMONDS + '.png';
                    this.labelDebris.text = '钻石x' + data.award.toString();
                    this.labelDebris.visible = true;
                    this.labelCount.text = 'x' + data.award.toString();
                    break;
                case 2:
                    break;
                case 4:
                    break;
                case 5:
                    break;
                case 11:
                    this.imgIcon.skin = 'sub1/ui/getReward/img_gameBox_1.png';
                    this.imgTag.visible = true;
                    this.labelDebris.text = '部件碎片x' + data.award.toString();
                    this.labelDebris.visible = true;
                    this.labelCount.text = 'x' + data.award.toString();
                    this.labelCount.bottom = 10;
                    break;
                case 10:
                    this.imgIcon.skin = 'sub1/ui/getReward/img_gameBox_2.png';
                    this.imgTag.visible = true;
                    this.labelDebris.text = '英雄碎片x' + data.award.toString();
                    this.labelCount.text = 'x' + data.award.toString();
                    this.labelDebris.visible = true;
                    this.labelCount.bottom = 10;
                    break;
                case 8:
                    break;
                case 9:
                    {}
                    break;
                default:
                    break;
            }
        }
    }

    class TaskViewCtrl extends ui.view.task.TaskViewUI {
        constructor() {
            super();
            this.cache = [];
            this.data = [];
            this.width = this.stage.width;
            this.height = this.stage.height;
            this.setView(true);
            this.btnBack.on(Laya.Event.CLICK, this, this.onBtnBack);
        }
        onAwake() {}
        onDestroy() {}
        setView(isFirst = false) {
            let h = 132;
            if (isFirst) {
                this.panel.vScrollBarSkin = '';
                for (let index = 0; index < 5; index++) {
                    let cellCtrl = new TaskCellViewCtrl();
                    this.boxCell.addChild(cellCtrl);
                    this.cache.push(cellCtrl);
                }
                for (let index = 0; index < 7; index++) {
                    let data = {
                        index: index + 1,
                        state: RoleManager.getInstance().getTaskStateByDay(index + 1)
                    };
                    this.data.push(data);
                    this.boxCell.height += h;
                }
                this.data.sort(this.sort);
                this.boxCell.height -= h;
                for (let index = 0; index < this.data.length; index++) {
                    this.data[index]['y'] = (index + 1) * h;
                }
                this.panel.vScrollBar.changeHandler = Laya.Handler.create(this, this.onPanelScroll, null, false);
            } else {
                this.data = [];
                for (let index = 0; index < 7; index++) {
                    let data = {
                        index: index + 1,
                        state: RoleManager.getInstance().getTaskStateByDay(index + 1)
                    };
                    this.data.push(data);
                }
                this.data.sort(this.sort);
                for (let index = 0; index < this.data.length; index++) {
                    this.data[index]['y'] = (index + 1) * h;
                }
                this.onPanelScroll(0);
                Laya.Tween.to(this.panel.vScrollBar, {
                    value: 0
                }, 500);
            }
        }
        onPanelScroll(value) {
            for (let i = 0, len = this.cache.length; i < len; i++) {
                this.cache[i].visible = false;
            }
            let cacheIdx = 0;
            for (let i = 0, len = this.data.length; i < len; i++) {
                let d = this.data[i];
                if (d.y >= value && d.y <= value + this.panel.height + 126) {
                    let cellCtrl = this.cache[cacheIdx];
                    if (!cellCtrl)
                        return;
                    cellCtrl.setView(d);
                    cellCtrl.y = d.y - 126;
                    cellCtrl.visible = true;
                    cacheIdx++;
                }
            }
        }
        sort(a, b) {
            if (a.state == TASK_STATE.COMPLETE) {
                if (b.state == a.state) {
                    if (a.index < b.index)
                        return 1;
                    else {
                        return -1;
                    }
                } else {
                    return -1;
                }
            } else {
                if (a.state == TASK_STATE.GET) {
                    if (b.state == a.state) {
                        if (a.index < b.index)
                            return -1;
                        else {
                            return 1;
                        }
                    } else {
                        return 1;
                    }
                } else {
                    if (a.state == TASK_STATE.UNINDAY) {
                        if (b.state == a.state) {
                            if (a.index < b.index)
                                return -1;
                            else {
                                return 1;
                            }
                        } else {
                            if (b.state == TASK_STATE.COMPLETE)
                                return 1;
                            else if (b.state == TASK_STATE.GET)
                                return -1;
                            else
                                return 1;
                        }
                    } else {
                        if (b.state == TASK_STATE.COMPLETE)
                            return 1;
                        else {
                            if (b.state == TASK_STATE.GET)
                                return -1;
                            else if (b.state == TASK_STATE.UNINDAY)
                                return -1;
                            else {
                                if (a.index < b.index)
                                    return -1;
                                else {
                                    return 1;
                                }
                            }
                        }
                    }
                }
            }
        }
        onBtnBack() {
            if (!CommonUtil.getTouch())
                return;
            UIManager.closeFunction();
        }
    }

    class TaskFunction extends BaseFunction {
        createView() {
            this._viewCtrl = new TaskViewCtrl();
            return this._viewCtrl;
        }
        getFunctionName() {
            return '任务界面';
        }
        onEnter() { super.onEnter(); }
        onExit() { super.onExit(); }
        onEnable() {
            super.onEnable();
            if (ConfigManager.platform == PLATFORM_TYPE.VIVO || ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS || ConfigManager.appId == ANDROID_APP_ID.C_233 || (ConfigManager.appId == ANDROID_APP_ID.C233_ME || ConfigManager.appId == ANDROID_APP_ID.MMY || ConfigManager.appId == ANDROID_APP_ID.HYKB)) {
                AdUtil.showBannerAd();
            }
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || ConfigManager.platform == PLATFORM_TYPE.WX) {
                AdUtil.showCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                AdUtil.showCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
            }
        }
        onDisbale() {
            super.onDisbale();
            if (ConfigManager.platform == PLATFORM_TYPE.VIVO || ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS || ConfigManager.appId == ANDROID_APP_ID.C_233 || (ConfigManager.appId == ANDROID_APP_ID.C233_ME || ConfigManager.appId == ANDROID_APP_ID.MMY || ConfigManager.appId == ANDROID_APP_ID.HYKB)) {
                AdUtil.hideBannerAd();
            }
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || ConfigManager.platform == PLATFORM_TYPE.WX) {
                AdUtil.hideCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                AdUtil.hideCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
            }
        }
        setAllButtonAnalysePoint() {}
        request(cb) {
            cb();
        }
    }

    class GetModeRewardFunction extends BaseFunction {
        createView() {
            this._viewCtrl = new GetModeRewardViewCtrl(this._args.mode, this._args.cb);
            return this._viewCtrl;
        }
        getFunctionName() {
            return '解锁新模式界面';
        }
        onEnter() { super.onEnter(); }
        onExit() { super.onExit(); }
        onEnable() {
            super.onEnter();
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || ConfigManager.platform == PLATFORM_TYPE.WX) {
                AdUtil.showCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                AdUtil.showCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
            }
        }
        onDisbale() {
            super.onDisbale();
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || ConfigManager.platform == PLATFORM_TYPE.WX) {
                AdUtil.hideCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                AdUtil.hideCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
            }
        }
        setAllButtonAnalysePoint() {}
        request(cb) {
            cb();
        }
    }

    class NotificationClickViewCtrl extends ui.view.common.LogClickViewUI {
        constructor(content) {
            super();
            this.isDown = false;
            this.height = this.stage.height;
            this.width = this.stage.width;
            this.setContent(content);
            var that = this;
            this.timer.once(3000, this, function() {
                if (that.isDown)
                    return;
                that.isDown = true;
                UIManager.closeFunction();
            });
            var that = this;
            Laya.timer.once(1000, this, function() {
                this.on(Laya.Event.CLICK, this, function() {
                    if (that.isDown)
                        return;
                    if (!CommonUtil.getTouch(500))
                        return;
                    that.timer.clearAll(that);
                    that.isDown = true;
                    UIManager.closeFunction();
                });
            }.bind(this));
        }
        setContent(content) {
            this.labelLog.text = content;
            this.imgBg.width = this.labelLog.width + 100;
        }
        onDestroy() {}
    }

    class NotificationFunction extends BaseFunction {
        createView() {
            this._viewCtrl = new NotificationClickViewCtrl(this.args);
            return this._viewCtrl;
        }
        getFunctionName() {
            return '通知点击界面';
        }
        onEnter() {
            super.onEnter();
            if (ConfigManager.platform == PLATFORM_TYPE.OPPO || ConfigManager.platform == PLATFORM_TYPE.WEB) {
                this.nativeBanner = new NativeBanner2ViewCtrl();
                let view = this._viewCtrl;
                view.addChild(this.nativeBanner);
            }
        }
        onExit() { super.onExit(); }
        onEnable() {
            super.onEnable();
            AdUtil.showBannerAd();
            this.nativeBanner && this.nativeBanner.show();
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || ConfigManager.appId == ANDROID_APP_ID.XM) {
                let x = PlatformUtil.getBannerCenterPos().x + PlatformUtil.getBannerWeight() + 30;
                let y = Laya.stage.height - PlatformUtil.getCustomSize().h;
                let x1 = PlatformUtil.getBannerCenterPos().x - PlatformUtil.getCustomSize().w - 30;
                AdUtil.showCustom(x1, y);
                AdUtil.showCustom(x, y);
            }
        }
        onDisbale() {
            super.onDisbale();
            AdUtil.hideBannerAd();
            this.nativeBanner && this.nativeBanner.hide();
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || ConfigManager.appId == ANDROID_APP_ID.XM) {
                let x = PlatformUtil.getBannerCenterPos().x + PlatformUtil.getBannerWeight() + 30;
                let y = Laya.stage.height - PlatformUtil.getCustomSize().h;
                let x1 = PlatformUtil.getBannerCenterPos().x - PlatformUtil.getCustomSize().w - 30;
                AdUtil.hideCustom(x1, y);
                AdUtil.hideCustom(x, y);
            }
        }
        setAllButtonAnalysePoint() {}
        request(cb) {
            cb();
        }
    }

    class GameBoxViewCtrl extends ui.view.gameBox.GameBoxViewUI {
        constructor(viewType) {
            super();
            this.viewType = 0;
            this.curBoxType = 0;
            this.isOpenRewardXQ = false;
            this.isCloseRewardXQ = true;
            this.isDown = false;
            this.width = this.stage.width;
            this.height = this.stage.height;
            this.viewType = viewType;
        }
        onAwake() {
            this.uiPlatformConfig();
            this.init();
            this.setPlatformStyle();
            this.setEvent();
            if (ConfigManager.platform == PLATFORM_TYPE.TT || ConfigManager.platform == PLATFORM_TYPE.WEB) {
                if (ConfigManager.isReviewVersion()) {
                    this.boxEndLabel.visible = false;
                }
                this.imgAd.visible = true;
                this.txtOpen.x += 15;
                this.imgAdIcon.visible = false;
            } else {
                this.imgAdIcon.visible = true;
                this.imgAd.visible = false;
            }
        }
        onDestroy() {
            NotifyManager.unregisterByEventId(NOTIFY_ID.ANDROID_REWARD_AD_LOAD);
            this.viewType = null;
            this.curBoxType = null;
        }
        init() {
            this.ani2.play(0, true);
            this.ani4.play(0, true);
            this.boxEndLabel.visible = false;
            this.btnBack.visible = false;
            if (this.viewType == 0) {
                this.boxEndLabel.visible = false;
                this.btnBack.visible = true;
                this.btnOpen.y = 596;
            } else {
                this.boxEndLabel.visible = true;
            }
        }
        adCtrl(isFirst = false) {
            this.boxAd.visible = false;
            this.boxNotAd.visible = false;
            if (this.viewType == 0) {
                this.boxAd.visible = true;
            } else {
                if (!isFirst) {
                    if (this.curBoxType == 0) {
                        this.curBoxType = 1;
                        this.boxNotAd.visible = true;
                        this.btnGetSenior.getChildAt(0).visible = false;
                        this.imgBox.skin = 'sub1/ui/gameBox/img_2.png';
                    } else {
                        this.curBoxType = 0;
                        this.boxAd.visible = true;
                        this.btnGetSenior.getChildAt(0).visible = true;
                        this.imgBox.skin = 'sub1/ui/gameBox/img_1.png';
                    }
                } else {
                    if (this.curBoxType == 0) {
                        this.boxAd.visible = true;
                        this.btnGetSenior.getChildAt(0).visible = true;
                        this.imgBox.skin = 'sub1/ui/gameBox/img_1.png';
                    } else {
                        this.boxNotAd.visible = true;
                        this.btnGetSenior.getChildAt(0).visible = false;
                        this.imgBox.skin = 'sub1/ui/gameBox/img_2.png';
                    }
                }
                if (ConfigManager.platform == PLATFORM_TYPE.WX) {
                    this.boxAd.visible = false;
                    this.boxNotAd.visible = true;
                }
            }
        }
        setEvent() {
            this.btnOpen.on(Laya.Event.CLICK, this, this.onBtnOpen);
            this.btnGetSenior.on(Laya.Event.CLICK, this, this.onBtnGetSenior);
            this.btnBack.on(Laya.Event.CLICK, this, this.onbBtnClose);
            this.btnCheckReward.on(Laya.Event.CLICK, this, this.onBtnCheckReward);
            if (ConfigManager.platform != PLATFORM_TYPE.TT) {
                this.boxSenior.on(Laya.Event.CLICK, this, this.onBtnOpen);
            }
        }
        onBtnCheckReward() {
            if (!CommonUtil.getTouch())
                return;
            if (!this.isOpenRewardXQ) {
                this.isOpenRewardXQ = true;
                this.ani5.play(0, false);
                this.timer.once(800, this, () => {
                    this.isCloseRewardXQ = false;
                });
            }
            if (!this.isCloseRewardXQ) {
                this.isCloseRewardXQ = true;
                this.ani6.play(0, false);
                this.timer.once(800, this, () => {
                    this.isOpenRewardXQ = false;
                });
            }
        }
        onbBtnClose() {
            if (!CommonUtil.getTouch())
                return;
            UIManager.closeFunction();
        }
        onBtnOpen() {
            if (!CommonUtil.getTouch(500))
                return;
            let curBoxType = this.curBoxType;
            let score = CharacterManger.playerLogicalBaseLayer ? CharacterManger.playerLogicalBaseLayer.playerKillCount : 2;
            score += 1;
            if (this.isDown)
                return;
            this.isDown = true;
            let that = this;
            if (curBoxType == 0) {
                AdUtil.setEvent(function() {
                    that.isDown = false;
                    UIManager.openFunction(FUNCTION_TAG.GET_BOX_REWARD, FUNCTION_OPEN_MODE.REPLACE, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE, {
                        itemList: [RoleManager.getInstance().getBoxTragmentId(), {
                            itemId: '2001',
                            count: RewardManager.getSeniorBoxReward().diamonds * 2
                        }, {
                            itemId: '3001',
                            count: score * 2
                        }, {
                            itemId: '1001',
                            count: Math.floor(RewardManager.getSeniorBoxReward().gold / 3 * 2)
                        }]
                    });
                }, function() {
                    that.isDown = false;
                }, REWARD_CTRL_TYPE.BOX_REWARD);
            } else {
                UIManager.openFunction(FUNCTION_TAG.GET_BOX_REWARD, FUNCTION_OPEN_MODE.REPLACE, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE, {
                    itemList: [RoleManager.getInstance().getBoxTragmentId(), {
                        itemId: '1001',
                        count: RewardManager.getSeniorBoxReward().gold
                    }, {
                        itemId: '2001',
                        count: RewardManager.getSeniorBoxReward().diamonds
                    }, {
                        itemId: '3001',
                        count: score
                    }, {
                        itemId: '1001',
                        count: Math.floor(RewardManager.getSeniorBoxReward().gold / 3)
                    }]
                });
            }
        }
        onBtnGetSenior() {
            if (!CommonUtil.getTouch())
                return;
            this.adCtrl();
        }
        award() {
            let score = CharacterManger.playerLogicalBaseLayer ? CharacterManger.playerLogicalBaseLayer.playerKillCount : 2;
            score += 1;
        }
        setPlatformStyle() {
            switch (ConfigManager.platform) {
                case PLATFORM_TYPE.WX:
                    {
                        this.setWXPlatform();
                        break;
                    }
                case PLATFORM_TYPE.QQ:
                    {
                        this.setQQPlatform();
                        break;
                    }
                case PLATFORM_TYPE.WEB:
                    {
                        this.setVIVOPlatform();
                        break;
                    }
                case PLATFORM_TYPE.WEB_4399:
                    {
                        this.setWeb4399Platform();
                        break;
                    }
                case PLATFORM_TYPE.VIVO:
                    {
                        this.setVIVOPlatform();
                        break;
                    }
                case PLATFORM_TYPE.OPPO:
                    {
                        this.setOPPOPlatform();
                        break;
                    }
                case PLATFORM_TYPE.NATIVE_IOS:
                    {
                        this.setNativeIOSPlatform();
                        break;
                    }
                case PLATFORM_TYPE.NATIVE_ANDRIOD:
                    {
                        if (ConfigManager.appId == ANDROID_APP_ID.XM) {
                            this.setNativeAndroidXMPlatform();
                        } else {
                            this.setAndroidPlatform();
                        }
                        break;
                    }
                case PLATFORM_TYPE.TT:
                    {
                        this.setTTPlatform();
                        break;
                    }
            }
        }
        setWXPlatform() {
            this.boxAd.visible = false;
            this.boxNotAd.visible = false;
            if (this.viewType == 0) {
                this.boxAd.visible = true;
            } else {
                this.boxEndLabel.visible = false;
                this.boxAd.visible = true;
                this.curBoxType = 0;
            }
        }
        setQQPlatform() {
            this.adCtrl(true);
        }
        setWebPlatform() {}
        setVIVOPlatform() {
            if (ConfigManager.isReviewVersion()) {
                this.boxAd.visible = false;
                this.boxNotAd.visible = false;
                if (this.viewType == 0) {
                    this.boxAd.visible = true;
                } else {
                    this.boxEndLabel.visible = false;
                    this.boxNotAd.visible = true;
                    this.curBoxType = 1;
                }
            } else
                this.adCtrl(true);
        }
        setOPPOPlatform() {
            this.adCtrl(true);
        }
        setNativeIOSPlatform() {
            if (GameScene.gameNum == 2 && RoleManager.getInstance().isNew) {
                this.adCtrl(false);
            } else {
                this.adCtrl(true);
            }
            if (this.viewType == 1) {}
        }
        setNativeAndroidXMPlatform() {
            this.boxNotAd.visible = false;
            this.boxAd.visible = true;
            this.btnGetSenior.visible = false;
            var that = this;
            NotifyManager.register(NOTIFY_ID.ANDROID_REWARD_AD_LOAD, function(isSuccess) {
                if (isSuccess) {
                    that.boxAd.visible = false;
                    that.boxNotAd.visible = true;
                } else {
                    that.boxNotAd.visible = false;
                    that.boxAd.visible = true;
                }
            }, this);
        }
        setAndroidPlatform() {
            if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD) {
                if (GameScene.gameNum == 2 && RoleManager.getInstance().isNew) {
                    this.adCtrl(false);
                } else {
                    this.adCtrl(true);
                }
                if (this.viewType == 1) {}
            } else {
                this.adCtrl(true);
            }
        }
        setWeb4399Platform() {
            this.boxAd.visible = false;
            this.boxNotAd.visible = false;
            if (this.viewType == 0) {
                this.boxAd.visible = true;
            } else {
                this.boxEndLabel.visible = false;
                this.boxAd.visible = true;
                this.curBoxType = 0;
            }
        }
        setTTPlatform() {
            this.adCtrl(true);
        }
        uiPlatformConfig() {
            UIManager.replaceAdIcon([{
                img: this.boxAd.getChildAt(1),
                type: 1
            }]);
            if (ConfigManager.platform == PLATFORM_TYPE.TT || ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.WEB_4399) {}
        }
    }

    class GameBoxFunction extends BaseFunction {
        createView() {
            this._viewCtrl = new GameBoxViewCtrl(this._args.viewType);
            return this._viewCtrl;
        }
        getFunctionName() {
            return '宝箱界面';
        }
        onEnter() { super.onEnter(); }
        onExit() { super.onExit(); }
        onEnable() {
            super.onEnable();
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || ConfigManager.platform == PLATFORM_TYPE.WX) {}
            AdUtil.showBannerAd(Laya.stage.width - PlatformUtil.getBannerWeight());
            AdUtil.showCustom(48, 75);
        }
        onDisbale() {
            super.onDisbale();
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || ConfigManager.platform == PLATFORM_TYPE.WX) {}
            AdUtil.hideBannerAd();
            AdUtil.hideCustom(48, 75);
        }
        setAllButtonAnalysePoint() {}
        request(cb) {
            cb();
        }
    }

    class NewReviveViewCtrl extends ui.view.revive.NewReviveViewUI {
        constructor(arg) {
            super();
            this.countDown = 6;
            this.isDone = false;
            this.scene3D = null;
            this._translate2 = new Laya.Vector3(5, -10, 1);
            this._translate = new Laya.Vector3(0, 0, 0);
            this.sp = null;
            this._pos = new Laya.Vector3(310, 500, 0);
            this.cb = null;
            this.width = this.stage.width;
            this.height = this.stage.height;
            this.cb = arg.cb;
            if (ConfigManager.platform == PLATFORM_TYPE.WEB_4399 && Laya.Browser.onPC) {
                Laya.Browser.document.exitPointerLock();
            }
        }
        onAwake() {
            AdUtil.showBannerAd();
            this.create3D();
            CharacterManger.gameStop = true;
            this.txtCountDown.text = this.countDown.toString();
            this.txtHit.text = '对我造成伤害：' + RandomUtil.onlyOneRandomInt(50, 100).toString();
            this.txtKiller.text = CharacterManger.killerName;
            this.timerLoop(1000, this, this.update);
            this.btnRevive.on(Laya.Event.CLICK, this, this.onBtnRevive);
        }
        onDestroy() {
            this.cb && this.cb();
            this.countDown = null;
            this.isDone = null;
            if (this.sp)
                this.sp.destroy();
            this.sp = null;
            if (this.scene3D)
                this.scene3D.destroy();
            this.scene3D = null;
            this._translate2 = null;
            this._translate = null;
            this.sp = null;
            if (ConfigManager.platform == PLATFORM_TYPE.WEB_4399 && Laya.Browser.onPC) {
                let view = UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME);
                view.onBtnDown(true);
            }
            this._pos = null;
        }
        create3D() {
            var scene = this.addChild(new Laya.Scene3D());
            var camera = scene.addChild(new Laya.Camera(0, 0.1, 1000));
            this.scene3D = scene;
            camera.transform.translate(this._translate2);
            camera.orthographic = true;
            camera.enableHDR = false;
            camera.clearColor = new Laya.Vector4(0.0, 0.0, 0.0, 0.0);
            var renderTexture = new Laya.RenderTexture(512, 512, Laya.RenderTextureFormat.R8G8B8A8, Laya.RenderTextureDepthFormat.DEPTH_16);
            camera.renderTarget = renderTexture;
            camera.orthographicVerticalSize = 10;
            scene.addChild(new Laya.DirectionLight());
            camera.convertScreenCoordToOrthographicCoord(this._pos, this._translate);
            this._translate.x += 3;
            this._translate.y -= 2;
            this.img3DCenter.source = new Laya.Texture(renderTexture);
            if (this.sp) {
                this.sp.destroy();
                this.sp = null;
            }
            this.sp = SkinManager.createRoleViewSkin(this._translate, this.scene3D, false, CharacterManger.killerSkin ? CharacterManger.killerSkin : '001');
            this.sp.transform.localRotationEulerY = 20;
            this.sp.transform.localPositionY -= 3;
            this.sp.transform.localPositionX -= 0.3;
            this.sp.transform.localScaleX = 6;
            this.sp.transform.localScaleY = 6;
            this.sp.transform.localScaleZ = 6;
            if (CharacterManger.killerLogic) {
                let a = 0;
                let id = CharacterManger.killerLogic.getArmCtrl() ? CharacterManger.killerLogic.getArmCtrl().getID() : 1;
                if (ModeManager.mode == GAME_MODE_TYPE.KNIFEWARMODE) {
                    a = 1;
                } else if (ModeManager.mode == GAME_MODE_TYPE.ONEVSONEMODE) {
                    id = 1;
                }
                let obj = SkinManager.createMenuArm(id, this.sp, a);
                obj.transform.localScaleX = 0.7;
                obj.transform.localScaleY = 0.7;
                obj.transform.localScaleZ = 0.7;
                if (CharacterManger.killerLogic.getArmCtrl())
                    this.imgArm.skin = CharacterManger.killerLogic.getArmCtrl().getIcon();
            }
        }
        update() {
            if (this.countDown != 0) {
                this.countDown--;
                this.txtCountDown.text = this.countDown.toString();
            } else {
                this.txtCountDown.text = this.countDown.toString();
                this.revive();
                this.timer.clear(this, this.update);
            }
        }
        revive() {
            if (this.isDone)
                return;
            AdUtil.hideBannerAd();
            this.isDone = true;
            this.timer.resume();
            UIManager.closeFunction();
            CharacterManger.gameStop = false;
            CharacterManger.playerLogicalBaseLayer.freeReviveNum--;
            CharacterManger.playerLogicalBaseLayer.directRevive(function() {
                CharacterManger.playerLogicalBaseLayer.getPresentationBaseLayer().setPos(CharacterManger.playerLogicalBaseLayer.getInitPos());
            });
        }
        onBtnRevive() {
            if (!CommonUtil.getTouch())
                return;
            let that = this;
            this.timer.pause();
            AdUtil.setEvent(function() {
                that.revive();
            }, function() {
                that.timer.resume();
            }, REWARD_CTRL_TYPE.REVIVE);
        }
    }

    class NewReviveFunction extends BaseFunction {
        createView() {
            this._viewCtrl = new NewReviveViewCtrl(this.args);
            return this._viewCtrl;
        }
        getFunctionName() {
            return '自动复活界面';
        }
        onEnter() {
            super.onEnter();
            if (ConfigManager.platform == PLATFORM_TYPE.OPPO || ConfigManager.platform == PLATFORM_TYPE.WEB) {
                this.nativeBanner = new NativeBanner2ViewCtrl();
                let view = this._viewCtrl;
                view.addChild(this.nativeBanner);
                this.nativeIcon1 = new NativeIcon1CellCtrl();
                view.boxAll.addChild(this.nativeIcon1);
                this.nativeIcon2 = new NativeIcon1CellCtrl();
                view.boxAll.addChild(this.nativeIcon2);
                this.nativeIcon1.x = 567;
                this.nativeIcon1.y = 86;
                this.nativeIcon2.x = 929;
                this.nativeIcon2.y = 86;
            }
        }
        onExit() { super.onExit(); }
        onEnable() {
            super.onEnable();
            let view = this.viewCtrl;
            AdUtil.showBannerAd();
            this.nativeBanner && this.nativeBanner.show();
            this.nativeIcon1 && this.nativeIcon1.show();
            this.nativeIcon2 && this.nativeIcon2.show();
            if (ConfigManager.platform == PLATFORM_TYPE.QQ || ConfigManager.platform == PLATFORM_TYPE.WX || ConfigManager.appId == ANDROID_APP_ID.XM) {
                let x = Laya.stage.width / 2 - 4;
                let y = 95;
                let x1 = Laya.stage.width / 2 + 356;
                AdUtil.showCustom(x1, y, WX_CUSTOM_AD_STYLE.SINGLE, null, function() {
                    ChannelManager.showSingleCell(x1, y, FUNCTION_TAG.AUTOREVIVE);
                });
                AdUtil.showCustom(x, y, WX_CUSTOM_AD_STYLE.SINGLE, null, function() {
                    ChannelManager.showSingleCell(x, y, FUNCTION_TAG.AUTOREVIVE);
                });
            }
        }
        onDisbale() {
            super.onDisbale();
            let view = this.viewCtrl;
            AdUtil.hideBannerAd();
            this.nativeBanner && this.nativeBanner.hide();
            this.nativeIcon1 && this.nativeIcon1.hide();
            this.nativeIcon2 && this.nativeIcon2.hide();
            if (ConfigManager.platform == PLATFORM_TYPE.QQ || ConfigManager.platform == PLATFORM_TYPE.WX || ConfigManager.appId == ANDROID_APP_ID.XM) {
                let x = Laya.stage.width / 2 - 4;
                let y = 95;
                let x1 = Laya.stage.width / 2 + 356;
                AdUtil.hideCustom(x1, y);
                AdUtil.hideCustom(x, y);
                ChannelManager.hideSingleCell(x, y, FUNCTION_TAG.AUTOREVIVE);
                ChannelManager.hideSingleCell(x1, y, FUNCTION_TAG.AUTOREVIVE);
            }
        }
        setAllButtonAnalysePoint() {}
        request(cb) {
            cb();
        }
    }

    class NativeIcon2CellCtrl extends ui.view.native.NativeIcon2CellUI {
        constructor() {
            super();
            this.isCanRefresh = true;
            this.isFirstTouch = true;
            this.isCanAutoShow = true;
        }
        onAwake() {
            this.on(Laya.Event.CLICK, this, this.onBtnAd);
            this.btnClose.on(Laya.Event.CLICK, this, this.onBtnClose);
            this.funcId = NotifyManager.register(NOTIFY_ID.REFRESH_NATIVE_AD, this.refresh, this);
            this.refresh();
        }
        onDestroy() {
            Laya.timer.clearAll(this);
            NotifyManager.unregisterByFuncId(this.funcId);
            LayaExtend.autoUnlinkUIReference(this);
            AdUtil.hideBannerAd();
        }
        onBtnAd() {
            if (!CommonUtil.getTouch())
                return;
            if (ConfigManager.platform == PLATFORM_TYPE.OPPO || ConfigManager.platform == PLATFORM_TYPE.VIVO) {
                AdUtil.nativeExtendIconList.ad && AdUtil.nativeExtendIconList.ad.reportAdClick({
                    adId: AdUtil.nativeExtendIconList.data.adId.toString()
                });
            }
            if (ConfigManager.platform == PLATFORM_TYPE.VIVO) {
                let that = this;
                AdUtil.preloadNativeAdExtend(function() {}, function() {}, NATIVE_TYPE.BANNER);
            }
        }
        onBtnClose() {
            this.destroy();
        }
        refresh() {
            if (!this.isCanRefresh)
                return;
            if (!this.imgAd)
                return;
            if (AdUtil.nativeExtendIconList.ad) {
                AdUtil.hideBannerAd();
                this.isCanAutoShow && this.show();
                if (ConfigManager.platform == PLATFORM_TYPE.OPPO || ConfigManager.platform == PLATFORM_TYPE.VIVO) {
                    AdUtil.nativeExtendIconList.ad && AdUtil.nativeExtendIconList.ad.reportAdShow({
                        adId: AdUtil.nativeExtendIconList.data.adId.toString()
                    });
                }
                this.imgAd.skin = AdUtil.nativeExtendIconList.data.imgUrlList[0];
            } else {
                this.autoHide();
                AdUtil.showBannerAd();
            }
        }
        hide() {
            if (this.destroyed)
                return;
            this.isCanAutoShow = false;
            this.mouseEnabled = false;
            this.visible = false;
        }
        autoHide() {
            this.mouseEnabled = false;
            this.visible = false;
        }
        show() {
            if (this.destroyed)
                return;
            this.isCanAutoShow = true;
            if (!AdUtil.nativeExtendIconList.ad)
                return;
            this.mouseEnabled = true;
            this.visible = true;
        }
    }

    class SuperStartViewCtrl extends ui.view.superStart.SuperStartViewUI {
        constructor(cb) {
            super();
            this.getSuperStart = false;
            this.cb = null;
            this.width = this.stage.width;
            this.height = this.stage.height;
            this.cb = cb;
        }
        onAwake() {
            this.uiPlatformConfig();
            if (!ConfigManager.getViolenceCtrl()) {
                let str = this.imgHead.skin;
                str = str.replace(".png", "_4399.png");
                this.imgHead.skin = str;
                this.labelHead.text = '暴击率';
            }
            this.getChildAt(0).visible = false;
            this.ani1.play(0, false);
            this.boxAd.visible = false;
            this.boxNoAd.visible = false;
            this.btnGet.getChildAt(0).visible = false;
            let num = ConfigManager.platform == PLATFORM_TYPE.OPPO ? 2 : 4;
            if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD) {
                num = 100;
            }
            if (GameScene.gameNum >= num) {
                this.getSuperStart = true;
                if (ConfigManager.platform == PLATFORM_TYPE.TT) {
                    this.getSuperStart = false;
                }
            }
            if (this.getSuperStart) {
                this.btnGet.getChildAt(0).visible = true;
                this.boxAd.visible = true;
            } else {
                this.boxNoAd.visible = true;
            }
            this.setPlatformStyle();
            this.btnSuperStart.on(Laya.Event.CLICK, this, this.onBtnSuperStart);
            this.btnChooseStart.on(Laya.Event.CLICK, this, this.onBtnChooseStart);
            this.btnGet.on(Laya.Event.CLICK, this, this.onBtnGet);
            if (ConfigManager.platform == PLATFORM_TYPE.TT) {
                if (ConfigManager.isReviewVersion()) {
                    this.boxSuperStart.visible = false;
                }
            }
        }
        setPlatformStyle() {
            switch (ConfigManager.platform) {
                case PLATFORM_TYPE.WX:
                    {
                        this.setWXPlatform();
                        break;
                    }
                case PLATFORM_TYPE.QQ:
                    {
                        this.setQQPlatform();
                        break;
                    }
                case PLATFORM_TYPE.WEB:
                    {
                        this.setWXPlatform();
                        break;
                    }
                case PLATFORM_TYPE.WEB_4399:
                    {
                        this.setWeb4399Platform();
                        break;
                    }
                case PLATFORM_TYPE.VIVO:
                    {
                        this.setVIVOPlatform();
                        break;
                    }
                case PLATFORM_TYPE.OPPO:
                    {
                        this.setOPPOPlatform();
                        break;
                    }
                case PLATFORM_TYPE.NATIVE_IOS:
                    {
                        this.setNativeIOSPlatform();
                        break;
                    }
                case PLATFORM_TYPE.NATIVE_ANDRIOD:
                    {
                        this.setNativeAndroidPlatform();
                        break;
                    }
                case PLATFORM_TYPE.TT:
                    {
                        this.setTTPlatform();
                        break;
                    }
            }
        }
        setWXPlatform() {
            this.boxSuperStart.visible = false;
            this.getSuperStart = false;
            this.boxAd.visible = false;
            this.boxNoAd.visible = true;
        }
        setQQPlatform() {}
        setWebPlatform() {}
        setVIVOPlatform() {
            this.btnChooseStart.x += 110;
            this.btnSuperStart.x += 160;
        }
        setOPPOPlatform() {
            this.btnChooseStart.x += 110;
            this.btnSuperStart.x += 160;
        }
        setNativeIOSPlatform() {}
        setWeb4399Platform() {}
        setNativeAndroidPlatform() {}
        setTTPlatform() {}
        setAd() {
            this.boxNoAd.visible = false;
            this.boxAd.visible = false;
            if (this.getSuperStart) {
                this.getSuperStart = false;
                this.btnGet.getChildAt(0).visible = false;
                this.boxNoAd.visible = true;
            } else {
                this.getSuperStart = true;
                this.btnGet.getChildAt(0).visible = true;
                this.boxAd.visible = true;
            }
        }
        onDestroy() {
            this.cb();
            this.cb = null;
        }
        onBtnSuperStart() {
            if (!CommonUtil.getTouch())
                return;
            AdUtil.setEvent(function() {
                BuffManager.setBuffGain(true, 10, 30, 10);
                UIManager.closeFunction();
            }, function() {}, REWARD_CTRL_TYPE.BUFF);
        }
        onBtnChooseStart() {
            if (!CommonUtil.getTouch())
                return;
            if (this.getSuperStart) {
                AdUtil.setEvent(function() {
                    BuffManager.setBuffGain(true, 10, 30, 10);
                    UIManager.closeFunction();
                }, function() {}, REWARD_CTRL_TYPE.BUFF);
            } else {
                BuffManager.setBuffGain();
                UIManager.closeFunction();
            }
        }
        onBtnGet() {
            if (!CommonUtil.getTouch())
                return;
            this.setAd();
        }
        uiPlatformConfig() {
            UIManager.replaceAdIcon([{
                img: this.btnSuperStart.getChildAt(0),
                type: 1
            }]);
        }
    }

    class SuperStartFunction extends BaseFunction {
        createView() {
            this._viewCtrl = new SuperStartViewCtrl(this._args.cb);
            return this._viewCtrl;
        }
        getFunctionName() {
            return '超凡开局界面';
        }
        onEnter() {
            super.onEnter();
            if (ConfigManager.platform == PLATFORM_TYPE.OPPO || ConfigManager.platform == PLATFORM_TYPE.WEB) {
                let view = this._viewCtrl;
                this.nativeIcon = new NativeIcon2CellCtrl();
                view.boxAll.addChild(this.nativeIcon);
                this.nativeIcon.x = 290;
                this.nativeIcon.y = 535;
            }
        }
        onExit() { super.onExit(); }
        onEnable() {
            super.onEnable();
            this.nativeIcon && this.nativeIcon.show();
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || ConfigManager.platform == PLATFORM_TYPE.WX) {
                AdUtil.showCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                AdUtil.showCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
            }
        }
        onDisbale() {
            super.onDisbale();
            this.nativeIcon && this.nativeIcon.hide();
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || ConfigManager.platform == PLATFORM_TYPE.WX) {
                AdUtil.hideCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                AdUtil.hideCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
            }
        }
        setAllButtonAnalysePoint() {}
        request(cb) {
            cb();
        }
    }

    class EndAniViewCtrl extends ui.view.ani.EndAniViewUI {
        constructor(cb) {
            super();
            this.endTime = 6;
            this.width = Laya.stage.width;
            this.height = Laya.stage.height;
            this.setView(CharacterManger._isWin, ModeManager.mode);
            Laya.timer.loop(1000, this, this.update);
            this.update();
            var that = this;
            Laya.timer.once(500, this, function() {
                that.on(Laya.Event.CLICK, that, that.onBtnClose);
            });
            this.cb = cb;
            if (ConfigManager.platform == PLATFORM_TYPE.WEB_4399 && Laya.Browser.onPC) {
                Laya.Browser.document.exitPointerLock();
            }
        }
        onDestroy() {
            this.cb && this.cb();
        }
        update() {
            this.endTime -= 1;
            this.labelTime.text = this.endTime + '秒后自动结算';
            if (this.endTime == 0) {
                this.onBtnClose();
            }
        }
        setView(isWin, mode) {
            this.boxLose.visible = false;
            this.boxWin.visible = false;
            this.imgLogBgLose.visible = false;
            this.imgLogBgWin.visible = false;
            this.imgLose.visible = false;
            this.imgWin.visible = false;
            if (mode == GAME_MODE_TYPE.TEAMCOMPETITION) {
                this.boxMode.visible = false;
            } else {
                this.labelInfo.text = TaskManager.taskEntry();
            }
            if (isWin) {
                SoundManager.playEffect(SOUND_PATH.WIN);
                this.boxWin.visible = true;
                this.imgWin.visible = true;
                this.imgLogBgWin.visible = true;
            } else {
                SoundManager.playEffect(SOUND_PATH.FAIL);
                this.boxLose.visible = true;
                this.imgLogBgLose.visible = true;
                this.imgLose.visible = true;
            }
            this.setPlatformStyle();
        }
        onBtnClose() {
            if (!CommonUtil.getTouch())
                return;
            this.timer.clearAll(this);
            UIManager.closeFunction();
        }
        setPlatformStyle() {
            switch (ConfigManager.platform) {
                case PLATFORM_TYPE.WX:
                    {
                        this.setWXPlatform();
                        break;
                    }
                case PLATFORM_TYPE.QQ:
                    {
                        this.setQQPlatform();
                        break;
                    }
                case PLATFORM_TYPE.WEB:
                    {
                        this.setWXPlatform();
                        break;
                    }
                case PLATFORM_TYPE.VIVO:
                    {
                        this.setVIVOPlatform();
                        break;
                    }
                case PLATFORM_TYPE.OPPO:
                    {
                        this.setOPPOPlatform();
                        break;
                    }
                case PLATFORM_TYPE.NATIVE_IOS:
                    {
                        this.setNativeIOSPlatform();
                        break;
                    }
                case PLATFORM_TYPE.NATIVE_ANDRIOD:
                    {
                        this.setNativeAndroidPlatform();
                        break;
                    }
                case PLATFORM_TYPE.TT:
                    {
                        this.setTTPlatform();
                        break;
                    }
            }
        }
        setWXPlatform() {
            if (PlatformUtil.isIOS()) {
                this.boxMode.y -= 30;
                this.boxWin.centerY -= 30;
                this.boxLose.centerY -= 30;
                this.labelEnd.bottom += 30;
            }
        }
        setQQPlatform() {}
        setWebPlatform() {}
        setVIVOPlatform() {}
        setOPPOPlatform() {}
        setNativeIOSPlatform() {}
        setNativeAndroidPlatform() {}
        setTTPlatform() {}
    }

    class EndAniFunction extends BaseFunction {
        createView() {
            this._viewCtrl = new EndAniViewCtrl(this.args);
            return this._viewCtrl;
        }
        getFunctionName() {
            return '结束交互动画界面';
        }
        onEnter() { super.onEnter(); }
        onExit() { super.onExit(); }
        onEnable() {
            super.onEnable();
            AdUtil.showBannerAd();
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || ConfigManager.platform == PLATFORM_TYPE.WX) {
                AdUtil.showCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                AdUtil.showCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
            }
        }
        onDisbale() {
            super.onDisbale();
            AdUtil.hideBannerAd();
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || ConfigManager.platform == PLATFORM_TYPE.WX) {
                AdUtil.hideCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                AdUtil.hideCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
            }
        }
        setAllButtonAnalysePoint() {}
        request(cb) {
            cb();
        }
    }

    class GetEquipOrRoleRewardViewCtrl extends ui.view.getReward.GetEquipOrRoleRewardViewUI {
        constructor(itemId, cb) {
            super();
            this.reward = 0;
            this.scene3D = null;
            this.rotMouseX = 0;
            this.sp3 = null;
            this.sp2 = null;
            this._translate2 = new Laya.Vector3(5, -10, 1);
            this._translate = new Laya.Vector3(0, 0, 0);
            this.sp = null;
            this._pos = new Laya.Vector3(310, 500, 0);
            this.width = this.stage.width;
            this.height = this.stage.height;
            this.boxBg.scaleX = this.stage.width / this.boxBg.width;
            this.data = Item.getDataByKey(itemId);
            if (this.data.type == ITEM_TYPE.HERO) {
                RoleManager.getInstance().setRoleSkinLib(this.data.extra());
                RoleManager.getInstance().setSelectRoleSkin(this.data.extra());
                SceneManager.getCurScene().lastSceneType = null;
                SceneManager.getCurScene().createMenu(2, null, this.data.extra());
                this.on(Laya.Event.MOUSE_DOWN, this, this.onBtnMouseDown);
                this.on(Laya.Event.MOUSE_MOVE, this, this.onBtnRot);
                this.boxEnter.on(Laya.Event.CLICK, this, this.onBtnBack);
            } else {
                if (this.data.type == ITEM_TYPE.PART) {
                    RoleManager.getInstance().setPartsSkin(this.data.extra());
                }
                this.create3D();
                this.on(Laya.Event.CLICK, this, this.onBtnBack);
            }
            this.cb = cb;
        }
        onAwake() {
            this.init();
            this.frameLoop(1, this, this.update);
        }
        onDestroy() {
            if (this.data.type == ITEM_TYPE.HERO)
                SceneManager.getCurScene().cleanMenu();
            this.timer.clearAll(this);
            this.cb && this.cb();
        }
        init() {
            this.boxAll.visible = false;
            this.boxHero.visible = false;
            if (this.data.type == ITEM_TYPE.HERO) {
                this.boxLv.removeSelf();
                this.labelName.text = this.data.name;
                this.labelHeroName.text = this.data.name;
                this.boxHero.visible = true;
                this.imgBg.skin = 'sub1/ui/common/img_bag_bg.jpg';
                this.imgBg.alpha = 1;
            } else {
                this.boxAll.visible = true;
                if (this.data.type == ITEM_TYPE.PART) {
                    this.boxLv.visible = false;
                }
                this.labelLv.text = this.data.extra().toString();
                let str = '';
                if (RoleManager.getInstance().getEquipHaveTime(this.data.extra())) {
                    let time = RoleManager.getInstance().getEquipHaveTime(this.data.extra()) - RoleManager.getInstance().getTime();
                    if (time > 3600 * 24) {
                        console.log('超过一天到期');
                        str = ' (' + Math.floor(time / (3600 * 24)) + '天)';
                    } else {
                        if (time > 3600) {
                            console.log('超过一小时到期');
                            str = ' (' + Math.floor(time / 3600) + '小时)';
                        } else {
                            str = ' (' + Math.floor(time / (60)) + '分钟)';
                        }
                    }
                }
                this.labelName.text = this.data.name + str;
                let wigth = this.labelName.width;
                this.boxLv.x -= wigth / 2 + 38;
            }
        }
        onBtnMouseDown(e) {
            this.rotMouseX = e.stageX;
        }
        onBtnRot(e) {
            if (SceneManager.getCurScene().menuPlayer) {
                let fac = e.stageX - this.rotMouseX;
                SceneManager.getCurScene().menuPlayer.transform.localRotationEulerY += fac * 0.4;
                this.rotMouseX = e.stageX;
            }
        }
        onBtnBack() {
            if (!CommonUtil.getTouch())
                return;
            this.mouseEnabled = false;
            UIManager.closeFunction();
        }
        create3D() {
            var scene = this.boxScene.addChild(new Laya.Scene3D());
            this.scene3D = scene;
            var camera = (scene.addChild(new Laya.Camera(0, 0.1, 1000)));
            camera.transform.position = new Laya.Vector3();
            camera.transform.localPositionX -= 5.2;
            camera.transform.localPositionY -= 2.3;
            camera.enableHDR = false;
            camera.clearFlag = Laya.CameraClearFlags.DepthOnly;
            var directionLight = scene.addChild(new Laya.DirectionLight());
            directionLight.color = new Laya.Vector3(0.6, 0.6, 0.6);
            directionLight.transform.worldMatrix.setForward(new Laya.Vector3(0, 0, -0.5));
            if (this.data.type == ITEM_TYPE.EQUIP) {
                this.sp3 = SkinManager.onLyToCreateArm(this.data.extra(), this.scene3D);
                this.sp3.transform.localRotationEulerY = -90;
                this.sp3.transform.localRotationEulerX = -15;
                this.sp3.transform.localScaleX = 6;
                this.sp3.transform.localScaleY = 6;
                this.sp3.transform.localScaleZ = 6;
                this.sp3.transform.localPosition = new Laya.Vector3(-4.99, -1, -11);
                this.sp3.active = true;
            } else {
                this.sp3 = new Laya.Sprite3D();
                SkinManager.createParts(this.data.extra(), this.sp3, new Laya.Vector3(6, 6, 6), null, false);
                this.sp3.transform.localRotationEulerY = 0;
                this.sp3.transform.localRotationEulerX = 0;
                this.sp3.transform.localScaleX = 1;
                this.sp3.transform.localScaleY = 1;
                this.sp3.transform.localScaleZ = 1;
                this.sp3.transform.localPosition = new Laya.Vector3(-4.99, -1, -11);
                this.scene3D.addChild(this.sp3);
                this.sp3.active = true;
            }
        }
        createHero3D() {
            var scene = this.boxScene.addChild(new Laya.Scene3D());
            this.scene3D = scene;
            var camera = (scene.addChild(new Laya.Camera(0, 0.1, 100)));
            camera.transform.position = new Laya.Vector3();
            camera.transform.localPositionX -= 5.2;
            camera.transform.localPositionY -= 2.3;
            camera.enableHDR = false;
            camera.clearFlag = Laya.CameraClearFlags.DepthOnly;
            var directionLight = scene.addChild(new Laya.DirectionLight());
            directionLight.color = new Laya.Vector3(0.6, 0.6, 0.6);
            directionLight.transform.worldMatrix.setForward(new Laya.Vector3(0, 0, -0.5));
            this.sp = SkinManager.createRoleViewSkin(this._translate, this.scene3D, false, this.data.extra());
            this.sp.transform.localRotationEulerY = 20;
            this.sp.transform.localScaleX = 3;
            this.sp.transform.localScaleY = 3;
            this.sp.transform.localScaleZ = 3;
            this.sp.transform.localPosition = new Laya.Vector3(-4.99, -3.0, -11);
            this.timerOnce(50, this, () => {
                let obj = SkinManager.createMenuArm(RoleManager.getInstance().getSelectSkin(), this.sp);
                obj.transform.localScaleX = 1.3;
                obj.transform.localScaleY = 1.3;
                obj.transform.localScaleZ = 1.3;
            });
        }
        update() {
            if (this.sp3)
                this.sp3.transform.localRotationEulerY++;
            if (this.sp)
                this.sp.transform.localRotationEulerY++;
        }
    }

    class GetEquipOrRoleRewardFunction extends BaseFunction {
        createView() {
            this._viewCtrl = new GetEquipOrRoleRewardViewCtrl(this.args.id, this.args.cb ? this.args.cb : null);
            return this._viewCtrl;
        }
        getFunctionName() {
            return '获得枪支人物界面';
        }
        onEnter() { super.onEnter(); }
        onExit() { super.onExit(); }
        onEnable() {
            super.onEnable();
            let view = this.viewCtrl;
            if (view.data.type == ITEM_TYPE.HERO) {
                if (ConfigManager.platform != PLATFORM_TYPE.NATIVE_ANDRIOD || ConfigManager.appId == ANDROID_APP_ID.XM)
                    AdUtil.showBannerAd(14, PlatformUtil.getBannerCenterPos().y + (PlatformUtil.isIOS() ? 30 : 0));
                else {
                    if (ConfigManager.appId == ANDROID_APP_ID.C_233 || (ConfigManager.appId == ANDROID_APP_ID.C233_ME || ConfigManager.appId == ANDROID_APP_ID.MMY || ConfigManager.appId == ANDROID_APP_ID.HYKB))
                        AdUtil.showBannerAd();
                }
            } else {
                AdUtil.showBannerAd();
                if (PLATFORM_TYPE.QQ == ConfigManager.platform || ConfigManager.platform == PLATFORM_TYPE.WX) {
                    AdUtil.showCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                    AdUtil.showCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                }
            }
        }
        onDisbale() {
            super.onDisbale();
            AdUtil.hideBannerAd();
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || ConfigManager.platform == PLATFORM_TYPE.WX) {
                AdUtil.hideCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                AdUtil.hideCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
            }
        }
        setAllButtonAnalysePoint() {}
        request(cb) {
            cb();
        }
    }

    class GetBoxRewardViewCtrl extends ui.view.getReward.GetBoxRewardViewUI {
        constructor(itemList, cb) {
            super();
            this.itemList = [];
            this.index = 0;
            this.boxItemCellCtrl = null;
            this.isAuto = true;
            this.width = Laya.stage.width;
            this.height = Laya.stage.height;
            this.itemList = itemList;
            console.log('itemList', itemList);
            this.setview();
            this.cb = cb;
        }
        setview() {
            this.setPlatformStyle();
            if (!this.itemList[0].isExtra)
                GetBoxRewardNextViewCtrl.adSuccess(this.itemList, true);
            this.newItem();
        }
        onDestroy() {
            this.cb && this.cb();
        }
        newItem() {
            if (this.index == this.itemList.length) {
                this.timer.clearAll(this);
                UIManager.openFunction(FUNCTION_TAG.GET_BOX_REWARD_NEXT, FUNCTION_OPEN_MODE.REPLACE, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE, this.itemList);
                return;
            }
            if (!this.boxItemCellCtrl) {
                this.boxItemCellCtrl = new BoxItemCellViewCtrl();
                this.btnEnter.on(Laya.Event.CLICK, this, this.onBtnEnter);
                this.boxItem.addChild(this.boxItemCellCtrl);
                console.log(this.itemList[this.index].itemId);
                this.boxItemCellCtrl.setView(this.itemList[this.index].itemId, this.itemList[this.index].count, this.itemList[this.index].isExtra);
            } else {
                if (!this.labelNext.visible && !ConfigManager.isReviewVersion())
                    AdUtil.showBannerAd();
                this.btnEnter.visible = false;
                this.labelNext.visible = true;
                this.offAll(Laya.Event.CLICK);
                this.on(Laya.Event.CLICK, this, this.onBtnEnter);
                this.boxItemCellCtrl.setView(this.itemList[this.index].itemId, this.itemList[this.index].count, this.itemList[this.index].isExtra);
            }
            this.boxItemCellCtrl.imgBg.width = 173.04;
            this.boxItemCellCtrl.imgBg.height = 173.04;
            this.boxItemCellCtrl.imgBg.scale(1.19, 1.19);
            this.boxItemCellCtrl.labelExtra.visible = false;
            if (this.itemList[this.index].isExtra) {
                this.imgExtra.visible = true;
            } else {
                this.imgExtra.visible = false;
            }
            this.boxItemCellCtrl.labelName.y = 268;
            this.index++;
            this.labelCount.text = (this.itemList.length - this.index).toString();
            this.boxItemCellCtrl.show();
            this.timer.clearAll(this);
            if (this.isAuto)
                this.timer.once(2000, this, this.newItem);
        }
        onBtnEnter() {
            if (!CommonUtil.getTouch())
                return;
            this.newItem();
        }
        setPlatformStyle() {
            switch (ConfigManager.platform) {
                case PLATFORM_TYPE.WX:
                    {
                        this.setWXPlatform();
                        break;
                    }
                case PLATFORM_TYPE.QQ:
                    {
                        this.setQQPlatform();
                        break;
                    }
                case PLATFORM_TYPE.WEB:
                    {
                        this.setWXPlatform();
                        break;
                    }
                case PLATFORM_TYPE.WEB_4399:
                    {
                        this.setWeb4399Platform();
                        break;
                    }
                case PLATFORM_TYPE.VIVO:
                    {
                        this.setVIVOPlatform();
                        break;
                    }
                case PLATFORM_TYPE.OPPO:
                    {
                        this.setOPPOPlatform();
                        break;
                    }
                case PLATFORM_TYPE.NATIVE_IOS:
                    {
                        this.setNativeIOSPlatform();
                        break;
                    }
                case PLATFORM_TYPE.NATIVE_ANDRIOD:
                    {
                        this.setNativeAndroidPlatform();
                        break;
                    }
                case PLATFORM_TYPE.TT:
                    {
                        this.setTTPlatform();
                        break;
                    }
            }
        }
        setWXPlatform() {
            if (PlatformUtil.isIOS()) {
                this.boxMain.centerY -= 60;
                this.btnEnter.y += 60;
            }
        }
        setWeb4399Platform() {}
        setQQPlatform() {}
        setWebPlatform() {}
        setVIVOPlatform() {}
        setOPPOPlatform() {}
        setNativeIOSPlatform() {}
        setNativeAndroidPlatform() {
            this.isAuto = false;
        }
        setTTPlatform() {}
    }

    class NativeBanner3ViewCtrl extends ui.view.native.NativeBanner3ViewUI {
        constructor(btnNative = null) {
            super();
            this.isCanRefresh = true;
            this.isFirstTouch = true;
            this.isCanAutoShow = true;
            this.btnNative = btnNative;
        }
        onAwake() {
            this.width = this.stage.width;
            this.height = this.stage.height;
            this.imgAd.on(Laya.Event.CLICK, this, this.onBtnAd);
            this.btnAd.on(Laya.Event.CLICK, this, this.onBtnAd);
            this.btnNative && this.btnNative.on(Laya.Event.CLICK, this, this.onBtnAd);
            this.btnClose.on(Laya.Event.CLICK, this, this.onBtnClose);
            this.funcId = NotifyManager.register(NOTIFY_ID.REFRESH_NATIVE_AD, this.refresh, this);
            this.refresh();
        }
        onDestroy() {
            if (this.btnNative) {
                this.btnNative.visible = false;
                Laya.Tween.clearAll(this.btnNative);
            }
            this.btnNative = null;
            Laya.timer.clearAll(this);
            NotifyManager.unregisterByFuncId(this.funcId);
        }
        playButtonScale() {
            let idx = 0;
            let that = this;
            let action = function() {
                if (idx % 2 == 0) {
                    Laya.Tween.to(that.btnNative, {
                        scaleX: 1.1,
                        scaleY: 1.1
                    }, 500, null, Laya.Handler.create(that, action));
                } else {
                    Laya.Tween.to(that.btnNative, {
                        scaleX: 1,
                        scaleY: 1
                    }, 500, null, Laya.Handler.create(that, action));
                }
                idx++;
            };
            action();
        }
        onBtnAd() {
            if (!CommonUtil.getTouch())
                return;
            if (ConfigManager.platform == PLATFORM_TYPE.OPPO || ConfigManager.platform == PLATFORM_TYPE.VIVO) {
                AdUtil.nativeExtendList.ad && AdUtil.nativeExtendList.ad.reportAdClick({
                    adId: AdUtil.nativeExtendList.data.adId.toString()
                });
            }
            if (ConfigManager.platform == PLATFORM_TYPE.VIVO) {
                let that = this;
                AdUtil.preloadNativeAdExtend(function() {}, function() {}, NATIVE_TYPE.BANNER);
            }
        }
        onBtnClose() {
            this.destroy();
        }
        refresh() {
            if (!this.isCanRefresh)
                return;
            if (!this.imgAd)
                return;
            if (AdUtil.nativeExtendList.data) {
                AdUtil.hideBannerAd();
                this.isCanAutoShow && this.show();
                ConfigManager.platform != PLATFORM_TYPE.WEB && AdUtil.nativeExtendList.ad && AdUtil.nativeExtendList.ad.reportAdShow({
                    adId: AdUtil.nativeExtendList.data.adId.toString()
                });
                this.imgAd.skin = AdUtil.nativeExtendList.data.imgUrlList[0];
            } else {
                this.autoHide();
            }
        }
        hide() {
            if (this.destroyed)
                return;
            this.isCanAutoShow = false;
            this.mouseEnabled = false;
            this.visible = false;
            if (this.btnNative)
                this.btnNative.visible = false;
        }
        autoHide() {
            this.mouseEnabled = false;
            this.visible = false;
            if (this.btnNative)
                this.btnNative.visible = false;
        }
        show() {
            if (this.destroyed)
                return;
            this.isCanAutoShow = true;
            if (!AdUtil.nativeExtendList.data || !AdUtil.nativeExtendList.data.imgUrlList[0])
                return;
            this.mouseEnabled = true;
            this.visible = true;
            if (this.btnNative)
                this.btnNative.visible = true;
        }
    }

    class GetBoxRewardFunction extends BaseFunction {
        createView() {
            this._viewCtrl = new GetBoxRewardViewCtrl(this.args.itemList, this.args.cb ? this.args.cb : null);
            return this._viewCtrl;
        }
        getFunctionName() {
            return '获得宝箱界面';
        }
        onEnter() {
            super.onEnter();
            if (ConfigManager.platform == PLATFORM_TYPE.OPPO || ConfigManager.platform == PLATFORM_TYPE.WEB) {
                this.nativeBanner = new NativeBanner3ViewCtrl();
                let view = this._viewCtrl;
                view.getChildAt(1).addChild(this.nativeBanner);
                view.getChildAt(1).addChild(this.nativeBanner.btnAd);
                this.nativeBanner.x = 600;
                this.nativeBanner.y = 246;
                this.nativeBanner.scale(0.8, 0.8);
                this.nativeBanner.btnAd.x = 1050;
                this.nativeBanner.btnAd.y = 620;
                this.nativeBanner.btnAd.visible = false;
            }
        }
        onExit() { super.onExit(); }
        onEnable() {
            super.onEnable();
            this.nativeBanner && this.nativeBanner.show();
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || ConfigManager.platform == PLATFORM_TYPE.WX) {
                AdUtil.showCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                AdUtil.showCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
            }
        }
        onDisbale() {
            super.onDisbale();
            AdUtil.hideBannerAd();
            this.nativeBanner && this.nativeBanner.hide();
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || ConfigManager.platform == PLATFORM_TYPE.WX) {
                AdUtil.hideCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                AdUtil.hideCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
            }
        }
        setAllButtonAnalysePoint() {}
        request(cb) {
            cb();
        }
    }

    class GetBoxRewardNextFunction extends BaseFunction {
        createView() {
            this._viewCtrl = new GetBoxRewardNextViewCtrl(this.args);
            return this._viewCtrl;
        }
        getFunctionName() {
            return '获得宝箱奖励界面';
        }
        onEnter() {
            super.onEnter();
            if (ConfigManager.platform == PLATFORM_TYPE.OPPO || ConfigManager.platform == PLATFORM_TYPE.WEB) {
                this.nativeBanner = new NativeBanner2ViewCtrl();
                let view = this._viewCtrl;
                view.boxAll.addChild(this.nativeBanner);
                this.nativeBanner.left = NaN;
                this.nativeBanner.bottom = NaN;
                this.nativeBanner.x = 413;
                this.nativeBanner.y = 380;
                this.nativeBanner.scale(0.8, 0.8);
            }
        }
        onExit() { super.onExit(); }
        onEnable() {
            super.onEnable();
            this.nativeBanner && this.nativeBanner.show();
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || ConfigManager.platform == PLATFORM_TYPE.WX) {
                AdUtil.showCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                AdUtil.showCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
            }
        }
        onDisbale() {
            super.onDisbale();
            this.nativeBanner && this.nativeBanner.hide();
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || ConfigManager.platform == PLATFORM_TYPE.WX) {
                AdUtil.hideCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                AdUtil.hideCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
            }
        }
        setAllButtonAnalysePoint() {}
        request(cb) {
            cb();
        }
    }

    class NativeInterstitialViewCtrl extends ui.view.native.NativeInterstitialViewUI {
        constructor(btnNative = null) {
            super();
            this.isCanRefresh = true;
            this.isFirstTouch = true;
            this.isCanAutoShow = true;
            this.btnNative = btnNative;
        }
        onAwake() {
            this.width = this.stage.width;
            this.height = this.stage.height;
            this.btnAd.on(Laya.Event.CLICK, this, this.onBtnAd);
            this.imgTouch.on(Laya.Event.CLICK, this, this.onBtnAd);
            this.btnNative && this.btnNative.on(Laya.Event.CLICK, this, this.onBtnAd);
            this.btnClose.on(Laya.Event.CLICK, this, this.onBtnClose);
            this.funcId = NotifyManager.register(NOTIFY_ID.REFRESH_NATIVE_AD, this.refresh, this);
            this.refresh();
        }
        onDestroy() {
            if (this.btnNative) {
                this.btnNative.visible = false;
                Laya.Tween.clearAll(this.btnNative);
            }
            this.btnNative = null;
            Laya.timer.clearAll(this);
            NotifyManager.unregisterByFuncId(this.funcId);
        }
        playButtonScale() {
            let idx = 0;
            let that = this;
            let action = function() {
                if (idx % 2 == 0) {
                    Laya.Tween.to(that.btnNative, {
                        scaleX: 1.1,
                        scaleY: 1.1
                    }, 500, null, Laya.Handler.create(that, action));
                } else {
                    Laya.Tween.to(that.btnNative, {
                        scaleX: 1,
                        scaleY: 1
                    }, 500, null, Laya.Handler.create(that, action));
                }
                idx++;
            };
            action();
        }
        onBtnAd() {
            if (ConfigManager.platform == PLATFORM_TYPE.OPPO || ConfigManager.platform == PLATFORM_TYPE.VIVO) {
                AdUtil.nativeExtendList.ad && AdUtil.nativeExtendList.ad.reportAdClick({
                    adId: AdUtil.nativeExtendList.data.adId.toString()
                });
            }
            if (ConfigManager.platform == PLATFORM_TYPE.VIVO) {
                let that = this;
                AdUtil.preloadNativeAdExtend(function() {}, function() {}, NATIVE_TYPE.BANNER);
            }
        }
        onBtnClose() {
            if (!CommonUtil.getTouch())
                return;
            UIManager.closeFunction();
        }
        refresh() {
            if (!this.isCanRefresh)
                return;
            if (!this.imgAd)
                return;
            if (AdUtil.nativeExtendList.data) {
                AdUtil.hideBannerAd();
                this.isCanAutoShow && this.show();
                ConfigManager.platform != PLATFORM_TYPE.WEB && AdUtil.nativeExtendList.ad && AdUtil.nativeExtendList.ad.reportAdShow({
                    adId: AdUtil.nativeExtendList.data.adId.toString()
                });
                this.imgAd.skin = AdUtil.nativeExtendList.data.imgUrlList[0];
                this.txtTitle.text = AdUtil.nativeExtendList.data.title;
                this.txtContent.text = AdUtil.nativeExtendList.data.desc;
            } else {
                this.autoHide();
            }
        }
        hide() {
            if (this.destroyed)
                return;
            this.isCanAutoShow = false;
            this.mouseEnabled = false;
            this.visible = false;
            if (this.btnNative)
                this.btnNative.visible = false;
        }
        autoHide() {
            this.mouseEnabled = false;
            this.visible = false;
            if (this.btnNative)
                this.btnNative.visible = false;
        }
        show() {
            if (this.destroyed)
                return;
            this.isCanAutoShow = true;
            if (!AdUtil.nativeExtendList.data || !AdUtil.nativeExtendList.data.imgUrlList[0])
                return;
            this.mouseEnabled = true;
            this.visible = true;
            if (this.btnNative)
                this.btnNative.visible = true;
        }
    }

    class NativeInterstitialFunction extends BaseFunction {
        createView() {
            this._viewCtrl = new NativeInterstitialViewCtrl();
            return this._viewCtrl;
        }
        getFunctionName() {
            return '原生插屏界面';
        }
        onEnter() { super.onEnter(); }
        onExit() { super.onExit(); }
        onEnable() {
            super.onEnable();
            this._viewCtrl.visible = true;
        }
        onDisbale() {
            super.onDisbale();
            this._viewCtrl.visible = false;
        }
        setAllButtonAnalysePoint() {}
        request(cb) {
            cb();
        }
    }

    class OPPOGameBoxViewCtrl extends ui.view.gameBox.OPPOGameBoxViewUI {
        constructor() {
            super();
            this.width = this.stage.width;
            this.height = this.stage.height;
        }
        onAwake() {
            this.init();
            this.setBtnEvent();
        }
        onDestroy() {
            OVAdManager.unregisterByFuncId();
        }
        init() {
            OVAdManager.adDown();
            OVAdManager.setAdTypeInNext();
            this.adCtrl();
            this.ani1.play(0, true);
            this.ani2.play(0, true);
        }
        adCtrl() {
            let that = this;
            OVAdManager.register(function() {
                console.log('oppogameBox广告关闭');
                UIManager.closeFunction();
                let score = CharacterManger.playerLogicalBaseLayer ? CharacterManger.playerLogicalBaseLayer.playerKillCount : 2;
                score += 1;
                UIManager.openFunction(FUNCTION_TAG.GET_BOX_REWARD, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE, {
                    itemList: [{
                        itemId: '1001',
                        count: RewardManager.getSeniorBoxReward().gold
                    }, {
                        itemId: '2001',
                        count: RewardManager.getSeniorBoxReward().diamonds
                    }, {
                        itemId: '3001',
                        count: score
                    }, {
                        itemId: '1001',
                        count: Math.floor(RewardManager.getSeniorBoxReward().gold / 3)
                    }]
                });
            });
        }
        setBtnEvent() {
            this.btnOpenSenior.on(Laya.Event.CLICK, this, this.onBtnOpeSenior);
            this.btnOpenPrimary.on(Laya.Event.CLICK, this, this.onBtnOpenPrimary);
        }
        onBtnOpeSenior() {
            if (!CommonUtil.getTouch())
                return;
            let score = CharacterManger.playerLogicalBaseLayer ? CharacterManger.playerLogicalBaseLayer.playerKillCount : 2;
            score += 1;
            AdUtil.setEvent(function() {
                UIManager.closeFunction();
                UIManager.openFunction(FUNCTION_TAG.GET_BOX_REWARD, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE, {
                    itemList: [{
                        itemId: '1001',
                        count: RewardManager.getSeniorBoxReward().gold
                    }, {
                        itemId: '2001',
                        count: RewardManager.getSeniorBoxReward().diamonds
                    }, {
                        itemId: '3001',
                        count: score
                    }, {
                        itemId: '1001',
                        count: Math.floor(RewardManager.getSeniorBoxReward().gold / 3)
                    }]
                });
            }, function() {
                OVAdManager.forceToSetAdType();
            }, REWARD_CTRL_TYPE.BOX_REWARD);
        }
        onBtnOpenPrimary() {
            if (!CommonUtil.getTouch())
                return;
            OVAdManager.execute(function() {
                if (UIManager.getFunction(FUNCTION_TAG.OPPOGAMEBOX))
                    UIManager.openFunction(FUNCTION_TAG.GET_GOLD_REWARD, FUNCTION_OPEN_MODE.REPLACE, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.GOLD, RewardManager.getPrimaryBoxReward().gold);
            }, false, true);
        }
    }

    class OPPOGameBoxFunction extends BaseFunction {
        createView() {
            this._viewCtrl = new OPPOGameBoxViewCtrl();
            return this._viewCtrl;
        }
        getFunctionName() {
            return 'OV结算宝箱界面';
        }
        onEnter() {
            super.onEnter();
            if (ConfigManager.platform == PLATFORM_TYPE.OPPO || ConfigManager.platform == PLATFORM_TYPE.WEB) {
                this.nativeBanner = new NativeBanner3ViewCtrl();
                let view = this._viewCtrl;
                view.boxAll.addChild(this.nativeBanner);
                view.boxAll.addChild(this.nativeBanner.btnAd);
                this.nativeBanner.x = 850.5;
                this.nativeBanner.y = 140;
                this.nativeBanner.btnAd.x = 1050;
                this.nativeBanner.btnAd.y = 550;
            }
        }
        onExit() { super.onExit(); }
        onEnable() {
            super.onEnable();
            this.nativeBanner && this.nativeBanner.show();
        }
        onDisbale() {
            super.onDisbale();
            this.nativeBanner && this.nativeBanner.hide();
        }
        setAllButtonAnalysePoint() {}
        request(cb) {
            cb();
        }
    }

    let LIBRARY_ARM_STATE$1 = {
        EQUIP: 1,
        REMOVE: 2,
    };
    let urlBg$2 = ['sub1/ui/library/img_arm_4.png', 'sub1/ui/library/img_arm_3.png', 'sub1/ui/library/img_arm_2.png', 'sub1/ui/library/img_arm_1.png'];
    class LibraryArmItemCtrl extends ui.view.library.LibraryArmItemUI {
        constructor() {
            super();
            this.armAperture = null;
            this.isCheckNoLocal = false;
            this.createArmAperture(this.btnEquip);
            this.btnDetails.on(Laya.Event.CLICK, this, this.onBtnDetails);
            this.btnEquip.on(Laya.Event.CLICK, this, this.onBtnEquip);
            this.btnRemove.on(Laya.Event.CLICK, this, this.onBtnRemove);
        }
        setView() {
            let data = this.dataSource.data;
            console.log('data:', data);
            this.imgIcon.skin = data.icon;
            let str = '';
            if (RoleManager.getInstance().getEquipHaveTime(data.id)) {
                let time = RoleManager.getInstance().getEquipHaveTime(data.id) - RoleManager.getInstance().getTime();
                if (time > 3600 * 24) {
                    console.log('超过一天到期');
                    str = ' (' + Math.floor(time / (3600 * 24)) + '天)';
                } else {
                    if (time > 3600) {
                        console.log('超过一小时到期');
                        str = ' (' + Math.floor(time / 3600) + '小时)';
                    } else {
                        str = ' (' + Math.floor(time / (60)) + '分钟)';
                    }
                }
            }
            this.imgGrade.skin = RES_PATH.GRADE_UI.GRADE_TAB_ROOT + data.grade + '.png';
            this.txtName.text = data.name + str;
            this.imgBg.skin = urlBg$2[data.grade - 1];
            this.setState();
            let guide = RoleManager.getInstance().getGuide();
            if (GuideManager.curEquiplLibraryStep > guide) {
                guide = GuideManager.curEquiplLibraryStep;
                this.isCheckNoLocal = true;
            }
            if (guide == GuideStep.TOEQUIP) {
                if (this.dataSource.myIndex == 0) {
                    this.armAperture.play(true);
                }
            }
        }
        setState() {
            this.imgEquiped.visible = false;
            this.btnEquip.visible = false;
            this.btnRemove.visible = false;
            if (this.dataSource.state == LIBRARY_ARM_STATE$1.EQUIP) {
                this.btnEquip.visible = true;
            } else if (this.dataSource.state == LIBRARY_ARM_STATE$1.REMOVE) {
                this.imgEquiped.visible = true;
                this.btnRemove.visible = true;
            }
        }
        createArmAperture(parent) {
            if (!this.armAperture) {
                this.armAperture = GuideManager.createCommonAperture(parent);
                this.armAperture.visible = false;
                this.armAperture.anchorX = .5;
                this.armAperture.anchorY = .5;
                this.armAperture.x = parent.width / 2;
                this.armAperture.y = parent.height / 2;
            }
        }
        onBtnDetails() {
            console.log('打开详情');
            UIManager.openFunction(FUNCTION_TAG.DETAIL, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.ALL_SHOW, this.dataSource.data);
        }
        onBtnEquip() {
            this.armAperture.stop();
            this.armAperture.visible = false;
            let guide = RoleManager.getInstance().getGuide();
            console.log('当前格子指引：', GuideManager.curEquiplLibraryStep, guide);
            if (GuideManager.curEquiplLibraryStep == GuideStep.TOEQUIP || guide == GuideStep.TOEQUIP) {
                if (guide < GuideStep.FINISH && RoleManager.getInstance().isNew) {
                    UIManager.getFunctionViewCtrl(FUNCTION_TAG.LIBRARY).setGuideByCell();
                }
            }
            let isArm = true;
            let view = UIManager.getFunctionViewCtrl(FUNCTION_TAG.LIBRARY);
            console.log(view.curListInBottom);
            console.log('当前单元格：', UIManager.getFunctionViewCtrl(FUNCTION_TAG.LIBRARY).index);
            if (this.dataSource.data.type == 2 || this.dataSource.data.type == 8) {
                RoleManager.getInstance().updateSkinGameCurPropLib(this.dataSource.data.id);
                isArm = false;
            } else {
                let lastId = null;
                if (view.curListInBottom[view.index]) {
                    lastId = view.curListInBottom[view.index];
                }
                RoleManager.getInstance().updateSkinGameCurLib(this.dataSource.data.id, lastId);
                RoleManager.getInstance().setSelectSkin(this.dataSource.data.id);
            }
            this.dataSource.state = LIBRARY_ARM_STATE$1.REMOVE;
            this.setView();
            UIManager.getFunctionViewCtrl(FUNCTION_TAG.LIBRARY).updateBottomArm();
            UIManager.getFunctionViewCtrl(FUNCTION_TAG.LIBRARY).btnCtrlRight(this.dataSource.data.id, isArm);
            UIManager.getFunctionViewCtrl(FUNCTION_TAG.LIBRARY).showRoleModel(RoleManager.getInstance().getSelectRoleSkin(), this.dataSource.data.id);
        }
        onBtnRemove() {
            let list = (this.dataSource.data.type == 2 || this.dataSource.data.type == 8) ? RoleManager.getInstance().getGameCurPropLib() : RoleManager.getInstance().getSkinGameCurLib();
            if (list.length == 1) {
                if ((this.dataSource.data.type == 2 || this.dataSource.data.type == 8)) {} else {
                    LogManager.showNotificationClick('至少携带一把主武器');
                    return;
                }
            }
            for (let k = 0; k < list.length; k++) {
                if (list[k] == this.dataSource.data.id) {
                    list.splice(k, 1);
                }
            }
            let isArm = true;
            if (this.dataSource.data.type == 2 || this.dataSource.data.type == 8) {
                RoleManager.getInstance().removeSkinGameCurPropLib(list);
                isArm = false;
            } else {
                RoleManager.getInstance().removeSkinGameCurLib(list);
            }
            this.dataSource.state = LIBRARY_ARM_STATE$1.EQUIP;
            this.setView();
            UIManager.getFunctionViewCtrl(FUNCTION_TAG.LIBRARY).updateBottomArm();
            UIManager.getFunctionViewCtrl(FUNCTION_TAG.LIBRARY).btnCtrlRight(this.dataSource.data.id, isArm);
            UIManager.getFunctionViewCtrl(FUNCTION_TAG.LIBRARY).showRoleModel(RoleManager.getInstance().getSelectRoleSkin());
        }
    }

    var LIBRARY_PARTS_STATE;
    (function(LIBRARY_PARTS_STATE) {
        LIBRARY_PARTS_STATE[LIBRARY_PARTS_STATE["UNLOCK_NORMAL"] = 1] = "UNLOCK_NORMAL";
        LIBRARY_PARTS_STATE[LIBRARY_PARTS_STATE["UNLOCK_SELECT"] = 2] = "UNLOCK_SELECT";
        LIBRARY_PARTS_STATE[LIBRARY_PARTS_STATE["LOCK_NORMAL"] = 3] = "LOCK_NORMAL";
        LIBRARY_PARTS_STATE[LIBRARY_PARTS_STATE["LOCK_SELECT"] = 4] = "LOCK_SELECT";
        LIBRARY_PARTS_STATE[LIBRARY_PARTS_STATE["USE_NORMAL"] = 5] = "USE_NORMAL";
        LIBRARY_PARTS_STATE[LIBRARY_PARTS_STATE["USE_SELECT"] = 6] = "USE_SELECT";
    })(LIBRARY_PARTS_STATE || (LIBRARY_PARTS_STATE = {}));
    class LibraryPartsItemCtrl extends ui.view.library.LibraryPartsItemUI {
        constructor() {
            super();
            this.myIndex = 0;
            this.btnUse.on(Laya.Event.CLICK, this, this.onBtnUse);
            this.btnBuy.on(Laya.Event.CLICK, this, this.onBtnBuy);
            this.btnAd.on(Laya.Event.CLICK, this, this.onBtnAd);
            this.btnRemove.on(Laya.Event.CLICK, this, this.onBtnRemove);
            this.btnBox.on(Laya.Event.CLICK, this, this.select);
            this.uiPlatformConfig();
        }
        onBtnUse() {
            if (!CommonUtil.getTouch())
                return;
            console.log('点击使用');
            UIManager.getFunctionViewCtrl(FUNCTION_TAG.LIBRARY).useParts(this.myIndex);
        }
        onBtnRemove() {
            if (!CommonUtil.getTouch())
                return;
            UIManager.getFunctionViewCtrl(FUNCTION_TAG.LIBRARY).removePart(this.myIndex);
        }
        select() {
            console.log('点击选择');
            UIManager.getFunctionViewCtrl(FUNCTION_TAG.LIBRARY).onPartSelectSkin(this.myIndex);
        }
        onBtnBuy() {
            if (!CommonUtil.getTouch())
                return;
            if (this.dataSource.costType == 1) {
                if (RoleManager.getInstance().costGold(this.dataSource.cost)) {
                    LogManager.showNotification('购买成功');
                    UIManager.getFunctionViewCtrl(FUNCTION_TAG.LIBRARY).buyParts(this.myIndex);
                } else {
                    UIManager.openFunction(FUNCTION_TAG.ADD_GOLD, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.WINDOW, COMMON_MENU_STYLE.GOLD, 1);
                }
            } else if (this.dataSource.costType == 2) {
                if (RoleManager.getInstance().costDiamond(this.dataSource.cost)) {
                    LogManager.showNotification('购买成功');
                    UIManager.getFunctionViewCtrl(FUNCTION_TAG.LIBRARY).buyParts(this.myIndex);
                } else {
                    UIManager.openFunction(FUNCTION_TAG.ADD_DIAMONDS, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.WINDOW, COMMON_MENU_STYLE.DIAMOND, 1);
                }
            }
        }
        setView(index) {
            if (this.dataSource.costType == 1) {
                this.img_costType.skin = 'sub1/ui/common/img_3.png';
            } else if (this.dataSource.costType == 2) {
                this.img_costType.skin = 'sub1/ui/common/img_4.png';
            }
            this.imgGrade.skin = RES_PATH.GRADE_UI.GRADE_TAB_ROOT + this.dataSource.grade + '.png';
            this.imgGradeBg.skin = RES_PATH.GRADE_UI.GRADE_BG_ROOT + this.dataSource.grade + '.png';
            this.imgGradeBottom.skin = RES_PATH.GRADE_UI.GRADE_BG_BOTTOM_ROOT + this.dataSource.grade + '.png';
            this.imgDebris.skin = urlDebris[this.dataSource.grade - 1];
            if (this.dataSource.activityType == 1) {
                this.img_NewYearTag.visible = false;
            } else if (this.dataSource.activityType == 2) {
                this.img_NewYearTag.visible = true;
            }
            this.txtName.text = this.dataSource.roleName;
            this.imgIcon.skin = this.dataSource.url;
            this.myIndex = index;
            this.txtCost.text = this.dataSource.cost.toString();
            this.setState();
        }
        mySelect(isUse) {
            if (this.dataSource.state == LIBRARY_PARTS_STATE.LOCK_NORMAL) {
                this.dataSource.state = LIBRARY_PARTS_STATE.LOCK_SELECT;
            } else if (this.dataSource.state == LIBRARY_PARTS_STATE.UNLOCK_NORMAL) {
                this.dataSource.state = LIBRARY_PARTS_STATE.UNLOCK_SELECT;
            } else if (this.dataSource.state == LIBRARY_PARTS_STATE.UNLOCK_SELECT) {
                if (isUse) {
                    this.dataSource.state = LIBRARY_PARTS_STATE.USE_SELECT;
                } else {
                    this.dataSource.state = LIBRARY_PARTS_STATE.USE_NORMAL;
                }
            } else if (this.dataSource.state == LIBRARY_PARTS_STATE.USE_NORMAL) {
                this.dataSource.state = LIBRARY_PARTS_STATE.USE_SELECT;
            }
            this.setState();
        }
        setState() {
            this.imgSelect.visible = false;
            this.btnUse.disabled = false;
            this.btnBuy.visible = false;
            this.btnUse.visible = false;
            this.imgUsing.visible = false;
            this.boxCost.visible = false;
            this.btnRemove.visible = false;
            this.btnAd.visible = false;
            this.boxDebris.visible = false;
            switch (this.dataSource.state) {
                case LIBRARY_PARTS_STATE.UNLOCK_NORMAL:
                    {
                        this.btnUse.visible = true;
                        break;
                    }
                case LIBRARY_PARTS_STATE.UNLOCK_SELECT:
                    {
                        this.imgSelect.visible = true;
                        this.btnUse.visible = true;
                        break;
                    }
                case LIBRARY_PARTS_STATE.LOCK_NORMAL:
                    {
                        if (this.dataSource.costType == 3) {
                            this.boxDebris.visible = true;
                            this.btnAd.visible = true;
                            let id = this.dataSource.id;
                            let itemId = ITEM_TYPE.PART_DEBRIS.toString() + (id > 99 ? id : id > 9 ? '0' + id : '00' + id);
                            let count = RoleManager.getInstance().getTargetFragment({
                                type: ITEM_TYPE.PART_DEBRIS,
                                id: itemId
                            });
                            this.labelDebrisAll.text = ' /' + this.dataSource.cost + ')';
                            this.labelDebris.text = count.toString();
                            if (count == 0) {
                                this.labelDebris.color = '#FF2A20';
                            } else {
                                this.labelDebris.color = '#ffffff';
                            }
                        } else {
                            this.btnBuy.visible = true;
                            this.boxCost.visible = true;
                        }
                        break;
                    }
                case LIBRARY_PARTS_STATE.LOCK_SELECT:
                    {
                        this.imgSelect.visible = true;
                        if (this.dataSource.costType == 3) {
                            this.boxDebris.visible = true;
                            this.btnAd.visible = true;
                            let id = this.dataSource.id;
                            let itemId = ITEM_TYPE.PART_DEBRIS.toString() + (id > 99 ? id : id > 9 ? '0' + id : '00' + id);
                            let count = RoleManager.getInstance().getTargetFragment({
                                type: ITEM_TYPE.PART_DEBRIS,
                                id: itemId
                            });
                            this.labelDebrisAll.text = ' /' + this.dataSource.cost + ')';
                            this.labelDebris.text = count.toString();
                            if (count == 0) {
                                this.labelDebris.color = '#FF2A20';
                            } else {
                                this.labelDebris.color = '#ffffff';
                            }
                        } else {
                            this.btnBuy.visible = true;
                            this.boxCost.visible = true;
                        }
                        break;
                    }
                case LIBRARY_PARTS_STATE.USE_NORMAL:
                    {
                        this.imgUsing.visible = true;
                        this.btnRemove.visible = true;
                        break;
                    }
                case LIBRARY_PARTS_STATE.USE_SELECT:
                    {
                        this.imgSelect.visible = true;
                        this.imgUsing.visible = true;
                        this.btnRemove.visible = true;
                        break;
                    }
            }
        }
        uiPlatformConfig() {
            UIManager.replaceAdIcon([{
                img: this.btnAd.getChildAt(1),
                type: 1
            }]);
        }
        onBtnAd() {
            if (!CommonUtil.getTouch(500))
                return;
            AdUtil.setEvent(() => {
                UIManager.getFunctionViewCtrl(FUNCTION_TAG.LIBRARY).buyPartDebris(this.myIndex);
            }, function() {}, REWARD_CTRL_TYPE.GET_DEBRIS);
        }
    }

    var LIBRARY_ROLE_STATE;
    (function(LIBRARY_ROLE_STATE) {
        LIBRARY_ROLE_STATE[LIBRARY_ROLE_STATE["UNLOCK_NORMAL"] = 1] = "UNLOCK_NORMAL";
        LIBRARY_ROLE_STATE[LIBRARY_ROLE_STATE["UNLOCK_SELECT"] = 2] = "UNLOCK_SELECT";
        LIBRARY_ROLE_STATE[LIBRARY_ROLE_STATE["LOCK_NORMAL"] = 3] = "LOCK_NORMAL";
        LIBRARY_ROLE_STATE[LIBRARY_ROLE_STATE["LOCK_SELECT"] = 4] = "LOCK_SELECT";
        LIBRARY_ROLE_STATE[LIBRARY_ROLE_STATE["USE_NORMAL"] = 5] = "USE_NORMAL";
        LIBRARY_ROLE_STATE[LIBRARY_ROLE_STATE["USE_SELECT"] = 6] = "USE_SELECT";
    })(LIBRARY_ROLE_STATE || (LIBRARY_ROLE_STATE = {}));
    class LibraryRoleItemCtrl extends ui.view.library.LibraryRoleItemUI {
        constructor() {
            super();
            this.myIndex = 0;
            this.btnUse.on(Laya.Event.CLICK, this, this.onBtnUse);
            this.btnBuy.on(Laya.Event.CLICK, this, this.onBtnBuy);
            this.btnAd.on(Laya.Event.CLICK, this, this.onBtnAd);
            this.uiPlatformConfig();
        }
        onBtnUse() {
            if (!CommonUtil.getTouch())
                return;
            UIManager.getFunctionViewCtrl(FUNCTION_TAG.LIBRARY).useRole(this.myIndex);
        }
        onBtnBuy() {
            if (!CommonUtil.getTouch())
                return;
            if (this.dataSource.costType == 1) {
                if (RoleManager.getInstance().costGold(this.dataSource.cost)) {
                    LogManager.showNotification('购买成功');
                    UIManager.getFunctionViewCtrl(FUNCTION_TAG.LIBRARY).buyRole(this.myIndex);
                } else {
                    UIManager.openFunction(FUNCTION_TAG.ADD_GOLD, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.WINDOW, COMMON_MENU_STYLE.GOLD, 1);
                }
            } else if (this.dataSource.costType == 2) {
                if (RoleManager.getInstance().costDiamond(this.dataSource.cost)) {
                    LogManager.showNotification('购买成功');
                    UIManager.getFunctionViewCtrl(FUNCTION_TAG.LIBRARY).buyRole(this.myIndex);
                } else {
                    UIManager.openFunction(FUNCTION_TAG.ADD_DIAMONDS, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.WINDOW, COMMON_MENU_STYLE.DIAMOND, 1);
                }
            }
        }
        onBtnAd() {
            if (!CommonUtil.getTouch(500))
                return;
            AdUtil.setEvent(() => {
                UIManager.getFunctionViewCtrl(FUNCTION_TAG.LIBRARY).buyRoleDebris(this.myIndex);
            }, function() {}, REWARD_CTRL_TYPE.GET_DEBRIS);
        }
        setView(index) {
            if (this.dataSource.costType == 1) {
                this.img_costType.skin = 'sub1/ui/common/img_3.png';
            } else if (this.dataSource.costType == 2) {
                this.img_costType.skin = 'sub1/ui/common/img_4.png';
            }
            this.imgGrade.skin = RES_PATH.GRADE_UI.GRADE_TAB_ROOT + this.dataSource.grade + '.png';
            this.imgGradeBg.skin = RES_PATH.GRADE_UI.GRADE_BG_ROOT + this.dataSource.grade + '.png';
            this.imgGradeBottom.skin = RES_PATH.GRADE_UI.GRADE_BG_BOTTOM_ROOT + this.dataSource.grade + '.png';
            this.imgDebris.skin = urlDebris[this.dataSource.grade - 1];
            if (this.dataSource.activityType == 1) {
                this.img_NewYearTag.visible = false;
            } else if (this.dataSource.activityType == 2) {
                this.img_NewYearTag.visible = true;
            }
            this.txtName.text = this.dataSource.roleName;
            this.imgIcon.skin = this.dataSource.url;
            this.myIndex = index;
            this.txtCost.text = this.dataSource.cost.toString();
            this.setState();
        }
        mySelect(isUse) {
            if (this.dataSource.state == LIBRARY_ROLE_STATE.LOCK_NORMAL) {
                this.dataSource.state = LIBRARY_ROLE_STATE.LOCK_SELECT;
            } else if (this.dataSource.state == LIBRARY_ROLE_STATE.UNLOCK_NORMAL) {
                this.dataSource.state = LIBRARY_ROLE_STATE.UNLOCK_SELECT;
            } else if (this.dataSource.state == LIBRARY_ROLE_STATE.UNLOCK_SELECT) {
                if (isUse) {
                    this.dataSource.state = LIBRARY_ROLE_STATE.USE_SELECT;
                } else {
                    this.dataSource.state = LIBRARY_ROLE_STATE.USE_NORMAL;
                }
            } else if (this.dataSource.state == LIBRARY_ROLE_STATE.USE_NORMAL) {
                this.dataSource.state = LIBRARY_ROLE_STATE.USE_SELECT;
            }
            this.setState();
        }
        setState() {
            console.log('this.dataSource:', this.dataSource);
            this.imgSelect.visible = false;
            this.btnUse.disabled = false;
            this.btnBuy.visible = false;
            this.btnUse.visible = false;
            this.imgUsing.visible = false;
            this.boxCost.visible = false;
            this.boxDebris.visible = false;
            this.btnAd.visible = false;
            switch (this.dataSource.state) {
                case LIBRARY_ROLE_STATE.UNLOCK_NORMAL:
                    {
                        this.btnUse.visible = true;
                        break;
                    }
                case LIBRARY_ROLE_STATE.UNLOCK_SELECT:
                    {
                        this.imgSelect.visible = true;
                        this.btnUse.visible = true;
                        break;
                    }
                case LIBRARY_ROLE_STATE.LOCK_NORMAL:
                    {
                        if (this.dataSource.costType == 3) {
                            this.boxDebris.visible = true;
                            this.btnAd.visible = true;
                            let id = this.dataSource.id;
                            let itemId = ITEM_TYPE.HERO_DEBRIS.toString() + (id > 99 ? id : id > 9 ? '0' + id : '00' + id);
                            let count = RoleManager.getInstance().getTargetFragment({
                                type: ITEM_TYPE.HERO_DEBRIS,
                                id: itemId
                            });
                            this.labelDebrisAll.text = ' /' + this.dataSource.cost + ')';
                            this.labelDebris.text = count.toString();
                            if (count == 0) {
                                this.labelDebris.color = '#FF2A20';
                            } else {
                                this.labelDebris.color = '#ffffff';
                            }
                        } else {
                            this.btnBuy.visible = true;
                            this.boxCost.visible = true;
                        }
                        break;
                    }
                case LIBRARY_ROLE_STATE.LOCK_SELECT:
                    {
                        this.imgSelect.visible = true;
                        if (this.dataSource.costType == 3) {
                            this.boxDebris.visible = true;
                            this.btnAd.visible = true;
                            let id = this.dataSource.id;
                            let itemId = ITEM_TYPE.HERO_DEBRIS.toString() + (id > 99 ? id : id > 9 ? '0' + id : '00' + id);
                            let count = RoleManager.getInstance().getTargetFragment({
                                type: ITEM_TYPE.HERO_DEBRIS,
                                id: itemId
                            });
                            this.labelDebrisAll.text = ' /' + this.dataSource.cost + ')';
                            this.labelDebris.text = count.toString();
                            if (count == 0) {
                                this.labelDebris.color = '#FF2A20';
                            } else {
                                this.labelDebris.color = '#ffffff';
                            }
                        } else {
                            this.btnBuy.visible = true;
                            this.boxCost.visible = true;
                        }
                        break;
                    }
                case LIBRARY_ROLE_STATE.USE_NORMAL:
                    {
                        this.btnUse.visible = true;
                        this.imgUsing.visible = true;
                        this.btnUse.disabled = true;
                        break;
                    }
                case LIBRARY_ROLE_STATE.USE_SELECT:
                    {
                        this.imgSelect.visible = true;
                        this.btnUse.visible = true;
                        this.imgUsing.visible = true;
                        this.btnUse.disabled = true;
                        break;
                    }
            }
        }
        uiPlatformConfig() {
            UIManager.replaceAdIcon([{
                img: this.btnAd.getChildAt(1),
                type: 1
            }]);
        }
    }

    let BTNTYPE$1 = [1, 2, 3];
    let ARM_KIND$1 = {
        RIFLE: 'RIFLE',
        CHARGE: 'CHARGE',
        SNIPER: 'SNIPER',
        SHRAPNEL: 'SHRAPNEL',
        PISTOL: 'PISTOL',
        MACHINE: 'MACHINE',
        OTHER: 'OTHER',
        WAISTDECORATIONS: 'WAISTDECORATIONS',
        WING: 'WING',
    };
    let TRYTYPE = {
        ROLE: 1,
        PARTS: 0
    };
    let OPEN_VIEW = {
        ARM: 'ARM',
        ROLE: 'ROLE',
        PARTS: 'PARTS'
    };
    class LibraryViewCtrl extends ui.view.library.LibraryViewUI {
        constructor() {
            super();
            this.armType = 'RIFLE';
            this.index = 0;
            this.curListInBottom = [];
            this.scene3D = null;
            this._translate2 = new Laya.Vector3(5, -10, 1);
            this._translate = new Laya.Vector3(0, 0, 0);
            this.sp = null;
            this._pos = new Laya.Vector3(310, 500, 0);
            this.rotMouseX = 0;
            this.curOpenView = 'ARM';
            this.curRole = null;
            this.isCheckNoLocal = false;
            this.closeAperture = null;
            this.curID = 1;
            this.curTryType = 1;
            this.curBtnType = 1;
            this.myIndex = 1;
            this.isrefresh = false;
            this.isFirstEnable = true;
            this.isMouseDown = false;
            this.width = this.stage.width;
            this.height = this.stage.height;
        }
        onAwake() {
            this.createArmAperture(this.btnBack);
            let guide = RoleManager.getInstance().getGuide();
            if (GuideManager.curEquiplLibraryStep == 5) {
                GuideManager.curEquiplLibraryStep++;
            }
            if (guide == 5) {
                RoleManager.getInstance().setGuide();
            }
            if (GuideManager.curEquiplLibraryStep == 7) {
                GuideManager.curEquiplLibraryStep = 6;
            }
            if (guide == 7) {
                RoleManager.getInstance().setGuide(6);
            }
            this.setPlatformStyle();
            this.init();
            this.setBtnEvent();
            this.setGuide();
        }
        onDestroy() {}
        createArmAperture(parent) {
            if (!this.closeAperture) {
                this.closeAperture = GuideManager.createCommonAperture(parent);
                this.closeAperture.visible = false;
                this.closeAperture.anchorX = .5;
                this.closeAperture.anchorY = .5;
                this.closeAperture.x = parent.width / 2;
                this.closeAperture.y = parent.height / 2;
            }
        }
        setGuide() {
            let guide = RoleManager.getInstance().getGuide();
            if (GuideManager.curEquiplLibraryStep > guide) {
                guide = GuideManager.curEquiplLibraryStep;
                this.isCheckNoLocal = true;
            }
            switch (guide) {
                case GuideStep.CHOOSEARM:
                    if (GuideManager.curEquiplLibraryStep == 6) {
                        GuideManager.curEquiplLibraryStep++;
                    }
                    if (guide == 6) {
                        RoleManager.getInstance().setGuide();
                    }
                    this.setGuide();
                    break;
                case GuideStep.TOEQUIP:
                    console.log('去装备');
                    this.onBtnCharge();
                    break;
            }
        }
        init() {
            let max = RoleManager.getInstance().getSkinGameCurLib()[0];
            for (let k = 0; k < RoleManager.getInstance().getSkinGameCurLib().length; k++) {
                if (max < RoleManager.getInstance().getSkinGameCurLib()[k]) {
                    max = RoleManager.getInstance().getSkinGameCurLib()[k];
                }
            }
            RoleManager.getInstance().setSelectSkin(max);
            this.viewCtrl();
            this.setRoleData();
            this.getArmListType();
            this.setData(this.armType, true);
            this.setPartData(true);
            this.create3D();
        }
        viewCtrl() {
            this.btnArm.skin = RES_PATH.LIBRARY_UI.LEFT_BTN_UI.TOUCH;
            this.btnRole.skin = RES_PATH.LIBRARY_UI.LEFT_BTN_UI.TOUCH;
            this.btnParts.skin = RES_PATH.LIBRARY_UI.LEFT_BTN_UI.TOUCH;
            this.boxArm.visible = false;
            this.boxRole.visible = false;
            this.boxParts.visible = false;
            if (this.curOpenView == OPEN_VIEW.ARM) {
                this.btnArm.skin = RES_PATH.LIBRARY_UI.LEFT_BTN_UI.TOUCHED;
                this.boxArm.visible = true;
            } else if (this.curOpenView == OPEN_VIEW.ROLE) {
                this.btnRole.skin = RES_PATH.LIBRARY_UI.LEFT_BTN_UI.TOUCHED;
                this.boxRole.visible = true;
            } else if (this.curOpenView == OPEN_VIEW.PARTS) {
                this.btnParts.skin = RES_PATH.LIBRARY_UI.LEFT_BTN_UI.TOUCHED;
                this.boxParts.visible = true;
            }
        }
        create3D() {
            var scene = this.addChild(new Laya.Scene3D());
            var camera = scene.addChild(new Laya.Camera(0, 0.1, 1000));
            this.scene3D = scene;
            camera.transform.translate(this._translate2);
            camera.orthographic = true;
            camera.enableHDR = false;
            camera.clearColor = new Laya.Vector4(0.0, 0.0, 0.0, 0.0);
            var renderTexture = new Laya.RenderTexture(1024, 1024, Laya.RenderTextureFormat.R8G8B8A8, Laya.RenderTextureDepthFormat.DEPTH_16);
            camera.renderTarget = renderTexture;
            camera.orthographicVerticalSize = 10;
            scene.addChild(new Laya.DirectionLight());
            camera.convertScreenCoordToOrthographicCoord(this._pos, this._translate);
            this._translate.x += 3;
            this._translate.y -= 2.2;
            this.img3DCenter.source = new Laya.Texture(renderTexture);
            this.showRoleModel(RoleManager.getInstance().getSelectRoleSkin());
            this.showModel(RoleManager.getInstance().getSelectSkin(), 0);
        }
        showRoleModel(id, armID = null) {
            if (this.sp) {
                this.sp.destroy();
                this.sp = null;
            }
            this.sp = SkinManager.createRoleViewSkin(this._translate, this.scene3D, false, id);
            this.sp.transform.localRotationEulerY = 90;
            Laya.Tween.to(this.sp.transform, {
                localRotationEulerY: 20
            }, 300);
            this.sp.transform.localPositionY -= 1;
            this.sp.transform.localPositionX -= 0.3;
            this.sp.transform.localScaleX = 5.4;
            this.sp.transform.localScaleY = 4.6;
            this.sp.transform.localScaleZ = 4.9;
            let arm = armID ? armID : RoleManager.getInstance().getSelectSkin();
            let obj = SkinManager.createMenuArm(arm, this.sp);
            obj.transform.localScaleX = 0.9;
            obj.transform.localScaleY = 0.9;
            obj.transform.localScaleZ = 0.9;
            SkinManager.createPartsByLocal(this.sp, new Laya.Vector3(1, 1, 1));
        }
        showModel(id, armType) {
            let obj = SkinManager.createMenuArm(id, this.sp, armType);
            obj.transform.localScaleX = 0.9;
            obj.transform.localScaleY = 0.9;
            obj.transform.localScaleZ = 0.9;
        }
        setBtnEvent() {
            this.bottomCtrl();
            this.btnArm.on(Laya.Event.CLICK, this, this.onBtnArm);
            this.btnBack.on(Laya.Event.CLICK, this, this.onBtnBack);
            this.btnBottomBack.on(Laya.Event.CLICK, this, this.onBtnBottomBack);
            this.btnBottomOpen.on(Laya.Event.CLICK, this, this.onBtnBottomOpen);
            this.btnCharge.on(Laya.Event.CLICK, this, this.onBtnCharge);
            this.btnOther.on(Laya.Event.CLICK, this, this.onBtnOther);
            this.btnPistol.on(Laya.Event.CLICK, this, this.onBtnPistol);
            this.btnRifle.on(Laya.Event.CLICK, this, this.onBtnRifle);
            this.btnRole.on(Laya.Event.CLICK, this, this.onBtnRole);
            this.btnParts.on(Laya.Event.CLICK, this, this.onBtnParts);
            this.btnSniper.on(Laya.Event.CLICK, this, this.onBtnSniper);
            this.btnShrapnel.on(Laya.Event.CLICK, this, this.onBtnShrapnel);
            this.btnMachine.on(Laya.Event.CLICK, this, this.onBtnMachine);
            this.btnWaistDecorations.on(Laya.Event.CLICK, this, this.onBtnWaistDecorations);
            this.btnWing.on(Laya.Event.CLICK, this, this.onBtnWing);
            this.btnTry.on(Laya.Event.CLICK, this, this.onBtnTry);
            this.on(Laya.Event.MOUSE_DOWN, this, this.onBtnMouseDown);
            this.on(Laya.Event.MOUSE_UP, this, this.onBtnMouseUp);
            this.on(Laya.Event.MOUSE_MOVE, this, this.onBtnRot);
        }
        onBtnMouseUp() {
            this.isMouseDown = false;
        }
        onBtnMouseDown(e) {
            this.isMouseDown = true;
            this.rotMouseX = e.stageX;
        }
        onBtnTry() {
            if (!CommonUtil.getTouch())
                return;
            let modelType = this.curTryType;
            let id = this.curID;
            UIManager.openFunction(FUNCTION_TAG.ROLETRY, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.WINDOW, COMMON_MENU_STYLE.HIDE, {
                modelType: modelType,
                id: id
            });
        }
        onBtnRot(e) {
            if (this.isMouseDown)
                if (this.sp) {
                    let fac = e.stageX - this.rotMouseX;
                    this.sp.transform.localRotationEulerY += fac * 0.4;
                    this.rotMouseX = e.stageX;
                }
        }
        bottomCtrl() {
            for (let k = 0; k < this.bottomArm.numChildren; k++) {
                let item = this.bottomArm.getChildAt(k);
                item.on(Laya.Event.CLICK, this, this.onBtnItem);
            }
            this.updateBottomArm();
            let id = RoleManager.getInstance().getUseEquip();
            let k = 0;
            for (let index = 0; index < this.curListInBottom.length; index++) {
                const element = this.curListInBottom[index];
                if (element == id) {
                    k = index;
                }
            }
            this.index = k;
            this.updateBottomArm();
        }
        onBtnItem(e) {
            if (e.target.name == 'arm1') {
                this.index = 0;
                let id = this.curListInBottom[this.index];
                if (id != -1) {
                    this.btnCtrlRight(id, true);
                    this.showModel(id, 0);
                    RoleManager.getInstance().setSelectSkin(id);
                }
            } else if (e.target.name == 'arm2') {
                this.index = 1;
                let id = this.curListInBottom[this.index];
                if (id != -1) {
                    this.btnCtrlRight(id, true);
                    this.showModel(id, 0);
                    RoleManager.getInstance().setSelectSkin(id);
                }
            } else if (e.target.name == 'other1') {
                this.index = 2;
                let id = this.curListInBottom[this.index];
                if (id != -1) {
                    this.btnCtrlRight(id, false);
                    this.showModel(id, 1);
                }
            } else if (e.target.name == 'other2') {
                this.index = 3;
                let id = this.curListInBottom[this.index];
                if (id != -1) {
                    this.btnCtrlRight(id, false);
                    this.showModel(id, 1);
                }
            }
            this.updateBottomArm();
        }
        btnCtrlRight(id, isArm = true) {
            if (isArm) {
                if (ARM.getDataByKey(id).type == 1) {
                    this.armType = ARM_KIND$1.RIFLE;
                } else if (ARM.getDataByKey(id).type == 3) {
                    this.armType = ARM_KIND$1.SNIPER;
                } else if (ARM.getDataByKey(id).type == 4) {
                    this.armType = ARM_KIND$1.PISTOL;
                } else if (ARM.getDataByKey(id).type == 5) {
                    this.armType = ARM_KIND$1.CHARGE;
                } else if (ARM.getDataByKey(id).type == 6) {
                    this.armType = ARM_KIND$1.MACHINE;
                } else if (ARM.getDataByKey(id).type == 7) {
                    this.armType = ARM_KIND$1.SHRAPNEL;
                }
            } else {
                this.armType = ARM_KIND$1.OTHER;
            }
            this.setData(this.armType, false);
        }
        setTryBtn(skin) {
            this.imgType.skin = skin;
        }
        updateBottomArm() {
            this.curListInBottom = [];
            let armGaming = RoleManager.getInstance().getSkinGameCurLib();
            let propGaming = RoleManager.getInstance().getGameCurPropLib();
            for (let k = 0; k < this.bottomArm.numChildren; k++) {
                let item = this.bottomArm.getChildAt(k);
                let imgIcon = item.getChildByName('imgIcon');
                let imgSelect = item.getChildByName('imgSelect');
                imgSelect.visible = false;
                if (k == 0) {
                    imgIcon.skin = ARM.getDataByKey(armGaming[0]).icon;
                    this.curListInBottom.push(ARM.getDataByKey(armGaming[0]).id);
                    imgIcon.scale(0.8, 0.8);
                } else if (k == 1) {
                    if (armGaming.length == 1) {
                        imgIcon.skin = 'sub1/ui/library/img_5.png';
                        this.curListInBottom.push(-1);
                        imgIcon.scale(1, 1);
                    } else {
                        imgIcon.skin = ARM.getDataByKey(armGaming[1]).icon;
                        this.curListInBottom.push(ARM.getDataByKey(armGaming[1]).id);
                        imgIcon.scale(0.8, 0.8);
                    }
                } else if (k == 2) {
                    let isHas = false;
                    for (let k = 0; k < propGaming.length; k++) {
                        let item = PROP.getDataByKey(propGaming[k]);
                        if (item.type == 2) {
                            imgIcon.skin = item.icon;
                            imgIcon.scale(0.8, 0.8);
                            this.curListInBottom.push(item.id);
                            isHas = true;
                        }
                    }
                    if (!isHas) {
                        this.curListInBottom.push(-1);
                        imgIcon.skin = 'sub1/ui/library/img_7.png';
                        imgIcon.scale(1, 1);
                    }
                } else if (k == 3) {
                    let isHas = false;
                    for (let k = 0; k < propGaming.length; k++) {
                        let item = PROP.getDataByKey(propGaming[k]);
                        if (item.type == 8) {
                            imgIcon.skin = item.icon;
                            imgIcon.scale(0.8, 0.8);
                            this.curListInBottom.push(item.id);
                            isHas = true;
                        }
                    }
                    if (!isHas) {
                        this.curListInBottom.push(-1);
                        imgIcon.skin = 'sub1/ui/library/img_6.png';
                        imgIcon.scale(1, 1);
                    }
                }
                if (this.index == k) {
                    imgSelect.visible = true;
                } else {
                    imgSelect.visible = false;
                }
            }
        }
        setData(target = ARM_KIND$1.RIFLE, isFirst = false) {
            this.armType = target;
            this.rightBtn(target);
            if (target != ARM_KIND$1.WAISTDECORATIONS && target != ARM_KIND$1.WING) {
                this.updateData(isFirst);
            }
        }
        rightBtn(target = ARM_KIND$1.RIFLE) {
            if (target != ARM_KIND$1.WAISTDECORATIONS && target != ARM_KIND$1.WING) {
                this.btnRifle.getChildAt(0).skin = RES_PATH.LIBRARY_UI.RIGHT_BTN_UI.TOUCH;
                this.btnCharge.getChildAt(0).skin = RES_PATH.LIBRARY_UI.RIGHT_BTN_UI.TOUCH;
                this.btnSniper.getChildAt(0).skin = RES_PATH.LIBRARY_UI.RIGHT_BTN_UI.TOUCH;
                this.btnShrapnel.getChildAt(0).skin = RES_PATH.LIBRARY_UI.RIGHT_BTN_UI.TOUCH;
                this.btnPistol.getChildAt(0).skin = RES_PATH.LIBRARY_UI.RIGHT_BTN_UI.TOUCH;
                this.btnMachine.getChildAt(0).skin = RES_PATH.LIBRARY_UI.RIGHT_BTN_UI.TOUCH;
                this.btnOther.getChildAt(0).skin = RES_PATH.LIBRARY_UI.RIGHT_BTN_UI.TOUCH;
            } else {
                this.btnWaistDecorations.getChildAt(0).skin = RES_PATH.LIBRARY_UI.RIGHT_BTN_UI.TOUCH;
                this.btnWing.getChildAt(0).skin = RES_PATH.LIBRARY_UI.RIGHT_BTN_UI.TOUCH;
            }
            if (target == ARM_KIND$1.RIFLE) {
                this.btnRifle.getChildAt(0).skin = RES_PATH.LIBRARY_UI.RIGHT_BTN_UI.TOUCHED;
            } else if (target == ARM_KIND$1.CHARGE) {
                this.btnCharge.getChildAt(0).skin = RES_PATH.LIBRARY_UI.RIGHT_BTN_UI.TOUCHED;
            } else if (target == ARM_KIND$1.OTHER) {
                this.btnOther.getChildAt(0).skin = RES_PATH.LIBRARY_UI.RIGHT_BTN_UI.TOUCHED;
            } else if (target == ARM_KIND$1.PISTOL) {
                this.btnPistol.getChildAt(0).skin = RES_PATH.LIBRARY_UI.RIGHT_BTN_UI.TOUCHED;
            } else if (target == ARM_KIND$1.SHRAPNEL) {
                this.btnShrapnel.getChildAt(0).skin = RES_PATH.LIBRARY_UI.RIGHT_BTN_UI.TOUCHED;
            } else if (target == ARM_KIND$1.SNIPER) {
                this.btnSniper.getChildAt(0).skin = RES_PATH.LIBRARY_UI.RIGHT_BTN_UI.TOUCHED;
            } else if (target == ARM_KIND$1.MACHINE) {
                this.btnMachine.getChildAt(0).skin = RES_PATH.LIBRARY_UI.RIGHT_BTN_UI.TOUCHED;
            } else if (target == ARM_KIND$1.WAISTDECORATIONS) {
                this.btnWaistDecorations.getChildAt(0).skin = RES_PATH.LIBRARY_UI.RIGHT_BTN_UI.TOUCHED;
            } else if (target == ARM_KIND$1.WING) {
                this.btnWing.getChildAt(0).skin = RES_PATH.LIBRARY_UI.RIGHT_BTN_UI.TOUCHED;
            }
        }
        updateData(isFirst = false) {
            if (isFirst) {
                let list = this.getList();
                this.armList.itemRender = LibraryArmItemCtrl;
                this.armList.vScrollBarSkin = '';
                this.armList.dataSource = list;
                this.armList.renderHandler = new Laya.Handler(this, this.updateSkinItem);
            } else {
                let list = this.getList();
                this.armList.dataSource = list;
                this.armList.refresh();
            }
        }
        updateSkinItem(cell, index) {
            let cellCtrl = cell;
            cellCtrl.setView();
        }
        getArmListType() {
            let id = RoleManager.getInstance().getSelectSkin();
            if (ARM.getDataByKey(id).type == 1) {
                this.armType = ARM_KIND$1.RIFLE;
            } else if (ARM.getDataByKey(id).type == 3) {
                this.armType = ARM_KIND$1.SNIPER;
            } else if (ARM.getDataByKey(id).type == 4) {
                this.armType = ARM_KIND$1.PISTOL;
            } else if (ARM.getDataByKey(id).type == 5) {
                this.armType = ARM_KIND$1.CHARGE;
            } else if (ARM.getDataByKey(id).type == 6) {
                this.armType = ARM_KIND$1.MACHINE;
            } else if (ARM.getDataByKey(id).type == 7) {
                this.armType = ARM_KIND$1.SHRAPNEL;
            }
        }
        getPartList() {
            this.myIndex = 0;
            let list = [];
            let mySkinLib = RoleManager.getInstance().getPartLib();
            let selectSkin = RoleManager.getInstance().getTargetPart(this.curBtnType);
            console.log('mySkinLib:', mySkinLib, 'selectSkin:', selectSkin);
            for (let k = 0; k < PARTS.keys.length; k++) {
                let data = {
                    id: PARTS.getDataByIndex(k).id,
                    url: PARTS.getDataByIndex(k).icon,
                    cost: PARTS.getDataByIndex(k).cost,
                    grade: PARTS.getDataByIndex(k).grade,
                    roleName: PARTS.getDataByIndex(k).cnName,
                    costType: PARTS.getDataByIndex(k).costType,
                    partType: PARTS.getDataByIndex(k).partType,
                    modelType: 0,
                    state: LIBRARY_PARTS_STATE.LOCK_NORMAL,
                    hd: PARTS.getDataByIndex(k).hd,
                };
                if (selectSkin == PARTS.getDataByIndex(k).id) {
                    data.state = LIBRARY_PARTS_STATE.USE_SELECT;
                    Laya.timer.once(1, this, function() {
                        this.showPartsModel(PARTS.getDataByIndex(k).id);
                    }, null, false);
                    this.myIndex = k;
                } else {
                    for (let k2 in mySkinLib) {
                        if (mySkinLib[k2] == PARTS.getDataByIndex(k).id) {
                            data.state = LIBRARY_PARTS_STATE.UNLOCK_NORMAL;
                            break;
                        }
                    }
                }
                if (data.partType == this.curBtnType) {
                    if (data.hd) {
                        if ((ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD || ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS))
                            list.push(data);
                    } else {
                        list.push(data);
                    }
                }
            }
            let sort = function(a, b) {
                if (b.id == null)
                    return;
                console.log('a:', a, 'b:', b);
                if (a.state == b.state) {
                    if (a.id > b.id) {
                        return 1;
                    } else {
                        return -1;
                    }
                } else {
                    if (a.state == LIBRARY_PARTS_STATE.LOCK_NORMAL) {
                        return 1;
                    } else {
                        if (a.state == LIBRARY_PARTS_STATE.UNLOCK_NORMAL && b.state == LIBRARY_PARTS_STATE.UNLOCK_SELECT) {
                            if (a.id > b.id) {
                                return 1;
                            } else {
                                return -1;
                            }
                        } else {
                            return -1;
                        }
                    }
                }
            };
            list.sort(sort);
            let list1 = this.getTargetList(list, 1);
            let list2 = this.getTargetList(list, 2);
            let list3 = this.getTargetList(list, 3);
            console.log('重新获取三个列表：', list1, list2, list3);
            let index = 0;
            let has = false;
            for (let k = 0; k < list.length; k++) {
                if (list[k].state == LIBRARY_PARTS_STATE.LOCK_NORMAL) {
                    index = k;
                    has = true;
                    break;
                }
            }
            if (index != 0) {
                list.splice(index, list.length);
                this.pushNewList(list, list1);
                this.pushNewList(list, list2);
                this.pushNewList(list, list3);
            } else {
                if (has) {
                    list.splice(index, list.length);
                    this.pushNewList(list, list1);
                    this.pushNewList(list, list2);
                    this.pushNewList(list, list3);
                }
            }
            console.log('skinData:', index, list);
            return list;
        }
        setPartData(isFirst = false) {
            if (isFirst) {
                let list = this.getPartList();
                this.partsList.itemRender = LibraryPartsItemCtrl;
                this.partsList.vScrollBarSkin = '';
                this.partsList.dataSource = list;
                this.partsList.selectEnable = true;
                this.partsList.renderHandler = new Laya.Handler(this, this.updateSkinPartsItem);
            } else {
                this.isrefresh = true;
                let list = this.getPartList();
                this.partsList.dataSource = list;
                console.log('更新完之后得数据：', this.partsList.dataSource);
                this.partsList.refresh();
            }
        }
        updateSkinPartsItem(cell, index) {
            let cellCtrl = cell;
            cellCtrl.setView(index);
        }
        getList() {
            let list = [];
            let oriList = [];
            let gamingList = (this.armType == ARM_KIND$1.OTHER) ? RoleManager.getInstance().getGameCurPropLib() : RoleManager.getInstance().getSkinGameCurLib();
            let hasList = (this.armType == ARM_KIND$1.OTHER) ? RoleManager.getInstance().getPropLib() : RoleManager.getInstance().getSkinLib();
            if (this.armType != ARM_KIND$1.OTHER) {
                for (let k = 0; k < hasList.length; k++) {
                    let item = hasList[k];
                    if (this.armType == ARM_KIND$1.RIFLE) {
                        if (ARM.getDataByKey(item).type == 1) {
                            oriList.push(ARM.getDataByKey(item));
                        }
                    } else if (this.armType == ARM_KIND$1.CHARGE) {
                        if (ARM.getDataByKey(item).type == 5) {
                            oriList.push(ARM.getDataByKey(item));
                        }
                    } else if (this.armType == ARM_KIND$1.PISTOL) {
                        if (ARM.getDataByKey(item).type == 4) {
                            oriList.push(ARM.getDataByKey(item));
                        }
                    } else if (this.armType == ARM_KIND$1.SHRAPNEL) {
                        if (ARM.getDataByKey(item).type == 7) {
                            oriList.push(ARM.getDataByKey(item));
                        }
                    } else if (this.armType == ARM_KIND$1.SNIPER) {
                        if (ARM.getDataByKey(item).type == 3) {
                            oriList.push(ARM.getDataByKey(item));
                        }
                    } else if (this.armType == ARM_KIND$1.MACHINE) {
                        if (ARM.getDataByKey(item).type == 6) {
                            oriList.push(ARM.getDataByKey(item));
                        }
                    }
                }
            } else {
                for (let k = 0; k < hasList.length; k++) {
                    let item = hasList[k];
                    oriList.push(PROP.getDataByKey(item));
                }
            }
            for (let k = 0; k < oriList.length; k++) {
                let data = {
                    myIndex: k,
                    data: oriList[k],
                    state: LIBRARY_ARM_STATE$1.EQUIP
                };
                for (let i = 0; i < gamingList.length; i++) {
                    if (oriList[k].id == gamingList[i]) {
                        data.state = LIBRARY_ARM_STATE$1.REMOVE;
                    }
                }
                list.push(data);
            }
            list = this.pjsort(list);
            return list;
        }
        pjsort(arr) {
            var len = arr.length;
            for (var i = 0; i < len - 1; i++) {
                for (var j = 0; j < len - 1 - i; j++) {
                    if (arr[j].data.grade > arr[j + 1].data.grade) {
                        var temp = arr[j];
                        arr[j] = arr[j + 1];
                        arr[j + 1] = temp;
                    }
                }
            }
            return arr;
        }
        setGuideByCell() {
            for (let k = 0; k < this.armList.dataSource.length; k++) {
                let cell = this.armList.getCell(k);
                if (cell) {
                    if (cell.armAperture) {
                        cell.armAperture.stop();
                        cell.armAperture.visible = false;
                    }
                }
            }
            let guide = RoleManager.getInstance().getGuide();
            if (GuideManager.curEquiplLibraryStep == GuideStep.TOEQUIP) {
                GuideManager.curEquiplLibraryStep++;
            }
            if (guide == GuideStep.TOEQUIP) {
                RoleManager.getInstance().setGuide();
            }
            console.log('开启关闭指引');
            if (this.closeAperture) {
                this.closeAperture.rotation = 60;
                this.closeAperture.play(true);
                GameScene.synthesisViewCtrl && GameScene.synthesisViewCtrl.warehouseAperture && GameScene.synthesisViewCtrl.warehouseAperture.stop();
            }
        }
        pushNewList(targetSkinList, list) {
            for (let k = 0; k < list.length; k++) {
                targetSkinList.push(list[k]);
            }
        }
        getTargetList(skinData = [], costType) {
            let list = [];
            for (let k = 0; k < skinData.length; k++) {
                if (skinData[k].costType == costType && skinData[k].state == LIBRARY_ROLE_STATE.LOCK_NORMAL) {
                    list.push(skinData[k]);
                }
            }
            list = this.bSort(list);
            return list;
        }
        bSort(arr) {
            var len = arr.length;
            for (var i = 0; i < len - 1; i++) {
                for (var j = 0; j < len - 1 - i; j++) {
                    if (arr[j].cost > arr[j + 1].cost) {
                        var temp = arr[j];
                        arr[j] = arr[j + 1];
                        arr[j + 1] = temp;
                    }
                }
            }
            return arr;
        }
        setRoleData() {
            let skinData = [];
            let mySkinLib = RoleManager.getInstance().getRoleSkinLib();
            let selectSkin = RoleManager.getInstance().getSelectRoleSkin();
            for (let k = 0; k < RoleData.keys.length; k++) {
                let data = {
                    id: RoleData.getDataByKey(k + 1).id,
                    url: RoleData.getDataByKey(k + 1).icon,
                    cost: RoleData.getDataByKey(k + 1).cost,
                    grade: RoleData.getDataByKey(k + 1).grade,
                    roleName: RoleData.getDataByKey(k + 1).cnName,
                    costType: RoleData.getDataByKey(k + 1).costType,
                    activityType: RoleData.getDataByKey(k + 1).activityType,
                    state: LIBRARY_ROLE_STATE.LOCK_NORMAL,
                    hd: RoleData.getDataByKey(k + 1).hd,
                };
                if (selectSkin == RoleData.getDataByKey(k + 1).id) {
                    data.state = LIBRARY_ROLE_STATE.USE_SELECT;
                    this.curRole = data;
                    this.updateRoleContent();
                    Laya.timer.once(1, this, function() {
                        this.showRoleModel(RoleData.getDataByKey(k + 1).id);
                    }, null, false);
                } else {
                    for (let k2 in mySkinLib) {
                        if (mySkinLib[k2] == RoleData.getDataByKey(k + 1).id) {
                            data.state = LIBRARY_ROLE_STATE.UNLOCK_NORMAL;
                            break;
                        }
                    }
                }
                if (data.hd) {
                    if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD || ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS)
                        skinData.push(data);
                } else {
                    skinData.push(data);
                }
            }
            let sort = function(a, b) {
                if (a.state == b.state) {
                    if (a.id > b.id) {
                        return 1;
                    } else {
                        return -1;
                    }
                } else {
                    if (a.state == LIBRARY_ROLE_STATE.LOCK_NORMAL) {
                        return 1;
                    } else {
                        if (a.state == LIBRARY_ROLE_STATE.UNLOCK_NORMAL && b.state == LIBRARY_ROLE_STATE.UNLOCK_SELECT) {
                            if (a.id > b.id) {
                                return 1;
                            } else {
                                return -1;
                            }
                        } else {
                            return -1;
                        }
                    }
                }
            };
            skinData.sort(sort);
            this.roleList.itemRender = LibraryRoleItemCtrl;
            this.roleList.vScrollBarSkin = '';
            this.roleList.dataSource = skinData;
            this.roleList.selectEnable = true;
            this.roleList.renderHandler = new Laya.Handler(this, this.updateRoleItem);
            this.roleList.selectHandler = new Laya.Handler(this, this.onSelectSkin);
        }
        onSelectSkin(index, isUse = false) {
            for (let k in this.roleList.dataSource) {
                let cellCtrl = this.roleList.getCell(parseInt(k));
                if (index != parseInt(k)) {
                    if (this.roleList.dataSource[parseInt(k)].state == LIBRARY_ROLE_STATE.LOCK_SELECT) {
                        this.roleList.dataSource[parseInt(k)].state = LIBRARY_ROLE_STATE.LOCK_NORMAL;
                    } else if (this.roleList.dataSource[parseInt(k)].state == LIBRARY_ROLE_STATE.UNLOCK_SELECT) {
                        this.roleList.dataSource[parseInt(k)].state = LIBRARY_ROLE_STATE.UNLOCK_NORMAL;
                    } else if (this.roleList.dataSource[parseInt(k)].state == LIBRARY_ROLE_STATE.USE_SELECT) {
                        if (isUse) {
                            this.roleList.dataSource[parseInt(k)].state = LIBRARY_ROLE_STATE.UNLOCK_NORMAL;
                        } else {
                            this.roleList.dataSource[parseInt(k)].state = LIBRARY_ROLE_STATE.USE_NORMAL;
                        }
                    } else if (this.roleList.dataSource[parseInt(k)].state == LIBRARY_ROLE_STATE.USE_NORMAL) {
                        if (isUse) {
                            this.roleList.dataSource[parseInt(k)].state = LIBRARY_ROLE_STATE.UNLOCK_NORMAL;
                            if (cellCtrl)
                                cellCtrl.setState();
                        }
                    }
                }
            }
            let cellCtrl = this.roleList.getCell(parseInt(index));
            this.curRole = this.roleList.dataSource[index];
            this.updateRoleContent();
            cellCtrl.mySelect(isUse);
            this.btnTry.visible = false;
            if (this.roleList.dataSource[index].state == LIBRARY_ROLE_STATE.LOCK_SELECT) {
                this.btnTry.visible = true;
                this.curID = this.roleList.dataSource[index].id;
                this.curTryType = TRYTYPE.ROLE;
                this.setTryBtn('sub1/ui/try/img_new_role_1.png');
            }
            this.showRoleModel(this.roleList.dataSource[index].id);
        }
        onPartSelectSkin(index, isUse = false, isRemove = false) {
            SoundManager.playEffect(SOUND_PATH.CLICK);
            this.myIndex = index;
            console.log('选择：', index, this.partsList.dataSource[index].state);
            for (let k in this.partsList.dataSource) {
                let cellCtrl = this.partsList.getCell(parseInt(k));
                if (index != parseInt(k)) {
                    if (this.partsList.dataSource[parseInt(k)].state == LIBRARY_PARTS_STATE.LOCK_SELECT) {
                        this.partsList.dataSource[parseInt(k)].state = LIBRARY_PARTS_STATE.LOCK_NORMAL;
                    } else if (this.partsList.dataSource[parseInt(k)].state == LIBRARY_PARTS_STATE.UNLOCK_SELECT) {
                        this.partsList.dataSource[parseInt(k)].state = LIBRARY_PARTS_STATE.UNLOCK_NORMAL;
                    } else if (this.partsList.dataSource[parseInt(k)].state == LIBRARY_PARTS_STATE.USE_SELECT) {
                        if (isUse) {
                            this.partsList.dataSource[parseInt(k)].state = LIBRARY_PARTS_STATE.UNLOCK_NORMAL;
                        } else {
                            this.partsList.dataSource[parseInt(k)].state = LIBRARY_PARTS_STATE.USE_NORMAL;
                        }
                    } else if (this.partsList.dataSource[parseInt(k)].state == LIBRARY_PARTS_STATE.USE_NORMAL) {
                        if (isUse) {
                            this.partsList.dataSource[parseInt(k)].state = LIBRARY_PARTS_STATE.UNLOCK_NORMAL;
                            if (cellCtrl)
                                cellCtrl.setState();
                        }
                    }
                }
            }
            this.isrefresh = false;
            let cellCtrl = this.partsList.getCell(this.myIndex);
            if (cellCtrl) {
                cellCtrl.mySelect(isUse);
            }
            this.btnTry.visible = false;
            if (this.partsList.dataSource[index].state == LIBRARY_PARTS_STATE.LOCK_SELECT) {
                this.btnTry.visible = true;
                this.curID = this.partsList.dataSource[index].id;
                this.curTryType = TRYTYPE.PARTS;
                this.setTryBtn('sub1/ui/try/img_new_role_2.png');
            }
            console.log('展示模型');
            if (!isRemove) {
                this.showPartsModel(this.partsList.dataSource[index].id);
            }
        }
        showPartsModel(id, decorate = null) {
            console.log('传入部件ID：', id);
            let obj = SkinManager.createParts(id, this.sp, new Laya.Vector3(1, 1, 1), decorate);
        }
        updateRoleContent() {
            this.txtRoleName.text = this.curRole.roleName ? this.curRole.roleName : this.curRole.cnName;
        }
        updateRoleItem(cell, index) {
            let cellCtrl = cell;
            cellCtrl.setView(index);
        }
        buyRole(index) {
            console.log('购买角色:', this.roleList.dataSource[index]);
            this.roleList.dataSource[index].state = LIBRARY_ROLE_STATE.USE_SELECT;
            RoleManager.getInstance().setRoleSkinLib(this.roleList.dataSource[index].id);
            RoleManager.getInstance().setSelectRoleSkin(this.roleList.dataSource[index].id);
            let id = this.roleList.dataSource[index].id;
            let itemId = ITEM_TYPE.HERO.toString() + (id > 99 ? id : id > 9 ? '0' + id : '00' + id);
            this.onSelectSkin(index, true);
            UIManager.openFunction(FUNCTION_TAG.GET_EQUIP_REWARD, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE, {
                id: itemId,
                cb: null
            });
        }
        buyParts(index) {
            this.partsList.dataSource[index].state = LIBRARY_ROLE_STATE.USE_SELECT;
            RoleManager.getInstance().setPartsSkin(this.partsList.dataSource[index].id);
            RoleManager.getInstance().setTargetPart(this.partsList.dataSource[index].id);
            let id = this.partsList.dataSource[index].id;
            let itemId = ITEM_TYPE.HERO.toString() + (id > 99 ? id : id > 9 ? '0' + id : '00' + id);
            this.onPartSelectSkin(index, true);
        }
        buyRoleDebris(index) {
            let id = this.roleList.dataSource[index].id;
            let itemId = ITEM_TYPE.HERO_DEBRIS.toString() + (id > 99 ? id : id > 9 ? '0' + id : '00' + id);
            GetBoxRewardNextViewCtrl.getAward([{
                itemId: itemId,
                count: 1
            }], FUNCTION_OPEN_MODE.COVER, true);
            this.roleList.refresh();
            if (RoleManager.getInstance().getTargetFragment({
                    type: ITEM_TYPE.HERO_DEBRIS,
                    id: itemId
                }) >= this.roleList.dataSource[index].cost) {
                this.useRole(index);
            }
        }
        buyPartDebris(index) {
            let id = this.partsList.dataSource[index].id;
            let itemId = ITEM_TYPE.PART_DEBRIS.toString() + (id > 99 ? id : id > 9 ? '0' + id : '00' + id);
            GetBoxRewardNextViewCtrl.getAward([{
                itemId: itemId,
                count: 1
            }], FUNCTION_OPEN_MODE.COVER, true);
            this.partsList.refresh();
            if (RoleManager.getInstance().getTargetFragment({
                    type: ITEM_TYPE.PART_DEBRIS,
                    id: itemId
                }) >= this.partsList.dataSource[index].cost)
                this.useParts(index);
        }
        useRole(index) {
            this.roleList.dataSource[index].state = LIBRARY_ROLE_STATE.USE_SELECT;
            RoleManager.getInstance().setSelectRoleSkin(this.roleList.dataSource[index].id);
            this.onSelectSkin(index, true);
        }
        useParts(index) {
            this.partsList.dataSource[index].state = LIBRARY_ROLE_STATE.USE_SELECT;
            RoleManager.getInstance().setTargetPart(this.partsList.dataSource[index].id);
            this.partsList.refresh();
            this.onPartSelectSkin(index, true);
        }
        removePart(index) {
            this.partsList.dataSource[index].state = LIBRARY_ROLE_STATE.UNLOCK_NORMAL;
            console.log('卸下：', this.curBtnType);
            RoleManager.getInstance().removePart(this.curBtnType);
            SkinManager.removePartsByTS(this.curBtnType, this.sp);
            this.onPartSelectSkin(index, false, true);
            console.log('卸下之后的数据：', RoleManager.getInstance().getPartsSkin());
        }
        onBtnArm() {
            if (!CommonUtil.getTouch())
                return;
            this.curOpenView = OPEN_VIEW.ARM;
            this.showRoleModel(RoleManager.getInstance().getSelectRoleSkin());
            this.curRole = RoleData.getDataByKey(RoleManager.getInstance().getSelectRoleSkin());
            console.log(' this.curRole:', this.curRole);
            this.updateRoleContent();
            this.viewCtrl();
            this.btnTry.visible = false;
        }
        onBtnBack() {
            if (!CommonUtil.getTouch())
                return;
            if (GuideManager.curEquiplLibraryStep == GuideStep.GAME_2) {
                if (RoleManager.getInstance().getGuide() > GuideStep.GAME_1 && RoleManager.getInstance().getGuide() < GuideStep.GAME_2) {
                    RoleManager.getInstance().setGuide();
                }
            }
            if (RoleManager.getInstance().getGuide() == GuideStep.GAME_2) {
                UIManager.getFunctionViewCtrl(FUNCTION_TAG.FIRST).resetData();
            }
            UIManager.getFunctionViewCtrl(FUNCTION_TAG.FIRST).setGuide();
            UIManager.closeFunction();
        }
        onBtnBottomBack() {
            if (!CommonUtil.getTouch())
                return;
            this.aniClose.play(0, false);
        }
        onBtnBottomOpen() {
            if (!CommonUtil.getTouch())
                return;
            this.aniOpen.play(0, false);
        }
        onBtnCharge() {
            this.setData(ARM_KIND$1.CHARGE);
        }
        onBtnOther() {
            if (!CommonUtil.getTouch())
                return;
            this.setData(ARM_KIND$1.OTHER);
        }
        onBtnPistol() {
            if (!CommonUtil.getTouch())
                return;
            this.setData(ARM_KIND$1.PISTOL);
        }
        onBtnRifle() {
            if (!CommonUtil.getTouch())
                return;
            this.setData(ARM_KIND$1.RIFLE);
        }
        onBtnRole() {
            if (!CommonUtil.getTouch())
                return;
            this.curOpenView = OPEN_VIEW.ROLE;
            this.btnTry.visible = false;
            this.viewCtrl();
        }
        onBtnParts() {
            if (!CommonUtil.getTouch())
                return;
            this.curOpenView = OPEN_VIEW.PARTS;
            this.btnTry.visible = false;
            this.viewCtrl();
            this.setData(ARM_KIND$1.WING);
            this.curBtnType = BTNTYPE$1[1];
            this.setPartData();
        }
        onBtnSniper() {
            if (!CommonUtil.getTouch())
                return;
            this.setData(ARM_KIND$1.SNIPER);
        }
        onBtnShrapnel() {
            if (!CommonUtil.getTouch())
                return;
            this.setData(ARM_KIND$1.SHRAPNEL);
        }
        onBtnMachine() {
            if (!CommonUtil.getTouch())
                return;
            this.setData(ARM_KIND$1.MACHINE);
        }
        onBtnWaistDecorations() {
            if (!CommonUtil.getTouch())
                return;
            this.setData(ARM_KIND$1.WAISTDECORATIONS);
            this.curBtnType = BTNTYPE$1[0];
            this.setPartData();
        }
        onBtnWing() {
            if (!CommonUtil.getTouch())
                return;
            this.setData(ARM_KIND$1.WING);
            this.curBtnType = BTNTYPE$1[1];
            this.setPartData();
        }
        setPlatformStyle() {
            switch (ConfigManager.platform) {
                case PLATFORM_TYPE.WX:
                    {
                        this.setWXPlatform();
                        break;
                    }
                case PLATFORM_TYPE.QQ:
                    {
                        this.setQQPlatform();
                        break;
                    }
                case PLATFORM_TYPE.WEB:
                    {
                        this.setNativeAndroidPlatform();
                        break;
                    }
                case PLATFORM_TYPE.WEB_4399:
                    {
                        this.setWeb4399Platform();
                        break;
                    }
                case PLATFORM_TYPE.VIVO:
                    {
                        this.setVIVOPlatform();
                        break;
                    }
                case PLATFORM_TYPE.OPPO:
                    {
                        this.setOPPOPlatform();
                        break;
                    }
                case PLATFORM_TYPE.NATIVE_IOS:
                    {
                        this.setNativeIOSPlatform();
                        break;
                    }
                case PLATFORM_TYPE.NATIVE_ANDRIOD:
                    {
                        this.setNativeAndroidPlatform();
                        break;
                    }
                case PLATFORM_TYPE.TT:
                    {
                        this.setTTPlatform();
                        break;
                    }
            }
        }
        setWeb4399Platform() {
            this.label4399.visible = true;
        }
        setWXPlatform() {
            this.armList.height = 453;
            this.roleList.height = 461;
            this.partsList.height = 461;
        }
        setQQPlatform() {
            this.armList.height = 453;
            this.roleList.height = 461;
            this.partsList.height = 461;
        }
        setWebPlatform() {}
        setVIVOPlatform() {}
        setOPPOPlatform() {}
        setNativeIOSPlatform() {}
        setNativeAndroidPlatform() {
            this.armList.height = 453;
            this.roleList.height = 461;
            this.partsList.height = 461;
        }
        setTTPlatform() {}
    }

    class LibraryFunction extends BaseFunction {
        createView() {
            this._viewCtrl = new LibraryViewCtrl();
            return this._viewCtrl;
        }
        getFunctionName() {
            return '仓库界面';
        }
        onEnter() { super.onEnter(); }
        onExit() { super.onExit(); }
        onEnable() {
            super.onEnable();
            if ((ConfigManager.platform == PLATFORM_TYPE.WX || ConfigManager.platform == PLATFORM_TYPE.QQ) || ConfigManager.appId == ANDROID_APP_ID.XM)
                AdUtil.showBannerAd(Laya.stage.width - (PlatformUtil.getBannerWeight()), PlatformUtil.getBannerCenterPos().y + (PlatformUtil.isIOS() ? 30 : 0));
        }
        onDisbale() {
            super.onDisbale();
            AdUtil.hideBannerAd();
        }
        setAllButtonAnalysePoint() {}
        request(cb) {
            cb();
        }
    }

    class EndMySelfViewCtrl extends ui.view.end.EndMySelfViewUI {
        constructor() {
            super();
            this.addExp = 4;
            this.scene3D = null;
            this._translate2 = new Laya.Vector3(5, -10, 1);
            this._translate = new Laya.Vector3(0, 0, 0);
            this.sp = null;
            this._pos = new Laya.Vector3(310, 500, 0);
            this.width = Laya.stage.width;
            this.height = Laya.stage.height;
        }
        onAwake() {
            this.share1.visible = false;
            this.share2.visible = false;
            if (ConfigManager.platform == PLATFORM_TYPE.TT) {
                this.share2.visible = true;
            } else {
                this.share1.visible = true;
            }
            SceneManager.getCurScene().createMenu(1, this.boxAll);
            this.init();
            this.setEvent();
            if (ConfigManager.platform != PLATFORM_TYPE.WX && ConfigManager.platform != PLATFORM_TYPE.QQ) {
                this.btnRevive.visible = false;
                this.btnBack.pos(this.btnRevive.x, this.btnRevive.y);
            }
        }
        setEvent() {
            this.btnBack.on(Laya.Event.CLICK, this, this.onBtnEnter);
            this.btnRevive.on(Laya.Event.CLICK, this, this.onBtnShard);
        }
        onBtnEnter() {
            if (!CommonUtil.getTouch())
                return;
            SceneManager.getCurScene().cleanMenu();
            UIManager.closeFunction();
        }
        onBtnShard() {
            if (!CommonUtil.getTouch())
                return;
            let that = this;
            if (ConfigManager.platform != PLATFORM_TYPE.TT && ConfigManager.platform != PLATFORM_TYPE.WEB) {
                AdUtil.shareMessage();
            } else {
                UIManager.openFunction(FUNCTION_TAG.RECORD, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.WINDOW, COMMON_MENU_STYLE.HIDE, {
                    cb: function() {},
                    sucessCb: function() {
                        that.btnRevive.visible = false;
                    }
                });
            }
        }
        init() {
            let isWin = CharacterManger._isWin;
            let progress = this.imgProgress.width;
            this.btnRevive.visible = false;
            if (isWin) {
                this.boxWin.visible = true;
                this.btnRevive.visible = true;
                this.addExp = 8;
            } else {
                if (ConfigManager.platform == PLATFORM_TYPE.TT) {
                    this.btnRevive.visible = true;
                }
                this.boxFail.visible = true;
                if (ConfigManager.platform != PLATFORM_TYPE.TT) {
                    this.btnBack.pos(this.btnRevive.x, this.btnRevive.y);
                }
            }
            let myData;
            let weList = [];
            let eList = [];
            let rank = 0;
            if (UIManager.getFunction(FUNCTION_TAG.FIRST))
                return; {
                for (let k = 0; k < CharacterManger.logicalBaseLayer.length; k++) {
                    let item = CharacterManger.logicalBaseLayer[k];
                    if (item.getIsMySelf()) {
                        myData = item;
                    }
                    if (item.getRoleType() == ROLE_TYPE.TYPE_0) {
                        weList.push(item);
                    } else {
                        eList.push(item);
                    }
                }
                let newWeList = this.sort(weList);
                let newEList = this.sort(eList);
                if (isWin) {
                    for (let index = 0; index < newWeList.length; index++) {
                        const element = newWeList[index];
                        if (element.getIsMySelf()) {
                            rank = index + 1;
                            break;
                        }
                    }
                    if (rank <= 1) {
                        this.imgMvp.visible = true;
                    } else {}
                } else {
                    for (let index = 0; index < newEList.length; index++) {
                        const element = newEList[index];
                        if (element.getIsMySelf()) {
                            rank = index + 1;
                            break;
                        }
                    }
                    if (rank <= 1) {
                        this.imgSvp.visible = true;
                    } else {}
                }
            }
            this.addExp = this.addExp * myData.playerKillCount + this.addExp;
            let isUp = RoleManager.getInstance().increaseExp(this.addExp);
            let expData = RoleManager.getInstance().getRoleExpData();
            this.labelAddExp.text = '+' + this.addExp.toString();
            this.imgProgress.width = expData.curExp / expData.exp * progress;
            this.labelDie.text = '被淘汰:' + myData.playerBeKillCount;
            this.labelKill.text = '击败:' + myData.playerKillCount;
            this.labelScore.text = '评分:' + myData.score;
            this.labelLv.text = 'Lv.' + expData.lv.toString();
        }
        onDestroy() {
            if (this.sp)
                this.sp.destroy();
            this.sp = null;
            if (this.scene3D)
                this.scene3D.destroy();
            this.scene3D = null;
            this._translate2 = null;
            this._translate = null;
            this.sp = null;
            this._pos = null;
        }
        sort(logicList) {
            var oValue;
            for (var i = 0, len = logicList.length; i < len; i++) {
                for (var j = 0; j <= i; j++) {
                    if (logicList[i].score > logicList[j].score) {
                        oValue = logicList[i];
                        logicList[i] = logicList[j];
                        logicList[j] = oValue;
                    }
                }
            }
            return logicList;
        }
        create3D() {
            var scene = this.addChild(new Laya.Scene3D());
            var camera = scene.addChild(new Laya.Camera(0, 0.1, 1000));
            this.scene3D = scene;
            camera.transform.translate(this._translate2);
            camera.orthographic = true;
            camera.enableHDR = false;
            camera.clearColor = new Laya.Vector4(0.0, 0.0, 0.0, 0.0);
            var renderTexture = new Laya.RenderTexture(512, 512, Laya.RenderTextureFormat.R8G8B8A8, Laya.RenderTextureDepthFormat.DEPTH_16);
            camera.renderTarget = renderTexture;
            camera.orthographicVerticalSize = 10;
            scene.addChild(new Laya.DirectionLight());
            camera.convertScreenCoordToOrthographicCoord(this._pos, this._translate);
            this._translate.x += 3;
            this._translate.y -= 2;
            this.img3DCenter.source = new Laya.Texture(renderTexture);
            if (this.sp) {
                this.sp.destroy();
                this.sp = null;
            }
            this.sp = SkinManager.createRoleViewSkin(this._translate, this.scene3D, false, RoleManager.getInstance().getSelectRoleSkin());
            this.sp.transform.localRotationEulerY = 20;
            this.sp.transform.localPositionY -= 3;
            this.sp.transform.localPositionX -= 0.3;
            this.sp.transform.localScaleX = 6;
            this.sp.transform.localScaleY = 6;
            this.sp.transform.localScaleZ = 6;
            let a = 0;
            let list = RoleManager.getInstance().getSkinGameCurLib();
            if (CharacterManger.playerLogicalBaseLayer.armCtrl) {
                if (CharacterManger.playerLogicalBaseLayer.armCtrl.getType() == 2) {
                    a = 1;
                    list = ['2001'];
                } else {
                    if (CharacterManger.playerLogicalBaseLayer.armCtrl.getType() != 8) {
                        a = 0;
                        list = [CharacterManger.playerLogicalBaseLayer.armCtrl.id];
                    }
                }
            }
            if (ModeManager.mode == GAME_MODE_TYPE.KNIFEWARMODE) {
                a = 1;
                list = ['2001'];
            }
            let obj = SkinManager.createMenuArm(list[0], this.sp, a);
            obj.transform.localScaleX = 0.7;
            obj.transform.localScaleY = 0.7;
            obj.transform.localScaleZ = 0.7;
        }
    }

    class EndMySelfFunction extends BaseFunction {
        createView() {
            this._viewCtrl = new EndMySelfViewCtrl();
            return this._viewCtrl;
        }
        getFunctionName() {
            return '个人结束界面';
        }
        onEnter() { super.onEnter(); }
        onExit() {
            super.onExit();
            UIManager.triggerAutoOpen();
        }
        onEnable() {
            super.onEnable();
            if (ConfigManager.appId == ANDROID_APP_ID.XM)
                AdUtil.showBannerAd(0, 314);
            if (ConfigManager.platform == PLATFORM_TYPE.VIVO || ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS || (ConfigManager.appId == ANDROID_APP_ID.C233_ME || ConfigManager.appId == ANDROID_APP_ID.MMY || ConfigManager.appId == ANDROID_APP_ID.HYKB) || ConfigManager.appId == ANDROID_APP_ID.C_233) {
                AdUtil.showBannerAd();
            }
            if (ConfigManager.platform == PLATFORM_TYPE.WX) {
                AdUtil.showBannerAd(Laya.stage.width / 2 + 80, 324);
                let x = 106;
                let y = 315;
                AdUtil.showCustom(x, y, WX_CUSTOM_AD_STYLE.SINGLE_1);
                AdUtil.createInterstitialAd();
            }
        }
        onDisbale() {
            super.onDisbale();
            AdUtil.hideBannerAd();
            let x = 106;
            let y = 315;
            AdUtil.hideCustom(x, y, WX_CUSTOM_AD_STYLE.SINGLE_1);
        }
        setAllButtonAnalysePoint() {}
        request(cb) {
            cb();
        }
    }

    class LibraryPropertybarItemCtrl extends ui.view.library.LibraryPropertybarItemUI {
        constructor() {
            super();
        }
        onAwake() {}
        onDestroy() {}
        setView() {
            this.txtAttribute.text = this.dataSource.attribute;
            this.txtPro.text = this.dataSource.pro;
            if (this.dataSource.attribute == '命中头部' || this.dataSource.attribute == '命中身体' || this.dataSource.attribute == '命中四肢') {
                this.txtPro.text = this.dataSource.bs;
            }
            this.imgPro.width = 166 * this.dataSource.pro / this.dataSource.maxPro;
        }
        update() {}
    }

    class DetailViewCtrl extends ui.view.library.DetailViewUI {
        constructor(myArmData) {
            super();
            this.myArmData = null;
            this.cacheList = [];
            this.scene3D = null;
            this._translate2 = new Laya.Vector3(5, -10, 1);
            this._translate = new Laya.Vector3(0, 0, 0);
            this._pos = new Laya.Vector3(310, 500, 0);
            this.rotMouseX = 0;
            this.sp = null;
            this.myArmData = myArmData;
            this.width = this.stage.width;
            this.height = this.stage.height;
        }
        onAwake() {
            this.setData();
            this.create3D();
            this.on(Laya.Event.MOUSE_DOWN, this, this.onBtnMouseDown);
            this.on(Laya.Event.MOUSE_MOVE, this, this.onBtnRot);
            this.btnBack.on(Laya.Event.CLICK, this, function() {
                UIManager.closeFunction();
            });
        }
        onDestroy() {
            this.cacheList = null;
            this.myArmData = null;
        }
        onBtnMouseDown(e) {
            this.rotMouseX = e.stageX;
        }
        onBtnRot(e) {
            if (this.sp) {
                let fac = e.stageX - this.rotMouseX;
                this.sp.transform.localRotationEulerY += fac * 0.4;
                this.rotMouseX = e.stageX;
            }
        }
        create3D() {
            var scene = this.addChild(new Laya.Scene3D());
            var camera = scene.addChild(new Laya.Camera(0, 2, 1000));
            this.scene3D = scene;
            camera.transform.translate(this._translate2);
            camera.orthographic = true;
            camera.enableHDR = false;
            camera.clearFlag = Laya.CameraClearFlags.SolidColor;
            camera.clearColor = new Laya.Vector4(0.0, 0.0, 0.0, 0.0);
            var renderTexture = new Laya.RenderTexture(1024, 1024, Laya.RenderTextureFormat.R8G8B8A8, Laya.RenderTextureDepthFormat.DEPTH_16);
            camera.renderTarget = renderTexture;
            camera.orthographicVerticalSize = 10;
            scene.addChild(new Laya.DirectionLight());
            camera.convertScreenCoordToOrthographicCoord(this._pos, this._translate);
            this._translate.x += 3;
            this._translate.y -= 2;
            this.img3DCenter.source = new Laya.Texture(renderTexture);
            let sp = SkinManager.onLyToCreateArm(this.myArmData.id, this.scene3D);
            sp.transform.localRotationEulerY = 90;
            sp.transform.localScaleX = 6;
            sp.transform.localScaleY = 6;
            sp.transform.localScaleZ = 6;
            sp.transform.position = camera.transform.position.clone();
            sp.transform.localPositionZ -= 15;
            sp.transform.localPositionX -= 1;
            this.sp = sp;
        }
        showModel(id) {
            let sp = SkinManager.onLyToCreateArm(id, this.scene3D);
            sp.transform.localRotationEulerY = 20;
            sp.transform.localScaleX = 10;
            sp.transform.localScaleY = 10;
            sp.transform.localScaleZ = 10;
        }
        notUpdateProp() {
            let data = {
                id: 8001,
                lv: 1,
                fire: PROP.getDataByKey(this.myArmData.id).hit,
                pierceThrough: PROP.getDataByKey(this.myArmData.id).pierceThrough,
                firingRate: PROP.getDataByKey(this.myArmData.id).interval,
                numberOfBullets: PROP.getDataByKey(this.myArmData.id).magazineBullet,
                range: PROP.getDataByKey(this.myArmData.id).range,
                accurate: 100,
                ammunitionChange: PROP.getDataByKey(this.myArmData.id).bullets,
                sight: PROP.getDataByKey(this.myArmData.id).sight,
                movingSpeed: PROP.getDataByKey(this.myArmData.id).movingSpeed,
                biochemicalCharging: PROP.getDataByKey(this.myArmData.id).biochemicalCharging
            };
            return data;
        }
        setData() {
            if (this.myArmData) {
                console.log('myArmData:', this.myArmData);
                this.cleanCacheList();
                this.txtName.text = this.myArmData.name;
                let type = '';
                if (this.myArmData.type == 1) {
                    type = '步枪';
                } else if (this.myArmData.type == 2) {
                    type = '刀';
                } else if (this.myArmData.type == 3) {
                    type = '狙击枪';
                } else if (this.myArmData.type == 4) {
                    type = '手枪';
                } else if (this.myArmData.type == 5) {
                    type = '冲锋枪';
                } else if (this.myArmData.type == 6) {
                    type = '机枪';
                } else if (this.myArmData.type == 7) {
                    type = '散弹枪';
                } else if (this.myArmData.type == 8) {
                    type = '手榴弹';
                }
                let data = [];
                let property = RoleManager.getInstance().getArmQualityByID(this.myArmData.id) ? RoleManager.getInstance().getArmQualityByID(this.myArmData.id) : this.notUpdateProp();
                console.log('武器属性-----------------------------:', property);
                if (this.myArmData.type == 1 || this.myArmData.type == 3 || this.myArmData.type == 4 || this.myArmData.type == 5 || this.myArmData.type == 6 || this.myArmData.type == 7) {
                    data = [{
                            attribute: '火力',
                            pro: property.fire,
                            maxPro: property.lv * property.fire * RoleManager.getInstance().getMaxMultiple() + 2
                        },
                        {
                            attribute: '护甲穿透',
                            pro: property.pierceThrough,
                            maxPro: property.lv * property.pierceThrough * RoleManager.getInstance().getMaxMultiple() / 3
                        },
                        {
                            attribute: '射速',
                            pro: property.firingRate,
                            maxPro: property.lv * property.firingRate * RoleManager.getInstance().getMaxMultiple() / 2
                        },
                        {
                            attribute: '子弹数',
                            pro: property.numberOfBullets,
                            maxPro: property.lv * property.numberOfBullets * RoleManager.getInstance().getMaxMultiple() + 1.5
                        },
                        {
                            attribute: '有效射程',
                            pro: property.range,
                            maxPro: property.lv * property.range * RoleManager.getInstance().getMaxMultiple() + 2
                        },
                        {
                            attribute: '精准',
                            pro: property.accurate,
                            maxPro: property.lv * property.accurate * RoleManager.getInstance().getMaxMultiple() + 1.5
                        },
                        {
                            attribute: '命中头部',
                            pro: property.headHit,
                            bs: property.bodyMultiple,
                            maxPro: property.maxHeadHit
                        },
                        {
                            attribute: '命中身体',
                            pro: property.fire,
                            bs: 1,
                            maxPro: property.maxBodyHit
                        },
                        {
                            attribute: '命中四肢',
                            pro: property.limbHit,
                            bs: property.limbMultiple,
                            maxPro: property.maxLimbHit
                        },
                    ];
                } else {
                    data = [{
                            attribute: '火力',
                            pro: property.fire,
                            maxPro: property.lv * property.fire * RoleManager.getInstance().getMaxMultiple() + 2
                        },
                        {
                            attribute: '护甲穿透',
                            pro: property.pierceThrough,
                            maxPro: property.lv * property.pierceThrough * RoleManager.getInstance().getMaxMultiple() / 2
                        },
                        {
                            attribute: '射速',
                            pro: property.firingRate,
                            maxPro: property.lv * property.firingRate * RoleManager.getInstance().getMaxMultiple() / 2
                        },
                        {
                            attribute: '子弹数',
                            pro: property.numberOfBullets,
                            maxPro: property.lv * property.numberOfBullets * RoleManager.getInstance().getMaxMultiple() + 1.5
                        },
                        {
                            attribute: '有效射程',
                            pro: property.range,
                            maxPro: property.lv * property.range * RoleManager.getInstance().getMaxMultiple() + 2
                        },
                        {
                            attribute: '精准',
                            pro: property.accurate,
                            maxPro: property.lv * property.accurate * RoleManager.getInstance().getMaxMultiple() + 1.5
                        },
                    ];
                }
                this.txtType.text = type;
                console.log('data:----------', data);
                this.addCacheList(data);
            }
        }
        cleanCacheList() {
            for (let k = 0; k < this.cacheList.length; k++) {
                this.cacheList[k].destroy();
                this.cacheList[k] = null;
            }
            this.cacheList = [];
        }
        addCacheList(data) {
            this.ListArm.itemRender = LibraryPropertybarItemCtrl;
            this.ListArm.vScrollBarSkin = '';
            this.ListArm.dataSource = data;
            this.ListArm.renderHandler = new Laya.Handler(this, this.updateSkinItem);
        }
        updateSkinItem(cell, index) {
            let cellCtrl = cell;
            cellCtrl.setView();
        }
    }

    class DetailFunction extends BaseFunction {
        createView() {
            this._viewCtrl = new DetailViewCtrl(this._args);
            return this._viewCtrl;
        }
        getFunctionName() {
            return '详情界面';
        }
        onEnter() { super.onEnter(); }
        onExit() { super.onExit(); }
        onEnable() {
            super.onEnable();
            if (ConfigManager.platform == PLATFORM_TYPE.VIVO || ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS || (ConfigManager.appId == ANDROID_APP_ID.C233_ME || ConfigManager.appId == ANDROID_APP_ID.MMY || ConfigManager.appId == ANDROID_APP_ID.HYKB) || ConfigManager.appId == ANDROID_APP_ID.C_233) {
                AdUtil.showBannerAd();
            }
        }
        onDisbale() {
            super.onDisbale();
            if (ConfigManager.platform == PLATFORM_TYPE.VIVO || ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS || (ConfigManager.appId == ANDROID_APP_ID.C233_ME || ConfigManager.appId == ANDROID_APP_ID.MMY || ConfigManager.appId == ANDROID_APP_ID.HYKB) || ConfigManager.appId == ANDROID_APP_ID.C_233) {
                AdUtil.hideBannerAd();
            }
        }
        setAllButtonAnalysePoint() {}
        request(cb) {
            cb();
        }
    }

    class LoadingFightViewCtrl extends ui.view.load.LoadingFightViewUI {
        constructor() {
            super();
            this.loadingTime = 0;
            this.isLoadingComplete = false;
            this.count = 0;
            this.isClose = false;
            this.step = 0;
            this.width = Laya.stage.width;
            this.height = Laya.stage.height;
        }
        onAwake() {
            var that = this;
            SoundManager.playEffect(SOUND_PATH.STARTGAME);
            ModeManager.modeLoadSubPackage(function() {
                that.doStep();
                that.isLoadingComplete = true;
            });
            this.ani1.on(Laya.Event.COMPLETE, this, this.aniEnd);
        }
        aniEnd() {
            Laya.timer.loop(20, this, this.update);
            this.btnBack.on(Laya.Event.CLICK, this, this.onBtnClose);
            this.ani1.off(Laya.Event.COMPLETE, this, this.aniEnd);
        }
        onDestroy() {
            Laya.Tween.clearAll(UIManager.viewCommon);
            Laya.Tween.to(UIManager.viewCommon, {
                y: 21
            }, 300);
            Laya.timer.clearAll(this);
        }
        onBtnClose() {
            if (!CommonUtil.getTouch())
                return;
            this.isClose = true;
            SkinManager.getTrialArm(null);
            this.ani1.wrapMode = Laya.Animation.WRAP_REVERSE;
            this.ani1.play(0, false);
            var that = this;
            UIManager.getFunctionViewCtrl(FUNCTION_TAG.FIRST).closeLoading();
            this.ani1.on(Laya.Event.COMPLETE, this, function() {
                UIManager.closeFunction();
            });
        }
        update() {
            if (this.isClose)
                return;
            this.loadingTime += 20;
            if (this.count < 10) {
                if (this.isLoadingComplete) {
                    if (this.loadingTime > 200) {
                        this.loadingTime = 0;
                        this.count++;
                        if (this.count >= 10) {
                            this.boxComplete.visible = true;
                            this.boxLoading.visible = false;
                            this.doStep();
                        }
                    }
                } else {
                    if (this.loadingTime > 1000) {
                        this.loadingTime = 0;
                        this.count++;
                        if (this.count >= 10) {
                            this.boxComplete.visible = true;
                            this.boxLoading.visible = false;
                            this.doStep();
                        }
                    }
                }
            }
        }
        doStep() {
            if (this.isClose)
                return;
            this.step++;
            if (this.step >= 2) {
                this.isClose = true;
                ModeManager.modeLoad();
            }
        }
    }

    class ReviewLoadingFightViewCtrl extends ui.view.review.ReviewLoadingFightViewUI {
        constructor() {
            super();
            this.loadingTime = 0;
            this.isLoadingComplete = false;
            this.count = 0;
            this.isClose = false;
            this.step = 0;
            this.width = Laya.stage.width;
            this.height = Laya.stage.height;
        }
        onAwake() {
            var that = this;
            SoundManager.playEffect(SOUND_PATH.STARTGAME);
            ModeManager.modeLoadSubPackage(function() {
                that.doStep();
                that.isLoadingComplete = true;
            });
            this.aniEnd();
        }
        aniEnd() {
            Laya.timer.loop(20, this, this.update);
            this.btnBack.on(Laya.Event.CLICK, this, this.onBtnClose);
        }
        onDestroy() {
            Laya.timer.clearAll(this);
        }
        onBtnClose() {
            if (!CommonUtil.getTouch())
                return;
            this.isClose = true;
            SkinManager.getTrialArm(null);
            UIManager.closeFunction();
        }
        update() {
            if (this.isClose)
                return;
            this.loadingTime += 20;
            if (this.count < 10) {
                if (this.isLoadingComplete) {
                    if (this.loadingTime > 200) {
                        this.loadingTime = 0;
                        this.count++;
                        if (this.count >= 10) {
                            this.boxComplete.visible = true;
                            this.boxLoading.visible = false;
                            this.labelLoading.visible = false;
                            this.doStep();
                        }
                    }
                } else {
                    if (this.loadingTime > 1000) {
                        this.loadingTime = 0;
                        this.count++;
                        if (this.count >= 10) {
                            this.boxComplete.visible = true;
                            this.boxLoading.visible = false;
                            this.labelLoading.visible = false;
                            this.doStep();
                        }
                    }
                }
            }
            if (!this.labelNum)
                return;
            this.labelNum.text = this.count.toString();
            this.labelNum1.x = 7 + this.labelNum.width;
        }
        doStep() {
            if (this.isClose)
                return;
            this.step++;
            if (this.step >= 2) {
                this.isClose = true;
                ModeManager.modeLoad();
            }
        }
    }

    class LoadingFightFunction extends BaseFunction {
        createView() {
            if (ConfigManager.gameType == GAME_MJB_TYPE.QZHXJY && ConfigManager.isReviewVersion()) {
                this._viewCtrl = new ReviewLoadingFightViewCtrl();
            } else {
                this._viewCtrl = new LoadingFightViewCtrl();
            }
            return this._viewCtrl;
        }
        getFunctionName() {
            return '加载界面';
        }
        onEnter() { super.onEnter(); }
        onExit() { super.onExit(); }
        onEnable() {
            super.onEnable();
            if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD)
                AdUtil.hideBannerAd();
        }
        onDisbale() { super.onDisbale(); }
        setAllButtonAnalysePoint() {}
        request(cb) {
            cb();
        }
    }

    class ActivityEquipFunction extends BaseFunction {
        createView() {
            this._viewCtrl = new ActivityEquipViewCtrl(this.args);
            return this._viewCtrl;
        }
        getFunctionName() {
            return '活动武器界面';
        }
        onEnter() { super.onEnter(); }
        onExit() { super.onExit(); }
        onEnable() {
            super.onEnable();
            if (ConfigManager.platform == PLATFORM_TYPE.VIVO || ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS || (ConfigManager.appId == ANDROID_APP_ID.C233_ME || ConfigManager.appId == ANDROID_APP_ID.MMY || ConfigManager.appId == ANDROID_APP_ID.HYKB) || ConfigManager.appId == ANDROID_APP_ID.C_233) {
                AdUtil.showBannerAd();
            }
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || ConfigManager.platform == PLATFORM_TYPE.WX) {
                AdUtil.showCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                AdUtil.showCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
            }
        }
        onDisbale() {
            super.onDisbale();
            if (ConfigManager.platform == PLATFORM_TYPE.VIVO || ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS || (ConfigManager.appId == ANDROID_APP_ID.C233_ME || ConfigManager.appId == ANDROID_APP_ID.MMY || ConfigManager.appId == ANDROID_APP_ID.HYKB) || ConfigManager.appId == ANDROID_APP_ID.C_233) {
                AdUtil.hideBannerAd();
            }
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || ConfigManager.platform == PLATFORM_TYPE.WX) {
                AdUtil.hideCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                AdUtil.hideCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
            }
        }
        setAllButtonAnalysePoint() {}
        request(cb) {
            cb();
        }
    }

    class NewYearGiftCellViewCtrl extends ui.view.award.NewYearGiftCellViewUI {
        constructor(index, root) {
            super();
            this.isDown = false;
            this.data = NewYearGiftData.getDataByKey(index);
            this.root = root;
        }
        onAwake() {
            this.setView();
        }
        setView() {
            let count = RoleManager.getInstance().getFirecrackerInfo().count;
            this.imgUse.visible = false;
            this.labelCost.text = this.data.cost + '爆竹';
            if (this.data.cost <= count) {
                this.imgUse.visible = true;
            }
            this.labelCount.text = this.data.info;
            this.imgIcon.visible = false;
            this.imgArm.visible = false;
            switch (this.data.awardType) {
                case 1:
                    this.imgIcon.visible = true;
                    this.imgIcon.skin = RES_PATH.ITEM_ROOT + SPECIAL_ID.GOLD + '.png';
                    break;
                case 3:
                    this.imgIcon.visible = true;
                    this.imgIcon.skin = RES_PATH.ITEM_ROOT + SPECIAL_ID.DIAMONDS + '.png';
                    break;
                case 2:
                    this.imgArm.visible = true;
                    this.imgArm.skin = ARM.getDataByKey(this.data.award).icon;
                    break;
                default:
                    break;
            }
        }
    }

    class NewYearGiftViewCtrl extends ui.view.award.NewYearGiftViewUI {
        constructor(cb = null) {
            super();
            this.isDown = false;
            this.cb = null;
            this.autoOpen = [];
            this.cellctrlList = [];
            this.width = this.stage.width;
            this.height = this.stage.height;
            this.cb = cb;
            this.maxProgress = this.imgP.width;
            this.btnBack.on(Laya.Event.CLICK, this, this.onBtnBack);
            this.btnGet.on(Laya.Event.CLICK, this, this.onBtnGet);
            this.btnNo.on(Laya.Event.CLICK, this, this.onBtnBack);
        }
        onAwake() {
            this.uiPlatformConfig();
            this.init();
            this.setView();
        }
        onDestroy() {
            if (this.cb)
                this.cb();
            UIManager.triggerAutoOpen();
        }
        setView() {
            this.labelInfo.text = '已发放' + RoleManager.getInstance().getFirecrackerInfo().count + '爆竹';
            this.imgP.width = this.maxProgress * (Math.min(RoleManager.getInstance().getFirecrackerInfo().count / NewYearGiftData.getDataByKey(NewYearGiftData.keys[NewYearGiftData.keys.length - 1]).cost, 1));
            for (let index = 0; index < NewYearGiftData.keys.length; index++) {
                let ctrl = this.cellctrlList[index];
                ctrl.setView();
            }
        }
        init() {
            for (let index = 0; index < NewYearGiftData.keys.length; index++) {
                const element = NewYearGiftData.keys[index];
                let ctrl = new NewYearGiftCellViewCtrl(element, this);
                this.cellctrlList.push(ctrl);
                this.boxCell.addChild(ctrl);
            }
        }
        onBtnBack() {
            if (!CommonUtil.getTouch())
                return;
            for (let index = 0; index < this.autoOpen.length; index++) {
                const element = this.autoOpen[index];
                UIManager.registerAutoOpenFunction(element.funcTag, element.mode, element.type, element.commonMenuStyle, element.args, element.isCanRepetition);
            }
            UIManager.closeFunction();
        }
        onBtnGet() {
            if (!CommonUtil.getTouch())
                return;
            if (this.isDown)
                return;
            this.isDown = true;
            var that = this;
            AdUtil.setEvent(function() {
                that.isDown = false;
                that.getFirecracker();
            }, function() {
                that.isDown = false;
            }, REWARD_CTRL_TYPE.FIRECRACKER);
        }
        getFirecracker() {
            UIManager.isAutoOpen = false;
            if (this.autoOpen.length == 0)
                for (let index = 0; index < UIManager.autoList.length; index++) {
                    const element = UIManager.autoList[index];
                    this.autoOpen.push(element);
                }
            UIManager.autoList = [];
            GetBoxRewardNextViewCtrl.getAward([{
                itemId: SPECIAL_ID.FIRECRACKER,
                count: 10
            }, {
                itemId: 1001,
                count: 500
            }], FUNCTION_OPEN_MODE.COVER, true);
        }
        onMyEnable() {
            this.setView();
        }
        uiPlatformConfig() {
            UIManager.replaceAdIcon([{
                img: this.btnGet.getChildAt(1),
                type: 1
            }]);
            if (ConfigManager.platform == PLATFORM_TYPE.TT || ConfigManager.platform == PLATFORM_TYPE.WEB) {
                this.btnGet.x = 692;
                this.btnNo.visible = true;
            }
        }
    }

    class NewYearGiftFunction extends BaseFunction {
        createView() {
            this._viewCtrl = new NewYearGiftViewCtrl();
            return this._viewCtrl;
        }
        getFunctionName() {
            return '新年礼包界面';
        }
        onEnter() { super.onEnter(); }
        onExit() { super.onExit(); }
        onEnable() {
            super.onEnable();
            let view = this.viewCtrl;
            view.onMyEnable();
            if (ConfigManager.platform == PLATFORM_TYPE.VIVO || ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS || (ConfigManager.appId == ANDROID_APP_ID.C233_ME || ConfigManager.appId == ANDROID_APP_ID.MMY || ConfigManager.appId == ANDROID_APP_ID.HYKB) || ConfigManager.appId == ANDROID_APP_ID.C_233) {
                AdUtil.showBannerAd();
            }
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || ConfigManager.platform == PLATFORM_TYPE.WX) {
                AdUtil.showCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                AdUtil.showCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
            }
        }
        onDisbale() {
            super.onDisbale();
            if (ConfigManager.platform == PLATFORM_TYPE.VIVO || ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS || (ConfigManager.appId == ANDROID_APP_ID.C233_ME || ConfigManager.appId == ANDROID_APP_ID.MMY || ConfigManager.appId == ANDROID_APP_ID.HYKB) || ConfigManager.appId == ANDROID_APP_ID.C_233) {
                AdUtil.hideBannerAd();
            }
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || ConfigManager.platform == PLATFORM_TYPE.WX) {
                AdUtil.hideCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                AdUtil.hideCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
            }
        }
        setAllButtonAnalysePoint() {}
        request(cb) {
            cb();
        }
    }

    class MoreGameViewCtrl extends ui.view.common.MoreGameViewUI {
        constructor() {
            super();
            this.height = this.stage.height;
            this.width = this.stage.width;
            let size = PlatformUtil.getCustomMatrixSize();
            this.imgBg.width = this.stage.width;
            this.imgBg.height = this.stage.height;
            let x = Laya.stage.width / 2 - size.w - 16;
            let y = Laya.stage.height / 2 - size.h / 2;
            let x1 = Laya.stage.width / 2 + 16;
            var that = this;
            this.btnClose.on(Laya.Event.CLICK, this, function() {
                if (!CommonUtil.getTouch(500))
                    return;
                that.timer.clearAll(that);
                AdUtil.hideCustom(x, y, WX_CUSTOM_AD_STYLE.MATRIX);
                AdUtil.hideCustom(x1, y, WX_CUSTOM_AD_STYLE.MATRIX);
                UIManager.closeFunction();
            });
        }
        onDestroy() {}
    }

    class MoreGameFunction extends BaseFunction {
        createView() {
            this._viewCtrl = new MoreGameViewCtrl();
            return this._viewCtrl;
        }
        getFunctionName() {
            return '更多游戏界面';
        }
        onEnter() { super.onEnter(); }
        onExit() { super.onExit(); }
        onEnable() { super.onEnable(); }
        onDisbale() { super.onDisbale();}
        setAllButtonAnalysePoint() {}
        request(cb) {
            cb();
        }
    }

    class GameAirFunction extends BaseFunction {
        createView() {
            this._viewCtrl = new GameAirViewCtrl(this._args);
            return this._viewCtrl;
        }
        getFunctionName() {
            return '空投神枪界面';
        }
        onEnter() { super.onEnter(); }
        onExit() { super.onExit(); }
        onEnable() { super.onEnable(); }
        onDisbale() { super.onDisbale(); }
        setAllButtonAnalysePoint() {}
        request(cb) {
            cb();
        }
    }

    class NewPlayerTryArmViewCtrl extends ui.view.award.NewPlayerTryArmViewUI {
        constructor(args) {
            super();
            this.cb = null;
            this.id = 1;
            this.cb = args.cb;
            this.width = this.stage.width;
            this.height = this.stage.height;
            if (ConfigManager.platform == PLATFORM_TYPE.WEB_4399 && Laya.Browser.onPC) {
                Laya.Browser.document.exitPointerLock();
            }
        }
        onAwake() {
            let list = [];
            for (let k = 0; k < ARM.keys.length; k++) {
                if (ARM.getDataByKey(ARM.keys[k]).type == 1) {
                    list.push(ARM.keys[k]);
                }
            }
            let id = 40;
            this.id = id;
            let isHas = false;
            if (CharacterManger.playerLogicalBaseLayer.armCtrlList) {
                for (let k = 0; k < CharacterManger.playerLogicalBaseLayer.armCtrlList.length; k++) {
                    if (this.id == CharacterManger.playerLogicalBaseLayer.armCtrlList[k].getID()) {
                        isHas = true;
                    }
                }
            }
            if (isHas) {
                if (ARM.getDataByKey(id + 1)) {
                    this.id = id + 1;
                } else {
                    if (ARM.getDataByKey(id - 1)) {
                        this.id = id - 1;
                    }
                }
            }
            this.txtName.text = ARM.getDataByKey(this.id).name;
            this.imgIcon.skin = ARM.getDataByKey(this.id).icon;
            this.btnTry.on(Laya.Event.CLICK, this, this.onBtnTry);
        }
        onDestroy() {
            if (ConfigManager.platform == PLATFORM_TYPE.WEB_4399 && Laya.Browser.onPC) {
                let view = UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME);
                view.onBtnDown(true);
            }
        }
        onBtnTry() {
            if (!CommonUtil.getTouch())
                return;
            this.cb && this.cb(this.id);
            UIManager.closeFunction();
        }
    }

    class NewPlayerTryArmFunction extends BaseFunction {
        createView() {
            this._viewCtrl = new NewPlayerTryArmViewCtrl(this.args);
            return this._viewCtrl;
        }
        getFunctionName() {
            return '新手局内试用界面';
        }
        onEnter() { super.onEnter(); }
        onExit() { super.onExit(); }
        onEnable() { super.onEnable(); }
        onDisbale() { super.onDisbale(); }
        setAllButtonAnalysePoint() {}
        request(cb) {
            cb();
        }
    }

    class RecordViewCtrl extends ui.view.record.RecordViewUI {
        constructor(args) {
            super();
            this.cb = null;
            this.sucessCb = null;
            this.resPath = null;
            this.width = this.stage.width;
            this.height = this.stage.height;
            this.cb = args.cb;
            this.sucessCb = args.sucessCb;
            this.resPath = args.path;
        }
        onAwake() {
            let that = this;
            let gold = RewardManager.curFreeGoldRewards != 0 ? RewardManager.curFreeGoldRewards : 100;
            this.txtGold.text = '金币+' + gold.toString();
            this.btnRecord1.on(Laya.Event.CLICK, this, this.onBtnRecord);
            this.btnRecord2.on(Laya.Event.CLICK, this, this.onBtnRecord);
            this.btnBack.on(Laya.Event.CLICK, this, this.onBtnBack);
        }
        onDestroy() {}
        onBtnRecord() {
            if (!CommonUtil.getTouch())
                return;
            console.log("分享录屏");
            if (!this.resPath) {
                LogManager.showNotification("视频制作中, 请稍后重试");
            } else {
                let that = this;
                let gold = RewardManager.curFreeGoldRewards != 0 ? RewardManager.curFreeGoldRewards : 100;
                PlatformUtil.shareRecord("", "", this.resPath, function() {
                    if (UIManager.getFunction(FUNCTION_TAG.RECORD)) {
                        UIManager.closeFunction();
                    }
                    UIManager.openFunction(FUNCTION_TAG.GET_GOLD_REWARD, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.GOLD, gold);
                    let cb = that.cb;
                    let sucessCb = that.sucessCb;
                    cb && cb();
                    sucessCb && sucessCb();
                }, function() {
                    LogManager.showNotification("录屏分享失败");
                });
            }
        }
        onBtnBack() {
            if (!CommonUtil.getTouch())
                return;
            let cb = this.cb;
            UIManager.closeFunction();
            cb && cb();
        }
        screenShot() {
            let tempTexture2D = new Laya.Texture2D(749, 382);
            let tempTexture = new Laya.Texture(tempTexture2D);
            let cans = document.getElementById("layaCanvas");;
            tempTexture2D.loadImageSource(cans, true);
            let sp = new Laya.Sprite();
            sp.width = this.imgBg.width;
            sp.height = this.imgBg.height;
            this.imgBg.addChild(sp);
            sp.zOrder = 0;
            sp.graphics.drawImage(tempTexture, 0, 0, sp.width, sp.height);
        }
    }

    class RecordFunction extends BaseFunction {
        createView() {
            this._viewCtrl = new RecordViewCtrl(this.args);
            return this._viewCtrl;
        }
        getFunctionName() {
            return '录屏界面';
        }
        onEnter() { super.onEnter(); }
        onExit() { super.onExit(); }
        onEnable() { super.onEnable(); }
        onDisbale() { super.onDisbale(); }
        setAllButtonAnalysePoint() {}
        request(cb) {
            cb();
        }
    }

    class TurnTableData {
        static getDataByKey(key) {
            if (TurnTableData.cache[key])
                return TurnTableData.cache[key];
            if (key == 1) {
                let template = new TurnTableData();
                template.id = 1;
                template.info = '钻石X100';
                template.itemData = [{
                    award: 100,
                    awardType: 3,
                    armTime: 0
                }];
                template.type = 1;
                template.awardType = 3;
                TurnTableData.cache[key] = template;
                return template;
            } else if (key == 6) {
                let template = new TurnTableData();
                template.id = 6;
                template.info = '星际绝影(24小时)';
                template.itemData = [{
                    award: 49,
                    awardType: 2,
                    armTime: 86400
                }];
                template.type = 2;
                template.awardType = 2;
                TurnTableData.cache[key] = template;
                return template;
            } else if (key == 3) {
                let template = new TurnTableData();
                template.id = 3;
                template.info = '金币X600';
                template.itemData = [{
                    award: 7018,
                    awardType: 7,
                    armTime: 0,
                    count: 1
                }];
                template.type = 1;
                template.awardType = 7;
                TurnTableData.cache[key] = template;
                return template;
            } else if (key == 4) {
                let template = new TurnTableData();
                template.id = 4;
                template.info = '补给箱';
                template.itemData = [{
                    award: 6004,
                    awardType: 6,
                    armTime: 0,
                    count: 1
                }];
                template.type = 1;
                template.awardType = 6;
                TurnTableData.cache[key] = template;
                return template;
            } else if (key == 5) {
                let template = new TurnTableData();
                template.id = 5;
                template.info = '钻石X300';
                template.itemData = [{
                    award: 300,
                    awardType: 3,
                    armTime: 0
                }];
                template.type = 1;
                template.awardType = 3;
                TurnTableData.cache[key] = template;
                return template;
            } else if (key == 2) {
                let template = new TurnTableData();
                template.id = 2;
                template.info = '星际绝影(永久)';
                template.itemData = [{
                    award: 49,
                    awardType: 2,
                    armTime: 0
                }];
                template.type = 3;
                template.awardType = 2;
                TurnTableData.cache[key] = template;
                return template;
            } else if (key == 7) {
                let template = new TurnTableData();
                template.id = 7;
                template.info = '高级补给箱';
                template.itemData = [{
                    award: 0,
                    awrdType: 4,
                    armTime: 0
                }];
                template.type = 1;
                template.awardType = 5;
                TurnTableData.cache[key] = template;
                return template;
            } else if (key == 8) {
                let template = new TurnTableData();
                template.id = 8;
                template.info = '金币X1200';
                template.itemData = [{
                    award: 7014,
                    awardType: 7,
                    armTime: 0,
                    count: 1
                }];
                template.type = 1;
                template.awardType = 7;
                TurnTableData.cache[key] = template;
                return template;
            } else if (key == 9) {
                let template = new TurnTableData();
                template.id = 9;
                template.info = '钻石X100';
                template.itemData = [{
                    award: 100,
                    awardType: 3,
                    armTime: 0
                }];
                template.type = 1;
                template.awardType = 3;
                TurnTableData.cache[key] = template;
                return template;
            } else if (key == 14) {
                let template = new TurnTableData();
                template.id = 14;
                template.info = '纳罗时空(24小时)';
                template.itemData = [{
                    award: 50,
                    awardType: 2,
                    armTime: 86400
                }];
                template.type = 2;
                template.awardType = 2;
                TurnTableData.cache[key] = template;
                return template;
            } else if (key == 11) {
                let template = new TurnTableData();
                template.id = 11;
                template.info = '金币X600';
                template.itemData = [{
                    award: 6003,
                    awardType: 6,
                    armTime: 0,
                    count: 1
                }];
                template.type = 1;
                template.awardType = 6;
                TurnTableData.cache[key] = template;
                return template;
            } else if (key == 12) {
                let template = new TurnTableData();
                template.id = 12;
                template.info = '补给箱';
                template.itemData = [{
                    award: 7015,
                    awardType: 7,
                    armTime: 0,
                    count: 1
                }];
                template.type = 1;
                template.awardType = 7;
                TurnTableData.cache[key] = template;
                return template;
            } else if (key == 13) {
                let template = new TurnTableData();
                template.id = 13;
                template.info = '钻石X300';
                template.itemData = [{
                    award: 300,
                    awardType: 3,
                    armTime: 0
                }];
                template.type = 1;
                template.awardType = 3;
                TurnTableData.cache[key] = template;
                return template;
            } else if (key == 10) {
                let template = new TurnTableData();
                template.id = 10;
                template.info = '纳罗时空(永久)';
                template.itemData = [{
                    award: 50,
                    awardType: 2,
                    armTime: 0
                }];
                template.type = 3;
                template.awardType = 2;
                TurnTableData.cache[key] = template;
                return template;
            } else if (key == 15) {
                let template = new TurnTableData();
                template.id = 15;
                template.info = '高级补给箱';
                template.itemData = [{
                    award: 0,
                    awrdType: 4,
                    armTime: 0
                }];
                template.type = 1;
                template.awardType = 5;
                TurnTableData.cache[key] = template;
                return template;
            } else if (key == 16) {
                let template = new TurnTableData();
                template.id = 16;
                template.info = '金币X1200';
                template.itemData = [{
                    award: 6004,
                    awardType: 6,
                    armTime: 0,
                    count: 1
                }];
                template.type = 1;
                template.awardType = 6;
                TurnTableData.cache[key] = template;
                return template;
            } else if (key == 17) {
                let template = new TurnTableData();
                template.id = 17;
                template.info = '钻石X100';
                template.itemData = [{
                    award: 100,
                    awardType: 3,
                    armTime: 0
                }];
                template.type = 1;
                template.awardType = 3;
                TurnTableData.cache[key] = template;
                return template;
            } else if (key == 18) {
                let template = new TurnTableData();
                template.id = 18;
                template.info = '守护者之刃-永久';
                template.itemData = [{
                    award: 8011,
                    awardType: 9,
                    armTime: 0
                }];
                template.type = 2;
                template.awardType = 9;
                TurnTableData.cache[key] = template;
                return template;
            } else if (key == 19) {
                let template = new TurnTableData();
                template.id = 19;
                template.info = '金币X600';
                template.itemData = [{
                    award: 6005,
                    awardType: 6,
                    armTime: 0,
                    count: 1
                }];
                template.type = 1;
                template.awardType = 6;
                TurnTableData.cache[key] = template;
                return template;
            } else if (key == 20) {
                let template = new TurnTableData();
                template.id = 20;
                template.info = '补给箱';
                template.itemData = [{
                    award: 6003,
                    awardType: 6,
                    armTime: 0,
                    count: 1
                }];
                template.type = 1;
                template.awardType = 6;
                TurnTableData.cache[key] = template;
                return template;
            } else if (key == 21) {
                let template = new TurnTableData();
                template.id = 21;
                template.info = '钻石X300';
                template.itemData = [{
                    award: 300,
                    awardType: 3,
                    armTime: 0
                }];
                template.type = 1;
                template.awardType = 3;
                TurnTableData.cache[key] = template;
                return template;
            } else if (key == 22) {
                let template = new TurnTableData();
                template.id = 22;
                template.info = '嗜血狂鲨-永久';
                template.itemData = [{
                    award: 7008,
                    awardType: 7,
                    armTime: 0,
                    count: 1
                }];
                template.type = 3;
                template.awardType = 7;
                TurnTableData.cache[key] = template;
                return template;
            } else if (key == 23) {
                let template = new TurnTableData();
                template.id = 23;
                template.info = '高级补给箱';
                template.itemData = [{
                    award: 0,
                    awrdType: 4,
                    armTime: 0
                }];
                template.type = 1;
                template.awardType = 5;
                TurnTableData.cache[key] = template;
                return template;
            } else if (key == 24) {
                let template = new TurnTableData();
                template.id = 24;
                template.info = '金币X1200';
                template.itemData = [{
                    award: 6003,
                    awardType: 6,
                    armTime: 0,
                    count: 1
                }];
                template.type = 1;
                template.awardType = 6;
                TurnTableData.cache[key] = template;
                return template;
            } else if (key == 25) {
                let template = new TurnTableData();
                template.id = 25;
                template.info = '钻石X100';
                template.itemData = [{
                    award: 100,
                    awardType: 3,
                    armTime: 0
                }];
                template.type = 1;
                template.awardType = 3;
                TurnTableData.cache[key] = template;
                return template;
            } else if (key == 30) {
                let template = new TurnTableData();
                template.id = 30;
                template.info = '嗜血狂鲨-24小时';
                template.itemData = [{
                    award: 7015,
                    awardType: 7,
                    armTime: 86400,
                    count: 2
                }];
                template.type = 2;
                template.awardType = 7;
                TurnTableData.cache[key] = template;
                return template;
            } else if (key == 27) {
                let template = new TurnTableData();
                template.id = 27;
                template.info = '金币X600';
                template.itemData = [{
                    award: 6004,
                    awardType: 6,
                    armTime: 0,
                    count: 1
                }];
                template.type = 1;
                template.awardType = 6;
                TurnTableData.cache[key] = template;
                return template;
            } else if (key == 28) {
                let template = new TurnTableData();
                template.id = 28;
                template.info = '补给箱';
                template.itemData = [{
                    award: 6005,
                    awardType: 6,
                    armTime: 0,
                    count: 1
                }];
                template.type = 1;
                template.awardType = 6;
                TurnTableData.cache[key] = template;
                return template;
            } else if (key == 29) {
                let template = new TurnTableData();
                template.id = 29;
                template.info = '钻石X300';
                template.itemData = [{
                    award: 300,
                    awardType: 3,
                    armTime: 0
                }];
                template.type = 1;
                template.awardType = 3;
                TurnTableData.cache[key] = template;
                return template;
            } else if (key == 26) {
                let template = new TurnTableData();
                template.id = 26;
                template.info = '幽灵猎手-永久';
                template.itemData = [{
                    award: 5005,
                    awardType: 5,
                    armTime: 0,
                    count: 1
                }];
                template.type = 3;
                template.awardType = 8;
                TurnTableData.cache[key] = template;
                return template;
            } else if (key == 31) {
                let template = new TurnTableData();
                template.id = 31;
                template.info = '高级补给箱';
                template.itemData = [{
                    award: 0,
                    awrdType: 4,
                    armTime: 0
                }];
                template.type = 1;
                template.awardType = 5;
                TurnTableData.cache[key] = template;
                return template;
            } else if (key == 32) {
                let template = new TurnTableData();
                template.id = 32;
                template.info = '金币X1200';
                template.itemData = [{
                    award: 7007,
                    awardType: 7,
                    armTime: 0,
                    count: 1
                }];
                template.type = 1;
                template.awardType = 7;
                TurnTableData.cache[key] = template;
                return template;
            } else if (key == 33) {
                let template = new TurnTableData();
                template.id = 33;
                template.info = '钻石X100';
                template.itemData = [{
                    award: 100,
                    awardType: 3,
                    armTime: 0
                }];
                template.type = 1;
                template.awardType = 3;
                TurnTableData.cache[key] = template;
                return template;
            } else if (key == 34) {
                let template = new TurnTableData();
                template.id = 34;
                template.info = '嗜血狂鲨-24小时';
                template.itemData = [{
                    award: 47,
                    awardType: 6,
                    armTime: 86400,
                    count: 2
                }];
                template.type = 2;
                template.awardType = 10;
                TurnTableData.cache[key] = template;
                return template;
            } else if (key == 35) {
                let template = new TurnTableData();
                template.id = 35;
                template.info = '金币X600';
                template.itemData = [{
                    award: 7008,
                    awardType: 7,
                    armTime: 0,
                    count: 1
                }];
                template.type = 1;
                template.awardType = 11;
                TurnTableData.cache[key] = template;
                return template;
            } else if (key == 36) {
                let template = new TurnTableData();
                template.id = 36;
                template.info = '补给箱';
                template.itemData = [{
                    award: 7020,
                    awardType: 7,
                    armTime: 0,
                    count: 1
                }];
                template.type = 1;
                template.awardType = 10;
                TurnTableData.cache[key] = template;
                return template;
            } else if (key == 37) {
                let template = new TurnTableData();
                template.id = 37;
                template.info = '钻石X300';
                template.itemData = [{
                    award: 300,
                    awardType: 3,
                    armTime: 0
                }];
                template.type = 1;
                template.awardType = 3;
                TurnTableData.cache[key] = template;
                return template;
            } else if (key == 38) {
                let template = new TurnTableData();
                template.id = 38;
                template.info = '嗜血狂鲨-永久';
                template.itemData = [{
                    award: 47,
                    awardType: 6,
                    armTime: 86400,
                    count: 2
                }];
                template.type = 3;
                template.awardType = 11;
                TurnTableData.cache[key] = template;
                return template;
            } else if (key == 39) {
                let template = new TurnTableData();
                template.id = 39;
                template.info = '高级补给箱';
                template.itemData = [{
                    award: 0,
                    awrdType: 4,
                    armTime: 0
                }];
                template.type = 1;
                template.awardType = 5;
                TurnTableData.cache[key] = template;
                return template;
            } else if (key == 40) {
                let template = new TurnTableData();
                template.id = 40;
                template.info = '金币X1200';
                template.itemData = [{
                    award: 7015,
                    awardType: 7,
                    armTime: 0,
                    count: 1
                }];
                template.type = 1;
                template.awardType = 11;
                TurnTableData.cache[key] = template;
                return template;
            }
        }
        static getDataByIndex(index) {
            if (TurnTableData.cache[this.keys[index]])
                return TurnTableData.cache[this.keys[index]];
            return this.getDataByKey(this.keys[index]);
        }
        static getAllData() {
            for (let index = 0; index < this.keys.length; index++) {
                this.getDataByKey(this.keys[index]);
            }
            return TurnTableData.cache;
        }
        clear() {
            TurnTableData.cache = {};
        }
    }
    TurnTableData.cache = {};
    TurnTableData.keys = [1, 6, 3, 4, 5, 2, 7, 8, 9, 14, 11, 12, 13, 10, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 30, 27, 28, 29, 26, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40];

    var TURN_TABLE_CELL_TYPE;
    (function(TURN_TABLE_CELL_TYPE) {
        TURN_TABLE_CELL_TYPE[TURN_TABLE_CELL_TYPE["NORMAL"] = 0] = "NORMAL";
        TURN_TABLE_CELL_TYPE[TURN_TABLE_CELL_TYPE["EFFECT"] = 1] = "EFFECT";
        TURN_TABLE_CELL_TYPE[TURN_TABLE_CELL_TYPE["TURN"] = 2] = "TURN";
        TURN_TABLE_CELL_TYPE[TURN_TABLE_CELL_TYPE["UNLOCK"] = 3] = "UNLOCK";
    })(TURN_TABLE_CELL_TYPE || (TURN_TABLE_CELL_TYPE = {}));
    class TurnTableCellViewCtrl extends ui.view.turnTable.TurnTableCellViewUI {
        constructor(index, times) {
            super();
            this.type = TURN_TABLE_CELL_TYPE.NORMAL;
            this.lastType = TURN_TABLE_CELL_TYPE.NORMAL;
            this.times = times;
            this.index = index;
        }
        onAwake() {
            this.init();
            if (!RoleManager.getInstance().isGetTurnAward(this.index))
                this.setView(TURN_TABLE_CELL_TYPE.NORMAL);
            else
                this.setView(TURN_TABLE_CELL_TYPE.UNLOCK);
        }
        reSet(index, times) {
            this.times = times;
            this.index = index;
            this.init();
            this.type = TURN_TABLE_CELL_TYPE.NORMAL;
            this.lastType = TURN_TABLE_CELL_TYPE.NORMAL;
            if (!RoleManager.getInstance().isGetTurnAward(this.index))
                this.setView(TURN_TABLE_CELL_TYPE.NORMAL);
            else
                this.setView(TURN_TABLE_CELL_TYPE.UNLOCK);
        }
        setView(type) {
            if (this.data.type == 1) {
                this.setImgState(type, this.boxSelectNormal, this.imgChoseNormal, this.boxNormaltem);
            } else {
                this.setImgState(type, this.boxSelectGun, this.imgChoseGun, this.boxGunItem);
            }
            this.type = type;
            if (type == TURN_TABLE_CELL_TYPE.NORMAL || type == TURN_TABLE_CELL_TYPE.UNLOCK) {
                if (this.lastType != TURN_TABLE_CELL_TYPE.UNLOCK) {
                    this.lastType = type;
                }
            }
        }
        init() {
            this.data = TurnTableData.getDataByKey(this.index + (Math.min(4, (this.times - 1)) * 8));
            this.boxGun.visible = false;
            this.boxNormal.visible = false;
            if (this.data.type == 1) {
                this.boxNormal.visible = true;
                if (!this.cellCtrl) {
                    this.cellCtrl = new BoxItemCellViewCtrl();
                    this.boxNormaltem.addChild(this.cellCtrl);
                }
                this.setImgIcon(this.imgNormal, this.labelNormal, this.boxNormaltem);
            } else {
                this.boxGun.visible = true;
                if (!this.cellCtrl) {
                    this.cellCtrl = new BoxItemCellViewCtrl();
                    this.boxGunItem.addChild(this.cellCtrl);
                }
                this.setImgIcon(this.imgGun, this.labelGun, this.boxGunItem);
            }
            this.aniEfffect.off(Laya.Event.LABEL, this, this.onAnieffect);
            this.aniEfffect.on(Laya.Event.LABEL, this, this.onAnieffect);
        }
        onAnieffect(label) {
            if (label == 'labelSound')
                SoundManager.playEffect(SOUND_PATH.TURN_TABLE);
            if (label == 'labelEnd') {
                {
                    SoundManager.playEffect(SOUND_PATH.TURN_TABLE);
                    this.setView(TURN_TABLE_CELL_TYPE.UNLOCK);
                    RoleManager.getInstance().setTurnAward(this.index);
                    let info = RoleManager.getInstance().getTurnInfo();
                    this.getAward();
                    UIManager.getFunctionViewCtrl(FUNCTION_TAG.TURNTABLE).setView();
                }
            }
        }
        setImgIcon(imgIcon, label, box) {
            label.text = this.data.info;
            imgIcon.scale(1, 1);
            imgIcon.visible = true;
            box.visible = false;
            label.fontSize = 22;
            switch (this.data.awardType) {
                case 1:
                    if (this.data.itemData[0].award < 500)
                        imgIcon.skin = RES_PATH.ITEM_ROOT + SPECIAL_ID.GOLD + '.png';
                    else {
                        imgIcon.skin = RES_PATH.ITEM_ROOT + SPECIAL_ID.GOLD1 + '.png';
                    }
                    break;
                case 3:
                    imgIcon.scale(0.9, 0.9);
                    if (this.data.itemData[0].award < 200)
                        imgIcon.skin = RES_PATH.ITEM_ROOT + SPECIAL_ID.DIAMONDS + '.png';
                    else
                        imgIcon.skin = RES_PATH.ITEM_ROOT + SPECIAL_ID.DIAMONDS1 + '.png';
                    break;
                case 2:
                    imgIcon.skin = ARM.getDataByKey(this.data.itemData[0].award).icon;
                    break;
                case 4:
                    imgIcon.skin = 'sub1/ui/sign/img_12.png';
                    break;
                case 5:
                    imgIcon.skin = 'sub1/ui/gameBox/img_1.png';
                    imgIcon.scale(0.7, 0.7);
                    break;
                case 6:
                case 7:
                case 10:
                case 11:
                    {
                        imgIcon.visible = false;
                        box.visible = true;
                        console.log('setImgIcon', this.data);
                        let info = RoleManager.getInstance().getTurnItemInfo(this.index, this.times);
                        console.log('setImgIcon', info);
                        this.cellCtrl.setView(info.itemId, info.count);
                        this.cellCtrl.imgDebris.visible = true;
                        this.cellCtrl.labelCount.visible = true;
                        this.cellCtrl.boxDebrisP.visible = false;
                        this.cellCtrl.labelName.visible = false;
                        this.cellCtrl.show();
                        label.text = this.cellCtrl.itemData.name + 'x' + this.cellCtrl.count;
                        label.fontSize = 17;
                        if (this.data.type >= 2) {
                            label.fontSize = 22;
                        }
                    }
                    break;
                case 8:
                    {
                        imgIcon.scale(0.6, 0.6);
                        let itemData = Item.getDataByKey(this.data.itemData[0].award);
                        let partData = RoleData.getDataByKey(itemData.extra());
                        imgIcon.skin = partData.icon;
                    }
                    break;
                case 9:
                    {
                        imgIcon.scale(0.6, 0.6);
                        let itemData = Item.getDataByKey(this.data.itemData[0].award);
                        let partData = PARTS.getDataByKey(itemData.extra());
                        imgIcon.skin = partData.icon;
                    }
                    break;
                default:
                    break;
            }
        }
        setImgState(type, box, img, item) {
            img.visible = false;
            box.visible = false;
            switch (type) {
                case TURN_TABLE_CELL_TYPE.EFFECT:
                    this.aniEfffect.play(0, false);
                    if (this.type == TURN_TABLE_CELL_TYPE.UNLOCK) {
                        console.log('bug');
                    }
                    SoundManager.playEffect(SOUND_PATH.TURN_TABLE);
                    break;
                case TURN_TABLE_CELL_TYPE.NORMAL:
                    if (this.type == TURN_TABLE_CELL_TYPE.UNLOCK) {
                        box.visible = true;
                    }
                    break;
                case TURN_TABLE_CELL_TYPE.TURN:
                    SoundManager.playEffect(SOUND_PATH.TURN_TABLE);
                    if (this.type == TURN_TABLE_CELL_TYPE.UNLOCK) {
                        box.visible = true;
                    }
                    img.visible = true;
                    break;
                case TURN_TABLE_CELL_TYPE.UNLOCK:
                    box.visible = true;
                    break;
            }
        }
        onDestroy() {
            LayaExtend.autoUnlinkUIReference(this);
        }
        getAward() {
            switch (this.data.awardType) {
                case 1:
                    UIManager.openFunction(FUNCTION_TAG.GET_GOLD_REWARD, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.GOLD, this.data.itemData[0].award);
                    break;
                case 3:
                    UIManager.openFunction(FUNCTION_TAG.GET_DIAMONDS_REWARD, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.DIAMOND, {
                        reward: this.data.itemData[0].award,
                        cb: null
                    });
                    break;
                case 2:
                    PeopleFactory.getInstance().getEquip(this.data.itemData[0].award, function() {}, this.data.itemData[0].armTime);
                    break;
                case 4:
                    let list = [];
                    for (let index = 0; index < this.data.itemData.length; index++) {
                        const element = this.data.itemData[index];
                        if (element.awardType == 1) {
                            if (element.award > 500) {
                                list.push({
                                    itemId: SPECIAL_ID.GOLD1,
                                    count: element.award
                                });
                            } else {
                                list.push({
                                    itemId: SPECIAL_ID.GOLD,
                                    count: element.award
                                });
                            }
                        } else {
                            if (element.awardType == 3) {
                                if (element.award > 200) {
                                    list.push({
                                        itemId: SPECIAL_ID.DIAMONDS1,
                                        count: element.award
                                    });
                                } else {
                                    list.push({
                                        itemId: SPECIAL_ID.DIAMONDS,
                                        count: element.award
                                    });
                                }
                            }
                        }
                    }
                    GetBoxRewardNextViewCtrl.adSuccess(list, true);
                    UIManager.openFunction(FUNCTION_TAG.GET_BOX_REWARD_NEXT, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE, list);
                    break;
                case 5:
                    RewardManager.setfreeRewardForGoldCoins();
                    UIManager.openFunction(FUNCTION_TAG.GET_GOLD_REWARD, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.GOLD, RewardManager.curFreeGoldRewards * 2);
                    break;
                case 6:
                case 7:
                case 11:
                case 10:
                    let info = RoleManager.getInstance().getTurnItemInfo(this.index, this.times);
                    GetBoxRewardNextViewCtrl.getAward([{
                        itemId: info.itemId,
                        count: info.count
                    }], FUNCTION_OPEN_MODE.COVER, true);
                    break;
                case 8:
                case 9:
                    UIManager.openFunction(FUNCTION_TAG.GET_EQUIP_REWARD, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE, {
                        id: this.data.itemData[0].award,
                        cb: null
                    });
                    break;
                default:
                    break;
            }
        }
    }

    let str = ['一', '二'];
    class TurnTableViewCtrl extends ui.view.turnTable.TurnTableViewUI {
        constructor() {
            super();
            this.cellCtrlList = [];
            this.isTurnTable = false;
            this.isDown = false;
            this.turnIndex = 0;
            this.awardIndex = 0;
            this.width = Laya.stage.width;
            this.height = Laya.stage.height;
        }
        onAwake() {
            this.init();
            this.btnBack.on(Laya.Event.CLICK, this, this.onBtnBack);
            this.btnGet.on(Laya.Event.CLICK, this, this.onBtnTurn);
        }
        onBtnBack() {
            if (!CommonUtil.getTouch())
                return;
            if (this.isDown)
                return;
            if (this.isTurnTable) {
                LogManager.showNotification('正在抽奖中');
                return;
            }
            UIManager.closeFunction();
        }
        onDestroy() {}
        init() {
            this.cellCtrlList = [];
            let info = RoleManager.getInstance().getTurnInfo();
            for (let index = 0; index < this.boxCell.numChildren; index++) {
                const element = this.boxCell.getChildAt(index);
                element.removeChildren();
                let ctrl = new TurnTableCellViewCtrl(index + 1, info.state);
                element.addChild(ctrl);
                this.cellCtrlList.push(ctrl);
            }
            this.labelTimes.text = '第' + info.state + '轮';
            this.img1.visible = false;
            this.img2.visible = false;
            this.boxDebris.visible = false;
            this.boxGun.visible = false;
            if (info.state >= 3) {
                this.labelInfo.text = '次必得稀有碎片';
                this.boxDebris.visible = true;
                this.labelLog.text = '稀有碎片';
            } else {}
            this.labelCount.text = '再抽' + (8 - info.lib.length) + '次必得';
            if (info.state == 1) {
                this.boxGun.visible = true;
                this.img2.visible = true;
            }
            if (info.state == 2) {
                this.boxGun.visible = true;
                this.img1.visible = true;
            }
            this.labelCount.text = '再抽' + (8 - info.lib.length) + '次必得';
        }
        setView() {
            this.img1.visible = false;
            this.img2.visible = false;
            this.boxDebris.visible = false;
            this.boxGun.visible = false;
            let info = RoleManager.getInstance().getTurnInfo();
            for (let index = 0; index < this.cellCtrlList.length; index++) {
                const element = this.cellCtrlList[index];
                element.reSet(index + 1, info.state);
            }
            this.labelTimes.text = '第' + info.state + '轮';
            if (info.state >= 3) {
                this.labelInfo.text = '次必得稀有碎片';
                this.boxDebris.visible = true;
                this.labelLog.text = '稀有碎片';
            } else {}
            this.labelCount.text = '再抽' + (8 - info.lib.length) + '次必得';
            if (info.state == 1) {
                this.boxGun.visible = true;
                this.img2.visible = true;
            }
            if (info.state == 2) {
                this.boxGun.visible = true;
                this.img1.visible = true;
            }
        }
        onBtnTurn() {
            if (!CommonUtil.getTouch())
                return;
            if (this.isDown)
                return;
            if (this.isTurnTable) {
                LogManager.showNotification('正在抽奖中');
                return;
            }
            this.isDown = true;
            AdUtil.setEvent(() => {
                this.turnTable();
                this.isDown = false;
            }, () => {
                this.isDown = false;
            }, REWARD_CTRL_TYPE.TURNTABLE);
        }
        turnTable() {
            if (this.isTurnTable)
                return;
            this.isTurnTable = true;
            this.turnIndex = 0;
            this.awardIndex = this.getAwardIndex();
            Laya.timer.clearAll(this);
            Laya.timer.scale = 4;
            Laya.timer.loop(500, this, this.update);
        }
        update() {
            this.turnIndex++;
            for (let index = 0; index < this.cellCtrlList.length; index++) {
                const element = this.cellCtrlList[index];
                element.setView(element.lastType);
            }
            if (this.turnIndex >= 8 * 3) {
                Laya.timer.scale = 0.8;
                if (this.turnIndex % 8 == this.awardIndex) {
                    this.isTurnTable = false;
                    console.log('转动结束');
                    Laya.timer.scale = 1;
                    this.cellCtrlList[this.turnIndex % 8].setView(TURN_TABLE_CELL_TYPE.EFFECT);
                    Laya.timer.clearAll(this);
                    return;
                }
            }
            if (this.turnIndex >= 8 * 1) {
                Laya.timer.scale = 3;
            }
            if (this.turnIndex >= 8 * 2) {
                Laya.timer.scale = 2;
            }
            if (this.turnIndex >= 8 * 2 + 4) {
                Laya.timer.scale = 1;
            }
            this.cellCtrlList[this.turnIndex % 8].setView(TURN_TABLE_CELL_TYPE.TURN);
        }
        getAwardIndex() {
            let list = [];
            let endCell;
            for (let index = 0; index < this.cellCtrlList.length; index++) {
                const element = this.cellCtrlList[index];
                if (element.type == TURN_TABLE_CELL_TYPE.NORMAL) {
                    if (element.data.type != 3)
                        list.push(element);
                    else {
                        endCell = element;
                    }
                }
            }
            if (list.length == 0) {
                if (endCell == null) {
                    console.log('xcfcfBug');
                }
                list.push(endCell);
            }
            return list[Math.floor(Math.random() * list.length)].index - 1;
        }
    }

    class TurnTableFunction extends BaseFunction {
        createView() {
            this._viewCtrl = new TurnTableViewCtrl();
            return this._viewCtrl;
        }
        getFunctionName() {
            return '转盘界面';
        }
        onEnter() { super.onEnter(); }
        onExit() { super.onExit(); }
        onEnable() {
            super.onEnable();
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || ConfigManager.platform == PLATFORM_TYPE.WX) {
                AdUtil.showCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                AdUtil.showCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
            }
        }
        onDisbale() {
            super.onDisbale();
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || ConfigManager.platform == PLATFORM_TYPE.WX) {
                AdUtil.hideCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                AdUtil.hideCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
            }
        }
        setAllButtonAnalysePoint() {}
        request(cb) {
            cb();
        }
    }

    class EndGameBoxViewCtrl extends ui.view.gameBox.EndGameBoxViewUI {
        constructor() {
            super();
            this.isDown = false;
            this.width = this.stage.width;
            this.height = this.stage.height;
        }
        onAwake() {
            this.init();
            this.setEvent();
        }
        onDestroy() {}
        init() {
            this.ani1.play(0, true);
            this.ani2.play(0, true);
        }
        setEvent() {
            this.btnOpen.on(Laya.Event.CLICK, this, this.onBtnOpen);
            this.btnNo.on(Laya.Event.CLICK, this, this.onBtnNo);
        }
        onBtnNo() {
            if (!CommonUtil.getTouch())
                return;
            if (this.isDown)
                return;
            let score = CharacterManger.playerLogicalBaseLayer ? CharacterManger.playerLogicalBaseLayer.playerKillCount : 2;
            score += 1;
            UIManager.openFunction(FUNCTION_TAG.GET_BOX_REWARD, FUNCTION_OPEN_MODE.REPLACE, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE, {
                itemList: [{
                    itemId: RoleManager.getInstance().getBoxTragmentId().itemId,
                    count: 2,
                    isExtra: true
                }, {
                    itemId: '1001',
                    count: RewardManager.getSeniorBoxReward().gold
                }, {
                    itemId: '2001',
                    count: RewardManager.getSeniorBoxReward().diamonds * 2
                }, {
                    itemId: '3001',
                    count: score * 2
                }, {
                    itemId: '1001',
                    count: RewardManager.getSeniorBoxReward().gold
                }]
            });
        }
        onBtnOpen() {
            if (!CommonUtil.getTouch())
                return;
            if (this.isDown)
                return;
            this.isDown = true;
            var that = this;
            let score = CharacterManger.playerLogicalBaseLayer ? CharacterManger.playerLogicalBaseLayer.playerKillCount : 2;
            score += 1;
            AdUtil.setEvent(function() {
                that.isDown = false;
                UIManager.openFunction(FUNCTION_TAG.GET_BOX_REWARD, FUNCTION_OPEN_MODE.REPLACE, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE, {
                    itemList: [{
                        itemId: RoleManager.getInstance().getBoxTragmentId().itemId,
                        count: 2,
                        isExtra: true
                    }, {
                        itemId: '1001',
                        count: RewardManager.getSeniorBoxReward().gold * 3
                    }, {
                        itemId: '2001',
                        count: RewardManager.getSeniorBoxReward().diamonds * 2
                    }, {
                        itemId: '3001',
                        count: score * 2
                    }, {
                        itemId: RoleManager.getInstance().getBoxTragmentId().itemId,
                        count: 1
                    }]
                });
            }, function() {
                that.isDown = false;
            }, REWARD_CTRL_TYPE.BOX_REWARD);
        }
    }

    class EndGameBoxFunction extends BaseFunction {
        createView() {
            this._viewCtrl = new EndGameBoxViewCtrl();
            return this._viewCtrl;
        }
        getFunctionName() {
            return '结算宝箱界面';
        }
        onEnter() { super.onEnter(); }
        onExit() { super.onExit(); }
        onEnable() {
            super.onEnable();
            if (ConfigManager.platform == PLATFORM_TYPE.WX) {
                AdUtil.showCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                AdUtil.showCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
            }
        }
        onDisbale() {
            super.onDisbale();
            if (ConfigManager.platform == PLATFORM_TYPE.WX) {
                AdUtil.hideCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                AdUtil.hideCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
            }
        }
        setAllButtonAnalysePoint() {}
        request(cb) {
            cb();
        }
    }

    class ShopTryViewCtrl extends ui.view.equipTry.ShopTryViewUI {
        constructor(args) {
            super();
            this.id = 1;
            this.id = args.id;
        }
        onAwake() {
            this.ani1.play(0, true);
            this.ani2.play(0, true);
            this.imgIcon.skin = ARM.getDataByKey(this.id).icon;
            this.txtName.text = ARM.getDataByKey(this.id).name;
            this.txtLv.text = this.id.toString();
            this.btnNo.visible = true;
            this.btnAd.on(Laya.Event.CLICK, this, this.onBtnAd);
            this.btnClose.on(Laya.Event.CLICK, this, this.onBtnClose);
            this.btnNo.on(Laya.Event.CLICK, this, this.onBtnClose);
            this.btnClose.visible = false;
        }
        onDestroy() {}
        onBtnAd() {
            if (!CommonUtil.getTouch())
                return;
            let that = this;
            AdUtil.setEvent(function() {
                RoleManager.getInstance().trialArm = that.id;
                UIManager.closeFunction();
                ModeManager.modeLoad(true);
            }, function() {}, REWARD_CTRL_TYPE.SHOP_TRY);
        }
        onBtnClose() {
            if (!CommonUtil.getTouch())
                return;
            UIManager.closeFunction();
        }
        uiPlatformConfig() {
            UIManager.replaceAdIcon([{
                img: this.btnAd.getChildAt(0),
                type: 1
            }]);
        }
    }

    class ShopTryFunction extends BaseFunction {
        createView() {
            this._viewCtrl = new ShopTryViewCtrl(this.args);
            return this._viewCtrl;
        }
        getFunctionName() {
            return '商店试用界面';
        }
        onEnter() { super.onEnter(); }
        onExit() { super.onExit(); }
        onEnable() {
            super.onEnable();
            AdUtil.showBannerAd();
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || PLATFORM_TYPE.WX == ConfigManager.platform || PLATFORM_TYPE.NATIVE_ANDRIOD == ConfigManager.platform) {
                let x = PlatformUtil.getBannerCenterPos().x + PlatformUtil.getBannerWeight() + 30;
                let y = Laya.stage.height - PlatformUtil.getCustomSize().h;
                let x1 = PlatformUtil.getBannerCenterPos().x - PlatformUtil.getCustomSize().w - 30;
                if (ConfigManager.platform == PLATFORM_TYPE.WX) {
                    AdUtil.showCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                    AdUtil.showCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                } else {
                    AdUtil.showCustom(x, y);
                    AdUtil.showCustom(x1, y);
                }
            }
        }
        onDisbale() {
            super.onDisbale();
            AdUtil.hideBannerAd();
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || PLATFORM_TYPE.WX == ConfigManager.platform || PLATFORM_TYPE.NATIVE_ANDRIOD == ConfigManager.platform) {
                let x = PlatformUtil.getBannerCenterPos().x + PlatformUtil.getBannerWeight() + 30;
                let y = Laya.stage.height - PlatformUtil.getCustomSize().h;
                let x1 = PlatformUtil.getBannerCenterPos().x - PlatformUtil.getCustomSize().w - 30;
                if (ConfigManager.platform == PLATFORM_TYPE.WX) {
                    AdUtil.hideCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                    AdUtil.hideCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                } else {
                    AdUtil.hideCustom(x, y);
                    AdUtil.hideCustom(x1, y);
                }
            }
        }
        setAllButtonAnalysePoint() {}
        request(cb) {
            cb();
        }
    }

    class RoleTryViewCtrl extends ui.view.equipTry.RoleTryViewUI {
        constructor(args) {
            super();
            this.id = 1;
            this.modelType = 1;
            this.scene3D = null;
            this._translate2 = new Laya.Vector3(5, -10, 1);
            this._translate = new Laya.Vector3(0, 0, 0);
            this.sp = null;
            this._pos = new Laya.Vector3(310, 500, 0);
            if (typeof args.modelType === 'undefined') {
                args.modelType = Math.random() < 0.5 ? 1 : 0;
            }
            if (typeof args.id === 'undefined') {
                if (args.modelType == 0) {
                    args.id = this.getRandomPartId();
                } else {
                    args.id = this.getRandomRoleId();
                }
            }
            this.id = args.id;
            this.modelType = args.modelType;
            this.width = Laya.stage.width;
            this.cb = args.cb;
        }
        getRandomPartId() {
            let list = [];
            let mySkinLib = RoleManager.getInstance().getPartLib();
            for (let k = 0; k < PARTS.keys.length; k++) {
                let isExist = false;
                for (let k2 in mySkinLib) {
                    if (mySkinLib[k2] == PARTS.getDataByKey(k + 1).id) {
                        isExist = true;
                        break;
                    }
                    if (!isExist) {
                        let data = PARTS.getDataByKey(k + 1);
                        if (data.hd == 0) {
                            list.push(data.id);
                        }
                    }
                }
            }
            if (list.length > 0) {
                let idx = Math.floor(Math.random() * list.length);
                return list[idx];
            } else {
                return 1;
            }
        }
        getRandomRoleId() {
            let list = [];
            let mySkinLib = RoleManager.getInstance().getRoleSkinLib();
            for (let k = 0; k < RoleData.keys.length; k++) {
                let isExist = false;
                for (let k2 in mySkinLib) {
                    if (mySkinLib[k2] == RoleData.getDataByKey(k + 1).id) {
                        isExist = true;
                        break;
                    }
                    if (!isExist) {
                        let data = RoleData.getDataByKey(k + 1);
                        if (data.hd == 0) {
                            list.push(data.id);
                        }
                    }
                }
            }
            if (list.length > 0) {
                let idx = Math.floor(Math.random() * list.length);
                return list[idx];
            } else {
                return 1;
            }
        }
        onAwake() {
            if (this.modelType == 1) {
                this.txtLabel.text = '"新英雄"免费试用';
                this.txtContent.text = '是否试用该角色进入对局？';
                this.txtName.text = RoleData.getDataByKey(this.id).cnName;
            } else if (this.modelType == 0) {
                this.txtLabel.text = '"新装备"免费试用';
                this.txtContent.text = '是否试用该装备进入对局？';
                this.txtName.text = PARTS.getDataByKey(this.id).cnName;
            }
            this.btnNo.visible = true;
            this.btnAd.on(Laya.Event.CLICK, this, this.onBtnAd);
            this.btnNo.on(Laya.Event.CLICK, this, this.onBtnClose);
            this.uiPlatformConfig();
            this.create3D();
            this.timer.frameLoop(1, this, this.update);
        }
        onDestroy() {}
        update() {
            if (!this.sp)
                return;
            this.sp.transform.localRotationEulerY++;
        }
        create3D() {
            var scene = this.addChild(new Laya.Scene3D());
            var camera = scene.addChild(new Laya.Camera(0, 0.1, 1000));
            this.scene3D = scene;
            camera.transform.translate(this._translate2);
            camera.orthographic = true;
            camera.enableHDR = false;
            camera.clearColor = new Laya.Vector4(0.0, 0.0, 0.0, 0.0);
            var renderTexture = new Laya.RenderTexture(512, 512, Laya.RenderTextureFormat.R8G8B8A8, Laya.RenderTextureDepthFormat.DEPTH_16);
            camera.renderTarget = renderTexture;
            camera.orthographicVerticalSize = 10;
            scene.addChild(new Laya.DirectionLight());
            camera.convertScreenCoordToOrthographicCoord(this._pos, this._translate);
            this._translate.x += 3;
            this._translate.y -= 2;
            this.img3DCenter.source = new Laya.Texture(renderTexture);
            if (this.sp) {
                this.sp.destroy();
                this.sp = null;
            }
            if (this.modelType == 1) {
                this.sp = SkinManager.createRoleViewSkin(this._translate, this.scene3D, false, this.id);
                this.sp.transform.localRotationEulerY = 20;
                this.sp.transform.localPositionZ -= 1;
                this.sp.transform.localPositionY += 1.3;
                this.sp.transform.localScaleX = 3;
                this.sp.transform.localScaleY = 3;
                this.sp.transform.localScaleZ = 3;
                let obj = SkinManager.createMenuArm(RoleManager.getInstance().getSelectSkin(), this.sp);
                obj.transform.localScaleX = 1.3;
                obj.transform.localScaleY = 1.3;
                obj.transform.localScaleZ = 1.3;
            } else {
                this.sp = new Laya.Sprite3D();
                SkinManager.createParts(this.id, this.sp, new Laya.Vector3(6, 6, 6));
                this.sp.transform.localPosition = new Laya.Vector3(5, -9, -5);
                this.scene3D.addChild(this.sp);
            }
        }
        onBtnAd() {
            if (!CommonUtil.getTouch())
                return;
            let that = this;
            AdUtil.setEvent(function() {
                if (that.modelType == 1) {
                    RoleManager.getInstance().trialSkin = that.id;
                }
                UIManager.closeFunction();
                if (that.cb) {
                    that.cb && that.cb();
                } else {
                    ModeManager.modeLoad(true);
                }
            }, function() {}, REWARD_CTRL_TYPE.ROLE_TRY);
        }
        onBtnClose() {
            if (!CommonUtil.getTouch())
                return;
            UIManager.closeFunction();
            this.cb && this.cb();
        }
        uiPlatformConfig() {
            UIManager.replaceAdIcon([{
                img: this.btnAd.getChildAt(0),
                type: 1
            }]);
        }
    }

    class RoleTryFunction extends BaseFunction {
        createView() {
            this._viewCtrl = new RoleTryViewCtrl(this.args);
            return this._viewCtrl;
        }
        getFunctionName() {
            return '角色试用界面';
        }
        onEnter() { super.onEnter(); }
        onExit() { super.onExit(); }
        onEnable() {
            super.onEnable();
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || ConfigManager.platform == PLATFORM_TYPE.WX) {
                AdUtil.showCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                AdUtil.showCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
            }
        }
        onDisbale() {
            super.onDisbale();
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || ConfigManager.platform == PLATFORM_TYPE.WX) {
                AdUtil.hideCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                AdUtil.hideCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
            }
        }
        setAllButtonAnalysePoint() {}
        request(cb) {
            cb();
        }
    }

    class ActivityPlayerViewCtrl extends ui.view.award.ActivityPlayerViewUI {
        constructor(args = null) {
            super();
            this.scuessCb = null;
            this.isDone = false;
            this.width = this.stage.width;
            this.height = this.stage.height;
            this.scuessCb = args ? args.scuessCb : null;
        }
        onAwake() {
            this.btnBack.on(Laya.Event.CLICK, this, this.onBtnBack);
            this.btnGet.on(Laya.Event.CLICK, this, this.onBtnGet);
        }
        onBtnBack() {
            if (!CommonUtil.getTouch())
                return;
            this.back();
        }
        onBtnGet() {
            if (!CommonUtil.getTouch())
                return;
            let that = this;
            AdUtil.setEvent(function() {
                that.get();
            }, function() {}, REWARD_CTRL_TYPE.NEW_YEAR_PLAYER);
        }
        back() {
            if (this.isDone)
                return;
            this.isDone = true;
            UIManager.closeFunction();
        }
        get() {
            if (this.isDone)
                return;
            this.isDone = true;
            let scuessCb = this.scuessCb;
            UIManager.closeFunction();
            let id = SPECIAL_ID.LAN;
            let itemId = ITEM_TYPE.HERO.toString() + (id > 99 ? id : id > 9 ? '0' + id : '00' + id);
            RoleManager.getInstance().setRoleSkinLib(id);
            RoleManager.getInstance().setSelectRoleSkin(id);
            UIManager.openFunction(FUNCTION_TAG.GET_EQUIP_REWARD, FUNCTION_OPEN_MODE.COVER, FUNCTION_TYPE.VIEW, COMMON_MENU_STYLE.HIDE, {
                id: itemId,
                cb: null
            });
            scuessCb && scuessCb();
        }
        onDestroy() {}
    }

    class ActivityPlayerFunction extends BaseFunction {
        createView() {
            this._viewCtrl = new ActivityPlayerViewCtrl(this.args);
            return this._viewCtrl;
        }
        getFunctionName() {
            return '活动人物界面';
        }
        onEnter() { super.onEnter(); }
        onExit() { super.onExit(); }
        onEnable() {
            super.onEnable();
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || ConfigManager.platform == PLATFORM_TYPE.WX) {
                AdUtil.showCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                AdUtil.showCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
            }
        }
        onDisbale() {
            super.onDisbale();
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || ConfigManager.platform == PLATFORM_TYPE.WX) {
                AdUtil.hideCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                AdUtil.hideCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
            }
        }
        setAllButtonAnalysePoint() {}
        request(cb) {
            cb();
        }
    }

    class GetBoxRewardNextExtraViewCtrl extends ui.view.getReward.GetBoxRewardNextExtraViewUI {
        constructor(itemList) {
            super();
            this.itemList = [];
            this.itemCellList = {};
            this.isAni = false;
            this.isDown = false;
            this.width = this.stage.width;
            this.height = this.stage.height;
            this.itemList[0] = itemList[0];
        }
        onAwake() {
            this.init();
            this.btnEnter.on(Laya.Event.CLICK, this, () => {
                if (!CommonUtil.getTouch())
                    return;
                UIManager.closeFunction();
                UIManager.triggerAutoOpen();
            });
        }
        onDestroy() {
            this.timer.clearAll(this);
            OVAdManager.unregisterByFuncId();
            GetBoxRewardNextViewCtrl.endFunc();
        }
        init() {
            GetBoxRewardNextViewCtrl.adSuccess(this.itemList, false);
            let isHaveExtra = false;
            for (let index = 0; index < this.itemList.length; index++) {
                const element = this.itemList[index];
                let ctrl = new BoxItemCellViewCtrl();
                ctrl.setView(element.itemId, element.count, element.isExtra);
                this.boxCell.addChild(ctrl);
                if (element.isExtra) {
                    isHaveExtra = true;
                }
                this.itemCellList[index] = ctrl;
            }
            this.showNormal();
        }
        showNormal() {
            this.isAni = true;
            var that = this;
            for (const key in this.itemCellList) {
                if (Object.prototype.hasOwnProperty.call(this.itemCellList, key)) {
                    const element = this.itemCellList[key];
                    if (element) {
                        let x = ITEM_POS_LIST$1[this.itemList.length][Number(key) * 3];
                        let y = ITEM_POS_LIST$1[this.itemList.length][Number(key) * 3 + 1];
                        let s = ITEM_POS_LIST$1[this.itemList.length][Number(key) * 3 + 2];
                        element.pos(x, y);
                        element.scale(s, s);
                        Laya.timer.once(Number(key) * 100, this, function() {
                            element.show();
                            if (Number(key) == that.itemList.length - 1) {
                                that.isAni = false;
                            }
                        });
                    }
                }
            }
        }
    }

    class GetBoxRewardNextExtraFunction extends BaseFunction {
        createView() {
            this._viewCtrl = new GetBoxRewardNextExtraViewCtrl(this.args);
            return this._viewCtrl;
        }
        getFunctionName() {
            return '获得宝箱奖励额外界面';
        }
        onEnter() { super.onEnter(); }
        onExit() { super.onExit(); }
        onEnable() {
            super.onEnable();
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || ConfigManager.platform == PLATFORM_TYPE.WX) {
                AdUtil.showCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                AdUtil.showCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
            }
        }
        onDisbale() {
            super.onDisbale();
            if (PLATFORM_TYPE.QQ == ConfigManager.platform || ConfigManager.platform == PLATFORM_TYPE.WX) {
                AdUtil.hideCustom(Laya.stage.width - PlatformUtil.getCustomVSize().w - 45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
                AdUtil.hideCustom(45, 85, WX_CUSTOM_AD_STYLE.VERTICAL);
            }
        }
        setAllButtonAnalysePoint() {}
        request(cb) {
            cb();
        }
    }

    class AccountUpgradeViewCtrl extends ui.view.ani.AccountUpgradeViewUI {
        constructor(reward = 100) {
            super();
            this.reward = 0;
            this.isDown = false;
            this.width = this.stage.width;
            this.height = this.stage.height;
            this.reward = reward;
            this.on(Laya.Event.CLICK, this, function() {});
        }
        onAwake() {
            this.init();
            this.setEvent();
        }
        onDestroy() {
            this.timer.clearAll(this);
        }
        init() {
            this.txtLv.text = RoleManager.getInstance().getRoleExpData().lv.toString();
            this.txtCurLv.text = '等级：' + RoleManager.getInstance().getRoleExpData().lv.toString();
            GameScene.isLevelUp = false;
        }
        setEvent() {
            var that = this;
            Laya.timer.once(1000, this, function() {
                that.on(Laya.Event.MOUSE_DOWN, that, that.onBtnBack);
            });
        }
        onBtnBack() {
            if (!CommonUtil.getTouch())
                return;
            if (this.isDown)
                return;
            this.isDown = true;
            UIManager.closeFunction();
        }
    }

    class AccountUpgradeFunction extends BaseFunction {
        createView() {
            this._viewCtrl = new AccountUpgradeViewCtrl();
            return this._viewCtrl;
        }
        getFunctionName() {
            return '账号升级界面';
        }
        onEnter() { super.onEnter(); }
        onExit() { super.onExit(); }
        onEnable() { super.onEnable(); }
        onDisbale() { super.onDisbale();}
        setAllButtonAnalysePoint() {}
        request(cb) {
            cb();
        }
    }

    class EquipLibraryFunction extends BaseFunction {
        createView() {
            this._viewCtrl = new EquipLibarayViewCtrl();
            return this._viewCtrl;
        }
        getFunctionName() {
            return '武器界面';
        }
        onEnter() { super.onEnter(); }
        onExit() { super.onExit(); }
        onEnable() { super.onEnable(); }
        onDisbale() { super.onDisbale(); }
        setAllButtonAnalysePoint() {}
        request(cb) {
            cb();
        }
    }

    class ActivityGoldGunViewCtrl extends ui.view.award.ActivityGoldGunViewUI {
        constructor() {
            super(...arguments);
            this.list = [
                34, 43
            ];
        }
        onAwake() {
            this.width = this.stage.width;
            this.height = this.stage.height;
            this.btnAd.on(Laya.Event.CLICK, this, this.onBtnAd);
            this.btnBack.on(Laya.Event.CLICK, this, this.onBtnBack);
            this.btnCancel.on(Laya.Event.CLICK, this, this.onBtnBack);
            if (ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.TT) {
                this.btnCancel.visible = true;
                this.btnBack.visible = false;
                this.btnAd.centerX = -this.btnCancel.centerX;
            } else {
                this.btnCancel.visible = false;
                this.btnBack.visible = true;
            }
        }
        onBtnAd() {
            if (!CommonUtil.getTouch())
                return;
            let that = this;
            AdUtil.setEvent(function() {
                UIManager.closeFunction();
                that.getEggHero();
                RoleManager.getInstance().setActGoldGunState();
            }, function() {}, REWARD_CTRL_TYPE.ACT_GOLD_GUN);
        }
        onBtnBack() {
            if (!CommonUtil.getTouch())
                return;
            UIManager.closeFunction();
        }
        getEggHero() {
            let data = this.list.pop();
            if (data) {
                var that = this;
                PeopleFactory.getInstance().getEquip(data, function() {
                    that.getEggHero();
                });
            }
        }
    }

    class ActivityGoldGunFunction extends BaseFunction {
        createView() {
            this._viewCtrl = new ActivityGoldGunViewCtrl();
            return this._viewCtrl;
        }
        getFunctionName() {
            return '金色传说';
        }
        onEnter() { super.onEnter(); }
        onExit() { super.onExit(); }
        onEnable() { super.onEnable(); }
        onDisbale() { super.onDisbale(); }
        setAllButtonAnalysePoint() {}
        request(cb) {
            cb();
        }
    }

    class CDKeyViewCtrl extends ui.view.cdkey.CDKeyViewUI {
        onAwake() {
            this.txtContent.text = '';
            this.txtContent.on(Laya.Event.CHANGE, this, this.textChange);
            for (let i = 0; i < this.boxCode.numChildren; i++) {
                let btn = this.boxCode.getChildAt(i);
                let number = btn.getChildAt(2);
                number.centerX = 2;
                btn.on(Laya.Event.CLICK, this, function() {
                    if (this.txtContent.text.length < 4) {
                        this.txtContent.text += i;
                    }
                });
            }
            this.btnDel.on(Laya.Event.CLICK, this, this.onBtnDel);
            this.btnClose.on(Laya.Event.CLICK, this, this.onBtnBack);
            this.btnConfirm.on(Laya.Event.CLICK, this, this.onBtnConfirm);
        }
        textChange() {
            if (this.txtContent.text.length >= 4) {
                this.imgTag.visible = false;
            } else {
                this.imgTag.visible = true;
            }
            this.imgTag.x = this.txtContent.x + this.txtContent.text.length * 25;
        }
        onBtnDel() {
            if (this.txtContent.text.length > 0) {
                this.txtContent.text = this.txtContent.text.substring(0, this.txtContent.text.length - 1);
            }
        }
        onBtnConfirm() {
            if (!CommonUtil.getTouch())
                return;
            if (this.txtContent.text.length == 0) {
                LogManager.showNotification('请输入兑换码');
            } else if (this.txtContent.text.length < 4) {
                LogManager.showNotification('兑换码为4位数');
            } else if (this.txtContent.text.length > 4) {
                LogManager.showNotification('兑换码为4位数');
            } else {
                let data = ConfigManager.getCDKeyeData()[this.txtContent.text];
                if (!data) {
                    LogManager.showNotification('兑换码错误');
                } else {
                    if (RoleManager.getInstance().receiveCDkey(this.txtContent.text)) {
                        let list = [];
                        for (let k in data) {
                            let item = data[k];
                            let itemData = Item.getDataByKey(item.itemId);
                            if (itemData.type == ITEM_TYPE.EQUIP) {
                                PeopleFactory.getInstance().getEquip(itemData.extra());
                            }
                        }
                    } else {
                        LogManager.showNotification('不可重复领取');
                    }
                }
            }
        }
        onBtnBack() {
            if (!CommonUtil.getTouch())
                return;
            UIManager.closeFunction();
        }
    }

    class CDKeyFunction extends BaseFunction {
        createView() {
            this._viewCtrl = new CDKeyViewCtrl();
            return this._viewCtrl;
        }
        getFunctionName() {
            return '兑换码';
        }
        onEnter() {
            super.onEnter();
        }
        onExit() { super.onExit(); }
        onEnable() { super.onEnable(); }
        onDisbale() { super.onDisbale(); }
        setAllButtonAnalysePoint() {
            let view = this.viewCtrl;
        }
        request(cb) {
            cb();
        }
    }

    var FUNCTION_OPEN_MODE;
    (function(FUNCTION_OPEN_MODE) {
        FUNCTION_OPEN_MODE[FUNCTION_OPEN_MODE["COVER"] = 0] = "COVER";
        FUNCTION_OPEN_MODE[FUNCTION_OPEN_MODE["REPLACE"] = 1] = "REPLACE";
    })(FUNCTION_OPEN_MODE || (FUNCTION_OPEN_MODE = {}));
    var FUNCTION_TYPE;
    (function(FUNCTION_TYPE) {
        FUNCTION_TYPE[FUNCTION_TYPE["WINDOW"] = 1] = "WINDOW";
        FUNCTION_TYPE[FUNCTION_TYPE["VIEW"] = 2] = "VIEW";
    })(FUNCTION_TYPE || (FUNCTION_TYPE = {}));
    let FUNCTION_TAG = {
        FIRST: 'FirstFunction',
        GAME: 'GameFunction',
        END: 'EndFunction',
        EQUIP: 'EquipFunciton',
        NEW_EQUIP_UNLOCK: 'NewEquipUnlockFunction',
        SHOP: 'ShopFunction',
        SYNTHESIS: 'SynthesisFunciotn',
        LOADING_FIGHT: 'LoadingFightFunction',
        ROLE: 'RoleFunction',
        SUPER_REWARD: 'SuperRewardFunction',
        ADD_GOLD: 'AddGoldFunction',
        ADD_DIAMONDS: 'AddDiamondsFunction',
        GET_GOLD_REWARD: ' GetGoldRewardFunction',
        GET_DIAMONDS_REWARD: 'GetDiamondsRewardFunction',
        OFF_LINE: 'OfflineFunction',
        MODE: 'ModeFunction',
        SIGN: 'SignFunction',
        GET_EQUIP_REWARD: 'GetEquipRewardFunction',
        SUPER_EQUIP: 'SuperEquipFunction',
        MAP_MENU: 'MapMenuFunction',
        TASK: 'TaskFunction',
        DAN_ANI: 'DanAniFunction',
        NEW_GIFT: 'NewGiftFunction',
        END_RECREATION: 'EndRecreationFunction',
        GET_THREE_REWARD: 'GetThreeRewardFunction',
        GET_BOX_REWARD: 'GetBoxRewardFunction',
        GET_BOX_REWARD_NEXT: 'GetBoxRewardNextFunction',
        EXIT: 'ExitFunction',
        REVIVE: 'ReviveFunction',
        GAMEOVER: 'GameOverFunction',
        EQUIP_TRY: 'EquipTryFunction',
        GET_MODE_REWARD: 'GetModeRewardFunction',
        NOTIFY_CLICK: 'NotificationFunction',
        GAMEBOX: 'GameBoxFunction',
        AUTOREVIVE: 'NewReviveFunction',
        SUPERSTART: 'SuperStartFunction',
        END_ANI: 'EndAniFunction',
        NATIVE_INTERSTITIAL: 'NativeInterstitialFunction',
        OPPOGAMEBOX: 'OPPOGameBoxFunction',
        LIBRARY: "LibraryFunction",
        END_MYSELF: 'EndMySelfFunction',
        DETAIL: 'DetailFunction',
        ACTIVITY_EQUIP: 'ActivityEquipFunction',
        NEW_YEAR_GIFT: 'NewYearGiftFunction',
        MORE_GAME: 'MoreGameFunction',
        GAMEAIR: 'GameAirFunction',
        NEWPLAYERTRYARM: 'NewPlayerTryArmFunction',
        RECORD: 'RecordFunction',
        TURNTABLE: 'TurnTableFunction',
        ENDGAMEBOX: 'EndGameBoxFunction',
        SHOPTRY: 'ShopTryFunction',
        ROLETRY: 'RoleTryFunction',
        ACTIVITYPLAYER: 'ActivityPlayerFunction',
        GET_BOX_REWARD_NEXT_EXTRA: 'GetBoxRewardNextExtraFunction',
        ACCOUNTUPGRADE: 'AccountUpgradeFunction',
        EQUIP_LIB: 'EquipLibraryFunction',
        ACT_GOLD_GUN: 'ActivityGoldGunFunction',
        CD_KEY: 'CDKeyFunction'
    };
    Laya.ClassUtils.regClass(FUNCTION_TAG.FIRST, FirstFunction);
    Laya.ClassUtils.regClass(FUNCTION_TAG.GAME, GameFunction);
    Laya.ClassUtils.regClass(FUNCTION_TAG.END, EndFunction);
    Laya.ClassUtils.regClass(FUNCTION_TAG.EQUIP, EquipFunction);
    Laya.ClassUtils.regClass(FUNCTION_TAG.NEW_EQUIP_UNLOCK, NewEquipUnLockFunction);
    Laya.ClassUtils.regClass(FUNCTION_TAG.SHOP, ShopFunction);
    Laya.ClassUtils.regClass(FUNCTION_TAG.SYNTHESIS, SynthesisFunction);
    Laya.ClassUtils.regClass(FUNCTION_TAG.LOADING_FIGHT, LoadingFightFunction);
    Laya.ClassUtils.regClass(FUNCTION_TAG.ROLE, RoleFunction);
    Laya.ClassUtils.regClass(FUNCTION_TAG.SUPER_REWARD, SuperRewardFunction);
    Laya.ClassUtils.regClass(FUNCTION_TAG.ADD_GOLD, AddGoldFunction);
    Laya.ClassUtils.regClass(FUNCTION_TAG.ADD_DIAMONDS, AddDiamondsFunction);
    Laya.ClassUtils.regClass(FUNCTION_TAG.GET_GOLD_REWARD, GetGoldRewardFunction);
    Laya.ClassUtils.regClass(FUNCTION_TAG.GET_DIAMONDS_REWARD, GetDiamondsRewardFunction);
    Laya.ClassUtils.regClass(FUNCTION_TAG.OFF_LINE, OffLineFunction);
    Laya.ClassUtils.regClass(FUNCTION_TAG.MODE, ModeFunction);
    Laya.ClassUtils.regClass(FUNCTION_TAG.SIGN, SignFunction);
    Laya.ClassUtils.regClass(FUNCTION_TAG.GET_EQUIP_REWARD, GetEquipOrRoleRewardFunction);
    Laya.ClassUtils.regClass(FUNCTION_TAG.SUPER_EQUIP, SuperEquipFunction);
    Laya.ClassUtils.regClass(FUNCTION_TAG.MAP_MENU, MapMenuFunction);
    Laya.ClassUtils.regClass(FUNCTION_TAG.TASK, TaskFunction);
    Laya.ClassUtils.regClass(FUNCTION_TAG.DAN_ANI, DanAniFunction);
    Laya.ClassUtils.regClass(FUNCTION_TAG.NEW_GIFT, NewGiftFunction);
    Laya.ClassUtils.regClass(FUNCTION_TAG.END_RECREATION, EndRecreationFunction);
    Laya.ClassUtils.regClass(FUNCTION_TAG.GET_THREE_REWARD, GetThreeRewardFunction);
    Laya.ClassUtils.regClass(FUNCTION_TAG.EXIT, ExitFunction);
    Laya.ClassUtils.regClass(FUNCTION_TAG.REVIVE, ReviveFunction);
    Laya.ClassUtils.regClass(FUNCTION_TAG.GAMEOVER, GameOverFunction);
    Laya.ClassUtils.regClass(FUNCTION_TAG.EQUIP_TRY, EquipTryFunction);
    Laya.ClassUtils.regClass(FUNCTION_TAG.GET_MODE_REWARD, GetModeRewardFunction);
    Laya.ClassUtils.regClass(FUNCTION_TAG.NOTIFY_CLICK, NotificationFunction);
    Laya.ClassUtils.regClass(FUNCTION_TAG.GAMEBOX, GameBoxFunction);
    Laya.ClassUtils.regClass(FUNCTION_TAG.AUTOREVIVE, NewReviveFunction);
    Laya.ClassUtils.regClass(FUNCTION_TAG.SUPERSTART, SuperStartFunction);
    Laya.ClassUtils.regClass(FUNCTION_TAG.END_ANI, EndAniFunction);
    Laya.ClassUtils.regClass(FUNCTION_TAG.GET_BOX_REWARD, GetBoxRewardFunction);
    Laya.ClassUtils.regClass(FUNCTION_TAG.GET_BOX_REWARD_NEXT, GetBoxRewardNextFunction);
    Laya.ClassUtils.regClass(FUNCTION_TAG.NATIVE_INTERSTITIAL, NativeInterstitialFunction);
    Laya.ClassUtils.regClass(FUNCTION_TAG.OPPOGAMEBOX, OPPOGameBoxFunction);
    Laya.ClassUtils.regClass(FUNCTION_TAG.LIBRARY, LibraryFunction);
    Laya.ClassUtils.regClass(FUNCTION_TAG.END_MYSELF, EndMySelfFunction);
    Laya.ClassUtils.regClass(FUNCTION_TAG.DETAIL, DetailFunction);
    Laya.ClassUtils.regClass(FUNCTION_TAG.ACTIVITY_EQUIP, ActivityEquipFunction);
    Laya.ClassUtils.regClass(FUNCTION_TAG.NEW_YEAR_GIFT, NewYearGiftFunction);
    Laya.ClassUtils.regClass(FUNCTION_TAG.MORE_GAME, MoreGameFunction);
    Laya.ClassUtils.regClass(FUNCTION_TAG.GAMEAIR, GameAirFunction);
    Laya.ClassUtils.regClass(FUNCTION_TAG.NEWPLAYERTRYARM, NewPlayerTryArmFunction);
    Laya.ClassUtils.regClass(FUNCTION_TAG.RECORD, RecordFunction);
    Laya.ClassUtils.regClass(FUNCTION_TAG.TURNTABLE, TurnTableFunction);
    Laya.ClassUtils.regClass(FUNCTION_TAG.ENDGAMEBOX, EndGameBoxFunction);
    Laya.ClassUtils.regClass(FUNCTION_TAG.SHOPTRY, ShopTryFunction);
    Laya.ClassUtils.regClass(FUNCTION_TAG.ROLETRY, RoleTryFunction);
    Laya.ClassUtils.regClass(FUNCTION_TAG.ACTIVITYPLAYER, ActivityPlayerFunction);
    Laya.ClassUtils.regClass(FUNCTION_TAG.GET_BOX_REWARD_NEXT_EXTRA, GetBoxRewardNextExtraFunction);
    Laya.ClassUtils.regClass(FUNCTION_TAG.ACCOUNTUPGRADE, AccountUpgradeFunction);
    Laya.ClassUtils.regClass(FUNCTION_TAG.EQUIP_LIB, EquipLibraryFunction);
    Laya.ClassUtils.regClass(FUNCTION_TAG.ACT_GOLD_GUN, ActivityGoldGunFunction);
    Laya.ClassUtils.regClass(FUNCTION_TAG.CD_KEY, CDKeyFunction);

    var SKILL_TYPE;
    (function(SKILL_TYPE) {
        SKILL_TYPE[SKILL_TYPE["ATTACK"] = 1] = "ATTACK";
        SKILL_TYPE[SKILL_TYPE["AREA"] = 2] = "AREA";
        SKILL_TYPE[SKILL_TYPE["DISTANCE"] = 3] = "DISTANCE";
        SKILL_TYPE[SKILL_TYPE["SPRINT"] = 4] = "SPRINT";
        SKILL_TYPE[SKILL_TYPE["ONCE"] = 5] = "ONCE";
    })(SKILL_TYPE || (SKILL_TYPE = {}));
    var SKILL_TARGET;
    (function(SKILL_TARGET) {
        SKILL_TARGET[SKILL_TARGET["ENEMY"] = 1] = "ENEMY";
        SKILL_TARGET[SKILL_TARGET["FRIEND"] = 2] = "FRIEND";
    })(SKILL_TARGET || (SKILL_TARGET = {}));
    var SKILL_COLLIDER;
    (function(SKILL_COLLIDER) {
        SKILL_COLLIDER[SKILL_COLLIDER["LINE"] = 1] = "LINE";
        SKILL_COLLIDER[SKILL_COLLIDER["CIRCLE"] = 2] = "CIRCLE";
    })(SKILL_COLLIDER || (SKILL_COLLIDER = {}));
    var SKILL_EFFCT_PART;
    (function(SKILL_EFFCT_PART) {
        SKILL_EFFCT_PART[SKILL_EFFCT_PART["TOP"] = 1] = "TOP";
        SKILL_EFFCT_PART[SKILL_EFFCT_PART["MIDDLE"] = 2] = "MIDDLE";
        SKILL_EFFCT_PART[SKILL_EFFCT_PART["BOTTOM"] = 3] = "BOTTOM";
        SKILL_EFFCT_PART[SKILL_EFFCT_PART["ORIGIN"] = 4] = "ORIGIN";
        SKILL_EFFCT_PART[SKILL_EFFCT_PART["WORLD"] = 5] = "WORLD";
    })(SKILL_EFFCT_PART || (SKILL_EFFCT_PART = {}));
    var BUFF_TYPE;
    (function(BUFF_TYPE) {
        BUFF_TYPE[BUFF_TYPE["ATTR"] = 1] = "ATTR";
        BUFF_TYPE[BUFF_TYPE["DIZZINESS"] = 2] = "DIZZINESS";
        BUFF_TYPE[BUFF_TYPE["REPEL"] = 3] = "REPEL";
    })(BUFF_TYPE || (BUFF_TYPE = {}));
    var BUFF_ATTR_TYPE;
    (function(BUFF_ATTR_TYPE) {
        BUFF_ATTR_TYPE[BUFF_ATTR_TYPE["RECOVER"] = 1] = "RECOVER";
        BUFF_ATTR_TYPE[BUFF_ATTR_TYPE["COVER"] = 2] = "COVER";
    })(BUFF_ATTR_TYPE || (BUFF_ATTR_TYPE = {}));
    var CMD_TYPE;
    (function(CMD_TYPE) {
        CMD_TYPE[CMD_TYPE["MOVE"] = 1] = "MOVE";
        CMD_TYPE[CMD_TYPE["STOP"] = 2] = "STOP";
        CMD_TYPE[CMD_TYPE["SKILL"] = 3] = "SKILL";
        CMD_TYPE[CMD_TYPE["SELECT_REWARD"] = 4] = "SELECT_REWARD";
        CMD_TYPE[CMD_TYPE["REVIVE"] = 5] = "REVIVE";
    })(CMD_TYPE || (CMD_TYPE = {}));
    let ATTR_NEW_NAME = {
        HP: 'h',
        MAX_HP: 'mH',
        ATK: 'a',
        DEF: "d",
        SPEED: "s",
        ATK_SPEED: "aS",
        CRL: "c",
        VPM: "v",
        EVA: "e",
        BLEED: "b",
        REN: "r",
        ATK_RATE: 'aR',
        DEF_RATE: 'dR',
        SPEED_RATE: 'sR',
        ATK_SPEED_RATE: 'aSR',
        CRL_DAMAGE_RATE: 'cDR',
        SKILL_TIME_RATE: 'sTR',
        SKILL_DAMAGE_RATE: 'sDR',
    };
    let ATTR_NAME = {
        HP: 'hp',
        MAX_HP: 'maxHp',
        ATK: 'atk',
        DEF: "def",
        SPEED: "speed",
        ATK_SPEED: "atkSpeed",
        CRL: "crl",
        VPM: "vpm",
        EVA: "eva",
        BLEED: "bleed",
        REN: "ren",
        ATK_RATE: 'atkRate',
        DEF_RATE: 'defRate',
        SPEED_RATE: 'speedRate',
        ATK_SPEED_RATE: 'atkSpeedRate',
        CRL_DAMAGE_RATE: 'crlDamageRate',
        SKILL_TIME_RATE: 'skillTimeRate',
        SKILL_DAMAGE_RATE: 'skillDamageRate',
    };
    let ATTR_NAME_CHANI = {
        HP: '血量',
        MAX_HP: '最大血量',
        ATK: '攻击力',
        DEF: "防御力",
        SPEED: "移速",
        ATK_SPEED: "攻击速度",
        CRL: "暴击",
        VPM: "吸血",
        EVA: "格挡机率",
        BLEED: "出血率",
        REN: "回血量",
        ATK_RATE: '攻击加成比',
        DEF_RATE: '防御加成比',
        SPEED_RATE: '移动速度',
        ATK_SPEED_RATE: '攻击速度',
        CRL_DAMAGE_RATE: '暴击伤害',
        SKILL_TIME_RATE: '技能冷却',
        SKILL_DAMAGE_RATE: '技能伤害',
    };
    let ATTR_MAP = [];
    for (let k in ATTR_NAME) {
        ATTR_MAP.push(ATTR_NAME[k]);
    }
    var AI_BEHAVIOUR_TYPE;
    (function(AI_BEHAVIOUR_TYPE) {
        AI_BEHAVIOUR_TYPE[AI_BEHAVIOUR_TYPE["AI_BEHAVIOUR_NONE"] = 0] = "AI_BEHAVIOUR_NONE";
        AI_BEHAVIOUR_TYPE[AI_BEHAVIOUR_TYPE["AI_BEHAVIOUR_IDLE"] = 1] = "AI_BEHAVIOUR_IDLE";
        AI_BEHAVIOUR_TYPE[AI_BEHAVIOUR_TYPE["AI_BEHAVIOUR_PATROL"] = 2] = "AI_BEHAVIOUR_PATROL";
        AI_BEHAVIOUR_TYPE[AI_BEHAVIOUR_TYPE["AI_BEHAVIOUR_TRACK"] = 3] = "AI_BEHAVIOUR_TRACK";
        AI_BEHAVIOUR_TYPE[AI_BEHAVIOUR_TYPE["AI_BEHAVIOUR_ESCAPE"] = 4] = "AI_BEHAVIOUR_ESCAPE";
        AI_BEHAVIOUR_TYPE[AI_BEHAVIOUR_TYPE["AI_BEHAVIOUR_CROUCHATTACK"] = 5] = "AI_BEHAVIOUR_CROUCHATTACK";
        AI_BEHAVIOUR_TYPE[AI_BEHAVIOUR_TYPE["AI_BEHAVIOUR_ATTACK"] = 6] = "AI_BEHAVIOUR_ATTACK";
        AI_BEHAVIOUR_TYPE[AI_BEHAVIOUR_TYPE["AI_BEHAVIOUR_MOVEATTACK"] = 7] = "AI_BEHAVIOUR_MOVEATTACK";
        AI_BEHAVIOUR_TYPE[AI_BEHAVIOUR_TYPE["AI_BEHAVIOUR_SEARCH"] = 8] = "AI_BEHAVIOUR_SEARCH";
    })(AI_BEHAVIOUR_TYPE || (AI_BEHAVIOUR_TYPE = {}));
    let PROP_ID = {
        HP: '0',
        FULL_HP: '1'
    };
    var AI_STATE;
    (function(AI_STATE) {
        AI_STATE[AI_STATE["NORMAL"] = 1] = "NORMAL";
        AI_STATE[AI_STATE["TRACK"] = 2] = "TRACK";
        AI_STATE[AI_STATE["ATTACK"] = 3] = "ATTACK";
        AI_STATE[AI_STATE["ESCAPE"] = 4] = "ESCAPE";
        AI_STATE[AI_STATE["REVENGE"] = 5] = "REVENGE";
        AI_STATE[AI_STATE["DIE"] = 6] = "DIE";
        AI_STATE[AI_STATE["SEARCH"] = 7] = "SEARCH";
    })(AI_STATE || (AI_STATE = {}));
    var ROLE_TYPE;
    (function(ROLE_TYPE) {
        ROLE_TYPE[ROLE_TYPE["TYPE_0"] = 0] = "TYPE_0";
        ROLE_TYPE[ROLE_TYPE["TYPE_1"] = 1] = "TYPE_1";
    })(ROLE_TYPE || (ROLE_TYPE = {}));
    var EQUIP_TYPE;
    (function(EQUIP_TYPE) {
        EQUIP_TYPE[EQUIP_TYPE["LIGHT"] = 0] = "LIGHT";
        EQUIP_TYPE[EQUIP_TYPE["MIDDLE"] = 1] = "MIDDLE";
        EQUIP_TYPE[EQUIP_TYPE["HEAVY"] = 2] = "HEAVY";
    })(EQUIP_TYPE || (EQUIP_TYPE = {}));
    var EQUIP_EXTEND_TYPE;
    (function(EQUIP_EXTEND_TYPE) {
        EQUIP_EXTEND_TYPE[EQUIP_EXTEND_TYPE["HERO"] = -1] = "HERO";
        EQUIP_EXTEND_TYPE[EQUIP_EXTEND_TYPE["EQUIP"] = 0] = "EQUIP";
        EQUIP_EXTEND_TYPE[EQUIP_EXTEND_TYPE["HEAD"] = 1] = "HEAD";
        EQUIP_EXTEND_TYPE[EQUIP_EXTEND_TYPE["PANTS"] = 3] = "PANTS";
        EQUIP_EXTEND_TYPE[EQUIP_EXTEND_TYPE["CLOTHES"] = 2] = "CLOTHES";
        EQUIP_EXTEND_TYPE[EQUIP_EXTEND_TYPE["ORNAMENTS"] = 5] = "ORNAMENTS";
        EQUIP_EXTEND_TYPE[EQUIP_EXTEND_TYPE["SHOE"] = 4] = "SHOE";
    })(EQUIP_EXTEND_TYPE || (EQUIP_EXTEND_TYPE = {}));
    var LEVEL_REWARD_TYPE;
    (function(LEVEL_REWARD_TYPE) {
        LEVEL_REWARD_TYPE[LEVEL_REWARD_TYPE["SKILL"] = 1] = "SKILL";
        LEVEL_REWARD_TYPE[LEVEL_REWARD_TYPE["ATTR"] = 2] = "ATTR";
    })(LEVEL_REWARD_TYPE || (LEVEL_REWARD_TYPE = {}));
    var GAME_TYPE;
    (function(GAME_TYPE) {
        GAME_TYPE[GAME_TYPE["INFINITE"] = 1] = "INFINITE";
        GAME_TYPE[GAME_TYPE["SALE_REGION"] = 2] = "SALE_REGION";
        GAME_TYPE[GAME_TYPE["PVP"] = 3] = "PVP";
        GAME_TYPE[GAME_TYPE["LEVEL"] = 4] = "LEVEL";
        GAME_TYPE[GAME_TYPE["LOUNGE"] = 5] = "LOUNGE";
    })(GAME_TYPE || (GAME_TYPE = {}));
    let SPECIAL_ID = {
        RED_TASSEL_EQUIP: 47,
        RED_SPIRIT_EQUIP: 48,
        ACTIVITY_EQUIP1: 56,
        ACTIVITY_EQUIP2: 57,
        ACTIVITY_BARRETT: 61,
        FIRECRACKER: '10001',
        DIAMONDS: '2001',
        DIAMONDS1: '2002',
        GOLD: '1001',
        GOLD1: '1002',
        LAN: 6
    };
    let GOBAL_DATA = {
        CHEST_GOLD: 5,
        KILL_GOLD: 10,
        KILL_EXP: 15,
        LEVEL_HP_RATE: 0.1,
        LEVEL_ATK_RATE: 0.05,
        LEVEL_SPEED_RATE: 0.015
    };
    var ITEM_TYPE;
    (function(ITEM_TYPE) {
        ITEM_TYPE[ITEM_TYPE["GOLD"] = 1] = "GOLD";
        ITEM_TYPE[ITEM_TYPE["DIAMOND"] = 2] = "DIAMOND";
        ITEM_TYPE[ITEM_TYPE["EXP"] = 3] = "EXP";
        ITEM_TYPE[ITEM_TYPE["EQUIP"] = 4] = "EQUIP";
        ITEM_TYPE[ITEM_TYPE["HERO"] = 5] = "HERO";
        ITEM_TYPE[ITEM_TYPE["HERO_DEBRIS"] = 6] = "HERO_DEBRIS";
        ITEM_TYPE[ITEM_TYPE["OTHER"] = 10] = "OTHER";
        ITEM_TYPE[ITEM_TYPE["PART_DEBRIS"] = 7] = "PART_DEBRIS";
        ITEM_TYPE[ITEM_TYPE["PART"] = 8] = "PART";
    })(ITEM_TYPE || (ITEM_TYPE = {}));
    var DAMAGE_TYPE;
    (function(DAMAGE_TYPE) {
        DAMAGE_TYPE[DAMAGE_TYPE["BASE_ATTACK"] = 1] = "BASE_ATTACK";
        DAMAGE_TYPE[DAMAGE_TYPE["SKILL"] = 2] = "SKILL";
        DAMAGE_TYPE[DAMAGE_TYPE["BUFF"] = 3] = "BUFF";
    })(DAMAGE_TYPE || (DAMAGE_TYPE = {}));
    let AI_VALUE_SETTING = {
        CRL_INCREASE: 5,
        ATK_RAND: [1.3, 4],
        HP_RAND: [2, 6]
    };
    var CUBE_OBJECT_ID;
    (function(CUBE_OBJECT_ID) {
        CUBE_OBJECT_ID[CUBE_OBJECT_ID["CUBE_1"] = 1] = "CUBE_1";
        CUBE_OBJECT_ID[CUBE_OBJECT_ID["CUBE_2"] = 2] = "CUBE_2";
        CUBE_OBJECT_ID[CUBE_OBJECT_ID["TREE"] = 3] = "TREE";
    })(CUBE_OBJECT_ID || (CUBE_OBJECT_ID = {}));
    var WHO_KILL;
    (function(WHO_KILL) {
        WHO_KILL[WHO_KILL["ENEMY"] = 1] = "ENEMY";
        WHO_KILL[WHO_KILL["FRIEND"] = 2] = "FRIEND";
    })(WHO_KILL || (WHO_KILL = {}));
    var TASK_STATE;
    (function(TASK_STATE) {
        TASK_STATE[TASK_STATE["GET"] = -1] = "GET";
        TASK_STATE[TASK_STATE["COMPLETE"] = -3] = "COMPLETE";
        TASK_STATE[TASK_STATE["UNINDAY"] = -2] = "UNINDAY";
    })(TASK_STATE || (TASK_STATE = {}));
    let POPUPLIST = [
        FUNCTION_TAG.NEW_GIFT,
        FUNCTION_TAG.ACT_GOLD_GUN,
        FUNCTION_TAG.SUPER_EQUIP,
        FUNCTION_TAG.TURNTABLE,
        FUNCTION_TAG.GAMEBOX,
        FUNCTION_TAG.TASK,
    ];
    var ARM_TYPE;
    (function(ARM_TYPE) {
        ARM_TYPE[ARM_TYPE["RIFLE_GUN"] = 1] = "RIFLE_GUN";
        ARM_TYPE[ARM_TYPE["KNIFE"] = 2] = "KNIFE";
        ARM_TYPE[ARM_TYPE["SNIPER_GUN"] = 3] = "SNIPER_GUN";
        ARM_TYPE[ARM_TYPE["HAND_GUN"] = 4] = "HAND_GUN";
        ARM_TYPE[ARM_TYPE["SUBMACHINE_GUN"] = 5] = "SUBMACHINE_GUN";
        ARM_TYPE[ARM_TYPE["MACHINE_GUN"] = 6] = "MACHINE_GUN";
        ARM_TYPE[ARM_TYPE["SHOT_GUN"] = 7] = "SHOT_GUN";
        ARM_TYPE[ARM_TYPE["BOMB"] = 8] = "BOMB";
    })(ARM_TYPE || (ARM_TYPE = {}));

    class PlayerLevelData {
        static getDataByKey(key) {
            if (PlayerLevelData.cache[key])
                return PlayerLevelData.cache[key];
            if (key == 1) {
                let template = new PlayerLevelData();
                template.id = 1;
                template.exp = 20;
                template.bonus = [{
                    "itemId": "1001",
                    "num": 100
                }, {
                    "itemId": "3001",
                    "num": 200
                }];
                PlayerLevelData.cache[key] = template;
                return template;
            } else if (key == 2) {
                let template = new PlayerLevelData();
                template.id = 2;
                template.exp = 45;
                template.bonus = [{
                    "itemId": "1001",
                    "num": 100
                }, {
                    "itemId": "3001",
                    "num": 200
                }];
                PlayerLevelData.cache[key] = template;
                return template;
            } else if (key == 3) {
                let template = new PlayerLevelData();
                template.id = 3;
                template.exp = 80;
                template.bonus = [{
                    "itemId": "1001",
                    "num": 100
                }, {
                    "itemId": "3001",
                    "num": 200
                }];
                PlayerLevelData.cache[key] = template;
                return template;
            } else if (key == 4) {
                let template = new PlayerLevelData();
                template.id = 4;
                template.exp = 125;
                template.bonus = [{
                    "itemId": "1001",
                    "num": 100
                }, {
                    "itemId": "3001",
                    "num": 200
                }];
                PlayerLevelData.cache[key] = template;
                return template;
            } else if (key == 5) {
                let template = new PlayerLevelData();
                template.id = 5;
                template.exp = 180;
                template.bonus = [{
                    "itemId": "1001",
                    "num": 100
                }, {
                    "itemId": "3001",
                    "num": 200
                }];
                PlayerLevelData.cache[key] = template;
                return template;
            } else if (key == 6) {
                let template = new PlayerLevelData();
                template.id = 6;
                template.exp = 245;
                template.bonus = [{
                    "itemId": "1001",
                    "num": 100
                }, {
                    "itemId": "3001",
                    "num": 200
                }];
                PlayerLevelData.cache[key] = template;
                return template;
            } else if (key == 7) {
                let template = new PlayerLevelData();
                template.id = 7;
                template.exp = 320;
                template.bonus = [{
                    "itemId": "1001",
                    "num": 100
                }, {
                    "itemId": "3001",
                    "num": 200
                }];
                PlayerLevelData.cache[key] = template;
                return template;
            } else if (key == 8) {
                let template = new PlayerLevelData();
                template.id = 8;
                template.exp = 405;
                template.bonus = [{
                    "itemId": "1001",
                    "num": 100
                }, {
                    "itemId": "3001",
                    "num": 200
                }];
                PlayerLevelData.cache[key] = template;
                return template;
            } else if (key == 9) {
                let template = new PlayerLevelData();
                template.id = 9;
                template.exp = 500;
                template.bonus = [{
                    "itemId": "1001",
                    "num": 100
                }, {
                    "itemId": "3001",
                    "num": 200
                }];
                PlayerLevelData.cache[key] = template;
                return template;
            } else if (key == 10) {
                let template = new PlayerLevelData();
                template.id = 10;
                template.exp = 605;
                template.bonus = [{
                    "itemId": "1001",
                    "num": 100
                }, {
                    "itemId": "3001",
                    "num": 200
                }];
                PlayerLevelData.cache[key] = template;
                return template;
            } else if (key == 11) {
                let template = new PlayerLevelData();
                template.id = 11;
                template.exp = 720;
                template.bonus = [{
                    "itemId": "1001",
                    "num": 100
                }, {
                    "itemId": "3001",
                    "num": 200
                }];
                PlayerLevelData.cache[key] = template;
                return template;
            } else if (key == 12) {
                let template = new PlayerLevelData();
                template.id = 12;
                template.exp = 845;
                template.bonus = [{
                    "itemId": "1001",
                    "num": 100
                }, {
                    "itemId": "3001",
                    "num": 200
                }];
                PlayerLevelData.cache[key] = template;
                return template;
            } else if (key == 13) {
                let template = new PlayerLevelData();
                template.id = 13;
                template.exp = 980;
                template.bonus = [{
                    "itemId": "1001",
                    "num": 100
                }, {
                    "itemId": "3001",
                    "num": 200
                }];
                PlayerLevelData.cache[key] = template;
                return template;
            } else if (key == 14) {
                let template = new PlayerLevelData();
                template.id = 14;
                template.exp = 1125;
                template.bonus = [{
                    "itemId": "1001",
                    "num": 100
                }, {
                    "itemId": "3001",
                    "num": 200
                }];
                PlayerLevelData.cache[key] = template;
                return template;
            } else if (key == 15) {
                let template = new PlayerLevelData();
                template.id = 15;
                template.exp = 1280;
                template.bonus = [{
                    "itemId": "1001",
                    "num": 100
                }, {
                    "itemId": "3001",
                    "num": 200
                }];
                PlayerLevelData.cache[key] = template;
                return template;
            } else if (key == 16) {
                let template = new PlayerLevelData();
                template.id = 16;
                template.exp = 1445;
                template.bonus = [{
                    "itemId": "1001",
                    "num": 100
                }, {
                    "itemId": "3001",
                    "num": 200
                }];
                PlayerLevelData.cache[key] = template;
                return template;
            } else if (key == 17) {
                let template = new PlayerLevelData();
                template.id = 17;
                template.exp = 1620;
                template.bonus = [{
                    "itemId": "1001",
                    "num": 100
                }, {
                    "itemId": "3001",
                    "num": 200
                }];
                PlayerLevelData.cache[key] = template;
                return template;
            } else if (key == 18) {
                let template = new PlayerLevelData();
                template.id = 18;
                template.exp = 1805;
                template.bonus = [{
                    "itemId": "1001",
                    "num": 100
                }, {
                    "itemId": "3001",
                    "num": 200
                }];
                PlayerLevelData.cache[key] = template;
                return template;
            } else if (key == 19) {
                let template = new PlayerLevelData();
                template.id = 19;
                template.exp = 2000;
                template.bonus = [{
                    "itemId": "1001",
                    "num": 100
                }, {
                    "itemId": "3001",
                    "num": 200
                }];
                PlayerLevelData.cache[key] = template;
                return template;
            } else if (key == 20) {
                let template = new PlayerLevelData();
                template.id = 20;
                template.exp = 2205;
                template.bonus = [{
                    "itemId": "1001",
                    "num": 100
                }, {
                    "itemId": "3001",
                    "num": 200
                }];
                PlayerLevelData.cache[key] = template;
                return template;
            } else if (key == 21) {
                let template = new PlayerLevelData();
                template.id = 21;
                template.exp = 2420;
                template.bonus = [{
                    "itemId": "1001",
                    "num": 100
                }, {
                    "itemId": "3001",
                    "num": 200
                }];
                PlayerLevelData.cache[key] = template;
                return template;
            } else if (key == 22) {
                let template = new PlayerLevelData();
                template.id = 22;
                template.exp = 2645;
                template.bonus = [{
                    "itemId": "1001",
                    "num": 100
                }, {
                    "itemId": "3001",
                    "num": 200
                }];
                PlayerLevelData.cache[key] = template;
                return template;
            } else if (key == 23) {
                let template = new PlayerLevelData();
                template.id = 23;
                template.exp = 2880;
                template.bonus = [{
                    "itemId": "1001",
                    "num": 100
                }, {
                    "itemId": "3001",
                    "num": 200
                }];
                PlayerLevelData.cache[key] = template;
                return template;
            } else if (key == 24) {
                let template = new PlayerLevelData();
                template.id = 24;
                template.exp = 3125;
                template.bonus = [{
                    "itemId": "1001",
                    "num": 100
                }, {
                    "itemId": "3001",
                    "num": 200
                }];
                PlayerLevelData.cache[key] = template;
                return template;
            } else if (key == 25) {
                let template = new PlayerLevelData();
                template.id = 25;
                template.exp = 3380;
                template.bonus = [{
                    "itemId": "1001",
                    "num": 100
                }, {
                    "itemId": "3001",
                    "num": 200
                }];
                PlayerLevelData.cache[key] = template;
                return template;
            } else if (key == 26) {
                let template = new PlayerLevelData();
                template.id = 26;
                template.exp = 3645;
                template.bonus = [{
                    "itemId": "1001",
                    "num": 100
                }, {
                    "itemId": "3001",
                    "num": 200
                }];
                PlayerLevelData.cache[key] = template;
                return template;
            } else if (key == 27) {
                let template = new PlayerLevelData();
                template.id = 27;
                template.exp = 3920;
                template.bonus = [{
                    "itemId": "1001",
                    "num": 100
                }, {
                    "itemId": "3001",
                    "num": 200
                }];
                PlayerLevelData.cache[key] = template;
                return template;
            } else if (key == 28) {
                let template = new PlayerLevelData();
                template.id = 28;
                template.exp = 4205;
                template.bonus = [{
                    "itemId": "1001",
                    "num": 100
                }, {
                    "itemId": "3001",
                    "num": 200
                }];
                PlayerLevelData.cache[key] = template;
                return template;
            } else if (key == 29) {
                let template = new PlayerLevelData();
                template.id = 29;
                template.exp = 4500;
                template.bonus = [{
                    "itemId": "1001",
                    "num": 100
                }, {
                    "itemId": "3001",
                    "num": 200
                }];
                PlayerLevelData.cache[key] = template;
                return template;
            } else if (key == 30) {
                let template = new PlayerLevelData();
                template.id = 30;
                template.exp = 4500;
                template.bonus = [{
                    "itemId": "1001",
                    "num": 100
                }, {
                    "itemId": "3001",
                    "num": 200
                }];
                PlayerLevelData.cache[key] = template;
                return template;
            }
        }
        static getDataByIndex(index) {
            if (PlayerLevelData.cache[this.keys[index]])
                return PlayerLevelData.cache[this.keys[index]];
            return this.getDataByKey(this.keys[index]);
        }
        static getAllData() {
            for (let index = 0; index < this.keys.length; index++) {
                this.getDataByKey(this.keys[index]);
            }
            return PlayerLevelData.cache;
        }
        clear() {
            PlayerLevelData.cache = {};
        }
    }
    PlayerLevelData.cache = {};
    PlayerLevelData.keys = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30];

    class debrisData {
        static getDataByKey(key) {
            if (debrisData.cache[key])
                return debrisData.cache[key];
            if (key == 1) {
                let template = new debrisData();
                template.id = 1;
                template.probability = 40;
                template.count = 1;
                debrisData.cache[key] = template;
                return template;
            } else if (key == 2) {
                let template = new debrisData();
                template.id = 2;
                template.probability = 13;
                template.count = 2;
                debrisData.cache[key] = template;
                return template;
            } else if (key == 3) {
                let template = new debrisData();
                template.id = 3;
                template.probability = 12;
                template.count = 3;
                debrisData.cache[key] = template;
                return template;
            } else if (key == 4) {
                let template = new debrisData();
                template.id = 4;
                template.probability = 8;
                template.count = 4;
                debrisData.cache[key] = template;
                return template;
            } else if (key == 5) {
                let template = new debrisData();
                template.id = 5;
                template.probability = 7;
                template.count = 5;
                debrisData.cache[key] = template;
                return template;
            } else if (key == 6) {
                let template = new debrisData();
                template.id = 6;
                template.probability = 6;
                template.count = 6;
                debrisData.cache[key] = template;
                return template;
            } else if (key == 7) {
                let template = new debrisData();
                template.id = 7;
                template.probability = 5;
                template.count = 7;
                debrisData.cache[key] = template;
                return template;
            } else if (key == 8) {
                let template = new debrisData();
                template.id = 8;
                template.probability = 4;
                template.count = 8;
                debrisData.cache[key] = template;
                return template;
            } else if (key == 9) {
                let template = new debrisData();
                template.id = 9;
                template.probability = 3;
                template.count = 9;
                debrisData.cache[key] = template;
                return template;
            } else if (key == 10) {
                let template = new debrisData();
                template.id = 10;
                template.probability = 2;
                template.count = 10;
                debrisData.cache[key] = template;
                return template;
            }
        }
        static getDataByIndex(index) {
            if (debrisData.cache[this.keys[index]])
                return debrisData.cache[this.keys[index]];
            return this.getDataByKey(this.keys[index]);
        }
        static getAllData() {
            for (let index = 0; index < this.keys.length; index++) {
                this.getDataByKey(this.keys[index]);
            }
            return debrisData.cache;
        }
        clear() {
            debrisData.cache = {};
        }
    }
    debrisData.cache = {};
    debrisData.keys = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10];

    const OFFLINE_TIME = 18000;
    const ONE_TIME = 3600;
    const TWO_TIME = 7200;
    const THREE_TIME = 10800;
    const FOUR_TIME = 14400;
    class RoleManager {
        constructor() {
            this.time = 0;
            this.isNew = false;
            this.id = 0;
            this.sceneCode = 0;
            this.gameCount = 0;
            this.trialSkin = null;
            this.trialArm = null;
            this.roleTpl = {
                gold: 500,
                diamond: 0,
                level: 1,
                sign: {
                    day: 1,
                    ts: 0,
                    state: 0
                },
                sceneId: 0,
                roleSkin: {
                    id: 1,
                    lib: [1]
                },
                skin: {
                    id: 1,
                    gameCurLib: [1],
                    lib: [1],
                    gameCurPropLib: [8001, 2001],
                    propLib: [8001, 2001],
                    updateMultiple: 2,
                    maxMultiple: 4,
                    armQuality: null,
                    synthesisMaxId: 1,
                    partsSkin: {
                        curBagId: null,
                        curHeadId: null,
                        partLib: []
                    }
                },
                warehouseGroove: 3,
                matrix: [1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
                maxUnLockArm: 1,
                buyByGoldNum: 0,
                buyByDiamondNum: 0,
                createTime: Math.floor(new Date().getTime() / 1000),
                task: {
                    count: 1,
                    state: []
                },
                dan: {
                    id: 1,
                    star: 1,
                },
                danAwards: [],
                danAwardsAd: [],
                roleExp: 0,
                equipTryCount: {},
                guide: GuideStep.GAME_1,
                onceGame: {
                    ts: 0,
                    state: 0
                },
                popUpRule: {
                    gameNum: 0,
                    isNew: true,
                },
                autoOpenTime: 0,
                actGoldGun: 0
            };
            this.guideBtnType = GUIDE_BTN.MODE;
            this.curOffinetime = 1;
            this.interstitialCreatCount = 0;
        }
        static getInstance() {
            if (!RoleManager.instance) {
                RoleManager.instance = new RoleManager();
            }
            return RoleManager.instance;
        }
        initData(data = null) {
            if (data) {
                let update = this.getUpdate();
                if (update == '1' || update == '') {
                    console.log('数据不必更新');
                    this.setRoleInfo(JSON.parse(data.roleInfo), '1');
                } else {
                    this.setLocalRoleInfo();
                    this.updateServer();
                }
                this.isNew = data.isNew;
                this.id = data.id;
                Laya.LocalStorage.setItem(STORAGE_ID.OPEN_ID, data.id);
                this.setTimer(data.time);
            } else {
                this.setLocalRoleInfo();
                this.setTimer(Math.floor(new Date().getTime() / 1000));
            }
            this.setSceneId(this.sceneCode);
        }
        setUpdate(isUpdate) {
            Laya.LocalStorage.setItem(STORAGE_ID.IS_UPDATE, isUpdate);
        }
        getUpdate() {
            return Laya.LocalStorage.getItem(STORAGE_ID.IS_UPDATE);
        }
        setRoleInfo(roleInfo, update = '0') {
            if (JSON.stringify(roleInfo) == '{}') {
                this.setLocalRoleInfo();
                this.updateServer();
                return;
            }
            this.setUpdate(update);
            this.roleInfo = roleInfo;
            Laya.LocalStorage.setItem(ConfigManager.appId + STORAGE_ID.ROLE_INFO, JSON.stringify(this.roleInfo));
        }
        setLocalRoleInfo() {
            let value = Laya.LocalStorage.getItem(ConfigManager.appId + STORAGE_ID.ROLE_INFO);
            if (value && value != '') {
                this.roleInfo = JSON.parse(value);
                this.setUpdate('0');
                return this.roleInfo;
            }
            this.isNew = true;
            this.setRoleInfo(this.roleTpl);
            return this.roleTpl;
        }
        getRoleInfo() {
            return this.roleInfo;
        }
        setTimer(time) {
            this.time = time;
            let that = this;
            if (this.timer) {
                clearInterval(this.timer);
            }
            this.timer = setInterval(function() {
                that.time++;
            }, 1000);
            if (this.roleInfo.sign && this.roleInfo.sign.ts < this.time && this.roleInfo.sign.state == 1) {
                this.roleInfo.sign.state = 0;
                this.roleInfo.sign.day = this.roleInfo.sign.day % 7 + 1;
                this.setRoleInfo(this.roleInfo);
            }
            let dot = this.getDotRewardDayInfo();
            if (dot.ts < this.time) {
                let minSec = this.getTime() * 1000;
                let date = new Date(minSec);
                date.setHours(0);
                date.setMinutes(0);
                date.setSeconds(0);
                date.setMilliseconds(0);
                let time = Math.floor(date.getTime() / 1000);
                Laya.LocalStorage.setItem(STORAGE_ID.DOT_REWARD_DAY_COUNT, JSON.stringify({
                    ts: time,
                    count: 0
                }));
            }
            let onceGame = this.getOnceGame();
            if (onceGame.ts < this.time) {
                this.updateOnceGame(0);
            }
        }
        getTime() {
            return this.time;
        }
        updateServer() {
            this.setUpdate('0');
            let updateData = {
                roleInfo: this.roleInfo
            };
            let that = this;
        }
        isAdLimit() {
            let data = Laya.LocalStorage.getItem(STORAGE_ID.AD_LIMIT);
            if (data == '' || !data) {
                return false;
            }
            let sec = parseInt(data);
            if (sec <= this.time) {
                return false;
            } else if (sec - this.time > 86400) {
                return false;
            } else {
                return true;
            }
        }
        setAdLimit() {
            Laya.LocalStorage.setItem(STORAGE_ID.AD_LIMIT, (this.getTime() + 3600) + '');
        }
        costGold(count) {
            let gold = this.getGold();
            if (gold >= count) {
                gold -= Math.floor(count);
            } else {
                return false;
            }
            this.roleInfo.gold = gold;
            this.setRoleInfo(this.roleInfo);
            return true;
        }
        costDiamond(count) {
            let diamond = this.getDiamond();
            if (diamond >= count) {
                diamond -= Math.floor(count);
            } else {
                return false;
            }
            this.roleInfo.diamond = diamond;
            this.setRoleInfo(this.roleInfo);
            NotifyManager.notify(NOTIFY_ID.REFRESH_DIAMOND_VIEW);
            return true;
        }
        rewardGold(count) {
            let gold = this.getGold();
            gold += Math.floor(count);
            this.roleInfo.gold = Math.floor(gold);
            this.setRoleInfo(this.roleInfo);
        }
        rewardDiamond(count) {
            let diamond = this.getDiamond();
            diamond += Math.floor(count);
            this.roleInfo.diamond = Math.floor(diamond);
            this.setRoleInfo(this.roleInfo);
            NotifyManager.notify(NOTIFY_ID.REFRESH_DIAMOND_VIEW);
        }
        getDiamond() {
            return this.roleInfo.diamond;
        }
        setSign() {
            if (this.roleInfo.sign.state == 0) {
                let minSec = this.getTime() * 1000;
                let date = new Date(minSec);
                date.setHours(0);
                date.setMinutes(0);
                date.setSeconds(0);
                date.setMilliseconds(0);
                let newSec = Math.floor(date.getTime() / 1000) + 86400 + 6 * 3600;
                this.roleInfo.sign.state = 1;
                this.roleInfo.sign.ts = newSec;
                this.setRoleInfo(this.roleInfo);
            }
        }
        getSign() {
            return this.roleInfo.sign;
        }
        getGold() {
            return this.roleInfo.gold;
        }
        getLevel() {
            return this.roleInfo.level;
        }
        setLevel(level) {
            this.gameCount++;
            PlatformUtil.reportAnalyise('过关' + this.roleInfo.level);
            if (this.roleInfo.level < level + 1)
                this.roleInfo.level = level + 1;
            this.setRoleInfo(this.roleInfo);
        }
        nextLevel() {
            this.setLevel(this.getLevel());
        }
        ruleCtrl() {
            if (ConfigManager.platform != PLATFORM_TYPE.WX && ConfigManager.platform != PLATFORM_TYPE.TT) {
                return true;
            }
            let scene = JSON.parse(ConfigManager.getConfig().scene);
            let myScene = this.getSceneId();
            console.log('scene', scene);
            console.log('myScene', myScene);
            if (!scene[1]) {
                console.log('场景值未设置');
                return true;
            }
            for (let k in scene[1]) {
                if (scene[1][k] == myScene) {
                    console.log('白名单');
                    return true;
                }
            }
            console.log('黑名单');
            return false;
        }
        launch(options, isFirst) {
            if (options.scene) {
                this.sceneCode = options.scene;
                if (options.scene == 1038) {} else if (options.scene == 1044 || options.scene == 1007 || options.scene == 1008) {} else if (options.scene == 1023) {
                    if (PlatformUtil.isIOS()) {}
                }
            }
            if (isFirst) {}
        }
        setSceneId(sceneId) {
            if (!sceneId)
                return;
            if (!this.roleInfo.sceneId || this.roleInfo.sceneId == 0) {
                this.roleInfo.sceneId = sceneId;
            }
            this.setRoleInfo(this.roleInfo);
        }
        getSceneId() {
            if (this.roleInfo.sceneId) {
                return this.roleInfo.sceneId;
            } else {
                return 0;
            }
        }
        isShareLimit() {
            if (!this.ruleCtrl()) {
                return true;
            }
            if (ConfigManager.isReviewVersion())
                return true;
            if (ConfigManager.getConfig().share_ctrl == 0) {
                return true;
            }
            return false;
        }
        getVibrate() {
            let vibrate = Laya.LocalStorage.getItem(STORAGE_ID.VIBRATE);
            if (!vibrate || vibrate == '') {
                Laya.LocalStorage.setItem(STORAGE_ID.VIBRATE, '1');
                return true;
            } else {
                return vibrate == '1' ? true : false;
            }
        }
        setVibrate() {
            let vibrate = Laya.LocalStorage.getItem(STORAGE_ID.VIBRATE);
            if (vibrate == '1') {
                Laya.LocalStorage.setItem(STORAGE_ID.VIBRATE, '0');
            } else {
                Laya.LocalStorage.setItem(STORAGE_ID.VIBRATE, '1');
            }
        }
        getMusic() {
            let vibrate = Laya.LocalStorage.getItem(STORAGE_ID.MUSIC);
            if (!vibrate || vibrate == '') {
                Laya.LocalStorage.setItem(STORAGE_ID.MUSIC, '1');
                return true;
            } else {
                return vibrate == '1' ? true : false;
            }
        }
        setMusic() {
            let vibrate = Laya.LocalStorage.getItem(STORAGE_ID.MUSIC);
            if (vibrate == '1') {
                Laya.LocalStorage.setItem(STORAGE_ID.MUSIC, '0');
                SoundManager.stopBGM();
            } else {
                Laya.LocalStorage.setItem(STORAGE_ID.MUSIC, '1');
                SoundManager.resumeBGM();
            }
        }
        getEffect() {
            let vibrate = Laya.LocalStorage.getItem(STORAGE_ID.EFFECT);
            if (!vibrate || vibrate == '') {
                Laya.LocalStorage.setItem(STORAGE_ID.EFFECT, '1');
                return true;
            } else {
                return vibrate == '1' ? true : false;
            }
        }
        setEffect() {
            let vibrate = Laya.LocalStorage.getItem(STORAGE_ID.EFFECT);
            if (vibrate == '1') {
                Laya.LocalStorage.setItem(STORAGE_ID.EFFECT, '0');
            } else {
                Laya.LocalStorage.setItem(STORAGE_ID.EFFECT, '1');
            }
        }
        isBannerTouch() {
            if (ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.WEB_4399)
                return true;
            if (ConfigManager.isReviewVersion())
                return false;
            if (ConfigManager.isZsCtrl) {
                return ChannelManager.isZsBannerCtrl();
            }
            if (this.isMaskIOS())
                return false;
            if (this.ruleCtrl() && ConfigManager.carelessCtrl() && !ConfigManager.isBlackRegion('1'))
                return true;
            return false;
        }
        isMaskIOS() {
            let system = PlatformUtil.getSystemInfo();
            if (ConfigManager.getConfig().cut_ios == 1 && system && system.platform == 'ios') {
                console.log("屏蔽IOS");
                return true;
            }
            console.log('开放IOS');
            return false;
        }
        getSelectSkin() {
            let roleInfo = this.getRoleInfo();
            this.clickEquipIsTimeOut();
            return roleInfo.skin.id;
        }
        getSkinLib() {
            let roleInfo = this.getRoleInfo();
            return roleInfo.skin.lib;
        }
        isHaveEquipById(id) {
            let lib = RoleManager.getInstance().getSkinLib();
            for (let index = 0; index < lib.length; index++) {
                const element = lib[index];
                if (element == id) {
                    return true;
                }
            }
            return false;
        }
        getSkinGameCurLib() {
            let roleInfo = this.getRoleInfo();
            return roleInfo.skin.gameCurLib;
        }
        updateSkinGameCurLib(data, lastId = null) {
            if (GuideManager.curEquiplLibraryStep < GuideStep.TOEQUIP && RoleManager.getInstance().getGuide() < GuideStep.TOEQUIP)
                return;
            let minId = 10000;
            let index = null;
            for (let k = 0; k < this.roleInfo.skin.gameCurLib.length; k++) {
                if (this.roleInfo.skin.gameCurLib[k] == data)
                    return;
                if (this.roleInfo.skin.gameCurLib[k] <= minId) {
                    minId = this.roleInfo.skin.gameCurLib[k];
                    index = k;
                }
            }
            if (this.isUseCurlLibById(lastId)) {
                this.roleInfo.skin.gameCurLib[index];
                for (let k = 0; k < this.roleInfo.skin.gameCurLib.length; k++) {
                    if (this.roleInfo.skin.gameCurLib[k] == data)
                        return;
                    if (this.roleInfo.skin.gameCurLib[k] == lastId) {
                        minId = this.roleInfo.skin.gameCurLib[k];
                        index = k;
                    }
                }
                this.roleInfo.skin.gameCurLib[index] = data;
                this.roleInfo.skin.id = data;
            } else {
                if (this.roleInfo.skin.gameCurLib.length + this.roleInfo.skin.gameCurPropLib.length >= 4) {
                    this.roleInfo.skin.gameCurLib[index] = data;
                    this.roleInfo.skin.id = data;
                } else {
                    this.roleInfo.skin.gameCurLib.push(data);
                    this.roleInfo.skin.id = data;
                }
            }
            minId = -1;
            for (let k = 0; k < this.roleInfo.skin.gameCurLib.length; k++) {
                if (this.roleInfo.skin.gameCurLib[k] >= minId) {
                    minId = this.roleInfo.skin.gameCurLib[k];
                    index = k;
                }
            }
            this.roleInfo.skin.id = this.roleInfo.skin.gameCurLib[index];
            this.setRoleInfo(this.roleInfo);
        }
        getUseEquip() {
            return this.roleInfo.skin.id;
        }
        isUseCurlLibById(id) {
            let lib = this.roleInfo.skin.gameCurLib;
            for (let index = 0; index < lib.length; index++) {
                const element = lib[index];
                if (element == id) {
                    return true;
                }
            }
            return false;
        }
        removeSkinGameCurLib(newList) {
            this.roleInfo.skin.gameCurLib = newList;
            this.roleInfo.skin.id = this.roleInfo.skin.gameCurLib[0];
            this.setRoleInfo(this.roleInfo);
        }
        setSelectSkin(id) {
            let roleInfo = this.getRoleInfo();
            for (let k in roleInfo.skin.lib) {
                if (roleInfo.skin.lib[k] == id) {
                    roleInfo.skin.id = id;
                    this.setRoleInfo(roleInfo);
                    return;
                }
            }
            console.log('皮肤' + id + '未拥有');
        }
        setSkinLib(id) {
            let roleInfo = this.getRoleInfo();
            for (let k in roleInfo.skin.lib) {
                if (roleInfo.skin.lib[k] == id) {
                    return false;
                }
            }
            this.addEquipRed(id);
            roleInfo.skin.lib.push(id);
            roleInfo.skin.lib.sort(function(a, b) {
                if (a > b) {
                    return 1;
                } else if (a < b) {
                    return -1;
                } else {
                    return 0;
                }
            });
            this.setRoleInfo(roleInfo);
            return true;
        }
        getPlatformUserId(success) {
            let userId = Laya.LocalStorage.getItem(STORAGE_ID.PLATFORM_USER_ID);
            if (userId == "" || !userId) {
                PlatformUtil.login(function(code) {
                    NetworkManager.request(ROUTE_MAP.PLATFORM_USER_ID, 'POST', {
                        appId: ConfigManager.appId,
                        code: code
                    }, function(data) {
                        console.log(data);
                        if (data.result == 1) {
                            Laya.LocalStorage.setItem(STORAGE_ID.PLATFORM_USER_ID, data.data.userId);
                            success(data.data.userId);
                        }
                    });
                });
            } else {
                success(userId);
            }
        }
        loginDay() {
            let createTime = this.roleInfo.createTime;
            let date = new Date();
            date.setHours(0);
            date.setMinutes(0);
            date.setSeconds(0);
            date.setMilliseconds(0);
            let curTime = Math.floor(date.getTime() / 1000);
            let minSec = createTime * 1000;
            date = new Date(minSec);
            date.setHours(0);
            date.setMinutes(0);
            date.setSeconds(0);
            date.setMilliseconds(0);
            createTime = Math.floor(date.getTime() / 1000);
            let day = (curTime - createTime) / 86400;
            return day;
        }
        getDotRewardCount() {
            let count = Laya.LocalStorage.getItem(STORAGE_ID.DOT_REWARD_COUNT);
            if (count == '' || !count) {
                return 0;
            }
            return parseInt(count);
        }
        getDotRewardDayCount() {
            let info = this.getDotRewardDayInfo();
            return info.count;
        }
        getDotRewardDayInfo() {
            let count = Laya.LocalStorage.getItem(STORAGE_ID.DOT_REWARD_DAY_COUNT);
            if (count == '' || !count) {
                let minSec = this.getTime() * 1000;
                let date = new Date(minSec);
                date.setHours(0);
                date.setMinutes(0);
                date.setSeconds(0);
                date.setMilliseconds(0);
                let time = Math.floor(date.getTime() / 1000) + 86400;
                let json = {
                    count: 0,
                    ts: time
                };
                Laya.LocalStorage.setItem(STORAGE_ID.DOT_REWARD_DAY_COUNT, JSON.stringify(json));
                console.log(json);
                return json;
            } else {
                let json = JSON.parse(count);
                console.log(json);
                return json;
            }
        }
        setDotRewardDayCount() {
            let json = this.getDotRewardDayInfo();
            json.count++;
            Laya.LocalStorage.setItem(STORAGE_ID.DOT_REWARD_DAY_COUNT, JSON.stringify(json));
        }
        isShowDotView() {
            if (ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.WEB_4399)
                return false;
            if (!this.isBannerTouch())
                return false;
            if (ConfigManager.getDotLimit('1', this.getDotRewardDayCount()) == 0)
                return false;
            return true;
        }
        getMatrix() {
            if (this.roleInfo.matrix.length == 17) {
                this.roleInfo.matrix.splice(this.roleInfo.matrix.length - 1, 1);
                this.setRoleInfo(this.roleInfo);
            }
            if (this.roleInfo.matrix.length < 16) {
                let subtract = 16 - this.roleInfo.matrix.length;
                for (let k = 0; k < subtract; k++) {
                    this.roleInfo.matrix.push(-1);
                }
                this.setRoleInfo(this.roleInfo);
            }
            return this.roleInfo.matrix;
        }
        updateMatrix(matrix) {
            this.roleInfo.matrix = matrix;
            this.updateMaxUnLockArm();
            this.setRoleInfo(this.roleInfo);
        }
        openNewMatrix() {
            if (this.roleInfo.matrix.length >= 16)
                return;
            this.roleInfo.matrix.push(-1);
            this.setRoleInfo(this.roleInfo);
        }
        refreshCanbuyArm() {
            let matrix = this.roleInfo.matrix;
            let max = matrix[0];
            let id = 1;
            for (let k = 0; k < matrix.length; k++) {
                let a = matrix[k];
                if (a > max) {
                    max = a;
                }
            }
            if (max > 4) {
                id = max - 4;
            }
            NotifyManager.notify(NOTIFY_ID.REFRESH_CANBUY_ARM, {
                id: id
            });
        }
        updateMaxUnLockArm() {
            let max = this.roleInfo.matrix[0];
            for (let k = 0; k < this.roleInfo.matrix.length; k++) {
                let a = this.roleInfo.matrix[k];
                if (a > max) {
                    max = a;
                }
            }
            if (this.roleInfo.maxUnLockArm < max) {
                this.roleInfo.maxUnLockArm = max;
            }
        }
        getMaxUnLockArm() {
            let max = this.roleInfo.matrix[0];
            for (let k = 0; k < this.roleInfo.matrix.length; k++) {
                let a = this.roleInfo.matrix[k];
                if (a > max) {
                    max = a;
                }
            }
            if (this.roleInfo.maxUnLockArm < max) {
                this.roleInfo.maxUnLockArm = max;
                this.setRoleInfo(this.roleInfo);
            }
            return this.roleInfo.maxUnLockArm;
        }
        updateBuyByGoldNum() {
            this.roleInfo.buyByGoldNum++;
            this.setRoleInfo(this.roleInfo);
            RewardManager.setRewardForInsufficientGoldCoins();
            RewardManager.setfreeRewardForGoldCoins();
        }
        getBuyByGoldNum() {
            return this.roleInfo.buyByGoldNum;
        }
        updateBuyByDiamondNum() {
            this.roleInfo.buyByDiamondNum++;
            this.setRoleInfo(this.roleInfo);
            RewardManager.setRewardForInsufficientDiamonds();
            RewardManager.setfreeDiamondsRewards();
        }
        getBuyByDiamondNum() {
            return this.roleInfo.buyByDiamondNum;
        }
        getUpdateMultiple() {
            if (!this.roleInfo.skin.updateMultiple) {
                this.roleInfo.skin.updateMultiple = 5;
                this.setRoleInfo(this.roleInfo);
            }
            return this.roleInfo.skin.updateMultiple;
        }
        getMaxMultiple() {
            if (!this.roleInfo.skin.maxMultiple) {
                this.roleInfo.skin.maxMultiple = 5;
                this.setRoleInfo(this.roleInfo);
            }
            return this.roleInfo.skin.maxMultiple;
        }
        getArmQuality() {
            if (!this.roleInfo.skin.armQuality) {
                let len = this.roleInfo.skin.lib.length;
                let list = [];
                for (let k = 0; k < len; k++) {
                    let data = {
                        id: 1,
                        lv: 1,
                        fire: ARM.getDataByKey(1).hit,
                        pierceThrough: ARM.getDataByKey(1).pierceThrough,
                        firingRate: ARM.getDataByKey(1).interval,
                        numberOfBullets: ARM.getDataByKey(1).magazineBullet,
                        range: ARM.getDataByKey(1).range,
                        accurate: 100,
                        ammunitionChange: ARM.getDataByKey(1).bullets,
                        sight: ARM.getDataByKey(1).sight,
                        movingSpeed: ARM.getDataByKey(1).movingSpeed,
                        biochemicalCharging: ARM.getDataByKey(1).biochemicalCharging,
                        bodyMultiple: ARM.getDataByKey(1).bodyMultiple,
                        headHit: ARM.getDataByKey(1).headHit,
                        limbMultiple: ARM.getDataByKey(1).limbMultiple,
                        limbHit: ARM.getDataByKey(1).limbHit,
                        maxBodyHit: ARM.getDataByKey(1).maxBodyHit,
                        maxHeadHit: ARM.getDataByKey(1).maxHeadHit,
                        maxLimbHit: ARM.getDataByKey(1).maxLimbHit
                    };
                    list.push(data);
                }
                this.roleInfo.skin.armQuality = list;
                this.setRoleInfo(this.roleInfo);
            }
            return this.roleInfo.skin.armQuality;
        }
        addNewArmQuality(data) {
            let armQuality = this.getArmQuality();
            for (let k = 0; k < armQuality.length; k++) {
                let item = armQuality[k];
                if (item.id == data.id)
                    return;
            }
            this.getArmQuality().push(data);
            this.setRoleInfo(this.roleInfo);
        }
        getArmQualityByID(id) {
            if (id == 8001 || id == 2001)
                return null;
            let data = {
                id: 1,
                lv: 1,
                fire: ARM.getDataByKey(id).hit,
                pierceThrough: ARM.getDataByKey(id).pierceThrough,
                firingRate: ARM.getDataByKey(id).interval,
                numberOfBullets: ARM.getDataByKey(id).magazineBullet,
                range: ARM.getDataByKey(id).range,
                accurate: 100,
                ammunitionChange: ARM.getDataByKey(id).bullets,
                sight: ARM.getDataByKey(id).sight,
                movingSpeed: ARM.getDataByKey(id).movingSpeed,
                biochemicalCharging: ARM.getDataByKey(id).biochemicalCharging,
                bodyMultiple: ARM.getDataByKey(id).bodyMultiple,
                headHit: ARM.getDataByKey(id).headHit,
                limbMultiple: ARM.getDataByKey(id).limbMultiple,
                limbHit: ARM.getDataByKey(id).limbHit,
                maxBodyHit: ARM.getDataByKey(id).maxBodyHit,
                maxHeadHit: ARM.getDataByKey(id).maxHeadHit,
                maxLimbHit: ARM.getDataByKey(id).maxLimbHit
            };
            return data;
        }
        removeArmQualityByID(id) {
            let armQuality = this.getArmQuality();
            let i = null;
            for (let index = 0; index < armQuality.length; index++) {
                const element = armQuality[index];
                if (id == element.id) {
                    i = index;
                }
            }
            if (i != null) {
                armQuality.splice(i, 1);
            }
            this.updateLocal();
        }
        updateArmQuality(id) {
            let armQuality = this.getArmQuality();
        }
        getWarehouseGroove() {
            if (!this.roleInfo.warehouseGroove) {
                this.roleInfo.warehouseGroove = 2;
                this.setRoleInfo(this.roleInfo);
            }
            return this.roleInfo.warehouseGroove;
        }
        updateWarehouseGroove() {
            if (this.getWarehouseGroove() != 9) {
                this.roleInfo.warehouseGroove++;
                this.setRoleInfo(this.roleInfo);
            }
        }
        getSelectRoleSkin() {
            let roleInfo = this.getRoleInfo();
            if (ConfigManager.isReviewVersion() && ConfigManager.isHideSkinById(roleInfo.roleSkin.id)) {
                return 3;
            }
            return roleInfo.roleSkin.id;
        }
        getRoleSkinLib() {
            let roleInfo = this.getRoleInfo();
            return roleInfo.roleSkin.lib;
        }
        setSelectRoleSkin(id) {
            let roleInfo = this.getRoleInfo();
            console.log('设置使用的ID:', id);
            for (let k in roleInfo.roleSkin.lib) {
                if (roleInfo.roleSkin.lib[k] == id) {
                    roleInfo.roleSkin.id = id;
                    this.setRoleInfo(roleInfo);
                    NotifyManager.notify(NOTIFY_ID.REFRESH_SKIN);
                    return;
                }
            }
            console.log('皮肤' + id + '未拥有');
        }
        checkIsHasRoleSkin(id) {
            let roleInfo = this.getRoleInfo();
            for (let k in roleInfo.roleSkin.lib) {
                if (roleInfo.roleSkin.lib[k] == id) {
                    return true;
                }
            }
            if (ConfigManager.isReviewVersion() && ConfigManager.isHideSkinById(id)) {
                return true;
            }
            return false;
        }
        setRoleSkinLib(id) {
            let roleInfo = this.getRoleInfo();
            for (let k in roleInfo.roleSkin.lib) {
                if (roleInfo.roleSkin.lib[k] == id) {
                    return;
                }
            }
            roleInfo.roleSkin.lib.push(id);
            roleInfo.roleSkin.lib.sort(function(a, b) {
                if (a > b) {
                    return 1;
                } else if (a < b) {
                    return -1;
                } else {
                    return 0;
                }
            });
            this.setRoleInfo(roleInfo);
        }
        getGameCurPropLib() {
            let roleInfo = this.getRoleInfo();
            return roleInfo.skin.gameCurPropLib;
        }
        getPropLib() {
            let roleInfo = this.getRoleInfo();
            return roleInfo.skin.propLib;
        }
        removeSkinGameCurPropLib(newList) {
            this.roleInfo.skin.gameCurPropLib = newList;
            this.setRoleInfo(this.roleInfo);
        }
        updateSkinGameCurPropLib(data) {
            for (let k = 0; k < this.roleInfo.skin.gameCurPropLib.length; k++) {
                if (this.roleInfo.skin.gameCurPropLib[k] == data)
                    return;
            }
            this.roleInfo.skin.gameCurPropLib.push(data);
            this.setRoleInfo(this.roleInfo);
        }
        updateLocal() {
            this.setRoleInfo(this.roleInfo);
        }
        getOnlineRewardInfo() {
            let roleInfo = this.getRoleInfo();
            if (!roleInfo.onlineReward) {
                roleInfo.onlineReward = {
                    ts: this.getTime() + 8 * 60,
                    state: 0
                };
                this.updateLocal();
            }
            return roleInfo.onlineReward;
        }
        reciveOnlineReward() {
            let onlineReward = this.getOnlineRewardInfo();
            if (onlineReward.ts <= this.getTime()) {
                onlineReward.ts = this.getTime() + 8 * 60;
                return true;
            }
            return false;
        }
        isCanReciveOnlineReward() {
            let onlineReward = this.getOnlineRewardInfo();
            if (onlineReward.ts <= this.getTime()) {
                return true;
            }
            return false;
        }
        setOfflineTime() {
            if (this.roleInfo) {
                this.roleInfo.offlineTime = this.getTime();
                this.updateLocal();
            }
        }
        getOfflineTime() {
            if (!this.roleInfo.offlineTime) {
                this.roleInfo.offlineTime = this.getTime();
                this.updateLocal();
            }
            return this.roleInfo.offlineTime;
        }
        isCanOpenOfflineView() {
            let time = this.getOfflineTime();
            let curTime = this.getTime();
            if (curTime - time >= ONE_TIME && curTime - time < TWO_TIME) {
                RoleManager.getInstance().curOffinetime = 1;
                return true;
            } else if (curTime - time >= TWO_TIME && curTime - time < THREE_TIME) {
                RoleManager.getInstance().curOffinetime = 2;
                return true;
            } else if (curTime - time >= THREE_TIME && curTime - time < FOUR_TIME) {
                RoleManager.getInstance().curOffinetime = 3;
                return true;
            } else if (curTime - time >= FOUR_TIME && curTime - time < OFFLINE_TIME) {
                RoleManager.getInstance().curOffinetime = 4;
                return true;
            } else if (curTime - time > OFFLINE_TIME) {
                RoleManager.getInstance().curOffinetime = 5;
                return true;
            }
            return false;
        }
        getSynthesisMaxId() {
            let roleInfo = this.getRoleInfo();
            if (!roleInfo.skin.synthesisMaxId) {
                roleInfo.skin.synthesisMaxId = 1;
                this.updateLocal();
            }
            return roleInfo.skin.synthesisMaxId;
        }
        updateSynthesisMaxId(id) {
            let roleInfo = this.getRoleInfo();
            let synthesisMaxId = this.getSynthesisMaxId();
            if (synthesisMaxId >= id)
                return;
            roleInfo.skin.synthesisMaxId = id;
            console.log('当前最高等级：', roleInfo.skin.synthesisMaxId);
            this.updateLocal();
        }
        getTask() {
            let roleInfo = this.getRoleInfo();
            let task;
            if (!roleInfo.task) {
                roleInfo.task = {
                    count: 1,
                    state: []
                };
                task = roleInfo.task;
            } else {
                task = roleInfo.task;
            }
            let day = this.loginDay() % 7 + 1;
            if (day == 0) {
                if (task.state.length > 1) {
                    task.count += 1;
                    task.state = [];
                }
            }
            if (task.state.length != day) {
                task.state.push(0);
            }
            roleInfo.task = task;
            this.setRoleInfo(roleInfo);
            return task.state;
        }
        getTaskStateByDay(day) {
            let s = this.getTask();
            if (s.length >= day) {
                let state = s[day - 1];
                if (state != TASK_STATE.UNINDAY && state != TASK_STATE.COMPLETE && state != TASK_STATE.GET) {
                    const p = state;
                    let data = TaskData.getDataByKey(day);
                    let task = TaskManager.getTaskType(data.taskType);
                    this.roleInfo.task.state[day - 1] = p >= task.data ? TASK_STATE.COMPLETE : p;
                    this.setRoleInfo(this.roleInfo);
                }
                return state;
            } else {
                return TASK_STATE.UNINDAY;
            }
        }
        isShowTaskRed() {
            for (let index = 1; index <= 7; index++) {
                const element = this.getTaskStateByDay(index);
                if (element == TASK_STATE.COMPLETE)
                    return true;
            }
            return false;
        }
        isShowTaskAtuo() {
            for (let index = 1; index <= 7; index++) {
                const element = this.getTaskStateByDay(index);
                if (element != TASK_STATE.GET && element != TASK_STATE.UNINDAY)
                    return true;
            }
            return false;
        }
        doTaksByDay(day, progress) {
            let state = this.getTaskStateByDay(day);
            if (state != TASK_STATE.UNINDAY && state != TASK_STATE.COMPLETE && state != TASK_STATE.GET) {
                const p = state;
                let data = TaskData.getDataByKey(day);
                let task = TaskManager.getTaskType(data.taskType);
                this.roleInfo.task.state[day - 1] = (p + progress) >= task.data ? TASK_STATE.COMPLETE : (p + progress);
                this.setRoleInfo(this.roleInfo);
            }
        }
        reciveTaskAwardByDay(day) {
            let state = this.getTaskStateByDay(day);
            if (state == TASK_STATE.COMPLETE) {
                this.roleInfo.task.state[day - 1] = TASK_STATE.GET;
                this.setRoleInfo(this.roleInfo);
                return true;
            } else {
                return false;
            }
        }
        getDanInfo() {
            if (!this.roleInfo.dan) {
                this.roleInfo.dan = {
                    id: 1,
                    star: 0,
                };
            }
            if (this.roleInfo.dan && this.roleInfo.dan.id > DanData.keys[DanData.keys.length - 1]) {
                this.roleInfo.dan.id = DanData.keys[DanData.keys.length - 1];
            }
            return this.roleInfo.dan;
        }
        getAllDanStar() {
            let myDan = this.getDanInfo();
            let star = myDan.star;
            for (let i = 1; i < myDan.id; i++) {
                let danData = DanData.getDataByKey(i);
                star += danData.star;
            }
            return star;
        }
        translateAllStarToDan(star) {
            let id = 1;
            if (star <= 0) {
                return {
                    id: id,
                    star: 0
                };
            }
            let allDanData = DanData.getAllData();
            for (let k in allDanData) {
                if (allDanData[k].star < star) {
                    star -= allDanData[k].star;
                } else {
                    id = allDanData[k].id;
                    break;
                }
            }
            return {
                id: id,
                star: star
            };
        }
        increaseStar() {
            let myDan = this.roleInfo.dan;
            let curDanData = DanData.getDataByKey(myDan.id);
            let ret = false;
            if (myDan.star + 1 > curDanData.star && myDan.id < DanData.keys[DanData.keys.length - 1]) {
                myDan.id += 1;
                if (myDan.id > DanData.keys[DanData.keys.length - 1]) {
                    myDan.id = DanData.keys[DanData.keys.length - 1];
                    myDan.star += 1;
                } else {
                    myDan.star = 1;
                }
                ret = true;
                TaskManager.completeTask(TASK_TYPE.DAN_UP);
            } else {
                myDan.star += 1;
            }
            this.setRoleInfo(this.roleInfo);
            return ret;
        }
        reduceStar() {
            let myDan = this.roleInfo.dan;
            let ret = false;
            if (myDan.star - 1 < 0) {
                if (myDan.id > 1) {
                    myDan.id -= 1;
                    let danaData = DanData.getDataByKey(myDan.id);
                    myDan.star = danaData.star - 1;
                    ret = true;
                } else {
                    myDan.star = 0;
                }
            } else {
                myDan.star -= 1;
            }
            this.setRoleInfo(this.roleInfo);
            return ret;
        }
        getDanAwards() {
            if (!this.roleInfo.danAwards) {
                this.roleInfo.danAwards = [];
                this.setRoleInfo(this.roleInfo);
            }
            return this.roleInfo.danAwards;
        }
        setDanAward(id) {
            let data = this.getDanAwards();
            for (let index = 0; index < data.length; index++) {
                const element = data[index];
                if (id == element) {
                    console.log("当前段位奖励以及领取过了");
                    return false;
                }
            }
            data.push(id);
            this.setRoleInfo(this.roleInfo);
            return true;
        }
        getDanAwardsAd() {
            if (!this.roleInfo.danAwardsAd) {
                this.roleInfo.danAwardsAd = [];
                this.setRoleInfo(this.roleInfo);
            }
            return this.roleInfo.danAwardsAd;
        }
        setDanAwardAd(id) {
            let data = this.getDanAwardsAd();
            for (let index = 0; index < data.length; index++) {
                const element = data[index];
                if (id == element) {
                    console.log("当前段位奖励以及领取过了");
                    return false;
                }
            }
            data.push(id);
            this.setRoleInfo(this.roleInfo);
            return true;
        }
        getNewGiftInfo() {
            if (typeof this.roleInfo.newGift == 'undefined') {
                this.roleInfo.newGift = {
                    state: 0
                };
                this.updateLocal();
            }
            return this.roleInfo.newGift;
        }
        reciveNewGift() {
            let newGift = this.getNewGiftInfo();
            newGift.state = 1;
            this.updateLocal();
        }
        increaseExp(exp, cb = null) {
            let preLv = this.getRoleExpData().lv;
            if (this.getRoleExpData().curExp + exp > this.getRoleExpData().exp) {
                exp = this.getRoleExpData().exp - this.getRoleExpData().curExp;
            }
            this.roleInfo.roleExp += exp;
            let curLv = this.getRoleExpData().lv;
            this.setRoleInfo(this.roleInfo);
            if (curLv > preLv) {
                this.setRoleInfo(this.roleInfo);
                cb && cb();
                GameScene.isLevelUp = true;
                return true;
            }
            return false;
        }
        getRoleExpData() {
            let keys = PlayerLevelData.keys;
            let exp = 0;
            let curExp = this.roleInfo.roleExp;
            for (let i = 0; i < keys.length; i++) {
                let data = PlayerLevelData.getDataByIndex(i);
                exp += data.exp;
                if (curExp - data.exp >= 0) {
                    curExp = curExp - data.exp;
                }
                if (exp > this.roleInfo.roleExp) {
                    return {
                        exp: data.exp,
                        curExp: curExp,
                        lv: data.id
                    };
                }
            }
            let data = PlayerLevelData.getDataByIndex(keys.length - 1);
            return {
                exp: data.exp,
                curExp: data.exp,
                lv: data.id
            };
        }
        isOpenEquipTry() {
            return true;
        }
        getEquipTryCount(equipId) {
            if (!this.roleInfo.equipTryCount) {
                this.roleInfo.equipTryCount = {};
                this.updateLocal();
                return 0;
            } else {
                if (this.roleInfo.equipTryCount[equipId]) {
                    return this.roleInfo.equipTryCount[equipId];
                } else
                    return 0;
            }
        }
        addEquipTryCount(equipId) {
            if (this.getEquipTryCount(equipId) == 0)
                this.roleInfo.equipTryCount[equipId] = 1;
            else {
                this.roleInfo.equipTryCount[equipId] += 1;
            }
            this.updateLocal();
        }
        addEquipRed(equipId) {
            let d = this.getEquipRed();
            if (d) {
                d[equipId] = 1;
                Laya.LocalStorage.setItem(STORAGE_ID.EQUIP_RED, JSON.stringify(d));
            } else {
                let datas = {};
                datas[equipId] = 1;
                Laya.LocalStorage.setItem(STORAGE_ID.EQUIP_RED, JSON.stringify(datas));
            }
        }
        setEquipRed(equipId) {
            let d = this.getEquipRed();
            if (d && d[equipId]) {
                d[equipId] = null;
                Laya.LocalStorage.setItem(STORAGE_ID.EQUIP_RED, JSON.stringify(d));
            } else {
                console.log('已经设置为旧武器');
            }
        }
        getEquipRedById(equipId) {
            let d = this.getEquipRed();
            if (d && d[equipId]) {
                return true;
            } else {
                return false;
            }
        }
        getEquipRed() {
            let d = Laya.LocalStorage.getItem(STORAGE_ID.EQUIP_RED);
            if (d) {
                let data = JSON.parse(d);
                return data;
            } else {
                return null;
            }
        }
        isShowEquipRed() {
            let d = this.getEquipRed();
            if (d) {
                for (const key in d) {
                    if (Object.prototype.hasOwnProperty.call(d, key)) {
                        const element = d[key];
                        if (element)
                            return true;
                    }
                }
                return false;
            } else {
                return false;
            }
        }
        getGuide() {
            let roleInfo = this.getRoleInfo();
            if (typeof roleInfo.guide == 'undefined') {
                roleInfo.guide = GuideStep.MAX;
            }
            return this.isNew ? this.roleInfo.guide : GuideStep.MAX;
        }
        setGuide(target = null) {
            let guide = this.getGuide();
            if (guide >= GuideStep.FINISH) {
                console.log('已完成所以教程');
                return;
            }
            let roleInfo = this.getRoleInfo();
            if (target == null) {
                roleInfo.guide = guide + 1;
                console.log('当前下一步：', roleInfo.guide);
            } else {
                roleInfo.guide = target;
            }
            if (GuideManager.curEquiplLibraryStep == GuideStep.GAME_2) {
                if (roleInfo.guide == GuideStep.EQUIP || roleInfo.guide == GuideStep.BUY || roleInfo.guide == GuideStep.SYNTHESIS || roleInfo.guide == GuideStep.WAREHOUSE || roleInfo.guide == GuideStep.TOEQUIP) {
                    roleInfo.guide = GuideStep.GAME_2;
                }
            }
            this.updateLocal();
        }
        setPlatfromUserInfo(res) {
            Laya.LocalStorage.setItem(STORAGE_ID.PLATFORM_USER_INFO, JSON.stringify(res));
        }
        getPlatfromUserInfo() {
            let res = Laya.LocalStorage.getItem(STORAGE_ID.PLATFORM_USER_INFO);
            if (res && res.length > 0)
                return JSON.parse(res);
            else
                return null;
        }
        getOnceGame() {
            let roleInfo = this.getRoleInfo();
            if (!roleInfo.onceGame) {
                let minSec = this.getTime() * 1000;
                let date = new Date(minSec);
                date.setHours(0);
                date.setMinutes(0);
                date.setSeconds(0);
                date.setMilliseconds(0);
                let time = Math.floor(date.getTime() / 1000) + 86400;
                roleInfo.onceGame = {
                    ts: time,
                    state: 0
                };
                this.updateLocal();
            }
            return roleInfo.onceGame;
        }
        getIsOnceGame() {
            let onceGame = this.getOnceGame();
            if (onceGame.state == 0)
                return true;
            return false;
        }
        updateOnceGame(state) {
            let onceGame = this.getOnceGame();
            if (state == 1 && onceGame.state == 1)
                return;
            if (state == 0) {
                let minSec = this.getTime() * 1000;
                let date = new Date(minSec);
                date.setHours(0);
                date.setMinutes(0);
                date.setSeconds(0);
                date.setMilliseconds(0);
                let time = Math.floor(date.getTime() / 1000) + 86400;
                this.roleInfo.onceGame.ts = time;
            }
            this.roleInfo.onceGame.state = state;
            this.updateLocal();
        }
        getSuperEquipId() {
            let id = {};
            id[SPECIAL_ID.RED_TASSEL_EQUIP] = 1;
            id[SPECIAL_ID.RED_SPIRIT_EQUIP] = 1;
            let lib = RoleManager.getInstance().getSkinLib();
            for (let index = 0; index < lib.length; index++) {
                const element = lib[index];
                if (element == SPECIAL_ID.RED_TASSEL_EQUIP) {
                    id[element] = 0;
                } else {
                    if (element == SPECIAL_ID.RED_SPIRIT_EQUIP) {
                        id[element] = 0;
                    }
                }
            }
            let keys = [];
            for (const key in id) {
                if (Object.prototype.hasOwnProperty.call(id, key)) {
                    const element = id[key];
                    if (element)
                        keys.push(key);
                }
            }
            if (keys.length > 0) {
                return Number(keys[Math.floor(Mathf.random(keys.length, 0))]);
            }
            return null;
        }
        isCanGetActivityByType(type) {
            switch (type) {
                case ACTIVITY_TYPE.DOUBLE_FOX:
                    {
                        if (this.isHaveEquipById(SPECIAL_ID.ACTIVITY_EQUIP1) || this.isHaveEquipById(SPECIAL_ID.ACTIVITY_EQUIP2))
                            return false;
                        else {
                            return true;
                        }
                    }
                case ACTIVITY_TYPE.BARRETT:
                    {
                        if (this.isHaveEquipById(SPECIAL_ID.ACTIVITY_BARRETT))
                            return false;
                        else {
                            return true;
                        }
                    }
                default:
                    break;
            }
            return false;
        }
        reciveFirecracker(count) {
            let firecracker = this.getFirecrackerInfo();
            firecracker.count += count;
            this.updateLocal();
        }
        getFirecrackerInfo() {
            if (this.roleInfo.firecracker) {} else {
                this.roleInfo.firecracker = {
                    count: 0,
                };
                this.updateLocal();
            }
            return this.roleInfo.firecracker;
        }
        setEquipHaveTime(id, time = 0) {
            this.getEquipHaveTime(id);
            if (this.roleInfo.equipHaveTime[id]) {
                this.roleInfo.equipHaveTime[id] += time;
            } else {
                this.roleInfo.equipHaveTime[id] = time + this.getTime();
            }
            if (time == 0) {
                this.roleInfo.equipHaveTime[id] = null;
            }
            this.updateLocal();
        }
        getEquipHaveTime(id = null) {
            if (this.roleInfo.equipHaveTime) {} else {
                this.roleInfo.equipHaveTime = {};
                this.updateLocal();
            }
            if (this.roleInfo.equipHaveTime[id]) {
                return this.roleInfo.equipHaveTime[id];
            } else
                return 0;
        }
        clickEquipIsTimeOut() {
            this.getEquipHaveTime();
            for (const key in this.roleInfo.equipHaveTime) {
                if (Object.prototype.hasOwnProperty.call(this.roleInfo.equipHaveTime, key)) {
                    const element = this.roleInfo.equipHaveTime[key];
                    if (element) {
                        if (this.getTime() > element) {
                            console.log('武器到期');
                            this.roleInfo.equipHaveTime[key] = null;
                            this.removeSkin(key);
                        }
                    }
                }
            }
        }
        removeSkin(id) {
            this.removeArmQualityByID(id); {
                let lib = this.roleInfo.skin.lib;
                let i = null;
                for (let index = 0; index < lib.length; index++) {
                    const element = lib[index];
                    if (element == id) {
                        i = index;
                    }
                }
                if (i != null) {
                    this.roleInfo.skin.lib.splice(i, 1);
                }
            } {
                let lib = this.roleInfo.skin.gameCurLib;
                let i = null;
                for (let index = 0; index < lib.length; index++) {
                    const element = lib[index];
                    if (element == id) {
                        i = index;
                    }
                }
                if (i != null) {
                    this.roleInfo.skin.gameCurLib.splice(i, 1);
                    if (this.roleInfo.skin.gameCurLib.length == 0) {
                        this.roleInfo.skin.gameCurLib[0] = this.roleInfo.skin.lib[this.roleInfo.skin.lib.length - 1];
                    }
                    this.removeSkinGameCurLib(this.roleInfo.skin.gameCurLib);
                }
            }
            this.updateLocal();
        }
        isShowNewYearGift() {
            if (RoleManager.getInstance().getFirecrackerInfo().count >= NewYearGiftData.getDataByKey(NewYearGiftData.keys[NewYearGiftData.keys.length - 1]).cost) {
                return false;
            } else {
                return true;
            }
        }
        isInterstitialTouch() {
            if (!this.isBannerTouch())
                return false;
            if (ConfigManager.getInterstitialTouchCount() == 0) {
                return false;
            }
            this.interstitialCreatCount += 1;
            console.log('interstitialCreatCount' + this.interstitialCreatCount);
            console.log('ConfigManager.getInterstitialTouchCount()' + ConfigManager.getInterstitialTouchCount());
            if (this.interstitialCreatCount >= ConfigManager.getInterstitialTouchCount()) {
                this.interstitialCreatCount = 0;
                return true;
            } else {
                return false;
            }
        }
        getTurnInfo() {
            if (!this.roleInfo.turnInfo) {
                this.roleInfo.turnInfo = {
                    state: 1,
                    lib: []
                };
                this.updateLocal();
            }
            return this.roleInfo.turnInfo;
        }
        setTurnAward(index) {
            let info = this.getTurnInfo();
            for (let i = 0; i < info.lib.length; i++) {
                const element = info.lib[i];
                if (element == index) {
                    console.log('已经领取过此索引');
                    return;
                }
            }
            info.lib.push(index);
            if (info.lib.length == 8) {
                console.log('进入下一轮');
                info.state += 1;
                info.lib = [];
            }
            this.updateLocal();
        }
        isGetTurnAward(index) {
            let info = this.getTurnInfo();
            for (let i = 0; i < info.lib.length; i++) {
                const element = info.lib[i];
                if (element == index) {
                    return true;
                }
            }
            return false;
        }
        getPartsSkin() {
            if (!this.roleInfo.skin.partsSkin) {
                let partsSkin = {
                    curBagId: null,
                    curHeadId: null,
                    partLib: []
                };
                this.roleInfo.skin.partsSkin = partsSkin;
                this.setRoleInfo(this.roleInfo);
            }
            return this.roleInfo.skin.partsSkin;
        }
        setPartsSkin(id) {
            let partsSkin = this.getPartsSkin();
            for (let k = 0; k < partsSkin.partLib.length; k++) {
                if (id == partsSkin.partLib[k])
                    return;
            }
            partsSkin.partLib.push(id);
            let data = PARTS.getDataByKey(id);
            if (data.partType == 1) {
                partsSkin.curBagId = id;
            } else if (data.partType == 2) {
                partsSkin.curHeadId = id;
            } else if (data.partType == 3) {
                partsSkin.curBagId = id;
            }
            this.roleInfo.skin.partsSkin = partsSkin;
            this.setRoleInfo(this.roleInfo);
        }
        setTargetPart(id) {
            let partsSkin = this.getPartsSkin();
            let data = PARTS.getDataByKey(id);
            if (data.partType == 1) {
                partsSkin.curBagId = id;
            } else if (data.partType == 2) {
                partsSkin.curHeadId = id;
            } else if (data.partType == 3) {
                partsSkin.curBagId = id;
            }
            this.roleInfo.skin.partsSkin = partsSkin;
            this.setRoleInfo(this.roleInfo);
        }
        getTargetPart(num) {
            let partsSkin = this.getPartsSkin();
            if (num == 1) {
                return partsSkin.curBagId;
            } else if (num == 2) {
                return partsSkin.curHeadId;
            } else if (num == 3) {
                return partsSkin.curBagId;
            }
        }
        checkPart(id) {
            let lib = this.getPartLib();
            for (let k = 0; k < lib.length; k++) {
                if (id == lib[k]) {
                    return true;
                }
            }
            return false;
        }
        getPartLib() {
            let partsSkin = this.getPartsSkin();
            return partsSkin.partLib;
        }
        removePart(num) {
            let partsSkin = this.getPartsSkin();
            if (num == 1) {
                partsSkin.curBagId = null;
            } else if (num == 2) {
                partsSkin.curHeadId = null;
            } else if (num == 3) {
                partsSkin.curBagId = null;
            }
            this.roleInfo.skin.partsSkin = partsSkin;
            this.setRoleInfo(this.roleInfo);
        }
        getFragmentList() {
            if (!this.roleInfo.fragmentList) {
                let fragmentList = [];
                this.roleInfo.fragmentList = fragmentList;
                this.setRoleInfo(this.roleInfo);
            }
            return this.roleInfo.fragmentList;
        }
        setFragmentList(data) {
            let fragmentList = this.getFragmentList();
            let isGetAward = false;
            for (let k = 0; k < fragmentList.length; k++) {
                let item = fragmentList[k];
                if (item.type == data.type && item.id == data.id) {
                    item.num += data.num;
                    this.roleInfo.fragmentList = fragmentList;
                    switch (data.type) {
                        case ITEM_TYPE.HERO_DEBRIS:
                            if (RoleData.getDataByKey(Item.getDataByKey(data.id).extra()).cost <= item.num && !this.checkIsHasRoleSkin(Item.getDataByKey(data.id).extra()))
                                isGetAward = true;
                            break;
                        case ITEM_TYPE.PART_DEBRIS:
                            if (PARTS.getDataByKey(Item.getDataByKey(data.id).extra()).cost <= item.num && !this.checkPart(Item.getDataByKey(data.id).extra()))
                                isGetAward = true;
                            break;
                    }
                    this.setRoleInfo(this.roleInfo);
                    return isGetAward;
                }
            }
            switch (data.type) {
                case ITEM_TYPE.HERO_DEBRIS:
                    if (RoleData.getDataByKey(Item.getDataByKey(data.id).extra()).cost <= data.num)
                        isGetAward = true;
                    break;
                case ITEM_TYPE.PART_DEBRIS:
                    if (PARTS.getDataByKey(Item.getDataByKey(data.id).extra()).cost <= data.num)
                        isGetAward = true;
                    break;
            }
            fragmentList.push(data);
            this.roleInfo.fragmentList = fragmentList;
            this.setRoleInfo(this.roleInfo);
            return isGetAward;
        }
        getTargetFragment(data) {
            let fragmentList = this.getFragmentList();
            for (let k = 0; k < fragmentList.length; k++) {
                let item = fragmentList[k];
                if (item.type == data.type && item.id == data.id) {
                    return item.num;
                }
            }
            return 0;
        }
        getBoxTragmentId(isHero = true, isPart = true) {
            let heroList = [];
            let partList = [];
            if (isHero)
                for (let index = 0; index < RoleData.keys.length; index++) {
                    const element = RoleData.getDataByIndex(index);
                    if (element.costType == 3) {
                        if (!this.checkIsHasRoleSkin(element.id))
                            heroList.push(element);
                    }
                }
            if (isPart)
                for (let index = 0; index < PARTS.keys.length; index++) {
                    const element = PARTS.getDataByIndex(index);
                    if (element.costType == 3) {
                        if (!this.checkPart(element.id))
                            partList.push(element);
                    }
                }
            let count = 1;
            let countRand = Mathf.random(100, 0);
            let p = 0;
            if (isHero && isPart)
                for (let index = 0; index < debrisData.keys.length; index++) {
                    const element = debrisData.getDataByIndex(index);
                    if (countRand <= element.probability + p) {
                        count = element.count;
                        break;
                    } else {
                        p = element.probability + p;
                    }
                }
            let rand = heroList.length + partList.length;
            let itemId;
            if (rand != 0) {
                if (heroList.length == 0 || partList.length == 0) {
                    if (heroList.length != 0) {
                        let data = heroList[Math.floor(Mathf.random(heroList.length, 0))];
                        let id = data ? data.id : null;
                        itemId = !id ? id : ITEM_TYPE.HERO_DEBRIS.toString() + (id > 99 ? id : id > 9 ? '0' + id : '00' + id);
                    } else {
                        let data = partList[Math.floor(Mathf.random(partList.length, 0))];
                        let id = data ? data.id : null;
                        itemId = !id ? id : ITEM_TYPE.PART_DEBRIS.toString() + (id > 99 ? id : id > 9 ? '0' + id : '00' + id);
                    }
                } else {
                    if (Mathf.random(rand, 0) > heroList.length) {
                        let data = heroList[Math.floor(Mathf.random(heroList.length, 0))];
                        let id = data ? data.id : null;
                        itemId = !id ? id : ITEM_TYPE.HERO_DEBRIS.toString() + (id > 99 ? id : id > 9 ? '0' + id : '00' + id);
                    } else {
                        let data = partList[Math.floor(Mathf.random(partList.length, 0))];
                        let id = data ? data.id : null;
                        itemId = !id ? id : ITEM_TYPE.PART_DEBRIS.toString() + (id > 99 ? id : id > 9 ? '0' + id : '00' + id);
                    }
                }
            }
            if (itemId)
                return {
                    itemId: itemId,
                    count: count
                };
            else {
                RewardManager.setfreeRewardForGoldCoins();
                return {
                    itemId: SPECIAL_ID.GOLD,
                    count: RewardManager.curFreeGoldRewards
                };
            }
        }
        getTurnItemInfo(index, state) {
            let key = index + '_' + state;
            let info = Laya.LocalStorage.getItem(STORAGE_ID.TURN_TABLE_ITEM);
            if (info) {} else {
                Laya.LocalStorage.setItem(STORAGE_ID.TURN_TABLE_ITEM, JSON.stringify({}));
            }
            let data = JSON.parse(Laya.LocalStorage.getItem(STORAGE_ID.TURN_TABLE_ITEM));
            if (data[key]) {
                let minSec = this.getTime() * 1000;
                let d = new Date(minSec);
                d.setHours(0);
                d.setMinutes(0);
                d.setSeconds(0);
                d.setMilliseconds(0);
                let time = Math.floor(d.getTime() / 1000);
                if (data[key].time < time) {
                    console.log('获取新的奖励');
                    if (state <= 4) {
                        let turnTableData = TurnTableData.getDataByKey(index + ((state - 1) * 8));
                        if (turnTableData.awardType != 6 && turnTableData.awardType != 7) {
                            RewardManager.setfreeRewardForGoldCoins();
                            return {
                                itemId: SPECIAL_ID.GOLD,
                                count: RewardManager.curFreeGoldRewards
                            };
                        }
                        let itemData = Item.getDataByKey(turnTableData.itemData[0].award);
                        if (itemData.type == ITEM_TYPE.HERO_DEBRIS) {
                            if (RoleManager.getInstance().checkIsHasRoleSkin(itemData.extra())) {
                                itemData = Item.getDataByKey(RoleManager.getInstance().getBoxTragmentId(true, false).itemId);
                            }
                        } else {
                            if (RoleManager.getInstance().checkPart(itemData.extra())) {
                                itemData = Item.getDataByKey(RoleManager.getInstance().getBoxTragmentId(false, true).itemId);
                            }
                        }
                        data[key] = {
                            itemId: itemData.id,
                            count: turnTableData.itemData[0].count,
                            time: time,
                        };
                        Laya.LocalStorage.setItem(STORAGE_ID.TURN_TABLE_ITEM, JSON.stringify(data));
                        return data[key];
                    } else {
                        let turnTableData = TurnTableData.getDataByKey(index + (Math.min((state - 1), 4) * 8));
                        if (turnTableData.awardType != 11 && turnTableData.awardType != 10) {
                            RewardManager.setfreeRewardForGoldCoins();
                            return {
                                itemId: SPECIAL_ID.GOLD,
                                count: RewardManager.curFreeGoldRewards
                            };
                        }
                        let itemData;
                        if (10 == turnTableData.awardType) {
                            itemData = Item.getDataByKey(RoleManager.getInstance().getBoxTragmentId(true, false).itemId);
                        } else {
                            itemData = Item.getDataByKey(RoleManager.getInstance().getBoxTragmentId(false, true).itemId);
                        }
                        data[key] = {
                            itemId: itemData.id,
                            count: turnTableData.itemData[0].count,
                            time: time,
                        };
                        Laya.LocalStorage.setItem(STORAGE_ID.TURN_TABLE_ITEM, JSON.stringify(data));
                        return data[key];
                    }
                } else {
                    let itemData = Item.getDataByKey(data[key].itemId);
                    if (itemData.type == ITEM_TYPE.HERO_DEBRIS) {
                        if (RoleManager.getInstance().checkIsHasRoleSkin(itemData.extra())) {
                            itemData = Item.getDataByKey(RoleManager.getInstance().getBoxTragmentId(true, false).itemId);
                        }
                    } else {
                        if (RoleManager.getInstance().checkPart(itemData.extra())) {
                            itemData = Item.getDataByKey(RoleManager.getInstance().getBoxTragmentId(false, true).itemId);
                        }
                    }
                    if (itemData.id != data[key].itemId) {
                        data[key].itemId = itemData.id;
                        Laya.LocalStorage.setItem(STORAGE_ID.TURN_TABLE_ITEM, JSON.stringify(data));
                    }
                    return data[key];
                }
            } else {
                let minSec = this.getTime() * 1000;
                let d = new Date(minSec);
                d.setHours(0);
                d.setMinutes(0);
                d.setSeconds(0);
                d.setMilliseconds(0);
                let time = Math.floor(d.getTime() / 1000);
                console.log('获取新的奖励');
                if (state <= 4) {
                    let turnTableData = TurnTableData.getDataByKey(index + ((state - 1) * 8));
                    if (turnTableData.awardType != 6 && turnTableData.awardType != 7) {
                        RewardManager.setfreeRewardForGoldCoins();
                        return {
                            itemId: SPECIAL_ID.GOLD,
                            count: RewardManager.curFreeGoldRewards
                        };
                    }
                    let itemData = Item.getDataByKey(turnTableData.itemData[0].award);
                    if (itemData.type == ITEM_TYPE.HERO_DEBRIS) {
                        if (RoleManager.getInstance().checkIsHasRoleSkin(itemData.extra())) {
                            itemData = Item.getDataByKey(RoleManager.getInstance().getBoxTragmentId(true, false).itemId);
                        }
                    } else {
                        if (RoleManager.getInstance().checkPart(itemData.extra())) {
                            itemData = Item.getDataByKey(RoleManager.getInstance().getBoxTragmentId(false, true).itemId);
                        }
                    }
                    data[key] = {
                        itemId: itemData.id,
                        count: turnTableData.itemData[0].count,
                        time: time,
                    };
                    Laya.LocalStorage.setItem(STORAGE_ID.TURN_TABLE_ITEM, JSON.stringify(data));
                    return data[key];
                } else {
                    let turnTableData = TurnTableData.getDataByKey(index + (Math.min((state - 1), 4) * 8));
                    if (turnTableData.awardType != 11 && turnTableData.awardType != 10) {
                        RewardManager.setfreeRewardForGoldCoins();
                        return {
                            itemId: SPECIAL_ID.GOLD,
                            count: RewardManager.curFreeGoldRewards
                        };
                    }
                    let itemData;
                    if (10 == turnTableData.awardType) {
                        itemData = Item.getDataByKey(RoleManager.getInstance().getBoxTragmentId(true, false).itemId);
                    } else {
                        itemData = Item.getDataByKey(RoleManager.getInstance().getBoxTragmentId(false, true).itemId);
                    }
                    data[key] = {
                        itemId: itemData.id,
                        count: turnTableData.itemData[0].count,
                        time: time,
                    };
                    Laya.LocalStorage.setItem(STORAGE_ID.TURN_TABLE_ITEM, JSON.stringify(data));
                    return data[key];
                }
            }
        }
        getPopUpRule() {
            if (!this.roleInfo.popUpRule) {
                let popUpRule = {
                    gameNum: 0,
                    isNew: true,
                };
                this.roleInfo.popUpRule = popUpRule;
                this.setRoleInfo(this.roleInfo);
            }
            return this.roleInfo.popUpRule;
        }
        updatePopUpRuleGameNum() {
            let popUpRule = this.getPopUpRule();
            if (popUpRule.gameNum < 4) {
                popUpRule.gameNum++;
            }
            this.roleInfo.popUpRule = popUpRule;
            this.setRoleInfo(this.roleInfo);
        }
        setPopUpRuleIsNew() {
            let popUpRule = this.getPopUpRule();
            if (popUpRule.gameNum >= 3) {
                popUpRule.isNew = false;
            }
            this.roleInfo.popUpRule = popUpRule;
            this.setRoleInfo(this.roleInfo);
        }
        getPopUpRuleIsNewRole() {
            let popUpRule = this.getPopUpRule();
            if (popUpRule.gameNum >= 4) {
                popUpRule.isNew = false;
                this.roleInfo.popUpRule = popUpRule;
                this.setRoleInfo(this.roleInfo);
            }
            return popUpRule.isNew;
        }
        getAutoOpenTime() {
            let roleInfo = this.getRoleInfo();
            if (!roleInfo.autoOpenTime) {
                roleInfo.autoOpenTime = 0;
                this.updateLocal();
            }
            return roleInfo.autoOpenTime;
        }
        setAutoOpenTime() {
            if (this.roleInfo) {
                this.roleInfo.autoOpenTime = this.getTime();
                this.updateLocal();
            }
        }
        isCanAutoOpenFunction() {
            let getAutoOpenTime = this.getAutoOpenTime();
            let curTime = this.getTime();
            if (getAutoOpenTime == 0) {
                console.log('为0是第一次');
                this.setAutoOpenTime();
                return true;
            } else {
                if (curTime - getAutoOpenTime >= FOUR_TIME) {
                    console.log('可以打开');
                    this.setAutoOpenTime();
                    return true;
                } else {
                    return false;
                }
            }
        }
        getActGoldGunState() {
            if (typeof this.roleInfo.actGoldGun === 'undefined') {
                this.roleInfo.actGoldGun = 0;
                this.setRoleInfo(this.roleInfo);
            }
            return this.roleInfo.actGoldGun;
        }
        setActGoldGunState() {
            this.roleInfo.actGoldGun = 1;
            this.setRoleInfo(this.roleInfo);
        }
        isReceiveCDKey(cdkey) {
            if (typeof this.roleInfo.cdkey === 'undefined') {
                this.roleInfo.cdkey = {};
                this.setRoleInfo(this.roleInfo);
            }
            if (this.roleInfo.cdkey[cdkey] == 1)
                return true;
            return false;
        }
        receiveCDkey(cdkey) {
            if (!this.isReceiveCDKey(cdkey)) {
                this.roleInfo.cdkey[cdkey] = 1;
                this.setRoleInfo(this.roleInfo);
                return true;
            }
            return false;
        }
    }
    RoleManager.isNewCupDan = false;

    class SoundManager {
        static vibrateShort(type = 'light') {
            if (ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.WEB_4399)
                return;
            if (PerformanceManager.isCloseZD)
                return;
            if (RoleManager.getInstance().getVibrate()) {
                PlatformUtil.vibrateShort(type);
            }
        }
        static vibrateLong() {
            if (ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.WEB_4399)
                return;
            if (PerformanceManager.isCloseZD)
                return;
            if (RoleManager.getInstance().getVibrate()) {
                PlatformUtil.vibrateLong();
            }
        }
        static cleanEffect() {
            for (let k in SoundManager.effectList) {
                SoundManager.destoryEffect(k);
            }
            SoundManager.effectList = {};
        }
        static cleanEffectByName(resName) {
            SoundManager.destoryEffect(`${resName}`);
        }
        static destoryEffect(resName) {
            if (SoundManager.effectList[resName]) {
                for (let k in SoundManager.effectList[resName]) {
                    if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD || ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS) {
                        Laya.SoundManager.removeChannel(SoundManager.effectList[resName][k]);
                        Laya.SoundManager.destroySound(resName);
                    } else {
                        SoundManager.effectList[resName][k].offPlay(SoundManager.effectList[resName][k].playCB);
                        SoundManager.effectList[resName][k].offEnded(SoundManager.effectList[resName][k].endCB);
                        SoundManager.effectList[resName][k].playCB = null;
                        SoundManager.effectList[resName][k].endCB = null;
                        SoundManager.effectList[resName][k].destroy();
                        SoundManager.effectList[resName][k] = null;
                    }
                }
                SoundManager.effectList[resName] = null;
                delete SoundManager.effectList[resName];
            }
        }
        static stop(resName) {
            if (SoundManager.effectList[resName]) {
                for (let k in SoundManager.effectList[resName]) {
                    let audio = SoundManager.effectList[resName][k];
                    audio.stop();
                }
            }
        }
        static playBGM(resName) {
            Laya.SoundManager.musicMuted = false;
            SoundManager.destoryBGM();
            if (!RoleManager.getInstance().getMusic()) {
                return;
            }
            if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD || ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS || ConfigManager.platform == PLATFORM_TYPE.WEB_4399 || ConfigManager.platform == PLATFORM_TYPE.WEB) {
                console.log('播放背景音乐-');
                SoundManager.bgm = Laya.SoundManager.playMusic(resName, 0);
            } else {
                let audio = wx.createInnerAudioContext();
                audio.src = resName;
                audio.loop = true;
                audio.play();
                SoundManager.bgm = audio;
            }
            SoundManager.isBGMPause = false;
        }
        static setBGMVolume(volume) {
            if (!RoleManager.getInstance().getMusic()) {
                return;
            }
            if (SoundManager.bgm) {
                SoundManager.bgm.volume = volume;
            }
        }
        static stopBGM() {
            if (SoundManager.bgm) {
                if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD || ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS) {
                    if (GameScene.isGaming) {
                        Laya.SoundManager.musicMuted = true;
                    }
                    SoundManager.bgm.pause();
                } else {
                    SoundManager.bgm.stop();
                }
                SoundManager.isBGMPause = true;
            }
        }
        static destoryBGM() {
            if (SoundManager.bgm) {
                if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD || ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS || ConfigManager.platform == PLATFORM_TYPE.WEB_4399 || ConfigManager.platform == PLATFORM_TYPE.WEB) {
                    Laya.SoundManager.stopMusic();
                } else {
                    if (SoundManager.bgm)
                        SoundManager.bgm.destroy();
                }
                SoundManager.bgm = null;
                SoundManager.isBGMPause = false;
            }
        }
        static resumeBGMFromInterruption() {
            if (GameScene.isGaming)
                return;
            if (SoundManager.bgm && !SoundManager.isBGMPause && RoleManager.getInstance().getMusic()) {
                if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD || ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS || ConfigManager.platform == PLATFORM_TYPE.WEB_4399 || ConfigManager.platform == PLATFORM_TYPE.WEB) {
                    SoundManager.bgm.resume();
                } else {
                    SoundManager.bgm.play();
                }
                SoundManager.isBGMPause = false;
            }
        }
        static resumeBGM() {
            if (GameScene.isGaming)
                return;
            if (SoundManager.bgm && RoleManager.getInstance().getMusic()) {
                if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD || ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS) {
                    SoundManager.bgm.resume();
                } else {
                    SoundManager.bgm.play();
                }
                SoundManager.isBGMPause = false;
            }
        }
        static playEffect(resName, count = 1, destory = false, volume = 1) {
            return SoundManager.play(resName, count, destory, volume);
        }
        static play(resName, count = 1, destory = false, volume = 1) {
            if (!RoleManager.getInstance().getEffect()) {
                return;
            }
            if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD || ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS) {
                let splits = resName.split('.');
                if (splits.length > 2) {
                    throw new Error('resName error!');
                }
                let name = 'native/' + splits[0] + '.wav';
                return SoundManager.playNative(name, count, destory, volume);
            } else if (ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.WEB_4399) {
                let splits = resName.split('.');
                if (splits.length > 2) {
                    throw new Error('resName error!');
                }
                let name = 'native/' + splits[0] + '.wav';
                return SoundManager.playNative(resName, count, destory, volume);
            } else {
                return SoundManager.playMini(resName, count, destory, volume);
            }
        }
        static playNative(resName, count = 1, destory = false, volume = 1) {
            let audio = Laya.SoundManager.playSound(resName, count);
            if (!audio)
                return;
            if (!audio.volume)
                return;
            audio.volume = volume;
            audio.isPause = false;
            audio.completeHandler = Laya.Handler.create(this, function() {
                audio.isPause = true;
                if (destory) {
                    SoundManager.destoryEffect(resName);
                }
            });
            return audio;
        }
        static playMini(resName, count = 1, destory = false, volume = 1) {
            if (SoundManager.effectList[resName]) {
                for (let k in SoundManager.effectList[resName]) {
                    let audio = SoundManager.effectList[resName][k];
                    if (audio.paused || audio.isPause) {
                        audio.volume = volume;
                        audio.isPause = false;
                        if (count == 0) {
                            audio.loop = true;
                        } else {
                            audio.loop = false;
                        }
                        audio.seek(0);
                        audio.play();
                        return audio;
                    }
                }
            } else {
                SoundManager.effectList[resName] = [];
            }
            let that = SoundManager;
            let audio = wx.createInnerAudioContext();
            audio.src = resName;
            audio.autoplay = false;
            if (count == 0) {
                audio.loop = true;
            } else {
                audio.loop = false;
            }
            audio.play();
            let playCB = function() {
                audio.isPause = false;
            };
            let endCB = function() {
                audio.isPause = true;
                if (destory) {
                    that.destoryEffect(resName);
                }
            };
            audio.onPlay(playCB);
            audio.onEnded(endCB);
            audio.endCB = endCB;
            audio.volume = volume;
            audio.playCB = playCB;
            SoundManager.effectList[resName].push(audio);
            return audio;
        }
        static preload(resName) {
            if (ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.WEB_4399)
                return;
            if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD || ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS)
                return;
            if (SoundManager.effectList[resName]) {
                return;
            } else {
                SoundManager.effectList[resName] = [];
            }
            let that = SoundManager;
            let audio = wx.createInnerAudioContext();
            audio.src = resName;
            audio.autoplay = false;
            SoundManager.effectList[resName].push(audio);
        }
        static playEffect3D(resName, pos = null, count = 1, sound = 1) {
            if (!RoleManager.getInstance().getEffect())
                return;
            let audio;
            if (pos) {
                if (SoundManager.effect3dCtrl[resName]) {
                    return;
                }
                let volume = SoundManager.calculateVolume(pos, CharacterManger.playerLogicalBaseLayer.getPresentationBaseLayer().getModelPosByVector3());
                if (volume == 0)
                    return;
                SoundManager.effect3dCtrl[resName] = true;
                let time = 100;
                if (PlatformUtil.isIOS()) {
                    time = 500;
                }
                setTimeout(function() {
                    SoundManager.effect3dCtrl[resName] = false;
                }, time);
                audio = SoundManager.play(resName, count, false, volume * sound);
            } else {
                audio = SoundManager.play(resName, count, false, sound);
            }
            let object = {
                audio: audio,
                pos: pos,
                resName: resName
            };
            return object;
        }
        static stopEffect3D(object) {
            if (!RoleManager.getInstance().getEffect())
                return;
            if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS || ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD || ConfigManager.platform == PLATFORM_TYPE.WEB_4399 || ConfigManager.platform == PLATFORM_TYPE.WEB) {
                let splits = object.resName.split('.');
                if (splits.length > 2) {
                    throw new Error('resName error!');
                }
                let name = 'native/' + splits[0] + '.wav';
                Laya.SoundManager.stopSound(name);
                if (object && object.audio)
                    object.audio.isPause = true;
            } else {
                let effect = object;
                effect.audio.stop();
                effect.audio.isPause = true;
            }
        }
        static calculateVolume(pos1, pos2) {
            let volume;
            let dis = Laya.Vector3.distanceSquared(pos1, pos2);
            if (dis > 50 * 50) {
                return 0;
            }
            let maxVolume = 1;
            let minDist = 50;
            let maxDist = 700;
            let k = maxVolume / (minDist - maxDist);
            if (dis <= minDist) {
                volume = maxVolume;
            } else if (dis > minDist && dis < maxDist) {
                volume = maxVolume + (dis - minDist) * k;
            } else {
                volume = 0.1;
            }
            if (volume < 0.1)
                volume = 0.1;
            return volume;
        }
        static stopAllEffect() {
            if (!RoleManager.getInstance().getEffect())
                return;
            if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS || ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD || ConfigManager.platform == PLATFORM_TYPE.WEB_4399 || ConfigManager.platform == PLATFORM_TYPE.WEB) {
                console.log('原生音频暂时不支持停止所有音效');
            } else {
                for (let k in SoundManager.effectList) {
                    this.stop(k);
                }
            }
        }
    }
    SoundManager.isMute = false;
    SoundManager.effectList = {};
    SoundManager.bgm = null;
    SoundManager.isBGMPause = false;
    SoundManager.effect3dCtrl = {};
    SoundManager.effect3dList = [];

    var WX_CUSTOM_AD_STYLE;
    (function(WX_CUSTOM_AD_STYLE) {
        WX_CUSTOM_AD_STYLE[WX_CUSTOM_AD_STYLE["SINGLE"] = 1] = "SINGLE";
        WX_CUSTOM_AD_STYLE[WX_CUSTOM_AD_STYLE["VERTICAL"] = 2] = "VERTICAL";
        WX_CUSTOM_AD_STYLE[WX_CUSTOM_AD_STYLE["HORIZONTAL"] = 3] = "HORIZONTAL";
        WX_CUSTOM_AD_STYLE[WX_CUSTOM_AD_STYLE["MATRIX"] = 4] = "MATRIX";
        WX_CUSTOM_AD_STYLE[WX_CUSTOM_AD_STYLE["SINGLE_1"] = 5] = "SINGLE_1";
    })(WX_CUSTOM_AD_STYLE || (WX_CUSTOM_AD_STYLE = {}));
    let EXE_BANNER_COMMAND_TS = 300;
    let EXE_COMMAND_COMMAND_TS = 300;
    class PlatformUtil {
        static createBannerAd(adUnitId, isHide = false, cb = null, width = null) {
            if (ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.WEB_4399)
                return;
            if (ConfigManager.platform == PLATFORM_TYPE.WX) {
                PlatformUtil._createBannerWX(adUnitId, isHide, cb, width);
            } else if (ConfigManager.platform == PLATFORM_TYPE.QQ) {
                PlatformUtil._createBannerQQ(adUnitId, isHide, cb, width);
            } else if (ConfigManager.platform == PLATFORM_TYPE.VIVO) {
                PlatformUtil._createBannerVV(adUnitId, isHide, cb);
            } else if (ConfigManager.platform == PLATFORM_TYPE.OPPO) {
                PlatformUtil._createBannerOP(adUnitId, isHide, cb);
            } else if (ConfigManager.platform == PLATFORM_TYPE.TT) {
                PlatformUtil._createBannerTT(adUnitId, isHide, cb, width);
            } else if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS) {
                PlatformUtil.isHideBanner = false;
                let PlatformClass = window['PlatformClass'];
                if (PlatformClass)
                    PlatformClass.createClass('JSBridge').call('createBannerAd:', adUnitId);
            } else if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD) {
                PlatformUtil.isHideBanner = false;
                let PlatformClass = window['PlatformClass'];
                if (PlatformClass)
                    PlatformClass.createClass('demo.JSBridge').call('createBannerAd', RoleManager.getInstance().isBannerTouch());
            }
            this.bannerSuccessCallBack = function() {
                cb && cb(true);
            };
            this.bannerFailCallBack = function() {
                cb && cb(false);
            };
        }
        static setSystemInfo(wight, height) {
            if (!PlatformUtil.systemInfo) {
                PlatformUtil.systemInfo = {
                    windowWidth: wight,
                    windowHeight: height
                }; {
                    let system = this.getSystemInfo();
                    PlatformUtil.bannerCenterPos.x = system.windowWidth / 2 - system.windowWidth * 3 / 20;
                    PlatformUtil.bannerCenterPos.y = system.windowHeight - 200;
                    console.log('system' + system);
                    console.log('bannerCenterPosx' + PlatformUtil.bannerCenterPos.x);
                }
            }
        }
        static _createBannerWX(adUnitId, isHide = false, cb = null, adWidth = null) {
            let system = PlatformUtil.getSystemInfo();
            if (!PlatformUtil.versionfunegt(system.SDKVersion, '2.0.4')) {
                return;
            }
            let width = 0;
            let height = 200 * system.windowWidth / 1334;
            let ad = wx.createBannerAd({
                adUnitId: adUnitId,
                style: {
                    left: (system.windowWidth - 300) * 0.5,
                    top: system.windowHeight,
                    width: 300
                }
            });
            PlatformUtil.bannerCenterPos.x = (system.windowWidth - 300) * 0.5;
            PlatformUtil.bannerCenterPos.y = system.windowHeight - 104;
            if (system.platform == 'ios') {
                if (Laya.stage.width / Laya.stage.height > 2) {
                    PlatformUtil.bannerCenterPos.y = system.windowHeight - 104 - 15;
                }
            }
            let resizeFunc = function(res) {
                console.log('resize', res);
                ad.style.top = system.windowHeight - res.height;
                ad.style.left = (system.windowWidth - res.width) * 0.5;
                if (system.platform == 'ios') {
                    if (Laya.stage.width / Laya.stage.height > 2) {
                        ad.style.top = system.windowHeight - res.height - 15;
                    }
                }
                if (PlatformUtil.bannerPrePos.y != null && !(PlatformUtil.bannerPrePos.y == 0 && PlatformUtil.bannerPrePos.x == 0)) {
                    ad.style.top = PlatformUtil.bannerPrePos.y;
                }
                if (PlatformUtil.bannerPrePos.x != null && !(PlatformUtil.bannerPrePos.y == 0 && PlatformUtil.bannerPrePos.x == 0)) {
                    ad.style.left = PlatformUtil.bannerPrePos.x;
                }
            };
            ad.onResize(resizeFunc);
            let errFunc = function(err) {
                PlatformUtil.isBannerError = true;
                console.log('banner 广告加载失败', err);
                if (cb)
                    cb();
                ad.offLoad(loadFunc);
                ad.offError(errFunc);
                ad.offResize(resizeFunc);
            };
            ad.onError(errFunc);
            let loadFunc = function(res) {
                PlatformUtil.isBannerError = false;
                ad.offLoad(loadFunc);
                ad.offError(errFunc);
                ad.offResize(resizeFunc);
                console.log('banner 广告加载成功');
                PlatformUtil.banner.push(ad);
                PlatformUtil.banner[PlatformUtil.banner.length - 1].isLoadSuccess = true;
                if (PlatformUtil.banner.length == 1) {
                    ad.show();
                } else
                    ad.hide();
                if (cb)
                    cb();
            };
            ad.onLoad(loadFunc);
        }
        static _createBannerQQ(adUnitId, isHide = false, cb = null, adWidth = null) {
            if (ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.WEB_4399)
                return;
            let system = PlatformUtil.getSystemInfo();
            PlatformUtil.bannerIdList[PlatformUtil.bannerIdx] = adUnitId;
            let curIdx = PlatformUtil.bannerIdx;
            let delay = function() {
                console.log('_createBannerQQ', adUnitId);
                let ad = wx.createBannerAd({
                    adUnitId: adUnitId,
                    style: {
                        left: (system.windowWidth - 320) * 0.5,
                        top: system.windowHeight,
                        width: 320
                    }
                });
                let resizeFunc = function(res) {
                    console.log(res);
                    ad.style.top = system.windowHeight - res.height;
                    ad.style.left = (system.windowWidth - res.width) * 0.5;
                    if (system.platform == 'ios') {
                        if (Laya.stage.width / Laya.stage.height > 2) {
                            ad.style.top = system.windowHeight - res.height;
                        }
                    }
                    if (PlatformUtil.bannerCenterPos.x == 0) {
                        PlatformUtil.bannerCenterPos.x = ad.style.left;
                    }
                    if (PlatformUtil.bannerCenterPos.y == 0)
                        PlatformUtil.bannerCenterPos.y = ad.style.top;
                    if (PlatformUtil.bannerPrePos.y != null && PlatformUtil.bannerPrePos.y != 0) {
                        ad.style.top = PlatformUtil.bannerPrePos.y;
                    }
                    if (PlatformUtil.bannerPrePos.x != null && (PlatformUtil.bannerPrePos.x != 0)) {
                        ad.style.left = PlatformUtil.bannerPrePos.x;
                    }
                    ad.offResize(resizeFunc);
                    PlatformUtil.banner.push(ad);
                    PlatformUtil.banner[PlatformUtil.banner.length - 1].isLoadSuccess = true;
                    if (PlatformUtil.banner.length == 1) {
                        if (!PlatformUtil.isHideBanner)
                            ad.show();
                    } else {
                        if (PlatformUtil.exeBannerCommandList.length > 0) {
                            PlatformUtil.exeBannerCommand();
                        } else {
                            if (PlatformUtil.isHideBanner)
                                ad.hide();
                            else {
                                ad.show();
                            }
                        }
                    }
                    if (cb)
                        cb();
                };
                ad.onResize(resizeFunc);
                let errFunc = function(err) {
                    PlatformUtil.isBannerError = true;
                    console.log('banner craate error', err);
                    if (cb)
                        cb();
                    ad.offLoad(loadFunc);
                    ad.offError(errFunc);
                    ad.offResize(resizeFunc);
                };
                ad.onError(errFunc);
                let loadFunc = function() {
                    PlatformUtil.isBannerError = false;
                    console.log('_createBannerQQ load success');
                    ad.offLoad(loadFunc);
                    ad.offError(errFunc);
                };
                ad.onLoad(loadFunc);
                ad.adUnitId = adUnitId;
            };
            delay();
        }
        static _createBannerVV(adUnitId, isHide = false, cb = null) {
            let systemInfo = PlatformUtil.getSystemInfo();
            if (systemInfo.platformVersionCode < 1031) {
                return;
            }
            console.log('PlatformUtil.bannerIdx', PlatformUtil.bannerIdx);
            if (PlatformUtil.banner[PlatformUtil.bannerIdx]) {
                PlatformUtil.banner[PlatformUtil.bannerIdx].destroy();
                PlatformUtil.banner[PlatformUtil.bannerIdx] = null;
            }
            var bannerAd = qg.createBannerAd({
                posId: adUnitId,
                style: {}
            });
            PlatformUtil.banner[PlatformUtil.bannerIdx] = bannerAd;
            console.log('_createBannerVV', adUnitId);
            let onLoad = function(res) {
                PlatformUtil.isBannerError = false;
                console.log('onLoad', res);
                bannerAd.offError(onError);
                bannerAd.offLoad(onLoad);
                PlatformUtil.banner[PlatformUtil.bannerIdx].isLoadSuccess = true;
                if (PlatformUtil.exeBannerCommandList.length > 0) {
                    PlatformUtil.exeBannerCommand();
                } else {
                    bannerAd.hide();
                }
                if (cb)
                    cb();
            };
            let onError = function(res) {
                PlatformUtil.isBannerError = true;
                console.log('onError', JSON.stringify(res));
                bannerAd.offError(onError);
                bannerAd.offLoad(onLoad);
            };
            bannerAd.onLoad(onLoad);
            bannerAd.onError(onError);
        }
        static _createBannerOP(adUnitId, isHide = false, cb = null) {
            PlatformUtil.isHideBanner = false;
            let ad;
            if (!PlatformUtil.banner[PlatformUtil.bannerIdx]) {
                ad = qg.createBannerAd({
                    posId: adUnitId,
                });
                ad = ad;
            } else {
                ad = PlatformUtil.banner[PlatformUtil.bannerIdx];
                console.log('recycle oppo banner');
            }
            let errorCB = function(err) {
                console.log('createBannerOppo onError', err);
                if (cb)
                    cb();
                ad.offShow(showCB);
                ad.offError(errorCB);
            };
            let showCB = function() {
                console.log('createBannerOppo onShow');
                if (cb)
                    cb();
                ad.offShow(showCB);
                ad.offError(errorCB);
                if (PlatformUtil.isHideBanner) {
                    ad.hide();
                }
            };
            ad.onError(errorCB);
            ad.onShow(showCB);
            if (isHide) {
                ad.hide();
            } else {
                ad.show();
            }
            PlatformUtil.banner[PlatformUtil.bannerIdx] = ad;
        }
        static _createBannerTT(adUnitId, isHide = false, cb = null, adWidth = null) {
            let system = PlatformUtil.getSystemInfo();
            let platform = tt;
            if (!platform.createBannerAd)
                return;
            if (PlatformUtil.banner[PlatformUtil.bannerIdx]) {
                PlatformUtil.banner[PlatformUtil.bannerIdx].destroy();
                PlatformUtil.banner[PlatformUtil.bannerIdx] = null;
            }
            PlatformUtil.bannerPrePos.x = null;
            PlatformUtil.bannerPrePos.y = null;
            let width = 0;
            let height = 150 * system.windowWidth / 1334;
            let ad = platform.createBannerAd({
                adUnitId: adUnitId,
                style: {
                    left: (system.windowWidth - 150) * 0.5,
                    top: system.windowHeight,
                    width: 150
                }
            });
            let resizeFunc = function(res) {
                ad.offResize(resizeFunc);
                console.log('resize', res);
                ad.style.top = system.windowHeight - res.height;
                ad.style.left = (system.windowWidth - res.width) * 0.5;
                if (system.platform == 'ios') {
                    if (Laya.stage.width / Laya.stage.height > 2) {
                        ad.style.top = system.windowHeight - res.height - 15;
                    }
                }
                PlatformUtil.bannerCenterPos.x = ad.style.left;
                PlatformUtil.bannerCenterPos.y = ad.style.top;
                if (PlatformUtil.bannerPrePos.y != null) {
                    ad.style.top = PlatformUtil.bannerPrePos.y;
                }
                if (PlatformUtil.bannerPrePos.x != null) {
                    ad.style.left = PlatformUtil.bannerPrePos.x;
                }
            };
            ad.onResize(resizeFunc);
            let errFunc = function(err) {
                PlatformUtil.isBannerError = true;
                console.log('banner 广告加载失败', err);
                if (cb)
                    cb();
                ad.offLoad(loadFunc);
                ad.offError(errFunc);
                ad.offResize(resizeFunc);
            };
            ad.onError(errFunc);
            let loadFunc = function(res) {
                PlatformUtil.isBannerError = false;
                ad.offLoad(loadFunc);
                ad.offError(errFunc);
                console.log('banner 广告加载成功');
                PlatformUtil.banner[PlatformUtil.bannerIdx].isLoadSuccess = true;
                if (PlatformUtil.exeBannerCommandList.length > 0) {
                    PlatformUtil.exeBannerCommand();
                } else {
                    ad.hide();
                }
                if (cb)
                    cb();
            };
            ad.onLoad(loadFunc);
            PlatformUtil.banner[PlatformUtil.bannerIdx] = ad;
        }
        static _preloadBannerQQ(adUnitId, isHide = false, cb = null, adWidth = null) {
            if (ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.WEB_4399)
                return;
            let system = PlatformUtil.getSystemInfo();
            if (PlatformUtil.banner[PlatformUtil.bannerIdx]) {
                PlatformUtil.banner[PlatformUtil.bannerIdx].hide();
                PlatformUtil.banner[PlatformUtil.bannerIdx].style.top = 10000;
                PlatformUtil.banner[PlatformUtil.bannerIdx].style.left = 10000;
                PlatformUtil.banner[PlatformUtil.bannerIdx] = null;
            }
            PlatformUtil.bannerIdList[PlatformUtil.bannerIdx] = adUnitId;
            PlatformUtil.bannerPrePos.x = null;
            PlatformUtil.bannerPrePos.y = null;
            let curIdx = PlatformUtil.bannerIdx;
            let delay = function() {
                console.log('_preloadBannerQQ', adUnitId);
                let ad = wx.createBannerAd({
                    adUnitId: adUnitId,
                    style: {
                        left: (system.windowWidth - 320) * 0.5,
                        top: system.windowHeight,
                        width: 320
                    }
                });
                let resizeFunc = function(res) {
                    console.log(res);
                    ad.style.top = system.windowHeight - res.height;
                    ad.style.left = (system.windowWidth - res.width) * 0.5;
                    if (system.platform == 'ios') {
                        if (Laya.stage.width / Laya.stage.height > 2) {
                            ad.style.top = system.windowHeight - res.height - 15;
                        }
                    }
                    if (!PlatformUtil.bannerCenterPos.x) {
                        PlatformUtil.bannerCenterPos.x = ad.style.left;
                        PlatformUtil.bannerCenterPos.y = ad.style.top;
                    }
                    if (PlatformUtil.bannerPrePos.y != null) {
                        ad.style.top = PlatformUtil.bannerPrePos.y;
                    }
                    if (PlatformUtil.bannerPrePos.x != null) {
                        ad.style.left = PlatformUtil.bannerPrePos.x;
                    }
                    ad.hide();
                    ad.offResize(resizeFunc);
                    PlatformUtil.banner[curIdx].isLoadSuccess = true;
                    if (PlatformUtil.bannerIdx == curIdx && PlatformUtil.exeBannerCommandList.length > 0) {
                        PlatformUtil.exeBannerCommand();
                    }
                    if (cb)
                        cb();
                };
                ad.onResize(resizeFunc);
                let errFunc = function(err) {
                    PlatformUtil.isBannerError = true;
                    console.log('banner craate error', err);
                    PlatformUtil.showModal('拉取banner失败', JSON.stringify(err));
                    if (cb)
                        cb();
                    ad.offLoad(loadFunc);
                    ad.offError(errFunc);
                    ad.offResize(resizeFunc);
                };
                ad.onError(errFunc);
                let loadFunc = function() {
                    PlatformUtil.isBannerError = false;
                    console.log('_createBannerQQ load success');
                    ad.offLoad(loadFunc);
                    ad.offError(errFunc);
                };
                ad.onLoad(loadFunc);
                PlatformUtil.banner[curIdx] = ad;
                ad.adUnitId = adUnitId;
            };
            setTimeout(delay, 20);
        }
        static showBannerAd(x = null, y = null, success = null) {
            if (ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.WEB_4399)
                return;
            if (x != null) {
                PlatformUtil.bannerPrePos.x = x;
            } else {
                PlatformUtil.bannerPrePos.x = PlatformUtil.bannerCenterPos.x;
            }
            if (y != null) {
                PlatformUtil.bannerPrePos.y = y;
            } else {
                PlatformUtil.bannerPrePos.y = PlatformUtil.bannerCenterPos.y;
            }
            if (PlatformUtil.bannerPrePos.x == 0) {
                PlatformUtil.bannerPrePos.x = PlatformUtil.bannerCenterPos.x;
            }
            if (PlatformUtil.bannerPrePos.y == 0) {
                PlatformUtil.bannerPrePos.y = PlatformUtil.bannerCenterPos.y;
            }
            if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS) {
                let PlatformClass = window['PlatformClass'];
                if (PlatformClass)
                    PlatformClass.createClass('JSBridge').call('showBannerAd');
                success && success();
                return;
            } else if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD) {
                let PlatformClass = window['PlatformClass'];
                let data = {
                    x: PlatformUtil.bannerPrePos.x,
                    y: PlatformUtil.bannerPrePos.y
                };
                let str = JSON.stringify(data);
                if (PlatformClass)
                    PlatformClass.createClass('demo.JSBridge').call('showBannerAd', str);
                success && success();
                return;
            }
            PlatformUtil.isHideBanner = false;
            PlatformUtil.pushBannerCommand(1, success);
            if (ConfigManager.platform == PLATFORM_TYPE.WX || ConfigManager.platform == PLATFORM_TYPE.QQ) {
                if (ConfigManager.platform == PLATFORM_TYPE.WX)
                    PlatformUtil.exeBannerCommand();
                return;
            }
            if (PlatformUtil.banner[PlatformUtil.bannerIdx]) {
                if (ConfigManager.platform != PLATFORM_TYPE.VIVO && ConfigManager.platform != PLATFORM_TYPE.OPPO) {
                    PlatformUtil.banner[PlatformUtil.bannerIdx].style.left = PlatformUtil.bannerPrePos.x;
                    PlatformUtil.banner[PlatformUtil.bannerIdx].style.top = PlatformUtil.bannerPrePos.y;
                }
                if (ConfigManager.platform == PLATFORM_TYPE.OPPO) {
                    PlatformUtil.banner[PlatformUtil.bannerIdx].show();
                    success && success();
                } else {
                    if (PlatformUtil.banner[PlatformUtil.bannerIdx].isLoadSuccess) {
                        PlatformUtil.exeBannerCommand();
                    } else {
                        console.log('banner show不执行');
                    }
                }
            }
        }
        static bannerIdxUpdate() {
            this.bannerIdx++;
            this.bannerIdx %= 2;
        }
        static hideBannerAd() {
            if (ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.WEB_4399)
                return;
            if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS) {
                let PlatformClass = window['PlatformClass'];
                if (PlatformClass)
                    PlatformClass.createClass('JSBridge').call('hideBannerAd');
                return;
            } else if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD) {
                let PlatformClass = window['PlatformClass'];
                if (PlatformClass)
                    PlatformClass.createClass('demo.JSBridge').call('hideBannerAd');
                return;
            }
            PlatformUtil.pushBannerCommand(0, null);
            if (ConfigManager.platform == PLATFORM_TYPE.WX || ConfigManager.platform == PLATFORM_TYPE.QQ) {
                for (let index = 0; index < PlatformUtil.banner.length; index++) {
                    const element = PlatformUtil.banner[index];
                    element && element.hide();
                }
            } else {
                if (PlatformUtil.banner[PlatformUtil.bannerIdx]) {
                    PlatformUtil.banner[PlatformUtil.bannerIdx].hide();
                }
            }
            PlatformUtil.isHideBanner = true;
        }
        static loopBannerCommand() {
            if (ConfigManager.platform != PLATFORM_TYPE.QQ)
                return;
            if (PlatformUtil.exeBannerCommandTime <= 0) {
                this.exeBannerCommand();
            }
            PlatformUtil.exeBannerCommandTime -= 70;
        }
        static exeBannerCommand() {
            if (PlatformUtil.exeBannerCommandList.length == 0)
                return;
            let firstCMD = PlatformUtil.exeBannerCommandList[PlatformUtil.exeBannerCommandList.length - 1];
            if (firstCMD.cmd == 0) {
                if (ConfigManager.platform == PLATFORM_TYPE.WX || ConfigManager.platform == PLATFORM_TYPE.QQ) {
                    for (let index = 0; index < PlatformUtil.banner.length; index++) {
                        const element = PlatformUtil.banner[index];
                        element && element.hide();
                    }
                    PlatformUtil.exeBannerCommandList = [];
                } else {
                    if (PlatformUtil.banner[PlatformUtil.bannerIdx] && PlatformUtil.banner[PlatformUtil.bannerIdx].isLoadSuccess) {
                        console.log('loopBannerCommand hide');
                        PlatformUtil.banner[PlatformUtil.bannerIdx].hide();
                        PlatformUtil.exeBannerCommandList = [];
                    }
                }
            } else {
                if (ConfigManager.platform == PLATFORM_TYPE.WX || ConfigManager.platform == PLATFORM_TYPE.QQ) {
                    let lastIndex = PlatformUtil.bannerIdx;
                    PlatformUtil.bannerIdx = PlatformUtil.banner.length - 1;
                    if (PlatformUtil.banner[PlatformUtil.bannerIdx] && PlatformUtil.banner[PlatformUtil.bannerIdx].isLoadSuccess) {
                        if (PlatformUtil.bannerPrePos.x != 0 && PlatformUtil.bannerPrePos.y != 0) {
                            PlatformUtil.banner[PlatformUtil.bannerIdx].style.left = PlatformUtil.bannerPrePos.x;
                            PlatformUtil.banner[PlatformUtil.bannerIdx].style.top = PlatformUtil.bannerPrePos.y;
                            let promise = PlatformUtil.banner[PlatformUtil.bannerIdx].show();
                            console.log('loopBannerCommand cb');
                            if (ConfigManager.platform == PLATFORM_TYPE.WX && promise.then) {
                                promise.then(() => {
                                    firstCMD.cb && firstCMD.cb();
                                });
                            }
                            PlatformUtil.exeBannerCommandList = [];
                        }
                    } else {
                        PlatformUtil.bannerIdx = lastIndex;
                        if (PlatformUtil.bannerPrePos.x != 0 && PlatformUtil.bannerPrePos.y != 0) {
                            if (PlatformUtil.banner[PlatformUtil.bannerIdx] && PlatformUtil.banner[PlatformUtil.bannerIdx].isLoadSuccess) {
                                PlatformUtil.banner[PlatformUtil.bannerIdx].style.left = PlatformUtil.bannerPrePos.x;
                                PlatformUtil.banner[PlatformUtil.bannerIdx].style.top = PlatformUtil.bannerPrePos.y;
                                let promise = PlatformUtil.banner[PlatformUtil.bannerIdx].show();
                                console.log('loopBannerCommand cb');
                                if (ConfigManager.platform == PLATFORM_TYPE.WX && promise.then) {
                                    promise.then(() => {
                                        firstCMD.cb && firstCMD.cb();
                                    });
                                }
                                PlatformUtil.exeBannerCommandList = [];
                            }
                        }
                    }
                } else if (PlatformUtil.banner[PlatformUtil.bannerIdx] && PlatformUtil.banner[PlatformUtil.bannerIdx].isLoadSuccess) {
                    console.log('loopBannerCommand show');
                    if (PlatformUtil.isIOS()) {
                        PlatformUtil.banner[PlatformUtil.bannerIdx].show();
                        firstCMD.cb && firstCMD.cb();
                    } else {
                        {
                            let promise = PlatformUtil.banner[PlatformUtil.bannerIdx].show();
                            if (promise.then) {
                                promise.then(() => {
                                    console.log('loopBannerCommand cb');
                                    firstCMD.cb && firstCMD.cb();
                                });
                            }
                        }
                    }
                    PlatformUtil.exeBannerCommandList = [];
                }
            }
            PlatformUtil.exeBannerCommandTime = EXE_BANNER_COMMAND_TS;
        }
        static pushBannerCommand(cmd, cb, x = null, y = null) {
            PlatformUtil.exeBannerCommandList.push({
                cmd: cmd,
                cb: cb,
                x: x,
                y: y
            });
            PlatformUtil.loopBannerCommand();
            PlatformUtil.exeBannerCommandTime = EXE_BANNER_COMMAND_TS;
        }
        static destroyBannerAd() {
            if (ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.WEB_4399)
                return;
            if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS) {
                let PlatformClass = window['PlatformClass'];
                if (PlatformClass)
                    PlatformClass.createClass('JSBridge').call('destroyBannerAd');
                return;
            } else if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD) {
                let PlatformClass = window['PlatformClass'];
                if (PlatformClass)
                    PlatformClass.createClass('demo.JSBridge').call('destroyBannerAd');
                return;
            }
            if (PlatformUtil.banner[PlatformUtil.bannerIdx]) {
                PlatformUtil.banner[PlatformUtil.bannerIdx].destroy();
                PlatformUtil.banner[PlatformUtil.bannerIdx] = null;
            }
        }
        static preloadRewardVideoAd(adUnitId) {
            if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS) {
                let PlatformClass = window['PlatformClass'];
                PlatformClass && PlatformClass.createClass('JSBridge').call("preloadRewardVideAd:", adUnitId);
            } else {
                if (ConfigManager.platform == PLATFORM_TYPE.WX) {
                    this._preloadRewardedVideoAdWX(adUnitId);
                }
            }
        }
        static createRewardedVideoAd(adUnitId, successCallBack, failCallBack, closeCallBack, showCallBack = null) {
            PlatformUtil.videoSuccessCallBack = successCallBack;
            PlatformUtil.videoFailCallBack = failCallBack;
            PlatformUtil.videoCloseCallBack = closeCallBack;
            PlatformUtil.videoShowCallBack = showCallBack;
            if (ConfigManager.platform == PLATFORM_TYPE.WEB){
                //test
                PlatformUtil._createRewardedVideoAdWeb();
                return;
            }
            if (ConfigManager.platform == PLATFORM_TYPE.WX) {
                PlatformUtil._createRewardedVideoAdWX(adUnitId);
            } else if (ConfigManager.platform == PLATFORM_TYPE.QQ) {
                PlatformUtil._createRewardedVideoAdQQ(adUnitId, successCallBack, failCallBack, closeCallBack);
            } else if (ConfigManager.platform == PLATFORM_TYPE.TT) {
                PlatformUtil._createRewardVideoAdTT(adUnitId, successCallBack, failCallBack, closeCallBack);
            } else if (ConfigManager.platform == PLATFORM_TYPE.VIVO) {
                PlatformUtil._createRewardVideoAdVIVO(adUnitId, successCallBack, failCallBack, closeCallBack);
            } else if (ConfigManager.platform == PLATFORM_TYPE.OPPO) {
                PlatformUtil._createRewardVideoAdOPPO(adUnitId, successCallBack, failCallBack, closeCallBack);
            } else if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS) {
                PlatformUtil._createRewardedVideoAdIOS(adUnitId);
            } else if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD) {
                PlatformUtil._createRewardedVideoAdAndroid(adUnitId);
            } else if (ConfigManager.platform == PLATFORM_TYPE.WEB_4399) {
                PlatformUtil._createRewardedVideoAdWeb();
            }
        }
        static _createRewardedVideoAdWeb() {
            let closeCB = function(obj) {
                //test
                //PlatformUtil.exeVideoSuccess();
                window.GameMainActivity.onRewarded = function (isReward) {
                    console.log("window.GameMainActivity.onRewarded:" + isReward)
                    if (isReward) {
                        PlatformUtil.exeVideoSuccess();
                    } else {
                    }
                    SoundManager.resumeBGM();
                };
                window.GameMainActivity.showRewardVideo();
                // console.log("代码:" + obj.code + ",消息:" + obj.message);
                // if (obj.code === 10000) {
                //     console.log("开始播放");
                //     PlatformUtil.exeVideoShow();
                // } else if (obj.code === 10001) {
                //     console.log("播放结束");
                //     PlatformUtil.exeVideoSuccess();
                // } else {
                //     PlatformUtil.exeVideoClose();
                // }
                //SoundManager.resumeBGM();
            };
            let errorCB = function() {
                console.log('激励视频 广告加载失败');
                PlatformUtil.hideLoading();
                PlatformUtil.exeVideoFail();
            };
            //test
            closeCB();
            // if (('h5api' in Laya.Browser.window)) {
            //     //test
            //     closeCB
            //     // function callback(data) {
            //     //     console.log("是否可播放广告： ", data.canPlayAd, '\n', "剩余次数： ", data.remain);
            //     //     console.log('');
            //     // }
            //     // let result = Laya.Browser.window.h5api.canPlayAd(callback);
            //     // if (result) {
            //     //     Laya.Browser.window.h5api.playAd(closeCB);
            //     //     console.log('有广告资源可播放');
            //     // } else {
            //     //     Laya.Browser.window.h5api.playAd();
            //     //     console.log('没有广告资源可播放');
            //     //     errorCB();
            //     // }
            // } else {
            //     PlatformUtil.exeVideoSuccess();
            //     console.log('找不到 4399HTML5 API');
            //     console.log('');
            // }
        }
        static _createRewardedVideoAdWX(adUnitId) {
            if (!adUnitId) {
                return;
            }
            console.log('adUnitId', adUnitId);
            let system = PlatformUtil.getSystemInfo();
            if (!PlatformUtil.versionfunegt(system.SDKVersion, '2.0.4')) {
                return;
            }
            let closeCB = function(res) {
                if (res.isEnded) {
                    PlatformUtil.exeVideoSuccess();
                } else {
                    PlatformUtil.exeVideoClose();
                }
                if (PlatformUtil.ad) {
                    PlatformUtil.ad.offClose(closeCB);
                    PlatformUtil.ad.offError(errorCB);
                }
                PlatformUtil.ad = null;
                setTimeout(function() {
                    PlatformUtil.preloadRewardVideoAd(adUnitId);
                }, 500);
                SoundManager.resumeBGM();
            };
            let errorCB = function(err) {
                console.log('激励视频 广告加载失败', err);
                PlatformUtil.hideLoading();
                PlatformUtil.exeVideoFail();
                if (PlatformUtil.ad) {
                    PlatformUtil.ad.offError(errorCB);
                    PlatformUtil.ad.offClose(closeCB);
                    PlatformUtil.ad = null;
                    setTimeout(function() {
                        PlatformUtil.preloadRewardVideoAd(adUnitId);
                    }, 500);
                }
            };
            if (this.ad) {
                PlatformUtil.ad.onClose(closeCB);
                PlatformUtil.ad.onError(errorCB);
                this.ad.show().then(() => {
                    console.log('激励视频 广告显示成功');
                    PlatformUtil.exeVideoShow();
                }).catch(err => {
                    console.log('激励视频 广告显示失败', err);
                    PlatformUtil.hideLoading();
                    PlatformUtil.exeVideoFail();
                    if (PlatformUtil.ad) {
                        PlatformUtil.ad.offError(errorCB);
                        PlatformUtil.ad.offClose(closeCB);
                    }
                    PlatformUtil.ad = null;
                    setTimeout(function() {
                        PlatformUtil.preloadRewardVideoAd(adUnitId);
                    }, 500);
                });
            } else {
                errorCB('预加载失败');
                this.preloadRewardVideoAd(adUnitId);
            }
        }
        static _preloadRewardedVideoAdWX(adUnitId) {
            if (!adUnitId) {
                return;
            }
            console.log('adUnitId', adUnitId);
            let system = PlatformUtil.getSystemInfo();
            if (!PlatformUtil.versionfunegt(system.SDKVersion, '2.0.4')) {
                return;
            }
            let ad = wx.createRewardedVideoAd({
                adUnitId: adUnitId
            });
            let errorCB = function(err) {
                console.log('激励视频 广告加载失败', err);
                ad.offError(errorCB);
                this.ad = null;
            };
            ad.onError(errorCB);
            ad.load().then(() => {
                console.log('load 激励视频 广告加载成功');
                this.ad = ad;
            }).catch((err) => {
                console.log('load 激励视频 广告加载失败', err);
                this.ad = null;
            });
        }
        static _createRewardedVideoAdQQ(adUnitId, successCallBack, failCallBack, closeCallBack) {
            console.log('adUnitId', adUnitId);
            PlatformUtil.showLoading();
            let ad = wx.createRewardedVideoAd({
                adUnitId: adUnitId
            });
            let closeCB = function(res) {
                if (res.isEnded) {
                    if (successCallBack) {
                        setTimeout(function() {
                            successCallBack(true);
                        }, 500);
                    }
                } else {
                    if (closeCallBack) {
                        closeCallBack();
                    }
                }
                ad.offClose(closeCB);
                ad.offError(errorCB);
                SoundManager.resumeBGM();
            };
            ad.onClose(closeCB);
            let errorCB = function(res) {
                PlatformUtil.hideLoading();
                if (failCallBack)
                    failCallBack();
                ad.offError(errorCB);
                ad.offClose(closeCB);
            };
            ad.onError(errorCB);
            ad.load().then(() => {
                PlatformUtil.hideLoading();
                ad.show();
            });
        }
        static _createRewardVideoAdVIVO(adUnitId, successCallBack, failCallBack, closeCallBack) {
            let systemInfo = PlatformUtil.getSystemInfo();
            if (systemInfo.platformVersionCode < 1041) {
                return;
            }
            let platform = qg;
            platform.showLoading({
                message: "加载中...",
            });
            PlatformUtil.exeVideoSuccess = successCallBack;
            PlatformUtil.exeVideoClose = closeCallBack;
            if (PlatformUtil.videoAd) {
                var adload = PlatformUtil.videoAd.load();
                adload && adload.then(() => {
                    wx.hideLoading();
                    console.log("激励视频广告加载成功");
                }).catch(err => {
                    wx.hideLoading();
                    console.log("激励广告load失败" + JSON.stringify(err));
                    PlatformUtil.videoAd.offError();
                    PlatformUtil.videoAd.offClose();
                    if (failCallBack)
                        failCallBack();
                });
            } else {
                if (qg.createRewardedVideoAd) {
                    let rewardedVideoAd = qg.createRewardedVideoAd({
                        posId: adUnitId
                    });
                    PlatformUtil.videoAd = rewardedVideoAd;
                }
                let isError = false;
                let errorCB = function(res) {
                    isError = true;
                    console.log("激励广告create 失败" + JSON.stringify(res));
                    if (failCallBack)
                        failCallBack();
                    PlatformUtil.videoAd.offError();
                    PlatformUtil.videoAd.offClose();
                    wx.hideLoading();
                };
                PlatformUtil.videoAd.onLoad(() => {
                    wx.hideLoading();
                    console.log("激励视频广告加载成功");
                    let adshow = PlatformUtil.videoAd.show();
                    SoundManager.stopBGM();
                    adshow && adshow.then(() => {}).catch(err => {
                        wx.hideLoading();
                        console.log("激励广告展示失败" + JSON.stringify(err));
                    });
                });
                PlatformUtil.videoAd.onError(errorCB);
            }
            PlatformUtil.videoAd.onClose(PlatformUtil.ovVideoClose);
        }
        static _createRewardVideoAdOPPO(adUnitId, successCallBack, failCallBack, closeCallBack) {
            let systemInfo = PlatformUtil.getSystemInfo();
            if (systemInfo.platformVersionCode < 1041) {
                return;
            }
            let platform = qg;
            platform.showLoading({
                message: "加载中...",
            });
            PlatformUtil.exeVideoSuccess = successCallBack;
            PlatformUtil.exeVideoClose = closeCallBack;
            if (PlatformUtil.videoAd) {} else {
                if (qg.createRewardedVideoAd) {
                    let rewardedVideoAd = qg.createRewardedVideoAd({
                        posId: adUnitId
                    });
                    PlatformUtil.videoAd = rewardedVideoAd;
                    console.log('PlatformUtil.videoAd1', PlatformUtil.videoAd);
                }
            }
            console.log('PlatformUtil.videoAd2', PlatformUtil.videoAd);
            PlatformUtil.videoAd.onClose(PlatformUtil.ovVideoClose);
            let errorCB = function(res) {
                console.log("激励广告create 失败" + JSON.stringify(res));
                if (failCallBack)
                    failCallBack();
                PlatformUtil.videoAd.offError();
                PlatformUtil.videoAd.offClose();
                wx.hideLoading();
            };
            PlatformUtil.videoAd.onLoad(() => {
                wx.hideLoading();
                console.log("激励视频广告加载成功");
                let adshow = PlatformUtil.videoAd.show();
                SoundManager.stopBGM();
                adshow && adshow.then(() => {}).catch(err => {
                    wx.hideLoading();
                    console.log("激励广告展示失败" + JSON.stringify(err));
                });
            });
            var adload = PlatformUtil.videoAd.load();
            adload && adload.then(() => {
                wx.hideLoading();
                console.log("激励视频广告加载成功");
            }).catch(err => {
                wx.hideLoading();
                console.log("激励广告load失败" + JSON.stringify(err));
                PlatformUtil.videoAd.offError();
                PlatformUtil.videoAd.offClose();
                if (failCallBack)
                    failCallBack();
            });
            PlatformUtil.videoAd.onError(errorCB);
        }
        static _createRewardVideoAdTT(adUnitId, successCallBack, failCallBack, closeCallBack) {
            let ad = wx.createRewardedVideoAd({
                adUnitId: adUnitId
            });
            ad.load().then(() => {
                ad.show();
                console.log('preloadVideoAd 预加载视频成功');
            }).catch(error => {
                console.log('preloadVideoAd 预加载视频失败', error);
            });
            PlatformUtil.videoAd = ad;
            let closeCB = function(res) {
                if (res.isEnded) {
                    if (successCallBack) {
                        setTimeout(function() {
                            successCallBack(true);
                        }, 500);
                    }
                } else {
                    if (closeCallBack) {
                        closeCallBack();
                    }
                }
                ad.offClose(closeCB);
                ad.offError(errorCB);
                SoundManager.resumeBGM();
            };
            ad.onClose(closeCB);
            let errorCB = function(res) {
                console.log('广告显示失败', res);
                wx.hideLoading();
                if (failCallBack)
                    failCallBack();
                ad.offError(errorCB);
                ad.offClose(closeCB);
            };
            ad.onError(errorCB);
        }
        static _createRewardedVideoAdIOS(adUnitId) {
            Laya.MouseManager.enabled = false;
            let PlatformClass = window['PlatformClass'];
            if (PlatformClass)
                PlatformClass.createClass('JSBridge').call("createRewardedVideoAd:", adUnitId);
        }
        static _createRewardedVideoAdAndroid(adUnitId) {
            let PlatformClass = window['PlatformClass'];
            if (PlatformClass)
                PlatformClass.createClass('demo.JSBridge').call("createRewardedVideoAd");
        }
        static ovVideoClose(res) {
            if (res && res.isEnded) {
                console.log("正常播放结束，可以下发游戏奖励");
                PlatformUtil.exeVideoSuccess();
            } else {
                console.log("播放中途退出，不下发游戏奖励");
                if (PlatformUtil.exeVideoFail)
                    PlatformUtil.exeVideoFail();
            }
            PlatformUtil.videoAd.offClose();
        }
        static createInterstitialAd(adUnitId, success = null, isShow = true) {
            if (ConfigManager.platform == PLATFORM_TYPE.WX) {
                PlatformUtil._createInterstitialAdWX(adUnitId, success, isShow);
            } else if (ConfigManager.platform == PLATFORM_TYPE.QQ) {
                PlatformUtil._createInterstitialAdQQ(adUnitId);
            } else if (ConfigManager.platform == PLATFORM_TYPE.VIVO) {
                PlatformUtil._createInterstitialVV(adUnitId);
            } else if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS) {
                let PlatformClass = window['PlatformClass'];
                if (PlatformClass)
                    PlatformClass.createClass('JSBridge').call("createBUInterstitalAd:", adUnitId);
            } else if (ConfigManager.platform == PLATFORM_TYPE.TT) {} else if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD) {
                let PlatformClass = window['PlatformClass'];
                if (PlatformClass)
                    PlatformClass.createClass('demo.JSBridge').call("createInterstitialAd", RoleManager.getInstance().isInterstitialTouch());
            }
        }
        static preloadInterstitialAd(adUnitId, success = null) {
            if (ConfigManager.platform == PLATFORM_TYPE.WX) {
                PlatformUtil._createInterstitialAdWX(adUnitId, success, false);
            }
        }
        static _createInterstitialAdWX(adUnitId, success, isShow) {
            let system = PlatformUtil.getSystemInfo();
            if (!this.versionfunegt(system.SDKVersion, '2.6.0')) {
                return;
            }
            let ad = wx.createInterstitialAd({
                adUnitId: adUnitId
            });
            let errFunc = function(err) {
                console.log('Interstitial 广告加载失败', err);
                ad.offLoad(loadFunc);
                ad.offError(errFunc);
            };
            ad.onError(errFunc);
            let loadFunc = function(res) {
                ad.offLoad(loadFunc);
                ad.offError(errFunc);
                console.log('Interstitial 广告加载成功');
                PlatformUtil.interstitialAd = ad;
                if (isShow) {
                    ad.show().then(() => {
                        console.log('Interstitial 广告显示');
                        if (success)
                            success();
                    }).catch(err => {
                        console.log('Interstitial 广告显示失败', err);
                    });
                }
            };
            ad.onLoad(loadFunc);
        }
        static showInterstitialAd(adUnitId, success) {
            if (PLATFORM_TYPE.WX == ConfigManager.platform) {
                if (PlatformUtil.interstitialAd) {
                    PlatformUtil.interstitialAd.show().then(() => {
                        console.log('Interstitial 广告显示');
                        if (success)
                            success();
                    }).catch(err => {
                        console.log('Interstitial 广告显示失败', err);
                    });
                } else {
                    this.createInterstitialAd(adUnitId, success);
                }
            }
        }
        static _createInterstitialAdQQ(adUnitId) {
            let system = PlatformUtil.getSystemInfo();
            if (!this.versionfunegt(system.SDKVersion, '1.8.6')) {
                return;
            }
            if (!qq.createInterstitialAd)
                return;
            let ad = qq.createInterstitialAd({
                adUnitId: adUnitId
            });
            ad.load().catch((err) => {
                console.error('load', err);
            });
            ad.onLoad(() => {
                console.log('onLoad event emit');
                ad.show();
            });
            ad.onClose(() => {
                console.log('close event emit');
            });
            ad.onError((e) => {
                console.log('error', e);
            });
        }
        static _createInterstitialVV(adUnitId, cb = null) {
            let systemInfo = PlatformUtil.getSystemInfo();
            if (systemInfo.platformVersionCode < 1031) {
                return;
            }
            let platform = qg;
            let interstitialAd = platform.createInterstitialAd({
                posId: adUnitId,
                style: {}
            });
            let adShow = interstitialAd.show();
            PlatformUtil.hideBannerAd();
            adShow && adShow.then(() => {
                console.log("插屏广告展示成功");
                let closeCB = function() {
                    if (cb)
                        cb();
                    interstitialAd.offClose(closeCB);
                };
                interstitialAd.onClose(closeCB);
            }).catch((err) => {
                console.log("插屏广告展示失败");
                switch (err.code) {
                    case 30003:
                        console.log("新用户7天内不能曝光Banner，请将手机时间调整为7天后，退出游戏重新进入");
                        break;
                    case 30009:
                        console.log("10秒内调用广告次数超过1次，10秒后再调用");
                        break;
                    case 30002:
                        console.log("load广告失败，重新加载广告");
                        break;
                    default:
                        console.log(JSON.stringify(err));
                        break;
                }
            });
        }
        static createAppBox(id) {
            if (ConfigManager.platform != PLATFORM_TYPE.QQ)
                return;
            let appbox = qq.createAppBox({
                adUnitId: id
            });
            appbox.load().then(() => {
                appbox.show();
                let onClose = function() {
                    appbox.offClose(onClose);
                    appbox.destroy();
                };
                appbox.onClose(onClose);
            });
        }
        static createGirdAd(id, width = 300, top = 0) {
            if (ConfigManager.platform != PLATFORM_TYPE.WX)
                return;
            let system = PlatformUtil.getSystemInfo();
            if (!this.versionfunegt(system.SDKVersion, '2.9.2')) {
                return;
            }
            let platform = wx;
            PlatformUtil.isHideGird = false;
            let ad = platform.createGridAd({
                adUnitId: id,
                adTheme: 'white',
                gridCount: 5,
                style: {
                    left: (system.windowWidth - width) * 0.5,
                    top: top,
                    width: width,
                }
            });
            let resizeFunc = function(res) {
                console.log('resize', res);
            };
            ad.onResize(resizeFunc);
            let errFunc = function(err) {
                console.log('gird ad 广告加载失败', err);
                ad.offLoad(loadFunc);
                ad.offError(errFunc);
                ad.offResize(resizeFunc);
            };
            ad.onError(errFunc);
            let loadFunc = function(res) {
                ad.offLoad(loadFunc);
                ad.offError(errFunc);
                ad.offResize(resizeFunc);
                console.log('gird ad 广告加载成功');
                if (PlatformUtil.isHideGird) {
                    ad.hide();
                } else {
                    ad.show().then(() => {
                        console.log('gird ad 广告显示');
                    }).catch(err => {
                        console.log('gird ad 广告显示失败', err);
                    });
                }
            };
            ad.onLoad(loadFunc);
            PlatformUtil.girdAd = ad;
        }
        static hideGirdAd() {
            if (ConfigManager.platform != PLATFORM_TYPE.WX)
                return;
            if (PlatformUtil.girdAd) {
                PlatformUtil.girdAd.hide();
            }
            PlatformUtil.isHideGird = true;
        }
        static preLoadNativeAd(id, success = null, fail = null) {
            console.log('preLoadNativeAd', id);
            let nativeAd = qg.createNativeAd({
                posId: id,
            });
            let onLoad = function(res) {
                console.log('原生广告加载完成', res);
                if (res && res.adList) {
                    let adData = res.adList.pop();
                    adData.nativeId = id;
                    PlatformUtil.nativeData = adData;
                    PlatformUtil.nativeAd = nativeAd;
                    if (success)
                        success();
                }
                nativeAd.offLoad(onLoad);
            };
            nativeAd.onLoad(onLoad);
            let adLoad = nativeAd.load();
            adLoad && adLoad.then(() => {}).catch(err => {
                console.log('原生广告加载失败', JSON.stringify(err));
                nativeAd.offLoad(onLoad);
                if (fail)
                    fail();
            });
        }
        static showNativeAd(success, fail = null) {
            if (ConfigManager.platform != PLATFORM_TYPE.VIVO && ConfigManager.platform != PLATFORM_TYPE.OPPO)
                return;
            if (PlatformUtil.nativeAd && PlatformUtil.nativeData) {
                PlatformUtil.nativeAd.reportAdShow({
                    adId: PlatformUtil.nativeData.adId.toString()
                });
                success(PlatformUtil.nativeAd, PlatformUtil.nativeData);
            } else {
                if (fail)
                    fail();
            }
        }
        static versionfunegt(ver1, ver2) {
            if (ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.WEB_4399)
                return;
            let unit1 = ver1.split(".");
            let unit2 = ver2.split(".");
            for (let k in unit1) {
                let v1 = parseInt(unit1[k]);
                let v2 = parseInt(unit2[k]);
                if (v1 > v2) {
                    return true;
                } else if (v1 < v2) {
                    return false;
                }
            }
            return true;
        }
        static getSystemInfo() {
            if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD) {
                return PlatformUtil.systemInfo;
            }
            if (ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS || ConfigManager.platform == PLATFORM_TYPE.WEB_4399)
                return;
            if (!PlatformUtil.systemInfo) {
                const res = wx.getSystemInfoSync();
                PlatformUtil.systemInfo = res;
            }
            return PlatformUtil.systemInfo;
        }
        static onShow(func) {
            if (ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.WEB_4399 || ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD || ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS)
                return;
            wx.onShow(func);
        }
        static onHide(func) {
            if (ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.WEB_4399 || ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD || ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS)
                return;
            wx.onHide(func);
        }
        static getLaunchOptionsSync() {
            if (ConfigManager.platform == PLATFORM_TYPE.QQ || ConfigManager.platform == PLATFORM_TYPE.WX)
                return wx.getLaunchOptionsSync();
            else
                return;
        }
        static showModal(title, content, isShowCancel = true, confirm = null, cancel = null, confirmText = null, confirmColor = null, cancelText = null, cancelColor = null) {
            if (ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.WEB_4399 || ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD || ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS)
                return;
            if (ConfigManager.platform == PLATFORM_TYPE.VIVO) {
                let platform = qg;
                platform.showDialog({
                    title: title,
                    message: content,
                    buttons: [{
                        text: confirmText ? confirmText : '确定',
                        color: '#33dd44'
                    }],
                    success: function(data) {
                        console.log('handling callback');
                        if (confirm)
                            confirm();
                    },
                    cancel: function() {
                        console.log('handling cancel');
                        if (cancel)
                            cancel();
                    },
                });
            } else {
                wx.showModal({
                    title: title,
                    content: content,
                    showCancel: isShowCancel,
                    success: function(res) {
                        if (res.confirm) {
                            if (confirm)
                                confirm();
                        } else if (res.cancel) {
                            if (cancel)
                                cancel();
                        }
                    },
                    confirmText: confirmText ? confirmText : '确定',
                    confirmColor: confirmColor ? confirmColor : "#3CC51F",
                    cancelText: cancelText ? cancelText : '取消',
                    cancelColor: cancelColor ? cancelColor : "#000000",
                });
            }
        }
        static setPreferredFramesPerSecond(fps) {
            if (ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.WEB_4399)
                return;
            wx.setPreferredFramesPerSecond(fps);
        }
        static vibrateShort(type = 'light') {
            if (ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.WEB_4399)
                return;
            if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS || ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD) {
                let PlatformClass = window['PlatformClass'];
                if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS) {
                    if (PlatformClass)
                        PlatformClass.createClass('JSBridge').call("vibrateShort");
                } else {
                    if (PlatformClass)
                        PlatformClass.createClass('demo.JSBridge').call("vibrateShort");
                }
            } else {
                wx.vibrateShort({
                    type: type,
                    success: null,
                    fail: null,
                    complete: null
                });
            }
        }
        static vibrateLong() {
            if (ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.WEB_4399)
                return;
            if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS) {
                let PlatformClass = window['PlatformClass'];
                if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS) {
                    if (PlatformClass)
                        PlatformClass.createClass('JSBridge').call("vibrateLong");
                } else {
                    if (PlatformClass)
                        PlatformClass.createClass('demo.JSBridge').call("vibrateLong");
                }
            } else {
                wx.vibrateLong({
                    success: null,
                    fail: null,
                    complete: null
                });
            }
        }
        static navigateToMiniProgram(appId, path = '', opt = null, success = null, fail = null) {
            if (ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.WEB_4399)
                return false;
            if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS) {
                let PlatformClass = window['PlatformClass'];
                if (PlatformClass)
                    PlatformClass.createClass('JSBridge').call("navigateToAppStore:", appId);
            } else if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD) {} else {
                wx.navigateToMiniProgram({
                    appId: appId,
                    path: path,
                    success: () => {
                        if (success)
                            success();
                    },
                    fail: () => {
                        if (fail)
                            fail();
                    }
                });
            }
        }
        static reportAnalyise(eventId, eventLabel = null, params = {}) {
            if (ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.WEB_4399 || ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD || ConfigManager.platform == PLATFORM_TYPE.OPPO || ConfigManager.platform == PLATFORM_TYPE.VIVO)
                return false;
            if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS) {
                let PlatformClass = window['PlatformClass'];
                if (PlatformClass)
                    PlatformClass.createClass('JSBridge').call("reportAnalyise:", eventId);
            } else {
                var sdk = GameGlobal.tdAppSdk;
                if (sdk) {
                    let data = {
                        id: eventId,
                        label: eventLabel ? eventId : eventLabel,
                        params: params
                    };
                    sdk.event(data);
                }
            }
        }
        static reportAldAnalyise(eventId, param = {}) {
            if (ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.WEB_4399 || ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD || ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS)
                return;
            wx.aldSendEvent(eventId, param);
        }
        static onShareAppMessage(title, url) {
            if (ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.WEB_4399 || ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD || ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS)
                return;
            let platform = wx;
            if (ConfigManager.platform == PLATFORM_TYPE.WX || ConfigManager.platform == PLATFORM_TYPE.QQ) {
                platform.onShareAppMessage(() => {
                    if (url.length > 0) {
                        return {
                            title: title,
                            imageUrl: url
                        };
                    } else {
                        return {
                            title: title,
                        };
                    }
                });
            }
        }
        static shareAppMessage(title, url, query = '') {
            if (ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.WEB_4399 || ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD || ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS)
                return;
            if (ConfigManager.platform == PLATFORM_TYPE.QQ || ConfigManager.platform == PLATFORM_TYPE.WX) {
                let platform = wx;
                platform.shareAppMessage({
                    title: title,
                    imageUrl: url,
                    query: query,
                });
            }
        }
        static showShareMenu() {
            if (ConfigManager.platform == PLATFORM_TYPE.WEB ||
                ConfigManager.platform == PLATFORM_TYPE.WEB_4399 ||
                ConfigManager.platform == PLATFORM_TYPE.OPPO ||
                ConfigManager.platform == PLATFORM_TYPE.VIVO ||
                ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD ||
                ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS)
                return;
            wx.showShareMenu();
        }
        static onAudioInterruptionEnd(callBack) {
            if (ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.WEB_4399 || ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD || ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS)
                return;
            wx.onAudioInterruptionEnd(callBack);
        }
        static checkUpdate() {
            if (ConfigManager.platform == PLATFORM_TYPE.WEB ||
                ConfigManager.platform == PLATFORM_TYPE.WEB_4399 ||
                ConfigManager.platform == PLATFORM_TYPE.OPPO ||
                ConfigManager.platform == PLATFORM_TYPE.VIVO ||
                ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD ||
                ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS)
                return;
            const updateManager = wx.getUpdateManager();
            updateManager.onCheckForUpdate(function(res) {
                console.log(res.hasUpdate);
            });
            updateManager.onUpdateReady(function() {
                wx.showModal({
                    title: '更新提示',
                    content: '新版本已经准备好，请更新。',
                    showCancel: false,
                    success: function(res) {
                        if (res.confirm) {
                            updateManager.applyUpdate();
                        }
                    }
                });
            });
            updateManager.onUpdateFailed(function() {
                wx.showToast({
                    title: "更新失败"
                });
            });
        }
        static postOpenData(msg) {
            if (ConfigManager.platform != PLATFORM_TYPE.WX && ConfigManager.platform != PLATFORM_TYPE.QQ)
                return;
            let openDataContext = wx.getOpenDataContext();
            openDataContext.postMessage(msg);
        }
        static setClipboardData(txt) {
            if (ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.WEB_4399)
                return false;
            wx.setClipboardData({
                data: txt,
                success(res) {
                    wx.hideToast();
                    console.log('copy success ' + txt);
                }
            });
        }
        static isFullScreen() {
            if (Laya.stage.height > Laya.stage.width && Laya.stage.height / Laya.stage.width > 2) {
                return true;
            } else if (Laya.stage.width > Laya.stage.height && Laya.stage.width / Laya.stage.height > 2) {
                return true;
            }
            return false;
        }
        static login(success, fail = null) {
            if (ConfigManager.platform == PLATFORM_TYPE.WX || ConfigManager.platform == PLATFORM_TYPE.QQ || ConfigManager.platform == PLATFORM_TYPE.TT) {
                wx.login({
                    success: function(res) {
                        res.code;
                        success(res.code);
                    },
                    fail: function(error) {
                        if (fail)
                            fail(error);
                    }
                });
            } else if (ConfigManager.platform == PLATFORM_TYPE.VIVO) {
                let system = PlatformUtil.getSystemInfo();
                if (system.platformVersionCode >= 1053) {
                    let platform = qg;
                    platform.login().then((res) => {
                        if (res.data.token) {
                            success(res.data.token);
                        }
                    }, (err) => {
                        console.log('登录失败' + JSON.stringify(err));
                    });
                }
            } else if (ConfigManager.platform == PLATFORM_TYPE.OPPO) {
                let system = PlatformUtil.getSystemInfo();
                if (system.platformVersionCode >= 1040) {
                    let platform = qg;
                    platform.login({
                        success: function(res) {
                            if (res.data.token) {
                                success(res.data.token);
                            }
                        },
                        fail: function(err) {
                            console.log('登录失败' + JSON.stringify(err));
                        }
                    });
                }
            }
        }
        static showLoading(title = '加载中...') {
            if (ConfigManager.platform == PLATFORM_TYPE.WX || ConfigManager.platform == PLATFORM_TYPE.QQ || ConfigManager.platform == PLATFORM_TYPE.TT || ConfigManager.platform == PLATFORM_TYPE.OPPO) {
                wx.showLoading({
                    title: title,
                    mask: true,
                    success: null,
                    fail: null,
                    complete: null
                });
            } else if (ConfigManager.platform == PLATFORM_TYPE.VIVO) {
                let platform = qg;
                platform.showLoading({
                    message: "加载中...",
                });
            }
        }
        static hideLoading() {
            if (ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.WEB_4399 || ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD || ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS)
                return;
            wx.hideLoading();
        }
        static reportMonitorOPPO(data) {
            if (ConfigManager.platform == PLATFORM_TYPE.OPPO) {
                let systemInfo = PlatformUtil.getSystemInfo();
                if (systemInfo.platformVersionCode < 1060) {
                    return;
                }
                let platform = qg;
                platform.reportMonitor(data.name, data.value);
            }
        }
        static isIOS() {
            if (ConfigManager.platform == PLATFORM_TYPE.OPPO || ConfigManager.platform == PLATFORM_TYPE.VIVO || ConfigManager.platform == PLATFORM_TYPE.WEB_4399 || ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD || ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS)
                return false;
            let system = PlatformUtil.getSystemInfo();
            if (system && system.platform == 'ios') {
                return true;
            }
            return false;
        }
        static startRecordGame(fail) {
            if (ConfigManager.platform != PLATFORM_TYPE.TT)
                return;
            let recorder = tt.getGameRecorderManager();
            recorder.start({
                duration: 299
            });
            console.log('startRecordGame', recorder);
            recorder.onError(fail);
        }
        static endRecordGame(success, fail = null) {
            if (ConfigManager.platform != PLATFORM_TYPE.TT)
                return;
            let recorder = tt.getGameRecorderManager();
            recorder.stop();
            recorder.onStop(function(res) {
                let mgr = wx.getFileSystemManager();
                mgr.access({
                    path: res.videoPath,
                    success: function() {
                        success(res.videoPath);
                    },
                    fail: function() {
                        console.log('shareVideo is not exist');
                        fail && fail();
                    }
                });
            });
        }
        static pasueRecordGame() {
            if (ConfigManager.platform != PLATFORM_TYPE.TT)
                return;
            let recorder = tt.getGameRecorderManager();
            recorder.pause();
        }
        static resumeRecordGame() {
            if (ConfigManager.platform != PLATFORM_TYPE.TT)
                return;
            let recorder = tt.getGameRecorderManager();
            recorder.resume();
        }
        static shareRecord(title, desc, path, success, fail) {
            if (ConfigManager.platform != PLATFORM_TYPE.TT)
                return;
            let platform = tt;
            platform.shareAppMessage({
                channel: "video",
                title: title,
                desc: desc,
                imageUrl: "",
                templateId: "",
                query: "",
                extra: {
                    videoPath: path,
                },
                success: function() {
                    console.log("分享视频成功");
                    success();
                },
                fail(e) {
                    console.log("分享视频失败", e);
                    fail();
                }
            });
        }
        static loadSubpackage(name, success, progress, fail = null) {
            console.log('加载分包:', name);
            if (ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.WEB_4399 || ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS || ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD) {
                progress(1);
                success();
                return;
            } else if (ConfigManager.platform == PLATFORM_TYPE.VIVO) {
                let platform = qg;
                const sysInfo = qg.getSystemInfoSync();
                if (sysInfo.platformVersionCode < 1052) {
                    progress(1);
                    success();
                    return;
                }
            }
            if (!wx.loadSubpackage) {
                progress(1);
                success();
                return;
            }
            let platform = null;
            if (ConfigManager.platform == PLATFORM_TYPE.VIVO || ConfigManager.platform == PLATFORM_TYPE.OPPO) {
                platform = qg;
            } else if (ConfigManager.platform == PLATFORM_TYPE.WX || ConfigManager.platform == PLATFORM_TYPE.QQ) {
                platform = wx;
            } else if (ConfigManager.platform == PLATFORM_TYPE.TT) {
                platform = tt;
            }
            let loadTask = platform.loadSubpackage({
                name: name,
                success: function() {
                    console.log(name + 'subpackage load success');
                    success();
                },
                fail: function(error) {
                    console.log(error);
                    if (fail)
                        fail();
                    PlatformUtil.loadSubpackage(name, success, progress, fail);
                }
            });
            loadTask.onProgressUpdate(function(res) {
                let percent = res.totalBytesWritten / res.totalBytesExpectedToWrite;
                console.log('load sub package percent', percent);
                if (percent == NaN)
                    return;
            });
            let isInto = false;
            if (!isInto) {
                console.log('没有进入加载进度的方法');
                progress(1);
            }
        }
        static getSetting(success) {
            if (ConfigManager.platform != PLATFORM_TYPE.QQ)
                return;
            let platform = qq;
            platform.getSetting({
                success: success
            });
        }
        static accessFile(path, success, fail) {
            if (ConfigManager.platform == PLATFORM_TYPE.WX || ConfigManager.platform == PLATFORM_TYPE.QQ || ConfigManager.platform == PLATFORM_TYPE.OPPO) {
                let mgr = wx.getFileSystemManager();
                mgr.access({
                    path: path,
                    success: function() {
                        if (success)
                            success();
                    },
                    fail: function(err) {
                        if (fail)
                            fail(err);
                    }
                });
            } else if (ConfigManager.platform == PLATFORM_TYPE.VIVO) {
                let platform = qg;
                let result = platform.accessFile({
                    uri: path
                });
                if (result == 'true') {
                    if (success)
                        success();
                } else if (result == 'false') {
                    if (fail)
                        fail();
                } else {
                    console.log('accessFile fail error code:', result);
                    if (fail)
                        fail(result);
                }
            }
        }
        static mkdir(path, success, fail) {
            if (ConfigManager.platform == PLATFORM_TYPE.WX || ConfigManager.platform == PLATFORM_TYPE.QQ || ConfigManager.platform == PLATFORM_TYPE.OPPO) {
                let mgr = wx.getFileSystemManager();
                mgr.mkdir({
                    dirPath: path,
                    recursive: true,
                    success: function() {
                        console.log(`mkdir success: ${path}`);
                        if (success)
                            success();
                    },
                    fail: function(err) {
                        console.log(`mkdir fail, error: ${err}`);
                        if (fail)
                            fail(err);
                    }
                });
            } else if (ConfigManager.platform == PLATFORM_TYPE.VIVO) {
                PlatformUtil.accessFile(path, success, function() {
                    let platform = qg;
                    platform.mkdir({
                        uri: path,
                        success: function(uri) {
                            console.log(`mkdir success: ${uri}`);
                            if (success)
                                success();
                        },
                        fail: function(data, code) {
                            console.log(`mkdir fail, code = ${code}`);
                            if (fail)
                                fail(code);
                        }
                    });
                });
            }
        }
        static rmdir(path, success, fail) {
            if (ConfigManager.platform == PLATFORM_TYPE.WX || ConfigManager.platform == PLATFORM_TYPE.QQ || ConfigManager.platform == PLATFORM_TYPE.OPPO) {
                let mgr = wx.getFileSystemManager();
                mgr.rmdir({
                    dirPath: path,
                    recursive: true,
                    success: function() {
                        console.log(`rmdir success: ${path}`);
                        if (success)
                            success();
                    },
                    fail: function(err) {
                        console.log(`rmdir fail ${path}, error: ${err}`);
                        if (fail)
                            fail(err);
                    }
                });
            } else if (ConfigManager.platform == PLATFORM_TYPE.VIVO) {
                let platform = qg;
                platform.rmdir({
                    uri: path,
                    success: function(uri) {
                        console.log(`rmdir success: ${uri}`);
                        if (success)
                            success();
                    },
                    fail: function(data, code) {
                        console.log(`rmdir fail ${path}, code: ${code}`);
                        if (fail)
                            fail(code);
                    }
                });
            }
        }
        static readdir(path, success, fail) {
            if (ConfigManager.platform == PLATFORM_TYPE.WX || ConfigManager.platform == PLATFORM_TYPE.QQ || ConfigManager.platform == PLATFORM_TYPE.OPPO) {
                let mgr = wx.getFileSystemManager();
                mgr.readdir({
                    dirPath: path,
                    recursive: true,
                    success: function(res) {
                        console.log(`readdir success: ${path}`, res);
                        if (success)
                            success(res.files);
                    },
                    fail: function(err) {
                        console.log(`readdir fail, error: ${err}`);
                        if (fail)
                            fail(err);
                    }
                });
            } else if (ConfigManager.platform == PLATFORM_TYPE.VIVO) {
                let platform = qg;
                platform.listDir({
                    uri: path,
                    success: function(res) {
                        console.log(`readdir success: ${path}`, res);
                        let list = [];
                        for (let k in res.fileList) {
                            list.push(res.fileList[k].uri);
                        }
                        if (success)
                            success(list);
                    },
                    fail: function(data, code) {
                        console.log(`readdir fail, code: ${code}`);
                        if (fail)
                            fail(code);
                    }
                });
            }
        }
        static unzip(zipPath, targetPath, success, fail) {
            if (ConfigManager.platform == PLATFORM_TYPE.WX || ConfigManager.platform == PLATFORM_TYPE.QQ || ConfigManager.platform == PLATFORM_TYPE.OPPO) {
                let mgr = wx.getFileSystemManager();
                mgr.unzip({
                    zipFilePath: zipPath,
                    targetPath: targetPath,
                    success: function() {
                        console.log(`unzip ${zipPath} success`);
                        if (success)
                            success();
                    },
                    fail: function(res) {
                        console.log(`unzip ${zipPath} fail`, res);
                        if (fail)
                            fail(res);
                    },
                });
            } else if (ConfigManager.platform == PLATFORM_TYPE.VIVO) {
                let platform = qg;
                platform.unzipFile({
                    srcUri: zipPath,
                    dstUri: targetPath,
                    success: function(uri) {
                        console.log(`unzip ${zipPath} success`);
                        if (success)
                            success();
                    },
                    fail: function(data, code) {
                        console.log(`unzip ${zipPath} fail code:`, code);
                        if (fail)
                            fail(code);
                    }
                });
            }
        }
        static fileStat(path, success, fail) {
            if (ConfigManager.platform == PLATFORM_TYPE.WX || ConfigManager.platform == PLATFORM_TYPE.QQ || ConfigManager.platform == PLATFORM_TYPE.OPPO) {
                wx.getFileSystemManager().stat({
                    path: path,
                    recursive: true,
                    success: function(res) {
                        console.log(`fileStat ${path} success`);
                        if (success)
                            success(res);
                    },
                    fail: function(res) {
                        console.log(`fileStat ${path} fail`, res);
                        if (fail)
                            fail(res);
                    }
                });
            }
        }
        static hasShortcutInstalled(cb) {
            if (ConfigManager.platform == PLATFORM_TYPE.OPPO || ConfigManager.platform == PLATFORM_TYPE.VIVO) {
                let platform = qg;
                platform.hasShortcutInstalled({
                    success: function(status) {
                        cb(status);
                    },
                    fail: function(err) {
                        console.log('hasShortcutInstalled error:', err);
                        cb(false);
                    }
                });
            }
        }
        static installShortcut(cb) {
            if (ConfigManager.platform == PLATFORM_TYPE.OPPO || ConfigManager.platform == PLATFORM_TYPE.VIVO) {
                let platform = qg;
                platform.installShortcut({
                    success: function() {
                        cb(true);
                    },
                    fail: function(err) {
                        console.log('installShortcut error:', err);
                        cb(false);
                    }
                });
            }
        }
        static setLoadingProgress(progress) {
            if (ConfigManager.platform == PLATFORM_TYPE.OPPO) {
                let platform = qg;
                platform.setLoadingProgress({
                    progress: progress
                });
            }
        }
        static loadingComplete(cb) {
            if (ConfigManager.platform == PLATFORM_TYPE.OPPO) {
                let platform = qg;
                platform.loadingComplete({
                    complete: function() {
                        cb();
                    }
                });
            }
        }
        static exeVideoSuccess() {
            Laya.MouseManager.enabled = true;
            if (PlatformUtil.videoSuccessCallBack)
                PlatformUtil.videoSuccessCallBack();
        }
        static exeVideoFail() {
            Laya.MouseManager.enabled = true;
            if (PlatformUtil.videoFailCallBack)
                PlatformUtil.videoFailCallBack();
            if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS) {
                alert('no ad!');
            }
        }
        static exeVideoClose() {
            Laya.MouseManager.enabled = true;
            if (PlatformUtil.videoCloseCallBack)
                PlatformUtil.videoCloseCallBack();
        }
        static exeFullscreenVideoClose() {
            console.log('exeFullscreenVideoClose');
            if (PlatformUtil.fullscreenVideoCloseCallBack) {
                SoundManager.resumeBGM();
                PlatformUtil.fullscreenVideoCloseCallBack();
            }
        }
        static exeFullscreenVideoShow() {
            if (PlatformUtil.fullscreenVideoShowCallBack) {
                SoundManager.stopBGM();
                PlatformUtil.fullscreenVideoShowCallBack();
            }
        }
        static createFullscreenVideo(adUnitId, close, show) {
            if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS) {
                PlatformUtil.fullscreenVideoCloseCallBack = close;
                PlatformUtil.fullscreenVideoShowCallBack = show;
                let PlatformClass = window['PlatformClass'];
                PlatformClass && PlatformClass.createClass('JSBridge').call("createFullscreenVideoAd:", adUnitId);
            } else if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD) {
                PlatformUtil.fullscreenVideoCloseCallBack = close;
                PlatformUtil.fullscreenVideoShowCallBack = show;
                let PlatformClass = window['PlatformClass'];
                PlatformClass && PlatformClass.createClass('demo.JSBridge').call("createFullscreenVideoAd");
            }
        }
        static navigateToTeam() {
            if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS) {
                let PlatformClass = window['PlatformClass'];
                if (PlatformClass)
                    PlatformClass.createClass('JSBridge').call("navigateToAppStoreTeam:", 'id' + ConfigManager.iosCfg.teamId);
            }
        }
        static addDesktop(success = null, fail = null) {
            if (ConfigManager.platform == PLATFORM_TYPE.OPPO || ConfigManager.platform == PLATFORM_TYPE.VIVO) {
                let platform = qg;
                platform.installShortcut({
                    success: function() {
                        success && success();
                    },
                    fail: function(err) {
                        console.log('installShortcut error:', err);
                        fail && fail();
                    }
                });
            } else if (ConfigManager.platform == PLATFORM_TYPE.QQ) {
                let platform = qq;
                platform.saveAppToDesktop({
                    success: function() {
                        console.log('成功创建桌面图标');
                        if (success)
                            success();
                    },
                    fail: function(err) {
                        console.log('创建桌面图标失败', err);
                        if (fail)
                            fail();
                    }
                });
            }
        }
        static createGameBannerAd(adId) {
            if (ConfigManager.platform == PLATFORM_TYPE.OPPO && PlatformUtil.getSystemInfo().platformVersionCode >= 1076) {
                let platform = qq;
                this.oppoGameBannerAd = platform.createGameBannerAd({
                    adUnitId: adId
                });
            }
        }
        static showGameBannerAd() {
            if (this.oppoGameBannerAd) {
                this.oppoGameBannerAd.show().then(function() {
                    console.log('show success');
                }).catch(function(error) {
                    console.log('show fail with:' + error.errCode + ',' + error.errMsg);
                });
            }
        }
        static destroyGameBannerAd() {
            if (this.oppoGameBannerAd) {
                this.oppoGameBannerAd.destroy();
            }
        }
        static createGamePortalAd(adId) {
            if (ConfigManager.platform == PLATFORM_TYPE.OPPO && PlatformUtil.getSystemInfo().platformVersionCode >= 1076) {
                let platform = qg;
                console.log('createGamePortalAd', adId);
                PlatformUtil.oppoGamePortalAd = platform.createGamePortalAd({
                    adUnitId: adId
                });
                PlatformUtil.oppoGamePortalAd.load().then(function() {
                    console.log('createGamePortalAd load success');
                    PlatformUtil.oppoGamePortalAd.show().then(function() {
                        console.log('createGamePortalAd show success');
                    }).catch(function(error) {
                        console.log('createGamePortalAd show fail with:' + error.errCode + ',' + error.errMsg);
                    });
                }).catch(function(error) {
                    console.log('createGamePortalAd load fail with:' + error.errCode + ',' + error.errMsg);
                });
            }
        }
        static destroyGamePortalAd() {
            console.log('destroyGamePortalAd');
            if (this.oppoGamePortalAd) {
                this.oppoGamePortalAd.destroy();
            }
        }
        static preLoadNativeAdExtend(id, success = null, fail = null) {
            console.log('preLoadNativeAdExtend', id);
            let nativeAd = qg.createNativeAd({
                posId: id,
            });
            let onLoad = function(res) {
                console.log('原生广告加载完成', res);
                if (res && res.adList) {
                    let adData = res.adList.pop();
                    console.log(JSON.stringify(adData));
                    adData.nativeId = id;
                    console.log(adData.imgUrlList[0]);
                    if (adData.imgUrlList[0]) {
                        let str = adData.imgUrlList[0].split('?')[0];
                        adData.imgUrlList[0] = str;
                        console.log(str);
                    } else {
                        adData.imgUrlList = [adData.icon];
                    }
                    PlatformUtil.nativeData = adData;
                    PlatformUtil.nativeAd = nativeAd;
                    if (success)
                        success(adData, nativeAd);
                }
                nativeAd.offLoad(onLoad);
            };
            nativeAd.onLoad(onLoad);
            let adLoad = nativeAd.load();
            adLoad && adLoad.then(() => {}).catch(err => {
                console.log('原生广告加载失败', JSON.stringify(err));
                nativeAd.offLoad(onLoad);
                if (PlatformUtil.nativeAd) {
                    if (success)
                        success(PlatformUtil.nativeData, PlatformUtil.nativeAd);
                } else {
                    if (fail)
                        fail();
                }
            });
        }
        static exeVideoShow() {
            console.log('onAdShow');
            if (PlatformUtil.videoShowCallBack)
                PlatformUtil.videoShowCallBack();
            PlatformUtil.videoShowCallBack = null;
        }
        static createCustomAd(adUnitId, x, y, style, cb = null, fail = null, isHide = false) {
            if (ConfigManager.platform == PLATFORM_TYPE.WX) {
                this._createCustomAdWX(adUnitId, x, y, style, cb, fail, isHide);
            }
            if (ConfigManager.platform == PLATFORM_TYPE.QQ) {
                this._createCustomAdQQ(adUnitId, x, y, style, cb, fail, isHide);
            } {
                if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD && ConfigManager.appId == ANDROID_APP_ID.XM) {
                    if (ConfigManager.isReviewVersion())
                        return;
                    console.log('创建NativeIcon');
                    let PlatformClass = window['PlatformClass'];
                    let system = PlatformUtil.getSystemInfo();
                    let windowWidth = system.windowWidth;
                    let windowHeight = system.windowHeight;
                    let data = {
                        x: x / Laya.stage.width * windowWidth,
                        y: y / Laya.stage.height * windowHeight
                    };
                    let str = JSON.stringify(data);
                    if (PlatformClass)
                        PlatformClass.createClass('demo.JSBridge').call('createIconNativeAd', str);
                    let key = adUnitId + '_' + style + '_' + x + '_' + y;
                    this.customAdList[key] = true;
                }
            }
        }
        static _createCustomAdWX(adUnitId, x, y, style, cb = null, fail = null, isHide = false) {
            let system = PlatformUtil.getSystemInfo();
            if (!PlatformUtil.versionfunegt(system.SDKVersion, '2.11.1')) {
                return;
            }
            let key = adUnitId + '_' + style + '_' + x + '_' + y;
            if (isHide) {
                PlatformUtil.isHideCustom[key] = true;
            }
            console.log('createCustomAdWX', adUnitId);
            let _left = 0;
            let ad;
            let windowHeight = system.windowHeight;
            let windowWidth = system.windowWidth;
            _left = x / Laya.stage.width * windowWidth;
            if (style == WX_CUSTOM_AD_STYLE.VERTICAL) {
                ad = wx.createCustomAd({
                    adUnitId: adUnitId,
                    left: _left,
                    top: y / Laya.stage.height * windowHeight,
                    adIntervals: 30,
                    width: 72
                });
            } else if (style == WX_CUSTOM_AD_STYLE.MATRIX) {
                ad = wx.createCustomAd({
                    adUnitId: adUnitId,
                    left: _left,
                    top: (y - 60) / Laya.stage.height * windowHeight,
                    adIntervals: 30,
                    width: 280
                });
            } else
                ad = wx.createCustomAd({
                    adUnitId: adUnitId,
                    left: _left,
                    top: y / Laya.stage.height * windowHeight,
                    adIntervals: 30
                });
            let errFunc = function(err) {
                console.log('custom 广告加载失败', err);
                ad.offLoad(loadFunc);
                ad.offError(errFunc);
                console.log(PlatformUtil.customAdList[key]);
                if (PlatformUtil.exeCustomCommandList[key] && PlatformUtil.exeCustomCommandList[key].length > 0) {
                    if (!PlatformUtil.isHideCustom[key]) {
                        if (PlatformUtil.customAdList[key]) {
                            PlatformUtil.exeCustomCommand();
                        } else {
                            fail && fail();
                        }
                    } else {
                        if (PlatformUtil.customAdList[key]) {
                            PlatformUtil.exeCustomCommand();
                        }
                    }
                } else {
                    if (!PlatformUtil.isHideCustom[key]) {
                        if (PlatformUtil.customAdList[key]) {
                            if (!PlatformUtil.customAdList[key].isShow())
                                PlatformUtil.customAdList[key].show().then(() => {
                                    console.log('custom 广告显示');
                                    cb && cb();
                                }).catch(err => {
                                    console.log('custom 广告显示失败', err);
                                    PlatformUtil.customAdList[key].destroy();
                                    PlatformUtil.customAdList[key] = null;
                                    fail && fail();
                                });
                            else {
                                cb && cb();
                            }
                        } else {
                            fail && fail();
                        }
                    } else {
                        if (PlatformUtil.customAdList[key]) {
                            if (PlatformUtil.customAdList[key].isShow())
                                PlatformUtil.customAdList[key].hide();
                        }
                    }
                }
            };
            ad.onError(errFunc);
            let loadFunc = function(res) {
                ad.isLoadSuccess = true;
                if (PlatformUtil.customAdList[key]) {
                    PlatformUtil.customAdList[key].destroy();
                    PlatformUtil.customAdList[key] = null;
                }
                ad.offLoad(loadFunc);
                ad.offError(errFunc);
                PlatformUtil.customAdList[key] = ad;
                PlatformUtil.customAdList[key].isLoading = true;
                let clossFunc = function() {
                    PlatformUtil.customAdList[key].destroy();
                    PlatformUtil.customAdList[key] = null;
                };
                PlatformUtil.customAdList[key].onClose(clossFunc);
                console.log('custom 广告加载成功');
                if (PlatformUtil.exeCustomCommandList[key] && PlatformUtil.exeCustomCommandList[key].length > 0) {
                    PlatformUtil.exeCustomCommand();
                } else {
                    if (!PlatformUtil.isHideCustom[key]) {
                        console.log('custom show');
                        ad.show().then(() => {
                            console.log('custom 广告显示');
                            cb && cb();
                        }).catch(err => {
                            console.log('custom 广告显示失败', err);
                        });
                    } else {
                        console.log('custom hide');
                        ad.hide().then(() => {
                            console.log('custom 广告hide');
                        }).catch(err => {
                            console.log('custom 广告hide失败', err);
                            console.log(ad);
                            if (ad) {
                                ad.destroy();
                                ad = null;
                            }
                        });
                    }
                }
            };
            ad.onLoad(loadFunc);
        }
        static _createCustomAdQQ(adUnitId, x, y, style, cb = null, fail = null, isHide = false) {
            let key = adUnitId + '_' + style + '_' + x + '_' + y;
            if (ConfigManager.platform != PLATFORM_TYPE.QQ)
                return;
            if (!ConfigManager.carelessCtrl())
                return;
            let system = PlatformUtil.getSystemInfo();
            if (!PlatformUtil.versionfunegt(system.SDKVersion, '1.15.0')) {
                return;
            }
            if (isHide) {
                PlatformUtil.isHideCustom[key] = true;
            }
            console.log('createCustomAdqq', adUnitId);
            let _left = 0;
            let ad;
            let windowHeight = system.windowHeight;
            let windowWidth = system.windowWidth;
            let platform = qq;
            _left = x / Laya.stage.width * windowWidth;
            if (_left <= 10) {
                _left += 30;
            }
            let _top = y / Laya.stage.height * windowHeight;
            if (_top > windowHeight - 73 - 50) {
                _top -= 34;
            }
            if (_left >= windowWidth - 65 - 50) {
                _left -= 25;
            }
            if (style == WX_CUSTOM_AD_STYLE.VERTICAL) {
                ad = platform.createBlockAd({
                    adUnitId: adUnitId,
                    style: {
                        left: _left,
                        top: _top,
                    },
                    size: 4,
                    orientation: 'vertical'
                });
            } else if (style == WX_CUSTOM_AD_STYLE.MATRIX) {
                ad = platform.createBlockAd({
                    adUnitId: adUnitId,
                    style: {
                        left: _left,
                        top: _top,
                    },
                    size: 5,
                    orientation: 'vertical'
                });
            } else {
                ad = platform.createBlockAd({
                    adUnitId: adUnitId,
                    style: {
                        left: _left,
                        top: _top,
                    },
                    size: 1,
                    orientation: 'vertical'
                });
            }
            let factor = system.windowHeight / 750;
            let resizeFunc = function(res) {
                ad.offResize(resizeFunc);
                console.log('resizeFunc', res);
                console.log(res.width);
                console.log(res.height);
                res.width = res.width / factor;
                res.height = res.height / factor;
            };
            ad.onResize(resizeFunc);
            let errFunc = function(err) {
                console.log('block craate error', err);
                ad.offLoad(loadFunc);
                ad.offError(errFunc);
                console.log(PlatformUtil.customAdList[key]);
                if (PlatformUtil.exeCustomCommandList[key] && PlatformUtil.exeCustomCommandList[key].length > 0) {
                    if (!PlatformUtil.isHideCustom[key]) {
                        if (PlatformUtil.customAdList[key]) {
                            PlatformUtil.exeCustomCommand();
                        } else {
                            fail && fail();
                        }
                    } else {
                        if (PlatformUtil.customAdList[key]) {
                            PlatformUtil.exeCustomCommand();
                        }
                    }
                } else {
                    if (!PlatformUtil.isHideCustom[key]) {
                        if (PlatformUtil.customAdList[key]) {
                            PlatformUtil.customAdList[key].show();
                        } else {
                            fail && fail();
                        }
                    } else {
                        if (PlatformUtil.customAdList[key]) {
                            PlatformUtil.customAdList[key].hide();
                        }
                    }
                }
            };
            ad.onError(errFunc);
            let loadFunc = function(res) {
                ad.isLoadSuccess = true;
                if (PlatformUtil.customAdList[key]) {
                    PlatformUtil.customAdList[key].destroy();
                    PlatformUtil.customAdList[key] = null;
                }
                ad.offLoad(loadFunc);
                ad.offError(errFunc);
                PlatformUtil.customAdList[key] = ad;
                PlatformUtil.customAdList[key].isLoading = true;
                console.log('custom 广告加载成功');
                if (PlatformUtil.exeCustomCommandList[key] && PlatformUtil.exeCustomCommandList[key].length > 0) {
                    PlatformUtil.exeCustomCommand();
                } else {
                    if (!PlatformUtil.isHideCustom[key]) {
                        console.log('custom show');
                        ad.show();
                    } else {
                        console.log('custom hide');
                        ad.hide();
                    }
                }
            };
            ad.onLoad(loadFunc);
        }
        static showCustomAd(adUnitId, x, y, style = WX_CUSTOM_AD_STYLE.SINGLE, cb = null, fail = null) {
            let key = adUnitId + '_' + style + '_' + x + '_' + y;
            PlatformUtil.isHideCustom[key] = false;
            if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD && ConfigManager.appId == ANDROID_APP_ID.XM) {
                if (ConfigManager.isReviewVersion())
                    return;
                if (PlatformUtil.customAdList[key]) {
                    let PlatformClass = window['PlatformClass'];
                    console.log('显示NativeIcon');
                    let system = PlatformUtil.getSystemInfo();
                    let windowWidth = system.windowWidth;
                    let windowHeight = system.windowHeight;
                    let data = {
                        x: x / Laya.stage.width * windowWidth,
                        y: y / Laya.stage.height * windowHeight
                    };
                    let str = JSON.stringify(data);
                    if (PlatformClass)
                        PlatformClass.createClass('demo.JSBridge').call('showIconNativeAd', str);
                    cb && cb();
                    if (this.handle[key]) {
                        Laya.timer.clear(this, this.handle[key]);
                    }
                    let func = function() {
                        console.log('刷新原生格子');
                        PlatformUtil.createCustomAd(adUnitId, x, y, style, cb, function() {
                            console.log('加载CustomCommand');
                            fail && fail();
                        });
                    };
                    this.handle[key] = func;
                    console.log('刷新原生格子时间:' + ConfigManager.getRefershNativeTime());
                    Laya.timer.loop(ConfigManager.getRefershNativeTime(), this, func);
                } else {
                    PlatformUtil.createCustomAd(adUnitId, x, y, style, cb, function() {
                        console.log('加载CustomCommand');
                        fail && fail();
                    });
                    console.log('显示NativeIcon');
                    let PlatformClass = window['PlatformClass'];
                    let system = PlatformUtil.getSystemInfo();
                    let windowWidth = system.windowWidth;
                    let windowHeight = system.windowHeight;
                    let data = {
                        x: x / Laya.stage.width * windowWidth,
                        y: y / Laya.stage.height * windowHeight
                    };
                    let str = JSON.stringify(data);
                    if (PlatformClass)
                        PlatformClass.createClass('demo.JSBridge').call('showIconNativeAd', str);
                    cb && cb();
                    if (this.handle[key]) {
                        Laya.timer.clear(this, this.handle[key]);
                    }
                    let func = function() {
                        console.log('刷新原生格子');
                        PlatformUtil.createCustomAd(adUnitId, x, y, style, cb, function() {
                            console.log('加载CustomCommand');
                            fail && fail();
                        });
                    };
                    this.handle[key] = func;
                    console.log('刷新原生格子时间:' + ConfigManager.getRefershNativeTime());
                    Laya.timer.loop(ConfigManager.getRefershNativeTime(), this, func);
                }
                return;
            }
            if (PlatformUtil.customAdList[key]) {
                PlatformUtil.pushCustomCommand(1, cb, function() {
                    console.log('加载CustomCommand');
                    fail && fail();
                }, adUnitId, x, y, style);
            } else {
                PlatformUtil.createCustomAd(adUnitId, x, y, style, cb, function() {
                    console.log('加载CustomCommand');
                    fail && fail();
                });
            }
        }
        static hideCustomAd(adUnitId, x, y, style = WX_CUSTOM_AD_STYLE.SINGLE) {
            let key = adUnitId + '_' + style + '_' + x + '_' + y;
            if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD && ConfigManager.appId == ANDROID_APP_ID.XM) {
                if (this.handle[key]) {
                    Laya.timer.clear(this, this.handle[key]);
                    this.handle[key] = null;
                }
                if (PlatformUtil.customAdList[key]) {
                    console.log('隐藏NativeIcon');
                    let PlatformClass = window['PlatformClass'];
                    let system = PlatformUtil.getSystemInfo();
                    let windowWidth = system.windowWidth;
                    let windowHeight = system.windowHeight;
                    let data = {
                        x: x / Laya.stage.width * windowWidth,
                        y: y / Laya.stage.height * windowHeight
                    };
                    let str = JSON.stringify(data);
                    if (PlatformClass)
                        PlatformClass.createClass('demo.JSBridge').call('hideIconNativeAd', str);
                } else {
                    PlatformUtil.createCustomAd(adUnitId, x, y, style);
                }
                return;
            }
            PlatformUtil.isHideCustom[key] = true;
            PlatformUtil.pushCustomCommand(0, function() {}, function() {}, adUnitId, x, y, style);
            if (PlatformUtil.customAdList[key]) {
                let ad = PlatformUtil.customAdList[key];
                if (ConfigManager.platform == PLATFORM_TYPE.QQ) {
                    ad.hide();
                } else {
                    if (ad.isShow())
                        ad.hide().then(() => {
                            console.log('custom 广告hide');
                        }).catch(err => {
                            console.log('custom 广告hide失败1', err);
                            console.log(ad);
                            if (ad) {
                                ad.destroy();
                                ad = null;
                            }
                        });
                }
            }
        }
        static getBannerCenterPos() {
            let d = {
                x: 0,
                y: 0
            };
            console.log(ConfigManager.platform);
            console.log(ConfigManager.appId);
            if (ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.WEB_4399)
                return d;
            if (PLATFORM_TYPE.WX != ConfigManager.platform && PLATFORM_TYPE.QQ != ConfigManager.platform && (ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD && ConfigManager.appId != ANDROID_APP_ID.XM))
                return d;
            let system = PlatformUtil.getSystemInfo();
            let windowHeight = system.windowHeight;
            let windowWidth = system.windowWidth;
            d.y = this.bannerCenterPos.y / windowHeight * Laya.stage.height;
            d.x = this.bannerCenterPos.x / windowWidth * Laya.stage.width;
            return d;
        }
        static getBannerWeight() {
            if (ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.WEB_4399)
                return 300;
            if (PLATFORM_TYPE.WX != ConfigManager.platform && PLATFORM_TYPE.QQ != ConfigManager.platform && (ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD && ConfigManager.appId != ANDROID_APP_ID.XM))
                return 300;
            let system = PlatformUtil.getSystemInfo();
            let windowWidth = system.windowWidth;
            if (ConfigManager.platform == PLATFORM_TYPE.WX)
                return 300 / windowWidth * Laya.stage.width;
            else {
                if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD) {
                    return 3 * Laya.stage.width / 10;
                } else {
                    if (ConfigManager.platform == PLATFORM_TYPE.QQ) {
                        return 310 / windowWidth * Laya.stage.width;
                    }
                    return 300;
                }
            }
        }
        static getCustomSize() {
            let d = {
                w: 0,
                h: 0
            };
            if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS || ConfigManager.platform == PLATFORM_TYPE.VIVO)
                return d;
            if (PLATFORM_TYPE.WX != ConfigManager.platform && PLATFORM_TYPE.QQ != ConfigManager.platform && (ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD && ConfigManager.appId != ANDROID_APP_ID.XM))
                return d;
            let system = PlatformUtil.getSystemInfo();
            let windowHeight = system.windowHeight;
            let windowWidth = system.windowWidth;
            let customHeight = 104 / windowHeight * Laya.stage.height * 0.8;
            let customWeight = 60 / windowWidth * Laya.stage.width * 0.8;
            if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD) {
                customHeight = 130 / windowHeight * Laya.stage.height;
                customWeight = 130 / windowWidth * Laya.stage.width;
            }
            if (ConfigManager.platform == PLATFORM_TYPE.QQ) {
                customWeight = 65 / windowWidth * Laya.stage.width;
                customHeight = 73 / windowHeight * Laya.stage.height;
            }
            return {
                w: customWeight,
                h: customHeight
            };
        }
        static getCustomVSize() {
            let d = {
                w: 0,
                h: 0
            };
            if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS || ConfigManager.platform == PLATFORM_TYPE.VIVO)
                return d;
            if (PLATFORM_TYPE.WX != ConfigManager.platform && PLATFORM_TYPE.QQ != ConfigManager.platform && (ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD && ConfigManager.appId != ANDROID_APP_ID.XM))
                return d;
            let system = PlatformUtil.getSystemInfo();
            let windowHeight = system.windowHeight;
            let windowWidth = system.windowWidth;
            let customHeight = (410 * 0.9) / windowHeight * Laya.stage.height;
            let customWeight = (72 * 0.9) / windowWidth * Laya.stage.width;
            if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD) {
                customHeight = 130 / windowHeight * Laya.stage.height;
                customWeight = 190 / windowWidth * Laya.stage.width;
            }
            if (ConfigManager.platform == PLATFORM_TYPE.QQ) {
                customWeight = 65 / windowWidth * Laya.stage.width;
                customHeight = 73 / windowHeight * Laya.stage.height;
            }
            return {
                w: customWeight,
                h: customHeight
            };
        }
        static getCustomMatrixSize() {
            let d = {
                w: 0,
                h: 0
            };
            if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS || ConfigManager.platform == PLATFORM_TYPE.VIVO)
                return d;
            if (PLATFORM_TYPE.WX != ConfigManager.platform && PLATFORM_TYPE.QQ != ConfigManager.platform && (ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD && ConfigManager.appId != ANDROID_APP_ID.XM))
                return d;
            let system = PlatformUtil.getSystemInfo();
            let windowHeight = system.windowHeight;
            let windowWidth = system.windowWidth;
            let customHeight = (352 * 300 / 360) / windowHeight * Laya.stage.height;
            let customWeight = (300) / windowWidth * Laya.stage.width;
            if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD) {
                customHeight = 130 / windowHeight * Laya.stage.height;
                customWeight = 190 / windowWidth * Laya.stage.width;
            }
            if (ConfigManager.platform == PLATFORM_TYPE.QQ) {
                customWeight = 65 / windowWidth * Laya.stage.width;
                customHeight = 73 / windowHeight * Laya.stage.height;
            }
            return {
                w: customWeight,
                h: customHeight
            };
        }
        static exeCustomCommand() {
            for (const key in this.exeCustomCommandList) {
                if (Object.prototype.hasOwnProperty.call(this.exeCustomCommandList, key)) {
                    const element = this.exeCustomCommandList[key];
                    let firstCMD = PlatformUtil.exeCustomCommandList[key][PlatformUtil.exeCustomCommandList[key].length - 1];
                    if (firstCMD) {
                        if (firstCMD.cmd == 0) {
                            if (ConfigManager.platform == PLATFORM_TYPE.QQ) {
                                if (PlatformUtil.customAdList[key]) {
                                    console.log('loopCustomCommand hide');
                                    PlatformUtil.customAdList[key].hide();
                                    PlatformUtil.exeCustomCommandList[key] = [];
                                }
                            } else {
                                if (PlatformUtil.customAdList[key] && PlatformUtil.customAdList[key].isShow()) {
                                    console.log('loopCustomCommand hide');
                                    PlatformUtil.customAdList[key].hide();
                                    PlatformUtil.exeCustomCommandList[key] = [];
                                }
                            }
                        } else {
                            console.log('PlatformUtil.customAdList[key]' + PlatformUtil.customAdList[key]);
                            if (PlatformUtil.customAdList[key] != undefined) {
                                console.log('loopCustomCommand show');
                                if (ConfigManager.platform == PLATFORM_TYPE.QQ) {
                                    let promise = PlatformUtil.customAdList[key].show();
                                    if (promise.then) {
                                        promise.then(() => {
                                            console.log('loopCustomCommand cb');
                                            firstCMD.cb && firstCMD.cb();
                                        });
                                    }
                                } else {
                                    if (!PlatformUtil.customAdList[key].isShow()) {
                                        let promise = PlatformUtil.customAdList[key].show();
                                        if (promise.then) {
                                            promise.then(() => {
                                                console.log('loopCustomCommand cb');
                                                firstCMD.cb && firstCMD.cb();
                                            });
                                        }
                                    }
                                }
                                PlatformUtil.exeCustomCommandList[key] = [];
                            } else {
                                console.log('loopCustomCommand fail');
                                firstCMD.fail && firstCMD.fail();
                            }
                        }
                    }
                    PlatformUtil.exeCustomCommandTime[key] = EXE_COMMAND_COMMAND_TS;
                }
            }
        }
        static pushCustomCommand(cmd, cb, fail, adUnitId, x, y, style = WX_CUSTOM_AD_STYLE.SINGLE) {
            let key = adUnitId + '_' + style + '_' + x + '_' + y;
            if (PlatformUtil.exeCustomCommandList[key])
                PlatformUtil.exeCustomCommandList[key].push({
                    cmd: cmd,
                    cb: cb,
                    fail: fail,
                    x: x,
                    y: y
                });
            else {
                PlatformUtil.exeCustomCommandList[key] = [];
                PlatformUtil.exeCustomCommandList[key].push({
                    cmd: cmd,
                    cb: cb,
                    fail: fail,
                    x: x,
                    y: y
                });
            }
            PlatformUtil.exeCustomCommandTime[key] = EXE_COMMAND_COMMAND_TS;
        }
        static execXMNativeClick() {
            this.xmNativeClickCallBack && this.xmNativeClickCallBack();
        }
        static registerXMNativeClick(cb) {
            this.xmNativeClickCallBack = cb;
        }
        static showNativeImg(x, y) {
            if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD && ConfigManager.appId == ANDROID_APP_ID.XM) {
                if (ConfigManager.isReviewVersion())
                    return;
                let PlatformClass = window['PlatformClass'];
                console.log('显示NativeImg');
                let system = PlatformUtil.getSystemInfo();
                let windowWidth = system.windowWidth;
                let windowHeight = system.windowHeight;
                let data = {
                    x: x / Laya.stage.width * windowWidth,
                    y: y / Laya.stage.height * windowHeight
                };
                let str = JSON.stringify(data);
                if (PlatformClass)
                    PlatformClass.createClass('demo.JSBridge').call('showImgNativeAd', str);
            }
        }
        static hideNativeImg() {
            if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD && ConfigManager.appId == ANDROID_APP_ID.XM) {
                if (ConfigManager.isReviewVersion())
                    return;
                let PlatformClass = window['PlatformClass'];
                console.log('隐藏NativeImg');
                if (PlatformClass)
                    PlatformClass.createClass('demo.JSBridge').call('hideImgNativeAd');
            }
        }
        static getImgSize() {
            if (PLATFORM_TYPE.WX != ConfigManager.platform && (ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD && ConfigManager.appId != ANDROID_APP_ID.XM))
                return {
                    w: 0,
                    h: 0
                };
            let system = PlatformUtil.getSystemInfo();
            let windowHeight = system.windowHeight;
            let windowWidth = system.windowWidth;
            let customHeight = (750) / windowHeight * Laya.stage.height;
            let customWeight = (500) / windowWidth * Laya.stage.width;
            return {
                w: customWeight,
                h: customHeight
            };
        }
        static loadImgFail() {
            NotifyManager.notify(NOTIFY_ID.ANDROID_IMG_AD_LOAD, false);
        }
        static loadImgSuccess() {
            NotifyManager.notify(NOTIFY_ID.ANDROID_IMG_AD_LOAD, true);
        }
        static loadRewardFail() {
            NotifyManager.notify(NOTIFY_ID.ANDROID_REWARD_AD_LOAD, false);
        }
        static loadRewardSuccess() {
            NotifyManager.notify(NOTIFY_ID.ANDROID_REWARD_AD_LOAD, true);
        }
        static screenShot(cb = null, type = 'fail') {
            let tempTexture2D = new Laya.Texture2D(749, 382);
            let tempTexture = new Laya.Texture(tempTexture2D);
            let cans = document.getElementById("layaCanvas");
            tempTexture2D.loadImageSource(cans, true);
            let sp = new Laya.Sprite();
            sp.graphics.drawImage(tempTexture, 0, 0, Laya.stage.width, Laya.stage.height);
            let box = new Laya.Box();
            box.anchorX = 0.5;
            box.anchorY = 0.5;
            box.width = Laya.stage.width;
            box.height = Laya.stage.height;
            box.x = Laya.stage.width / 2;
            box.y = Laya.stage.height / 2;
            box.addChild(sp);
            Laya.stage.addChild(box);
            if (type == 'win') {
                let img = new Laya.Image('');
                Laya.stage.addChild(img);
                img.alpha = 0;
                img.width = Laya.stage.width;
                img.height = Laya.stage.height;
                Laya.Tween.to(img, {
                    alpha: 1
                }, 150, null, Laya.Handler.create(this, () => {
                    Laya.Tween.to(img, {
                        alpha: 0
                    }, 150, null, Laya.Handler.create(this, () => {
                        Laya.Tween.clearAll(img);
                        img.removeSelf();
                        Laya.Tween.to(box, {
                            scaleX: 0.5,
                            scaleY: 0.5
                        }, 500, null, Laya.Handler.create(this, () => {
                            if (cb) {
                                cb(box, tempTexture);
                            }
                            Laya.Tween.clearAll(box);
                        }));
                    }));
                }));
            } else if (type == 'fail') {
                console.log('失败设置');
                if (cb) {
                    cb(box, tempTexture);
                }
            }
        }
        static setAndroidChannelId(value) {
            console.log('setAndroidChannelId' + value);
            PlatformUtil.androidChannelId = value;
        }
        static setAndroidOffline(value) {
            console.log('Laya端执行离线时间-----------------------------' + value);
            RoleManager.getInstance().setOfflineTime();
        }
        static getPackageName(cb) {
            if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD) {
                PlatformUtil.isHideBanner = false;
                let PlatformClass = window['PlatformClass'];
                if (PlatformClass)
                    PlatformClass.createClass('demo.JSBridge').callWithBack(function(pkgName) {
                        cb(pkgName);
                    }, "getPackageName");
            }
        }
        static execBannerSuccess() {
            PlatformUtil.bannerSuccessCallBack && PlatformUtil.bannerSuccessCallBack();
            PlatformUtil.bannerSuccessCallBack = null;
        }
        static execBannerFail() {
            PlatformUtil.bannerFailCallBack && PlatformUtil.bannerFailCallBack();
            PlatformUtil.bannerFailCallBack = null;
        }
        static execBannerClose() {
            this.bannerCloseUnixTime = Laya.timer.currTimer;
        }
        static execNativeBannerTouch() {
            PlatformUtil.nativeBannerTouchCallBack && PlatformUtil.nativeBannerTouchCallBack();
            PlatformUtil.nativeBannerTouchCallBack = null;
        }
        static registerNativeBannerTouchCallBack(cb) {
            PlatformUtil.nativeBannerTouchCallBack = cb;
        }
        static execNativeInterstitialTouchCallBack() {
            PlatformUtil.nativeInterstitialCallBack && PlatformUtil.nativeInterstitialCallBack();
            PlatformUtil.nativeInterstitialCallBack = null;
        }
        static registerNativeInterstitialTouchCallBack(cb) {
            PlatformUtil.nativeInterstitialCallBack = cb;
        }
    }
    PlatformUtil.banner = [];
    PlatformUtil.bannerList = [];
    PlatformUtil.bannerCount = 0;
    PlatformUtil.createBannerTime = 0;
    PlatformUtil.systemInfo = null;
    PlatformUtil.isHideBanner = false;
    PlatformUtil.girdAd = null;
    PlatformUtil.isHideGird = false;
    PlatformUtil.videoAd = null;
    PlatformUtil.nativeData = null;
    PlatformUtil.nativeAd = null;
    PlatformUtil.oppoGameBannerAd = null;
    PlatformUtil.oppoGamePortalAd = null;
    PlatformUtil.interstitialAd = null;
    PlatformUtil.bannerCenterPos = {
        x: 0,
        y: 0
    };
    PlatformUtil.bannerPrePos = {
        x: null,
        y: null
    };
    PlatformUtil.isBannerError = false;
    PlatformUtil.exeBannerCommandTime = 0;
    PlatformUtil.exeBannerCommandList = [];
    PlatformUtil.bannerIdx = 0;
    PlatformUtil.bannerIdList = [];
    PlatformUtil.customAdList = {};
    PlatformUtil.isHideCustom = {};
    PlatformUtil.exeCustomCommandTime = {};
    PlatformUtil.exeCustomCommandList = {};
    PlatformUtil.handle = {};
    PlatformUtil.bannerCloseUnixTime = 0;
    PlatformUtil.path = '';
    PlatformUtil.customAdCloseList = {};
    PlatformUtil.nativeBannerTouchCallBack = null;
    PlatformUtil.nativeInterstitialCallBack = null;
    window["PlatformUtil"] = PlatformUtil;

    var GAME_MJB_TYPE;
    (function(GAME_MJB_TYPE) {
        GAME_MJB_TYPE[GAME_MJB_TYPE["QZHXJY"] = 0] = "QZHXJY";
        GAME_MJB_TYPE[GAME_MJB_TYPE["YHXYQZ"] = 1] = "YHXYQZ";
        GAME_MJB_TYPE[GAME_MJB_TYPE["YHQZSN"] = 2] = "YHQZSN";
    })(GAME_MJB_TYPE || (GAME_MJB_TYPE = {}));
    class ConfigManager {
        static setData(share, config, region) {
            ConfigManager.reward = AdData;
            ConfigManager.region = region ? region : {
                city: '',
                province: ''
            };
            ConfigManager.share = share ? share : [{
                title: '分享',
                img: ''
            }];
            if (config) {
                ConfigManager.config = config;
                if (config.region)
                    ConfigManager.config.region = JSON.parse(config.region);
                if (config.dot_list)
                    ConfigManager.config.dot_list = JSON.parse(config.dot_list);
                Laya.LocalStorage.setItem(STORAGE_ID.CONFIG, JSON.stringify(config));
            }
            PlatformUtil.showShareMenu();
            if (share[SHARE_TYPE.NORMAL]) {
                let idx = Math.floor(Math.random() * share.length);
                PlatformUtil.onShareAppMessage(share[idx].title, share[idx].img);
            }
        }
        static getConfig() {
            if (ConfigManager.config) {
                return ConfigManager.config;
            } else {
                let _config = {
                    share_sec: 2,
                    scene: JSON.stringify({
                        "1": [1001, 1037, 1058, 1067, 1095, 1044, 1007, 1008, 1038, 1089],
                    }),
                    share_ctrl: (ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS || ConfigManager.platform == PLATFORM_TYPE.VIVO || ConfigManager.platform == PLATFORM_TYPE.OPPO) ? 0 : 1,
                    careless_ctrl: ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS ? 0 : 1,
                    nav_ctrl: ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS ? 0 : 1,
                    dot_limit: 8,
                    dot_list: {
                        "1": [1],
                    },
                    ver: 1,
                    review: 0,
                    region: [],
                    cut_ios: 0,
                    extra: JSON.stringify({
                        refresh_native: 30000,
                        clickNativeButtonCtrl: 0,
                        delayButton: 0,
                        autoClickNativeCount: 0,
                        autoPlayVideo: 0,
                        buttonTitle: 0,
                        scaleButton: 0,
                        closeButton: 0,
                        exit_ctrl: 0,
                        interstitial_times: 0,
                        bannerCount: 3,
                        refresh_nativeBanner_beforeOnceGame: 9000,
                        refresh_nativeIcon_beforeOnceGame: 15000,
                        refresh_nativeBanner_afterOnceGame: 8000,
                        refresh_nativeIcon_afterOnceGame: 9000,
                        oppo_end_count: 2000,
                        oppo_prior_ad: 1,
                        oppo_end_adTotal: 1,
                        interstitialTouchCount: 5,
                        refresh_custom: 12,
                        refresh_Banner_Time: 6000,
                        native_splash_time: 2,
                        cdkey: {
                            "6868": [{
                                itemId: "4047",
                                count: 1
                            }]
                        },
                    }),
                };
                return _config;
            }
        }
        static getShare(callBack) {
            let rand = Math.floor(Math.random() * 10) % ConfigManager.share.length;
            let share = ConfigManager.share[rand];
            callBack(share);
        }
        static getRewardCtrl(type) {
            if (ConfigManager.reward[type]) {
                for (let k in ConfigManager.reward) {
                    if (ConfigManager.reward[k].id == type) {
                        return ConfigManager.reward[k];
                    }
                }
            }
            return ConfigManager.reward[REWARD_CTRL_TYPE.DEFAULT];
        }
        static isReviewVersion() {
            if (ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.WEB_4399)
                return false;
            if (ConfigManager.isZsCtrl) {
                return ChannelManager.isZSReviewVersion();
            }
            if (ConfigManager.getConfig().review == 1 && ConfigManager.getConfig().ver == ConfigManager.ver) {
                console.log('版本审核中');
                return true;
            } else {
                return false;
            }
        }
        static isBlackRegion(id) {
            console.log(ConfigManager.region);
            if (ConfigManager.getConfig().region && ConfigManager.getConfig().region[id]) {
                for (let k in ConfigManager.getConfig().region[id]) {
                    let region = ConfigManager.getConfig().region[id][k];
                    if (region == ConfigManager.region.city) {
                        console.log('地区黑名单');
                        return true;
                    } else if (region == ConfigManager.region.province) {
                        console.log('地区黑名单');
                        return true;
                    }
                }
            }
            console.log('地区白名单');
            return false;
        }
        static carelessCtrl() {
            if (this.isZsCtrl) {
                if (ChannelManager.isZSReviewVersion())
                    return false;
                else {
                    console.log('误触开关:开');
                    return true;
                }
            }
            if (ConfigManager.getConfig().careless_ctrl == 1) {
                console.log('误触开关:开');
                return true;
            } else {
                console.log('误触开关:关');
                return false;
            }
        }
        static navCtrl() {
            if (ConfigManager.getConfig().nav_ctrl == 1) {
                console.log('跳转开关:开');
                return true;
            } else {
                console.log('跳转开关:关');
                return false;
            }
        }
        static getDotLimit(type, count) {
            let list = ConfigManager.getConfig().dot_list[type];
            if (count > ConfigManager.getConfig().dot_limit)
                return 0;
            if (list) {
                return list[count % list.length];
            } else {
                return 0;
            }
        }
        static getExtra() {
            let extra = ConfigManager.getConfig().extra;
            return JSON.parse(extra);
        }
        static getRefershNativeTime() {
            if (ConfigManager.platform == PLATFORM_TYPE.VIVO) {
                let nv = this.getExtra().refresh_native ? this.getExtra().refresh_native : 900000;
                return nv;
            } else if (ConfigManager.platform == PLATFORM_TYPE.OPPO) {
                return 90 * 1000;
            } else if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD) {
                console.log('this.getExtra().refresh_native ' + this.getExtra().refresh_native);
                let nv = this.getExtra().refresh_native != null ? this.getExtra().refresh_native : 30000;
                return nv;
            }
        }
        static clickNativeButtonCtrl() {
            if (ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.WEB_4399) {
                return 1;
            }
            if (ConfigManager.platform == PLATFORM_TYPE.VIVO || ConfigManager.platform == PLATFORM_TYPE.OPPO) {
                if (ConfigManager.getExtra().clickNativeButtonCtrl == 1) {
                    return 1;
                } else if (ConfigManager.getExtra().clickNativeButtonCtrl == 2) {
                    return 2;
                } else {
                    return 0;
                }
            }
        }
        static getDelayButton() {
            if (ConfigManager.platform == PLATFORM_TYPE.WEB || ConfigManager.platform == PLATFORM_TYPE.WEB_4399)
                return 2000;
            let delayButton = this.getExtra().delayButton;
            if (ConfigManager.isReviewVersion()) {
                delayButton = 1;
            }
            return delayButton;
        }
        static getAutoPlayVideo() {
            let autoPlayVideo = ConfigManager.getExtra().autoPlayVideo;
            return autoPlayVideo == 1;
        }
        static getButtonTitle() {
            let buttonTitle = ConfigManager.getExtra().buttonTitle;
            if (buttonTitle == 1) {
                return true;
            } else {
                return false;
            }
        }
        static getAutoClickNativeCount() {
            let autoClickNativeCount = ConfigManager.getExtra().autoClickNativeCount;
            return autoClickNativeCount;
        }
        static getScaleButton() {
            let scaleButton = ConfigManager.getExtra().scaleButton;
            if (scaleButton == 1)
                return true;
            return false;
        }
        static getCloseButton() {
            let closeButton = ConfigManager.getExtra().closeButton;
            return closeButton;
        }
        static exitCtrl() {
            return this.getExtra().exit_ctrl;
        }
        static getInterstitial_times() {
            return this.getExtra().interstitial_times;
        }
        static getAndroidChannelId(cb) {
            if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD) {
                console.log("androidChannelId" + PlatformUtil.androidChannelId);
                cb(PlatformUtil.androidChannelId);
            }
        }
        static getRefresh_nativeBanner_beforeOnceGame() {
            console.log('当前解析出来的数据：', this.getExtra());
            return this.getExtra().refresh_nativeBanner_beforeOnceGame;
        }
        static getRefresh_nativeIcon_beforeOnceGame() {
            return this.getExtra().refresh_nativeIcon_beforeOnceGame;
        }
        static getRefresh_nativeBanner_afterOnceGame() {
            return this.getExtra().refresh_nativeBanner_afterOnceGame;
        }
        static getRefresh_nativeIcon_afterOnceGame() {
            return this.getExtra().refresh_nativeIcon_afterOnceGame;
        }
        static getBannerCount() {
            return this.getExtra().bannerCount ? this.getExtra().bannerCount : 12;
        }
        static getCustomCount() {
            return this.getExtra().refresh_custom ? this.getExtra().refresh_custom : 12;
        }
        static getOppo_end_count() {
            return this.getExtra().oppo_end_count;
        }
        static getOppo_prior_ad() {
            return this.getExtra().oppo_prior_ad;
        }
        static getoOppo_end_adTotal() {
            return this.getExtra().oppo_end_adTotal;
        }
        static getInterstitialTouchCount() {
            if (this.getExtra().interstitialTouchCount != null) {
                return this.getExtra().interstitialTouchCount;
            } else {
                return 5;
            }
        }
        static getRefreshBannerTime() {
            if (this.getExtra().refresh_Banner_Time != null) {
                return this.getExtra().refresh_Banner_Time;
            } else {
                return 10000;
            }
        }
        static getNativeSplashTime() {
            if (this.getExtra().native_splash_time != null) {
                return this.getExtra().native_splash_time;
            }
            return 2;
        }
        static getViolenceCtrl() {
            if (ConfigManager.platform == PLATFORM_TYPE.WEB)
                return false;
            if (ConfigManager.platform == PLATFORM_TYPE.WEB_4399)
                return false;
            if (this.isReviewVersion())
                return false;
            if (ConfigManager.isZsCtrl) {
                return ChannelManager.getViolenceCtrl();
            } else {
                if (this.getExtra().violence_ctrl == 1)
                    return true;
            }
            return false;
        }
        static getJumpBackGezi() {
            if (this.getExtra().zs_jump_back_gezi) {
                return this.getExtra().zs_jump_back_gezi;
            } else {
                return 0;
            }
        }
        static getCDKeyeData() {
            return this.getExtra().cdkey;
        }
        static isHideSkinById(id) {
            if (ConfigManager.platform == PLATFORM_TYPE.TT || ConfigManager.platform == PLATFORM_TYPE.WEB) {
                if (id == 1 || id == 4 || id == 5) {
                    return true;
                }
            }
            return false;
        }
    }
    ConfigManager.platform = PLATFORM_TYPE.WEB;
    ConfigManager.gameType = GAME_MJB_TYPE.YHQZSN;
    ConfigManager.resVer = '1';
    ConfigManager.isDebug = false;
    ConfigManager.share = [];
    ConfigManager.reward = {};
    ConfigManager.isUnZip = false;
    ConfigManager.ver = 1;
    ConfigManager.zsVer = '1.0';
    ConfigManager.iosCfg = {
        buId: '',
        teamId: '',
    };
    ConfigManager.isTest = false;
    ConfigManager.isCP = false;
    ConfigManager.isShowFullscreen = true;
    ConfigManager.costGold = 1.07;
    ConfigManager.costDiamond = 1.1;
    ConfigManager.secret = '';
    ConfigManager.otherViewComBackMenu = 0;
    ConfigManager.isRefinedVersion = true;
    ConfigManager.adpaterIpad = true;
    ConfigManager.isZsCtrl = false;
    if (typeof wx !== "undefined") {
        ConfigManager.platform = PLATFORM_TYPE.WX;
        if (typeof qq !== "undefined") {
            ConfigManager.platform = PLATFORM_TYPE.QQ;
            console.log('设置为QQ平台');
        } else if (typeof tt !== "undefined") {
            ConfigManager.platform = PLATFORM_TYPE.TT;
            console.log('设置为头条平台');
        } else {
            console.log('设置为微信平台');
        }
    } else if (typeof qg !== "undefined") {
        let platform = qg;
        const res = platform.getSystemInfoSync();
        console.log('brand', res.brand);
        if (res.brand == 'OPPO') {
            ConfigManager.platform = PLATFORM_TYPE.OPPO;
            console.log('设置位OPPO平台');
        } else {
            ConfigManager.platform = PLATFORM_TYPE.VIVO;
            console.log('设置位VIVO平台');
        }
        window.wx = platform;
    } else if (typeof window["conch"] !== "undefined") {
        let os = window["conchConfig"].getOS();
        if (os == 'Conch-ios') {
            ConfigManager.platform = PLATFORM_TYPE.NATIVE_IOS;
            console.log("设置为原生ios");
        } else if (os == 'Conch-android') {
            ConfigManager.platform = PLATFORM_TYPE.NATIVE_ANDRIOD;
            console.log("设置为原生android");
        }
    }
    if (ConfigManager.platform == PLATFORM_TYPE.WX) {
        if (ConfigManager.gameType == GAME_MJB_TYPE.YHXYQZ) {
            let list = [
                'adunit-bef012095d302598',
            ];
            for (let k in AdData) {
                AdData[k].ad_id = list[parseInt(k) % list.length];
            }
            AD_BANNER[0] = 'adunit-5990f2511c0a70b2';
            AD_INTERSTITIAL[0] = 'adunit-4ea8fc1021abd716';
            AD_CUSTOM[0] = 'adunit-830bc218d44e46a6';
            AD_CUSTOM[1] = 'adunit-5abafb7bb402ea60';
            AD_CUSTOM_1[0] = 'adunit-8c4e799d7421bb2b';
            AD_CUSTOM_1[1] = 'adunit-338c82ca3e3166c8';
            AD_CUSTOM_V[0] = 'adunit-28de1ee499de1f8d';
            AD_CUSTOM_MATRIX[0] = 'adunit-4cac3b4f0929d014';
            ConfigManager.appId = 'wxb9baaf26310bd321';
            ConfigManager.ver = 6;
            ConfigManager.zsVer = '1';
            ConfigManager.zsVer = '1.0.5';
            ConfigManager.secret = '6jGO1kknbb6ByWfI';
            ConfigManager.isZsCtrl = false;
        } else if (ConfigManager.gameType == GAME_MJB_TYPE.YHQZSN) {
            let list = [
                'adunit-820f7d1f176731e5',
            ];
            for (let k in AdData) {
                AdData[k].ad_id = list[parseInt(k) % list.length];
            }
            AD_BANNER[0] = 'adunit-e9aa529a57142b3d';
            AD_INTERSTITIAL[0] = 'adunit-495125682cfadf31';
            AD_CUSTOM[0] = 'adunit-44ab43fc5859f506';
            AD_CUSTOM[1] = 'adunit-d0cffee7269257ee';
            AD_CUSTOM_1[0] = 'adunit-35836c443f420050';
            AD_CUSTOM_1[1] = 'adunit-287d744b70ec1028';
            AD_CUSTOM_V[0] = 'adunit-1307e71d2ddf1d59';
            AD_CUSTOM_MATRIX[0] = 'adunit-8ca826b138e19ce7';
            ConfigManager.appId = 'wx1a4dda4c71d36a21';
            ConfigManager.ver = 3;
            ConfigManager.isZsCtrl = false;
        }
    } else if (ConfigManager.platform == PLATFORM_TYPE.QQ) {
        let list = [
            '3e01a6954744310f11dd928181ac1b43',
        ];
        for (let k in AdData) {
            AdData[k].ad_id = list[parseInt(k) % list.length];
        }
        AD_BANNER[0] = '9870a30c8387d3719fb4f4958a6184bc';
        AD_APP_BOX[0] = 'fb96d8ec1613adb459a609341b7ea2ee';
        AD_INTERSTITIAL[0] = 'd069ff192987a579ed4add02fe726874';
        AD_CUSTOM[0] = 'de1043e821bb1833831134604340dae3';
        AD_CUSTOM_1[0] = 'd47e02ef03f62a188a633665e4075a1d';
        AD_CUSTOM_V[0] = 'c71489b669cc9b6d2892e3faca42f149';
        AD_CUSTOM_MATRIX[0] = 'c71489b669cc9b6d2892e3faca42f149';
        ConfigManager.appId = '1112169204';
        ConfigManager.ver = 1;
        ConfigManager.zsVer = '1';
    } else if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_IOS) {
        let list = [
            '',
        ];
        for (let k in AdData) {
            AdData[k].ad_id = list[parseInt(k) % list.length];
        }
        AD_FULL_SCREEN[0] = '';
        AD_BANNER[0] = '';
        ConfigManager.iosCfg.teamId = '1528473223';
        ConfigManager.appId = 'qzryjy_ios';
        ConfigManager.ver = 1;
        ConfigManager.iosCfg.buId = '';
    } else if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD) {
        let list = [
            'b60d5935f79b46',
        ];
        for (let k in AdData) {
            AdData[k].ad_id = list[parseInt(k) % list.length];
        }
        AD_FULL_SCREEN[0] = 'b60d5935f763b7';
        AD_BANNER[0] = 'b60d59360226c8';
        AD_INTERSTITIAL[0] = '999000003';
        ConfigManager.ver = 1;
        let PlatformClass = window['PlatformClass'];
        ConfigManager.appId = 'qzryjy_android_233';
        if (PlatformClass)
            PlatformClass.createClass('demo.JSBridge').callWithBack(function(value) {
                console.log('getAndroidChannelId' + value);
                value = Number(value);
                if (value == 0) {
                    ConfigManager.appId = ANDROID_APP_ID.TAP;
                    ConfigManager.ver = 2;
                } else if (value == 1) {
                    ConfigManager.appId = ANDROID_APP_ID.XM;
                    ConfigManager.ver = 6;
                } else if (value == 2) {
                    ConfigManager.appId = ANDROID_APP_ID.C_233;
                    ConfigManager.ver = 3;
                } else if (value == 3) {
                    ConfigManager.appId = ANDROID_APP_ID.HYKB;
                    ConfigManager.ver = 2;
                } else if (value == 4) {
                    ConfigManager.appId = ANDROID_APP_ID.MMY;
                    ConfigManager.ver = 2;
                } else if (value == 5) {
                    ConfigManager.appId = ANDROID_APP_ID.TEST;
                } else if (value == 6) {
                    ConfigManager.appId = ANDROID_APP_ID.C233_ME;
                    ConfigManager.ver = 2;
                }
                console.log(ConfigManager.appId);
            }, "getAndroidChannelId");
    } else if (ConfigManager.platform == PLATFORM_TYPE.VIVO) {
        let list = [
            '9f11be6c30ea429ba71d661d485bcf32',
        ];
        for (let k in AdData) {
            AdData[k].ad_id = list[parseInt(k) % list.length];
        }
        AD_NAVITE_EXTEND[0] = '117137107e3a4b6d9233e961604b13bc';
        AD_BANNER[0] = '117137107e3a4b6d9233e961604b13bc';
        AD_INTERSTITIAL[0] = 'e146761009e94af49dd9f27c5b911200';
        ConfigManager.appId = '105541485';
        ConfigManager.ver = 1;
        ConfigManager.zsVer = '1';
    } else if (ConfigManager.platform == PLATFORM_TYPE.OPPO) {
        let list = [
            '437721',
        ];
        for (let k in AdData) {
            AdData[k].ad_id = list[parseInt(k) % list.length];
        }
        AD_NAVITE_EXTEND[0] = '437727';
        AD_NAVITE_EXTEND[1] = '437724';
        ConfigManager.appId = '30714057';
        ConfigManager.ver = 1;
        ConfigManager.zsVer = '1';
    } else if (ConfigManager.platform == PLATFORM_TYPE.TT) {
        let list = [
            '4mfejnho25da41fd17',
        ];
        for (let k in AdData) {
            AdData[k].ad_id = list[parseInt(k) % list.length];
        }
        ConfigManager.appId = 'ttcb9fbd2254a13c6702';
        ConfigManager.ver = 3;
        ConfigManager.zsVer = '1';
    } else {
        //test
        //ConfigManager.platform = PLATFORM_TYPE.WEB_4399;
        if (('h5api' in Laya.Browser.window)) {
            ConfigManager.platform = PLATFORM_TYPE.WEB_4399;
        }
    }

    let wxPath = '';
    if (ConfigManager.platform == PLATFORM_TYPE.WX || ConfigManager.platform == PLATFORM_TYPE.TT || ConfigManager.platform == PLATFORM_TYPE.QQ) {
        wxPath = wx.env.USER_DATA_PATH;
    }
    const WX_USER_PACKAGE_ROOT = `${wxPath}/package`;
    const WX_USER_PACKAGE_PATH = `${WX_USER_PACKAGE_ROOT}/${ConfigManager.resVer}`;
    let RES_PATH = {
        IMG_GUN_ROOT: 'sub1/equip/arm/',
        IMG_SHARE_ICON: 'main/ui/img_game65.png',
        IMG_AD_ICON: 'main/ui/img_game60.png',
        IMG_MASK_BG: 'sub1/ui/scale9/img_13.png',
        JSON_UI_MAP: 'sub1/ui/ui.json',
        CHANNEL_BAR_BG: [
            'main/channel/img_0.png',
            'main/channel/img_1.png',
            'main/channel/img_2.png',
            'main/channel/img_3.png',
        ],
        PFB_UI_BREAK_STAR: 'prefab/BreakStar.json',
        IMG_DAN_ROOT: 'sub1/ui/dan/',
        MENU_SCENE: 'sub2/3d/LayaScene_menuScene/Conventional/menuScene.ls',
        EFFECT_PREFEB: 'sub2/3d/LayaScene_effect/Conventional/effect.lh',
        SKIN_PREFEB: 'role/3d/LayaScene_role1/Conventional/role1.lh',
        HAND_PREFEB: 'role/3d/LayaScene_role1/Conventional/role1.lh',
        SKIN_ZOMBIE: 'sub13/3d/LayaScene_zombie/Conventional/zombie.lh',
        WEAPON_PREFEB: 'sub3/3d/LayaScene_weapon/Conventional/weapon.lh',
        PARTS_PREFEB: 'sub18/3d/LayaScene_Decorate_hd/Conventional/Decorate_hd.lh',
        MAP1: 'sub8/3d/LayaScene_map1/Conventional/map1.ls',
        MAP2: 'sub9/3d/LayaScene_map2/Conventional/map2.ls',
        MAP3: 'sub10/3d/LayaScene_map3/Conventional/map3.ls',
        BEHIT_UI: 'sub1/ui/game/img_34.png',
        ATTACK_UI: {
            TOUCH: 'sub1/ui/game/img_4.png',
            TOUCHED: 'sub1/ui/game/img_5.png'
        },
        BOMB_UI: {
            TOUCH: 'sub1/ui/game/img_36.png',
            TOUCHED: 'sub1/ui/game/img_35.png'
        },
        JUMP_UI: {
            TOUCH: 'sub1/ui/game/img_8.png',
            TOUCHED: 'sub1/ui/game/img_9.png'
        },
        AUTO_ATTACK_UI: {
            AUTO_ATTACK: 'sub1/ui/game/img_18.png',
            NOT_AUTO_ATTACK: 'sub1/ui/game/img_17.png'
        },
        HP_PRO_UI: {
            HP_MORE_30: 'sub1/ui/scale9/img_7.png',
            HP_LESS_30: 'sub1/ui/scale9/img_9.png'
        },
        FLOATING_UP_GHOST_UI: 'sub1/ui/game/img_23.png',
        BULLSEYE: {
            QUASI_WHITE: 'sub1/ui/game/img_15.png',
            QUASI_RED: 'sub1/ui/game/img_24.png',
            VERTICAL_WHITE: 'sub1/ui/game/img_13.png',
            VERTICAL_RED: 'sub1/ui/game/img_25.png',
            POINT_WHITE: 'sub1/ui/game/img_14.png',
            POINT_RED: 'sub1/ui/game/img_26.png',
            VERTICAL_WHITE_1: 'sub1/ui/game/img_13_1.png',
            POINT_WHITE_1: 'sub1/ui/game/img_14_1.png',
        },
        BULLSEYE1: {
            VERTICAL_WHITE: 'sub1/ui/game/img_Rect_1.png',
            VERTICAL_RED: 'sub1/ui/game/img_Rect_2.png',
            POINT_WHITE: 'sub1/ui/game/img_Point_1.png',
            POINT_RED: 'sub1/ui/game/img_Point_2.png',
            VERTICAL_WHITE_1: 'sub1/ui/game/img_Rect_3.png',
            POINT_WHITE_1: 'sub1/ui/game/img_Point_3.png',
        },
        HEADSHOT_UI: {
            CLASS_1: 'sub1/ui/game/img_45.png',
            CLASS_2: 'sub1/ui/game/img_46.png'
        },
        HEAD_TOP_FRAME_UI: {
            FRIENDLY: 'sub1/ui/scale9/img_4.png',
            ENEMY: 'sub1/ui/scale9/img_5.png'
        },
        TOP_HRAD_STATE_UI: {
            NORMAL: 'sub1/ui/game/img_1.png',
            DIE: 'sub1/ui/game/img_2.png'
        },
        SQUATDOWN_UI: {
            TOUCH: 'sub1/ui/game/img_7.png',
            TOUCHED: 'sub1/ui/game/img_6.png'
        },
        SYNTHESIS_UI: {
            TOUCH: 'sub1/ui/equip/img_4.png',
            TOUCHED: 'sub1/ui/equip/img_3.png',
            BG: 'sub1/ui/equip/img_10.jpg',
            CELL_TOUCH: 'sub1/ui/scale9/img_24.png',
            CELL_TOUCHED: 'sub1/ui/scale9/img_23.png',
            SYNTHESIS_ATLAS: 'sub1/effect/effect1/effect1.atlas',
            SYNTHESIS_ANI: 'ani/SynthesisEffect.ani',
            UNLOCK1_ATLAS: 'sub1/effect/effect2/01/01.atlas',
            UNLOCK1_ANI: 'ani/NewUnlockArm1.ani',
            UNLOCK2_ATLAS: 'sub1/effect/effect2/02/02.atlas',
            UNLOCK2_ANI: 'ani/NewUnlockArm2.ani',
            CELL_STYLE_1: 'sub1/ui/scale9/img_eq_2.png',
            CELL_STYLE_2: 'sub1/ui/scale9/img_eq_3.png'
        },
        WAREHOUSE_UI: {
            TOUCH: 'sub1/ui/equip/img_1.png',
            TOUCHED: 'sub1/ui/equip/img_2.png',
            BG: 'sub1/ui/equip/img_11.jpg',
            GRADE_LABEL_ROOT: 'sub1/ui/warehouse/img_pingji_',
            ARM_NAME_GRADE_BG_ROOT: 'sub1/ui/scale9/img_pingjikuang_bg_',
            ARM_GRADE_FRAME: 'sub1/ui/scale9/img_pingjikuang_',
            RIGHTCELLFRAME: {
                TOUCH: 'sub1/ui/scale9/img_46.png',
                TOUCHED: 'sub1/ui/scale9/img_47.png'
            }
        },
        BUYTYPE_UI: {
            GOLD: 'sub1/ui/common/img_3.png',
            DIAMOND: 'sub1/ui/common/img_4.png'
        },
        FNT: {
            FNT1: 'sub1/fnt/fnt1/fnt1.fnt',
            FNT2: 'sub1/fnt/fnt2/fnt2.fnt',
            FNT3: 'sub1/fnt/fnt3/fnt3.fnt',
            FNT4: 'sub1/fnt/fnt4/fnt4.fnt',
            FNT5: 'sub1/fnt/fnt5/fnt5.fnt'
        },
        FNT_NUMBER: [
            'sub1/fnt/number1.fnt',
            'sub1/fnt/number2.fnt',
            'sub1/fnt/number3.fnt',
        ],
        END_UI: {
            MVP_UI: {
                FIRST: 'sub1/ui/end/img_3.png',
                SECOND: 'sub1/ui/end/img_2.png'
            },
            THIME_UI: {
                WIN: 'sub1/ui/end/img_5.png',
                FAIL: 'sub1/ui/end/img_6.png'
            },
            BG: {
                WIN: 'sub1/ui/end/img_4.png',
                FAIL: 'sub1/ui/end/img_10.png'
            },
            DOUBLE_UI: {
                THREE: 'sub1/ui/end/3.png',
                FOUR: 'sub1/ui/end/4.png',
                FIVE: 'sub1/ui/end/5.png',
                SIX: 'sub1/ui/end/6.png'
            }
        },
        ROLE_VIEW_UI: {
            GRADE_FRAME_UI_ROOT: 'sub1/ui/scale9/img_bag_'
        },
        GAMING_BOTTOM_ARM_UI: {
            TOUCH: 'sub1/ui/scale9/img_1.png',
            TOUCHED: 'sub1/ui/scale9/img_2.png'
        },
        IMG_DIAMOND_ICON: 'sub1/ui/common/img_4.png',
        IMG_GOLD_ICON: 'sub1/ui/common/img_3.png',
        ITEM_ROOT: 'sub1/item/',
        ROLE_ROOT: 'sub1/role/',
        ZOMBIEMODE_GAMING_UI: {
            ROUND_UI: {
                ONE: 'sub1/ui/game/img_shenghua_2.png',
                TWO: 'sub1/ui/game/img_shenghua_3.png',
                THREE: 'sub1/ui/game/img_shenghua_4.png'
            },
            CLEANSCUESS: 'sub1/ui/game/img_shenghua_1.png',
            CLEANFINISH: 'sub1/ui/game/img_shenghua_6.png',
            DOWNTIME_BG_UI: {
                BEFORE10S: 'sub1/ui/game/img_shenghua_8.png',
                AFTER10S: 'sub1/ui/game/img_shenghua_9.png'
            }
        },
        DISCARD_UI: {
            TOUCH: 'sub1/ui/game/img_diu_1.png',
            TOUCHED: 'sub1/ui/game/img_diu_2.png'
        },
        DOUBLE_HIT_UI: {
            CLASS_1: 'sub1/ui/game/img_52.png',
            CLASS_2: 'sub1/ui/game/img_47.png',
            CLASS_3: 'sub1/ui/game/img_48.png'
        },
        MARK_UI: {
            PRIMARY: 'sub1/ui/game/img_49.png',
            INTERMEDIATE: 'sub1/ui/game/img_50.png'
        },
        LIBRARY_UI: {
            RIGHT_BTN_UI: {
                TOUCH: 'sub1/ui/scale9/img_library_4.png',
                TOUCHED: 'sub1/ui/scale9/img_library_3.png'
            },
            LEFT_BTN_UI: {
                TOUCH: 'sub1/ui/scale9/img_library_2.png',
                TOUCHED: 'sub1/ui/scale9/img_library_1.png'
            }
        },
        ADICON: {
            TT_AD_1: 'sub1/ui/common/img_tt_1.png'
        },
        GRADE_UI: {
            GRADE_TAB_ROOT: 'sub1/ui/library/img_grade_',
            GRADE_BG_ROOT: 'sub1/ui/library/img_grade_bg_',
            GRADE_BG_BOTTOM_ROOT: 'sub1/ui/library/img_grade_bg_bottom_'
        }
    };
    let SOUND_PATH = {
        CLICK: 'sub3/sound/Click.mp3',
        BGM: 'sub3/sound/BGM.mp3',
        ATTACKSOUNDROOT: 'gameSound/sound/gun/',
        DEATH: 'gameSound/sound/death.mp3',
        HEADSHOT: 'gameSound/sound/headshot.mp3',
        DOUBLE: {
            FIRST: 'gameSound/sound/double_kill_1.mp3',
            SEDOND: 'gameSound/sound/double_kill_2.mp3',
            THIRD: 'gameSound/sound/double_kill_3.mp3',
            FOURTH: 'gameSound/sound/double_kill_4.mp3',
            FIFTH: 'gameSound/sound/double_kill_5.mp3',
            SIX: 'gameSound/sound/double_kill_6.mp3'
        },
        BOMB_KILL: 'gameSound/sound/bomb_kill.mp3',
        COMPOND: 'sub3/sound/Compound.mp3',
        GOLD1: 'sub3/sound/gold1.mp3',
        GOLD2: 'sub3/sound/gold2.mp3',
        WIN: 'gameSound/sound/win.mp3',
        FAIL: 'gameSound/sound/fail.mp3',
        NEWEQUIP: 'sub3/sound/newEquip.mp3',
        GAMESTART: 'sub3/sound/start.mp3',
        BOMB: 'gameSound/sound/bomb.mp3',
        FIRETHEHOLE: 'gameSound/sound/FileInTheHole.mp3',
        XIEXIA: 'gameSound/sound/xiexia.mp3',
        TOUCHBOX: 'sub3/sound/touchBox.mp3',
        ZOMBIESHOW: 'gameSound/sound/zomBieShow.mp3',
        ZOMBIEBEATTACK: 'gameSound/sound/zomBieBeAttack.mp3',
        BULLETHIT: 'gameSound/sound/bulletHit.mp3',
        ENDWIN: 'gameSound/sound/endWin.mp3',
        HCXQ: 'sub3/sound/hcxq.mp3',
        STARTGAME: 'sub3/sound/startGame.mp3',
        GAME_DOWN_START: {
            ROOT: 'gameSound/sound/down_',
            START: 'gameSound/sound/start.mp3'
        },
        SWITCH_ARM: {
            ROOT: 'gameSound/sound/switch'
        },
        KILL_DOUBLE_ROOT: 'gameSound/sound/double_kill_',
        KILL_HEADSHOT_ROOT: 'gameSound/sound/headShot_',
        TURN_TABLE: 'sub3/sound/turnTable.mp3',
        FIRE_IN_TEH_HOLE: 'gameSound/sound/Fireinthehole_Grenade_GR.mp3',
        KILL_HEADSHOT: 'gameSound/sound/headshot.mp3',
        FOOT: [
            'gameSound/sound/foot1.mp3',
            'gameSound/sound/foot2.mp3'
        ],
        JUMP: 'gameSound/sound/jump.mp3',
        DROP: 'gameSound/sound/drop.mp3',
        REVENGE: 'gameSound/sound/Revenge.mp3'
    };
    let SUB_NAME = {
        RES: 'res',
        SUB1: 'sub1',
        SUB2: 'sub2',
        SUB3: 'sub3',
        SUB8: 'sub8',
        SUB9: 'sub9',
        SUB10: 'sub10',
        SUB13: 'sub13',
        SUB14: 'sub14',
        SUB15: 'sub15',
        SUB18: 'sub18',
        GAME_SOUND: 'gameSound',
        ROLE: 'role'
    };

    class ButtonEffect extends Laya.Script {
        constructor() {
            super();
        }
        onAwake() {
            this.owner.on(Laya.Event.MOUSE_OVER, this, this.onDown);
            this.owner.on(Laya.Event.MOUSE_OUT, this, this.onUp);
            this.imgMask = this.owner.getChildByName('imgMask');
            if (this.imgMask)
                this.imgMask.visible = false;
        }
        onDown() {
            SoundManager.playEffect(SOUND_PATH.CLICK);
            if (this.imgMask)
                this.imgMask.visible = true;
            else {
                Laya.Tween.to(this.owner, {
                    scaleX: 0.9,
                    scaleY: 0.9
                }, 50);
            }
        }
        onUp() {
            if (this.imgMask)
                this.imgMask.visible = false;
            else
                Laya.Tween.to(this.owner, {
                    scaleX: 1,
                    scaleY: 1
                }, 50);
        }
        onDisable() {
            let img = this.owner;
            img.scale(1, 1);
        }
        onDestroy() {
            this.owner.off(Laya.Event.MOUSE_OVER, this, this.onDown);
            this.owner.off(Laya.Event.MOUSE_OUT, this, this.onUp);
        }
    }

    class BlinBlinEffect$1 extends Laya.Script {
        constructor() {
            super();
            this.scaleMax = 1;
            this.scaleMin = 0;
            this.alphaMax = 1;
            this.alphaMin = 0;
            this.scaleTime = 1;
            this.alphaTime = 0.5;
            this.nextTime = 0.4;
        }
        onAwake() {}
        onDisable() {
            for (let i = 0; i < this.owner.numChildren; i++) {
                let img = this.owner.getChildAt(i);
                Laya.Tween.clearAll(img);
            }
        }
        onEnable() {
            for (let i = 0; i < this.owner.numChildren; i++) {
                let img = this.owner.getChildAt(i);
                img.scale(this.scaleMax, this.scaleMax);
                img.alpha = 0;
                Laya.timer.once(i * this.nextTime * 1000, this, function() {
                    this.action(img);
                });
            }
        }
        action(img) {
            Laya.Tween.clearAll(img);
            if (this.scaleMin != this.scaleMax) {
                img.scale(this.scaleMin, this.scaleMin);
                Laya.Tween.to(img, {
                    scaleX: 1,
                    scaleY: 1
                }, this.scaleTime * 1000, null, Laya.Handler.create(this, function() {
                    this.action(img);
                }));
            } else {}
            img.alpha = this.alphaMax;
            Laya.Tween.to(img, {
                alpha: this.alphaMin
            }, this.alphaTime * 1000, null, null, (this.scaleTime - this.alphaTime) * 1000);
        }
    }

    class QuasiCenterCtrl extends ui.view.game.QuasiCenterUI {
        constructor() {
            super();
            this.initPos = {
                up: new Laya.Point(),
                down: new Laya.Point(),
                left: new Laya.Point(),
                right: new Laya.Point()
            };
            this.initPos1 = {
                up: new Laya.Point(),
                down: new Laya.Point(),
                left: new Laya.Point(),
                right: new Laya.Point()
            };
            this.isHaveTarget = false;
        }
        onAwake() {
            this.initPos.up.x = this.imgZhunXinUp.x;
            this.initPos.up.y = this.imgZhunXinUp.y;
            this.initPos.down.x = this.imgZhunXinDown.x;
            this.initPos.down.y = this.imgZhunXinDown.y;
            this.initPos.left.x = this.imgZhunXinLeft.x;
            this.initPos.left.y = this.imgZhunXinLeft.y;
            this.initPos.right.x = this.imgZhunXinRight.x;
            this.initPos.right.y = this.imgZhunXinRight.y;
            this.initPos1.up.x = this.imgTop.x;
            this.initPos1.up.y = this.imgTop.y;
            this.initPos1.down.x = this.imgBottom.x;
            this.initPos1.down.y = this.imgBottom.y;
            this.initPos1.left.x = this.imgLeft.x;
            this.initPos1.left.y = this.imgLeft.y;
            this.initPos1.right.x = this.imgRight.x;
            this.initPos1.right.y = this.imgRight.y;
            this.frameLoop(1, this, this.update);
        }
        onDestroy() {
            this.timer.clearAll(this);
            this.imgZhunXinDown = null;
            this.imgZhunXinLeft = null;
            this.imgZhunXinRight = null;
            this.imgZhunXinUp = null;
            this.imgAttack = null;
            this.imgPoint = null;
            this.initPos = null;
        }
        update() {
            if (SceneManager.getCurScene().state != GAME_STATE.START)
                return;
            this.setBullsEyeSkin();
            if (CharacterManger.playerLogicalBaseLayer.getPresentationBaseLayer().isCanShowHitUI && CharacterManger.targetLogicalBaseLayer && !CharacterManger.targetLogicalBaseLayer.getIsDie() && !CharacterManger.playerLogicalBaseLayer.isStartHuaBullet && CharacterManger.playerLogicalBaseLayer.bullets != 0 && CharacterManger.playerLogicalBaseLayer.magazineBullet != 0 && CharacterManger.playerLogicalBaseLayer.getArmCtrl()) {
                if (this.imgAttack.alpha <= 0) {
                    this.imgAttack.alpha += 0.05;
                } else {
                    this.imgAttack.alpha = 1;
                }
            } else {
                if (this.imgAttack.alpha >= 1) {
                    this.imgAttack.alpha -= 0.05;
                } else {
                    this.imgAttack.alpha = 0;
                }
            }
            if (CharacterManger.targetLogicalBaseLayer) {
                let fac = 27;
                let fac1 = 2;
                if (this.imgTop.y < this.initPos1.up.y + fac) {
                    this.imgTop.y += fac1;
                } else {
                    this.imgTop.y = this.initPos1.up.y + fac;
                }
                if (this.imgBottom.y > this.initPos1.down.y - fac) {
                    this.imgBottom.y -= fac1;
                } else {
                    this.imgBottom.y = this.initPos1.down.y - fac;
                }
                if (this.imgLeft.x < this.initPos1.left.x + fac) {
                    this.imgLeft.x += fac1;
                } else {
                    this.imgLeft.x = this.initPos1.left.x + fac;
                }
                if (this.imgRight.x > this.initPos1.right.x - fac) {
                    this.imgRight.x -= fac1;
                } else {
                    this.imgRight.x = this.initPos1.right.x - fac;
                }
                if (this.boxArrow.alpha < 1)
                    this.boxArrow.alpha += 0.2;
                else {
                    this.boxArrow.alpha = 1;
                }
            } else {
                if (this.imgTop.y > this.initPos1.up.y) {
                    this.imgTop.y -= 2;
                } else {
                    this.imgTop.y = this.initPos1.up.y;
                }
                if (this.imgBottom.y < this.initPos1.down.y) {
                    this.imgBottom.y += 2;
                } else {
                    this.imgBottom.y = this.initPos1.down.y;
                }
                if (this.imgLeft.x > this.initPos1.left.x) {
                    this.imgLeft.x -= 2;
                } else {
                    this.imgLeft.x = this.initPos1.left.x;
                }
                if (this.imgRight.x < this.initPos1.right.x) {
                    this.imgRight.x += 2;
                } else {
                    this.imgRight.x = this.initPos1.right.x;
                }
                if (this.boxArrow.alpha > 0)
                    this.boxArrow.alpha -= 0.1;
                else {
                    this.boxArrow.alpha = 0;
                }
            }
            if (CharacterManger.playerLogicalBaseLayer.getIsMoving() || CharacterManger.playerLogicalBaseLayer.getPresentationBaseLayer().isCanShowHitScale) {
                let fac = 10;
                let fac1 = 1;
                if (CharacterManger.playerLogicalBaseLayer.getPresentationBaseLayer().isCanShowHitScale) {
                    fac += 7;
                    fac1 += 5;
                }
                if (this.imgZhunXinUp.y > this.initPos.up.y - fac) {
                    this.imgZhunXinUp.y -= fac1;
                } else {
                    this.imgZhunXinUp.y = this.initPos.up.y - fac;
                }
                if (this.imgZhunXinDown.y < this.initPos.down.y + fac) {
                    this.imgZhunXinDown.y += fac1;
                } else {
                    this.imgZhunXinDown.y = this.initPos.down.y + fac;
                }
                if (this.imgZhunXinLeft.x > this.initPos.left.x - fac) {
                    this.imgZhunXinLeft.x -= fac1;
                } else {
                    this.imgZhunXinLeft.x = this.initPos.left.x - fac;
                }
                if (this.imgZhunXinRight.x < this.initPos.right.x + fac) {
                    this.imgZhunXinRight.x += fac1;
                } else {
                    this.imgZhunXinRight.x = this.initPos.right.x + fac;
                }
            } else {
                if (this.imgZhunXinUp.y < this.initPos.up.y) {
                    this.imgZhunXinUp.y++;
                } else {
                    this.imgZhunXinUp.y = this.initPos.up.y;
                }
                if (this.imgZhunXinDown.y > this.initPos.down.y) {
                    this.imgZhunXinDown.y--;
                } else {
                    this.imgZhunXinDown.y = this.initPos.down.y;
                }
                if (this.imgZhunXinLeft.x < this.initPos.left.x) {
                    this.imgZhunXinLeft.x++;
                } else {
                    this.imgZhunXinLeft.x = this.initPos.left.x;
                }
                if (this.imgZhunXinRight.x > this.initPos.right.x) {
                    this.imgZhunXinRight.x--;
                } else {
                    this.imgZhunXinRight.x = this.initPos.right.x;
                }
            }
        }
        setBullsEyeSkin() {
            if (CharacterManger.targetLogicalBaseLayer) {
                if (ConfigManager.platform == PLATFORM_TYPE.WEB_4399 && Laya.Browser.onPC) {
                    if (CharacterManger.playerLogicalBaseLayer.getArmCtrl()) {
                        if (!CharacterManger.playerLogicalBaseLayer.isStartHuaBullet && !CharacterManger.playerLogicalBaseLayer.getIsDie() && !CharacterManger.targetLogicalBaseLayer.getIsDie() && CharacterManger.targetLogicalBaseLayer.getRoleType() != ROLE_TYPE.TYPE_0) {
                            if (this.imgAttack.skin != RES_PATH.BULLSEYE.QUASI_RED) {
                                this.imgAttack.skin = RES_PATH.BULLSEYE.QUASI_RED;
                                this.imgZhunXinDown.skin = RES_PATH.BULLSEYE.VERTICAL_RED;
                                this.imgZhunXinLeft.skin = RES_PATH.BULLSEYE.VERTICAL_RED;
                                this.imgZhunXinRight.skin = RES_PATH.BULLSEYE.VERTICAL_RED;
                                this.imgZhunXinUp.skin = RES_PATH.BULLSEYE.VERTICAL_RED;
                                this.imgPoint.skin = RES_PATH.BULLSEYE.POINT_RED;
                            }
                        } else {
                            if (this.imgAttack.skin != RES_PATH.BULLSEYE.QUASI_WHITE) {
                                this.imgAttack.skin = RES_PATH.BULLSEYE.QUASI_WHITE;
                                this.imgZhunXinDown.skin = RES_PATH.BULLSEYE.VERTICAL_WHITE;
                                this.imgZhunXinLeft.skin = RES_PATH.BULLSEYE.VERTICAL_WHITE;
                                this.imgZhunXinRight.skin = RES_PATH.BULLSEYE.VERTICAL_WHITE;
                                this.imgZhunXinUp.skin = RES_PATH.BULLSEYE.VERTICAL_WHITE;
                                this.imgPoint.skin = RES_PATH.BULLSEYE.POINT_WHITE;
                            }
                        }
                    } else {
                        if (this.imgAttack.skin != RES_PATH.BULLSEYE.QUASI_WHITE) {
                            this.imgAttack.skin = RES_PATH.BULLSEYE.QUASI_WHITE;
                            this.imgZhunXinDown.skin = RES_PATH.BULLSEYE.VERTICAL_WHITE;
                            this.imgZhunXinLeft.skin = RES_PATH.BULLSEYE.VERTICAL_WHITE;
                            this.imgZhunXinRight.skin = RES_PATH.BULLSEYE.VERTICAL_WHITE;
                            this.imgZhunXinUp.skin = RES_PATH.BULLSEYE.VERTICAL_WHITE;
                            this.imgPoint.skin = RES_PATH.BULLSEYE.POINT_WHITE;
                        }
                    }
                    return;
                }
                if (CharacterManger.targetLogicalBaseLayer.getHP() < 30 && CharacterManger.targetLogicalBaseLayer.getHP() > 0 && !CharacterManger.playerLogicalBaseLayer.isStartHuaBullet && !CharacterManger.playerLogicalBaseLayer.getIsDie() && !CharacterManger.targetLogicalBaseLayer.getIsDie()) {
                    if (this.imgAttack.skin != RES_PATH.BULLSEYE.QUASI_RED) {
                        this.imgAttack.skin = RES_PATH.BULLSEYE.QUASI_RED;
                        this.imgZhunXinDown.skin = RES_PATH.BULLSEYE.VERTICAL_RED;
                        this.imgZhunXinLeft.skin = RES_PATH.BULLSEYE.VERTICAL_RED;
                        this.imgZhunXinRight.skin = RES_PATH.BULLSEYE.VERTICAL_RED;
                        this.imgZhunXinUp.skin = RES_PATH.BULLSEYE.VERTICAL_RED;
                        this.imgPoint.skin = RES_PATH.BULLSEYE.POINT_RED;
                    }
                } else {
                    if (CharacterManger.playerLogicalBaseLayer.getArmCtrl()) {
                        if (CharacterManger.playerLogicalBaseLayer.getArmCtrl().getType() == 3 && !CharacterManger.playerLogicalBaseLayer.isOpenMioing) {
                            if (!CharacterManger.playerLogicalBaseLayer.isStartHuaBullet && !CharacterManger.playerLogicalBaseLayer.getIsDie() && !CharacterManger.targetLogicalBaseLayer.getIsDie() && CharacterManger.targetLogicalBaseLayer.getRoleType() != ROLE_TYPE.TYPE_0) {
                                if (this.imgAttack.skin != RES_PATH.BULLSEYE.QUASI_RED) {
                                    this.imgAttack.skin = RES_PATH.BULLSEYE.QUASI_RED;
                                    this.imgZhunXinDown.skin = RES_PATH.BULLSEYE.VERTICAL_RED;
                                    this.imgZhunXinLeft.skin = RES_PATH.BULLSEYE.VERTICAL_RED;
                                    this.imgZhunXinRight.skin = RES_PATH.BULLSEYE.VERTICAL_RED;
                                    this.imgZhunXinUp.skin = RES_PATH.BULLSEYE.VERTICAL_RED;
                                    this.imgPoint.skin = RES_PATH.BULLSEYE.POINT_RED;
                                }
                            } else {
                                if (this.imgAttack.skin != RES_PATH.BULLSEYE.QUASI_WHITE) {
                                    this.imgAttack.skin = RES_PATH.BULLSEYE.QUASI_WHITE;
                                    this.imgZhunXinDown.skin = RES_PATH.BULLSEYE.VERTICAL_WHITE;
                                    this.imgZhunXinLeft.skin = RES_PATH.BULLSEYE.VERTICAL_WHITE;
                                    this.imgZhunXinRight.skin = RES_PATH.BULLSEYE.VERTICAL_WHITE;
                                    this.imgZhunXinUp.skin = RES_PATH.BULLSEYE.VERTICAL_WHITE;
                                    this.imgPoint.skin = RES_PATH.BULLSEYE.POINT_WHITE;
                                }
                            }
                        } else {
                            if (this.imgAttack.skin != RES_PATH.BULLSEYE.QUASI_WHITE) {
                                this.imgAttack.skin = RES_PATH.BULLSEYE.QUASI_WHITE;
                                this.imgZhunXinDown.skin = RES_PATH.BULLSEYE.VERTICAL_WHITE;
                                this.imgZhunXinLeft.skin = RES_PATH.BULLSEYE.VERTICAL_WHITE;
                                this.imgZhunXinRight.skin = RES_PATH.BULLSEYE.VERTICAL_WHITE;
                                this.imgZhunXinUp.skin = RES_PATH.BULLSEYE.VERTICAL_WHITE;
                                this.imgPoint.skin = RES_PATH.BULLSEYE.POINT_WHITE;
                            }
                        }
                    } else {
                        if (this.imgAttack.skin != RES_PATH.BULLSEYE.QUASI_WHITE) {
                            this.imgAttack.skin = RES_PATH.BULLSEYE.QUASI_WHITE;
                            this.imgZhunXinDown.skin = RES_PATH.BULLSEYE.VERTICAL_WHITE;
                            this.imgZhunXinLeft.skin = RES_PATH.BULLSEYE.VERTICAL_WHITE;
                            this.imgZhunXinRight.skin = RES_PATH.BULLSEYE.VERTICAL_WHITE;
                            this.imgZhunXinUp.skin = RES_PATH.BULLSEYE.VERTICAL_WHITE;
                            this.imgPoint.skin = RES_PATH.BULLSEYE.POINT_WHITE;
                        }
                    }
                }
            } else {
                if (this.imgAttack.skin != RES_PATH.BULLSEYE.QUASI_WHITE) {
                    this.imgAttack.skin = RES_PATH.BULLSEYE.QUASI_WHITE;
                    this.imgZhunXinDown.skin = RES_PATH.BULLSEYE.VERTICAL_WHITE;
                    this.imgZhunXinLeft.skin = RES_PATH.BULLSEYE.VERTICAL_WHITE;
                    this.imgZhunXinRight.skin = RES_PATH.BULLSEYE.VERTICAL_WHITE;
                    this.imgZhunXinUp.skin = RES_PATH.BULLSEYE.VERTICAL_WHITE;
                    this.imgPoint.skin = RES_PATH.BULLSEYE.POINT_WHITE;
                }
            }
        }
    }

    class QuasiCenter1Ctrl extends ui.view.game.QuasiCenter1UI {
        constructor() {
            super();
            this.initPos = {
                up: new Laya.Point(),
                down: new Laya.Point(),
                left: new Laya.Point(),
                right: new Laya.Point()
            };
            this.a = 0;
        }
        onAwake() {
            this.frameLoop(1, this, this.update);
        }
        onDestroy() {
            this.timer.clearAll(this);
            this.imgPoint = null;
            this.initPos = null;
        }
        update() {
            if (SceneManager.getCurScene().state != GAME_STATE.START)
                return;
            this.setBullsEyeSkin();
            if (CharacterManger.playerLogicalBaseLayer.getPresentationBaseLayer().isCanShowHitUI && CharacterManger.targetLogicalBaseLayer && !CharacterManger.targetLogicalBaseLayer.getIsDie() && !CharacterManger.playerLogicalBaseLayer.isStartHuaBullet && CharacterManger.playerLogicalBaseLayer.bullets != 0 && CharacterManger.playerLogicalBaseLayer.magazineBullet != 0 && CharacterManger.playerLogicalBaseLayer.getArmCtrl()) {
                if (this.a <= 0) {
                    this.a += 0.05;
                } else {
                    this.a = 1;
                }
                if (this.imgPoint.skin != RES_PATH.BULLSEYE1.POINT_RED) {
                    this.imgRect.skin = RES_PATH.BULLSEYE1.VERTICAL_RED;
                    this.imgPoint.skin = RES_PATH.BULLSEYE1.POINT_RED;
                }
            } else {
                if (this.a >= 1) {
                    this.a -= 0.05;
                } else {
                    this.a = 0;
                }
            }
            if (CharacterManger.playerLogicalBaseLayer.getIsMoving() || CharacterManger.playerLogicalBaseLayer.getPresentationBaseLayer().isCanShowHitScale) {
                let s = 1.5;
                let s1 = 0.05;
                if (CharacterManger.playerLogicalBaseLayer.getPresentationBaseLayer().isCanShowHitScale) {
                    s += 0.35;
                    s1 += 0.25;
                }
                if (this.imgRect.scaleX < s) {
                    this.imgRect.scaleX += s1;
                    this.imgRect.scaleY += s1;
                } else {
                    this.imgRect.scaleX = s;
                    this.imgRect.scaleY = s;
                }
            } else {
                if (this.imgRect.scaleX > 1) {
                    this.imgRect.scaleX -= 0.05;
                    this.imgRect.scaleY -= 0.05;
                } else {
                    this.imgRect.scaleX = 1;
                    this.imgRect.scaleY = 1;
                }
            }
        }
        setBullsEyeSkin() {
            if (CharacterManger.targetLogicalBaseLayer) {
                if (ConfigManager.platform == PLATFORM_TYPE.WEB_4399 && Laya.Browser.onPC) {
                    if (CharacterManger.playerLogicalBaseLayer.getArmCtrl()) {
                        if (!CharacterManger.playerLogicalBaseLayer.isStartHuaBullet && !CharacterManger.playerLogicalBaseLayer.getIsDie() && !CharacterManger.targetLogicalBaseLayer.getIsDie() && CharacterManger.targetLogicalBaseLayer.getRoleType() != ROLE_TYPE.TYPE_0) {
                            if (this.imgPoint.skin != RES_PATH.BULLSEYE1.POINT_RED) {
                                this.imgRect.skin = RES_PATH.BULLSEYE1.VERTICAL_RED;
                                this.imgPoint.skin = RES_PATH.BULLSEYE1.POINT_RED;
                            }
                        } else {
                            if (this.imgPoint.skin != RES_PATH.BULLSEYE1.POINT_WHITE) {
                                this.imgRect.skin = RES_PATH.BULLSEYE1.VERTICAL_WHITE;
                                this.imgPoint.skin = RES_PATH.BULLSEYE1.POINT_WHITE;
                            }
                        }
                    } else {
                        if (this.imgPoint.skin != RES_PATH.BULLSEYE1.POINT_WHITE) {
                            this.imgRect.skin = RES_PATH.BULLSEYE1.VERTICAL_WHITE;
                            this.imgPoint.skin = RES_PATH.BULLSEYE1.POINT_WHITE;
                        }
                    }
                    return;
                }
                if (CharacterManger.targetLogicalBaseLayer.getHP() < 30 && CharacterManger.targetLogicalBaseLayer.getHP() > 0 && !CharacterManger.playerLogicalBaseLayer.isStartHuaBullet && !CharacterManger.playerLogicalBaseLayer.getIsDie() && !CharacterManger.targetLogicalBaseLayer.getIsDie()) {
                    if (this.imgPoint.skin != RES_PATH.BULLSEYE1.POINT_RED) {
                        this.imgRect.skin = RES_PATH.BULLSEYE1.VERTICAL_RED;
                        this.imgPoint.skin = RES_PATH.BULLSEYE1.POINT_RED;
                    }
                } else {
                    if (CharacterManger.playerLogicalBaseLayer.getArmCtrl()) {
                        if (CharacterManger.playerLogicalBaseLayer.getArmCtrl().getType() != 3 && !CharacterManger.playerLogicalBaseLayer.isStartHuaBullet && !CharacterManger.playerLogicalBaseLayer.getIsDie() && !CharacterManger.targetLogicalBaseLayer.getIsDie() && CharacterManger.targetLogicalBaseLayer.getRoleType() != ROLE_TYPE.TYPE_0) {
                            if (this.imgPoint.skin != RES_PATH.BULLSEYE1.POINT_WHITE_1) {
                                this.imgRect.skin = RES_PATH.BULLSEYE1.VERTICAL_WHITE_1;
                                this.imgPoint.skin = RES_PATH.BULLSEYE1.POINT_WHITE_1;
                            }
                        } else {
                            if (CharacterManger.playerLogicalBaseLayer.getArmCtrl().getType() == 3 && !CharacterManger.playerLogicalBaseLayer.isOpenMioing) {
                                if (!CharacterManger.playerLogicalBaseLayer.isStartHuaBullet && !CharacterManger.playerLogicalBaseLayer.getIsDie() && !CharacterManger.targetLogicalBaseLayer.getIsDie() && CharacterManger.targetLogicalBaseLayer.getRoleType() != ROLE_TYPE.TYPE_0) {
                                    if (this.imgPoint.skin != RES_PATH.BULLSEYE1.POINT_RED) {
                                        this.imgRect.skin = RES_PATH.BULLSEYE1.VERTICAL_RED;
                                        this.imgPoint.skin = RES_PATH.BULLSEYE1.POINT_RED;
                                    }
                                } else {
                                    if (this.imgPoint.skin != RES_PATH.BULLSEYE1.POINT_WHITE) {
                                        this.imgRect.skin = RES_PATH.BULLSEYE1.VERTICAL_WHITE;
                                        this.imgPoint.skin = RES_PATH.BULLSEYE1.POINT_WHITE;
                                    }
                                }
                            } else {
                                if (this.imgPoint.skin != RES_PATH.BULLSEYE1.POINT_WHITE) {
                                    this.imgRect.skin = RES_PATH.BULLSEYE1.VERTICAL_WHITE;
                                    this.imgPoint.skin = RES_PATH.BULLSEYE1.POINT_WHITE;
                                }
                            }
                        }
                    } else {
                        if (this.imgPoint.skin != RES_PATH.BULLSEYE1.POINT_WHITE) {
                            this.imgRect.skin = RES_PATH.BULLSEYE1.VERTICAL_WHITE;
                            this.imgPoint.skin = RES_PATH.BULLSEYE1.POINT_WHITE;
                        }
                    }
                }
            } else {
                if (this.imgPoint.skin != RES_PATH.BULLSEYE1.POINT_WHITE) {
                    this.imgRect.skin = RES_PATH.BULLSEYE1.VERTICAL_WHITE;
                    this.imgPoint.skin = RES_PATH.BULLSEYE1.POINT_WHITE;
                }
            }
        }
    }

    class GunMoveEffect extends Laya.Script {
        constructor() {
            super();
            this.list = [];
            this.length = 150;
        }
        onAwake() {
            for (let index = 0; index < this.owner.numChildren; index++) {
                const element = this.owner.getChildAt(index);
                this.list.push(element);
            }
        }
        onDisable() {}
        onEnable() {}
        onUpdate() {
            for (let index = 0; index < this.list.length; index++) {
                const element = this.list[index];
                element.y -= 1;
                if (element.y < -this.length) {
                    element.y += this.length * this.list.length;
                }
            }
        }
    }

    class TurnEffect extends Laya.Script {
        constructor() {
            super();
            this.rotateSpeed = 20;
            this.dis = 1;
        }
        onAwake() {
            var that = this;
            this.y = that.owner.y;
            Laya.timer.loop(20, this, function() {
                let img = that.owner;
                img.y += that.dis * 0.3;
                if (img.y >= that.rotateSpeed + that.y) {
                    that.dis = -1;
                }
                if (img.y < that.y) {
                    that.dis = 1;
                }
            });
        }
        onDisable() {}
        onDestroy() {
            Laya.timer.clearAll(this);
        }
    }

    class TurnEffect$1 extends Laya.Script {
        constructor() {
            super();
            this.rotateSpeed = 1;
        }
        onAwake() {
            var that = this;
            Laya.timer.loop(20, this, function() {
                that.owner.rotation += that.rotateSpeed;
            });
        }
        onDisable() {}
        onDestroy() {
            Laya.timer.clearAll(this);
        }
    }

    class BreatheEffect extends Laya.Script {
        constructor() {
            super();
            this.rotateSpeed = 1;
        }
        onAwake() {
            var that = this;
            this.action(this.owner);
        }
        onDisable() {}
        onDestroy() {
            Laya.timer.clearAll(this);
        }
        action(img) {
            img.alpha = 1;
            Laya.Tween.clearAll(img);
            Laya.Tween.to(img, {
                alpha: 0.5
            }, 1500 * this.rotateSpeed, null);
            Laya.Tween.to(img, {
                alpha: 1
            }, 1500 * this.rotateSpeed, null, Laya.Handler.create(this, function() {
                this.action(img);
            }), 1500 * this.rotateSpeed);
        }
    }

    class GameConfig {
        constructor() {}
        static init() {
            var reg = Laya.ClassUtils.regClass;
            reg("effect/UpMoveEffect.ts", BlinBlinEffect);
            reg("effect/PointEffect.ts", PointEffect);
            reg("effect/ButtonEffect.ts", ButtonEffect);
            reg("effect/BlinBlinEffect.ts", BlinBlinEffect$1);
            reg("view/game/QuasiCenterCtrl.ts", QuasiCenterCtrl);
            reg("view/game/QuasiCenter1Ctrl.ts", QuasiCenter1Ctrl);
            reg("effect/GunMoveEffect.ts", GunMoveEffect);
            reg("effect/FlyEffect.ts", TurnEffect);
            reg("effect/TurnEffect.ts", TurnEffect$1);
            reg("effect/BreatheEffect.ts", BreatheEffect);
        }
    }
    GameConfig.width = 1520;
    GameConfig.height = 750;
    GameConfig.scaleMode = "fixedheight";
    GameConfig.screenMode = "horizontal";
    GameConfig.alignV = "top";
    GameConfig.alignH = "left";
    GameConfig.startScene = "scene/GameScene.scene";
    GameConfig.sceneRoot = "";
    GameConfig.debug = false;
    GameConfig.stat = false;
    GameConfig.physicsDebug = false;
    GameConfig.exportSceneToJson = true;
    GameConfig.init();

    class Main {
        constructor() {
            if (Laya.Browser.onIOS) {
                Config.isAntialias = true;
                Config.useWebGL2 = false;
            }
            let config = new Config3D();
            if (window["Laya3D"])
                Laya3D.init(GameConfig.width, GameConfig.height, config);
            else
                Laya.init(GameConfig.width, GameConfig.height, Laya["WebGL"]);
            Laya["Physics"] && Laya["Physics"].enable();
            Laya["DebugPanel"] && Laya["DebugPanel"].enable();
            if (ConfigManager.platform == PLATFORM_TYPE.WEB_4399 && Laya.Browser.onPC) {
                Laya.stage.scaleMode = GameConfig.scaleMode = 'showall';
                Laya.stage.alignH = GameConfig.alignH = 'center';
                Laya.stage.alignV = GameConfig.alignV = 'middle';
            } else {
                if (Laya.Browser.clientWidth / Laya.Browser.clientHeight < 1.5 && ConfigManager.adpaterIpad) {
                    Laya.stage.scaleMode = GameConfig.scaleMode = 'fixedwidth';
                } else {
                    Laya.stage.scaleMode = GameConfig.scaleMode;
                }
            }
            Laya.stage.screenMode = GameConfig.screenMode;
            Laya.stage.alignV = GameConfig.alignV;
            Laya.stage.alignH = GameConfig.alignH;
            Laya.URL.exportSceneToJson = GameConfig.exportSceneToJson;
            this.orient();
            if (GameConfig.debug || Laya.Utils.getQueryString("debug") == "true")
                Laya.enableDebugPanel();
            if (GameConfig.physicsDebug && Laya["PhysicsDebugDraw"])
                Laya["PhysicsDebugDraw"].enable();
            if (GameConfig.stat)
                Laya.Stat.show();
            Laya.alertGlobalError(true);
            Laya.ResourceVersion.enable("version.json", Laya.Handler.create(this, this.onVersionLoaded), Laya.ResourceVersion.FILENAME_VERSION);
        }
        onVersionLoaded() {
            Laya.AtlasInfoManager.enable("fileconfig.json", Laya.Handler.create(this, this.onConfigLoaded));
        }
        onConfigLoaded() {
            LayaExtend.overwrite();
            Mathf.seed = Laya.timer.currTimer;
            Laya.loader.maxLoader = 20;
            PlatformUtil.onShow(function(data) {
                console.log('onShow', data);
                SoundManager.resumeBGMFromInterruption();
                AdUtil.triggerShareEvent();
                RoleManager.getInstance().launch(data, false);
                NotifyManager.notify(NOTIFY_ID.ON_SHOW);
                Laya.MouseManager.instance.disableMouseEvent = false;
            });
            PlatformUtil.onHide(function() {
                console.log('设备----- onHide');
                RoleManager.getInstance().setOfflineTime();
                RoleManager.getInstance().setAutoOpenTime();
                RoleManager.getInstance().updateServer();
                that.isTouchBannerInCrazy();
                AdUtil.onHide();
            });
            let options = PlatformUtil.getLaunchOptionsSync();
            if (options) {
                console.log('options', options);
                RoleManager.getInstance().launch(options, true);
            }
            PlatformUtil.onAudioInterruptionEnd(function() {
                console.log('onAudioInterruptionEnd');
                SoundManager.resumeBGMFromInterruption();
            });
            let time = 100;
            let that = this;
            let cb = function() {
                Laya.timer.once(time, that, function() {
                    SceneManager.pushScene(GameScene);
                });
            };
            console.log('appId' + ConfigManager.appId);
            if (ConfigManager.platform == PLATFORM_TYPE.NATIVE_ANDRIOD) {
                PrivateDialogViewCtrl.create(cb);
            } else {
                cb();
            }
        }
        orient() {}
        isTouchBannerInCrazy() {
            let func = UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME);
            if (func == null)
                return;
            let view = UIManager.getFunctionViewCtrl(FUNCTION_TAG.GAME).getChildByName('GameAirCrazyView');
            if (view) {
                console.log('拥有狂点界面');
                if (view.isDie) {
                    console.log('已经点到banner');
                    GameScene.isShowRevivieCrazy = false;
                }
            }
        }
    }
    new Main();

}());